 __       __   ______      _____  ________      __    __ 
|  \  _  |  \ /      \    |     \|        \    |  \  |  \
| $$ / \ | $$|  $$$$$$\    \$$$$$ \$$$$$$$$    | $$  | $$
| $$/  $\| $$| $$___\$$      | $$   | $$ ______ \$$\/  $$
| $$  $$$\ $$ \$$    \  __   | $$   | $$|      \ >$$  $$ 
| $$ $$\$$\$$ _\$$$$$$\|  \  | $$   | $$ \$$$$$$/  $$$$\ 
| $$$$  \$$$$|  \__| $$| $$__| $$   | $$       |  $$ \$$\
| $$$    \$$$ \$$    $$ \$$    $$   | $$       | $$  | $$
 \$$      \$$  \$$$$$$   \$$$$$$     \$$        \$$   \$$
                                                         
                                                         
                                                         
Copyright (C) 2001 - 2023 by Joe Taylor, K1JT.

WSJT-X Version 2.6.1 offers eleven different protocols or modes: FT4,
FT8, JT4, JT9, JT65, Q65, FST4, MSK144, WSPR, FST4W, and Echo. The
first seven are designed for making reliable QSOs under weak-signal
conditions. They use nearly identical message structure and source
encoding. JT65 and Q65 were designed for EME (“moonbounce”), but not
limited to just that propagation path, on the VHF/UHF bands and JT65
has also proven very effective for worldwide QRP communication on the
HF bands. Q65 has a number of advantages over JT65, including better
performance on the very weakest signals and variants with different
T/R period lengths. We imagine that over time it may replace JT65 for
EME use, it has also proved to be very effective for iono-scatter
paths on 6m. JT9 was originally designed for the LF, MF, and lower HF
bands. Its submode JT9A is 2 dB more sensitive than JT65 while using
less than 10% of the bandwidth. JT4 offers a wide variety of tone
spacings and has proven highly effective for EME on microwave bands up
to 24 GHz. These four “slow” modes use one-minute timed sequences of
alternating transmission and reception, so a minimal QSO takes four to
six minutes — two or three transmissions by each station, one sending
in odd UTC minutes and the other even. FT8 is operationally similar
but four times faster (15-second T/R sequences) and less sensitive by
a few dB. FT4 is faster still (7.5 s T/R sequences) and especially
well suited for radio contesting. On the HF bands, world-wide QSOs are
possible with any of these modes using power levels of a few watts (or
even milliwatts) and compromise antennas. QSOs are possible at signal
levels 10 to 15 dB below those required for CW. FST4 has similarities
in use to JT9 but offers more flexibility as it offers different
period lengths allowing QSO completion time to be traded off against
sensitivity. In its base form of FST4-60A it has better sensitivity
than JT9A and should be considered as an upgrade where JT9 has been
the preferred slow QSO mode.

Note that even though their T/R sequences are short, FT4 and FT8 are
classified as slow modes because their message frames are sent only
once per transmission. All fast modes in WSJT-X send their message
frames repeatedly, as many times as will fit into the Tx sequence
length.

MSK144, and optionally submodes JT9E-H are “fast” protocols designed
to take advantage of brief signal enhancements from ionized meteor
trails, aircraft scatter, and other types of scatter
propagation. These modes use timed sequences of 5, 10, 15, or 30 s
duration. User messages are transmitted repeatedly at high rate (up to
250 characters per second, for MSK144) to make good use of the
shortest meteor-trail reflections or “pings”. MSK144 uses the same
structured messages as the slow modes and optionally an abbreviated
format with hashed callsigns.

WSPR (pronounced “whisper”) stands for Weak Signal Propagation
Reporter. The WSPR protocol was designed for probing potential
propagation paths using low-power transmissions. WSPR messages
normally carry the transmitting station’s callsign, grid locator, and
transmitter power in dBm, and they can be decoded at signal-to-noise
ratios as low as -31 dB in a 2500 Hz bandwidth. WSPR users with
internet access can automatically upload reception reports to a
central database called WSPRnet that provides a mapping facility,
archival storage, and many other features.

FST4W, like WSPR, is a quasi-beacon mode, it targets LF and MF bands
and offers a number of T/R periods form 2 minutes up to 30 minutes for
the most challenging weak signal paths. Similarly to WSPR reception
reports can be automatically uploaded to the WSPRnet.org web service.

Echo mode allows you to detect and measure your own station’s echoes
from the moon, even if they are far below the audible threshold.

WSJT-X provides spectral displays for receiver passbands as wide as 5
kHz, flexible rig control for nearly all modern radios used by
amateurs, and a wide variety of special aids such as automatic Doppler
tracking for EME QSOs and Echo testing. The program runs equally well
on Windows, Macintosh, and Linux systems, and installation packages
are available for all three platforms.

WSJT-X is an open-source project released under the GPLv3 license (See
COPYING). If you have programming or documentation skills or would
like to contribute to the project in other ways, please make your
interests known to the development team.  The project’s source-code
repositories can be found at
https://sourceforge.net/p/wsjt/wsjtx/ci/master/tree/, and
communication among the developers takes place on the email reflector
https://sourceforge.net/p/wsjt/mailman.  User-level questions and
answers, and general communication among users is found on the
https://wsjtx.groups.io/g/main email reflector.


Project web site:

https://wsjt.sourceforge.io/wsjtx.html

Project mailing list (shared with other applications from the same
team):

https://sourceforge.net/projects/wsjt/lists/wsjt-devel

WSJT-X IMPROVED is published by Uwe Risse, DG2YCB (https://www.qrz.com/db/DG2YCB). It is an enhanced edition of the excellent WSJT-X software by Joe Taylor K1JT, Steve Franke K9AN, Bill Somerville G4WJS, Uwe Risse, DG2YCB and others (https://sourceforge.net/projects/wsjt/) that provides several additional features and improvements, as well as more frequent updates and bug fixes. 

Notes: WSJT-X Improved is experimental and is licensed under GNU GPL v3 (https://www.gnu.org/licenses/gpl-3.0.txt). I am not aware of any adverse effects. However, use it at your own risk!

Mailing list: https://sourceforge.net/projects/wsjt-x-improved/lists/wsjt-x-improved-community

CHANGELOG

VERSIONS WSJT-X_v3.1.0

A new 3.1 version of WSJT-X Improved is currently under development. As with any new version
that introduces major changes, I recommend making backup copies of the files WSJT-X.ini and 
wsjtx_log.adi, and installing the program in a new directory (e.g., C:\WSJT\wsjtx-310).
You can find these two files in your log directory. 

Important: Always use the latest builds available before reporting any bugs!

New features of v3.1.0 260418 compared to v3.0.0 251212:

 - Introduction of a new open-source FT2 mode:
  - FT2 is an ultra-fast 77-bit mode with TR periods of 3.75 seconds (= 1/2 of FT4).
  - The history of FT2 goes back to experiments by Joe, Steve, and Bill (sk) which later
    became FT4. IU8LMC recently introduced an FT2 mode with modified parameters. The FT2
    mode introduced here is compatible with it, but is fully open-source. No code from
    IU8LMC was used.
  - Note that FT2 is still experimental. I haven't decided yet whether we'll keep it. Let's
    see if FT2 proves itself alongside FT4, or if it's just a short-lived hype.
 - Support of QSOs between two stations with non-standard or compound callsigns for the
   77-bit modes (FT8, FT4, FT2, MSK144, Q65, FST4). The following QSOs are now possible:
   - two non-standard callsigns (e.g. DG123YCB with W250USA) 
   - two compound callsigns (e.g. DG2YCB/QRP with W1XYZ/YOTA, or HB9/DG2YCB with KP5/W1XY)
   - non-standard callsign and compound callsign (e.g. DG123YCB with W1XYZ/QRP)
   - non-standard callsign and /P callsign (e.g. DG123YCB with W1XYZ/P)
   - two standard callsigns with /P, /M, /R or whatever (e.g. DG2YCB/MM with W1XYZ/P)
   Notes:
   - Both stations must use WSJT-X Improved v3.1 (or compatible software) for such QSOs.
     I noticed that some beta builds of JTDX and MSHV seem to be compatible with these
     message formats, however, the standard WSJT-X would get stuck in an endless autoseq
     loop.
   - All previous message types are still fully supported, making WSJT-X Improved 3.1 
     fully backward compatible.
   - These new QSO types cannot be used in special operating activities, as the available
     77 bits are not sufficient for this purpose.
 - Support of Worked All States or similar awards:
   - In addition to grid mapping, a new method has been added to map U.S. callsigns to U.S.
     states. It uses a database containing FCC data.
   - This allowed adding two new highlighting and alert categories: "New US States" and
     "New US States on Band".
   - At startup, the program reads any <STATE:2> tags in the wsjtx_log.adi file, and such
     tags are now written when logging a QSO with a station from U.S.A. Missing tags are
     automatically retrieved from the database.
   - Users can easily update the callsign_states database using the new function at
     Settings | Colors.
 - Slightly improved decoding performance:
   - Added a7 decoding technology, sub-sample DT refinement, and a 4th pass after a7 for
     both FT4 and FT2.
   - Optimized baseline calculation, effective for FT4, FT2 and FT8 (STD). The filter edges
     are now automatically optimized according to the actual passband of your transceiver.
     This results in better decoding performance and fewer false decodes when the Wide
     Graph limits are poorly set.
 - New technology for the MAP65 program, and for some FORTRAN files:
   - The map65.exe file is now less than 1/4 the size it was before. This new technology
     will (hopefully) also bring stability improvements.
   - It comes along with modernized FORTRAN code. 
 - Various minor improvements and fixes:
   - Added a new option to skip a8 decodes for the multithreaded FT8 decoder (MTD).
   - The band hopping interval can now be switched between 1 minute and 2 minutes. See 
     the new checkbox on the Settings | General tab.
   - The "Less button coloring" option has been removed because it was rarely used.
   - Fixed a flaw that caused FT4 decodes not to be displayed when the program was
     started with CQonly enabled.
   - Bugfix: Country names are no longer accidentally displayed when in FST4W mode.
   - Fixed an inconsistency regarding the highlighting of prefixes.
   - Transmissions above 5362 kHz on 60m are allowed for for UK stations again. Only
     Tx frequencies between 5358 and 5362 kHz are prevented now.
   - Better visibility of the Settings | Tx Macros tab when dark style is enabled.
   - Added an option to log the dial frequency instead of the actual Tx frequency.
   - WSPR messages are now also sent to PSK Reporter if both "Enable PSK Reporter
     Spotting" and "Upload spots"are enabled.
   - Added an option to clear the Band Activity window after changing mode.
   - The Settings window can now be minimized much further, which improves usability on
     small screens. If the window is too small to display all the controls, scroll bars
     will appear so you can still access all of them.
   - Echo mode: The estimated signal degradation in dB (Dgrd) is printed to screen and
     written to the "all_echo.txt" file.
   - QMAP and MAP65 are now included in the Linux installation packages.
   - Multilingual alert voices now work out of the box. The necessary files are included
     in the installation packages, so no additional language pack is required anymore.
   - The itone data is now added to the UDP status message packet. This feature is useful
     for DDS transceivers as they no longer need to rely on the AFP-FSK technique for
     direct digital synthesis of the correct messages.
   - Fixed "Test API key" button not working for Cloudlog/Wavelog.
 - Support of the new Hamlib 5 series.


VERSIONS WSJT-X_v3.0.0

WSJT-X Improved v3.0.0, is a major revision offering many new features and capabilities.
Its focus is on further improved FT8 decoding performance.

Changes compared to WSJT-X Improved v2.8.0:

 - Introduction of a new multithreaded FT8 decoder (MTD).
 - Improvements to the existing, single-threaded FT8 Decoder (STD) to yield improved
   performance.
 - With the MTD options "2-stage" and "3-stage" both decoders can be intelligently
   combined, resulting in the best FT8 decoding performance to date.
 - Echo mode allows you to transmit your callsign (or any other 6-character group) to
   the Moon and decode its echo.
 - Quick Filter categories can highlight decoded transmissions from specified territories.
 - Right-click on the Band Hopping button to move you to the next specified band hopping
   frequency when Band Hopping is active.
 - MSK144 operation: "73" messages addressed to MyCall are now also displayed in the
   right pane. A bank line is inserted between decodes for different TR periods.
 - Q65 operation at VHF: A new option on the Decode menu disables mouse clicks on the
   waterfall unless ALT key is held down.
 - "Highlight orange" and "Highlight blue" features on the File | Settings | Colors tab
   can now be used to highlight directional calls (DX, SOTA, POTA, YOTA, etc.).
 - QMAP and MAP65: Improved handling of long compound messages in Q65 mode. Corrected
   a bug that could cause a crash when receiving a CQ message not containing a grid.
 - A variety of other minor improvements and bug fixes.
 - Update to Hamlib 4.7_2025-09-05_SHA=e762a8.

The "250924" update brings the following improvements:

 - Fixed a bug that caused AutoSeq to not log MSK144 QSOs and not send the final 73
   message in some cases when RRR was used instead of RR73.
 - Fixed some minor inconsistencies in the "MSK144/Q65: Tx until 73 is received" feature.
 - Fixed right-clicking on the Erase button not working with macOS (relevant when
   "Alternate Erase button behavior" is enabled).
 - MTD 3-Stage now (partially) supports the new 'a8' decoding technology. This has the
   advantage that, under certain conditions, messages from the station you are in QSO
   with can be displayed 0.5 to 1 second earlier.
 - Fixed a small bug regarding the highlighting of directional calls. Entries in Highlight
   orange/blue regarding directional calls must now always be preceded and followed by a
   comma (and without spaces). Highlighting of callsigns, grids ad directional calls can
   still be combined. So, e.g., ",YOTA,SOTA,POTA,DX,DG2YCB,JO42,".
 - A minor bug has been fixed that prevented the Calling You alert sound from playing
   when it was the only selected alert category.
 - Corrected a small inconsistency regarding very low SNR values for 'a8' decodes.
 - Right-clicking on the FT8 Mode button to toggle the last used contest mode on/off no
   longer resets the frequency to default values for band/mode. That's more intuitive.
 - Changed the download location for the "Update Hamlib" feature to a Hamlib mirror on my
   server, as https://n0nb.users.sourceforge.net/ may soon no longer be available. As a
   positive side effect, downloading Hamlib is now faster.
 - Fixed a compilation error with Qt6 when using GCC versions > 14.
 - Fixed a rare inconsistency when starting the program in MSK144 mode.
 - Update to Hamlib 4.7_2025-09-18_SHA=d44011, which brings us back the FLRig and GQRX
   entries.

The "251101" update brings the following improvements:

In programs QMAP and MAP65:
 - Stability improvements in QMAP and MAP65. This also prevents program crashes when
   receiving certain contest messages.
 - Added optional PSK Reporter spotting to MAP65.
 - QMAP now supports highDPI scaling. Useful when using high-resolution monitors.
 - Moon Ephemeris charts can be downloaded from the Help menu.

In program WSJT-X:
 - Added a new spin box to the Astronomical data window to set the sked frequency to kHz
   integer values. The existing methods, such as left- or right-clicking on the frequency
   display in the main program window, using the mouse wheel while hovering over the
   frequency display, manual entry of frequency values in the band combo box, or press
   and hold CRTL and dial the VFO on your rig, are still available. EME operators now
   have several options at their disposal.
 - "Highlight orange" and "Highlight blue" can now also highlight prefixes. Prefixes must
   be followed by a semicolon; callsigns and grids by a comma. Directional calls must be
   preceded and followed by a comma (e.g. ",DX,K1JT,DG2YCB,JO42,VK;ZL;T88;,POTA,SOTA,").
 - Added a new alert category "Wanted callsigns, grids, prefixes and directional calls".
   It uses the entries from "Highlight orange" and "Highlight blue", and can also be used,
   for example, to be notified when a POTA or SOTA station is on the air.
 - Stability improvements for MSK144: Saving and restoring individual TR values for 2m
   and 6m, as well as switching from MSK144 to FT8, FT4, Q65 or JT65 is now more
   reliable.
 - WSJT-X Improved now supports multilingual alert sounds. Additional voices can be
   installed from an optional language pack. Just copy the content of the zip file
   into the "sounds" folder of your installation; so on Windows usually to
   "c:\WSJT\wsjtx\bin\sounds\". The voices can then be selected in the new combo box
   under Settings | Alerts.
 - Further improvements to the multithreaded FT8 decoder (MTD):
   - The MTD now fully supports the 'a8' decoding technology.
   - Various MTD AP types ('a31', 'a35', etc.) are now summarized as 'a9', since more
     detailed information is not useful. Similar to 'a7' for the single-threaded
     decoder, 'a9' indicates that also certain information from previous Rx sequences
     has been used.
   - Fixed an issue with decoding of certain EU VHF contest messages with the MTD.
   - Corrected a flaw that caused the 'Rx All Freqs' checkbox to not work correctly
     when MTD was selected.
   - Fixed a bug where some FT8 messages were incorrectly spotted as FT4 by JTAlert.
   - Both decoders (MTD and STD) now use a shared hash table, further reducing the
   - Better communication between the hash tables of both decoders (MTD and STD),
     further reducing the likelihood of hash collisions.
 - Added an option to hide AP information in the Band Activity window.
 - Logged QSOs can now be uploaded to eQSL.cc.
 - Better handling of multiple sound cards with the same name. Note: Don't use "Sort
   alphabetically" in such a case.
 - Improved compatibility with macOS Tahoe. The progress bar should now be displayed
   reliably again with the M1 packages.
 - The Qt6 code is now compatible with Qt6.9 (relevant for Gentoo Linux, etc.).
 - Update to Hamlib-4.7_2025-10-10_SHA=23710c.

The "251212" update brings the following improvements:

 - Stability improvements for MSK144: Fixed an issue with restoring individual T/R 
   values for 2m and 6m when switching mode within a band.
 - It is now ensured that stations with callsigns from the United Kingdom transmit
   below 5358 kHz on 60m. This means: No special version required anymore!
 - Added a new "Highlight Whitelist entries" feature. It can be activated from the
   Filters menu, and is used to highlight all callsigns that contain specific
   character strings (for example, all stations with the suffix “EUDXF,” or all
   callsigns that contain “100”).
 - Changed the report time for PSKReporter to start time of decoded message (at the
   request of Philip, the owner of PSKReporter).
 - The “Show blank line with time stamp” feature now also works for WSPR.
 - AutoSeq for JT65/JT4 short messages is now only processed if Enable Tx is active.
 - Better font and scaling for some MAP65 widgets.
 - Numerous other minor code improvements.


VERSIONS WSJT-X_v2.8.0

WSJT-X Improved v2.8.0 is a General Availability (GA) release that contains all the
"stable" developments that have been successfully tested and optimized in the various
2.7.1-devel versions, as well as several new features, bug fixes and other enhancements.
The most recent include:

 - Fixed an inconsistency where with all prior WSJT-X and WSJT-X Improved releases,
   incorrect frequencies could be logged and posted to PSK Reporter when non-band/mode
   default frequencies had been selected.
 - Fixed a long-standing flaw where the third callsign in combined messages was
   sometimes displayed as <> after clearing the DX Call box by right-clicking on 
   the DX Call button or pressing the Esc key. (The latter also applies to WSJT-X, 
   by the way.)
 - All program features now work on Windows out of the box, i.e. without having to 
   install OpenSSL manually. The latter is only necessary if another, incompatible
   OpenSSL version is already installed on the computer.
 - For EME operation, a new option has been added to the Astronomical Data window
   to enable Tx shift relative to an Rx sked frequency to enable wide in-band
   separation of Tx and Rx frequencies.
 - Q65 submodes 15A, 15B and 15C can now be decoded with EME delay, for experimental
   purposes. Additional submode buttons make operation easier.
 - Better readability of the green “goal post” when Dark Style is switched on.
 - Improvements for Fox operators: 
   - Inadvertent transmissions on frequencies overlapping the WSPR sub-bands is
     now prevented.
   - The Fox operator is notified if there is probably another Fox station on the
     frequency.
 - Better support of SuperFox mode for Wait and Call: It is now possible to activate
   Wait & Call also in SuperHound mode, even if the SuperFox has not yet been
   received. However, "blind calling" is still prevented to keep the bands clean!
 - Added a new Quick Filter category "Ignore stations worked before on band".
 - Playing of the alert sounds is now muted for callsigns from the "Ignore list", or
   from the three "Ignore …​" Quick Filter categories, unless you have checked the
   BP (bypass) checkbox.
 - Numerous other code improvements.
 - Furthermore, the “improved” features are now also described in the User Guide
   (see sections 1.2 and 16 in particular).

The following list summarizes the key features of WSJT-X Improved v2.8.0 especially
for those upgrading from WSJT-X v2.7.0:

 - Three different GUIs (WSJT-X layout, AL and widescreen).
 - Built-in Dark Style:
   - You can switch to dark style with one click.
   - The built-in Dark Style is more capable than just using the start parameter
     " --stylesheet :/qdarkstyle/style.qss". Don't use this parameter.
 - High DPI scaling, resulting in a better and proportionally correct display of
   the control elements for 2K, 4K, 8K, monitors.
 - Wait Features: 
   - Three different "Wait Features" are available: Wait and Reply, Wait and Call
     and Wait and Pounce.
   - All of them are provided to assist making QSOs more efficienctly by removing
     the need to constantly call a station who does not reply initially, or under
     difficult propagation conditions such as bad QSB. 
 - Audio Alerts:
   - Built-in audio alerts. 
   - A new technology is now used, resulting in fewer resources being required when
     playing the sound files, especially under Windows.
   - The sound files are now located in the bin directory of the installation. This 
     has the advantage that also on Linux and macOS you won't have to cope the sounds
     folder to your home directory anymore.
 - Filters:
   - WSJT-X Improved has a range of powerful filters.
   - Quick Filters are accessible via the new "Filters" menu directly from the main
     window.
   - Hide stations from certain continents or DXCC with one click.
   - Hide, ignore or highlight stations worked before on band, or worked today or
     yesterday. The latter is particularly useful for contests, or for time zones
     where 00:00 UTC is not at midnight but sometime in the middle of the day.
   - A new Ignore List allows you to either highlight unwanted stations, ignore them
     with CQ: XYZ, Wait&Pounce and Best S+P, or hide them completely. Click the new
     "Ignore" button to add a station to the list. You can delete the Ignore List via
     the new "Erase Ignore List" entry in the File menu.
   - Bypass your filter settings with one click with the BP checkbox.
 - Full Duplex Mode (FDM):
   - When enabled, wsjt-x_improved is able to transmit and receive at the same time. 
   - Very useful for satellite operation, where the audio source is normally set to
     the transponder downlink, and possibly also in some special situations where you
     want to monitor your own transmit signal (e.g. using a webSDR as audio source). 
   - FDM works for the slow modes (FT8, FT4, Q65, etc.) as well as for fast modes 
     like MSK144.
   - Several modifications to AutoSeq were made to prevent QSOs with the own callsign. 
   - Your own messages are highlighted in the Band Activity window in the color you 
     selected for "Transmitted message".
 - TCI support:
   - TCI – Transceiver Control Interface is a network interface for control, data 
     transfer and synchronization between a transceiver/receiver, logger, digital 
     software, skimmer, other software and external power amplifier, band filters, 
     antenna switch, radio station controller and other devices.
   - The TCI interface supports both TCI CAT control and TCI audio. Note that when 
     switching from non-TCI to TCI or TCI audio or back, a restart of the program 
     is required, or at least recommended.
   - A new Refresh button in Settings/Audio that can be used to reload the audio 
     device list.
 - Advanced functions for the 72-bit modes (JT65, JT9, JT4):
   - Introduction of AutoSeq also to JT65, JT9 and JT4, so that these modes can now 
     be operated (almost) as easily as the 77-bit modes (FT8, FT4, MSK144, Q65, FST4).
   - The Wait features and also Filters now also work for JT65, JT9 and JT4.
   - Also CQ: First, CQ: MaxDist, CQ: Max dB and CQ: Min dB are now operational for 
     these modes.
   - This makes especially the "good old" JT9 mode interesting for DX again, because 
     it is more than 3 dB more sensitive than FT8, and also very frequency-efficient.
 - Freely selectable FT8 frequencies for band hopping:
   - Several OMs wanted this.  
   - Now the user can define up to 8 FT8 frequencies himself by spinboxes, or simply 
     enter the QRG via the keypad. 
   - The default frequencies for the new spinboxes are set to the standard DXp QRGs. 
   - But now you can enter any frequency, and it is remembered, so you can monitor  
     for example you local QRG, or a DXpedition using other frequencies, or the like.
 - Display PWR and SWR, and Halt Tx when SWR > 2.5:
   - You can now stop the transmission automatically if the SWR exceeds 2.5, e.g. if 
     you have accidentally selected the wrong antenna. 
   - Also the transmit PWR is then displayed in realtime.
   - It works with most of the modern rigs. Important: Your transceiver must be  
     either connected via one of the hamlib rig drivers or via FLRig.
 - Band Buttons:
   - The band select buttons can be switched on/off via the View menu. 
   - Clicking on a band button causes the program to search the frequency table for 
     the band/mode "default" frequency. Users can define these "default" QRGs by 
     their own. Just set the "Pref" checkboxes in Settings/Frequencies according to 
     your needs.
   - Right-clicking the band buttons will take you directly to the main DXpedition 
     frequencies when in FT8 mode (or to the intercontinental QRG on 6m).
   - With the latest Hamlib version, ATU on/off status is now remembered per band 
     for Yaesu FT-991. Very useful together with the new band buttons! Support of this 
     function for more rigs may follow in the future. This feature is brand new!
 - New technology for the Band Hopping checkboxes:
   - Like with the band buttons, the static Band Hopping checkboxes for FT8, FT4 and
     MSK144 now also get their frequencies from the Settings / Frequencies list. This
     has the advantage that you can define yourself which QRGs should be hopped to. 
     Useful for contests, or when there are local frequencies (e.g. 160m in Japan).
 - New option to automatically remove saved audio files after 30 days. 
   - It can be activated in the "Save" menu and helps to keep the total size of the 
     saved data within reasonable limits. 
   - If active, such files are removed when the program is started.
 - Download CALL3.TXT master files with one click:
   - You can now download the latest CALL3.TXT file either for terrestrial use or EME.
   - Your previous CALL3.TXT file is backed up.
   - The CALL3.TXT file for terrestrial use contains grids for more than ten thousand
     frequently heard callsigns, most of them 6-digit grids.
 - Useful improvements for EME operation:
   - A new "kHz without k" checkbox allows setting of kHz frequency offsets without 'k' 
     suffix via the band select field. EME enthusiasts can now for example directly 
     enter something like "250", press the RETURN key, and it will bring them to 
     XXXX.250 MHz instead of 250 MHz. 
   - New option to enable Tx shift relative to an Rx sked frequency.
   - Buttons are now provided for quick selection of Echo mode, as well as six sub-modes
     of Q65. Submodes 15A, 15B and 15C can now be decoded with EME delay.
 - Download CALL3.TXT master files with one click: 
   - You can now download the latest CALL3.TXT file either for terrestrial use or EME.
     Your previous CALL3.TXT file is backed up.
   - The CALL3.TXT file for terrestrial use contains grids for more than ten thousand
     frequently heard callsigns, most of them 6-digit grids.
 - Improvements to the logging of QSOs:
   - New option to log the ADIF field <SAT_MODE>.
   - Log automatically is now also possible when not in contest mode. Use this only 
     when really needed (e.g. for remote operation).
   - Two new checkboxes in Settings/Reporting: “Fill missing grids with ‘ZZ00’” and 
     “Log 4-digit grids”. This is for better support of certain contests. Note that 
     the restriction to 4-digit grids already applies automatically for certain special 
     operating activities. The new checkbox only needs to be used if this should also 
     apply to normal modes.
 - Better support of SuperFox mode for Wait and Call: 
   - It is now possible to activate Wait & Call in SuperHound mode even if the 
     SuperFox has not yet been received. 
   - However, “blind calling” is still prevented to keep the bands clean!
 - File Saving Reminder: In both QMAP and WSJT-X the Monitor button changes colour
   if File saving is active.
 - Numerous other code improvements and fixes.
 - Update to the new hamlib_4.6.1, providing the latest rig driver technology.
 - Source code available for both Qt5 and Qt6 environments.  

 Read the User Guide for more information.

The "250501" update brings the following improvements:

In programs QMAP and MAP65:
 - Introduction of a new "LiveCQ" feature. It allows messages that you decode with 
   QMAP and/or MAP65 to be uploaded automatically via the internet to the new website:
   https://w3sz.com/livecq.html. The idea is to provide spots of active EME stations
   so that others will know where to look. Read section 16.14 of the User Guide for
   more information.
 - Fixed a long-standing flaw in QMAP which could cause the program to crash after a
   few hours of operation.

In program WSJT-X:
 - The dial frequency can now be controlled via mouse (useful for EME, or when a 
   DXpedition is not on the standard DXp QRGs). If you hover the mouse pointer over
   the frequency display, you have two new options:
    - Left-click to decrease the rig dial frequency by 1 kHz, or right-click to
      increase it by 1 kHz.
    - Turn the mouse wheel to scroll the kHz values.
 - You can now choose between “worked today” and “worked today or yesterday” for the
   three respective Hide/Ignore/Highlight Quick Filters. Switching is done via a new
   checkbox under Settings/Filters.
 - Fixed some inconsistencies around the Tx watchdog. The countdown now only starts
   when Enable Tx is active (important for Wait & Call).
 - Repeated use of the rig (ATU) tuning function now works more reliably.
 - Minor bug fixes and performance improvements.
 - Slightly more detailed explanations in the WSJT-X Improved User Guide.
 - Update to Hamlib 4.6.2.
 - Last not least: The Qt6 source code can now also be compiled with Qt 6.8.x
   (important for Linux Fedora, etc.).


VERSIONS WSJT-X_v2.7.1

Various experimental builds of wsjt-x_improved 2.7.1-devel have been used to 
develop and carefully test a number of new program features for both WSJT-X and
wsjt-x_improved. Thanks to all who have contributed to the development, even if 
only as alpha or beta testers!

WSJT-X_IMPROVED 2.7.1-devel 250106-RC8:

Release candidate 8 introduces a new program feature Message System, and brings 
the following enhancements and bug fixes:

 - Introduction of the new WSJT-X Message System. It can be used to invite your 
   QSO partner to QSY to another frequency or mode (e.g. during contests), or to
   send some general short messages. It consists of the Message Creator and the 
   QSY Monitor. Received messages are displayed as popups. Read the new chapter 8
   of the User Guide for more information. 
 - A new alert category “Message received” has been added, which optionally announces
   "Message" when a message has arrived via the new message system.
 - Fixed a long-standing flaw on macOS that caused some audible alerts to not play
   correctly.
 - More intuitive navigation when WSJT-X is used together with QMAP. A single click
   in Active Stations window now selects a station to be called; a double-click also
   activates Enable Tx.
 - Added a download dialog for Hamlib Update and CALL3.TXT.
 - Avoided a potential program crash when Astronomical data window is not open.
 - Protection against some rare but possible bounds errors.
 - In WSJT-X and QMAP, the “Monitor” button now turns cyan when audio files are to 
   be saved. This is intended to prevent large amounts of data from accumulating 
   unnoticed.
 - Auto QSY (e.g. "CQ 104 A1BCD") is no longer allowed for FT8 messages, because 
   clicking on it had led to bad mistakes with some inexperienced OMs.
 - It is now ensured that a QSO is logged when "MSK 144/Q65: Tx until 73 is received" 
   is checked and a message with “73” is received.
 - Fixed an inconsistency with the Tx even/1st checkbox when switching from 
   SuperHound mode to any other mode.
 - The Help menu now provides a hyperlink to the file "How_to_deal_with_rig_
   control_errors.pdf".
 - Update to Hamlib_4.6_2024-12-04_SHA=be045d.


WSJT-X_IMPROVED 2.7.1-devel 241014-RC7:

With this update all the minor inconsistencies in our otherwise very well-functioning 
Release Candidate 7 should now be fixed. It brings the following enhancements:

 - Fixed the bug that "Enable Tx" was no longer stopped after double-clicking on a 
   message if TxFreq=RxFreq and the other station replied to someone else.
 - The GUI now prevents an incorrect Tx frequency from being set or displayed in 
   SuperFox mode when clicking on the waterfall or Tx Freq spin box.
 - Fixed an inconsistency that "Enable Tx" could not be activated in some cases when 
   SuperHound mode was previously set.
 - Better compatibility with certain MSHV multi-stream messages when your own 
   callsign is a compound call.
 - You can now use the Tab key on your keyboard to scroll through the various fields 
   in Settings/Filters.
 - Fixed a bug that caused the displayed names of Territories 1 to 4 to be retained 
   until the program was restarted, even if they had been deleted in Settings/Filters.
 - The status of the "CQ only" checkbox is now saved and restored.
 - Updated tooltip for the "BP" checkbox.


WSJT-X_IMPROVED 2.7.1-devel 241005-RC7:

This update brings some minor improvements:

 - Fixed an inconsistency when using "Rig" as your method for Split Operation. 
   This mainly affected some Elecraft rigs.
 - The program now prevents users in SuperHound mode from inadvertently setting 
   parameters that can lead to a subprocess error in the SF decoder. (For those 
   of you who don't want to update, don't set FTol greater than 100 and stay away 
   from the upper or lower limits of the waterfall with the Rx frequency. Such 
   settings make no sense in SF mode anyway.)
 - The text color of the “H” button is now white instead of red, which improves 
   readability when this button is activated.
 - When in SuperHound mode and "Special operating activity to comments" is
   checked,"SF/H mode" is now logged.
 - Another attempt to solve the audio issues with some macOS versions. 


WSJT-X_IMPROVED 2.7.1-devel 240930-RC7:

Release Candidate 7 brings for both WSJT-X and wsjt-x_improved significant 
improvements for the new SuperFox mode. It introduces a new verification 
system which replaces the previous one, and works for both the SuperFox mode 
and for old-style Fox and Hound operation. All code for SuperFox operation 
is now open source.
  
IMPORTANT: OpenSSL v1.1.1 or higher is required for the real-time
verification of Fox and SuperFox messages.

Enhancements to the SuperFox decoder:
 - Performance of the SuperFox decoder has been further improved.
 - You can now set individual FTol values and tune the decoder to
   the exact sync frequency of the SuperFox signal if it is not exactly
   750 Hz. Both result in a better decodability in certain situations.
 - Important: The Rx frequency must be set close to the sync frequency
   +/- FTol, for example 750 +/- 50 Hz.

Introduction of a new Fox verification system:
 - The new Fox verification system uses one time passwords (OTPs), and 
   works for the SuperFox mode as well as for old-style Fox and Hound 
   operation. It can be enabled by the new OTP checkbox on the Advanced
   tab of the Settings dialog.
 - Fox or SuperFox stations send individual OTPs via radio. Hounds 
   automatically check the validity of the received OTPs in real time 
   from a server when there is an internet connection. Otherwise, the 
   validity can also be queried manually later. OTP verifications can 
   only be retrieved once the transmission has already taken place.
 - You may optionally display the received OTP values by checking
   the box "Show OTP messages".
 - If the Fox or SuperFox callsign is verified by receipt of the
   correct OTP, the background color of the Hound or Super Hound label
   switches to green.
 - Theoretically, DXpeditions can set up their own OTP server, however, 
   we recommend using the server at https://www.9dx.cc. 
 - Use of the new Fox verification system requires an OTP key. The
   system uses open source code and standard encryption
   technology. For testing purposes, non-verified SuperFox
   transmissions are now possible without a key.

Improvements to SuperFox/Hound operation:
 - SuperHounds must now first decode the SuperFox before they can
   call, and a QSO must be started by double-clicking on a SuperFox
   decode. (Note that calling the Fox blindly not only leads to
   unnecessary band utilization, but can also significantly reduce the
   QSO rate due to unanswered (Super)Fox replies.)
 - Switching to SuperHound mode automatically sets the Rx frequency to
   750 Hz. The previously selected frequency is saved and restored 
   afterwards.
 - Right-clicking on the H button now activates/deactivates SuperFox mode.
 - A flaw resulting in sub-optimal SuperFox QSO rates has been
   corrected.
 - SuperFox decoder now does a more thorough job of rejecting QRM from
   non-SuperFox signals.
 - Fields in the SuperFox payload not otherwise used in a particular
   transmission are now set to known nonzero values. Do NOT use RC6 or
   earlier versions to decode SuperFox transmissions from RC7 or 
   later.
 - Old-style Fox stations can now transmit free text messages (up to
   13 characters) by using an available stream.
 - Some enhancements useful for Fox operators: Active Station Window now 
   shows band activity. Hound callsigns can be highlighted via UDP API, and 
   assigned a score for sorting via UDP API. Fox Tx frequency is preserved 
   when switching in/out of Fox mode.
 - UDP Status Update messages now include information on how many callsigns
   have highlighting applied, and how many callsigns have a score assigned.

Other enhancements and fixes:
 - In FT8 mode, the Settings dialog no longer resets the VFO frequency 
   to band/mode default unless really needed.
 - Several code improvements specifically for macOS.
 - Updated CTY.DAT and Hamlib.

Enhancements and fixes specific to wsjt-x_improved:
 - Better initialization of VFO B when using Split Operation "Rig". 
 - Allow 4-digit and 5-digit Cloudlog Station IDs .
 - A more robust code is now used for calculating distance and azimuth.
 - Prevented a program crash when compiled with Qt6 and in Fox mode.
 - Diagnostic Mode now also works with more than one instances. The individual
   instance names are added to the event log file path.


WSJT-X_IMPROVED 2.7.1-devel 240814:

 - Wait & Call no longer sets the Tx QRG to 2300 Hz when in Hound or Super Hound
   mode.
 - If using OmniRig, your rig should no longer stay at + 55 Hz after the program 
   starts. Activate "Monitor returns to last used frequency" if you want a complete 
   initialization of rig split, mode etc. at program start.
 - When transmitting in Hound mode with Tx3 and the Tx watchdog times out, the 
   program now always returns to Tx1. (Note that the special Hound watchdog is not 
   active while sending a Tx3 message. Thus, it cannot interrupt your QSO with the 
   Fox.)
 - It is now displayed in the watchdog label (bottom right) when the Hound watchdog
   (HWD) is about to time out (less than 2 minutes left). The background color 
   switches to yellow when the remaining time is less than 1 minute, and to red when
   the HWD has timed out.    
 - Inadvertently tuning on top of a SuperFox messages is now prevented.
 - When in Hound mode, AutoSeq now ignores stations calling in the wrong time lot.
 - Update to Hamlib_4.6_2024-08-09_SHA=1e54e2.


WSJT-X_IMPROVED 2.7.1-devel 240806:

 - A slightly clearer spectral display of the waterfall.
 - New options to sort the Audio device lists alphabetically, and on Linux to hide 
   the usually unusable ALSA CARD subdevices.
 - The drop-down list of COM ports is now also sorted alphabetically.
 - A more robust solution for saving and restoring the status of the “Hold Tx Freq” 
   checkbox when switching to/from Hound mode.
 - Fixed a bug that caused the program to crash on some macOS versions, especially 
   when in MSK144 mode.
 - 'Special operating activity to comments' should now work more reliably.
 - The SuperFox decoder has been further improved.
 - Some detail improvements to the Diagnostic Mode.
 - Update to hamlib_4.6_2024-08-02_SHA=fe43a6.


VERSIONS WSJT-X_v2.7.0

Release Candidate 6 2024-07-19:

WSJT-X 2.7.0 Release Candidate 6 is a bug-fix release primarily affecting the new 
SuperFox mode. It brings significant performance enhancement to the SuperFox decoder. 
My 'improved' version with this code is wsjt-x_improved 2.7.1-devel 240719-RC6. 

Other improvements introduced with the 240719-RC6 code:
 - Fixed a minor inconsistency in the Wait & Call function when in Hound (or Super 
   Hound) mode.
 - The Rx Frequency window shows now only messages for you when in Super Hound mode.
   (Hopefully) fixed this annoying "subprocess error at line 63 of sfox_demod.f90 ..." 
   bug that occurred on some operating systems. We took two slightly different 
   approaches to this, and we will see which one works best:
    - WSJT-X can now only be installed in a path that does not contain any blanks.
    - wsjt-x_improved uses a slightly more sophisticated approach, so that the program 
      can still be installed in a path that contains blanks on Windows.
 - Update to Hamlib_4.6_2024-07-13_SHA=fc8642.

Here are the original Release Notes for WSJT-X 2.7.0-rc6: (Note that as an "Improved" 
user, you have already received some of the mentioned bug fixes with the 240714 update)
 - Strong signals from Superfox too frequently failed to decode.
 - SuperFox sometimes sent incorrect signal reports and an invalid
   digital signature.
 - A Fortran bounds error could sometimes occur in the SuperFox
   decoder.
 - For SuperFox operator, the "age" displayed for Hound callers
   became garbled after the 0000 UTC date change.
 - Decodes of SuperFox transmissions were not posted to PSK Reporter.
 - Some SuperFox-related  messages were posted incorrectly to ALL.TXT.
 - Logic for turning the SuperHound label green was flawed in some
   circumstances.

Release Candidate 5 2024-07-01:

WSJT-X 2.7.0 Release Candidate 5 introduces "SuperFox" mode, a powerful new tool 
designed to help DXpeditions make digital QSOs at very high rates. RC5 also 
brings several other improvements and bug fixes.
The new wsjt-x_improved version with these features is wsjt-x_improved 2.7.1-devel 
"240701-RC5".

Changes to both WSJT-X 2.7.0-rc5 and wsjt-x_improved 2.7.1-devel "240701-RC5":
  SuperFox mode:
   - The SuperFox mode behaves operationally like the present Fox and Hounds mode 
     but uses a constant envelope waveform for Fox's transmissions rather than 
     sending concurrent streams of up to five normal FT8 signals. This approach 
     means that up to 9 messages can be transmitted simultaneously with no 
     signal-strength penalty, resulting in a system gain of about +10 dB compared 
     to the conventional Fox/Hound operation with 5 slots.
   - IMPORTANT: Older revisions of WSJT-X and derivative programs will not be 
     able to decode SuperFox transmissions. Hounds must use either WSJT-X 2.7.0-rc5 
     wsjt-x_improved 2.7.1-devel "240701-RC5" (or a later release, when available) 
     to receive SuperFox messages.
   - Hounds chasing the DX station will transmit normal FT8 signals, as in the 
     old-style Fox and Hound mode.  QSOs will be logged as FT8 mode.
   - When using SuperFox mode, Hound stations may call at any frequency in Fox's 
     received passband, including the range 0 - 1000 Hz. Hounds do not QSY to a 
     lower frequency for their final transmission.
   - SuperFox Operation requires the Fox operator to use a valid digital key.  
     Keys will be issued in advance to legitimate DXpeditions by the Northern 
     California DX Foundation, and will be kept secret.
   - Every SuperFox transmission includes a unique digital signature. Hounds 
     receiving a SuperFox message will see a "<callsign> verified" flag if the 
     transmitted signature is valid, and the on-screen "Super Hound" label will 
     turn from red to green.
   - Hound operation should begin by selecting "Special operating activity", 
     "Hound", and "SuperFox mode" on the Settings -> Advanced tab. Alternatively, 
     right-clicking on the FT8 button toggles SuperFox mode on/off for either 
     Fox or Hound, allowing quick transitions between SuperFox and old-style Fox 
     and Hound operation.
   - SuperFox stations can send free text messages of up to 26 characters together 
     with messages to as many as 4 Hounds.
  Other enhancements:
   - Corrected a flaw that caused "Log automatically" to not work for the ARRL 
     Digi Contest.
   - Control elements for special operating activities are now disabled (grayed 
     out) if the respective function is not applicable.
   - Corrected a longstanding flaw that caused "Start new period decodes at top" 
     to stop working properly after some time.
   - Right-click mouse press events are now less error-prone.
   - Improved the readability of the first line when "Start new period decodes at 
     top" is checked.
   - 4-digit grids are now logged for certain contest modes to ensure that the log 
     complies with contest rules.
   - The Fox Tx frequency is now saved and restored separately.

Changes exclusively to wsjt-x_improved 2.7.1-RC5 "240701-RC5":
  - All versions of wsjt-x_improved now provide highDPI scaling (4K support). 
    This function is enabled by default, but can now be switched off via the 
    checkbox at Settings/Advanced. The highDPI scaling feature usually results in 
    a better and proportionally correct display of the control elements on 
    high-resolution monitors (2K, 4K, 8K, etc.). However, this applies primarily 
    to Windows. My code should theoretically also work on Linux, but this depends 
    on the distribution. MacOS offers its own 4K support out of the box.
  - The Advanced tab of the Settings dialog has now a new "GUI tweaks for 
    high-resolution monitors" group box. Besides highDPI scaling there is also a 
    new "Increased height of the tab widget" checkbox. This option is primarily 
    intended for the AL version.
  - Some minor improvements and bug fixes.
  - Update to hamlib 4.6_2024-06-27_SHA=745e72.

Release Candidate 4 2024-03-11:

WSJT-X v2.7.0 Release Candidate 4 brings two major improvements:
1. QMAP is now able to decode both 60-second and 30-second T/R sequence lengths at 
   the same time. This is a milestone for EME operation, and many users had wished 
   for this.
2. Some code changes to WSJT-X which significantly reduce problems experienced when 
   (contrary to our recommendations) messages with short (10-bit) callsign hashes 
   are used in standard FT4/FT8 sub-bands.
The new wsjt-x_improved version with these features is wsjt-x_improved 2.7.1-devel 
"240311-rc4".

Enhancements for both WSJT-X v2.7.0-RC4 and wsjt-x_improved 2.7.1 "240311-rc4":
 - QMAP enhancements -- of particular interest to EME operators:
   - QMAP now decodes Q65 submodes with both 60-second and 30-second T/R sequence 
     lengths. Clicking on a resulting line in the WSJT-X Active Stations window 
     automatically sets dial frequency and working submode as needed to call that 
     station.
   - QMAP operates in 60-second receive sequences, and its Q65 decoder starts at 
     t=19.5, 30.0, 49.5, and 58.5 s into the sequence. Most decoded messages are 
     displayed well before the end of the relevant time slot.
   - A new, more compact file format is now used for wideband data files. A "Save 
     decoded" option has been added to the Save menu.
   - An option has been added to allow exporting a 3 kHz portion of a wideband data 
     file as a standard WSJT-X *.wav file.
   - CTRL+click on QMAP's upper waterfall sends an integer kHz dial frequency 
     request to WSJT-X.
   - With focus on the WSJT-X main window, hit Alt+A on the keyboard to clear the 
     Active Stations window.
   - Many minor enhancements to the User Interface.
 - WSJT-X:
   - Enable decoding of MSK144 from the jt9[.exe] executable.
   - Several changes to reduce problems experienced when (contrary to our 
     recommendations) messages with short (10-bit) callsign hashes are used in 
     standard FT4/FT8 sub-bands.
  - Update to hamlib 4.6_2024-03-05_SHA=b358cd.

Enhancements exclusively for wsjt-x_improved 2.7.1 "240311-rc4":
 - The 60m band button now uses the same technology as the others, meaning that  
   the target frequency is searched in the frequencies table. This fixes a bug 
   that prevented some OMs from switching to 60m with the band button.
 - This technology is now also used for Band Hopping, meaning that the target 
   frequencies for the FT8, FT4 and MSK144 checkboxes are now also searched in 
   the Working Frequencies table at Settings/Frequencies, and thus can be defined 
   by the user.
 - Set the OK button in the LogQSO dialogue window as the default.
 - Some detail improvements to the "Erase band Activity window after band change" 
   feature.
 - The text "Runaway Tx watchdog" is now displayed at the bottom left until the 
   next mouse or key press event, and the readability has been improved.
 - The ADIF tag  <my_gridsquare> is now only written when myGrid is not empty 
   (needed for some contest situations).
 - Right-clicking on the "Band Hopping" button now plays a sound file to test the 
   Audible Alerts.

Release Candidate 3 2024-01-01:

With WSJT-X v2.7.0-rc3 we have added a few more of my 'improved' features to the 
standard WSJT-X, as well as numerous detail improvements and bug fixes. Note that 
RC3 brings significant advantages compared to RC2, so you should all update to at 
least 2.7.0-rc3. Those of you who downloaded my recent wsjt-x_improved 2.7.1-devel 
versions already received most of these important and useful new features. 
However, I am also releasing a new 2.7.0-rc3 version for wsjt-x_improved so that 
OMs who do not want to install development versions can now also enjoy the great 
new features. For this, I took the latest stable snapshot of my 2.7.1 development 
code, because it makes no sense to downgrade this well-functioning code again. 
With this measure, it now has the status of a release candidate. 

Changes for WSJT-X and wsjt-x_improved compared to v2.7.0-rc2:
 - Added a new "Update Hamlib" function. On Windows, it allows the user to update 
   Hamlib directly from the program. The previously used version isbacked up, so 
   the user can easily revert a hamlib update. 
 - The Hamlib version in use is now displayed (also on Linux and macOS).
 - The FT Roundup Messages protocol has been enhanced. It now allows also the
   exchange of static 4-digit numbers instead of serial numbers. This extends the 
   usability of the FT RU protocol for other contest types.
 - Improved direct switching between modes. Submode, as well as the status of the 
   "Sh" and "Fast" checkboxes are now saved and restored by mode.
 - Some right-click events were made more intuitive and consistent. 
   - Right-clicking the Q65 button enables Q65 Pileup mode, a left-click brings 
     you back to the normal Q65 mode.
   - Right-click the JT65 button to switch to JT9 mode.
 - For Q65, all messages for us are now displayed in the right window.
 - Message averaging is now allowed only when VHF features are enabled, and label 
   texts are changed to "Single Period Decodes" and "Average Decodes" only if 
   averaging is enabled.
 - Some improvements to the Hamlib Transceiver code. Behavior is now more stable 
   when Rig Split has been selected.
 - Prevented redundant network communication between WSJT-X and DX Lab Suite 
   Commander.
 - Download of the LotW file now works without OpenSSL libraries.
 - Made the spot counter work for WSPR.
 - Prevented insertion of an individual contest name when in Fox mode.
 - WAE entities are now assigned to the correct DXCC when "Include extra WAE 
   entities" is not selected.
 - Added a utility program 'cablog' which can be used to convert the wsjtx.log 
   file to Cabrillo format for the ARRL EME contest.
 - Minor improvements to the Active Stations window.
 - The Rx/Tx frequency for Echo mode has been fixed at 1500 Hz.
 - Some corrections and updates to the INSTALL instructions for Linux.
 - Updated CTY.DAT file.

Changes exclusively for wsjt-x_improved:
 - Full Duplex Mode (FDM):
   - New optional feature. 
   - When FDM is enabled, wsjt-x_improved is able to transmit and receive at the 
     same time. This is very useful for satellite operation, where the audio source 
     is normally set to the transponder downlink, and possibly also in some special 
     situations where you want to monitor your own transmit signal (e.g. when using 
     a webSDR as audio source). 
   - FDM works for the slow modes (FT8, FT4, Q65, etc.) as well as for fast modes 
     like MSK144.
   - Several modifications to AutoSeq were made to prevent QSOs with the own callsign. 
   - Your own messages are highlighted in the Band Activity window in the color you 
     selected for "Transmitted message".
 - Freely selectable FT8 frequencies for band hopping:
   - Several OMs wanted this.  
   - Now the user can define up to 8 FT8 frequencies himself by spinboxes, or simply 
     enter the QRG via the keypad. 
   - The default frequencies for the new spinboxes are set to the standard DXp QRGs. 
   - But now you can enter any frequency, and it is remembered, so you can monitor  
     for example your local QRG, or a DXpedition using other frequencies, or the like.
 - Advanced functions for the 72-bit modes (JT65, JT9, JT4):
   - Introduction of AutoSeq also to JT65, JT9 and JT4, so that these modes can now 
     be operated (almost) as easily as the 77-bit modes (FT8, FT4, MSK144, Q65, FST4).
   - The Wait features and also Filters now also work for JT65, JT9 and JT4.
   - Also CQ: First, CQ: MaxDist, CQ: Max dB and CQ: Min dB are now operational for 
     these modes.
   - This makes especially the "good old" JT9 mode interesting for DX again, because 
     it is more than 3 dB more sensitive than FT8, and also very frequency-efficient.
 - Display PWR and SWR, and Halt Tx when SWR > 2.5:
   - You can now stop the transmission automatically if the SWR exceeds 2.5, e.g. if 
     you have accidentally selected the wrong antenna. 
   - Also the transmit PWR is then displayed in real-time.
   - It works with most of the modern rigs. Important: Your transceiver must be  
     either connected via one of the hamlib rig drivers or via FLRig.
 - New option to log the ADIF field <SAT_MODE>.
 - Several other improvements and fixes to make the code more stable, more reliable,
   and also a little faster.

Update 2023-08-01:
This intermediate update brings some important bug fixes as well as a number of
interesting new features. To remain compatible with the version numbering of 
WSJT-X, the name "v2.7.0-rc2" remains the same, only the revision ID has been 
changed to "230728". It brings the following changes:

 - The sensitivity and stability of the FT8 decoder has been further improved.
   Do not expect miracles, but occasionally one or two additional decodes.
 - New option to turn the progress bar red while transmitting. This feature is
   enabled by default, but you can switch it off in Settings > General via the 
   new "Turn progress bar red while transmitting" checkbox.
 - The FT Roundup Messages protocol has been enhanced. You can now exchange fixed 
   4-digit numbers instead of consecutive QSO numbers. This enables a whole new  
   range of contests or QSO parties in the future. For example, the 4-digit number
   can represent a POTA, COTA, SOTA designator, or a county, or something. 
   Note: This enhancement will also come for the original WSJT-X with v2.7.0-rc3.
 - New option to freeze the Tx5 text by right-clicking on the Tx5 button. Useful
   when some additional information (e.g. "73 FF4156") shall be transmitted as  
   free text message. Important: Any Tx5 message must contain "73".
 - Blank lines between decode periods are now suppressed when Filters are enabled
   and there are no other decodes than the filtered ones. 
 - Highlight DX Grid now also highlights the DX Grid in the messages if the 
   DX Grid text field contains a 6-digit locator.
 - A new "Auto-open/close Astronomical Data window" checkbox allows EME operators
   to automatically open the Astronomical Data window when switching to Q65, JT65,
   or Echo mode and "Decode after EME delay" is checked. It closes automatically
   when you switch to any other mode.
 - NCCC FT4 Sprint: Logging is now also triggered when "RR73" is received from the 
   other station. This happens when the other station is not in contest mode and 
   responds with a normal Tx2 message. An algorithm reduces duplicate log entries 
   to a minimum caused by stations being in NA VHF Contest mode but not having the 
   NCCC Sprint checkbox checked, or only using the original WSJT-X.
 - NCCC FT4 Sprint: Now also messages with " R " are highlighted when in FT4 mode,
   the NCCC Sprint submode is enabled, and you have the "Highlight also messages 
   with 73 or RR73" checkbox activated.  
 - Several important bug fixes:
   - "MSK144/Q65 Tx until 73 is received" works better now. A few inconsistencies
     have been fixed.
   - Fixed a flaw that in some cases caused transmissions to stop too early when
     anything other than "CQ: None" was selected.
   - Fixed a flaw that could cause the program to crash when the "Apply filters 
     only to the callsigns of the calling stations" checkbox was checked and then
     certain free text messages were received.
   - Q65 decodes directed to own callsign are now always displayed in the right 
     window again.
   - Minor improvements to the sat.dat file.
 - Update to hamlib_4.6_2023-07-21. 

Release Candidate 2 2023-07-07:

Release Candidate 2 introduces for the original WSJT-X primarily bug fixes. 
However, for wsjt-x_improved, there are some nice improvements, especially for the 
filters, as well as support of the new NCCC FT4 Sprint contest mode.

Changes for WSJT-X and wsjt-x_improved:
 - CTRL+SHIFT+F11/F12 now changes dial frequency by 1000 Hz instead of 2000 Hz.
 - Improved spotting to PSK Reporter for upcoming HamSCI Festivals of Eclipse 
   Ionospheric Science.
 - Added optional Hungarian translation of the user interface.
 - Fixed a flaw that could produce false decodes in Q65 submodes D and E.
 - Fixed a flaw with the QSO start time. It is now reset when the DX Call changes.
 - Fixed a flaw that prevented contest logging of the ARRL Digi Contest.
 - Right-clicking the Q65 mode button to toggle the Q65 Pileup mode on/off now 
   also works on macOS.
 - Fixed a compilation error on macOS Ventura.
 - WSPR and FST4W band hopping now works again.
 - It is now ensured that "U.S.A." is displayed when using certain cty.dat files.
 - Corrected the problem with duplicated FT8 entries in ActiveStations window.

Changes exclusively for wsjt-x_improved:
 - Advanced options for the Filters:
   - It is now possible to hide up to 4 DXCC countries. Specify the Territories via
     Settings > Filters, and then you are able to toggle these new filters on/off 
     directly from the View menu of the main program window.
   - New option to hide certain continents. These checkboxes are also available from
     the View menu of the main program window, so you can turn it off or on quickly.
   - New option to hide callsigns worked B4 on the band.
   - It is now shown in the Tx Status Label (bottom left) if any filters are switched 
     on, which can lead to not all decodes being displayed. Then, the label text 
     changes from "Receiving" to "Receiving, Filters On", and the background color 
     from green to cyan. (Note: This commit accidentally didn't make it into my 
     recent hotfix.)
 - Good news for contesters: 
   - All versions of wsjt-x_improved now support the NCCC Sprint FT4 short message
     protocol. Go to Settings > Advanced and enable both the NA VHF contest mode 
     and the new "NCCC Sprint" checkbox. This means, that from now on, no special 
     version is necessary when you want to participate in the weekly NCCC FT4 Sprint 
     contests.
   - Some improvements have been made to the NCCC Sprint algorithm, bringing better 
     compatibility with stations using only the normal NA VHF contest mode.
   - You can now toggle the last used contest mode on/off by simply right-clicking 
     the "H" button. This allows you to quickly reply to a station that is not in
     contest mode. 
 - wsjt-x_improved is now able to highlight individual callsigns or grids according 
   to your specifications. Callsigns and/or grids can be highlighted with orange or 
   blue background colors. The callsigns/grids must be separated by comma and can be 
   mixed (e.g. "K1JT, DG2YCB, JO33, JN58"). Important: There must be a comma behind 
   each callsign (i.e. also at the end of the line).
 - The built-in highlighting function has now two different default color schemes.
   You can choose between WSJT-X's default color scheme or the one I use with my own 
   wsjt-x_improved versions. Just go to Settings -> Colors and click one of the two
   "Reset" buttons. 
 - Some improvements to the False Decodes Reduction.
 - CQ: Max Dist is working better now. If no station answers with grid (i.e. Tx1), 
   a station sending Tx2 is now also selected. However, any Tx1 reply is preferred, 
   since a valid grid is required to calculate the distance.
 - New option to freeze the state of the Tx even/1st checkbox (e.g useful for SO2R). 
   Just set the right state and right-click the checkbox. Right-click either the 
   FT8 or MSK button to unfreeze.
 - Update to hamlib 4.6_2023-06-28, which is much faster than all previous hamlib 
   versions, at least on Windows.


Hotfix 2023-05-19:

This is primarily a bug fix release. It brings the following changes:
 - Downgrade to hamlib 4.5.5, which hopefully fixes the recent issues with some ICOM
   rigs.
 - Wait and Pounce as well as calling CQ with either CQ: Max Dist, or CQ: Max, db or
   CQ: Min dB enabled should work better now. There were some inconsistencies in the
   algorithms for these functions.
 - With CQ: Max Dist, or CQ: Max, db or CQ: Min dB enabled, the DX Call entry is no
   longer cleared after a QSO since it is not necessary anymore with my new code.
 - Some improvements to highlighting of callsigns for the slow modes (i.e. MSK144).
 - STRG + ALT + F11/F12 now moves the frequency +-1000 Hz instead of 2 kHz.

Release Candidate 1 2023-05-12:

WSJT-X 2.7.0 Release Candidate 1 introduces a new program called QMAP,
a new Special Operating Activity known as Q65 Pileup, and a number of
other enhancements and fixes.
 - QMAP and Q65 Pileup mode are of particular interest to those
   engaged in Earth-Moon-Earth (EME) communication, but other
   applications may be found for them as well.
   - QMAP is derived from MAP65, an older program used since 2007 for
     EME, mainly on the 2 m band. QMAP provides single-polarization
     receive-only capabilities for any one of the 60-second submodes
     of Q65. It allows you to monitor all traffic in a 90 kHz subband
     while conducting EME QSOs in the usual way with WSJT-X.
   - Q65 Pileup mode is a new feature in WSJT-X that will assist DX
     operators using Q65 in pileup circumstances with many
     simultaneous callers and very weak signals, such as those
     experienced by 6-meter EME DXpeditions.
   - Further details on QMAP and Q65 Pileup mode are available in a
     Quick-Start guide posted here:
     https://wsjt.sourceforge.io/Quick_Start_WSJT-X_2.7_QMAP.pdf
 - WSJT-X now provides more efficient spotting to PSK Reporter.
   Redundant spots are omitted, and posting of spots is now spread
   more widely in time. (Temporarily, in support of the HamSCI
   Festivals of Eclipse Ionospheric Science, spots will be transmitted
   more frequently during the upcoming solar eclipses.)
 - WSJT-X is now able to process more than 100 FT8 decodes in a single
   reception interval.
 - Improvements to the Fox mode:
   - More convenient and efficient handling of the two queues.
   - Fox Log window now displays statistical data on the QSO rate.
 - When the station locator is changed (e.g during portable
   operations), the new locator will be sent automatically to PSK
   Reporter.
 - The cty.dat file can now be updated by clicking a button on the
   Settings -> Colors tab.
 - A new status display appears when fetching a new LotW file.
 - Multi-streamed messages transmitted by MSHV are now handled
   properly when WSJT-X is in Hound mode.
 - Auto-sequencing now has better protection against unwanted effects
   caused by late FT8 decodes.
 - Fixed an inconsistency in which Contest Name was not correctly
   remembered.
 - Other minor bug fixes.
 - Updated hyperlinks to our homepage and to our new WSJT GROUP User
   Forum (https://groups.io/g/wsjtgroup/) can now also be found in the
   User Guide.
 - The build instructions for macOS have been clarified.

New features exclusively for wsjt-x_improved:
 - Introduction of a new "Wait and Pounce" feature. It allows you to respond 
   to incoming CQ messages from other stations according to certain criteria 
   (Max Dist, Max dB, Min dB), and can also be combined with filters. Right-click 
   on the "Enable Tx" button to activate Wait and Pounce. The "Enable Tx" button 
   then turns orange.
 - More options for the filters, and a better and faster algorithm for using them:
  - You now have 3 categories (Blacklist, Whitelist, Always Pass) and have a new
    option to use them for Wait and Pounce only. 
  - New option to apply the Whitelist and Always Pass filters only to the first
    4 characters of the second word of the messages (usually the prefix of the
    calling station).
 - Filters can now also be used for the fast modes (i.e. MSK144).
 - Highlight DX Call / Grid now also works for the fast modes (i.e. MSK144).
 - Improved algorithm for the CQ: Max Dist function. It works really well now, 
   both when calling CQ, or when you use it with the new Wait and Pounce feature.
 - Various improvements to the code to make it faster.
 - Update to hamlib 4.6_2023-05-05.

Note: Due to the politically unstable situation in the world, I offer you again a  
      time-unlimited version right away.


VERSIONS WSJT-X_v2.6.2

Update 2023-4-20:

 - New "CQ: Min dB" feature: Call CQ and automatically reply to the station with the 
   weakest signal. Current limitation: Very late decodes may not always be considered. 
   However, this is probably not so bad, because very late decodes are sometimes of 
   doubtful quality. 
 - Some improvements also to the "CQ: Max dB" feature. It is now ensured that the dB 
   score used for the selection process is correctly reset after a QSO or any manual 
   user interaction. 
 - For both "CQ: Min dB" and "CQ: Max dB", each manual click on "Halt Tx" now resets 
   the dB score and also clears the DX Call field (which is required for the next QSO). 
   The same happens when the QSO is logged. Clicking "Enable Tx" when active also resets 
   the dB score, but does not clear the DX Call field. With these changes, the two 
   "CQ: ..." features can be used more intuitively.
 - The code for the Alerts feature has been optimized (PLUS versions only): 
   - Especially on Windows, playback of the sound files is now noticeable smoother 
     and requires fewer resources.
   - The alert sounds are now also played correctly for late decodes.

GA Release 2023-04-14:

WSJT-X_v2.6.2 is a General Availability (GA) release exclusively for wsjt-x_improved users.
It brings the following enhancements and bug fixes since v2.6.1:

 - Better compatibility with MSHV and Fox stations operating in the wrong time slot:
   - When in Hound mode, AutoSeq is now also able to correctly handle QSOs where the 
     other station uses MSHV multi-stream mode instead of F/H.
   - It is now possible to work Fox stations which are operating in the wrong time slot 
     without having to leave the Hound mode: After double-clicking on such a station,
     the program temporarily switches the time slot, so AutoSeq can finish the QSO. 
     After the QSO is finished and also in case of any manual intervention by the user, 
     wsjt-x_improved immediately resets the time slot to our F/H protocol. This makes it 
     impossible to accidentally call a real Fox station in the wrong time slot. 
   - Furthermore, Christo LZ2HV seems to have accepted my suggestion that in the future 
     MSHV also transmits only even (00/30) when multi-stream mode is enabled. With this, 
     we should finally overcome the incompatibilities. Thanks for the cooperation!
 - In the WideGraph, you can now choose whether you want the timestamp to be displayed or 
   not, and whether it should be on the left or right side.
 - New feature: Show distance and/or azimuth in messages with grid: If a station sends 
   a valid Maidenhead locator, wsjt-x_improved now automatically calculates the distance 
   and the great-circle azimuth and displays it in the Band Activity pane.
 - A new "Align DXCC / distance / azimuth" checkbox allows you to keep the DXCC names 
   (or principal prefixes) as well as distance/azimuth in an aligned table form. 
 - Two spin boxes allow further configuration of the preferred layout.
   - The first spin box sets the number of spaces between the decoded message and the 
     DXCC name (or the principal prefix). The default is set to "1", which means one 
     space more compared to the WSJT-X standard.
   - The second spin box sets the number of spaces between the DXCC and the distance/ 
     azimuth field. You can increase or decrease the default number. 
   - The first spin box works also when "Align DXCC / distance / azimuth" is not checked.
     It can be used to increase the spacing between the decoded messages and the DXCC 
     names. I programmed this because the number of stations with non-standard callsigns 
     has greatly increased, and a little more space might be appropriate.
 - The horizontal position of the Band Activity window is now remembered. This allows 
   on smaller screens scrolling to the distance/azimuth field and keeping this position 
   even when new decodes arrive.
 - In the help menu, hyperlinks to the wsjt-x_improved home page as well as to the pdf 
   file "The additional features of wsjt-x_improvd" have been added.
 - The checkbox "Show principal prefix instead of country name" now automatically appears
   dimmed when "Show DXCC ..." is not activated, so this function is not applicable.
 - New option: ALT + Double-click on a call adds the callsign to DX Call Box, but does NOT
   enable Tx, although "Double-click on call sets Tx enable" is checked. You can use this
   option if you want to monitor a station first before starting a QSO.
 - Repeated double-clicking on a callsign now updates its dB values in the Tx 2 and Tx3
   messages.
 - In Settings, some checkboxes have been repositioned to make it a bit more compact and 
   intuitive. The "Show country information for all messages" checkbox has been moved to 
   the General tab and renamed "Show DXCC for all messages" so that the three content-
   related checkboxes are now arranged directly next to each other.  
 - The cty.dat file has been upgraded to the "Big CTY" variant. This allows in particular 
   a much more correct mapping of the ITU zones. 
 - Some minor improvements to the code to make it faster and more robust.
 - Bugfix: Do not switch to Tx1 after double-clicking on a message unless Tx1 is needed.
 - The source code of the wsjt-x_improved PLUS version is now also compatible with macOS.
   Therefore, I am now able to provide you with Darwin installer packages with the PLUS
   features (i.e. audible alerts and Cloudlog support).


VERSIONS WSJT-X_v2.6.1

Update 2023-02-18:
This update is exclusive for wsjt-x_improved users, and brings some useful new features,
improvements and bug fixes. The program can now also be better customized:

 - New option: "MSK144/Q65: Tx until 73 is received". It does what the name promises.
   Quite useful on VHF/UHF/SHF, it increases the success rate for a difficult QSO. 
   A maximum of 10 attempts are made before it times out. Use Wait & Reply in case
   this is still not enough for you.
 - The "Wait features" (Wait & Reply and Wait and Call) can now be disabled. As there 
   is actually no reason why to disable them, they are enabled by default. But a few
   OMs have requested this option.
 - The "Enable Tx" and "DX Call" buttons are now colored yellow if theoretically certain 
   incoming messages could switch on the Tx. This is the case in Hound mode, but also 
   with Wait & Reply or Wait & Call enabled. Some OMs had requested this safety feature
   to remind them to keep their ATU or PA on. Right-click on the DX Call button to clear
   the DX Call box and thus completely disable Tx. Experienced users don't really need
   such yellow colorings, so they can be turned off with "Disable Tx warnings".
 - If the DX Call Box contains a callsign and then "Generate Std Msgs" is clicked, Tx1 
   is now automatically selected (or Tx2 if Tx1 is disabled). This saves one click and 
   you can start your QSO right away.
 - Minor stability improvements in the modules DXLabSuiteCommanderTransceiver and 
   HamlibTransceiver.
 - Some improvements to the tooltips. Some texts now change dynamically depending on 
   which functions are active, allowing a more intuitive operation. 
 - The minimum height of the Settings window has been reduced, making it easier to  
   use on smaller screens (relevant for Linux, Raspberry Pi, etc.). 
 - New option to add the Special Operating Activity mode/name to the comments field. 
   Note: Retained comments and "dB reports to comments" override this feature.
 - Fix a flaw that the Contest Name was not always remembered or incorrectly displayed.
 - Fix a flaw when "Log QSO" was clicked during special operating activities. 
 - Fix a long-standing inconsistency that under certain conditions "RU" or "TEST" was
   also displayed in Hound mode.

Update 2023-01-20:
This update fixes a minor bug in the "dB reports to comments" feature. No other changes.

GA Release 2023-01-16:

Merged with the official WSJT-X 2.6.1 source code which is mostly a bug fix release
for Q65.  It has the following changes since release 2.6.0:

 - Fix a flaw in Q65 mode that prevented proper display of the T/R period spinner.
   Note: I had fixed this already with my wsjt-x_improved 2.6.0 versions on January 7.
 - Make the initialization of the decoded text font more robust.
 - Better initialization when starting the program in FT8 Hound mode.
 - Fix a bug causing program crash with more than 100 decodes in a single FT8 sequence.
 - Fix a compiler warning on macOS.
 - Correct the reference to "ARRL International Digital Contest" in the Release Notes.
 - Update to hamlib 4.5.4.

No changes to the wsjt-x_improved features.


VERSIONS WSJT-X_v2.6.0

GA Release 2023-01-06:

Merged with the official WSJT-X 2.6.0 source code. This is a General Availability 
(GA) release, which brings the following enhancements and bug fixes: 

Changes since 2.6.0-rc5 (both WSJT-X and wsjt-x_improved):
 - PSK Reporter spotting is now also possible for frequencies > 4 GHz. 
   This is required for QO-100, for example.
 - The minimum width of the main window has been further reduced, and such 
   small sizes are now remembered and properly restored.
 - Some further improvements for Fox operators.
 - Fix the long-standing flaw that "Start new period decodes at top" didn't
   work anymore after several hours.
 - Fix a flaw that could cause crashes by double-clicking messages with
   <...> in certain QSO situations.
 - Fix a flaw that prevented the rig from initializing correctly after 
   switching between configurations when connected via HRD.
 - Add tooltips to better explain the split operation options.
 - Add some additional FT roundup exchanges which can be used for local 
   contests or QSO parties:
    - Abbreviations for the 12 Dutch Provinces
    - 99 neutral exchanges (X01 ... X99)    
 - Update of some ARRL section abbreviations.

New features exclusively for wsjt-x_improved:
 - MSK144: Remember TR period for 6+4m, for 2m and for the other bands 
   separately. (Needed here in Europe as we use 15s on 6m, but 30s on 2m)
 - MSK144: Allow FTol up to 500.
 - MSK144: New option to freeze the Tx even/1st checkbox, so that one cannot 
   accidentally call a station in the same time slot.
 - Remember FTol values by mode. (Useful for MS and EME operation)

For full details on changes since wsjt-x_improved version 2.5.4, read the 
following sections of this changelog.


Update 2022-11-29: 
Merged with the official WSJT-X 2.6.0-rc5 source code, which brings a number 
of improvements as well as some bug fixes.

In program WSJT-X:
 - Better calibration for FST4/W SNR estimates.
 - Upload FST4W-900 spots to wsprnet with TR code 15 instead of 16.
 - Improved FT8 decoding on crowded bands. 
 - The Working frequency table now offers the following options:
    - Better handling of more than one frequency per band.
    - Set your preferred frequencies, WSJT-X always comes back to these QRGs 
      when changing band or mode.
    - You can label your frequencies with descriptions (e.g. DXp AB0YXZ).
    - Option to set Start and End Date/Time, so that the frequencies 
      automatically appear and disappear. Useful for contest or 
      DXpedition QRGs.
    - Load a frequency table from a file to easily get all such data 
 - In Fox mode, there are now a few additional functions that allow operators
   to react even better to different QSO situations:
    - A new two-column table in Tab 2 provides a better overview of the queue
      and of the callsigns with QSOs in progress.
    - Fox operator can now change the ordering of callsigns in the queue so
      that he can react if there is only a narrow time slot for a particular
      QSO due to propagation.
    - Fox now responds for another two cycles to stations whose report was
      not received, increasing the success rate for a difficult QSO.
 - Correct a flaw in Hound mode that sometimes prevented completion of QSOs
   with non-standard calls.
 - Improvements to EME Echo mode:
    - New control "Avg" sets the number of Echo cycles to be averaged.
    - New capability to display measurements of wideband noise power as a
      function of time.  This can be useful for measuring Sun noise, antenna
      tracking errors, and the like.
    - Several minor bug fixes
 - Correct a flaw that prevented WSJT-X from always initializing correctly
   when special operating activities were enabled.
 - Correct a flaw that caused wrong Tx frequencies to be written to ALL.TXT.
 - The GUI has been improved regarding some details. The controls now scale
   better at different font sizes and on different operating 
   systems.
 - When in Hound mode and click the "H" button again, the frequency 
   is now kept. This gives the user the following two options to return 
   to normal FT8 mode:
    - Click the "H" button again. Then you will stay on the QRG.
    - Click the "FT8" button (or use the Settings menu). It brings  
      you back to the default FT8 QRG.
 - Decodes flagged as 'a7' are now disabled when "Enable AP" is not checked,
   and during the first period after a band change.
 - The network address of the UDP server is now checked for errors before 
   being accepted.
 - Some improvements to the DX Lab Suite Commander interface. 
 - Correct some possible flaws that could cause segfault errors in certain
   unusual situations.
 - Warnings on dropped audio have been disabled for now, as detection has 
   turned out to be not reliable enough.
 - Correct a long-standing flaw which caused the "Transmit digital gain" 
   overlay to appear somewhere on the screen.
 - "Highlight DX Call" now also works when the other station is <...>.
 - CQ messages without a grid are now sent to PSK reporter.
 - Several other minor corrections (tool tips, etc.). 

In program MAP65 (Windows only):
 - an aid for measuring antenna pointing errors
 - an ability to read the file wsjtx.log (kept by WSJT-X) to recognize EME 
   contest dupes.

New features exclusively for wsjt-x_improved:
 - Right-clicking on the DX Call button now deletes the DX Call and DX Grid entries.
 - You can now let the Erase button behave like with JTDX:
    - Left-click --> Erase the Band Activity window
    - Right-click --> Erase the Rx Frequency window 
    - Double-click on left mouse button --> Erase both windows (unchanged)
   Enable this new "Alternate Erase button behavior" in the Settings menu, default
   is still like with WSJT-X. 
 - A new option has been added to show country names for all messages. It can be
   enabled on the Settings->Colors tab.
 - The countdown of the Tune watchdog is now displayed (like with JTDX). Remember
   that the Tune watchdog can be disabled when needed. But it protects your Rig!
 - To make it easier for you to get started with the new possibilities of the 
   Working frequency table, wsjt-x_improved already has a table, which for FT8 
   also contains the standard DXpedition QRGs, and the default QRGs are set as 
   preference. To upgrade to this table, right-click on the table and then on 
   "Reset".
 - When "Call with individual contest name" is checked, the Contest Name in now 
   automatically put in the Comments field when logging the QSO. 
 - You can now add your comments to a comments list and select the different entries
   from a combo box. Useful if you want to log your QSOs with recurring information
   like "Rig 1", "Antenna 2", "QRP", "Long path", etc.
 - DX-oriented adjustments of the FT4 decoder settings.
 - Adaptation of my 'improved' FT8 decoder settings to the updated WSJT-X FT8 decoder. 
   This brings a few more decodes and less false decodes in some situations.
 - The False Decodes Reduction (FDR) has been simplified. I made it purely optional 
   again, as it is now needed less often.
 - For the first time, I have created a special version for Fox operators. It has 
   an additional "F" button for switching the Fox mode on/off. In the future, new
   features that are especially useful for Fox operators will be implemented here.
 - With my wsjt-x_improved versions, the Fox operator is now notified when a second 
   DXpedition is operating on the same frequency.

Note: Due to the politically unstable situation in the world, I offer you again a  
      time-unlimited version right away.

Update 2022-10-07:
This update is exclusive for wsjt-x_improved users and brings some new features, 
performance enhancements as well as bug fixes:
- Dark Style: Now it is possible to switch the dark style on and off directly in  
  the main window. Just click on the new item "Use Dark Style" in the "View" menu.  
  This switch does more than restart of wsjtx.exe with the parameter --stylesheet
  :/qdarkstyle/style.qss. Additionally, it adjusts some internal settings and uses
  an optimized stylesheet for the dark style. If you have enabled the dark style,
  you should adjust the highlight color scheme towards pastel tones. Go at Settings
  to Colors and adjust the background colors according to your needs.
- Auto Sequence is now automatically enabled when you switch to a mode where it is 
  available (FT8, FT4, Q65, MSK144, and FST4).
- Wait and Reply: "Wait and Reply" and "Wait and Call" are nice little assistance 
  functions to help finish a QSO more intelligently than calling all the time when 
  the other station does not answer, or disappears temporarily due to QSB. As long 
  as you have the other station's callsign in the DX Call box, Wait and Call will 
  attempt to continue your QSO when the station finally answers your call. This  
  also ensures that a second RR73 is sent when the other station could not copy  
  your first. Wait and Reply is automatically enabled for modes where Auto Seq is 
  available.
- Wait and Call: In situations where the QSB is so strong that the other station 
  disappears for an extended period of time, Wait and Call can help you. When this 
  feature is enabled, the other station will be called up to three times as soon as 
  they reappear on the band with their message containing "CQ", "73" or "RRR". To 
  enable Wait and Call, click on the new DX Call button. Wait and Call requires a 
  valid callsign in the DX Call box (= the station where you are in QSO with) as well 
  as Auto Seq to be enabled. Any manual intervention, such as pressing the Halt Tx 
  or Stop button, will immediately disable Wait and Call, giving you full control 
  over your QSO in any case.
- "CQ: First" is now also available with MSK144.
- I found a way to further reduce the minimum GUI size of wsjt-x_improved_AL. So  
  the AL version should now work on small screens down to 640 pixels high.
- Auto-sizing of the AL GUI geometry optimized. The "AL" GUI works best with font
  sizes between 8 and 11 pt, and is now "the" GUI for small screens.
- Fixed a bug that could cause wrong Tx frequencies to be written to ALL.TXT.
- Optimization of some internal algorithms to increase performance.
- Update to hamlib 4.5_2022-10-02.
- Last but not least: There is a new wsjt-x-improved-community mailing list where all
  wsjt-x_improved topics can be discussed and where you/we can all try to help each 
  other. To subscribe, go to the following page:
  https://sourceforge.net/projects/wsjt-x-improved/lists/wsjt-x-improved-community
  In the future I plan to use this mailing list also to announce updates. 
Note: Due to the politically unstable situation in the world, I offer you again a  
      time-unlimited version right away.
Note: For technical reasons, updates to the Raspberry Pi installers must be made later. 
      Should one of you be able to provide me with installers for Raspberry Pi and/or 
      macOS, please contact me via private email.

Update 2022-09-08:
- Merged with the official WSJT-X v2.6.0-rc4 source code, which provides further 
  improvements to Echo mode, a new File menu item, and several bug fixes.
   - New features and fixes for Echo mode:
      - Created a new simulator echosim[.exe].
      - Improved organization of output to text window.
      - Gain and Zero controls in Echo Graph now behave independently.
      - "Clear Avg" now erases the plot in Echo Graph.
      - Optional baseline for plots in Echo Graph.
   - New menu item "File | Copy main text window to WSJT-X.txt".
   - Doppler tracking checkbox is made sticky.
   - Fix an RC2 bug that prevented normal use of JT9.
   - Fix a rarely experienced failure when writing to decoded.txt.
   - Fix a hamlib bug caused by setting VFO B when Split is not used.
   - Rig control interface to Ham Radio deluxe made more robust. 
- New wsjt-x_improved feature: Display bars for the Tx and Rx audio frequencies
  on the Wide Graph (like JTDX). In Wide Graph Control, use the new "Bars" and
  "Freq" checkboxes to toggle bars and frequency lables ON / OFF.  

Update 2022-08-30:
- Fix a defect in the JT9 mode.
- Stability improvements when wsjt-x_improved is connected to Ham Radio Deluxe.
- Update to hamlib 4.5_2022-08-29.

PLUS Versions with Alerts and Cloudlog Support:
- To reduce the number of different versions, I have combined the functions Alerts 
  and Cloudlog Support in a so-called "PLUS Version". Future features that may not 
  be interesting for everyone will be integrated here as well.
- Cloudlog support: Optionally upload of your QSOs to Cloudlog. Cloudlog is an 
  open-source PHP & MySQL based amateur radio logging application. You can find it
  at https://www.magicbug.co.uk/cloudlog/. Many thanks to DF2ET for the patch!

Update 2022-08-22:
- Merged with the official WSJT-X v2.6.0-rc3 source code, which brings the following 
  improvements:
   - Echo mode now allows audio-frequency corrections rather than CAT-controlled 
     resetting of dial frequency for Doppler corrections, when Doppler shift is 
     less than 750 Hz. Audio-frequency corrections are also used to correct any 
     remaining portion of Doppler shift caused by coarse CAT-controlled frequency
     setting.
   - Echo mode now saves .wav files when "Save all" is selected. When such files 
     are opened in Echo mode, the astronomical parameters at recording time are 
     restored and used for processing the Echo data.
   - A missing Leap Second (January 1, 2017) was added to the code that converts 
     UTC to UT1.  This detail might matter if you want full accuracy EME Doppler 
     corrections.
   - EME Doppler values are now rounded to nearest integer Hz.
   - For backward compatibility, "Special Operating Activity" enumerations for 
     Fox and Hound modes are reset to their previous values 6 and 7.
   - Allow FST4W transmissions on 30m band.  Ensure that correct frequency is 
     reported to WSPRnet for FST4W decodes with Rx Freq spinbox not set to 1500.
   - Fix a bug that could truncate WSPR transmissions early.
   - Fix a bug that occasionally caused a crash when 'decoded.txt'could not be 
     opened.
   - Fix a bug that could cause a crash if Astronomical Data window is not active 
     when needed.
   - Fix a bug that caused a crash when "Reset Cabrillo Log" is selected with 
     Active Stations window not active.  
- No changes to the wsjt-x_improved features.
- Update to hamlib 4.5_2022-08-20.
Note: Due to the politically unstable situation in the world I offer you again a  
      time-unlimited version right away.

Update 2022-07-26:
- Fixed a bug that could cause WSPR and FST4W transmissions to be truncated.

Update 2022-07-21:
- Merged with the official WSJT-X v2.6.0-rc2 source code, which brings the following
  improvements:
   - The "Measure" function in Echo mode now uses the computed Doppler spread for 
     DX grid, when available.  This feature is especially helpful for microwave 
     EME tests, enabling accurate measurement of SNR for a DX station.
   - Settings for T/R period and Submode are now remembered by mode when you switch 
     directly between (for example) MSK144-15, Q65-60A, JT65C, or FST4-120.
   - Tx and Rx audio frequencies are remembered and restored when you return from a 
     mode that sets a default frequency of 1500 Hz (MSK144, FST4W, Echo, WSPR, FreqCal)
     and then switching back to FT4, FT8, Q65, JT65, or FST4.
   - QSOs in the Contest Log can now be displayed in increasing or decreasing order 
     of logged time. By default the log is scrolled to the latest logged QSO, ready 
     for insertion of a new contact. The total number of QSOs in the Contest Log is 
     displayed at bottom left of its window.
   - Default FT8 frequency for 4m band (Region 1) is set to 70.154 MHz.
   - Layout of mode buttons has been optimized for 4K screens.
   - Display of Keyboard Shortcuts has been updated.
   - The OK button now has default focus in the LogQSO dialog window. You may just 
     hit Enter to log the QSO.
   - Bug fix: The Tx Freq spinbox remained red when coming back from some Q65 submodes.
   - Hamlib bug fixes: make sure that VFOB is selected when required on some rigs 
     (e.g. IC7610, IC7100), and others.
- In addition, wsjt-x_improved also brings you a couple of nice new features exclusively:  
   - Doubleclick on the Lookup button searches on QRZ.com for the callsign from the 
     DX Call box.
   - Improved behavior of the mouse buttons when clicking on the waterfall display:
     - Left-click --> set Rx offset (unchanged)
     - Right-click --> set Tx offset (NEW, behaves now like with JTDX)
     - Double-click on right mouse button --> set Rx & Tx offset (Rx = Tx), (NEW feature)
     - Shift + left-click --> set Tx offset (unchanged) 
     - Ctrl + left-click --> set Rx & Tx offset (unchanged)
   - A so-called diagnostic mode has been added. It allows you to collect data to 
     troubleshoot problems with wsjt-x_improved, or its communication with your rig. 
     Also helps to find bugs in hamlib.
   - Add an option to disable event logging entirely (saves CPU load and disk space).
   - I fixed a few minor inconsistencies.
   - Update to hamlib 4.5_2022-07-17.
Note: Due to the politically unstable situation in the world I offer you again a  
      time-unlimited version right away.

Update 2022-06-30:
- Fix an inconsistency in the Lookup function.
- Optimize mode button layout on 4K screens.
- Update to hamlib 4.5_2022-06-21.

Release 2022-06-16:
- The source codes of WSJT-X and wsjt-x_improved now have a common core. This means 
  that the basic functions of both programs are now identical and maintenance is 
  easier and more effective for both.
- I have implemented some of my wsjt-x_improved features now also in the official 
  WSJT-X v2.6.0 version so that more users can benefit from it, but of course only 
  wsjt-x_improved has all the well known extra features.
- This new version of WSJT-X and wsjt-x_improved brings some performance enhancements 
  and several bug fixes:
  In program WSJT-X:
   - Improved decoding for FT8: additional messages are marked 'a7'.
   - Improved decoding for Q65 when AP is in use.
   - Optional new "Active Stations" window and other features supporting ARRL 
     International Digital Contest.
   - Accurate SNR measurements in Echo mode, including large Doppler spreads.
   - Add a "Clr Avg" button for Echo mode.
   - Add Russian to available translations of user interface.
   - Allow auto reply for non-CQ messages via UDP (JTAlert, etc.) when Hold Tx Freq 
     is enabled.
   - Suppress transmission of blank messages.
   - Suppress self-spotting when running multiple instances.
   - Correct the handling of messages starting with "CQ xxxx ...".
   - Correct a flaw that could cause Windows to drop audio samples.
   - Correct a flaw that could send incorrect frequencies to ALL.TXT and PSK Reporter 
     after a band change.
   - Correct the auto-sequencing logic in several specific circumstances.
   - Correct a flaw in WSPR mode when handling three-character callsigns.
   - Correct a flaw that could cause OmniRig 1.19 or later to set incorrect 
     frequencies after initialization.
  In program MAP65 (Windows only):
   - Send additional information to file azel.dat.
   - Allow optional scaling of digital I/Q data.
   - Suppress a bounds error caused by too-wide setting of displaybandwidth.
- New wsjt-x_improved features:
   - The False Decodes Reduction now works in two levels. Level 1 offers very 
     effective basic protection and is always activated, while level 2 is optional 
     as before and is automatically deactivated during special operating activities.
   - Fine-tuning of my DX-optimized FT8 and FT4 decoder settings.
   - Update to hamlib 4.5_2022-06-14.
   - No changes to the other wsjt-x_improved features.
Note: Due to the politically unstable situation in the world I refrain from limiting 
      my 'improved' rc1 version and offer you the time-unlimited full version right away.


VERSIONS WSJT-X_v2.5.4

Update 2022-03-04:
- Lower CPU usage for versions with Alerts.
- Integration of DF2ET's sat patch to all my wsjt-x_improved v2.5.4 builds, meaning 
  that you don't need the special version anymore!
- Update to hamlib 4.5_2022-03-02.
- A few minor bug fixes.

Update 2022-02-11:
- Fixing a bug (U.S. States were not displayed in versions without alerts).
Version with SatPatch:
With this version you can log the satellite name and your RX frequency. Useful when 
working via Es'hail-2 / QO-100. Thanks to DF2ET for the patch!

Update 2022-01-28:
This update brings some bug fixes and performance enhancements:
- Improved algorithm to prevent spotting wrong bands to PSK Reporter when using Band 
  Hopping.
- Further improvement of the False Decodes Reduction (FDR).
- Fix of an inconsistency in Auto Seq. 

Update 2022-01-12:
This update brings you two new wsjt-x_improved features:
- The ALL.TXT file can now be automatically split yearly or monthly. Alternatively 
  you can disable writing of this file entirely. Find the new buttons on the 
  mainwindow under Save. 
- The Settings window has now a new Filters tab. There is a Blacklist and a Whitelist. 
  Filter criteria can be combined in any way. This gives you a powerful tool for 
  customization of what is being displayed at the Band Activity window. For more 
  information, see the Filters.pdf file.

Release 2021-12-28:
- Merged with the official WSJT-X v2.5.4 source code (brings a bug fix for slashed 
  callsigns)
Note: My wsjt-x_improved versions were not affected by this bug, meaning that there 
      is no urgent need for you to update from v2.5.3 to v.2.5.4. 
- Update to hamlib 4.5_2022-01-02 (brings some more fixes for ICOM and YAESU rigs).
- I upgraded my wsjt-x_improved builds to using dynamic hamlib files. This makes it 
  much more easier for you to switch to another hamlib version in case of troubles 
  with your rig. It just needs one file to be replaced now (libhamlib-4.dll).
- No changes to the other wsjt-x_improved features.


VERSIONS WSJT-X_v2.5.3

- Merged with the official WSJT-X v2.5.3 source code ($DXCALL macro capability added). 
- Update to hamlib 4.5_2021-12-13 (brings a bug fix for ICOM rigs).
- No changes to the other wsjt-x_improved features.


VERSIONS WSJT-X_v2.5.2

Update 2021-12-05:
- Update to hamlib 4.4_2021-12-02 files (brings some improvements for ICOM, YAESU
  and Elecraft rigs).
- Reduced minimum width of the main window (standard and widescreen versions).
- Implementation of the extra feature introduced by NJ0A. With that, you can map 
  grid locators to U.S. States (useful when working without JTAlert). 
  Current limitation: Sometimes the result is only a list of possible States.

Release 2021-11-04:
- Merged with the official WSJT-X v2.5.2 source code (brings again some bug fixes, 
  and minor corrections to the main window GUI). 
- Since the current hamlib has a couple of not yet fixed issues, I stayed with 
  hamlib 4.4_2021-10-20.
- No changes to the other wsjt-x_improved features.


VERSIONS WSJT-X_v2.5.1

- Merged with the official WSJT-X v2.5.1 source code (brings mainly bug fixes, and 
  a slightly wider main window). 
- Update to hamlib 4.4_2021-10-20.
- No changes to the other wsjt-x_improved features.


VERSIONS WSJT-X_v2.5.0

UPDATE 2021-10-14
Since I received a couple of suggestions for additional features I summarized all 
of them into a new release and upgraded all wsjt-x_improved v2.5.0 versions to that 
level. This includes:
- Highlight the call from the DX Call box. (Note: The colors may be overwritten 
  by JTAlert, GridTracker or some loggers.)
- Highlight the grid from the DX Grid box.
- Automatically clear the DX Call and/or DX Grid boxes after a QSO is logged 
  (useful when DX Call/Grid is highlighted).
- Automatically erase the Band Activity window after a band change.
- Automatically set the RX frequency to the TX frequency after a QSO is logged.
You can switch all these features on or off via new checkboxes on the General tab 
of the Settings window.

Release 2021-09-27:
- Merged with the official WSJT-X v2.5.0 source code (brings a faster and more 
  robust decoder for Q65). 
- The official v2.5.0 comes as a bundle of WSJT-X and MAP65 v3.0.0 (now also 
  supporting Q65). Those who do not like this is recommended to use V2.4.0 instead. 
  If you are not interested in EME, you don't need MAP65.
- Also for v2.5.0, I have restored the combined JT9+JT65 mode.
- New: Better readability of the band select box entries.
- New: More checkboxes for wsjt-x_improved band hopping. Now, you can let the 
  program also scan over the main DXpedition frequencies.
- I kept the DX-optimized FT8 and FT4 decoders from previous version but further 
  improved the internal decoder settings. The FT8 Decoder has become a bit more 
  sensitive when "deep" or "normal" is selected (detects now down to -26) while 
  "fast" now works better on slow computers.
- New: False Decodes Reduction (FDR). When enabled, it reduces significantly the 
  number of FT8 false decodes without a reduction of the sensitivity. It only 
  increases the required confidence level for some unusual message formats. 
  FDR is automatically disabled for all Special Operating modes.
- New: It is now possible in contest mode to call CQ together with an individual 
 contest name (e.g. CQ PACC ... instead of CQ TEST ... or CQ RU ...).
- No changes to the other wsjt-x_improved features.

Note: wsjt-x_improved is now available both as 64-bit and 32-bit versions (as well 
      as 64-bit versions with Alerts). While the 64-bit versions are the best for 
      all modern computers with 64-bit Windows operating system, the 32-bit versions 
      also work on older computers with 32-bit operating systems (Windows 7, etc.).


VERSIONS WSJT-X_v2.4.0

- Merged with the official WSJT-X v2.4.0 source code (introduction of the new Q65 mode). 
  Note: Joe dropped QRA64 as well as the combined JT9+JT65 mode. I have restored the
  latter.
- I kept the DX-optimized FT8 and FT4 decoders from previous version.
- The arrangement of the checkboxes for wsjt-x_improved band hopping has been 
  slightly optimized (addition of Q65 mode for 6m and 2m and FST4 for 160m, 2190m 
  and 630m FST4 removed due to low band activity).
- No changes to the other wsjt-x_improved features.
 

VERSIONS WSJT-X_v2.3.1

- Merged with the official WSJT-X v2.3.1 source code (inverts the PTT serial port 
  sharing default behaviour, and re-enables sharing when non-Hamlib CAT control is 
  combined with direct serial port PTT control).
- I kept the DX-optimized FT8 and FT4 decoders from previous version.
- The arrangement of the checkboxes for wsjt-x_improved band hopping has been
  slightly optimized.
- Settings of the band hopping checkboxes are now stored.
- No changes to the other wsjt-x_improved features.
- New: Latest hamlib 4.2 files (supporting Malachite SDR, Yaesu FTDX10, etc.).


VERSIONS WSJT-X_v2.3.0

- Merged with WSJT-X v2.3.0 GA source code (introduction of the new FST4 and FST4W 
  modes, changed UDP multicast configuration, new internal system and data logging 
  facility). Note: Joe dropped the old tab2 because of inconsistencies with some 
  newer modes.
- I kept the DX-optimized FT8 and FT4 decoders from previous version 2.2.2.
- Optional Band Hopping for FT8, FT4, MSK144 (and now also for FST4) becomes a 
  standard feature of all wsjt-x_improved versions. At 2190 m and 630 m, the mode 
  now automatically changes to FST4.
- A watchdog has been added to the Tune button to prevent accidental transmissions 
  for minutes or hours. It's set to one minute.
- The time limit when transmitting in Hound mode has been increased to 300 seconds.
- In my wsjt-x_improved versions, the new internal system and data logging system 
  is unchanged but disabled by default, since in my opinion unnecessary writes to 
  the hard disk are generated. It is activated automatically when a 
  "wsjtx_log_config.ini" file is placed in the log directory. This means that all 
  new v2.3.0 diagnostic functions are still available, but unnecessary access to 
  your hard drive is prevented.
- New wsjt-x_improved feature: The continuous writing of the ALL.TXT file can now 
  be switched off. It significantly reduces the number of writes to your hard drive
  (extends the lifespan of your SSD, also useful for older computers). To disable 
  writing, create a "noALL.txt" file and place it in the log directory. 
- Note: My wsjt-x_improved_v2.3.0 versions have already been compiled using the 
  latest hamlib database. So I skipped rc4 and published the GA version directly. 
  In case further adjustments are needed, I will release an updated version.

IMPORTANT NOTE: For UDP multicast use either 224.0.0.x or 239.255.0.x addresses 
(x between 1 and 255). 


VERSIONS WSJT-X_v2.2.2

- Merged with WSJT-X v2.2.2 GA source code, except for Joe's/Steve's changes to the 
  FT8 decoder.
- FT8 and FT4 decoders kept from v.2.2.1, but further optimized for DX. Note: this 
  new feature is experimental. Sometimes even more decodes than with JTDX, however, 
  slightly more false decodes might occur when 'Deep' is selected in the 'Decode' 
  menu. If you don't like that, choose 'Normal' instead.

Versions ...+BandHopping:
- New wsjt-x_improved feature: Band Hopping for FT8, FT4 and MSK144! At the new 
  Tab4 you'll find checkboxes for the most relevant FT8, FT4 and MSK144 frequencies. 
  Select the bands/modes you want and push the "Band Hopping" button. Automatic 
  band hopping takes place every other full minute. (This feature is very useful in 
  combination with Philip's nice www.pskreporter.info tool to get an overview on 
  propagation.)

Versions ..._updateMay2021:
Since v2.2.2 is the last version that has Tab2, I decided to provide you with an 
update from my wsjt-x_improved v2.2.2. These updated versions are like the versions 
2.2.2+BandHopping, however, they also contain the following features of v2.3.1 and higher:
- Latest hamlib 4.2 files (supporting Malachite SDR, Yaesu FTDX10, etc.).
- Settings of the band hopping checkboxes are stored and remembered.
- The continuous writing of the ALL.TXT file can be switched off by a "noALL.txt" file.
- Minor corrections of the GUI.


VERSIONS WSJT-X_v2.2.1

- WSJT-X v2.2.1 is Joe's/Bill's bug fix release that fixes regressions found in the 
  prior v2.2.0 GA release. However, it came with a new bug, relevant to YAESU FT-897D. 
  In my wsjt-x_improved versions, this new bug has already been fixed.
- No changes to the wsjt-x_improved features.


VERSIONS WSJT-X_v2.2.0

- Merged with WSJT-X v2.2.0 GA source code.
- "B" layout becomes now default.
- Layout of AL version has been slightly modified. 
- New: A bug fix relase for hams using YAESU rigs and having troubles with CAT control. 
  (The bug came with the official wsjt-x v2.2.0 GA release)


VERSIONS WSJT-X_v2.1.2

wsjt-x_improved includes the following additional functions:
- Highlighting of CQ and 73/RR73 messages.
- A new "H" button enables the FT8 DXpedition hound mode to be switched on and off 
  directly via the main program window. Simply set your rig's VFO to the correct DXp 
  frequency. When you hear the fox, just press the "H" button and make your QSO. Press 
  the "H" button again to return to normal FT8 mode.
- “FT8”, “FT4”, “MSK”, and “JT” buttons make it easy to switch between the frequently 
  used modes (useful when menus are hidden)
- Some bug fixes to wsjtx v2.1.2 (e.g. now “Hold Tx Freq” is always checked when
  coming back from FT8 Hound mode).

wsjt-x_improved_B has one more modification:
- In the Wide Graph window, text of the "Control" checkbox has been removed to prevent 
  accidental ticking when setting lower audio frequencies.

Widescreen versions:
The widescreen versions are optimized for laptops. They provide a larger Band Activity 
window, but require more horizontal space. Try it!

AL version:
The alternative layout (AL) version provides a larger Band Activity window even on 
narrow screens. 

Example WSJT-X Logging Configuration Files
==========================================

Here you  will find  some typical loggin  configuration files.  Pick a
suitable one and copy it to the WSJT-X log files directory.

This folder  contains the sources  of WSJT-X documentation.   To build
these you will need the asciidoctor tool installed.

If you do not wish to build  the documentation, it is possible to skip
this  directory  in the  WSJT-X  build  by  setting the  CMake  option
WSJT_GENERATE_DOCS to OFF in your build tree.


On Linux
========

You will probably have these installed already if you are building the
WSJT-X  manpages,  if you  are  not  you  will  just need  to  install
asciidoc:

 sudo apt-get install asciidoctor

or

 sudo yum install asciidoctor

or whatever your distribution and package management requires.


On Mac OS X
===========

I recommend MacPorts:

 sudo port install rb-rubygems
 sudo gem install asciidoctor


On Windows
==========

The asciidoctor  tool is a  Ruby script so you  will need to  install a
version of Ruby. The gem tool is a good way to install asciidoctor:

   gem install asciidoctor

                    Notes on WSJT-X Installation for Mac OS X

                    -----------------------------------------



If you have already downloaded a previous version of WSJT-X then I suggest 

you change the name in the Applications folder from WSJT-X to WSJT-X_previous 

before proceeding.  



I recommend that you follow the installation instructions especially if you

are moving from v2.5 to v2.6 or later, of WSJT-X or you have upgraded macOS.



Double-click on the wsjtx-...-Darwin.dmg file you have downloaded from K1JT's web-site.

Make sure that you leave this window open for the remaining installation steps.



Now open a Terminal window by going to Applications->Utilities and clicking on Terminal.



Along with this ReadMe file there is a file:   com.wsjtx.sysctl.plist  which must be copied to a

system area by typing these lines in the Terminal window and then pressing the Return key after

each line.



      sudo  cp  /Volumes/WSJT-X/com.wsjtx.sysctl.plist  /Library/LaunchDaemons

      sudo  chown root:wheel  /Library/LaunchDaemons/com.wsjtx.sysctl.plist



you will be asked for your normal password because authorisation is needed to copy this file.

(Your password will not be echoed but press the Return key when completed.)



IMPORTANT: Now re-boot your Mac otherwise these changes will not take effect. 



After the reboot you should re-open the Terminal window as before and you can check 

that the change has been made by typing:



      sysctl -a | grep sysv.shm



If shmmax is not shown as 52428800 then contact me since WSJT-X will fail to load with

an error message: "Unable to create shared memory segment".  If the value of shmmax

is shown as 20971520 then it is probable that you have download JTDX.   WSJT-X and JTDX

cannot both control the shmmax parameter.  Contact me for advice.



You can now close the Terminal window.  It will not be necessary to repeat this procedure 

again, even when you download an updated version of WSJT-X.  It might be necessary if you

upgrade macOS.

 

Drag the WSJT-X app to your preferred location, such as Applications.



You need to configure your sound card.   Visit Applications > Utilities > Audio MIDI 

Setup and select your sound card and then set Format to be "48000Hz 2ch-16bit" for 

input and output.  On rare occasions problems with audio output to your rig can be

corrected if you select 44100Hz for output format.



Now double-click on the WSJT-X app and two windows will appear.  Select Preferences 

under the WSJT-X Menu and fill in various station details on the General panel.   

I recommend checking the 4 boxes under the Display heading and the first 4 boxes under 

the Behaviour heading.



Depending on your macOS you might see a pop-up window suggesting that wsjtx wants to use the

microphone.   What this means is that audio input must be allowed.  Agree.



Next visit the Audio panel and select the Audio Codec you use to communicate between 

WSJT-X and your rig.   There are so many audio interfaces available that it is not 

possible to give detailed advice on selection.  If you have difficulties contact me.   

Note the location of the Save Directory.  Decoded wave forms are located here.



Look at the Reporting panel.  If you check the "Prompt me" box, a logging panel will appear 

at the end of the QSO.  Visit Section 11 of the User Guide for information about log files

and how to access them.



Finally, visit the Radio panel.  WSJT-X is most effective when operated with CAT 

control.  You will need to install the relevant Mac device driver for your rig, 

and then re-launch WSJT-X. Return to the Radio panel in Preferences and in 

the "Serial port" panel select your driver from the list that is presented. 



You may need a device driver for your Mac. The USB/UART Bridge chip inside the Icom,

Yaesu and Kenwood radios is a Silicon Labs USB to UART Bridge Controller and the Mac

drivers are available here:



https://www.silabs.com/products/development-tools/software/usb-to-uart-bridge-vcp-drivers



Visit the SiLabs site and download v6 for a Mac. Then in WSJT-X if you use the drop-down menu

for Serial Port you should see something like /dev/tty.SLAB_USBtoUART if the driver has been

installed correctly.  Make sure you read the release notes that come with the driver.



WSJT-X needs the Mac clock to be accurate.  Visit System Preferences > Date & Time 

and make sure that Date and Time are set automatically.  The drop-down menu will 

normally offer you several time servers to choose from.



On the Help menu, have a look at the new Online User's Guide for operational hints 

and tips and possible solutions to any problem you might have.



Please email me if you have problems.



--- John G4KLA     (g4kla@rmnjmn.co.uk)



Addendum:  Information about com.wsjtx.sysctl.plist and multiple instances of WSJT-X.



WSJT-X makes use of a block of memory which is shared between different parts of

the code.  The normal allocation of shared memory on a Mac is insufficient and this 

has to be increased.  The com.wsjtx.sysctl.plist file is used for this purpose.  You can 

use a Mac editor to examine the file.  (Do not use another editor - the file 

would probably be corrupted.)



It is possible to run two instances of WSJT-X simultaneously.  See "Section 16.2 

Frequently asked Questions" in the User Guide.  If you wish to run more than two instances

simultaneously, the shmall parameter in the com.wsjtx.sysctl.plist file needs to be modified as follows.



The shmall parameter determines the amount of shared memory which is allocated in 4096 byte pages

with 50MB (52428800) required for each instance.   The shmall parameter is calculated as: 

(n * 52428800)/4096  where 'n' is the number of instances required to run simultaneously.

Replace your new version of this file in /Library/LaunchDaemons and remember to reboot your

Mac afterwards.



Note that the shmmax parameter remains unchanged.  This is the maximum amount of shared memory that

any one instance is allowed to request from the total shared memory allocation and should not

be changed.



If two instances of WSJT-X are running, it is likely that you might need additional

audio devices, from two rigs for example.  Visit Audio MIDI Setup and create an Aggregate Device

which will allow you to specify more than one interface.  I recommend you consult Apple's guide

on combining multiple audio interfaces which is at https://support.apple.com/en-us/HT202000.  



2.  Preventing WSJT-X from being put into 'sleep' mode (App Nap).



In normal circumstances an application which has not been directly accessed for a while can be

subject to App Nap which means it is suspended until such time as its windows are accessed.  If

you find that WSJT-X seems disabled check this by opening Applications > Utilities > Activity Monitor and

then select Energy and look at the column marked App Nap.  If you see wsjtx marked "Yes" then you need

to disable App Nap by opening a Terminal window and typing:

    defaults  write  NSGlobalDomain  NSAppSleepDisabled  -bool  YES

This will disable App Nap for all applications.  If you wish to reverse this type:

    defaults delete  NSGlobalDomain  NSAppSleepDisabled

A UI for downloading sample files from a web server.

Works in concert with  samples/CMakeLists.txt which generates the JSON
contents description file  and has a build  target upload-samples that
uploads the samples and content file to the project files server.

QTHID INFORMATION

Qthid is simple cross platform controller application for the Funcube Dongle
Pro and Pro+ software defined radio receivers.

Author........: OZ9AEC
License.......: GNU General Public License
Site..........: http://www.oz9aec.net/index.php/funcube-dongle/qthid-fcd-controller
Source........: http://sourceforge.net/projects/qthid/files
Yahoo Group ..: https://uk.groups.yahoo.com/neo/groups/FCDevelopment/info

The qthid folder contains two binaries:

* qthid-4.0.exe
* qthid-4.1.exe

QTHID 4.0 is the current stable providing full support for the Funcube Dongle
API available with firmware 18f or later.

QTHID 4.1 is an updated version that supports the new Funcube Dongle Pro+
devices. This does not work with the original Funcube Dongle Pro!

# QDarkStylesheet

[![Build Status](https://travis-ci.org/ColinDuquesnoy/QDarkStyleSheet.png?branch=master)](https://travis-ci.org/ColinDuquesnoy/QDarkStyleSheet)
[![Latest PyPI version](https://img.shields.io/pypi/v/QDarkStyle.svg)](https://pypi.python.org/pypi/QDarkStyle)
[![License: MIT](https://img.shields.io/dub/l/vibe-d.svg)](https://opensource.org/licenses/MIT)
[![License: CC BY 4.0](https://img.shields.io/badge/License-CC%20BY%204.0-lightgrey.svg)](https://creativecommons.org/licenses/by/4.0/)
[![conduct](https://img.shields.io/badge/code%20of%20conduct-contributor%20covenant-green.svg?style=flat-square)](http://contributor-covenant.org/version/1/4/)


A dark stylesheet for Qt applications (Qt4, Qt5, PySide, PySide2, PyQt4, PyQt5, QtPy,
PyQtGraph).

## Installation

### Python

From PyPI: Get the latest stable version of ``qdarkstyle`` package
using *pip* (preferable):

```bash
pip install qdarkstyle
```

From code: Download/clone the project, go to ``qdarkstyle`` folder then:

- You can use the *setup* script and pip install.
    ```bash
    pip install .
    ```

- Or, you can use the *setup* script with Python:
    ```bash
    python setup.py install
    ```

### C++

- Download/clone the project and copy the following files to your application
  directory (keep the existing directory hierarchy):

  - **qdarkstyle/style.qss**
  - **qdarkstyle/style.qrc**
  - **qdarkstyle/rc/** (the whole directory)

- Add **qdarkstyle/style.qrc** to your **.pro file** as follows:

  ```cpp
  RESOURCES += qdarkstyle/style.qrc
  ```
- Load the stylesheet:

  ```cpp
  QFile f(":qdarkstyle/style.qss");
  if (!f.exists())
  {
      printf("Unable to set stylesheet, file not found\n");
  }
  else
  {
      f.open(QFile::ReadOnly | QFile::Text);
      QTextStream ts(&f);
      qApp->setStyleSheet(ts.readAll());
  }
  ```

_Note: The ":" in the file name is necessary to define that file as a resource library. For more information see the discussion [here](https://github.com/ColinDuquesnoy/QDarkStyleSheet/pull/87)._

## Usage

Here is an example using PySide

```Python
import sys
import qdarkstyle
from PySide import QtGui

# create the application and the main window
app = QtGui.QApplication(sys.argv)
window = QtGui.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_pyside())

# run
window.show()
app.exec_()
```

To use another wrapper for Qt, you need to replace some lines.
See examples below.

To use PyQt4, change two lines

```Python
from PySide import QtGui
app.setStyleSheet(qdarkstyle.load_stylesheet_pyqt())
```

If PyQt5, more lines need to be changed because of its API,
see the complete example

```Python
import sys
import qdarkstyle
from PyQt5 import QtWidgets

# create the application and the main window
app = QtWidgets.QApplication(sys.argv)
window = QtWidgets.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_pyqt5())

# run
window.show()
app.exec_()
```

If your project uses QtPy or you need to set it programmatically,
it is far more simple

```Python
import sys
import qdarkstyle
import os

# set the environment variable to use a specific wrapper
# it can be set to pyqt, pyqt5, pyside or pyside2 (not implemented yet)
# you do not need to use QtPy to set this variable
os.environ['QT_API'] = 'pyqt'

# import from QtPy instead of doing it directly
# note that QtPy always uses PyQt5 API
from qtpy import QtWidgets

# create the application and the main window
app = QtWidgets.QApplication(sys.argv)
window = QtWidgets.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_from_environment())

# run
window.show()
app.exec_()
```

It is also simple if you use PyQtGraph

```Python
import sys
import qdarkstyle
import os

# set the environment variable to use a specific wrapper
# it can be set to PyQt, PyQt5, PySide or PySide2 (not implemented yet)
os.environ['PYQTGRAPH_QT_LIB'] = 'PyQt'

# import from pyqtgraph instead of doing it directly
# note that PyQtGraph always uses PyQt4 API
from pyqtgraph.Qt import QtGui

# create the application and the main window
app = QtGui.QApplication(sys.argv)
window = QtGui.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_from_environment(is_pyqtgraph=True))

# run
window.show()
app.exec_()
```

If you are using Qt.py, which is different from qtpy, you should install
qtpy then set both to the same binding.

_There is an example included in the *example* folder.
You can run the script without installing qdarkstyle. You only need to have
PySide or PySide2 or PyQt4 or PyQt5 installed on your system._


## What is new?

In the version 2.6 and later, a reestructure stylesheet is provided. The palette has only 9 colors. Most widgets are revised and their styles were improved. We also provide a command line (script) to get info that could be used when opening issues. See the image below.

```
qdarkstyle --all
```

<img src="./screenshots/cmd.png"/>


## Snapshots

Here are a few snapshots comparing the use of QDarkStyle v2.6.1 and the default style.
Click in the image to zoom.

<table style="width:100%">
  <tr>
    <th colspan=2>Containers (no tabs) and Buttons</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_containers_buttons.png"/></td>
    <td><img src="./screenshots/no_dark_containers_buttons.png"/></td>
  </tr>
  <tr>
    <th colspan=2>Containers (tabs) and Displays</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_containers_tabs_displays.png"/></td>
    <td><img src="./screenshots/no_dark_containers_tabs_displays.png"/></td>
  </tr>
  <tr>
    <th colspan=2>Widgets and Inputs (fields)</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_widgets_inputs_fields.png"/></td>
    <td><img src="./screenshots/no_dark_widgets_inputs_fields.png"/></td>
  </tr>
  <tr>
    <th colspan=2>Views and Inputs (no fields)</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_views_inputs_no_fields.png"/></td>
    <td><img src="./screenshots/no_dark_views_inputs_no_fields.png"/></td>
  </tr>
</table>

## Changelog

Please, see [CHANGES](CHANGES.md) file.

## License

This project is licensed under the MIT license.
Images contained in this project are licensed under CC-BY license.

For more information see [LICENSE](LICENSE.md) file.

## Authors

For more information see [AUTHORS](AUTHORS.md) file.

## Contributing

Most widgets have been styled. If you find a widget that has not been
style, just open an issue on the issue tracker or, better, submit a pull
request.

If you want to contribute, see [CONTRIBUTING](CONTRIBUTING.md) file.

wsprd is a decoder for K1JT's Weak Signal Propagation Reporter (WSPR) mode.

The program is written in C and is a command-line program that reads from a
.c2 file or .wav file and writes output to the console. It is used by WSJT-X
for wspr-mode decoding. 

USAGE: 
       wsprd [options...] infile

OPTIONS:
       -a <path> path to writeable data files, default="."
       -B disable block demodulation - use single-symbol noncoherent demod
       -c write .c2 file at the end of the first pass
       -C maximum number of decoder cycles per bit, default 10000
       -d deeper search. Slower, a few more decodes
       -e x (x is transceiver dial frequency error in Hz)
       -f x (x is transceiver dial frequency in MHz)
       -H do not use (or update) the hash table
       -J use the stack decoder instead of Fano decoder
       -m decode wspr-15 .wav file
       -o n (0<=n<=5), decoding depth for OSD, default is disabled
       -q quick mode - doesn't dig deep for weak signals
       -s single pass mode, no subtraction (same as original wsprd)
       -v verbose mode (shows dupes)
       -w wideband mode - decode signals within +/- 150 Hz of center
       -z x (x is fano metric table bias, default is 0.45)

infile can be either .wav or .c2

e.g. 
./wsprd -wf 14.0956 140709_2258.wav

Note that for .c2 files, the frequency within the file overrides the command
line value.

FEATURES:
By default, wsprd reports signals that are within +/- 110 Hz of the
subband center frequency. The wideband option (-w) extends this to +/- 150 Hz.

wsprd maintains a hashtable and will decode all three types of wspr
messages. An option (-H) is available to turn off use of the hashtable.

Decoding is attempted using soft symbols derived using single-symbol 
noncoherent detection. If decoding fails, then soft symbols derived using
block demodulation over 2- and 3-symbol blocks are used in subsequent
decoding attempts. For slower computers, block demodulation can be 
disabled with the -B command line option. 

The symbols are decoded using Phil Karn's sequential decoder routine,
fano.c. The -J option replaces the Fano algorithm with the Jelinek 
"stack-bucket" algorithm. If the -o command line option is enabled, then
an ordered-statistics decoder (OSD) is invoked if the Fano (or Jelinek) algorithm
fails. The OSD is a complete decoder, meaning that it always returns a codeword. 
A returned codeword is considered valid only if the unpacked decode contains
a callsign that is already in the hashtable. 

NOTES:
This program attempts to maximize the number of successful decodes per transmit
interval by trying to decode virtually every peak in the averaged spectrum. 
The program also implements two-pass decoding, whereby signals that are successfully
decoded are subtracted one-by-one during the first decoding pass. Then, the 
decoder is run again. In many cases the subtraction process will uncover signals
that can then be successfully decoded on the second pass.

There will be occasional duplicate decodes when two closely spaced 
peaks come from the same signal. The program removes dupes based on callsign 
and frequency. Two decodes that have the same callsign and estimated frequencies
that are within 1 Hz will be treated as decodes of the same signal. This
dupechecking is turned off with the -v flag.

1. INTRODUCTION

Qthid is a Funcube Dongle control application with Qt user interface. It is an evolution of the qthid002 package by Howard Long G6LVB.

The Funcube Dongle (http://www.funcubedongle.com/) is a small software defined radio receiver for 64 MHz - 1.7 GHz. It fits into a computer's USB port and uses USB audio to transfer complex I/Q data to SDR applications. The control API for setting frequency, gain, filter, etc. uses the USB HID standard, thus the Funcube Dongle does not require any specific hardware drivers as long as the host operating system supports USB audio and HID.

Qthid uses the HIDAPI cross platform library by Signal 11 Software (http://www.signal11.us/oss/hidapi/). All the required files are bundled with qthid and no installation of the library is required.

The current version 4.0 implements the full API available with the 18f firmware. It should cover all the functionality provided by the "fully functional windows frontend". Note that the majority of this full API is only available since firmware 18f and qthid 4 will not work with earlier firmware. The application will simply fail to detect the FCD with earlier firmwares.

You can use qthid 2.x to upgrade your firmware to 18f or later.


2. INSTALLATION AND USAGE

2.1 Linux

If you are using Debian testing or Ubuntu, you can install the qthid-fcd-controller package. This should set everything up and you can skip the rest of this section.

Otherwise you can use the precompiled binaries (32 or 64 bit) but you need the Qt runtime libraries installed. On Ubuntu these are called libqtcore4 and libqtgui4 and their dependencies. You can simply install everything Qt version 4 (not version 3!). Qt 4.8 has been tested, Qt 4.7 will probably also work.

In order to use the Funcube Dongle as regular user, you need to create an udev rule. An example funcube-dongle.rules file is included with the package and you can simply copy that into the /lib/udev/rules.d/ directory.
  
(hint: open a terminal and type: sudo cp funcube-dongle.rules /lib/udev/rules.d/funcube-dongle.rules)

Qthid should now detect your FCD when you plug it in. No need to restart udev.


2.2 Mac OS X (10.6+)

The Mac OS X bundle contains all the necessary Qt libraries and no additional installation or configuration is required. Unlike Linux, the Funcube Dongle will just work.


2.3 Windows

The windows package is self containing and does not require and Qt libs to be installed separately. It is known to work on Windows XP and Windows 7.


2.4 Building from source

- Install Qt Creator 2.0.1 or newer and Qt SDK 4.7. On recent linux it is normally sufficient to select Qt Creator and the required Qt libraries will be installed as dependencies. On Mac and Windows you need to download the full Qt SDK. On Windows you also need the MS Windows SDK.
- On linux you also need to install the libudev-dev package using the package manager (the name may be different depending on distribution but it should have libudev and dev int he name).
- Open the qthid.pro file in Qt Creator. It will say something about setting up a target; say OK or Finish or Done (depends on version and OS).
- You can now build and execute the project.

If you want to try the latest experimental code you can check it out from Github: https://github.com/csete/qthid


3. License

Qthid is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.


The frequency controller widget was taken from Cutesdr by Moe Wheatley, released under the following "Simplified BSD License":

Copyright 2010 Moe Wheatley. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of
    conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright notice, this list
    of conditions and the following disclaimer in the documentation and/or other materials
    provided with the distribution.

THIS SOFTWARE IS PROVIDED BY Moe Wheatley ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Moe Wheatley OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those of the
authors and should not be interpreted as representing official policies, either expressed
or implied, of Moe Wheatley.

1. INTRODUCTION

Qthid is a small control application for the Funcube Dongle devices. It is an evolution of the qthid002 package by Howard Long G6LVB.

This version 4.1 is a special version that adds support for the Funcube Dongle Pro+ (see http://www.funcubedongle.com/?page_id=1073). The original Funcube Dongle Pro is not supported by this version.

Qthid uses the HIDAPI cross platform library by Signal 11 Software (http://www.signal11.us/oss/hidapi/). All the required files are bundled with qthid and no installation of the library is required.


2. INSTALLATION AND USAGE

2.1 Linux

Precompiled binaries (32 or 64 bit) are avaialble for download but users are required to install the Qt runtime libraries on their own. All common Linux distrib utions have the Qt libraries packaged and they can be installed using the package manager for the platform. Qt 4.7 and 4.8 has been tested.

In order to use the Funcube Dongle Pro+ as regular user and udev rule is required. An example funcube-dongle.rules file is included with the package and you can simply copy that file to the /etc/udev/rules.d/ directory (hint: open a terminal and type: "sudo cp funcube-dongle.rules /etc/udev/rules.d/" without the quotes)

Qthid should now detect your Funcube Dongle Pro+ when you plug it in. No reboot or udev restart is necessary.


2.2 Mac OS X (10.6+)

The Mac OS X bundle contains all the necessary Qt libraries and no additional installation or configuration is required. Unlike Linux, the Funcube Dongle will just work.


2.3 Windows

The windows package is self containing and does not require and Qt libs to be installed separately. This release has been tested on Windows 7.


2.4 Building from source

- Install Qt Creator 2.0.1 or newer and Qt SDK 4.7. On recent linux it is normally sufficient to select Qt Creator and the required Qt libraries will be installed as dependencies. On Mac and Windows you need to download the full Qt SDK. On Windows you also need the MS Windows SDK.
- On linux you also need to install the libudev-dev package using the package manager (the name may be different depending on distribution but it should have libudev and dev int he name).
- Open the qthid.pro file in Qt Creator. It will say something about setting up a target; say OK or Finish or Done (depends on version and OS).
- You can now build and execute the project.

It is also possible to build in a terminal:

$ tar xvfz qthid-X.Y.tar.gz
$ cd qthid-X.Y
$ mkdir build
$ cd build
$ qmake ../qthid.pro
$ make

You should now have a qthid binary.


3. License

Qthid is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.


The frequency controller widget was taken from Cutesdr by Moe Wheatley, released under the following "Simplified BSD License":

Copyright 2010 Moe Wheatley. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY Moe Wheatley "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Moe Wheatley OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those of the authors and should not be interpreted as representing official policies, either expressed or implied, of Moe Wheatley.

subroutine symspec2(c5,nz3,nsps8,nspsd,fsample,freq,drift,snrdb,schk,    &
     i1SoftSymbolsScrambled)

! Compute soft symbols from the final downsampled data

  complex c5(0:4096-1)
  complex z
  integer*1 i1SoftSymbolsScrambled(207)
  real aa(3)
  real ss2(0:8,85)
  real ss3(0:7,69)
  include 'jt9sync.f90'
  data scale/10.0/

  aa(1)=-1500.0/nsps8
  aa(2)=0.
  aa(3)=0.
  do i=0,8                                         !Loop over the 9 tones
     if(i.ge.1) call twkfreq(c5,c5,nz3,fsample,aa)
     m=0
     k=-1
     do j=1,85                                     !Loop over all symbols
        z=0.
        do n=1,nspsd                               !Sum over 16 samples
           k=k+1
           z=z+c5(k)
        enddo
        ss2(i,j)=real(z)**2 + aimag(z)**2        !Symbol speactra, data and sync
        if(i.ge.1 .and. isync(j).eq.0) then
           m=m+1
           ss3(i-1,m)=ss2(i,j)                   !Symbol speactra, data only
        endif
     enddo
  enddo

  call chkss2(ss2,freq,drift,schk)

  ss=0.
  sig=0.
  do j=1,69
     smax=0.
     do i=0,7
        smax=max(smax,ss3(i,j))
        ss=ss+ss3(i,j)
     enddo
     sig=sig+smax
     ss=ss-smax
  enddo
  ave=ss/(69*7)                           !Baseline
  call pctile(ss2,9*85,35,xmed)
  ss3=ss3/ave
  sig=sig/69.                             !Signal
  t=max(1.0,sig - 1.0)
  snrdb=db(t) - 61.3
     
  m0=3
  k=0
  do j=1,69
        smax=0.
        do i=0,7
           if(ss3(i,j).gt.smax) smax=ss3(i,j)
        enddo

     do m=m0-1,0,-1                   !Get bit-wise soft symbols
        if(m.eq.2) then
           r1=max(ss3(4,j),ss3(5,j),ss3(6,j),ss3(7,j))
           r0=max(ss3(0,j),ss3(1,j),ss3(2,j),ss3(3,j))
        else if(m.eq.1) then
           r1=max(ss3(2,j),ss3(3,j),ss3(4,j),ss3(5,j))
           r0=max(ss3(0,j),ss3(1,j),ss3(6,j),ss3(7,j))
        else
           r1=max(ss3(1,j),ss3(2,j),ss3(4,j),ss3(7,j))
           r0=max(ss3(0,j),ss3(3,j),ss3(5,j),ss3(6,j))
        endif

        k=k+1
        i4=nint(scale*(r1-r0))
        if(i4.lt.-127) i4=-127
        if(i4.gt.127) i4=127
!        i4=i4+128
!        if(i4.le.127) i1SoftSymbolsScrambled(k)=i4
!        if(i4.ge.128) i1SoftSymbolsScrambled(k)=i4-256
        i1SoftSymbolsScrambled(k)=i4
     enddo
  enddo

  return
end subroutine symspec2

subroutine gen_fst4wave(itone,nsym,nsps,nwave,fsample,hmod,f0,    &
   icmplx,cwave,wave)

   use prog_args
   parameter(NTAB=65536)
   real wave(nwave)
   complex cwave(nwave),ctab(0:NTAB-1)
   character(len=1) :: cvalue 
   real, allocatable, save :: pulse(:)
   real, allocatable :: dphi(:)
   integer hmod
   integer itone(nsym)
   logical first, lshape
   data first/.true./
   data nsps0/-99/
   data lshape/.true./
   save first,twopi,dt,tsym,nsps0,ctab,lshape

   if(first) then
      twopi=8.0*atan(1.0)
      do i=0,NTAB-1
         phi=i*twopi/NTAB
         ctab(i)=cmplx(cos(phi),sin(phi))
      enddo
      call get_environment_variable("FST4_NOSHAPING",cvalue,nlen)
      if(nlen.eq.1 .and. cvalue.eq."1") lshape=.false.
   endif

   if(first.or.nsps.ne.nsps0) then
      if(allocated(pulse)) deallocate(pulse)
      allocate(pulse(1:3*nsps))
      dt=1.0/fsample
      tsym=nsps/fsample
! Compute the smoothed frequency-deviation pulse
      do i=1,3*nsps
         tt=(i-1.5*nsps)/real(nsps)
         pulse(i)=gfsk_pulse(2.0,tt)
      enddo
      first=.false.
      nsps0=nsps
   endif

! Compute the smoothed frequency waveform.
! Length = (nsym+2)*nsps samples, zero-padded
   allocate( dphi(0:(nsym+2)*nsps-1) )
   dphi_peak=twopi*hmod/real(nsps)
   dphi=0.0
   do j=1,nsym
      ib=(j-1)*nsps
      ie=ib+3*nsps-1
      dphi(ib:ie) = dphi(ib:ie) + dphi_peak*pulse(1:3*nsps)*itone(j)
   enddo

! Calculate and insert the audio waveform
   phi=0.0
   dphi = dphi + twopi*(f0-1.5*hmod/tsym)*dt       !Shift frequency up by f0
   if(icmplx.eq.0) wave=0.
   if(icmplx.eq.1) cwave=0.
   k=0
   do j=nsps,(nsym+1)*nsps-1
      k=k+1
      i=phi*float(NTAB)/twopi
      i=iand(i,NTAB-1)
      if(icmplx.eq.0) then
         wave(k)=aimag(ctab(i))
      else
         cwave(k)=ctab(i)
      endif
      phi=phi+dphi(j)
      if(phi.gt.twopi) phi=phi-twopi
   enddo

! Compute the ramp-up and ramp-down symbols
   if(icmplx.eq.0) then
      if(lshape) then
         wave(1:nsps/4)=wave(1:nsps/4) *                      &
            (1.0-cos(twopi*(/(i,i=0,nsps/4-1)/)/real(nsps/2)))/2.0
         k1=(nsym-1)*nsps+3*nsps/4+1
         wave(k1:k1+nsps/4)=wave(k1:k1+nsps/4) *                              &
            (1.0+cos(twopi*(/(i,i=0,nsps/4)/)/real(nsps/2)))/2.0
      endif
   else
      if(lshape) then
         cwave(1:nsps/4)=cwave(1:nsps/4) *                    &
            (1.0-cos(twopi*(/(i,i=0,nsps/4-1)/)/real(nsps/2)))/2.0
         k1=(nsym-1)*nsps+3*nsps/4+1
         cwave(k1:k1+nsps/4)=cwave(k1:k1+nsps/4) *                              &
            (1.0+cos(twopi*(/(i,i=0,nsps/4)/)/real(nsps/2)))/2.0
      endif
   endif

   return
end subroutine gen_fst4wave

subroutine echo_snr(sa,sb,fspread,blue,red,snrdb,db_err,fpeak,snr_detect)

  parameter (NZ=4096)
  real sa(NZ)
  real sb(NZ)
  real blue(NZ)
  real red(NZ)
  integer ipkv(1)
  equivalence (ipk,ipkv)

  df=12000.0/32768.0
  wh=0.5*fspread+10.0
  i1=nint((1500.0 - 2.0*wh)/df) - 2048
  i2=nint((1500.0 - wh)/df) - 2048
  i3=nint((1500.0 + wh)/df) - 2048
  i4=nint((1500.0 + 2.0*wh)/df) - 2048

!  call pctile(sb(i1),i2-i1,50,r0)
!  call pctile(sb(i3+1),i4-i3,50,r1)
!  ave=0.5*(r0+r1)
!  blue=sa/ave
!  red=sb/ave

  baseline=(sum(sb(i1:i2-1)) + sum(sb(i3+1:i4)))/(i2+i4-i1-i3)
  blue=sa/baseline
  red=sb/baseline
  psig=sum(red(i2:i3)-1.0)
  pnoise_2500 = 2500.0/df
  snrdb=db(psig/pnoise_2500)

  smax=0.
  mh=max(1,nint(0.2*fspread/df))
  do i=i2,i3
     ssum=sum(red(i-mh:i+mh))
     if(ssum.gt.smax) then
        smax=ssum
        ipk=i
     endif
  enddo
  fpeak=ipk*df - 750.0

  call averms(red(i1:i2-1),i2-i1,-1,ave1,rms1)
  call averms(red(i3+1:i4),i4-i3,-1,ave2,rms2)
  perr=0.707*(rms1+rms2)*sqrt(float(i2-i1+i4-i3))
  snr_detect=psig/perr
  db_err=99.0
  if(psig.gt.perr) db_err=snrdb - db((psig-perr)/pnoise_2500)
  if(db_err.lt.0.5) db_err=0.5

  return
end subroutine echo_snr

real function fchisq65(cx,npts,fsample,nflip,a,ccfmax,dtmax)

  use timer_module, only: timer

  parameter (NMAX=60*12000)          !Samples per 60 s
  complex cx(npts)
  real a(5)
  complex w,wstep,z
  real ss(3000)
  complex csx(0:NMAX/8)
  data twopi/6.283185307/a1,a2,a3/99.,99.,99./
  save

  call timer('fchisq65',0)
  baud=11025.0/4096.0
  nsps=nint(fsample/baud)                  !Samples per symbol
  nsph=nsps/2                              !Samples per half-symbol
  ndiv=16                                  !Output ss() steps per symbol
  nout=ndiv*npts/nsps
  dtstep=1.0/(ndiv*baud)                   !Time per output step

 if(a(1).ne.a1 .or. a(2).ne.a2 .or. a(3).ne.a3) then
     a1=a(1)
     a2=a(2)
     a3=a(3)

! Mix and integrate the complex signal
     csx(0)=0.
     w=1.0
     x0=0.5*(npts+1)
     s=2.0/npts
     do i=1,npts
        x=s*(i-x0)
        if(mod(i,100).eq.1) then
           p2=1.5*x*x - 0.5
           dphi=(a(1) + x*a(2) + p2*a(3)) * (twopi/fsample)
          wstep=cmplx(cos(dphi),sin(dphi))
        endif
        w=w*wstep
        csx(i)=csx(i-1) + w*cx(i)
     enddo
  endif

! Compute whole-symbol powers at 1/16-symbol steps.
  fac=1.e-4
  do i=1,nout
     j=nsps+(i-1)*nsps/16 !steps by 8 samples (1/16 of a symbol)
     k=j-nsps
     ss(i)=0.
     if(k.ge.0 .and. j.le.npts) then
        z=csx(j)-csx(k) ! difference over span of 128 pts
        ss(i)=fac*(real(z)**2 + aimag(z)**2)
     endif
  enddo

  ccfmax=0.
  call timer('ccf2    ',0)
  call ccf2(ss,nout,nflip,ccf,xlagpk)
  call timer('ccf2    ',1)
  if(ccf.gt.ccfmax) then
     ccfmax=ccf
     dtmax=xlagpk*dtstep
  endif
  fchisq65=-ccfmax
  call timer('fchisq65',1)

  return
end function fchisq65

subroutine bpdecode40(llr,maxiterations,decoded,niterations)
!
! A log-domain belief propagation decoder for the msk40 code.
! The code is a regular (32,16) code with column weight 3, row weights 5,6,7.
! k9an August, 2016
!
integer, parameter:: N=32, K=16, M=N-K
integer*1 codeword(N),cw(N)
integer*1 colorder(N)
integer*1 decoded(K)
integer Nm(7,M)  ! 5,6 or 7 bits per check 
integer Mn(3,N)  ! 3 checks per bit
integer synd(M)
real tov(3,N)
real toc(7,M)
real tanhtoc(7,M)
real zn(N)
real llr(N)
real Tmn
integer nrw(M)

data colorder/ &
    4,   1,   2,   3,   0,   8,   6,  10, &
   13,  28,  20,  23,  17,  15,  27,  25, &
   16,  12,  18,  19,   7,  21,  22,  11, &
   24,   5,  26,  14,   9,  29,  30,  31/

data Mn/               &
  1, 6, 13,  & 
  2, 3, 14,  & 
  4, 8, 15,  & 
  5, 11, 12,  & 
  7, 10, 16,  & 
  6, 9, 15,  & 
  1, 11, 16,  & 
  2, 4, 5,  & 
  3, 7, 9,  & 
  8, 10, 12,  & 
  8, 13, 14,  & 
  1, 4, 12,  & 
  2, 6, 10,  & 
  3, 11, 15,  & 
  5, 9, 14,  & 
  7, 13, 15,  & 
  12, 14, 16,  & 
  1, 2, 8,  & 
  3, 5, 6,  & 
  4, 9, 11,  & 
  1, 7, 14,  & 
  5, 10, 13,  & 
  3, 4, 16,  & 
  2, 15, 16,  & 
  6, 7, 12,  & 
  7, 8, 11,  & 
  1, 9, 10,  & 
  2, 11, 13,  & 
  3, 12, 13,  & 
  4, 6, 14,  & 
  1, 5, 15,  & 
  8, 9, 16/

data Nm/               &
1, 7, 12, 18, 21, 27, 31,  & 
2, 8, 13, 18, 24, 28, 0, & 
2, 9, 14, 19, 23, 29, 0, & 
3, 8, 12, 20, 23, 30, 0, & 
4, 8, 15, 19, 22, 31, 0, & 
1, 6, 13, 19, 25, 30, 0, & 
5, 9, 16, 21, 25, 26, 0, & 
3, 10, 11, 18, 26, 32, 0, & 
6, 9, 15, 20, 27, 32,  0,& 
5, 10, 13, 22, 27, 0, 0, & 
4, 7, 14, 20, 26, 28, 0, & 
4, 10, 12, 17, 25, 29, 0, & 
1, 11, 16, 22, 28, 29, 0, & 
2, 11, 15, 17, 21, 30, 0, & 
3, 6, 14, 16, 24, 31, 0, & 
5, 7, 17, 23, 24, 32, 0/  

data nrw/7,6,6,6,6,6,6,6,6,5,6,6,6,6,6,6/ 

ncw=3

toc=0
tov=0
tanhtoc=0

! initialize messages to checks
do j=1,M
  do i=1,nrw(j)
    toc(i,j)=llr((Nm(i,j)))
  enddo
enddo

do iter=0,maxiterations

! Update bit log likelihood ratios (tov=0 in iteration 0).
  do i=1,N
    zn(i)=llr(i)+sum(tov(1:ncw,i))
  enddo

! Check to see if we have a codeword (check before we do any iteration).
  cw=0
  where( zn .gt. 0. ) cw=1
  ncheck=0
  do i=1,M
    synd(i)=sum(cw(Nm(1:nrw(i),i)))
    if( mod(synd(i),2) .ne. 0 ) ncheck=ncheck+1
  enddo

  if( ncheck .eq. 0 ) then ! we have a codeword - reorder the columns and return it
    niterations=iter
    codeword=cw(colorder+1)
    decoded=codeword(M+1:N)
    return
  endif

! Send messages from bits to check nodes 
  do j=1,M
    do i=1,nrw(j)
      ibj=Nm(i,j)
      toc(i,j)=zn(ibj)  
      do kk=1,ncw ! subtract off what the bit had received from the check
        if( Mn(kk,ibj) .eq. j ) then  
          toc(i,j)=toc(i,j)-tov(kk,ibj)
        endif
      enddo
    enddo
  enddo

! send messages from check nodes to variable nodes
  do i=1,M
    tanhtoc(1:7,i)=tanh(-toc(1:7,i)/2)
  enddo

  do j=1,N
    do i=1,ncw
      ichk=Mn(i,j)  ! Mn(:,j) are the checks that include bit j
      Tmn=product(tanhtoc(1:nrw(ichk),ichk),mask=Nm(1:nrw(ichk),ichk).ne.j)
      call platanh(-Tmn,y)
      tov(i,j)=2*y
    enddo
  enddo

enddo
niterations=-1
return
end subroutine bpdecode40

program jt4code

! Provides examples of message packing, bit and symbol ordering,
! convolutional encoding, and other necessary details of the JT4
! protocol.

  use jt4
  use packjt
  character*22 msg,decoded,bad*1,msgtype*13
  integer i4tone(206)
  include 'testmsg.f90'

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: jt4code "message"'
     print*,'       jt4code -t'
     go to 999
  endif

  call getarg(1,msg)
  nmsg=1
  if(msg(1:2).eq."-t") nmsg=NTEST

  write(*,1010)
1010 format("     Message                 Decoded                Err? Type"/   &
            74("-"))
  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)
     call fmtmsg(msg,iz)                !To upper case, collapse multiple blanks
     ichk=0
     call gen4(msg,ichk,decoded,i4tone,itype)

     msgtype=""
     if(itype.eq.1) msgtype="Std Msg"
     if(itype.eq.2) msgtype="Type 1 prefix"
     if(itype.eq.3) msgtype="Type 1 suffix"
     if(itype.eq.4) msgtype="Type 2 prefix"
     if(itype.eq.5) msgtype="Type 2 suffix"
     if(itype.eq.6) msgtype="Free text"

     bad=" "
     if(decoded.ne.msg) bad="*"
     write(*,1020) imsg,msg,decoded,bad,itype,msgtype
1020 format(i2,'.',2x,a22,2x,a22,3x,a1,i3,": ",a13)
  enddo

  if(nmsg.eq.1) write(*,1030) i4tone
1030 format(/'Channel symbols'/(30i2))

999 end program jt4code

program fer65

! End-to-end simulator for testing JT65.

! Options 
!  jt65sim                             jt65
!----------------------------------------------------------------
!                                      -a aggressive
!  -d Doppler spread                   -d depth
!  -f Number of files                  -f freq
!  -m (sub)mode                        -m (sub)mode
!  -n number of generated sigs         -n ntrials
!  -t Time offset (s)                  -r robust sync
!  -p Do not seed random #s            -c mycall
!                                      -x hiscall
!                                      -g hisgrid
!                                      -X hinted-decode flags
!  -s S/N in 2500 Hz                   -s single-decode mode

  implicit real*8 (a-h,o-z)
  real*8 s(7),sq(7)
  character arg*12,cmnd*100,decoded*22,submode*1,csync*1,f1*15,f2*15
  character*12 outfile
  logical syncok

  nargs=iargc()
  if(nargs.ne.7) then
     print*,'Usage:   fer65 submode fspread snr1 snr2 Navg  DS  iters'
     print*,'Example: fer65    C      3.0   -28  -12    8    1  1000'
     go to 999
  endif

  call getarg(1,submode)
  call getarg(2,arg)
  read(arg,*) d
  call getarg(3,arg)
  read(arg,*) snr1
  call getarg(4,arg)
  read(arg,*) snr2
  call getarg(5,arg)
  read(arg,*) navg
  call getarg(6,arg)
  read(arg,*) nds
  call getarg(7,arg)
  read(arg,*) iters

  write(outfile,1001) submode,d,navg,nds
1001 format(a1,f6.2,'_',i2.2,'_',i1)
  if(outfile(2:2).eq.' ') outfile(2:2)='0'
  if(outfile(3:3).eq.' ') outfile(3:3)='0'

  ndepth=3
  if(navg.gt.1) ndepth=ndepth+16
  if(nds.ne.0) ndepth=ndepth+32

  dfmax=3
  if(submode.eq.'b' .or. submode.eq.'B') dfmax=6
  if(submode.eq.'c' .or. submode.eq.'C') dfmax=11

  ntrials=1000
  naggressive=10

  open(20,file=outfile,status='unknown')
  open(21,file='fer65.21',status='unknown')

  write(20,1000) submode,iters,ntrials,naggressive,d,ndepth,navg,nds
1000 format(/'JT65',a1,'  Iters:',i5,'  T:',i6,'  Aggr:',i3,  &
          '  Dop:',f6.2,'  Depth:',i2,'  Navg:',i3,'  DS:',i2)
  write(20,1002) 
1002 format(/'  dB  nsync ngood nbad     sync       dsnr        ',     &
            'DT       Freq      Nsum     Width'/85('-'))
  flush(20)

  do isnr=0,20
     snr=snr1+isnr
     if(snr.gt.snr2) exit
     nsync=0
     ngood=0
     nbad=0
     s=0.
     sq=0.
     do iter=1,iters
        write(cmnd,1010) submode,d,snr,navg
1010    format('./jt65sim -n 1 -m ',a1,' -d',f7.2,' -s \\',f5.1,' -f',i3,' >devnull')
        call unlink('000000_????.wav')
        call system(cmnd)
        if(navg.gt.1) then
           do i=navg,2,-1
              j=2*i-1
              write(f1,1011) i
              write(f2,1011) j
1011          format('000000_',i4.4,'.wav')
              call rename(f1,f2)
           enddo
        endif
        call unlink('decoded.txt')
        call unlink('fort.13')
        isync=0
        nsnr=0
        dt=0.
        nfreq=0
        ndrift=0
        nwidth=0
        cmnd='./jt65 -m A -a 10 -c K1ABC -f 1500 -n 1000 -d  5 -s 000000_????.wav > decoded.txt'
        cmnd(11:11)=submode
        write(cmnd(47:48),'(i2)') ndepth
        call system(cmnd)
        open(13,file='fort.13',status='old',err=20)
        do i=1,navg
           read(13,1012) nutc,isync,nsnr,dt,nfreq,ndrift,nwidth,decoded,     &
             nft,nsum,nsmo
1012       format(i4,i4,i5,f6.2,i5,i4,i3,1x,a22,5x,3i3)
           if(nft.gt.0) exit
        enddo
        close(13)
        syncok=abs(dt).lt.0.2 .and. float(abs(nfreq-1500)).lt.dfmax
        csync=' '
        if(syncok) csync='*'
        write(21,1014) nutc,isync,nsnr,dt,nfreq,ndrift,nwidth,     &
             nft,nsum,nsmo,csync,decoded(1:16),nft,nsum,nsmo
1014    format(i4,i4,i5,f6.2,i5,i4,3x,4i3,1x,a1,1x,a16,i2,2i3)
        flush(21)

        if(syncok) then
           nsync=nsync+1
           s(1)=s(1) + isync
           sq(1)=sq(1) + isync*isync
           s(6)=s(6) + nwidth
           sq(6)=sq(6) + nwidth*nwidth
           if(decoded.eq.'K1ABC W9XYZ EN37      ') then
              ngood=ngood+1
              s(2)=s(2) + nsnr
              s(3)=s(3) + dt
              s(4)=s(4) + nfreq
              s(5)=s(5) + ndrift
              s(7)=s(7) + nsum

              sq(2)=sq(2) + nsnr*nsnr
              sq(3)=sq(3) + dt*dt
              sq(4)=sq(4) + nfreq*nfreq
              sq(5)=sq(5) + ndrift*ndrift
              sq(7)=sq(7) + nsum*nsum
           else if(decoded.ne.'                      ') then
              nbad=nbad+1
              print*,'Nbad:',nbad,decoded
           endif
        endif
20      continue
        fsync=float(nsync)/iter
        fgood=float(ngood)/iter
        fbad=float(nbad)/iter
        write(*,1020) nint(snr),iter,isync,nsnr,dt,nfreq,ndrift,nwidth,fsync,  &
             fgood,fbad,decoded(1:16),nft,nsum,nsmo
1020    format(i3,i5,i3,i4,f6.2,i5,i3,i3,2f6.3,f7.4,1x,a16,i2,2i3)
     enddo

     if(nsync.ge.1) then
        xsync=s(1)/nsync
        xwidth=s(6)/nsync
     endif
     esync=0.
     if(nsync.ge.2) then
        esync=sqrt(sq(1)/nsync - xsync**2)
        ewidth=sqrt(sq(6)/nsync - xwidth**2)
     endif

     if(ngood.ge.1) then
        xsnr=s(2)/ngood
        xdt=s(3)/ngood
        xfreq=s(4)/ngood
        xdrift=s(5)/ngood
        xsum=s(7)/ngood
     endif
     if(ngood.ge.2) then
        esnr=sqrt(sq(2)/ngood - xsnr**2)
        edt=sqrt(sq(3)/ngood - xdt**2)
        efreq=sqrt(sq(4)/ngood - xfreq**2)
        edrift=sqrt(sq(5)/ngood - xdrift**2)
        esum=sqrt(sq(7)/ngood - xsum**2)
     endif

     dsnr=xsnr-snr
     dfreq=xfreq-1500.0
     if(ngood.eq.0) then
        dsnr=0.
        dfreq=0.
     endif
     write(20,1100) snr,nsync,ngood,nbad,xsync,esync,dsnr,esnr,  &
          xdt,edt,dfreq,efreq,xsum,esum,xwidth,ewidth
1100 format(f5.1,2i6,i4,2f6.1,f6.1,f5.1,f6.2,f5.2,6f5.1)
     flush(20)
     if(ngood.ge.int(0.99*iters)) exit
  enddo

999 end program fer65

program jt49sim

! Generate simulated data for testing JT4 and JT9
! April 26, 2020: changed to Watterson channel simulator (K9AN)
!
  use wavhdr
  use packjt
  use jt4
  parameter (NMAX=60*12000)              ! = 648,000
  parameter (NFFT=10*65536,NH=NFFT/2)
  type(hdr) h                            !Header for .wav file
  integer*2 iwave(NMAX)                  !Generated waveform
  integer*4 itone(206)                   !Channel symbols (values 0-8)
  real*4 xnoise(NMAX)                    !Generated random noise
  real*4 dat(NMAX)                       !Generated real data
  complex cdat(NMAX)                     !Generated complex waveform
  complex c0(NMAX)                   !Waveform multipled by fading realization
  complex z
  real*8 f0,dt,twopi,phi,dphi,baud,fsample,freq,dnsps
  character message*22,fname*11,csubmode*2,arg*12
  character msgsent*22
  
  nargs=iargc()
  if(nargs.ne. 8) then
     print *, 'Usage:   jt49sim        "msg"     nA-nE Nsigs fDop delay DT Nfiles SNR'
     print *, 'Example: jt49sim "K1ABC W9XYZ EN37" 4G   10   0.2   1.0 0.0   1     0'
     print *, 'Example: jt49sim "K1ABC W9XYZ EN37" 9A    1   0.0   0.0 0.0   1    -20'
     print *, 'Use msg=@nnnn to generate a tone at nnnn Hz:'
     print *, 'Example: jt49sim "@1500"            9A    1  10.0   0.0 0.0   1    -20'
     print *, 'If Nsigs > 100, generate one signal with f0=Nsigs'
     print *, 'Example: jt49sim "K1ABC W9XYZ EN37" 4F  1800  0.2   0.0 0.0   1    -20'
     go to 999
  endif
  call getarg(1,message)
  call fmtmsg(message, iz)
  call getarg(2,csubmode)
  imode=ichar(csubmode(1:1)) - ichar('0')
  nsubmode=ichar(csubmode(2:2)) - ichar('A')
  if(imode.ne.4 .and. imode.ne.9) go to 999
  if(nsubmode.lt.0 .or. nsubmode.gt.7) go to 999
  call getarg(3,arg)
  read(arg,*) nsigs
  call getarg(4,arg)
  read(arg,*) fspread
  call getarg(5,arg)
  read(arg,*) delay 
  call getarg(6,arg)
  read(arg,*) xdt
  call getarg(7,arg)
  read(arg,*) nfiles
  call getarg(8,arg)
  read(arg,*) snrdb

  rms=100.
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  h=default_header(12000,NMAX)
  dfsig=2000.0/nsigs                 !Freq spacing between sigs in file (Hz)
  ichk=0
  nsym=0
  dnsps=0.
  baud=0.
  sig=0.

  if(imode.eq.4) then
     nsym=206                           !Number of channel symbols (JT4)
     dnsps=12000.d0/4.375d0
     baud=12000.d0/dnsps                !Keying rate = 1.7361111111
  else if(imode.eq.9) then
     nsym=85                            !Number of channel symbols (JT9)
     dnsps=6912.d0                      !Samples per symbol
     baud=12000.d0/dnsps                !Keying rate = 1.736...
  endif
  NZ=nsym*dnsps
 
  write(*,1000) 
1000 format('File  Sig    Freq  Mode   S/N   DT   fDop   delay    Message'/60('-'))

  do ifile=1,nfiles                  !Loop over requested number of files
     write(fname,1002) ifile         !Output filename
1002 format('000000_',i4.4)
     open(10,file=fname//'.wav',access='stream',status='unknown')
     xnoise=0.
     cdat=0.
     if(snrdb.lt.90) then
        do i=1,NMAX
           xnoise(i)=gran()          !Generate gaussian noise
        enddo
     endif

     do isig=1,nsigs                 !Generate requested number of sigs
        if(mod(nsigs,2).eq.0) f0=1500.0 + dfsig*(isig-0.5-nsigs/2)
        if(mod(nsigs,2).eq.1) f0=1500.0 + dfsig*(isig-(nsigs+1)/2)
        if(nsigs.eq.1) f0=1500.0
        if(nsigs.gt.100) f0=nsigs
        xsnr=snrdb
        if(snrdb.eq.0.0) xsnr=-20 - isig

        if(imode.eq.4) call gen4(message,ichk,msgsent,itone,itype)
        if(imode.eq.9) call gen9(message,ichk,msgsent,itone,itype)

        bandwidth_ratio=2500.0/6000.0
        sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*xsnr)
        if(xsnr.gt.90.0) sig=1.0
        write(*,1020) ifile,isig,f0,csubmode,xsnr,xdt,fspread,delay,message
1020    format(i4,i4,f10.3,2x,a2,2x,f5.1,f6.2,f6.1,1x,f6.1,2x,a22)

        phi=0.d0
        dphi=0.d0
        k=(xdt+1.0)*12000                   !Start audio at t = xdt + 1.0 s
        isym0=-99        
        do i=1,NMAX                         !Add this signal into cdat()
           isym=i/dnsps + 1
           if(isym.gt.nsym) exit
           if(isym.ne.isym0) then
              if(message(1:1).eq.'@') then
                 read(message(2:),*) freq
              else 
                 if(imode.eq.4) freq=f0 + itone(isym)*baud*nch(1+nsubmode) !JT4
                 if(imode.eq.9) freq=f0 + itone(isym)*baud*(2**nsubmode)   !JT9
              endif
              dphi=twopi*freq*dt
              isym0=isym
           endif
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=cmplx(cos(xphi),sin(xphi))
           k=k+1
           if(k.ge.1) cdat(k)=cdat(k) + z
        enddo
        if(nsigs.gt.100) exit
     enddo

     c0=cdat 
     if(fspread.ne.0 .or. delay.ne.0) then                  !Apply specified Doppler spread
        fs=12000.0
        call watterson(c0,NMAX,NZ,fs,delay,fspread) 
     endif

     dat=sig*aimag(c0) + xnoise                 !Add the generated noise
     fac=32767.0/nsigs
     if(snrdb.ge.90.0) iwave(1:NMAX)=nint(fac*dat(1:NMAX))
     if(snrdb.lt.90.0) iwave(1:NMAX)=nint(rms*dat(1:NMAX))
     write(10) h,iwave(1:NMAX)                !Save the .wav file
     close(10)
  enddo

999 end program jt49sim

program bodide
! Compute probability of word error for a bounded distance decoder.
! Hardwired for non-coherent 64-FSK and the JT65 RS (63,12) code on GF(64).
!
! Let ps be symbol error probability. 
! The probability of getting an error pattern with e symbol errors is:
! ps^e * (1-ps)*(n-e)
! The number of error patterns with e errors is binomial(63,e)
! Overall probability of getting a word with e errors is:
! P(e)= binomial(63,e)* ps^e * (1-ps)*(n-e)
! Probability that word is correct is P(0 to 25 errors) = sum{e=0}^{25} P(e)
! Probability that word is wrong is 1-P(0 to 25 errors) 
! P_word_error=1-( sum_{e=0}^{t} P(e) )
!
  implicit real*16 (a-h,o-z)

  integer*8 binomial
  integer x,s,XX,NN,M
  character arg*8

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Probability of word error for noncoherent 64-FSK with bounded distance decoding'
     print*,'Usage:    bounded_distance   D'
     print*,'Example:  bounded_distance  25'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nt 
  M=64
  write(*,1012) 
1012 format('Es/No  P(word error)'/  &
             '----------------------')
  do isnr=0,40
    esno=10**(isnr/2.0/10.0)
    hsum=0.d0
    do k=1,M-1
      h=binomial(M-1,k)
      h=h*((-1)**(k+1))/(k+1)
      h=h*exp(-esno*k/(k+1))
      hsum=hsum + h
    enddo
    ps=hsum
    hsum=0.d0
    do i=0,nt
      h=binomial(63,i)
      h=h*ps**i
      h=h*(1-ps)**(63-i)
      hsum=hsum+h
    enddo
    pw=1-hsum
    write(*,'(f4.1,4x,e10.4,4x,e10.4)') isnr/2.0, ps, pw
  enddo
999 end program bodide 

module jt9_decode

  type :: jt9_decoder
     procedure(jt9_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type jt9_decoder

  abstract interface
     subroutine jt9_decode_callback (this, sync, snr, dt, freq, drift, &
          decoded)
       import jt9_decoder
       implicit none
       class(jt9_decoder), intent(inout) :: this
       real, intent(in) :: sync
       integer, intent(in) :: snr
       real, intent(in) :: dt
       real, intent(in) :: freq
       integer, intent(in) :: drift
       character(len=22), intent(in) :: decoded
     end subroutine jt9_decode_callback
  end interface

contains

  subroutine decode(this,callback,ss,id2,nfqso,newdat,npts8,nfa,    &
       nfsplit,nfb,ntol,nzhsym,nagain,ndepth,nmode,nsubmode,nexp_decode)
    use timer_module, only: timer

    include 'constants.f90'
    class(jt9_decoder), intent(inout) :: this
    procedure(jt9_decode_callback) :: callback
    real ss(184,NSMAX)
    logical, intent(in) :: newdat, nagain
    character*22 msg
    real*4 ccfred(NSMAX)
    real*4 red2(NSMAX)
    logical ccfok(NSMAX)
    logical done(NSMAX)
    integer*2 id2(NTMAX*12000)
    integer*1 i1SoftSymbols(207)
    common/decstats/ntry65a,ntry65b,n65a,n65b,num9,numfano
    save ccfred,red2

    if(nexp_decode.eq.-99) stop     !Silence compiler warning
    this%callback => callback
    if(nmode.eq.9 .and. nsubmode.ge.1) then
       call decode9w(nfqso,ntol,nsubmode,ss,id2,sync,nsnr,xdt,freq,msg)
       if (associated(this%callback)) then
          ndrift=0
          call this%callback(sync,nsnr,xdt,freq,ndrift,msg)
       end if
       go to 999
    endif

    nsynced=0
    ndecoded=0
    nsps=6912                                   !Params for JT9-1
    df3=1500.0/2048.0

    tstep=0.5*nsps/12000.0                      !Half-symbol step (seconds)
    done=.false.

    nf0=0
    nf1=nfa
    if(nmode.eq.65+9) nf1=nfsplit
    ia=max(1,nint((nf1-nf0)/df3))
    ib=min(NSMAX,nint((nfb-nf0)/df3))
    lag1=-int(2.5/tstep + 0.9999)
    lag2=int(5.0/tstep + 0.9999)
    if(newdat) then
       call timer('sync9   ',0)
       call sync9(ss,nzhsym,lag1,lag2,ia,ib,ccfred,red2,ipk)
       call timer('sync9   ',1)
    endif

    nsps8=nsps/8
    df8=1500.0/nsps8
    dblim=db(864.0/nsps8) - 26.2

    ia1=1                         !quel compiler gripe
    ib1=1                         !quel compiler gripe
    do nqd=1,0,-1
       limit=5000
       ccflim=3.0
       red2lim=1.6
       schklim=2.2
       if(iand(ndepth,7).eq.2) then
          limit=10000
          ccflim=2.7
       endif
       if(iand(ndepth,7).eq.3 .or. nqd.eq.1) then
          limit=30000
          ccflim=2.5
          schklim=2.0
       endif
       if(nagain) then
          limit=100000
          ccflim=2.4
          schklim=1.8
       endif
       ccfok=.false.

       if(nqd.eq.1) then
          nfa1=nfqso-ntol
          nfb1=nfqso+ntol
          ia=max(1,nint((nfa1-nf0)/df3))
          ib=min(NSMAX,nint((nfb1-nf0)/df3))
          ccfok(ia:ib)=(ccfred(ia:ib).gt.(ccflim-2.0)) .and.               &
               (red2(ia:ib).gt.(red2lim-1.0))
          ia1=ia
          ib1=ib
       else
          nfa1=nf1
          nfb1=nfb
          ia=max(1,nint((nfa1-nf0)/df3))
          ib=min(NSMAX,nint((nfb1-nf0)/df3))
          do i=ia,ib
             ccfok(i)=ccfred(i).gt.ccflim .and. red2(i).gt.red2lim
          enddo
          ccfok(ia1:ib1)=.false.
       endif

       fgood=0.
       do i=ia,ib
          if(done(i) .or. (.not.ccfok(i))) cycle
          f=(i-1)*df3
          if(nqd.eq.1 .or.                                                   &
               (ccfred(i).ge.ccflim .and. abs(f-fgood).gt.10.0*df8)) then

             call timer('softsym ',0)
             fpk=nf0 + df3*(i-1)
             call softsym(id2,npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
                  freq,drift,a3,schk,i1SoftSymbols)
             call timer('softsym ',1)

             sync=(syncpk+1)/4.0
             if(nqd.eq.1 .and. ((sync.lt.0.5) .or. (schk.lt.1.0))) cycle
             if(nqd.ne.1 .and. ((sync.lt.1.0) .or. (schk.lt.1.5))) cycle

             call timer('jt9fano ',0)
             call jt9fano(i1SoftSymbols,limit,nlim,msg)
             call timer('jt9fano ',1)

             if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
             nsync=int(sync)
             if(nsync.gt.10) nsync=10
             nsnr=nint(snrdb)
             ndrift=nint(drift/df3)
             num9=num9+1

             if(msg.ne.'                      ') then
                numfano=numfano+1
                if (associated(this%callback)) then
                   call this%callback(sync,nsnr,xdt,freq,ndrift,msg)
                end if
                iaa=max(1,i-1)
                ibb=min(NSMAX,i+22)
                fgood=f
                nsynced=1
                ndecoded=1
                ccfok(iaa:ibb)=.false.
                done(iaa:ibb)=.true.
             endif
          endif
       enddo
       if(nagain) exit
    enddo

999 return
  end subroutine decode
end module jt9_decode

program ldpcsim240_101

! End-to-end test of the (240,101)/crc24 encoder and decoders.

   use packjt77

   parameter(N=240, K=101, M=N-K)
   character*8 arg
   character*37 msg0,msg
   character*77 c77
   character*24 c24
   integer*1 msgbits(101)
   integer*1 apmask(240)
   integer*1 cw(240)
   integer*1 codeword(N),message101(101)
   integer ncrc24
   real rxdata(N),llr(N)
   logical first,unpk77_success
   data first/.true./

   nargs=iargc()
   if(nargs.ne.5 .and. nargs.ne.6) then
      print*,'Usage: ldpcsim        niter ndeep  #trials    s    K      [msg]'
      print*,'e.g.   ldpcsim240_101   20     5     1000    0.85  91 "K9AN K1JT FN20"'
      print*,'s    : if negative, then value is ignored and sigma is calculated from SNR.'
      print*,'niter: is the number of BP iterations.'
      print*,'ndeep: -1 is BP only, ndeep>=0 is OSD order'
      print*,'K    :is the number of message+CRC bits and must be in the range [77,101]'
      print*,'WSPR-format message is optional'
      return
   endif
   call getarg(1,arg)
   read(arg,*) max_iterations
   call getarg(2,arg)
   read(arg,*) norder
   call getarg(3,arg)
   read(arg,*) ntrials
   call getarg(4,arg)
   read(arg,*) s
   call getarg(5,arg)
   read(arg,*) Keff
   msg0='K9AN K1JT FN20                       '
   if(nargs.eq.6) call getarg(6,msg0)
   call pack77(msg0,i3,n3,c77)

   rate=real(Keff)/real(N)

   write(*,*) "code rate: ",rate
   write(*,*) "niter    : ",max_iterations
   write(*,*) "norder   : ",norder
   write(*,*) "s        : ",s
   write(*,*) "K        : ",Keff

   msgbits=0
   read(c77,'(77i1)') msgbits(1:77)
   write(*,*) 'message'
   write(*,'(77i1)') msgbits(1:77)

   call get_crc24(msgbits,101,ncrc24)
   write(c24,'(b24.24)') ncrc24
   read(c24,'(24i1)') msgbits(78:101)
write(*,'(24i1)') msgbits(78:101)
   write(*,*) 'message with crc24'
   write(*,'(101i1)') msgbits(1:101)
   call encode240_101(msgbits,codeword)
   call init_random_seed()
   call sgran()

   write(*,*) 'codeword'
   write(*,'(77i1,1x,24i1,1x,73i1)') codeword

   write(*,*) "Eb/N0    Es/N0   ngood  nundetected   sigma   symbol error rate"
   do idb = 8,-3,-1
      db=idb/2.0-1.0
      sigma=1/sqrt( 2*rate*(10**(db/10.0)) )  ! to make db represent Eb/No
!  sigma=1/sqrt( 2*(10**(db/10.0)) )        ! db represents Es/No
      ngood=0
      nue=0
      nberr=0
      do itrial=1, ntrials
! Create a realization of a noisy received word
         do i=1,N
            rxdata(i) = 2.0*codeword(i)-1.0 + sigma*gran()
         enddo
         nerr=0
         do i=1,N
            if( rxdata(i)*(2*codeword(i)-1.0) .lt. 0 ) nerr=nerr+1
         enddo
         nberr=nberr+nerr

         rxav=sum(rxdata)/N
         rx2av=sum(rxdata*rxdata)/N
         rxsig=sqrt(rx2av-rxav*rxav)
         rxdata=rxdata/rxsig
         if( s .lt. 0 ) then
            ss=sigma
         else
            ss=s
         endif

         llr=2.0*rxdata/(ss*ss)
         apmask=0
         dmin=0.0
         maxosd=2
         call decode240_101(llr, Keff, maxosd, norder, apmask, message101, cw, ntype, nharderror, dmin)
         if(nharderror.ge.0) then
            n2err=0
            do i=1,N
               if( cw(i).ne.codeword(i) ) n2err=n2err+1
            enddo
            if(n2err.eq.0) then
               ngood=ngood+1
            else
               nue=nue+1
            endif
         endif
      enddo
!      snr2500=db+10*log10(200.0/116.0/2500.0)
      esn0=db+10*log10(rate)
      pberr=real(nberr)/(real(ntrials*N))
      write(*,"(f4.1,4x,f5.1,1x,i8,1x,i8,8x,f5.2,8x,e10.3)") db,esn0,ngood,nue,ss,pberr

      if(first) then
         write(c77,'(77i1)') message101(1:77)
write(*,'(101i1)') message101
         call unpack77(c77,0,msg,unpk77_success)
         if(unpk77_success) then
            write(*,1100) msg(1:37)
1100        format('Decoded message: ',a37)
         else
            print*,'Error unpacking message'
         endif
         first=.false.
      endif
   enddo

end program ldpcsim240_101

program genmet

! Generate metric table for M-FSK modulation.

  character*12 arg
  real*4 r(0:255)
  integer hist(2,-128:128)
  data hist/514*0/,idum/-1/

  lim(x)=min(127,max(-128,nint(scale*x)))

  nargs=iargc()
  if(nargs.ne.5) then
     print*,'Usage: genmet ncoh nadd m0 snr iters'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) ncoh
  call getarg(2,arg)
  read(arg,*) nadd
  call getarg(3,arg)
  read(arg,*) m0
  call getarg(4,arg)
  read(arg,*) snr
  call getarg(5,arg)
  read(arg,*) iters

  ntones=2**m0
  xm0=m0
  scale=5.0
  fac=sqrt(1.0/nadd)
  s=sqrt(10.0**(0.1*snr))
  hist=0
  nerr=0

  call sgran()

  do iter=1,iters
     do i=0,ntones-1
        r(i)=0.
        do n=1,nadd
           x1=0.707*gran()
           y1=0.707*gran()
           if(i.eq.0) x1=x1+s
           if(ncoh.eq.0) r(i)=r(i) + x1*x1 + y1*y1
           if(ncoh.ne.0) r(i)=r(i) + x1
        enddo
        r(i)=fac*r(i)
     enddo
     do m=0,m0-1
        n=2**m
        r1=0.
        r2=0.
        do i=0,ntones-1
           if(iand(i,n).ne.0) r1=max(r1,r(i))
           if(iand(i,n).eq.0) r2=max(r2,r(i))
        enddo
        don=r2-r1
        doff=r1-r2
        if(don.lt.0.0) nerr=nerr+1
        j1=lim(doff)
        hist(1,j1)=hist(1,j1)+1
        j2=lim(don)
        hist(2,j2)=hist(2,j2)+1
     enddo
  enddo

  do i=-128,127
     write(13,1010) i/scale,hist(1,i)/(xm0*iters),hist(2,i)/(xm0*iters)
1010 format(f8.3,2f12.9)
  enddo

  ber=nerr/(xm0*iters)
  write(*,1020) nadd,m0,snr,ber
1020 format('nadd:',i3,'   m0:',i2,'   snr: 'f5.1,'   BER:',f8.3)
      
  xln2=log(2.0)
  do i=-128,127
     p1=hist(2,i)/(xm0*iters)
     p0=hist(1,i)/(xm0*iters)
     if(p0+p1.eq.0.0 .and. i.lt.0) p0=1.e-6
     if(p0+p1.eq.0.0 .and. i.gt.0) p1=1.e-6
     xlhd0=log(max(0.001,2.0*p0/(p0+p1)))/xln2
     xlhd1=log(max(0.001,2.0*p1/(p0+p1)))/xln2
     write(14,1012) i/scale,xlhd0,xlhd1,p0/(p0+p1),p1/(p0+p1)
1012 format(f7.1,2f8.3,2f9.6)
  enddo
      
999 end program genmet

subroutine get_ft4_bitmetrics(cd,bitmetrics,badsync)

   include 'ft4_params.f90'
   parameter (NSS=NSPS/NDOWN,NDMAX=NMAX/NDOWN)
   complex cd(0:NN*NSS-1)
   complex cs(0:3,NN)
   complex csymb(NSS)
   integer icos4a(0:3),icos4b(0:3),icos4c(0:3),icos4d(0:3)
   integer graymap(0:3)
   integer ip(1)
   logical one(0:255,0:7)    ! 256 4-symbol sequences, 8 bits
   logical first
   logical badsync
   real bitmetrics(2*NN,3)
   real s2(0:255)
   real s4(0:3,NN)

   data icos4a/0,1,3,2/
   data icos4b/1,0,2,3/
   data icos4c/2,3,1,0/
   data icos4d/3,2,0,1/
   data graymap/0,1,3,2/
   data first/.true./
   save first,one

   if(first) then
      one=.false.
      do i=0,255
         do j=0,7
            if(iand(i,2**j).ne.0) one(i,j)=.true.
         enddo
      enddo
      first=.false.
   endif

   do k=1,NN
      i1=(k-1)*NSS
      csymb=cd(i1:i1+NSS-1)
      call four2a(csymb,NSS,1,-1,1)
      cs(0:3,k)=csymb(1:4)
      s4(0:3,k)=abs(csymb(1:4))
   enddo

! Sync quality check
   is1=0
   is2=0
   is3=0
   is4=0
   badsync=.false.
   ibmax=0
   
   do k=1,4
      ip=maxloc(s4(:,k))
      if(icos4a(k-1).eq.(ip(1)-1)) is1=is1+1
      ip=maxloc(s4(:,k+33))
      if(icos4b(k-1).eq.(ip(1)-1)) is2=is2+1
      ip=maxloc(s4(:,k+66))
      if(icos4c(k-1).eq.(ip(1)-1)) is3=is3+1
      ip=maxloc(s4(:,k+99))
      if(icos4d(k-1).eq.(ip(1)-1)) is4=is4+1
   enddo
   nsync=is1+is2+is3+is4   !Number of correct hard sync symbols, 0-16
   if(nsync .lt. 8) then
      badsync=.true.
      return
   endif

   do nseq=1,3             !Try coherent sequences of 1, 2, and 4 symbols
      if(nseq.eq.1) nsym=1
      if(nseq.eq.2) nsym=2
      if(nseq.eq.3) nsym=4
      nt=2**(2*nsym)
      do ks=1,NN-nsym+1,nsym  !87+16=103 symbols.
         amax=-1.0
         do i=0,nt-1
            i1=i/64
            i2=iand(i,63)/16
            i3=iand(i,15)/4
            i4=iand(i,3)
            if(nsym.eq.1) then
               s2(i)=abs(cs(graymap(i4),ks))
            elseif(nsym.eq.2) then
               s2(i)=abs(cs(graymap(i3),ks)+cs(graymap(i4),ks+1))
            elseif(nsym.eq.4) then
               s2(i)=abs(cs(graymap(i1),ks  ) + &
                  cs(graymap(i2),ks+1) + &
                  cs(graymap(i3),ks+2) + &
                  cs(graymap(i4),ks+3)   &
                  )
            else
               print*,"Error - nsym must be 1, 2, or 4."
            endif
         enddo
         ipt=1+(ks-1)*2
         if(nsym.eq.1) ibmax=1
         if(nsym.eq.2) ibmax=3
         if(nsym.eq.4) ibmax=7
         do ib=0,ibmax
            bm=maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)) - &
               maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib))
            if(ipt+ib.gt.2*NN) cycle
            bitmetrics(ipt+ib,nseq)=bm
         enddo
      enddo
   enddo

   bitmetrics(205:206,2)=bitmetrics(205:206,1)
   bitmetrics(201:204,3)=bitmetrics(201:204,2)
   bitmetrics(205:206,3)=bitmetrics(205:206,1)

   call normalizebmet(bitmetrics(:,1),2*NN)
   call normalizebmet(bitmetrics(:,2),2*NN)
   call normalizebmet(bitmetrics(:,3),2*NN)
   return

end subroutine get_ft4_bitmetrics

subroutine tone8(lmycallstd,lhiscallstd)

  use ft8_mod1, only : itone56,idtone56,msg,csynce,mycall,hiscall,idtonecqdxcns,idtonedxcns73,mybcall,hisbcall,lhound, &
                       idtonefox73,idtonespec
  complex csig0(151680)
  character msg37*37,msgsent37*37,mycall14*14,hiscall14*14
  character*4 rpt(56)
  integer itone(79),itone1(79)
  integer*1 msgbits(77)
  logical(1), intent(in) :: lmycallstd,lhiscallstd

  data rpt/'-01 ','-02 ','-03 ','-04 ','-05 ','-06 ','-07 ','-08 ','-09 ','-10 ', &
           '-11 ','-12 ','-13 ','-14 ','-15 ','-16 ','-17 ','-18 ','-19 ','-20 ', &
           '-21 ','-22 ','-23 ','-24 ','-25 ','-26 ','R-01','R-02','R-03','R-04', &
           'R-05','R-06','R-07','R-08','R-09','R-10','R-11','R-12','R-13','R-14', &
           'R-15','R-16','R-17','R-18','R-19','R-20','R-21','R-22','R-23','R-24', &
           'R-25','R-26','AA00','RRR ','RR73','73  '/

! taken from ft8_mod1
!    integer itone56(56,79),idtone56(56,58)
!    character*37 msg(56)

  if(lhound .and. len_trim(mybcall).gt.2 .and. len_trim(hisbcall).gt.2) then
    msg37=''; msg37=trim(mybcall)//' '//trim(hisbcall)//' RR73'
    i3=-1; n3=-1
    call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonefox73(1:29)=itone(8:36)
    idtonefox73(30:58)=itone(44:72)
    msg37=''; msg37=trim(mybcall)//' RR73; '//trim(mybcall)//' <'//trim(hiscall)//'> -12'
    i3=-1; n3=-1
    call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonespec(1:29)=itone(8:36)
    idtonespec(30:58)=itone(44:72)
  endif

  if(.not.lhiscallstd .and. len(trim(hiscall)).gt.2) then
    msg37=''; msg37='CQ '//trim(hiscall)
    i3=-1; n3=-1
    call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonecqdxcns(1:29)=itone(8:36)
    idtonecqdxcns(30:58)=itone(44:72)
    msg37=''; msg37='<AA1AAA> '//trim(hiscall)//' 73'
    i3=-1; n3=-1
    call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonedxcns73(1:29)=itone(8:36)
    idtonedxcns73(30:58)=itone(44:72)
  endif

  if(.not.lhiscallstd .and. .not.lmycallstd) return ! we do not support such message in FT8v2
  if(.not.lhiscallstd .or. .not.lmycallstd) then
    mycall14='              '; mycall14='<'//trim(mycall)//'>'
    hiscall14='              '; hiscall14='<'//trim(hiscall)//'>'
  endif

  if(lhiscallstd .and. lmycallstd) then
    do i=1,56
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
      i3=-1; n3=-1
      call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
      if(i.eq.1) itone1=itone
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
    enddo
    go to 2
  endif

  if(.not.lhiscallstd .and. lmycallstd) then
    do i=1,52
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall14)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
      if(i.eq.1) itone1=itone
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    do i=54,56
      msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)
    msg(53)=msg37
    i3=-1; n3=-1
    call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtone56(53,1:29)=itone(8:36)
    idtone56(53,30:58)=itone(44:72)
    itone56(53,1:79)=itone(1:79)
    go to 2
  endif

  if(lhiscallstd .and. .not.lmycallstd) then
    do i=1,52
      msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
      if(i.eq.1) itone1=itone
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    do i=54,56
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall14)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)
    msg(53)=msg37
    i3=-1; n3=-1
    call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtone56(53,1:29)=itone(8:36)
    idtone56(53,30:58)=itone(44:72)
    itone56(53,1:79)=itone(1:79)
    go to 2
  endif

2 m=13441 ! 7*1920+1
  call gen_ft8wavevar(itone1,79,1920,2.0,12000.0,0.0,csig0,xjunk,1,151680)
  do j=0,18
    do k=1,32; csynce(j,k)=csig0(m); m=m+60; enddo
  enddo
 
  return
end subroutine tone8

program test_ft8q3

! Test q3-style decodes for FT8.

  use packjt77
  parameter(NN=79,NSPS=32)
  parameter(NWAVE=NN*NSPS)               !2528
  parameter(NZ=3200,NLAGS=NZ-NWAVE)
  character arg*12
  character*37 msg
  character*12 call_1,call_2
  character*4 grid4
  complex cd(0:NZ-1)

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.4 .and. nargs.ne.5) then
     print*,'Usage: ft8q3 DT f0 call_1 call_2 [grid4]'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) xdt                        !Time offset from nominal (s)
  call getarg(2,arg)
  read(arg,*) f0                         !Frequency (Hz)
  call getarg(3,call_1)                  !First callsign
  call getarg(4,call_2)                  !Second callsign
  grid4='    '
  if(nargs.eq.5) call getarg(5,grid4)    !Locator for call_2

  do i=0,NZ-1
     read(40,3040) cd(i)
3040 format(17x,2f10.3)
  enddo

  call sec0(0,t)
  call ft8q3(cd,xdt,f0,call_1,call_2,grid4,msg,snr)
  call sec0(1,t)
  write(*,1100) t,snr,trim(msg)
1100 format('Time:',f6.2,'   S/N:',f6.1,'   msg: ',a)

999 end program test_ft8q3

program twq

  character*22 msg0,msg
  integer*1 data0(11)

  open(10,file='wqmsg.txt',status='old')
  write(*,1000)
1000 format(4x,'Encoded message',9x,'Decoded as',12x,'itype'/55('-'))
  
  do line=1,9999
     read(10,*,end=999) msg0
     call wqenc(msg0,itype,data0)
     call wqdec(data0,msg,ntype)
     write(*,1100) line,msg0,msg,ntype
1100 format(i2,'.',1x,a22,2x,a22,i3)
  enddo
  
999 end program twq

subroutine softsym(id2,npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,        &
     freq,drift,a3,schk,i1SoftSymbols)

! Compute the soft symbols

  use timer_module, only: timer

  parameter (NZ2=1512,NZ3=1360)
  logical, intent(inout) :: newdat
  complex c2(0:NZ2-1)
  complex c3(0:NZ3-1)
  complex c5(0:NZ3-1)
  real a(3)
  integer*1 i1SoftSymbolsScrambled(207)
  integer*1 i1SoftSymbols(207)
  include 'jt9sync.f90'

  nspsd=16
  ndown=nsps8/nspsd

! Mix, low-pass filter, and downsample to 16 samples per symbol
  call timer('downsam9',0)
  call downsam9(id2,npts8,nsps8,newdat,nspsd,fpk,c2)
  call timer('downsam9',1)

  call peakdt9(c2,nsps8,nspsd,c3,xdt)  !Find DT

  fsample=1500.0/ndown
  a=0.
  call timer('afc9    ',0)
  call afc9(c3,nz3,fsample,a,syncpk)  !Find deltaF, fDot, extra DT
  call timer('afc9    ',1)
  freq=fpk - a(1)
  drift=-2.0*a(2)
!  write(*,3301) fpk,freq,a
!3301 format(2f9.3,3f10.4)
  a3=a(3)
  a(3)=0.

  call timer('twkfreq ',0)
  call twkfreq(c3,c5,nz3,fsample,a)   !Correct for delta f, f1, f2 ==> a(1:3)
  call timer('twkfreq ',1)

! Compute soft symbols (in scrambled order)
  call timer('symspec2',0)
  call symspec2(c5,nz3,nsps8,nspsd,fsample,freq,drift,snrdb,schk,      &
       i1SoftSymbolsScrambled)
  call timer('symspec2',1)

! Remove interleaving
  call interleave9(i1SoftSymbolsScrambled,-1,i1SoftSymbols)

  return
end subroutine softsym

module fst280_decode
  type :: fst280_decoder
     procedure(fst280_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type fst280_decoder

  abstract interface
     subroutine fst280_decode_callback (this,nutc,sync,nsnr,dt,freq,    &
          decoded,nap,qual,ntrperiod)
       import fst280_decoder
       implicit none
       class(fst280_decoder), intent(inout) :: this
       integer, intent(in) :: nutc
       real, intent(in) :: sync
       integer, intent(in) :: nsnr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=37), intent(in) :: decoded
       integer, intent(in) :: nap
       real, intent(in) :: qual
       integer, intent(in) :: ntrperiod
     end subroutine fst280_decode_callback
  end interface

contains

 subroutine decode(this,callback,iwave,nutc,nQSOProgress,nfqso,    &
      nfa,nfb,nsubmode,ndeep,ntrperiod,nexp_decode,ntol)

   use timer_module, only: timer
   use packjt77
   include 'fst280/fst280_params.f90'
   parameter (MAXCAND=100)
   class(fst280_decoder), intent(inout) :: this
   procedure(fst280_decode_callback) :: callback
   character*37 decodes(100)
   character*37 msg
   character*77 c77
   complex, allocatable :: c2(:)
   complex, allocatable :: cframe(:)
   complex, allocatable :: c_bigfft(:)          !Complex waveform
   real, allocatable :: r_data(:)
   real llr(280),llra(280),llrb(280),llrc(280),llrd(280)
   real candidates(100,4)
   real bitmetrics(328,4)
   real s4(0:3,NN)
   integer itone(NN)
   integer hmod
   integer*1 apmask(280),cw(280)
   integer*1 hbits(328)
   integer*1 message101(101),message74(74)
   logical badsync,unpk77_success,single_decode
   integer*2 iwave(300*12000)

   this%callback => callback
   hmod=2**nsubmode
   if(nfqso+nqsoprogress.eq.-999) return
   Keff=91
   iwspr=0
   nmax=15*12000
   single_decode=iand(nexp_decode,32).eq.32
   if(ntrperiod.eq.15) then
      nsps=800
      nmax=15*12000
      ndown=20/hmod
      if(hmod.eq.8) ndown=2
   else if(ntrperiod.eq.30) then
      nsps=1680
      nmax=30*12000
      ndown=42/hmod
      if(hmod.eq.4) ndown=10
      if(hmod.eq.8) ndown=5
   else if(ntrperiod.eq.60) then
      nsps=3888
      nmax=60*12000
      ndown=96/hmod
      if(hmod.eq.1) ndown=108
   else if(ntrperiod.eq.120) then
      nsps=8200
      nmax=120*12000
      if(hmod.eq.1) ndown=205
      ndown=100/hmod
   else if(ntrperiod.eq.300) then
      nsps=21168
      nmax=300*12000
      ndown=504/hmod
   end if
   nss=nsps/ndown
   fs=12000.0                       !Sample rate
   fs2=fs/ndown
   nspsec=nint(fs2)
   dt=1.0/fs                        !Sample interval (s)
   dt2=1.0/fs2
   tt=nsps*dt                       !Duration of "itone" symbols (s)
   baud=1.0/tt
   nfft1=2*int(nmax/2)
   nh1=nfft1/2
   allocate( r_data(1:nfft1+2) )
   allocate( c_bigfft(0:nfft1/2) )

   nfft2=nfft1/ndown
   allocate( c2(0:nfft2-1) ) 
   allocate( cframe(0:164*nss-1) )

   npts=nmax
   if(single_decode) then
      fa=max(100,nint(nfqso+1.5*hmod*baud-ntol))
      fb=min(4800,nint(nfqso+1.5*hmod*baud+ntol))
   else
      fa=max(100,nfa)
      fb=min(4800,nfb)
   endif

   if(ndeep.eq.3) then
      ntmax=4      ! number of block sizes to try
      jittermax=2
      norder=3
   elseif(ndeep.eq.2) then
      ntmax=3
      jittermax=2
      norder=3
   elseif(ndeep.eq.1) then
      ntmax=1
      jittermax=2
      norder=2
   endif

   ! The big fft is done once and is used for calculating the smoothed spectrum 
! and also for downconverting/downsampling each candidate.
   r_data(1:nfft1)=iwave(1:nfft1)
   r_data(nfft1+1:nfft1+2)=0.0
   call four2a(r_data,nfft1,1,-1,0)
   c_bigfft=cmplx(r_data(1:nfft1+2:2),r_data(2:nfft1+2:2))

! Get first approximation of candidate frequencies
   call get_candidates_fst280(c_bigfft,nfft1,nsps,hmod,fs,fa,fb,     &
        ncand,candidates,base)

   ndecodes=0
   decodes=' '

   isbest1=0
   isbest8=0
   fc21=0.
   fc28=0.
   do icand=1,ncand
      fc0=candidates(icand,1)
      detmet=candidates(icand,2)

! Downconvert and downsample a slice of the spectrum centered on the
! rough estimate of the candidates frequency.
! Output array c2 is complex baseband sampled at 12000/ndown Sa/sec.
! The size of the downsampled c2 array is nfft2=nfft1/ndown

      call fst280_downsample(c_bigfft,nfft1,ndown,fc0,c2)
      
      call timer('sync280 ',0)
      do isync=0,1
         if(isync.eq.0) then
            fc1=0.0
            is0=1.5*nint(fs2)
            ishw=1.5*is0
            isst=4*hmod
            ifhw=12
            df=.1*baud
         else if(isync.eq.1) then
            fc1=fc21
            if(hmod.eq.1) fc1=fc28
            is0=isbest1
            if(hmod.eq.1) is0=isbest8
            ishw=4*hmod
            isst=1*hmod
            ifhw=7
            df=.02*baud
         endif

         smax1=0.0
         smax8=0.0
         do if=-ifhw,ifhw
            fc=fc1+df*if
            do istart=max(1,is0-ishw),is0+ishw,isst
               call sync_fst280(c2,istart,fc,hmod,1,nfft2,nss,fs2,sync1)
               call sync_fst280(c2,istart,fc,hmod,8,nfft2,nss,fs2,sync8)
               if(sync8.gt.smax8) then
                  fc28=fc
                  isbest8=istart
                  smax8=sync8
               endif
               if(sync1.gt.smax1) then
                  fc21=fc
                  isbest1=istart
                  smax1=sync1
               endif
            enddo
         enddo
      enddo
      call timer('sync280 ',1)

      if(smax8/smax1 .lt. 0.65 ) then
         fc2=fc21
         isbest=isbest1
         if(hmod.gt.1) ntmax=1
         njitter=2
      else
         fc2=fc28
         isbest=isbest8
         if(hmod.gt.1) ntmax=1
         njitter=2
      endif
      fc_synced = fc0 + fc2
      dt_synced = (isbest-fs2)*dt2  !nominal dt is 1 second so frame starts at sample fs2
      candidates(icand,3)=fc_synced
      candidates(icand,4)=isbest
   enddo 
! remove duplicate candidates
   do icand=1,ncand
      fc=candidates(icand,3)
      isbest=nint(candidates(icand,4))
      do ic2=1,ncand
         fc2=candidates(ic2,3)
         isbest2=nint(candidates(ic2,4))
         if(ic2.ne.icand .and. fc2.gt.0.0) then
            if(abs(fc2-fc).lt.0.05*baud) then ! same frequency
               if(abs(isbest2-isbest).le.2) then
                  candidates(ic2,3)=-1
               endif
            endif
         endif
      enddo
   enddo

   ic=0
   do icand=1,ncand
      if(candidates(icand,3).gt.0) then
         ic=ic+1
         candidates(ic,:)=candidates(icand,:)
      endif
   enddo
   ncand=ic
   do icand=1,ncand
      sync=candidates(icand,2)
      fc_synced=candidates(icand,3)
      isbest=nint(candidates(icand,4))   
      xdt=(isbest-nspsec)/fs2

      call fst280_downsample(c_bigfft,nfft1,ndown,fc_synced,c2)

      do ijitter=0,jittermax
         if(ijitter.eq.0) ioffset=0
         if(ijitter.eq.1) ioffset=1
         if(ijitter.eq.2) ioffset=-1
         is0=isbest+ioffset
         if(is0.lt.0) cycle
         cframe=c2(is0:is0+164*nss-1)
         bitmetrics=0
         call get_fst280_bitmetrics(cframe,nss,hmod,ntmax,bitmetrics,s4,badsync)
         if(badsync) cycle

         hbits=0
         where(bitmetrics(:,1).ge.0) hbits=1
         ns1=count(hbits( 71: 78).eq.(/0,0,0,1,1,0,1,1/))
         ns2=count(hbits( 79: 86).eq.(/0,1,0,0,1,1,1,0/))
         ns3=count(hbits(157:164).eq.(/0,0,0,1,1,0,1,1/))
         ns4=count(hbits(165:172).eq.(/0,1,0,0,1,1,1,0/))
         ns5=count(hbits(243:250).eq.(/0,0,0,1,1,0,1,1/))
         ns6=count(hbits(251:258).eq.(/0,1,0,0,1,1,1,0/))
         nsync_qual=ns1+ns2+ns3+ns4+ns5+ns6
         if(nsync_qual.lt. 26) cycle                   !### Value ?? ###

         scalefac=2.83
         llra(  1: 14)=bitmetrics(  1: 14, 1)
         llra( 15: 28)=bitmetrics(315:328, 1)
         llra( 29: 42)=bitmetrics( 15: 28, 1)
         llra( 43: 56)=bitmetrics(301:314, 1)
         llra( 57: 98)=bitmetrics( 29: 70, 1)
         llra( 99:168)=bitmetrics( 87:156, 1)
         llra(169:238)=bitmetrics(173:242, 1)
         llra(239:280)=bitmetrics(259:300, 1)
         llra=scalefac*llra
         llrb(  1: 14)=bitmetrics(  1: 14, 2)
         llrb( 15: 28)=bitmetrics(315:328, 2)
         llrb( 29: 42)=bitmetrics( 15: 28, 2)
         llrb( 43: 56)=bitmetrics(301:314, 2)
         llrb( 57: 98)=bitmetrics( 29: 70, 2)
         llrb( 99:168)=bitmetrics( 87:156, 2)
         llrb(169:238)=bitmetrics(173:242, 2)
         llrb(239:280)=bitmetrics(259:300, 2)
         llrb=scalefac*llrb
         llrc(  1: 14)=bitmetrics(  1: 14, 3)
         llrc( 15: 28)=bitmetrics(315:328, 3)
         llrc( 29: 42)=bitmetrics( 15: 28, 3)
         llrc( 43: 56)=bitmetrics(301:314, 3)
         llrc( 57: 98)=bitmetrics( 29: 70, 3)
         llrc( 99:168)=bitmetrics( 87:156, 3)
         llrc(169:238)=bitmetrics(173:242, 3)
         llrc(239:280)=bitmetrics(259:300, 3)
         llrc=scalefac*llrc
         llrd(  1: 14)=bitmetrics(  1: 14, 4)
         llrd( 15: 28)=bitmetrics(315:328, 4)
         llrd( 29: 42)=bitmetrics( 15: 28, 4)
         llrd( 43: 56)=bitmetrics(301:314, 4)
         llrd( 57: 98)=bitmetrics( 29: 70, 4)
         llrd( 99:168)=bitmetrics( 87:156, 4)
         llrd(169:238)=bitmetrics(173:242, 4)
         llrd(239:280)=bitmetrics(259:300, 4)
         llrd=scalefac*llrd
         apmask=0

         do itry=1,ntmax
            if(itry.eq.1) llr=llra
            if(itry.eq.2) llr=llrb
            if(itry.eq.3) llr=llrc
            if(itry.eq.4) llr=llrd
            dmin=0.0
            nharderrors=-1
            unpk77_success=.false.
            if(iwspr.eq.0) then
               maxosd=2
               call timer('d280_101',0)
               call decode280_101(llr,Keff,maxosd,norder,apmask,message101, &
                    cw,ntype,nharderrors,dmin)
               call timer('d280_101',1)
            else
               maxosd=2
               call timer('d280_74 ',0)
               call decode280_74(llr,Keff,maxosd,norder,apmask,message74,cw, &
                    ntype,nharderrors,dmin)
               call timer('d280_74 ',1)
            endif
            if(nharderrors .ge.0) then
               if(iwspr.eq.0) then
                  write(c77,'(77i1)') message101(1:77)
                  call unpack77(c77,0,msg,unpk77_success)
               else
                  write(c77,'(50i1)') message74(1:50)
                  c77(51:77)='000000000000000000000110000'
                  call unpack77(c77,0,msg,unpk77_success)
               endif
               if(unpk77_success) then
                  idupe=0
                  do i=1,ndecodes
                     if(decodes(i).eq.msg) idupe=1
                  enddo
                  if(idupe.eq.1) exit
                  ndecodes=ndecodes+1
                  decodes(ndecodes)=msg
                  if(iwspr.eq.0) then
                     call get_fst280_tones_from_bits(message101,itone,iwspr)
                     xsig=0
                     do i=1,NN
                        xsig=xsig+s4(itone(i),i)**2
                     enddo
                     arg=400.0*(xsig/base)-1.0
                     if(arg.gt.0.0) then
                        xsnr=10*log10(arg)-21.0-11.7*log10(nsps/800.0)
                     else
                        xsnr=-99.9
                     endif
                  endif
                  nsnr=nint(xsnr)
                  iaptype=0
                  qual=0.
                  fsig=fc_synced - 1.5*hmod*baud
!write(21,'(8i4,f7.1,f7.2,3f7.1,1x,a37)') &
!  nutc,icand,itry,iaptype,ijitter,ntype,nsync_qual,nharderrors,dmin,sync,xsnr,xdt,fsig,msg
                  call this%callback(nutc,smax1,nsnr,xdt,fsig,msg,    &
                       iaptype,qual,ntrperiod)
                  goto 2002
               else
                  cycle
               endif
            endif
         enddo  ! metrics
      enddo  ! istart jitter
2002  continue
   enddo !candidate list!ws

   return
 end subroutine decode

 subroutine sync_fst280(cd0,i0,f0,hmod,ncoh,np,nss,fs,sync)

! Compute sync power for a complex, downsampled FST280 signal.

   include 'fst280/fst280_params.f90'
   complex cd0(0:np-1)
   complex, allocatable, save ::  csync(:)
   complex, allocatable, save ::  csynct(:)
   complex ctwk(8*nss)
   complex z1,z2,z3
   logical first
   integer hmod,isyncword(0:7)
   real f0save
   data isyncword/0,1,3,2,1,0,2,3/
   data first/.true./,f0save/0.0/,nss0/-1/
   save first,twopi,dt,fac,f0save,nss0
   p(z1)=(real(z1*fac)**2 + aimag(z1*fac)**2)**0.5     !Compute power

   if(nss.ne.nss0 .and. allocated(csync)) deallocate(csync,csynct)
   if(first .or. nss.ne.nss0) then
      allocate( csync(8*nss) )
      allocate( csynct(8*nss) )
      twopi=8.0*atan(1.0)
      dt=1/fs
      k=1
      phi=0.0
      do i=0,7
         dphi=twopi*hmod*(isyncword(i)-1.5)/real(nss)
         do j=1,nss
            csync(k)=cmplx(cos(phi),sin(phi))
            phi=mod(phi+dphi,twopi)
            k=k+1
         enddo
      enddo
      first=.false.
      nss0=nss
      fac=1.0/(8.0*nss)
   endif

   if(f0.ne.f0save) then
      dphi=twopi*f0*dt
      phi=0.0
      do i=1,8*nss
         ctwk(i)=cmplx(cos(phi),sin(phi))
         phi=mod(phi+dphi,twopi)
      enddo
      csynct=ctwk*csync
      f0save=f0
   endif

   i1=i0+35*nss                            !Costas arrays
   i2=i0+78*nss
   i3=i0+121*nss

   s1=0.0
   s2=0.0
   s3=0.0
   nsec=8/ncoh
   do i=1,nsec
      is=(i-1)*ncoh*nss
      z1=0
      if(i1+is.ge.1) then
         z1=sum(cd0(i1+is:i1+is+ncoh*nss-1)*conjg(csynct(is+1:is+ncoh*nss)))
      endif
      z2=sum(cd0(i2+is:i2+is+ncoh*nss-1)*conjg(csynct(is+1:is+ncoh*nss)))
      z3=0
      if(i3+is+ncoh*nss-1.le.np) then
         z3=sum(cd0(i3+is:i3+is+ncoh*nss-1)*conjg(csynct(is+1:is+ncoh*nss)))
      endif
      s1=s1+abs(z1)/(8*nss)
      s2=s2+abs(z2)/(8*nss)
      s3=s3+abs(z3)/(8*nss)
   enddo

   sync = s1+s2+s3

   return
 end subroutine sync_fst280

 subroutine fst280_downsample(c_bigfft,nfft1,ndown,f0,c1)

! Output: Complex data in c(), sampled at 12000/ndown Hz

   complex c_bigfft(0:nfft1/2)
   complex c1(0:nfft1/ndown-1)

   df=12000.0/nfft1
   i0=nint(f0/df)
   c1(0)=c_bigfft(i0)
   nfft2=nfft1/ndown
   do i=1,nfft2/2
      if(i0+i.le.nfft1/2) c1(i)=c_bigfft(i0+i)
      if(i0-i.ge.0) c1(nfft2-i)=c_bigfft(i0-i)
   enddo
   c1=c1/nfft2
   call four2a(c1,nfft2,1,1,1)            !c2c FFT back to time domain
   return

 end subroutine fst280_downsample

 subroutine get_candidates_fst280(c_bigfft,nfft1,nsps,hmod,fs,fa,fb,   &
      ncand,candidates,base)

   complex c_bigfft(0:nfft1/2)
   integer hmod
   integer indx(100)
   real candidates(100,4)
   real candidates0(100,4)
   real snr_cand(100)
   real s(18000)
   real s2(18000)
   data nfft1z/-1/
   save nfft1z

   nh1=nfft1/2
   df1=fs/nfft1
   baud=fs/nsps
   df2=baud/2.0
   nd=df2/df1
   ndh=nd/2
   ia=nint(max(100.0,fa)/df2)
   ib=nint(min(4800.0,fb)/df2)
   signal_bw=4*(12000.0/nsps)*hmod
   analysis_bw=min(4800.0,fb)-max(100.0,fa)
   noise_bw=10.0*signal_bw
   if(analysis_bw.gt.noise_bw) then
      ina=ia
      inb=ib
   else
      fcenter=(fa+fb)/2.0
      fl = max(100.0,fcenter-noise_bw/2.)/df2
      fh = min(4800.0,fcenter+noise_bw/2.)/df2
      ina=nint(fl)
      inb=nint(fh)
   endif
   s=0.
   do i=ina,inb   ! noise analysis window includes signal analysis window
      j0=nint(i*df2/df1)
      do j=j0-ndh,j0+ndh
         s(i)=s(i) + real(c_bigfft(j))**2 + aimag(c_bigfft(j))**2
      enddo
   enddo
   ina=max(ina,1+3*hmod) 
   inb=min(inb,18000-3*hmod)
   s2=0.
   do i=ina,inb
      s2(i)=s(i-hmod*3) + s(i-hmod) +s(i+hmod) +s(i+hmod*3)
   enddo
   call pctile(s2(ina+hmod*3:inb-hmod*3),inb-ina+1-hmod*6,30,base)
   s2=s2/base
   thresh=1.25

   ncand=0
   candidates=0
   if(ia.lt.3) ia=3
   if(ib.gt.18000-2) ib=18000-2
   do i=ia,ib
      if((s2(i).gt.s2(i-2)).and. &
           (s2(i).gt.s2(i+2)).and. &
           (s2(i).gt.thresh).and.ncand.lt.100) then
         ncand=ncand+1
         candidates(ncand,1)=df2*i
         candidates(ncand,2)=s2(i)
      endif
   enddo

   snr_cand=0.
   snr_cand(1:ncand)=candidates(1:ncand,2)
   call indexx(snr_cand,ncand,indx)
   nmax=min(ncand,20)
   do i=1,nmax
      j=indx(ncand+1-i)
      candidates0(i,1:4)=candidates(j,1:4)
   enddo
   ncand=nmax
   candidates(1:ncand,1:4)=candidates0(1:ncand,1:4)
   candidates(ncand+1:,1:4)=0.
   return 
 end subroutine get_candidates_fst280

end module fst280_decode

module gran_interface
  use iso_c_binding
  implicit none

  interface
    function gran() bind(C, name='gran_')
      import :: c_float
      real(c_float) :: gran
    end function gran

    function rran() bind(C, name='rran_')
      import :: c_float
      real(c_float) :: rran
    end function rran
  end interface

end module gran_interface

logical function baddata(id2,nz)

  integer*2 id2(nz)

  nadd=1200
  j=0
  smin=1.e30
  smax=-smin
  iz=49*12000/nadd
  do i=1,iz
     sq=0.
     do n=1,nadd
        j=j+1
        x=id2(j)
        sq=sq + x*x
     enddo
     rms=sqrt(sq/nadd)
     if(i.gt.6) then
        smin=min(smin,rms)
        smax=max(smax,rms)
     endif
  enddo

  sratio=smax/(smin+1.e-30)
  baddata=.false.
  if(sratio.gt.1.e30) baddata=.true.

  return
end function baddata

subroutine noisegen(d4,nmax)

  real*4 d4(4,nmax)

  call init_random_seed()       ! seed Fortran RANDOM_NUMBER generator
  call sgran()                  ! see C rand generator (used in gran)

  do i=1,nmax
     d4(1,i)=gran()
     d4(2,i)=gran()
     d4(3,i)=gran()
     d4(4,i)=gran()
  enddo

  return
end subroutine noisegen

subroutine subtractft8var(itone,f0,dt)

! Subtract an ft8 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  use ft8_mod1, only : dd8,cw,NFILT1,NFILT2,endcorr
! NMAX=15*12000,NFFT=15*12000,NFRAME=1920*79
  parameter (NFFT=180000,NMAX=180000,NFRAME=151680)
  complex cref(nframe),cfilt(nmax)
  integer itone(79)
  save cfilt
  !$omp threadprivate(cfilt)

  nstart=dt*12000+1
  call gen_ft8wavevar(itone,79,1920,2.0,12000.0,f0,cref,xjunk,1,NFRAME)
  do i=1,nframe
    id=nstart-1+i 
    if(id.ge.1.and.id.le.NMAX) then
      cfilt(i)=dd8(id)*conjg(cref(i))
    else
      cfilt(i)=0.0
    endif
  enddo
  cfilt(nframe+1:)=0.0
  call four2avar(cfilt,nfft,1,-1,1)
  cfilt(1:nfft)=cfilt(1:nfft)*cw(1:nfft)
  call four2avar(cfilt,nfft,1,1,1)
  cfilt(1:NFILT1/2+1)=cfilt(1:NFILT1/2+1)*endcorr
  cfilt(nframe:nframe-NFILT1/2:-1)=cfilt(nframe:nframe-NFILT1/2:-1)*endcorr
  do i=1,nframe
     j=nstart+i-1
     if(j.ge.1 .and. j.le.NMAX) dd8(j)=dd8(j)-2*REAL(cfilt(i)*cref(i))
  enddo
!!!$omp flush(dd8) ! makes no difference in number of decoded messages

  return
end subroutine subtractft8var

subroutine ft2_gfsk_iwave(msg37,f0,snrdb,iwave)

! Generate waveform for experimental "FT2" mode 

  use packjt77
  include 'ft2_params.f90'               !Set various constants
  parameter (NWAVE=(NN+2)*NSPS)
  character msg37*37,msgsent37*37
  real wave(NWAVE),xnoise(NWAVE)
  real dphi(NWAVE)
  real pulse(480)

  integer itone(NN)
  integer*2 iwave(NWAVE)                 !Generated full-length waveform
  logical first
  data first/.true./
  save pulse
 
  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  hmod=0.8                               !Modulation index (MSK=0.5, FSK=1.0)
  tt=NSPS*dt                             !Duration of symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  bw=1.5*baud                            !Occupied bandwidth (Hz)
  txt=NZ*dt                              !Transmission length (s)
  bandwidth_ratio=2500.0/(fs/2.0)
!  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
!  if(snrdb.gt.90.0) sig=1.0
  txt=NN*NSPS/12000.0

  if(first) then
! The filtered frequency pulse
     do i=1,480
        tt=(i-240.5)/160.0
        pulse(i)=gfsk_pulse(1.0,tt)
     enddo
     dphi_peak=twopi*(hmod/2.0)/real(NSPS)
     first=.false.
  endif

! Source-encode, then get itone():
  itype=1
  call genft2(msg37,0,msgsent37,itone,itype)

! Create the instantaneous frequency waveform
  dphi=0.0
  do j=1,NN
     ib=(j-1)*160+1
     ie=ib+480-1
     dphi(ib:ie)=dphi(ib:ie)+dphi_peak*pulse*(2*itone(j)-1)
  enddo

  phi=0.0
  wave=0.0
  sqrt2=sqrt(2.)
  dphi=dphi+twopi*f0*dt
  do j=1,NWAVE
     wave(j)=sqrt2*sin(phi)
     sqsig=sqsig + wave(j)**2
     phi=mod(phi+dphi(j),twopi)
  enddo
  wave(1:160)=wave(1:160)*(1.0-cos(twopi*(/(i,i=0,159)/)/320.0) )/2.0
  wave(145*160+1:146*160)=wave(145*160+1:146*160)*(1.0+cos(twopi*(/(i,i=0,159)/)/320.0 ))/2.0
  wave(146*160+1:)=0.

  if(snrdb.gt.90.0) then
     iwave=nint((32767.0/sqrt(2.0))*wave)
     return
  endif
  
  sqnoise=1.e-30
  if(snrdb.lt.90) then
     do i=1,NWAVE                   !Add gaussian noise at specified SNR
        xnoise(i)=gran()            !Noise has rms = 1.0
     enddo
  endif
  xnoise=xnoise*sqrt(0.5*fs/2500.0)
  fac=30.0
  snr_amplitude=10.0**(0.05*snrdb)
  wave=fac*(snr_amplitude*wave + xnoise)
  datpk=maxval(abs(wave))
  print*,'A',snr_amplitude,datpk

  iwave=nint((30000.0/datpk)*wave)
  
  return
end subroutine ft2_gfsk_iwave

module astro_mod
  use iso_fortran_env, only: real64, real32, int16
  implicit none

  ! Sky temperature lookup table (was integer*2 nt144 + DATA + SAVE)
  integer(int16), parameter :: nt144(180) = [ &
     234_int16, 246_int16, 257_int16, 267_int16, 275_int16, 280_int16, 283_int16, 286_int16, 291_int16, 298_int16, &
     305_int16, 313_int16, 322_int16, 331_int16, 341_int16, 351_int16, 361_int16, 369_int16, 376_int16, 381_int16, &
     383_int16, 382_int16, 379_int16, 374_int16, 370_int16, 366_int16, 363_int16, 361_int16, 363_int16, 368_int16, &
     376_int16, 388_int16, 401_int16, 415_int16, 428_int16, 440_int16, 453_int16, 467_int16, 487_int16, 512_int16, &
     544_int16, 579_int16, 607_int16, 618_int16, 609_int16, 588_int16, 563_int16, 539_int16, 512_int16, 482_int16, &
     450_int16, 422_int16, 398_int16, 379_int16, 363_int16, 349_int16, 334_int16, 319_int16, 302_int16, 282_int16, &
     262_int16, 242_int16, 226_int16, 213_int16, 205_int16, 200_int16, 198_int16, 197_int16, 196_int16, 197_int16, &
     200_int16, 202_int16, 204_int16, 205_int16, 204_int16, 203_int16, 202_int16, 201_int16, 203_int16, 206_int16, &
     212_int16, 218_int16, 223_int16, 227_int16, 231_int16, 236_int16, 240_int16, 243_int16, 247_int16, 257_int16, &
     276_int16, 301_int16, 324_int16, 339_int16, 346_int16, 344_int16, 339_int16, 331_int16, 323_int16, 316_int16, &
     312_int16, 310_int16, 312_int16, 317_int16, 327_int16, 341_int16, 358_int16, 375_int16, 392_int16, 407_int16, &
     422_int16, 437_int16, 451_int16, 466_int16, 480_int16, 494_int16, 511_int16, 530_int16, 552_int16, 579_int16, &
     612_int16, 653_int16, 702_int16, 768_int16, 863_int16,1008_int16,1232_int16,1557_int16,1966_int16,2385_int16, &
    2719_int16,2924_int16,3018_int16,3038_int16,2986_int16,2836_int16,2570_int16,2213_int16,1823_int16,1461_int16, &
    1163_int16, 939_int16, 783_int16, 677_int16, 602_int16, 543_int16, 494_int16, 452_int16, 419_int16, 392_int16, &
     373_int16, 360_int16, 353_int16, 350_int16, 350_int16, 350_int16, 350_int16, 350_int16, 350_int16, 348_int16, &
     344_int16, 337_int16, 329_int16, 319_int16, 307_int16, 295_int16, 284_int16, 276_int16, 272_int16, 272_int16, &
     273_int16, 274_int16, 274_int16, 271_int16, 266_int16, 260_int16, 252_int16, 245_int16, 238_int16, 231_int16 ]

  real(real32), parameter :: RAD2DEG = 57.2957795130823
  real(real32), parameter :: C_KM_S  = 2.99792458e5

contains

  subroutine astro(nyear,month,nday,uth,nfreq,Mygrid,NStation,MoonDX,     &
       AzSun,ElSun,AzMoon0,ElMoon0,ntsky,doppler00,doppler,dbMoon,RAMoon, &
       DecMoon,HA,Dgrd,sd,poloffset,xnr,day,lon,lat,LST)

    use coord_mod
    use sun_mod
    use moondop_mod
    use grid2deg_mod, only: grid2deg
    implicit none

    ! Dummy arguments
    integer,      intent(in)    :: nyear, month, nday, nfreq, NStation
    real,         intent(in)    :: uth
    real,         intent(in)    :: MoonDX
    character(len=6), intent(in):: MyGrid
    integer,      intent(out)   :: ntsky
    real, intent(out) :: AzSun, ElSun, AzMoon0, ElMoon0
    real, intent(out) :: doppler00, doppler, dbMoon
    real, intent(out) :: RAMoon, DecMoon, HA, Dgrd, sd
    real, intent(out) :: poloffset, xnr
    real, intent(out) :: day
    real, intent(out) :: lon, lat, LST

    ! Locals
    character(len=6) :: HisGrid = 'UNK   '
    real(real64)     :: freq
    real     :: RASun, DecSun
    real     :: AzMoon, ElMoon, vr, dist
    real(real64) :: xx, yy, poloffset1 = 0.0_real64, poloffset2 = 0.0_real64
    real(real64)     :: techo
    real(real32) :: el, eb
    integer          :: longecl_half, t144
    real(real64)     :: tsky, x1, tr, tskymin, tsysmin, tsys
    real     :: elon
    real(real64)     :: xdop(2)
    integer          :: mjd

    ! Initialize intent(out) variables
    ntsky = 0
    AzSun = 0.0
    ElSun = 0.0
    AzMoon0 = 0.0
    ElMoon0 = 0.0
    doppler00 = 0.0
    doppler = 0.0
    dbMoon = 0.0
    RAMoon = 0.0
    DecMoon = 0.0
    HA = 0.0
    Dgrd = 0.0
    sd = 0.0
    poloffset = 0.0
    xnr = 0.0
    day = 0.0
    lon = 0.0
    lat = 0.0
    LST = 0.0

    ! Convert grid to lon/lat
    call grid2deg(MyGrid, elon, lat)
    lon = -elon

    call sun(nyear,month,nday,uth,lon,lat,RASun,DecSun,LST,AzSun,ElSun,mjd,day)

    freq = real(nfreq,real64)*1.0e6_real64
    if (nfreq == 2) freq = 1.8e6_real64
    if (nfreq == 4) freq = 3.5e6_real64

    call MoonDop(nyear,month,nday,uth,lon,lat,RAMoon,DecMoon,LST,HA,   &
         AzMoon,ElMoon,vr,dist)

    ! Spatial polarization offset
    xx = sin(lat/RAD2DEG)*cos(ElMoon/RAD2DEG) - &
         cos(lat/RAD2DEG)*cos(AzMoon/RAD2DEG)*sin(ElMoon/RAD2DEG)
    yy = cos(lat/RAD2DEG)*sin(AzMoon/RAD2DEG)
    if (NStation == 1) poloffset1 = RAD2DEG*atan2(yy,xx)
    if (NStation == 2) poloffset2 = RAD2DEG*atan2(yy,xx)

    techo   = 2.0_real64 * dist / C_KM_S
    doppler = -freq*vr / C_KM_S

    call coord(0.,0.,-1.570796,1.161639, &
               RAMoon/RAD2DEG,DecMoon/RAD2DEG,el,eb)

    longecl_half = nint(RAD2DEG*el/2.0_real64)
    if (longecl_half < 1 .or. longecl_half > 180) longecl_half = 180
    t144 = nt144(longecl_half)
    tsky = (real(t144,real64)-2.7_real64)*(144.0_real64/freq*1.0e-6_real64)**2.6_real64 + 2.7_real64

    xdop(NStation) = doppler
    if (NStation == 2) then
       HisGrid = MyGrid
    else
       doppler00 = 2.0_real64*xdop(1)
       doppler   = xdop(1) + xdop(2)
       dbMoon    = -40.0_real64*log10(dist/356903.0_real64)
       sd        = 16.23_real64*370152.0_real64/dist

       if (NStation == 1 .and. MoonDX /= 0.0_real64) then
          poloffset = mod(poloffset2-poloffset1+720.0_real64,180.0_real64)
          if (poloffset > 90.0_real64) poloffset = poloffset - 180.0_real64
          x1 = abs(cos(2.0_real64*poloffset/RAD2DEG))
          if (x1 < 0.056234_real64) x1 = 0.056234_real64
          xnr = -20.0_real64*log10(x1)
          if (HisGrid(1:1) < 'A' .or. HisGrid(1:1) > 'R') xnr = 0.0_real64
       end if

       tr      = 80.0_real64
       tskymin = 13.0_real64*(408.0_real64/freq*1.0e-6_real64)**2.6_real64
       tsysmin = tskymin + tr
       tsys    = tsky + tr
       Dgrd    = -10.0_real64*log10(tsys/tsysmin) + dbMoon
    end if

    AzMoon0 = AzMoon
    ElMoon0 = ElMoon
    ntsky   = nint(tsky)

  end subroutine astro

end module astro_mod

subroutine geodist(Eplat,Eplon,Stlat,Stlon,Az,Baz,Dist)
  implicit none
  real eplat, eplon, stlat, stlon, az, baz, dist

! JHT: In actual fact, I use the first two arguments for "My Location",
!     the second two for "His location"; West longitude is positive.

!      Taken directly from:
!      Thomas, P.D., 1970, Spheroidal geodesics, reference systems,
!      & local geometry, U.S. Naval Oceanographi!Office SP-138,
!      165 pp.
!      assumes North Latitude and East Longitude are positive

!      EpLat, EpLon = End point Lat/Long
!      Stlat, Stlon = Start point lat/long
!      Az, BAz = direct & reverse azimuith
!      Dist = Dist (km); Deg = central angle, discarded

  real BOA, F, P1R, P2R, L1R, L2R, DLR, T1R, T2R, TM,          &
       DTM, STM, CTM, SDTM,CDTM, KL, KK, SDLMR, L,                &
       CD, DL, SD, T, U, V, D, X, E, Y, A, FF64, TDLPM,           &
       HAPBR, HAMBR, A1M2, A2M1

  real AL,BL,D2R,Pi2

  data AL/6378206.4/              ! Clarke 1866 ellipsoid
  data BL/6356583.8/
!      real pi /3.14159265359/
  data D2R/0.01745329251994/      ! degrees to radians conversion factor
  data Pi2/6.28318530718/

  if(abs(Eplat-Stlat).lt.0.02 .and. abs(Eplon-Stlon).lt.0.02) then
     Az=0.
     Baz=180.0
     Dist=0
     go to 999
  endif

  BOA = BL/AL
  F = 1.0 - BOA
! Convert st/end pts to radians
  P1R = Eplat * D2R
  P2R = Stlat * D2R
  L1R = Eplon * D2R
  L2R = StLon * D2R
  DLR = L2R - L1R                 ! DLR = Delta Long in Rads
  T1R = ATan(BOA * Tan(P1R))
  T2R = ATan(BOA * Tan(P2R))
  TM = (T1R + T2R) / 2.0
  DTM = (T2R - T1R) / 2.0
  STM = Sin(TM)
  CTM = Cos(TM)
  SDTM = Sin(DTM)
  CDTM = Cos(DTM)
  KL = STM * CDTM
  KK = SDTM * CTM
  SDLMR = Sin(DLR/2.0)
  L = SDTM * SDTM + SDLMR * SDLMR * (CDTM * CDTM - STM * STM)
  CD = 1.0 - 2.0 * L
  DL = ACos(CD)
  SD = Sin(DL)
  T = DL/SD
  U = 2.0 * KL * KL / (1.0 - L)
  V = 2.0 * KK * KK / L
  D = 4.0 * T * T
  X = U + V
  E = -2.0 * CD
  Y = U - V
  A = -D * E
  FF64 = F * F / 64.0
  Dist = AL*SD*(T -(F/4.0)*(T*X-Y)+FF64*(X*(A+(T-(A+E)                 &
       /2.0)*X)+Y*(-2.0*D+E*Y)+D*X*Y))/1000.0
  TDLPM = Tan((DLR+(-((E*(4.0-X)+2.0*Y)*((F/2.0)*T+FF64*               &
       (32.0*T+(A-20.0*T)*X-2.0*(D+2.0)*Y))/4.0)*Tan(DLR)))/2.0)
  HAPBR = ATan2(SDTM,(CTM*TDLPM))
  HAMBR = Atan2(CDTM,(STM*TDLPM))
  A1M2 = Pi2 + HAMBR - HAPBR
  A2M1 = Pi2 - HAMBR - HAPBR

1 If ((A1M2 .ge. 0.0) .AND. (A1M2 .lt. Pi2)) GOTO 5
  If (A1M2 .lt. Pi2) GOTO 4
  A1M2 = A1M2 - Pi2
  GOTO 1
4 A1M2 = A1M2 + Pi2
  GOTO 1

! All of this gens the proper az, baz (forward and back azimuth)

5 If ((A2M1 .ge. 0.0) .AND. (A2M1 .lt. Pi2)) GOTO 9
  If (A2M1 .lt. Pi2) GOTO 8
  A2M1 = A2M1 - Pi2
  GOTO 5
8 A2M1 = A2M1 + Pi2
  GOTO 5

9 Az = A1M2 / D2R
  BAZ = A2M1 / D2R

!Fix the mirrored coords here.
  
  az = 360.0 - az
  baz = 360.0 - baz

999 return
end subroutine geodist

program ft8d

! Decode FT8 data read from *.wav files.

  include 'ft8_params.f90'
  character*12 arg
  character infile*80,datetime*13,message*22
  real s(NH1,NHSYM)
  real candidate(3,100)
  integer ihdr(11)
  integer*2 iwave(NMAX)                 !Generated full-length waveform  
  real dd(NMAX)
 
  nargs=iargc()
  if(nargs.lt.3) then
     print*,'Usage:   ft8d MaxIt Norder file1 [file2 ...]'
     print*,'Example  ft8d   40     2   *.wav'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) max_iterations
  call getarg(2,arg)
  read(arg,*) norder
  nfiles=nargs-2

  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate
  dt=1.0/fs                              !Sample interval (s)
  tt=NSPS*dt                             !Duration of "itone" symbols (s)
  ts=2*NSPS*dt                           !Duration of OQPSK symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  txt=NZ*dt                              !Transmission length (s)
  nfa=100.0
  nfb=3000.0
  nfqso=1500.0

  do ifile=1,nfiles
     call getarg(ifile+2,infile)
     open(10,file=infile,status='old',access='stream')
     read(10,end=999) ihdr,iwave
     close(10)
     j2=index(infile,'.wav')
     read(infile(j2-6:j2-1),*) nutc
     datetime=infile(j2-13:j2-1)
     call sync8(iwave,nfa,nfb,nfqso,s,candidate,ncand)
     syncmin=2.0
     dd=iwave
     do icand=1,ncand
       sync=candidate(3,icand)
       if( sync.lt.syncmin) cycle
       f1=candidate(1,icand)
       xdt=candidate(2,icand)
       nsnr=min(99,nint(10.0*log10(sync)-25.5))
       call ft8b(dd,nfqso,f1,xdt,nharderrors,dmin,nbadcrc,message,xsnr)
       nsnr=xsnr
       xdt=xdt-0.6
       write(*,1110) datetime,0,nsnr,xdt,f1,message,nharderrors,dmin
1110   format(a13,2i4,f6.2,f7.1,' ~ ',a22,i6,f7.1)
     enddo
  enddo   ! ifile loop

999 end program ft8d
  

subroutine genft4(msg0,ichk,msgsent,msgbits,i4tone)

! Encode an FT4  message
! Input:
!   - msg0     requested message to be transmitted
!   - ichk     if ichk=1, return only msgsent
!   - msgsent  message as it will be decoded
!   - i4tone   array of audio tone values, {0,1,2,3} 

! Frame structure:
! s16 + 87symbols + 2 ramp up/down = 105 total channel symbols
! r1 + s4 + d29 + s4 + d29 + s4 + d29 + s4 + r1

! Message duration: TxT = 105*576/12000 = 5.04 s
  
! use iso_c_binding, only: c_loc,c_size_t

  use packjt77
  include 'ft4_params.f90'  
  character*37 msg0
  character*37 message                    !Message to be generated
  character*37 msgsent                    !Message as it will be received
  character*77 c77
  integer*4 i4tone(NN),itmp(ND)
  integer*1 codeword(2*ND)
  integer*1 msgbits(77),rvec(77) 
  integer icos4a(4),icos4b(4),icos4c(4),icos4d(4)
  logical unpk77_success
  data icos4a/0,1,3,2/
  data icos4b/1,0,2,3/
  data icos4c/2,3,1,0/
  data icos4d/3,2,0,1/
  data rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
            1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
            0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/
  message=msg0

  do i=1, 37
     if(ichar(message(i:i)).eq.0) then
        message(i:37)=' '
        exit
     endif
  enddo
  do i=1,37                               !Strip leading blanks
     if(message(1:1).ne.' ') exit
     message=message(i+1:)
  enddo

  i3=-1
  n3=-1
  call pack77(message,i3,n3,c77)
  call unpack77(c77,0,msgsent,unpk77_success) !Unpack to get msgsent

  if(ichk.eq.1) go to 999
  read(c77,'(77i1)',err=1) msgbits
  if(unpk77_success) go to 2
1 msgbits=0
  itone=0
  msgsent='*** bad message ***                  '
  go to 999

entry get_ft4_tones_from_77bits(msgbits,i4tone)

2 msgbits=mod(msgbits+rvec,2)
  call encode174_91(msgbits,codeword)

! Grayscale mapping:
! bits   tone
! 00     0
! 01     1
! 11     2
! 10     3

  do i=1,ND
    is=codeword(2*i)+2*codeword(2*i-1)
    if(is.le.1) itmp(i)=is
    if(is.eq.2) itmp(i)=3
    if(is.eq.3) itmp(i)=2
  enddo

  i4tone(1:4)=icos4a
  i4tone(5:33)=itmp(1:29)
  i4tone(34:37)=icos4b
  i4tone(38:66)=itmp(30:58)
  i4tone(67:70)=icos4c
  i4tone(71:99)=itmp(59:87)
  i4tone(100:103)=icos4d

999 return
end subroutine genft4

subroutine q65c

  use timer_module, only: timer
  use timer_impl, only: fini_timer !, limtrace
  use, intrinsic :: iso_c_binding, only: C_NULL_CHAR
  use FFTW3
  use q65
  use q65_decode

  parameter (NFFT=32768)
  include 'njunk.f90'
  real*8 fcenter
  real*4 pdb(4)
  integer nparams0(NJUNK+3),nparams(NJUNK+3)
!  integer values(8)
  logical first
  logical*1 bAlso30
  character*120 fname
  character*22 revision
  character*12 mycall,hiscall
  character*6 mygrid,hisgrid
  character*20 datetime
  character*64 result
  common/decodes/ndecodes,ncand2,nQDecoderDone,nWDecoderBusy,              &
       nWTransmitting,kHzRequested,result(50)
  common/datcom2/dd(2,5760000),ss(400,NFFT),savg(NFFT),nparams0
  common/savecom/revision,fname
!### REMEMBER that /npar/ is not updated until nparams=nparams0 is executed. ###
  common/npar/fcenter,nutc,fselected,mousedf,mousefqso,nagain,            &
       ndepth,ndiskdat,ntx60,newdat,nn1,nn2,nfcal,nfshift,                 &
       ntx30a,ntx30b,ntol,n60,nCFOM,nfsample,ndop58,nmode,               &
       ndop00,nsave,nn3,nn4,nhsym,mycall,mygrid,hiscall,hisgrid,      &
       datetime,junk1,junk2,bAlso30
  equivalence (nparams,fcenter)
  data first/.true./
  save first

  nparams=nparams0                     !Copy parameters into common/npar/
  datetime(12:)='00       '
  npatience=1
  newdat=1                          !Always on ??

  if(ndiskdat.eq.1) then
     call chkstat(dd,nhsym,pdb)
     if((abs(pdb(1)-pdb(2)).gt.3.0 .and. pdb(1).gt.1.0) .or.  &
          pdb(1).lt.1.0) ntx30a=20                               !Tx 1st half
     if((abs(pdb(3)-pdb(4)).gt.3.0 .and. pdb(3).gt.1.0) .or.  &
          pdb(3).lt.1.0) ntx30b=20                               !Tx 2nd half
     if(pdb(4).lt.0.04) then
        ntx30a=0  !Older 56s files have no Tx
        ntx30b=0  !Older 56s files have no Tx
     endif
  endif

  if(ntx30a.gt.5) then
     dd(1:2,1:30*96000)=0.
     ss(1:200,1:NFFT)=0.
     do i=1,NFFT
        savg(i)=sum(ss(201:400,i))
     enddo
  endif
  if(ntx30b.gt.5) then
     dd(1:2,30*96000+1:60*96000)=0.
     ss(201:400,1:NFFT)=0.
     do i=1,NFFT
        savg(i)=sum(ss(1:200,i))
     enddo
  endif

  if(nhsym.gt.200 .and. ntx30b.gt.5) go to 10
  call timer('decode0 ',0)
  call decode0(dd,ss,savg)
  call timer('decode0 ',1)

10 continue
!  call date_and_time(VALUES=values)
!  n60b=values(7)
!  nd=n60b-n60
!  if(nd.lt.0) nd=nd+60
!  write(*,3002) nutc,nagain,nhsym,n60,n60b,nd,ntx30a,ntx30b,ndecodes,  &
!       nsave,revision
!3002 format('A',i5.4,i3,i5,7i4,1x,a22)
!  flush(6)

  if(ndiskdat.eq.0) then
     if(nhsym.eq.390 .and.                                                   &
          (nsave.eq.2 .or. (nsave.eq.1 .and. ndecodes.ge.1))) then
        call save_qm(fname,revision,mycall,mygrid,dd,ntx30a,ntx30b,fcenter,  &
             nutc,ndop00,ndop58)
     endif
  endif

  return
end subroutine q65c

subroutine all_done

  use timer_module, only: timer
  use timer_impl, only: fini_timer

  call timer('decode0 ',101)
  call fini_timer

  return
end subroutine all_done

module twkfreq_mod
  implicit none
contains
  subroutine twkfreq(c3,c4,npts,fsample,a)
    implicit none
    integer, intent(in) :: npts
    complex, intent(in) :: c3(npts)
    complex, intent(out) :: c4(npts)
    real, intent(in) :: fsample, a(3)
    
    complex :: w,wstep
    real :: twopi
    data twopi/6.283185307/
    real :: x0, s, x, p2, dphi
    integer :: i
  
  ! Mix the complex signal
    w=1.0
    wstep=1.0
    x0=0.5*(npts+1)
    s=2.0/npts
    do i=1,npts
       x=s*(i-x0)
       p2=1.5*x*x - 0.5
  !          p3=2.5*(x**3) - 1.5*x
  !          p4=4.375*(x**4) - 3.75*(x**2) + 0.375
       dphi=(a(1) + x*a(2) + p2*a(3)) * (twopi/fsample)
       wstep=cmplx(cos(dphi),sin(dphi))
       w=w*wstep
       c4(i)=w*c3(i)
    enddo
  
  end subroutine twkfreq
end module twkfreq_mod

module shmem
  ! external routines wrapping the Qt QSharedMemory class
  interface
     function shmem_create (size) bind(C, name="shmem_create")
       use iso_c_binding, only: c_bool, c_int
       logical(c_bool) :: shmem_create
       integer(c_int), value, intent(in) :: size
     end function shmem_create

     subroutine shmem_setkey (key) bind(C, name="shmem_setkey")
       use iso_c_binding, only: c_bool, c_char
       character(kind=c_char), intent(in) :: key(*)
     end subroutine shmem_setkey

     function shmem_attach () bind(C, name="shmem_attach")
       use iso_c_binding, only: c_bool
       logical(c_bool) :: shmem_attach
     end function shmem_attach

     function shmem_address() bind(C, name="shmem_address")
       use, intrinsic :: iso_c_binding, only: c_ptr
       type(c_ptr) :: shmem_address
     end function shmem_address

     function shmem_size() bind(C, name="shmem_size")
       use, intrinsic :: iso_c_binding, only: c_int
       integer(c_int) :: shmem_size
     end function shmem_size

     function shmem_lock () bind(C, name="shmem_lock")
       use iso_c_binding, only: c_bool
       logical(c_bool) :: shmem_lock
     end function shmem_lock

     function shmem_unlock () bind(C, name="shmem_unlock")
       use iso_c_binding, only: c_bool
       logical(c_bool) :: shmem_unlock
     end function shmem_unlock

     function shmem_detach () bind(C, name="shmem_detach")
       use iso_c_binding, only: c_bool
       logical(c_bool) :: shmem_detach
     end function shmem_detach
  end interface
end module shmem

subroutine entail(dgen,data0)

! Move 72-bit packed data from 6-bit to 8-bit symbols and add a zero tail.
  integer dgen(13)
  integer*1 data0(13)

  i4=0
  k=0
  m=0
  do i=1,12
     n=dgen(i)
     do j=1,6
        k=k+1
        i4=i4+i4+iand(1,ishft(n,j-6))
        i4=iand(i4,255)
        if(k.eq.8) then
           m=m+1
           if(i4.gt.127) i4=i4-256
           data0(m)=i4
           k=0
        endif
     enddo
  enddo
  do m=10,13
     data0(m)=0
  enddo

  return
end subroutine entail

subroutine msk144signalquality(cframe,snr,freq,t0,softbits,msg,dxcall,       &
   btrain,datadir,nbiterrors,eyeopening,pcoeffs)

  character*37 msg,msgsent
  character*12 dxcall
  character*12 training_dxcall
  character*12 trained_dxcall
  character*512 pcoeff_filename
  character*8 date
  character*10 time
  character*5 zone
  character*(*) datadir

  complex cframe(864)
  complex cross(864)
  complex cross_avg(864)
  complex canalytic(1024)
  complex cmodel(1024)

  integer i4tone(144)
  integer hardbits(144)
  integer msgbits(144)
  integer values(8)

  logical*1 btrain
  logical*1 first
  logical*1 currently_training
  logical*1 msg_has_dxcall
  logical*1 is_training_frame
 
  real softbits(144)
  real waveform(0:863)  
  real d(1024)
  real phase(864)
  real twopi,freq,phi,dphi0,dphi1,dphi
  real*8 x(145),y(145),pp(145),sigmay(145),a(5),chisqr
  real*8 pcoeffs(5)

  parameter (NFREQLOW=500,NFREQHIGH=2500)
  data first/.true./
  save cross_avg,wt_avg,first,currently_training,   &
       navg,tlast,training_dxcall,trained_dxcall

  if (first) then
    navg=0
    cross=cmplx(0.0,0.0)
    cross_avg=cmplx(0.0,0.0)
    wt_avg=0.0
    tlast=0.0
    trained_dxcall(1:12)=' '
    training_dxcall(1:12)=' '
    currently_training=.false.
    first=.false.
  endif

  if( (currently_training .and. (dxcall .ne. training_dxcall)) .or. &
      (navg .gt. 10 )) then !reset and retrain
    navg=0
    cross=cmplx(0.0,0.0)
    cross_avg=cmplx(0.0,0.0)
    wt_avg=0.0
    tlast=0.0
    trained_dxcall(1:12)=' '
    currently_training=.false.
    training_dxcall(1:12)=' '
    trained_dxcall(1:12)=' '
!write(*,*) 'reset to untrained state '
  endif

  indx_dxcall=index(msg,trim(dxcall))
  msg_has_dxcall = indx_dxcall .ge. 4

  if( btrain .and. msg_has_dxcall .and. (.not. currently_training) ) then
    currently_training=.true.
    training_dxcall=trim(dxcall)
    trained_dxcall(1:12)=' '
!write(*,*) 'start training on call ',training_dxcall
  endif

  if( msg_has_dxcall .and. currently_training ) then
    trained_dxcall(1:12)=' '
    training_dxcall=dxcall
  endif

! use decoded message to figure out how many bit errors in the frame 
  do i=1, 144
    hardbits(i)=0
    if(softbits(i) .gt. 0 ) hardbits(i)=1
  enddo

! generate tones from decoded message
  ichk=0
  call genmsk_128_90(msg,ichk,msgsent,i4tone,itype)

! reconstruct message bits from tones
  msgbits(1)=0
  do i=1,143
    if( i4tone(i) .eq. 0 ) then
      if( mod(i,2) .eq. 1 ) then
        msgbits(i+1)=msgbits(i)
      else 
        msgbits(i+1)=mod(msgbits(i)+1,2)
      endif
    else
      if( mod(i,2) .eq. 1 ) then
        msgbits(i+1)=mod(msgbits(i)+1,2)
      else 
        msgbits(i+1)=msgbits(i)
      endif
    endif
  enddo

  nbiterrors=0
  do i=1,144
    if( hardbits(i) .ne. msgbits(i) ) nbiterrors=nbiterrors+1
  enddo

  nplus=0
  nminus=0
  eyetop=1
  eyebot=-1
  do i=1,144
    if( msgbits(i) .eq. 1 ) then
      if( softbits(i) .lt. eyetop ) eyetop=softbits(i)
    else
      if( softbits(i) .gt. eyebot ) eyebot=softbits(i)
    endif
  enddo  
  eyeopening=eyetop-eyebot

  is_training_frame =                                                          &
      (snr.gt.5.0 .and.(nbiterrors.lt.7))    .and.                             &
      (abs(t0-tlast) .gt. 0.072)             .and.                             &
      msg_has_dxcall                              
  if( currently_training .and. is_training_frame ) then
      twopi=8.0*atan(1.0)
      nsym=144
      if( i4tone(41) .lt. 0 ) nsym=40
      dphi0=twopi*(freq-500)/12000.0
      dphi1=twopi*(freq+500)/12000.0
      phi=-twopi/8
      indx=0
      do i=1,nsym
        if( i4tone(i) .eq. 0 ) then
          dphi=dphi0
        else
          dphi=dphi1
        endif
        do j=1,6  
          waveform(indx)=cos(phi);
          indx=indx+1
          phi=mod(phi+dphi,twopi)
        enddo 
      enddo
! convert the passband waveform to complex baseband
      npts=864
      nfft=1024
      d=0
      d(1:864)=waveform(0:863)
      call analytic(d,npts,nfft,canalytic,pcoeffs,.false.) ! don't equalize the model
      call tweak1(canalytic,nfft,-freq,cmodel)
      call four2a(cframe(1:864),864,1,-1,1)
      call four2a(cmodel(1:864),864,1,-1,1)

! Cross spectra from different messages can be averaged
! as long as all messages originate from dxcall. 
      cross=cmodel(1:864)*conjg(cframe)/1000.0
      cross=cshift(cross,864/2)
      cross_avg=cross_avg+10**(snr/20.0)*cross
      wt_avg=wt_avg+10**(snr/20.0)
      navg=navg+1
      tlast=t0
      phase=atan2(imag(cross_avg),real(cross_avg))
      df=12000.0/864.0
      nm=145
      do i=1,145
        x(i)=(i-73)*df/1000.0
      enddo
      y=phase((864/2-nm/2):(864/2+nm/2))
      sigmay=wt_avg/abs(cross_avg((864/2-nm/2):(864/2+nm/2)))
      mode=1
      npts=145
      nterms=5
      call polyfit(x,y,sigmay,npts,nterms,mode,a,chisqr)
      pp=a(1)+x*(a(2)+x*(a(3)+x*(a(4)+x*a(5)))) 
      rmsdiff=sum( (pp-phase((864/2-nm/2):(864/2+nm/2)))**2 )/145.0
!write(*,*) 'training ',navg,sqrt(chisqr),rmsdiff
      if( (sqrt(chisqr).lt.1.8) .and. (rmsdiff.lt.0.5) .and. (navg.ge.5) ) then 
        trained_dxcall=dxcall
        call date_and_time(date,time,zone,values)
        write(pcoeff_filename,'(i2.2,i2.2,i2.2,"_",i2.2,i2.2,i2.2)')    &
          values(1)-2000,values(2),values(3),values(5),values(6),values(7)
        pcoeff_filename=trim(trained_dxcall)//"_"//trim(pcoeff_filename)//".pcoeff"
        pcoeff_filename=datadir//'/'//trim(pcoeff_filename)
!write(*,*) 'trained - writing coefficients to: ',pcoeff_filename
        open(17,file=pcoeff_filename,status='new')
        write(17,'(i4,2f10.2,3i5,5e25.16)') navg,sqrt(chisqr),rmsdiff,NFREQLOW,NFREQHIGH,nterms,a
        do i=1, 145
          write(17,*) x(i),pp(i),y(i),sigmay(i)
        enddo
        do i=1,864
          write(17,*) i,real(cframe(i)),imag(cframe(i)),real(cross_avg(i)),imag(cross_avg(i))
        enddo
        close(17)
        training_dxcall(1:12)=' '
        currently_training=.false.
        btrain=.false.
        navg=0
      endif
  endif

  return
  end subroutine msk144signalquality

program jt9sim

! Generate simulated data for testing of WSJT-X

  use wavhdr
  use packjt
  parameter (NTMAX=120)
  parameter (NMAX=NTMAX*12000)
  type(hdr) h
  integer*2 iwave(NMAX)                  !Generated waveform (no noise)
  real*4 dat(NMAX)
  real*8 f0,f,dt,twopi,phi,dphi,baud,fspan,fsample,freq
  character msg*22,msg0*22,message*22,msgsent*22,arg*8,fname*11

  integer*4 i4tone(85)             !Channel symbols (values 0-8)
  integer*4 i4DataSymNoGray(69)    !Data Symbols, values 0-7
  integer*1 i1ScrambledBits(207)   !Unpacked bits, scrambled order
  integer*1 i1Bits(207)            !Encoded information-carrying bits
  integer*1 i1SoftSymbols(207)
  include 'jt9sync.f90'

  nargs=iargc()
  if(nargs.ne.6) then
     print*,'Usage:   jt9sim "message"     fspan nsigs minutes SNR nfiles'
     print*,'Example: jt9sim "CQ K1ABC FN42" 200  20      2    -28    1'
     print*,' '
     print*,'Enter message = "" to use entries in msgs.txt.'
     print*,'Enter SNR = 0 to generate a range of SNRs.'
     print*,'Enter SNR = 99 to generate a noiseless signal at frequency fspan'
     go to 999
  endif

  call getarg(1,msg0)  
  call fmtmsg(msg0,iz)
  message=msg0                       !Transmitted message
  call getarg(2,arg)
  read(arg,*) fspan                  !Total freq range (Hz)
  call getarg(3,arg)
  read(arg,*) nsigs                  !Number of signals in each file
  call getarg(4,arg)
  read(arg,*) minutes                !Length of file (1 2 5 10 30 minutes)
  call getarg(5,arg)
  read(arg,*) snrdb                  !S/N in dB (2500 hz reference BW)
  call getarg(6,arg)
  read(arg,*) nfiles                 !Number of files     

  rmsdb=25.
  rms=10.0**(0.05*rmsdb)
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  npts=12000*(60*minutes-6)
  nsps=0
  if(minutes.eq.1)  nsps=6912
  if(minutes.eq.2)  nsps=15360
  if(minutes.eq.5)  nsps=40960
  if(minutes.eq.10) nsps=82944
  if(minutes.eq.30) nsps=252000
  if(nsps.eq.0) stop 'Bad value for minutes.'

  f0=1400.d0                         !Center frequency (Hz)
!  f0=3000.d0                         !Center frequency (Hz)

!  f0=1500.0
!  if(minutes.eq.5)  f0=1100.
!  if(minutes.eq.10) f0=1050.
!  if(minutes.eq.30) f0=1025.


  call init_random_seed()       ! seed Fortran RANDOM_NUMBER generator
  call sgran()                  ! see C rand generator (used in gran)

  h=default_header(12000,npts)  
  k=0                                !Silence compiler warning

  if(msg0(1:3).eq.'sin') read(msg0(4:),*) sinfreq
  
  if(message.eq."") open(12,file='msgs.txt',status='old')

  write(*,1000)
1000 format('File  N    freq      S/N  Message'/    &
            '---------------------------------------------------')

  do ifile=1,nfiles                            !Loop over all files
     nmin=(ifile-1)*minutes
     ihr=nmin/60
     imin=mod(nmin,60)
     write(fname,1002) ihr,imin                !Create output filename
1002 format('000000_',2i2.2)
     open(10,file=fname//'.wav',access='stream',status='unknown')

     if(snrdb.lt.90) then
        do i=1,npts
           dat(i)=gran()
        enddo
     else
        dat(1:npts)=0.
     endif

     if(msg0.ne.'                      ') then
        call gen9(message,0,msgsent,i4tone,itype) !Encode message into tone #s
     endif

     rewind 12
     do isig=1,nsigs                            !Loop over multiple signals

        if(msg0.eq.'                      ') then
           read(12,1004) message                !Use pre-generated message texts
1004       format(a22)
           call gen9(message,0,msgsent,i4tone,itype)
        endif

        f=f0
        if(nsigs.gt.1) f=f0 - 0.5d0*fspan + fspan*(isig-1.d0)/(nsigs-1.d0)
        snrdbx=snrdb 
!        snrdbx=snrdb + (ifile-1)*4.0
        sig=10.0**(0.05*snrdbx)
        if(snrdb.gt.90.0) sig=1.0
        write(*,1020) ifile,isig,f,snrdbx,msgsent
1020    format(i3,i4,f10.3,f7.1,2x,a22)

        phi=0.
        baud=12000.d0/nsps
        k=12000                             !Start audio at t = 1.0 s
!        f1=0.0001 * (ifile-1)
        f1=0.
!        print*,ifile-1,f1
        dphi2=0.
        ddphi2=twopi*f1*dt/60.0
        do isym=1,85
           freq=f + i4tone(isym)*baud
           if(msg0(1:3).eq.'sin') freq=sinfreq
           dphi=twopi*freq*dt + dphi2
           do i=1,nsps
              phi=phi + dphi
              dphi2=dphi2 + ddphi2
              if(phi.lt.-twopi) phi=phi+twopi
              if(phi.gt.twopi) phi=phi-twopi
              xphi=phi
              k=k+1
              dat(k)=dat(k) + sig*sin(xphi)  !Use lookup table for i*2 sin(x) ?
           enddo
        enddo
     enddo

     fac=32767.0/nsigs
     if(snrdb.ge.90.0) iwave(1:npts)=nint(fac*dat(1:npts))
     if(snrdb.lt.90.0) iwave(1:npts)=nint(rms*dat(1:npts))

     write(10) h,iwave(1:npts)
     close(10)

! We're done!  Now decode the data symbols from i4tone, as a test.
     if(msg0.ne.'                      ') then
        j=0
        do i=1,85
           if(isync(i).eq.1) cycle
           j=j+1
           i4DataSymNoGray(j)=igray(i4tone(i)-1,-1)
        enddo
        call unpackbits(i4DataSymNoGray,69,3,i1ScrambledBits)
        call interleave9(i1ScrambledBits,-1,i1Bits)
 
        do i=1,206
           i4=-10
           if(i1Bits(i).eq.1) i4=10
           i1SoftSymbols(i)=i4
        enddo
        limit=1000
        call jt9fano(i1SoftSymbols,limit,nlim,msg)
        if(msg.ne.msg0) print*,'Decode error: ',msg0,' ',msg
     endif
  enddo

999 end program jt9sim

subroutine q65_ap(nQSOprogress,ipass,ncontest,lapcqonly,iaptype,   &
     apsym0,apmask,apsymbols)

  integer apsym0(58),aph10(10)
  integer apmask(78),apsymbols(78)
  integer naptypes(0:5,4) ! (nQSOProgress, ipass)  maximum of 4 passes for now
  integer mcqru(29),mcqfd(29),mcqtest(29),mcqww(29)
  integer mcq(29),mrrr(19),m73(19),mrr73(19)
  logical lapcqonly,first
  data     mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
  data   mcqru/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,0,0,1,1,0,0/
  data   mcqfd/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,1,0,0,0,1,0/
  data mcqtest/0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,0,1,0,1,1,1,1,1,1,0,0,1,0/
  data   mcqww/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,1,1,1,1,0/
  data    mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
  data     m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
  data   mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
  data ncontest0/99/
  data first/.true./
  save naptypes,ncontest0

! nQSOprogress
!   0  CALLING
!   1  REPLYING
!   2  REPORT
!   3  ROGER_REPORT
!   4  ROGERS
!   5  SIGNOFF

  if(first.or.(ncontest.ne.ncontest0)) then
! iaptype
!------------------------
!   1        CQ     ???    ???           (29+4=33 ap bits)
!   2        MyCall ???    ???           (29+4=33 ap bits)
!   3        MyCall DxCall ???           (58+4=62 ap bits)
!   4        MyCall DxCall RRR           (78 ap bits)
!   5        MyCall DxCall 73            (78 ap bits)
!   6        MyCall DxCall RR73          (78 ap bits)

     naptypes(0,1:4)=(/1,2,0,0/) ! Tx6 selected (CQ)
     naptypes(1,1:4)=(/2,3,0,0/) ! Tx1
     naptypes(2,1:4)=(/2,3,0,0/) ! Tx2
     naptypes(3,1:4)=(/3,4,5,6/) ! Tx3
     naptypes(4,1:4)=(/3,4,5,6/) ! Tx4
     naptypes(5,1:4)=(/3,1,2,0/) ! Tx5
     first=.false.
     ncontest0=ncontest
  endif

  apsymbols=0
  iaptype=naptypes(nQSOProgress,ipass)
  if(lapcqonly) iaptype=1
  
! ncontest=0 : NONE
!          1 : NA_VHF
!          2 : EU_VHF
!          3 : FIELD DAY
!          4 : RTTY
!          5 : WW_DIGI 
!          6 : FOX
!          7 : HOUND

! Conditions that cause us to bail out of AP decoding
!  if(ncontest.le.5 .and. iaptype.ge.3 .and. (abs(f1-nfqso).gt.napwid .and. abs(f1-nftx).gt.napwid) ) goto 900
!  if(ncontest.eq.6) goto 900                      !No AP for Foxes
!  if(ncontest.eq.7.and.f1.gt.950.0) goto 900      !Hounds use AP only below 950 Hz
  if(ncontest.ge.6) goto 900
  if(iaptype.ge.2 .and. apsym0(1).gt.1) goto 900  !No, or nonstandard, mycall 
  if(ncontest.eq.7 .and. iaptype.ge.2 .and. aph10(1).gt.1) goto 900
  if(iaptype.ge.3 .and. apsym0(30).gt.1) goto 900 !No, or nonstandard, dxcall

  if(iaptype.eq.1) then ! CQ or CQ RU or CQ TEST or CQ FD
     apmask=0
     apmask(1:29)=1  
     if(ncontest.eq.0) apsymbols(1:29)=mcq
     if(ncontest.eq.1) apsymbols(1:29)=mcqtest
     if(ncontest.eq.2) apsymbols(1:29)=mcqtest
     if(ncontest.eq.3) apsymbols(1:29)=mcqfd
     if(ncontest.eq.4) apsymbols(1:29)=mcqru
     if(ncontest.eq.5) apsymbols(1:29)=mcqww
     if(ncontest.eq.7) apsymbols(1:29)=mcq
     apmask(75:78)=1 
     apsymbols(75:78)=(/0,0,1,0/)
  endif

  if(iaptype.eq.2) then ! MyCall,???,??? 
     apmask=0
     if(ncontest.eq.0.or.ncontest.eq.1.or.ncontest.eq.5) then
        apmask(1:29)=1  
        apsymbols(1:29)=apsym0(1:29)
        apmask(75:78)=1
        apsymbols(75:78)=(/0,0,1,0/)
     else if(ncontest.eq.2) then
        apmask(1:28)=1  
        apsymbols(1:28)=apsym0(1:28)
        apmask(72:74)=1
        apsymbols(72)=0
        apsymbols(73)=(+1)
        apsymbols(74)=0
        apmask(75:78)=1 
        apsymbols(75:78)=0
     else if(ncontest.eq.3) then
        apmask(1:28)=1  
        apsymbols(1:28)=apsym0(1:28)
        apmask(75:78)=1 
        apsymbols(75:78)=0
     else if(ncontest.eq.4) then
        apmask(2:29)=1  
        apsymbols(2:29)=apsym0(1:28)
        apmask(75:78)=1 
        apsymbols(75:78)=(/0,0,1,0/)
     else if(ncontest.eq.7) then ! ??? RR73; MyCall <Fox Call hash10> ???
        apmask(29:56)=1  
        apsymbols(29:56)=apsym0(1:28)
        apmask(57:66)=1
        apsymbols(57:66)=aph10(1:10)
        apmask(72:78)=1
        apsymbols(72:74)=(/0,0,1/)
        apsymbols(75:78)=0
     endif
  endif

  if(iaptype.eq.3) then ! MyCall,DxCall,??? 
     apmask=0
     if(ncontest.eq.0.or.ncontest.eq.1.or.ncontest.eq.2.or.ncontest.eq.5.or.ncontest.eq.7) then
        apmask(1:58)=1  
        apsymbols(1:58)=apsym0
        apmask(75:78)=1
        apsymbols(75:78)=(/0,0,1,0/)
     else if(ncontest.eq.3) then ! Field Day
        apmask(1:56)=1  
        apsymbols(1:28)=apsym0(1:28)
        apsymbols(29:56)=apsym0(30:57)
        apmask(72:78)=1 
        apsymbols(75:78)=0
     else if(ncontest.eq.4) then 
        apmask(2:57)=1  
        apsymbols(2:29)=apsym0(1:28)
        apsymbols(30:57)=apsym0(30:57)
        apmask(75:78)=1 
        apsymbols(75:78)=(/0,0,1,0/)
     endif
  endif

  if(iaptype.eq.5.and.ncontest.eq.7) goto 900 !Hound
  if(iaptype.eq.4 .or. iaptype.eq.5 .or. iaptype.eq.6) then  
     apmask=0
     if(ncontest.le.5 .or. (ncontest.eq.7.and.iaptype.eq.6)) then
        apmask(1:78)=1                      !MyCall, HisCall, RRR|73|RR73
        apmask(72:74)=0                     !Check for <blank>, RRR, RR73, 73
        apsymbols(1:58)=apsym0
        if(iaptype.eq.4) apsymbols(59:77)=mrrr
        if(iaptype.eq.5) apsymbols(59:77)=m73
        if(iaptype.eq.6) apsymbols(59:77)=mrr73
     else if(ncontest.eq.7.and.iaptype.eq.4) then ! Hound listens for MyCall RR73;...
        apmask(1:28)=1
        apsymbols(1:28)=apsym0(1:28)
        apmask(57:66)=1
        apsymbols(57:66)=aph10(1:10)
        apmask(72:78)=1
        apsymbols(72:78)=(/0,0,1,0,0,0,0/)
     endif
  endif

900 return
end subroutine q65_ap

module astro0_state_mod
  use iso_fortran_env, only: real64
  implicit none
  real(real64) :: uth8z      = 0.0_real64
  real(real64) :: dopplerz   = 0.0_real64
  real(real64) :: doppler00z = 0.0_real64
end module astro0_state_mod


module astro0_mod
  use iso_fortran_env, only: real64
  use astro_mod
  use astro0_state_mod
  use tm2_mod
  implicit none

  real(real64), parameter :: DEGS = 57.2957795130823_real64

contains

  subroutine astro0(nyear,month,nday,uth8,nfreq,mygrid,hisgrid,              &
       AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,    &
       dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,    &
       width1,width2,w501,w502,xlst8)

    implicit none

    ! Dummy arguments
    integer,        intent(in)    :: nyear, month, nday, nfreq
    real(real64),   intent(inout) :: uth8
    character(len=6), intent(in)  :: mygrid, hisgrid
    real(real64),   intent(out)   :: AzSun8, ElSun8, AzMoon8, ElMoon8
    real(real64),   intent(out)   :: AzMoonB8, ElMoonB8
    integer,        intent(out)   :: ntsky, ndop, ndop00
    real(real64),   intent(out)   :: dbMoon8, RAMoon8, DecMoon8, HA8
    real(real64),   intent(out)   :: Dgrd8, sd8, poloffset8, xnr8
    real(real64),   intent(out)   :: dfdt, dfdt0
    real(real64),   intent(out)   :: width1, width2, w501, w502, xlst8

       ! Locals
    real :: uth,day
    real :: doppler00_loc, ndop_loc
    real :: AzSun, ElSun, AzMoon, ElMoon
    real :: AzMoonB, ElMoonB
    integer      :: ntsky_loc
    real :: dbMoon, RAMoon, DecMoon, HA, Dgrd, sd
    real :: poloffset, xnr
    real         :: xlon1, xlat1, xlon2, xlat2
    real         :: xlst
    real :: xl1, b1, xl2, b2
    real :: xl1a, b1a, xl2a, b2a
    real(real64) :: fghz, dldt1, dbdt1, dldt2, dbdt2
    real(real64) :: rate1, rate2
    real(real64) :: fbend, a2, f50
    real(real64) :: dt

    uth = uth8

    ! Station 2 (hisgrid)
    call astro(nyear,month,nday,uth,nfreq,hisgrid,2,1.0,          &
         AzSun,ElSun,AzMoonB,ElMoonB,ntsky_loc,doppler00_loc,ndop_loc,   &
         dbMoon,RAMoon,DecMoon,HA,Dgrd,sd,poloffset,xnr,                 &
         day,xlon2,xlat2,xlst)

    AzMoonB8 = AzMoonB
    ElMoonB8 = ElMoonB

    ! Station 1 (mygrid)
    call astro(nyear,month,nday,uth,nfreq,mygrid,1,1.0,           &
         AzSun,ElSun,AzMoon,ElMoon,ntsky_loc,doppler00_loc,ndop_loc,     &
         dbMoon,RAMoon,DecMoon,HA,Dgrd,sd,poloffset,xnr,                 &
         day,xlon1,xlat1,xlst)
         
    ! Outputs from second call
    AzSun8   = AzSun
    ElSun8   = ElSun
    AzMoon8  = AzMoon
    ElMoon8  = ElMoon
    dbMoon8  = dbMoon
    RAMoon8  = RAMoon/15.0_real64
    DecMoon8 = DecMoon
    HA8      = HA
    Dgrd8    = Dgrd
    sd8      = sd
    poloffset8 = poloffset
    xnr8       = xnr
    ndop       = nint(ndop_loc)
    ndop00     = nint(doppler00_loc)
    ntsky      = ntsky_loc
    xlst8      = xlst

    ! Tracking motion for width1/width2
    call tm2(real(day,8),xlat1,xlon1,xl1,b1)
    call tm2(real(day,8),xlat2,xlon2,xl2,b2)
    call tm2(real(day,8)+1.0/1440.0,xlat1,xlon1,xl1a,b1a)
    call tm2(real(day,8)+1.0/1440.0,xlat2,xlon2,xl2a,b2a)

    fghz  = 0.001_real64*real(nfreq,real64)
    dldt1 = DEGS*(xl1a-xl1)
    dbdt1 = DEGS*(b1a-b1)
    dldt2 = DEGS*(xl2a-xl2)
    dbdt2 = DEGS*(b2a-b2)

    rate1  = 2.0_real64*sqrt(dldt1**2 + dbdt1**2)
    width1 = 0.5_real64*6741.0_real64*fghz*rate1
    rate2  = sqrt((dldt1+dldt2)**2 + (dbdt1+dbdt2)**2)
    width2 = 0.5_real64*6741.0_real64*fghz*rate2

    fbend = 0.7_real64
    a2    = 0.0045_real64*log(fghz/fbend)/log(1.05_real64)
    if (fghz < fbend) a2 = 0.0_real64
    f50 = 0.19_real64 * (fghz/fbend)**a2
    if (f50 > 1.0_real64) f50 = 1.0_real64
    w501 = f50*width1
    w502 = f50*width2

    ! df/dt using persistent state in astro0_state_mod
    if (uth8z == 0.0_real64) then
       uth8z      = uth8 - 1.0_real64/3600.0_real64
       dopplerz   = ndop_loc
       doppler00z = doppler00_loc
    end if

    dt = 60.0_real64*(uth8-uth8z)
    if (dt <= 0.0_real64) dt = 1.0_real64/60.0_real64

    dfdt  = (ndop_loc     - dopplerz  )/dt
    dfdt0 = (doppler00_loc - doppler00z)/dt

    uth8z      = uth8
    dopplerz   = ndop_loc
    doppler00z = doppler00_loc

  end subroutine astro0

end module astro0_mod

subroutine tm2(day,xlat4,xlon4,xl4,b4)

  implicit real*8 (a-h,o-z)
  parameter (RADS=0.0174532925199433d0)

  real*4 xlat4,xlon4,xl4,b4

  glat=xlat4*RADS
  glong=xlon4*RADS
  call tmoonsub(day,glat,glong,el,rv,xl,b,pax)
  xl4=xl
  b4=b

end subroutine tm2

subroutine spec9f(id2,npts,nsps,s1,jz,nq)

! Compute symbol spectra at quarter-symbol steps.

  integer*2 id2(0:npts)
  real s1(nq,jz)
  real x(960)
  complex c(0:480)
  equivalence (x,c)

  nfft=2*nsps                               !FFTs at twice the symbol length
  nh=nfft/2
  do j=1,jz
     ia=(j-1)*nsps/4
     ib=ia+nsps-1
     if(ib.gt.npts) exit
     x(1:nh)=id2(ia:ib)
     x(nh+1:)=0.
     call four2a(x,nfft,1,-1,0)           !r2c
     k=mod(j-1,340)+1
     do i=1,NQ
        s1(i,j)=1.e-10*(real(c(i))**2 + aimag(c(i))**2)
     enddo
  enddo

!### Reference spectrum should be applied here (or possibly earlier?) ###
!### Normalize so that rms (or level?) is 1.0 ?  ###

  return
end subroutine spec9f

subroutine fqso_first(nfqso,ntol,ca,ncand)

! If a candidate was found within +/- ntol of nfqso, move it into ca(1).

  type candidate
     real freq
     real dt
     real sync
     real flip
  end type candidate
  type(candidate) ca(300),cb

  dmin=1.e30
  i0=0
  do i=1,ncand
     d=abs(ca(i)%freq-nfqso)
     if(d.lt.dmin) then
        i0=i
        dmin=d
     endif
  enddo

  if(dmin.lt.float(ntol)) then
     cb=ca(i0)
     do i=i0,2,-1
        ca(i)=ca(i-1)
     enddo
     ca(1)=cb
  endif

  return
end subroutine fqso_first

program ft8code

! Provides examples of message packing, LDPC(174,91) encoding, bit and
! symbol ordering, and other details of the FT8 protocol.

  use packjt77
  include 'ft8_params.f90'               !Set various constants
  include 'ft8_testmsg.f90'
  parameter (NWAVE=NN*NSPS)
 
  character*37 msg,msgsent
  character*9 comment
  character bad*1,msgtype*18
  integer itone(NN)
  integer*1 msgbits(77),codeword(174)
  logical short

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.1 .and. nargs.ne.3) then
     print*
     print*,'Program ft8code:  Provides examples of message packing, ',       &
          'LDPC(174,91) encoding,'
     print*,'bit and symbol ordering, and other details of the FT8 protocol.'
     print*
     print*,'Usage: ft8code [-c grid] "message"  # Results for specified message'
     print*,'       ft8code -T                   # Examples of all message types'
     print*,'       ft8code -t                   # Short format examples'
     go to 999
  endif

  call getarg(1,msg)                    !Message to be transmitted
  short=.false.
  if(len(trim(msg)).eq.2 .and. (msg(1:2).eq.'-T' .or. msg(1:2).eq.'-t')) then
     nmsg=NTEST
     short=msg(1:2).eq.'-t'
  else
     call fmtmsg(msg,iz)          !To upper case; collapse multiple blanks
     nmsg=1
  endif

  if(.not.short) write(*,1010)
1010 format(4x,'Message',31x,'Decoded',29x,'Err i3.n3'/100('-')) 

  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)
     
! Generate msgsent, msgbits, and itone
     i3=-1
     n3=-1
     call genft8(msg,i3,n3,msgsent,msgbits,itone)
     call encode174_91(msgbits,codeword)
     msgtype=""
     if(i3.eq.0) then
        if(n3.eq.0) msgtype="Free text"
        if(n3.eq.1) msgtype="DXpedition mode"
        if(n3.eq.2) msgtype="EU VHF Contest"
        if(n3.eq.3) msgtype="ARRL Field Day"
        if(n3.eq.4) msgtype="ARRL Field Day"
        if(n3.eq.5) msgtype="Telemetry"
        if(n3.ge.6) msgtype="Undefined type"
     endif 
     if(i3.eq.1) msgtype="Standard msg"
     if(i3.eq.2) msgtype="EU VHF Contest"
     if(i3.eq.3) msgtype="ARRL RTTY Roundup"
     if(i3.eq.4) msgtype="Nonstandard call"
     if(i3.eq.5) msgtype="EU VHF Contest"
     if(i3.ge.6) msgtype="Undefined type"
     if(i3.ge.1) n3=-1
     bad=" "
     comment='         '
     if(msg.ne.msgsent) bad="*"
     if(short) then
        if(n3.ge.0) then
           write(*,1020) i3,n3,msg,bad,msgtype
1020       format(i1,'.',i1,2x,a37,1x,a1,1x,a18)
        else
           write(*,1022) i3,msg,bad,msgtype
1022       format(i1,'.',3x,a37,1x,a1,1x,a18)
        endif
     else
        if(n3.ge.0) then
           write(*,1024) imsg,msg,msgsent,bad,i3,n3,msgtype,comment
1024       format(i2,'.',1x,a37,1x,a37,1x,a1,2x,i1,'.',i1,1x,a18,1x,a9)
        else
           write(*,1026) imsg,msg,msgsent,bad,i3,msgtype,comment
1026       format(i2,'.',1x,a37,1x,a37,1x,a1,2x,i1,'.',1x,1x,a18,1x,a9)
        endif
     endif
  enddo

  if(nmsg.eq.1) then
     write(*,1030) msgbits
1030 format(/'Source-encoded message, 77 bits: ',/77i1)
     write(*,1031) codeword(78:91)
1031 format(/'14-bit CRC: ',/14i1)
     write(*,1032) codeword(92:174)
1032 format(/'83 Parity bits: ',/83i1)     
     write(*,1034) itone
1034 format(/'Channel symbols (79 tones):'/                             &
          '  Sync ',14x,'Data',15x,'Sync',15x,'Data',15x,'Sync'/        &
           7i1,1x,29i1,1x,7i1,1x,29i1,1x,7i1)
  endif

999 end program ft8code

subroutine msgparservar(msg37,msg37_2)

  character msg37*37,msg37_2*37,call1*12,call2*12,call3*12,report*6

! ES1JA RR73; TA1BM <...> -22 
! ES1JA RR73; TA1BM <SX60RAAG> -22

  call1='            '; call2='            '; call3='            '; report='      '
  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
  ispc3=index(msg37((ispc2+1):),' ')+ispc2; ispc4=index(msg37((ispc3+1):),' ')+ispc3
  ispc5=index(msg37((ispc4+1):),' ')+ispc4
  if(ispc5.gt.20) then
    call1=msg37(1:ispc1-1); call2=msg37(ispc2+1:ispc3-1)
    if(msg37(ispc3+1:ispc3+2).eq.'<.') then
      call3='<...>'
    else
      call3=msg37(ispc3+1:ispc4-1)
    endif
    if(len_trim(call3).lt.11) then; report=msg37(ispc4+1:ispc5-1); else; report=msg37(ispc4+1:37); endif
! build standard messages
    msg37=trim(call1)//' RR73; '//trim(call2)//' '//trim(call3)//' '//trim(report)  !ft8md reformat msg37
    msg37_2=trim(call2)//' '//trim(call3)//' '//trim(report)
  endif

  return
end subroutine msgparservar

subroutine decode0(dd,ss,savg,nstandalone)

  use timer_module, only: timer
  parameter (NSMAX=60*96000)

  real*4 dd(4,NSMAX),ss(4,322,NFFT),savg(4,NFFT)
  real*8 fcenter
  integer hist(0:32768)
  logical ldecoded
  character mycall*12,hiscall*12,mygrid*6,hisgrid*6,datetime*20
  character mycall0*12,hiscall0*12,hisgrid0*6
  common/npar/fcenter,nutc,idphi,mousedf,mousefqso,nagain,                &
       ndepth,ndiskdat,neme,newdat,nfa,nfb,nfcal,nfshift,                 &
       mcall3,nkeep,ntol,nxant,nrxlog,nfsample,nxpol,nmode,               &
       ndop00,nsave,max_drift,nhsym,mycall,mygrid,hiscall,hisgrid,datetime
  common/early/nhsym1,nhsym2,ldecoded(32768)
  common/decodes/ndecodes
  data neme0/-99/,mcall3b/1/
  save

  call sec0(0,tquick)
  call timer('decode0 ',0)
  if(newdat.ne.0) then
     nz=96000*nhsym/5.3833
     hist=0
     do i=1,nz
        j1=min(abs(dd(1,i)),32768.0)
        hist(j1)=hist(j1)+1
        j2=min(abs(dd(2,i)),32768.0)
        hist(j2)=hist(j2)+1
        j3=min(abs(dd(3,i)),32768.0)
        hist(j3)=hist(j3)+1
        j4=min(abs(dd(4,i)),32768.0)
        hist(j4)=hist(j4)+1
     enddo
     m=0
     do i=0,32768
        m=m+hist(i)
        if(m.ge.2*nz) go to 10
     enddo
10   rmsdd=1.5*i
  endif
  ndphi=0
  if(iand(nrxlog,8).ne.0) ndphi=1

  if(mycall.ne.mycall0 .or. hiscall.ne.hiscall0 .or.         &
       hisgrid.ne.hisgrid0 .or. mcall3.ne.0 .or. neme.ne.neme0) mcall3b=1
      
  mycall0=mycall
  hiscall0=hiscall
  hisgrid0=hisgrid
  neme0=neme

  call timer('map65a  ',0)
  call map65a(dd,ss,savg,newdat,nutc,fcenter,ntol,idphi,nfa,nfb,           &
       mousedf,mousefqso,nagain,ndecdone,nfshift,ndphi,max_drift,          &
       nfcal,nkeep,mcall3b,nsum,nsave,nxant,mycall,mygrid,                 &
       neme,ndepth,nstandalone,hiscall,hisgrid,nhsym,nfsample,             &
       ndiskdat,nxpol,nmode,ndop00)
  call timer('map65a  ',1)
  call timer('decode0 ',1)

  call sec0(1,tdec)
  if(nhsym.eq.nhsym1) write(*,1010) nsum,nsave,nstandalone,nhsym,tdec
1010 format('<EarlyFinished>',3i4,i6,f6.2)
  if(nhsym.eq.nhsym2) write(*,1012) nsum,nsave,nstandalone,nhsym,tdec,ndecodes
1012 format('<DecodeFinished>',3i4,i6,f6.2,i5)
  flush(6)

  return
end subroutine decode0

subroutine decode65a(dd,npts,newdat,nqd,f0,nflip,mode65,ntrials,     &
     naggressive,ndepth,ntol,mycall,hiscall,hisgrid,nQSOProgress,    &
     ljt65apon,bVHF,sync2,a,dt,nft,nspecial,qual,nhist,nsmo,decoded)

! Apply AFC corrections to a candidate JT65 signal, then decode it.

  use jt65_mod
  use timer_module, only: timer

  parameter (NMAX=60*12000)          !Samples per 60 s
  real*4  dd(NMAX)                   !92 MB: raw data from Linrad timf2
  complex cx(NMAX/8)                 !Data at 1378.125 sps
  complex cx1(NMAX/8)                !Data at 1378.125 sps, offset by 355.3 Hz
  complex c5x(NMAX/32)               !Data at 344.53125 Hz
  complex c5a(512)
  real s2(66,126)
  real a(5)
  logical bVHF,first,ljt65apon
  character decoded*22,decoded_best*22
  character mycall*12,hiscall*12,hisgrid*6
  character*27 cr
  data first/.true./,jjjmin/1000/,jjjmax/-1000/,cr/'(C) 2016, Joe Taylor - K1JT'/
  save

! Mix sync tone to baseband, low-pass filter, downsample to 1378.125 Hz
  call timer('filbig  ',0)
  call filbig(dd,npts,f0,newdat,cx,n5,sq0)
  if(mode65.eq.4) call filbig(dd,npts,f0+355.297852,newdat,cx1,n5,sq0)
  call timer('filbig  ',1)
! NB: cx has sample rate 12000*77125/672000 = 1378.125 Hz

! Check for a shorthand message
  if(bVHF .and. mode65.ne.101) then
     call sh65(cx,n5,mode65,ntol,xdf,nspecial,sync2)
     if(nspecial.gt.0) then
        a=0.
        a(1)=xdf
        nflip=0
     endif
  endif
  if(nflip.eq.0) go to 900

! Find best DF, drift, curvature, and DT.  Start by downsampling to 344.53125 Hz
  call fil6521(cx,n5,c5x,n6)

  fsample=1378.125/4.

  call timer('afc65b  ',0)
! Best fit for DF, drift, and dt. fsample = 344.53125 S/s
  dtbest=dt
  call afc65b(c5x,n6,fsample,nflip,mode65,a,ccfbest,dtbest)
  call timer('afc65b  ',1)
  dtbest=dtbest+0.003628 !Remove decimation filter and coh. integrator delay
  dt=dtbest              !Return new, improved estimate of dt
  sync2=3.7e-4*ccfbest/sq0                    !Constant is empirical 
  if(mode65.eq.4) cx=cx1

! Apply AFC corrections to the time-domain signal
! Now we are back to using the 1378.125 Hz sample rate, enough to 
! accommodate the full JT65C bandwidth.
  a(3)=0
  call twkfreq65(cx,n5,a)

! Compute spectrum for each symbol.
  nsym=126
  nfft=512
  df=1378.125/nfft
  j=int(dtbest*1378.125)

  c5a=cmplx(0.0,0.0)
  do k=1,nsym
     do i=1,nfft
        j=j+1
        if(j.ge.1 .and. j.le.NMAX/8) then
           c5a(i)=cx(j)
        else
           c5a(i)=0.
        endif
     enddo
     call four2a(c5a,nfft,1,1,1)
     do i=1,512
        jj=i
        if(i.gt.256) jj=i-512
        s1(jj,k)=real(c5a(i))**2 + aimag(c5a(i))**2
     enddo
  enddo

  call timer('dec65b  ',0)
  qualbest=0.
  nftbest=0
  qual0=-1.e30
  minsmo=0
  maxsmo=0
  if(mode65.ge.2 .and. mode65.ne.101) then
     minsmo=nint(width/df)-1
     maxsmo=2*nint(width/df)
  endif
  nn=0
  do ismo=minsmo,maxsmo
     if(ismo.gt.0) then
        do j=1,126
           call smo121(s1(-255,j),512)
           if(j.eq.1) nn=nn+1
           if(nn.ge.4) then
              call smo121(s1(-255,j),512)
              if(j.eq.1) nn=nn+1
           endif
        enddo
     endif

     do i=1,66
        jj=i
        if(mode65.eq.2) jj=2*i-1
        if(mode65.eq.4) then
           ff=4*(i-1)*df - 355.297852
           jj=nint(ff/df)+1
        endif
        s2(i,1:126)=s1(jj,1:126)
     enddo
     nadd=ismo  !### ??? ###
     call decode65b(s2,nflip,nadd,mode65,ntrials,naggressive,ndepth,        &
          mycall,hiscall,hisgrid,nQSOProgress,ljt65apon,nqd,nft,qual,       &
          nhist,decoded)
     if(nft.eq.1) then
        nsmo=ismo
        param(9)=nsmo
        nsum=1
        exit
     else if(nft.eq.2) then
        if(qual.gt.qualbest) then
           decoded_best=decoded
           qualbest=qual
           nnbest=nn
           nsmobest=ismo
           nftbest=nft
        endif
     endif
     if(qual.lt.qual0) exit
     qual0=qual
  enddo

  if(nftbest.eq.2) then
     decoded=decoded_best
     qual=qualbest
     nsmo=nsmobest
     param(9)=nsmo
     nn=nnbest
     nft=nftbest
  endif

  call timer('dec65b  ',1)

900 return
end subroutine decode65a

subroutine symspec(shared_data,k,TRperiod,nsps,ingain,bLowSidelobes,    &
     nminw,pxdb,s,df3,ihsym,npts8,pxdbmax,npct)

! Input:
!  k              pointer to the most recent new data
!  TRperiod       T/R sequence length, seconds
!  nsps           samples per symbol, at 12000 Hz
!  bLowSidelobes  true to use windowed FFTs
!  ndiskdat       0/1 to indicate if data from disk

! Output:
!  pxdb      raw power (0-90 dB)
!  s()       current spectrum for waterfall display
!  ihsym     index number of this half-symbol (1-184) for 60 s modes

! jt9com
!  ss()      JT9 symbol spectra at half-symbol steps
!  savg()    average spectra for waterfall display

  use, intrinsic :: iso_c_binding, only: c_int, c_short, c_float, c_char
  include 'jt9com.f90'

  type(dec_data) :: shared_data
  real*8 TRperiod
  real*4 w3(MAXFFT3)
  real*4 s(NSMAX)
  real*4 ssum(NSMAX)
  real*4 xc(0:MAXFFT3-1)
  real*4 tmp(NSMAX)
  complex cx(0:MAXFFT3/2)
  integer nch(7)
  logical*1 bLowSidelobes

  common/spectra/syellow(NSMAX),ref(0:3456),filter(0:3456)
  data k0/99999999/,nfft3z/0/
  data nch/1,2,4,9,18,36,72/
  equivalence (xc,cx)
  save

  if(TRperiod+npct.eq.-999.9) stop             !Silence compiler warning
  nfft3=16384                                  !df=12000.0/16384 = 0.732422
  jstep=nsps/2                                 !Step size = half-symbol in id2()
  if(k.gt.NMAX) go to 900
  if(k.lt.2048) then                !(2048 was nfft3)  (Any need for this ???)
     ihsym=0
     go to 900                                 !Wait for enough samples to start
  endif

  if(nfft3.ne.nfft3z) then
! Compute new window
     pi=4.0*atan(1.0)
     w3=0
     call nuttal_window(w3,nfft3)
     nfft3z=nfft3
  endif

  if(k.lt.k0) then                             !Start a new data block
     k0=0
     ja=0
     ssum=0.
     ihsym=0
     if(.not. shared_data%params%ndiskdat) shared_data%id2(k+1:)=0   !Needed to prevent "ghosts". Not sure why.
  endif
  gain=10.0**(0.1*ingain)
  sq=0.
  pxmax=0.;

  do i=k0+1,k
     if(k0.eq.0 .and. i.le.10) cycle
     x1=shared_data%id2(i)
     if (abs(x1).gt.pxmax) pxmax = abs(x1);
     sq=sq + x1*x1
  enddo
  pxdb = 0.
  if(sq.gt.0.0) pxdb=10*log10(sq/(k-k0))
  pxdbmax=0.
  if(pxmax.gt.0) pxdbmax = 20*log10(pxmax)

  k0=k
  ja=ja+jstep                         !Index of first sample

  fac0=0.1
  do i=0,nfft3-1                      !Copy data into cx
     j=ja+i-(nfft3-1)
     xc(i)=0.
     if(j.ge.1 .and.j.le.NMAX) xc(i)=fac0*shared_data%id2(j)
  enddo
  ihsym=ihsym+1

  if(bLowSidelobes) xc(0:nfft3-1)=w3(1:nfft3)*xc(0:nfft3-1)    !Apply window 
  call four2a(xc,nfft3,1,-1,0)        !Real-to-complex FFT

  df3=12000.0/nfft3                   !JT9: 0.732 Hz = 0.42 * tone spacing
  iz=min(NSMAX,nint(5000.0/df3))
  fac=(1.0/nfft3)**2
  do i=1,iz
     j=i-1
     if(j.lt.0) j=j+nfft3
     sx=fac*(real(cx(j))**2 + aimag(cx(j))**2)
     if(ihsym.le.184) shared_data%ss(ihsym,i)=sx
     ssum(i)=ssum(i) + sx
     s(i)=1000.0*gain*sx
  enddo

  shared_data%savg=ssum/ihsym

  if(mod(ihsym,10).eq.0) then
     mode4=nch(nminw+1)
     nsmo=min(10*mode4,150)
     nsmo=4*nsmo
     call flat1(shared_data%savg,iz,nsmo,syellow)
     if(mode4.ge.2) call smo(syellow,iz,tmp,mode4)
     if(mode4.ge.2) call smo(syellow,iz,tmp,mode4)
     syellow(1:250)=0.
     ia=500./df3
     ib=2700.0/df3
     smin=minval(syellow(ia:ib))
     smax=maxval(syellow(1:iz))
     syellow=(50.0/(smax-smin))*(syellow-smin)
     where(syellow<0) syellow=0.
  endif

900 npts8=k/8

  return
end subroutine symspec

module mulmod64_interface
  use iso_c_binding
  implicit none

  interface
    function mulmod64(a, b) bind(C, name="mulmod64")
      import :: c_int64_t
      implicit none
      integer(c_int64_t), value :: a, b
      integer(c_int64_t) :: mulmod64
    end function mulmod64
  end interface

end module mulmod64_interface

subroutine sh65(cx,n5,mode65,ntol,xdf,nspecial,snrdb)
  parameter(NFFT=2048,NH=NFFT/2)
  complex cx(n5)               !Centered on nfqso, sample rate 1378.125
  complex c(0:NFFT-1)
  real s(-NH+1:NH)
  real ss(-NH+1:NH,16)
  real sigmax(16)
  integer ipk(16)

  ss=0.

  jstep=NFFT/8
  nblks=272
  ia=-jstep+1
  do iblk=1,nblks
     n=mod(iblk-1,16) + 1
     ia=ia+jstep
     ib=ia+NFFT-1
     c=cx(ia:ib)
     call four2a(c,nfft,1,1,1)            !c2c FFT
     do i=0,NFFT-1
        j=i
        if(j.gt.NH) j=j-NFFT
        ss(j,n)=ss(j,n) + real(c(i))**2 + aimag(c(i))**2
     enddo
  enddo

  s=1.e-5*s
  ss=1.e-5*ss
  df=1378.1285/NFFT
  nfac=40*mode65
  dtstep=0.25/df

  do i=1,2*mode65
     call smo121(ss,16*NFFT)
  enddo

!  do i=-NH+1,NH
!     write(72,3072) i*df,(ss(i,j),j=1,16)
!3072 format(17f7.1)
!  enddo

! Define freq range to be searched. Upper tone is at sync freq  + 4*nfac*df Hz
  fa=-ntol
  fb=ntol
  ia2=max(-NH+1,nint(fa/df))
  ib2=min(NH,nint(fb/df + 4.1*nfac))

! Find strongest line in each of the 16 phases
  sbest=0.
  snrbest=0.
  nbest=1
  ipk=0
  do n=1,16
     sigmax(n)=0.
     do i=ia2,ib2
        sig=ss(i,n)
        if(sig.ge.sigmax(n)) then
           ipk(n)=i
           sigmax(n)=sig
           if(sig.ge.sbest) then
              sbest=sig
              nbest=n
           endif
        endif
     enddo
  enddo
  n2best=nbest+8
  if(n2best.gt.16) n2best=nbest-8
  xdf=min(ipk(nbest),ipk(n2best))*df
  nspecial=0
  if(abs(xdf).le.ntol) then
     idiff=abs(ipk(nbest)-ipk(n2best))
     xk=float(idiff)/nfac
     k=nint(xk)
     iderr=nint((xk-k)*nfac)
!     maxerr=nint(0.008*abs(idiff) + 0.51)
     maxerr=nint(0.02*abs(idiff) + 0.51)     !### Better test ??? ###
!     write(71,3001) nbest,n2best,idiff,iderr,maxerr,k,      &
!          ipk(nbest)*df,ipk(n2best)*df,sbest
!3001 format(6i4,2f7.1,f7.2)
     if(abs(iderr).le.maxerr .and. k.ge.2 .and. k.le.4) nspecial=k
     snrdb=-30.0
     if(nspecial.gt.0) then
        call sh65snr(ss(ia2,nbest),ib2-ia2+1,snr1)
        call sh65snr(ss(ia2,n2best),ib2-ia2+1,snr2)
        snr=0.5*(snr1+snr2)
        snrdb=db(snr) - db(2500.0/df) - db(sqrt(nblks/4.0)) + 8.0
     endif
     if(snr1.lt.4.0 .or. snr2.lt.4.0 .or. snr.lt.5.0) nspecial=0
  endif

  return
end subroutine sh65

subroutine encode174_91var(message77,codeword)
!
! Add a 14-bit CRC to a 77-bit message and return a 174-bit codeword
!
use, intrinsic :: iso_c_binding
use iso_c_binding, only: c_loc,c_size_t
use crc

integer, parameter:: N=174, K=91, M=N-K
character*91 tmpchar
integer*1 codeword(N)
integer*1 gen(M,K)
integer*1 message77(77),message(K)
integer*1 pchecks(M)
integer*1, target :: i1MsgBytes(12)
include '/lib/ft8/ldpc_174_91_c_generator.f90'
logical first
data first/.true./
save first,gen
!$omp threadprivate(first,gen)

if( first ) then ! fill the generator matrix
  first=.false.
  gen=0
  do i=1,M
    do j=1,23
      read(g(i)(j:j),"(Z1)") istr
        ibmax=4
        if(j.eq.23) ibmax=3 
        do jj=1, ibmax 
          icol=(j-1)*4+jj
          if( btest(istr,4-jj) ) gen(i,icol)=1
        enddo
    enddo
  enddo
endif

! Add 14-bit CRC to form 91-bit message+CRC14
write(tmpchar,'(77i1)') message77
tmpchar(78:80)='000'
i1MsgBytes=0
read(tmpchar,'(10b8)') i1MsgBytes(1:10)
ncrc14 = crc14 (c_loc (i1MsgBytes), 12)
write(tmpchar(78:91),'(b14)') ncrc14
read(tmpchar,'(91i1)') message

do i=1,M
  nsum=0
  do j=1,K 
    nsum=nsum+message(j)*gen(i,j)
  enddo
  pchecks(i)=mod(nsum,2)
enddo

codeword(1:K)=message
codeword(K+1:N)=pchecks

return
end subroutine encode174_91var

subroutine decode9w(nfqso,ntol,nsubmode,ss,id2,sync,nsnr,xdt1,f0,decoded)

! Decode a weak signal in a wide/slow JT9 submode.

  parameter (NSMAX=6827,NZMAX=60*12000)
  real ss(184,NSMAX)                     !Symbol spectra at 1/2-symbol steps
  real ccfred(NSMAX)                     !Best sync vs frequency
  real ccfblue(-9:18)                    !Sync vs time at best frequency
  real a(5)                              !Fitted Lorentzian params
  integer*2 id2(NZMAX)                   !Raw 16-bit data
  integer*1 i1SoftSymbols(207)           !Binary soft symbols
  character*22 decoded                   !Decoded message

  df=12000.0/16384.0                     !Bin spacing in ss()
  nsps=6912                              !Samples per 9-FSK symbol
  tstep=nsps*0.5/12000.0                 !Half-symbol duration
  npts=52*12000
  limit=10000                            !Fano timeout parameter

  ia=max(1,nint((nfqso-ntol)/df))        !Start frequency bin
  ib=min(NSMAX,nint((nfqso+ntol)/df))    !End frequency bin
  lag1=-int(2.5/tstep + 0.9999)          !Start lag
  lag2=int(5.0/tstep + 0.9999)           !End lag
  nhsym=184                              !Number of half-symbols

! First sync pass finds approximate Doppler spread; second pass does a
! good Lorentzian fit to determine frequency f0.
  do iter=1,2
     nadd=3
     if(iter.eq.2) nadd=2*nint(0.375*a(4)) + 1
     call sync9w(ss,nhsym,lag1,lag2,ia,ib,ccfred,ccfblue,ipk,lagpk,nadd)
     s=0.
     sq=0.
     ns=0
     do i=-9,18
        if(abs(i-lagpk).gt.3) then
           s=s+ccfblue(i)
           sq=sq+ccfblue(i)**2
           ns=ns+1
        endif
     enddo
     base=s/ns
     rms=sqrt(sq/ns - base**2)
     sync=(ccfblue(lagpk)-base)/rms
     xdt0=lagpk*tstep
     call lorentzian(ccfred(ia),ib-ia+1,a)
     f0=(ia+a(3))*df
  enddo
  ccfblue=(ccfblue-base)/rms

  call softsym9w(id2,npts,xdt0,f0,a(4)*df,nsubmode,xdt1-1.05,snrdb,i1softsymbols)
  nsnr=nint(snrdb)
  call jt9fano(i1softsymbols,limit,nlim,decoded)

!###
!  do i=-9,18
!     write(81,3081) i,ccfblue(i)
!3081 format(i3,f10.3)
!  enddo
!  do i=1,NSMAX
!     write(82,3082) i*df,ccfred(i)
!3082 format(f10.1,e12.3)
!  enddo
!###

  return
end subroutine decode9w

subroutine ft8_downsample(dd,newdat,f0,c1)

! Downconvert to complex data sampled at 200 Hz ==> 32 samples/symbol

  parameter (NMAX=15*12000,NSPS=1920)
  parameter (NFFT1=192000,NFFT2=3200)      !192000/60 = 3200
  
  logical newdat,first
  complex c1(0:NFFT2-1)
  complex cx(0:NFFT1/2)
  real dd(NMAX),x(NFFT1),taper(0:100)
  equivalence (x,cx)
  data first/.true./
  save cx,first,taper

  if(first) then
     pi=4.0*atan(1.0)
     do i=0,100
       taper(i)=0.5*(1.0+cos(i*pi/100))
     enddo
     first=.false.
  endif
  if(newdat) then
! Data in dd have changed, recompute the long FFT
     x(1:NMAX)=dd
     x(NMAX+1:NFFT1)=0.                       !Zero-pad the x array
     call four2a(cx,NFFT1,1,-1,0)             !r2c FFT to freq domain
     newdat=.false.
  endif

  df=12000.0/NFFT1
  baud=12000.0/NSPS
  i0=nint(f0/df)
  ft=f0+8.5*baud
  it=min(nint(ft/df),NFFT1/2)
  fb=f0-1.5*baud
  ib=max(1,nint(fb/df))
  k=0
  c1=0.
  do i=ib,it
   c1(k)=cx(i)
   k=k+1
  enddo
  c1(0:100)=c1(0:100)*taper(100:0:-1)
  c1(k-1-100:k-1)=c1(k-1-100:k-1)*taper
  c1=cshift(c1,i0-ib)
  call four2a(c1,NFFT2,1,1,1)            !c2c FFT back to time domain
  fac=1.0/sqrt(float(NFFT1)*NFFT2)
  c1=fac*c1

  return
end subroutine ft8_downsample

! qmap_timer_init.f90 — bind(C) entry point so the QMAP main() can
! enable K1JT's existing decoder timing instrumentation. Without this,
! the `call timer('fftbig  ',0/1)` etc. calls strewn across qmapa.f90,
! q65c.f90, fftbig.f90, decode0.f90 all route to null_timer and the
! data is dropped on the floor.
!
! Once init_timer() is called with a path, every `call timer(...)`
! accumulates per-stage CPU time, and q65c.f90:105's `call timer(
! 'decode0 ',101)` (k=101 triggers dump-and-reset) writes one block
! per decoder cycle to that file. Format is K1JT's own table:
!
!   Name                 Time  Frac     dTime dFrac    Calls
!   ----------------------------------------------------------
!     decode0           0.183  1.00     0.001  0.01        1
!       qmapa           0.182  1.00     0.012  0.07        1
!         get_cand      0.024  0.13     0.024  0.13        1
!         fftbig        0.135  0.74     0.001  0.01        1
!         q65b          0.011  0.06     0.011  0.06        4
!
! That tells us where the 6 s decoder cost goes (fftbig vs candidate
! processing) so we know what to optimise if we bust the TR-60 budget.

subroutine qmap_init_timer_c(path_cstr) bind(C, name="qmap_init_timer_c")
  use, intrinsic :: iso_c_binding, only: c_char
  use timer_impl, only: init_timer
  implicit none
  character(c_char), intent(in) :: path_cstr(*)
  character(len=512) :: path
  integer :: i

  ! Decode the C string up to the NUL terminator (or 512 B max).
  path = ' '
  do i = 1, 512
    if (path_cstr(i) == achar(0)) exit
    path(i:i) = path_cstr(i)
  end do

  if (i > 1) then
    call init_timer(path(1:i-1))
  else
    call init_timer("timer.out")
  end if
end subroutine qmap_init_timer_c

subroutine rfile3a(infile,ibuf,n,fcenter,ierr)

  character*(*) infile
  integer*8 ibuf(n)
  real*8 fcenter

  open(10,file=infile,access='stream',status='old',err=998)
  read(10,end=998) (ibuf(i),i=1,n/8),fcenter
  ierr=0
  go to 999
998 ierr=1002
999 close(10)
  return
end subroutine rfile3a

C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER1(NRECL,KSIZE,NRFILE,NAMFIL)
C
C++++++++++++++++++++++++
C
C   Version 1.0 uses the INQUIRE statement to find out the the record length 
C   of the direct access file before opening it.  This procedure is non-standard, 
C   but seems to work for VAX machines. 
C
C  THE SUBROUTINE ALSO SETS THE VALUES OF  NRECL, NRFILE, AND NAMFIL.

C  *****************************************************************
C  *****************************************************************
C
C  THE PARAMETERS NAMFIL, NRECL, AND NRFILE ARE TO BE SET BY THE USER
C
C  *****************************************************************

C  NAMFIL IS THE EXTERNAL NAME OF THE BINARY EPHEMERIS FILE

      CHARACTER*256  NAMFIL

c      NAMFIL='JPLEPH'

C  *****************************************************************

C  NRECL=1 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN S.P. WORDS
C  NRECL=4 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN BYTES
C  (for a VAX, it is probably 1)
C
      NRECL=4

C  *****************************************************************

C  NRFILE IS THE INTERNAL UNIT NUMBER USED FOR THE EPHEMERIS FILE

c      NRFILE=12

C  *****************************************************************

C   FIND THE RECORD SIZE USING THE INQUIRE STATEMENT  


c      IRECSZ=0

      INQUIRE(FILE=NAMFIL,RECL=IRECSZ)

C IF 'INQUIRE' DOES NOT WORK, USUALLY IRECSZ WILL BE LEFT AT 0 

      IF(IRECSZ .LE. 0) write(*,*)
     . ' INQUIRE STATEMENT PROBABLY DID NOT WORK'

      KSIZE=IRECSZ/NRECL
      if(nrfile.eq.-99) stop              !silence compiler warning

      RETURN

      END
C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER2(NRECL,KSIZE,NRFILE,NAMFIL)
C
C++++++++++++++++++++++++
C  THIS SUBROUTINE OPENS THE FILE, 'NAMFIL', WITH A PHONY RECORD LENGTH, READS 
C  THE FIRST RECORD, AND USES THE INFO TO COMPUTE KSIZE, THE NUMBER OF SINGLE 
C  PRECISION WORDS IN A RECORD.  
C
C  THE SUBROUTINE ALSO SETS THE VALUES OF  NRECL, NRFILE, AND NAMFIL.

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      SAVE

      INTEGER OLDMAX
      PARAMETER (OLDMAX = 400)
      INTEGER NMAX
      PARAMETER (NMAX = 1000)
      CHARACTER*6 TTL(14,3),CNAM(NMAX)
      CHARACTER*256 NAMFIL,jpleph_file_name
      DIMENSION SS(3)
      INTEGER IPT(3,13)
      common/jplcom/jpleph_file_name

C  *****************************************************************
C  *****************************************************************
C
C  THE PARAMETERS NRECL, NRFILE, AND NAMFIL ARE TO BE SET BY THE USER
C
C  *****************************************************************

C  NRECL=1 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN S.P. WORDS
C  NRECL=4 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN BYTES
C  (for UNIX, it is probably 4)
C
      NRECL=4

C  NRFILE IS THE INTERNAL UNIT NUMBER USED FOR THE EPHEMERIS FILE

      NRFILE=12

C  NAMFIL IS THE EXTERNAL NAME OF THE BINARY EPHEMERIS FILE

!      NAMFIL='JPLEPH' 
      NAMFIL=jpleph_file_name

C  *****************************************************************
C  *****************************************************************

C  **  OPEN THE DIRECT-ACCESS FILE AND GET THE POINTERS IN ORDER TO 
C  **  DETERMINE THE SIZE OF THE EPHEMERIS RECORD

      MRECL=NRECL*1000

        OPEN(NRFILE,
     *       FILE=NAMFIL,
     *       ACCESS='DIRECT',
     *       FORM='UNFORMATTED',
     *       RECL=MRECL,
     *       STATUS='OLD')

      READ(NRFILE,REC=1)TTL,(CNAM(K),K=1,OLDMAX),SS,NCON,AU,EMRAT,
     & ((IPT(I,J),I=1,3),J=1,12),NUMDE,(IPT(I,13),I=1,3)

      CLOSE(NRFILE)

C  FIND THE NUMBER OF EPHEMERIS COEFFICIENTS FROM THE POINTERS

      KMX = 0
      KHI = 0

      DO I = 1,13
         IF (IPT(1,I) .GT. KMX) THEN
            KMX = IPT(1,I)
            KHI = I
         ENDIF
      ENDDO

      ND = 3
      IF (KHI .EQ. 12) ND=2

      KSIZE = 2*(IPT(1,KHI)+ND*IPT(2,KHI)*IPT(3,KHI)-1)

      RETURN

      END
C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER3(NRECL,KSIZE,NRFILE,NAMFIL)
C
C++++++++++++++++++++++++
C
C  THE SUBROUTINE SETS THE VALUES OF  NRECL, KSIZE, NRFILE, AND NAMFIL.

      SAVE
      CHARACTER*256 NAMFIL,jpleph_file_name
      common/jplcom/jpleph_file_name

C  *****************************************************************
C  *****************************************************************
C
C  THE PARAMETERS NRECL, NRFILE, AND NAMFIL ARE TO BE SET BY THE USER

C  *****************************************************************

C  NRECL=1 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN S.P. WORDS
C  NRECL=4 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN BYTES

       NRECL=4

C  *****************************************************************

C  NRFILE IS THE INTERNAL UNIT NUMBER USED FOR THE EPHEMERIS FILE (DEFAULT: 12)

      NRFILE=12

C  *****************************************************************

C  NAMFIL IS THE EXTERNAL NAME OF THE BINARY EPHEMERIS FILE

!      NAMFIL='JPLEPH'
      NAMFIL=jpleph_file_name

C  *****************************************************************

C  KSIZE must be set by the user according to the ephemeris to be read

C  For  de200, set KSIZE to 1652
C  For  de405, set KSIZE to 2036
C  For  de406, set KSIZE to 1456
C  For  de414, set KSIZE to 2036
C  For  de418, set KSIZE to 2036
C  For  de421, set KSIZE to 2036
C  For  de422, set KSIZE to 2036
C  For  de423, set KSIZE to 2036
C  For  de424, set KSIZE to 2036
C  For  de430, set KSIZE to 2036

      KSIZE = 2036

C  *******************************************************************

      RETURN

      END
C++++++++++++++++++++++++++
C
      SUBROUTINE PLEPH ( ET, NTARG, NCENT, RRD )
C
C++++++++++++++++++++++++++
C  NOTE : Over the years, different versions of PLEPH have had a fifth argument:
C  sometimes, an error return statement number; sometimes, a logical denoting
C  whether or not the requested date is covered by the ephemeris.  We apologize
C  for this inconsistency; in this present version, we use only the four necessary 
C  arguments and do the testing outside of the subroutine.
C
C     THIS SUBROUTINE READS THE JPL PLANETARY EPHEMERIS
C     AND GIVES THE POSITION AND VELOCITY OF THE POINT 'NTARG'
C     WITH RESPECT TO 'NCENT'.
C
C     CALLING SEQUENCE PARAMETERS:
C
C       ET = D.P. JULIAN EPHEMERIS DATE AT WHICH INTERPOLATION
C            IS WANTED.
C
C       ** NOTE THE ENTRY DPLEPH FOR A DOUBLY-DIMENSIONED TIME **
C          THE REASON FOR THIS OPTION IS DISCUSSED IN THE 
C          SUBROUTINE STATE
C
C     NTARG = INTEGER NUMBER OF 'TARGET' POINT.
C
C     NCENT = INTEGER NUMBER OF CENTER POINT.
C
C            THE NUMBERING CONVENTION FOR 'NTARG' AND 'NCENT' IS:
C
C                1 = MERCURY           8 = NEPTUNE
C                2 = VENUS             9 = PLUTO
C                3 = EARTH            10 = MOON
C                4 = MARS             11 = SUN
C                5 = JUPITER          12 = SOLAR-SYSTEM BARYCENTER
C                6 = SATURN           13 = EARTH-MOON BARYCENTER
C                7 = URANUS           14 = NUTATIONS (LONGITUDE AND OBLIQ)
C                            15 = LIBRATIONS, IF ON EPH FILE
C
C             (IF NUTATIONS ARE WANTED, SET NTARG = 14. FOR LIBRATIONS,
C              SET NTARG = 15. SET NCENT=0.)
C
C      RRD = OUTPUT 6-WORD D.P. ARRAY CONTAINING POSITION AND VELOCITY
C            OF POINT 'NTARG' RELATIVE TO 'NCENT'. THE UNITS ARE AU AND
C            AU/DAY. FOR LIBRATIONS THE UNITS ARE RADIANS AND RADIANS
C            PER DAY. IN THE CASE OF NUTATIONS THE FIRST FOUR WORDS OF
C            RRD WILL BE SET TO NUTATIONS AND RATES, HAVING UNITS OF
C            RADIANS AND RADIANS/DAY.
C
C            The option is available to have the units in km and km/sec.
C            For this, set km=.true. in the STCOMX common block.
C

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INTEGER NMAX
      PARAMETER (NMAX = 1000)

      DIMENSION RRD(6),ET2Z(2),ET2(2),PV(6,13)
      DIMENSION PVST(6,11),PNUT(4)
      DIMENSION SS(3),CVAL(NMAX),PVSUN(6),ZIPS(2)
      DATA ZIPS/2*0.d0/

      LOGICAL BSAVE,KM,BARY
      LOGICAL FIRST
      DATA FIRST/.TRUE./

      INTEGER LIST(12),IPT(39),DENUM
      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,DENUM,NCON,IPT
      COMMON/STCOMX/KM,BARY,PVSUN

C     INITIALIZE ET2 FOR 'STATE' AND SET UP COMPONENT COUNT
C
      ET2(1)=ET
      ET2(2)=0.D0
      GO TO 11

C     ENTRY POINT 'DPLEPH' FOR DOUBLY-DIMENSIONED TIME ARGUMENT 
C          (SEE THE DISCUSSION IN THE SUBROUTINE STATE)

      ENTRY DPLEPH(ET2Z,NTARG,NCENT,RRD)

      ET2(1)=ET2Z(1)
      ET2(2)=ET2Z(2)

  11  IF(FIRST) CALL STATE(ZIPS,LIST,PVST,PNUT)
      FIRST=.FALSE.

      IF(NTARG .EQ. NCENT) RETURN

      DO I=1,12
        LIST(I)=0
      ENDDO

C     CHECK FOR NUTATION CALL

      IF(NTARG.NE.14) GO TO 97
        IF(IPT(35).GT.0) THEN
          LIST(11)=2
          CALL STATE(ET2,LIST,PVST,PNUT)
          DO I=1,4
            RRD(I)=PNUT(I)
          ENDDO
          RRD(5) = 0.d0
          RRD(6) = 0.d0
          RETURN
        ELSE
          DO I=1,4
            RRD(I)=0.d0
          ENDDO
          WRITE(6,297)
  297     FORMAT(' *****  NO NUTATIONS ON THE EPHEMERIS FILE  *****')
          STOP
        ENDIF

C     CHECK FOR LIBRATIONS

  97  CONTINUE
      DO I=1,6
        RRD(I)=0.d0
      ENDDO

      IF(NTARG.NE.15) GO TO 98
        IF(IPT(38).GT.0) THEN
          LIST(12)=2
          CALL STATE(ET2,LIST,PVST,PNUT)
          DO I=1,6
            RRD(I)=PVST(I,11)
          ENDDO
          RETURN
        ELSE
          WRITE(6,298)
  298     FORMAT(' *****  NO LIBRATIONS ON THE EPHEMERIS FILE  *****')
          STOP
        ENDIF

C       FORCE BARYCENTRIC OUTPUT BY 'STATE'

  98  BSAVE=BARY
      BARY=.TRUE.

C       SET UP PROPER ENTRIES IN 'LIST' ARRAY FOR STATE CALL

      DO I=1,2
        K=NTARG
        IF(I .EQ. 2) K=NCENT
        IF(K .LE. 10) LIST(K)=2
        IF(K .EQ. 10) LIST(3)=2
        IF(K .EQ. 3) LIST(10)=2
        IF(K .EQ. 13) LIST(3)=2
      ENDDO

C       MAKE CALL TO STATE

      CALL STATE(ET2,LIST,PVST,PNUT)

      DO I=1,10
        DO J = 1,6
          PV(J,I) = PVST(J,I)
        ENDDO
      ENDDO

      IF(NTARG .EQ. 11 .OR. NCENT .EQ. 11) THEN
      DO I=1,6
        PV(I,11)=PVSUN(I)
      ENDDO
      ENDIF

      IF(NTARG .EQ. 12 .OR. NCENT .EQ. 12) THEN
        DO I=1,6
          PV(I,12)=0.D0
        ENDDO
      ENDIF

      IF(NTARG .EQ. 13 .OR. NCENT .EQ. 13) THEN
        DO I=1,6
          PV(I,13) = PVST(I,3)
        ENDDO
      ENDIF

      IF(NTARG*NCENT .EQ. 30 .AND. NTARG+NCENT .EQ. 13) THEN
        DO I=1,6
          PV(I,3)=0.D0
        ENDDO
        GO TO 99
      ENDIF

      IF(LIST(3) .EQ. 2) THEN
        DO I=1,6
          PV(I,3)=PVST(I,3)-PVST(I,10)/(1.D0+EMRAT)
        ENDDO
      ENDIF

      IF(LIST(10) .EQ. 2) THEN
        DO I=1,6
          PV(I,10) = PV(I,3)+PVST(I,10)
        ENDDO
      ENDIF

  99  DO I=1,6
        RRD(I)=PV(I,NTARG)-PV(I,NCENT)
      ENDDO

      BARY=BSAVE

      RETURN
      END
C+++++++++++++++++++++++++++++++++
C
      SUBROUTINE INTERP(BUF,T,NCF,NCM,NA,IFL,PV)
C
C+++++++++++++++++++++++++++++++++
C
C     THIS SUBROUTINE DIFFERENTIATES AND INTERPOLATES A
C     SET OF CHEBYSHEV COEFFICIENTS TO GIVE POSITION AND VELOCITY
C
C     CALLING SEQUENCE PARAMETERS:
C
C       INPUT:
C
C         BUF   1ST LOCATION OF ARRAY OF D.P. CHEBYSHEV COEFFICIENTS OF POSITION
C
C           T   T(1) IS DP FRACTIONAL TIME IN INTERVAL COVERED BY
C               COEFFICIENTS AT WHICH INTERPOLATION IS WANTED
C               (0 .LE. T(1) .LE. 1).  T(2) IS DP LENGTH OF WHOLE
C               INTERVAL IN INPUT TIME UNITS.
C
C         NCF   # OF COEFFICIENTS PER COMPONENT
C
C         NCM   # OF COMPONENTS PER SET OF COEFFICIENTS
C
C          NA   # OF SETS OF COEFFICIENTS IN FULL ARRAY
C               (I.E., # OF SUB-INTERVALS IN FULL INTERVAL)
C
C          IFL  INTEGER FLAG: =1 FOR POSITIONS ONLY
C                             =2 FOR POS AND VEL
C
C
C       OUTPUT:
C
C         PV   INTERPOLATED QUANTITIES REQUESTED.  DIMENSION
C               EXPECTED IS PV(NCM,IFL), DP.
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      SAVE
C
      DOUBLE PRECISION BUF(NCF,NCM,*),T(2),PV(NCM,*),PC(18),VC(18)

C
      DATA NP/2/
      DATA NV/3/
      DATA TWOT/0.D0/
      DATA PC(1),PC(2)/1.D0,0.D0/
      DATA VC(2)/1.D0/
C
C       ENTRY POINT. GET CORRECT SUB-INTERVAL NUMBER FOR THIS SET
C       OF COEFFICIENTS AND THEN GET NORMALIZED CHEBYSHEV TIME
C       WITHIN THAT SUBINTERVAL.
C
      DNA=DBLE(NA)
      DT1=DINT(T(1))
      TEMP=DNA*T(1)
      L=IDINT(TEMP-DT1)+1

C         TC IS THE NORMALIZED CHEBYSHEV TIME (-1 .LE. TC .LE. 1)

      TC=2.D0*(DMOD(TEMP,1.D0)+DT1)-1.D0

C       CHECK TO SEE WHETHER CHEBYSHEV TIME HAS CHANGED,
C       AND COMPUTE NEW POLYNOMIAL VALUES IF IT HAS.
C       (THE ELEMENT PC(2) IS THE VALUE OF T1(TC) AND HENCE
C       CONTAINS THE VALUE OF TC ON THE PREVIOUS CALL.)

      IF(TC.NE.PC(2)) THEN
        NP=2
        NV=3
        PC(2)=TC
        TWOT=TC+TC
      ENDIF
C
C       BE SURE THAT AT LEAST 'NCF' POLYNOMIALS HAVE BEEN EVALUATED
C       AND ARE STORED IN THE ARRAY 'PC'.
C
      IF(NP.LT.NCF) THEN
        DO 1 I=NP+1,NCF
        PC(I)=TWOT*PC(I-1)-PC(I-2)
    1   CONTINUE
        NP=NCF
      ENDIF
C
C       INTERPOLATE TO GET POSITION FOR EACH COMPONENT
C
      DO 2 I=1,NCM
      PV(I,1)=0.D0
      DO 3 J=NCF,1,-1
      PV(I,1)=PV(I,1)+PC(J)*BUF(J,I,L)
    3 CONTINUE
    2 CONTINUE
      IF(IFL.LE.1) RETURN
C
C       IF VELOCITY INTERPOLATION IS WANTED, BE SURE ENOUGH
C       DERIVATIVE POLYNOMIALS HAVE BEEN GENERATED AND STORED.
C
      VFAC=(DNA+DNA)/T(2)
      VC(3)=TWOT+TWOT
      IF(NV.LT.NCF) THEN
        DO 4 I=NV+1,NCF
        VC(I)=TWOT*VC(I-1)+PC(I-1)+PC(I-1)-VC(I-2)
    4   CONTINUE
        NV=NCF
      ENDIF
C
C       INTERPOLATE TO GET VELOCITY FOR EACH COMPONENT
C
      DO 5 I=1,NCM
      PV(I,2)=0.D0
      DO 6 J=NCF,2,-1
      PV(I,2)=PV(I,2)+VC(J)*BUF(J,I,L)
    6 CONTINUE
      PV(I,2)=PV(I,2)*VFAC
    5 CONTINUE
C
      RETURN
C
      END

C+++++++++++++++++++++++++
C
      SUBROUTINE SPLIT(TT,FR)
C
C+++++++++++++++++++++++++
C
C     THIS SUBROUTINE BREAKS A D.P. NUMBER INTO A D.P. INTEGER
C     AND A D.P. FRACTIONAL PART.
C
C     CALLING SEQUENCE PARAMETERS:
C
C       TT = D.P. INPUT NUMBER
C
C       FR = D.P. 2-WORD OUTPUT ARRAY.
C            FR(1) CONTAINS INTEGER PART
C            FR(2) CONTAINS FRACTIONAL PART
C
C            FOR NEGATIVE INPUT NUMBERS, FR(1) CONTAINS THE NEXT
C            MORE NEGATIVE INTEGER; FR(2) CONTAINS A POSITIVE FRACTION.
C
C       CALLING SEQUENCE DECLARATIONS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION FR(2)

C       MAIN ENTRY -- GET INTEGER AND FRACTIONAL PARTS

      FR(1)=DINT(TT)
      FR(2)=TT-FR(1)

      IF(TT.GE.0.D0 .OR. FR(2).EQ.0.D0) RETURN

C       MAKE ADJUSTMENTS FOR NEGATIVE INPUT NUMBER

      FR(1)=FR(1)-1.D0
      FR(2)=FR(2)+1.D0

      RETURN

      END


C++++++++++++++++++++++++++++++++
C
      SUBROUTINE STATE(ET2,LIST,PV,PNUT)
C
C++++++++++++++++++++++++++++++++
C
C THIS SUBROUTINE READS AND INTERPOLATES THE JPL PLANETARY EPHEMERIS FILE
C
C     CALLING SEQUENCE PARAMETERS:
C
C     INPUT:
C
C         ET2   DP 2-WORD JULIAN EPHEMERIS EPOCH AT WHICH INTERPOLATION
C               IS WANTED.  ANY COMBINATION OF ET2(1)+ET2(2) WHICH FALLS
C               WITHIN THE TIME SPAN ON THE FILE IS A PERMISSIBLE EPOCH.
C
C                A. FOR EASE IN PROGRAMMING, THE USER MAY PUT THE
C                   ENTIRE EPOCH IN ET2(1) AND SET ET2(2)=0.
C
C                B. FOR MAXIMUM INTERPOLATION ACCURACY, SET ET2(1) =
C                   THE MOST RECENT MIDNIGHT AT OR BEFORE INTERPOLATION
C                   EPOCH AND SET ET2(2) = FRACTIONAL PART OF A DAY
C                   ELAPSED BETWEEN ET2(1) AND EPOCH.
C
C                C. AS AN ALTERNATIVE, IT MAY PROVE CONVENIENT TO SET
C                   ET2(1) = SOME FIXED EPOCH, SUCH AS START OF INTEGRATION,
C                   AND ET2(2) = ELAPSED INTERVAL BETWEEN THEN AND EPOCH.
C
C        LIST   12-WORD INTEGER ARRAY SPECIFYING WHAT INTERPOLATION
C               IS WANTED FOR EACH OF THE BODIES ON THE FILE.
C
C                         LIST(I)=0, NO INTERPOLATION FOR BODY I
C                                =1, POSITION ONLY
C                                =2, POSITION AND VELOCITY
C
C               THE DESIGNATION OF THE ASTRONOMICAL BODIES BY I IS:
C
C                         I = 1: MERCURY
C                           = 2: VENUS
C                           = 3: EARTH-MOON BARYCENTER
C                           = 4: MARS
C                           = 5: JUPITER
C                           = 6: SATURN
C                           = 7: URANUS
C                           = 8: NEPTUNE
C                           = 9: PLUTO
C                           =10: GEOCENTRIC MOON
C                           =11: NUTATIONS IN LONGITUDE AND OBLIQUITY
C                           =12: LUNAR LIBRATIONS (IF ON FILE)
C
C     OUTPUT:
C
C          PV   DP 6 X 11 ARRAY THAT WILL CONTAIN REQUESTED INTERPOLATED
C               QUANTITIES (OTHER THAN NUTATION, STOERD IN PNUT).  
C               THE BODY SPECIFIED BY LIST(I) WILL HAVE ITS
C               STATE IN THE ARRAY STARTING AT PV(1,I).  
C               (ON ANY GIVEN CALL, ONLY THOSE WORDS IN 'PV' WHICH ARE 
C                AFFECTED BY THE  FIRST 10 'LIST' ENTRIES, AND BY LIST(12)
C                IF LIBRATIONS ARE ON THE FILE, ARE SET.  
C                THE REST OF THE 'PV' ARRAYIS UNTOUCHED.)  
C               THE ORDER OF COMPONENTS STARTING IN PV(1,I) IS: X,Y,Z,DX,DY,DZ.
C
C               ALL OUTPUT VECTORS ARE REFERENCED TO THE EARTH MEAN
C               EQUATOR AND EQUINOX OF J2000 IF THE DE NUMBER IS 200 OR
C               GREATER; OF B1950 IF THE DE NUMBER IS LESS THAN 200. 
C
C               THE MOON STATE IS ALWAYS GEOCENTRIC; THE OTHER NINE STATES 
C               ARE EITHER HELIOCENTRIC OR SOLAR-SYSTEM BARYCENTRIC, 
C               DEPENDING ON THE SETTING OF COMMON FLAGS (SEE BELOW).
C
C               LUNAR LIBRATIONS, IF ON FILE, ARE PUT INTO PV(K,11) IF
C               LIST(12) IS 1 OR 2.
C
C         NUT   DP 4-WORD ARRAY THAT WILL CONTAIN NUTATIONS AND RATES,
C               DEPENDING ON THE SETTING OF LIST(11).  THE ORDER OF
C               QUANTITIES IN NUT IS:
C
C                        D PSI  (NUTATION IN LONGITUDE)
C                        D EPSILON (NUTATION IN OBLIQUITY)
C                        D PSI DOT
C                        D EPSILON DOT
C
C           *   STATEMENT # FOR ERROR RETURN, IN CASE OF EPOCH OUT OF
C               RANGE OR I/O ERRORS.
C
C     COMMON AREA STCOMX:
C
C          KM   LOGICAL FLAG DEFINING PHYSICAL UNITS OF THE OUTPUT
C               STATES. KM = .TRUE., KM AND KM/SEC
C                          = .FALSE., AU AND AU/DAY
C               DEFAULT VALUE = .FALSE.  (KM DETERMINES TIME UNIT
C               FOR NUTATIONS AND LIBRATIONS.  ANGLE UNIT IS ALWAYS RADIANS.)
C
C        BARY   LOGICAL FLAG DEFINING OUTPUT CENTER.
C               ONLY THE 9 PLANETS ARE AFFECTED.
C                        BARY = .TRUE. =\ CENTER IS SOLAR-SYSTEM BARYCENTER
C                             = .FALSE. =\ CENTER IS SUN
C               DEFAULT VALUE = .FALSE.
C
C       PVSUN   DP 6-WORD ARRAY CONTAINING THE BARYCENTRIC POSITION AND
C               VELOCITY OF THE SUN.
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      SAVE

      INTEGER OLDMAX
      PARAMETER ( OLDMAX = 400)
      INTEGER NMAX
      PARAMETER ( NMAX = 1000)

      DIMENSION ET2(2),PV(6,11),PNUT(4),T(2),PJD(4),BUF(1500),
     . SS(3),CVAL(NMAX),PVSUN(6)

      INTEGER LIST(12),IPT(3,13)

      LOGICAL FIRST
      DATA FIRST/.TRUE./

      CHARACTER*6 TTL(14,3),CNAM(NMAX)
      CHARACTER*256 NAMFIL

      LOGICAL KM,BARY

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,NUMDE,NCON,IPT
      COMMON/CHRHDR/CNAM,TTL
      COMMON/STCOMX/KM,BARY,PVSUN

C
C       ENTRY POINT - 1ST TIME IN, GET POINTER DATA, ETC., FROM EPH FILE
C
      IF(FIRST) THEN
        FIRST=.FALSE.

C ************************************************************************
C ************************************************************************

C THE USER MUST SELECT ONE OF THE FOLLOWING BY DELETING THE 'C' IN COLUMN 1

C ************************************************************************

C        CALL FSIZER1(NRECL,KSIZE,NRFILE,NAMFIL)
C        CALL FSIZER2(NRECL,KSIZE,NRFILE,NAMFIL)
        CALL FSIZER3(NRECL,KSIZE,NRFILE,NAMFIL)

      IF(NRECL .EQ. 0) WRITE(*,*)'  ***** FSIZER IS NOT WORKING *****'

C ************************************************************************
C ************************************************************************

      IRECSZ=NRECL*KSIZE
      NCOEFFS=KSIZE/2

        OPEN(NRFILE,
     *       FILE=NAMFIL,
     *       ACCESS='DIRECT',
     *       FORM='UNFORMATTED',
     *       RECL=IRECSZ,
     *       STATUS='OLD')

      READ(NRFILE,REC=1)TTL,(CNAM(K),K=1,OLDMAX),SS,NCON,AU,EMRAT,
     & ((IPT(I,J),I=1,3),J=1,12),NUMDE,(IPT(I,13),I=1,3)
     & ,(CNAM(L),L=OLDMAX+1,NCON)

      IF(NCON .LE. OLDMAX)THEN
        READ(NRFILE,REC=2)(CVAL(I),I=1,OLDMAX)
      ELSE
        READ(NRFILE,REC=2)(CVAL(I),I=1,NCON)
      ENDIF

      NRL=0

      ENDIF

C       ********** MAIN ENTRY POINT **********

      IF(ET2(1) .EQ. 0.D0) RETURN

      S=ET2(1)-.5D0
      CALL SPLIT(S,PJD(1))
      CALL SPLIT(ET2(2),PJD(3))
      PJD(1)=PJD(1)+PJD(3)+.5D0
      PJD(2)=PJD(2)+PJD(4)
      CALL SPLIT(PJD(2),PJD(3))
      PJD(1)=PJD(1)+PJD(3)

C       ERROR RETURN FOR EPOCH OUT OF RANGE

      IF(PJD(1)+PJD(4).LT.SS(1) .OR. PJD(1)+PJD(4).GT.SS(2)) GO TO 98

C       CALCULATE RECORD # AND RELATIVE TIME IN INTERVAL

      NR=IDINT((PJD(1)-SS(1))/SS(3))+3
      IF(PJD(1).EQ.SS(2)) NR=NR-1

        tmp1 = DBLE(NR-3)*SS(3) + SS(1)
        tmp2 = PJD(1) - tmp1
        T(1) = (tmp2 + PJD(4))/SS(3)

C       READ CORRECT RECORD IF NOT IN CORE

      IF(NR.NE.NRL) THEN
        NRL=NR
        READ(NRFILE,REC=NR,ERR=99)(BUF(K),K=1,NCOEFFS)
      ENDIF

      IF(KM) THEN
      T(2)=SS(3)*86400.D0
      AUFAC=1.D0
      ELSE
      T(2)=SS(3)
      AUFAC=1.D0/AU
      ENDIF

C   INTERPOLATE SSBARY SUN

      CALL INTERP(BUF(IPT(1,11)),T,IPT(2,11),3,IPT(3,11),2,PVSUN)

      DO I=1,6
      PVSUN(I)=PVSUN(I)*AUFAC
      ENDDO

C   CHECK AND INTERPOLATE WHICHEVER BODIES ARE REQUESTED

      DO 4 I=1,10
      IF(LIST(I).EQ.0) GO TO 4

      CALL INTERP(BUF(IPT(1,I)),T,IPT(2,I),3,IPT(3,I),
     & LIST(I),PV(1,I))

      DO J=1,6
       IF(I.LE.9 .AND. .NOT.BARY) THEN
       PV(J,I)=PV(J,I)*AUFAC-PVSUN(J)
       ELSE
       PV(J,I)=PV(J,I)*AUFAC
       ENDIF
      ENDDO

   4  CONTINUE

C       DO NUTATIONS IF REQUESTED (AND IF ON FILE)

      IF(LIST(11).GT.0 .AND. IPT(2,12).GT.0)
     * CALL INTERP(BUF(IPT(1,12)),T,IPT(2,12),2,IPT(3,12),
     * LIST(11),PNUT)

C       GET LIBRATIONS IF REQUESTED (AND IF ON FILE)

      IF(LIST(12).GT.0 .AND. IPT(2,13).GT.0)
     * CALL INTERP(BUF(IPT(1,13)),T,IPT(2,13),3,IPT(3,13),
     * LIST(12),PV(1,11))

      RETURN

  98  WRITE(*,198)ET2(1)+ET2(2),SS(1),SS(2)
 198  FORMAT(' ***  Requested JED,',f12.2,
     * ' not within ephemeris limits,',2f12.2,'  ***')

      STOP

   99 WRITE(*,'(2F12.2,A80)')ET2,'ERROR RETURN IN STATE'

      STOP

      END
C+++++++++++++++++++++++++++++
C
      SUBROUTINE CONST(NAM,VAL,SSS,N)
C
C+++++++++++++++++++++++++++++
C
C     THIS ENTRY OBTAINS THE CONSTANTS FROM THE EPHEMERIS FILE
C
C     CALLING SEQEUNCE PARAMETERS (ALL OUTPUT):
C
C       NAM = CHARACTER*6 ARRAY OF CONSTANT NAMES
C
C       VAL = D.P. ARRAY OF VALUES OF CONSTANTS
C
C       SSS = D.P. JD START, JD STOP, STEP OF EPHEMERIS
C
C         N = INTEGER NUMBER OF ENTRIES IN 'NAM' AND 'VAL' ARRAYS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      SAVE

      INTEGER NMAX
      PARAMETER (NMAX = 1000)

      CHARACTER*6 NAM(*),TTL(14,3),CNAM(NMAX)

      DOUBLE PRECISION VAL(*),SSS(3),SS(3),CVAL(NMAX),ZIPS(2)
      DOUBLE PRECISION PVST(6,11),PNUT(4)
      DATA ZIPS/2*0.d0/

      INTEGER IPT(3,13),DENUM,LIST(12)
      logical first
      data first/.true./

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,DENUM,NCON,IPT
      COMMON/CHRHDR/CNAM,TTL

C  CALL STATE TO INITIALIZE THE EPHEMERIS AND READ IN THE CONSTANTS

      IF(FIRST) CALL STATE(ZIPS,LIST,PVST,PNUT)
      first=.false.

      N=NCON

      DO I=1,3
        SSS(I)=SS(I)
      ENDDO

      DO I=1,N
        NAM(I)=CNAM(I)
        VAL(I)=CVAL(I)
      ENDDO

      RETURN

      END

subroutine sync8d(cd0,i0,ctwk,itwk,sync)

! Compute sync power for a complex, downsampled FT8 signal.

  parameter(NP2=2812,NDOWN=60)
  complex cd0(0:3199)
  complex csync(0:6,32)
  complex csync2(32)
  complex ctwk(32)
  complex z1,z2,z3
  logical first
  integer icos7(0:6)
  data icos7/3,1,4,0,6,5,2/
  data first/.true./
  save first,twopi,csync

  p(z1)=real(z1)**2 + aimag(z1)**2          !Statement function for power

! Set some constants and compute the csync array.  
  if( first ) then
    twopi=8.0*atan(1.0)
    do i=0,6
      phi=0.0
      dphi=twopi*icos7(i)/32.0 
      do j=1,32
        csync(i,j)=cmplx(cos(phi),sin(phi)) !Waveform for 7x7 Costas array
        phi=mod(phi+dphi,twopi)
      enddo
    enddo
    first=.false.
  endif

  sync=0
  do i=0,6                              !Sum over 7 Costas frequencies and
     i1=i0+i*32                         !three Costas arrays
     i2=i1+36*32
     i3=i1+72*32
     csync2=csync(i,1:32)
     if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
     z1=0.
     z2=0.
     z3=0.
     if(i1.ge.0 .and. i1+31.le.NP2-1) z1=sum(cd0(i1:i1+31)*conjg(csync2))
     if(i2.ge.0 .and. i2+31.le.NP2-1) z2=sum(cd0(i2:i2+31)*conjg(csync2))
     if(i3.ge.0 .and. i3+31.le.NP2-1) z3=sum(cd0(i3:i3+31)*conjg(csync2))
     sync = sync + p(z1) + p(z2) + p(z3)
  enddo

  return
end subroutine sync8d

program qratest

  parameter (NMAX=60*12000) 
  real dd(NMAX)
  character arg*8,mycall*12,hiscall*12,hisgrid*6,decoded*22
  character c*1
  logical loop

  nargs=iargc()
  if(nargs.lt.1 .or. nargs.gt.4) then
     print*,'Usage: qratest nfile [sync f0 fTol]'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nfile
  loop=arg(1:1).eq.'+'
  minsync0=-1
  nfqso0=-1
  ntol0=-1
  if(nargs.gt.1) then
     call getarg(2,arg)
     read(arg,*) minsync0
     call getarg(3,arg)
     read(arg,*) nfqso0
     call getarg(4,arg)
     read(arg,*) ntol0
  endif
  ndepth=3
  nft=99
  
  open(60,file='qra64_data.bin',access='stream')

  do ifile=1,999
     read(60,end=999) dd,npts,nutc,nf1,nf2,nfqso,ntol,mode64,minsync,ndepth, &
          mycall,hiscall,hisgrid
     if(ifile.lt.nfile) cycle
     
     if(minsync0.ne.-1) minsync=minsync0
     if(nfqso0.ne.-1) nfqso=nfqso0
     if(ntol0.ne.-1) ntol=ntol0

     call qra64a(dd,npts,nf1,nf2,nfqso,ntol,mode64,minsync,ndepth,      &
          mycall,hiscall,hisgrid,sync,nsnr,dtx,nfreq,decoded,nft)
     c='a'
     if(mode64.eq.2) c='b'
     if(mode64.eq.4) c='c'
     if(mode64.eq.8) c='d'
     if(mode64.eq.16) c='e'
     write(*,1000) ifile,c,nutc,nsnr,dtx,nfreq,decoded,nft-100,sync-3.4
1000 format(i4,1x,a1,1x,i4.4,i4,f6.2,i5,1x,a22,i3,f6.2)
     if(ifile.eq.nfile .and. (.not.loop)) exit
  enddo

999 end program qratest

module decode0_mod
   implicit none
contains

   subroutine decode0(nstandalone) bind(C, name='decode0_')

      use iso_c_binding, only: c_int
      use timer_module, only: timer
      use npar_ptrs_mod
      use datcom_ptrs_mod, only: NFFT, dd
      use debug_log
      use map65a_mod
      use stdout_channel_mod, only: write_stdout
      use decodes_mod, only: ndecodes, nhsym1, nhsym2
      use sec0_mod, only:sec0

      implicit none

      integer, parameter :: NSMAX = 60*96000
      integer(c_int), intent(in) :: nstandalone
      integer hist(0:32768)
      integer i, j1, j2, j3, j4, m, mcall3b, ndphi, neme0, nsum
      integer :: ndecdone
      real :: tdec, tquick, rmsdd
      integer nz
      character(len=128) :: line
      character mycall0*12, hiscall0*12, hisgrid0*6
      data neme0/-99/, mcall3b/1/, mycall0/'            '/, hiscall0/'            '/, hisgrid0/'      '/

      save

      nkeep = 20

      call sec0(0, tquick)
      call timer('decode0 ', 0)
      if (newdat .ne. 0) then
         nz = int(96000.0*nhsym/5.3833)
         hist = 0
         do i = 1, nz
            j1 = int(min(abs(dd(1, i)), 32768.0))
            hist(j1) = hist(j1) + 1
            j2 = int(min(abs(dd(2, i)), 32768.0))
            hist(j2) = hist(j2) + 1
            j3 = int(min(abs(dd(3, i)), 32768.0))
            hist(j3) = hist(j3) + 1
            j4 = int(min(abs(dd(4, i)), 32768.0))
            hist(j4) = hist(j4) + 1
         enddo
         m = 0
         do i = 0, 32768
            m = m + hist(i)
            if (m .ge. 2*nz) go to 10
         enddo
10       rmsdd = 1.5*i
      endif
      ndphi = 0
      if (iand(nrxlog, 8) .ne. 0) ndphi = 1

      if (mycall .ne. mycall0 .or. hiscall .ne. hiscall0 .or. &
          hisgrid .ne. hisgrid0 .or. mcall3 .ne. 0 .or. neme .ne. neme0) mcall3b = 1

      mycall0 = mycall
      hiscall0 = hiscall
      hisgrid0 = hisgrid
      neme0 = neme

      call timer('map65a  ', 0)
      call map65a(dd, newdat, nutc, fcenter, ntol, idphi, nfa, nfb, &
                  mousedf, mousefqso, nagain, ndecdone, nfshift, ndphi, max_drift, &
                  nfcal, nkeep, mcall3b, nsum, nsave, nxant, mycall, mygrid, &
                  neme, ndepth, nstandalone, hiscall, hisgrid, nhsym, nfsample, &
                  ndiskdat, nxpol, nmode, ndop00)
      call timer('map65a  ', 1)
      call timer('decode0 ', 1)

      call sec0(1, tdec)

      if (nhsym == nhsym1) then
         write (line, '("<EarlyFinished>",3I4,I6,F6.2)') &
            nsum, nsave, nstandalone, nhsym, tdec
         call write_stdout(trim(line)//new_line('a'))
      end if

      if (nhsym == nhsym2) then
         write (line, '("<DecodeFinished>",3I4,I6,F6.2,I5)') &
            nsum, nsave, nstandalone, nhsym, tdec, ndecodes
         call write_stdout(trim(line)//new_line('a'))
      end if
!      print *, 'nhsym is: ',nhsym,' nhsym1 is: ',nhsym1,' nhsym2 is: ',nhsym2
      return
   end subroutine decode0

end module decode0_mod

subroutine fspread_lorentz(cdat,fspread)

  parameter (NZ=3*12000)
  complex cdat(0:NZ-1)
  complex cspread(0:NZ-1)
  complex z

  twopi=8.0*atan(1.0)
  nfft=NZ
  nh=nfft/2
  df=12000.0/nfft
  cspread(0)=1.0
  cspread(nh)=0.
  b=6.0                       !Use truncated Lorenzian shape for fspread
  do i=1,nh
     f=i*df
     x=b*f/fspread
     z=0.
     a=0.
     if(x.lt.3.0) then                          !Cutoff beyond x=3
        a=sqrt(1.111/(1.0+x*x)-0.1)             !Lorentzian amplitude
        phi1=twopi*rran()                       !Random phase
        z=a*cmplx(cos(phi1),sin(phi1))
     endif
     cspread(i)=z
     z=0.
     if(x.lt.3.0) then                !Same thing for negative freqs
        phi2=twopi*rran()
        z=a*cmplx(cos(phi2),sin(phi2))
     endif
     cspread(nfft-i)=z
  enddo

  call four2a(cspread,nfft,1,1,1)             !Transform to time domain
  
  sum=0.
  do i=0,nfft-1
     p=real(cspread(i))**2 + aimag(cspread(i))**2
     sum=sum+p
  enddo
  avep=sum/nfft
  fac=sqrt(1.0/avep)
  cspread=fac*cspread                   !Normalize to constant avg power
  cdat=cspread*cdat                     !Apply Rayleigh fading

  return
end subroutine fspread_lorentz

subroutine xcor4(s2,ipk,nsteps,nsym,lag1,lag2,ich,mode4,ccf,ccf0,   &
     lagpk,flip)

! Computes ccf of the 4_FSK spectral array s2 and the pseudo-random 
! array pr2.  Returns peak of CCF and the lag at which peak occurs.  
! The CCF peak may be either positive or negative, with negative
! implying the "OOO" message.

  parameter (NHMAX=1260)           !Max length of power spectra
  parameter (NSMAX=525)            !Max number of half-symbol steps
  real s2(NHMAX,NSMAX)             !2d spectrum, stepped by half-symbols
  real a(NSMAX)
  real ccf(-5:540)
  integer nch(7)
  integer npr2(207)
  real pr2(207)
  logical first
  data lagmin/0/                    !Silence compiler warning
  data first/.true./
  data npr2/                                                        &
       0,0,0,0,1,1,0,0,0,1,1,0,1,1,0,0,1,0,1,0,0,0,0,0,0,0,1,1,0,0, &
       0,0,0,0,0,0,0,0,0,0,1,0,1,1,0,1,1,0,1,0,1,1,1,1,1,0,1,0,0,0, &
       1,0,0,1,0,0,1,1,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,1,0,1,1,0,0,1, &
       0,0,0,1,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,0,1,0,1,0,1,1,0,1,0,1, &
       0,1,1,1,0,0,1,0,1,1,0,1,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,1,1,1, &
       0,1,1,1,0,1,1,1,0,0,1,0,0,0,1,1,0,1,1,0,0,1,0,0,0,1,1,1,1,1, &
       1,0,0,1,1,0,0,0,0,1,1,0,0,0,1,0,1,1,0,1,1,1,1,0,1,0,1/
  data nch/1,2,4,9,18,36,72/
  save

  if(first) then
     do i=1,207
        pr2(i)=2*npr2(i)-1
     enddo
     first=.false.
  endif

  ccfmax=0.
  ccfmin=0.
  nw=nch(min(max(ich,1),7))

  do j=1,nsteps
     n=2*mode4
     if(mode4.eq.1) then
        a(j)=max(s2(ipk+n,j),s2(ipk+3*n,j)) - max(s2(ipk  ,j),s2(ipk+2*n,j))
     else
        kz=max(1,nw/2)
        ss0=0.
        ss1=0.
        ss2=0.
        ss3=0.
        wsum=0.
        do k=-kz+1,kz-1
           w=float(kz-iabs(k))/nw
           wsum=wsum+w
           ss0=ss0 + w*s2(ipk    +k,j)
           ss1=ss1 + w*s2(ipk+  n+k,j)
           ss2=ss2 + w*s2(ipk+2*n+k,j)
           ss3=ss3 + w*s2(ipk+3*n+k,j)
        enddo
        a(j)=(max(ss1,ss3) - max(ss0,ss2))/sqrt(wsum)
     endif
  enddo

  do lag=lag1,lag2
     x=0.
     do i=1,nsym
        j=2*i-1+lag
        if(j.ge.1 .and. j.le.nsteps) x=x+a(j)*pr2(i)
     enddo
     ccf(lag)=2*x                        !The 2 is for plotting scale
     if(ccf(lag).gt.ccfmax) then
        ccfmax=ccf(lag)
        lagpk=lag
     endif

     if(ccf(lag).lt.ccfmin) then
        ccfmin=ccf(lag)
        lagmin=lag
     endif
  enddo

  ccf0=ccfmax
  flip=1.0
  if(-ccfmin.gt.ccfmax) then
     do lag=lag1,lag2
        ccf(lag)=-ccf(lag)
     enddo
     lagpk=lagmin
     ccf0=-ccfmin
     flip=-1.0
  endif

  return
end subroutine xcor4

program code426

  parameter (MZ=26)                !Number of 4-FSK symbols
  parameter (JZMAX=64)             !Desired number of codewords
  integer ic(MZ,JZMAX),icsave(MZ)
  real c(MZ)
  character*12 arg

  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage:   code426 <nmsgs> <iters>'
     print*,'Example: code426   64   10000000'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nmsgs
  call getarg(2,arg)
  read(arg,*) iters

  call init_random_seed()

  open(13,file='code426.out',status='unknown')

  write(*,1002) nmsgs,iters
  write(13,1002) nmsgs,iters
1002 format('Nmsgs:',i4,'   Iters:',i10/(66('-')))
  
  do i=1,MZ                     !Create 4 mutually orthogonal codewords
     ic(i,1)=mod(i-1,4)
     ic(i,2)=mod(i,4)
     ic(i,3)=mod(i+1,4)
     ic(i,4)=mod(i+2,4)
  enddo

  do j=1,4                      !Write them out
     write(*,1000) j,MZ,ic(1:MZ,j)
     write(13,1000) j,MZ,ic(1:MZ,j)
1000 format(2i5,3x,26i2)
  enddo
 
  do j=5,nmsgs                  !Find codewords up to j=nmsgs with maximum
     npk=0                      !distance from all the rest
     do i=1,iters
        call random_number(c)   !Generate a random codeword candidate
        ic(1:MZ,j)=int(4*c)     !Convert real to integer
!        nd=MZ
!        do k=1,j-1              !Test candidate against all others in list
!           n=count(ic(1:MZ,j).ne.ic(1:MZ,k))
!           nd=min(n,nd)
!        enddo
        call dist426(ic,j,mind)
        if(mind.gt.npk) then
           npk=mind
           icsave=ic(1:MZ,j)    !Best candidate so far, save it
!           if(npk.ge.19) exit   !It won't get any better...
        endif
     enddo
     write(*,1000) j,npk,ic(1:MZ,j)
     write(13,1000) j,npk,ic(1:MZ,j)
  enddo

999 end program code426

program test_q65

  character*84 cmd1,cmd2,line
  character*22 msg
  character*8 arg
  character*1 csubmode
  integer naptype(0:5)
  logical decok

  nargs=iargc()
  if(nargs.ne.12) then
     print*,'Usage:   test_q65        "msg"       A-D depth freq  DT fDop  f1 Stp TRp Q nfiles SNR'
     print*,'Example: test_q65 "K1ABC W9XYZ EN37"  A    3   1500 0.0  5.0 0.0  1   60 3  100   -20'
     print*,'Use SNR = 0 to loop over all relevant SNRs'
     print*,'Use MyCall=K1ABC, HisCall=W9XYZ, HisGrid="EN37" for AP decodes'
     print*,'Option Q sets QSOprogress (0-5) for AP decoding.'
     print*,'Add 16 to requested depth to enable message averaging.'
     go to 999
  endif
  call getarg(1,msg)
  call getarg(2,csubmode)
  call getarg(3,arg)
  read(arg,*) ndepth
  call getarg(4,arg)
  read(arg,*) nf0
  call getarg(5,arg)
  read(arg,*) dt
  call getarg(6,arg)
  read(arg,*) fDop
  call getarg(7,arg)
  read(arg,*) f1
  call getarg(8,arg)
  read(arg,*) nstp
  call getarg(9,arg)
  read(arg,*) ntrperiod
  call getarg(10,arg)
  read(arg,*) nQSOprogress
  call getarg(11,arg)
  read(arg,*) nfiles
  call getarg(12,arg)
  read(arg,*) snr

  if(ntrperiod.eq.15) then
     nsps=1800
     i50=-23
  else if(ntrperiod.eq.30) then
     nsps=3600
     i50=-26
  else if(ntrperiod.eq.60) then
     nsps=7200
     i50=-29
  else if(ntrperiod.eq.120) then
     nsps=16000
     i50=-31
  else if(ntrperiod.eq.300) then
     nsps=41472
     i50=-35
  else
     stop 'Invalid TR period'
  endif

  i50=i50 + 8.0*log(1.0+fDop)/log(240.0)
  ia=i50 + 7
  ib=i50 - 10
  if(snr.ne.0.0) then
     ia=99
     ib=99
  endif

  baud=12000.0/nsps
  tsym=1.0/baud

!                1         2         3         4         5         6         7
!       1234567890123456789012345678901234567890123456789012345678901234567890123456'
  cmd1='q65sim   "K1ABC W9XYZ EN37      " A 1500  5.0  0.0   0.0  1  60  100   -10.0 > junk0'
  cmd2='jt9 -3 -p  15 -L 300 -H 3000 -d   3 -b A -Q 3 -f 1500 -X 32 *.wav > junk'

  write(cmd1(10:33),'(a)') '"'//msg//'"'
  cmd1(35:35)=csubmode
  write(cmd1(37:40),'(i4)') nf0
  write(cmd1(41:45),'(f5.0)') fDop
  write(cmd1(46:50),'(f5.2)') dt
  write(cmd1(51:56),'(i6)') nint(f1)
  write(cmd1(57:59),'(i3)') nstp
  write(cmd1(60:63),'(i4)') ntrperiod
  write(cmd1(64:68),'(i5)') nfiles

  write(cmd2(11:13),'(i3)') ntrperiod
  write(cmd2(33:35),'(i3)') ndepth
  write(cmd2(45:45),'(i1)') nQSOprogress
  write(cmd2(50:53),'(i4)') nf0
  cmd2(40:40)=csubmode
  
  call system('rm -f *.wav')

  write(*,1008) ntrperiod,csubmode,ndepth,fDop,f1,nstp
1008 format('Mode:',i4,a1,'  Depth:',i3,'  fDop:',f6.1,'  Drift:',f8.1,  &
          '  Steps:',i3)
  write(*,1010) (j,j=0,5)
  write(12,1010) (j,j=0,5)
1010 format(' SNR Sync Avg Dec  Bad',6i4,'  tdec   avg  rms'/64('-'))

  dterr=tsym/4.0
  nferr=max(1,nint(0.5*baud),nint(fdop/3.0))
  ndec1z=nfiles

  do nsnr=ia,ib,-1
     snr1=nsnr
     if(ia.eq.99) snr1=snr
     nsync=0
     ndec1=0
     nfalse=0
     naptype=0
     ndecn=0
     write(cmd1(72:76),'(f5.1)') snr1
     call system(cmd1)
     call sec0(0,tdec)
     call system(cmd2)
     call sec0(1,tdec)
     open(10,file='junk',status='unknown')
     n=0
     snrsum=0.
     snrsq=0.
     nsum=0
     do iline=1,9999
        read(10,'(a71)',end=10) line
        if(index(line,'<Decode').eq.1) cycle
        read(line,*) itime,xsnr,xdt,nf
        decok=index(line,trim(msg)).gt.0
        if(decok) then
           snrsum=snrsum + xsnr
           snrsq=snrsq + xsnr*xsnr
           nsum=nsum+1
        endif
        if((abs(xdt-dt).le.dterr .and. abs(nf-nf0).le.nferr) .or. decok) then
           nsync=nsync+1
        endif
        idec=-1
        iavg=0
        i0=23
        if(ntrperiod.le.30) i0=25
        if(line(i0:i0).ne.' ') then
           i1=index(line,'q')
           idec=-1
           read(line(i1+1:i1+1),*) idec
           if(line(i1+2:i1+2).eq.'*') then
              iavg=10
           else
              read(line(i1+2:i1+2),*,end=100) iavg
           endif
        endif
100     if(idec.lt.0) cycle
        if(decok) then
           ndecn=ndecn + 1
           if(iavg.le.1) ndec1=ndec1 + 1
           naptype(idec)=naptype(idec) + 1
        else
           nfalse=nfalse + 1
           print*,'False: ',line
        endif
     enddo
10   close(10)
     snr_avg=0.
     snr_rms=0.
     if(nsum.ge.1) then
        snr_avg=snrsum/nsum
        snr_rms=sqrt(snrsq/nsum - snr_avg**2)
     endif
     write(*,1100) snr1,nsync,ndecn,ndec1,nfalse,naptype,tdec/nfiles,  &
          snr_avg,snr_rms
     write(12,1100) snr1,nsync,ndecn,ndec1,nfalse,naptype,tdec/nfiles, &
          snr_avg,snr_rms
1100 format(f5.1,4i4,i5,5i4,f6.2,f6.1,f5.1)
     if(ndec1.lt.nfiles/2 .and. ndec1z.ge.nfiles/2) then
        snr_thresh=snr1 + float(nfiles/2 - ndec1)/(ndec1z-ndec1)
        open(13,file='snr_thresh.out',status='unknown',position='append')
        write(13,1200) ntrperiod,csubmode,ndepth,nQSOprogress,nfiles,   &
             fdop,f1,nstp,nfalse,snr_thresh,trim(msg)
1200    format(i3,a1,2i3,i5,2f7.1,2i3,f7.1,2x,a)
        close(13)
     endif
     flush(6)
     flush(12)
     if(ndec1.eq.0 .and. ndecn.eq.0) exit           !Bail out if no decodes at this SNR
     ndec1z=ndec1
  enddo  ! nsnr

999 end program test_q65

include 'sec0.f90'

real function fchisq(c3,npts,fsample,a)

  parameter (NMAX=85*16)
  complex c3(npts)
  complex c4(NMAX)
  real a(3)
  complex z
  data a1,a2,a3/99.,99.,99./
  include 'jt9sync.f90'
  save

  if(a(1).ne.a1 .or. a(2).ne.a2 .or. a(3).ne.a3) then
     a1=a(1)
     a2=a(2)
     a3=a(3)
     call twkfreq(c3,c4,npts,fsample,a)
  endif

! Get sync power.
  nspsd=16
  sum1=0.
  sum0=0.
  k=-1
  do i=1,85
     z=0.
     do j=1,nspsd
        k=k+1
        z=z+c4(k+1)
     enddo
     pp=real(z)**2 + aimag(z)**2     
     if(isync(i).eq.1) then
        sum1=sum1+pp
     else
        sum0=sum0+pp
     endif
  enddo
  sync_4992=(sum1/16.0)/(sum0/69.0) - 1.0             !r4992
  sync_4993=sum1/10000.0                              !r4993+
!  write(80,3001) 1.e-5*sum1,1.e-5*sum0,sync_4992,sync_4993,sync
!3001 format(5f11.4)
  fchisq=-sync_4993

  return
end function fchisq

subroutine ft2_decode(cdatetime0,nfqso,iwave,ndecodes,mycall,hiscall,nrx,line)

  use crc
  use packjt77
  include 'ft2_params.f90'
  character message*37,c77*77
  character*61 line
  character*37 decodes(100)
  character*120 data_dir
  character*17 cdatetime0,cdatetime
  character*6 mycall,hiscall,hhmmss
  complex c2(0:NMAX/16-1)                  !Complex waveform
  complex cb(0:NMAX/16-1)
  complex cd(0:144*10-1)                  !Complex waveform
  complex c1(0:9),c0(0:9)
  complex ccor(0:1,144)
  complex csum,cterm,cc0,cc1,csync1
  real*8 fMHz

  real a(5)
  real rxdata(128),llr(128)               !Soft symbols
  real llr2(128)
  real sbits(144),sbits1(144),sbits3(144)
  real ps(0:8191),psbest(0:8191)
  real candidate(3,100)
  real savg(NH1)
  integer*2 iwave(NMAX)                 !Generated full-length waveform  
  integer*1 message77(77),apmask(128),cw(128)
  integer*1 hbits(144),hbits1(144),hbits3(144)
  integer*1 s16(16)
  logical unpk77_success
  data s16/0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0/

  hhmmss=cdatetime0(8:13)
  fs=12000.0/NDOWN                       !Sample rate
  dt=1/fs                                !Sample interval after downsample (s)
  tt=NSPS*dt                             !Duration of "itone" symbols (s)
  baud=1.0/tt                            !Keying rate for "itone" symbols (baud)
  txt=NZ*dt                              !Transmission length (s)
  twopi=8.0*atan(1.0)
  h=0.8                                  !h=0.8 seems to be optimum for AWGN sensitivity (not for fading)

  dphi=twopi/2*baud*h*dt*16  ! dt*16 is samp interval after downsample
  dphi0=-1*dphi
  dphi1=+1*dphi
  phi0=0.0
  phi1=0.0
  do i=0,9
    c1(i)=cmplx(cos(phi1),sin(phi1))
    c0(i)=cmplx(cos(phi0),sin(phi0))
    phi1=mod(phi1+dphi1,twopi)
    phi0=mod(phi0+dphi0,twopi)
  enddo
  the=twopi*h/2.0
  cc1=cmplx(cos(the),-sin(the))
  cc0=cmplx(cos(the),sin(the))
  
  data_dir="."
  fMHz=7.074
  ncoh=1  
  candidate=0.0
  ncand=0
  fa=375.0
  fb=3000.0
  syncmin=0.2
  maxcand=100
  nfqso=-1
  call getcandidates2a(iwave,fa,fb,maxcand,savg,candidate,ncand)
  ndecodes=0
  do icand=1,ncand
     f0=candidate(1,icand)
     if( f0.le.375.0 .or. f0.ge.(5000.0-375.0) ) cycle 
     call ft2_downsample(iwave,f0,c2) ! downsample from 160s/Symbol to 10s/Symbol
! 750 samples/second here
     ibest=-1
     sybest=-99.
     dfbest=-1.
!###     do if=-15,+15
     do if=-30,30
        df=if
        a=0.
        a(1)=-df
        call twkfreq1(c2,NMAX/16,fs,a,cb)
        do is=0,374                           !DT search range is 0 - 0.5 s
           csync1=0.
           cterm=1
           do ib=1,16
              i1=(ib-1)*10+is
              i2=i1+136*10
              if(s16(ib).eq.1) then
                 csync1=csync1+sum(cb(i1:i1+9)*conjg(c1(0:9)))*cterm
                 cterm=cterm*cc1
              else
                 csync1=csync1+sum(cb(i1:i1+9)*conjg(c0(0:9)))*cterm
                 cterm=cterm*cc0
              endif
           enddo
           if(abs(csync1).gt.sybest) then
              ibest=is
              sybest=abs(csync1)
              dfbest=df
           endif
        enddo
     enddo

     a=0.
     a(1)=-dfbest
     call twkfreq1(c2,NMAX/16,fs,a,cb)
     ib=ibest
     cd=cb(ib:ib+144*10-1) 
     s2=sum(real(cd*conjg(cd)))/(10*144)
     cd=cd/sqrt(s2)
     do nseq=1,5
        if( nseq.eq.1 ) then  ! noncoherent single-symbol detection
           sbits1=0.0
           do ibit=1,144
              ib=(ibit-1)*10
              ccor(1,ibit)=sum(cd(ib:ib+9)*conjg(c1(0:9)))        
              ccor(0,ibit)=sum(cd(ib:ib+9)*conjg(c0(0:9)))   
              sbits1(ibit)=abs(ccor(1,ibit))-abs(ccor(0,ibit))
              hbits1(ibit)=0
              if(sbits1(ibit).gt.0) hbits1(ibit)=1
           enddo
           sbits=sbits1
           hbits=hbits1
           sbits3=sbits1
           hbits3=hbits1
        elseif( nseq.ge.2 ) then
           nbit=2*nseq-1
           numseq=2**(nbit)
           ps=0
           do ibit=nbit/2+1,144-nbit/2
              ps=0.0
              pmax=0.0
              do iseq=0,numseq-1
                 csum=0.0
                 cterm=1.0
                 k=1
                 do i=nbit-1,0,-1
                    ibb=iand(iseq/(2**i),1) 
                    csum=csum+ccor(ibb,ibit-(nbit/2+1)+k)*cterm
                    if(ibb.eq.0) cterm=cterm*cc0
                    if(ibb.eq.1) cterm=cterm*cc1
                    k=k+1
                 enddo
                 ps(iseq)=abs(csum) 
                 if( ps(iseq) .gt. pmax ) then
                    pmax=ps(iseq)
                    ibflag=1
                 endif
              enddo
              if( ibflag .eq. 1 ) then
                 psbest=ps
                 ibflag=0
              endif
              call getbitmetric(2**(nbit/2),psbest,numseq,sbits3(ibit))
              hbits3(ibit)=0
              if(sbits3(ibit).gt.0) hbits3(ibit)=1
           enddo
           sbits=sbits3
           hbits=hbits3
        endif
        nsync_qual=count(hbits(1:16).eq.s16)
        if(nsync_qual.lt.10) exit 
        rxdata=sbits(17:144)
        rxav=sum(rxdata(1:128))/128.0
        rx2av=sum(rxdata(1:128)*rxdata(1:128))/128.0
        rxsig=sqrt(rx2av-rxav*rxav)
        rxdata=rxdata/rxsig
        sigma=0.80
        llr(1:128)=2*rxdata/(sigma*sigma)
        apmask=0
        max_iterations=40
        do ibias=0,0
           llr2=llr
           if(ibias.eq.1) llr2=llr+0.4
           if(ibias.eq.2) llr2=llr-0.4
           call bpdecode128_90(llr2,apmask,max_iterations,message77,cw,nharderror,niterations)
           if(nharderror.ge.0) exit 
        enddo
        nhardmin=-1
        if(sum(message77).eq.0) cycle
        if( nharderror.ge.0 ) then
           write(c77,'(77i1)') message77(1:77)
           call unpack77(c77,nrx,message,unpk77_success)
           idupe=0
           do i=1,ndecodes
              if(decodes(i).eq.message) idupe=1 
           enddo
           if(idupe.eq.1) exit
           ndecodes=ndecodes+1 
           decodes(ndecodes)=message
           xsnr=db(sybest*sybest) - 115.0   !### Rough estimate of S/N ###
           nsnr=nint(xsnr)
           freq=f0+dfbest
           write(line,1000) hhmmss,nsnr,ibest/750.0,nint(freq),message
1000       format(a6,i4,f5.2,i5,' + ',1x,a37)
           open(24,file='all_ft2.txt',status='unknown',position='append')
           write(24,1002) cdatetime0,nsnr,ibest/750.0,nint(freq),message,    &
                nseq,nharderror,nhardmin
           if(hhmmss.eq.'      ') write(*,1002) cdatetime0,nsnr,             &
                ibest/750.0,nint(freq),message,nseq,nharderror,nhardmin
1002       format(a17,i4,f6.2,i5,' Rx  ',a37,3i5)
           close(24)

!### Temporary: assume most recent decoded message conveys "hiscall".
           i0=index(message,' ')
           if(i0.ge.3 .and. i0.le.7) then
              hiscall=message(i0+1:i0+6)
              i1=index(hiscall,' ')
              if(i1.gt.0) hiscall=hiscall(1:i1)
           endif
           nrx=-1
           if(index(message,'CQ ').eq.1) nrx=1
           if((index(message,trim(mycall)//' ').eq.1) .and.                 &
                (index(message,' '//trim(hiscall)//' ').ge.4)) then
              if(index(message,' 559 ').gt.8) nrx=2
              if(index(message,' R 559 ').gt.8) nrx=3
              if(index(message,' RR73 ').gt.8) nrx=4
           endif
!###
           exit
        endif
     enddo ! nseq
  enddo !candidate list

  return
end subroutine ft2_decode

subroutine getbitmetric(ib,ps,ns,xmet)
  real ps(0:ns-1)
  xm1=0
  xm0=0
  do i=0,ns-1
    if( iand(i/ib,1) .eq. 1 .and. ps(i) .gt. xm1 ) xm1=ps(i)
    if( iand(i/ib,1) .eq. 0 .and. ps(i) .gt. xm0 ) xm0=ps(i)
  enddo
  xmet=xm1-xm0
  return
end subroutine getbitmetric

subroutine downsample2(ci,f0,co)
  parameter(NI=144*160,NH=NI/2,NO=NI/16)  ! downsample from 200 samples per symbol to 10
  complex ci(0:NI-1),ct(0:NI-1) 
  complex co(0:NO-1)
  fs=12000.0
  df=fs/NI
  ct=ci
  call four2a(ct,NI,1,-1,1)             !c2c FFT to freq domain
  i0=nint(f0/df)
  ct=cshift(ct,i0)
  co=0.0
  co(0)=ct(0)
  b=8.0
  do i=1,NO/2
     arg=(i*df/b)**2
     filt=exp(-arg)
     co(i)=ct(i)*filt
     co(NO-i)=ct(NI-i)*filt
  enddo
  co=co/NO
  call four2a(co,NO,1,1,1)            !c2c FFT back to time domain
  return
end subroutine downsample2

subroutine ft2_downsample(iwave,f0,c)

! Input: i*2 data in iwave() at sample rate 12000 Hz
! Output: Complex data in c(), sampled at 1200 Hz

  include 'ft2_params.f90'
  parameter (NFFT2=NMAX/16)
  integer*2 iwave(NMAX)
  complex c(0:NMAX/16-1)
  complex c1(0:NFFT2-1)
  complex cx(0:NMAX/2)
  real x(NMAX)
  equivalence (x,cx)

  BW=4.0*75
  df=12000.0/NMAX
  x=iwave
  call four2a(x,NMAX,1,-1,0)             !r2c FFT to freq domain
  ibw=nint(BW/df)
  i0=nint(f0/df)
  c1=0.
  c1(0)=cx(i0)
  do i=1,NFFT2/2
     arg=(i-1)*df/bw
     win=exp(-arg*arg)
     c1(i)=cx(i0+i)*win
     c1(NFFT2-i)=cx(i0-i)*win
  enddo
  c1=c1/NFFT2
  call four2a(c1,NFFT2,1,1,1)            !c2c FFT back to time domain
  c=c1(0:NMAX/16-1)
  return
end subroutine ft2_downsample

      SUBROUTINE sla_CLDJ (IY, IM, ID, DJM, J)
*+
*     - - - - -
*      C L D J
*     - - - - -
*
*  Gregorian Calendar to Modified Julian Date
*
*  Given:
*     IY,IM,ID     int    year, month, day in Gregorian calendar
*
*  Returned:
*     DJM          dp     modified Julian Date (JD-2400000.5) for 0 hrs
*     J            int    status:
*                           0 = OK
*                           1 = bad year   (MJD not computed)
*                           2 = bad month  (MJD not computed)
*                           3 = bad day    (MJD computed)
*
*  The year must be -4699 (i.e. 4700BC) or later.
*
*  The algorithm is adapted from Hatcher 1984 (QJRAS 25, 53-55).
*
*  Last revision:   27 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID
      DOUBLE PRECISION DJM
      INTEGER J

*  Month lengths in days
      INTEGER MTAB(12)
      DATA MTAB / 31,28,31,30,31,30,31,31,30,31,30,31 /



*  Preset status.
      J = 0

*  Validate year.
      IF ( IY .LT. -4699 ) THEN
         J = 1
      ELSE

*     Validate month.
         IF ( IM.GE.1 .AND. IM.LE.12 ) THEN

*        Allow for leap year.
            IF ( MOD(IY,4) .EQ. 0 ) THEN
               MTAB(2) = 29
            ELSE
               MTAB(2) = 28
            END IF
            IF ( MOD(IY,100).EQ.0 .AND. MOD(IY,400).NE.0 )
     :         MTAB(2) = 28

*        Validate day.
            IF ( ID.LT.1 .OR. ID.GT.MTAB(IM) ) J=3

*        Modified Julian Date.
            DJM = DBLE ( ( 1461 * ( IY - (12-IM)/10 + 4712 ) ) / 4
     :               + ( 306 * MOD ( IM+9, 12 ) + 5 ) / 10
     :               - ( 3 * ( ( IY - (12-IM)/10 + 4900 ) / 100 ) ) / 4
     :               + ID - 2399904 )

*        Bad month.
         ELSE
            J=2
         END IF

      END IF

      END
      DOUBLE PRECISION FUNCTION sla_DAT (UTC)
*+
*     - - - -
*      D A T
*     - - - -
*
*  Increment to be applied to Coordinated Universal Time UTC to give
*  International Atomic Time TAI (double precision)
*
*  Given:
*     UTC      d      UTC date as a modified JD (JD-2400000.5)
*
*  Result:  TAI-UTC in seconds
*
*  Notes:
*
*  1  The UTC is specified to be a date rather than a time to indicate
*     that care needs to be taken not to specify an instant which lies
*     within a leap second.  Though in most cases UTC can include the
*     fractional part, correct behaviour on the day of a leap second
*     can only be guaranteed up to the end of the second 23:59:59.
*
*  2  For epochs from 1961 January 1 onwards, the expressions from the
*     file ftp://maia.usno.navy.mil/ser7/tai-utc.dat are used.
*
*  3  The 5ms time step at 1961 January 1 is taken from 2.58.1 (p87) of
*     the 1992 Explanatory Supplement.
*
*  4  UTC began at 1960 January 1.0 (JD 2436934.5) and it is improper
*     to call the routine with an earlier epoch.  However, if this
*     is attempted, the TAI-UTC expression for the year 1960 is used.
*
*
*     :-----------------------------------------:
*     :                                         :
*     :                IMPORTANT                :
*     :                                         :
*     :  This routine must be updated on each   :
*     :     occasion that a leap second is      :
*     :                announced                :
*     :                                         :
*     :  Latest leap second:  2015 July 1       :
*     :                                         :
*     :-----------------------------------------:
*
*  Last revision:   5 July 2008
*
*  Copyright P.T.Wallace.  All rights reserved.
*-

      IMPLICIT NONE

      DOUBLE PRECISION UTC

      DOUBLE PRECISION DT



      IF (.FALSE.) THEN

* - - - - - - - - - - - - - - - - - - - - - - *
*  Add new code here on each occasion that a  *
*  leap second is announced, and update the   *
*  preamble comments appropriately.           *
* - - - - - - - - - - - - - - - - - - - - - - *

*     2017 January 1
      ELSE IF (UTC.GE.57754D0) THEN
         DT=37D0

*     2015 July 1
      ELSE IF (UTC.GE.57204D0) THEN
         DT=36D0

*     2012 July 1
      ELSE IF (UTC.GE.56109D0) THEN
         DT=35D0

*     2009 January 1
      ELSE IF (UTC.GE.54832D0) THEN
         DT=34D0

*     2006 January 1
      ELSE IF (UTC.GE.53736D0) THEN
         DT=33D0

*     1999 January 1
      ELSE IF (UTC.GE.51179D0) THEN
         DT=32D0

*     1997 July 1
      ELSE IF (UTC.GE.50630D0) THEN
         DT=31D0

*     1996 January 1
      ELSE IF (UTC.GE.50083D0) THEN
         DT=30D0

*     1994 July 1
      ELSE IF (UTC.GE.49534D0) THEN
         DT=29D0

*     1993 July 1
      ELSE IF (UTC.GE.49169D0) THEN
         DT=28D0

*     1992 July 1
      ELSE IF (UTC.GE.48804D0) THEN
         DT=27D0

*     1991 January 1
      ELSE IF (UTC.GE.48257D0) THEN
         DT=26D0

*     1990 January 1
      ELSE IF (UTC.GE.47892D0) THEN
         DT=25D0

*     1988 January 1
      ELSE IF (UTC.GE.47161D0) THEN
         DT=24D0

*     1985 July 1
      ELSE IF (UTC.GE.46247D0) THEN
         DT=23D0

*     1983 July 1
      ELSE IF (UTC.GE.45516D0) THEN
         DT=22D0

*     1982 July 1
      ELSE IF (UTC.GE.45151D0) THEN
         DT=21D0

*     1981 July 1
      ELSE IF (UTC.GE.44786D0) THEN
         DT=20D0

*     1980 January 1
      ELSE IF (UTC.GE.44239D0) THEN
         DT=19D0

*     1979 January 1
      ELSE IF (UTC.GE.43874D0) THEN
         DT=18D0

*     1978 January 1
      ELSE IF (UTC.GE.43509D0) THEN
         DT=17D0

*     1977 January 1
      ELSE IF (UTC.GE.43144D0) THEN
         DT=16D0

*     1976 January 1
      ELSE IF (UTC.GE.42778D0) THEN
         DT=15D0

*     1975 January 1
      ELSE IF (UTC.GE.42413D0) THEN
         DT=14D0

*     1974 January 1
      ELSE IF (UTC.GE.42048D0) THEN
         DT=13D0

*     1973 January 1
      ELSE IF (UTC.GE.41683D0) THEN
         DT=12D0

*     1972 July 1
      ELSE IF (UTC.GE.41499D0) THEN
         DT=11D0

*     1972 January 1
      ELSE IF (UTC.GE.41317D0) THEN
         DT=10D0

*     1968 February 1
      ELSE IF (UTC.GE.39887D0) THEN
         DT=4.2131700D0+(UTC-39126D0)*0.002592D0

*     1966 January 1
      ELSE IF (UTC.GE.39126D0) THEN
         DT=4.3131700D0+(UTC-39126D0)*0.002592D0

*     1965 September 1
      ELSE IF (UTC.GE.39004D0) THEN
         DT=3.8401300D0+(UTC-38761D0)*0.001296D0

*     1965 July 1
      ELSE IF (UTC.GE.38942D0) THEN
         DT=3.7401300D0+(UTC-38761D0)*0.001296D0

*     1965 March 1
      ELSE IF (UTC.GE.38820D0) THEN
         DT=3.6401300D0+(UTC-38761D0)*0.001296D0

*     1965 January 1
      ELSE IF (UTC.GE.38761D0) THEN
         DT=3.5401300D0+(UTC-38761D0)*0.001296D0

*     1964 September 1
      ELSE IF (UTC.GE.38639D0) THEN
         DT=3.4401300D0+(UTC-38761D0)*0.001296D0

*     1964 April 1
      ELSE IF (UTC.GE.38486D0) THEN
         DT=3.3401300D0+(UTC-38761D0)*0.001296D0

*     1964 January 1
      ELSE IF (UTC.GE.38395D0) THEN
         DT=3.2401300D0+(UTC-38761D0)*0.001296D0

*     1963 November 1
      ELSE IF (UTC.GE.38334D0) THEN
         DT=1.9458580D0+(UTC-37665D0)*0.0011232D0

*     1962 January 1
      ELSE IF (UTC.GE.37665D0) THEN
         DT=1.8458580D0+(UTC-37665D0)*0.0011232D0

*     1961 August 1
      ELSE IF (UTC.GE.37512D0) THEN
         DT=1.3728180D0+(UTC-37300D0)*0.001296D0

*     1961 January 1
      ELSE IF (UTC.GE.37300D0) THEN
         DT=1.4228180D0+(UTC-37300D0)*0.001296D0

*     Before that
      ELSE
         DT=1.4178180D0+(UTC-37300D0)*0.001296D0

      END IF

      sla_DAT=DT

      END
      SUBROUTINE sla_DC62S (V, A, B, R, AD, BD, RD)
*+
*     - - - - - -
*      D C 6 2 S
*     - - - - - -
*
*  Conversion of position & velocity in Cartesian coordinates
*  to spherical coordinates (double precision)
*
*  Given:
*     V      d(6)   Cartesian position & velocity vector
*
*  Returned:
*     A      d      longitude (radians)
*     B      d      latitude (radians)
*     R      d      radial coordinate
*     AD     d      longitude derivative (radians per unit time)
*     BD     d      latitude derivative (radians per unit time)
*     RD     d      radial derivative
*
*  P.T.Wallace   Starlink   28 April 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(6),A,B,R,AD,BD,RD

      DOUBLE PRECISION X,Y,Z,XD,YD,ZD,RXY2,RXY,R2,XYP



*  Components of position/velocity vector
      X=V(1)
      Y=V(2)
      Z=V(3)
      XD=V(4)
      YD=V(5)
      ZD=V(6)

*  Component of R in XY plane squared
      RXY2=X*X+Y*Y

*  Modulus squared
      R2=RXY2+Z*Z

*  Protection against null vector
      IF (R2.EQ.0D0) THEN
         X=XD
         Y=YD
         Z=ZD
         RXY2=X*X+Y*Y
         R2=RXY2+Z*Z
      END IF

*  Position and velocity in spherical coordinates
      RXY=SQRT(RXY2)
      XYP=X*XD+Y*YD
      IF (RXY2.NE.0D0) THEN
         A=ATAN2(Y,X)
         B=ATAN2(Z,RXY)
         AD=(X*YD-Y*XD)/RXY2
         BD=(ZD*RXY2-Z*XYP)/(R2*RXY)
      ELSE
         A=0D0
         IF (Z.NE.0D0) THEN
            B=ATAN2(Z,RXY)
         ELSE
            B=0D0
         END IF
         AD=0D0
         BD=0D0
      END IF
      R=SQRT(R2)
      IF (R.NE.0D0) THEN
         RD=(XYP+Z*ZD)/R
      ELSE
         RD=0D0
      END IF

      END
      SUBROUTINE sla_DCC2S (V, A, B)
*+
*     - - - - - -
*      D C C 2 S
*     - - - - - -
*
*  Cartesian to spherical coordinates (double precision)
*
*  Given:
*     V     d(3)   x,y,z vector
*
*  Returned:
*     A,B   d      spherical coordinates in radians
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  If V is null, zero A and B are returned.  At either pole, zero A is
*  returned.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(3),A,B

      DOUBLE PRECISION X,Y,Z,R


      X = V(1)
      Y = V(2)
      Z = V(3)
      R = SQRT(X*X+Y*Y)

      IF (R.EQ.0D0) THEN
         A = 0D0
      ELSE
         A = ATAN2(Y,X)
      END IF

      IF (Z.EQ.0D0) THEN
         B = 0D0
      ELSE
         B = ATAN2(Z,R)
      END IF

      END
      SUBROUTINE sla_DCS2C (A, B, V)
*+
*     - - - - - -
*      D C S 2 C
*     - - - - - -
*
*  Spherical coordinates to direction cosines (double precision)
*
*  Given:
*     A,B       d      spherical coordinates in radians
*                         (RA,Dec), (long,lat) etc.
*
*  Returned:
*     V         d(3)   x,y,z unit vector
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION A,B,V(3)

      DOUBLE PRECISION COSB


      COSB = COS(B)

      V(1) = COS(A)*COSB
      V(2) = SIN(A)*COSB
      V(3) = SIN(B)

      END
      SUBROUTINE sla_DE2H (HA, DEC, PHI, AZ, EL)
*+
*     - - - - -
*      D E 2 H
*     - - - - -
*
*  Equatorial to horizon coordinates:  HA,Dec to Az,El
*
*  (double precision)
*
*  Given:
*     HA      d     hour angle
*     DEC     d     declination
*     PHI     d     observatory latitude
*
*  Returned:
*     AZ      d     azimuth
*     EL      d     elevation
*
*  Notes:
*
*  1)  All the arguments are angles in radians.
*
*  2)  Azimuth is returned in the range 0-2pi;  north is zero,
*      and east is +pi/2.  Elevation is returned in the range
*      +/-pi/2.
*
*  3)  The latitude must be geodetic.  In critical applications,
*      corrections for polar motion should be applied.
*
*  4)  In some applications it will be important to specify the
*      correct type of hour angle and declination in order to
*      produce the required type of azimuth and elevation.  In
*      particular, it may be important to distinguish between
*      elevation as affected by refraction, which would
*      require the "observed" HA,Dec, and the elevation
*      in vacuo, which would require the "topocentric" HA,Dec.
*      If the effects of diurnal aberration can be neglected, the
*      "apparent" HA,Dec may be used instead of the topocentric
*      HA,Dec.
*
*  5)  No range checking of arguments is carried out.
*
*  6)  In applications which involve many such calculations, rather
*      than calling the present routine it will be more efficient to
*      use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude, and (for tracking a star)
*      sine and cosine of declination.
*
*  P.T.Wallace   Starlink   9 July 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION HA,DEC,PHI,AZ,EL

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)

      DOUBLE PRECISION SH,CH,SD,CD,SP,CP,X,Y,Z,R,A


*  Useful trig functions
      SH=SIN(HA)
      CH=COS(HA)
      SD=SIN(DEC)
      CD=COS(DEC)
      SP=SIN(PHI)
      CP=COS(PHI)

*  Az,El as x,y,z
      X=-CH*CD*SP+SD*CP
      Y=-SH*CD
      Z=CH*CD*CP+SD*SP

*  To spherical
      R=SQRT(X*X+Y*Y)
      IF (R.EQ.0D0) THEN
         A=0D0
      ELSE
         A=ATAN2(Y,X)
      END IF
      IF (A.LT.0D0) A=A+D2PI
      AZ=A
      EL=ATAN2(Z,R)

      END
      SUBROUTINE sla_DEULER (ORDER, PHI, THETA, PSI, RMAT)
*+
*     - - - - - - -
*      D E U L E R
*     - - - - - - -
*
*  Form a rotation matrix from the Euler angles - three successive
*  rotations about specified Cartesian axes (double precision)
*
*  Given:
*    ORDER   c*(*)   specifies about which axes the rotations occur
*    PHI     d       1st rotation (radians)
*    THETA   d       2nd rotation (   "   )
*    PSI     d       3rd rotation (   "   )
*
*  Returned:
*    RMAT    d(3,3)  rotation matrix
*
*  A rotation is positive when the reference frame rotates
*  anticlockwise as seen looking towards the origin from the
*  positive region of the specified axis.
*
*  The characters of ORDER define which axes the three successive
*  rotations are about.  A typical value is 'ZXZ', indicating that
*  RMAT is to become the direction cosine matrix corresponding to
*  rotations of the reference frame through PHI radians about the
*  old Z-axis, followed by THETA radians about the resulting X-axis,
*  then PSI radians about the resulting Z-axis.
*
*  The axis names can be any of the following, in any order or
*  combination:  X, Y, Z, uppercase or lowercase, 1, 2, 3.  Normal
*  axis labelling/numbering conventions apply;  the xyz (=123)
*  triad is right-handed.  Thus, the 'ZXZ' example given above
*  could be written 'zxz' or '313' (or even 'ZxZ' or '3xZ').  ORDER
*  is terminated by length or by the first unrecognized character.
*
*  Fewer than three rotations are acceptable, in which case the later
*  angle arguments are ignored.  If all rotations are zero, the
*  identity matrix is produced.
*
*  P.T.Wallace   Starlink   23 May 1997
*
*  Copyright (C) 1997 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      CHARACTER*(*) ORDER
      DOUBLE PRECISION PHI,THETA,PSI,RMAT(3,3)

      INTEGER J,I,L,N,K
      DOUBLE PRECISION RESULT(3,3),ROTN(3,3),ANGLE,S,C,W,WM(3,3)
      CHARACTER AXIS



*  Initialize result matrix
      DO J=1,3
         DO I=1,3
            IF (I.NE.J) THEN
               RESULT(I,J) = 0D0
            ELSE
               RESULT(I,J) = 1D0
            END IF
         END DO
      END DO

*  Establish length of axis string
      L = LEN(ORDER)

*  Look at each character of axis string until finished
      DO N=1,3
         IF (N.LE.L) THEN

*        Initialize rotation matrix for the current rotation
            DO J=1,3
               DO I=1,3
                  IF (I.NE.J) THEN
                     ROTN(I,J) = 0D0
                  ELSE
                     ROTN(I,J) = 1D0
                  END IF
               END DO
            END DO

*        Pick up the appropriate Euler angle and take sine & cosine
            IF (N.EQ.1) THEN
               ANGLE = PHI
            ELSE IF (N.EQ.2) THEN
               ANGLE = THETA
            ELSE
               ANGLE = PSI
            END IF
            S = SIN(ANGLE)
            C = COS(ANGLE)

*        Identify the axis
            AXIS = ORDER(N:N)
            IF (AXIS.EQ.'X'.OR.
     :          AXIS.EQ.'x'.OR.
     :          AXIS.EQ.'1') THEN

*           Matrix for x-rotation
               ROTN(2,2) = C
               ROTN(2,3) = S
               ROTN(3,2) = -S
               ROTN(3,3) = C

            ELSE IF (AXIS.EQ.'Y'.OR.
     :               AXIS.EQ.'y'.OR.
     :               AXIS.EQ.'2') THEN

*           Matrix for y-rotation
               ROTN(1,1) = C
               ROTN(1,3) = -S
               ROTN(3,1) = S
               ROTN(3,3) = C

            ELSE IF (AXIS.EQ.'Z'.OR.
     :               AXIS.EQ.'z'.OR.
     :               AXIS.EQ.'3') THEN

*           Matrix for z-rotation
               ROTN(1,1) = C
               ROTN(1,2) = S
               ROTN(2,1) = -S
               ROTN(2,2) = C

            ELSE

*           Unrecognized character - fake end of string
               L = 0

            END IF

*        Apply the current rotation (matrix ROTN x matrix RESULT)
            DO I=1,3
               DO J=1,3
                  W = 0D0
                  DO K=1,3
                     W = W+ROTN(I,K)*RESULT(K,J)
                  END DO
                  WM(I,J) = W
               END DO
            END DO
            DO J=1,3
               DO I=1,3
                  RESULT(I,J) = WM(I,J)
               END DO
            END DO

         END IF

      END DO

*  Copy the result
      DO J=1,3
         DO I=1,3
            RMAT(I,J) = RESULT(I,J)
         END DO
      END DO

      END
      SUBROUTINE sla_DMOON (DATE, PV)
*+
*     - - - - - -
*      D M O O N
*     - - - - - -
*
*  Approximate geocentric position and velocity of the Moon
*  (double precision)
*
*  Given:
*     DATE       D       TDB (loosely ET) as a Modified Julian Date
*                                                    (JD-2400000.5)
*
*  Returned:
*     PV         D(6)    Moon x,y,z,xdot,ydot,zdot, mean equator and
*                                         equinox of date (AU, AU/s)
*
*  Notes:
*
*  1  This routine is a full implementation of the algorithm
*     published by Meeus (see reference).
*
*  2  Meeus quotes accuracies of 10 arcsec in longitude, 3 arcsec in
*     latitude and 0.2 arcsec in HP (equivalent to about 20 km in
*     distance).  Comparison with JPL DE200 over the interval
*     1960-2025 gives RMS errors of 3.7 arcsec and 83 mas/hour in
*     longitude, 2.3 arcsec and 48 mas/hour in latitude, 11 km
*     and 81 mm/s in distance.  The maximum errors over the same
*     interval are 18 arcsec and 0.50 arcsec/hour in longitude,
*     11 arcsec and 0.24 arcsec/hour in latitude, 40 km and 0.29 m/s
*     in distance.
*
*  3  The original algorithm is expressed in terms of the obsolete
*     timescale Ephemeris Time.  Either TDB or TT can be used, but
*     not UT without incurring significant errors (30 arcsec at
*     the present time) due to the Moon's 0.5 arcsec/sec movement.
*
*  4  The algorithm is based on pre IAU 1976 standards.  However,
*     the result has been moved onto the new (FK5) equinox, an
*     adjustment which is in any case much smaller than the
*     intrinsic accuracy of the procedure.
*
*  5  Velocity is obtained by a complete analytical differentiation
*     of the Meeus model.
*
*  Reference:
*     Meeus, l'Astronomie, June 1984, p348.
*
*  P.T.Wallace   Starlink   22 January 1998
*
*  Copyright (C) 1998 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,PV(6)

*  Degrees, arcseconds and seconds of time to radians
      DOUBLE PRECISION D2R,DAS2R,DS2R
      PARAMETER (D2R=0.0174532925199432957692369D0,
     :           DAS2R=4.848136811095359935899141D-6,
     :           DS2R=7.272205216643039903848712D-5)

*  Seconds per Julian century (86400*36525)
      DOUBLE PRECISION CJ
      PARAMETER (CJ=3155760000D0)

*  Julian epoch of B1950
      DOUBLE PRECISION B1950
      PARAMETER (B1950=1949.9997904423D0)

*  Earth equatorial radius in AU ( = 6378.137 / 149597870 )
      DOUBLE PRECISION ERADAU
      PARAMETER (ERADAU=4.2635212653763D-5)

      DOUBLE PRECISION T,THETA,SINOM,COSOM,DOMCOM,WA,DWA,WB,DWB,WOM,
     :                 DWOM,SINWOM,COSWOM,V,DV,COEFF,EMN,EMPN,DN,FN,EN,
     :                 DEN,DTHETA,FTHETA,EL,DEL,B,DB,BF,DBF,P,DP,SP,R,
     :                 DR,X,Y,Z,XD,YD,ZD,SEL,CEL,SB,CB,RCB,RBD,W,EPJ,
     :                 EQCOR,EPS,SINEPS,COSEPS,ES,EC
      INTEGER N,I

*
*  Coefficients for fundamental arguments
*
*   at J1900:  T**0, T**1, T**2, T**3
*   at epoch:  T**0, T**1
*
*  Units are degrees for position and Julian centuries for time
*

*  Moon's mean longitude
      DOUBLE PRECISION ELP0,ELP1,ELP2,ELP3,ELP,DELP
      PARAMETER (ELP0=270.434164D0,
     :           ELP1=481267.8831D0,
     :           ELP2=-0.001133D0,
     :           ELP3=0.0000019D0)

*  Sun's mean anomaly
      DOUBLE PRECISION EM0,EM1,EM2,EM3,EM,DEM
      PARAMETER (EM0=358.475833D0,
     :           EM1=35999.0498D0,
     :           EM2=-0.000150D0,
     :           EM3=-0.0000033D0)

*  Moon's mean anomaly
      DOUBLE PRECISION EMP0,EMP1,EMP2,EMP3,EMP,DEMP
      PARAMETER (EMP0=296.104608D0,
     :           EMP1=477198.8491D0,
     :           EMP2=0.009192D0,
     :           EMP3=0.0000144D0)

*  Moon's mean elongation
      DOUBLE PRECISION D0,D1,D2,D3,D,DD
      PARAMETER (D0=350.737486D0,
     :           D1=445267.1142D0,
     :           D2=-0.001436D0,
     :           D3=0.0000019D0)

*  Mean distance of the Moon from its ascending node
      DOUBLE PRECISION F0,F1,F2,F3,F,DF
      PARAMETER (F0=11.250889D0,
     :           F1=483202.0251D0,
     :           F2=-0.003211D0,
     :           F3=-0.0000003D0)

*  Longitude of the Moon's ascending node
      DOUBLE PRECISION OM0,OM1,OM2,OM3,OM,DOM
      PARAMETER (OM0=259.183275D0,
     :           OM1=-1934.1420D0,
     :           OM2=0.002078D0,
     :           OM3=0.0000022D0)

*  Coefficients for (dimensionless) E factor
      DOUBLE PRECISION E1,E2,E,DE,ESQ,DESQ
      PARAMETER (E1=-0.002495D0,E2=-0.00000752D0)

*  Coefficients for periodic variations etc
      DOUBLE PRECISION PAC,PA0,PA1
      PARAMETER (PAC=0.000233D0,PA0=51.2D0,PA1=20.2D0)
      DOUBLE PRECISION PBC
      PARAMETER (PBC=-0.001778D0)
      DOUBLE PRECISION PCC
      PARAMETER (PCC=0.000817D0)
      DOUBLE PRECISION PDC
      PARAMETER (PDC=0.002011D0)
      DOUBLE PRECISION PEC,PE0,PE1,PE2
      PARAMETER (PEC=0.003964D0,
     :                     PE0=346.560D0,PE1=132.870D0,PE2=-0.0091731D0)
      DOUBLE PRECISION PFC
      PARAMETER (PFC=0.001964D0)
      DOUBLE PRECISION PGC
      PARAMETER (PGC=0.002541D0)
      DOUBLE PRECISION PHC
      PARAMETER (PHC=0.001964D0)
      DOUBLE PRECISION PIC
      PARAMETER (PIC=-0.024691D0)
      DOUBLE PRECISION PJC,PJ0,PJ1
      PARAMETER (PJC=-0.004328D0,PJ0=275.05D0,PJ1=-2.30D0)
      DOUBLE PRECISION CW1
      PARAMETER (CW1=0.0004664D0)
      DOUBLE PRECISION CW2
      PARAMETER (CW2=0.0000754D0)

*
*  Coefficients for Moon position
*
*   Tx(N)       = coefficient of L, B or P term (deg)
*   ITx(N,1-5)  = coefficients of M, M', D, F, E**n in argument
*
      INTEGER NL,NB,NP
      PARAMETER (NL=50,NB=45,NP=31)
      DOUBLE PRECISION TL(NL),TB(NB),TP(NP)
      INTEGER ITL(5,NL),ITB(5,NB),ITP(5,NP)
*
*  Longitude
*                                         M   M'  D   F   n
      DATA TL( 1)/            +6.288750D0                     /,
     :     (ITL(I, 1),I=1,5)/            +0, +1, +0, +0,  0   /
      DATA TL( 2)/            +1.274018D0                     /,
     :     (ITL(I, 2),I=1,5)/            +0, -1, +2, +0,  0   /
      DATA TL( 3)/            +0.658309D0                     /,
     :     (ITL(I, 3),I=1,5)/            +0, +0, +2, +0,  0   /
      DATA TL( 4)/            +0.213616D0                     /,
     :     (ITL(I, 4),I=1,5)/            +0, +2, +0, +0,  0   /
      DATA TL( 5)/            -0.185596D0                     /,
     :     (ITL(I, 5),I=1,5)/            +1, +0, +0, +0,  1   /
      DATA TL( 6)/            -0.114336D0                     /,
     :     (ITL(I, 6),I=1,5)/            +0, +0, +0, +2,  0   /
      DATA TL( 7)/            +0.058793D0                     /,
     :     (ITL(I, 7),I=1,5)/            +0, -2, +2, +0,  0   /
      DATA TL( 8)/            +0.057212D0                     /,
     :     (ITL(I, 8),I=1,5)/            -1, -1, +2, +0,  1   /
      DATA TL( 9)/            +0.053320D0                     /,
     :     (ITL(I, 9),I=1,5)/            +0, +1, +2, +0,  0   /
      DATA TL(10)/            +0.045874D0                     /,
     :     (ITL(I,10),I=1,5)/            -1, +0, +2, +0,  1   /
      DATA TL(11)/            +0.041024D0                     /,
     :     (ITL(I,11),I=1,5)/            -1, +1, +0, +0,  1   /
      DATA TL(12)/            -0.034718D0                     /,
     :     (ITL(I,12),I=1,5)/            +0, +0, +1, +0,  0   /
      DATA TL(13)/            -0.030465D0                     /,
     :     (ITL(I,13),I=1,5)/            +1, +1, +0, +0,  1   /
      DATA TL(14)/            +0.015326D0                     /,
     :     (ITL(I,14),I=1,5)/            +0, +0, +2, -2,  0   /
      DATA TL(15)/            -0.012528D0                     /,
     :     (ITL(I,15),I=1,5)/            +0, +1, +0, +2,  0   /
      DATA TL(16)/            -0.010980D0                     /,
     :     (ITL(I,16),I=1,5)/            +0, -1, +0, +2,  0   /
      DATA TL(17)/            +0.010674D0                     /,
     :     (ITL(I,17),I=1,5)/            +0, -1, +4, +0,  0   /
      DATA TL(18)/            +0.010034D0                     /,
     :     (ITL(I,18),I=1,5)/            +0, +3, +0, +0,  0   /
      DATA TL(19)/            +0.008548D0                     /,
     :     (ITL(I,19),I=1,5)/            +0, -2, +4, +0,  0   /
      DATA TL(20)/            -0.007910D0                     /,
     :     (ITL(I,20),I=1,5)/            +1, -1, +2, +0,  1   /
      DATA TL(21)/            -0.006783D0                     /,
     :     (ITL(I,21),I=1,5)/            +1, +0, +2, +0,  1   /
      DATA TL(22)/            +0.005162D0                     /,
     :     (ITL(I,22),I=1,5)/            +0, +1, -1, +0,  0   /
      DATA TL(23)/            +0.005000D0                     /,
     :     (ITL(I,23),I=1,5)/            +1, +0, +1, +0,  1   /
      DATA TL(24)/            +0.004049D0                     /,
     :     (ITL(I,24),I=1,5)/            -1, +1, +2, +0,  1   /
      DATA TL(25)/            +0.003996D0                     /,
     :     (ITL(I,25),I=1,5)/            +0, +2, +2, +0,  0   /
      DATA TL(26)/            +0.003862D0                     /,
     :     (ITL(I,26),I=1,5)/            +0, +0, +4, +0,  0   /
      DATA TL(27)/            +0.003665D0                     /,
     :     (ITL(I,27),I=1,5)/            +0, -3, +2, +0,  0   /
      DATA TL(28)/            +0.002695D0                     /,
     :     (ITL(I,28),I=1,5)/            -1, +2, +0, +0,  1   /
      DATA TL(29)/            +0.002602D0                     /,
     :     (ITL(I,29),I=1,5)/            +0, +1, -2, -2,  0   /
      DATA TL(30)/            +0.002396D0                     /,
     :     (ITL(I,30),I=1,5)/            -1, -2, +2, +0,  1   /
      DATA TL(31)/            -0.002349D0                     /,
     :     (ITL(I,31),I=1,5)/            +0, +1, +1, +0,  0   /
      DATA TL(32)/            +0.002249D0                     /,
     :     (ITL(I,32),I=1,5)/            -2, +0, +2, +0,  2   /
      DATA TL(33)/            -0.002125D0                     /,
     :     (ITL(I,33),I=1,5)/            +1, +2, +0, +0,  1   /
      DATA TL(34)/            -0.002079D0                     /,
     :     (ITL(I,34),I=1,5)/            +2, +0, +0, +0,  2   /
      DATA TL(35)/            +0.002059D0                     /,
     :     (ITL(I,35),I=1,5)/            -2, -1, +2, +0,  2   /
      DATA TL(36)/            -0.001773D0                     /,
     :     (ITL(I,36),I=1,5)/            +0, +1, +2, -2,  0   /
      DATA TL(37)/            -0.001595D0                     /,
     :     (ITL(I,37),I=1,5)/            +0, +0, +2, +2,  0   /
      DATA TL(38)/            +0.001220D0                     /,
     :     (ITL(I,38),I=1,5)/            -1, -1, +4, +0,  1   /
      DATA TL(39)/            -0.001110D0                     /,
     :     (ITL(I,39),I=1,5)/            +0, +2, +0, +2,  0   /
      DATA TL(40)/            +0.000892D0                     /,
     :     (ITL(I,40),I=1,5)/            +0, +1, -3, +0,  0   /
      DATA TL(41)/            -0.000811D0                     /,
     :     (ITL(I,41),I=1,5)/            +1, +1, +2, +0,  1   /
      DATA TL(42)/            +0.000761D0                     /,
     :     (ITL(I,42),I=1,5)/            -1, -2, +4, +0,  1   /
      DATA TL(43)/            +0.000717D0                     /,
     :     (ITL(I,43),I=1,5)/            -2, +1, +0, +0,  2   /
      DATA TL(44)/            +0.000704D0                     /,
     :     (ITL(I,44),I=1,5)/            -2, +1, -2, +0,  2   /
      DATA TL(45)/            +0.000693D0                     /,
     :     (ITL(I,45),I=1,5)/            +1, -2, +2, +0,  1   /
      DATA TL(46)/            +0.000598D0                     /,
     :     (ITL(I,46),I=1,5)/            -1, +0, +2, -2,  1   /
      DATA TL(47)/            +0.000550D0                     /,
     :     (ITL(I,47),I=1,5)/            +0, +1, +4, +0,  0   /
      DATA TL(48)/            +0.000538D0                     /,
     :     (ITL(I,48),I=1,5)/            +0, +4, +0, +0,  0   /
      DATA TL(49)/            +0.000521D0                     /,
     :     (ITL(I,49),I=1,5)/            -1, +0, +4, +0,  1   /
      DATA TL(50)/            +0.000486D0                     /,
     :     (ITL(I,50),I=1,5)/            +0, +2, -1, +0,  0   /
*
*  Latitude
*                                         M   M'  D   F   n
      DATA TB( 1)/            +5.128189D0                     /,
     :     (ITB(I, 1),I=1,5)/            +0, +0, +0, +1,  0   /
      DATA TB( 2)/            +0.280606D0                     /,
     :     (ITB(I, 2),I=1,5)/            +0, +1, +0, +1,  0   /
      DATA TB( 3)/            +0.277693D0                     /,
     :     (ITB(I, 3),I=1,5)/            +0, +1, +0, -1,  0   /
      DATA TB( 4)/            +0.173238D0                     /,
     :     (ITB(I, 4),I=1,5)/            +0, +0, +2, -1,  0   /
      DATA TB( 5)/            +0.055413D0                     /,
     :     (ITB(I, 5),I=1,5)/            +0, -1, +2, +1,  0   /
      DATA TB( 6)/            +0.046272D0                     /,
     :     (ITB(I, 6),I=1,5)/            +0, -1, +2, -1,  0   /
      DATA TB( 7)/            +0.032573D0                     /,
     :     (ITB(I, 7),I=1,5)/            +0, +0, +2, +1,  0   /
      DATA TB( 8)/            +0.017198D0                     /,
     :     (ITB(I, 8),I=1,5)/            +0, +2, +0, +1,  0   /
      DATA TB( 9)/            +0.009267D0                     /,
     :     (ITB(I, 9),I=1,5)/            +0, +1, +2, -1,  0   /
      DATA TB(10)/            +0.008823D0                     /,
     :     (ITB(I,10),I=1,5)/            +0, +2, +0, -1,  0   /
      DATA TB(11)/            +0.008247D0                     /,
     :     (ITB(I,11),I=1,5)/            -1, +0, +2, -1,  1   /
      DATA TB(12)/            +0.004323D0                     /,
     :     (ITB(I,12),I=1,5)/            +0, -2, +2, -1,  0   /
      DATA TB(13)/            +0.004200D0                     /,
     :     (ITB(I,13),I=1,5)/            +0, +1, +2, +1,  0   /
      DATA TB(14)/            +0.003372D0                     /,
     :     (ITB(I,14),I=1,5)/            -1, +0, -2, +1,  1   /
      DATA TB(15)/            +0.002472D0                     /,
     :     (ITB(I,15),I=1,5)/            -1, -1, +2, +1,  1   /
      DATA TB(16)/            +0.002222D0                     /,
     :     (ITB(I,16),I=1,5)/            -1, +0, +2, +1,  1   /
      DATA TB(17)/            +0.002072D0                     /,
     :     (ITB(I,17),I=1,5)/            -1, -1, +2, -1,  1   /
      DATA TB(18)/            +0.001877D0                     /,
     :     (ITB(I,18),I=1,5)/            -1, +1, +0, +1,  1   /
      DATA TB(19)/            +0.001828D0                     /,
     :     (ITB(I,19),I=1,5)/            +0, -1, +4, -1,  0   /
      DATA TB(20)/            -0.001803D0                     /,
     :     (ITB(I,20),I=1,5)/            +1, +0, +0, +1,  1   /
      DATA TB(21)/            -0.001750D0                     /,
     :     (ITB(I,21),I=1,5)/            +0, +0, +0, +3,  0   /
      DATA TB(22)/            +0.001570D0                     /,
     :     (ITB(I,22),I=1,5)/            -1, +1, +0, -1,  1   /
      DATA TB(23)/            -0.001487D0                     /,
     :     (ITB(I,23),I=1,5)/            +0, +0, +1, +1,  0   /
      DATA TB(24)/            -0.001481D0                     /,
     :     (ITB(I,24),I=1,5)/            +1, +1, +0, +1,  1   /
      DATA TB(25)/            +0.001417D0                     /,
     :     (ITB(I,25),I=1,5)/            -1, -1, +0, +1,  1   /
      DATA TB(26)/            +0.001350D0                     /,
     :     (ITB(I,26),I=1,5)/            -1, +0, +0, +1,  1   /
      DATA TB(27)/            +0.001330D0                     /,
     :     (ITB(I,27),I=1,5)/            +0, +0, -1, +1,  0   /
      DATA TB(28)/            +0.001106D0                     /,
     :     (ITB(I,28),I=1,5)/            +0, +3, +0, +1,  0   /
      DATA TB(29)/            +0.001020D0                     /,
     :     (ITB(I,29),I=1,5)/            +0, +0, +4, -1,  0   /
      DATA TB(30)/            +0.000833D0                     /,
     :     (ITB(I,30),I=1,5)/            +0, -1, +4, +1,  0   /
      DATA TB(31)/            +0.000781D0                     /,
     :     (ITB(I,31),I=1,5)/            +0, +1, +0, -3,  0   /
      DATA TB(32)/            +0.000670D0                     /,
     :     (ITB(I,32),I=1,5)/            +0, -2, +4, +1,  0   /
      DATA TB(33)/            +0.000606D0                     /,
     :     (ITB(I,33),I=1,5)/            +0, +0, +2, -3,  0   /
      DATA TB(34)/            +0.000597D0                     /,
     :     (ITB(I,34),I=1,5)/            +0, +2, +2, -1,  0   /
      DATA TB(35)/            +0.000492D0                     /,
     :     (ITB(I,35),I=1,5)/            -1, +1, +2, -1,  1   /
      DATA TB(36)/            +0.000450D0                     /,
     :     (ITB(I,36),I=1,5)/            +0, +2, -2, -1,  0   /
      DATA TB(37)/            +0.000439D0                     /,
     :     (ITB(I,37),I=1,5)/            +0, +3, +0, -1,  0   /
      DATA TB(38)/            +0.000423D0                     /,
     :     (ITB(I,38),I=1,5)/            +0, +2, +2, +1,  0   /
      DATA TB(39)/            +0.000422D0                     /,
     :     (ITB(I,39),I=1,5)/            +0, -3, +2, -1,  0   /
      DATA TB(40)/            -0.000367D0                     /,
     :     (ITB(I,40),I=1,5)/            +1, -1, +2, +1,  1   /
      DATA TB(41)/            -0.000353D0                     /,
     :     (ITB(I,41),I=1,5)/            +1, +0, +2, +1,  1   /
      DATA TB(42)/            +0.000331D0                     /,
     :     (ITB(I,42),I=1,5)/            +0, +0, +4, +1,  0   /
      DATA TB(43)/            +0.000317D0                     /,
     :     (ITB(I,43),I=1,5)/            -1, +1, +2, +1,  1   /
      DATA TB(44)/            +0.000306D0                     /,
     :     (ITB(I,44),I=1,5)/            -2, +0, +2, -1,  2   /
      DATA TB(45)/            -0.000283D0                     /,
     :     (ITB(I,45),I=1,5)/            +0, +1, +0, +3,  0   /
*
*  Parallax
*                                         M   M'  D   F   n
      DATA TP( 1)/            +0.950724D0                     /,
     :     (ITP(I, 1),I=1,5)/            +0, +0, +0, +0,  0   /
      DATA TP( 2)/            +0.051818D0                     /,
     :     (ITP(I, 2),I=1,5)/            +0, +1, +0, +0,  0   /
      DATA TP( 3)/            +0.009531D0                     /,
     :     (ITP(I, 3),I=1,5)/            +0, -1, +2, +0,  0   /
      DATA TP( 4)/            +0.007843D0                     /,
     :     (ITP(I, 4),I=1,5)/            +0, +0, +2, +0,  0   /
      DATA TP( 5)/            +0.002824D0                     /,
     :     (ITP(I, 5),I=1,5)/            +0, +2, +0, +0,  0   /
      DATA TP( 6)/            +0.000857D0                     /,
     :     (ITP(I, 6),I=1,5)/            +0, +1, +2, +0,  0   /
      DATA TP( 7)/            +0.000533D0                     /,
     :     (ITP(I, 7),I=1,5)/            -1, +0, +2, +0,  1   /
      DATA TP( 8)/            +0.000401D0                     /,
     :     (ITP(I, 8),I=1,5)/            -1, -1, +2, +0,  1   /
      DATA TP( 9)/            +0.000320D0                     /,
     :     (ITP(I, 9),I=1,5)/            -1, +1, +0, +0,  1   /
      DATA TP(10)/            -0.000271D0                     /,
     :     (ITP(I,10),I=1,5)/            +0, +0, +1, +0,  0   /
      DATA TP(11)/            -0.000264D0                     /,
     :     (ITP(I,11),I=1,5)/            +1, +1, +0, +0,  1   /
      DATA TP(12)/            -0.000198D0                     /,
     :     (ITP(I,12),I=1,5)/            +0, -1, +0, +2,  0   /
      DATA TP(13)/            +0.000173D0                     /,
     :     (ITP(I,13),I=1,5)/            +0, +3, +0, +0,  0   /
      DATA TP(14)/            +0.000167D0                     /,
     :     (ITP(I,14),I=1,5)/            +0, -1, +4, +0,  0   /
      DATA TP(15)/            -0.000111D0                     /,
     :     (ITP(I,15),I=1,5)/            +1, +0, +0, +0,  1   /
      DATA TP(16)/            +0.000103D0                     /,
     :     (ITP(I,16),I=1,5)/            +0, -2, +4, +0,  0   /
      DATA TP(17)/            -0.000084D0                     /,
     :     (ITP(I,17),I=1,5)/            +0, +2, -2, +0,  0   /
      DATA TP(18)/            -0.000083D0                     /,
     :     (ITP(I,18),I=1,5)/            +1, +0, +2, +0,  1   /
      DATA TP(19)/            +0.000079D0                     /,
     :     (ITP(I,19),I=1,5)/            +0, +2, +2, +0,  0   /
      DATA TP(20)/            +0.000072D0                     /,
     :     (ITP(I,20),I=1,5)/            +0, +0, +4, +0,  0   /
      DATA TP(21)/            +0.000064D0                     /,
     :     (ITP(I,21),I=1,5)/            -1, +1, +2, +0,  1   /
      DATA TP(22)/            -0.000063D0                     /,
     :     (ITP(I,22),I=1,5)/            +1, -1, +2, +0,  1   /
      DATA TP(23)/            +0.000041D0                     /,
     :     (ITP(I,23),I=1,5)/            +1, +0, +1, +0,  1   /
      DATA TP(24)/            +0.000035D0                     /,
     :     (ITP(I,24),I=1,5)/            -1, +2, +0, +0,  1   /
      DATA TP(25)/            -0.000033D0                     /,
     :     (ITP(I,25),I=1,5)/            +0, +3, -2, +0,  0   /
      DATA TP(26)/            -0.000030D0                     /,
     :     (ITP(I,26),I=1,5)/            +0, +1, +1, +0,  0   /
      DATA TP(27)/            -0.000029D0                     /,
     :     (ITP(I,27),I=1,5)/            +0, +0, -2, +2,  0   /
      DATA TP(28)/            -0.000029D0                     /,
     :     (ITP(I,28),I=1,5)/            +1, +2, +0, +0,  1   /
      DATA TP(29)/            +0.000026D0                     /,
     :     (ITP(I,29),I=1,5)/            -2, +0, +2, +0,  2   /
      DATA TP(30)/            -0.000023D0                     /,
     :     (ITP(I,30),I=1,5)/            +0, +1, -2, +2,  0   /
      DATA TP(31)/            +0.000019D0                     /,
     :     (ITP(I,31),I=1,5)/            -1, -1, +4, +0,  1   /



*  Centuries since J1900
      T=(DATE-15019.5D0)/36525D0

*
*  Fundamental arguments (radians) and derivatives (radians per
*  Julian century) for the current epoch
*

*  Moon's mean longitude
      ELP=D2R*MOD(ELP0+(ELP1+(ELP2+ELP3*T)*T)*T,360D0)
      DELP=D2R*(ELP1+(2D0*ELP2+3D0*ELP3*T)*T)

*  Sun's mean anomaly
      EM=D2R*MOD(EM0+(EM1+(EM2+EM3*T)*T)*T,360D0)
      DEM=D2R*(EM1+(2D0*EM2+3D0*EM3*T)*T)

*  Moon's mean anomaly
      EMP=D2R*MOD(EMP0+(EMP1+(EMP2+EMP3*T)*T)*T,360D0)
      DEMP=D2R*(EMP1+(2D0*EMP2+3D0*EMP3*T)*T)

*  Moon's mean elongation
      D=D2R*MOD(D0+(D1+(D2+D3*T)*T)*T,360D0)
      DD=D2R*(D1+(2D0*D2+3D0*D3*T)*T)

*  Mean distance of the Moon from its ascending node
      F=D2R*MOD(F0+(F1+(F2+F3*T)*T)*T,360D0)
      DF=D2R*(F1+(2D0*F2+3D0*F3*T)*T)

*  Longitude of the Moon's ascending node
      OM=D2R*MOD(OM0+(OM1+(OM2+OM3*T)*T)*T,360D0)
      DOM=D2R*(OM1+(2D0*OM2+3D0*OM3*T)*T)
      SINOM=SIN(OM)
      COSOM=COS(OM)
      DOMCOM=DOM*COSOM

*  Add the periodic variations
      THETA=D2R*(PA0+PA1*T)
      WA=SIN(THETA)
      DWA=D2R*PA1*COS(THETA)
      THETA=D2R*(PE0+(PE1+PE2*T)*T)
      WB=PEC*SIN(THETA)
      DWB=D2R*PEC*(PE1+2D0*PE2*T)*COS(THETA)
      ELP=ELP+D2R*(PAC*WA+WB+PFC*SINOM)
      DELP=DELP+D2R*(PAC*DWA+DWB+PFC*DOMCOM)
      EM=EM+D2R*PBC*WA
      DEM=DEM+D2R*PBC*DWA
      EMP=EMP+D2R*(PCC*WA+WB+PGC*SINOM)
      DEMP=DEMP+D2R*(PCC*DWA+DWB+PGC*DOMCOM)
      D=D+D2R*(PDC*WA+WB+PHC*SINOM)
      DD=DD+D2R*(PDC*DWA+DWB+PHC*DOMCOM)
      WOM=OM+D2R*(PJ0+PJ1*T)
      DWOM=DOM+D2R*PJ1
      SINWOM=SIN(WOM)
      COSWOM=COS(WOM)
      F=F+D2R*(WB+PIC*SINOM+PJC*SINWOM)
      DF=DF+D2R*(DWB+PIC*DOMCOM+PJC*DWOM*COSWOM)

*  E-factor, and square
      E=1D0+(E1+E2*T)*T
      DE=E1+2D0*E2*T
      ESQ=E*E
      DESQ=2D0*E*DE

*
*  Series expansions
*

*  Longitude
      V=0D0
      DV=0D0
      DO N=NL,1,-1
         COEFF=TL(N)
         EMN=DBLE(ITL(1,N))
         EMPN=DBLE(ITL(2,N))
         DN=DBLE(ITL(3,N))
         FN=DBLE(ITL(4,N))
         I=ITL(5,N)
         IF (I.EQ.0) THEN
            EN=1D0
            DEN=0D0
         ELSE IF (I.EQ.1) THEN
            EN=E
            DEN=DE
         ELSE
            EN=ESQ
            DEN=DESQ
         END IF
         THETA=EMN*EM+EMPN*EMP+DN*D+FN*F
         DTHETA=EMN*DEM+EMPN*DEMP+DN*DD+FN*DF
         FTHETA=SIN(THETA)
         V=V+COEFF*FTHETA*EN
         DV=DV+COEFF*(COS(THETA)*DTHETA*EN+FTHETA*DEN)
      END DO
      EL=ELP+D2R*V
      DEL=(DELP+D2R*DV)/CJ

*  Latitude
      V=0D0
      DV=0D0
      DO N=NB,1,-1
         COEFF=TB(N)
         EMN=DBLE(ITB(1,N))
         EMPN=DBLE(ITB(2,N))
         DN=DBLE(ITB(3,N))
         FN=DBLE(ITB(4,N))
         I=ITB(5,N)
         IF (I.EQ.0) THEN
            EN=1D0
            DEN=0D0
         ELSE IF (I.EQ.1) THEN
            EN=E
            DEN=DE
         ELSE
            EN=ESQ
            DEN=DESQ
         END IF
         THETA=EMN*EM+EMPN*EMP+DN*D+FN*F
         DTHETA=EMN*DEM+EMPN*DEMP+DN*DD+FN*DF
         FTHETA=SIN(THETA)
         V=V+COEFF*FTHETA*EN
         DV=DV+COEFF*(COS(THETA)*DTHETA*EN+FTHETA*DEN)
      END DO
      BF=1D0-CW1*COSOM-CW2*COSWOM
      DBF=CW1*DOM*SINOM+CW2*DWOM*SINWOM
      B=D2R*V*BF
      DB=D2R*(DV*BF+V*DBF)/CJ

*  Parallax
      V=0D0
      DV=0D0
      DO N=NP,1,-1
         COEFF=TP(N)
         EMN=DBLE(ITP(1,N))
         EMPN=DBLE(ITP(2,N))
         DN=DBLE(ITP(3,N))
         FN=DBLE(ITP(4,N))
         I=ITP(5,N)
         IF (I.EQ.0) THEN
            EN=1D0
            DEN=0D0
         ELSE IF (I.EQ.1) THEN
            EN=E
            DEN=DE
         ELSE
            EN=ESQ
            DEN=DESQ
         END IF
         THETA=EMN*EM+EMPN*EMP+DN*D+FN*F
         DTHETA=EMN*DEM+EMPN*DEMP+DN*DD+FN*DF
         FTHETA=COS(THETA)
         V=V+COEFF*FTHETA*EN
         DV=DV+COEFF*(-SIN(THETA)*DTHETA*EN+FTHETA*DEN)
      END DO
      P=D2R*V
      DP=D2R*DV/CJ

*
*  Transformation into final form
*

*  Parallax to distance (AU, AU/sec)
      SP=SIN(P)
      R=ERADAU/SP
      DR=-R*DP*COS(P)/SP

*  Longitude, latitude to x,y,z (AU)
      SEL=SIN(EL)
      CEL=COS(EL)
      SB=SIN(B)
      CB=COS(B)
      RCB=R*CB
      RBD=R*DB
      W=RBD*SB-CB*DR
      X=RCB*CEL
      Y=RCB*SEL
      Z=R*SB
      XD=-Y*DEL-W*CEL
      YD=X*DEL-W*SEL
      ZD=RBD*CB+SB*DR

*  Julian centuries since J2000
      T=(DATE-51544.5D0)/36525D0

*  Fricke equinox correction
      EPJ=2000D0+T*100D0
      EQCOR=DS2R*(0.035D0+0.00085D0*(EPJ-B1950))

*  Mean obliquity (IAU 1976)
      EPS=DAS2R*(84381.448D0+(-46.8150D0+(-0.00059D0+0.001813D0*T)*T)*T)

*  To the equatorial system, mean of date, FK5 system
      SINEPS=SIN(EPS)
      COSEPS=COS(EPS)
      ES=EQCOR*SINEPS
      EC=EQCOR*COSEPS
      PV(1)=X-EC*Y+ES*Z
      PV(2)=EQCOR*X+Y*COSEPS-Z*SINEPS
      PV(3)=Y*SINEPS+Z*COSEPS
      PV(4)=XD-EC*YD+ES*ZD
      PV(5)=EQCOR*XD+YD*COSEPS-ZD*SINEPS
      PV(6)=YD*SINEPS+ZD*COSEPS

      END
      SUBROUTINE sla_DMXV (DM, VA, VB)
*+
*     - - - - -
*      D M X V
*     - - - - -
*
*  Performs the 3-D forward unitary transformation:
*
*     vector VB = matrix DM * vector VA
*
*  (double precision)
*
*  Given:
*     DM       dp(3,3)    matrix
*     VA       dp(3)      vector
*
*  Returned:
*     VB       dp(3)      result vector
*
*  To comply with the ANSI Fortran 77 standard, VA and VB must be
*  different arrays.  However, the routine is coded so as to work
*  properly on many platforms even if this rule is violated.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DM(3,3),VA(3),VB(3)

      INTEGER I,J
      DOUBLE PRECISION W,VW(3)


*  Matrix DM * vector VA -> vector VW
      DO J=1,3
         W=0D0
         DO I=1,3
            W=W+DM(J,I)*VA(I)
         END DO
         VW(J)=W
      END DO

*  Vector VW -> vector VB
      DO J=1,3
         VB(J)=VW(J)
      END DO

      END
      DOUBLE PRECISION FUNCTION sla_DRANGE (ANGLE)
*+
*     - - - - - - -
*      D R A N G E
*     - - - - - - -
*
*  Normalize angle into range +/- pi  (double precision)
*
*  Given:
*     ANGLE     dp      the angle in radians
*
*  The result (double precision) is ANGLE expressed in the range +/- pi.
*
*  P.T.Wallace   Starlink   23 November 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION ANGLE

      DOUBLE PRECISION DPI,D2PI
      PARAMETER (DPI=3.141592653589793238462643D0)
      PARAMETER (D2PI=6.283185307179586476925287D0)


      sla_DRANGE=MOD(ANGLE,D2PI)
      IF (ABS(sla_DRANGE).GE.DPI)
     :          sla_DRANGE=sla_DRANGE-SIGN(D2PI,ANGLE)

      END
      DOUBLE PRECISION FUNCTION sla_DRANRM (ANGLE)
*+
*     - - - - - - -
*      D R A N R M
*     - - - - - - -
*
*  Normalize angle into range 0-2 pi  (double precision)
*
*  Given:
*     ANGLE     dp      the angle in radians
*
*  The result is ANGLE expressed in the range 0-2 pi.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION ANGLE

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)


      sla_DRANRM = MOD(ANGLE,D2PI)
      IF (sla_DRANRM.LT.0D0) sla_DRANRM = sla_DRANRM+D2PI

      END
      DOUBLE PRECISION FUNCTION sla_DTT (UTC)
*+
*     - - - -
*      D T T
*     - - - -
*
*  Increment to be applied to Coordinated Universal Time UTC to give
*  Terrestrial Time TT (formerly Ephemeris Time ET)
*
*  (double precision)
*
*  Given:
*     UTC      d      UTC date as a modified JD (JD-2400000.5)
*
*  Result:  TT-UTC in seconds
*
*  Notes:
*
*  1  The UTC is specified to be a date rather than a time to indicate
*     that care needs to be taken not to specify an instant which lies
*     within a leap second.  Though in most cases UTC can include the
*     fractional part, correct behaviour on the day of a leap second
*     can only be guaranteed up to the end of the second 23:59:59.
*
*  2  Pre 1972 January 1 a fixed value of 10 + ET-TAI is returned.
*
*  3  See also the routine sla_DT, which roughly estimates ET-UT for
*     historical epochs.
*
*  Called:  sla_DAT
*
*  P.T.Wallace   Starlink   6 December 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION UTC

      DOUBLE PRECISION sla_DAT


      sla_DTT=32.184D0+sla_DAT(UTC)

      END
      SUBROUTINE sla_ECMAT (DATE, RMAT)
*+
*     - - - - - -
*      E C M A T
*     - - - - - -
*
*  Form the equatorial to ecliptic rotation matrix - IAU 1980 theory
*  (double precision)
*
*  Given:
*     DATE     dp         TDB (loosely ET) as Modified Julian Date
*                                            (JD-2400000.5)
*  Returned:
*     RMAT     dp(3,3)    matrix
*
*  Reference:
*     Murray,C.A., Vectorial Astrometry, section 4.3.
*
*  Note:
*    The matrix is in the sense   V(ecl)  =  RMAT * V(equ);  the
*    equator, equinox and ecliptic are mean of date.
*
*  Called:  sla_DEULER
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,RMAT(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T,EPS0



*  Interval between basic epoch J2000.0 and current epoch (JC)
      T = (DATE-51544.5D0)/36525D0

*  Mean obliquity
      EPS0 = AS2R*
     :   (84381.448D0+(-46.8150D0+(-0.00059D0+0.001813D0*T)*T)*T)

*  Matrix
      CALL sla_DEULER('X',EPS0,0D0,0D0,RMAT)

      END
      DOUBLE PRECISION FUNCTION sla_EPJ (DATE)
*+
*     - - - -
*      E P J
*     - - - -
*
*  Conversion of Modified Julian Date to Julian Epoch (double precision)
*
*  Given:
*     DATE     dp       Modified Julian Date (JD - 2400000.5)
*
*  The result is the Julian Epoch.
*
*  Reference:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*
*  P.T.Wallace   Starlink   February 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE


      sla_EPJ = 2000D0 + (DATE-51544.5D0)/365.25D0

      END
      SUBROUTINE sla_EQECL (DR, DD, DATE, DL, DB)
*+
*     - - - - - -
*      E Q E C L
*     - - - - - -
*
*  Transformation from J2000.0 equatorial coordinates to
*  ecliptic coordinates (double precision)
*
*  Given:
*     DR,DD       dp      J2000.0 mean RA,Dec (radians)
*     DATE        dp      TDB (loosely ET) as Modified Julian Date
*                                              (JD-2400000.5)
*  Returned:
*     DL,DB       dp      ecliptic longitude and latitude
*                         (mean of date, IAU 1980 theory, radians)
*
*  Called:
*     sla_DCS2C, sla_PREC, sla_EPJ, sla_DMXV, sla_ECMAT, sla_DCC2S,
*     sla_DRANRM, sla_DRANGE
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DR,DD,DATE,DL,DB

      DOUBLE PRECISION sla_EPJ,sla_DRANRM,sla_DRANGE

      DOUBLE PRECISION RMAT(3,3),V1(3),V2(3)



*  Spherical to Cartesian
      CALL sla_DCS2C(DR,DD,V1)

*  Mean J2000 to mean of date
      CALL sla_PREC(2000D0,sla_EPJ(DATE),RMAT)
      CALL sla_DMXV(RMAT,V1,V2)

*  Equatorial to ecliptic
      CALL sla_ECMAT(DATE,RMAT)
      CALL sla_DMXV(RMAT,V2,V1)

*  Cartesian to spherical
      CALL sla_DCC2S(V1,DL,DB)

*  Express in conventional ranges
      DL=sla_DRANRM(DL)
      DB=sla_DRANGE(DB)

      END
      DOUBLE PRECISION FUNCTION sla_EQEQX (DATE)
*+
*     - - - - - -
*      E Q E Q X
*     - - - - - -
*
*  Equation of the equinoxes  (IAU 1994, double precision)
*
*  Given:
*     DATE    dp      TDB (loosely ET) as Modified Julian Date
*                                          (JD-2400000.5)
*
*  The result is the equation of the equinoxes (double precision)
*  in radians:
*
*     Greenwich apparent ST = GMST + sla_EQEQX
*
*  References:  IAU Resolution C7, Recommendation 3 (1994)
*               Capitaine, N. & Gontier, A.-M., Astron. Astrophys.,
*               275, 645-650 (1993)
*
*  Called:  sla_NUTC
*
*  Patrick Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE

*  Turns to arc seconds and arc seconds to radians
      DOUBLE PRECISION T2AS,AS2R
      PARAMETER (T2AS=1296000D0,
     :           AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T,OM,DPSI,DEPS,EPS0



*  Interval between basic epoch J2000.0 and current epoch (JC)
      T=(DATE-51544.5D0)/36525D0

*  Longitude of the mean ascending node of the lunar orbit on the
*   ecliptic, measured from the mean equinox of date
      OM=AS2R*(450160.280D0+(-5D0*T2AS-482890.539D0
     :         +(7.455D0+0.008D0*T)*T)*T)

*  Nutation
      CALL sla_NUTC(DATE,DPSI,DEPS,EPS0)

*  Equation of the equinoxes
      sla_EQEQX=DPSI*COS(EPS0)+AS2R*(0.00264D0*SIN(OM)+
     :                               0.000063D0*SIN(OM+OM))

      END
      SUBROUTINE sla_GEOC (P, H, R, Z)
*+
*     - - - - -
*      G E O C
*     - - - - -
*
*  Convert geodetic position to geocentric (double precision)
*
*  Given:
*     P     dp     latitude (geodetic, radians)
*     H     dp     height above reference spheroid (geodetic, metres)
*
*  Returned:
*     R     dp     distance from Earth axis (AU)
*     Z     dp     distance from plane of Earth equator (AU)
*
*  Notes:
*
*  1  Geocentric latitude can be obtained by evaluating ATAN2(Z,R).
*
*  2  IAU 1976 constants are used.
*
*  Reference:
*
*     Green,R.M., Spherical Astronomy, CUP 1985, p98.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION P,H,R,Z

*  Earth equatorial radius (metres)
      DOUBLE PRECISION A0
      PARAMETER (A0=6378140D0)

*  Reference spheroid flattening factor and useful function
      DOUBLE PRECISION F,B
      PARAMETER (F=1D0/298.257D0,B=(1D0-F)**2)

*  Astronomical unit in metres
      DOUBLE PRECISION AU
      PARAMETER (AU=1.49597870D11)

      DOUBLE PRECISION SP,CP,C,S



*  Geodetic to geocentric conversion
      SP = SIN(P)
      CP = COS(P)
      C = 1D0/SQRT(CP*CP+B*SP*SP)
      S = B*C
      R = (A0*C+H)*CP/AU
      Z = (A0*S+H)*SP/AU

      END
      DOUBLE PRECISION FUNCTION sla_GMST (UT1)
*+
*     - - - - -
*      G M S T
*     - - - - -
*
*  Conversion from universal time to sidereal time (double precision)
*
*  Given:
*    UT1    dp     universal time (strictly UT1) expressed as
*                  modified Julian Date (JD-2400000.5)
*
*  The result is the Greenwich mean sidereal time (double
*  precision, radians).
*
*  The IAU 1982 expression (see page S15 of 1984 Astronomical Almanac)
*  is used, but rearranged to reduce rounding errors.  This expression
*  is always described as giving the GMST at 0 hours UT.  In fact, it
*  gives the difference between the GMST and the UT, which happens to
*  equal the GMST (modulo 24 hours) at 0 hours UT each day.  In this
*  routine, the entire UT is used directly as the argument for the
*  standard formula, and the fractional part of the UT is added
*  separately.  Note that the factor 1.0027379... does not appear in the
*  IAU 1982 expression explicitly but in the form of the coefficient
*  8640184.812866, which is 86400x36525x0.0027379...
*
*  See also the routine sla_GMSTA, which delivers better numerical
*  precision by accepting the UT date and time as separate arguments.
*
*  Called:  sla_DRANRM
*
*  P.T.Wallace   Starlink   14 October 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION UT1

      DOUBLE PRECISION sla_DRANRM

      DOUBLE PRECISION D2PI,S2R
      PARAMETER (D2PI=6.283185307179586476925286766559D0,
     :           S2R=7.272205216643039903848711535369D-5)

      DOUBLE PRECISION TU



*  Julian centuries from fundamental epoch J2000 to this UT
      TU=(UT1-51544.5D0)/36525D0

*  GMST at this UT
      sla_GMST=sla_DRANRM(MOD(UT1,1D0)*D2PI+
     :                    (24110.54841D0+
     :                    (8640184.812866D0+
     :                    (0.093104D0-6.2D-6*TU)*TU)*TU)*S2R)

      END
      SUBROUTINE sla_NUTC (DATE, DPSI, DEPS, EPS0)
*+
*     - - - - -
*      N U T C
*     - - - - -
*
*  Nutation:  longitude & obliquity components and mean obliquity,
*  using the Shirai & Fukushima (2001) theory.
*
*  Given:
*     DATE        d    TDB (loosely ET) as Modified Julian Date
*                                            (JD-2400000.5)
*  Returned:
*     DPSI,DEPS   d    nutation in longitude,obliquity
*     EPS0        d    mean obliquity
*
*  Notes:
*
*  1  The routine predicts forced nutation (but not free core nutation)
*     plus corrections to the IAU 1976 precession model.
*
*  2  Earth attitude predictions made by combining the present nutation
*     model with IAU 1976 precession are accurate to 1 mas (with respect
*     to the ICRF) for a few decades around 2000.
*
*  3  The sla_NUTC80 routine is the equivalent of the present routine
*     but using the IAU 1980 nutation theory.  The older theory is less
*     accurate, leading to errors as large as 350 mas over the interval
*     1900-2100, mainly because of the error in the IAU 1976 precession.
*
*  References:
*
*     Shirai, T. & Fukushima, T., Astron.J. 121, 3270-3283 (2001).
*
*     Fukushima, T., Astron.Astrophys. 244, L11 (1991).
*
*     Simon, J. L., Bretagnon, P., Chapront, J., Chapront-Touze, M.,
*     Francou, G. & Laskar, J., Astron.Astrophys. 282, 663 (1994).
*
*  This revision:   24 November 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,DPSI,DEPS,EPS0

*  Degrees to radians
      DOUBLE PRECISION DD2R
      PARAMETER (DD2R=1.745329251994329576923691D-2)

*  Arc seconds to radians
      DOUBLE PRECISION DAS2R
      PARAMETER (DAS2R=4.848136811095359935899141D-6)

*  Arc seconds in a full circle
      DOUBLE PRECISION TURNAS
      PARAMETER (TURNAS=1296000D0)

*  Reference epoch (J2000), MJD
      DOUBLE PRECISION DJM0
      PARAMETER (DJM0=51544.5D0 )

*  Days per Julian century
      DOUBLE PRECISION DJC
      PARAMETER (DJC=36525D0)

      INTEGER I,J
      DOUBLE PRECISION T,EL,ELP,F,D,OM,VE,MA,JU,SA,THETA,C,S,DP,DE

*  Number of terms in the nutation model
      INTEGER NTERMS
      PARAMETER (NTERMS=194)

*  The SF2001 forced nutation model
      INTEGER NA(9,NTERMS)
      DOUBLE PRECISION PSI(4,NTERMS), EPS(4,NTERMS)

*  Coefficients of fundamental angles
      DATA ( ( NA(I,J), I=1,9 ), J=1,10 ) /
     :    0,   0,   0,   0,  -1,   0,   0,   0,   0,
     :    0,   0,   2,  -2,   2,   0,   0,   0,   0,
     :    0,   0,   2,   0,   2,   0,   0,   0,   0,
     :    0,   0,   0,   0,  -2,   0,   0,   0,   0,
     :    0,   1,   0,   0,   0,   0,   0,   0,   0,
     :    0,   1,   2,  -2,   2,   0,   0,   0,   0,
     :    1,   0,   0,   0,   0,   0,   0,   0,   0,
     :    0,   0,   2,   0,   1,   0,   0,   0,   0,
     :    1,   0,   2,   0,   2,   0,   0,   0,   0,
     :    0,  -1,   2,  -2,   2,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=11,20 ) /
     :    0,   0,   2,  -2,   1,   0,   0,   0,   0,
     :   -1,   0,   2,   0,   2,   0,   0,   0,   0,
     :   -1,   0,   0,   2,   0,   0,   0,   0,   0,
     :    1,   0,   0,   0,   1,   0,   0,   0,   0,
     :    1,   0,   0,   0,  -1,   0,   0,   0,   0,
     :   -1,   0,   2,   2,   2,   0,   0,   0,   0,
     :    1,   0,   2,   0,   1,   0,   0,   0,   0,
     :   -2,   0,   2,   0,   1,   0,   0,   0,   0,
     :    0,   0,   0,   2,   0,   0,   0,   0,   0,
     :    0,   0,   2,   2,   2,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=21,30 ) /
     :    2,   0,   0,  -2,   0,   0,   0,   0,   0,
     :    2,   0,   2,   0,   2,   0,   0,   0,   0,
     :    1,   0,   2,  -2,   2,   0,   0,   0,   0,
     :   -1,   0,   2,   0,   1,   0,   0,   0,   0,
     :    2,   0,   0,   0,   0,   0,   0,   0,   0,
     :    0,   0,   2,   0,   0,   0,   0,   0,   0,
     :    0,   1,   0,   0,   1,   0,   0,   0,   0,
     :   -1,   0,   0,   2,   1,   0,   0,   0,   0,
     :    0,   2,   2,  -2,   2,   0,   0,   0,   0,
     :    0,   0,   2,  -2,   0,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=31,40 ) /
     :   -1,   0,   0,   2,  -1,   0,   0,   0,   0,
     :    0,   1,   0,   0,  -1,   0,   0,   0,   0,
     :    0,   2,   0,   0,   0,   0,   0,   0,   0,
     :   -1,   0,   2,   2,   1,   0,   0,   0,   0,
     :    1,   0,   2,   2,   2,   0,   0,   0,   0,
     :    0,   1,   2,   0,   2,   0,   0,   0,   0,
     :   -2,   0,   2,   0,   0,   0,   0,   0,   0,
     :    0,   0,   2,   2,   1,   0,   0,   0,   0,
     :    0,  -1,   2,   0,   2,   0,   0,   0,   0,
     :    0,   0,   0,   2,   1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=41,50 ) /
     :    1,   0,   2,  -2,   1,   0,   0,   0,   0,
     :    2,   0,   0,  -2,  -1,   0,   0,   0,   0,
     :    2,   0,   2,  -2,   2,   0,   0,   0,   0,
     :    2,   0,   2,   0,   1,   0,   0,   0,   0,
     :    0,   0,   0,   2,  -1,   0,   0,   0,   0,
     :    0,  -1,   2,  -2,   1,   0,   0,   0,   0,
     :   -1,  -1,   0,   2,   0,   0,   0,   0,   0,
     :    2,   0,   0,  -2,   1,   0,   0,   0,   0,
     :    1,   0,   0,   2,   0,   0,   0,   0,   0,
     :    0,   1,   2,  -2,   1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=51,60 ) /
     :    1,  -1,   0,   0,   0,   0,   0,   0,   0,
     :   -2,   0,   2,   0,   2,   0,   0,   0,   0,
     :    0,  -1,   0,   2,   0,   0,   0,   0,   0,
     :    3,   0,   2,   0,   2,   0,   0,   0,   0,
     :    0,   0,   0,   1,   0,   0,   0,   0,   0,
     :    1,  -1,   2,   0,   2,   0,   0,   0,   0,
     :    1,   0,   0,  -1,   0,   0,   0,   0,   0,
     :   -1,  -1,   2,   2,   2,   0,   0,   0,   0,
     :   -1,   0,   2,   0,   0,   0,   0,   0,   0,
     :    2,   0,   0,   0,  -1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=61,70 ) /
     :    0,  -1,   2,   2,   2,   0,   0,   0,   0,
     :    1,   1,   2,   0,   2,   0,   0,   0,   0,
     :    2,   0,   0,   0,   1,   0,   0,   0,   0,
     :    1,   1,   0,   0,   0,   0,   0,   0,   0,
     :    1,   0,  -2,   2,  -1,   0,   0,   0,   0,
     :    1,   0,   2,   0,   0,   0,   0,   0,   0,
     :   -1,   1,   0,   1,   0,   0,   0,   0,   0,
     :    1,   0,   0,   0,   2,   0,   0,   0,   0,
     :   -1,   0,   1,   0,   1,   0,   0,   0,   0,
     :    0,   0,   2,   1,   2,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=71,80 ) /
     :   -1,   1,   0,   1,   1,   0,   0,   0,   0,
     :   -1,   0,   2,   4,   2,   0,   0,   0,   0,
     :    0,  -2,   2,  -2,   1,   0,   0,   0,   0,
     :    1,   0,   2,   2,   1,   0,   0,   0,   0,
     :    1,   0,   0,   0,  -2,   0,   0,   0,   0,
     :   -2,   0,   2,   2,   2,   0,   0,   0,   0,
     :    1,   1,   2,  -2,   2,   0,   0,   0,   0,
     :   -2,   0,   2,   4,   2,   0,   0,   0,   0,
     :   -1,   0,   4,   0,   2,   0,   0,   0,   0,
     :    2,   0,   2,  -2,   1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=81,90 ) /
     :    1,   0,   0,  -1,  -1,   0,   0,   0,   0,
     :    2,   0,   2,   2,   2,   0,   0,   0,   0,
     :    1,   0,   0,   2,   1,   0,   0,   0,   0,
     :    3,   0,   0,   0,   0,   0,   0,   0,   0,
     :    0,   0,   2,  -2,  -1,   0,   0,   0,   0,
     :    3,   0,   2,  -2,   2,   0,   0,   0,   0,
     :    0,   0,   4,  -2,   2,   0,   0,   0,   0,
     :   -1,   0,   0,   4,   0,   0,   0,   0,   0,
     :    0,   1,   2,   0,   1,   0,   0,   0,   0,
     :    0,   0,   2,  -2,   3,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=91,100 ) /
     :   -2,   0,   0,   4,   0,   0,   0,   0,   0,
     :   -1,  -1,   0,   2,   1,   0,   0,   0,   0,
     :   -2,   0,   2,   0,  -1,   0,   0,   0,   0,
     :    0,   0,   2,   0,  -1,   0,   0,   0,   0,
     :    0,  -1,   2,   0,   1,   0,   0,   0,   0,
     :    0,   1,   0,   0,   2,   0,   0,   0,   0,
     :    0,   0,   2,  -1,   2,   0,   0,   0,   0,
     :    2,   1,   0,  -2,   0,   0,   0,   0,   0,
     :    0,   0,   2,   4,   2,   0,   0,   0,   0,
     :   -1,  -1,   0,   2,  -1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=101,110 ) /
     :   -1,   1,   0,   2,   0,   0,   0,   0,   0,
     :    1,  -1,   0,   0,   1,   0,   0,   0,   0,
     :    0,  -1,   2,  -2,   0,   0,   0,   0,   0,
     :    0,   1,   0,   0,  -2,   0,   0,   0,   0,
     :    1,  -1,   2,   2,   2,   0,   0,   0,   0,
     :    1,   0,   0,   2,  -1,   0,   0,   0,   0,
     :   -1,   1,   2,   2,   2,   0,   0,   0,   0,
     :    3,   0,   2,   0,   1,   0,   0,   0,   0,
     :    0,   1,   2,   2,   2,   0,   0,   0,   0,
     :    1,   0,   2,  -2,   0,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=111,120 ) /
     :   -1,   0,  -2,   4,  -1,   0,   0,   0,   0,
     :   -1,  -1,   2,   2,   1,   0,   0,   0,   0,
     :    0,  -1,   2,   2,   1,   0,   0,   0,   0,
     :    2,  -1,   2,   0,   2,   0,   0,   0,   0,
     :    0,   0,   0,   2,   2,   0,   0,   0,   0,
     :    1,  -1,   2,   0,   1,   0,   0,   0,   0,
     :   -1,   1,   2,   0,   2,   0,   0,   0,   0,
     :    0,   1,   0,   2,   0,   0,   0,   0,   0,
     :    0,   1,   2,  -2,   0,   0,   0,   0,   0,
     :    0,   3,   2,  -2,   2,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=121,130 ) /
     :    0,   0,   0,   1,   1,   0,   0,   0,   0,
     :   -1,   0,   2,   2,   0,   0,   0,   0,   0,
     :    2,   1,   2,   0,   2,   0,   0,   0,   0,
     :    1,   1,   0,   0,   1,   0,   0,   0,   0,
     :    2,   0,   0,   2,   0,   0,   0,   0,   0,
     :    1,   1,   2,   0,   1,   0,   0,   0,   0,
     :   -1,   0,   0,   2,   2,   0,   0,   0,   0,
     :    1,   0,  -2,   2,   0,   0,   0,   0,   0,
     :    0,  -1,   0,   2,  -1,   0,   0,   0,   0,
     :   -1,   0,   1,   0,   2,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=131,140 ) /
     :    0,   1,   0,   1,   0,   0,   0,   0,   0,
     :    1,   0,  -2,   2,  -2,   0,   0,   0,   0,
     :    0,   0,   0,   1,  -1,   0,   0,   0,   0,
     :    1,  -1,   0,   0,  -1,   0,   0,   0,   0,
     :    0,   0,   0,   4,   0,   0,   0,   0,   0,
     :    1,  -1,   0,   2,   0,   0,   0,   0,   0,
     :    1,   0,   2,   1,   2,   0,   0,   0,   0,
     :    1,   0,   2,  -1,   2,   0,   0,   0,   0,
     :   -1,   0,   0,   2,  -2,   0,   0,   0,   0,
     :    0,   0,   2,   1,   1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=141,150 ) /
     :   -1,   0,   2,   0,  -1,   0,   0,   0,   0,
     :   -1,   0,   2,   4,   1,   0,   0,   0,   0,
     :    0,   0,   2,   2,   0,   0,   0,   0,   0,
     :    1,   1,   2,  -2,   1,   0,   0,   0,   0,
     :    0,   0,   1,   0,   1,   0,   0,   0,   0,
     :   -1,   0,   2,  -1,   1,   0,   0,   0,   0,
     :   -2,   0,   2,   2,   1,   0,   0,   0,   0,
     :    2,  -1,   0,   0,   0,   0,   0,   0,   0,
     :    4,   0,   2,   0,   2,   0,   0,   0,   0,
     :    2,   1,   2,  -2,   2,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=151,160 ) /
     :    0,   1,   2,   1,   2,   0,   0,   0,   0,
     :    1,   0,   4,  -2,   2,   0,   0,   0,   0,
     :    1,   1,   0,   0,  -1,   0,   0,   0,   0,
     :   -2,   0,   2,   4,   1,   0,   0,   0,   0,
     :    2,   0,   2,   0,   0,   0,   0,   0,   0,
     :   -1,   0,   1,   0,   0,   0,   0,   0,   0,
     :    1,   0,   0,   1,   0,   0,   0,   0,   0,
     :    0,   1,   0,   2,   1,   0,   0,   0,   0,
     :   -1,   0,   4,   0,   1,   0,   0,   0,   0,
     :   -1,   0,   0,   4,   1,   0,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=161,170 ) /
     :    2,   0,   2,   2,   1,   0,   0,   0,   0,
     :    2,   1,   0,   0,   0,   0,   0,   0,   0,
     :    0,   0,   5,  -5,   5,  -3,   0,   0,   0,
     :    0,   0,   0,   0,   0,   0,   0,   2,   0,
     :    0,   0,   1,  -1,   1,   0,   0,  -1,   0,
     :    0,   0,  -1,   1,  -1,   1,   0,   0,   0,
     :    0,   0,  -1,   1,   0,   0,   2,   0,   0,
     :    0,   0,   3,  -3,   3,   0,   0,  -1,   0,
     :    0,   0,  -8,   8,  -7,   5,   0,   0,   0,
     :    0,   0,  -1,   1,  -1,   0,   2,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=171,180 ) /
     :    0,   0,  -2,   2,  -2,   2,   0,   0,   0,
     :    0,   0,  -6,   6,  -6,   4,   0,   0,   0,
     :    0,   0,  -2,   2,  -2,   0,   8,  -3,   0,
     :    0,   0,   6,  -6,   6,   0,  -8,   3,   0,
     :    0,   0,   4,  -4,   4,  -2,   0,   0,   0,
     :    0,   0,  -3,   3,  -3,   2,   0,   0,   0,
     :    0,   0,   4,  -4,   3,   0,  -8,   3,   0,
     :    0,   0,  -4,   4,  -5,   0,   8,  -3,   0,
     :    0,   0,   0,   0,   0,   2,   0,   0,   0,
     :    0,   0,  -4,   4,  -4,   3,   0,   0,   0 /
      DATA ( ( NA(I,J), I=1,9 ), J=181,190 ) /
     :    0,   1,  -1,   1,  -1,   0,   0,   1,   0,
     :    0,   0,   0,   0,   0,   0,   0,   1,   0,
     :    0,   0,   1,  -1,   1,   1,   0,   0,   0,
     :    0,   0,   2,  -2,   2,   0,  -2,   0,   0,
     :    0,  -1,  -7,   7,  -7,   5,   0,   0,   0,
     :   -2,   0,   2,   0,   2,   0,   0,  -2,   0,
     :   -2,   0,   2,   0,   1,   0,   0,  -3,   0,
     :    0,   0,   2,  -2,   2,   0,   0,  -2,   0,
     :    0,   0,   1,  -1,   1,   0,   0,   1,   0,
     :    0,   0,   0,   0,   0,   0,   0,   0,   2 /
      DATA ( ( NA(I,J), I=1,9 ), J=191,NTERMS ) /
     :    0,   0,   0,   0,   0,   0,   0,   0,   1,
     :    2,   0,  -2,   0,  -2,   0,   0,   3,   0,
     :    0,   0,   1,  -1,   1,   0,   0,  -2,   0,
     :    0,   0,  -7,   7,  -7,   5,   0,   0,   0 /

*  Nutation series: longitude
      DATA ( ( PSI(I,J), I=1,4 ), J=1,10 ) /
     :  3341.5D0, 17206241.8D0,  3.1D0, 17409.5D0,
     : -1716.8D0, -1317185.3D0,  1.4D0,  -156.8D0,
     :   285.7D0,  -227667.0D0,  0.3D0,   -23.5D0,
     :   -68.6D0,  -207448.0D0,  0.0D0,   -21.4D0,
     :   950.3D0,   147607.9D0, -2.3D0,  -355.0D0,
     :   -66.7D0,   -51689.1D0,  0.2D0,   122.6D0,
     :  -108.6D0,    71117.6D0,  0.0D0,     7.0D0,
     :    35.6D0,   -38740.2D0,  0.1D0,   -36.2D0,
     :    85.4D0,   -30127.6D0,  0.0D0,    -3.1D0,
     :     9.0D0,    21583.0D0,  0.1D0,   -50.3D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=11,20 ) /
     :    22.1D0,    12822.8D0,  0.0D0,    13.3D0,
     :     3.4D0,    12350.8D0,  0.0D0,     1.3D0,
     :   -21.1D0,    15699.4D0,  0.0D0,     1.6D0,
     :     4.2D0,     6313.8D0,  0.0D0,     6.2D0,
     :   -22.8D0,     5796.9D0,  0.0D0,     6.1D0,
     :    15.7D0,    -5961.1D0,  0.0D0,    -0.6D0,
     :    13.1D0,    -5159.1D0,  0.0D0,    -4.6D0,
     :     1.8D0,     4592.7D0,  0.0D0,     4.5D0,
     :   -17.5D0,     6336.0D0,  0.0D0,     0.7D0,
     :    16.3D0,    -3851.1D0,  0.0D0,    -0.4D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=21,30 ) /
     :    -2.8D0,     4771.7D0,  0.0D0,     0.5D0,
     :    13.8D0,    -3099.3D0,  0.0D0,    -0.3D0,
     :     0.2D0,     2860.3D0,  0.0D0,     0.3D0,
     :     1.4D0,     2045.3D0,  0.0D0,     2.0D0,
     :    -8.6D0,     2922.6D0,  0.0D0,     0.3D0,
     :    -7.7D0,     2587.9D0,  0.0D0,     0.2D0,
     :     8.8D0,    -1408.1D0,  0.0D0,     3.7D0,
     :     1.4D0,     1517.5D0,  0.0D0,     1.5D0,
     :    -1.9D0,    -1579.7D0,  0.0D0,     7.7D0,
     :     1.3D0,    -2178.6D0,  0.0D0,    -0.2D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=31,40 ) /
     :    -4.8D0,     1286.8D0,  0.0D0,     1.3D0,
     :     6.3D0,     1267.2D0,  0.0D0,    -4.0D0,
     :    -1.0D0,     1669.3D0,  0.0D0,    -8.3D0,
     :     2.4D0,    -1020.0D0,  0.0D0,    -0.9D0,
     :     4.5D0,     -766.9D0,  0.0D0,     0.0D0,
     :    -1.1D0,      756.5D0,  0.0D0,    -1.7D0,
     :    -1.4D0,    -1097.3D0,  0.0D0,    -0.5D0,
     :     2.6D0,     -663.0D0,  0.0D0,    -0.6D0,
     :     0.8D0,     -714.1D0,  0.0D0,     1.6D0,
     :     0.4D0,     -629.9D0,  0.0D0,    -0.6D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=41,50 ) /
     :     0.3D0,      580.4D0,  0.0D0,     0.6D0,
     :    -1.6D0,      577.3D0,  0.0D0,     0.5D0,
     :    -0.9D0,      644.4D0,  0.0D0,     0.0D0,
     :     2.2D0,     -534.0D0,  0.0D0,    -0.5D0,
     :    -2.5D0,      493.3D0,  0.0D0,     0.5D0,
     :    -0.1D0,     -477.3D0,  0.0D0,    -2.4D0,
     :    -0.9D0,      735.0D0,  0.0D0,    -1.7D0,
     :     0.7D0,      406.2D0,  0.0D0,     0.4D0,
     :    -2.8D0,      656.9D0,  0.0D0,     0.0D0,
     :     0.6D0,      358.0D0,  0.0D0,     2.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=51,60 ) /
     :    -0.7D0,      472.5D0,  0.0D0,    -1.1D0,
     :    -0.1D0,     -300.5D0,  0.0D0,     0.0D0,
     :    -1.2D0,      435.1D0,  0.0D0,    -1.0D0,
     :     1.8D0,     -289.4D0,  0.0D0,     0.0D0,
     :     0.6D0,     -422.6D0,  0.0D0,     0.0D0,
     :     0.8D0,     -287.6D0,  0.0D0,     0.6D0,
     :   -38.6D0,     -392.3D0,  0.0D0,     0.0D0,
     :     0.7D0,     -281.8D0,  0.0D0,     0.6D0,
     :     0.6D0,     -405.7D0,  0.0D0,     0.0D0,
     :    -1.2D0,      229.0D0,  0.0D0,     0.2D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=61,70 ) /
     :     1.1D0,     -264.3D0,  0.0D0,     0.5D0,
     :    -0.7D0,      247.9D0,  0.0D0,    -0.5D0,
     :    -0.2D0,      218.0D0,  0.0D0,     0.2D0,
     :     0.6D0,     -339.0D0,  0.0D0,     0.8D0,
     :    -0.7D0,      198.7D0,  0.0D0,     0.2D0,
     :    -1.5D0,      334.0D0,  0.0D0,     0.0D0,
     :     0.1D0,      334.0D0,  0.0D0,     0.0D0,
     :    -0.1D0,     -198.1D0,  0.0D0,     0.0D0,
     :  -106.6D0,        0.0D0,  0.0D0,     0.0D0,
     :    -0.5D0,      165.8D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=71,80 ) /
     :     0.0D0,      134.8D0,  0.0D0,     0.0D0,
     :     0.9D0,     -151.6D0,  0.0D0,     0.0D0,
     :     0.0D0,     -129.7D0,  0.0D0,     0.0D0,
     :     0.8D0,     -132.8D0,  0.0D0,    -0.1D0,
     :     0.5D0,     -140.7D0,  0.0D0,     0.0D0,
     :    -0.1D0,      138.4D0,  0.0D0,     0.0D0,
     :     0.0D0,      129.0D0,  0.0D0,    -0.3D0,
     :     0.5D0,     -121.2D0,  0.0D0,     0.0D0,
     :    -0.3D0,      114.5D0,  0.0D0,     0.0D0,
     :    -0.1D0,      101.8D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=81,90 ) /
     :    -3.6D0,     -101.9D0,  0.0D0,     0.0D0,
     :     0.8D0,     -109.4D0,  0.0D0,     0.0D0,
     :     0.2D0,      -97.0D0,  0.0D0,     0.0D0,
     :    -0.7D0,      157.3D0,  0.0D0,     0.0D0,
     :     0.2D0,      -83.3D0,  0.0D0,     0.0D0,
     :    -0.3D0,       93.3D0,  0.0D0,     0.0D0,
     :    -0.1D0,       92.1D0,  0.0D0,     0.0D0,
     :    -0.5D0,      133.6D0,  0.0D0,     0.0D0,
     :    -0.1D0,       81.5D0,  0.0D0,     0.0D0,
     :     0.0D0,      123.9D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=91,100 ) /
     :    -0.3D0,      128.1D0,  0.0D0,     0.0D0,
     :     0.1D0,       74.1D0,  0.0D0,    -0.3D0,
     :    -0.2D0,      -70.3D0,  0.0D0,     0.0D0,
     :    -0.4D0,       66.6D0,  0.0D0,     0.0D0,
     :     0.1D0,      -66.7D0,  0.0D0,     0.0D0,
     :    -0.7D0,       69.3D0,  0.0D0,    -0.3D0,
     :     0.0D0,      -70.4D0,  0.0D0,     0.0D0,
     :    -0.1D0,      101.5D0,  0.0D0,     0.0D0,
     :     0.5D0,      -69.1D0,  0.0D0,     0.0D0,
     :    -0.2D0,       58.5D0,  0.0D0,     0.2D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=101,110 ) /
     :     0.1D0,      -94.9D0,  0.0D0,     0.2D0,
     :     0.0D0,       52.9D0,  0.0D0,    -0.2D0,
     :     0.1D0,       86.7D0,  0.0D0,    -0.2D0,
     :    -0.1D0,      -59.2D0,  0.0D0,     0.2D0,
     :     0.3D0,      -58.8D0,  0.0D0,     0.1D0,
     :    -0.3D0,       49.0D0,  0.0D0,     0.0D0,
     :    -0.2D0,       56.9D0,  0.0D0,    -0.1D0,
     :     0.3D0,      -50.2D0,  0.0D0,     0.0D0,
     :    -0.2D0,       53.4D0,  0.0D0,    -0.1D0,
     :     0.1D0,      -76.5D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=111,120 ) /
     :    -0.2D0,       45.3D0,  0.0D0,     0.0D0,
     :     0.1D0,      -46.8D0,  0.0D0,     0.0D0,
     :     0.2D0,      -44.6D0,  0.0D0,     0.0D0,
     :     0.2D0,      -48.7D0,  0.0D0,     0.0D0,
     :     0.1D0,      -46.8D0,  0.0D0,     0.0D0,
     :     0.1D0,      -42.0D0,  0.0D0,     0.0D0,
     :     0.0D0,       46.4D0,  0.0D0,    -0.1D0,
     :     0.2D0,      -67.3D0,  0.0D0,     0.1D0,
     :     0.0D0,      -65.8D0,  0.0D0,     0.2D0,
     :    -0.1D0,      -43.9D0,  0.0D0,     0.3D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=121,130 ) /
     :     0.0D0,      -38.9D0,  0.0D0,     0.0D0,
     :    -0.3D0,       63.9D0,  0.0D0,     0.0D0,
     :    -0.2D0,       41.2D0,  0.0D0,     0.0D0,
     :     0.0D0,      -36.1D0,  0.0D0,     0.2D0,
     :    -0.3D0,       58.5D0,  0.0D0,     0.0D0,
     :    -0.1D0,       36.1D0,  0.0D0,     0.0D0,
     :     0.0D0,      -39.7D0,  0.0D0,     0.0D0,
     :     0.1D0,      -57.7D0,  0.0D0,     0.0D0,
     :    -0.2D0,       33.4D0,  0.0D0,     0.0D0,
     :    36.4D0,        0.0D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=131,140 ) /
     :    -0.1D0,       55.7D0,  0.0D0,    -0.1D0,
     :     0.1D0,      -35.4D0,  0.0D0,     0.0D0,
     :     0.1D0,      -31.0D0,  0.0D0,     0.0D0,
     :    -0.1D0,       30.1D0,  0.0D0,     0.0D0,
     :    -0.3D0,       49.2D0,  0.0D0,     0.0D0,
     :    -0.2D0,       49.1D0,  0.0D0,     0.0D0,
     :    -0.1D0,       33.6D0,  0.0D0,     0.0D0,
     :     0.1D0,      -33.5D0,  0.0D0,     0.0D0,
     :     0.1D0,      -31.0D0,  0.0D0,     0.0D0,
     :    -0.1D0,       28.0D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=141,150 ) /
     :     0.1D0,      -25.2D0,  0.0D0,     0.0D0,
     :     0.1D0,      -26.2D0,  0.0D0,     0.0D0,
     :    -0.2D0,       41.5D0,  0.0D0,     0.0D0,
     :     0.0D0,       24.5D0,  0.0D0,     0.1D0,
     :   -16.2D0,        0.0D0,  0.0D0,     0.0D0,
     :     0.0D0,      -22.3D0,  0.0D0,     0.0D0,
     :     0.0D0,       23.1D0,  0.0D0,     0.0D0,
     :    -0.1D0,       37.5D0,  0.0D0,     0.0D0,
     :     0.2D0,      -25.7D0,  0.0D0,     0.0D0,
     :     0.0D0,       25.2D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=151,160 ) /
     :     0.1D0,      -24.5D0,  0.0D0,     0.0D0,
     :    -0.1D0,       24.3D0,  0.0D0,     0.0D0,
     :     0.1D0,      -20.7D0,  0.0D0,     0.0D0,
     :     0.1D0,      -20.8D0,  0.0D0,     0.0D0,
     :    -0.2D0,       33.4D0,  0.0D0,     0.0D0,
     :    32.9D0,        0.0D0,  0.0D0,     0.0D0,
     :     0.1D0,      -32.6D0,  0.0D0,     0.0D0,
     :     0.0D0,       19.9D0,  0.0D0,     0.0D0,
     :    -0.1D0,       19.6D0,  0.0D0,     0.0D0,
     :     0.0D0,      -18.7D0,  0.0D0,     0.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=161,170 ) /
     :     0.1D0,      -19.0D0,  0.0D0,     0.0D0,
     :     0.1D0,      -28.6D0,  0.0D0,     0.0D0,
     :     4.0D0,      178.8D0,-11.8D0,     0.3D0,
     :    39.8D0,     -107.3D0, -5.6D0,    -1.0D0,
     :     9.9D0,      164.0D0, -4.1D0,     0.1D0,
     :    -4.8D0,     -135.3D0, -3.4D0,    -0.1D0,
     :    50.5D0,       75.0D0,  1.4D0,    -1.2D0,
     :    -1.1D0,      -53.5D0,  1.3D0,     0.0D0,
     :   -45.0D0,       -2.4D0, -0.4D0,     6.6D0,
     :   -11.5D0,      -61.0D0, -0.9D0,     0.4D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=171,180 ) /
     :     4.4D0,      -68.4D0, -3.4D0,     0.0D0,
     :     7.7D0,      -47.1D0, -4.7D0,    -1.0D0,
     :   -42.9D0,      -12.6D0, -1.2D0,     4.2D0,
     :   -42.8D0,       12.7D0, -1.2D0,    -4.2D0,
     :    -7.6D0,      -44.1D0,  2.1D0,    -0.5D0,
     :   -64.1D0,        1.7D0,  0.2D0,     4.5D0,
     :    36.4D0,      -10.4D0,  1.0D0,     3.5D0,
     :    35.6D0,       10.2D0,  1.0D0,    -3.5D0,
     :    -1.7D0,       39.5D0,  2.0D0,     0.0D0,
     :    50.9D0,       -8.2D0, -0.8D0,    -5.0D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=181,190 ) /
     :     0.0D0,       52.3D0,  1.2D0,     0.0D0,
     :   -42.9D0,      -17.8D0,  0.4D0,     0.0D0,
     :     2.6D0,       34.3D0,  0.8D0,     0.0D0,
     :    -0.8D0,      -48.6D0,  2.4D0,    -0.1D0,
     :    -4.9D0,       30.5D0,  3.7D0,     0.7D0,
     :     0.0D0,      -43.6D0,  2.1D0,     0.0D0,
     :     0.0D0,      -25.4D0,  1.2D0,     0.0D0,
     :     2.0D0,       40.9D0, -2.0D0,     0.0D0,
     :    -2.1D0,       26.1D0,  0.6D0,     0.0D0,
     :    22.6D0,       -3.2D0, -0.5D0,    -0.5D0 /
      DATA ( ( PSI(I,J), I=1,4 ), J=191,NTERMS ) /
     :    -7.6D0,       24.9D0, -0.4D0,    -0.2D0,
     :    -6.2D0,       34.9D0,  1.7D0,     0.3D0,
     :     2.0D0,       17.4D0, -0.4D0,     0.1D0,
     :    -3.9D0,       20.5D0,  2.4D0,     0.6D0 /

*  Nutation series: obliquity
      DATA ( ( EPS(I,J), I=1,4 ), J=1,10 ) /
     : 9205365.8D0, -1506.2D0,  885.7D0, -0.2D0,
     :  573095.9D0,  -570.2D0, -305.0D0, -0.3D0,
     :   97845.5D0,   147.8D0,  -48.8D0, -0.2D0,
     :  -89753.6D0,    28.0D0,   46.9D0,  0.0D0,
     :    7406.7D0,  -327.1D0,  -18.2D0,  0.8D0,
     :   22442.3D0,   -22.3D0,  -67.6D0,  0.0D0,
     :    -683.6D0,    46.8D0,    0.0D0,  0.0D0,
     :   20070.7D0,    36.0D0,    1.6D0,  0.0D0,
     :   12893.8D0,    39.5D0,   -6.2D0,  0.0D0,
     :   -9593.2D0,    14.4D0,   30.2D0, -0.1D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=11,20 ) /
     :   -6899.5D0,     4.8D0,   -0.6D0,  0.0D0,
     :   -5332.5D0,    -0.1D0,    2.7D0,  0.0D0,
     :    -125.2D0,    10.5D0,    0.0D0,  0.0D0,
     :   -3323.4D0,    -0.9D0,   -0.3D0,  0.0D0,
     :    3142.3D0,     8.9D0,    0.3D0,  0.0D0,
     :    2552.5D0,     7.3D0,   -1.2D0,  0.0D0,
     :    2634.4D0,     8.8D0,    0.2D0,  0.0D0,
     :   -2424.4D0,     1.6D0,   -0.4D0,  0.0D0,
     :    -123.3D0,     3.9D0,    0.0D0,  0.0D0,
     :    1642.4D0,     7.3D0,   -0.8D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=21,30 ) /
     :      47.9D0,     3.2D0,    0.0D0,  0.0D0,
     :    1321.2D0,     6.2D0,   -0.6D0,  0.0D0,
     :   -1234.1D0,    -0.3D0,    0.6D0,  0.0D0,
     :   -1076.5D0,    -0.3D0,    0.0D0,  0.0D0,
     :     -61.6D0,     1.8D0,    0.0D0,  0.0D0,
     :     -55.4D0,     1.6D0,    0.0D0,  0.0D0,
     :     856.9D0,    -4.9D0,   -2.1D0,  0.0D0,
     :    -800.7D0,    -0.1D0,    0.0D0,  0.0D0,
     :     685.1D0,    -0.6D0,   -3.8D0,  0.0D0,
     :     -16.9D0,    -1.5D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=31,40 ) /
     :     695.7D0,     1.8D0,    0.0D0,  0.0D0,
     :     642.2D0,    -2.6D0,   -1.6D0,  0.0D0,
     :      13.3D0,     1.1D0,   -0.1D0,  0.0D0,
     :     521.9D0,     1.6D0,    0.0D0,  0.0D0,
     :     325.8D0,     2.0D0,   -0.1D0,  0.0D0,
     :    -325.1D0,    -0.5D0,    0.9D0,  0.0D0,
     :      10.1D0,     0.3D0,    0.0D0,  0.0D0,
     :     334.5D0,     1.6D0,    0.0D0,  0.0D0,
     :     307.1D0,     0.4D0,   -0.9D0,  0.0D0,
     :     327.2D0,     0.5D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=41,50 ) /
     :    -304.6D0,    -0.1D0,    0.0D0,  0.0D0,
     :     304.0D0,     0.6D0,    0.0D0,  0.0D0,
     :    -276.8D0,    -0.5D0,    0.1D0,  0.0D0,
     :     268.9D0,     1.3D0,    0.0D0,  0.0D0,
     :     271.8D0,     1.1D0,    0.0D0,  0.0D0,
     :     271.5D0,    -0.4D0,   -0.8D0,  0.0D0,
     :      -5.2D0,     0.5D0,    0.0D0,  0.0D0,
     :    -220.5D0,     0.1D0,    0.0D0,  0.0D0,
     :     -20.1D0,     0.3D0,    0.0D0,  0.0D0,
     :    -191.0D0,     0.1D0,    0.5D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=51,60 ) /
     :      -4.1D0,     0.3D0,    0.0D0,  0.0D0,
     :     130.6D0,    -0.1D0,    0.0D0,  0.0D0,
     :       3.0D0,     0.3D0,    0.0D0,  0.0D0,
     :     122.9D0,     0.8D0,    0.0D0,  0.0D0,
     :       3.7D0,    -0.3D0,    0.0D0,  0.0D0,
     :     123.1D0,     0.4D0,   -0.3D0,  0.0D0,
     :     -52.7D0,    15.3D0,    0.0D0,  0.0D0,
     :     120.7D0,     0.3D0,   -0.3D0,  0.0D0,
     :       4.0D0,    -0.3D0,    0.0D0,  0.0D0,
     :     126.5D0,     0.5D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=61,70 ) /
     :     112.7D0,     0.5D0,   -0.3D0,  0.0D0,
     :    -106.1D0,    -0.3D0,    0.3D0,  0.0D0,
     :    -112.9D0,    -0.2D0,    0.0D0,  0.0D0,
     :       3.6D0,    -0.2D0,    0.0D0,  0.0D0,
     :     107.4D0,     0.3D0,    0.0D0,  0.0D0,
     :     -10.9D0,     0.2D0,    0.0D0,  0.0D0,
     :      -0.9D0,     0.0D0,    0.0D0,  0.0D0,
     :      85.4D0,     0.0D0,    0.0D0,  0.0D0,
     :       0.0D0,   -88.8D0,    0.0D0,  0.0D0,
     :     -71.0D0,    -0.2D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=71,80 ) /
     :     -70.3D0,     0.0D0,    0.0D0,  0.0D0,
     :      64.5D0,     0.4D0,    0.0D0,  0.0D0,
     :      69.8D0,     0.0D0,    0.0D0,  0.0D0,
     :      66.1D0,     0.4D0,    0.0D0,  0.0D0,
     :     -61.0D0,    -0.2D0,    0.0D0,  0.0D0,
     :     -59.5D0,    -0.1D0,    0.0D0,  0.0D0,
     :     -55.6D0,     0.0D0,    0.2D0,  0.0D0,
     :      51.7D0,     0.2D0,    0.0D0,  0.0D0,
     :     -49.0D0,    -0.1D0,    0.0D0,  0.0D0,
     :     -52.7D0,    -0.1D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=81,90 ) /
     :     -49.6D0,     1.4D0,    0.0D0,  0.0D0,
     :      46.3D0,     0.4D0,    0.0D0,  0.0D0,
     :      49.6D0,     0.1D0,    0.0D0,  0.0D0,
     :      -5.1D0,     0.1D0,    0.0D0,  0.0D0,
     :     -44.0D0,    -0.1D0,    0.0D0,  0.0D0,
     :     -39.9D0,    -0.1D0,    0.0D0,  0.0D0,
     :     -39.5D0,    -0.1D0,    0.0D0,  0.0D0,
     :      -3.9D0,     0.1D0,    0.0D0,  0.0D0,
     :     -42.1D0,    -0.1D0,    0.0D0,  0.0D0,
     :     -17.2D0,     0.1D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=91,100 ) /
     :      -2.3D0,     0.1D0,    0.0D0,  0.0D0,
     :     -39.2D0,     0.0D0,    0.0D0,  0.0D0,
     :     -38.4D0,     0.1D0,    0.0D0,  0.0D0,
     :      36.8D0,     0.2D0,    0.0D0,  0.0D0,
     :      34.6D0,     0.1D0,    0.0D0,  0.0D0,
     :     -32.7D0,     0.3D0,    0.0D0,  0.0D0,
     :      30.4D0,     0.0D0,    0.0D0,  0.0D0,
     :       0.4D0,     0.1D0,    0.0D0,  0.0D0,
     :      29.3D0,     0.2D0,    0.0D0,  0.0D0,
     :      31.6D0,     0.1D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=101,110 ) /
     :       0.8D0,    -0.1D0,    0.0D0,  0.0D0,
     :     -27.9D0,     0.0D0,    0.0D0,  0.0D0,
     :       2.9D0,     0.0D0,    0.0D0,  0.0D0,
     :     -25.3D0,     0.0D0,    0.0D0,  0.0D0,
     :      25.0D0,     0.1D0,    0.0D0,  0.0D0,
     :      27.5D0,     0.1D0,    0.0D0,  0.0D0,
     :     -24.4D0,    -0.1D0,    0.0D0,  0.0D0,
     :      24.9D0,     0.2D0,    0.0D0,  0.0D0,
     :     -22.8D0,    -0.1D0,    0.0D0,  0.0D0,
     :       0.9D0,    -0.1D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=111,120 ) /
     :      24.4D0,     0.1D0,    0.0D0,  0.0D0,
     :      23.9D0,     0.1D0,    0.0D0,  0.0D0,
     :      22.5D0,     0.1D0,    0.0D0,  0.0D0,
     :      20.8D0,     0.1D0,    0.0D0,  0.0D0,
     :      20.1D0,     0.0D0,    0.0D0,  0.0D0,
     :      21.5D0,     0.1D0,    0.0D0,  0.0D0,
     :     -20.0D0,     0.0D0,    0.0D0,  0.0D0,
     :       1.4D0,     0.0D0,    0.0D0,  0.0D0,
     :      -0.2D0,    -0.1D0,    0.0D0,  0.0D0,
     :      19.0D0,     0.0D0,   -0.1D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=121,130 ) /
     :      20.5D0,     0.0D0,    0.0D0,  0.0D0,
     :      -2.0D0,     0.0D0,    0.0D0,  0.0D0,
     :     -17.6D0,    -0.1D0,    0.0D0,  0.0D0,
     :      19.0D0,     0.0D0,    0.0D0,  0.0D0,
     :      -2.4D0,     0.0D0,    0.0D0,  0.0D0,
     :     -18.4D0,    -0.1D0,    0.0D0,  0.0D0,
     :      17.1D0,     0.0D0,    0.0D0,  0.0D0,
     :       0.4D0,     0.0D0,    0.0D0,  0.0D0,
     :      18.4D0,     0.1D0,    0.0D0,  0.0D0,
     :       0.0D0,    17.4D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=131,140 ) /
     :      -0.6D0,     0.0D0,    0.0D0,  0.0D0,
     :     -15.4D0,     0.0D0,    0.0D0,  0.0D0,
     :     -16.8D0,    -0.1D0,    0.0D0,  0.0D0,
     :      16.3D0,     0.0D0,    0.0D0,  0.0D0,
     :      -2.0D0,     0.0D0,    0.0D0,  0.0D0,
     :      -1.5D0,     0.0D0,    0.0D0,  0.0D0,
     :     -14.3D0,    -0.1D0,    0.0D0,  0.0D0,
     :      14.4D0,     0.0D0,    0.0D0,  0.0D0,
     :     -13.4D0,     0.0D0,    0.0D0,  0.0D0,
     :     -14.3D0,    -0.1D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=141,150 ) /
     :     -13.7D0,     0.0D0,    0.0D0,  0.0D0,
     :      13.1D0,     0.1D0,    0.0D0,  0.0D0,
     :      -1.7D0,     0.0D0,    0.0D0,  0.0D0,
     :     -12.8D0,     0.0D0,    0.0D0,  0.0D0,
     :       0.0D0,   -14.4D0,    0.0D0,  0.0D0,
     :      12.4D0,     0.0D0,    0.0D0,  0.0D0,
     :     -12.0D0,     0.0D0,    0.0D0,  0.0D0,
     :      -0.8D0,     0.0D0,    0.0D0,  0.0D0,
     :      10.9D0,     0.1D0,    0.0D0,  0.0D0,
     :     -10.8D0,     0.0D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=151,160 ) /
     :      10.5D0,     0.0D0,    0.0D0,  0.0D0,
     :     -10.4D0,     0.0D0,    0.0D0,  0.0D0,
     :     -11.2D0,     0.0D0,    0.0D0,  0.0D0,
     :      10.5D0,     0.1D0,    0.0D0,  0.0D0,
     :      -1.4D0,     0.0D0,    0.0D0,  0.0D0,
     :       0.0D0,     0.1D0,    0.0D0,  0.0D0,
     :       0.7D0,     0.0D0,    0.0D0,  0.0D0,
     :     -10.3D0,     0.0D0,    0.0D0,  0.0D0,
     :     -10.0D0,     0.0D0,    0.0D0,  0.0D0,
     :       9.6D0,     0.0D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=161,170 ) /
     :       9.4D0,     0.1D0,    0.0D0,  0.0D0,
     :       0.6D0,     0.0D0,    0.0D0,  0.0D0,
     :     -87.7D0,     4.4D0,   -0.4D0, -6.3D0,
     :      46.3D0,    22.4D0,    0.5D0, -2.4D0,
     :      15.6D0,    -3.4D0,    0.1D0,  0.4D0,
     :       5.2D0,     5.8D0,    0.2D0, -0.1D0,
     :     -30.1D0,    26.9D0,    0.7D0,  0.0D0,
     :      23.2D0,    -0.5D0,    0.0D0,  0.6D0,
     :       1.0D0,    23.2D0,    3.4D0,  0.0D0,
     :     -12.2D0,    -4.3D0,    0.0D0,  0.0D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=171,180 ) /
     :      -2.1D0,    -3.7D0,   -0.2D0,  0.1D0,
     :     -18.6D0,    -3.8D0,   -0.4D0,  1.8D0,
     :       5.5D0,   -18.7D0,   -1.8D0, -0.5D0,
     :      -5.5D0,   -18.7D0,    1.8D0, -0.5D0,
     :      18.4D0,    -3.6D0,    0.3D0,  0.9D0,
     :      -0.6D0,     1.3D0,    0.0D0,  0.0D0,
     :      -5.6D0,   -19.5D0,    1.9D0,  0.0D0,
     :       5.5D0,   -19.1D0,   -1.9D0,  0.0D0,
     :     -17.3D0,    -0.8D0,    0.0D0,  0.9D0,
     :      -3.2D0,    -8.3D0,   -0.8D0,  0.3D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=181,190 ) /
     :      -0.1D0,     0.0D0,    0.0D0,  0.0D0,
     :      -5.4D0,     7.8D0,   -0.3D0,  0.0D0,
     :     -14.8D0,     1.4D0,    0.0D0,  0.3D0,
     :      -3.8D0,     0.4D0,    0.0D0, -0.2D0,
     :      12.6D0,     3.2D0,    0.5D0, -1.5D0,
     :       0.1D0,     0.0D0,    0.0D0,  0.0D0,
     :     -13.6D0,     2.4D0,   -0.1D0,  0.0D0,
     :       0.9D0,     1.2D0,    0.0D0,  0.0D0,
     :     -11.9D0,    -0.5D0,    0.0D0,  0.3D0,
     :       0.4D0,    12.0D0,    0.3D0, -0.2D0 /
      DATA ( ( EPS(I,J), I=1,4 ), J=191,NTERMS ) /
     :       8.3D0,     6.1D0,   -0.1D0,  0.1D0,
     :       0.0D0,     0.0D0,    0.0D0,  0.0D0,
     :       0.4D0,   -10.8D0,    0.3D0,  0.0D0,
     :       9.6D0,     2.2D0,    0.3D0, -1.2D0 /



*  Interval between fundamental epoch J2000.0 and given epoch (JC).
      T = (DATE-DJM0)/DJC

*  Mean anomaly of the Moon.
      EL  = 134.96340251D0*DD2R+
     :      MOD(T*(1717915923.2178D0+
     :          T*(        31.8792D0+
     :          T*(         0.051635D0+
     :          T*(       - 0.00024470D0)))),TURNAS)*DAS2R

*  Mean anomaly of the Sun.
      ELP = 357.52910918D0*DD2R+
     :      MOD(T*( 129596581.0481D0+
     :          T*(       - 0.5532D0+
     :          T*(         0.000136D0+
     :          T*(       - 0.00001149D0)))),TURNAS)*DAS2R

*  Mean argument of the latitude of the Moon.
      F   =  93.27209062D0*DD2R+
     :      MOD(T*(1739527262.8478D0+
     :          T*(      - 12.7512D0+
     :          T*(      -  0.001037D0+
     :          T*(         0.00000417D0)))),TURNAS)*DAS2R

*  Mean elongation of the Moon from the Sun.
      D   = 297.85019547D0*DD2R+
     :      MOD(T*(1602961601.2090D0+
     :          T*(       - 6.3706D0+
     :          T*(         0.006539D0+
     :          T*(       - 0.00003169D0)))),TURNAS)*DAS2R

*  Mean longitude of the ascending node of the Moon.
      OM  = 125.04455501D0*DD2R+
     :      MOD(T*( - 6962890.5431D0+
     :          T*(         7.4722D0+
     :          T*(         0.007702D0+
     :          T*(       - 0.00005939D0)))),TURNAS)*DAS2R

*  Mean longitude of Venus.
      VE    = 181.97980085D0*DD2R+MOD(210664136.433548D0*T,TURNAS)*DAS2R

*  Mean longitude of Mars.
      MA    = 355.43299958D0*DD2R+MOD( 68905077.493988D0*T,TURNAS)*DAS2R

*  Mean longitude of Jupiter.
      JU    =  34.35151874D0*DD2R+MOD( 10925660.377991D0*T,TURNAS)*DAS2R

*  Mean longitude of Saturn.
      SA    =  50.07744430D0*DD2R+MOD(  4399609.855732D0*T,TURNAS)*DAS2R

*  Geodesic nutation (Fukushima 1991) in microarcsec.
      DP = -153.1D0*SIN(ELP)-1.9D0*SIN(2D0*ELP)
      DE = 0D0

*  Shirai & Fukushima (2001) nutation series.
      DO J=NTERMS,1,-1
         THETA = DBLE(NA(1,J))*EL+
     :           DBLE(NA(2,J))*ELP+
     :           DBLE(NA(3,J))*F+
     :           DBLE(NA(4,J))*D+
     :           DBLE(NA(5,J))*OM+
     :           DBLE(NA(6,J))*VE+
     :           DBLE(NA(7,J))*MA+
     :           DBLE(NA(8,J))*JU+
     :           DBLE(NA(9,J))*SA
         C = COS(THETA)
         S = SIN(THETA)
         DP = DP+(PSI(1,J)+PSI(3,J)*T)*C+(PSI(2,J)+PSI(4,J)*T)*S
         DE = DE+(EPS(1,J)+EPS(3,J)*T)*C+(EPS(2,J)+EPS(4,J)*T)*S
      END DO

*  Change of units, and addition of the precession correction.
      DPSI = (DP*1D-6-0.042888D0-0.29856D0*T)*DAS2R
      DEPS = (DE*1D-6-0.005171D0-0.02408D0*T)*DAS2R

*  Mean obliquity of date (Simon et al. 1994).
      EPS0 = (84381.412D0+
     :         (-46.80927D0+
     :          (-0.000152D0+
     :           (0.0019989D0+
     :          (-0.00000051D0+
     :          (-0.000000025D0)*T)*T)*T)*T)*T)*DAS2R

      END
      SUBROUTINE sla_NUT (DATE, RMATN)
*+
*     - - - -
*      N U T
*     - - - -
*
*  Form the matrix of nutation for a given date - Shirai & Fukushima
*  2001 theory (double precision)
*
*  Reference:
*     Shirai, T. & Fukushima, T., Astron.J. 121, 3270-3283 (2001).
*
*  Given:
*     DATE    d          TDB (loosely ET) as Modified Julian Date
*                                           (=JD-2400000.5)
*  Returned:
*     RMATN   d(3,3)     nutation matrix
*
*  Notes:
*
*  1  The matrix is in the sense  v(true) = rmatn * v(mean) .
*     where v(true) is the star vector relative to the true equator and
*     equinox of date and v(mean) is the star vector relative to the
*     mean equator and equinox of date.
*
*  2  The matrix represents forced nutation (but not free core
*     nutation) plus corrections to the IAU~1976 precession model.
*
*  3  Earth attitude predictions made by combining the present nutation
*     matrix with IAU~1976 precession are accurate to 1~mas (with
*     respect to the ICRS) for a few decades around 2000.
*
*  4  The distinction between the required TDB and TT is always
*     negligible.  Moreover, for all but the most critical applications
*     UTC is adequate.
*
*  Called:   sla_NUTC, sla_DEULER
*
*  Last revision:   1 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,RMATN(3,3)

      DOUBLE PRECISION DPSI,DEPS,EPS0



*  Nutation components and mean obliquity
      CALL sla_NUTC(DATE,DPSI,DEPS,EPS0)

*  Rotation matrix
      CALL sla_DEULER('XZX',EPS0,-DPSI,-(EPS0+DEPS),RMATN)

      END
      SUBROUTINE sla_PREBN (BEP0, BEP1, RMATP)
*+
*     - - - - - -
*      P R E B N
*     - - - - - -
*
*  Generate the matrix of precession between two epochs,
*  using the old, pre-IAU1976, Bessel-Newcomb model, using
*  Kinoshita's formulation (double precision)
*
*  Given:
*     BEP0    dp         beginning Besselian epoch
*     BEP1    dp         ending Besselian epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  The matrix is in the sense   V(BEP1)  =  RMATP * V(BEP0)
*
*  Reference:
*     Kinoshita, H. (1975) 'Formulas for precession', SAO Special
*     Report No. 364, Smithsonian Institution Astrophysical
*     Observatory, Cambridge, Massachusetts.
*
*  Called:  sla_DEULER
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION BEP0,BEP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION BIGT,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch B1850.0 and beginning epoch in TC
      BIGT = (BEP0-1850D0)/100D0

*  Interval over which precession required, in tropical centuries
      T = (BEP1-BEP0)/100D0

*  Euler angles
      TAS2R = T*AS2R
      W = 2303.5548D0+(1.39720D0+0.000059D0*BIGT)*BIGT

      ZETA = (W+(0.30242D0-0.000269D0*BIGT+0.017996D0*T)*T)*TAS2R
      Z = (W+(1.09478D0+0.000387D0*BIGT+0.018324D0*T)*T)*TAS2R
      THETA = (2005.1125D0+(-0.85294D0-0.000365D0*BIGT)*BIGT+
     :        (-0.42647D0-0.000365D0*BIGT-0.041802D0*T)*T)*TAS2R

*  Rotation matrix
      CALL sla_DEULER('ZYZ',-ZETA,THETA,-Z,RMATP)

      END
      SUBROUTINE sla_PRECES (SYSTEM, EP0, EP1, RA, DC)
*+
*     - - - - - - -
*      P R E C E S
*     - - - - - - -
*
*  Precession - either FK4 (Bessel-Newcomb, pre IAU 1976) or
*  FK5 (Fricke, post IAU 1976) as required.
*
*  Given:
*     SYSTEM     char   precession to be applied: 'FK4' or 'FK5'
*     EP0,EP1    dp     starting and ending epoch
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP0
*
*  Returned:
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP1
*
*  Called:    sla_DRANRM, sla_PREBN, sla_PREC, sla_DCS2C,
*             sla_DMXV, sla_DCC2S
*
*  Notes:
*
*     1)  Lowercase characters in SYSTEM are acceptable.
*
*     2)  The epochs are Besselian if SYSTEM='FK4' and Julian if 'FK5'.
*         For example, to precess coordinates in the old system from
*         equinox 1900.0 to 1950.0 the call would be:
*             CALL sla_PRECES ('FK4', 1900D0, 1950D0, RA, DC)
*
*     3)  This routine will NOT correctly convert between the old and
*         the new systems - for example conversion from B1950 to J2000.
*         For these purposes see sla_FK425, sla_FK524, sla_FK45Z and
*         sla_FK54Z.
*
*     4)  If an invalid SYSTEM is supplied, values of -99D0,-99D0 will
*         be returned for both RA and DC.
*
*  P.T.Wallace   Starlink   20 April 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      CHARACTER SYSTEM*(*)
      DOUBLE PRECISION EP0,EP1,RA,DC

      DOUBLE PRECISION PM(3,3),V1(3),V2(3)
      CHARACTER SYSUC*3

      DOUBLE PRECISION sla_DRANRM




*  Convert to uppercase and validate SYSTEM
      SYSUC=SYSTEM
      IF (SYSUC(1:1).EQ.'f') SYSUC(1:1)='F'
      IF (SYSUC(2:2).EQ.'k') SYSUC(2:2)='K'
      IF (SYSUC.NE.'FK4'.AND.SYSUC.NE.'FK5') THEN
         RA=-99D0
         DC=-99D0
      ELSE

*     Generate appropriate precession matrix
         IF (SYSUC.EQ.'FK4') THEN
            CALL sla_PREBN(EP0,EP1,PM)
         ELSE
            CALL sla_PREC(EP0,EP1,PM)
         END IF

*     Convert RA,Dec to x,y,z
         CALL sla_DCS2C(RA,DC,V1)

*     Precess
         CALL sla_DMXV(PM,V1,V2)

*     Back to RA,Dec
         CALL sla_DCC2S(V2,RA,DC)
         RA=sla_DRANRM(RA)

      END IF

      END
      SUBROUTINE sla_PREC (EP0, EP1, RMATP)
*+
*     - - - - -
*      P R E C
*     - - - - -
*
*  Form the matrix of precession between two epochs (IAU 1976, FK5)
*  (double precision)
*
*  Given:
*     EP0    dp         beginning epoch
*     EP1    dp         ending epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  Notes:
*
*     1)  The epochs are TDB (loosely ET) Julian epochs.
*
*     2)  The matrix is in the sense   V(EP1)  =  RMATP * V(EP0)
*
*     3)  Though the matrix method itself is rigorous, the precession
*         angles are expressed through canonical polynomials which are
*         valid only for a limited time span.  There are also known
*         errors in the IAU precession rate.  The absolute accuracy
*         of the present formulation is better than 0.1 arcsec from
*         1960AD to 2040AD, better than 1 arcsec from 1640AD to 2360AD,
*         and remains below 3 arcsec for the whole of the period
*         500BC to 3000AD.  The errors exceed 10 arcsec outside the
*         range 1200BC to 3900AD, exceed 100 arcsec outside 4200BC to
*         5600AD and exceed 1000 arcsec outside 6800BC to 8200AD.
*         The SLALIB routine sla_PRECL implements a more elaborate
*         model which is suitable for problems spanning several
*         thousand years.
*
*  References:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*      equations (6) & (7), p283.
*     Kaplan,G.H., 1981. USNO circular no. 163, pA2.
*
*  Called:  sla_DEULER
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EP0,EP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T0,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch J2000.0 and beginning epoch (JC)
      T0 = (EP0-2000D0)/100D0

*  Interval over which precession required (JC)
      T = (EP1-EP0)/100D0

*  Euler angles
      TAS2R = T*AS2R
      W = 2306.2181D0+(1.39656D0-0.000139D0*T0)*T0

      ZETA = (W+((0.30188D0-0.000344D0*T0)+0.017998D0*T)*T)*TAS2R
      Z = (W+((1.09468D0+0.000066D0*T0)+0.018203D0*T)*T)*TAS2R
      THETA = ((2004.3109D0+(-0.85330D0-0.000217D0*T0)*T0)
     :        +((-0.42665D0-0.000217D0*T0)-0.041833D0*T)*T)*TAS2R

*  Rotation matrix
      CALL sla_DEULER('ZYZ',-ZETA,THETA,-Z,RMATP)

      END
      SUBROUTINE sla_PVOBS (P, H, STL, PV)
*+
*     - - - - - -
*      P V O B S
*     - - - - - -
*
*  Position and velocity of an observing station (double precision)
*
*  Given:
*     P     dp     latitude (geodetic, radians)
*     H     dp     height above reference spheroid (geodetic, metres)
*     STL   dp     local apparent sidereal time (radians)
*
*  Returned:
*     PV    dp(6)  position/velocity 6-vector (AU, AU/s, true equator
*                                              and equinox of date)
*
*  Called:  sla_GEOC
*
*  IAU 1976 constants are used.
*
*  P.T.Wallace   Starlink   14 November 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION P,H,STL,PV(6)

      DOUBLE PRECISION R,Z,S,C,V

*  Mean sidereal rate (at J2000) in radians per (UT1) second
      DOUBLE PRECISION SR
      PARAMETER (SR=7.292115855306589D-5)



*  Geodetic to geocentric conversion
      CALL sla_GEOC(P,H,R,Z)

*  Functions of ST
      S=SIN(STL)
      C=COS(STL)

*  Speed
      V=SR*R

*  Position
      PV(1)=R*C
      PV(2)=R*S
      PV(3)=Z

*  Velocity
      PV(4)=-V*S
      PV(5)=V*C
      PV(6)=0D0

      END

module rfile3a_mod
  implicit none
contains
  subroutine rfile3a(infile,ibuf,n,fcenter,ierr)
    use iso_c_binding
    use iso_fortran_env, only: real64, int64
    implicit none
    character*(*), intent(in) :: infile
    integer, intent(in) :: n
    ! integer*8, intent(out) :: ibuf(n/8) ! ibuf(n) in original but read (ibuf(i),i=1,n/8). So ibuf must be n/8 size if int*8? 
    ! Wait, original: integer*8 ibuf(n). read (ibuf(i),i=1,n/8).
    ! So it writes to the first n/8 elements. 
    ! But if n is byte count, and ibuf is 8 bytes, then n/8 is 64-bit word count.
    ! So ibuf is integer*8 array of size at least n/8.
    ! The declaration integer*8 ibuf(n) implies size n.
    ! I will keep it as ibuf(n) or ibuf(*).
    integer(int64), intent(out) :: ibuf(n)
    real(real64), intent(out) :: fcenter
    integer, intent(out) :: ierr
    
    integer :: i
  
    open(10,file=infile,access='stream',status='old',err=998)
    read(10,end=998) (ibuf(i),i=1,n/8),fcenter
    ierr=0
    close(10)
    return
  
  998 ierr=1002
    close(10)
    return
  end subroutine rfile3a
end module rfile3a_mod

subroutine unpackprop(n1,k,muf,ccur,cxp)

  character ccur*4,cxp*2

  muf=mod(n1,62)
  n1=n1/62

  k=mod(n1,11)
  n1=n1/11

  j=mod(n1,53)
  n1=n1/53
  if(j.eq.0) cxp='*'
  if(j.ge.1 .and. j.le.26) cxp=char(64+j)
  if(j.gt.26) cxp=char(64+j-26)//char(64+j-26)

  j=mod(n1,53)
  n1=n1/53
  if(j.eq.0) ccur(2:2)='*'
  if(j.ge.1 .and. j.le.26) ccur(2:2)=char(64+j)
  if(j.gt.26) ccur(2:3)=char(64+j-26)//char(64+j-26)
  j=n1
  if(j.eq.0) ccur(1:1)='*'
  if(j.ge.1 .and. j.le.26) ccur(1:1)=char(64+j)
  if(j.gt.26) ccur=char(64+j-26)//char(64+j-26)//ccur(2:3)

  return
end subroutine unpackprop

subroutine peakdt9(c2,nsps8,nspsd,c3,xdt)

  parameter (NZ2=1512,NZ3=1360)
  complex c2(0:NZ2-1)
  complex c3(0:NZ3-1)
  complex z
  real p(0:3300)
  include 'jt9sync.f90'

  p=0.
  i0=5*nspsd 
  do i=0,NZ2-1
     z=1.e-3*sum(c2(max(i-(nspsd-1),0):i))
     p(i0+i)=real(z)**2 + aimag(z)**2      !Integrated symbol power at freq=0
  enddo

  call getlags(nsps8,lag0,lag1,lag2)
  tsymbol=nsps8/1500.0
  dtlag=tsymbol/nspsd
  smax=0.
  lagpk=0
  do lag=lag1,lag2
     sum0=0.
     sum1=0.
     j=-nspsd
     do i=1,85
        j=j+nspsd
        if(isync(i).eq.1) then
           sum1=sum1+p(j+lag)
        else
           sum0=sum0+p(j+lag)
        endif
     enddo
     ss=(sum1/16.0)/(sum0/69.0) - 1.0
     xdt=(lag-lag0)*dtlag
     if(ss.gt.smax) then
        smax=ss
        lagpk=lag
     endif
  enddo

  xdt=(lagpk-lag0)*dtlag

  do i=0,NZ3-1
     j=i+lagpk-i0-nspsd+1
     if(j.ge.0 .and. j.lt.NZ2) then
        c3(i)=c2(j)
     else
        c3(i)=0.
     endif
  enddo
 
  return
end subroutine peakdt9

subroutine sync8(dd,nfa,nfb,syncmin,nfqso,maxcand,candidate,ncand,sbase)

  include 'ft8_params.f90'
  parameter (MAXPRECAND=1000)
! Maximum sync correlation lag +/- 2.5s relative to 0.5s TX start time. 
! 2.5s / 0.16s/symbol * 4 samples/symbol = 62.5 lag steps in 2.5s
  parameter (JZ=62)                        
  complex cx(0:NH1)
  real s(NH1,NHSYM)
  real savg(NH1)
  real sbase(NH1)
  real x(NFFT1)
  real sync2d(NH1,-JZ:JZ)
  real red(NH1)
  real red2(NH1)
  real candidate0(3,MAXPRECAND)
  real candidate(3,maxcand)
  real dd(NMAX)
  integer jpeak(NH1)
  integer jpeak2(NH1)
  integer indx(NH1)
  integer indx2(NH1)
  integer ii(1)
  integer icos7(0:6)
  data icos7/3,1,4,0,6,5,2/                   !Costas 7x7 tone pattern
  equivalence (x,cx)

! Compute symbol spectra, stepping by NSTEP steps.  
  savg=0.
  tstep=NSTEP/12000.0                         
  df=12000.0/NFFT1                            !3.125 Hz
  fac=1.0/300.0
  do j=1,NHSYM
     ia=(j-1)*NSTEP + 1
     ib=ia+NSPS-1
     x(1:NSPS)=fac*dd(ia:ib)
     x(NSPS+1:)=0.
     call four2a(x,NFFT1,1,-1,0)              !r2c FFT
     do i=1,NH1
        s(i,j)=real(cx(i))**2 + aimag(cx(i))**2
     enddo
     savg=savg + s(1:NH1,j)                   !Average spectrum
  enddo
  call get_spectrum_baseline(dd,nfa,nfb,sbase)

  ia=max(1,nint(nfa/df))
  ib=nint(nfb/df)
  nssy=NSPS/NSTEP   ! # steps per symbol
  nfos=NFFT1/NSPS   ! # frequency bin oversampling factor
  jstrt=0.5/tstep
  candidate0=0.
  k=0

  do i=ia,ib
     do j=-JZ,+JZ
        ta=0.
        tb=0.
        tc=0.
        t0a=0.
        t0b=0.
        t0c=0.
        do n=0,6
           m=j+jstrt+nssy*n
           if(m.ge.1.and.m.le.NHSYM) then
              ta=ta + s(i+nfos*icos7(n),m)
              t0a=t0a + sum(s(i:i+nfos*6:nfos,m))
           endif
           tb=tb + s(i+nfos*icos7(n),m+nssy*36)
           t0b=t0b + sum(s(i:i+nfos*6:nfos,m+nssy*36))
           if(m+nssy*72.le.NHSYM) then
              tc=tc + s(i+nfos*icos7(n),m+nssy*72)
              t0c=t0c + sum(s(i:i+nfos*6:nfos,m+nssy*72))
           endif
        enddo
        t=ta+tb+tc
        t0=t0a+t0b+t0c
        t0=(t0-t)/6.0
        sync_abc=t/t0
        t=tb+tc
        t0=t0b+t0c
        t0=(t0-t)/6.0
        sync_bc=t/t0
        sync2d(i,j)=max(sync_abc,sync_bc)
     enddo
  enddo

  red=0.
  red2=0.
  mlag=13
  mlag2=JZ
  do i=ia,ib
     ii=maxloc(sync2d(i,-mlag:mlag)) - 1 - mlag 
     jpeak(i)=ii(1)
     red(i)=sync2d(i,jpeak(i))
     ii=maxloc(sync2d(i,-mlag2:mlag2)) - 1 - mlag2
     jpeak2(i)=ii(1)
     red2(i)=sync2d(i,jpeak2(i))
  enddo
  iz=ib-ia+1
  call indexx(red(ia:ib),iz,indx)
  npctile=nint(0.40*iz)
  if(npctile.lt.1) then ! something is wrong; bail out
    ncand=0
    return;
  endif
  ibase=indx(npctile) - 1 + ia
  if(ibase.lt.1) ibase=1
  if(ibase.gt.nh1) ibase=nh1
  base=red(ibase)
  red=red/base
  call indexx(red2(ia:ib),iz,indx2)
  ibase2=indx2(npctile) - 1 + ia
  if(ibase2.lt.1) ibase2=1
  if(ibase2.gt.nh1) ibase2=nh1
  base2=red2(ibase2)
  red2=red2/base2
  do i=1,min(MAXPRECAND,iz)
     n=ia + indx(iz+1-i) - 1
     if(k.ge.MAXPRECAND) exit
     if( (red(n).ge.syncmin) .and. (.not.isnan(red(n))) ) then 
        k=k+1
        candidate0(1,k)=n*df
        candidate0(2,k)=(jpeak(n)-0.5)*tstep
        candidate0(3,k)=red(n)
     endif
     if(abs(jpeak2(n)-jpeak(n)).eq.0) cycle 
     if(k.ge.MAXPRECAND) exit
     if( (red2(n).ge.syncmin) .and. (.not.isnan(red2(n))) ) then
        k=k+1
        candidate0(1,k)=n*df
        candidate0(2,k)=(jpeak2(n)-0.5)*tstep
        candidate0(3,k)=red2(n)
     endif
  enddo
  ncand=k

! Save only the best of near-dupe freqs.  
  do i=1,ncand
     if(i.ge.2) then
        do j=1,i-1
           fdiff=abs(candidate0(1,i))-abs(candidate0(1,j))
           tdiff=abs(candidate0(2,i)-candidate0(2,j))
           if(abs(fdiff).lt.4.0.and.tdiff.lt.0.04) then
              if(candidate0(3,i).ge.candidate0(3,j)) candidate0(3,j)=0.
              if(candidate0(3,i).lt.candidate0(3,j)) candidate0(3,i)=0.
           endif
        enddo
     endif
  enddo
  fac=20.0/maxval(s)
  s=fac*s

! Sort by sync
  call indexx(candidate0(3,1:ncand),ncand,indx)
! Place candidates within 10 Hz of nfqso at the top of the list
  k=1
  do i=1,ncand
    if( abs( candidate0(1,i)-nfqso ).le.10.0 .and. candidate0(3,i).ge.syncmin ) then
      candidate(1:3,k)=candidate0(1:3,i)
      candidate0(3,i)=0.0
      k=k+1
    endif
  enddo
 
  do i=ncand,1,-1
     j=indx(i)
     if( candidate0(3,j) .ge. syncmin ) then
       candidate(2:3,k)=candidate0(2:3,j)
       candidate(1,k)=abs(candidate0(1,j))
       k=k+1
       if(k.gt.maxcand) exit
     endif
  enddo
  ncand=k-1
  return
end subroutine sync8

!subroutine xcor(ss,ipk,nsteps,nsym,lag1,lag2,ccf,ccf0,lagpk,flip,fdot,nrobust)
subroutine xcor(ipk,nsteps,nsym,lag1,lag2,ccf,ccf0,lagpk,flip,fdot,nrobust)

! Computes ccf of a row of ss and the pseudo-random array pr.  Returns
! peak of the CCF and the lag at which peak occurs.  For JT65, the 
! CCF peak may be either positive or negative, with negative implying
! the "OOO" message.

  use jt65_mod
  parameter (NHMAX=3413)           !Max length of power spectra
  parameter (NSMAX=552)            !Max number of quarter-symbol steps
  real ss(NSMAX,NHMAX)             !2d spectrum, stepped by half-symbols
  real a(NSMAX)
!  real ccf(-44:118)
  real ccf(lag1:lag2)
  data lagmin/0/                              !Silence g77 warning
!  save
  common/sync/ss

  df=12000.0/8192.
!  dtstep=0.5/df
  dtstep=0.25/df
  fac=dtstep/(60.0*df)
  do j=1,nsteps
     ii=nint((j-nsteps/2)*fdot*fac)+ipk
     if( (ii.ge.1) .and. (ii.le.NHMAX) ) then
       a(j)=ss(j,ii)
     endif
  enddo

  if(nrobust.eq.1) then
! use robust correlation estimator to mitigate AGC attack spikes at beginning
! this reduces the number of spurious candidates overall
    call pctile(a,nsteps,50,xmed)
    do j=1,nsteps
      if( a(j).ge.xmed ) then
        a(j)=1
      else
        a(j)=-1
      endif
    enddo
  endif

  ccfmax=0.
  ccfmin=0.
  do lag=lag1,lag2
     x=0.
     do i=1,nsym
        j=4*i-3+lag
        if(j.ge.1 .and. j.le.nsteps) x=x+a(j)*pr(i)
     enddo
     ccf(lag)=2*x                        !The 2 is for plotting scale
     if(ccf(lag).gt.ccfmax) then
        ccfmax=ccf(lag)
        lagpk=lag
     endif

     if(ccf(lag).lt.ccfmin) then
        ccfmin=ccf(lag)
        lagmin=lag
     endif
  enddo

  ccf0=ccfmax
  flip=1.0
  if(-ccfmin.gt.ccfmax) then
     do lag=lag1,lag2
        ccf(lag)=-ccf(lag)
     enddo
     lagpk=lagmin
     ccf0=-ccfmin
     flip=-1.0
  endif

  return
end subroutine xcor

program fst4sim

! Generate simulated signals for experimental slow FT4  mode

   use wavhdr
   use packjt77
   include 'fst4_params.f90'               !Set various constants
   type(hdr) h                                !Header for .wav file
   logical*1 wspr_hint
   character arg*12,fname*17
   character msg37*37,msgsent37*37,c77*77
   complex, allocatable :: c0(:)
   complex, allocatable :: c(:)
   real, allocatable :: wave(:)
   integer hmod
   integer itone(NN)
   integer*1 msgbits(101)
   integer*2, allocatable :: iwave(:)        !Generated full-length waveform

! Get command-line argument(s)
   nargs=iargc()
   if(nargs.ne.9) then
      print*,'Need 9 arguments, got ',nargs
      print*,'Usage:    fst4sim "message"        TRsec f0   DT  fdop del nfiles snr W'
      print*,'Examples: fst4sim "K1JT K9AN EN50"  60  1500 0.0   0.1 1.0   10   -15 F'
      print*,'W (T or F) argument is hint to encoder to use WSPR message when there is abiguity'
      go to 999
   endif
   call getarg(1,msg37)                   !Message to be transmitted
   call getarg(2,arg)
   read(arg,*) nsec                       !TR sequence length, seconds
   call getarg(3,arg)
   read(arg,*) f00                        !Frequency (only used for single-signal)
   call getarg(4,arg)
   read(arg,*) xdt                        !Time offset from nominal (s)
   call getarg(5,arg)
   read(arg,*) fspread                    !Watterson frequency spread (Hz)
   call getarg(6,arg)
   read(arg,*) delay                      !Watterson delay (ms)
   call getarg(7,arg)
   read(arg,*) nfiles                     !Number of files
   call getarg(8,arg)
   read(arg,*) snrdb                      !SNR_2500
   call getarg(9,arg)
   read(arg,*) wspr_hint                  !0:break ties as 77-bit 1:break ties as 50-bit

   nfiles=abs(nfiles)
   twopi=8.0*atan(1.0)
   fs=12000.0                             !Sample rate (Hz)
   dt=1.0/fs                              !Sample interval (s)
   nsps=0
   if(nsec.eq.15) nsps=720
   if(nsec.eq.30) nsps=1680
   if(nsec.eq.60) nsps=3888
   if(nsec.eq.120) nsps=8200
   if(nsec.eq.300) nsps=21504
   if(nsec.eq.900) nsps=66560
   if(nsec.eq.1800) nsps=134400
   if(nsps.eq.0) then
      print*,'Invalid TR sequence length.'
      go to 999
   endif
   baud=12000.0/nsps                      !Keying rate (baud)
   nmax=nsec*12000
   nz=nsps*NN
   txt=nz*dt                              !Transmission length (s)
   tt=nsps*dt                             !Duration of symbols (s)
   nwave=max(nmax,(NN+2)*nsps)
   allocate( c0(0:nwave-1) )
   allocate( c(0:nwave-1) )
   allocate( wave(nwave) )
   allocate( iwave(nmax) )

   bandwidth_ratio=2500.0/(fs/2.0)
   sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
   if(snrdb.gt.90.0) sig=1.0

   if(wspr_hint) then
      i3=0
      n3=6
   else
      i3=-1
      n3=-1
   endif
   call pack77(msg37,i3,n3,c77)
   if(i3.eq.0.and.n3.eq.6) iwspr=1
   call genfst4(msg37,0,msgsent37,msgbits,itone,iwspr)
   write(*,*)
   write(*,'(a9,a37,a3,L2,a7,i2)') 'Message: ',msgsent37,'W:',wspr_hint,' iwspr:',iwspr
   write(*,1000) f00,xdt,txt,snrdb
1000 format('f0:',f9.3,'   DT:',f6.2,'   TxT:',f6.1,'   SNR:',f6.1)
   write(*,*)
   if(i3.eq.1) then
      write(*,*) '         mycall                         hiscall                    hisgrid'
      write(*,'(28i1,1x,i1,1x,28i1,1x,i1,1x,i1,1x,15i1,1x,3i1)') msgbits(1:77)
   elseif(i3.eq.0 .and. n3.eq.6) then
      write(*,'(a15,37x,a5)') '50-bit message','CRC24'
      write(*,'(50i1,1x,24i1)') msgbits(1:50),msgbits(51:74)
      write(*,'(a50)') '01234567890123456789012345678901234567890123456789'
   else
      write(*,'(a14)') 'Message bits: '
      write(*,'(77i1,1x,24i1)') msgbits
   endif
   write(*,*)
   write(*,'(a17)') 'Channel symbols: '
   write(*,'(10i1)') itone
   write(*,*)

!   call sgran()

   fsample=12000.0 
   hmod=1
   icmplx=1
   f0=f00+1.5*hmod*baud
   call gen_fst4wave(itone,NN,nsps,nwave,fsample,hmod,f0,icmplx,c0,wave)
   k=nint((xdt+1.0)/dt)
   if(nsec.eq.15) k=nint((xdt+0.5)/dt)
   c0=cshift(c0,-k)
   if(k.gt.0) c0(0:k-1)=0.0
   if(k.lt.0) c0(nmax+k:nmax-1)=0.0

   do ifile=1,nfiles
      c=c0
      if(fspread.gt.0.0 .or. delay.ne.0.0) call watterson(c,nwave,NZ,fs,delay,fspread)
      if(fspread.lt.0.0) call lorentzian_fading(c,nwave,fs,-fspread)
      c=sig*c
      wave=aimag(c)
      if(snrdb.lt.90) then
         do i=1,nmax                   !Add gaussian noise at specified SNR
            xnoise=gran()
            wave(i)=wave(i) + xnoise
         enddo
      endif
      gain=100.0
      if(snrdb.lt.90.0) then
         wave=gain*wave
      else
         datpk=maxval(abs(wave))
         fac=32766.9/datpk
         wave=fac*wave
      endif
      if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
      iwave=nint(wave(:size(iwave)))
      h=default_header(12000,nmax)
      if(nmax/12000.le.30) then
         write(fname,1102) ifile
1102     format('000000_',i6.6,'.wav')
      else
         write(fname,1104) ifile
1104     format('000000_',i4.4,'.wav')
      endif
      open(10,file=trim(fname),status='unknown',access='stream')
      write(10) h,iwave                !Save to *.wav file
      close(10)
      write(*,1110) ifile,xdt,f00,snrdb,fname
1110  format(i4,f7.2,f8.2,f7.1,2x,a17)
   enddo

999 end program fst4sim

subroutine ftninit

  use timer_impl, only: init_timer !,fini_timer, limtrace
  use, intrinsic :: iso_c_binding, only: C_NULL_CHAR
  use FFTW3
  character*1 appd
  character addpfx*8
  common/pfxcom/addpfx

  lu=8
  call init_timer('./timer.out')
  
  appd='.'
  addpfx='    '
  open(12,file=appd//'/all_qmap.txt',status='unknown',position='append')
  open(17,file=appd//'/red.dat',status='unknown')
  open(19,file=appd//'/livecq.txt',status='unknown')

  return
end subroutine ftninit

module datcom_ptrs_mod
  use iso_c_binding
  implicit none

  ! Fortran pointer targets
  real(c_float), pointer, contiguous :: dd(:,:) => null()      ! [4, 5760000]
  real(c_float), pointer, contiguous :: ss(:,:,:) => null()     ! [4, 322, NFFT]
  real(c_float), pointer, contiguous :: savg(:,:) => null()     ! [4, NFFT]

  ! Scalar values
  integer, parameter :: NFFT=32768              !Length of FFTs
  integer(c_int) :: junk1 = 0, junk2 = 0, quitid = 0
  
contains

  ! Helper subroutine to copy fixed-length Fortran string to C buffer
  subroutine move_chars(dest, dest_len, src)
    integer(c_int), intent(in) :: dest_len
    character(kind=c_char), intent(out) :: dest(dest_len)
    character(len=*), intent(in) :: src
    integer :: i, n

    n = min(len(src), dest_len)
    do i = 1, n
      dest(i) = src(i:i)
    end do
  end subroutine move_chars
  
  subroutine set_dd_ptr(ptr, dim1, dim2) bind(C, name="set_dd_ptr")
    use iso_c_binding
    implicit none
    type(c_ptr), value :: ptr
    integer(c_int), value :: dim1, dim2
    call c_f_pointer(ptr, dd, [dim1, dim2])
    print *, "Fortran: dd pointer associated with dimensions", dim1, dim2
  end subroutine

  subroutine set_ss_ptr(ptr, dim1, dim2, dim3) bind(C, name="set_ss_ptr")
    use iso_c_binding
    implicit none
    type(c_ptr), value :: ptr
    integer(c_int), value :: dim1, dim2, dim3
    call c_f_pointer(ptr, ss, [dim1, dim2, dim3])
    print *, "Fortran: ss pointer associated with dimensions", dim1, dim2, dim3
  end subroutine

  subroutine set_savg_ptr(ptr, dim1, dim2) bind(C, name="set_savg_ptr")
    use iso_c_binding
    implicit none
    type(c_ptr), value :: ptr
    integer(c_int), value :: dim1, dim2
    call c_f_pointer(ptr, savg, [dim1, dim2])
    print *, "Fortran: savg pointer associated with dimensions", dim1, dim2
  end subroutine 
  
  function get_junk1() bind(C, name="get_junk1")
    integer(c_int) :: get_junk1
    get_junk1 = junk1
  end function

  function get_junk2() bind(C, name="get_junk2")
    integer(c_int) :: get_junk2
    get_junk2 = junk2
  end function
  
subroutine set_quitid(val) bind(C, name="set_quitid")
    use iso_c_binding
    integer(c_long_long), value :: val
    quitid = val
    print*,'DATCOM_PTRS_MOD QUITID is:',quitid
  end subroutine

  subroutine set_junk1(val) bind(C, name="set_junk1")
    use iso_c_binding
    integer(c_int), value :: val
    junk1 = val
  end subroutine

  subroutine set_junk2(val) bind(C, name="set_junk2")
    use iso_c_binding
    integer(c_int), value :: val
    junk2 = val
  end subroutine

end module datcom_ptrs_mod

subroutine unpackname(n1,n2,name,len)

  character*9 name
  real*8 dn

  dn=32768.d0*n1 + n2
  len=0
  do i=9,1,-1
     j=mod(dn,27.d0)
     if(j.ge.1) then
        name(i:i)=char(64+j)
        len=len+1
     else
        name(i:i)=' '
     endif
     dn=dn/27.d0
  enddo

  return
end subroutine unpackname

module rs_mod
  use iso_c_binding
  implicit none
  interface
    subroutine rs_encode_(dgen, sent) bind(C, name="rs_encode_")
      use iso_c_binding
      implicit none
      integer(c_int), intent(in)  :: dgen(12)
      integer(c_int), intent(out) :: sent(63)
    end subroutine rs_encode_   
    
  subroutine rs_decode_(recd0, era0, numera0, decoded, nerr) bind(C, name="rs_decode_")
    use iso_c_binding
    implicit none
    integer(c_int), intent(in)    :: recd0(63)
    integer(c_int), intent(in)    :: era0(*)      ! size = numera0
    integer(c_int), intent(in)    :: numera0
    integer(c_int), intent(out)   :: decoded(12)
    integer(c_int), intent(out)   :: nerr
  end subroutine rs_decode_
end interface

end module rs_mod

subroutine averms(x,n,nskip,ave,rms)
  real x(n)
  integer ipk(1)

  ns=0
  s=0.
  sq=0.
  ipk=maxloc(x)
  do i=1,n
     if(abs(i-ipk(1)).gt.nskip) then
        s=s + x(i)
        sq=sq + x(i)**2
        ns=ns+1
     endif
  enddo
  ave=s/ns
  rms=sqrt(sq/ns - ave*ave)
 
  return
end subroutine averms

! FST4
! LDPC(240,101)/CRC24 code, five 8x4 sync

parameter (KK=77)                     !Information bits (77 + CRC24)
parameter (ND=120)                    !Data symbols
parameter (NS=40)                     !Sync symbols 
parameter (NN=NS+ND)                  !Sync and data symbols (160)

subroutine fastosd240_74(llr,k,apmask,ndeep,message74,cw,nhardmin,dmin)
! 
! An ordered-statistics decoder for the (240,74) code.
! Message payload is 50 bits. Any or all of a 24-bit CRC can be
! used for detecting incorrect codewords. The remaining CRC bits are
! cascaded with the LDPC code for the purpose of improving the
! distance spectrum of the code.
!
! If p1 (0.le.p1.le.24) is the number of CRC24 bits that are
! to be used for bad codeword detection, then the argument k should
! be set to 77+p1.
!
! Valid values for k are in the range [50,74].
!
   character*24 c24
   integer, parameter:: N=240
   integer*1 apmask(N),apmaskr(N)
   integer*1, allocatable, save :: gen(:,:)
   integer*1, allocatable :: genmrb(:,:),g2(:,:)
   integer*1, allocatable :: temp(:),temprow(:),m0(:),me(:),mi(:)
   integer indices(N),indices2(N),nxor(N)
   integer*1 cw(N),ce(N),c0(N),hdec(N)
   integer*1, allocatable :: decoded(:)
   integer*1 message74(74)
   integer*1, allocatable :: sp(:)
   integer indx(N),ksave
   real llr(N),rx(N),absrx(N)

   logical first
   data first/.true./,ksave/64/
   save first,ksave

   allocate( genmrb(k,N), g2(N,k) )
   allocate( temp(k), temprow(n), m0(k), me(k), mi(k) )
   allocate( decoded(k) )

   if( first .or. k.ne.ksave) then ! fill the generator matrix
!
! Create generator matrix for partial CRC cascaded with LDPC code.
!
! Let p2=74-k and p1+p2=24.
!
! The last p2 bits of the CRC24 are cascaded with the LDPC code.
!
! The first p1=k-50 CRC24 bits will be used for error detection.
!
      if( allocated(gen) ) deallocate(gen)
      allocate( gen(k,N) )
      gen=0
      do i=1,k
         message74=0
         message74(i)=1
         if(i.le.50) then
            call get_crc24(message74,74,ncrc24)
            write(c24,'(b24.24)') ncrc24
            read(c24,'(24i1)') message74(51:74)
            message74(51:k)=0
         endif
         call encode240_74(message74,cw)
         gen(i,:)=cw
      enddo

      first=.false.
      ksave=k
   endif

! Use best k elements from the sorted list for the first basis. For the 2nd basis replace 
! the nswap lowest quality symbols with the best nswap elements from the parity symbols.
   nswap=20

   do ibasis=1,2
      rx=llr
      apmaskr=apmask

! Hard decisions on the received word.
      hdec=0
      where(rx .ge. 0) hdec=1

! Use magnitude of received symbols as a measure of reliability.
      absrx=abs(llr)
      call indexx(absrx,N,indx)

! Re-order the columns of the generator matrix in order of decreasing reliability.
      do i=1,N
         genmrb(1:k,i)=gen(1:k,indx(N+1-i))
         indices(i)=indx(N+1-i)
      enddo

      if(ibasis.eq.2) then
         do i=k-nswap+1,k
            temp(1:k)=genmrb(1:k,i)
            genmrb(1:k,i)=genmrb(1:k,i+nswap)
            genmrb(1:k,i+nswap)=temp(1:k)
            itmp=indices(i)
            indices(i)=indices(i+nswap)
            indices(i+nswap)=itmp
         enddo
      endif

! Do gaussian elimination to create a generator matrix with the most reliable
! received bits in positions 1:k in order of decreasing reliability (more or less).

      icol=1
      indices2=0
      nskipped=0
      do id=1,k
         iflag=0
         do while(iflag.eq.0)
            if(genmrb(id,icol).ne.1) then
               do j=id+1,k
                  if(genmrb(j,icol).eq.1) then
                     temprow=genmrb(id,:)
                     genmrb(id,:)=genmrb(j,:)
                     genmrb(j,:)=temprow
                     iflag=1
                  endif
               enddo
               if(iflag.eq.0) then ! skip this column
                  nskipped=nskipped+1
                  indices2(k+nskipped)=icol ! put icol where skipped columns go
                  icol=icol+1 ! look at the next column
               endif
            else
               iflag=1
            endif
         enddo
         indices2(id)=icol
         do j=1,k
            if(id.ne.j .and. genmrb(j,icol).eq.1) then
               genmrb(j,:)=ieor(genmrb(id,:),genmrb(j,:))
            endif
         enddo
         icol=icol+1
      enddo
      do i=k+nskipped+1,240
         indices2(i)=i
      enddo
      genmrb(1:k,:)=genmrb(1:k,indices2)
      indices=indices(indices2)

!************************************
      g2=transpose(genmrb)

! The hard decisions for the k MRB bits define the order 0 message, m0.
! Encode m0 using the modified generator matrix to find the "order 0" codeword.
! Flip various combinations of bits in m0 and re-encode to generate a list of
! codewords. Return the member of the list that has the smallest Euclidean
! distance to the received word.

      hdec=hdec(indices)   ! hard decisions from received symbols
      m0=hdec(1:k)         ! zero'th order message
      absrx=abs(llr)
      absrx=absrx(indices)
      rx=rx(indices)
      apmaskr=apmaskr(indices)

      call mrbencode74(m0,c0,g2,N,k)
      nxor=ieor(c0,hdec)
      nhardmin=sum(nxor)
      dmin=sum(nxor*absrx)
      np=32
      if(ibasis.eq.1)   allocate(sp(np))

      cw=c0
      ntotal=0
      nrejected=0
      xlambda=0.0

      if(ndeep.eq.0) goto 998  ! norder=0
      if(ndeep.gt.4) ndeep=4
      if( ndeep.eq. 1) then
         nord=1
         xlambda=0.0
         nsyndmax=np
      elseif(ndeep.eq.2) then
         nord=2
         xlambda=0.0
         nsyndmax=np
      elseif(ndeep.eq.3) then
         nord=3
         xlambda=4.0
         nsyndmax=11
      elseif(ndeep.eq.4) then
         nord=4
         xlambda=3.4
         nsyndmax=12
      endif

      s1=sum(absrx(1:k))
      s2=sum(absrx(k+1:N))
      rho=s1/(s1+xlambda*s2)
      rhodmin=rho*dmin
      do iorder=1,nord
!beta=0.0
!if(iorder.ge.3) beta=0.4
!spnc_order=sum(absrx(k-iorder+1:k))+beta*(N-k)
!if(dmin.lt.spnc_order) cycle 
         mi(1:k-iorder)=0
         mi(k-iorder+1:k)=1
         iflag=k-iorder+1
         do while(iflag .ge.0)
            ntotal=ntotal+1
            me=ieor(m0,mi)
            d1=sum(mi(1:k)*absrx(1:k))
            if(d1.gt.rhodmin) exit
            call partial_syndrome(me,sp,np,g2,N,K)
            nwhsp=sum(ieor(sp(1:np),hdec(k:k+np-1)))
            if(nwhsp.le.nsyndmax) then
               call mrbencode74(me,ce,g2,N,k)
               nxor=ieor(ce,hdec)
               dd=sum(nxor*absrx(1:N))
               if( dd .lt. dmin ) then
                  dmin=dd
                  rhodmin=rho*dmin
                  cw=ce
                  nhardmin=sum(nxor)
                  nwhspmin=nwhsp
               endif
            endif
! Get the next test error pattern, iflag will go negative
! when the last pattern with weight iorder has been generated.
            call nextpat74(mi,k,iorder,iflag)
         enddo
      enddo
998   continue
! Re-order the codeword to [message bits][parity bits] format.
      cw(indices)=cw
      hdec(indices)=hdec
      message74=cw(1:74)
      call get_crc24(message74,74,nbadcrc)
      if(nbadcrc.eq.0) exit
      nhardmin=-nhardmin
   enddo  ! basis loop
   return
end subroutine fastosd240_74

subroutine mrbencode74(me,codeword,g2,N,K)
   integer*1 me(K),codeword(N),g2(N,K)
! fast encoding for low-weight test patterns
   codeword=0
   do i=1,K
      if( me(i) .eq. 1 ) then
         codeword=ieor(codeword,g2(1:N,i))
      endif
   enddo
   return
end subroutine mrbencode74

subroutine partial_syndrome(me,sp,np,g2,N,K)
   integer*1 me(K),sp(np),g2(N,K)
! compute partial syndrome
   sp=0
   do i=1,K
      if( me(i) .eq. 1 ) then
         sp=ieor(sp,g2(K:K+np-1,i))
      endif
   enddo
   return
end subroutine partial_syndrome

subroutine nextpat74(mi,k,iorder,iflag)
   integer*1 mi(k),ms(k)
! generate the next test error pattern
   ind=-1
   do i=1,k-1
      if( mi(i).eq.0 .and. mi(i+1).eq.1) ind=i
   enddo
   if( ind .lt. 0 ) then ! no more patterns of this order
      iflag=ind
      return
   endif
   ms=0
   ms(1:ind-1)=mi(1:ind-1)
   ms(ind)=1
   ms(ind+1)=0
   if( ind+1 .lt. k ) then
      nz=iorder-sum(ms)
      ms(k-nz+1:k)=1
   endif
   mi=ms
   do i=1,k  ! iflag will point to the lowest-index 1 in mi
      if(mi(i).eq.1) then
         iflag=i
         exit
      endif
   enddo
   return
end subroutine nextpat74

subroutine decode240_74(llr,Keff,maxosd,norder,apmask,message74,cw,ntype,nharderror,dmin)
!
! A hybrid bp/osd decoder for the (240,74) code.
!
! maxosd<0: do bp only
! maxosd=0: do bp and then call osd once with channel llrs
! maxosd>1: do bp and then call osd maxosd times with saved bp outputs
! norder  : osd decoding depth
!
   integer, parameter:: N=240, K=74, M=N-K
   integer*1 cw(N),apmask(N)
   integer*1 nxor(N),hdec(N)
   integer*1 message74(74),m74(74)
   integer nrw(M),ncw
   integer Nm(5,M)
   integer Mn(3,N)  ! 3 checks per bit
   integer synd(M)
   real tov(3,N)
   real toc(5,M)
   real tanhtoc(5,M)
   real zn(N),zsum(N),zsave(N,3)
   real llr(N)
   real Tmn

   include "ldpc_240_74_parity.f90"

   maxiterations=30
   if(Keff.eq.50) maxiterations=1

   nosd=0
   if(maxosd.gt.3) maxosd=3
   if(maxosd.eq.0) then ! osd with channel llrs
      nosd=1
      zsave(:,1)=llr
   elseif(maxosd.gt.0) then !
      nosd=maxosd
   elseif(maxosd.lt.0) then ! just bp
      nosd=0
   endif

   if(maxosd.eq.0) goto 73

   toc=0
   tov=0
   tanhtoc=0
! initialize messages to checks
   do j=1,M
      do i=1,nrw(j)
         toc(i,j)=llr((Nm(i,j)))
      enddo
   enddo

   ncnt=0
   nclast=0
   zsum=0.0
   do iter=0,maxiterations
! Update bit log likelihood ratios (tov=0 in iteration 0).
      do i=1,N
         if( apmask(i) .ne. 1 ) then
            zn(i)=llr(i)+sum(tov(1:ncw,i))
         else
            zn(i)=llr(i)
         endif
      enddo
      zsum=zsum+zn
      if(iter.gt.0 .and. iter.le.maxosd) then
         zsave(:,iter)=zsum
      endif

! Check to see if we have a codeword (check before we do any iteration).
      cw=0
      where( zn .gt. 0. ) cw=1
      ncheck=0
      do i=1,M
         synd(i)=sum(cw(Nm(1:nrw(i),i)))
         if( mod(synd(i),2) .ne. 0 ) ncheck=ncheck+1
      enddo
      if( ncheck .eq. 0 ) then ! we have a codeword - if crc is good, return it
         m74=0
         m74(1:74)=cw(1:74)
         call get_crc24(m74,74,nbadcrc)
         if(nbadcrc.eq.0) then
            message74=cw(1:74)
            hdec=0
            where(llr .ge. 0) hdec=1
            nxor=ieor(hdec,cw)
            nharderror=sum(nxor)
            dmin=sum(nxor*abs(llr))
            ntype=1
            return
         endif
      endif

  if( iter.gt.0 ) then  ! this code block implements an early stopping criterion
!      if( iter.gt.10000 ) then  ! this code block implements an early stopping criterion
         nd=ncheck-nclast
         if( nd .lt. 0 ) then ! # of unsatisfied parity checks decreased
            ncnt=0  ! reset counter
         else
            ncnt=ncnt+1
         endif
!    write(*,*) iter,ncheck,nd,ncnt
         if( ncnt .ge. 5 .and. iter .ge. 10 .and. ncheck .gt. 15) then
            nharderror=-1
            exit
         endif
      endif
      nclast=ncheck

! Send messages from bits to check nodes
      do j=1,M
         do i=1,nrw(j)
            ibj=Nm(i,j)
            toc(i,j)=zn(ibj)
            do kk=1,ncw ! subtract off what the bit had received from the check
               if( Mn(kk,ibj) .eq. j ) then
                  toc(i,j)=toc(i,j)-tov(kk,ibj)
               endif
            enddo
         enddo
      enddo

! send messages from check nodes to variable nodes
      do i=1,M
         tanhtoc(1:5,i)=tanh(-toc(1:5,i)/2)
      enddo

      do j=1,N
         do i=1,ncw
            ichk=Mn(i,j)  ! Mn(:,j) are the checks that include bit j
            Tmn=product(tanhtoc(1:nrw(ichk),ichk),mask=Nm(1:nrw(ichk),ichk).ne.j)
            call platanh(-Tmn,y)
!      y=atanh(-Tmn)
            tov(i,j)=2*y
         enddo
      enddo

   enddo   ! bp iterations

73 continue
   do i=1,nosd
      zn=zsave(:,i)
!      call osd240_74(zn,Keff,apmask,norder,message74,cw,nharderror,dminosd)
      call fastosd240_74(zn,Keff,apmask,norder,message74,cw,nharderror,dminosd)
      if(nharderror.gt.0) then
         hdec=0
         where(llr .ge. 0) hdec=1
         nxor=ieor(hdec,cw)
         nharderror=sum(nxor) ! nharderror based on input llrs
         dmin=sum(nxor*abs(llr))
         ntype=1+i
         return
      endif
   enddo

   ntype=0
   nharderror=-1
   dminosd=0.0

   return
end subroutine decode240_74

module grid2deg_mod
  implicit none
contains
  subroutine grid2deg(grid0,dlong,dlat)
    character(len=6), intent(in) :: grid0
    real, intent(out) :: dlong, dlat
    
    character(len=6) grid
    character(len=1) g1,g2,g3,g4,g5,g6
    integer :: i, nlong, n20d, nlat
    real :: xminlong, xminlat

    grid=grid0
    i=ichar(grid(5:5))
    if(grid(5:5).eq.' ' .or. i.le.64 .or. i.ge.128) grid(5:6)='mm'

    if(grid(1:1).ge.'a' .and. grid(1:1).le.'z') grid(1:1)=              &
         char(ichar(grid(1:1))+ichar('A')-ichar('a'))
    if(grid(2:2).ge.'a' .and. grid(2:2).le.'z') grid(2:2)=              &
         char(ichar(grid(2:2))+ichar('A')-ichar('a'))
    if(grid(5:5).ge.'A' .and. grid(5:5).le.'Z') grid(5:5)=              &
         char(ichar(grid(5:5))-ichar('A')+ichar('a'))
    if(grid(6:6).ge.'A' .and. grid(6:6).le.'Z') grid(6:6)=              &
         char(ichar(grid(6:6))-ichar('A')+ichar('a'))

    g1=grid(1:1)
    g2=grid(2:2)
    g3=grid(3:3)
    g4=grid(4:4)
    g5=grid(5:5)
    g6=grid(6:6)

    nlong = 180 - 20*(ichar(g1)-ichar('A'))
    n20d = 2*(ichar(g3)-ichar('0'))
    xminlong = 5*(ichar(g5)-ichar('a')+0.5)
    dlong = nlong - n20d - xminlong/60.0
    nlat = -90+10*(ichar(g2)-ichar('A')) + ichar(g4)-ichar('0')
    xminlat = 2.5*(ichar(g6)-ichar('a')+0.5)
    dlat = nlat + xminlat/60.0

  end subroutine grid2deg
end module grid2deg_mod

subroutine chkss2(ss2,freq,drift,schk)

  real ss2(0:8,85)
  real s(0:8,85)
  include 'jt9sync.f90'

  ave=sum(ss2)/(9*85)
  if(freq+drift.eq.-999999.0) ave=0.      !To silence compiler warning
  s=ss2/ave-1.0

  s1=0.
  do i=1,16
     j=ii(i)
     if(j.le.85) s1=s1 + s(0,j)
  enddo
  schk=s1/16.0

  return
end subroutine chkss2

program chkfft

! Tests and times one-dimensional FFTs computed by FFTW3
  
  use, intrinsic :: iso_c_binding
  use FFTW3
  parameter (NMAX=8*1024*1024)           !Maximum FFT length
  complex a(NMAX),b(NMAX),c(NMAX)
  real ar(NMAX),br(NMAX),cr(NMAX)
  real mflops
  type(C_PTR) :: plan1,plan2              !Pointers to FFTW plans
  character infile*12,arg*8
  logical list
  common/patience/npatience
  equivalence (a,ar),(b,br),(c,cr)

  nargs=iargc()
  if(nargs.ne.5) then
     print*,'Usage: chkfft3 <nfft | infile> nr nw nc np'
     print*,'       nfft:    length of FFT'
     print*,'       nfft=0:  do lengths 2^n, n=2^8 to 2^23'
     print*,'       infile:  name of file with nfft values, one per line'
     print*,'       nr:      0/1 to not read (or read) wisdom'
     print*,'       nw:      0/1 to not write (or write) wisdom'
     print*,'       nc:      0/1 for real or complex data'
     print*,'       np:      0-4 patience for finding best algorithm'
     go to 999
  endif

  list=.false.
  nfft=-1
  call getarg(1,infile)
  open(10,file=infile,status='old',err=1)
  list=.true.                          !A valid file name was provided
  go to 2
1 read(infile,*) nfft                  !Take first argument to be nfft
2  call getarg(2,arg)
  read(arg,*) nr
  call getarg(3,arg)
  read(arg,*) nw
  call getarg(4,arg)
  read(arg,*) ncomplex
  call getarg(5,arg)
  read(arg,*) npatience

  if(list) write(*,1000) infile,nr,nw,ncomplex,npatience
1000 format(/'infile: ',a12,'   nr:',i2,'   nw',i2,'   nc:',i2,'   np:',i2/)
  if(.not.list) write(*,1002) nfft,nr,nw,ncomplex,npatience
1002 format(/'nfft: ',i10,'   nr:',i2,'   nw',i2,'   nc:',i2,'   np:',i2/)

  nflags=FFTW_ESTIMATE
  if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
  if(npatience.eq.2) nflags=FFTW_MEASURE
  if(npatience.eq.3) nflags=FFTW_PATIENT
  if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

  open(12,file='chkfft.out',status='unknown')

  if(nr.ne.0) then
     isuccess=fftwf_import_wisdom_from_filename('fftwf_wisdom.dat'//char(0))
     if(isuccess.eq.1) then
        write(*,1010) 
1010    format('Imported FFTW wisdom.')        
     else
        write(*,1012)
1012    format('Failed to import FFTW wisdom.')
        go to 999
     endif
  endif

  idum=-1                               !Set random seed
  ndim=1                                !One-dimensional transforms
  do i=1,NMAX                           !Set random data
     x=gran()
     y=gran()
     b(i)=cmplx(x,y)                    !Generate random data
  enddo

  iters=1000000
  if(list .or. (nfft.gt.0)) then
     n1=1
     n2=1
     if(nfft.eq.-1) n2=999999
     write(*,1020) 
1020 format('    NFFT     Time        rms      MHz   MFlops  iters',    &
          '  tplan'/61('-'))
  else
     n1=8
     n2=23
     write(*,1030) 
1030 format(' n   N=2^n     Time        rms      MHz   MFlops  iters',  &
          '  tplan'/63('-'))
  endif

  do ii=n1,n2                           !Test one or more FFT lengths
     if(list) then
        read(10,*,end=900) nfft         !Read nfft from file
     else if(n2.gt.n1) then
        nfft=2**ii                      !Do powers of 2
     endif

     iformf=1
     iformb=1
     if(ncomplex.eq.0) then
        iformf=0                        !Real-to-complex transform
        iformb=-1                       !Complex-to-real (inverse) transform
     endif

     if(nfft.gt.NMAX) go to 900
     a(1:nfft)=b(1:nfft)                !Copy test data into a()
     t0=second()
     if(ncomplex.ne.0) then
        plan1=fftwf_plan_dft_1d(nfft,a,c,-1,nflags)
        plan2=fftwf_plan_dft_1d(nfft,a,c,+1,nflags)
     else
        plan1=fftwf_plan_dft_r2c_1d(nfft,ar,c,nflags)
        plan2=fftwf_plan_dft_c2r_1d(nfft,c,ar,nflags)
     endif

     t2=second()
     tplan=t2-t0                        !Total planning time for this length
     
     total=0.
     do iter=1,iters                    !Now do many iterations
        a(1:nfft)=b(1:nfft)             !Copy test data into a()
        t0=second()
        call fftwf_execute_dft(plan1,a,c)
        call fftwf_execute_dft(plan2,c,a)
        t1=second()
        total=total+t1-t0
        if(total.ge.1.0) go to 40       !Cut iterations short if t>1 s
     enddo
     iter=iters

40   time=0.5*total/iter                !Time for one FFT of current length
     tplan=0.5*tplan-time               !Planning time for one FFT
     if(tplan.lt.0) tplan=0.
     a(1:nfft)=a(1:nfft)/nfft

! Compute RMS difference between original array and back-transformed array.
     sq=0.
     if(ncomplex.eq.1) then
        do i=1,nfft
           sq=sq + real(a(i)-b(i))**2 + imag(a(i)-b(i))**2
        enddo
     else
        do i=1,nfft
           sq=sq + (ar(i)-br(i))**2
        enddo
     endif
     rms=sqrt(sq/nfft)

     freq=1.e-6*nfft/time
     mflops=5.0/(1.e6*time/(nfft*log(float(nfft))/log(2.0)))
     if(n2.eq.1 .or. n2.eq.999999) then
        write(*,1050) nfft,time,rms,freq,mflops,iter,tplan
        write(12,1050) nfft,time,rms,freq,mflops,iter,tplan
1050    format(i8,f11.7,f12.8,f7.0,f8.0,i8,f6.1)
     else
        write(*,1060) ii,nfft,time,rms,freq,mflops,iter,tplan
        write(12,1060) ii,nfft,time,rms,freq,mflops,iter,tplan
1060    format(i2,i8,f11.7,f12.8,f7.0,f8.0,i8,f6.1)
     endif
  enddo

900  continue 
  if(nw.eq.1) then
     ierr=fftwf_export_wisdom_to_filename('fftwf_wisdom.dat'//char(0))
     write(*,1070)
1070 format(/'Exported FFTW wisdom')
  endif

  call fftwf_destroy_plan(plan1)
  call fftwf_destroy_plan(plan2)

999 end program chkfft

subroutine ft8sd1var(s8,itone,msgd,msg37,lft8sd,lcq)

  use ft8_mod1, only : mycall
  real, intent(in) :: s8(0:7,79)
  real s8_1(0:7,79)
  character msgd*37,msg37*37,msg372*37,msgsent37*37,c1*12,c2*12
  character*37 msg4(4)
  integer idtone4(4,58),itone4(4,79)
  integer itone(79),itonedem(58),idtone(58),ip1(1)
  integer*1 msgbits(77)
  logical(1), intent(in) :: lcq
  logical(1) lft8sd,lr73,lgrid,lmatched(58)

  lmatched=.false.; lr73=.false.; lgrid=.false.
  itonedem=11

  if(.not.lcq) then
    c1='            '; c2='            '
    ispc1=index(msgd,' '); ispc2=index(msgd((ispc1+1):),' ')+ispc1; ispc3=index(msgd((ispc2+1):),' ')+ispc2
    if(len(msgd(1:ispc1-1)).le.12 .and. len(msgd(ispc1+1:ispc2-1)).le.12) then
      c1=msgd(1:ispc1-1); c2=msgd(ispc1+1:ispc2-1)
    else
      return
    endif
    if(len_trim(c1).lt.3 .or. len_trim(c2).lt.3 .or. c2.eq.trim(mycall)) return
    if(index(msgd,' RR73').gt.0 .or. index(msgd,' 73').gt.0) lr73=.true.
    if(.not.lr73 .and. (ispc3-ispc2).eq.5 .and. msgd(ispc2+1:ispc2+2).ne.'R+' &
       .and. msgd(ispc2+1:ispc2+2).ne.'R-') lgrid=.true.
    if(.not.lgrid .and. .not.lr73) then
      do i=1,4
        msg4(i)='                                     '
        if(i.eq.1) msg4(i)=msgd
        if(i.eq.2) msg4(i)=trim(c1)//' '//trim(c2)//' RRR'
        if(i.eq.3) msg4(i)=trim(c1)//' '//trim(c2)//' RR73'
        if(i.eq.4) msg4(i)=trim(c1)//' '//trim(c2)//' 73'
      enddo
    endif
  endif

  if(lcq .or. lgrid .or. lr73) then
    i3=-1; n3=-1
    msg372=msgd
    call genft8sdvar(msg372,i3,n3,msgsent37,msgbits,itone)
    idtone(1:29)=itone(8:36)
    idtone(30:58)=itone(44:72)
  else
    do i=1,4
      msg372=msg4(i)
      i3=-1; n3=-1
      call genft8sdvar(msg372,i3,n3,msgsent37,msgbits,itone)
      idtone4(i,1:29)=itone(8:36)
      idtone4(i,30:58)=itone(44:72)
      itone4(i,1:79)=itone(1:79)
    enddo
  endif

  s8_1=s8
  do i=1,58
    if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
    else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
  enddo

  imax=0
  if(lcq .or. lgrid .or. lr73) then
    nmatch1=0; ncrcpaty1=0
    do k=1,58
      if(idtone(k).eq.itonedem(k)) then; nmatch1=nmatch1+1; if(k.gt.25) ncrcpaty1=ncrcpaty1+1; endif
    enddo
    if(nmatch1.gt.29 .and. ncrcpaty1.gt.10) then; lft8sd=.true.; msg37=msgd; return; endif
  else
    nmatchditer1=0; ncrcpatyiter1=0
    do i=1,4
      nmatch1=0; ncrcpaty1=0
      do k=1,58
        if(idtone4(i,k).eq.itonedem(k)) then; nmatch1=nmatch1+1; if(k.gt.25) ncrcpaty1=ncrcpaty1+1; endif
      enddo
      if(nmatch1.gt.nmatchditer1) then; imax=i; nmatchditer1=nmatch1; ncrcpatyiter1=ncrcpaty1; endif
    enddo
    if(imax.eq.0) return
    if(lr73 .and. imax.eq.2) return ! RRR is not a valid message
    nmatch1=nmatchditer1; ncrcpaty1=ncrcpatyiter1
    idtone(1:58)=idtone4(imax,1:58)
    if(nmatch1.gt.29 .and. ncrcpaty1.gt.10) then; lft8sd=.true.; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); return; endif
  endif

  if(nmatch1.ge.22) then
    do k=1,58
      if(idtone(k).eq.itonedem(k)) lmatched(k)=.true.
    enddo
    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1)
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); endif
    enddo

    nmatch2=nmatch1; ncrcpaty2=ncrcpaty1
    if(lcq .or. lgrid .or. lr73) then
      do k=1,58
        if(lmatched(k)) cycle
        if(idtone(k).eq.itonedem(k)) then; nmatch2=nmatch2+1; if(k.gt.25) ncrcpaty2=ncrcpaty2+1; endif
      enddo
      if(nmatch2.gt.41 .and. ncrcpaty2.gt.19) then; lft8sd=.true.; msg37=msgd; return; endif
    else
      do k=1,58
        if(lmatched(k)) cycle
        if(idtone(k).eq.itonedem(k)) then; nmatch2=nmatch2+1; if(k.gt.25) ncrcpaty2=ncrcpaty2+1; endif
      enddo
      if(nmatch2.gt.41 .and. ncrcpaty2.gt.19) then; lft8sd=.true.; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); return; endif
    endif
  endif

  return
end subroutine ft8sd1var

subroutine sh65snr(x,nz,snr)

  real x(nz)

  ipk=0 !Shut up compiler warnings. -db
  smax=-1.e30
  do i=1,nz
     if(x(i).gt.smax) then
        ipk=i
        smax=x(i)
     endif
     s=s+x(i)
  enddo

  s=0.
  ns=0
  do i=1,nz
     if(abs(i-ipk).ge.3) then
        s=s+x(i)
        ns=ns+1
     endif
  enddo
  ave=s/ns

  sq=0.
  do i=1,nz
     if(abs(i-ipk).ge.3) then
        sq=sq+(x(i)-ave)**2
        ns=ns+1
     endif
  enddo
  rms=sqrt(sq/(nz-2))
  snr=(smax-ave)/rms

  return
end subroutine sh65snr

subroutine get_fst4_bitmetrics2(cd,nss,hmod,nsizes,bitmetrics,s4snr,badsync)

   include 'fst4_params.f90'
   complex cd(0:NN*nss-1)
   complex csymb(nss)
   complex, allocatable, save :: c1(:,:)   ! ideal waveforms, 4 tones
   complex cp(0:3)        ! accumulated phase shift over symbol types 0:3
   integer isyncword1(0:7),isyncword2(0:7)
   integer graymap(0:3)
   integer ip(1)
   integer hmod
   logical one(0:65535,0:15)    ! 65536 8-symbol sequences, 16 bits
   logical first
   logical badsync
   real bitmetrics(2*NN,4)
   real s2(0:65535)
   real s4(0:3,NN,4),s4snr(0:3,NN)
   data isyncword1/0,1,3,2,1,0,2,3/
   data isyncword2/2,3,1,0,3,2,0,1/
   data graymap/0,1,3,2/
   data first/.true./,nss0/-1/
   save first,one,cp,nss0

   if(nss.ne.nss0 .and. allocated(c1)) deallocate(c1)
   if(first .or. nss.ne.nss0) then
      allocate(c1(nss,0:3))
      one=.false.
      do i=0,65535
         do j=0,15
            if(iand(i,2**j).ne.0) one(i,j)=.true.
         enddo
      enddo
      twopi=8.0*atan(1.0)
      dphi=twopi*hmod/nss
      do itone=0,3
         dp=(itone-1.5)*dphi
         phi=0.0
         do j=1,nss
            c1(j,itone)=cmplx(cos(phi),sin(phi))
            phi=mod(phi+dp,twopi)
         enddo
         cp(itone)=cmplx(cos(phi),sin(phi))
      enddo
      first=.false.
   endif

   do k=1,NN
      i1=(k-1)*NSS
      csymb=cd(i1:i1+NSS-1)
      do itone=0,3
         s4(itone,k,1)=abs(sum(csymb*conjg(c1(:,itone))))**2
         s4(itone,k,2)=abs(sum(csymb(      1:nss/2)*conjg(c1(      1:nss/2,itone))))**2 + &
                       abs(sum(csymb(nss/2+1:  nss)*conjg(c1(nss/2+1:  nss,itone))))**2
         s4(itone,k,3)=abs(sum(csymb(        1:  nss/4)*conjg(c1(        1:  nss/4,itone))))**2 + &
                       abs(sum(csymb(  nss/4+1:  nss/2)*conjg(c1(  nss/4+1:  nss/2,itone))))**2 + &
                       abs(sum(csymb(  nss/2+1:3*nss/4)*conjg(c1(  nss/2+1:3*nss/4,itone))))**2 + &
                       abs(sum(csymb(3*nss/4+1:    nss)*conjg(c1(3*nss/4+1:    nss,itone))))**2
         s4(itone,k,4)=abs(sum(csymb(        1:  nss/8)*conjg(c1(        1:  nss/8,itone))))**2 + &
                       abs(sum(csymb(  nss/8+1:  nss/4)*conjg(c1(  nss/8+1:  nss/4,itone))))**2 + &
                       abs(sum(csymb(  nss/4+1:3*nss/8)*conjg(c1(  nss/4+1:3*nss/8,itone))))**2 + &
                       abs(sum(csymb(3*nss/8+1:  nss/2)*conjg(c1(3*nss/8+1:  nss/2,itone))))**2 + &
                       abs(sum(csymb(  nss/2+1:5*nss/8)*conjg(c1(  nss/2+1:5*nss/8,itone))))**2 + &
                       abs(sum(csymb(5*nss/8+1:3*nss/4)*conjg(c1(5*nss/8+1:3*nss/4,itone))))**2 + &
                       abs(sum(csymb(3*nss/4+1:7*nss/8)*conjg(c1(3*nss/4+1:7*nss/8,itone))))**2 + &
                       abs(sum(csymb(7*nss/8+1:    nss)*conjg(c1(7*nss/8+1:    nss,itone))))**2

      enddo
   enddo

! Sync quality check
   is1=0
   is2=0
   is3=0
   is4=0
   is5=0
   badsync=.false.
   ibmax=0

   is1=0; is2=0; is3=0; is4=0; is5=0
   do k=1,8
      ip=maxloc(s4(:,k,1))
      if(isyncword1(k-1).eq.(ip(1)-1)) is1=is1+1
      ip=maxloc(s4(:,k+38,1))
      if(isyncword2(k-1).eq.(ip(1)-1)) is2=is2+1
      ip=maxloc(s4(:,k+76,1))
      if(isyncword1(k-1).eq.(ip(1)-1)) is3=is3+1
      ip=maxloc(s4(:,k+114,1))
      if(isyncword2(k-1).eq.(ip(1)-1)) is4=is4+1
      ip=maxloc(s4(:,k+152,1))
      if(isyncword1(k-1).eq.(ip(1)-1)) is5=is5+1
   enddo
   nsync=is1+is2+is3+is4+is5   !Number of correct hard sync symbols, 0-40
   badsync=.false.

   if(nsync .lt. 16) then
      badsync=.true.
      return
   endif

   bitmetrics=0.0
   do nsub=1,nsizes  
      do ks=1,NN  
         s2=0
         do i=0,3
            s2(i)=s4(graymap(i),ks,nsub)
         enddo
         ipt=1+(ks-1)*2
         ibmax=1
         do ib=0,ibmax
            bm=maxval(s2(0:3),one(0:3,ibmax-ib)) - &
               maxval(s2(0:3),.not.one(0:3,ibmax-ib))
            if(ipt+ib.gt.2*NN) cycle
            bitmetrics(ipt+ib,nsub)=bm
         enddo
      enddo
   enddo

   call normalizebmet(bitmetrics(:,1),2*NN)
   call normalizebmet(bitmetrics(:,2),2*NN)
   call normalizebmet(bitmetrics(:,3),2*NN)
   call normalizebmet(bitmetrics(:,4),2*NN)

! Return the s4 array corresponding to N=1. Will be used for SNR calculation
   s4snr(:,:)=s4(:,:,1)
   return

end subroutine get_fst4_bitmetrics2

subroutine ft8_downsamplevar(newdat1,f0,nqso,c0,c2,c3,lhighsens,lsubtracted,npos,freqsub)

! Downconvert to complex data sampled at 200 Hz ==> 32 samples/symbol
  use ft8_mod1, only : dd8,windowc1,facc1
  parameter (NFFT1=192000,NFFT2=3200)      !192000/60 = 3200
  
  logical newdat1
  complex, intent(out) :: c0(-800:4000),c2(-800:4000),c3(-800:4000)
  complex cx(0:96000),cxx(0:96000),c1(0:3199) ! 0:NFFT1/2
  real x(NFFT1)
  real, intent(in) :: f0
  integer, intent(in) :: nqso
  real freqsub(200)
  logical(1), intent(in) :: lhighsens
  logical(1) lsubtracted,ldofft
  equivalence (x,cx)
  save cxx

  ldofft=.false.
  if(lsubtracted) then
    do i=1,npos
      if(abs(f0-freqsub(i)).lt.50.) then; ldofft=.true.; lsubtracted=.false.; exit; endif
    enddo
  endif

  if(newdat1 .or. ldofft) then
! Data in dd have changed, recompute the long FFT
     x(1:180000)=dd8
     x(180001:NFFT1)=0.                       !Zero-pad the x array
     call four2avar(cx,NFFT1,1,-1,0)             !r2c FFT to freq domain
     newdat1=.false.; ldofft=.false.; npos=0
     cxx=cx
  endif

  df=0.0625 ! 12000.0/NFFT1
!  tonewidth=6.25 Hz ! 12000.0/1920.
  i0=nint(f0/df)
  ft=f0+55.75; it=min(nint(ft/df),96000)
  fb=f0-5.75; ib=max(1,nint(fb/df))
  c1=cmplx(0.0,0.0)
  k=it-ib
  c1(0:k)=cxx(ib:it)
  c1(0:54)=c1(0:54)*windowc1(54:0:-1)
  c1(k-54:k)=c1(k-54:k)*windowc1
  c1=cshift(c1,i0-ib)
  if(lhighsens) then; c1(0)=c1(0)*1.93; c1(799)=c1(799)*1.7; c1(800)=c1(800)*1.7; c1(3199)=c1(3199)*1.93
  else; c1(45)=c1(45)*1.49; c1(54)=c1(54)*1.49; c1(3145)=c1(3145)*1.49; c1(3154)=c1(3154)*1.49
  endif ! 10346..10347
  call four2avar(c1,NFFT2,1,1,1)            !c2c FFT back to time domain
  c0(-800:-1)=0.; c0(0:3199)=facc1*c1(0:3199); c0(3200:4000)=0.
  if(nqso.gt.1) then
    c2(-800:-1)=0.; c2(3200:4000)=0.
    do i=0,3198; c2(i)=c0(i)+c0(i+1); enddo
    c2(3199)=c0(3199); c2=c2/2
  endif
  if(nqso.eq.3) then
    c3(-800:-1)=0.; c3(3200:4000)=0.
    do i=1,3199; c3(i)=c0(i-1)+c0(i); enddo
    c3(0)=c0(0); c3=c3/2
  endif

  return
end subroutine ft8_downsamplevar

program QRA64code

! Provides examples of message packing, bit and symbol ordering,
! QRA (63,12) encoding, and other necessary details of the QRA64
! protocol.  

  use packjt
  character*22 msg,msg0,msg1,decoded,cok*3,msgtype*10
  integer dgen(12),sent(63)
  integer icos7(0:6)
  data icos7/2,5,6,0,4,1,3/     !Defines a 7x7 Costas array

  include 'testmsg.f90'

  nargs=iargc()
  if(nargs.lt.1) then
     print*,'Usage: qra64code "message"'
     print*,'       qra64code -t'
     go to 999
  endif

  call getarg(1,msg)                     !Get message from command line
  nmsg=1
  if(msg(1:2).eq."-t") nmsg=NTEST

  write(*,1010)
1010 format("     Message                 Decoded                Err? Type"/74("-"))

  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)
    call fmtmsg(msg,iz)                     !To upper, collapse mult blanks
     msg0=msg                               !Input message
     call chkmsg(msg,cok,nspecial,flip)     !See if it includes "OOO" report
     msg1=msg                               !Message without "OOO"
     call packmsg(msg1,dgen,itype)          !Pack message into 12 six-bit bytes
     msgtype=""
     if(itype.eq.1) msgtype="Std Msg"
     if(itype.eq.2) msgtype="Type 1 pfx"
     if(itype.eq.3) msgtype="Type 1 sfx"
     if(itype.eq.4) msgtype="Type 2 pfx"
     if(itype.eq.5) msgtype="Type 2 sfx"
     if(itype.eq.6) msgtype="Free text"

     call qra64_enc(dgen,sent)              !Encode using QRA64

     call unpackmsg(dgen,decoded)           !Unpack the user message
     call fmtmsg(decoded,iz)
     ii=imsg
     write(*,1020) ii,msg0,decoded,itype,msgtype
1020 format(i4,1x,a22,2x,a22,4x,i3,": ",a13)
  enddo

  if(nmsg.eq.1) then
     write(*,1030) dgen
1030 format(/'Packed message, 6-bit symbols ',12i3) !Display packed symbols

     write(*,1040) sent
1040 format(/'Information-carrying channel symbols'/(i5,29i3))

     write(*,1050) 10*icos7,sent(1:32),10*icos7,sent(33:63),10*icos7
1050 format(/'Channel symbols including sync'/(i5,29i3))
  endif
  
999 end program QRA64code

subroutine jt9a()
  use, intrinsic :: iso_c_binding, only: c_f_pointer, c_null_char, c_bool
  use prog_args
  use timer_module, only: timer
  use timer_impl, only: init_timer !, limtrace
  use shmem

  include 'jt9com.f90'

  integer*2 id2a(180000)
! Multiple instances:
  type(dec_data), pointer, volatile :: shared_data !also makes target volatile
  type(params_block) :: local_params
  logical(c_bool) :: ok

  call init_timer (trim(data_dir)//'/timer.out')
!  open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')

!  limtrace=-1                            !Disable all calls to timer()

! Multiple instances: set the shared memory key before attaching
  call shmem_setkey(trim(shm_key)//c_null_char)
  ok=shmem_attach()
  if(.not.ok) call abort
  msdelay=30
  call c_f_pointer(shmem_address(),shared_data)

! Terminate if ipc(2) is 999
10 ok=shmem_lock()
  if(.not.ok) call abort
  if(shared_data%ipc(2).eq.999.0) then
     ok=shmem_unlock()
     ok=shmem_detach()
     go to 999
  endif
! Wait here until GUI has set ipc(2) to 1
  if(shared_data%ipc(2).ne.1) then
     ok=shmem_unlock()
     if(.not.ok) call abort
     call sleep_msec(msdelay)
     go to 10
  endif
  shared_data%ipc(2)=0

  nbytes=shmem_size()
  if(nbytes.le.0) then
     ok=shmem_unlock()
     ok=shmem_detach()
     print*,'jt9a: Shared memory does not exist.'
     print*,"Must start 'jt9 -s <thekey>' from within WSJT-X."
     go to 999
  endif
  local_params=shared_data%params !save a copy because wsjtx carries on accessing  
  ok=shmem_unlock()
  if(.not.ok) call abort
  call flush(6)
  call timer('decoder ',0)
  if(local_params%nmode.eq.8 .and. local_params%ndiskdat .and.    &
       .not. local_params%nagain) then
! Early decoding pass, FT8 only, when wsjtx reads from disk
     nearly=41
     local_params%nzhsym=nearly
     id2a(1:nearly*3456)=shared_data%id2(1:nearly*3456)
     id2a(nearly*3456+1:)=0
     call multimode_decoder(shared_data%ss,id2a,local_params,12000)
     nearly=47
     local_params%nzhsym=nearly
     id2a(1:nearly*3456)=shared_data%id2(1:nearly*3456)
     id2a(nearly*3456+1:)=0
     call multimode_decoder(shared_data%ss,id2a,local_params,12000)
     local_params%nzhsym=50
  endif

  if(local_params%nmode .eq. 144) then
    ! MSK144
    call decode_msk144(shared_data%id2, shared_data%params, data_dir)
  else
    ! Normal decoding pass
    call multimode_decoder(shared_data%ss,shared_data%id2,local_params,12000)
  endif

  call timer('decoder ',1)


! Wait here until GUI routine decodeDone() has set ipc(3) to 1
100 ok=shmem_lock()
  if(.not.ok) call abort
  if(shared_data%ipc(3).ne.1) then
     ok=shmem_unlock()
     if(.not.ok) call abort
     call sleep_msec(msdelay)
     go to 100
  endif
  shared_data%ipc(3)=0
  ok=shmem_unlock()
  if(.not.ok) call abort
  go to 10
  
999 call timer('decoder ',101)

  return
end subroutine jt9a

program synctst

! Tests JT65B2 sync patterns

  parameter (LAGMAX=20)
  real ccf0(0:LAGMAX),ccf2(0:LAGMAX),ccf3(0:LAGMAX)
  character*12 arg
  integer npr(126),np0(126),np1(126),npr2(126)
  data npr/1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,  &
           0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,  &
           0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,  &
           0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,  &
           1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,  &
           0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,  &
           1,1,1,1,1,1/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: synctst iters'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) iters

  worst=0.
  do lag=0,LAGMAX
     nsum=0
     do i=1,126-lag
        nsum=nsum + npr(i)*npr(lag+i)
     enddo
     ccf0(lag)=2.0*nsum/(126.0-lag)
     if(lag.ge.1 .and. ccf0(lag).gt.worst) worst=ccf0(lag)
  enddo

  best2=1.0
  do iter=1,iters

10   np0=0
     np1=0
     n0=0
     do i=1,126
        if(npr(i).eq.1) then
           call random_number(r)
           if(r.lt.0.5) then
              np0(i)=1
              n0=n0+1
           else
              np1(i)=1
           endif
        endif
     enddo
     if(n0.ne.31 .and. n0.ne.32) go to 10

     worst2=0.
     do lag=0,LAGMAX
        nsum=0
        do i=1,126-lag
           nsum=nsum + np0(i)*np0(lag+i) + np1(i)*np1(lag+i)
        enddo
        ccf2(lag)=2.0*nsum/(126.0-lag)
        if(lag.ge.1 .and. ccf2(lag).gt.worst2) then
           worst2=ccf2(lag)
           lagbad=lag
        endif
     enddo
     if(worst2.lt.best2) then
        best2=worst2
        lagbest=lagbad
        n0best=n0
        ccf3=ccf2
        npr2=np0 + 2*np1           
     endif
  enddo

  do lag=0,LAGMAX
     write(13,1100) lag,ccf0(lag),ccf3(lag)
1100 format(i3,2f10.3)
  enddo

  print*,worst,best2,n0best,lagbest
  write(*,1110) npr2
1110 format((8x,20(i1,',')))

999 end program synctst

subroutine msk40spd(cbig,n,ntol,mycall,hiscall,bswl,nhasharray,   &
                    nsuccess,msgreceived,fc,fret,tret,navg)
! msk40 short-ping-decoder

  use packjt77
  use timer_module, only: timer

  parameter (NSPM=240, MAXSTEPS=150, NFFT=NSPM, MAXCAND=5, NPATTERNS=6)
  character*12 mycall,hiscall
  character*37 msgreceived
  complex cbig(n)
  complex cdat(3*NSPM)                    !Analytic signal
  complex c(NSPM)
  complex ct(NSPM)
  complex ctmp(NFFT)                  
  integer, dimension(1) :: iloc
  integer indices(MAXSTEPS)
  integer npkloc(10)
  integer navpatterns(3,NPATTERNS)
  integer navmask(3)
  integer nstart(MAXCAND)
  logical ismask(NFFT)
  logical*1 bswl
  real detmet(-2:MAXSTEPS+3)
  real detmet2(-2:MAXSTEPS+3)
  real detfer(MAXSTEPS)
  real rcw(12)
  real ferrs(MAXCAND)
  real snrs(MAXCAND)
  real tonespec(NFFT)
  real tpat(NPATTERNS)
  real*8 dt, df, fs, pi, twopi
  logical first
  data first/.true./
  data navpatterns/ &
       0,1,0, &
       1,0,0, &
       0,0,1, &
       1,1,0, &
       0,1,1, &
       1,1,1/
  data tpat/1.5,0.5,2.5,1.0,2.0,1.5/
  save df,first,fs,pi,twopi,dt,tframe,rcw

  if(first) then
     nmatchedfilter=1
! define half-sine pulse and raised-cosine edge window
     pi=4d0*datan(1d0)
     twopi=8d0*datan(1d0)
     fs=12000.0
     dt=1.0/fs
     df=fs/NFFT
     tframe=NSPM/fs

     do i=1,12
       angle=(i-1)*pi/12.0
       rcw(i)=(1-cos(angle))/2
     enddo

     first=.false.
  endif


  ! fill the detmet, detferr arrays
  nstep=(n-NSPM)/60  ! 20ms/4=5ms steps
  detmet=0
  detmet2=0
  detfer=-999.99
  nfhi=2*(fc+500)
  nflo=2*(fc-500)
  ihlo=nint((nfhi-2*ntol)/df)+1
  ihhi=nint((nfhi+2*ntol)/df)+1
  illo=nint((nflo-2*ntol)/df)+1
  ilhi=nint((nflo+2*ntol)/df)+1
  i2000=nint(nflo/df)+1
  i4000=nint(nfhi/df)+1
  do istp=1,nstep
    ns=1+60*(istp-1)
    ne=ns+NSPM-1
    if( ne .gt. n ) exit
    ctmp=cmplx(0.0,0.0)
    ctmp(1:NSPM)=cbig(ns:ne)

! Coarse carrier frequency sync - seek tones at 2000 Hz and 4000 Hz in 
! squared signal spectrum.

    ctmp=ctmp**2
    ctmp(1:12)=ctmp(1:12)*rcw
    ctmp(NSPM-11:NSPM)=ctmp(NSPM-11:NSPM)*rcw(12:1:-1)
    call four2a(ctmp,NFFT,1,-1,1)
    tonespec=abs(ctmp)**2

    ismask=.false.
    ismask(ihlo:ihhi)=.true.  ! high tone search window
    iloc=maxloc(tonespec,ismask)
    ihpk=iloc(1)
    deltah=-real( (ctmp(ihpk-1)-ctmp(ihpk+1)) / (2*ctmp(ihpk)-ctmp(ihpk-1)-ctmp(ihpk+1)) )
    ah=tonespec(ihpk)
    ahavp=(sum(tonespec,ismask)-ah)/count(ismask)
    trath=ah/(ahavp+0.01)
    ismask=.false.
    ismask(illo:ilhi)=.true.   ! window for low tone
    iloc=maxloc(tonespec,ismask)
    ilpk=iloc(1)
    deltal=-real( (ctmp(ilpk-1)-ctmp(ilpk+1)) / (2*ctmp(ilpk)-ctmp(ilpk-1)-ctmp(ilpk+1)) )
    al=tonespec(ilpk)
    alavp=(sum(tonespec,ismask)-al)/count(ismask)
    tratl=al/(alavp+0.01)
    fdiff=(ihpk+deltah-ilpk-deltal)*df
    ferrh=(ihpk+deltah-i4000)*df/2.0
    ferrl=(ilpk+deltal-i2000)*df/2.0
    if( ah .ge. al ) then
      ferr=ferrh
    else
      ferr=ferrl
    endif
    detmet(istp)=max(ah,al)
    detmet2(istp)=max(trath,tratl)
    detfer(istp)=ferr
  enddo  ! end of detection-metric and frequency error estimation loop

  call indexx(detmet(1:nstep),nstep,indices) !find median of detection metric vector
  xmed=detmet(indices(nstep/4))
  detmet=detmet/xmed ! noise floor of detection metric is 1.0
  ndet=0

  do ip=1,MAXCAND ! Find candidates
    iloc=maxloc(detmet(1:nstep))
    il=iloc(1)
    if( (detmet(il) .lt. 3.5) ) exit 
    if( abs(detfer(il)) .le. ntol ) then 
      ndet=ndet+1
      nstart(ndet)=1+(il-1)*60+1
      ferrs(ndet)=detfer(il)
      snrs(ndet)=12.0*log10(detmet(il))/2-9.0
    endif
    detmet(il)=0.0
  enddo

  if( ndet .lt. 3 ) then  
    do ip=1,MAXCAND-ndet ! Find candidates
      iloc=maxloc(detmet2(1:nstep))
      il=iloc(1)
      if( (detmet2(il) .lt. 12.0) ) exit 
      if( abs(detfer(il)) .le. ntol ) then 
        ndet=ndet+1
        nstart(ndet)=1+(il-1)*60+1
        ferrs(ndet)=detfer(il)
        snrs(ndet)=12.0*log10(detmet2(il))/2-9.0
      endif
      detmet2(il)=0.0
    enddo
  endif

  nsuccess=0
  msgreceived=' '
  npeaks=2
  ntol0=29
  deltaf=7.2
  do icand=1,ndet  ! Try to sync/demod/decode each candidate.
    ib=max(1,nstart(icand)-NSPM)
    ie=ib-1+3*NSPM
    if( ie .gt. n ) then
      ie=n
      ib=ie-3*NSPM+1
    endif
    cdat=cbig(ib:ie) 
    fo=fc+ferrs(icand)
    xsnr=snrs(icand)
    do iav=1,NPATTERNS
      navmask=navpatterns(1:3,iav) 
      call msk40sync(cdat,3,ntol0,deltaf,navmask,npeaks,fo,fest,npkloc,       &
                     nsyncsuccess,c)
      if( nsyncsuccess .eq. 0 ) cycle

      do ipk=1,npeaks
        do is=1,3
          ic0=npkloc(ipk)
          if( is.eq.2) ic0=max(1,ic0-1)
          if( is.eq.3) ic0=min(NSPM,ic0+1)
          ct=cshift(c,ic0-1)
          call msk40decodeframe(ct,mycall,hiscall,xsnr,bswl,nhasharray,        &
                                msgreceived,ndecodesuccess)   
          if( ndecodesuccess .gt. 0 ) then
!write(*,*) icand, iav, ipk, is, tret, fret, msgreceived
            tret=(nstart(icand)+NSPM/2)/fs
            fret=fest
            navg=sum(navmask)
            nsuccess=ndecodesuccess
            return
          endif 
        enddo
      enddo
    enddo
  enddo       ! candidate loop

  return
end subroutine msk40spd

subroutine zplot9(s,freq,drift)

  real s(0:8,85)
  character*1 line(85),mark(0:6)
  data mark/' ',' ','.','-','+','X','$'/
  include 'jt9sync.f90'

  write(32,1000) freq,drift
1000 format('Freq:',f7.1,'   Drift:',f5.1,'  ',60('-'))
  do j=8,0,-1
     do i=1,85
        n=(s(j,i))
        if(n.lt.0) n=0
        if(n.gt.6) n=6
        line(i)=mark(n)
     enddo
     write(32,1010) j,line
1010 format(i1,1x,85a1)
  enddo
  do i=1,85
     line(i)=' '
     if(isync(i).eq.1) line(i)='@'
  enddo
  write(32,1015)
1015 format(87('-'))
  write(32,1020) line
1020 format(2x,85a1)
  call flush(32)

  return
end subroutine zplot9

subroutine ft8mfcqvar(s8,itone,msgd,msg37,lft8sd)

  use ft8_mod1, only : idtone25
  real, intent(in) :: s8(0:7,79)
  real s8d(0:7,58)
  character*37 msgd,msg37,msgsent37
  integer itone(79),mrs(58),mrs2(58)
  integer*1 msgbits(77)
  logical(1) lft8sd

  if(len_trim(msgd).lt.6) return
  i3=-1; n3=-1
  call genft8sdvar(msgd,i3,n3,msgsent37,msgbits,itone)
  idtone25(1,1:29)=itone(8:36)
  idtone25(1,30:58)=itone(44:72)

  thresh=0.0; i1=0; i2=0
  do i=1,58; if(i.le.29) then; s8d(0:7,i)=s8(0:7,i+7); else; s8d(0:7,i)=s8(0:7,i+14); endif; enddo
  do j=1,58
    s1=-1.0E6; s2=-1.0E6
    do i=0,7; if(s8d(i,j).gt.s1) then; s1=s8d(i,j); i1=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. s8d(i,j).gt.s2) then; s2=s8d(i,j); i2=i; endif; enddo
    mrs(j)=i1; mrs2(j)=i2
  enddo
  ref0=0.0
  do i=1,58; ref0=ref0 + s8d(mrs(i),i); enddo

  ipk=0; u1=0.0; u2=0.0
  do k=1,25
    psum=0.; ref=ref0
    do j=1,58; i3=idtone25(k,j); psum=psum + s8d(i3,j); if(i3.eq.mrs(j)) ref=ref - s8d(i3,j) + s8d(mrs2(j),j); enddo
    p=psum/ref
    if(p.gt.u1) then; u2=u1; u1=p; ipk=k
    else; if(p.gt.u2) u2=p
    endif
  enddo

  if(ipk.eq.1) then
    qual=100.0*(u1-u2)
    thresh=(qual+10.0)*(u1-0.6)
    if(thresh.gt.4.0 .and. qual.gt.2.6 .and. u1.gt.0.77) then
!print *,'matched',thresh
!print *,msgsd76(ipk)
!      if(msgd(1:10).eq.'CQ DE AA00') return ! triggered by memory corruption?
      lft8sd=.true.; msg37=msgd; return
    endif
  endif

  return
end subroutine ft8mfcqvar

subroutine demod64a(s3,nadd,afac1,mrsym,mrprob,mr2sym,mr2prob,ntest,nlow)

! Demodulate the 64-bin spectra for each of 63 symbols in a frame.

! Parameters
!    nadd     number of spectra already summed
!    mrsym    most reliable symbol value
!    mr2sym   second most likely symbol value
!    mrprob   probability that mrsym was the transmitted value
!    mr2prob  probability that mr2sym was the transmitted value

  implicit real*8 (a-h,o-z)
  real*4 s3(64,63),afac1
  integer mrsym(63),mrprob(63),mr2sym(63),mr2prob(63)

  if(nadd.eq.-999) return
  afac=afac1 * float(nadd)**0.64
  scale=255.999

! Compute average spectral value
  ave=sum(s3)/(64.*63.)
  i1=1                                      !Silence warning
  i2=1

! Compute probabilities for most reliable symbol values
  do j=1,63
     s1=-1.e30
     psum=0. 
     do i=1,64
        x=min(afac*s3(i,j)/ave,50.d0)
        psum=psum+s3(i,j)
        if(s3(i,j).gt.s1) then
           s1=s3(i,j)
           i1=i                              !Most reliable
        endif
     enddo
     if(psum.eq.0.0) psum=1.e-6

     s2=-1.e30
     do i=1,64
        if(i.ne.i1 .and. s3(i,j).gt.s2) then
           s2=s3(i,j)
           i2=i                              !Second most reliable
        endif
     enddo
     p1=s1/psum                              !Symbol metrics for ftrsd
     p2=s2/psum               
     mrsym(j)=i1-1
     mr2sym(j)=i2-1
     mrprob(j)=scale*p1
     mr2prob(j)=scale*p2
  enddo

  nlow=0
  do j=1,63
     if(mrprob(j).le.5) nlow=nlow+1
  enddo
  ntest=sum(mrprob)

  return
end subroutine demod64a

program chkfft

! Tests and times one-dimensional FFTs computed by four2a().
! An all-Fortran version of four2a() is available, but the preferred
! version uses calls to the FFTW library.

  parameter (NMAX=8*1024*1024)            !Maximum FFT length
  complex a(NMAX),b(NMAX)
  real ar(NMAX),br(NMAX)
  real mflops
  character infile*12,arg*8
  logical list
  common/patience/npatience
  equivalence (a,ar),(b,br)

  nargs=iargc()
  if(nargs.ne.5) then
     print*,'Usage: chkfft <nfft | infile> nr nw nc np'
     print*,'       nfft:   length of FFT'
     print*,'       nfft=0: do lengths 2^n, n=2^4 to 2^23'
     print*,'       infile: name of file with nfft values, one per line'
     print*,'       nr:     0/1 to not read (or read) wisdom'
     print*,'       nw:     0/1 to not write (or write) wisdom'
     print*,'       nc:     0/1 for real or complex data'
     print*,'       np:     0-4 patience for finding best algorithm'
     go to 999
  endif

  list=.false.
  nfft=-1
  call getarg(1,infile)
  open(10,file=infile,status='old',err=1)
  list=.true.                          !A valid file name was provided
  go to 2
1 read(infile,*) nfft                  !Takje first argument to be nfft
2  call getarg(2,arg)
  read(arg,*) nr
  call getarg(3,arg)
  read(arg,*) nw
  call getarg(4,arg)
  read(arg,*) ncomplex
  call getarg(5,arg)
  read(arg,*) npatience

  call sgran()

  if(list) write(*,1000) infile,nr,nw,ncomplex,npatience
1000 format(/'infile: ',a12,'   nr:',i2,'   nw',i2,'   nc:',i2,'   np:',i2/)
  if(.not.list) write(*,1002) nfft,nr,nw,ncomplex,npatience
1002 format(/'nfft: ',i10,'   nr:',i2,'   nw',i2,'   nc:',i2,'   np:',i2/)

  open(12,file='chkfft.out',status='unknown')
  open(13,file='fftwf_wisdom.dat',status='unknown')

  if(nr.ne.0) then
     call import_wisdom_from_file(isuccess,13)
     if(isuccess.eq.0) then
        write(*,1010) 
1010    format('Failed to import FFTW wisdom.')
        go to 999
     endif
  endif

  idum=-1                               !Set random seed
  ndim=1                                !One-dimensional transforms
  do i=1,NMAX                           !Set random data
     x=gran()
     y=gran()
     b(i)=cmplx(x,y)                    !Generate random data
  enddo

  iters=1000000
  if(list .or. (nfft.gt.0)) then
     n1=1
     n2=1
     if(nfft.eq.-1) n2=999999
     write(*,1020) 
1020 format('    NFFT     Time        rms      MHz   MFlops  iters',    &
          '  tplan'/61('-'))
  else
     n1=4
     n2=23
     write(*,1030) 
1030 format(' n   N=2^n     Time        rms      MHz   MFlops  iters',  &
          '  tplan'/63('-'))
  endif

  do ii=n1,n2                           !Test one or more FFT lengths
     if(list) then
        read(10,*,end=900) nfft         !Read nfft from file
     else if(n2.gt.n1) then
        nfft=2**ii                      !Do powers of 2
     endif

     iformf=1
     iformb=1
     if(ncomplex.eq.0) then
        iformf=0                        !Real-to-complex transform
        iformb=-1                       !Complex-to-real (inverse) transform
     endif

     if(nfft.gt.NMAX) go to 900
     a(1:nfft)=b(1:nfft)                !Copy test data into a()
     t0=second()
     call four2a(a,nfft,ndim,-1,iformf) !Get planning time for forward FFT
     call four2a(a,nfft,ndim,+1,iformb) !Get planning time for backward FFT
     t2=second()
     tplan=t2-t0                        !Total planning time for this length
     
     total=0.
     do iter=1,iters                    !Now do many iterations
        a(1:nfft)=b(1:nfft)             !Copy test data into a()

        t0=second()
        call four2a(a,nfft,ndim,-1,iformf) !Forward FFT
        call four2a(a,nfft,ndim,+1,iformb) !Backward FFT on same data
        t1=second()
        total=total+t1-t0
        if(total.ge.1.0) go to 40       !Cut iterations short if t>1 s
     enddo
     iter=iters

40   time=0.5*total/iter                !Time for one FFT of current length
     tplan=0.5*tplan-time               !Planning time for one FFT
     if(tplan.lt.0) tplan=0.
     a(1:nfft)=a(1:nfft)/nfft

! Compute RMS difference between original array and back-transformed array.
     sq=0.
     if(ncomplex.eq.1) then
        do i=1,nfft
           sq=sq + real(a(i)-b(i))**2 + imag(a(i)-b(i))**2
        enddo
     else
        do i=1,nfft
           sq=sq + (ar(i)-br(i))**2
        enddo
     endif
     rms=sqrt(sq/nfft)

     freq=1.e-6*nfft/time
     mflops=5.0/(1.e6*time/(nfft*log(float(nfft))/log(2.0)))
     if(n2.eq.1 .or. n2.eq.999999) then
        write(*,1050) nfft,time,rms,freq,mflops,iter,tplan
        write(12,1050) nfft,time,rms,freq,mflops,iter,tplan
1050    format(i8,f11.7,f12.8,f7.2,f8.1,i8,f6.1)
     else
        write(*,1060) ii,nfft,time,rms,freq,mflops,iter,tplan
        write(12,1060) ii,nfft,time,rms,freq,mflops,iter,tplan
1060    format(i2,i8,f11.7,f12.8,f7.2,f8.1,i8,f6.1)
     endif
     if(mod(ii,50).eq.0) call four2a(0,-1,0,0,0)
  enddo

900  continue 
  if(nw.eq.1) then
     rewind 13
     call export_wisdom_to_file(13)
!     write(*,1070) 
!1070 format(/'Exported FFTW wisdom')
  endif

999 call four2a(0,-1,0,0,0)
end program chkfft

subroutine getcand2(ss,savg0,nts_q65,nagain,nhsym,ntx30a,ntx30b,     &
     ntol,f0_selected,bAlso30,cand,ncand2)

! Get candidates for Q65 decodes, based on presence of sync tone.
  
  type candidate
     real :: snr          !Relative S/N of sync detection
     real :: f            !Freq of sync tone, 0 to 96000 Hz
     real :: xdt          !DT of matching sync pattern, -1.0 to +4.0 s
     integer :: ntrperiod !60 for Q65-60x, 30 for Q65-30x
     integer :: iseq      !0 for first half-minute, 1 for second half
  end type candidate

  parameter (NFFT=32768)                !FFTs done in symspec()
  parameter (MAX_CANDIDATES=50)
  type(candidate) :: cand(MAX_CANDIDATES)
  real ss(400,NFFT)                     !Symbol spectra
  real savg0(NFFT),savg(NFFT)           !Average spectra over whole Rx sequence
  integer ipk1(1)                       !Peak index of local portion of spectrum
  logical sync_ok                       !True if sync pattern is present
  logical*1 bAlso30
  data nseg/16/,npct/40/

  savg=savg0                            !Save the original spectrum
  nlen=NFFT/nseg
  do iseg=1,nseg                        !Normalize spectrum with nearby baseline
     ja=(iseg-1)*nlen + 1
     jb=ja + nlen - 1
     call pctile(savg(ja),nlen,npct,base)
     savg(ja:jb)=savg(ja:jb)/(1.015*base)
     savg0(ja:jb)=savg0(ja:jb)/(1.015*base)
  enddo

  df=96000.0/NFFT
  bw=65*nts_q65*1.666666667             !Bandwidth of Q65 signal
  nbw=bw/df + 1                         !Bandwidth in bins
  nb0=2*nts_q65                         !Range of peak search, in bins
  smin=1.4                              !First threshold
  nguard=5                              !Guard range in bins
  i1=1
  i2=NFFT-nbw-nguard
  if(nagain.ge.1) then
     i1=nint((1000.0*f0_selected-ntol)/df)
     i2=nint((1000.0*f0_selected+ntol)/df)
  endif

  j=0
  do i=i1,i2                         !Look for local peaks in average spectrum
     if(savg(i).lt.smin) cycle
     spk=maxval(savg(i:i+nb0))
     ipk1=maxloc(savg(i:i+nb0))
     i0=ipk1(1) + i - 1                         !Index of local peak in savg()
     fpk=0.001*i0*df                            !Frequency of peak (kHz)
! Check to see if sync tone is present.
     ntrperiod=60
     iseq=0
     if(nhsym.ge.200) then
        call q65_sync(ss,i0,nts_q65,ntrperiod,iseq,sync_ok,snr_sync,xdt)
        if(sync_ok) then
! Sync tone is present, we have a candidate for decoding
           j=j+1
           cand(j)%f=fpk
           cand(j)%xdt=xdt
           cand(j)%snr=snr_sync
           cand(j)%ntrperiod=ntrperiod
           cand(j)%iseq=iseq
           ia=max(1,min(i,i0-nguard))
           ib=min(i0+nbw+nguard,32768)
           savg(ia:ib)=0.
           if(j.ge.MAX_CANDIDATES) exit
        endif
     endif

     if(.not.bAlso30) cycle
     ntrperiod=30
     
     if(nhsym.le.200 .and. ntx30a.le.5) then
        call q65_sync(ss,i0,nts_q65,ntrperiod,iseq,sync_ok,snr_sync,xdt)
        if(sync_ok) then
! Sync tone is present, we have a candidate for decoding
           j=j+1
           cand(j)%f=fpk
           cand(j)%xdt=xdt
           cand(j)%snr=snr_sync
           cand(j)%ntrperiod=ntrperiod
           cand(j)%iseq=iseq
           ia=max(1,min(i,i0-nguard))
           ib=min(i0+nbw+nguard,32768)
           savg(ia:ib)=0.
           if(j.ge.MAX_CANDIDATES) exit
        endif
     endif

     iseq=1
     if(nhsym.ge.330 .and. ntx30b.le.5) then
        call q65_sync(ss,i0,nts_q65,ntrperiod,iseq,sync_ok,snr_sync,xdt)
        if(sync_ok) then
! Sync tone is present, we have a candidate for decoding
           j=j+1
           cand(j)%f=fpk
           cand(j)%xdt=xdt
           cand(j)%snr=snr_sync
           cand(j)%ntrperiod=ntrperiod
           cand(j)%iseq=iseq
           ia=max(1,min(i,i0-nguard))
           ib=min(i0+nbw+nguard,32768)
           savg(ia:ib)=0.
           if(j.ge.MAX_CANDIDATES) exit
        endif
     endif

  enddo
  ncand2=j                              !Total number of candidates found

  return
end subroutine getcand2

subroutine txpol(xpol,decoded,mygrid,npol,nxant,ntxpol,cp)

!  If Tx station's grid is in decoded message, compute optimum TxPol
  character*22 decoded
  character*6 mygrid,grid
  character*1 cp
  logical xpol

  ntxpol=0
  i1=index(decoded,' ')
  i2=index(decoded(i1+1:),' ') + i1
  grid='      '
  if(i2.ge.8 .and. i2.le.18) grid=decoded(i2+1:i2+4)//'mm'
  ntxpol=0
  cp=' '
  if(xpol .and.grid(1:4).ne.'RR73') then
     if(grid(1:1).ge.'A' .and. grid(1:1).le.'R' .and.           &
          grid(2:2).ge.'A' .and. grid(2:2).le.'R' .and.         &
          grid(3:3).ge.'0' .and. grid(3:3).le.'9' .and.         &
          grid(4:4).ge.'0' .and. grid(4:4).le.'9') then                 
        ntxpol=mod(npol-nint(2.0*dpol(mygrid,grid))+720,180)
        if(nxant.eq.0) then
           cp='H'
           if(ntxpol.gt.45 .and. ntxpol.le.135) cp='V'
        else
           cp='/'
           if(ntxpol.ge.90 .and. ntxpol.lt.180) cp='\'
        endif
     endif
  endif

  return
end subroutine txpol

subroutine MoonDop(nyear,month,nday,uth4,lon4,lat4,RAMoon4,DecMoon4,   &
     LST4,HA4,AzMoon4,ElMoon4,vr4,dist4)

  implicit real*8 (a-h,o-z)
  real*4 uth4                    !UT in hours
  real*4 lon4                    !West longitude, degrees
  real*4 lat4                    !Latitude, degrees
  real*4 RAMoon4                 !Topocentric RA of moon, hours
  real*4 DecMoon4                !Topocentric Dec of Moon, degrees
  real*4 LST4                    !Locat sidereal time, hours
  real*4 HA4                     !Local Hour angle, degrees
  real*4 AzMoon4                 !Topocentric Azimuth of moon, degrees
  real*4 ElMoon4                 !Topocentric Elevation of moon, degrees
  real*4 vr4                     !Radial velocity of moon wrt obs, km/s
  real*4 dist4                   !Echo time, seconds

  real*8 LST
  real*8 RME(6)                  !Vector from Earth center to Moon
  real*8 RAE(6)                  !Vector from Earth center to Obs
  real*8 RMA(6)                  !Vector from Obs to Moon
  real*8 rme0(6)
  logical km

  data rad/57.2957795130823d0/,twopi/6.28310530717959d0/

  km=.true.
  dlat=lat4/rad
  dlong1=lon4/rad
  elev1=200.d0
  call geocentric(dlat,elev1,dlat1,erad1)

  dt=100.d0                       !For numerical derivative, in seconds
  UT=uth4

! NB: geodetic latitude used here, but geocentric latitude used when 
! determining Earth-rotation contribution to Doppler.

  call moon2(nyear,month,nDay,UT-dt/3600.d0,dlong1*rad,dlat*rad,     &
       RA,Dec,topRA,topDec,LST,HA,Az0,El0,dist)
  call toxyz(RA/rad,Dec/rad,dist,rme0)      !Convert to rectangular coords

  call moon2(nyear,month,nDay,UT,dlong1*rad,dlat*rad,                &
       RA,Dec,topRA,topDec,LST,HA,Az,El,dist)
  call toxyz(RA/rad,Dec/rad,dist,rme)       !Convert to rectangular coords

  phi=LST*twopi/24.d0
  call toxyz(phi,dlat1,erad1,rae)           !Gencentric numbers used here!
  radps=twopi/(86400.d0/1.002737909d0)
  rae(4)=-rae(2)*radps                      !Vel of Obs wrt Earth center
  rae(5)=rae(1)*radps
  rae(6)=0.d0

  do i=1,3
     rme(i+3)=(rme(i)-rme0(i))/dt
     rma(i)=rme(i)-rae(i)
     rma(i+3)=rme(i+3)-rae(i+3)
  enddo

  call fromxyz(rma,alpha1,delta1,dtopo0)     !Get topocentric coords
  vr=dot(rma(4),rma)/dtopo0

  RAMoon4=topRA
  DecMoon4=topDec
  LST4=LST
  HA4=HA
  AzMoon4=Az
  ElMoon4=El
  vr4=vr
  dist4=dist

  return
end subroutine MoonDop

subroutine ft4_downsample(dd,newdata,f0,c)

   include 'ft4_params.f90'
   parameter (NFFT2=NMAX/NDOWN)
   real dd(NMAX)
   complex c(0:NMAX/NDOWN-1)
   complex c1(0:NFFT2-1)
   complex cx(0:NMAX/2)
   real x(NMAX), window(0:NFFT2-1)
   equivalence (x,cx)
   logical first, newdata
   data first/.true./
   save first,window,x

   df=12000.0/NMAX
   baud=12000.0/NSPS
   if(first) then
      bw_transition = 0.5*baud
      bw_flat = 4*baud
      iwt = bw_transition / df
      iwf = bw_flat / df
      pi=4.0*atan(1.0)
      window(0:iwt-1) = 0.5*(1+cos(pi*(/(i,i=iwt-1,0,-1)/)/iwt))
      window(iwt:iwt+iwf-1)=1.0
      window(iwt+iwf:2*iwt+iwf-1) = 0.5*(1+cos(pi*(/(i,i=0,iwt-1)/)/iwt))
      window(2*iwt+iwf:)=0.0
      iws = baud / df
      window=cshift(window,iws)
      first=.false.
   endif

   if(newdata) then
      x=dd
      call four2a(cx,NMAX,1,-1,0)             !r2c FFT to freq domain
   endif
   i0=nint(f0/df)
   c1=0.
   if(i0.ge.0 .and. i0.le.NMAX/2) c1(0)=cx(i0)
   do i=1,NFFT2/2
      if(i0+i.ge.0 .and. i0+i.le.NMAX/2) c1(i)=cx(i0+i)
      if(i0-i.ge.0 .and. i0-i.le.NMAX/2) c1(NFFT2-i)=cx(i0-i)
   enddo
   c1=c1*window/NFFT2
   call four2a(c1,NFFT2,1,1,1)            !c2c FFT back to time domain
   c=c1(0:NMAX/NDOWN-1)

   return
end subroutine ft4_downsample

program msk144code

! Provides examples of message packing, bit and symbol ordering,
! LDPC encoding, and other necessary details of the MSK144 protocol.

  use packjt77
  character*77 c77
  character msg*37,msgsent*37,bad*1,msgtype*18
  integer*4 i4tone(144)
  include 'msk144_testmsg.f90'

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: msk144code "message"'
     print*,'       msk144code -t'
     print*,' '
     print*,'Examples:'
     print*,'       msk144code "KA1ABC WB9XYZ EN37"'
     print*,'       msk144code "<KA1ABC WB9XYZ> R-03"'
     print*,'       msk144code "KA1ABC WB9XYZ R EN37"'
     go to 999
  endif

  call getarg(1,msg)
  nmsg=1
  if(msg(1:2).eq."-t") then
     nmsg=NTEST
  endif

  write(*,1010)
1010 format(4x,"Message",31x,"Decoded",29x,"Err i3.n3"/100("-")) 

  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)
     call fmtmsg(msg,iz)                !To upper case, collapse multiple blanks
     call genmsk_128_90(msg,ichk,msgsent,i4tone,itype)
     i3=-1
     n3=-1
     call pack77(msg,i3,n3,c77)
     msgtype=""
     if(i3.eq.0) then
        if(n3.eq.0) msgtype="Free text"
        if(n3.eq.1) msgtype="DXpedition mode"
        if(n3.eq.2) msgtype="EU VHF Contest"
        if(n3.eq.3) msgtype="ARRL Field Day"
        if(n3.eq.4) msgtype="ARRL Field Day"
        if(n3.eq.5) msgtype="Telemetry"
        if(n3.ge.6) msgtype="Undefined type"
     endif
     if(i3.eq.1) msgtype="Standard msg"
     if(i3.eq.2) msgtype="EU VHF Contest"
     if(i3.eq.3) msgtype="ARRL RTTY Roundup"
     if(i3.eq.4) msgtype="Nonstandard calls"
     if(i3.eq.5) msgtype="EU VHF Contest"
     if(i3.ge.6) msgtype="Undefined msg type"
     if(i3.ge.1) n3=-1
     if(i4tone(41).lt.0) then
        msgtype="Sh msg"
        i3=-1
     endif
     bad=" "
     if(msg.ne.msgsent) bad="*"
     if(i3.eq.0.and.n3.ge.0) then
        write(*,1020) imsg,msg,msgsent,bad,i3,n3,msgtype
1020    format(i2,'.',1x,a37,1x,a37,1x,a1,2x,i1,'.',i1,1x,a18)
     elseif(i3.ge.1) then
        write(*,1022) imsg,msg,msgsent,bad,i3,msgtype
1022    format(i2,'.',1x,a37,1x,a37,1x,a1,2x,i1,'.',1x,1x,a18)
     elseif(i3.lt.0) then
        write(*,1024) imsg,msg,msgsent,bad,msgtype
1024    format(i2,'.',1x,a37,1x,a37,1x,a1,6x,a18)
     endif

  enddo

  if(nmsg.eq.1) then
     n=144
     if(i4tone(41).lt.0) n=40
     write(*,1030) i4tone(1:n)
1030 format(/'Channel symbols'/(72i1))
  endif

999 end program msk144code

subroutine sort(n,arr)

  integer n,m,nstack
  real arr(n)
  parameter (m=7,nstack=50)
  integer i,ir,j,jstack,k,l,istack(nstack)
  real a,temp

  jstack=0
  l=1
  ir=n
  n0=n

1 if(ir-l.lt.m) then
     do j=l+1,ir
        a=arr(j)
        do i=j-1,1,-1
           if(arr(i).le.a) goto 2
           arr(i+1)=arr(i)
        enddo
        i=0
2       arr(i+1)=a
     enddo

     if(jstack.eq.0) return

     ir=istack(jstack)
     l=istack(jstack-1)
     jstack=jstack-2

  else
     k=(l+ir)/2
     temp=arr(k)
     arr(k)=arr(l+1)
     arr(l+1)=temp

     if(arr(l+1).gt.arr(ir)) then
        temp=arr(l+1)
        arr(l+1)=arr(ir)
        arr(ir)=temp
     endif

     if(arr(l).gt.arr(ir)) then
        temp=arr(l)
        arr(l)=arr(ir)
        arr(ir)=temp
     endif

     if(arr(l+1).gt.arr(l)) then
        temp=arr(l+1)
        arr(l+1)=arr(l)
        arr(l)=temp
     endif

     i=l+1
     j=ir
     a=arr(l)
3    i=i+1
     if(i.gt.n0) then
        do jj=1,n0
           write(99,3001) jj,arr(jj),i,n,ir
3001       format(i10,e12.3,3i10)
        enddo
        close(99)
        stop 'Bounds error in sort.f90'
     endif
     if(arr(i).lt.a) goto 3

4    j=j-1
     if(arr(j).gt.a) goto 4

     if(j.lt.i) goto 5
     temp=arr(i)
     arr(i)=arr(j)
     arr(j)=temp
     goto 3

5    arr(l)=arr(j)
     arr(j)=a
     jstack=jstack+2
     if(jstack.gt.nstack) stop 'nstack too small in sort'

     if(ir-i+1.ge.j-l) then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
     else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
     endif

  endif
  goto 1

end subroutine sort

subroutine get_crc24(mc,len,ncrc)
!
! 1. To calculate 24-bit CRC, mc(1:len-24) is the message and mc(len-23:len) are zero.
! 2. To check a received CRC, mc(1:len) is the received message plus CRC. 
!    ncrc will be zero if the received message/CRC are consistent.
!
   character c24*24
   integer*1 mc(len)
   integer*1 r(25),p(25)
   integer ncrc
! polynomial for 24-bit CRC 0x100065b
   data p/1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,1,1,0,1,1/

! divide by polynomial
   r=mc(1:25)
   do i=0,len-25 
      r(25)=mc(i+25)
      r=mod(r+r(1)*p,2)
      r=cshift(r,1)
   enddo

   write(c24,'(24b1)') r(1:24)
   read(c24,'(b24.24)') ncrc

end subroutine get_crc24

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    wqdecode.f90
! Description:  
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------
subroutine wqdecode(data0,message,ntype)

  parameter (N15=32768)
  integer*1 data0(11)
  character*22 message
  character*12 callsign
  character*3 cdbm
  character grid4*4,grid6*6
  logical first
  character*12 dcall(0:N15-1)
  data first/.true./
  save first,dcall

! May want to have a timeout (say, one hour?) on calls fetched 
! from the hash table.

  if(first) then
     dcall='            '
     first=.false.
  endif

  message='                      '
  call unpack50(data0,n1,n2)
!  print*,data0,n1,n2
  call unpackcall(n1,callsign)
  i1=index(callsign,' ')
  call unpackgrid(n2/128,grid4)
  ntype=iand(n2,127) -64

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  if(ntype.ge.0 .and. ntype.le.62) then
     nu=mod(ntype,10)
     if(nu.eq.0 .or. nu.eq.3 .or. nu.eq.7) then
        write(cdbm,'(i3)') ntype
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        message=callsign(1:i1)//grid4//' '//cdbm
        call hash(callsign,i1-1,ih)
        dcall(ih)=callsign(:i1)
     else
        nadd=nu
        if(nu.gt.3) nadd=nu-3
        if(nu.gt.7) nadd=nu-7
        ng=n2/128 + 32768*(nadd-1)
        call unpackpfx(ng,callsign)
        ndbm=ntype-nadd
        write(cdbm,'(i3)') ndbm
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        i2=index(callsign,' ')
        message=callsign(:i2)//cdbm
        call hash(callsign,i2-1,ih)
        dcall(ih)=callsign(:i2)
     endif
  else if(ntype.lt.0) then
     ndbm=-(ntype+1)
     grid6=callsign(6:6)//callsign(1:5)
     ih=(n2-ntype-64)/128
     callsign=dcall(ih)
     write(cdbm,'(i3)') ndbm
     if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
     if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
     i2=index(callsign,' ')
     if(dcall(ih)(1:1).ne.' ') then
        message='<'//callsign(:i2-1)//'> '//grid6//' '//cdbm
     else
        message='<...> '//grid6//' '//cdbm
     endif
  endif

  return
end subroutine wqdecode

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    unpack50.f90
! Description:  
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------
subroutine unpack50(dat,n1,n2)

  integer*1 dat(11)

  i=dat(1)
  i4=iand(i,255)
  n1=ishft(i4,20)
  i=dat(2)
  i4=iand(i,255)
  n1=n1 + ishft(i4,12)
  i=dat(3)
  i4=iand(i,255)
  n1=n1 + ishft(i4,4)
  i=dat(4)
  i4=iand(i,255)
  n1=n1 + iand(ishft(i4,-4),15)
  n2=ishft(iand(i4,15),18)
  i=dat(5)
  i4=iand(i,255)
  n2=n2 + ishft(i4,10)
  i=dat(6)
  i4=iand(i,255)
  n2=n2 + ishft(i4,2)
  i=dat(7)
  i4=iand(i,255)
  n2=n2 + iand(ishft(i4,-6),3)

  return
end subroutine unpack50

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    unpackcall.f90
! Description:  
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------
subroutine unpackcall(ncall,word)

  character word*12,c*37

  data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ '/

  n=ncall
  word='......'
  if(n.ge.262177560) go to 999            !Plain text message ...
  i=mod(n,27)+11
  word(6:6)=c(i:i)
  n=n/27
  i=mod(n,27)+11
  word(5:5)=c(i:i)
  n=n/27
  i=mod(n,27)+11
  word(4:4)=c(i:i)
  n=n/27
  i=mod(n,10)+1
  word(3:3)=c(i:i)
  n=n/10
  i=mod(n,36)+1
  word(2:2)=c(i:i)
  n=n/36
  i=n+1
  word(1:1)=c(i:i)
  do i=1,4
     if(word(i:i).ne.' ') go to 10
  enddo
  go to 999
10 word=word(i:)

999 if(word(1:3).eq.'3D0') word='3DA0'//word(4:)
  return
end subroutine unpackcall

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    unpackgrid.f90
! Description:  
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------
subroutine unpackgrid(ng,grid)

  parameter (NGBASE=180*180)
  character grid*4,grid6*6,digit*10
  data digit/'0123456789'/

  grid='    '
  if(ng.ge.32400) go to 10
  dlat=mod(ng,180)-90
  dlong=(ng/180)*2 - 180 + 2
  call deg2grid(dlong,dlat,grid6)
  grid=grid6(1:4) !XXX explicitly truncate this -db
  go to 100

10 n=ng-NGBASE-1
  if(n.ge.1 .and.n.le.30) then
     grid(1:1)='-'
     grid(2:2)=char(48+n/10)
     grid(3:3)=char(48+mod(n,10))
  else if(n.ge.31 .and.n.le.60) then
     n=n-30
     grid(1:2)='R-'
     grid(3:3)=char(48+n/10)
     grid(4:4)=char(48+mod(n,10))
  else if(n.eq.61) then
     grid='RO'
  else if(n.eq.62) then
     grid='RRR'
  else if(n.eq.63) then
     grid='73'
  endif

100 return
end subroutine unpackgrid

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    unpackpfx.f90
! Description:  
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------
subroutine unpackpfx(ng,call1)

  character*12 call1
  character*3 pfx

  if(ng.lt.60000) then
! Add-on prefix of 1 to 3 characters
     n=ng
     do i=3,1,-1
        nc=mod(n,37)
        if(nc.ge.0 .and. nc.le.9) then
           pfx(i:i)=char(nc+48)
        else if(nc.ge.10 .and. nc.le.35) then
           pfx(i:i)=char(nc+55)
        else
           pfx(i:i)=' '
        endif
        n=n/37
     enddo
     call1=pfx//'/'//call1(1:8)
     if(call1(1:1).eq.' ') call1=call1(2:)
     if(call1(1:1).eq.' ') call1=call1(2:)
  else
! Add-on suffix, one or teo characters
     i1=index(call1,' ')
     nc=ng-60000
     if(nc.ge.0 .and. nc.le.9) then
        call1=call1(:i1-1)//'/'//char(nc+48)
     else if(nc.ge.10 .and. nc.le.35) then
        call1=call1(:i1-1)//'/'//char(nc+55)
     else if(nc.ge.36 .and. nc.le.125) then
        nc1=(nc-26)/10
        nc2=mod(nc-26,10)
        call1=call1(:i1-1)//'/'//char(nc1+48)//char(nc2+48)
     endif
  endif

  return
end subroutine unpackpfx

subroutine gen4(msg0,ichk,msgsent,itone,itype)

! Encode a JT4 message.  Returns msgsent, the message as it will be
! decoded, an integer array itone(206) of 4-FSK tons values in the
! range 0-3; and itype, the JT message type.  

  use jt4
  use packjt
  character*22 msg0
  character*22 message          !Message to be generated
  character*22 msgsent          !Message as it will be received
  character*1 c
  integer itone(206)
  integer*4 i4Msg6BitWords(13)            !72-bit message as 6-bit words
  integer mettab(-128:127,0:1)
  save

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    itone(1)=nfreq
     msgsent=msg0
  else
     call getmet4(mettab,ndelta)

     message=msg0
     call fmtmsg(message,iz)
     call packmsg(message,i4Msg6BitWords,itype) !Pack into 12 6-bit bytes
     call unpackmsg(i4Msg6BitWords,msgsent) !Unpack to get msgsent
     if(ichk.ne.0) go to 999
     call encode4(message,itone)                 !Encode the information bits
     i1=index(message,'-')
     c=message(i1+1:i1+1)
     if(i1.ge.9 .and. c.ge.'0' .and. c.le.'3') then
        itone=2*itone + (1-npr(2:))             !Inverted '#' sync
     else 
        itone=2*itone + npr(2:)                 !Data = MSB, sync = LSB
     endif
  endif

999 return
end subroutine gen4

subroutine moon2(y,m,Day,UT,lon,lat,RA,Dec,topRA,topDec,LST,HA,Az,El,dist)

  implicit none

  integer y                           !Year
  integer m                           !Month
  integer Day                         !Day
  real*8 UT                           !UTC in hours
  real*8 RA,Dec                       !RA and Dec of moon

! NB: Double caps are single caps in the writeup.

  real*8 NN                           !Longitude of ascending node
  real*8 i                            !Inclination to the ecliptic
  real*8 w                            !Argument of perigee
  real*8 a                            !Semi-major axis
  real*8 e                            !Eccentricity
  real*8 MM                           !Mean anomaly

  real*8 v                            !True anomaly
  real*8 EE                           !Eccentric anomaly
  real*8 ecl                          !Obliquity of the ecliptic

  real*8 d                            !Ephemeris time argument in days
  real*8 r                            !Distance to sun, AU
  real*8 xv,yv                        !x and y coords in ecliptic
  real*8 lonecl,latecl                !Ecliptic long and lat of moon
  real*8 xg,yg,zg                     !Ecliptic rectangular coords
  real*8 Ms                           !Mean anomaly of sun
  real*8 ws                           !Argument of perihelion of sun
  real*8 Ls                           !Mean longitude of sun (Ns=0)
  real*8 Lm                           !Mean longitude of moon
  real*8 DD                           !Mean elongation of moon
  real*8 FF                           !Argument of latitude for moon
  real*8 xe,ye,ze                     !Equatorial geocentric coords of moon
  real*8 mpar                         !Parallax of moon (r_E / d)
  real*8 lat,lon                      !Station coordinates on earth
  real*8 gclat                        !Geocentric latitude
  real*8 rho                          !Earth radius factor
  real*8 GMST0,LST,HA
  real*8 g
  real*8 topRA,topDec                 !Topocentric coordinates of Moon
  real*8 Az,El
  real*8 dist

  real*8 rad,twopi,pi,pio2
  data rad/57.2957795131d0/,twopi/6.283185307d0/

  d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + Day - 730530 + UT/24.d0
  ecl = 23.4393d0 - 3.563d-7 * d

! Orbital elements for Moon:  
  NN = 125.1228d0 - 0.0529538083d0 * d
  i = 5.1454d0
  w = mod(318.0634d0 + 0.1643573223d0 * d + 360000.d0,360.d0)
  a = 60.2666d0
  e = 0.054900d0
  MM = mod(115.3654d0 + 13.0649929509d0 * d + 360000.d0,360.d0)

  EE = MM + e*rad*sin(MM/rad) * (1.d0 + e*cos(MM/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.d0 - e*cos(EE/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.d0 - e*cos(EE/rad))

  xv = a * (cos(EE/rad) - e)
  yv = a * (sqrt(1.d0-e*e) * sin(EE/rad))

  v = mod(rad*atan2(yv,xv)+720.d0,360.d0)
  r = sqrt(xv*xv + yv*yv)

! Get geocentric position in ecliptic rectangular coordinates:

  xg = r * (cos(NN/rad)*cos((v+w)/rad)-sin(NN/rad)*sin((v+w)/rad)*cos(i/rad))
  yg = r * (sin(NN/rad)*cos((v+w)/rad)+cos(NN/rad)*sin((v+w)/rad)*cos(i/rad))
  zg = r * (sin((v+w)/rad)*sin(i/rad))

! Ecliptic longitude and latitude of moon:
  lonecl = mod(rad*atan2(yg/rad,xg/rad)+720.d0,360.d0)
  latecl = rad*atan2(zg/rad,sqrt(xg*xg + yg*yg)/rad)

! Now include orbital perturbations:
  Ms = mod(356.0470d0 + 0.9856002585d0 * d + 3600000.d0,360.d0)
  ws = 282.9404d0 + 4.70935d-5*d
  Ls = mod(Ms + ws + 720.d0,360.d0)
  Lm = mod(MM + w + NN+720.d0,360.d0)
  DD = mod(Lm - Ls + 360.d0,360.d0)
  FF = mod(Lm - NN + 360.d0,360.d0)

  lonecl = lonecl                                &
       - 1.274d0 * sin((MM-2.d0*DD)/rad)         &
       + 0.658d0 * sin(2.d0*DD/rad)              &
       - 0.186d0 * sin(Ms/rad)                   &
       - 0.059d0 * sin((2.d0*MM-2.d0*DD)/rad)    &
       - 0.057d0 * sin((MM-2.d0*DD+Ms)/rad)      &
       + 0.053d0 * sin((MM+2.d0*DD)/rad)         &
       + 0.046d0 * sin((2.d0*DD-Ms)/rad)         &
       + 0.041d0 * sin((MM-Ms)/rad)              &
       - 0.035d0 * sin(DD/rad)                   &
       - 0.031d0 * sin((MM+Ms)/rad)              &
       - 0.015d0 * sin((2.d0*FF-2.d0*DD)/rad)    &
       + 0.011d0 * sin((MM-4.d0*DD)/rad)

  latecl = latecl                                &
       - 0.173d0 * sin((FF-2.d0*DD)/rad)         &
       - 0.055d0 * sin((MM-FF-2.d0*DD)/rad)      &
       - 0.046d0 * sin((MM+FF-2.d0*DD)/rad)      &
       + 0.033d0 * sin((FF+2.d0*DD)/rad)         &
       + 0.017d0 * sin((2.d0*MM+FF)/rad)

  r = 60.36298d0                                 &
       - 3.27746d0*cos(MM/rad)                   &
       - 0.57994d0*cos((MM-2.d0*DD)/rad)         &
       - 0.46357d0*cos(2.d0*DD/rad)              &
       - 0.08904d0*cos(2.d0*MM/rad)              &
       + 0.03865d0*cos((2.d0*MM-2.d0*DD)/rad)    &
       - 0.03237d0*cos((2.d0*DD-Ms)/rad)         &
       - 0.02688d0*cos((MM+2.d0*DD)/rad)         &
       - 0.02358d0*cos((MM-2.d0*DD+Ms)/rad)      &
       - 0.02030d0*cos((MM-Ms)/rad)              &
       + 0.01719d0*cos(DD/rad)                   &
       + 0.01671d0*cos((MM+Ms)/rad)
  
  dist=r*6378.140d0

! Geocentric coordinates:
! Rectangular ecliptic coordinates of the moon:

  xg = r * cos(lonecl/rad)*cos(latecl/rad)
  yg = r * sin(lonecl/rad)*cos(latecl/rad)
  zg = r *                 sin(latecl/rad)

! Rectangular equatorial coordinates of the moon:
  xe = xg
  ye = yg*cos(ecl/rad) - zg*sin(ecl/rad)
  ze = yg*sin(ecl/rad) + zg*cos(ecl/rad)
   
! Right Ascension, Declination:
  RA = mod(rad*atan2(ye,xe)+360.d0,360.d0)
  Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))

! Now convert to topocentric system:
  mpar=rad*asin(1.d0/r)
!     alt_topoc = alt_geoc - mpar*cos(alt_geoc)
  gclat = lat - 0.1924d0*sin(2.d0*lat/rad)
  rho = 0.99883d0 + 0.00167d0*cos(2.d0*lat/rad)
  GMST0 = (Ls + 180.d0)/15.d0
  LST = mod(GMST0+UT+lon/15.d0+48.d0,24.d0)    !LST in hours
  HA = 15.d0*LST - RA                          !HA in degrees
  g = rad*atan(tan(gclat/rad)/cos(HA/rad))
  topRA = RA - mpar*rho*cos(gclat/rad)*sin(HA/rad)/cos(Dec/rad)
  topDec = Dec - mpar*rho*sin(gclat/rad)*sin((g-Dec)/rad)/sin(g/rad)

  HA = 15.d0*LST - topRA                       !HA in degrees
  if(HA.gt.180.d0) HA=HA-360.d0
  if(HA.lt.-180.d0) HA=HA+360.d0

  pi=0.5d0*twopi
  pio2=0.5d0*pi
  call dcoord(pi,pio2-lat/rad,0.d0,lat/rad,ha*twopi/360,topDec/rad,az,el)
  Az=az*rad
  El=El*rad

  return
end subroutine moon2

module jt65_mod

  integer param(0:9)
  integer mrs(63)
  integer mrs2(63)
  integer mdat(126),mref(126,2),mdat2(126),mref2(126,2)    !From prcom

  real s1(-255:256,126)
  real s3a(64,63)
  real pr(126)
  real width

end module jt65_mod

program test28

  use packjt77
  parameter (NTOKENS=2063592,MAX22=4194304)
  character*13 arg,call_00,call_0,call_1
  character*1 cerr
  logical unpk28_success

  nargs=iargc()
  n28=-1
  if(nargs.eq.1) then
     call getarg(1,arg)
     read(arg,'(i13)',err=2) n28
  endif
  if(n28.ge.0) go to 100
  
2 open(10,file='test28.txt',status='old')

  write(*,1000)
1000 format('Encoded text   Recovered text      n28 Err?   Type'/60('-'))
  
  do iline=1,999999
     if(nargs.eq.0) then
        read(10,'(a13)',end=999) call_0
     else
        call_0=arg
     endif
     if(call_0.eq.'             ') exit
     if(call_0(1:3).eq.'CQ ' .and. call_0(4:4).ne.' ') call_0(3:3)='_'
     call_1='             '
     call_00=call_0
     call pack28(call_00,n28)
     call unpack28(n28,call_1,unpk28_success)
     cerr=' '
     if(call_0.ne.call_1) cerr='*'
     if(call_0(1:3).eq.'CQ_') call_0(3:3)=' '
     if(call_1(1:3).eq.'CQ_') call_1(3:3)=' '
     if(n28.lt.NTOKENS) write(*,1010) call_0,call_1,n28,cerr
1010 format(a13,2x,a13,i10,2x,a1,2x,'Special token')
     if(n28.ge.NTOKENS .and. n28.lt.NTOKENS+MAX22) then
        call_00=call_0
        call save_hash_call(call_00,n10,n12,n22)
        write(*,1012) call_0,call_1,n28,cerr,n22
1012    format(a13,2x,a13,i10,2x,a1,2x,'22-bit hash',i15)
     endif
     if(n28.ge.NTOKENS+MAX22) write(*,1014) call_0,call_1,n28,cerr
1014 format(a13,2x,a13,i10,2x,a1,2x,'Standard callsign')
     if(nargs.gt.0) exit
  enddo
  go to 999
  
100 call unpack28(n28,call_1,unpk28_success)
  cerr=' '
  if(.not.unpk28_success) cerr='*'
  if(call_1(1:3).eq.'CQ_') call_1(3:3)=' '
  if(n28.lt.NTOKENS) write(*,2010) n28,call_1,cerr
2010 format(i10,2x,a13,2x,a1,2x,'Special token')
  if(n28.ge.NTOKENS .and. n28.lt.NTOKENS+MAX22) write(*,2012) n28,call_1,cerr
2012 format(i10,2x,a13,2x,a1,2x,'22-bit hash')
  if(n28.ge.NTOKENS+MAX22) write(*,2014) n28,call_1,cerr
2014 format(i10,2x,a13,2x,a1,2x,'Standard callsign')
  
999 end program test28

subroutine gen_q65_cwave(msg,ntxfreq,ntone_spacing,msgsent,cwave,nwave)

! Encodes a Q65 message to yield complex cwave() at fsample = 96000 Hz

  use packjt
  use q65_encoding
  parameter (NMAX=60*96000)
  character*22 msg
  character*22 msgsent          !Message as it will be received
  character*37 msg37
  real*8 t,dt,phi,f,f0,dfgen,dphi,twopi,tsym
  complex cwave(NMAX)
  integer codeword(65),itone(85)
  integer icos7(0:6)
  data icos7/2,5,6,0,4,1,3/     !Defines a 7x7 Costas array
  data twopi/6.283185307179586476d0/
  save

  msgsent=msg
  msg37=''
  msg37(1:22)=msg
  call get_q65_tones(msg37,codeword,itone)

! Set up necessary constants
  nsym=85
  tsym=7200.d0/12000.d0
  dt=1.d0/96000.d0
  f0=ntxfreq
  dfgen=ntone_spacing*12000.d0/7200.d0
  phi=0.d0
  dphi=twopi*dt*f0
  i=0
  nwave=85*7200*96000.d0/12000.d0
  t=0.d0
  j0=0
  do i=1,nwave
     t=t+dt
     j=t/tsym + 1
     if(j.gt.85) exit
     if(j.ne.j0) then
        f=f0 + itone(j)*dfgen
        dphi=twopi*dt*f
        j0=j
     endif
     phi=phi+dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     cwave(i)=cmplx(cos(xphi),-sin(xphi))
  enddo

999  return
end subroutine gen_q65_cwave

subroutine setup65

! Defines arrays related to the JT65 pseudo-random synchronizing pattern.
! Executed at program start.

  use jt65_mod
  integer nprc(126)

! JT65
  data nprc/                                   &
      1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0, &
      0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1, &
      0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1, &
      0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1, &
      1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1, &
      0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1, &
      1,1,1,1,1,1/
  data mr2/0/                !Silence compiler warning

! Put the appropriate pseudo-random sequence into pr
  nsym=126
  do i=1,nsym
     pr(i)=2*nprc(i)-1
  enddo

! Determine locations of data and reference symbols
  k=0
  mr1=0
  do i=1,nsym
     if(pr(i).lt.0.0) then
        k=k+1
        mdat(k)=i
     else
        mr2=i
        if(mr1.eq.0) mr1=i
     endif
  enddo
  nsig=k

! Determine the reference symbols for each data symbol.
  do k=1,nsig
     m=mdat(k)
     mref(k,1)=mr1
     do n=1,10                     !Get ref symbol before data
        if((m-n).gt.0) then
           if (pr(m-n).gt.0.0) go to 10
        endif
     enddo
     go to 12
10   mref(k,1)=m-n
12   mref(k,2)=mr2
     do n=1,10                     !Get ref symbol after data
        if((m+n).le.nsym) then
           if (pr(m+n).gt.0.0) go to 20
        endif
     enddo
     cycle
20   mref(k,2)=m+n
  enddo

! Now do it all again, using opposite logic on pr(i)
  k=0
  mr1=0
  do i=1,nsym
     if(pr(i).gt.0.0) then
        k=k+1
        mdat2(k)=i
     else
        mr2=i
        if(mr1.eq.0) mr1=i
     endif
  enddo
  nsig=k

  do k=1,nsig
     m=mdat2(k)
     mref2(k,1)=mr1
     do n=1,10
        if((m-n).gt.0) then
           if (pr(m-n).lt.0.0) go to 110
        endif
     enddo
     go to 112
110  mref2(k,1)=m-n
112  mref2(k,2)=mr2
     do n=1,10
        if((m+n).le.nsym) then
           if (pr(m+n).lt.0.0) go to 120
        endif
     enddo
     cycle
120  mref2(k,2)=m+n
  enddo

  return
end subroutine setup65

subroutine interleave9(ia,ndir,ib)
  integer*1 ia(0:205),ib(0:205)
  integer j0(0:205)
  logical first
  data first/.true./
  save first,j0                     !Save not working, or j0 overwritten ???

  if(first) then
     k=-1
     do i=0,255
        m=i
        n=iand(m,1)
        n=2*n + iand(m/2,1)
        n=2*n + iand(m/4,1)
        n=2*n + iand(m/8,1)
        n=2*n + iand(m/16,1)
        n=2*n + iand(m/32,1)
        n=2*n + iand(m/64,1)
        n=2*n + iand(m/128,1)
        if(n.le.205) then
           k=k+1
           j0(k)=n
        endif
     enddo
!     first=.false.
  endif

  if(ndir.gt.0) then
     do i=0,205
        ib(j0(i))=ia(i)
     enddo
  else
     do i=0,205
        ib(i)=ia(j0(i))
     enddo
  endif

  return
end subroutine interleave9

subroutine wqdec(data0,message,ntype)

  use packjt
  parameter (N15=32758)
  integer*1 data0(11)
  character*22 message
  character*12 callsign
  character*3 cdbm,cf
  character*2 crpt
  character*4 grid,psfx
  character*9 name
  character*36 fmt
  character*6 cwx(4)
  character*7 cwind(5)
  character ccur*4,cxp*2
  logical first
  character*12 dcall(0:N15-1)
  data first/.true./
  data cwx/'CLEAR','CLOUDY','RAIN','SNOW'/
  data cwind/'CALM','BREEZES','WINDY','DRY','HUMID'/
  save first,dcall

  if(first) then
     dcall='            '
     first=.false.
  endif

  message='                      '
  call unpack50(data0,n1,n2)
  call unpackcall(n1,callsign,iv2,psfx)
  i1=index(callsign,' ')
  call unpackgrid(n2/128,grid)
  ntype=iand(n2,127) -64

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  nu=mod(ntype,10)
  if(ntype.ge.0 .and. ntype.le.60 .and. (nu.eq.0 .or. nu.eq.3 .or.   &
       nu.eq.7)) then
     write(cdbm,'(i3)'),ntype
     if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
     if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
     message=callsign(1:i1)//grid//' '//cdbm
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1)

! "Best DX" WSPR response (type 1)
  else if(ntype.eq.1) then
     message=grid//' DE '//callsign

! CQ (msg 3; types 2,4,5)
  else if(ntype.eq.2) then
     message='CQ '//callsign(:i1)//grid
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1)
  else if(ntype.eq.4 .or. ntype.eq.5) then
     ng=n2/128 + 32768*(ntype-4)
     call unpackpfx(ng,callsign)
     message='CQ '//callsign
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1)

! Reply to CQ (msg #2; type 6)
  else if(ntype.eq.6) then
     ih=(n2-64-ntype)/128
     if(dcall(ih)(1:1).ne.' ') then
        i2=index(dcall(ih),' ')
        message='<'//dcall(ih)(:i2-1)//'> '//callsign(:i1-1)
     else
        message='<...> '//callsign
     endif
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! Reply to CQ (msg #2; type 8)
  else if(ntype.eq.8) then
     message='DE '//callsign(:i1)//grid
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! Reply to CQ, DE pfx/call (msg #2; types 9, 11)
  else if(ntype.eq.9 .or. ntype.eq.11) then
     ng=n2/128 + 32768*(ntype-9)/2
     call unpackpfx(ng,callsign)
     message='DE '//callsign
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! Calls and report (msg #3; types -1 to -9)
  else if(ntype.le.-1 .and. ntype.ge.-9) then
     write(crpt,1010) -ntype
1010 format('S',i1)
     ih=(n2-62-ntype)/128
     if(dcall(ih)(1:1).ne.' ') then
        i2=index(dcall(ih),' ')
        message=callsign(:i1)//'<'//dcall(ih)(:i2-1)//'> '//crpt
     else
        message=callsign(:i1)//'<...> '//crpt
     endif
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! pfx/call and report (msg #3; types -10 to -27)
  else if(ntype.le.-10 .and. ntype.ge.-27) then
     ng=n2/128
     nrpt=-ntype-9
     if(ntype.le.-19) then
        ng=ng + 32768
        nrpt=-ntype-18
     endif
     write(crpt,1010) nrpt
     call unpackpfx(ng,callsign)
     message=callsign//' '//crpt
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! Calls and R and report (msg #4; types -28 to -36)
  else if(ntype.le.-28 .and. ntype.ge.-36) then
     write(crpt,1010) -(ntype+27)
     ih=(n2-64+28-ntype)/128
     if(dcall(ih)(1:1).ne.' ') then
        i2=index(dcall(ih),' ')
        message=callsign(:i1)//'<'//dcall(ih)(:i2-1)//'> '//'R '//crpt
     else
        message=callsign(:i1)//'<...> '//'R '//crpt
     endif
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! pfx/call R and report (msg #4; types -37 to -54)
  else if(ntype.le.-37 .and. ntype.ge.-54) then
     ng=n2/128
     nrpt=-ntype-36
     if(ntype.le.-46) then
        ng=ng + 32768
        nrpt=-ntype-45
     endif
     write(crpt,1010) nrpt
     call unpackpfx(ng,callsign)
     message=callsign//' R '//crpt
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! Calls and RRR (msg#5; type 12)
  else if(ntype.eq.12) then
     ih=(n2-64+28-ntype)/128
     if(dcall(ih)(1:1).ne.' ') then
        i2=index(dcall(ih),' ')
        message=callsign(:i1)//'<'//dcall(ih)(:i2-1)//'> RRR'
     else
        message=callsign(:i1)//'<...> RRR'
     endif
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! Calls and RRR (msg#5; type 14)
  else if(ntype.eq.14) then
     ih=(n2-64+28-ntype)/128
     if(dcall(ih)(1:1).ne.' ') then
        i2=index(dcall(ih),' ')
        message='<'//dcall(ih)(:i2-1)//'> '//callsign(:i1)//'RRR'
     else
        message='<...> '//callsign(:i1)//' RRR'
     endif
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! DE pfx/call and RRR (msg#5; types 15, 16)
  else if(ntype.eq.15 .or. ntype.eq.16) then
     ng=n2/128 + 32768*(ntype-15)
     call unpackpfx(ng,callsign)
     message='DE '//callsign//' RRR'
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! TNX [name] 73 GL (msg #6; type 18)
  else if(ntype.eq.18) then
     ng=(n2-18-64)/128
     call unpackname(n1,ng,name,len)
     message='TNX '//name(:len)//' 73 GL'

! OP [name] 73 GL (msg #6; type 18)
  else if(ntype.eq.-56) then
     ng=(n2+56-64)/128
     call unpackname(n1,ng,name,len)
     message='OP '//name(:len)//' 73 GL'

! 73 DE [call] [grid] (msg #6; type 19)
  else if(ntype.eq.19) then
     ng=(n2-19-64)/128
     message='73 DE '//callsign(:i1)//grid
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! 73 DE pfx/call (msg #6; type 21, 22)
  else if(ntype.eq.21 .or. ntype.eq.22) then
     ng=n2/128 + (ntype-21)*32768
     call unpackpfx(ng,callsign)
     i1=index(callsign,' ')
     message='73 DE '//callsign
     call hash(callsign,i1-1,ih)
     dcall(ih)=callsign(:i1-1)

! [power] W [gain] DBD 73 GL (msg#6; type 24, 25)
  else if(ntype.eq.24 .or. ntype.eq.25) then
     ng=(n2-24-64)/128 - 32
     i1=1
     if(n1.gt.0) i1=log10(float(n1)) + 1
     i2=1
     if(ng.ge.10) i2=2
     if(ng.lt.0) i2=i2+1
     if(n1.le.3000) then
        if(ntype.eq.24) fmt="(i4,' W ',i2,' DBD 73 GL')"
        if(ntype.eq.25) fmt="(i4,' W ',i2,' DBD      ')"
        fmt(3:3)=char(48+i1)
        fmt(12:12)=char(48+i2)
        if(ng.le.100) then
           write(message,fmt) n1,ng
        else
           if(ng.eq.30000) fmt=fmt(1:8)//"DIPOLE')"
           if(ng.eq.30001) fmt=fmt(1:8)//"VERTICAL')"
           write(message,fmt) n1
        endif
     else
        mw=n1-3000
        if(ntype.eq.24) fmt="('0.',i3.3,' W ',i2,' DBD 73 GL')"
        if(ntype.eq.25) fmt="('0.',i3.3,' W ',i2,' DBD      ')"
        fmt(19:19)=char(48+i2)
        if(ng.le.100) then
           write(message,fmt) mw,ng
        else
           if(ng.eq.30000) fmt=fmt(1:15)//"DIPOLE')"
           if(ng.eq.30001) fmt=fmt(1:15)//"VERTICAL')"
           write(message,fmt) n1
        endif
        if(index(message,'***').gt.0) go to 700
     endif

! QRZ call (msg #3; type 26)
  else if(ntype.eq.26) then
     ng=(n2-24-64)/128 - 32
     message='QRZ '//callsign

! PSE QSY [nnn] KHZ (msg #6; type 28)
  else if(ntype.eq.28) then
     if(n1.gt.0) i1=log10(float(n1)) + 1
     fmt="('PSE QSY ',i2,' KHZ')"
     fmt(14:14)=char(48+i1)
     write(message,fmt) n1        

! WX wx temp C/F wind (msg #6; type 29)
  else if(ntype.eq.29) then
     nwx=n1/10000
     ntemp=mod(n1,10000) - 100
     cf=' F '
     if(ntemp.gt.800) then
        ntemp=ntemp-1000
        cf=' C '
     endif
     n2a=n2/128
     if(nwx.ge.1 .and. nwx.le.4 .and. n2a.ge.1 .and. n2a.le.5) then
        write(message,1020) cwx(nwx),ntemp,cf,cwind(n2/128)
1020    format('WX ',a6,i3,a3,a7)
     else
        message='WX'//' (BadMsg)'
     endif

! Hexadecimal data (type 62)
  else if(ntype.eq.62) then
     ng=n2/128
     write(message,'(z4.4,z7.7)') ng,n1
     
! Solar/geomagnetic/ionospheric data (type 63)
  else if(ntype.eq.63) then
     ih=(n2-64-ntype)/128
     if(dcall(ih)(1:1).ne.' ') then
        i2=index(dcall(ih),' ')
        message='<'//dcall(ih)(:i2-1)//'> '
     else
        message='<...> '
     endif
     call unpackprop(n1,k,muf,ccur,cxp)
     i2=index(message,'>')
     write(message(i2+1:),'(i3,i3)') k,muf
     message=message(:i2+7)//ccur//' '//cxp
     
! [plain text] (msg #6; type -57)
  else if(ntype.eq.-57) then
     ng=n2/128
     call unpacktext2(n1,ng,message)
  else
     go to 700
  endif
  go to 750

!     message='<Unknown message type>'
700 i1=index(callsign,' ')
  if(i1.lt.1) i1=12
  message=callsign(:i1)//' (BadMsg)'

750 do i=1,22
     if(ichar(message(i:i)).eq.0) message(i:i)=' '
  enddo

  do i=22,1,-1
     if(message(i:i).ne.' ') go to 800
  enddo
800 i2=i
  do n=1,20
     i1=index(message(:i2),'  ')
     if(i1.le.0) go to 900
     message=message(1:i1)//message(i1+2:)
     i2=i2-1
  enddo

900  return
end subroutine wqdec

! Runtime sample-rate / FFT-size parameters for QMAP wide-mode.
!
! Allocatable arrays don't work in Fortran COMMON blocks, so the
! /datcom/ buffers are sized at compile time against MAX_IQ_RATE_HZ
! (the largest supported input rate). The runtime variables below
! control how much of the buffer is actually used at a given session;
! the C++ side calls qmap_set_runtime_config(rate, nfft) once at
! startup before any Fortran call into libqmap.
!
! Default values reproduce the original 96 kHz / NFFT=32768 behaviour
! exactly so a scaffold-only build is byte-identical to upstream.

module qmap_params
  use, intrinsic :: iso_c_binding
  implicit none

  ! Compile-time upper bounds. Pick to be the worst case the ABI
  ! supports; runtime can only request rates / NFFT sizes <= these.
  integer, parameter :: MAX_IQ_RATE_HZ = 256000
  integer, parameter :: MAX_NSMAX      = 60 * MAX_IQ_RATE_HZ        ! 15,360,000
  integer, parameter :: MAX_NFFT       = 131072                     ! next pow2 above 32768 * 256/96
  integer, parameter :: MAX_NFFT_BIG   = 56 * MAX_IQ_RATE_HZ        ! 14,336,000 — fftbig long-FFT plan size at 256 kHz
  integer, parameter :: BASELINE_RATE  = 96000                      ! upstream default
  integer, parameter :: BASELINE_NFFT  = 32768                      ! upstream default
  integer, parameter :: BASELINE_NFFT_BIG = 56 * BASELINE_RATE      ! 5,376,000 — historical MAXFFT1

  ! Active runtime values. Defaults preserve upstream behaviour;
  ! bumped by qmap_set_runtime_config from C++ at startup if the
  ! user has selected a wider mode.
  integer :: nrate_active     = BASELINE_RATE
  integer :: nfft_active      = BASELINE_NFFT
  integer :: nsmax_active     = 60 * BASELINE_RATE                  ! 5,760,000
  integer :: nfft_big_active  = BASELINE_NFFT_BIG                   ! 5,376,000

  ! Per-packet IQ-pair count for the nrx=+1 (single pol, i*2) Linrad
  ! UDP datagram. Updated on EVERY packet receive by soundin.cpp via
  ! qmap_set_iz_packet_active() so recvpkt's inner loop knows how
  ! many pairs the wire actually carried (legacy 348 at 96 kHz; can
  ! grow up to LINRAD_MAX_PAIRS_PER_PACKET=1024 in wide-mode).
  integer :: iz_packet_active = 348

contains

  ! Setter callable from C++ (see qmap_runtime_config.h).
  ! Idempotent — call once at startup, before any decoder activity.
  subroutine qmap_set_runtime_config(rate_hz, nfft) bind(c, name='qmap_set_runtime_config')
    integer(c_int), value :: rate_hz, nfft
    if (rate_hz <= 0 .or. rate_hz > MAX_IQ_RATE_HZ) return
    if (nfft    <= 0 .or. nfft    > MAX_NFFT)       return
    nrate_active    = rate_hz
    nfft_active     = nfft
    nsmax_active    = 60 * rate_hz
    nfft_big_active = 56 * rate_hz
  end subroutine qmap_set_runtime_config

  ! Per-packet pair-count setter, called from soundin.cpp after each
  ! readDatagram() so recvpkt's loop bound matches the actual wire size.
  subroutine qmap_set_iz_packet_active(iz) bind(c, name='qmap_set_iz_packet_active')
    integer(c_int), value :: iz
    if (iz > 0) iz_packet_active = iz
  end subroutine qmap_set_iz_packet_active

end module qmap_params

subroutine unpacktext2(n1,ng,msg)

  character*22 msg
  real*8 dn
  character*41 c
  data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +./?'/

  msg='                      '
  dn=32768.d0*n1 + ng
  do i=8,1,-1
     j=mod(dn,41.d0)
     msg(i:i)=c(j+1:j+1)
     dn=dn/41.d0
  enddo

  return
end subroutine unpacktext2

subroutine MoonDopJPL(nyear,month,nday,uth4,lon4,lat4,RAMoon4,        &
     DecMoon4,LST4,HA4,AzMoon4,ElMoon4,vr4,dist4)

  implicit real*8 (a-h,o-z)
  real*4 uth4                    !UT in hours
  real*4 lon4                    !East longitude, degrees
  real*4 lat4                    !Latitude, degrees
  real*4 RAMoon4                 !Topocentric RA of moon, hours
  real*4 DecMoon4                !Topocentric Dec of Moon, degrees
  real*4 LST4                    !Locat sidereal time, hours
  real*4 HA4                     !Local Hour angle, degrees
  real*4 AzMoon4                 !Topocentric Azimuth of moon, degrees
  real*4 ElMoon4                 !Topocentric Elevation of moon, degrees
  real*4 vr4                     !Radial velocity of moon wrt obs, km/s
  real*4 dist4                   !Echo time, seconds

  twopi=8.d0*atan(1.d0)          !Define some constants
  rad=360.d0/twopi
  clight=2.99792458d5

  call sla_CLDJ(nyear,month,nday,djutc,j)
  djutc=djutc + uth4/24.d0
  dut=-0.460d0

  east_long=lon4/rad
  geodetic_lat=lat4/rad
  height=40.
  nspecial=0

  call ephem(djutc,dut,east_long,geodetic_lat,height,nspecial,    &
       RA,Dec,Az,El,techo,dop,fspread_1GHz,vr)

  RAMoon4=RA
  DecMoon4=Dec
  LST4=0.                 !These two variables not presently used
  HA4=0.
  AzMoon4=Az*rad
  ElMoon4=El*rad
  vr4=vr
  dist4=techo

  return
end subroutine MoonDopJPL

subroutine sync65(nfa,nfb,ntol,nqsym,ca,ncand,nrobust,bVHF)

  parameter (NSZ=3413,NFFT=8192,MAXCAND=300)
  real ss(552,NSZ)
  real ccfblue(-32:82)             !CCF with pseudorandom sequence
  real ccfred(NSZ)                  !Peak of ccfblue, as function of freq
  logical bVHF

  type candidate
     real freq
     real dt
     real sync
     real flip
  end type candidate
  type(candidate) ca(MAXCAND)

  common/steve/thresh0
  common/sync/ss

  if(ntol.eq.-99) stop                       !Silence compiler warning
  call setup65

  df=12000.0/NFFT                            !df = 12000.0/8192 = 1.465 Hz
  ia=max(2,nint(nfa/df))
  ib=min(NSZ-1,nint(nfb/df))
!  lag1=-11
!  lag2=59
!  lag1=-22
!  lag2=118
  lag1=-32
  lag2=82        !may need to be extended for EME
  nsym=126
  ncand=0
  fdot=0.
  ccfred=0.
  ccfblue=0.
  ccfmax=0.
  ipk=0
  do i=ia,ib
     call xcor(i,nqsym,nsym,lag1,lag2,ccfblue,ccf0,lagpk0,flip,fdot,nrobust)
! Remove best-fit slope from ccfblue and normalize so baseline rms=1.0
     if(.not.bVHF) call slope(ccfblue(lag1),lag2-lag1+1,      &
          lagpk0-lag1+1.0)
     ccfred(i)=ccfblue(lagpk0)
     if(ccfred(i).gt.ccfmax) then
        ccfmax=ccfred(i)
        ipk=i
     endif
  enddo
  call pctile(ccfred(ia:ib),ib-ia+1,35,xmed)
  ccfred(ia:ib)=ccfred(ia:ib)-xmed
  ccfred(ia-1)=ccfred(ia)
  ccfred(ib+1)=ccfred(ib)

  do i=ia,ib
     freq=i*df
     itry=0
     if(bVHF) then
        if(i.ne.ipk .or. ccfmax.lt.thresh0) cycle
        itry=1
        ncand=ncand+1
     else
        if(ccfred(i).ge.thresh0 .and. ccfred(i).gt.ccfred(i-1) .and.       &
             ccfred(i).gt.ccfred(i+1)) then
           itry=1
           ncand=ncand+1
        endif
     endif
     if(itry.ne.0) then
        call xcor(i,nqsym,nsym,lag1,lag2,ccfblue,ccf0,lagpk,flip,fdot,nrobust)
        if(.not.bVHF) call slope(ccfblue(lag1),lag2-lag1+1,       &
             lagpk-lag1+1.0)
        xlag=lagpk
        if(lagpk.gt.lag1 .and. lagpk.lt.lag2) then
           call peakup(ccfblue(lagpk-1),ccfmax,ccfblue(lagpk+1),dx2)
           xlag=lagpk+dx2
        endif
        dtx=xlag*1024.0/11025.0
        ccfblue(lag1)=0.
        ccfblue(lag2)=0.
        ca(ncand)%freq=freq
        ca(ncand)%dt=dtx
        ca(ncand)%flip=flip
        if(bVHF) then
           ca(ncand)%sync=db(ccfred(i)) - 16.0
        else
           ca(ncand)%sync=ccfred(i)
        endif
     endif
     if(ncand.eq.MAXCAND) exit
  enddo

  return
end subroutine sync65

	subroutine ffft(d,npts,isign,ireal)

C  Fourier transform of length npts=2**k, performed in place.
C  Input data in array d, treated as complex if ireal=0, and as real if ireal=1.
C  In either case the transform values are returned in array d, treated as
C  complex. The DC term is d(1), and d(npts/2+1) is the term at the Nyquist
C  frequency.  The basic algorithm is the same as Norm Brenner's FOUR1, and
C  uses radix-2 transforms.

C  J. H. Taylor, Princeton University.

	complex d(npts),t,w,wstep,tt,uu
	data pi/3.14159265359/

C  Shuffle the data to bit-reversed order.

	imax=npts/(ireal+1)
	irev=1
	do 5 i=1,imax
	if(i.ge.irev) go to 2
	t=d(i)
	d(i)=d(irev)
	d(irev)=t
2	mmax=imax/2
3	if(irev.le.mmax) go to 5
	irev=irev-mmax
	mmax=mmax/2
	if(mmax.ge.1) go to 3
5	irev=irev+mmax

C  The radix-2 transform begins here.

	api=isign*pi/2.
	mmax=1
6	istep=2*mmax
	wstep=cmplx(-2.*sin(api/mmax)**2,sin(2.*api/mmax))
	w=1.
	do 9 m=1,mmax

C  This in the inner-most loop -- optimization here is important!
	do 8 i=m,imax,istep
	t=w*d(i+mmax)
	d(i+mmax)=d(i)-t
8	d(i)=d(i)+t

9	w=w*(1.+wstep)
	mmax=istep
	if(mmax.lt.imax) go to 6

	if(ireal.eq.0) return

C  Now complete the last stage of a doubled-up real transform.

	jmax=imax/2 + 1
	wstep=cmplx(-2.*sin(isign*pi/npts)**2,sin(isign*pi/imax))
	w=1.0
	d(imax+1)=d(1)

	do 10 j=1,jmax
	uu=cmplx(real(d(j))+real(d(2+imax-j)),aimag(d(j)) - 
     +    aimag(d(2+imax-j)))
	tt=w*cmplx(aimag(d(j))+aimag(d(2+imax-j)),-real(d(j)) +
     +    real(d(2+imax-j)))
	d(j)=uu+tt
	d(2+imax-j)=conjg(uu-tt)
10	w=w*(1.+wstep)

	return
	end

program ldpcsim128_90

! Simulate the performance of the (128,90) code that is used in
! the second incarnation of MSK144.

  use packjt77
  integer, parameter:: N=128, K=90, M=N-K
!  character*12 recent_calls(NRECENT)
  character*37 msg,msgsent,msgreceived
  character*77 c77 
  character*8 arg
  integer*1 codeword(N), message77(77)
  integer*1 apmask(N),cw(N)
  integer*1 msgbits(77)
  integer*4 i4Msg6BitWords(13)
  integer nerrtot(0:N),nerrdec(0:N)
  logical unpk77_success
  real*8 rxdata(N), rxavgd(N)
  real llr(N),llra(N)

  do i=1,MAXNRECENT
    recent_calls(i)='            '
  enddo
  nerrtot=0
  nerrdec=0

  nargs=iargc()
  if(nargs.ne.5) then
    print*,'Usage: ldpcsim  niter ndeep  navg  #trials  s '
    print*,'eg:    ldpcsim    10    2     1     1000    0.75'
    return
  endif
  call getarg(1,arg)
  read(arg,*) max_iterations 
  call getarg(2,arg)
  read(arg,*) ndeep
  call getarg(3,arg)
  read(arg,*) navg
  call getarg(4,arg)
  read(arg,*) ntrials
  call getarg(5,arg)
  read(arg,*) s

  rate=real(77)/real(N)

  write(*,*) "rate: ",rate
  write(*,*) "niter= ",max_iterations," navg= ",navg," s= ",s

  msg="K1ABC RR73; W9XYZ <KH1/KH7Z> -12"
  i3=0
  n3=1
  call pack77(msg,i3,n3,c77)
  call unpack77(c77,0,msgsent,unpk77_success)
  read(c77,'(77i1)') msgbits

  write(*,*) "message sent ",msgsent

  write(*,*) 'msgbits'
  write(*,'(77i1)') msgbits

! msgbits is the 77-bit message, codeword is 128 bits
  call encode_128_90(msgbits,codeword)

!  call init_random_seed()

  write(*,*) "Eb/N0  SNR2500   ngood  nundetected  sigma    psymerr"
  do idb = 6,6,-1 
    db=idb/2.0-1.0
    sigma=1/sqrt( 2*rate*(10**(db/10.0)) )
    ngood=0
    nue=0
    nbadcrc=0
    nsumerr=0

    do itrial=1, ntrials
      rxavgd=0d0
      do iav=1,navg
!        call sgran()
! Create a realization of a noisy received word
        do i=1,N
          rxdata(i) = 2.0*codeword(i)-1.0 + sigma*gran()
        enddo
        rxavgd=rxavgd+rxdata
      enddo
      rxdata=rxavgd
      nerr=0
      do i=1,N
        if( rxdata(i)*(2*codeword(i)-1.0) .lt. 0 ) nerr=nerr+1
      enddo
      nerrtot(nerr)=nerrtot(nerr)+1

      rxav=sum(rxdata)/N
      rx2av=sum(rxdata*rxdata)/N
      rxsig=sqrt(rx2av-rxav*rxav)
      rxdata=rxdata/rxsig
! The s parameter can be tuned to trade a few tenth's dB of threshold for an order of
! magnitude in UER 
      if( s .lt. 0 ) then
        ss=sigma
      else 
        ss=s
      endif

      llr=2.0*rxdata/(ss*ss)

      apmask=0
! max_iterations is max number of belief propagation iterations

      call bpdecode128_90(llr, apmask, max_iterations, message77, cw, nharderrors, niterations)

      if(ndeep.ge.0 .and. nharderrors.lt.0) then
        call osd128_90(llr, apmask, ndeep, message77, cw, nharderrors, dmin)
      endif
 
! If the decoder finds a valid codeword, nharderrors will be .ge. 0.
      if( nharderrors .ge. 0 ) then
        write(c77,'(77i1)') message77
        call unpack77(c77,1,msgreceived,unpk77_success)
        nhw=count(cw.ne.codeword)
        if(nhw.eq.0) then ! this is a good decode
          ngood=ngood+1
          nerrdec(nerr)=nerrdec(nerr)+1 
        else              ! this is an undetected error
          nue=nue+1
        endif
      endif
      nsumerr=nsumerr+nerr
    enddo

    snr2500=db+10*log10(rate*2000.0/2500.0) ! symbol rate is 2000 s^-1 and ref BW is 2500 Hz.
    pberr=real(nsumerr)/real(ntrials*N)
    write(*,"(f4.1,4x,f5.1,1x,i8,1x,i8,7x,f5.2,3x,e10.3)") db,snr2500,ngood,nue,ss,pberr
  
  enddo

  open(unit=23,file='nerrhisto.dat',status='unknown')
  do i=0,N
    write(23,'(i4,2x,i10,i10,f10.2)') i,nerrdec(i),nerrtot(i),real(nerrdec(i))/real(nerrtot(i)+1e-10)
  enddo
  close(23)

end program ldpcsim128_90

module txpol_mod
  implicit none
contains
  subroutine txpol(xpol,decoded,mygrid,npol,nxant,ntxpol,cp)
  
  use dpol_mod
  implicit none
  
  !  If Tx station's grid is in decoded message, compute optimum TxPol
    character*(*), intent(in) :: decoded
    character(len=6), intent(in) :: mygrid
    character(len=1), intent(out) :: cp
    logical, intent(in) :: xpol
    integer, intent(in) :: npol,nxant
    integer, intent(out) :: ntxpol
    
    integer :: i1,i2
    character(len=6) :: grid
  
    ntxpol=0
    i1=index(decoded,' ')
    i2=index(decoded(i1+1:),' ') + i1
    grid='      '
    if(i2.ge.8 .and. i2.le.18) grid=decoded(i2+1:i2+4)//'mm'
    ntxpol=0
    cp=' '
    if(xpol .and.grid(1:4).ne.'RR73') then
       if(grid(1:1).ge.'A' .and. grid(1:1).le.'R' .and.           &
            grid(2:2).ge.'A' .and. grid(2:2).le.'R' .and.         &
            grid(3:3).ge.'0' .and. grid(3:3).le.'9' .and.         &
            grid(4:4).ge.'0' .and. grid(4:4).le.'9') then                 
          ntxpol=mod(npol-nint(2.0*dpol(mygrid,grid))+720,180)
          if(nxant.eq.0) then
             cp='H'
             if(ntxpol.gt.45 .and. ntxpol.le.135) cp='V'
          else
             cp='/'
             if(ntxpol.ge.90 .and. ntxpol.lt.180) cp='\'
          endif
       endif
    endif
  
  end subroutine txpol
end module txpol_mod

subroutine multimode_decoder(ss,id2,params,nfsample)

!$ use omp_lib
  use prog_args
  use timer_module, only: timer
  use jt4_decode
  use jt65_decode
  use jt9_decode
  use ft8_decode
  use ft4_decode
  use fst4_decode
  use q65_decode

  include 'jt9com.f90'
  include 'timer_common.inc'

  type, extends(jt4_decoder) :: counting_jt4_decoder
     integer :: decoded
  end type counting_jt4_decoder

  type, extends(jt65_decoder) :: counting_jt65_decoder
     integer :: decoded
  end type counting_jt65_decoder

  type, extends(jt9_decoder) :: counting_jt9_decoder
     integer :: decoded
  end type counting_jt9_decoder

  type, extends(ft8_decoder) :: counting_ft8_decoder
     integer :: decoded
  end type counting_ft8_decoder

  type, extends(ft4_decoder) :: counting_ft4_decoder
     integer :: decoded
  end type counting_ft4_decoder

  type, extends(fst4_decoder) :: counting_fst4_decoder
     integer :: decoded
  end type counting_fst4_decoder

  type, extends(q65_decoder) :: counting_q65_decoder
     integer :: decoded
  end type counting_q65_decoder

  real ss(184,NSMAX)
  logical baddata,newdat65,newdat9,single_decode,bVHF,bad0,newdat,ex
  logical lprinthash22
  integer*2 id2(NTMAX*12000)
  integer nqf(20)
  type(params_block) :: params
  real*4 dd(NTMAX*12000)
  character(len=20) :: datetime
  character(len=12) :: mycall, hiscall
  character(len=6) :: mygrid, hisgrid
  character*60 line
  data ndec8/0/,ntr0/-1/
  save
  type(counting_jt4_decoder) :: my_jt4
  type(counting_jt65_decoder) :: my_jt65
  type(counting_jt9_decoder) :: my_jt9
  type(counting_ft8_decoder) :: my_ft8
  type(counting_ft4_decoder) :: my_ft4
  type(counting_fst4_decoder) :: my_fst4
  type(counting_q65_decoder) :: my_q65

  if(.not.params%newdat .and. params%ntr.gt.ntr0) go to 800
  ntr0=params%ntr
  rms=sqrt(dot_product(float(id2(1:180000)),                         &
       float(id2(1:180000)))/180000.0)
  if(rms.lt.0.5) go to 800

  !cast C character arrays to Fortran character strings
  datetime=transfer(params%datetime, datetime)
  mycall=transfer(params%mycall,mycall)
  hiscall=transfer(params%hiscall,hiscall)
  mygrid=transfer(params%mygrid,mygrid)
  hisgrid=transfer(params%hisgrid,hisgrid)

  ! initialize decode counts
  my_jt4%decoded = 0
  my_jt65%decoded = 0
  my_jt9%decoded = 0
  my_ft8%decoded = 0
  my_ft4%decoded = 0
  my_fst4%decoded = 0
  my_q65%decoded = 0
  
! For testing only: return Rx messages stored in a file as decodes
  inquire(file='rx_messages.txt',exist=ex)
  if(ex) then
     if(params%nzhsym.eq.41) then
        open(39,file='rx_messages.txt',status='old')
        do i=1,9999
           read(39,'(a60)',end=5) line
           if(line(1:1).eq.' ' .or. line(1:1).eq.'-') go to 800
           write(*,'(a)') trim(line)
        enddo
5       close(39)
     endif
     go to 800
  endif

  ncontest=iand(params%nexp_decode,7)
  single_decode=iand(params%nexp_decode,32).ne.0
  bVHF=iand(params%nexp_decode,64).ne.0
  if(mod(params%nranera,2).eq.0) ntrials=10**(params%nranera/2)
  if(mod(params%nranera,2).eq.1) ntrials=3*10**(params%nranera/2)
  if(params%nranera.eq.0) ntrials=0
  
  nfail=0
10 if (params%nagain) then
     open(13,file=trim(temp_dir)//'/decoded.txt',status='unknown',            &
          position='append',iostat=ios13)
  else
     open(13,file=trim(temp_dir)//'/decoded.txt',status='unknown',iostat=ios13)
  endif
  if(ios13.ne.0) then
     nfail=nfail+1
     if(nfail.le.3) then
        call sleep_msec(10)
        go to 10
     endif
  endif

  if(params%nmode.eq.8) then
! We're in FT8 mode
     if(ncontest.eq.6) then            !Fox=6, Hound=7
! Fox mode: initialize and open houndcallers.txt     
        inquire(file=trim(temp_dir)//'/houndcallers.txt',exist=ex)
        if(.not.ex) then
           c2fox='            '
           g2fox='    '
           nsnrfox=-99
           nfreqfox=-99
           n30z=0
           nwrap=0
           nfox=0
        endif
        open(19,file=trim(temp_dir)//'/houndcallers.txt',status='unknown')
     endif

     if(ncontest.eq.7 .and. params%b_superfox .and. params%b_even_seq) then
        if(params%nzhsym.lt.50) go to 800
! Call the superFox decoder
        open(47,file=trim(temp_dir)//'/fort.47',status='unknown',  &
             access='stream')
        write(47) params%yymmdd,params%nutc,id2(1:20),id2(1:180000)
        close(47)
        call execute_command_line(trim(exe_dir)//'/sfrx '//'"'//trim(temp_dir)//'/fort.47"')
     else
        call timer('decft8  ',0)
        newdat=params%newdat
        if(params%emedelay.ne.0.0) then
           id2(1:156000)=id2(24001:180000)  ! Drop the first 2 seconds of data
           id2(156001:180000)=0
        endif
        call my_ft8%decode(ft8_decoded,id2,params%nQSOProgress,params%nfqso, &
             params%nftx,newdat,params%nutc,params%nfa,params%nfb,           &
             params%nzhsym,params%ndepth,params%emedelay,ncontest,           &
             logical(params%nagain),logical(params%lft8apon),                &
             logical(params%lapcqonly),params%napwid,mycall,hiscall,         &
             params%ndiskdat)
        call timer('decft8  ',1)
     endif
     j=0

     if(ncontest.eq.6) then
! Fox mode: save decoded Hound calls for possible selection by FoxOp

        n=params%nutc
        n30=(3600*(n/10000) + 60*mod((n/100),100) + mod(n,100))/30
        if(n30.lt.n30z) nwrap=nwrap+2880    !New UTC day, handle the wrap
        n30z=n30
        n30=n30+nwrap

        rewind 19
        if(nfox.eq.0) then
           endfile 19
           rewind 19
        else
           do i=1,nfox
              n=n30fox(i)
              if(n30-n30fox(i).le.4) then
                 j=j+1
                 c2fox(j)=c2fox(i)
                 g2fox(j)=g2fox(i)
                 nsnrfox(j)=nsnrfox(i)
                 nfreqfox(j)=nfreqfox(i)
                 n30fox(j)=n
                 nage=min(99,mod(n30-n+288000,2880))
                 if(len(trim(g2fox(j))).eq.4) then
                    call azdist(mygrid,g2fox(j)//'  ',0.d0,nAz,nEl,nDmiles, &
                         nDkm,nHotAz,nHotABetter)
                 else
                    nDkm=9999
                 endif
                 write(19,1004) c2fox(j),g2fox(j),nsnrfox(j),nfreqfox(j), &
                      nDkm,nage
1004             format(a12,1x,a4,i5,i6,i7,i3)
              endif
           enddo
           nfox=j
           flush(19)
        endif
     endif
     go to 800
  endif

  if(params%nmode.eq.5) then
     call timer('decft4  ',0)
     call my_ft4%decode(ft4_decoded,id2,params%nQSOProgress,params%nfqso,    &
          params%nfa,params%nfb,params%ndepth,                               &
          logical(params%lapcqonly),ncontest,mycall,hiscall)
     call timer('decft4  ',1)
     go to 800
  endif

  if(params%nmode.eq.66) then        !NB: JT65 = 65, Q65 = 66.
! We're in Q65 mode
     open(17,file=trim(temp_dir)//'/red.dat',status='unknown')
     open(14,file=trim(temp_dir)//'/avemsg.txt',status='unknown')
     call timer('dec_q65 ',0)
     nqd=1
     call my_q65%decode(q65_decoded,id2,nqd,params%nutc,params%ntr,      &
          params%nsubmode,params%nfqso,params%ntol,params%ndepth,        &
          params%nfa,params%nfb,logical(params%nclearave),               &
          single_decode,logical(params%nagain),params%max_drift,         &
          logical(params%newdat),params%emedelay,mycall,hiscall,hisgrid, &
          params%nQSOProgress,ncontest,logical(params%lapcqonly),navg0,nqf)
     params%nclearave=.false.

     if(.not.params%nagain) then
! Go through identified candidates again, treating each as if it had been
! double-clicked on the waterfall.
        do k=1,20
           if(nqf(k).eq.0) exit
           if(params%nagain .and. abs(nqf(k)-params%nfqso).gt.params%ntol) cycle
           nqd=1
           navg0=0
           ntol=5
           call my_q65%decode(q65_decoded,id2,nqd,params%nutc,params%ntr,    &
                params%nsubmode,nqf(k),ntol,params%ndepth,                   &
                params%nfa,params%nfb,logical(params%nclearave),             &
                .true.,.true.,params%max_drift,                              &
                .false.,params%emedelay,mycall,hiscall,hisgrid,              &
                params%nQSOProgress,ncontest,logical(params%lapcqonly),      &
                navg0,nqf)
        enddo
     endif

     call timer('dec_q65 ',1)
     close(17)
     go to 800
  endif

  if(params%nmode.eq.240) then
! We're in FST4 mode
     ndepth=iand(params%ndepth,3)
     iwspr=0
     lprinthash22=.false.
     params%nsubmode=0
     call timer('dec_fst4',0)
     call my_fst4%decode(fst4_decoded,id2,params%nutc,                &
          params%nQSOProgress,params%nfa,params%nfb,                  &
          params%nfqso,ndepth,params%ntr,params%nexp_decode,          &
          params%ntol,params%emedelay,logical(params%nagain),         &
          logical(params%lapcqonly),mycall,hiscall,iwspr,lprinthash22)
     call timer('dec_fst4',1)
     go to 800
  endif

    if(params%nmode.eq.241 .or. params%nmode.eq.242) then
! We're in FST4W mode
     ndepth=iand(params%ndepth,3)
     iwspr=1
     lprinthash22=.false.
     if(params%nmode.eq.242) lprinthash22=.true. 
     call timer('dec_fst4',0)
     call my_fst4%decode(fst4_decoded,id2,params%nutc,                &
          params%nQSOProgress,params%nfa,params%nfb,                  &
          params%nfqso,ndepth,params%ntr,params%nexp_decode,          &
          params%ntol,params%emedelay,logical(params%nagain),         &
          logical(params%lapcqonly),mycall,hiscall,iwspr,lprinthash22)
     call timer('dec_fst4',1)
     go to 800
  endif

! Zap data at start that might come from T/R switching transient?
  nadd=100
  k=0
  bad0=.false.
  do i=1,240
     sq=0.
     do n=1,nadd
        k=k+1
        sq=sq + float(id2(k))**2
     enddo
     rms=sqrt(sq/nadd)
     if(rms.gt.10000.0) then
        bad0=.true.
        kbad=k
        rmsbad=rms
     endif
  enddo
  if(bad0) then
     nz=min(NTMAX*12000,kbad+100)
!     id2(1:nz)=0                ! temporarily disabled as it can breaak the JT9 decoder, maybe others
  endif
  
  if(params%nmode.eq.4 .or. params%nmode.eq.65) open(14,file=trim(temp_dir)// &
       '/avemsg.txt',status='unknown')

  if(params%nmode.eq.4) then
     jz=52*nfsample
     if(params%newdat) then
        if(nfsample.eq.12000) call wav11(id2,jz,dd)
        if(nfsample.eq.11025) dd(1:jz)=id2(1:jz)
     else
        jz=52*11025
     endif
     call my_jt4%decode(jt4_decoded,dd,jz,params%nutc,params%nfqso,         &
          params%ntol,params%emedelay,params%dttol,logical(params%nagain),  &
          params%ndepth,logical(params%nclearave),params%minsync,           &
          params%minw,params%nsubmode,mycall,hiscall,         &
          hisgrid,params%nlist,params%listutc,jt4_average)
     go to 800
  endif

  npts65=52*12000
  if(baddata(id2,npts65)) then
     nsynced=0
     ndecoded=0
     go to 800
  endif
 
  ntol65=params%ntol              !### is this OK? ###
  newdat65=params%newdat
  newdat9=params%newdat

!$call omp_set_dynamic(.true.)
!$omp parallel sections num_threads(2) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac

!$omp section
  if(params%nmode.eq.65) then
! We're in JT65 mode

     if(newdat65) dd(1:npts65)=id2(1:npts65)
     nf1=params%nfa
     nf2=params%nfb
     call timer('jt65a   ',0)
     call my_jt65%decode(jt65_decoded,dd,npts65,newdat65,params%nutc,      &
          nf1,nf2,params%nfqso,ntol65,params%nsubmode,params%minsync,      &
          logical(params%nagain),params%n2pass,logical(params%nrobust),    &
          ntrials,params%naggressive,params%ndepth,params%emedelay,        &
          logical(params%nclearave),mycall,hiscall,          &
          hisgrid,params%nexp_decode,params%nQSOProgress,           &
          logical(params%ljt65apon))
     call timer('jt65a   ',1)

  else if(params%nmode.eq.9 .or. (params%nmode.eq.(65+9) .and. params%ntxmode.eq.9)) then
! We're in JT9 mode, or should do JT9 first
     call timer('decjt9  ',0)
     call my_jt9%decode(jt9_decoded,ss,id2,params%nfqso,       &
          newdat9,params%npts8,params%nfa,params%nfsplit,params%nfb,       &
          params%ntol,params%nzhsym,logical(params%nagain),params%ndepth,  &
          params%nmode,params%nsubmode,params%nexp_decode)
     call timer('decjt9  ',1)
  endif

!$omp section
  if(params%nmode.eq.(65+9)) then       !Do the other mode (we're in dual mode)
     if (params%ntxmode.eq.9) then
        if(newdat65) dd(1:npts65)=id2(1:npts65)
        nf1=params%nfa
        nf2=params%nfb
        call timer('jt65a   ',0)
        call my_jt65%decode(jt65_decoded,dd,npts65,newdat65,params%nutc,   &
             nf1,nf2,params%nfqso,ntol65,params%nsubmode,params%minsync,   &
             logical(params%nagain),params%n2pass,logical(params%nrobust), &
             ntrials,params%naggressive,params%ndepth,params%emedelay,     &
             logical(params%nclearave),mycall,hiscall,       &
             hisgrid,params%nexp_decode,params%nQSOProgress,        &
             logical(params%ljt65apon))
        call timer('jt65a   ',1)
     else
        call timer('decjt9  ',0)
        call my_jt9%decode(jt9_decoded,ss,id2,params%nfqso,                &
             newdat9,params%npts8,params%nfa,params%nfsplit,params%nfb,    &
             params%ntol,params%nzhsym,logical(params%nagain),             &
             params%ndepth,params%nmode,params%nsubmode,params%nexp_decode)
        call timer('decjt9  ',1)
     end if
  endif

!$omp end parallel sections

! JT65 is not yet producing info for nsynced, ndecoded.
800 ndecoded = my_jt4%decoded + my_jt65%decoded + my_jt9%decoded +       &
         my_ft8%decoded + my_ft4%decoded + my_fst4%decoded +             &
         my_q65%decoded
  if(params%nmode.eq.8 .and. params%nzhsym.eq.41) ndec41=ndecoded
  if(params%nmode.eq.8 .and. params%nzhsym.eq.47) ndec47=ndecoded
  if(params%nmode.eq.8 .and. params%nzhsym.eq.50) then
     ndecoded=ndec41+ndec47+ndecoded
  endif
  if(params%nmode.ne.8 .or. params%nzhsym.eq.50 .or.                     &
       .not.params%ndiskdat) then

     write(*,1010) nsynced,ndecoded,navg0
1010 format('<DecodeFinished>',2i4,i9)
     call flush(6)
  endif
  close(13)
  if(ncontest.eq.6) close(19)
  if(params%nmode.eq.4 .or. params%nmode.eq.65 .or. params%nmode.eq.66) close(14)
  return
contains

  subroutine jt4_decoded(this,snr,dt,freq,have_sync,sync,is_deep,    &
       decoded0,qual,ich,is_average,ave)
    implicit none
    class(jt4_decoder), intent(inout) :: this
    integer, intent(in) :: snr
    real, intent(in) :: dt
    integer, intent(in) :: freq
    logical, intent(in) :: have_sync
    logical, intent(in) :: is_deep
    character(len=1), intent(in) :: sync
    character(len=22), intent(in) :: decoded0
    real, intent(in) :: qual
    integer, intent(in) :: ich
    logical, intent(in) :: is_average
    integer, intent(in) :: ave

    character*22 decoded
    character*3 cflags

    if(ich.eq.-99) stop                         !Silence compiler warning
    if (have_sync) then
       decoded=decoded0
       cflags='   '
       if(decoded.ne.'                      ') then
          cflags='f  '
          if(is_deep) then
             cflags='d  '
             write(cflags(2:2),'(i1)') min(int(qual),9)
             if(qual.ge.10.0) cflags(2:2)='*'
             if(qual.lt.3.0) decoded(22:22)='?'
          endif
          if(is_average) then
             write(cflags(3:3),'(i1)') min(ave,9)
             if(ave.ge.10) cflags(3:3)='*'
             if(cflags(1:1).eq.'f') cflags=cflags(1:1)//cflags(3:3)//' '
          endif
       endif
       write(*,1000) params%nutc,snr,dt,freq,sync,decoded,cflags
1000   format(i4.4,i4,f5.1,i5,1x,'$',a1,1x,a22,1x,a3)
    else
       write(*,1000) params%nutc,snr,dt,freq
    end if

    select type(this)
    type is (counting_jt4_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt4_decoded

  subroutine jt4_average (this, used, utc, sync, dt, freq, flip)
    implicit none
    class(jt4_decoder), intent(inout) :: this
    logical, intent(in) :: used
    integer, intent(in) :: utc
    real, intent(in) :: sync
    real, intent(in) :: dt
    integer, intent(in) :: freq
    logical, intent(in) :: flip
    character(len=1) :: cused, csync

    cused = '.'
    csync = '*'
    if (used) cused = '$'
    if (flip) csync = '$'
    write(14,1000) cused,utc,sync,dt,freq,csync
1000 format(a1,i5.4,f6.1,f6.2,i6,1x,a1)
  end subroutine jt4_average

  subroutine jt65_decoded(this,sync,snr,dt,freq,drift,nflip,width,     &
       decoded0,ft,qual,nsmo,nsum,minsync)

    use jt65_decode
    implicit none

    class(jt65_decoder), intent(inout) :: this
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    integer, intent(in) :: freq
    integer, intent(in) :: drift
    integer, intent(in) :: nflip
    real, intent(in) :: width
    character(len=22), intent(in) :: decoded0
    integer, intent(in) :: ft
    integer, intent(in) :: qual
    integer, intent(in) :: nsmo
    integer, intent(in) :: nsum
    integer, intent(in) :: minsync

    integer i,nap
    logical is_deep,is_average
    character decoded*22,csync*2,cflags*3

    if(width.eq.-9999.0) stop              !Silence compiler warning
!$omp critical(decode_results)
    decoded=decoded0
    cflags='   '
    is_deep=ft.eq.2

    if(ft.eq.0 .and. minsync.ge.0 .and. int(sync).lt.minsync) then
       write(*,1010) params%nutc,snr,dt,freq
    else
       is_average=nsum.ge.2
       if(bVHF .and. ft.gt.0) then
          cflags='f  '
          if(is_deep) then
             cflags='d  '
             write(cflags(2:2),'(i1)') min(qual,9)
             if(qual.ge.10) cflags(2:2)='*'
             if(qual.lt.3) decoded(22:22)='?'
          endif
          if(is_average) then
             write(cflags(3:3),'(i1)') min(nsum,9)
             if(nsum.ge.10) cflags(3:3)='*'
          endif
          nap=ishft(ft,-2)
          if(nap.ne.0) then
             if(nsum.lt.2) write(cflags(1:3),'(a1,i1," ")') 'a',nap
             if(nsum.ge.2) write(cflags(1:3),'(a1,2i1)') 'a',nap,min(nsum,9)
          endif
       endif
       csync='# '
       i=0
       if(bVHF .and. nflip.ne.0 .and.                         &
            sync.ge.max(0.0,float(minsync))) then
          csync='#*'
          if(nflip.eq.-1) then
             csync='##'
             if(decoded.ne.'                      ') then
                do i=22,1,-1
                   if(decoded(i:i).ne.' ') exit
                enddo
                if(i.gt.18) i=18
                decoded(i+2:i+4)='OOO'
             endif
          endif
       endif
       n=len(trim(decoded))
       if(n.eq.2 .or. n.eq.3) csync='# '
       if(cflags(1:1).eq.'f') then
          cflags(2:2)=cflags(3:3)
          cflags(3:3)=' '
       endif
       write(*,1010) params%nutc,snr,dt,freq,csync,decoded,cflags
1010   format(i4.4,i4,f5.1,i5,1x,a2,1x,a22,1x,a3)
    endif
    if(ios13.eq.0) write(13,1012) params%nutc,nint(sync),snr,dt,    &
         float(freq),drift,decoded,ft,nsum,nsmo
1012 format(i4.4,i4,i5,f6.2,f8.0,i4,3x,a22,' JT65',3i3)
    call flush(6)

!$omp end critical(decode_results)
    select type(this)
    type is (counting_jt65_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt65_decoded

  subroutine jt9_decoded (this, sync, snr, dt, freq, drift, decoded)
    use jt9_decode
    implicit none

    class(jt9_decoder), intent(inout) :: this
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    integer, intent(in) :: drift
    character(len=22), intent(in) :: decoded

    !$omp critical(decode_results)
    write(*,1000) params%nutc,snr,dt,nint(freq),decoded
1000 format(i4.4,i4,f5.1,i5,1x,'@ ',1x,a22)
    if(ios13.eq.0) write(13,1002) params%nutc,nint(sync),snr,dt,freq,  &
         drift,decoded
1002 format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a22,' JT9')
    call flush(6)
    !$omp end critical(decode_results)
    select type(this)
    type is (counting_jt9_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt9_decoded

  subroutine ft8_decoded (this,sync,snr,dt,freq,decoded,nap,qual)
    use ft8_decode
    implicit none

    class(ft8_decoder), intent(inout) :: this
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=37), intent(in) :: decoded
    character c1*12,c2*12,g2*4,w*4
    integer i0,i1,i2,i3,i4,i5,n30,nwrap
    integer, intent(in) :: nap 
    real, intent(in) :: qual 
    character*2 annot
    character*37 decoded0
    logical isgrid4,first,b0,b1,b2
    data first/.true./
    save

    isgrid4(w)=(len_trim(w).eq.4 .and.                                        &
         ichar(w(1:1)).ge.ichar('A') .and. ichar(w(1:1)).le.ichar('R') .and.  &
         ichar(w(2:2)).ge.ichar('A') .and. ichar(w(2:2)).le.ichar('R') .and.  &
         ichar(w(3:3)).ge.ichar('0') .and. ichar(w(3:3)).le.ichar('9') .and.  &
         ichar(w(4:4)).ge.ichar('0') .and. ichar(w(4:4)).le.ichar('9'))

    if(first) then
       c2fox='            '
       g2fox='    '
       nsnrfox=-99
       nfreqfox=-99
       n30z=0
       nwrap=0
       nfox=0
       first=.false.
    endif
    
    decoded0=decoded

    annot='  ' 
    if(nap.ne.0) then
       write(annot,'(a1,i1)') 'a',nap
       if(qual.lt.0.17) decoded0(37:37)='?'
    endif

!    i0=index(decoded0,';')
! Always print 37 characters? Or, send i3,n3 up to here from ft8b_2 and use them
! to decide how many chars to print?
!TEMP
    i0=1
    if(i0.le.0) write(*,1000) params%nutc,snr,dt,nint(freq),decoded0(1:22),annot
1000 format(i6.6,i4,f5.1,i5,' ~ ',1x,a22,1x,a2)
    if(i0.gt.0) write(*,1001) params%nutc,snr,dt,nint(freq),decoded0,annot
1001 format(i6.6,i4,f5.1,i5,' ~ ',1x,a37,1x,a2)
    if(ios13.eq.0) write(13,1002) params%nutc,nint(sync),snr,dt,freq,0,decoded0
1002 format(i6.6,i4,i5,f6.1,f8.0,i4,3x,a37,' FT8')

    if(ncontest.eq.6) then
       i1=index(decoded0,' ')
       i2=i1 + index(decoded0(i1+1:),' ')
       i3=i2 + index(decoded0(i2+1:),' ')
       if(i1.ge.3 .and. i2.ge.7 .and. i3.ge.10) then
          c1=decoded0(1:i1-1)//'            '
          c2=decoded0(i1+1:i2-1)
          g2=decoded0(i2+1:i3-1)
          b0=c1.eq.mycall
          if(c1(1:3).eq.'DE ' .and. index(c2,'/').ge.2) b0=.true.
          if(len(trim(c1)).ne.len(trim(mycall))) then
             i4=index(trim(c1),trim(mycall))
             i5=index(trim(mycall),trim(c1))
             if(i4.ge.1 .or. i5.ge.1) b0=.true.
          endif
          b1=i3-i2.eq.5 .and. isgrid4(g2)
          b2=i3-i2.eq.1
          if(b0 .and. (b1.or.b2) .and. (nint(freq).ge.1000 .or. params%b_superfox)) then
             n=params%nutc
             n30=(3600*(n/10000) + 60*mod((n/100),100) + mod(n,100))/30
             if(n30.lt.n30z) nwrap=nwrap+2880    !New UTC day, handle the wrap
             n30z=n30
             n30=n30+nwrap
             if(nfox.lt.MAXFOX) nfox=nfox+1
             c2fox(nfox)=c2
             g2fox(nfox)=g2
             nsnrfox(nfox)=snr
             nfreqfox(nfox)=nint(freq)
             n30fox(nfox)=n30
          endif
       endif
    endif
    
    call flush(6)
    if(ios13.eq.0) call flush(13)
    
    select type(this)
    type is (counting_ft8_decoder)
       this%decoded = this%decoded + 1
    end select

    return
  end subroutine ft8_decoded

  subroutine ft4_decoded (this,sync,snr,dt,freq,decoded,nap,qual)
    use ft4_decode
    implicit none

    class(ft4_decoder), intent(inout) :: this
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=37), intent(in) :: decoded
    integer, intent(in) :: nap
    real, intent(in) :: qual 
    character*2 annot
    character*37 decoded0
    
    decoded0=decoded

    annot='  ' 
    if(nap.ne.0) then
       write(annot,'(a1,i1)') 'a',nap
       if(qual.lt.0.17) decoded0(37:37)='?'
    endif

    write(*,1001) params%nutc,snr,dt,nint(freq),decoded0,annot
1001 format(i6.6,i4,f5.1,i5,' + ',1x,a37,1x,a2)

    if(ios13.eq.0) then
       write(13,1002,err=10) params%nutc,nint(sync),snr,dt,freq,0,decoded0
1002   format(i6.6,i4,i5,f6.1,f8.0,i4,3x,a37,' FT4')
       flush(13)
    endif
    
10  call flush(6)
    
    select type(this)
    type is (counting_ft4_decoder)
       this%decoded = this%decoded + 1
    end select

    return
  end subroutine ft4_decoded

  subroutine fst4_decoded (this,nutc,sync,nsnr,dt,freq,decoded,nap,   &
       qual,ntrperiod,fmid,w50)

    use fst4_decode
    implicit none

    class(fst4_decoder), intent(inout) :: this
    integer, intent(in) :: nutc
    real, intent(in) :: sync
    integer, intent(in) :: nsnr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=37), intent(in) :: decoded
    integer, intent(in) :: nap
    real, intent(in) :: qual
    integer, intent(in) :: ntrperiod
    real, intent(in) :: fmid
    real, intent(in) :: w50

    character*2 annot
    character*37 decoded0
    character*70 line

    decoded0=decoded
    annot='  '
    if(nap.ne.0) then
       write(annot,'(a1,i1)') 'a',nap
       if(qual.lt.0.17) decoded0(37:37)='?'
    endif

    if(ntrperiod.lt.60) then
       write(line,1001) nutc,nsnr,dt,nint(freq),decoded0,annot
1001   format(i6.6,i4,f5.1,i5,' ` ',1x,a37,1x,a2)
       if(ios13.eq.0) write(13,1002) nutc,nint(sync),nsnr,dt,freq,0,decoded0
1002   format(i6.6,i4,i5,f6.1,f8.0,i4,3x,a37,' FST4')
    else
       write(line,1003) nutc,nsnr,dt,nint(freq),decoded0,annot
1003   format(i4.4,i4,f5.1,i5,' ` ',1x,a37,1x,a2,2f7.3)
       if(ios13.eq.0) write(13,1004) nutc,nint(sync),nsnr,dt,freq,0,decoded0
1004   format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a37,' FST4')
    endif

    if(fmid.ne.-999.0) then
       if(w50.lt.0.95) write(line(65:70),'(f6.3)') w50
       if(w50.ge.0.95) write(line(65:70),'(f6.2)') w50
    endif

    write(*,1005) line
1005 format(a70)

    call flush(6)
    if(ios13.eq.0) call flush(13)

    select type(this)
    type is (counting_fst4_decoder)
       this%decoded = this%decoded + 1
    end select

   return
 end subroutine fst4_decoded

 subroutine q65_decoded (this,nutc,snr1,nsnr,dt,freq,decoded,idec,   &
      nused,ntrperiod)

    use q65_decode
    implicit none

    class(q65_decoder), intent(inout) :: this
    integer, intent(in) :: nutc
    real, intent(in) :: snr1
    integer, intent(in) :: nsnr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=37), intent(in) :: decoded
    integer, intent(in) :: idec
    integer, intent(in) :: nused
    integer, intent(in) :: ntrperiod
    character*3 cflags
  
    cflags='   '
    if(idec.ge.0) then
       cflags='q  '
       write(cflags(2:2),'(i1)') idec
       if(nused.ge.2) write(cflags(3:3),'(i1)') nused
    endif

    if(ntrperiod.lt.60) then
       write(*,1001) nutc,nsnr,dt,nint(freq),decoded,cflags
1001   format(i6.6,i4,f5.1,i5,' : ',1x,a37,1x,a3)
    if(ios13.eq.0) write(13,1002) nutc,nint(snr1),nsnr,dt,freq,0,decoded
1002 format(i6.6,i4,i5,f6.1,f8.0,i4,3x,a37,' Q65')
    else
       write(*,1003) nutc,nsnr,dt,nint(freq),decoded,cflags
1003   format(i4.4,i4,f5.1,i5,' : ',1x,a37,1x,a3)
       if(ios13.eq.0) write(13,1004) nutc,nint(snr1),nsnr,dt,freq,0,decoded
1004   format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a37,' Q65')

    endif
    call flush(6)
    if(ios13.eq.0) call flush(13)

    select type(this)
    type is (counting_q65_decoder)
       if(idec.ge.0) this%decoded = this%decoded + 1
    end select

   return
 end subroutine q65_decoded

end subroutine multimode_decoder

subroutine softsym9w(id2,npts,xdt0,f0,width,nsubmode,xdt1,snrdb,i1softsymbols)

  parameter (NFFT=6912,NH=NFFT/2,NQ=NH/2)
  real s(NQ)
  real s2(0:8,85)
  real s3(0:7,69)
  real x(NFFT)
  complex cx(0:NH)
  integer*2 id2(60*12000)
  integer*1 i1SoftSymbolsScrambled(207)
  integer*1 i1softsymbols(207)
  include 'jt9sync.f90'
  equivalence (x,cx)

  if(npts.eq.-99) stop                     !Silence compiler warning
  df=12000.0/NFFT
  i0a=max(1.0,(xdt0-1.0)*12000.0)
  i0b=(xdt0+1.0)*12000.0
  k1=max(1,nint((f0-0.5*width)/df))
  k2=min(NQ,nint((f0+0.5*width)/df))
  smax=0.
  i0pk=1
  i1softsymbols=0

  do i0=i0a,i0b,432
     s=0.
     ssum=0.
     do j=1,16
        ia=i0 + (ii(j)-1)*nfft
        ib=ia+NFFT-1
        x=1.e-6*id2(ia:ib)
        call four2a(x,nfft,1,-1,0)        !r2c FFT
        do k=1,NQ
           s(k)=s(k) + real(cx(k))**2 + aimag(cx(k))**2
        enddo
     enddo
     ssum=ssum + sum(s(k1:k2))
     if(ssum.gt.smax) then
        smax=ssum
        i0pk=i0
     else 
        if(ssum.lt.0.7*smax) exit
     endif
  end do
  xdt1=(i0pk-1)/12000.0

  if(i0pk.le.0) go to 999

  m=0
  do j=1,85
     ia=i0pk + (j-1)*nfft
     ib=ia+NFFT-1
     x=1.e-6*id2(ia:ib)
     call four2a(x,nfft,1,-1,0)        !r2c FFT
     do k=1,NQ
        s(k)=real(cx(k))**2 + aimag(cx(k))**2
     enddo

     dtone=df*(2**nsubmode)
     do i=0,8
        f=f0 + i*dtone
        k1=max(1,nint((f-0.5*width)/df))
        k2=min(NQ,nint((f+0.5*width)/df))
        s2(i,j)=sum(s(k1:k2))                  !Symbol spectra, including sync
     enddo

     if(isync(j).eq.0) then
        m=m+1
        s3(0:7,m)=s2(1:8,j)                   !Symbol spectra, data only
     endif

!     write(19,3101) j,s2(0:8,j)
!3101 format(i2,9f8.2)
  enddo

  ss=0.
  sig=0.
  do j=1,69
     smax=0.
     do i=0,7
        smax=max(smax,s3(i,j))
        ss=ss+s3(i,j)
     enddo
     sig=sig+smax
     ss=ss-smax
  enddo
  ave=ss/(69*7)                           !Baseline
  call pctile(s2,9*85,35,xmed)
  s3=s3/ave
  sig=sig/69.                             !Signal
  snrdb=db(sig/xmed) - 28.0
     
  m0=3
  k=0
  do j=1,69
     smax=0.
     do i=0,7
        if(s3(i,j).gt.smax) smax=s3(i,j)
     enddo
 
     do m=m0-1,0,-1                   !Get bit-wise soft symbols
        if(m.eq.2) then
           r1=max(s3(4,j),s3(5,j),s3(6,j),s3(7,j))
           r0=max(s3(0,j),s3(1,j),s3(2,j),s3(3,j))
        else if(m.eq.1) then
           r1=max(s3(2,j),s3(3,j),s3(4,j),s3(5,j))
           r0=max(s3(0,j),s3(1,j),s3(6,j),s3(7,j))
        else
           r1=max(s3(1,j),s3(2,j),s3(4,j),s3(7,j))
           r0=max(s3(0,j),s3(3,j),s3(5,j),s3(6,j))
        endif

        k=k+1
        i4=nint(10.0*(r1-r0))
        if(i4.lt.-127) i4=-127
        if(i4.gt.127) i4=127
        i1SoftSymbolsScrambled(k)=i4
     enddo
  enddo

! Remove interleaving
  call interleave9(i1SoftSymbolsScrambled,-1,i1SoftSymbols)

999  return
end subroutine softsym9w

subroutine gen65(message,mode65,samfac,nsendingsh,msgsent,iwave,nwave)

! Encodes a JT65 message into a wavefile.  
! Executes in 17 ms on opti-745.

  use packjt
  
  parameter (NMAX=2*60*11025)   !Max length of wave file
  character*22 message          !Message to be generated
  character*22 msgsent          !Message as it will be received
  character*3 cok               !'   ' or 'OOO'
  real*8 dt,phi,f,f0,dfgen,dphi,twopi,samfac
  integer*2 iwave(NMAX)         !Generated wave file
  integer dgen(12)
  integer sent(63)
  logical first
  integer nprc(126)
  real pr(126)
  data nprc/1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,  &
            0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,  &
            0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,  &
            0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,  &
            1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,  &
            0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,  &
            1,1,1,1,1,1/
  data twopi/6.283185307179586476d0/,first/.true./
  save

  if(first) then
     do i=1,126
        pr(i)=2*nprc(i)-1
     enddo
     first=.false.
  endif

  call chkmsg(message,cok,nspecial,flip)
  if(nspecial.eq.0) then
     call packmsg(message,dgen,itype)    !Pack message into 72 bits
     nsendingsh=0
     if(iand(dgen(10),8).ne.0) nsendingsh=-1    !Plain text flag

     call rs_encode(dgen,sent)
     call interleave63(sent,1)           !Apply interleaving
     call graycode(sent,63,1)            !Apply Gray code
     nsym=126                            !Symbols per transmission
     nsps=4096
  else
     nsym=32
     nsps=16384
     nsendingsh=1                         !Flag for shorthand message
  endif
  if(mode65.eq.0) go to 900

! Set up necessary constants
  dt=1.d0/(samfac*11025.d0)
  f0=118*11025.d0/1024
  dfgen=mode65*11025.d0/4096.d0
  phi=0.d0
  dphi=twopi*dt*f0
  i=0
  k=0
  do j=1,nsym
     if(message(1:5).ne.'@TUNE') then
        f=f0
        if(nspecial.ne.0 .and. mod(j,2).eq.0) f=f0+10*nspecial*dfgen
        if(nspecial.eq.0 .and. flip*pr(j).lt.0.0) then
           k=k+1
           f=f0+(sent(k)+2)*dfgen
        endif
        dphi=twopi*dt*f
     endif
     do ii=1,nsps
        phi=phi+dphi
        if(phi.gt.twopi) phi=phi-twopi
        xphi=phi
        i=i+1
        iwave(2*i-1)=32767.0*cos(xphi)
        iwave(2*i)=32767.0*sin(xphi)
     enddo
  enddo

  iwave(2*nsym*nsps+1:)=0
  nwave=2*nsym*nsps + 5512
  call unpackmsg(dgen,msgsent)
  if(flip.lt.0.0) then
     do i=22,1,-1
        if(msgsent(i:i).ne.' ') goto 10
     enddo
10   msgsent=msgsent(1:i)//' OOO'
  endif

  if(nsendingsh.eq.1) then
     if(nspecial.eq.2) msgsent='RO'
     if(nspecial.eq.3) msgsent='RRR'
     if(nspecial.eq.4) msgsent='73'
  endif

900 return
end subroutine gen65

module debug_log
  implicit none
  integer, save :: dbg_unit = -1
  logical, save :: dbg_opened = .false.
contains
  subroutine ensure_log_open()
    if (.not. dbg_opened) then
      open(newunit=dbg_unit, file='w3sz_debug.log', status='unknown', &
           action='write', position='append')
      dbg_opened = .true.
    end if
  end subroutine ensure_log_open
end module debug_log

subroutine q65b(nutc,nqd,fcenter,nfcal,nfsample,ikhz,mousedf,ntol,          &
     ntrperiod,iseq,mycall0,hiscall0,hisgrid,mode_q65,f0,fqso,nkhz_center,  &
     newdat,nagain,bClickDecode,max_drift,offset,ndepth,datetime,nCFOM,     &
     ndop00,nhsym,idec)

! This routine provides an interface between QMAP and the Q65 decoder
! in WSJT-X.  All arguments are input data obtained from the QMAP GUI.
! Raw Rx data are available as the 96 kHz complex spectrum ca(MAXFFT1)
! in common/cacb.  Decoded messages are sent back to the GUI.

  use q65_decode
  use wavhdr
  use timer_module, only: timer

  parameter (MAXFFT1=5376000)              !56*96000
  parameter (MAXFFT2=336000)               !56*6000 (downsampled by 1/16)
  parameter (NMAX=60*12000)
  parameter (RAD=57.2957795)
  type(hdr) h
  integer*2 iwave(60*12000)
  integer offset
  complex ca(MAXFFT1)                      !FFT of raw I/Q data from Linrad
  complex cx(0:MAXFFT2-1),cz(0:MAXFFT2)
  real*8 fcenter,freq0,freq1
  logical*1 bClickDecode
  character*12 mycall0,hiscall0
  character*12 mycall,hiscall
  character*6 hisgrid
  character*4 grid4
  character*3 csubmode
  character*17 fname
  character*64 result,ctmp
  character*20 datetime,datetime1
  common/decodes/ndecodes,ncand2,nQDecoderDone,nWDecoderBusy,              &
       nWTransmitting,kHzRequested,result(50)
  common/cacb/ca
  data ifile/0/
  save
  
  if(mycall0(1:1).ne.' ') mycall=mycall0
  if(hiscall0(1:1).ne.' ') hiscall=hiscall0
  if(hisgrid(1:4).ne.'    ') grid4=hisgrid(1:4)

! Find best frequency from sync_dat, the "orange sync curve".
  df3=96000.0/32768.0
  ipk=(1000.0*f0-1.0)/df3
  if(nagain.ge.2) ipk = nint(1000.0*(fqso-nkhz_center+48.0)/df3)
  nfft1=MAXFFT1
  nfft2=MAXFFT2
  df=96000.0/NFFT1
  nh=nfft2/2
  k0=nint((ipk*df3-1000.0)/df)
  if(k0.lt.nh .or. k0.gt.MAXFFT1-nfft2+1) go to 900
  fac=1.0/nfft2
  cx(0:nfft2-1)=fac*ca(k0:k0+nfft2-1)

! Here cx is frequency-domain data around the selected
! QSO frequency, taken from the full-length FFT computed in fftbig().
! Values for fsample, nfft1, nfft2, df, and the downsampled data rate
! are as follows:

!  fSample  nfft1       df        nfft2  fDownSampled
!    (Hz)              (Hz)                 (Hz)
!----------------------------------------------------
!   96000  5376000  0.017857143  336000   6000.000

  cz(0:MAXFFT2-1)=cx
  cz(MAXFFT2)=0.
! Roll off below 500 Hz and above 2500 Hz.
  ja=nint(500.0/df)
  jb=nint(2500.0/df)
  do i=0,ja
     r=0.5*(1.0+cos(i*3.14159/ja))
     cz(ja-i)=r*cz(ja-i)
     cz(jb+i)=r*cz(jb+i)
  enddo
 cz(ja+jb+1:)=0.

!Transform to time domain (real), fsample=12000 Hz
  call four2a(cz,2*nfft2,1,1,-1)
  do i=0,nfft2-1
     j=nfft2-1-i
     iwave(2*i+2)=nint(real(cz(j)))       !Note the reversed order!
     iwave(2*i+1)=nint(aimag(cz(j)))
  enddo
  iwave(2*nfft2+1:)=0

  nsubmode=mode_q65-1
  nfa=990                   !Tight limits around ipk for the wideband decode
  nfb=1010
  if(nagain.ge.1) then      !For nagain>=1, use limits of +/- ntol
     nfa=max(100,1000-ntol)
     nfb=min(2500,1000+ntol)
  endif
  nsnr0=-99             !Default snr for no decode

  if(iseq.eq.1) iwave(1:360000)=iwave(360001:720000)

  csubmode(1:2)='60'
  csubmode(3:3)=char(ichar('A')+nsubmode)
  nhhmmss=100*nutc
  nutc1=nutc
  datetime(12:13)='00'
  datetime1=datetime
  if(ntrperiod.eq.30) then
     csubmode(1:2)='30'
     nhhmmss=100*nutc + iseq*30
     nutc1=nhhmmss
     if(iseq.eq.1) datetime1(12:13)='30'
  endif

  if(nagain.ge.2) then
     ifile=ifile+1
     write(fname,1000) ifile
1000 format('000000_',i6.6,'.wav')
     open(27,file=fname,status='unknown',access='stream')
     if(nagain.eq.2) then
        h=default_header(12000,60*12000)
        ia=1
        ib=60*12000
     else if(nagain.eq.3) then
        h=default_header(12000,30*12000)
        ia=1
        ib=30*12000
     else
        h=default_header(12000,30*12000)
        ia=30*12000 + 1
        ib=60*12000
     endif
     write(27) h,iwave(ia:ib)
     close(27)
     go to 900
  endif
  
! NB: Frequency of ipk is now shifted to 1000 Hz.
  nagain2=0
  call map65_mmdec(nutc1,iwave,nqd,ntrperiod,nsubmode,nfa,nfb,1000,ntol,     &
       newdat,nagain2,max_drift,ndepth,mycall,hiscall,hisgrid)
  MHz=fcenter
  freq0=MHz + 0.001d0*ikhz

  if(nsnr0.gt.-99) then

     do i=1,ndecodes                    !Check for dupes
        i1=index(result(i)(42:),trim(msg0))
!          If this is a dupe, don't save it again:
        if(i1.gt.0 .and. (.not.bClickDecode .or. nhsym.eq.390)) go to 800
     enddo
     
     nq65df=nint(1000*(0.001*k0*df+nkhz_center-48.0+1.000-1.27046-ikhz))-nfcal
     nq65df=nq65df + nfreq0 - 1000
     ikhz1=ikhz
     ndf=nq65df
     if(ndf.gt.500) ikhz1=ikhz + (nq65df+500)/1000
     if(ndf.lt.-500) ikhz1=ikhz + (nq65df-500)/1000
     ndf=nq65df - 1000*(ikhz1-ikhz)
     freq1=freq0 + 0.001d0*(ikhz1-ikhz)
     frx=0.001*k0*df+nkhz_center-48.0+1.0 - 0.001*nfcal
     fsked=frx - 0.001*ndop00/2.0 - 0.001*offset
     ctmp=csubmode//'  '//trim(msg0)
     ndecodes=min(ndecodes+1,50)
     write(result(ndecodes),1120) nhhmmss,frx,fsked,xdt0,nsnr0,trim(ctmp)
1120 format(i6.6,f9.3,f7.1,f7.2,i5,2x,a)
     write(12,1130) datetime1,trim(result(ndecodes)(7:))
1130 format(a13,1x,a)
     result(ndecodes)=trim(result(ndecodes))//char(0)
800  idec=0
  endif

900 flush(12)
  return
end subroutine q65b

module jt4_decode
  type :: jt4_decoder
     procedure(jt4_decode_callback), pointer :: decode_callback => null ()
     procedure(jt4_average_callback), pointer :: average_callback => null ()
   contains
     procedure :: decode
     procedure, private :: wsjt4, avg4
  end type jt4_decoder

! Callback function to be called with each decode
  abstract interface
     subroutine jt4_decode_callback (this, snr, dt, freq, have_sync,     &
          sync, is_deep, decoded, qual, ich, is_average, ave)
       import jt4_decoder
       implicit none
       class(jt4_decoder), intent(inout) :: this
       integer, intent(in) :: snr
       real, intent(in) :: dt
       integer, intent(in) :: freq
       logical, intent(in) :: have_sync
       logical, intent(in) :: is_deep
       character(len=1), intent(in) :: sync
       character(len=22), intent(in) :: decoded
       real, intent(in) :: qual
       integer, intent(in) :: ich
       logical, intent(in) :: is_average
       integer, intent(in) :: ave
     end subroutine jt4_decode_callback
  end interface

! Callback function to be called with each average result
  abstract interface
     subroutine jt4_average_callback (this, used, utc, sync, dt, freq, flip)
       import jt4_decoder
       implicit none
       class(jt4_decoder), intent(inout) :: this
       logical, intent(in) :: used
       integer, intent(in) :: utc
       real, intent(in) :: sync
       real, intent(in) :: dt
       integer, intent(in) :: freq
       logical, intent(in) :: flip
     end subroutine jt4_average_callback
  end interface

contains

  subroutine decode(this,decode_callback,dd,jz,nutc,nfqso,ntol0,emedelay,     &
       dttol,nagain,ndepth,nclearave,minsync,minw,nsubmode,mycall,hiscall,    &
       hisgrid,nlist0,listutc0,average_callback)

    use jt4
    use timer_module, only: timer

    class(jt4_decoder), intent(inout) :: this
    procedure(jt4_decode_callback) :: decode_callback
    integer, intent(in) :: jz,nutc,nfqso,ntol0,ndepth,minsync,minw,nsubmode,  &
         nlist0,listutc0(10)
    real, intent(in) :: dd(jz),emedelay,dttol
    logical, intent(in) :: nagain, nclearave
    character(len=12), intent(in) :: mycall,hiscall
    character(len=6), intent(in) :: hisgrid
    procedure(jt4_average_callback), optional :: average_callback

    real*4 dat(30*11025)
    character*6 cfile6

    this%decode_callback => decode_callback
    if (present (average_callback)) then
       this%average_callback => average_callback
    end if
    mode4=nch(nsubmode+1)
    ntol=ntol0
    neme=0
    lumsg=6                         !### temp ? ###
    ndiag=1
    nlist=nlist0
    listutc=listutc0

    ! Lowpass filter and decimate by 2
    call timer('lpf1    ',0)
    call lpf1(dd,jz,dat,jz2)
    call timer('lpf1    ',1)

    write(cfile6(1:4),1000) nutc
1000 format(i4.4)
    cfile6(5:6)='  '

    call timer('wsjt4   ',0)
    call this%wsjt4(dat,jz2,nutc,NClearAve,minsync,ntol,emedelay,dttol,mode4, &
         minw,mycall,hiscall,hisgrid,nfqso,NAgain,ndepth,neme)
    call timer('wsjt4   ',1)

    return
  end subroutine decode

  subroutine wsjt4(this,dat,npts,nutc,NClearAve,minsync,ntol,emedelay,dttol,  &
       mode4,minw,mycall,hiscall,hisgrid,nfqso,NAgain,ndepth,neme)

! Orchestrates the process of decoding JT4 messages.  Note that JT4
! always operates as if in "Single Decode" mode; it looks for only one 
! decodable signal in the FTol range.

    use jt4
    use timer_module, only: timer

    class(jt4_decoder), intent(inout) :: this
    integer, intent(in) :: npts,nutc,minsync,ntol,mode4,minw,       &
         nfqso,ndepth,neme
    logical, intent(in) :: NAgain,NClearAve
    character(len=12), intent(in) :: mycall,hiscall
    character(len=6), intent(in) :: hisgrid
    real, intent(in) :: dat(npts) !Raw data
    logical first,prtavg
    character decoded*22,special*5
    character*22 avemsg,deepmsg,deepave,blank,deepmsg0,deepave1
    character csync*1
    data first/.true./,nutc0/-999/,nfreq0/-999999/
    save

    if(first) then
       nsave=0
       first=.false.
       blank='                      '
! Silence compiler warnings
       if(dttol.eq.-99.0 .and. emedelay.eq.-99.0 .and. nagain) stop
    endif

    zz=0.
!    syncmin=3.0 + minsync
    syncmin=1.0+minsync
    naggressive=0
    if(ndepth.ge.2) naggressive=1
    nq1=3
    nq2=6
    if(naggressive.eq.1) nq1=1
    if(NClearAve) then
       nsave=0
       iutc=-1
       nfsave=0.
       listutc=0
       ppsave=0.
       rsymbol=0.
       dtsave=0.
       syncsave=0.
       nfanoave=0
       ndeepave=0
    endif

! Attempt to synchronize: look for sync pattern, get DF and DT.
    call timer('sync4   ',0)
    call sync4(dat,npts,ntol,nfqso,4,mode4,minw+1,dtx,dfx,    &
         snrx,snrsync,flip,width)
    sync=snrsync
    dtxz=dtx-0.8
    nfreqz=nint(dfx)
    call timer('sync4   ',1)

    nsnr=-26
    if(sync.lt.syncmin) then
       if (associated (this%decode_callback)) then
          call this%decode_callback(nsnr,dtxz,nfreqz,.false.,csync,      &
               .false.,decoded,0.,ich,.false.,0)
       end if
       go to 990
    endif

! We have achieved sync
    nsnr=nint(snrsync - 22.9)
    decoded=blank
    deepmsg=blank
    special='     '
    nsync=sync
    nsnrlim=-33
    csync='*'
    if(flip.lt.0.0) csync='#'
    qbest=0.
    qabest=0.
    prtavg=.false.

    do idt=-2,2
       dtx=dtxz + 0.03*idt
       nfreq=nfreqz + 2*idf

! Attempt a single-sequence decode, including deep4 if Fano fails.
       call timer('decode4 ',0)
       call decode4(dat,npts,dtx,nfreq,flip,mode4,ndepth,neme,minw,           &
            mycall,hiscall,hisgrid,decoded,nfano,deepmsg,qual,ich)
       call timer('decode4 ',1)

       if(nfano.gt.0) then
! Fano succeeded: report the message and return              !Fano OK
          if (associated (this%decode_callback)) then
             call this%decode_callback(nsnr,dtx,nfreq,.true.,csync,      &
                  .false.,decoded,99.,ich,.false.,0)
          end if
!###          nsave=0
          go to 990

       else                                                  !Fano failed
          if(qual.gt.qbest) then
             dtx0=dtx
             nfreq0=nfreq
             deepmsg0=deepmsg
             ich0=ich
             qbest=qual
          endif
       endif

       if(idt.ne.0) cycle
! Single-sequence Fano decode failed, so try for an average Fano decode:
       qave=0.
! If we're doing averaging, call avg4
       if(iand(ndepth,16).eq.16 .and. (.not.prtavg)) then
          if(nutc.ne.nutc0 .or. abs(nfreq-nfreq0).gt.ntol) then
! This is a new minute or a new frequency, so call avg4.
             nutc0=nutc                                   !Try decoding average
             nfreq0=nfreq
             nsave=nsave+1
             nsave=mod(nsave-1,64)+1
             call timer('avg4    ',0)
             call this%avg4(nutc,sync,dtx,flip,nfreq,mode4,ntol,ndepth,neme,  &
                  mycall,hiscall,hisgrid,nfanoave,avemsg,qave,deepave,ich,    &
                  ndeepave)
             call timer('avg4    ',1)
          endif

          if(nfanoave.gt.0) then
! Fano succeeded: report the message                       AVG FANO OK
             if (associated (this%decode_callback)) then
                call this%decode_callback(nsnr,dtx,nfreq,.true.,csync,   &
                     .false.,avemsg,99.,ich,.true.,nfanoave)
             end if
             prtavg=.true.
             cycle
          else
             if(qave.gt.qabest) then
                dtx1=dtx
                nfreq1=nfreq
                deepave1=deepave
                ich1=ich
                qabest=qave
             endif
          endif
       endif
    enddo

    dtx=dtx0
    nfreq=nfreq0
    deepmsg=deepmsg0
    ich=ich0
    qual=qbest

    if (associated (this%decode_callback)) then
       if(int(qual).ge.nq1) then
          call this%decode_callback(nsnr,dtx,nfreqz,.true.,csync,.true., &
               deepmsg,qual,ich,.false.,0)
       else
          call this%decode_callback(nsnr,dtxz,nfreqz,.true.,csync,       &
               .false.,blank,0.,ich,.false.,0)
       endif
    end if

    dtx=dtx1
    nfreq=nfreq1
    deepave=deepave1
    ich=ich1
    qave=qabest

    if (associated (this%decode_callback) .and. ndeepave.ge.2) then
       if(int(qave).ge.nq1) then
          call this%decode_callback(nsnr,dtx,nfreq,.true.,csync,.true.,  &
               deepave,qave,ich,.true.,ndeepave)
       endif
    end if

990 return
  end subroutine wsjt4

  subroutine avg4(this,nutc,snrsync,dtxx,flip,nfreq,mode4,ntol,ndepth,neme,   &
       mycall,hiscall,hisgrid,nfanoave,avemsg,qave,deepave,ichbest,ndeepave)

! Decodes averaged JT4 data

    use jt4
    class(jt4_decoder), intent(inout) :: this

    character*22 avemsg,deepave,deepbest
    character mycall*12,hiscall*12,hisgrid*6
    character*1 csync,cused(64)
    real sym(207,7)
    integer iused(64)
    logical first
    data first/.true./
    save

    if(first) then
       iutc=-1
       nfsave=0
       dtdiff=0.2
       first=.false.
       nsave=1        ! ### Should this be here? ###
    endif

    do i=1,64
       if(nutc.eq.iutc(i) .and. abs(nfreq-nfsave(i)).le.ntol) go to 10
    enddo

! Save data for message averaging
    iutc(nsave)=nutc
    syncsave(nsave)=snrsync
    dtsave(nsave)=dtxx
    nfsave(nsave)=nfreq
    flipsave(nsave)=flip
    ppsave(1:207,1:7,nsave)=rsymbol(1:207,1:7)

10  sym=0.
    syncsum=0.
    dtsum=0.
    nfsum=0
    nsum=0

    do i=1,64
       cused(i)='.'
       if(iutc(i).lt.0) cycle
       if(mod(iutc(i),2).ne.mod(nutc,2)) cycle  !Use only same sequence
       if(abs(dtxx-dtsave(i)).gt.dtdiff) cycle  !DT must match
       if(abs(nfreq-nfsave(i)).gt.ntol) cycle   !Freq must match
       if(flip.ne.flipsave(i)) cycle            !Sync (*/#) must match
       sym(1:207,1:7)=sym(1:207,1:7) +  ppsave(1:207,1:7,i)
       syncsum=syncsum + syncsave(i)
       dtsum=dtsum + dtsave(i)
       nfsum=nfsum + nfsave(i)
       cused(i)='$'
       nsum=nsum+1
       iused(nsum)=i
    enddo
    if(nsum.lt.64) iused(nsum+1)=0

    syncave=0.
    dtave=0.
    fave=0.
    if(nsum.gt.0) then
       sym=sym/nsum
       syncave=syncsum/nsum
       dtave=dtsum/nsum
       fave=float(nfsum)/nsum
    endif

    do i=1,nsave
       csync='*'
       if(flipsave(i).lt.0.0) csync='#'
       if (associated (this%average_callback)) then
          call this%average_callback(cused(i) .eq. '$',iutc(i),               &
               syncsave(i),dtsave(i),nfsave(i),flipsave(i).lt.0.)
       end if
    enddo

    sqt=0.
    sqf=0.
    do j=1,64
       i=iused(j)
       if(i.eq.0) exit
       csync='*'
       if(flipsave(i).lt.0.0) csync='#'
       sqt=sqt + (dtsave(i)-dtave)**2
       sqf=sqf + (nfsave(i)-fave)**2
    enddo
    rmst=0.
    rmsf=0.
    if(nsum.ge.2) then
       rmst=sqrt(sqt/(nsum-1))
       rmsf=sqrt(sqf/(nsum-1))
    endif
    kbest=ich1
    do k=ich1,ich2
       call extract4(sym(1,k),ncount,avemsg)     !Do the Fano decode
       nfanoave=0
       if(ncount.ge.0) then
          ichbest=k
          nfanoave=nsum
          go to 900
       endif
       if(nch(k).ge.mode4) exit
    enddo

    deepave='                      '
    qave=0.

! Possibly should pass nadd=nused, also ?
    if(iand(ndepth,32).eq.32) then
       flipx=1.0                     !Normal flip not relevant for ave msg
       qbest=0.
       do k=ich1,ich2
          call deep4(sym(2,k),neme,flipx,mycall,hiscall,hisgrid,deepave,qave)
          if(qave.gt.qbest) then
             qbest=qave
             deepbest=deepave
             kbest=k
             ndeepave=nsum
          endif
          if(nch(k).ge.mode4) exit
       enddo

       deepave=deepbest
       qave=qbest
       ichbest=kbest
    endif

900 return
  end subroutine avg4
end module jt4_decode

module types
  use, intrinsic :: iso_fortran_env
  implicit none

  ! use the Fortran 2008 intrinsic constants to define real kinds
  integer, parameter :: sp = REAL32
  integer, parameter :: dp = REAL64
  integer, parameter :: qp = REAL128

  type q3list
     character*6 call
     character*4 grid
     integer nsec
     integer nfreq
     integer moonel
  end type q3list

end module types

subroutine getlags(nsps8,lag0,lag1,lag2)
  if(nsps8.eq.864) then
     lag1=39
     lag2=291
     lag0=123
  else if(nsps8.eq.1920) then
     lag1=70
     lag2=184
     lag0=108
  else if(nsps8.eq.5120) then
     lag1=84
     lag2=129
     lag0=99
  else if(nsps8.eq.10368) then
     lag1=91
     lag2=112
     lag0=98
  else if(nsps8.eq.31500) then
     lag1=93
     lag2=102
     lag0=96
  else 
     stop 'Error in getlags'
  endif

  return
end subroutine getlags

subroutine extract(s3,nadd,mode65,ntrials,naggressive,ndepth,nflip,     &
     mycall_12,hiscall_12,hisgrid,nQSOProgress,ljt65apon,               &
     ncount,nhist,decoded,ltext,nft,qual)

! Input:
!   s3       64-point spectra for each of 63 data symbols
!   nadd     number of spectra summed into s3
!   nqd      0/1 to indicate decode attempt at QSO frequency

! Output:
!   ncount   number of symbols requiring correction (-1 for no KV decode)
!   nhist    maximum number of identical symbol values
!   decoded  decoded message (if ncount >=0)
!   ltext    true if decoded message is free text
!   nft      0=no decode; 1=FT decode; 2=hinted decode

  use prog_args                       !shm_key, exe_dir, data_dir
  use packjt
  use jt65_mod
  use timer_module, only: timer

  real s3(64,63)
  character decoded*22, apmessage*22
  character*12 mycall_12,hiscall_12
  character*6 mycall,hiscall,hisgrid
  character*6 mycall0,hiscall0,hisgrid0
  integer apsymbols(7,12),ap(12)
  integer nappasses(0:5)  ! the number of decoding passes to use for each QSO state
  integer naptypes(0:5,4) ! (nQSOProgress, decoding pass)  maximum of 4 passes for now 
  integer dat4(12)
  integer mrsym(63),mr2sym(63),mrprob(63),mr2prob(63)
  integer correct(63),tmp(63)
  logical first,ltext,ljt65apon
  common/chansyms65/correct
  data first/.true./
  save
  
  if(mode65.eq.-99) stop                   !Silence compiler warning
  if(first) then

! aptype
!------------------------
!   1        CQ     ???    ???
!   2        MyCall ???    ???
!   3        MyCall DxCall ???
!   4        MyCall DxCall RRR
!   5        MyCall DxCall 73
!   6        MyCall DxCall DxGrid
!   7        CQ     DxCall DxGrid

     apsymbols=-1
     nappasses=(/3,4,2,3,3,4/)
     naptypes(0,1:4)=(/1,2,6,0/)  ! Tx6
     naptypes(1,1:4)=(/2,3,6,7/)  ! Tx1
     naptypes(2,1:4)=(/2,3,0,0/)  ! Tx2
     naptypes(3,1:4)=(/3,4,5,0/)  ! Tx3
     naptypes(4,1:4)=(/3,4,5,0/)  ! Tx4
     naptypes(5,1:4)=(/2,3,4,5/)  ! Tx5
     first=.false.
  endif

  mycall=mycall_12(1:6)
  hiscall=hiscall_12(1:6)
! Fill apsymbols array
  if(ljt65apon .and.                                             &
     (mycall.ne.mycall0 .or. hiscall.ne.hiscall0 .or. hisgrid.ne.hisgrid0)) then 
!write(*,*) 'initializing apsymbols '
     apsymbols=-1
     mycall0=mycall
     hiscall0=hiscall
     ap=-1
     apsymbols(1,1:4)=(/62,32,32,49/) ! CQ
     if(len_trim(mycall).gt.0) then
        apmessage=mycall//" "//mycall//" RRR" 
        call packmsg(apmessage,ap,itype)
        if(itype.ne.1) ap=-1
        apsymbols(2,1:4)=ap(1:4)
!write(*,*) 'mycall symbols ',ap(1:4)
        if(len_trim(hiscall).gt.0) then
           apmessage=mycall//" "//hiscall//" RRR" 
           call packmsg(apmessage,ap,itype)
           if(itype.ne.1) ap=-1
           apsymbols(3,1:9)=ap(1:9)
           apsymbols(4,:)=ap
           apmessage=mycall//" "//hiscall//" 73" 
           call packmsg(apmessage,ap,itype)
           if(itype.ne.1) ap=-1
           apsymbols(5,:)=ap
           if(len_trim(hisgrid(1:4)).gt.0) then
              apmessage=mycall//' '//hiscall//' '//hisgrid(1:4)
              call packmsg(apmessage,ap,itype)
              if(itype.ne.1) ap=-1
              apsymbols(6,:)=ap
              apmessage='CQ'//' '//hiscall//' '//hisgrid(1:4)
              call packmsg(apmessage,ap,itype)
              if(itype.ne.1) ap=-1
              apsymbols(7,:)=ap
           endif
        endif
     endif
  endif
   
  qual=0.
  nbirdie=20
  npct=50
  afac1=1.1
  nft=0
  nfail=0
  decoded='                      '
  call pctile(s3,4032,npct,base)
  s3=s3/base
  s3a=s3                                            !###

! Get most reliable and second-most-reliable symbol values, and their
! probabilities
1 call demod64a(s3,nadd,afac1,mrsym,mrprob,mr2sym,mr2prob,ntest,nlow)

  call chkhist(mrsym,nhist,ipk)       !Test for birdies and QRM
  if(nhist.ge.nbirdie) then
     nfail=nfail+1
     call pctile(s3,4032,npct,base)
     s3(ipk,1:63)=base
     if(nfail.gt.30) then
        decoded='                      '
        ncount=-1
        go to 900
     endif
     go to 1
  endif

  mrs=mrsym
  mrs2=mr2sym

  call graycode65(mrsym,63,-1)        !Remove gray code 
  call interleave63(mrsym,-1)         !Remove interleaving
  call interleave63(mrprob,-1)

  call graycode65(mr2sym,63,-1)      !Remove gray code and interleaving
  call interleave63(mr2sym,-1)       !from second-most-reliable symbols
  call interleave63(mr2prob,-1)

  npass=1  ! if ap decoding is disabled  
  if(ljt65apon .and. len_trim(mycall).gt.0) then 
     npass=1+nappasses(nQSOProgress)
!write(*,*) 'ap is on: ',npass-1,'ap passes of types ',naptypes(nQSOProgress,:)
  endif
  do ipass=1,npass
     ap=-1
     ntype=0
     if(ipass.gt.1) then
       ntype=naptypes(nQSOProgress,ipass-1)
!write(*,*) 'ap pass, type ',ntype
       ap=apsymbols(ntype,:)
       if(count(ap.ge.0).eq.0) cycle  ! don't bother if all ap symbols are -1
!write(*,'(12i3)') ap
     endif
     ntry=0
     call timer('ftrsd   ',0)
     param=0
     call ftrsdap(mrsym,mrprob,mr2sym,mr2prob,ap,ntrials,correct,param,ntry)
     call timer('ftrsd   ',1)
     ncandidates=param(0)
     nhard=param(1)
     nsoft=param(2)
     nerased=param(3)
     rtt=0.001*param(4)
     ntotal=param(5)
     qual=0.001*param(7)
     nd0=81
     r0=0.87
     if(naggressive.eq.10) then
        nd0=83
        r0=0.90
     endif

     if(ntotal.le.nd0 .and. rtt.le.r0) then
        nft=1+ishft(ntype,2)
     endif 
  
     if(nft.gt.0) exit
  enddo
  if(nft.eq.0 .and. iand(ndepth,32).eq.32) then
     qmin=2.0 - 0.1*naggressive
     call timer('hint65  ',0)
     call hint65(s3,mrs,mrs2,nadd,nflip,mycall,hiscall,hisgrid,qual,decoded)
     if(qual.ge.qmin) then
        nft=2
        ncount=0
     else
        decoded='                      '
        ntry=0
     endif
     call timer('hint65  ',1)
     go to 900
  endif

  ncount=-1
  decoded='                      '
  ltext=.false.
  if(nft.gt.0) then
! Turn the corrected symbol array into channel symbols for subtraction;
! pass it back to jt65a via common block "chansyms65".
     do i=1,12
        dat4(i)=correct(13-i)
     enddo
     do i=1,63
       tmp(i)=correct(64-i)
     enddo
     correct(1:63)=tmp(1:63)
     call interleave63(correct,1)
     call graycode65(correct,63,1)
     call unpackmsg(dat4,decoded)     !Unpack the user message
     ncount=0
     if(iand(dat4(10),8).ne.0) ltext=.true.
  endif
900 continue
  if(nft.eq.1 .and. nhard.lt.0) decoded='                      '

  return
end subroutine extract

subroutine getpp(workdat,p)

  use jt65_mod
  integer workdat(63)
  integer a(63)

  a(1:63)=workdat(63:1:-1)
  call interleave63(a,1)
  call graycode(a,63,1,a)

  psum=0.
  do j=1,63
     i=a(j)+1
     x=s3a(i,j)
     s3a(i,j)=0.
     psum=psum + x
     s3a(i,j)=x
  enddo
  p=psum/63.0

  return
end subroutine getpp

subroutine makepings(pings,nTRperiod,npts,width,sig)

  real pings(npts)
  real*8 t
  real t0(29)

  dt=1.0/12000.0
  do i=1,nTRperiod-1
     t0(i)=i                            !Make pings at t=1, 2, ... 14 s.
  enddo
  amp=sig

  do i=1,npts
     iping=min(max(1,i/12000),nTRperiod-1)
     t=(i*dt-t0(iping))/width
     if(t.lt.0.d0 .or. t.gt.10.0) then
        fac=0.
     else
        fac=2.718*t*dexp(-t)
     endif
     pings(i)=fac*amp
  enddo

  return
end subroutine makepings

module moon2_mod
  use iso_fortran_env, only: real64
  implicit none
contains
  subroutine moon2(y,m,Day,UT,lon,lat,RA,Dec,topRA,topDec,LST,HA,Az,El,dist)
  
    use dcoord_mod
    implicit none
  
    integer, intent(in) :: y                           !Year
    integer, intent(in) :: m                           !Month
    integer, intent(in) :: Day                         !Day
    real(real64), intent(in) :: UT                           !UTC in hours
    real(real64), intent(out) :: RA,Dec                       !RA and Dec of moon
    real(real64), intent(in) :: lat,lon                      !Station coordinates on earth
    real(real64), intent(out) :: topRA,topDec                 !Topocentric coordinates of Moon
    real(real64), intent(out) :: LST,HA
    real(real64), intent(out) :: Az,El
    real(real64), intent(out) :: dist
  
  ! NB: Double caps are single caps in the writeup.
  
    real(real64) NN                           !Longitude of ascending node
    real(real64) i                            !Inclination to the ecliptic
    real(real64) w                            !Argument of perigee
    real(real64) a                            !Semi-major axis
    real(real64) e                            !Eccentricity
    real(real64) MM                           !Mean anomaly
  
    real(real64) v                            !True anomaly
    real(real64) EE                           !Eccentric anomaly
    real(real64) ecl                          !Obliquity of the ecliptic
  
    real(real64) d                            !Ephemeris time argument in days
    real(real64) r                            !Distance to sun, AU
    real(real64) xv,yv                        !x and y coords in ecliptic
    real(real64) lonecl,latecl                !Ecliptic long and lat of moon
    real(real64) xg,yg,zg                     !Ecliptic rectangular coords
    real(real64) Ms                           !Mean anomaly of sun
    real(real64) ws                           !Argument of perihelion of sun
    real(real64) Ls                           !Mean longitude of sun (Ns=0)
    real(real64) Lm                           !Mean longitude of moon
    real(real64) DD                           !Mean elongation of moon
    real(real64) FF                           !Argument of latitude for moon
    real(real64) xe,ye,ze                     !Equatorial geocentric coords of moon
    real(real64) mpar                         !Parallax of moon (r_E / d)
    real(real64) gclat                        !Geocentric latitude
    real(real64) rho                          !Earth radius factor
    real(real64) GMST0
    real(real64) g
  
    real(real64) rad,twopi,pi,pio2
    data rad/57.2957795131d0/,twopi/6.283185307d0/
  
    d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + Day - 730530 + UT/24.d0
    ecl = 23.4393d0 - 3.563d-7 * d
  
  ! Orbital elements for Moon:  
    NN = 125.1228d0 - 0.0529538083d0 * d
    i = 5.1454d0
    w = mod(318.0634d0 + 0.1643573223d0 * d + 360000.d0,360.d0)
    a = 60.2666d0
    e = 0.054900d0
    MM = mod(115.3654d0 + 13.0649929509d0 * d + 360000.d0,360.d0)
  
    EE = MM + e*rad*sin(MM/rad) * (1.d0 + e*cos(MM/rad))
    EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.d0 - e*cos(EE/rad))
    EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.d0 - e*cos(EE/rad))
  
    xv = a * (cos(EE/rad) - e)
    yv = a * (sqrt(1.d0-e*e) * sin(EE/rad))
  
    v = mod(rad*atan2(yv,xv)+720.d0,360.d0)
    r = sqrt(xv*xv + yv*yv)
  
  ! Get geocentric position in ecliptic rectangular coordinates:
  
    xg = r * (cos(NN/rad)*cos((v+w)/rad)-sin(NN/rad)*sin((v+w)/rad)*cos(i/rad))
    yg = r * (sin(NN/rad)*cos((v+w)/rad)+cos(NN/rad)*sin((v+w)/rad)*cos(i/rad))
    zg = r * (sin((v+w)/rad)*sin(i/rad))
  
  ! Ecliptic longitude and latitude of moon:
    lonecl = mod(rad*atan2(yg/rad,xg/rad)+720.d0,360.d0)
    latecl = rad*atan2(zg/rad,sqrt(xg*xg + yg*yg)/rad)
  
  ! Now include orbital perturbations:
    Ms = mod(356.0470d0 + 0.9856002585d0 * d + 3600000.d0,360.d0)
    ws = 282.9404d0 + 4.70935d-5*d
    Ls = mod(Ms + ws + 720.d0,360.d0)
    Lm = mod(MM + w + NN+720.d0,360.d0)
    DD = mod(Lm - Ls + 360.d0,360.d0)
    FF = mod(Lm - NN + 360.d0,360.d0)
  
    lonecl = lonecl                                &
         - 1.274d0 * sin((MM-2.d0*DD)/rad)         &
         + 0.658d0 * sin(2.d0*DD/rad)              &
         - 0.186d0 * sin(Ms/rad)                   &
         - 0.059d0 * sin((2.d0*MM-2.d0*DD)/rad)    &
         - 0.057d0 * sin((MM-2.d0*DD+Ms)/rad)      &
         + 0.053d0 * sin((MM+2.d0*DD)/rad)         &
         + 0.046d0 * sin((2.d0*DD-Ms)/rad)         &
         + 0.041d0 * sin((MM-Ms)/rad)              &
         - 0.035d0 * sin(DD/rad)                   &
         - 0.031d0 * sin((MM+Ms)/rad)              &
         - 0.015d0 * sin((2.d0*FF-2.d0*DD)/rad)    &
         + 0.011d0 * sin((MM-4.d0*DD)/rad)
  
    latecl = latecl                                &
         - 0.173d0 * sin((FF-2.d0*DD)/rad)         &
         - 0.055d0 * sin((MM-FF-2.d0*DD)/rad)      &
         - 0.046d0 * sin((MM+FF-2.d0*DD)/rad)      &
         + 0.033d0 * sin((FF+2.d0*DD)/rad)         &
         + 0.017d0 * sin((2.d0*MM+FF)/rad)
  
    r = 60.36298d0                                 &
         - 3.27746d0*cos(MM/rad)                   &
         - 0.57994d0*cos((MM-2.d0*DD)/rad)         &
         - 0.46357d0*cos(2.d0*DD/rad)              &
         - 0.08904d0*cos(2.d0*MM/rad)              &
         + 0.03865d0*cos((2.d0*MM-2.d0*DD)/rad)    &
         - 0.03237d0*cos((2.d0*DD-Ms)/rad)         &
         - 0.02688d0*cos((MM+2.d0*DD)/rad)         &
         - 0.02358d0*cos((MM-2.d0*DD+Ms)/rad)      &
         - 0.02030d0*cos((MM-Ms)/rad)              &
         + 0.01719d0*cos(DD/rad)                   &
         + 0.01671d0*cos((MM+Ms)/rad)
    
    dist=r*6378.140d0
  
  ! Geocentric coordinates:
  ! Rectangular ecliptic coordinates of the moon:
  
    xg = r * cos(lonecl/rad)*cos(latecl/rad)
    yg = r * sin(lonecl/rad)*cos(latecl/rad)
    zg = r *                 sin(latecl/rad)
  
  ! Rectangular equatorial coordinates of the moon:
    xe = xg
    ye = yg*cos(ecl/rad) - zg*sin(ecl/rad)
    ze = yg*sin(ecl/rad) + zg*cos(ecl/rad)
     
  ! Right Ascension, Declination:
    RA = mod(rad*atan2(ye,xe)+360.d0,360.d0)
    Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))
  
  ! Now convert to topocentric system:
    mpar=rad*asin(1.d0/r)
  !     alt_topoc = alt_geoc - mpar*cos(alt_geoc)
    gclat = lat - 0.1924d0*sin(2.d0*lat/rad)
    rho = 0.99883d0 + 0.00167d0*cos(2.d0*lat/rad)
    GMST0 = (Ls + 180.d0)/15.d0
    LST = mod(GMST0+UT+lon/15.d0+48.d0,24.d0)    !LST in hours
    HA = 15.d0*LST - RA                          !HA in degrees
    g = rad*atan(tan(gclat/rad)/cos(HA/rad))
    topRA = RA - mpar*rho*cos(gclat/rad)*sin(HA/rad)/cos(Dec/rad)
    topDec = Dec - mpar*rho*sin(gclat/rad)*sin((g-Dec)/rad)/sin(g/rad)
  
    HA = 15.d0*LST - topRA                       !HA in degrees
    if(HA.gt.180.d0) HA=HA-360.d0
    if(HA.lt.-180.d0) HA=HA+360.d0
  
    pi=0.5d0*twopi
    pio2=0.5d0*pi
    call dcoord(pi,pio2-lat/rad,0.d0,lat/rad,ha*twopi/360,topDec/rad,az,el)
    Az=az*rad
    El=El*rad
  
  end subroutine moon2
end module moon2_mod

module astro_module
  implicit none

  private
  public :: astrosub

  logical :: initialized = .false.
  integer :: azel_extra_lines = 0

contains

  subroutine astrosub(nyear,month,nday,uth8,freq8,mygrid_cp,                    &
       hisgrid_cp,AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,              &
       ntsky,ndop,ndop00,RAMoon8,DecMoon8,Dgrd8,poloffset8,xnr8,techo8,width1,  &
       width2,bTx,AzElFileName_cp,jpleph_file_name_cp)                          &
       bind (C, name="astrosub")

    use :: types, only: dp
    use :: C_interface_module, only: C_int, C_double, C_bool, C_ptr, C_string_value, assignment(=)

    integer(C_int), intent(in), value :: nyear, month, nday
    real(C_double), intent(in), value :: uth8, freq8
    real(C_double), intent(out) :: AzSun8, ElSun8, AzMoon8, ElMoon8, AzMoonB8,  &
         ElMoonB8, Ramoon8, DecMoon8, Dgrd8, poloffset8, xnr8, techo8, width1,  &
         width2
    integer(C_int), intent(out) :: ntsky, ndop, ndop00
    logical(C_bool), intent(in), value :: bTx
    type(C_ptr), value, intent(in) :: mygrid_cp, hisgrid_cp, AzElFileName_cp,   &
         jpleph_file_name_cp

    character(len=6) :: mygrid, hisgrid
    character(len=:), allocatable :: AzElFileName
    character(len=1) :: c1
    character(len=32) :: envvar
    integer :: ih, im, imin, is, isec, nfreq, env_status
    real(dp) :: AzAux, ElAux, dbMoon8, dfdt, dfdt0, doppler, doppler00, HA8, sd8, xlst8
    character*256 jpleph_file_name
    common/jplcom/jpleph_file_name

    if (.not.initialized) then
       call get_environment_variable ('WSJT_AZEL_EXTRA_LINES', envvar, status=env_status)
       if (env_status.eq.0) read (envvar, *, iostat=env_status) azel_extra_lines
       initialized = .true.
    end if

    mygrid = mygrid_cp
    hisgrid = hisgrid_cp
    AzElFileName = C_string_value (AzElFileName_cp)
    jpleph_file_name = jpleph_file_name_cp

    call astro0(nyear,month,nday,uth8,freq8,mygrid,hisgrid,                &
         AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
         dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,  &
         width1,width2,xlst8,techo8)

    if (len_trim(AzElFileName) .eq. 0) go to 999
    if(len(trim(hisgrid)).eq.0) then  !If DX grid is blank, set these to zero:
       AzMoonB8=0
       ElMoonB8=0
       ndop=0
       width2=0
    endif
    imin=60*uth8
    isec=3600*uth8
    ih=uth8
    im=mod(imin,60)
    is=mod(isec,60)
    open(15,file=AzElFileName,status='unknown',err=900)
    c1='R'
    if(bTx) then
       c1='T'
    endif
    AzAux=0.
    ElAux=0.
    nfreq=freq8/1000000
    doppler=ndop
    doppler00=ndop00
    write(15,1010,err=10) ih,im,is,AzMoon8,ElMoon8,                     &
         ih,im,is,AzSun8,ElSun8,                                        &
         ih,im,is,AzAux,ElAux,                                          &
         nfreq,doppler,dfdt,doppler00,dfdt0,c1
    if (azel_extra_lines.ge.1) write(15, 1020, err=10) poloffset8,      &
         xnr8,Dgrd8,width1,width2
1010 format(                                                          &
         i2.2,':',i2.2,':',i2.2,',',f5.1,',',f5.1,',Moon'/               &
         i2.2,':',i2.2,':',i2.2,',',f5.1,',',f5.1,',Sun'/                &
         i2.2,':',i2.2,':',i2.2,',',f5.1,',',f5.1,',Source'/             &
         i5,',',f8.1,',',f8.2,',',f8.1,',',f8.2,',Doppler, ',a1)
1020 format(f8.1,',',f8.1,',',f8.1,',',f8.1,',',f8.1,',Pol')
10  close(15)
    go to 999

900 print*,'Error opening azel.dat'

999 return
  end subroutine astrosub

end module astro_module

subroutine wspr_wav(baud,xdt,h,f0,itone,snrdb,iwave)

! Generate iwave() from itone().
  
  include 'wspr_params.f90'
  integer itone(NN)
  integer*2 iwave(NMAX)
  real*8 twopi,dt,dphi0,dphi1,dphi,phi
  real dat(NMAX)

  twopi=8.d0*atan(1.d0)
  dt=1.d0/12000.d0
  baud=375.0/256.0

  dat=0.
  if(snrdb.lt.90) then
     do i=1,NMAX
        dat(i)=gran()          !Generate gaussian noise
     enddo
     bandwidth_ratio=2500.0/6000.0
     sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*snrdb)
  else
     sig=1.0
  endif

  phi=0.d0
  k=nint(xdt/dt)
  do j=1,NN
     dphi=twopi*(f0+h*(itone(j)-1.5)*baud)*dt
     do i=1,NSPS0
        k=k+1
        phi=mod(phi+dphi,twopi)
        if(k.gt.0 .and. k.le.NMAX) dat(k)=dat(k) + sig*sin(phi)
     enddo
  enddo

  rms=100.0
  if(snrdb.lt.90.0) then
    dat=rms*dat;
    if(maxval(abs(dat)).gt.32767.0) print*,"Warning - data will be clipped."
  else
    datpk=maxval(abs(dat))
    fac=32767.0/datpk
    dat=fac*dat
  endif
  iwave=nint(dat)

  return
end subroutine wspr_wav

subroutine twkfreq1var(ca,nbot,npts,ntop,fsample,a,cb)

  use ft8_mod1, only : twopi
  complex, intent(in) :: ca(nbot:ntop)
  complex, intent(out) :: cb(nbot:ntop)
  complex w,wstep
  real a(5)

! Mix the complex signal
  w=1.0; wstep=1.0
!!  x0=0.5*(npts+1)
!!  s=2.0/npts
  do i=0,npts
!!     x=s*(i-x0) ! valid for 'do i=1,npts'
!!     p2=1.5*x*x - 0.5
!!     p3=2.5*(x**3) - 1.5*x
!!     p4=4.375*(x**4) - 3.75*(x**2) + 0.375
!!     dphi=(a(1) + x*a(2) + p2*a(3) + p3*a(4) + p4*a(5)) * (twopi/fsample)
     dphi=a(1) * (twopi/fsample)
     wstep=cmplx(cos(dphi),sin(dphi))
     w=w*wstep
     cb(i)=w*ca(i)
  enddo

  return
end subroutine twkfreq1var

module gen_q65_cwave_mod
  implicit none
contains

subroutine gen_q65_cwave(msg,ntxfreq,ntone_spacing,msgsent,cwave,nwave)

  use packjt
  use q65_encoding
  use iso_fortran_env, only: real64

  integer, parameter :: NMAX = 60*96000

  !--------------------------------------------------------------------
  ! Arguments (with correct intent and explicit types)
  !--------------------------------------------------------------------
  character*24, intent(in)  :: msg
  integer,      intent(in)  :: ntxfreq
  integer,      intent(in)  :: ntone_spacing
  character*24, intent(out) :: msgsent
  complex,      intent(out) :: cwave(NMAX)
  integer,      intent(out) :: nwave

  !--------------------------------------------------------------------
  ! Local character variables
  !--------------------------------------------------------------------
  character*37 :: msg37

  !--------------------------------------------------------------------
  ! Explicit declarations for all formerly implicit variables
  !--------------------------------------------------------------------
  ! Implicit REAL(4) variables (A–H, O–Z)
  real(real64) :: t, dt, phi, f, f0, dfgen, dphi, twopi, tsym, xphi

  ! Implicit INTEGER variables (I–N)
  integer :: i, j, j0, nsym

  ! Explicit locals
  integer :: codeword(65), itone(85)
  integer :: icos7(0:6)

  data icos7 /2,5,6,0,4,1,3/
  data twopi /6.283185307179586476d0/
  save

  !--------------------------------------------------------------------
  ! Begin logic (unchanged from legacy)
  !--------------------------------------------------------------------
  msgsent = msg
  msg37 = ''
  msg37(1:24) = msg

  call get_q65_tones(msg37, codeword, itone)

  ! Constants
  nsym = 85
  tsym = 7200.d0 / 12000.d0
  dt   = 1.d0 / 96000.d0
  f0   = ntxfreq
  dfgen = ntone_spacing * 12000.d0 / 7200.d0

  phi = 0.d0
  dphi = twopi * dt * f0

  nwave = 85 * 7200 * 96000.d0 / 12000.d0

  t = 0.d0
  j0 = 0

  do i = 1, nwave
     t = t + dt
     j = t/tsym + 1
     if (j > 85) exit

     if (j /= j0) then
        f = f0 + itone(j) * dfgen
        dphi = twopi * dt * f
        j0 = j
     endif

     phi = phi + dphi
     if (phi > twopi) phi = phi - twopi

     xphi = phi
     cwave(i) = cmplx(cos(xphi), -sin(xphi))
  enddo

end subroutine gen_q65_cwave

end module gen_q65_cwave_mod

subroutine extractmessage77(decoded77,msgreceived)
  use packjt

  character*22 msgreceived
  character*77 cbits
  integer*1 decoded77(77)
  integer*4 i4Dec6BitWords(12)

  write(cbits,'(77i1)') decoded77
!**** Temporary: For now, just handle i5bit=0.
  read(cbits,'(12b6)') i4Dec6BitWords 
  read(cbits,'(72x,i5.5)') i5bit
  if( i5bit .eq. 0 ) then
    call unpackmsg(i4Dec6BitWords,msgreceived)
  endif
  return
end subroutine extractmessage77

program chkdec

  parameter(NMAX=100)
  character*88 line
  character*37 msg(NMAX),msg0,msg1
  character*2 c2(NMAX)
  character*1 c1(NMAX)
  character*1 only
  integer nsnr(NMAX,0:1),nf(NMAX,0:1)
  real dt(NMAX,0:1)
  logical found,eof

! These files are sorted by freq within each Rx sequence
  open(10,file='all.wsjtx',status='old')
  open(11,file='all.jtdx',status='old')
  write(20,1030)
1030 format('  iseq    B   w   j   W  W+   J   E       B     w     j     W',  &
          '    W+     J     E'/80('-'))

  nutc0=-1
  nbt=0        !Both
  nwt=0        !WSJT-X only
  njt=0        !JTDX only
  net=0        !Either
  n7t=0        !a7
  eof=.false.
  
  do iseq=1,9999
     j=0
     msg=' '
     nsnr=-99
     nf=-99
     dt=-99
     c1=' '
     c2=' '
     do i=1,NMAX
        read(10,'(a88)',end=8) line           !Read from the WSJT-X file
        if(line(25:30).ne.'Rx FT8') cycle     !Ignore any line not an FT8 decode
        read(line(8:13),*) nutc
        if(nutc0.lt.0) nutc0=nutc             !First time only
        if(nutc.ne.nutc0) then
           backspace(10)
           go to 10                            !Finished WSJT-X for this sequence
        endif
        j=j+1
        if(j.eq.1) then
           nf(j,0)=-1
           j=j+1
        endif
        read(line,1001) nsnr(j,0),dt(j,0),nf(j,0),msg(j),c2(j)
1001    format(30x,i7,f5.1,i5,1x,a36,2x,a2)
!        if(nutc.eq.180215 .and. c2(j).eq.'a7') print*,'aaa',j,nf(j,0),c2(j)
        nutc0=nutc
     enddo  ! i
     
8    eof=.true.
10   jz=j
     do i=1,NMAX
        read(11,'(a88)',end=20) line           !Read from the JTDX file
        if(line(31:31).ne.'~') cycle           !Ignore any line not an FT8 decode
        read(line(10:15),*) nutc
        if(nutc.ne.nutc0) then
           backspace(11)
           go to 20                            !Finished JTDX for this sequence
        endif
        msg1=line(33:58)
        read(line(25:29),*) nf1
        found=.false.
        do j=1,jz
           if(msg(j).eq.msg1) then
              read(line,1002) nsnr(j,1),dt(j,1),nf(j,1),c1(j)
1002          format(15x,i4,f5.1,i5,29x,a1)
              found=.true.
              exit
           endif
           i1=index(msg(j),'<')
           if(i1.gt.0) then
              i2=index(msg(j),'>')
              msg0=msg(j)(1:i1-1)//msg(j)(i1+1:i2-1)//msg(j)(i2+1:)
              if(msg0.eq.msg1) then
                 read(line,1002) nsnr(j,1),dt(j,1),nf(j,1),c1(j)
                 found=.true.
                 exit
              endif
           endif
        enddo  ! j

        if(.not.found) then                    !Insert this one as a new message
           do j=1,jz
              if(nf1.ge.nf(j,0) .and. nf1.lt.nf(j+1,0)) then
                 jj=j+1
                 exit
              endif
           enddo
           do j=jz+1,jj+1,-1
              nsnr(j,0)=nsnr(j-1,0)
              dt(j,0)=dt(j-1,0)
              nf(j,0)=nf(j-1,0)
              msg(j)=msg(j-1)
              c1(j)=c1(j-1)
              c2(j)=c2(j-1)
           enddo  ! j
           read(line,1004) nsnr(jj,1),dt(jj,1),nf(jj,1),msg(jj),c1(jj)
1004       format(15x,i4,f5.1,i5,3x,a26,a1)
           c2(jj)='  '
           nsnr(jj,0)=-99
           dt(jj,0)=-99.0
           nf(jj,0)=-99
           jz=jz+1
        endif
     enddo  ! i

20   nb=0
     nw=0
     nj=0
     ne=0
     n7=0
     do j=2,jz
        write(line,1020) nutc0,j,nsnr(j,:),dt(j,:),nf(j,:),msg(j)(1:26),   &
             c2(j),c1(j)
1020    format(i6.6,i3,1x,2i4,1x,2f6.1,1x,2i5,1x,a26,1x,a2,1x,a1)
        if(c2(j).eq.'a7') n7=n7+1
        only=' '
        if(line(12:14).eq.'-99') then
           line(12:14)='   '
           only='j'
           nj=nj+1
!           if(c2(j).eq.'a7') print*,'aaa ',trim(line)
        endif
        if(line(16:18).eq.'-99') then
           line(16:18)='   '
           only='w'
           nw=nw+1
        endif
        if(line(12:14).ne.'   ' .or. line(16:19).ne.'   ') ne=ne+1
        if(line(12:14).ne.'   ' .and. line(16:19).ne.'   ') nb=nb+1
        if(line(21:25).eq.'-99.0') line(21:25)='     '
        if(line(27:31).eq.'-99.0') line(27:31)='     '
        if(line(35:37).eq.'-99') line(35:37)='   '
        if(line(40:42).eq.'-99') line(40:42)='   '
!        if(line(12:14).ne.'   ') nw=nw+1
!        if(line(16:18).ne.'   ') nj=nj+1
        write(*,'(a74,1x,a1)') line(1:74),only
     enddo  ! j

     nbt=nbt+nb
     nwt=nwt+nw
     n7t=n7t+n7
     njt=njt+nj
     net=net+ne
     nutc0=nutc
     write(*,*)

     write(20,1031) iseq,nb,nw,nj,nb+nw-n7,nb+nw,nb+nj,ne,nbt,nwt,njt,   &
          nbt+nwt-n7t,nbt+nwt,nbt+njt,net
1031 format(i5,2x,7i4,2x,7i6)
     if(eof) exit
!     if(iseq.eq.2) exit
  enddo  ! iseq

end program chkdec

!     FILE: c_interface_module.f90
!     PURPOSE: Supplement ISO-C-Binding to provide type aliases and interfaces
!     to common ISO-C string functions to aid working with strings.
!     AUTHOR: Joseph M. Krahn
!     STATUS: Still in development. Reasonably complete, but somewhat limited testing.
!
!     The idea is to provide type aliases for all ISO-C types, so that the
!     Fortran interface code more explicitly defines the actual C interface.
!     This should be updated to support F2008 variable-length allocatable
!     strings.
!
!     Entity names all have the "C_" prefix, as with ISO-C-Binding, with a
!     few exceptions.
!
!     Sourced from: http://fortranwiki.org/fortran/show/c_interface_module
!
!     One FORALL statement reverted to a DO loop to avoid a gfortran 4.9.2 ICE
!
module C_interface_module
  use, intrinsic :: ISO_C_Binding, &
                                !     C type aliases for pointer derived types:
       C_ptr => C_ptr , &
       C_char_ptr => C_ptr, &
       C_const_char_ptr => C_ptr, &
       C_void_ptr => C_ptr, &
       C_const_void_ptr => C_ptr

  implicit none
  public

  !----------------------------------------------------------------------------
  !     C type aliases for intrinsic type KIND parameters:

  !     NOTE: a C enum may not always be a standard C int
  integer, parameter :: C_enum = C_int

  !     Defining off_t is difficult, because it may depend on "LARGEFILE" selection.
  !     integer, parameter :: C_off_t = ??

  !     C string terminator alais using the 3-letter ASCII name.
  !     The C_ prefix is not used because it is just an ASCII character.
  character(len=1,kind=C_char), parameter :: NUL = C_NULL_char

  !     NOTE: In C, "char" is distinct from "signed char", unlike integers.
  !     The plain "char" type is specific for text/string values, whereas
  !     "signed char" should indicate 1-byte integer data.
  !
  !     Most ISO-C systems have wide chars "wchar_t", but Fortran compilers
  !     have limited support for different character kinds. UTF encoding
  !     adds more complexity. This should be updated as Fortran compilers
  !     include support for more character types.
  !

  !     Fortran does not (yet) support unsigned types.
  integer, parameter :: &
       C_unsigned = C_int, &
       C_unsigned_short = C_short, &
       C_unsigned_long = C_long, &
       C_unsigned_long_long = C_long_long, &
       C_unsigned_char = C_signed_char, &
       C_ssize_t = C_size_t, &
       C_uint8_t = C_int8_t, &
       C_uint16_t = C_int16_t, &
       C_uint32_t = C_int32_t, &
       C_uint64_t = C_int64_t, &
       C_uint_least8_t = C_int_least8_t, &
       C_uint_least16_t = C_int_least16_t, &
       C_uint_least32_t = C_int_least32_t, &
       C_uint_least64_t = C_int_least64_t, &
       C_uint_fast8_t = C_int_fast8_t, &
       C_uint_fast16_t = C_int_fast16_t, &
       C_uint_fast32_t = C_int_fast32_t, &
       C_uint_fast64_t = C_int_fast64_t, &
       C_uintmax_t = C_intmax_t
  !     Note: ptrdiff_t cannot be reliably defined from other types.
  !     When practical, it is larger than a pointer because it benefits
  !     from the full unsigned range in both positive and negative directions.

  !     Integer versions including 'int', where the 'int' is optional:
  integer, parameter :: &
       C_short_int = C_short, &
       C_long_int = C_long, &
       C_long_long_int = C_long_long, &
       C_unsigned_int = C_unsigned, &
       C_unsigned_short_int = C_short, &
       C_unsigned_long_int = C_long, &
       C_unsigned_long_long_int = C_long_long

  interface C_F_string
     module procedure C_F_string_ptr
     module procedure C_F_string_chars
  end interface C_F_string

  interface F_C_string
     module procedure F_C_string_ptr
     module procedure F_C_string_chars
  end interface F_C_string

  !=======================================================================
  !     Some useful ISO C library string functions from <string.h>
  !     These are based on GCC header sections marked as NAMESPACE_STD
  interface

     !     Copy N bytes of SRC to DEST, no aliasing or overlapping allowed.
     !     extern void *memcpy (void *dest, const void *src, size_t n);
     function C_memcpy(dest, src, n) result(result) bind(C,name="memcpy")
       import C_void_ptr, C_size_t
       type(C_void_ptr) :: result
       type(C_void_ptr), value, intent(in) :: dest ! target=intent(out)
       type(C_void_ptr), value, intent(in) :: src ! target=intent(in)
       integer(C_size_t), value, intent(in) :: n
     end function C_memcpy

     ! Copy N bytes of SRC to DEST, guaranteeing correct behavior for overlapping strings.
     !extern void *memmove (void *dest, const void *src, size_t n)
     function C_memmove(dest, src, n) result(result) bind(C,name="memmove")
       import C_void_ptr, C_size_t
       type(C_void_ptr) :: result
       type(C_void_ptr), value, intent(in) :: dest ! target=intent(out)
       type(C_void_ptr), value, intent(in) :: src
       integer(C_size_t), value, intent(in) :: n
     end function C_memmove

     ! Set N bytes of S to C.
     !extern void *memset (void *s, int c, size_t n)
     function C_memset(s, c, n) result(result) bind(C,name="memset")
       import C_void_ptr, C_int, C_size_t
       type(C_void_ptr) :: result
       type(C_void_ptr), value, intent(in) :: s ! target=intent(out)
       integer(C_int), value, intent(in) :: c
       integer(C_size_t), value, intent(in) :: n
     end function C_memset

     ! Compare N bytes of S1 and S2.
     !extern int memcmp (const void *s1, const void *s2, size_t n)
     pure function C_memcmp(s1, s2, n) result(result) bind(C,name="memcmp")
       import C_int, C_void_ptr, C_size_t
       integer(C_int) :: result
       type(C_void_ptr), value, intent(in) :: s1
       type(C_void_ptr), value, intent(in) :: s2
       integer(C_size_t), value, intent(in) :: n
     end function C_memcmp

     ! Search N bytes of S for C.
     !extern void *memchr (const void *s, int c, size_t n)
     pure function C_memchr(s, c, n) result(result) bind(C,name="memchr")
       import C_void_ptr, C_int, C_size_t
       type(C_void_ptr) :: result
       type(C_void_ptr), value, intent(in) :: s
       integer(C_int), value, intent(in) :: c
       integer(C_size_t), value, intent(in) :: n
     end function C_memchr

     ! Copy SRC to DEST.
     !extern char *strcpy (char *dest, const char *src)
     function C_strcpy(dest, src) result(result) bind(C,name="strcpy")
       import C_char_ptr, C_size_t
       type(C_char_ptr) :: result
       type(C_char_ptr), value, intent(in) :: dest ! target=intent(out)
       type(C_char_ptr), value, intent(in) :: src
     end function C_strcpy

     ! Copy no more than N characters of SRC to DEST.
     !extern char *strncpy (char *dest, const char *src, size_t n)
     function C_strncpy(dest, src, n) result(result) bind(C,name="strncpy")
       import C_char_ptr, C_size_t
       type(C_char_ptr) :: result
       type(C_char_ptr), value, intent(in) :: dest ! target=intent(out)
       type(C_char_ptr), value, intent(in) :: src
       integer(C_size_t), value, intent(in) :: n
     end function C_strncpy

     ! Append SRC onto DEST.
     !extern char *strcat (char *dest, const char *src)
     function C_strcat(dest, src) result(result) bind(C,name="strcat")
       import C_char_ptr, C_size_t
       type(C_char_ptr) :: result
       type(C_char_ptr), value, intent(in) :: dest ! target=intent(out)
       type(C_char_ptr), value, intent(in) :: src
     end function C_strcat

     ! Append no more than N characters from SRC onto DEST.
     !extern char *strncat (char *dest, const char *src, size_t n)
     function C_strncat(dest, src, n) result(result) bind(C,name="strncat")
       import C_char_ptr, C_size_t
       type(C_char_ptr) :: result
       type(C_char_ptr), value, intent(in) :: dest ! target=intent(out)
       type(C_char_ptr), value, intent(in) :: src
       integer(C_size_t), value, intent(in) :: n
     end function C_strncat

     ! Compare S1 and S2.
     !extern int strcmp (const char *s1, const char *s2)
     pure function C_strcmp(s1, s2) result(result) bind(C,name="strcmp")
       import C_int, C_char_ptr, C_size_t
       integer(C_int) :: result
       type(C_char_ptr), value, intent(in) :: s1
       type(C_char_ptr), value, intent(in) :: s2
     end function C_strcmp

     ! Compare N characters of S1 and S2.
     !extern int strncmp (const char *s1, const char *s2, size_t n)
     pure function C_strncmp(s1, s2, n) result(result) bind(C,name="strncmp")
       import C_int, C_char_ptr, C_size_t
       integer(C_int) :: result
       type(C_char_ptr), value, intent(in) :: s1
       type(C_char_ptr), value, intent(in) :: s2
       integer(C_size_t), value, intent(in) :: n
     end function C_strncmp

     ! Return the length of S.
     !extern size_t strlen (const char *s)
     pure function C_strlen(s) result(result) bind(C,name="strlen")
       import C_char_ptr, C_size_t
       integer(C_size_t) :: result
       type(C_char_ptr), value, intent(in) :: s  !character(len=*), intent(in)
     end function C_strlen

  end interface

  ! End of <string.h>
  !=========================================================================
  ! Standard ISO-C malloc routines:
  interface

     ! void *calloc(size_t nmemb, size_t size);
     type(C_void_ptr) function C_calloc(nmemb, size) bind(C,name="calloc")
       import C_void_ptr, C_size_t
       integer(C_size_t), value, intent(in) :: nmemb, size
     end function C_calloc

     ! void *malloc(size_t size);
     type(C_void_ptr) function C_malloc(size) bind(C,name="malloc")
       import C_void_ptr, C_size_t
       integer(C_size_t), value, intent(in) :: size
     end function C_malloc

     ! void free(void *ptr);
     subroutine C_free(ptr) bind(C,name="free")
       import C_void_ptr
       type(C_void_ptr), value, intent(in) :: ptr
     end subroutine C_free

     ! void *realloc(void *ptr, size_t size);
     type(C_void_ptr) function C_realloc(ptr,size) bind(C,name="realloc")
       import C_void_ptr, C_size_t
       type(C_void_ptr), value, intent(in) :: ptr
       integer(C_size_t), value, intent(in) :: size
     end function C_realloc

  end interface

  interface assignment(=)
     module procedure F_string_assign_C_string
  end interface assignment(=)

  !==========================================================================

contains

  ! HACK: For some reason, C_associated was not defined as pure.
  pure logical function C_associated_pure(ptr) result(associated)
    type(C_ptr), intent(in) :: ptr
    integer(C_intptr_t) :: iptr
    iptr = transfer(ptr,iptr)
    associated = (iptr /= 0)
  end function C_associated_pure

  ! Set a fixed-length Fortran string to the value of a C string.
  subroutine F_string_assign_C_string(F_string, C_string)
    character(len=*), intent(out) :: F_string
    type(C_ptr), intent(in) :: C_string
    character(len=1,kind=C_char), pointer :: p_chars(:)
    integer :: i
    if (.not. C_associated(C_string) ) then
       F_string = ' '
    else
       call C_F_pointer(C_string,p_chars,[huge(0)])
       i=1
       do while(p_chars(i)/=NUL .and. i<=len(F_string))
          F_string(i:i) = p_chars(i)
          i=i+1
       end do
       if (i<len(F_string)) F_string(i:) = ' '
    end if
  end subroutine F_string_assign_C_string

  ! Copy a C string, passed by pointer, to a Fortran string.
  ! If the C pointer is NULL, the Fortran string is blanked.
  ! C_string must be NUL terminated, or at least as long as F_string.
  ! If C_string is longer, it is truncated. Otherwise, F_string is
  ! blank-padded at the end.
  subroutine C_F_string_ptr(C_string, F_string)
    type(C_ptr), intent(in) :: C_string
    character(len=*), intent(out) :: F_string
    character(len=1,kind=C_char), dimension(:), pointer :: p_chars
    integer :: i
    if (.not. C_associated(C_string)) then
       F_string = ' '
    else
       call C_F_pointer(C_string,p_chars,[huge(0)])
       i=1
       do while(p_chars(i)/=NUL .and. i<=len(F_string))
          F_string(i:i) = p_chars(i)
          i=i+1
       end do
       if (i<len(F_string)) F_string(i:) = ' '
    end if
  end subroutine C_F_string_ptr

  ! Copy a C string, passed as a char-array reference, to a Fortran string.
  subroutine C_F_string_chars(C_string, F_string)
    character(len=1,kind=C_char), intent(in) :: C_string(*)
    character(len=*), intent(out) :: F_string
    integer :: i
    i=1
    do while(C_string(i)/=NUL .and. i<=len(F_string))
       F_string(i:i) = C_string(i)
       i=i+1
    end do
    if (i<len(F_string)) F_string(i:) = ' '
  end subroutine C_F_string_chars

  ! Copy a Fortran string to an allocated C string pointer.
  ! If the C pointer is NULL, no action is taken. (Maybe auto allocate via libc call?)
  ! If the length is not passed, the C string must be at least: len(F_string)+1
  ! If the length is passed and F_string is too long, it is truncated.
  subroutine F_C_string_ptr(F_string, C_string, C_string_len)
    character(len=*), intent(in) :: F_string
    type(C_ptr), intent(in) :: C_string ! target = intent(out)
    integer, intent(in), optional :: C_string_len  ! Max string length,
    ! INCLUDING THE TERMINAL NUL
    character(len=1,kind=C_char), dimension(:), pointer :: p_chars
    integer :: i, strlen
    strlen = len(F_string)
    if (present(C_string_len)) then
       if (C_string_len <= 0) return
       strlen = min(strlen,C_string_len)
    end if
    if (.not. C_associated(C_string)) then
       return
    end if
    call C_F_pointer(C_string,p_chars,[strlen+1])
    forall (i=1:strlen)
       p_chars(i) = F_string(i:i)
    end forall
    p_chars(strlen+1) = NUL
  end subroutine F_C_string_ptr

  pure function C_strlen_safe(s) result(length)
    integer(C_size_t) :: length
    type(C_char_ptr), value, intent(in) :: s
    if (.not. C_associated_pure(s)) then
       length = 0
    else
       length = C_strlen(s)
    end if
  end function C_strlen_safe

  function C_string_value(C_string) result(F_string)
    type(C_ptr), intent(in) :: C_string
    character(len=C_strlen_safe(C_string)) :: F_string
    character(len=1,kind=C_char), dimension(:), pointer :: p_chars
    integer :: i, length
    length = len(F_string)
    if (length/=0) then
       call C_F_pointer(C_string,p_chars,[length])
       forall (i=1:length)
          F_string(i:i) = p_chars(i)
       end forall
    end if
  end function C_string_value

  ! Copy a Fortran string to a C string passed by char-array reference.
  ! If the length is not passed, the C string must be at least: len(F_string)+1
  ! If the length is passed and F_string is too long, it is truncated.
  subroutine F_C_string_chars(F_string, C_string, C_string_len)
    character(len=*), intent(in) :: F_string
    character(len=1,kind=C_char), dimension(*), intent(out) :: C_string
    integer, intent(in), optional :: C_string_len  ! Max string length,
    ! INCLUDING THE TERMINAL NUL
    integer :: i, strlen
    strlen = len(F_string)
    if (present(C_string_len)) then
       if (C_string_len <= 0) return
       strlen = min(strlen,C_string_len)
    end if
    forall (i=1:strlen)
       C_string(i) = F_string(i:i)
    end forall
    C_string(strlen+1) = NUL
  end subroutine F_C_string_chars

  ! NOTE: Strings allocated here must be freed by the
  ! C library, such as via C_free() or C_string_free(),
  type(C_ptr) function F_C_string_dup(F_string,length) result(C_string)
    character(len=*), intent(in) :: F_string
    integer, intent(in), optional :: length
    character(len=1,kind=C_char), pointer :: C_string_ptr(:)
    integer :: i
    integer(C_size_t) :: strlen
    if (present(length)) then
       strlen = length
    else
       strlen = len(F_string)
    end if
    if (strlen <= 0) then
       C_string = C_NULL_ptr
    else
       C_string = C_malloc(strlen+1)
       if (C_associated(C_string)) then
          call C_F_pointer(C_string,C_string_ptr,[strlen+1])
          forall (i=1:strlen)
             C_string_ptr(i) = F_string(i:i)
          end forall
          C_string_ptr(strlen+1) = NUL
       end if
    end if
  end function F_C_string_dup

  ! NOTE: Strings allocated here must be freed by the
  ! C library, such as via C_free() or C_string_free(),
  type(C_ptr) function C_string_alloc(length) result(C_string)
    integer(C_size_t), intent(in) :: length
    character(len=1,kind=C_char), pointer :: C_charptr
    C_string = C_malloc(length+1)
    if (C_associated(C_string)) then
       call C_F_pointer(C_string,C_charptr)
       C_charptr = NUL
    end if
  end function C_string_alloc

  subroutine C_string_free(string)
    type(C_ptr), intent(inout) :: string
    if (C_associated(string)) then
       call C_free(string)
       string = C_NULL_ptr
    end if
  end subroutine C_string_free

end module C_interface_module

subroutine sec0(n,t)

  ! Simple execution timer.
  ! call sec0(0,t)
  ! ... statements to be timed ...
  ! call sec0(1,t)
  ! print*,'Execution time:',t

  integer*8 count0,count1,clkfreq
  save count0

  call system_clock(count1,clkfreq)
  if(n.eq.0) then
     count0=count1
     return
  else
     t=float(count1-count0)/float(clkfreq)
  endif

  return
end subroutine sec0

subroutine get_q3list(fname,bDiskData,nlist,list)

  type q3list
     character*6 call
     character*4 grid
     integer nsec
     integer nfreq
     integer moonel
  end type q3list

  parameter (MAX_CALLERS=40)
  character*(*) fname
  character*36 list(40)
  character*8 grid6
  logical*1 bDiskData
  integer time
  integer nt(8)
  integer indx(MAX_CALLERS)
  type(q3list) ctmp(MAX_CALLERS),callers(MAX_CALLERS)
  character*256 jpleph_file_name,file24name
  common/jplcom/jpleph_file_name
  common/lu24com/file24name

  nhist2=0
 open(24,file=fname,status='unknown',form='unformatted')
  read(24,end=1) nhist2
  if(nhist2.ge.1 .and. nhist2.le.40) then
     read(24,end=1) ctmp(1:nhist2)
  else
     nhist2=0
  endif
1 rewind 24
  if(nhist2.eq.0) go to 900

  now=time()
  call date_and_time(values=nt)
  uth=nt(5) + (nt(6)-nt(4))/60.0 + nt(7)/3600.0
  j=0
  
  do i=1,nhist2
     age=(now - ctmp(i)%nsec)/3600.0
     if(age.gt.24.0) cycle
     grid6=ctmp(i)%grid//'mm'
     call grid2deg(grid6,xlon,xlat)
     call sun(nt(1),nt(2),nt(3),uth,-xlon,xlat,RASun,DecSun,xLST,        &
          AzSun,ElSun,mjd,day)
     call moondopjpl(nt(1),nt(2),nt(3),uth,-xlon,xlat,RAMoon,DecMoon,    &
          xLST,HA,AzMoon,ElMoon,vr,techo)
     if(ElMoon.lt.-5.0 .and. (.not.bDiskData)) cycle
     j=j+1                                   !Keep this one...
     callers(j)=ctmp(i)
     callers(j)%moonel=nint(ElMoon)          !... and save its current moonel
  enddo

  nhist2=j
  write(24) nhist2
  write(24) callers(1:nhist2)

  call indexx(callers(1:nhist2)%nfreq,nhist2,indx)
  do i=1,nhist2
     j=indx(i)
     moon_el=nint(ElMoon)
     age=(now - callers(j)%nsec)/3600.0
     write(list(i),1000) i,callers(j)%nfreq,callers(j)%call,    &
          callers(j)%grid,callers(j)%moonel,age,char(0)
1000 format(i2,'.',i6,2x,a6,2x,a4,i5,f7.1,a1)

!     h1=mod(now,86400)/3600.0
!     h2=mod(callers(i)%nsec,86400)/3600.0
!     hd=h1-h2
!     if(hd.lt.0.0) hd=hd+24.0
!     write(*,3301) i,callers(i)%call,now,callers(i)%nsec,h1,h2,hd
!3301 format(i3,2x,a6,2i12,3f10.6)

  enddo

900 close(24)
  nlist=nhist2
  file24name=fname

  return
end subroutine get_q3list

subroutine rm_q3list(dxcall0)

  parameter (MAX_CALLERS=40)
  type q3list
     character*6 call
     character*4 grid
     integer nsec
     integer nfreq
     integer moonel
  end type q3list
  character*(*) dxcall0
  character*6 dxcall
  character*256 file24name
  type(q3list) callers(MAX_CALLERS)
  common/lu24com/file24name

  dxcall=dxcall0
  open(24,file=trim(file24name),status='unknown',form='unformatted')
  read(24) nhist2
  read(24) callers(1:nhist2)

  if(nhist2.eq.MAX_CALLERS .and. dxcall.eq.callers(nhist2)%call) then
     nhist2=MAX_CALLERS - 1
     go to 10
  endif

  iz=nhist2
  do i=1,iz
     if(callers(i)%call .eq. dxcall) then
        nhist2=nhist2-1
        callers(i:nhist2)=callers(i+1:nhist2+1)    !Remove dxcall from q3list
        exit
     endif
  enddo

10 rewind 24
  write(24) nhist2
  write(24) callers(1:nhist2)
  close(24)

  return
end subroutine rm_q3list

subroutine jpl_setup(fname)
  character*256 fname,jpleph_file_name
  common/jplcom/jpleph_file_name
  jpleph_file_name=fname
  return
end subroutine jpl_setup

subroutine update_msk40_hasharray(nhasharray)

  use packjt77  
  character*37 hashmsg
  integer nhasharray(MAXRECENT,MAXRECENT)

  nhasharray=-1
  do i=1,MAXRECENT
    do j=i+1,MAXRECENT
      if( recent_calls(i)(1:1) .ne. ' ' .and. recent_calls(j)(1:1) .ne. ' ' ) then
        hashmsg=trim(recent_calls(i))//' '//trim(recent_calls(j))
        call fmtmsg(hashmsg,iz)
        call hash(hashmsg,37,ihash)
        ihash=iand(ihash,4095)
        nhasharray(i,j)=ihash
        hashmsg=trim(recent_calls(j))//' '//trim(recent_calls(i))
        call fmtmsg(hashmsg,iz)
        call hash(hashmsg,37,ihash)
        ihash=iand(ihash,4095)
        nhasharray(j,i)=ihash
      endif
    enddo
  enddo 

end subroutine update_msk40_hasharray

subroutine subtractft4(dd,itone,f0,dt)

! Subtract an ft4 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  use timer_module, only: timer

  parameter (NMAX=21*3456,NSPS=576,NFFT=NMAX,NFILT=1400)
  parameter (NFRAME=(103+2)*NSPS)
  real*4  dd(NMAX), window(-NFILT/2:NFILT/2), xjunk
  complex cref,camp,cfilt,cw
  integer itone(103)
  logical first
  data first/.true./
  common/heap4/cref(NFRAME),camp(NMAX),cfilt(NMAX),cw(NMAX),xjunk(NFRAME)
  save first

  nstart=dt*12000+1-NSPS
  nsym=103
  fs=12000.0
  icmplx=1
  bt=1.0 
  nss=NSPS
  call gen_ft4wave(itone,nsym,nss,fs,f0,cref,xjunk,icmplx,NFRAME)
  camp=0.
  do i=1,nframe
    id=nstart-1+i 
    if(id.ge.1.and.id.le.NMAX) camp(i)=dd(id)*conjg(cref(i))
  enddo

  if(first) then
! Create and normalize the filter
     pi=4.0*atan(1.0)
     fac=1.0/float(nfft)
     sum=0.0
     do j=-NFILT/2,NFILT/2
        window(j)=cos(pi*j/NFILT)**2
        sum=sum+window(j)
     enddo
     cw=0.
     cw(1:NFILT+1)=window/sum
     cw=cshift(cw,NFILT/2+1)
     call four2a(cw,nfft,1,-1,1)
     cw=cw*fac
     first=.false.
  endif

  cfilt=0.0
  cfilt(1:nframe)=camp(1:nframe)
  call four2a(cfilt,nfft,1,-1,1)
  cfilt(1:nfft)=cfilt(1:nfft)*cw(1:nfft)
  call four2a(cfilt,nfft,1,1,1)

! Subtract the reconstructed signal
  do i=1,nframe
     j=nstart+i-1
     if(j.ge.1 .and. j.le.NMAX) dd(j)=dd(j)-2*REAL(cfilt(i)*cref(i))
  enddo

  return
end subroutine subtractft4

subroutine map65a(dd,ss,savg,newdat,nutc,fcenter,ntol,idphi,nfa,nfb,        &
     mousedf,mousefqso,nagain,ndecdone,nfshift,ndphi,max_drift,             &
     nfcal,nkeep,mcall3b,nsum,nsave,nxant,mycall,mygrid,                    &
     neme,ndepth,nstandalone,hiscall,hisgrid,nhsym,nfsample,                &
     ndiskdat,nxpol,nmode,ndop00)

!  Processes timf2 data from Linrad to find and decode JT65 signals.

  use wideband_sync
  use timer_module, only: timer

  parameter (MAXMSG=1000)            !Size of decoded message list
  parameter (NSMAX=60*96000)
  real dd(4,NSMAX)
  real*4 ss(4,322,NFFT),savg(4,NFFT)
  real tavg(-50:50)                  !Temp for finding local base level
  real base(4)                       !Local basel level at 4 pol'ns
  real sig(MAXMSG,30)                !Parameters of detected signals
  real a(5)
  real*8 fcenter
  character*22 msg(MAXMSG)
  character*3 shmsg0(4)
  character mycall*12,hiscall*12,mygrid*6,hisgrid*6,cp*1,cm*1
  integer indx(MAXMSG),nsiz(MAXMSG)
  logical done(MAXMSG)
  logical xpol,bq65,q65b_called
  logical candec(MAX_CANDIDATES)
  logical ldecoded
  character decoded*22,blank*22,cmode*2
  real short(3,NFFT)                 !SNR dt ipol for potential shorthands
  real qphi(12)
  type(candidate) :: cand(MAX_CANDIDATES)
  
  common/c3com/ mcall3a
  common/testcom/ifreq
  common/early/nhsym1,nhsym2,ldecoded(32768)
  common/decodes/ndecodes

  data blank/'                      '/,cm/'#'/
  data shmsg0/'ATT','RO ','RRR','73 '/
  data nfile/0/,nutc0/-999/,nid/0/,ip000/1/,ip001/1/,mousefqso0/-999/
  save

  rewind 12
  ndecodes=0

! Clean start for Q65 at early decode
  if(nhsym.eq.nhsym1 .or. nagain.ne.0) ldecoded=.false.
  if(ndiskdat.eq.1) ldecoded=.false.

  nkhz_center=nint(1000.0*(fcenter-int(fcenter)))
  mfa=nfa-nkhz_center+48
  mfb=nfb-nkhz_center+48
  mode65=mod(nmode,10)
  if(mode65.eq.3) mode65=4
  mode_q65=nmode/10
  nts_jt65=mode65                     !JT65 tone separation factor
  nts_q65=2**(mode_q65-1)             !Q65 tone separation factor
  xpol=(nxpol.ne.0)
  
! No second decode for JT65?
  if(nhsym.eq.nhsym2 .and. nagain.eq.0 .and.ndiskdat.eq.0) mode65=0

  if(nagain.eq.0) then
     call timer('get_cand',0)
     call get_candidates(ss,savg,xpol,nhsym,mfa,mfb,nts_jt65,nts_q65,cand,ncand)
     call timer('get_cand',1)
     candec=.false.
  endif
!###
!  do k=1,ncand
!     freq=cand(k)%f+nkhz_center-48.0
!     ipk=cand(k)%indx
!     write(71,3071) k,db(cand(k)%snr),freq,cand(k)%xdt,    &
!          cand(k)%ipol,cand(k)%iflip,ipk,ldecoded(ipk)
!3071 format(i3,f8.2,f10.3,f8.2,2i3,i6,L4)
!  enddo
!###

  nwrite_q65=0
  bq65=mode_q65.gt.0

  mcall3a=mcall3b
  mousefqso0=mousefqso
  if(.not.xpol) ndphi=0
  nsum=0

!### Should use AppDir! ###
  open(23,file='CALL3.TXT',status='unknown')

  df=96000.0/NFFT                     !df = 96000/NFFT = 2.930 Hz
  if(nfsample.eq.95238) df=95238.1/NFFT
  ftol=0.010                          !Frequency tolerance (kHz)
  dphi=idphi/57.2957795
  foffset=0.001*(1270 + nfcal)              !Offset from sync tone, plus CAL
  fqso=mousefqso + foffset - 0.5*(nfa+nfb) + nfshift !fqso at baseband (khz)
  iloop=0

2  if(ndphi.eq.1) dphi=30*iloop/57.2957795

  if(nutc.ne.nutc0) nfile=nfile+1
  nutc0=nutc

  do nqd=1,0,-1
     if(nqd.eq.1) then                     !Quick decode, at fQSO
        fa=1000.0*(fqso+0.001*mousedf) - ntol
        fb=1000.0*(fqso+0.001*mousedf) + ntol + 4*53.8330078
     else                                  !Wideband decode at all freqs
        fa=-1000*0.5*(nfb-nfa) + 1000*nfshift
        fb= 1000*0.5*(nfb-nfa) + 1000*nfshift
     endif
     ia=nint(fa/df) + 16385
     ib=nint(fb/df) + 16385
     ia=max(51,ia)
     ib=min(32768-51,ib)
     if(ndiskdat.eq.1 .and. mode65.eq.0) ib=ia

     km=0
     nkm=1
     nz=n/8
     freq0=-999.
     sync10=-999.
     fshort0=-999.
     syncshort0=-999.
     ntry=0
     short=0.                                 !Zero the whole short array
     jpz=1
     if(xpol) jpz=4

! First steps for JT65 decoding
     do i=ia,ib                               !Search over freq range
        freq=0.001*(i-16385)*df
!  Find the local base level for each polarization; update every 10 bins.
        if(mod(i-ia,10).eq.0) then
           do jp=1,jpz
              do ii=-50,50
                 iii=i+ii
                 if(iii.ge.1 .and. iii.le.32768) then
                    tavg(ii)=savg(jp,iii)
                 else
                    write(13,*) 'Error in iii:',iii,ia,ib,fa,fb
                    flush(13)
                    go to 900
                 endif
              enddo
              call pctile(tavg,101,50,base(jp))
           enddo
        endif

!  Find max signal at this frequency
        smax=0.
        do jp=1,jpz
           if(savg(jp,i)/base(jp).gt.smax) then
              smax=savg(jp,i)/base(jp)
              jpmax=jp
           endif
        enddo

        if(smax.gt.1.1 .or. ia.eq.ib) then
!  Look for JT65 sync patterns and shorthand square-wave patterns.
           call timer('ccf65   ',0)
           ssmax=1.e30
           call ccf65(ss(1,1,i),nhsym,ssmax,sync1,ipol,jpz,dt,     &
                flipk,syncshort,snr2,ipol2,dt2)
!###           if(dt.lt.-2.6 .or. dt.gt.2.5) sync1=-99.0  !###
           call timer('ccf65   ',1)
           if(mode65.eq.0) syncshort=-99.0     !If "No JT65", don't waste time

! ########################### Search for Shorthand Messages #################
!  Is there a shorthand tone above threshold?
           thresh0=1.0
!  Use lower thresh0 at fQSO
           if(nqd.eq.1 .and. ntol.le.100) thresh0=0.
           if(syncshort.gt.thresh0) then
! ### Do shorthand AFC here (or maybe after finding a pair?) ###
              short(1,i)=syncshort
              short(2,i)=dt2
              short(3,i)=ipol2

!  Check to see if lower tone of shorthand pair was found.
              do j=2,4
                 i0=i-nint(j*mode65*10.0*(11025.0/4096.0)/df)
!  Should this be i0 +/- 1, or just i0?
!  Should we also insist that difference in DT be either 1.5 or -1.5 s?
                 if(short(1,i0).gt.thresh0) then
                    fshort=0.001*(i0-16385)*df
                    noffset=0
                    if(nqd.eq.1) noffset=nint(1000.0*(fshort-fqso)-mousedf)
                    if(abs(noffset).le.ntol) then
!  Keep only the best candidate within ftol.
!### NB: sync2 was not defined here!
!                       sync2=syncshort                   !### try this ???
                       if(fshort-fshort0.le.ftol .and.         &
                            syncshort.gt.syncshort0 .and. nkm.eq.2) km=km-1
                       if(fshort-fshort0.gt.ftol .or.                     &
                            syncshort.gt.syncshort0) then
                          if(km.lt.MAXMSG) km=km+1
                          sig(km,1)=nfile
                          sig(km,2)=nutc
                          sig(km,3)=fshort + 0.5*(nfa+nfb)
                          sig(km,4)=syncshort
                          sig(km,5)=dt2
                          sig(km,6)=45*(ipol2-1)/57.2957795
                          sig(km,7)=0
                          sig(km,8)=snr2
                          sig(km,9)=0
                          sig(km,10)=0
!                           sig(km,11)=rms0
                          sig(km,12)=savg(ipol2,i)
                          sig(km,13)=0
                          sig(km,14)=0
                          sig(km,15)=0
                          sig(km,16)=0
!                           sig(km,17)=0
                          sig(km,18)=0
                          msg(km)=shmsg0(j)
                          fshort0=fshort
                          syncshort0=syncshort
                          nkm=2
                       endif
                    endif
                 endif
              enddo
           endif

! ########################### Search for Normal Messages ###########
!  Is sync1 above threshold?
           thresh1=1.0
!  Use lower thresh1 at fQSO
           if(nqd.eq.1 .and. ntol.le.100) thresh1=0.
           noffset=0
           if(nqd.ge.1) noffset=nint(1000.0*(freq-fqso)-mousedf)
           if(newdat.eq.1 .and. sync1.gt.-99.0) then
              sync1=thresh1+1.0
              noffset=0
           endif
           if(sync1.gt.thresh1 .and. abs(noffset).le.ntol) then
!  Keep only the best candidate within ftol.
!  (Am I deleting any good decodes by doing this?)
              if(freq-freq0.le.ftol .and. sync1.gt.sync10 .and.       &
                   nkm.eq.1) km=km-1
              if(freq-freq0.gt.ftol .or. sync1.gt.sync10) then
                 nflip=nint(flipk)
                 f00=(i-1)*df          !Freq of detected sync tone (0-96000 Hz)
                 ntry=ntry+1
                 if((nqd.eq.1 .and. ntry.ge.40) .or.                  &
                          (nqd.eq.0 .and. ntry.ge.400)) then
! Too many calls to decode1a!
                    write(*,*) '! Signal too strong, or suspect data?  Decoding aborted.'
                    write(13,*) 'Signal too strong, or suspect data?  Decoding aborted.'
                    call flush(13)
                    go to 900
                 endif

                 call timer('decode1a',0)
                 ifreq=i
                 ikhz=nint(freq+0.5*(nfa+nfb)-foffset)-nfshift
                 idf=nint(1000.0*(freq+0.5*(nfa+nfb)-foffset-(ikHz+nfshift)))
                 call decode1a(dd,newdat,f00,nflip,mode65,nfsample,       &
                      xpol,mycall,hiscall,hisgrid,neme,ndepth,nqd,dphi,   &
                      ndphi,nutc,ikHz,idf,ipol,ntol,sync2,                &
                      a,dt,pol,nkv,nhist,nsum,nsave,qual,decoded)
                 call timer('decode1a',1)

! The case sync1=2.0 is just to make sure decode1a is called and bigfft done.
                 if(mode65.ne.0 .and. sync1.ne.2.000000) then
                    if(km.lt.MAXMSG) km=km+1
                    sig(km,1)=nfile
                    sig(km,2)=nutc
                    sig(km,3)=freq + 0.5*(nfa+nfb)
                    sig(km,4)=sync1
                    sig(km,5)=dt
                    sig(km,6)=pol
                    sig(km,7)=flipk
                    sig(km,8)=sync2
                    sig(km,9)=nkv
                    sig(km,10)=qual
!                    sig(km,11)=idphi
                    sig(km,12)=savg(ipol,i)
                    sig(km,13)=a(1)
                    sig(km,14)=a(2)
                    sig(km,15)=a(3)
                    sig(km,16)=a(4)
!                     sig(km,17)=a(5)
                    sig(km,18)=nhist
                    msg(km)=decoded
                    freq0=freq
                    sync10=sync1
                    nkm=1
                 endif
              endif
           endif
        endif
     enddo  !i=ia,ib

     if(nqd.eq.1) then
        nwrite=0
        if(mode65.eq.0) km=0
        do k=1,km
           decoded=msg(k)
           if(decoded.ne.'                      ') then
              nutc=sig(k,2)
              freq=sig(k,3)
              sync1=sig(k,4)
              dt=sig(k,5)
              npol=nint(57.2957795*sig(k,6))
              flip=sig(k,7)
              sync2=sig(k,8)
              nkv=sig(k,9)
              nqual=sig(k,10)
!              idphi=nint(sig(k,11))
              if(flip.lt.0.0) then
                 do i=22,1,-1
                    if(decoded(i:i).ne.' ') go to 8
                 enddo
                 stop 'Error in message format'
8                if(i.le.18) decoded(i+2:i+4)='OOO'
              endif
              nkHz=nint(freq-foffset)-nfshift
              mhz=fcenter                         ! ... +fadd ???
              f0=mhz+0.001*nkHz
              ndf=nint(1000.0*(freq-foffset-(nkHz+nfshift)))
              nsync1=sync1

              s2db=10.0*log10(sync2) - 40             !### empirical ###
              nsync2=nint(s2db)
              if(decoded(1:4).eq.'RO  ' .or. decoded(1:4).eq.'RRR  ' .or.  &
                   decoded(1:4).eq.'73  ') then
                 nsync2=nint(1.33*s2db + 2.0)
              endif

              nwrite=nwrite+1
              if(nxant.ne.0) then
                 npol=npol-45
                 if(npol.lt.0) npol=npol+180
              endif

              call txpol(xpol,decoded,mygrid,npol,nxant,ntxpol,cp)

              if(ndphi.eq.0) then
                 write(*,1010) nkHz,ndf,npol,nutc,dt,nsync2,    &
                      cm,decoded,nkv,nqual,ntxpol,cp
1010             format('!',i3,i5,i4,i6.4,f5.1,i5,1x,a1,1x,a22,i2,i5,i5,1x,a1)
              else
                 if(iloop.ge.1) qphi(iloop)=sig(k,10)
                 write(*,1010) nkHz,ndf,npol,nutc,dt,nsync2,    &
                      cm,decoded,nkv,nqual,30*iloop
                 write(27,1011) 30*iloop,nkHz,ndf,npol,nutc,  &
                      dt,sync2,nkv,nqual,cm,decoded
1011             format(i3,i4,i5,i4,i6.4,1x,f5.1,f7.1,i3,i5,a1,1x,a22)
              endif
           endif
        enddo  ! k=1,km

        if(bq65) then
           q65b_called=.false.
           do icand=1,ncand
              if(cand(icand)%iflip.ne.0) cycle        !Keep only Q65 candidates
              freq=cand(icand)%f+nkhz_center-48.0-1.27046
              nhzdiff=nint(1000.0*(freq-mousefqso)-mousedf) - nfcal
! Now looking for "quick decode" (nqd=1) candidates at cursor freq +/- ntol.
              if(nqd.eq.1 .and. abs(nhzdiff).gt.ntol) cycle
              ikhz=mousefqso
              q65b_called=.true.
              f0=cand(icand)%f
              call timer('q65b    ',0)
              call q65b(nutc,nqd,nxant,fcenter,nfcal,nfsample,ikhz,mousedf,   &
                   ntol,xpol,mycall,mygrid, hiscall,hisgrid,mode_q65,f0,fqso, &
                   newdat,nagain,max_drift,nhsym,ndop00,idec)
              call timer('q65b    ',1)
              if(idec.ge.0) candec(icand)=.true.
           enddo
           if(.not.q65b_called) then
              freq=mousefqso + 0.001*mousedf
              ikhz=mousefqso
              f0=freq - (nkhz_center-48.0-1.27046)   !### ??? ###
              call timer('q65b    ',0)
              call q65b(nutc,nqd,nxant,fcenter,nfcal,nfsample,ikhz,mousedf,   &
                   ntol,xpol,mycall,mygrid,hiscall,hisgrid,mode_q65,f0,fqso,  &
                   newdat,nagain,max_drift,nhsym,ndop00,idec)
              call timer('q65b    ',1)
           endif
        endif

        if(nwrite.eq.0 .and. nwrite_q65.eq.0) then
           write(*,1012) mousefqso,nutc
1012       format('!',i3,9x,i6.4,'  ')
        endif
     endif  !nqd.eq.1

     if(ndphi.eq.1 .and.iloop.lt.12) then
        iloop=iloop+1
        go to 2
     endif
     
     if(ndphi.eq.1 .and.iloop.eq.12) call getdphi(qphi)
     if(nqd.eq.1) then
        call sec0(1,tdec)
        write(*,1013) nsum,nsave,nstandalone,nhsym,tdec
1013    format('<QuickDecodeDone>',3i4,i6,f6.2)
        flush(6)
        open(16,file='tquick.dat',status='unknown',access='append')
        write(16,1016) nutc,tdec
1016    format(i4.4,f7.1)
        close(16)
     endif
     call sec0(1,tsec0)
     if(nhsym.eq.nhsym1 .and. tsec0.gt.3.0) go to 700
     if(nqd.eq.1 .and. nagain.eq.1) go to 900

     if(nqd.eq.0 .and. bq65) then
! Do the wideband Q65 decode        
        do icand=1,ncand
           if(cand(icand)%iflip.ne.0) cycle    !Do only Q65 candidates here
           if(candec(icand)) cycle             !Skip if already decoded
           freq=cand(icand)%f+nkhz_center-48.0-1.27046
!###! If here at nqd=1, do only candidates at mousefqso +/- ntol
!###           if(nqd.eq.1 .and. abs(freq-mousefqso).gt.0.001*ntol) cycle
           ikhz=nint(freq)
           f0=cand(icand)%f
           call timer('q65b    ',0)
           call q65b(nutc,nqd,nxant,fcenter,nfcal,nfsample,ikhz,mousedf,ntol, &
                xpol,mycall,mygrid,hiscall,hisgrid,mode_q65,f0,fqso,newdat,   &
                nagain,max_drift,nhsym,ndop00,idec)
           call timer('q65b    ',1)
           if(idec.ge.0) candec(icand)=.true.
        enddo  ! icand
     endif
     call sec0(1,tsec0)

  enddo  ! nqd

!  Trim the list and produce a sorted index and sizes of groups.
!  (Should trimlist remove all but best SNR for given UTC and message content?)
700 call trimlist(sig,km,ftol,indx,nsiz,nz)
  done(1:km)=.false.
  j=0
  ilatest=-1
  do n=1,nz
     ifile0=0
     do m=1,nsiz(n)
        i=indx(j+m)
        ifile=sig(i,1)
        if(ifile.gt.ifile0 .and.msg(i).ne.blank) then
           ilatest=i
           ifile0=ifile
        endif
     enddo
     i=ilatest

     if(i.ge.1) then
        if(.not.done(i)) then
           done(i)=.true.
           nutc=sig(i,2)
           freq=sig(i,3)
           sync1=sig(i,4)
           dt=sig(i,5)
           npol=nint(57.2957795*sig(i,6))
           flip=sig(i,7)
           sync2=sig(i,8)
           nkv=sig(i,9)
           nqual=min(sig(i,10),10.0)
!                  rms0=sig(i,11)
           do k=1,5
              a(k)=sig(i,12+k)
           enddo
           nhist=sig(i,18)
           decoded=msg(i)
           
           if(flip.lt.0.0) then
              do i=22,1,-1
                 if(decoded(i:i).ne.' ') go to 10
              enddo
              stop 'Error in message format'
10            if(i.le.18) decoded(i+2:i+4)='OOO'
           endif
           mhz=fcenter                             !... +fadd ???
           nkHz=nint(freq-foffset)-nfshift
           f0=mhz+0.001*nkHz
           ndf=nint(1000.0*(freq-foffset-(nkHz+nfshift)))
           ndf0=nint(a(1))
           ndf1=nint(a(2))
           ndf2=nint(a(3))
           nsync1=sync1

           s2db=10.0*log10(sync2) - 40             !### empirical ###
           nsync2=nint(s2db)
           if(decoded(1:4).eq.'RO  ' .or. decoded(1:4).eq.'RRR  ' .or.  &
                decoded(1:4).eq.'73  ') then
              nsync2=nint(1.33*s2db + 2.0)
           endif

           if(nxant.ne.0) then
              npol=npol-45
              if(npol.lt.0) npol=npol+180
           endif

           call txpol(xpol,decoded,mygrid,npol,nxant,ntxpol,cp)

           cmode='#A'
           if(mode65.eq.2) cmode='#B'
           if(mode65.eq.4) cmode='#C'
           write(26,1014) f0,ndf,ndf0,ndf1,ndf2,dt,npol,nsync1,       &
                nsync2,nutc,decoded,cp,cmode
1014       format(f8.3,i5,3i3,f5.1,i4,i3,i4,i5.4,4x,a22,2x,a1,3x,a2)
           ndecodes=ndecodes+1
           write(21,1100) f0,ndf,dt,npol,nsync2,nutc,decoded,cp,          &
                cmode(1:1),cmode(2:2)
1100       format(f8.3,i5,f5.1,2i4,i5.4,2x,a22,2x,a1,3x,a1,1x,a1)
        endif

     endif
     j=j+nsiz(n)
  enddo  !i=1,km

  write(26,1015) nutc
1015 format(37x,i6.4,' ')
  call flush(21)
  call flush(26)
  call display(nkeep,ftol)
  ndecdone=2

900 close(23)
  call flush(12)
  ndphi=0
  mcall3b=mcall3a

  return
end subroutine map65a

program genmet

  character*12 arg
  integer hist(-128:128)
  lim(x)=min(127,max(-128,nint(scale*x)))

  nargs=iargc()
  if(nargs.ne.4) then
     print*,'Usage:   genmet  bw  scale snr   iters'
     print*,'Example: genmet 1.46  20   -24  1000000'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) bw
  call getarg(2,arg)
  read(arg,*) scale
  call getarg(3,arg)
  read(arg,*) snr
  call getarg(4,arg)
  read(arg,*) iters

  hist=0
  s=sqrt(2500.0/bw) * 10.0**(0.05*snr)
  fac=1.0/sqrt(2.0)
  do iter=1,iters
     x1=fac*gran()
     y1=fac*gran()
     x0=fac*gran()
     y0=fac*gran()
     r=(x1+s)**2 + y1*y1 - x0*x0 - y0*y0
     hist(lim(r))=hist(lim(r))+1
  enddo

  xln2=log(2.0)
  do i=-128,127
     p1=hist(i)/dfloat(iters)
     j=-i
     if(j.gt.127) j=127
     p0=hist(j)/dfloat(iters)
     xlhd0=log(max(0.001,2.0*p0/(p0+p1)))/xln2
     xlhd1=log(max(0.001,2.0*p1/(p0+p1)))/xln2
     write(13,1010) i/scale,hist(i)/dfloat(iters)
1010 format(f8.3,f12.9)
     write(14,1012) i+128,xlhd0,xlhd1
1012 format(i4,2f8.3)
  enddo

999 end program genmet

module sun_mod
  implicit none
contains
  subroutine sun(y,m,DD,UT,lon,lat,RA,Dec,LST,Az,El,mjd,day)
  
    implicit none
  
    integer, intent(in) :: y                         !Year
    integer, intent(in) :: m                         !Month
    integer, intent(in) :: DD                        !Day
    integer, intent(out) :: mjd                       !Modified Julian Date
    real, intent(in) :: UT                           !UTC in hours
    real, intent(out) :: RA,Dec                       !RA and Dec of sun
    real, intent(in) :: lon,lat
    real, intent(out) :: LST,Az,El,day
  
  ! NB: Double caps here are single caps in the writeup.
  
  ! Orbital elements of the Sun (also N=0, i=0, a=1):
    real w                            !Argument of perihelion
    real e                            !Eccentricity
    real MM                           !Mean anomaly
    real Ls                           !Mean longitude
  
  ! Other standard variables:
    real v                            !True anomaly
    real EE                           !Eccentric anomaly
    real ecl                          !Obliquity of the ecliptic
    real d                            !Ephemeris time argument in days
    real r                            !Distance to sun, AU
    real xv,yv                        !x and y coords in ecliptic
    real lonsun                       !Ecliptic long and lat of sun
  ! Ecliptic coords of sun (geocentric)
    real xs,ys
  ! Equatorial coords of sun (geocentric)
    real xe,ye,ze
    real GMST0,HA
    real xx,yy,zz
    real xhor,yhor,zhor
  
    real rad
    data rad/57.2957795/
  
  ! Time in days, with Jan 0, 2000 equal to 0.0:
    d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + DD - 730530 + UT/24.0
    mjd=d + 51543
    ecl = 23.4393 - 3.563e-7 * d
  
  ! Compute updated orbital elements for Sun:
    w = 282.9404 + 4.70935e-5 * d
    e = 0.016709 - 1.151e-9 * d
    MM = mod(356.0470d0 + 0.9856002585d0 * d + 360000.d0,360.d0)
    Ls = mod(w+MM+720.0,360.0)
  
    EE = MM + e*rad*sin(MM/rad) * (1.0 + e*cos(M/rad)) 
    EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.0 - e*cos(EE/rad))
  
    xv = cos(EE/rad) - e
    yv = sqrt(1.0-e*e) * sin(EE/rad)
    v = rad*atan2(yv,xv)
    r = sqrt(xv*xv + yv*yv)
    lonsun = mod(v + w + 720.0,360.0)
  ! Ecliptic coordinates of sun (rectangular):
    xs = r * cos(lonsun/rad)
    ys = r * sin(lonsun/rad)
  
  ! Equatorial coordinates of sun (rectangular):
    xe = xs
    ye = ys * cos(ecl/rad)
    ze = ys * sin(ecl/rad)
  
  ! RA and Dec in degrees:
    RA = rad*atan2(ye,xe)
    Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))
  
    GMST0 = (Ls + 180.0)/15.0
    LST = mod(GMST0+UT+lon/15.0+48.0,24.0)    !LST in hours
    HA = 15.0*LST - RA                        !HA in degrees
    xx = cos(HA/rad)*cos(Dec/rad)
    yy = sin(HA/rad)*cos(Dec/rad)
    zz =             sin(Dec/rad)
    xhor = xx*sin(lat/rad) - zz*cos(lat/rad)
    yhor = yy
    zhor = xx*cos(lat/rad) + zz*sin(lat/rad)
    Az = mod(rad*atan2(yhor,xhor) + 180.0 + 360.0,360.0)
    El = rad*asin(zhor)
    day=d-1.5
  
  end subroutine sun
end module sun_mod

subroutine flat2(s,nz,ref)

  parameter (NSMAX=6827)
  real s(NSMAX)
  real ref(NSMAX)

  nsmo=10
  ia=nsmo+1
  ib=nz-nsmo-1
  do i=ia,ib
     call pctile(s(i-nsmo),2*nsmo+1,5,ref(i))
  enddo

  ref(:ia-1)=ref(ia)
  ref(ib+1:)=ref(ib)

  return
end subroutine flat2

subroutine decode4(dat,npts,dtx,nfreq,flip,mode4,ndepth,neme,minw,           &
     mycall,hiscall,hisgrid,decoded,nfano,deepbest,qbest,ichbest)

! Decodes JT4 data, assuming that DT and DF have already been determined.
! Input dat(npts) has already been downsampled by 2: rate = 11025/2.
! ### NB: this initial downsampling should be removed in WSJT-X, since
! it restricts the useful bandwidth to < 2.7 kHz.

  use jt4
  real dat(npts)                        !Raw data
  character decoded*22,deepmsg*22,deepbest*22
  character*12 mycall,hiscall
  character*6 hisgrid
  real*8 dt,df,phi,f0,dphi,twopi,phi1,dphi1
  complex*16 cz,cz1,c0,c1
  real*4 sym(207)

  twopi=8*atan(1.d0)
  dt=2.d0/11025             !Sample interval (2x downsampled data)
  df=11025.d0/2520.d0       !Tone separation for JT4A mode
  nsym=206
  amp=15.0
  istart=nint((dtx+0.8)/dt)              !Start index for synced FFTs
  if(istart.lt.0) istart=0
  nchips=0
  qbest=0.
  qtop=0.
  deepmsg='                      '
  ichbest=-1
  c0=0.
  k=istart
  phi=0.d0
  phi1=0.d0

  ich1=minw+1
  do ich=1,7
     if(nch(ich).le.mode4) ich2=ich
  enddo

  do ich=ich1,ich2
     nchips=min(nch(ich),70)
     nspchip=1260/nchips
     k=istart
     phi=0.d0
     phi1=0.d0
     fac2=1.e-8 * sqrt(float(mode4))
     do j=1,nsym+1
        if(flip.gt.0.0) then
           f0=nfreq + (npr(j))*mode4*df
           f1=nfreq + (2+npr(j))*mode4*df
        else
           f0=nfreq + (1-npr(j))*mode4*df
           f1=nfreq + (3-npr(j))*mode4*df
        endif
        dphi=twopi*dt*f0
        dphi1=twopi*dt*f1
        sq0=0.
        sq1=0.
        do nc=1,nchips
           phi=0.d0
           phi1=0.d0
           c0=0.
           c1=0.
           do i=1,nspchip
              k=k+1
              phi=phi+dphi
              phi1=phi1+dphi1
              cz=dcmplx(cos(phi),-sin(phi))
              cz1=dcmplx(cos(phi1),-sin(phi1))
              if(k.le.npts) then
                 c0=c0 + dat(k)*cz
                 c1=c1 + dat(k)*cz1
              endif
           enddo
           sq0=sq0 + real(c0)**2 + aimag(c0)**2
           sq1=sq1 + real(c1)**2 + aimag(c1)**2
        enddo
        sq0=fac2*sq0
        sq1=fac2*sq1
        rsym=amp*(sq1-sq0)
        if(j.ge.1) then
           rsymbol(j,ich)=rsym
           sym(j)=rsym
        endif
     enddo
     
     call extract4(sym,ncount,decoded)          !Do the convolutional decode
     nfano=0
     if(ncount.ge.0) then
        nfano=1
        ichbest=ich
        exit
     endif

     qual=0.                                    !Now try deep search
!     if(ndepth.ge.1) then
     if(iand(ndepth,32).eq.32) then
        call deep4(sym(2),neme,flip,mycall,hiscall,hisgrid,deepmsg,qual)
        if(qual.gt.qbest) then
           qbest=qual
           deepbest=deepmsg
           ichbest=ich
        endif
     endif
  enddo
  if(qbest.gt.qtop) then
     qtop=qbest
  endif
  qual=qbest

  return
end subroutine decode4

subroutine fano232(symbol,nbits,mettab,ndelta,maxcycles,dat,     &
     ncycles,metric,ierr)

! Sequential decoder for K=32, r=1/2 convolutional code using 
! the Fano algorithm.  Translated from C routine for same purpose
! written by Phil Karn, KA9Q.

  parameter (MAXBITS=103)
  parameter (MAXBYTES=13)          !(MAXBITS+7)/8
  integer*1 symbol(0:2*MAXBITS-1)  !Soft symbols (as unsigned i*1)
  integer*1 dat(MAXBYTES)          !Decoded user data, 8 bits per byte
  integer mettab(-128:127,0:1)     !Metric table

! These were the "node" structure in Karn's C code:
  integer nstate(0:MAXBITS)        !Encoder state of next node
  integer gamma(0:MAXBITS)         !Cumulative metric to this node
  integer metrics(0:3,0:MAXBITS)   !Metrics indexed by all possible Tx syms
  integer tm(0:1,0:MAXBITS)        !Sorted metrics for current hypotheses
  integer ii(0:MAXBITS)            !Current branch being tested

  logical noback
  include 'conv232.f90'            !Polynomials defined here

  ntail=nbits-31

! Compute all possible branch metrics for each symbol pair.
! This is the only place we actually look at the raw input symbols
  i4a=0
  i4b=0
  do np=0,nbits-1
     j=2*np
     i4a=symbol(j)
     i4b=symbol(j+1)
     metrics(0,np) = mettab(i4a,0) + mettab(i4b,0)
     metrics(1,np) = mettab(i4a,0) + mettab(i4b,1)
     metrics(2,np) = mettab(i4a,1) + mettab(i4b,0)
     metrics(3,np) = mettab(i4a,1) + mettab(i4b,1)
  enddo

  np=0
  nstate(np)=0

  n=iand(nstate(np),npoly1)                  !Compute and sort branch metrics 
  n=ieor(n,ishft(n,-16))                     !from the root node
  lsym=partab(iand(ieor(n,ishft(n,-8)),255))
  n=iand(nstate(np),npoly2)
  n=ieor(n,ishft(n,-16))
  lsym=lsym+lsym+partab(iand(ieor(n,ishft(n,-8)),255))
  m0=metrics(lsym,np)
  m1=metrics(ieor(3,lsym),np)
  if(m0.gt.m1) then
     tm(0,np)=m0                             !0-branch has better metric
     tm(1,np)=m1
  else
     tm(0,np)=m1                             !1-branch is better
     tm(1,np)=m0
     nstate(np)=nstate(np) + 1               !Set low bit
  endif

  ii(np)=0                                   !Start with best branch
  gamma(np)=0
  nt=0

  do i=1,nbits*maxcycles                     !Start the Fano decoder
     ngamma=gamma(np) + tm(ii(np),np)        !Look forward
     if(ngamma.ge.nt) then
! Node is acceptable.  If first time visiting this node, tighten threshold:
        if(gamma(np).lt.(nt+ndelta)) nt=nt + ndelta * ((ngamma-nt)/ndelta)
        gamma(np+1)=ngamma                   !Move forward
        nstate(np+1)=ishft(nstate(np),1)
        np=np+1
        if(np.eq.nbits) go to 100          !We're done!

        n=iand(nstate(np),npoly1)
        n=ieor(n,ishft(n,-16))
        lsym=partab(iand(ieor(n,ishft(n,-8)),255))
        n=iand(nstate(np),npoly2)
        n=ieor(n,ishft(n,-16))
        lsym=lsym+lsym+partab(iand(ieor(n,ishft(n,-8)),255))
            
        if(np.ge.ntail) then
           tm(0,np)=metrics(lsym,np)      !We're in the tail, now all zeros
        else
           m0=metrics(lsym,np)
           m1=metrics(ieor(3,lsym),np)
           if(m0.gt.m1) then
              tm(0,np)=m0                 !0-branch has better metric
              tm(1,np)=m1
           else
              tm(0,np)=m1                 !1-branch is better
              tm(1,np)=m0
              nstate(np)=nstate(np) + 1   !Set low bit
           endif
        endif
        ii(np)=0                          !Start with best branch
     else
        do while(.true.)
           noback=.false.                 !Threshold violated, can't go forward
           if(np.eq.0) noback=.true.
           if(np.gt.0) then
              if(gamma(np-1).lt.nt) noback=.true.
           endif

           if(noback) then               !Can't back up, either
              nt=nt-ndelta               !Relax threshold and look forward again
              if(ii(np).ne.0) then
                 ii(np)=0
                 nstate(np)=ieor(nstate(np),1)
              endif
              exit
           endif

           np=np-1                       !Back up
           if(np.lt.ntail .and. ii(np).ne.1) then
              ii(np)=ii(np)+1            !Search the next best branch
              nstate(np)=ieor(nstate(np),1)
              exit
           endif
        enddo
     endif
  enddo
  i=nbits*maxcycles
  
100 metric=gamma(np)                       !Final path metric
  nbytes=(nbits+7)/8                       !Copy decoded data to user's buffer
  np=7
  do j=1,nbytes-1
     i4a=nstate(np)
     dat(j)=int(i4a,1)
     np=np+8
  enddo
  dat(nbytes)=0
  ncycles=i+1
  ierr=0
  if(i.ge.maxcycles*nbits) ierr=-1

  return
end subroutine fano232

! NOTE: This routine must remain a top-level Fortran subroutine.
! It has CHARACTER arguments, which require hidden length parameters
! that are passed automatically by the Fortran ABI.
! Keeping it outside any module preserves the legacy Fortran/C++ ABI
! and ensures the caller can continue to use the symbol name gen65_.

subroutine gen65_core(message, mode65, samfac, nsendingsh, msgsent, iwave, nwave)
  use iso_c_binding
  use packjt
  use chkmsg_mod
  use graycode_mod
  use rs_mod, only: rs_encode_
  use interleave63_mod
  implicit none

  !--------------------------------------------------------------------
  ! Parameters
  !--------------------------------------------------------------------
  integer, parameter :: NMAX = 2*60*11025

  !--------------------------------------------------------------------
  ! Arguments
  !--------------------------------------------------------------------
  character(len=22), intent(inout)    :: message
  integer,          intent(in)     :: mode65
  real(8),          intent(in)     :: samfac
  integer,          intent(out)    :: nsendingsh
  character(len=22), intent(out)   :: msgsent
  integer(2), intent(out) :: iwave(NMAX)
  integer,          intent(out)    :: nwave

  !--------------------------------------------------------------------
  ! Locals
  !--------------------------------------------------------------------
  character(len=3) :: cok
  real(8) :: dt, phi, f, f0, dfgen, dphi, twopi
  integer :: dgen(12)
  integer :: sent(63)
  logical :: first
  integer :: nprc(126)
  real    :: pr(126), flip
  integer :: nspecial
  integer :: nsym, nsps
  integer :: i, j, ii, k, itype
  real(8) :: xphi

  !--------------------------------------------------------------------
  ! Initialization
  !--------------------------------------------------------------------
  data nprc / &
     1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0, &
     0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1, &
     0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1, &
     0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1, &
     1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1, &
     0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1, &
     1,1,1,1,1,1 /
  data twopi / 6.283185307179586476d0 /
  data first /.true./
  save first, pr

  !--------------------------------------------------------------------
  ! Precompute PR sequence once
  !--------------------------------------------------------------------
  if (first) then
     do i = 1, 126
        pr(i) = 2*nprc(i) - 1
     end do
     first = .false.
  end if

  !--------------------------------------------------------------------
  ! Message classification
  !--------------------------------------------------------------------
  !write(*,*) 'GEN65 received message', message
  call chkmsg(message, cok, nspecial, flip)

  if (nspecial == 0) then
  
     call packmsg(message, dgen, itype)
     
     nsendingsh = 0
     if (iand(dgen(10), 8) /= 0) nsendingsh = -1

     call rs_encode_(dgen, sent)
     call interleave63(sent, 1)
     call graycode(sent, 63, 1)

     nsym = 126
     nsps = 4096
  else
     nsym = 32
     nsps = 16384
     nsendingsh = 1
  end if

  if (mode65 == 0) then
     nwave = 0
     return
  end if

  !--------------------------------------------------------------------
  ! Waveform generation
  !--------------------------------------------------------------------
  dt    = 1.d0 / (samfac * 11025.d0)
  f0    = 118 * 11025.d0 / 1024.d0
  dfgen = mode65 * 11025.d0 / 4096.d0
  phi   = 0.d0
  dphi  = twopi * dt * f0

  i = 0
  k = 0

  do j = 1, nsym
     if (message(1:5) /= '@TUNE') then
        f = f0
        if (nspecial /= 0 .and. mod(j,2) == 0) f = f0 + 10*nspecial*dfgen
        if (nspecial == 0 .and. flip*pr(j) < 0.0) then
           k = k + 1
           f = f0 + (sent(k) + 2)*dfgen
        end if
        dphi = twopi * dt * f
     end if

     do ii = 1, nsps
        phi = phi + dphi
        if (phi > twopi) phi = phi - twopi
        xphi = phi
        i = i + 1
        iwave(2*i-1) = 32767.0 * cos(xphi)
        iwave(2*i)   = 32767.0 * sin(xphi)
     end do
  end do

  !--------------------------------------------------------------------
  ! Finalize waveform
  !--------------------------------------------------------------------
  iwave(2*nsym*nsps+1:) = 0
  nwave = 2*nsym*nsps + 5512

  !--------------------------------------------------------------------
  ! Decode message for display
  !--------------------------------------------------------------------
   if (nspecial == 0) then
      call unpackmsg(dgen, msgsent)
      write(*,*) 'GEN65 msgsent is: ',msgsent
      if (flip < 0.0) then
         do i = 22, 1, -1
            if (msgsent(i:i) /= ' ') exit
         end do
         msgsent = msgsent(1:i) // ' OOO'
      end if
   else
      msgsent = '                      '   ! or leave as-is; will be overwritten below
   end if

   if (nsendingsh == 1) then
      if (nspecial == 2) msgsent = 'RO'
      if (nspecial == 3) msgsent = 'RRR'
      if (nspecial == 4) msgsent = '73'
   end if

end subroutine gen65_core

subroutine gen65_c(msg, mode65, samfac, nsendingsh, msgsent_c, iwave_c, nwave) &
  bind(C, name="gen65_")
  use iso_c_binding
  implicit none

  ! C-side arguments
  character(kind=c_char), dimension(*), intent(inout) :: msg
  integer(c_int),                      intent(in)     :: mode65
  real(c_double),                      intent(in)     :: samfac
  integer(c_int),                      intent(out)    :: nsendingsh
  character(kind=c_char), dimension(*),intent(out)    :: msgsent_c
  integer(c_short),  dimension(*),     intent(out)    :: iwave_c
  integer(c_int),                      intent(out)    :: nwave

  ! Fortran locals
  character(len=22) :: fmsg, fmsgsent
  integer(2), dimension(2*60*11025) :: fiwave
  integer :: i

  ! Copy C msg ? Fortran CHARACTER(22)
  fmsg = ' '
  do i = 1, 22
     if (msg(i) == c_null_char) exit
     fmsg(i:i) = achar(iachar(msg(i)))
  end do

  ! Call the real Fortran routine
  call gen65_core(fmsg, mode65, samfac, nsendingsh, fmsgsent, fiwave, nwave)

  ! Copy Fortran msgsent ? C buffer
  do i = 1, 22
     msgsent_c(i) = fmsgsent(i:i)
  end do
  msgsent_c(23) = c_null_char   ! null terminate

  ! Copy waveform
  do i = 1, nwave
     iwave_c(i) = fiwave(i)
  end do

end subroutine gen65_c


!does not require end module

subroutine unpack50(dat,n1,n2)

  integer*1 dat(11)

  i=dat(1)
  i4=iand(i,255)
  n1=ishft(i4,20)
  i=dat(2)
  i4=iand(i,255)
  n1=n1 + ishft(i4,12)
  i=dat(3)
  i4=iand(i,255)
  n1=n1 + ishft(i4,4)
  i=dat(4)
  i4=iand(i,255)
  n1=n1 + iand(ishft(i4,-4),15)
  n2=ishft(iand(i4,15),18)
  i=dat(5)
  i4=iand(i,255)
  n2=n2 + ishft(i4,10)
  i=dat(6)
  i4=iand(i,255)
  n2=n2 + ishft(i4,2)
  i=dat(7)
  i4=iand(i,255)
  n2=n2 + iand(ishft(i4,-6),3)

  return
end subroutine unpack50

subroutine syncmsk(cdat,npts,jpk,ipk,idf,rmax,snr,metric,decoded)

! Attempt synchronization, and if successful decode using Viterbi algorithm.

  use iso_c_binding, only: c_loc,c_size_t
  use packjt
  use hashing
  use timer_module, only: timer

  parameter (NSPM=1404,NSAVE=2000)
  complex cdat(npts)                    !Analytic signal
  complex cb(66)                        !Complex waveform for Barker-11 code
  complex cd(0:11,0:3)
  complex c(0:NSPM-1)                   !Complex data for one message length
  complex c2(0:NSPM-1)
  complex cb3(1:NSPM,3)
  real r(12000)
  real rdat(12000)
  real ss1(12000)
  real symbol(234)
  real rdata(198)
  real rd2(198)
  real rsave(NSAVE)
  real xp(29)
  complex z,z0,z1,z2,z3,cfac
  integer*1 e1(198)
  integer*1, target :: d8(13)
  integer*1 i1hash(4)
  integer*1 i1
  integer*4 i4Msg6BitWords(12)            !72-bit message as 6-bit words
  integer mettab(0:255,0:1)               !Metric table for BPSK modulation
  integer ipksave(NSAVE)
  integer jpksave(NSAVE)
  integer indx(NSAVE)
  integer b11(11)                      !Barker-11 code
  character*22 decoded
  character*72 c72
  logical first
  equivalence (i1,i4)
  equivalence (ihash,i1hash)
  data xp/0.500000, 0.401241, 0.309897, 0.231832, 0.168095,    &
          0.119704, 0.083523, 0.057387, 0.039215, 0.026890,    &
          0.018084, 0.012184, 0.008196, 0.005475, 0.003808,    &
          0.002481, 0.001710, 0.001052, 0.000789, 0.000469,    &
          0.000329, 0.000225, 0.000187, 0.000086, 0.000063,    &
          0.000017, 0.000091, 0.000032, 0.000045/
  data first/.true./
  data b11/1,1,1,0,0,0,1,0,0,1,0/
  save first,cb,cd,twopi,dt,f0,f1,mettab

  phi=0.
  if(first) then
! Get the metric table
     bias=0.0
     scale=20.0
     xln2=log(2.0)
     mettab=0
     do i=128,156
        x0=log(max(0.001,2.0*xp(i-127)))/xln2
        x1=log(max(0.001,2.0*(1.0-xp(i-127))))/xln2
        mettab(i,0)=nint(scale*(x0-bias))
        mettab(i,1)=nint(scale*(x1-bias))
        mettab(256-i,0)=mettab(i,1)
        mettab(256-i,1)=mettab(i,0)
     enddo
     do i=157,255
        mettab(i,0)=mettab(156,0)
        mettab(i,1)=mettab(156,1)
        mettab(256-i,0)=mettab(i,1)
        mettab(256-i,1)=mettab(i,0)
     enddo
     j=0
     twopi=8.0*atan(1.0)
     dt=1.0/12000.0
     f0=1000.0
     f1=2000.0
     dphi=0
     do i=1,11
        if(b11(i).eq.0) dphi=twopi*f0*dt
        if(b11(i).eq.1) dphi=twopi*f1*dt
        do n=1,6
           j=j+1
           phi=phi+dphi
           cb(j)=cmplx(cos(phi),sin(phi))
        enddo
     enddo
     cb3=0.
     cb3(1:66,1)=cb
     cb3(283:348,1)=cb
     cb3(769:834,1)=cb

     cb3(1:66,2)=cb
     cb3(487:552,2)=cb
     cb3(1123:1188,2)=cb

     cb3(1:66,3)=cb
     cb3(637:702,3)=cb
     cb3(919:984,3)=cb

     phi=0.
     do n=0,3
        k=-1
        dphi=twopi*f0*dt
        if(n.ge.2) dphi=twopi*f1*dt
        do i=0,5
           k=k+1
           phi=phi+dphi
           if(phi.gt.twopi) phi=phi-twopi
           cd(k,n)=cmplx(cos(phi),sin(phi))
        enddo

        dphi=twopi*f0*dt
        if(mod(n,2).eq.1) dphi=twopi*f1*dt
        do i=6,11
           k=k+1
           phi=phi+dphi
           if(phi.gt.twopi) phi=phi-twopi
           cd(k,n)=cmplx(cos(phi),sin(phi))
        enddo
     enddo

     first=.false.
  endif

  nfft=NSPM
  jz=npts-nfft
  decoded="                      "
  ipk=0
  jpk=0
  metric=-9999
  r=0.

  call timer('sync1   ',0)
  do j=1,jz                               !Find the Barker-11 sync vectors
     z=0.
     ss=0.
     do i=1,66
        ss=ss + real(cdat(j+i-1))**2 + aimag(cdat(j+i-1))**2
        z=z + cdat(j+i-1)*conjg(cb(i))    !Signal matching Barker 11
     enddo
     ss=sqrt(ss/66.0)*66.0
     r(j)=abs(z)/(0.908*ss)               !Goodness-of-fit to Barker 11
     ss1(j)=ss
  enddo
  call timer('sync1   ',1)

  call timer('sync2   ',0)
  jz=npts-nfft
  rmax=0.
!  n1=35, n2=69, n3=94
  k=0
  do j=1,jz                               !Find best full-message sync
     if(ss1(j).lt.85.0) cycle
     r1=r(j) + r(j+282) + r(j+768)        ! 6*(12+n1) 6*(24+n1+n2)
     r2=r(j) + r(j+486) + r(j+1122)       ! 6*(12+n2) 6*(24+n2+n3)
     r3=r(j) + r(j+636) + r(j+918)        ! 6*(12+n3) 6*(24+n3+n1)
     if(r1.gt.rmax) then
        rmax=r1
        jpk=j
        ipk=1
     endif
     if(r2.gt.rmax) then
        rmax=r2
        jpk=j
        ipk=2
     endif
     if(r3.gt.rmax) then
        rmax=r3
        jpk=j
        ipk=3
     endif
     rrmax=max(r1,r2,r3)
     if(rrmax.gt.1.9) then
        k=min(k+1,NSAVE)
        if(r1.eq.rrmax) ipksave(k)=1
        if(r2.eq.rrmax) ipksave(k)=2
        if(r3.eq.rrmax) ipksave(k)=3
        jpksave(k)=j
        rsave(k)=rrmax
     endif
  enddo
  call timer('sync2   ',1)
  kmax=k

  call indexx(rsave,kmax,indx)

  call timer('sync3   ',0)
  do kk=1,kmax
     k=indx(kmax+1-kk)
     ipk=ipksave(k)
     jpk=jpksave(k)
     rmax=rsave(k)

     c=conjg(cb3(1:NSPM,ipk))*cdat(jpk:jpk+nfft-1)
     smax=0.
     dfx=0.
     idfbest=0
     do itry=1,25
        idf=itry/2
        if(mod(itry,2).eq.0) idf=-idf
        idf=4*idf
        twk=idf
        call tweak1(c,NSPM,-twk,c2)
        z=sum(c2)
        if(abs(z).gt.smax) then
           dfx=twk
           smax=abs(z)
           phi=atan2(aimag(z),real(z))            !Carrier phase offset
           idfbest=idf
        endif
     enddo
     idf=idfbest
     call tweak1(cdat,npts,-dfx,cdat)
     cfac=cmplx(cos(phi),-sin(phi))
     cdat=cfac*cdat

     sig=0.
     ref=0.
     rdat(1:npts)=cdat
     iz=11
     do k=1,234                                !Compute soft symbols
        j=jpk+6*(k-1)

        z0=2.0*dot_product(cdat(j:j+iz),cd(0:iz,0))
        z1=2.0*dot_product(cdat(j:j+iz),cd(0:iz,1))
        z2=2.0*dot_product(cdat(j:j+iz),cd(0:iz,2))
        z3=2.0*dot_product(cdat(j:j+iz),cd(0:iz,3))

!### Maybe these should be weighted by yellow() ?
        if(j+1404+iz.lt.npts) then
           z0=z0 + dot_product(cdat(j+1404:j+1404+iz),cd(0:iz,0))
           z1=z1 + dot_product(cdat(j+1404:j+1404+iz),cd(0:iz,1))
           z2=z2 + dot_product(cdat(j+1404:j+1404+iz),cd(0:iz,2))
           z3=z3 + dot_product(cdat(j+1404:j+1404+iz),cd(0:iz,3))
        endif

        if(j-1404.ge.1) then
           z0=z0 + dot_product(cdat(j-1404:j-1404+iz),cd(0:iz,0))
           z1=z1 + dot_product(cdat(j-1404:j-1404+iz),cd(0:iz,1))
           z2=z2 + dot_product(cdat(j-1404:j-1404+iz),cd(0:iz,2))
           z3=z3 + dot_product(cdat(j-1404:j-1404+iz),cd(0:iz,3))
        endif

        sym=max(abs(real(z2)),abs(real(z3))) - max(abs(real(z0)),abs(real(z1)))

        if(sym.lt.0.0) then
           phi=atan2(aimag(z0),real(z0))
           sig=sig + real(z0)**2
           ref=ref + aimag(z0)**2
        else
           phi=atan2(aimag(z1),real(z1))
           sig=sig + real(z1)**2
           ref=ref + aimag(z1)**2
        endif
        n=k
        if(ipk.eq.2) n=k+47
        if(ipk.eq.3) n=k+128
        if(n.gt.234) n=n-234
        ibit=0
        if(sym.ge.0) ibit=1
        symbol(n)=sym
     enddo
     snr=db(sig/ref-1.0)

     rdata(1:35)=symbol(12:46)
     rdata(36:104)=symbol(59:127)
     rdata(105:198)=symbol(140:233)

! Re-order the symbols and make them i*1
     j=0
     do i=1,99
        i4=128+rdata(i)                       !### Should be nint() ??? ###
        if(i4.gt.255)  i4=255
        if(i4.lt.0) i4=0
        j=j+1
        e1(j)=i1
        rd2(j)=rdata(i)
        i4=128+rdata(i+99)
        if(i4.gt.255)  i4=255
        if(i4.lt.0) i4=0
        j=j+1
        e1(j)=i1
        rd2(j)=rdata(i+99)
     enddo

! Decode the message
     nb1=87
     call vit213(e1,nb1,mettab,d8,metric)
     ihash=nhash(c_loc(d8),int(9,c_size_t),146)
     ihash=2*iand(ihash,32767)
     decoded='                      '
     if(d8(10).eq.i1hash(2) .and. d8(11).eq.i1hash(1)) then
        write(c72,1012) d8(1:9)
1012    format(9b8.8)
        read(c72,1014) i4Msg6BitWords
1014    format(12b6.6)
        call unpackmsg(i4Msg6BitWords,decoded) !Unpack to get msgsent
     endif
     if(decoded.ne.'                      ') exit
  enddo
  call timer('sync3   ',1)

  return
end subroutine syncmsk

module npar_ptrs_mod
  use iso_c_binding
  implicit none

  ! Scalar values
  real(c_double) :: fcenter      ! RF center frequency (MHz)
  integer(c_int) :: nfa          ! Low decode limit (kHz, RF-relative)
  integer(c_int) :: nfb          ! High decode limit (kHz, RF-relative)
  integer(c_int) :: nfshift      ! Display center shift (kHz, RF-relative)
  integer(c_int) :: nfcal        ! Frequency calibration offset (Hz)
  integer(c_int) :: nutc, idphi, mousedf, mousefqso, nagain, ndepth
  integer(c_int) :: ndiskdat, neme, newdat,map65RxLog
  integer(c_int) :: mcall3, ntimeout, ntol, nxant, nfsample
  integer(c_int) :: nxpol, nmode, nsave, max_drift, nhsym
  integer(c_int) :: ndop00,nrxlog,nkeep
  character(len=12) :: mycall, hiscall
  character(len=6)  :: mygrid, hisgrid
  character(len=20) :: datetime  ! changed 1/4/26 to match legacy code
  integer(c_int)  :: stop_m65 = 0
  integer(c_int)  :: decoder_ready = 0
  character(len=512) :: wsjtx_dir = ''

  
contains

  subroutine set_wsjtx_dir(path, path_len) bind(C, name="set_wsjtx_dir_")
    use iso_c_binding
    implicit none
    character(kind=c_char), dimension(*), intent(in) :: path
    integer(c_int), value :: path_len

    ! Convert C char array to a Fortran string
    wsjtx_dir = ''
    if (path_len > 0) then
       wsjtx_dir(1:path_len) = transfer(path(1:path_len), wsjtx_dir(1:path_len))
    end if
  end subroutine set_wsjtx_dir


  subroutine set_stop_m65(val) bind(C, name="set_stop_m65")
    use iso_c_binding
    integer(c_int), value :: val
    stop_m65 = 0
    if (val /= 0) stop_m65 = 1
  end subroutine

  subroutine set_decoder_ready(val) bind(C, name="set_decoder_ready")
    use iso_c_binding
    integer(c_int), value :: val    
    decoder_ready = 0
    if (val /= 0) decoder_ready = 1
  end subroutine
    
  subroutine get_mycall(buf) bind(C, name="get_mycall")
    character(kind=c_char), intent(out) :: buf(12)
    integer :: i

    do i = 1, 12
      buf(i) = mycall(i:i)
    end do
  end subroutine get_mycall

  subroutine get_hiscall(buf) bind(C, name="get_hiscall")
    character(kind=c_char), intent(out) :: buf(12)
    integer :: i
    do i = 1, 12
      buf(i) = hiscall(i:i)
    end do
  end subroutine

  subroutine get_mygrid(buf) bind(C, name="get_mygrid")
    character(kind=c_char), intent(out) :: buf(6)
    integer :: i
    do i = 1, 6
      buf(i) = mygrid(i:i)
    end do
  end subroutine

  subroutine get_hisgrid(buf) bind(C, name="get_hisgrid")
    character(kind=c_char), intent(out) :: buf(6)
    integer :: i
    do i = 1, 6
      buf(i) = hisgrid(i:i)
    end do
  end subroutine

! NOTE ABOUT DATETIME LENGTH (17 vs 20)
!
! datetime is declared as CHARACTER(len=20) for legacy compatibility with the
! old COMMON block, but only the first 17 characters are meaningful. The decoder
! in m65_mod writes:
!
!     write(..., '( "UTC Date: ", a17 )') datetime(1:17)
!
! so the timestamp format is always 17 characters (YYYY-MM-DD HH:MM). The extra
! 3 characters are unused padding. The C interface therefore exchanges only the
! first 17 bytes, which is intentional and correct.
!
! If the timestamp format changes in the future, this interface boundary should
! be updated accordingly.

  subroutine get_datetime(buf) bind(C, name="get_datetime")
    character(kind=c_char), intent(out) :: buf(17)
    integer :: i
    do i = 1, 17
      buf(i) = datetime(i:i)
    end do
  end subroutine

  ! Helper subroutine to copy fixed-length Fortran string to C buffer
  subroutine move_chars(dest, dest_len, src)
    integer(c_int), intent(in) :: dest_len
    character(kind=c_char), intent(out) :: dest(dest_len)
    character(len=*), intent(in) :: src
    integer :: i, n

    n = min(len(src), dest_len)
    do i = 1, n
      dest(i) = src(i:i)
    end do
  end subroutine move_chars
   
  function get_fcenter() bind(C, name="get_fcenter")
    real(c_double) :: get_fcenter
    get_fcenter = fcenter
  end function
  
  function get_nkeep() bind(C, name="get_nkeep")
    integer(c_int) :: get_nkeep
    get_nkeep = nkeep
  end function
  
  function get_ndop00() bind(C, name="get_ndop00")
    integer(c_int) :: get_ndop00
    get_ndop00 = ndop00
  end function
  
  function get_map65RxLog() bind(C, name="get_map65RxLog")
    integer(c_int) :: get_map65RxLog
    get_map65RxLog = map65RxLog
  end function
  
  function get_nutc() bind(C, name="get_nutc")
    integer(c_int) :: get_nutc
    get_nutc = nutc
  end function

  function get_idphi() bind(C, name="get_idphi")
    integer(c_int) :: get_idphi
    get_idphi = idphi
  end function

  function get_mousedf() bind(C, name="get_mousedf")
    integer(c_int) :: get_mousedf
    get_mousedf = mousedf
  end function

  function get_mousefqso() bind(C, name="get_mousefqso")
    integer(c_int) :: get_mousefqso
    get_mousefqso = mousefqso
  end function

  function get_nagain() bind(C, name="get_nagain")
    integer(c_int) :: get_nagain
    get_nagain = nagain
  end function

  function get_ndepth() bind(C, name="get_ndepth")
    integer(c_int) :: get_ndepth
    get_ndepth = ndepth
  end function

  function get_ndiskdat() bind(C, name="get_ndiskdat")
    integer(c_int) :: get_ndiskdat
    get_ndiskdat = ndiskdat
  end function

  function get_neme() bind(C, name="get_neme")
    integer(c_int) :: get_neme
    get_neme = neme
  end function

  function get_newdat() bind(C, name="get_newdat")
    integer(c_int) :: get_newdat
    get_newdat = newdat
  end function

  function get_nfa() bind(C, name="get_nfa")
    integer(c_int) :: get_nfa
    get_nfa = nfa
  end function

  function get_nfb() bind(C, name="get_nfb")
    integer(c_int) :: get_nfb
    get_nfb = nfb
  end function

  function get_nfcal() bind(C, name="get_nfcal")
    integer(c_int) :: get_nfcal
    get_nfcal = nfcal
  end function

  function get_nfshift() bind(C, name="get_nfshift")
    integer(c_int) :: get_nfshift
    get_nfshift = nfshift
  end function

  function get_mcall3() bind(C, name="get_mcall3")
    integer(c_int) :: get_mcall3
    get_mcall3 = mcall3
  end function

  function get_ntimeout() bind(C, name="get_ntimeout")
    integer(c_int) :: get_ntimeout
    get_ntimeout = ntimeout
  end function

  function get_ntol() bind(C, name="get_ntol")
    integer(c_int) :: get_ntol
    get_ntol = ntol
  end function

  function get_nxant() bind(C, name="get_nxant")
    integer(c_int) :: get_nxant
    get_nxant = nxant
  end function

  function get_nfsample() bind(C, name="get_nfsample")
    integer(c_int) :: get_nfsample
    get_nfsample = nfsample
  end function

  function get_nxpol() bind(C, name="get_nxpol")
    integer(c_int) :: get_nxpol
    get_nxpol = nxpol
  end function

  function get_nmode() bind(C, name="get_nmode")
    integer(c_int) :: get_nmode
    get_nmode = nmode
  end function

  function get_nsave() bind(C, name="get_nsave")
    integer(c_int) :: get_nsave
    get_nsave = nsave
  end function

  function get_max_drift() bind(C, name="get_max_drift")
    integer(c_int) :: get_max_drift
    get_max_drift = max_drift
  end function

  function get_nhsym() bind(C, name="get_nhsym")
    integer(c_int) :: get_nhsym
    get_nhsym = nhsym
  end function  

  subroutine set_fcenter(val) bind(C, name="set_fcenter")
  use iso_c_binding
  real(c_double), value :: val
  fcenter = val
  end subroutine
  
  subroutine set_nkeep(val) bind(C, name="set_nkeep")
    use iso_c_binding
    integer(c_int), value :: val
    nkeep = val
  end subroutine
  
  subroutine set_ndop00(val) bind(C, name="set_ndop00")
    use iso_c_binding
    integer(c_int), value :: val
    ndop00 = val
  end subroutine
  
  subroutine set_map65RxLog(val) bind(C, name="set_map65RxLog")
    use iso_c_binding
    integer(c_int), value :: val
    map65RxLog = val
  end subroutine
  
  subroutine set_nutc(val) bind(C, name="set_nutc")
    use iso_c_binding
    integer(c_int), value :: val
    nutc = val
  end subroutine

  subroutine set_idphi(val) bind(C, name="set_idphi")
    use iso_c_binding
    integer(c_int), value :: val
    idphi = val
  end subroutine

  subroutine set_mousedf(val) bind(C, name="set_mousedf")
    use iso_c_binding
    integer(c_int), value :: val
    mousedf = val
  end subroutine

  subroutine set_mousefqso(val) bind(C, name="set_mousefqso")
    use iso_c_binding
    integer(c_int), value :: val
    mousefqso = val
  end subroutine

  subroutine set_nagain(val) bind(C, name="set_nagain")
    use iso_c_binding
    integer(c_int), value :: val
    nagain = val
  end subroutine

  subroutine set_ndepth(val) bind(C, name="set_ndepth")
    use iso_c_binding
    integer(c_int), value :: val
    ndepth = val
  end subroutine

  subroutine set_ndiskdat(val) bind(C, name="set_ndiskdat")
    use iso_c_binding
    integer(c_int), value :: val
    ndiskdat = val
  end subroutine

  subroutine set_neme(val) bind(C, name="set_neme")
    use iso_c_binding
    integer(c_int), value :: val
    neme = val
  end subroutine

  subroutine set_newdat(val) bind(C, name="set_newdat")
    use iso_c_binding
    integer(c_int), value :: val
    newdat = val
  end subroutine

  subroutine set_nfa(val) bind(C, name="set_nfa")
    use iso_c_binding
    integer(c_int), value :: val
    nfa = val
  end subroutine

  subroutine set_nfb(val) bind(C, name="set_nfb")
    use iso_c_binding
    integer(c_int), value :: val
    nfb = val
  end subroutine

  subroutine set_nfcal(val) bind(C, name="set_nfcal")
    use iso_c_binding
    integer(c_int), value :: val
    nfcal = val
  end subroutine

  subroutine set_nfshift(val) bind(C, name="set_nfshift")
    use iso_c_binding
    integer(c_int), value :: val
    nfshift = val
  end subroutine

  subroutine set_mcall3(val) bind(C, name="set_mcall3")
    use iso_c_binding
    integer(c_int), value :: val
    mcall3 = val
  end subroutine

  subroutine set_ntimeout(val) bind(C, name="set_ntimeout")
    use iso_c_binding
    integer(c_int), value :: val
    ntimeout = val
  end subroutine

  subroutine set_ntol(val) bind(C, name="set_ntol")
    use iso_c_binding
    integer(c_int), value :: val
    ntol = val
  end subroutine

  subroutine set_nxant(val) bind(C, name="set_nxant")
    use iso_c_binding
    integer(c_int), value :: val
    nxant = val
  end subroutine

  subroutine set_nfsample(val) bind(C, name="set_nfsample")
    use iso_c_binding
    integer(c_int), value :: val
    nfsample = val
  end subroutine

  subroutine set_nxpol(val) bind(C, name="set_nxpol")
    use iso_c_binding
    integer(c_int), value :: val
    nxpol = val
  end subroutine

  subroutine set_nmode(val) bind(C, name="set_nmode")
    use iso_c_binding
    integer(c_int), value :: val
    nmode = val
  end subroutine

  subroutine set_nsave(val) bind(C, name="set_nsave")
    use iso_c_binding
    integer(c_int), value :: val
    nsave = val
  end subroutine

  subroutine set_max_drift(val) bind(C, name="set_max_drift")
    use iso_c_binding
    integer(c_int), value :: val
    max_drift = val
  end subroutine

  subroutine set_nhsym(val) bind(C, name="set_nhsym")
    use iso_c_binding
    integer(c_int), value :: val
    nhsym = val
  end subroutine

  subroutine set_mycall(buf) bind(C, name="set_mycall")
    use iso_c_binding
    character(kind=c_char), intent(in) :: buf(12)
    integer :: i
    do i = 1, 12
      mycall(i:i) = buf(i)
    end do
  end subroutine

  subroutine set_hiscall(buf) bind(C, name="set_hiscall")
    use iso_c_binding
    character(kind=c_char), intent(in) :: buf(12)
    integer :: i
    do i = 1, 12
      hiscall(i:i) = buf(i)
    end do
  end subroutine

  subroutine set_mygrid(buf) bind(C, name="set_mygrid")
    use iso_c_binding
    character(kind=c_char), intent(in) :: buf(6)
    integer :: i
    do i = 1, 6
      mygrid(i:i) = buf(i)
    end do
  end subroutine

  subroutine set_hisgrid(buf) bind(C, name="set_hisgrid")
    use iso_c_binding
    character(kind=c_char), intent(in) :: buf(6)
    integer :: i
    do i = 1, 6
      hisgrid(i:i) = buf(i)
    end do
end subroutine

subroutine set_datetime(buf) bind(C, name="set_datetime")
  use iso_c_binding
  character(kind=c_char), intent(in) :: buf(17)
  integer :: i
  do i = 1, 17
    datetime(i:i) = buf(i)
  end do
end subroutine

end module npar_ptrs_mod

subroutine extract2(s3,nadd,ntrials,param,msg)

  real s3(64,63)
  real tmp(4032)
  integer np1(0:7,0:7),np2(0:7,0:7),np0(0:7,0:7)
  integer ns(0:7,0:7)
  integer perr(0:7,0:7),pmr2(0:7,0:7)
  character msg*22
  integer dat4(12)
  integer mrsym(0:62),mr2sym(0:62),mrprob(0:62),mr2prob(0:62)
  integer correct(0:62)
  integer param(0:7)
  integer indx(0:62)
  logical first
  real*8 tt
  common/extcom/ntdecode
  data ndone/0/,ngood/0/,nbad/0/,first/.true./
  save

  if(first) then
     np1=0
     np2=0
     np0=0
     ns=0
     first=.false.
  endif

  nfail=0
1 call demod64a(s3,nadd,mrsym,mrprob,mr2sym,mr2prob,ntest,nlow)

!  if(ntest.lt.50 .or. nlow.gt.20) then
!     ncount=-999                         !Flag bad data
!     go to 900
!  endif

  call chkhist(mrsym,nhist,ipk)
  if(nhist.ge.20) then
     nfail=nfail+1
     call pctile(s3,tmp,4032,50,base)     ! ### or, use ave from demod64a ?
     do j=1,63
        s3(ipk,j)=base
     enddo
     go to 1
  endif

  call graycode(mrsym,63,-1)
  call interleave63(mrsym,-1)
  call interleave63(mrprob,-1)

  call graycode(mr2sym,63,-1)
  call interleave63(mr2sym,-1)
  call interleave63(mr2prob,-1)

  nverbose=0
  call ftrsd2(mrsym,mrprob,mr2sym,mr2prob,ntrials,nverbose,correct,   &
       param,indx,tt,ntry)
  ncandidates=param(0)
  nhard=param(1)
  nsoft=param(2)
  nera=param(3)
  ngmd=param(4)
  ndone=ndone+1

  do i=1,12
     dat4(i)=correct(12-i)
  enddo


  msg='                      '
! if(nhard.ge.0) then
  if(nhard.ge.0 .and. nhard.le.42 .and. nsoft.le.32 .and.              &
       (nhard+nsoft).le.73) then
     call unpackmsg(dat4,msg) !Unpack the user message
     if(msg.eq.'VK7MO K1JT FN20       ') then
        ngood=ngood+1
        do k=0,62
           j=indx(k)
           i=(62-j)
           p1=mrprob(i)/255.0 + 1.e-10
           p2=mr2prob(i)/255.0
           ii=k/8
           jj=7.9999*p2/p1
           ns(ii,jj)=ns(ii,jj)+1
           if(correct(j).eq.mrsym(i)) then
              np1(ii,jj)=np1(ii,jj)+1
           else
              np0(ii,jj)=np0(ii,jj)+1
           endif
           if(correct(j).eq.mr2sym(i)) np2(ii,jj)=np2(ii,jj)+1
        enddo
     else
        nbad=nbad+1
     endif
  endif
  fgood=float(ngood)/ndone
  fbad=float(nbad)/ndone

  nboth=nhard+nsoft
  if(nhard.lt.0) then
     nsoft=99
     nera=99
     nboth=99
  endif
  write(*,1010) ndone,fgood,fbad,ncandidates,nhard,nsoft,nera,nboth,   &
       ntry,tt,msg
  write(32,1010) ndone,fgood,fbad,ncandidates,nhard,nsoft,nera,nboth,  &
       ntry,tt,msg
1010 format(i4,2f7.3,i7,4i3,i8,f8.1,1x,a22)
  flush(32)

  if(msg.eq.'VK7MO K1JT FN20       ') then
     write(33,1012) ndone,ngood,nbad,ntry,log10(float(1+ntry))
1012 format(4i8,f8.3)
     flush(33)
  endif

  rewind 40
  write(40,1080)
1080 format('Totals:')
  write(40,1090) ns
1090 format(8i7)
  write(40,1091)
1091 format(/'error:')
  write(40,1090) np0
  write(40,1092)
1092 format(/'sym = mrsym:')
  write(40,1090) np1
  write(40,1093)
1093 format(/'sym = mr2sym:')
  write(40,1090) np2

  write(40,1095)
1095 format(/'Probability of error:')
  perr=nint(100.0*float(np0)/(ns+0.001))
  write(40,1096) perr
1096 format(8i7)

  write(40,1097)
1097 format(/'P(mr2 correct | mr not correct) :')
  pmr2=nint(100.0*float(np2)/(np0+0.001))
  write(40,1096) pmr2
  flush(40)

  return
end subroutine extract2

subroutine sync9f(s2,nq,nfa,nfb,ss2,ss3,lagpk,ipk,ccfbest)

! Look for JT9 sync pattern in the folded symbol spectra, s2.
! Frequency search extends from nfa to nfb.  Synchronized symbol
! spectra are put into ss2() and ss3().

  integer ii4(16)
  real s2(240,340)
  real ss2(0:8,85)
  real ss3(0:7,69)
  include 'jt9sync.f90'

  ii4=4*ii-3
  ccf=0.
  ccfbest=0.
  nfft=4*nq
  df=12000.0/nfft
  ia=nfa/df
  ib=nfb/df + 0.9999

  do i=ia,ib
     do lag=0,339
        t=0.
        do n=1,16
           j=ii4(n)+lag
           if(j.gt.340) j=j-340
           t=t + s2(i,j)
        enddo
        if(t.gt.ccfbest) then
           lagpk=lag
           ipk=i
           ccfbest=t
        endif
     enddo
  enddo

  do i=0,8
     j4=lagpk-4
     i2=2*i + ipk
     if(i2.lt.1) i2=1
     m=0
     do j=1,85
        j4=j4+4
        if(j4.gt.340) j4=j4-340
        if(j4.lt.1) j4=j4+340
        ss2(i,j)=s2(i2,j4)
        if(i.ge.1 .and. isync(j).eq.0) then
           m=m+1
           ss3(i-1,m)=ss2(i,j)
        endif
     enddo
  enddo

  return
end subroutine sync9f

module fst4_decode

   type :: fst4_decoder
      procedure(fst4_decode_callback), pointer :: callback
   contains
      procedure :: decode
   end type fst4_decoder

   abstract interface
      subroutine fst4_decode_callback (this,nutc,sync,nsnr,dt,freq,    &
         decoded,nap,qual,ntrperiod,fmid,w50)
         import fst4_decoder
         implicit none
         class(fst4_decoder), intent(inout) :: this
         integer, intent(in) :: nutc
         real, intent(in) :: sync
         integer, intent(in) :: nsnr
         real, intent(in) :: dt
         real, intent(in) :: freq
         character(len=37), intent(in) :: decoded
         integer, intent(in) :: nap
         real, intent(in) :: qual
         integer, intent(in) :: ntrperiod
         real, intent(in) :: fmid
         real, intent(in) :: w50
      end subroutine fst4_decode_callback
   end interface

contains

   subroutine decode(this,callback,iwave,nutc,nQSOProgress,nfa,nfb,nfqso, &
      ndepth,ntrperiod,nexp_decode,ntol,emedelay,lagain,lapcqonly,mycall, &
      hiscall,iwspr,lprinthash22)

      use prog_args
      use timer_module, only: timer
      use packjt77
      use, intrinsic :: iso_c_binding
      include 'fst4/fst4_params.f90'
      parameter (MAXCAND=100,MAXWCALLS=100)
      class(fst4_decoder), intent(inout) :: this
      procedure(fst4_decode_callback) :: callback
      character*37 decodes(100)
      character*37 msg,msgsent
      character*20 wcalls(MAXWCALLS), wpart
      character*77 c77
      character*12 mycall,hiscall
      character*12 mycall0,hiscall0
      complex, allocatable :: c2(:)
      complex, allocatable :: cframe(:)
      complex, allocatable :: c_bigfft(:)          !Complex waveform
      real llr(240),llrs(240,4)
      real candidates0(200,5),candidates(200,5)
      real bitmetrics(320,4)
      real s4(0:3,NN)
      real minsync
      logical lagain,lapcqonly
      integer itone(NN)
      integer hmod
      integer*1 apmask(240),cw(240),hdec(240)
      integer*1 message101(101),message74(74),message77(77)
      integer*1 rvec(77)
      integer apbits(240)
      integer nappasses(0:5)   ! # of decoding passes for QSO states 0-5
      integer naptypes(0:5,4)  ! (nQSOProgress,decoding pass)
      integer mcq(29),mrrr(19),m73(19),mrr73(19)

      logical badsync,unpk77_success,single_decode
      logical first,nohiscall
      logical new_callsign,plotspec_exists,wcalls_exists,do_k50_decode
      logical decdata_exists
      logical lprinthash22

      integer*2 iwave(30*60*12000)

      data   mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
      data  mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
      data   m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
      data mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
      data  rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
         1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
         0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/
      data first/.true./,hmod/1/
      save first,apbits,nappasses,naptypes,mycall0,hiscall0
      save wcalls,nwcalls

      this%callback => callback
      dxcall13=hiscall   ! initialize for use in packjt77
      mycall13=mycall

      if(iwspr.ne.0 .and. iwspr.ne.1) return 

      if(lagain) continue ! use lagain to keep compiler happy 

      if(first) then
! read the fst4_calls.txt file
         inquire(file=trim(data_dir)//'/fst4w_calls.txt',exist=wcalls_exists)
         if( wcalls_exists ) then
            open(42,file=trim(data_dir)//'/fst4w_calls.txt',status='unknown')
            do i=1,MAXWCALLS
               wcalls(i)=''
               read(42,fmt='(a)',end=2867) wcalls(i)
               wcalls(i)=adjustl(wcalls(i))
               if(len(trim(wcalls(i))).eq.0) exit
            enddo
2867        nwcalls=i-1
            close(42)
         endif

         mcq=2*mod(mcq+rvec(1:29),2)-1
         mrrr=2*mod(mrrr+rvec(59:77),2)-1
         m73=2*mod(m73+rvec(59:77),2)-1
         mrr73=2*mod(mrr73+rvec(59:77),2)-1

         nappasses(0)=2
         nappasses(1)=2
         nappasses(2)=2
         nappasses(3)=2
         nappasses(4)=2
         nappasses(5)=3

! iaptype
!------------------------
!   1        CQ     ???    ???           (29 ap bits)
!   2        MyCall ???    ???           (29 ap bits)
!   3        MyCall DxCall ???           (58 ap bits)
!   4        MyCall DxCall RRR           (77 ap bits)
!   5        MyCall DxCall 73            (77 ap bits)
!   6        MyCall DxCall RR73          (77 ap bits)
!********

         naptypes(0,1:4)=(/1,2,0,0/) ! Tx6 selected (CQ)
         naptypes(1,1:4)=(/2,3,0,0/) ! Tx1
         naptypes(2,1:4)=(/2,3,0,0/) ! Tx2
         naptypes(3,1:4)=(/3,6,0,0/) ! Tx3
         naptypes(4,1:4)=(/3,6,0,0/) ! Tx4
         naptypes(5,1:4)=(/3,1,2,0/) ! Tx5

         mycall0=''
         hiscall0=''
         first=.false.
      endif

      l1=index(mycall,char(0))
      if(l1.ne.0) mycall(l1:)=" "
      l1=index(hiscall,char(0))
      if(l1.ne.0) hiscall(l1:)=" "
      if(mycall.ne.mycall0 .or. hiscall.ne.hiscall0) then
         apbits=0
         apbits(1)=99
         apbits(30)=99

         if(len(trim(mycall)) .lt. 3) go to 10

         nohiscall=.false.
         hiscall0=hiscall
         if(len(trim(hiscall0)).lt.3) then
            hiscall0=mycall  ! use mycall for dummy hiscall - mycall won't be hashed.
            nohiscall=.true.
         endif
         msg=trim(mycall)//' '//trim(hiscall0)//' RR73'
         i3=-1
         n3=-1
         call pack77(msg,i3,n3,c77)
         call unpack77(c77,1,msgsent,unpk77_success)
         if(i3.ne.1 .or. (msg.ne.msgsent) .or. .not.unpk77_success) go to 10
         read(c77,'(77i1)') message77
         message77=mod(message77+rvec,2)
         apbits(1:77)=2*message77-1
         if(nohiscall) apbits(30)=99

10       continue
         mycall0=mycall
         hiscall0=hiscall
      endif
!************************************

      if(nfqso+nqsoprogress.eq.-999) return
      Keff=91
      nmax=15*12000
      if(ntrperiod.eq.15) then
         nsps=720
         nmax=15*12000
         ndown=18                  !nss=40,80,160,400
         nfft1=int(nmax/ndown)*ndown
      else if(ntrperiod.eq.30) then
         nsps=1680
         nmax=30*12000
         ndown=42                  !nss=40,80,168,336
         nfft1=359856  !nfft2=8568=2^3*3^2*7*17
      else if(ntrperiod.eq.60) then
         nsps=3888
         nmax=60*12000
         ndown=108
         nfft1=7500*96    ! nfft2=7500=2^2*3*5^4
      else if(ntrperiod.eq.120) then
         nsps=8200
         nmax=120*12000
         ndown=205                 !nss=40,82,164,328
         nfft1=7200*200   ! nfft2=7200=2^5*3^2*5^2
      else if(ntrperiod.eq.300) then
         nsps=21504
         nmax=300*12000
         ndown=512                 !nss=42,84,168,336
         nfft1=7020*512   ! nfft2=7020=2^2*3^3*5*13
      else if(ntrperiod.eq.900) then
         nsps=66560
         nmax=900*12000
         ndown=1664                !nss=40,80,160,320
         nfft1=6480*1664  ! nfft2=6480=2^4*3^4*5
      else if(ntrperiod.eq.1800) then
         nsps=134400
         nmax=1800*12000
         ndown=3360                !nss=40,80,160,320
         nfft1=6426*3360  ! nfft2=6426=2*3^3*7*17
      end if
      nss=nsps/ndown
      fs=12000.0                       !Sample rate
      fs2=fs/ndown
      nspsec=nint(fs2)
      dt=1.0/fs                        !Sample interval (s)
      dt2=1.0/fs2
      tt=nsps*dt                       !Duration of "itone" symbols (s)
      baud=1.0/tt
      sigbw=4.0*baud
      nfft2=nfft1/ndown                !make sure that nfft1 is exactly nfft2*ndown
      nfft1=nfft2*ndown
      nh1=nfft1/2

      allocate( c_bigfft(0:nfft1/2) )
      allocate( c2(0:nfft2-1) )
      allocate( cframe(0:160*nss-1) )

      jittermax=2
      do_k50_decode=.false.
      if(ndepth.eq.3) then
         nblock=4
         jittermax=2
         do_k50_decode=.true.
      elseif(ndepth.eq.2) then
         nblock=4
         jittermax=2
         do_k50_decode=.false.
      elseif(ndepth.eq.1) then
         nblock=4
         jittermax=0
         do_k50_decode=.false.
      endif

! Noise blanker setup
      ndropmax=1
      single_decode=iand(nexp_decode,32).ne.0
      npct=0
      nb=nexp_decode/256 - 3
      if(nb.ge.0) npct=nb
      inb1=20
      inb2=5
      if(nb.eq.-1) then
         inb2=5                !Try NB = 0, 5, 10, 15, 20%
      else if(nb.eq.-2) then
         inb2=2                !Try NB = 0, 2, 4,... 20%
      else if(nb.eq.-3) then
         inb2=1                !Try NB = 0, 1, 2,... 20%
      else
         inb1=0                !Fixed NB value, 0 to 25%
      endif


! nfa,nfb: define the noise-baseline analysis window
!  fa, fb: define the signal search window
! We usually make nfa<fa and nfb>fb so that noise baseline analysis
! window extends outside of the [fa,fb] window where we think the signals are.
!
      if(iwspr.eq.1) then  !FST4W
         nfa=max(100,nfqso-ntol-100)
         nfb=min(4800,nfqso+ntol+100)
         fa=max(100,nint(nfqso+1.5*baud-ntol))  ! signal search window
         fb=min(4800,nint(nfqso+1.5*baud+ntol))
      else if(iwspr.eq.0) then
         if(single_decode) then
            fa=max(100,nint(nfa+1.5*baud))
            fb=min(4800,nint(nfb+1.5*baud))
            ! extend noise fit 100 Hz outside of search window
            nfa=max(100,nfa-100)
            nfb=min(4800,nfb+100)
         else
            fa=max(100,nint(nfa+1.5*baud))
            fb=min(4800,nint(nfb+1.5*baud))
            ! extend noise fit 100 Hz outside of search window
            nfa=max(100,nfa-100)
            nfb=min(4800,nfb+100)
         endif
      endif

      ndecodes=0
      decodes=' '
      new_callsign=.false.
      do inb=0,inb1,inb2
         if(nb.lt.0) npct=inb ! we are looping over blanker settings
         call blanker(iwave,nfft1,ndropmax,npct,c_bigfft)

! The big fft is done once and is used for calculating the smoothed spectrum
! and also for downconverting/downsampling each candidate.
         call four2a(c_bigfft,nfft1,1,-1,0)         !r2c
         nhicoh=1
         nsyncoh=8
         minsync=1.20
         if(ntrperiod.eq.15) minsync=1.15

! Get first approximation of candidate frequencies
         call get_candidates_fst4(c_bigfft,nfft1,nsps,hmod,fs,fa,fb,nfa,nfb,  &
            minsync,ncand,candidates0)
         isbest=0
         fc2=0.
         do icand=1,ncand
            fc0=candidates0(icand,1)
            if(iwspr.eq.0 .and. nb.lt.0 .and. npct.ne.0 .and.            &
               abs(fc0-(nfqso+1.5*baud)).gt.ntol) cycle  ! blanker loop only near nfqso
            detmet=candidates0(icand,2)

! Downconvert and downsample a slice of the spectrum centered on the
! rough estimate of the candidates frequency.
! Output array c2 is complex baseband sampled at 12000/ndown Sa/sec.
! The size of the downsampled c2 array is nfft2=nfft1/ndown
            call timer('dwnsmpl ',0)
            call fst4_downsample(c_bigfft,nfft1,ndown,fc0,sigbw,c2)
            call timer('dwnsmpl ',1)

            call timer('sync240 ',0)
            call fst4_sync_search(c2,nfft2,hmod,fs2,nss,ntrperiod,nsyncoh,emedelay,sbest,fcbest,isbest)
            call timer('sync240 ',1)

            fc_synced = fc0 + fcbest
            dt_synced = (isbest-fs2)*dt2  !nominal dt is 1 second so frame starts at sample fs2
            candidates0(icand,3)=fc_synced
            candidates0(icand,4)=isbest
         enddo

! remove duplicate candidates
         do icand=1,ncand
            fc=candidates0(icand,3)
            isbest=nint(candidates0(icand,4))
            do ic2=icand+1,ncand
               fc2=candidates0(ic2,3)
               isbest2=nint(candidates0(ic2,4))
               if(fc2.gt.0.0) then
                  if(abs(fc2-fc).lt.0.10*baud) then ! same frequency
                     if(abs(isbest2-isbest).le.2) then
                        candidates0(ic2,3)=-1
                     endif
                  endif
               endif
            enddo
         enddo
         ic=0
         do icand=1,ncand
            if(candidates0(icand,3).gt.0) then
               ic=ic+1
               candidates0(ic,:)=candidates0(icand,:)
            endif
         enddo
         ncand=ic

! If FST4 mode and Single Decode is not checked, then find candidates
! within 20 Hz of nfqso and put them at the top of the list
         if(iwspr.eq.0 .and. .not.single_decode) then
            nclose=count(abs(candidates0(:,3)-(nfqso+1.5*baud)).le.20)
            k=0
            do i=1,ncand
               if(abs(candidates0(i,3)-(nfqso+1.5*baud)).le.20) then
                  k=k+1
                  candidates(k,:)=candidates0(i,:)
               endif
            enddo
            do i=1,ncand
               if(abs(candidates0(i,3)-(nfqso+1.5*baud)).gt.20) then
                  k=k+1
                  candidates(k,:)=candidates0(i,:)
               endif
            enddo
         else
            candidates=candidates0
         endif

         xsnr=0.
         do icand=1,ncand
            sync=candidates(icand,2)
            fc_synced=candidates(icand,3)
            isbest=nint(candidates(icand,4))
            xdt=(isbest-nspsec)/fs2
            if(ntrperiod.eq.15) xdt=(isbest-real(nspsec)/2.0)/fs2
            call timer('dwnsmpl ',0)
            call fst4_downsample(c_bigfft,nfft1,ndown,fc_synced,sigbw,c2)
            call timer('dwnsmpl ',1)

            do ijitter=0,jittermax
               if(ijitter.eq.0) ioffset=0
               if(ijitter.eq.1) ioffset=1
               if(ijitter.eq.2) ioffset=-1
               is0=isbest+ioffset
               iend=is0+160*nss-1
               if( is0.lt.0 .or. iend.gt.(nfft2-1) ) cycle
               cframe=c2(is0:iend)
               bitmetrics=0
               call timer('bitmetrc',0)
               call get_fst4_bitmetrics(cframe,nss,bitmetrics, &
                  s4,nsync_qual,badsync)
               call timer('bitmetrc',1)
               if(badsync) cycle

               do il=1,4
                  llrs(  1: 60,il)=bitmetrics( 17: 76, il)
                  llrs( 61:120,il)=bitmetrics( 93:152, il)
                  llrs(121:180,il)=bitmetrics(169:228, il)
                  llrs(181:240,il)=bitmetrics(245:304, il)
               enddo

               apmag=maxval(abs(llrs(:,4)))*1.1
               ntmax=nblock+nappasses(nQSOProgress)
               if(lapcqonly) ntmax=nblock+1
               if(ndepth.eq.1) ntmax=nblock ! no ap for ndepth=1
               apmask=0

               if(iwspr.eq.1) then ! 50-bit msgs, no ap decoding
                  nblock=4
                  ntmax=nblock
               endif

               do itry=1,ntmax
                  if(itry.eq.1) llr=llrs(:,1)
                  if(itry.eq.2.and.itry.le.nblock) llr=llrs(:,2)
                  if(itry.eq.3.and.itry.le.nblock) llr=llrs(:,3)
                  if(itry.eq.4.and.itry.le.nblock) llr=llrs(:,4)
                  if(itry.le.nblock) then
                     apmask=0
                     iaptype=0
                  endif

                  if(itry.gt.nblock .and. iwspr.eq.0) then ! do ap passes
                     llr=llrs(:,nblock)  ! Use largest blocksize as the basis for AP passes
                     iaptype=naptypes(nQSOProgress,itry-nblock)
                     if(lapcqonly) iaptype=1
                     if(iaptype.ge.2 .and. apbits(1).gt.1) cycle  ! No, or nonstandard, mycall
                     if(iaptype.ge.3 .and. apbits(30).gt.1) cycle ! No, or nonstandard, dxcall
                     if(iaptype.eq.1) then   ! CQ
                        apmask=0
                        apmask(1:29)=1
                        llr(1:29)=apmag*mcq(1:29)
                     endif

                     if(iaptype.eq.2) then  ! MyCall ??? ???
                        apmask=0
                        apmask(1:29)=1
                        llr(1:29)=apmag*apbits(1:29)
                     endif

                     if(iaptype.eq.3) then  ! MyCall DxCall ???
                        apmask=0
                        apmask(1:58)=1
                        llr(1:58)=apmag*apbits(1:58)
                     endif

                     if(iaptype.eq.4 .or. iaptype.eq.5 .or. iaptype .eq.6) then
                        apmask=0
                        apmask(1:77)=1
                        llr(1:58)=apmag*apbits(1:58)
                        if(iaptype.eq.4) llr(59:77)=apmag*mrrr(1:19)
                        if(iaptype.eq.5) llr(59:77)=apmag*m73(1:19)
                        if(iaptype.eq.6) llr(59:77)=apmag*mrr73(1:19)
                     endif
                  endif

                  dmin=0.0
                  nharderrors=-1
                  unpk77_success=.false.
                  if(iwspr.eq.0) then
                     maxosd=2
                     Keff=91
                     norder=3
                     call timer('d240_101',0)
                     call decode240_101(llr,Keff,maxosd,norder,apmask,message101, &
                        cw,ntype,nharderrors,dmin)
                     call timer('d240_101',1)
                     if(count(cw.eq.1).eq.0) then
                        nharderrors=-nharderrors
                        cycle
                     endif
                     write(c77,'(77i1)') mod(message101(1:77)+rvec,2)
                     call unpack77(c77,1,msg,unpk77_success)
                  elseif(iwspr.eq.1) then
! Try decoding with Keff=66
                     maxosd=2
                     call timer('d240_74 ',0)
                     Keff=66
                     norder=3
                     call decode240_74(llr,Keff,maxosd,norder,apmask,message74,cw, &
                        ntype,nharderrors,dmin)
                     call timer('d240_74 ',1)
                     if(nharderrors.lt.0) goto 3465
                     if(count(cw.eq.1).eq.0) then
                        nharderrors=-nharderrors
                        cycle
                     endif
                     write(c77,'(50i1)') message74(1:50)
                     c77(51:77)='000000000000000000000110000'
                     call unpack77(c77,1,msg,unpk77_success)
                     if(lprinthash22 .and. unpk77_success .and. index(msg,'<...>').gt.0) then
                        read(c77,'(b22.22)') n22tmp
                        i1=index(msg,' ')
                        wpart=trim(msg(i1+1:))
                        write(msg,'(a1,i7.7,a1)') '<',n22tmp,'>' 
                        msg=trim(msg)//' '//trim(wpart)
                     endif
                     if(unpk77_success .and. do_k50_decode) then
! If decode was obtained with Keff=66, save call/grid in fst4w_calls.txt if not there already.
                        i1=index(msg,' ')
                        i2=i1+index(msg(i1+1:),' ')
                        wpart=trim(msg(1:i2))
! Only save callsigns/grids from type 1 messages
                        if(index(wpart,'/').eq.0 .and. index(wpart,'<').eq.0) then
                           ifound=0
                           do i=1,nwcalls
                              if(index(wcalls(i),wpart).ne.0) ifound=1
                           enddo

                           if(ifound.eq.0) then ! This is a new callsign
                              new_callsign=.true.
                              if(nwcalls.lt.MAXWCALLS) then
                                 nwcalls=nwcalls+1
                                 wcalls(nwcalls)=wpart
                              else
                                 wcalls(1:nwcalls-1)=wcalls(2:nwcalls)
                                 wcalls(nwcalls)=wpart
                              endif
                           endif
                        endif
                     endif
3465                 continue

! If no decode then try Keff=50
                     iaptype=0
                     if( .not. unpk77_success .and. do_k50_decode ) then
                        maxosd=1
                        call timer('d240_74 ',0)
                        Keff=50
                        norder=4
                        call decode240_74(llr,Keff,maxosd,norder,apmask,message74,cw, &
                           ntype,nharderrors,dmin)
                        call timer('d240_74 ',1)
                        if(count(cw.eq.1).eq.0) then
                           nharderrors=-nharderrors
                           cycle
                        endif
                        write(c77,'(50i1)') message74(1:50)
                        c77(51:77)='000000000000000000000110000'
                        call unpack77(c77,1,msg,unpk77_success)
! No CRC in this mode, so only accept the decode if call/grid have been seen before
                        if(unpk77_success) then
                           unpk77_success=.false.
                           do i=1,nwcalls
                              if(index(msg,trim(wcalls(i))).gt.0) then
                                 unpk77_success=.true.
                              endif
                           enddo
                        endif
                     endif

                  endif

                  if(nharderrors .ge.0 .and. unpk77_success) then
                     idupe=0
                     do i=1,ndecodes
                        if(decodes(i).eq.msg) idupe=1
                     enddo
                     if(idupe.eq.1) goto 800
                     ndecodes=ndecodes+1
                     decodes(ndecodes)=msg

                     if(iwspr.eq.0) then
                        call get_fst4_tones_from_bits(message101,itone,0)
                     else
                        call get_fst4_tones_from_bits(message74,itone,1)
                     endif
                     inquire(file='plotspec',exist=plotspec_exists)
                     fmid=-999.0
                     call timer('dopsprd ',0)
                     if(plotspec_exists) then
                        call dopspread(itone,iwave,nsps,nmax,ndown,hmod,  &
                           isbest,fc_synced,fmid,w50)
                     endif
                     call timer('dopsprd ',1)
                     xsig=0
                     do i=1,NN
                        xsig=xsig+s4(itone(i),i)
                     enddo
                     base=candidates(icand,5)
                     select case(ntrperiod)
                        case(15) 
                           snr_calfac=800.0
                        case(30) 
                           snr_calfac=600.0
                        case(60) 
                           snr_calfac=430.0
                        case(120) 
                           snr_calfac=390.0
                        case(300) 
                           snr_calfac=340.0
                        case(900) 
                           snr_calfac=320.0
                        case(1800) 
                           snr_calfac=320.0
                        case default
                           snr_calfac=430.0
                     end select
                     arg=snr_calfac*xsig/base - 1.0
                     if(arg.gt.0.0) then
                        xsnr=10*log10(arg)+10*log10(1.46/2500)+10*log10(8200.0/nsps)
                     else
                        xsnr=-99.9
                     endif
                     nsnr=nint(xsnr)
                     qual=0.0
                     fsig=fc_synced - 1.5*baud
                     inquire(file=trim(data_dir)//'/decdata',exist=decdata_exists)
                     if(decdata_exists) then
                        hdec=0
                        where(llrs(:,1).ge.0.0) hdec=1
                        nhp=count(hdec.ne.cw) ! # hard errors wrt N=1 soft symbols
                        hd=sum(ieor(hdec,cw)*abs(llrs(:,1))) ! weighted distance wrt N=1 symbols
                        open(21,file=trim(data_dir)//'/fst4_decodes.dat',status='unknown',position='append')
                        write(21,3021) nutc,icand,itry,nsyncoh,iaptype,  &
                           ijitter,npct,ntype,Keff,nsync_qual,nharderrors,dmin,nhp,hd,  &
                           sync,xsnr,xdt,fsig,w50,trim(msg)
3021                    format(i6.6,i4,6i3,3i4,f6.1,i4,f6.1,f9.2,f6.1,f6.2,f7.1,f7.3,1x,a)
                        close(21)
                     endif
                     call this%callback(nutc,smax1,nsnr,xdt,fsig,msg,    &
                        iaptype,qual,ntrperiod,fmid,w50)
                     goto 800
                  endif
               enddo  ! metrics
            enddo  ! istart jitter
800      enddo !candidate list
      enddo ! noise blanker loop

      if(new_callsign .and. do_k50_decode) then ! re-write the fst4w_calls.txt file
         open(42,file=trim(data_dir)//'/fst4w_calls.txt',status='unknown')
         do i=1,nwcalls
            write(42,'(a20)') trim(wcalls(i))
         enddo
         close(42)
      endif

      return
   end subroutine decode

   subroutine sync_fst4(cd0,i0,f0,hmod,ncoh,np,nss,ntr,fs,sync)

! Compute sync power for a complex, downsampled FST4 signal.

      use timer_module, only: timer
      include 'fst4/fst4_params.f90'
      complex cd0(0:np-1)
      complex csync1,csync2,csynct1,csynct2
      complex ctwk(3200)
      complex z1,z2,z3,z4,z5
      integer hmod,isyncword1(0:7),isyncword2(0:7)
      real f0save
      common/sync240com/csync1(3200),csync2(3200),csynct1(3200),csynct2(3200)
      data isyncword1/0,1,3,2,1,0,2,3/
      data isyncword2/2,3,1,0,3,2,0,1/
      data f0save/-99.9/,nss0/-1/,ntr0/-1/
      save twopi,dt,fac,f0save,nss0,ntr0

      p(z1)=(real(z1*fac)**2 + aimag(z1*fac)**2)**0.5     !Compute power

      nz=8*nss
      call timer('sync240a',0)
      if(nss.ne.nss0 .or. ntr.ne.ntr0) then
         twopi=8.0*atan(1.0)
         dt=1/fs
         k=1
         phi1=0.0
         phi2=0.0
         do i=0,7
            dphi1=twopi*hmod*(isyncword1(i)-1.5)/real(nss)
            dphi2=twopi*hmod*(isyncword2(i)-1.5)/real(nss)
            do j=1,nss
               csync1(k)=cmplx(cos(phi1),sin(phi1))
               csync2(k)=cmplx(cos(phi2),sin(phi2))
               phi1=mod(phi1+dphi1,twopi)
               phi2=mod(phi2+dphi2,twopi)
               k=k+1
            enddo
         enddo
         fac=1.0/(8.0*nss)
         nss0=nss
         ntr0=ntr
         f0save=-1.e30
      endif

      if(f0.ne.f0save) then
         dphi=twopi*f0*dt
         phi=0.0
         do i=1,nz
            ctwk(i)=cmplx(cos(phi),sin(phi))
            phi=mod(phi+dphi,twopi)
         enddo
         csynct1(1:nz)=ctwk(1:nz)*csync1(1:nz)
         csynct2(1:nz)=ctwk(1:nz)*csync2(1:nz)
         f0save=f0
         nss0=nss
      endif
      call timer('sync240a',1)

      i1=i0                            !Costas arrays
      i2=i0+38*nss
      i3=i0+76*nss
      i4=i0+114*nss
      i5=i0+152*nss

      s1=0.0
      s2=0.0
      s3=0.0
      s4=0.0
      s5=0.0

      if(ncoh.gt.0) then
         nsec=8/ncoh
         do i=1,nsec
            is=(i-1)*ncoh*nss
            z1=0
            if(i1+is.ge.1) then
               z1=sum(cd0(i1+is:i1+is+ncoh*nss-1)*conjg(csynct1(is+1:is+ncoh*nss)))
            endif
            z2=sum(cd0(i2+is:i2+is+ncoh*nss-1)*conjg(csynct2(is+1:is+ncoh*nss)))
            z3=sum(cd0(i3+is:i3+is+ncoh*nss-1)*conjg(csynct1(is+1:is+ncoh*nss)))
            z4=sum(cd0(i4+is:i4+is+ncoh*nss-1)*conjg(csynct2(is+1:is+ncoh*nss)))
            z5=0
            if(i5+is+ncoh*nss-1.le.np) then
               z5=sum(cd0(i5+is:i5+is+ncoh*nss-1)*conjg(csynct1(is+1:is+ncoh*nss)))
            endif
            s1=s1+abs(z1)/nz
            s2=s2+abs(z2)/nz
            s3=s3+abs(z3)/nz
            s4=s4+abs(z4)/nz
            s5=s5+abs(z5)/nz
         enddo
      else
         nsub=-ncoh
         nps=nss/nsub
         do i=1,8
            do isub=1,nsub
               is=(i-1)*nss+(isub-1)*nps
               z1=0.0
               if(i1+is.ge.1) then
                  z1=sum(cd0(i1+is:i1+is+nps-1)*conjg(csynct1(is+1:is+nps)))
               endif
               z2=sum(cd0(i2+is:i2+is+nps-1)*conjg(csynct2(is+1:is+nps)))
               z3=sum(cd0(i3+is:i3+is+nps-1)*conjg(csynct1(is+1:is+nps)))
               z4=sum(cd0(i4+is:i4+is+nps-1)*conjg(csynct2(is+1:is+nps)))
               z5=0.0
               if(i5+is+ncoh*nss-1.le.np) then
                  z5=sum(cd0(i5+is:i5+is+nps-1)*conjg(csynct1(is+1:is+nps)))
               endif
               s1=s1+abs(z1)/(8*nss)
               s2=s2+abs(z2)/(8*nss)
               s3=s3+abs(z3)/(8*nss)
               s4=s4+abs(z4)/(8*nss)
               s5=s5+abs(z5)/(8*nss)
            enddo
         enddo
      endif
      sync = s1+s2+s3+s4+s5
      return
   end subroutine sync_fst4

   subroutine fst4_downsample(c_bigfft,nfft1,ndown,f0,sigbw,c1)

! Output: Complex data in c(), sampled at 12000/ndown Hz

      complex c_bigfft(0:nfft1/2)
      complex c1(0:nfft1/ndown-1)

      df=12000.0/nfft1
      i0=nint(f0/df)
      ih=nint( ( f0 + 1.3*sigbw/2.0 )/df)
      nbw=ih-i0+1
      c1=0.
      c1(0)=c_bigfft(i0)
      nfft2=nfft1/ndown
      do i=1,nbw
         if(i0+i.le.nfft1/2) c1(i)=c_bigfft(i0+i)
         if(i0-i.ge.0) c1(nfft2-i)=c_bigfft(i0-i)
      enddo
      c1=c1/nfft2
      call four2a(c1,nfft2,1,1,1)            !c2c FFT back to time domain
      return

   end subroutine fst4_downsample

   subroutine get_candidates_fst4(c_bigfft,nfft1,nsps,hmod,fs,fa,fb,nfa,nfb,   &
      minsync,ncand,candidates)

      complex c_bigfft(0:nfft1/2)              !Full length FFT of raw data
      integer hmod                             !Modulation index (submode)
      integer im(1)                            !For maxloc
      real candidates(200,5)                   !Candidate list
      real, allocatable :: s(:)                !Low resolution power spectrum
      real, allocatable :: s2(:)               !CCF of s() with 4 tones
      real, allocatable :: sbase(:)            !noise baseline estimate
      real xdb(-3:3)                           !Model 4-tone CCF peaks
      real minsync
      data xdb/0.25,0.50,0.75,1.0,0.75,0.50,0.25/

      nh1=nfft1/2
      df1=fs/nfft1
      baud=fs/nsps                             !Keying rate
      df2=baud/2.0
      nd=df2/df1                               !s() sums this many bins of big FFT
      ndh=nd/2
      ia=nint(max(100.0,fa)/df2)               !Low frequency search limit
      ib=nint(min(4800.0,fb)/df2)              !High frequency limit
      ina=nint(max(100.0,real(nfa))/df2)       !Low freq limit for noise baseline fit
      inb=nint(min(4800.0,real(nfb))/df2)      !High freq limit for noise fit
      if(ia.lt.ina) ia=ina
      if(ib.gt.inb) ib=inb

      nnw=nint(48000.*nsps*2./fs)
      allocate (s(nnw))
      s=0.                                  !Compute low-resolution power spectrum
      do i=ina,inb   ! noise analysis window includes signal analysis window
         j0=nint(i*df2/df1)
         do j=j0-ndh,j0+ndh
            s(i)=s(i) + real(c_bigfft(j))**2 + aimag(c_bigfft(j))**2
         enddo
      enddo

      ina=max(ina,1+3*hmod)                       !Don't run off the ends
      inb=min(inb,nnw-3*hmod)
      allocate (s2(nnw))
      allocate (sbase(nnw))
      s2=0.
      do i=ina,inb                                !Compute CCF of s() and 4 tones
         s2(i)=s(i-hmod*3) + s(i-hmod) +s(i+hmod) +s(i+hmod*3)
      enddo
      npctile=30
      call fst4_baseline(s2,nnw,ina+hmod*3,inb-hmod*3,npctile,sbase)
      if(any(sbase(ina:inb).le.0.0)) return
      s2(ina:inb)=s2(ina:inb)/sbase(ina:inb)             !Normalize wrt noise level

      ncand=0
      candidates=0
      if(ia.lt.3) ia=3
      if(ib.gt.nnw-2) ib=nnw-2

! Find candidates, using the CLEAN algorithm to remove a model of each one
! from s2() after it has been found.
      pval=99.99
      do while(ncand.lt.200)
         im=maxloc(s2(ia:ib))
         iploc=ia+im(1)-1                         !Index of CCF peak
         pval=s2(iploc)                           !Peak value
         if(pval.lt.minsync) exit
         do i=-3,+3                            !Remove 0.9 of a model CCF at
            k=iploc+2*hmod*i                   !this frequency from s2()
            if(k.ge.ia .and. k.le.ib) then
               s2(k)=max(0.,s2(k)-0.9*pval*xdb(i))
            endif
         enddo
         ncand=ncand+1
         candidates(ncand,1)=df2*iploc         !Candidate frequency
         candidates(ncand,2)=pval              !Rough estimate of SNR
         candidates(ncand,5)=sbase(iploc)
      enddo
      return
   end subroutine get_candidates_fst4

   subroutine fst4_sync_search(c2,nfft2,hmod,fs2,nss,ntrperiod,nsyncoh,emedelay,sbest,fcbest,isbest)
      complex c2(0:nfft2-1)
      integer hmod
      nspsec=int(fs2)
      baud=fs2/real(nss)
      fc1=0.0
      if(emedelay.lt.0.1) then  ! search offsets from 0 s to 2 s
         is0=1.5*nspsec
         ishw=1.5*nspsec
      else      ! search plus or minus 1.5 s centered on emedelay
         is0=nint((emedelay+1.0)*nspsec)
         ishw=1.5*nspsec
      endif

      sbest=-1.e30
      do if=-12,12
         fc=fc1 + 0.1*baud*if
         do istart=max(1,is0-ishw),is0+ishw,4*hmod
            call sync_fst4(c2,istart,fc,hmod,nsyncoh,nfft2,nss,   &
               ntrperiod,fs2,sync)
            if(sync.gt.sbest) then
               fcbest=fc
               isbest=istart
               sbest=sync
            endif
         enddo
      enddo

      fc1=fcbest
      is0=isbest
      ishw=4*hmod
      isst=1*hmod

      sbest=0.0
      do if=-7,7
         fc=fc1 + 0.02*baud*if
         do istart=max(1,is0-ishw),is0+ishw,isst
            call sync_fst4(c2,istart,fc,hmod,nsyncoh,nfft2,nss,   &
               ntrperiod,fs2,sync)
            if(sync.gt.sbest) then
               fcbest=fc
               isbest=istart
               sbest=sync
            endif
         enddo
      enddo
   end subroutine fst4_sync_search

   subroutine dopspread(itone,iwave,nsps,nmax,ndown,hmod,i0,fc,fmid,w50)

! On "plotspec" special request, compute Doppler spread for a decoded signal

      include 'fst4/fst4_params.f90'
      complex, allocatable :: cwave(:)       !Reconstructed complex signal
      complex, allocatable :: g(:)           !Channel gain, g(t) in QEX paper
      real,allocatable :: ss(:)              !Computed power spectrum of g(t)
      integer itone(160)                     !Tones for this message
      integer*2 iwave(nmax)                  !Raw Rx data
      integer hmod                           !Modulation index
      data ncall/0/
      save ncall

      ncall=ncall+1
      nfft=2*nmax
      nwave=max(nmax,(NN+2)*nsps)
      allocate(cwave(0:nwave-1))
      allocate(g(0:nfft-1))
      wave=0
      fsample=12000.0
      call gen_fst4wave(itone,NN,nsps,nwave,fsample,hmod,fc,1,cwave,wave)
      cwave=cshift(cwave,-i0*ndown)
      fac=1.0/32768
      g(0:nmax-1)=fac*float(iwave)*conjg(cwave(:nmax-1))
      g(nmax:)=0.
      call four2a(g,nfft,1,-1,1)         !Forward c2c FFT

      df=12000.0/nfft
      ia=1.0/df
      smax=0.
      do i=-ia,ia                        !Find smax in +/- 1 Hz around 0.
         j=i
         if(j.lt.0) j=i+nfft
         s=real(g(j))**2 + aimag(g(j))**2
         smax=max(s,smax)
      enddo

      ia=10.1/df
      allocate(ss(-ia:ia))               !Allocate space for +/- 10 Hz
      sum1=0.
      sum2=0.
      nns=0
      do i=-ia,ia
         j=i
         if(j.lt.0) j=i+nfft
         ss(i)=(real(g(j))**2 + aimag(g(j))**2)/smax
         f=i*df
         if(f.ge.-4.0 .and. f.le.-2.0) then
            sum1=sum1 + ss(i)                  !Power between -2 and -4 Hz
            nns=nns+1
         else if(f.ge.2.0 .and. f.le.4.0) then
            sum2=sum2 + ss(i)                  !Power between +2 and +4 Hz
         endif
      enddo
      avg=min(sum1/nns,sum2/nns)               !Compute avg from smaller sum

      sum1=0.
      do i=-ia,ia
         f=i*df
         if(abs(f).le.1.0) sum1=sum1 + ss(i)-avg !Power in abs(f) < 1 Hz
      enddo

      ia=nint(1.0/df) + 1
      sum2=0.0
      xi1=-999
      xi2=-999
      xi3=-999
      sum2z=0.
      do i=-ia,ia                !Find freq range that has 50% of signal power
         sum2=sum2 + ss(i)-avg
         if(sum2.ge.0.25*sum1 .and. xi1.eq.-999.0) then
            xi1=i - 1 + (0.25*sum1-sum2)/(sum2-sum2z)
         endif
         if(sum2.ge.0.50*sum1 .and. xi2.eq.-999.0) then
            xi2=i - 1 + (sum2-0.50*sum1)/(sum2-sum2z)
         endif
         if(sum2.ge.0.75*sum1) then
            xi3=i - 1 + (sum2-0.75*sum1)/(sum2-sum2z)
            exit
         endif
         sum2z=sum2
      enddo
      xdiff=sqrt(1.0+(xi3-xi1)**2) !Keep small values from fluctuating too widely
      w50=xdiff*df                 !Compute Doppler spread
      fmid=xi2*df                  !Frequency midpoint of signal powere

      do i=-ia,ia                          !Save the spectrum for plotting
         y=ncall-1
         j=i+nint(xi2)
         if(abs(j*df).lt.10.0) y=0.99*ss(i+nint(xi2)) + ncall-1
         write(52,1010) i*df,y
1010     format(f12.6,f12.6)
      enddo

      return
   end subroutine dopspread

end module fst4_decode

module m65_mod

use iso_c_binding, only: c_int8_t,c_int,c_loc, c_ptr
use decodes_mod, only: nhsym1,nhsym2,ldecoded

implicit none

contains

subroutine m65c() bind(C)
  use decode0_mod
  use npar_ptrs_mod, only: nhsym, nrxlog, datetime
  integer :: npatience, nstandalone
  
  npatience=1
  if(nhsym.eq.nhsym1 .and. iand(nrxlog,1).ne.0) then
     write(21,1000) datetime(1:17)
1000 format(/'UTC Date: ', a17, /78('-'))
     flush(21)
  endif
  if(iand(nrxlog,2).ne.0) rewind(21)
  if(iand(nrxlog,4).ne.0) then
     if(nhsym.eq.nhsym1) rewind(26)
     if(nhsym.eq.nhsym2) backspace(26)
  endif

  nstandalone=0

      call decode0(nstandalone)

end subroutine m65c
end module m65_mod

subroutine get_spectrum_baseline(dd,nfa,nfb,sbase)

  include 'ft8_params.f90'
  parameter(NST=NFFT1/2,NF=93)              !NF=NMAX/NST-1
  real s(NH1,NF)
  real savg(NH1)
  real sbase(NH1)
  real x(NFFT1)
  real window(NFFT1)
  complex cx(0:NH1)
  real dd(NMAX)
  equivalence (x,cx)
  logical first
  data first/.true./
  save first,window

  if(first) then
    first=.false.
    pi=4.0*atan(1.)
    window=0.
    call nuttal_window(window,NFFT1)
    window=window/sum(window)*NSPS*2/300.0
  endif

! Compute symbol spectra, stepping by NSTEP steps.  
  savg=0.
  df=12000.0/NFFT1  
  do j=1,NF
     ia=(j-1)*NST + 1
     ib=ia+NFFT1-1
     if(ib.gt.NMAX) exit
     x=dd(ia:ib)*window
     call four2a(x,NFFT1,1,-1,0)              !r2c FFT
     s(1:NH1,j)=abs(cx(1:NH1))**2
     savg=savg + s(1:NH1,j)                   !Average spectrum
  enddo

  nwin=nfb-nfa
  if(nfa.lt.100) then
     nfa=100
     if(nwin.lt.100) then ! nagain
        nfb=nfa+nwin  
     endif
  endif
  if(nfb.gt.4910) then
     nfb=4910
     if(nwin.lt.100) then 
        nfa=nfb-nwin
     endif
  endif
  call baseline(savg,nfa,nfb,sbase)

return
end subroutine get_spectrum_baseline

subroutine get_crc14(mc,len,ncrc)
!
! 1. To calculate 14-bit CRC, mc(1:len-14) is the message and mc(len-13:len) are zero.
! 2. To check a received CRC, mc(1:len is the received message plus CRC.
!    ncrc will be zero if the received message/CRC are consistent
!  
  character c14*14
  integer*1 mc(len)
  integer*1 r(15),p(15)
  integer ncrc
! polynomial for 14-bit CRC 0x6757
  data p/1,1,0,0,1,1,1,0,1,0,1,0,1,1,1/
  
! divide by polynomial
  r=mc(1:15)
  do i=0,len-15
    r(15)=mc(i+15)
    r=mod(r+r(1)*p,2)
    r=cshift(r,1)
  enddo

  write(c14,'(14b1)') r(1:14)
  read(c14,'(b14.14)') ncrc

end subroutine get_crc14

subroutine platanh(x,y)
  isign=+1
  z=x
  if( x.lt.0 ) then
    isign=-1
    z=abs(x)
  endif
  if( z.le. 0.664 ) then
    y=x/0.83
    return
  elseif( z.le. 0.9217 ) then
    y=isign*(z-0.4064)/0.322
    return
  elseif( z.le. 0.9951 ) then
    y=isign*(z-0.8378)/0.0524
    return
  elseif( z.le. 0.9998 ) then
    y=isign*(z-0.9914)/0.0012
    return
  else
    y=isign*7.0
    return
  endif
end subroutine platanh

subroutine azdist(MyGrid,HisGrid,utch,nAz,nEl,nDmiles,nDkm,nHotAz,nHotABetter)

  character(len=*) :: MyGrid,HisGrid
  character*6 mygrid0,hisgrid0
  real*8 utch,utch0
  logical HotABetter,IamEast
  real eltab(22),daztab(22)
  data eltab/18.,15.,13.,11.,9.,8.,7.,6.,5.3,4.7,4.,3.3,2.7,    &
       2.,1.5,1.,0.8,0.6,0.4,0.2,0.0,0.0/
  data daztab/21.,18.,16.,15.,14.,13.,12.,11.,10.7,10.3,10.,    &
       10.,10.,10.,10.,10.,10.,9.,9.,9.,8.,8./
  data mygrid0/"      "/,hisgrid0/"      "/,utch0/-999.d0/
  save

  if(MyGrid.eq.HisGrid) then
     naz=0
     nel=0
     ndmiles=0
     ndkm=0
     nhotaz=0
     nhotabetter=1
     go to 999
  endif

  if(mygrid.eq.mygrid0 .and. hisgrid.eq.hisgrid0 .and.              &
       abs(utch-utch0).lt.0.1666667d0) go to 900
  utch0=utch
  mygrid0=mygrid
  hisgrid0=hisgrid
  utchours=utch

  if(MyGrid(5:5).eq.' ') MyGrid(5:5)='m'
  if(MyGrid(6:6).eq.' ') MyGrid(6:6)='m'
  if(HisGrid(5:5).eq.' ') HisGrid(5:5)='m'
  if(HisGrid(6:6).eq.' ') HisGrid(6:6)='m'

  if(MyGrid.eq.HisGrid) then
     Az=0.
     Dmiles=0.
     Dkm=0.0
     El=0.
     HotA=0.
     HotB=0.
     HotABetter=.true.
     go to 900
  endif
  call grid2deg(MyGrid,dlong1,dlat1)
  call grid2deg(HisGrid,dlong2,dlat2)
  eps=1.e-6
  Az=0.
  Dmiles=0.
  Dkm=0.0
  El=0.
  HotA=0.
  HotB=0.
  HotABetter=.true.
  if(abs(dlat1-dlat2).lt.eps .and. abs(dlong1-dlong2).lt.eps) go to 900

  difflong=mod(dlong1-dlong2+720.0,360.0)
  if(abs(dlat1+dlat2).lt.eps .and. abs(difflong-180.0).lt.eps) then
! Antipodes
     Dkm=20400
     go to 900
  endif

  call geodist(dlat1,dlong1,dlat2,dlong2,Az,Baz,Dkm)

  ndkm=Dkm/100
  j=ndkm-4
  if(j.lt.1) j=1
  if(j.gt.21)j=21
  if(Dkm.lt.500.0) then
     El=18.0
  else
     u=(Dkm-100.0*ndkm)/100.0
     El=(1.0-u)*eltab(j) + u*eltab(j+1)
  endif

  daz=daztab(j) + u * (daztab(j+1)-daztab(j))
  Dmiles=Dkm/1.609344

  tmid=mod(UTChours-0.5*(dlong1+dlong2)/15.0+48.0,24.0)
  IamEast=.false.
  if(dlong1.lt.dlong2) IamEast=.true.
  if(dlong1.eq.dlong2 .and. dlat1.gt.dlat2) IamEast=.false.
  azEast=baz
  if(IamEast) azEast=az
  if((azEast.ge.45.0 .and. azEast.lt.135.0) .or.                    &
       (azEast.ge.225.0 .and. azEast.lt.315.0)) then
! The path will be taken as "east-west".
     HotABetter=.true.
     if(abs(tmid-6.0).lt.6.0) HotABetter=.false.
     if((dlat1+dlat2)/2.0 .lt. 0.0) HotABetter=.not.HotABetter
  else
! The path will be taken as "north-south".
     HotABetter=.false.
     if(abs(tmid-12.0).lt.6.0) HotABetter=.true.
  endif
  if(IamEast) then
     HotA = Az - daz
     HotB = Az + daz
  else
     HotA = Az + daz
     HotB = Az - daz
  endif
  if(HotA.lt.0.0)   HotA=HotA+360.0
  if(HotA.gt.360.0) HotA=HotA-360.0
  if(HotB.lt.0.0)   HotB=HotB+360.0
  if(HotB.gt.360.0) HotB=HotB-360.0

900 continue
  naz=nint(Az)
  nel=nint(el)
  nDmiles=nint(Dmiles)
  nDkm=nint(Dkm)
  nHotAz=nint(HotB)
  nHotABetter=0
  if(HotABetter) then
     nHotAz=nint(HotA)
     nHotABetter=1
  endif

999 return
end subroutine azdist

subroutine grid2k(grid,k)

  character*6 grid

  call grid2deg(grid,xlong,xlat)
  nlong=nint(xlong)
  nlat=nint(xlat)
  k=0
  if(nlat.ge.85) k=5*(nlong+179)/2 + nlat-84

  return
end subroutine grid2k

subroutine imopen(plotfile)
  character*(*) plotfile
  common/imcom/ lu,npage

  lu=80
  open(lu,file=plotfile,status='unknown')
  write(lu,1000) 
1000 format('%!PS-Adobe-2.0'/                                            &
          '/rightshow { dup stringwidth pop neg 0 rmoveto show } def'/   &
          '/centershow { dup stringwidth pop neg 2 div ',                &
          '0 rmoveto show } def'/                                        &
          '/lt { lineto } def'/'%%Page: 1 1')
  npage=1

  return
end subroutine imopen

subroutine impalette(palette)
  character*(*) palette
  integer r(0:8),g(0:8),b(0:8)
  integer rr,gg,bb
  common/imcom/ lu,npage
  common/imcom2/rr(0:255),gg(0:255),bb(0:255)

  if(palette.eq.'afmhot') then
     do i=0,255
        j=255-i
        rr(i)=min(255,2*j)
        gg(i)=max(0,min(255,2*j-128))
        bb(i)=max(0,min(255,2*j-256))
     enddo
  else if(palette.eq.'hot') then
     do i=0,255
        j=255-i
        rr(i)=min(255,3*j)
        gg(i)=max(0,min(255,3*j-256))
        bb(i)=max(0,min(255,3*j-512))
     enddo
  else
     open(11,file="Palettes/"//palette,status="old")
     do j=0,8
        read(11,*) r(j),g(j),b(j)
     enddo
     close(11)
     do i=0,255
        j0=i/32
        j1=j0+1
        k=i-32*j0
        rr(i)=r(j0) + int((k*(r(j1)-r(j0)))/31 + 0.5)
        gg(i)=g(j0) + int((k*(g(j1)-g(j0)))/31 + 0.5)
        bb(i)=b(j0) + int((k*(b(j1)-b(j0)))/31 + 0.5)
     enddo

  endif

  return
end subroutine impalette

subroutine imclose
  common/imcom/ lu,npage
  write(lu,1000)
1000 format('showpage'/'%%Trailer')
  close(lu)
  return
end subroutine imclose

subroutine imnewpage
  common/imcom/ lu,npage
  npage=npage+1
  write(lu,1000) npage,npage
1000 format('showpage'/'%%Page:',2i4)
  return
end subroutine imnewpage

subroutine imxline(x,y,dx)
! Draw a line from (x,y) to (x+dx,y)  integer r,g,b
  common/imcom/ lu,npage
  write(lu,1000) 72.0*x,72.0*y,72.0*dx
1000 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto stroke')
  return
end subroutine imxline

subroutine imyline(x,y,dy)
! Draw a line from (x,y) to (x,y+dy)
  common/imcom/ lu,npage
  write(lu,1000) 72.0*x,72.0*y,72.0*dy
1000 format('newpath',2f7.1,' moveto 0',f7.1,' rlineto stroke')
  return
end subroutine imyline

subroutine imwidth(width)
  common/imcom/ lu,npage
  write(lu,1000) width
1000 format(f7.1,' setlinewidth')
  return
end subroutine imwidth

subroutine imfont(fontname,npoints)
  character*(*) fontname
  common/imcom/ lu,npage
  write(lu,1000) fontname,npoints
1000 format('/',a,' findfont',i4,' scalefont setfont')
  return
end subroutine imfont

subroutine imstring(string,x,y,just,ndeg)
  character*(*) string
  common/imcom/ lu,npage
  write(lu,1000) 72.0*x,72.0*y,ndeg,string
1000 format(2f7.1,' moveto',i4,' rotate'/'(',a,')')
  if(just.eq.1) write(lu,*) 'rightshow'
  if(just.eq.2) write(lu,*) 'centershow'
  if(just.eq.3) write(lu,*) 'show'
  write(lu,1010) -ndeg
1010 format(i4,' rotate'/)
  return
end subroutine imstring

subroutine imr4mat(z,IP,JP,imax,jmax,zz1,zz2,x,y,dx,dy,nbox)
  real z(IP,JP)
  integer idat(2048)
  common/imcom/ lu,npage

  z1=zz1
  z2=zz2
  if(z1.eq.0.0 .and. z2.eq.0.0) then
     z1=z(1,1)
     z2=z1
     do i=1,imax
        do j=1,jmax
           z1=min(z(i,j),z1)
           z2=max(z(i,j),z2)
        enddo
     enddo
  endif
  scale=255.99/(z2-z1)

  write(lu,1002) 72.0*x,72.0*y,72.0*dx,72.0*dy
1002 format(2f7.1,' translate',2f7.1,' scale')
  write(lu,*) imax,jmax,8,' [',imax,0,0,jmax,0,0,']'
  write(lu,*) '{<'

  do j=1,jmax
     do i=1,imax
        idat(i)=scale*(z(i,j)-z1)
        idat(i)=max(idat(i),0)
        idat(i)=min(idat(i),255)
        idat(i)=255-idat(i)
     enddo
     write(lu,1004) (idat(i),i=1,imax)
1004 format(30z2.2)
  enddo
  write(lu,*) '>} image'
  write(lu,1006) 1.0/(72.0*dx),1.0/(72.0*dy),-72.0*x,-72.0*y
1006 format(2f9.6,' scale',2f7.1,' translate')

  if(nbox.ne.0) then
     write(lu,1010) 72.0*x,72.0*y,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',             &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4mat

subroutine imr4mat_color(z,IP,JP,imax,jmax,zz1,zz2,x,y,dx,dy,nbox)
  real z(IP,JP)
  integer idat(2048,3)
  integer rr,gg,bb
  common/imcom/ lu,npage
  common/imcom2/rr(0:255),gg(0:255),bb(0:255)

  z1=zz1
  z2=zz2
  if(z1.eq.0.0 .and. z2.eq.0.0) then
     z1=z(1,1)
     z2=z1
     do i=1,imax
        do j=1,jmax
           z1=min(z(i,j),z1)
           z2=max(z(i,j),z2)
        enddo
     enddo
  endif
  scale=255.99/(z2-z1)

  write(lu,1002) 72.0*x,72.0*y,72.0*dx,72.0*dy
1002 format(2f7.1,' translate',2f7.1,' scale')
  write(lu,1003) imax,jmax,8,imax,0,0,jmax,0,0
1003 format(3i5,' [',6i4,']')
  write(lu,1004) imax
1004 format('{currentfile 3',i4,' mul string readhexstring pop} bind'/   &
          'false 3 colorimage')

  do j=1,jmax
     do i=1,imax
        n=scale*(z(i,j)-z1)
        n=max(n,0)
        n=min(n,255)
        idat(i,1)=rr(n)
        idat(i,2)=gg(n)
        idat(i,3)=bb(n)
     enddo
     write(lu,1005) (idat(i,1),idat(i,2),idat(i,3),i=1,imax)
1005 format(30z2.2)
  enddo

  write(lu,1006) 1.0/(72.0*dx),1.0/(72.0*dy),-72.0*x,-72.0*y
1006 format(2f9.6,' scale',2f7.1,' translate')

  if(nbox.ne.0) then
     write(lu,1010) 72.0*x,72.0*y,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',             &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4mat_color

subroutine imr4pro(p,imax,yy1,yy2,x,y,dx,dy,nbox)
  real p(imax)
  common/imcom/ lu,npage

  y1=yy1
  y2=yy2
  if(y1.eq.0.0 .and. y2.eq.0.0) then
     y1=p(1)
     y2=y1
     do i=1,imax
        y1=min(p(i),y1)
        y2=max(p(i),y2)
     enddo
  endif

  xscale=72.0*dx/imax
  xoff=72.0*x
  yscale=72.0*dy
  if(y1.ne.y2) yscale=yscale/(y2-y1)
  yoff=72.0*y

  write(lu,*) '1.416 setmiterlimit'
  write(lu,1002) xoff+0.5*xscale,yoff+yscale*(p(1)-y1)
1002 format('newpath',2f7.1,' moveto')

  do i=2,imax
     write(lu,1004) xoff+(i-0.5)*xscale,yoff+yscale*(p(i)-y1)
1004 format(2f6.1,' lt')
  enddo
  write(lu,*) 'stroke'

  if(nbox.ne.0) then
     write(lu,1010) xoff,yoff,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',               &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4pro

subroutine imline(x1,y1,x2,y2)
  common/imcom/ lu,npage
  write(lu,1000) 72*x1,72*y1,72*x2,72*y2
1000 format('newpath',2f7.1,' moveto',2f7.1,' lineto stroke')
  return
end subroutine imline

subroutine imcircle(x,y,radius,shade)
  common/imcom/ lu,npage
  write(lu,1000) shade
1000 format(f7.1,' setgray')
  write(lu,1002) 72*x,72*y,72*radius
1002 format('newpath',3f7.1,' 0 360 arc fill')
  write(lu,1000) 0.0
  write(lu,1004) 72*x,72*y,72*radius
1004 format('newpath',3f7.1,' 0 360 arc stroke')
  return
end subroutine imcircle

subroutine imtriangle(x,y,rr,shade)
  common/imcom/ lu,npage
  write(lu,1000) shade
1000 format(f7.1,' setgray')
  write(lu,1002) 72*x,72*(y+rr)
1002 format('newpath',2f7.1,' moveto ')
  write(lu,1004) 72*(x-rr),72*(y-rr)
1004 format(2f7.1,' lineto ')
  write(lu,1004) 72*(x+rr),72*(y-rr)
  write(lu,*) 'closepath fill 0 setgray'
  write(lu,1002) 72*x,72*(y+rr)
  write(lu,1004) 72*(x-rr),72*(y-rr)
  write(lu,1004) 72*(x+rr),72*(y-rr)
  write(lu,*) 'closepath stroke'
  
  return
end subroutine imtriangle

subroutine imr4prov(p,jmax,xx1,xx2,x,y,dx,dy,nbox)
  real p(jmax)
  common/imcom/ lu,npage

  x1=xx1
  x2=xx2
  if(x1.eq.0.0 .and. x2.eq.0.0) then
     x1=p(1)
     x2=x1
     do j=1,jmax
        x1=min(p(j),x1)
        x2=max(p(j),x2)
     enddo
  endif

  xscale=72.0*dx
  xoff=72.0*x
  if(x1.ne.x2) xscale=xscale/(x2-x1)

  yscale=72.0*dy/jmax
  yoff=72.0*y
  
  write(lu,*) '1.416 setmiterlimit'
  write(lu,1002) xoff+xscale*(x2-p(1)),yoff+0.5*yscale
1002 format('newpath',2f7.1,' moveto')
  
  do j=2,jmax
     write(lu,1004) xoff+xscale*(x2-p(j)),yoff+(j-0.5)*yscale
1004 format(2f6.1,' lt')
  enddo
  write(lu,*) 'stroke'

  if(nbox.ne.0) then
     write(lu,1010) xoff,yoff,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',            &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4prov

module map65a_mod
   use txpol_mod
   use trimlist_mod
   use iso_fortran_env, only: real64
   implicit none
contains

   subroutine map65a(dd, newdat, nutc, fcenter, ntol, idphi, nfa, nfb, &
                     mousedf, mousefqso, nagain, ndecdone, nfshift, ndphi, max_drift, &
                     nfcal, nkeep, mcall3b, nsum, nsave, nxant, mycall, mygrid, &
                     neme, ndepth, nstandalone, hiscall, hisgrid, nhsym, nfsample, &
                     ndiskdat, nxpol, nmode, ndop00)
!  Processes timf2 data from Linrad to find and decode JT65 signals.
      use iso_c_binding
      use wideband_sync
      use timer_module, only: timer
      use debug_log
      use q65b_mod
      use decode1a_mod
      use ccf65_legacy_mod
      use pctile_mod
      use stdout_channel_mod, only: write_stdout
      use decodes_mod, only: nhsym1, nhsym2, ldecoded, ndecodes, mcall3a, decodes_init
      use display_mod
      use timf2_mod
      use getdphi_mod
      use datcom_ptrs_mod, only: ss, savg
      use sec0_mod, only: sec0

      implicit none
    
      integer, parameter :: MAXMSG = 1000            !Size of decoded message list
      integer, parameter :: NSMAX = 60*96000
      real,    intent(in)    :: dd(4,NSMAX)
    !  real*4,  intent(in)    :: ss(4,322,NFFT), savg(4,NFFT)

      integer, intent(inout) :: newdat
      integer, intent(inout) :: nutc
      real(real64),  intent(in)    :: fcenter
      integer, intent(in)    :: ntol, idphi, nfa, nfb
      integer, intent(in)    :: mousedf, mousefqso, nagain
      integer, intent(inout) :: ndecdone
      integer, intent(in)    :: nfshift
      integer, intent(inout) :: ndphi
      integer, intent(in)    :: max_drift, nfcal, nkeep
      integer, intent(inout) :: mcall3b
      integer, intent(inout) :: nsum, nsave
      integer, intent(in)    :: nxant
      character(len=12), intent(in) :: mycall, hiscall
      character(len=6),  intent(in) :: mygrid, hisgrid
      integer, intent(in)    :: neme, ndepth, nstandalone
      integer, intent(in)    :: nhsym, nfsample, ndiskdat, nxpol, nmode, ndop00

      real tavg(-50:50)                  !Temp for finding local base level
      real base(4)                       !Local basel level at 4 pol'ns
      real sig(MAXMSG, 30)                !Parameters of detected signals
      real a(5)
      real :: df, dphi, dt, dt2, fa, fb, flip, flipk, foffset, freq, freq0, fshort
      real :: ftol, pol, qual, s2db, smax, snr2, ssmax, sync1, sync10, sync2, syncshort
      real :: tdec, thresh0, thresh1, tsec0, fshort0, fqso, syncshort0
      real(real64) :: f0
      character(len=22) msg(MAXMSG)
      character(len=3) shmsg0(4)
      character(len=1) :: cp, cm
      integer indx(MAXMSG), nsiz(MAXMSG)
      integer :: ipol, mode65
      integer :: i, ia, ib, i0, icand, idf, ifile, ifile0, ifreq, ii, iii, ikhz, ilatest, iloop
      integer :: ip000, ip001, ipol2, j, jp, jpmax, jpz, k, km, m, mfa, mfb, mhz, mode_q65
      integer :: mousefqso0, n, ncand, ndf, ndf0, ndf1, ndf2, nfile, nflip, nhist
      integer :: nhzdiff, nid, nkhz, nkm, nkv, noffset, npol, nqd, nqual, nsync1
      integer :: nsync2, ntry, nts_jt65, nts_q65, ntxpol, nutc0, nwrite, nwrite_q65, nz
      integer :: idec
      logical done(MAXMSG)
      logical xpol, bq65, q65b_called
      logical candec(MAX_CANDIDATES)
      character(len=22) decoded
      character(len=22) blank 
      character(len=2) cmode
      real short(3, NFFT)                 !SNR dt ipol for potential shorthands
      real qphi(12)
      type(candidate) :: cand(MAX_CANDIDATES)
      real(real64) :: f00
      character(len=256) :: line

      logical :: m65_inited = .false.     ! added with modernization
     
      data blank/'                      '/, cm/'#'/
      data shmsg0/'ATT', 'RO ', 'RRR', '73 '/
      data nfile/0/, nutc0/-999/, nid/0/, ip000/1/, ip001/1/, mousefqso0/-999/
      save

      if (.not. m65_inited) then
         call decodes_init()
         call init_wideband_sync(NFFT)
         m65_inited = .true.
      endif
     
      rewind 12
      ndecodes = 0

      ipol = 1

! Clean start for Q65 at early decode
      if (nhsym .eq. nhsym1 .or. nagain .ne. 0) ldecoded = .false.
      if (ndiskdat .eq. 1) ldecoded = .false.

      nkhz_center = nint(1000.0*(fcenter - int(fcenter)))
      mfa = nfa - nkhz_center + 48
      mfb = nfb - nkhz_center + 48
      mode65 = mod(nmode, 10)
      if (mode65 .eq. 3) mode65 = 4
      mode_q65 = nmode/10      
      nts_jt65 = mode65                     !JT65 tone separation factor
      nts_q65 = 2**(mode_q65 - 1)             !Q65 tone separation factor
      xpol = (nxpol .ne. 0)

! No second decode for JT65?
      if (nhsym .eq. nhsym2 .and. nagain .eq. 0 .and. ndiskdat .eq. 0) mode65 = 0

      if (nagain .eq. 0) then
         call timer('get_cand', 0)
         call get_candidates(ss, savg, xpol, nhsym, mfa, mfb, nts_jt65, nts_q65, cand, ncand)
         call timer('get_cand', 1)
         candec = .false.
      endif
!###
!  do k=1,ncand
!     freq=cand(k)%f+nkhz_center-48.0
!     ipk=cand(k)%indx
!     write(71,3071) k,db(cand(k)%snr),freq,cand(k)%xdt,    &
!          cand(k)%ipol,cand(k)%iflip,ipk,ldecoded(ipk)
!3071 format(i3,f8.2,f10.3,f8.2,2i3,i6,L4)
!  enddo
!###

      nwrite_q65 = 0
      bq65 = mode_q65 .gt. 0

      mcall3a = mcall3b
      mousefqso0 = mousefqso
      if (.not. xpol) ndphi = 0
      nsum = 0

!### Should use AppDir! ###
      open (23, file='CALL3.TXT', status='unknown')

      df = 96000.0/NFFT                    !df = 96000/NFFT = 2.930 Hz
      if (nfsample .eq. 95238) df = 95238.1/NFFT
      ftol = 0.010                          !Frequency tolerance (kHz)
      dphi = idphi/57.2957795
      foffset = 0.001*(1270 + nfcal)              !Offset from sync tone, plus CAL
      fqso = mousefqso + foffset - 0.5*(nfa + nfb) + nfshift !fqso at baseband (khz)
      iloop = 0

2     if (ndphi .eq. 1) dphi = 30*iloop/57.2957795

      if (nutc .ne. nutc0) nfile = nfile + 1
      nutc0 = nutc

      do nqd = 1, 0, -1
         if (nqd .eq. 1) then                     !Quick decode, at fQSO
            fa = 1000.0*(fqso + 0.001*mousedf) - ntol
            fb = 1000.0*(fqso + 0.001*mousedf) + ntol + 4*53.8330078
         else                                  !Wideband decode at all freqs
            fa = -1000*0.5*(nfb - nfa) + 1000*nfshift
            fb = 1000*0.5*(nfb - nfa) + 1000*nfshift
         endif
         ia = nint(fa/df) + 16385
         ib = nint(fb/df) + 16385
         ia = max(51, ia)
         ib = min(32768 - 51, ib)
         if (ndiskdat .eq. 1 .and. mode65 .eq. 0) ib = ia

         km = 0
         nkm = 1
         nz = n/8
         freq0 = -999.
         sync10 = -999.
         fshort0 = -999.
         syncshort0 = -999.
         ntry = 0
         short = 0.                                 !Zero the whole short array
         jpz = 1
         if (xpol) jpz = 4

! First steps for JT65 decoding
      !   open(unit=97, file='map65a_bins_all_MODERN.log', status='unknown', position='append')
      !   open(unit=98, file='map65a_bins_accept_MODERN.log', status='unknown', position='append')

         do i = ia, ib                               !Search over freq range
            freq = 0.001*(i - 16385)*df
!  Find the local base level for each polarization; update every 10 bins.
            if (mod(i - ia, 10) .eq. 0) then
               do jp = 1, jpz
                  do ii = -50, 50
                     iii = i + ii
                     if (iii .ge. 1 .and. iii .le. 32768) then
                        tavg(ii) = savg(jp, iii)
                     else
                        write (13, *) 'Error in iii:', iii, ia, ib, fa, fb
                        flush (13)
                        go to 900
                     endif
                  enddo
                  call pctile(tavg, 101, 50, base(jp))
               enddo
            endif

!  Find max signal at this frequency
            smax = 0.
            jpmax = 1
            do jp = 1, jpz
               if (savg(jp, i)/base(jp) .gt. smax) then
                  smax = savg(jp, i)/base(jp)
                  jpmax = jp
               endif
            enddo
            
          !  if (smax .gt. 1.08 .and. smax < 1.20) then
          !    ! Log ALL bins for comparison (legacy + modern)
          !    write(97,'(i10,1x,f10.3,1x,i4,1x,i4,1x,f8.3,1x,f10.1,1x,f10.1,1x,i6,1x,i4)') &
          !         nutc, freq, nkv, km, smax, savg(jpmax,i), base(jpmax), i, jpmax
          !  endif
 
            if (smax .gt. 1.1 .or. ia .eq. ib) then

          !  ! Log the values actually used by DECODE1A
          !  write(98,'(i10,1x,f10.3,1x,i4,1x,i4,1x,f8.3,1x,f10.1,1x,f10.1,1x,i6,1x,i4)') &
          !      nutc, freq, nkv, km, smax, savg(jpmax,i), base(jpmax), i, jpmax
            
!  Look for JT65 sync patterns and shorthand square-wave patterns.
               call timer('ccf65   ', 0)
               ssmax = 1.e30
               call ccf65(ss(:,:,i), nhsym, ssmax, sync1, ipol, jpz, dt, &
                          flipk, syncshort, snr2, ipol2, dt2)
!###           if(dt.lt.-2.6 .or. dt.gt.2.5) sync1=-99.0  !###
               call timer('ccf65   ', 1)
               if (mode65 .eq. 0) syncshort = -99.0     !If "No JT65", don't waste time

! ########################### Search for Shorthand Messages #################
!  Is there a shorthand tone above threshold?
               thresh0 = 1.0
!  Use lower thresh0 at fQSO
               if (nqd .eq. 1 .and. ntol .le. 100) thresh0 = 0.
               if (syncshort .gt. thresh0) then
! ### Do shorthand AFC here (or maybe after finding a pair?) ###
                  short(1, i) = syncshort
                  short(2, i) = dt2
                  short(3, i) = ipol2

!  Check to see if lower tone of shorthand pair was found.
                  do j = 2, 4
                     i0 = i - nint(j*mode65*10.0*(11025.0/4096.0)/df)
!  Should this be i0 +/- 1, or just i0?
!  Should we also insist that difference in DT be either 1.5 or -1.5 s?
                     if (short(1, i0) .gt. thresh0) then
                        fshort = 0.001*(i0 - 16385)*df
                        noffset = 0
                        if (nqd .eq. 1) noffset = nint(1000.0*(fshort - fqso) - mousedf)
                        if (abs(noffset) .le. ntol) then
!  Keep only the best candidate within ftol.
!### NB: sync2 was not defined here!
!                       sync2=syncshort                   !### try this ???
                           if (fshort - fshort0 .le. ftol .and. &
                            syncshort.gt.syncshort0 .and. nkm.eq.2) km=km-1
                           if (fshort - fshort0 .gt. ftol .or. &
                               syncshort .gt. syncshort0) then
                              if (km .lt. MAXMSG) km = km + 1
                              sig(km, 1) = nfile
                              sig(km, 2) = nutc
                              sig(km, 3) = fshort + 0.5*(nfa + nfb)
                              sig(km, 4) = syncshort
                              sig(km, 5) = dt2
                              sig(km, 6) = 45*(ipol2 - 1)/57.2957795
                              sig(km, 7) = 0
                              sig(km, 8) = snr2
                              sig(km, 9) = 0
                              sig(km, 10) = 0
!                           sig(km,11)=rms0
                              sig(km, 12) = savg(ipol2, i)
                              sig(km, 13) = 0
                              sig(km, 14) = 0
                              sig(km, 15) = 0
                              sig(km, 16) = 0
!                           sig(km,17)=0
                              sig(km, 18) = 0
                              msg(km) = shmsg0(j)
                             
                              fshort0 = fshort
                              syncshort0 = syncshort
                              nkm = 2
                           endif
                        endif
                     endif
                  enddo
               endif

! ########################### Search for Normal Messages ###########
!  Is sync1 above threshold?
               thresh1 = 1.0
!  Use lower thresh1 at fQSO
               if (nqd .eq. 1 .and. ntol .le. 100) thresh1 = 0.
               noffset = 0
               if (nqd .ge. 1) noffset = nint(1000.0*(freq - fqso) - mousedf)
               if (newdat .eq. 1 .and. sync1 .gt. -99.0) then
                  sync1 = thresh1 + 1.0
                  noffset = 0
               endif
               if (sync1 .gt. thresh1 .and. abs(noffset) .le. ntol) then
!  Keep only the best candidate within ftol.
!  (Am I deleting any good decodes by doing this?)
              if(freq-freq0.le.ftol .and. sync1.gt.sync10 .and.       &
                   nkm.eq.1) km=km-1
                  if (freq - freq0 .gt. ftol .or. sync1 .gt. sync10) then
                     nflip = nint(flipk)
                     f00 = (i - 1)*df          !Freq of detected sync tone (0-96000 Hz)
                     ntry = ntry + 1
                     if ((nqd .eq. 1 .and. ntry .ge. 40) .or. &
                         (nqd .eq. 0 .and. ntry .ge. 400)) then
  ! Too many calls to decode1a!
                        call write_stdout('! Signal too strong, or suspect data?  Decoding aborted.'//new_line('a'))
                        write (13, *) 'Signal too strong, or suspect data?  Decoding aborted.'
                        flush (13)
                        go to 900
                     endif

                     call timer('decode1a', 0)
                     ifreq = i
                     ikhz = nint(freq + 0.5*(nfa + nfb) - foffset) - nfshift
                     idf = nint(1000.0*(freq + 0.5*(nfa + nfb) - foffset - (ikHz + nfshift)))
                     call decode1a(dd, newdat, f00, nflip, mode65, nfsample, &
                                   xpol, mycall, hiscall, hisgrid, neme, ndepth, nqd, dphi, &
                                   ndphi, nutc, ikHz, idf, ipol, ntol, sync2, &
                                   a, dt, pol, nkv, nhist, nsum, nsave, qual, decoded)
                     call timer('decode1a', 1)
                    ! ! ===== Minimal DECODE1A debug logging (modern only) =====
                    !  if (mode65 .ne. 0) then
                    !     if (decoded(1:1) .ne. ' ') then
                    !        open(unit=99, file='DECODE1A_DEBUG.TXT', status='unknown', !position='append')
                    !        write(99,'("DECODE1A: nutc=",I6.4," freq=",F10.3, &
                    !          & " sync1=",F6.2," sync2=",F6.2, &
                    !          & " nkv=",I2," km=",I4," smax=",F8.2," savg=",F10.2," base=",F10.2, &
                    !          & " itest=",I6," jpmax=",I6," nhsym=",I6," decoded=",A22)') &
                    !         nutc, freq, sync1, sync2, nkv, km, smax, savg(jpmax,i), base(jpmax), &
                    !         i, jpmax, nhsym, decoded
                    !        close(99)
                    !     endif
                    !  endif
                    !  ! =========================================================

! The case sync1=2.0 is just to make sure decode1a is called and bigfft done.
                     if (mode65 .ne. 0 .and. sync1 .ne. 2.000000) then
                        if (km .lt. MAXMSG) km = km + 1
                        sig(km, 1) = nfile
                        sig(km, 2) = nutc
                        sig(km, 3) = freq + 0.5*(nfa + nfb)
                        sig(km, 4) = sync1
                        sig(km, 5) = dt
                        sig(km, 6) = pol
                        sig(km, 7) = flipk
                        sig(km, 8) = sync2
                        sig(km, 9) = nkv
                        sig(km, 10) = qual
!                    sig(km,11)=idphi
                        sig(km, 12) = savg(ipol, i)
                        sig(km, 13) = a(1)
                        sig(km, 14) = a(2)
                        sig(km, 15) = a(3)
                        sig(km, 16) = a(4)
!                     sig(km,17)=a(5)
                        sig(km, 18) = nhist
                        msg(km) = decoded
                        freq0 = freq
                        sync10 = sync1
                        nkm = 1
                     endif
                  endif
               endif
            endif
         enddo  !i=ia,ib
         
      !   close(97)
      !   close(98)


         if (nqd .eq. 1) then
            nwrite = 0
            if (mode65 .eq. 0) km = 0
            do k = 1, km
               decoded = msg(k)
               if (decoded .ne. '                      ') then
                  nutc = sig(k, 2)
                  freq = sig(k, 3)
                  sync1 = sig(k, 4)
                  dt = sig(k, 5)
                  npol = nint(57.2957795*sig(k, 6))
                  flip = sig(k, 7)
                  sync2 = sig(k, 8)
                  nkv = sig(k, 9)
                  nqual = sig(k, 10)
!              idphi=nint(sig(k,11))
                  if (flip .lt. 0.0) then
                     do i = 22, 1, -1
                        if (decoded(i:i) .ne. ' ') go to 8
                     enddo
                     stop 'Error in message format'
8                    if (i .le. 18) decoded(i + 2:i + 4) = 'OOO'
                  endif
                  nkHz = nint(freq - foffset) - nfshift
                  mhz = fcenter                         ! ... +fadd ???
                  f0 = mhz + 0.001*nkHz
                  ndf = nint(1000.0*(freq - foffset - (nkHz + nfshift)))
                  nsync1 = sync1
                  s2db = 10.0*log10(sync2) - 40             !### empirical ###
                  nsync2 = nint(s2db)
                  if (decoded(1:4) .eq. 'RO  ' .or. decoded(1:4) .eq. 'RRR  ' .or. &
                      decoded(1:4) .eq. '73  ') then
                     nsync2 = nint(1.33*s2db + 2.0)
                  endif

                  nwrite = nwrite + 1
                  if (nxant .ne. 0) then
                     npol = npol - 45
                     if (npol .lt. 0) npol = npol + 180
                  endif

                  call txpol(xpol, decoded, mygrid, npol, nxant, ntxpol, cp)

                  if (ndphi .eq. 0) then
                     write (line, '("!",I3,I5,I4,I6.4,F5.1,I5,1X,A1,1X,A22,I2,I5,I5,1X,A1)') &
                        nkHz, ndf, npol, nutc, dt, nsync2, cm, decoded, nkv, nqual, ntxpol, cp
                     call write_stdout(trim(line)//new_line('a'))
                  else
                     if (iloop .ge. 1) qphi(iloop) = sig(k, 10)
                     write (line, '("!",I3,I5,I4,I6.4,F5.1,I5,1X,A1,1X,A22,I2,I5,I5,1X,A1)') &
                        nkHz, ndf, npol, nutc, dt, nsync2, cm, decoded, nkv, nqual, 30*iloop
                     call write_stdout(trim(line)//new_line('a'))
                     write (27, 1011) 30*iloop, nkHz, ndf, npol, nutc, &
                        dt, sync2, nkv, nqual, cm, decoded
1011                 format(i3, i4, i5, i4, i6.4, 1x, f5.1, f7.1, i3, i5, a1, 1x, a22)
                  endif
               endif
            enddo  ! k=1,km

            if (bq65) then
               q65b_called = .false.
               do icand = 1, ncand
                  if (cand(icand)%iflip .ne. 0) cycle        !Keep only Q65 candidates
                  freq = cand(icand)%f + nkhz_center - 48.0 - 1.27046
                  nhzdiff = nint(1000.0*(freq - mousefqso) - mousedf) - nfcal
! Now looking for "quick decode" (nqd=1) candidates at cursor freq +/- ntol.
                  if (nqd .eq. 1 .and. abs(nhzdiff) .gt. ntol) cycle
                  ikhz = mousefqso
                  q65b_called = .true.
                  f0 = cand(icand)%f
                  call timer('q65b    ', 0)
                  call q65b(nutc, nqd, nxant, fcenter, nfcal, nfsample, ikhz, mousedf, &
                            ntol, xpol, mycall, mygrid, hiscall, hisgrid, mode_q65, f0, fqso, &
                            newdat, nagain, max_drift, ndop00, idec)
                  call timer('q65b    ', 1)
                  if (idec .ge. 0) candec(icand) = .true.
               enddo
               if (.not. q65b_called) then
                  freq = mousefqso + 0.001*mousedf
                  ikhz = mousefqso
                  f0 = freq - (nkhz_center - 48.0 - 1.27046)   !### ??? ###
                  call timer('q65b    ', 0)
                  call q65b(nutc, nqd, nxant, fcenter, nfcal, nfsample, ikhz, mousedf, &
                            ntol, xpol, mycall, mygrid, hiscall, hisgrid, mode_q65, f0, fqso, &
                            newdat, nagain, max_drift, ndop00, idec)
                  call timer('q65b    ', 1)
               endif
            endif

            if (nwrite .eq. 0 .and. nwrite_q65 .eq. 0) then
               write (line, '("!",I3,9X,I6.4,"  ")') mousefqso, nutc
               call write_stdout(trim(line)//new_line('a'))
            endif
         endif  !nqd.eq.1

         if (ndphi .eq. 1 .and. iloop .lt. 12) then
            iloop = iloop + 1
            go to 2
         endif

         if (ndphi .eq. 1 .and. iloop .eq. 12) call getdphi(qphi)
         if (nqd .eq. 1) then
            call sec0(1, tdec)
            write (line, '("<QuickDecodeDone>",3I4,I6,F6.2)') &
               nsum, nsave, nstandalone, nhsym, tdec

            call write_stdout(trim(line)//new_line('a'))

            open (16, file='tquick.dat', status='unknown', position='append')
            write (16, 1016) nutc, tdec
1016        format(i4.4, f7.1)
            close (16)
         endif
         call sec0(1, tsec0)
         if (nhsym .eq. nhsym1 .and. tsec0 .gt. 3.0) go to 700
         if (nqd .eq. 1 .and. nagain .eq. 1) go to 900

         if (nqd .eq. 0 .and. bq65) then
! Do the wideband Q65 decode
            do icand = 1, ncand
               if (cand(icand)%iflip .ne. 0) cycle    !Do only Q65 candidates here
               if (candec(icand)) cycle             !Skip if already decoded
               freq = cand(icand)%f + nkhz_center - 48.0 - 1.27046
!###! If here at nqd=1, do only candidates at mousefqso +/- ntol
!###           if(nqd.eq.1 .and. abs(freq-mousefqso).gt.0.001*ntol) cycle
               ikhz = nint(freq)
               f0 = cand(icand)%f
               call timer('q65b    ', 0)
               call q65b(nutc, nqd, nxant, fcenter, nfcal, nfsample, ikhz, mousedf, ntol, &
                         xpol, mycall, mygrid, hiscall, hisgrid, mode_q65, f0, fqso, newdat, &
                         nagain, max_drift, ndop00, idec)
               call timer('q65b    ', 1)
               if (idec .ge. 0) candec(icand) = .true.
            enddo  ! icand
         endif
         call sec0(1, tsec0)

      enddo  ! nqd

!  Trim the list and produce a sorted index and sizes of groups.
!  (Should trimlist remove all but best SNR for given UTC and message content?)
700   continue
      if (km < 0) km = 0      ! single safety clamp
      call trimlist(sig, km, ftol, indx, nsiz, nz)

      if (km .gt. 0) done(1:km) = .false.
      j = 0
      ilatest = -1
      do n = 1, nz
         ifile0 = 0
         do m = 1, nsiz(n)
            i = indx(j + m)
            ifile = sig(i, 1)
            if (ifile .gt. ifile0 .and. msg(i) .ne. blank) then
               ilatest = i
               ifile0 = ifile
            endif
         enddo
         i = ilatest

         if (i .ge. 1) then
            if (.not. done(i)) then
               done(i) = .true.
               nutc = sig(i, 2)
               freq = sig(i, 3)
               sync1 = sig(i, 4)
               dt = sig(i, 5)
               npol = nint(57.2957795*sig(i, 6))
               flip = sig(i, 7)
               sync2 = sig(i, 8)
               nkv = sig(i, 9)
               nqual = min(sig(i, 10), 10.0)
!                  rms0=sig(i,11)
               do k = 1, 5
                  a(k) = sig(i, 12 + k)
               enddo
               nhist = sig(i, 18)
               decoded = msg(i)

               if (flip .lt. 0.0) then
                  do i = 22, 1, -1
                     if (decoded(i:i) .ne. ' ') go to 10
                  enddo
                  stop 'Error in message format'
10                if (i .le. 18) decoded(i + 2:i + 4) = 'OOO'
               endif
               mhz = fcenter                             !... +fadd ???
               nkHz = nint(freq - foffset) - nfshift
               f0 = mhz + 0.001*nkHz
               ndf = nint(1000.0*(freq - foffset - (nkHz + nfshift)))
               ndf0 = nint(a(1))
               ndf1 = nint(a(2))
               ndf2 = nint(a(3))
               nsync1 = sync1

               s2db = 10.0*log10(sync2) - 40             !### empirical ###
               nsync2 = nint(s2db)
               if (decoded(1:4) .eq. 'RO  ' .or. decoded(1:4) .eq. 'RRR  ' .or. &
                   decoded(1:4) .eq. '73  ') then
                  nsync2 = nint(1.33*s2db + 2.0)
               endif

               if (nxant .ne. 0) then
                  npol = npol - 45
                  if (npol .lt. 0) npol = npol + 180
               endif

               call txpol(xpol, decoded, mygrid, npol, nxant, ntxpol, cp)

               cmode = '#A'
               if (mode65 .eq. 2) cmode = '#B'
               if (mode65 .eq. 4) cmode = '#C'
               write (26, 1014) f0, ndf, ndf0, ndf1, ndf2, dt, npol, nsync1, &
                  nsync2, nutc, decoded, '#', cp, cmode ! was decoded,cp,
1014           format(f8.3, i5, 3i3, f5.1, i4, i3, i4, i5.4, 4x, a22, 7x, 2a1, 2x, a2) ! was a22,2x,a1,3x,a2
               ndecodes = ndecodes + 1
               write (21, 1100) f0, ndf, dt, npol, nsync2, nutc, decoded, '#', cp, &
                  cmode(1:1), cmode(2:2)! was decoded,cp,
1100           format(f8.3, i5, f5.1, 2i4, i5.4, 2x, a22, 7x, 2a1, 3x, a1, 1x, a1) ! was a22,2x,a1,1x,a1
            endif

         endif
         j = j + nsiz(n)
      enddo  !i=1,km

      write (26, 1015) nutc
1015  format(37x, i6.4, ' ')
      flush (21)
      flush (26)
      call display(nkeep, ftol)
      ndecdone = 2

900   close (23)
      flush (12)
      ndphi = 0
      mcall3b = mcall3a

      return
   end subroutine map65a

end module map65a_mod

subroutine q65_loops(c00,npts2,nsps2,nsubmode,ndepth,jpk0,    &
     xdt0,f0,iaptype,xdt1,f1,snr2,dat4,idec)

  use packjt77
  use timer_module, only: timer
  use q65
  
  parameter (NN=63)
  parameter (LN=2176*63)           !LN=LL*NN; LL=64*(mode_q65+2), NN=63
  complex c00(0:npts2-1)           !Analytic representation of dd(), 6000 Hz
  complex ,allocatable :: c0(:)    !Ditto, with freq shift
  character decoded*37
  real a(3)                        !twkfreq params f,f1,f2
  real,allocatable :: s3(:)        !Symbol spectra
  integer dat4(13)                 !Decoded message (as 13 six-bit integers)
  integer nap(0:11)                !AP return codes
  data nap/0,2,3,2,3,4,2,3,6,4,6,6/

  LL=64*(mode_q65+2)
  allocate(s3(LL*NN))
  allocate(c0(0:npts2-1))
  idec=-1
  ircbest=9999
  irc=-99
  s3lim=20.
  baud=6000.0/nsps2

  idfmax=1
  idtmax=1
  maxdist=4
  ibw0=(ibwa+ibwb)/2
  if(iand(ndepth,3).eq.2) then
     idfmax=3
     idtmax=3
     maxdist=5
  endif
  if(iand(ndepth,3).eq.3) then
     idfmax=5
     idtmax=5
     maxdist=5
  endif

  napmin=99
  xdt1=xdt0
  f1=f0
  idfbest=0
  idtbest=0
  ndistbest=0

  do idf=1,idfmax
     ndf=idf/2
     if(mod(idf,2).eq.0) ndf=-ndf
     a=0.
     a(1)=-(f0+0.5*baud*ndf)
! Variable 'drift' is frequency increase over full TxT.  Therefore we want:
     a(2)=-0.5*drift
     call twkfreq(c00,c0,npts2,6000.0,a)
     do idt=1,idtmax
        ndt=idt/2
        if(mod(idt,2).eq.0) ndt=-ndt
        jpk=jpk0 + nsps2*ndt/16              !tsym/16
        jpk=max(0,jpk)
        jpk=min(29000,jpk)
        call spec64(c0,npts2,nsps2,mode_q65,jpk,s3,LL,NN)
        call pctile(s3,LL*NN,40,base)
        s3=s3/base
        where(s3(1:LL*NN)>s3lim) s3(1:LL*NN)=s3lim
        call q65_bzap(s3,LL)                   !Zap birdies
        do ibw=ibwa,ibwb
           ndist=ndf**2 + ndt**2 + (ibw-ibw0)**2
           if(ndist.gt.maxdist) cycle
           b90=1.72**ibw
           if(b90.gt.345.0) cycle
           b90ts = b90/baud
           call timer('dec2    ',0)
           call q65_dec2(s3,nsubmode,b90ts,esnodb,irc,dat4,decoded)
           call timer('dec2    ',1)
              ! irc > 0 ==> number of iterations required to decode
              !  -1 = invalid params
              !  -2 = decode failed
              !  -3 = CRC mismatch
           if(irc.ge.0) then
              idfbest=idf
              idtbest=idt
              ndistbest=ndist
              nrc=irc
              go to 100
           endif
        enddo  ! ibw (b90 loop)
     enddo  ! idt (DT loop)
  enddo  ! idf (f0 loop)

100 if(irc.ge.0) then
     idec=iaptype
     snr2=esnodb - db(2500.0/baud)
     xdt1=xdt0 +  nsps2*ndt/(16.0*6000.0)
     f1=f0 + 0.5*baud*ndf
  endif

  return
end subroutine q65_loops

subroutine decode65b(s2,flip,mycall,hiscall,hisgrid,mode65,neme,ndepth,  &
     nqd,nkv,nhist,qual,decoded,s3,sy)

  real s2(66,126)
  real s3(64,63),sy(63)
  logical first,ltext
  character decoded*22,deepmsg*22
  character mycall*12,hiscall*12,hisgrid*6
  common/prcom/pr(126),mdat(126),mref(126,2),mdat2(126),mref2(126,2)
  data first/.true./
  save

  if(first) call setup65
  first=.false.

  do j=1,63
     k=mdat(j)                       !Points to data symbol
     if(flip.lt.0.0) k=mdat2(j)
     do i=1,64
        s3(i,j)=s2(i+2,k)
     enddo
     k=mdat2(j)                       !Points to data symbol
     if(flip.lt.0.0) k=mdat(j)
     sy(j)=s2(1,k)
  enddo

  nadd=mode65
  call extract(s3,nadd,ncount,nhist,decoded,ltext)     !Extract the message
! Suppress "birdie messages" and other garbage decodes:
  if(decoded(1:7).eq.'000AAA ') ncount=-1
  if(decoded(1:7).eq.'0L6MWK ') ncount=-1
  if(flip.lt.0.0 .and. ltext) ncount=-1
  nkv=1
  if(ncount.lt.0) then 
     nkv=0
     decoded='                      '
  endif

  qual=0.
  if(ndepth.ge.1 .and. (nqd.eq.1 .or. flip.eq.1.0)) then
     call deep65(s3,mode65,neme,flip,mycall,hiscall,hisgrid,deepmsg,qual)
     if(nqd.ne.1 .and. qual.lt.10.0) qual=0.0
     if(ndepth.lt.2 .and. qual.lt.6.0) qual=0.0
  endif
  if(nkv.eq.0 .and. qual.ge.1.0) decoded=deepmsg

  return
end subroutine decode65b

program mfsk
! Compute probability of symbol error for non-coherent MFSK
  implicit real*16 (a-h,o-z)
  integer*8 binomial
  integer x,s,XX,NN,M
  real*16 hypergeo, snr, term, sum
  character arg*8

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Probability of symbol error for noncoherent MFSK'
     print*,'Usage:    mfsk   M'
     print*,'Example:  mfsk  64'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) M

  write(*,1012) 
1012 format('Es/No  P(symbol error)'/  &
             '----------------------')
  do isnr=0,40
    esno=10**(isnr/2.0/10.0)
    hsum=0.d0
    do k=1,M-1
      h=binomial(M-1,k)
      h=h*((-1)**(k+1))/(k+1)
      h=h*exp(-esno*k/(k+1))
      hsum=hsum + h
    enddo
    write(*,'(f4.1,4x,e10.4)') isnr/2.0, hsum
  enddo
999 end program mfsk

program q65_ftn_test

  use packjt77
  parameter (LL=192,NN=63)
  integer x(13)              !User's 78-bit message as 13 six-bit integers
  integer y(63)              !Q65 codeword for x
  integer xdec(13)            !Decoded message
  integer APmask(13)
  integer APsymbols(13)
  real s3(0:LL-1,NN)
  real s3prob(0:LL-1,NN)
  character*37 msg0,msg,msgsent
  character*77 c77
  logical unpk77_success

  narg=iargc()
  if(narg.ne.1) then
     print*,'Usage:   q65_ftn_test "message"'
     print*,'Example: q65_ftn_test "K1ABC W9XYZ EN37"'
     go to 999
  endif
  call getarg(1,msg0)
  call pack77(msg0,i3,n3,c77)
  call unpack77(c77,0,msgsent,unpk77_success) !Unpack to get msgsent
  read(c77,1000) x
1000 format(12b6.6,b5.5)

  call q65_enc(x,y)                            !Encode message, x(1:13) ==> y(1:63)
  
  write(*,1010) x,msg0
1010 format('User message:'/13i3,2x,a)
  write(*,1020) y
1020 format(/'Generated codeword:'/(20i3))

  s3=0.
  s3prob=0.
  do j=1,NN
     s3(y(j)+64,j)=1.0
  enddo
  APmask=0
  APsymbols=0
  nsubmode=0
  b90=1.0
  nFadingModel=1
  call q65_dec(s3,APmask,APsymbols,nsubmode,b90,nFadingModel,s3prob,snr2500,xdec,irc)
  write(c77,1000) xdec
  call unpack77(c77,0,msg,unpk77_success) !Unpack to get msgsent
  write(*,1100) xdec,trim(msg)
1100 format(/'Decoded message:'/13i3,2x,a)

999 end program q65_ftn_test

subroutine update_recent_calls(call,calls_hrd,nsize)
character*12 call,calls_hrd(nsize)

 new=1
 do ic=1,nsize
   if( calls_hrd(ic).eq.call ) then
     new=0
   endif
 enddo

 if( new.eq.1 ) then
   do ic=nsize-1,1,-1
     calls_hrd(ic+1)(1:12)=calls_hrd(ic)(1:12)
   enddo
   calls_hrd(1)(1:12)=call(1:12)
 endif

 return
 end subroutine update_recent_calls

module run_m65_mod
   use iso_c_binding
   implicit none
contains

subroutine run_m65(pol, sample_rate_96000) bind(C, name='run_m65_')
  use iso_c_binding
  use timer_module, only: timer
  use timer_impl, only: init_timer, fini_timer
  use debug_log
  use m65a_mod
  use datcom_ptrs_mod, only: dd, ss, savg
  use npar_ptrs_mod, only: newdat, stop_m65, decoder_ready
  use stdout_channel_mod, only: write_stdout
  use decodes_mod, only: nhsym1,nhsym2
  use sleep_msec_mod

  implicit none

  integer(c_int), intent(in) :: pol, sample_rate_96000

  ! Local variables
  integer :: sample_rate
  character(len=128) :: line
  
  ! timestamp variables
  character(len=8)  :: d
  character(len=10) :: t
  integer           :: v(8)
  character(len=32) :: timestamp

  nhsym1=280
  nhsym2=302 

  if (sample_rate_96000 /=0) then
     sample_rate = 96000
  else
     sample_rate = 95238   ! 96000 / 1.008, legacy WSJT slow-96k correction
  endif
  call write_stdout('STARTING RUN_M65'//new_line('a'))

  ! and one of the others, e.g.
  write (line, '(A, I0)') ' ********** IN RUN_M65 sample_rate is: ', sample_rate
  call write_stdout(trim(line)//new_line('a'))

  if (.not. associated(savg)) then
     print *, 'ERROR:RUN_M65 savg is not associated!'
  else
     print *, 'RUN_M65 savg is associated. Shape =', shape(savg), " loc:", loc(savg)
  end if

  if (.not. associated(dd)) then
     print *, 'ERROR: RUN_M65 dd is not associated!'
  else
     print *, 'RUN_M65 dd is associated. Shape =', shape(dd), " loc:", loc(dd)
  end if

  if (.not. associated(ss)) then
     print *, 'ERROR: RUN_M65 ss is not associated!'
  else
     print *, 'RUN_M65 ss is associated. Shape =', shape(ss), " loc:", loc(ss)
  end if

  print *, ' ********** IN RUN_M65 sample_rate_96000 is: ', sample_rate
  flush (6)
  print *, ' ********** IN RUN_M65 pol is: ', pol
  flush (6)

  !print *, 'IN RUN_M65, initial stop_m65 =', stop_m65
  !flush(6)

  !call date_and_time(d, t, values=v)

  !write(timestamp, '(I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":",I2.2,".",I3.3)') &
  !     v(1), v(2), v(3), v(5), v(6), v(7), v(8)

  !print *, trim(timestamp), ' CALLING M65A'


  call init_timer()

  !print *, 'IN RUN_M65, just passed init_timer'
  do while (stop_m65 == 0)
     if (decoder_ready /=0 .and. newdat /= 0) then
      !  call date_and_time(d, t, values=v)

      !  write(timestamp, '(I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":",I2.2,".",I3.3)') &
      !       v(1), v(2), v(3), v(5), v(6), v(7), v(8)

      !  print *, trim(timestamp), ' CALLING M65A'
        call m65a()
     end if
!print *, ' ENTERING SLEEP_MSEC'
call sleep_msec(50)
!print *, ' RETURNED FROM SLEEP_MSEC'
!print *, ' LOOP: stop_m65 =', stop_m65, &
!         ' decoder_ready=', decoder_ready, &
!         ' newdat=', newdat

! stop_m65 = .true.
  end do

  print *, 'RUN_M65 exiting main loop.'
  flush (6)
  call fini_timer()
  close(21)

end subroutine run_m65
end module run_m65_mod

subroutine pack50(n1,n2,dat)

  integer*1 dat(11),i1

  i1=iand(ishft(n1,-20),255)                !8 bits
  dat(1)=i1
  i1=iand(ishft(n1,-12),255)                 !8 bits
  dat(2)=i1
  i1=iand(ishft(n1, -4),255)                 !8 bits
  dat(3)=i1
  i1=16*iand(n1,15)+iand(ishft(n2,-18),15)   !4+4 bits
  dat(4)=i1
  i1=iand(ishft(n2,-10),255)                 !8 bits
  dat(5)=i1
  i1=iand(ishft(n2, -2),255)                 !8 bits
  dat(6)=i1
  i1=64*iand(n2,3)                           !2 bits
  dat(7)=i1
  dat(8)=0
  dat(9)=0
  dat(10)=0
  dat(11)=0

  return
end subroutine pack50

  parameter (MAXTEST=75,NTEST=43)
  character*37 testmsg(MAXTEST)
  data testmsg(1:NTEST)/                   &
       "CQ K1ABC FN42",                    &
       "K1ABC W9XYZ EN37",                 &
       "W9XYZ K1ABC -11",                  &
       "K1ABC W9XYZ R-09",                 &
       "W9XYZ K1ABC RRR",                  &
       "K1ABC W9XYZ 73",                   &
       "K1ABC W9XYZ RR73",                 &
       "CQ KH1/KH7Z",                      &
       "CQ TEST K1ABC/R FN42",             &
       "K1ABC/R W9XYZ EN37",               &
       "W9XYZ K1ABC/R R FN42",             &
       "K1ABC/R W9XYZ RR73",               &
       "CQ TEST K1ABC FN42",               &
       "K1ABC/R W9XYZ/R R FN42",           &
       "CQ G4ABC/P IO91",                  &
       "G4ABC/P PA9XYZ JO22",              &
       "PA9XYZ 590003 IO91NP",             &
       "G4ABC/P R 570007 JO22DB",          &
       "PA9XYZ G4ABC/P RR73",              &
       "CQ PJ4/K1ABC",                     &
       "PJ4/K1ABC <W9XYZ>",                &
       "W9XYZ <PJ4/K1ABC> -11",            &
       "<PJ4/K1ABC> W9XYZ R-09",           &
       "<W9XYZ> PJ4/K1ABC RRR",            &
       "PJ4/K1ABC <W9XYZ> 73",             &
       "CQ W9XYZ EN37",                    & 
       "<W9XYZ> YW18FIFA",                 &
       "<YW18FIFA> W9XYZ -11",             &
       "W9XYZ <YW18FIFA> R-09",            &
       "YW18FIFA <W9XYZ> RRR",             &
       "<W9XYZ> YW18FIFA 73",              &
       "TNX BOB 73 GL",                    &
       "CQ YW18FIFA",                      &
       "<YW18FIFA> KA1ABC",                &
       "KA1ABC <YW18FIFA> -11",            &
       "<YW18FIFA> KA1ABC R-17",           &
       "<KA1ABC> YW18FIFA RR73",           &
       "<YW18FIFA> KA1ABC 73",             &
       "123456789ABCDEF012",               &
       "<KA1ABC WB9XYZ> -03",              &
       "<KA1ABC WB9XYZ> R+03",             &
       "<KA1ABC WB9XYZ> RRR",              &
       "<KA1ABC WB9XYZ> 73"/

subroutine astro0(nyear,month,nday,uth8,nfreq,mygrid,hisgrid,              &
     AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,    &
     dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,    &
     width1,width2,w501,w502,xlst8)

  parameter (DEGS=57.2957795130823d0)
  character*6 mygrid,hisgrid
  real*8 AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8
  real*8 dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,xnr8,dfdt,dfdt0,dt
  real*8 sd8,poloffset8,day8,width1,width2,w501,w502,xlst8
  real*8 uth8
  data uth8z/0.d0/
  save

  uth=uth8
  call astro(nyear,month,nday,uth,nfreq,hisgrid,2,1,                 &
       AzSun,ElSun,AzMoon,ElMoon,ntsky,doppler00,doppler,            &
       dbMoon,RAMoon,DecMoon,HA,Dgrd,sd,poloffset,xnr,               &
       day,xlon2,xlat2,xlst)
  AzMoonB8=AzMoon
  ElMoonB8=ElMoon
  call astro(nyear,month,nday,uth,nfreq,mygrid,1,1,                  &
       AzSun,ElSun,AzMoon,ElMoon,ntsky,doppler00,doppler,            &
       dbMoon,RAMoon,DecMoon,HA,Dgrd,sd,poloffset,xnr,               &
       day,xlon1,xlat1,xlst)

  day8=day
  xlst8=xlst
  call tm2(day8,xlat1,xlon1,xl1,b1)
  call tm2(day8,xlat2,xlon2,xl2,b2)
  call tm2(day8+1.d0/1440.0,xlat1,xlon1,xl1a,b1a)
  call tm2(day8+1.d0/1440.0,xlat2,xlon2,xl2a,b2a)
  fghz=0.001*nfreq
  dldt1=DEGS*(xl1a-xl1)
  dbdt1=DEGS*(b1a-b1)
  dldt2=DEGS*(xl2a-xl2)
  dbdt2=DEGS*(b2a-b2)
  rate1=2.0*sqrt(dldt1**2 + dbdt1**2)
  width1=0.5*6741*fghz*rate1
  rate2=sqrt((dldt1+dldt2)**2 + (dbdt1+dbdt2)**2)
  width2=0.5*6741*fghz*rate2

  fbend=0.7
  a2=0.0045*log(fghz/fbend)/log(1.05)
  if(fghz.lt.fbend) a2=0.0
  f50=0.19 * (fghz/fbend)**a2
  if(f50.gt.1.0) f50=1.0
  w501=f50*width1
  w502=f50*width2

  AzSun8=AzSun
  ElSun8=ElSun
  AzMoon8=AzMoon
  ElMoon8=ElMoon
  dbMoon8=dbMoon
  RAMoon8=RAMoon/15.0
  DecMoon8=DecMoon
  HA8=HA
  Dgrd8=Dgrd
  sd8=sd
  poloffset8=poloffset
  xnr8=xnr
  ndop=nint(doppler)
  ndop00=nint(doppler00)

  if(uth8z.eq.0.d0) then
     uth8z=uth8-1.d0/3600.d0
     dopplerz=doppler
     doppler00z=doppler00
  endif
     
  dt=60.0*(uth8-uth8z)
  if(dt.le.0) dt=1.d0/60.d0
  dfdt=(doppler-dopplerz)/dt
  dfdt0=(doppler00-doppler00z)/dt
  uth8z=uth8
  dopplerz=doppler
  doppler00z=doppler00

  return
end subroutine astro0

program q65code
   use q65_encoding

   implicit none
   character*37 msg37
   integer nargs
   integer codeword(65),tones(85)

   nargs=iargc()
   if(nargs .ne. 1) then
      print*,'Usage: q65code "msg"'
      goto 999
   endif
   call getarg(1,msg37)

   call get_q65_tones(msg37,codeword,tones)

   write(*,*) 'Generated message plus CRC (90 bits)'
   write(*,'(a8,15i4)') '6 bit : ',codeword(1:15)
   write(*,'(a8,15b6.6)') 'binary: ',codeword(1:15)
   write(*,*) ' '
   write(*,*) 'Codeword with CRC symbols (65 symbols)'
   write(*,'(20i3)') codeword

   write(*,*) ' '
   write(*,*) 'Channel symbols (85 total)'
   write(*,'(20i3)') tones

999 end program q65code

subroutine sun(y,m,DD,UT,lon,lat,RA,Dec,LST,Az,El,mjd,day)

  implicit none

  integer y                         !Year
  integer m                         !Month
  integer DD                        !Day
  integer mjd                       !Modified Julian Date
  real UT                           !UT!in hours
  real RA,Dec                       !RA and Dec of sun

! NB: Double caps here are single caps in the writeup.

! Orbital elements of the Sun (also N=0, i=0, a=1):
  real w                            !Argument of perihelion
  real e                            !Eccentricity
  real MM                           !Mean anomaly
  real Ls                           !Mean longitude

! Other standard variables:
  real v                            !True anomaly
  real EE                           !Eccentric anomaly
  real ecl                          !Obliquity of the ecliptic
  real d                            !Ephemeris time argument in days
  real r                            !Distance to sun, AU
  real xv,yv                        !x and y coords in ecliptic
  real lonsun                       !Ecliptic long and lat of sun
!Ecliptic coords of sun (geocentric)
  real xs,ys
!Equatorial coords of sun (geocentric)
  real xe,ye,ze
  real lon,lat
  real GMST0,LST,HA
  real xx,yy,zz
  real xhor,yhor,zhor
  real Az,El

  real day
  real rad
  data rad/57.2957795/

! Time in days, with Jan 0, 2000 equal to 0.0:
  d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + DD - 730530 + UT/24.0
  mjd=d + 51543
  ecl = 23.4393 - 3.563e-7 * d

! Compute updated orbital elements for Sun:
  w = 282.9404 + 4.70935e-5 * d
  e = 0.016709 - 1.151e-9 * d
  MM = mod(356.0470d0 + 0.9856002585d0 * d + 360000.d0,360.d0)
  Ls = mod(w+MM+720.0,360.0)

  EE = MM + e*rad*sin(MM/rad) * (1.0 + e*cos(MM/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.0 - e*cos(EE/rad))

  xv = cos(EE/rad) - e
  yv = sqrt(1.0-e*e) * sin(EE/rad)
  v = rad*atan2(yv,xv)
  r = sqrt(xv*xv + yv*yv)
  lonsun = mod(v + w + 720.0,360.0)
! Ecliptic coordinates of sun (rectangular):
  xs = r * cos(lonsun/rad)
  ys = r * sin(lonsun/rad)

! Equatorial coordinates of sun (rectangular):
  xe = xs
  ye = ys * cos(ecl/rad)
  ze = ys * sin(ecl/rad)

! RA and Dec in degrees:
  RA = rad*atan2(ye,xe)
  Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))

  GMST0 = (Ls + 180.0)/15.0
  LST = mod(GMST0+UT+lon/15.0+48.0,24.0)    !LST in hours
  HA = 15.0*LST - RA                        !HA in degrees
  xx = cos(HA/rad)*cos(Dec/rad)
  yy = sin(HA/rad)*cos(Dec/rad)
  zz =             sin(Dec/rad)
  xhor = xx*sin(lat/rad) - zz*cos(lat/rad)
  yhor = yy
  zhor = xx*cos(lat/rad) + zz*sin(lat/rad)
  Az = mod(rad*atan2(yhor,xhor) + 180.0 + 360.0,360.0)
  El = rad*asin(zhor)
  day=d-1.5
  
  return
end subroutine sun

subroutine grid2deg(grid0,dlong,dlat)

! Converts Maidenhead grid locator to degrees of West longitude
! and North latitude.

  character*(*) grid0
  character*6 grid
  character*1 g1,g2,g3,g4,g5,g6

  grid=grid0
  i=ichar(grid(5:5))
  if(grid(5:5).eq.' ' .or. i.le.64 .or. i.ge.128) grid(5:6)='mm'

  if(grid(1:1).ge.'a' .and. grid(1:1).le.'z') grid(1:1)=          &
        char(ichar(grid(1:1))+ichar('A')-ichar('a'))
  if(grid(2:2).ge.'a' .and. grid(2:2).le.'z') grid(2:2)=          &
        char(ichar(grid(2:2))+ichar('A')-ichar('a'))
  if(grid(5:5).ge.'A' .and. grid(5:5).le.'Z') grid(5:5)=          &
        char(ichar(grid(5:5))-ichar('A')+ichar('a'))
  if(grid(6:6).ge.'A' .and. grid(6:6).le.'Z') grid(6:6)=          &
        char(ichar(grid(6:6))-ichar('A')+ichar('a'))

  g1=grid(1:1)
  g2=grid(2:2)
  g3=grid(3:3)
  g4=grid(4:4)
  g5=grid(5:5)
  g6=grid(6:6)

  nlong = 180 - 20*(ichar(g1)-ichar('A'))
  n20d = 2*(ichar(g3)-ichar('0'))
  xminlong = 5*(ichar(g5)-ichar('a')+0.5)
  dlong = nlong - n20d - xminlong/60.0
  nlat = -90+10*(ichar(g2)-ichar('A')) + ichar(g4)-ichar('0')
  xminlat = 2.5*(ichar(g6)-ichar('a')+0.5)
  dlat = nlat + xminlat/60.0

  return
end subroutine grid2deg

SUBROUTINE DCOORD(A0,B0,AP,BP,A1,B1,A2,B2)

  implicit real*8 (a-h,o-z)
! Examples:
! 1. From ha,dec to az,el:
!      call coord(pi,pio2-lat,0.,lat,ha,dec,az,el)
! 2. From az,el to ha,dec:
!      call coord(pi,pio2-lat,0.,lat,az,el,ha,dec)
! 3. From ra,dec to l,b
!      call coord(4.635594495,-0.504691042,3.355395488,0.478220215,
!        ra,dec,l,b)
! 4. From l,b to ra,dec
!      call coord(1.705981071d0,-1.050357016d0,2.146800277d0,
!        0.478220215d0,l,b,ra,dec)
! 5. From ecliptic latitude (eb) and longitude (el) to ra, dec:
!      call coord(0.d0,0.d0,-pio2,pio2-23.443*pi/180,ra,dec,el,eb)

  SB0=sin(B0)
  CB0=cos(B0)
  SBP=sin(BP)
  CBP=cos(BP)
  SB1=sin(B1)
  CB1=cos(B1)
  SB2=SBP*SB1 + CBP*CB1*cos(AP-A1)
  CB2=SQRT(1.D0-SB2**2)
  B2=atan(SB2/CB2)
  SAA=sin(AP-A1)*CB1/CB2
  CAA=(SB1-SB2*SBP)/(CB2*CBP)
  CBB=SB0/CBP
  SBB=sin(AP-A0)*CB0
  SA2=SAA*CBB-CAA*SBB
  CA2=CAA*CBB+SAA*SBB
  TA2O2=0.0 !Shut up compiler warnings. -db
  IF(CA2.LE.0.D0) TA2O2=(1.D0-CA2)/SA2 
  IF(CA2.GT.0.D0) TA2O2=SA2/(1.D0+CA2)
  A2=2.D0*atan(TA2O2)
  IF(A2.LT.0.D0) A2=A2+6.2831853071795864D0

  RETURN
END SUBROUTINE DCOORD

subroutine fftbig(dd,nmax)

! Do the full length FFT of complex data stored in array dd(2,nmax).  

  use, intrinsic :: iso_c_binding
  
  use FFTW3
  use timer_module, only: timer
  parameter (MAXFFT1=5376000)
  real*4  dd(2,nmax)                         !Input data
  complex ca(MAXFFT1)                        !FFT of input
  real*8 df
  type(C_PTR) :: plan1                       !Pointer to FFTW plan
  logical first
  common/cacb/ca
  equivalence (rfilt,cfilt)
  data first/.true./,npatience/0/
  save

  if(nmax.lt.0) go to 900

  nfft1=MAXFFT1
  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE
     
! Plan the big FFT just once
     call timer('FFTplan ',0)
     plan1=fftwf_plan_dft_1d(nfft1,ca,ca,+1,nflags)
     call timer('FFTplan ',1)
     df=96000.d0/nfft1
     first=.false.
  endif

  nz=min(nmax,nfft1)
  do i=1,nz
     ca(i)=cmplx(dd(1,i),dd(2,i))
  enddo

  if(nmax.lt.nfft1) then
     do i=nmax+1,nfft1
        ca(i)=0.
     enddo
  endif
  call timer('FFTbig  ',0)
  call fftwf_execute_dft(plan1,ca,ca)
  call timer('FFTbig  ',1)
  go to 999

900 call fftwf_destroy_plan(plan1)

999 return
end subroutine fftbig

subroutine s3avg(nsave,mode65,nutc,nhz,xdt,npol,ntol,s3,nsum,nkv,decoded)

! Save the current synchronized spectra, s3(64,63), for possible
! decoding of average.

  real s3(64,63)                        !Synchronized spectra for 63 symbols
  real s3a(64,63,64)                    !Saved spectra
  real s3b(64,63)                       !Average spectra
  integer iutc(64),ihz(64),ipol(64)
  real dt(64)
  character*22 decoded
  logical ltext,first
  data first/.true./
  save

  if(first) then
     iutc=-1
     ihz=0
     ipol=0
     first=.false.
     ihzdiff=min(100,ntol)
     dtdiff=0.2
  endif

  do i=1,64
     if(nutc.eq.iutc(i) .and. abs(nhz-ihz(i)).lt.ihzdiff) then
        nsave=mod(nsave-1+64,64)+1
        go to 10
     endif
  enddo
  
  iutc(nsave)=nutc                          !Save UTC
  ihz(nsave)=nhz                            !Save freq in Hz
  ipol(nsave)=npol                          !Save pol
  dt(nsave)=xdt                             !Save DT
  s3a(1:64,1:63,nsave)=s3                   !Save the spectra

10 s3b=0.
  do i=1,64                                 !Accumulate avg spectra
     if(iutc(i).lt.0) cycle
     if(mod(iutc(i),2).ne.mod(nutc,2)) cycle !Use only same sequence
     if(abs(nhz-ihz(i)).gt.ihzdiff) cycle   !Freq must match
     if(abs(xdt-dt(i)).gt.dtdiff) cycle     !DT must match
     s3b=s3b + s3a(1:64,1:63,i)
     nsum=nsum+1
  enddo
 
  decoded='                      '
  if(nsum.ge.2) then                        !Try decoding the sverage
     nadd=mode65*nsum
     call extract(s3b,nadd,ncount,nhist,decoded,ltext)     !Extract the message
     nkv=nsum
     if(ncount.lt.0) then 
        nkv=0
        decoded='                      '
     endif
  endif

  return
end subroutine s3avg

subroutine ft8apsetvar(lmycallstd,lhiscallstd,numthreads)

  use packjt77
  use ft8_mod1, only : apsym,mycall,hiscall,apsymsp,lhound,apsymdxns1,apsymdxnsrrr,mybcall,hisbcall,apcqsym,hisgrid4,     &
                       apsymdxnsrr73,apsymdxns73,apsymmyns1,apsymmyns2,apsymmynsrr73,apsymmyns73,apsymdxstd,apsymdxnsr73, &
                       apsymdxns732,apsymmynsrrr
  character*77 c77
  character*37 msg,msgchk
  character*12 hiscallt,mycallprev,hiscallprev
  logical lnohiscall,unpk77_successvar,first
  logical(1) lhoundprev
  logical(1), intent(in) :: lmycallstd,lhiscallstd
  data mycallprev/'QQ2QQ'/
  data hiscallprev/'QQ1QQ'/
  data lhoundprev/.false./
  data first/.true./
  save hiscallprev,mycallprev,lhoundprev,first

  if(hiscall.ne.hiscallprev .or. mycall.ne.mycallprev .or. (lhound.neqv.lhoundprev) .or. first) then ! first for lhound triggered

    first=.false.; mycallprev=mycall; lhoundprev=lhound

! shall hash both callsigns for making AP masks with nonstandard callsign message
    if(.not.lhound) call fillhashvar(numthreads,.true.)

    lnohiscall=.false.
    hiscallt=hiscall
    if(len_trim(hiscallt).lt.3) then
      hiscallt=mycall  ! use mycall for dummy hiscall - mycall won't be hashed
      lnohiscall=.true.
    endif

    if(hiscall.ne.hiscallprev) then
      hiscallprev=hiscall
! Encode a dummy standard message: i3=1, 28 1 28 1 1 15
      if(len_trim(hiscall).gt.2) then
        if(lhiscallstd .and. len_trim(hisgrid4).eq.4) then; msg='CQ '//trim(hiscall)//' '//trim(hisgrid4)
        else; msg='CQ '//trim(hiscall)
        endif

        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(lhiscallstd .and. i3.ne.1 .or. .not.lhiscallstd .and. i3.ne.4 .or. (msg.ne.msgchk) .or. .not.unpk77_successvar) go to 1
        read(c77,'(77i1)',err=1) apcqsym(1:77)
        apcqsym=2*apcqsym-1
      endif

      if(lhiscallstd .and. .not.lmycallstd) then
        msg=trim(hiscall)//' '//trim(hiscall)//' RRR'
        i3=0; n3=0
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.1 .or. (msg.ne.msgchk) .or. .not.unpk77_successvar) go to 2
        read(c77,'(58i1)',err=2) apsymdxstd(1:58)
        apsymdxstd=2*apsymdxstd-1
      endif

      if(.not.lhound .and. .not.lhiscallstd .and. len_trim(hiscall).gt.2) then
! nonstandard DXCall searching
        msg='<W9XYZ> '//trim(hiscall)//' RR73'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.4 .or. .not.unpk77_successvar) go to 3
        read(c77,'(77i1)',err=3) apsymdxnsrr73(1:77)
        apsymdxnsrr73=2*apsymdxnsrr73-1

        msg='<W9XYZ> '//trim(hiscall)//' 73'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.4 .or. .not.unpk77_successvar) go to 4
        read(c77,'(77i1)',err=4) apsymdxns73(1:77)
        apsymdxns73=2*apsymdxns73-1
      endif
    endif

    if(.not.lhound .and. .not.lmycallstd .and. len_trim(mycall).gt.2) then
      if(lhiscallstd) then
        msg='<'//trim(mycall)//'> '//trim(hiscall)//' -15'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
        if(i3.ne.1 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 5
        read(c77,'(58i1)',err=5) apsymmyns2(1:58)
        apsymmyns2=2*apsymmyns2-1

        nlenmyc=len_trim(mycall)
        msg=trim(mycall)//' <'//trim(hiscall)//'> RR73'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
        if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 6
        read(c77,'(77i1)',err=6) apsymmynsrr73(1:77)
        apsymmynsrr73=2*apsymmynsrr73-1
        msg=trim(mycall)//' <'//trim(hiscall)//'> 73'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
        if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 7
        read(c77,'(77i1)',err=7) apsymmyns73(1:77)
        apsymmyns73=2*apsymmyns73-1
        msg=trim(mycall)//' <'//trim(hiscall)//'> RRR'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
        if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 15
        read(c77,'(77i1)',err=15) apsymmynsrrr(1:77)
        apsymmynsrrr=2*apsymmynsrrr-1

      else if(lnohiscall) then

        msg='<'//trim(mycall)//'> ZZ1ZZZ -15'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
        if(i3.ne.1 .or. msgchk.ne.msg .or. .not.unpk77_successvar) go to 8
        read(c77,'(29i1)',err=8) apsymmyns1(1:29)
        apsymmyns1=2*apsymmyns1-1
      endif
    endif

    if(len_trim(mycall).lt.3) return

    if(.not.lhound .and. lmycallstd .and. (lhiscallstd .or. lnohiscall)) then
      msg=trim(mycall)//' '//trim(hiscallt)//' RRR'
      i3=0; n3=0
      call pack77var(msg,i3,n3,c77,0)
      call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.1 .or. (msg.ne.msgchk) .or. .not.unpk77_successvar) go to 9
      read(c77,'(58i1)',err=9) apsym(1:58)
      apsym=2*apsym-1; if(lnohiscall) apsym(30)=99
    endif

    if(lhound) then
! standard messages from Fox, always base callsigns
      if(len_trim(hisbcall).gt.2 .and. len_trim(mybcall).gt.2) then
        msg=trim(mybcall)//' '//trim(hisbcall)//' -15'
        call pack77var(msg,i3,n3,c77,0)
        call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.1 .or. (msg.ne.msgchk) .or. .not.unpk77_successvar) go to 9
        read(c77,'(58i1)',err=9) apsym(1:58)
        apsym=2*apsym-1
      else
        apsym(30)=99
      endif

! special messages
      msg=trim(mycall)//' RR73; '//trim(mycall)//' <'//trim(hiscallt)//'> -16'
      i3=0; n3=1
      call pack77var(msg,i3,n3,c77,0)
      call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      i1=0; i1=index(msgchk,'<'); if(i1.lt.15) return
      if(i3.ne.0 .or. msg(1:i1).ne.msgchk(1:i1) .or. .not.unpk77_successvar) go to 10
      read(c77,'(66i1)',err=10) apsymsp(1:66)
      apsymsp=2*apsymsp-1!; if(lnohiscall) apsymsp(30)=99
    endif

    if(.not.lhound .and. lmycallstd .and. .not.lhiscallstd .and. len_trim(hiscall).gt.2) then
      msg=trim(mycall)//' <'//trim(hiscall)//'> -16' ! report, rreport
      call pack77var(msg,i3,n3,c77,0)
      call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.1 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 11
      read(c77,'(58i1)',err=11) apsymdxns1(1:58)
      apsymdxns1=2*apsymdxns1-1

      msg='<'//trim(mycall)//'> '//trim(hiscall)//' RRR'
      call pack77var(msg,i3,n3,c77,0)
      call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 12
      read(c77,'(77i1)',err=12) apsymdxnsrrr(1:77)
      apsymdxnsrrr=2*apsymdxnsrrr-1

      msg='<'//trim(mycall)//'> '//trim(hiscall)//' RR73'
      call pack77var(msg,i3,n3,c77,0)
      call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 13
      read(c77,'(77i1)',err=13) apsymdxnsr73(1:77)
      apsymdxnsr73=2*apsymdxnsr73-1

      msg='<'//trim(mycall)//'> '//trim(hiscall)//' 73'
      call pack77var(msg,i3,n3,c77,0)
      call unpack77var(c77,1,msgchk,unpk77_successvar,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_successvar) go to 14
      read(c77,'(77i1)',err=14) apsymdxns732(1:77)
      apsymdxns732=2*apsymdxns732-1
    endif

  endif

  go to 32

1 apcqsym=0; apcqsym(1)=99; apcqsym(30)=99; go to 32
2 apsymdxstd=0; apsymdxstd(1)=99; apsymdxstd(30)=99; go to 32
3 apsymdxnsrr73=0; apsymdxnsrr73(1)=99; apsymdxnsrr73(30)=99; go to 32
4 apsymdxns73=0; apsymdxns73(1)=99; apsymdxns73(30)=99; go to 32
5 apsymmyns2=0; apsymmyns2(1)=99; apsymmyns2(30)=99; go to 32
6 apsymmynsrr73=0; apsymmynsrr73(1)=99; apsymmynsrr73(30)=99; go to 32
7 apsymmyns73=0; apsymmyns73(1)=99; apsymmyns73(30)=99; go to 32
8 apsymmyns1=0; apsymmyns1(1)=99; go to 32
9 apsym=0; apsym(1)=99; apsym(30)=99; go to 32
10 apsymsp=0; apsymsp(1)=99; apsymsp(30)=99; go to 32
11 apsymdxns1=0; apsymdxns1(1)=99; apsymdxns1(30)=99; go to 32
12 apsymdxnsrrr=0; apsymdxnsrrr(1)=99; apsymdxnsrrr(30)=99; go to 32
13 apsymdxnsr73=0; apsymdxnsr73(1)=99; apsymdxnsr73(30)=99; go to 32
14 apsymdxns732=0; apsymdxns732(1)=99; apsymdxns732(30)=99; go to 32
15 apsymmynsrrr=0; apsymmynsrrr(1)=99; apsymmynsrrr(30)=99; go to 32

32 continue

  return
end subroutine ft8apsetvar

subroutine msk40decodeframe(c,mycall,hiscall,xsnr,bswl,nhasharray,             &
                            msgreceived,nsuccess)
!  use timer_module, only: timer
  use packjt77

  parameter (NSPM=240)
  character*4 rpt(0:15)
  character*12 mycall,hiscall,mycall0,hiscall0
  character*37 hashmsg,msgreceived
  complex cb(42)
  complex cfac,cca
  complex c(NSPM)
  integer*1 cw(32)
  integer*1 decoded(16)
  integer s8r(8),hardbits(40)
  integer nhasharray(MAXRECENT,MAXRECENT)
  real*8 dt, fs, pi, twopi
  real cbi(42),cbq(42)
  real pp(12)
  real softbits(40)
  real llr(32)
  logical first
  logical*1 bswl
  data first/.true./
  data s8r/1,0,1,1,0,0,0,1/
  data mycall0/'dummy'/,hiscall0/'dummy'/
  data rpt/"-03 ","+00 ","+03 ","+06 ","+10 ","+13 ","+16 ", &
           "R-03","R+00","R+03","R+06","R+10","R+13","R+16", &
           "RRR ","73  "/
  save first,cb,fs,pi,twopi,dt,s8r,pp,rpt,mycall0,hiscall0,ihash

  if(first) then
! define half-sine pulse and raised-cosine edge window
     pi=4d0*datan(1d0)
     twopi=8d0*datan(1d0)
     fs=12000.0
     dt=1.0/fs

     do i=1,12
       angle=(i-1)*pi/12.0
       pp(i)=sin(angle)
     enddo

! define the sync word waveforms
     s8r=2*s8r-1  
     cbq(1:6)=pp(7:12)*s8r(1)
     cbq(7:18)=pp*s8r(3)
     cbq(19:30)=pp*s8r(5)
     cbq(31:42)=pp*s8r(7)
     cbi(1:12)=pp*s8r(2)
     cbi(13:24)=pp*s8r(4)
     cbi(25:36)=pp*s8r(6)
     cbi(37:42)=pp(1:6)*s8r(8)
     cb=cmplx(cbi,cbq)
     first=.false.
  endif

  if(mycall.ne.mycall0 .or. hiscall.ne.hiscall0) then
    hashmsg=trim(mycall)//' '//trim(hiscall)
    if( hashmsg .ne. ' ' .and. hiscall .ne. ''  ) then ! protect against blank mycall/hiscall
      call fmtmsg(hashmsg,iz)
      call hash(hashmsg,37,ihash)
      ihash=iand(ihash,4095)
    else
      ihash=9999  ! so that it can never match a received hash
    endif
    mycall0=mycall
    hiscall0=hiscall
  endif

  nsuccess=0
  msgreceived=' '

! Estimate carrier phase. 
  cca=sum(c(1:1+41)*conjg(cb))
  phase0=atan2(imag(cca),real(cca))

! Remove phase error - want constellation rotated so that sample points lie on I/Q axes
  cfac=cmplx(cos(phase0),sin(phase0))
  c=c*conjg(cfac)

! Matched filter.
  softbits(1)=sum(imag(c(1:6))*pp(7:12))+sum(imag(c(NSPM-5:NSPM))*pp(1:6))
  softbits(2)=sum(real(c(1:12))*pp)
  do i=2,20
    softbits(2*i-1)=sum(imag(c(1+(i-1)*12-6:1+(i-1)*12+5))*pp)
    softbits(2*i)=sum(real(c(7+(i-1)*12-6:7+(i-1)*12+5))*pp)
  enddo

! Sync word hard error weight is used to reject frames that 
! are unlikely to decode.
  hardbits=0
  do i=1,40
    if( softbits(i) .ge. 0.0 ) then
      hardbits(i)=1
    endif
  enddo
  nbadsync1=(8-sum( (2*hardbits(1:8)-1)*s8r ) )/2
  nbadsync=nbadsync1
  if( nbadsync .gt. 3 ) then
    return
  endif

! Normalize the softsymbols before submitting to decoder.
  sav=sum(softbits)/40
  s2av=sum(softbits*softbits)/40
  ssig=sqrt(s2av-sav*sav)
  softbits=softbits/ssig

  sigma=0.75
!  if(xsnr.lt.0.0) sigma=0.75-0.0875*xsnr
  if(xsnr.lt.0.0) sigma=0.75-0.11*xsnr
  llr(1:32)=softbits(9:40)
  llr=2.0*llr/(sigma*sigma)
  
  max_iterations=5
  call bpdecode40(llr,max_iterations,decoded,niterations)
  if( niterations .ge. 0.0 ) then
    call encode_msk40(decoded,cw)
    nhammd=0
    cord=0.0
    do i=1,32
      if( cw(i) .ne. hardbits(i+8) ) then
        nhammd=nhammd+1
        cord=cord+abs(softbits(i+8))
      endif
    enddo

    imsg=0
    do i=1,16
      imsg=ishft(imsg,1)+iand(1_1,decoded(17-i))
    enddo
    nrxrpt=iand(imsg,15)
    nrxhash=(imsg-nrxrpt)/16
    if(nhammd.le.4 .and. cord .lt. 0.65 .and.                                  &
       nrxhash.eq.ihash .and. nrxrpt.ge.7) then
      nsuccess=1    
      write(msgreceived,'(a1,a,1x,a,a1,1x,a4)') "<",trim(mycall),   &
                                    trim(hiscall),">",rpt(nrxrpt)
      return
    elseif(bswl .and. nhammd.le.4 .and. cord.lt.0.65 .and. nrxrpt.ge.7 ) then
      do i=1,MAXRECENT
        do j=i+1,MAXRECENT
          if( nrxhash .eq. nhasharray(i,j) ) then
            nsuccess=2
            write(msgreceived,'(a1,a,1x,a,a1,1x,a4)') "<",trim(recent_calls(i)),   &
                                  trim(recent_calls(j)),">",rpt(nrxrpt)
          elseif( nrxhash .eq. nhasharray(j,i) ) then
            nsuccess=2
            write(msgreceived,'(a1,a,1x,a,a1,1x,a4)') "<",trim(recent_calls(j)),   &
                                  trim(recent_calls(i)),">",rpt(nrxrpt)
          endif
        enddo
      enddo
      if(nsuccess.eq.0) then
        nsuccess=3
        write(msgreceived,'(a1,i4.4,a1,1x,a4)') "<",nrxhash,">",rpt(nrxrpt)
      endif
    endif 
  endif

  return
end subroutine msk40decodeframe

program fixwav

  use wavhdr
  parameter (NBANDS=23,NMODES=11)
  parameter(NMAX=120*12000)
  type(hdr) h
  integer*2 id2(NMAX),id(4)
  character*8 mode,mode0
  character*6 band
  character*12 arg
  character*80 infile
  character*1 c
  logical ok

  nargs=iargc()
  if(nargs.ne.1 .and. nargs.ne.5) then
     print*,'Usage: fixwav [fMHz mode submode TRperiod] infile'
     go to 999
  endif
  call getarg(1,infile)
  if(nargs.eq.1) go to 10
  read(infile,*) fMHz
  call getarg(2,mode0)
  call getarg(3,arg)
  nsubmode0=-1
  do i=1,8
     if(arg(1:1).eq.char(ichar('A')-1+i)) nsubmode0=i
  enddo
  if(nsubmode0.lt.0) read(arg,*) nsubmode0
  call getarg(4,arg)
  read(arg,*) ntrperiod0
  call getarg(5,infile)

10 open(10,file=infile,status='old',access='stream')
  read(10) h
  npts=h%ndata/2
  nfsample=h%nsamrate
  read(10) id2(1:npts)
  write(*,1002) h%nchan2,h%nbitsam2,h%nsamrate,npts
1002 format('Channels:',i2,'   Bits/sample:',i3,'   Sample rate:',i6,   &
          '   Npts:',i8)

  call get_wsjtx_wav_params(id2,band,mode,nsubmode,ntrperiod,ok)
  if(nfsample.ne.11025 .and. nfsample.ne.12000) ok=.false.
  if(ok) write(*,1010) band,ntrperiod,mode,char(ichar('A')-1+id2(3))
1010 format('Band: ',a6,'  T/R period:',i4,'   Mode: ',a8,1x,a1)

  if(.not.ok) write(*,'(a)') 'File has no valid WSJT-X params.'
  if(ok .and. nargs.eq.1) go to 999

  write(*,'(a)',advance='no') 'Do you want to add or change them? (Y/N): '
  read*,c
  if(c.ne.'y' .and. c.ne.'Y') go to 999

  print*,fMHz,mode0,nsubmode0,ntrperiod0
  call set_wsjtx_wav_params(fMHz,mode0,nsubmode0,ntrperiod0,id2)
  band=""
  mode=""
  nsubmode=0
  ntrperiod=0
  call get_wsjtx_wav_params(id2,band,mode,nsubmode,ntrperiod,ok)
  write(*,1010) band,ntrperiod,mode,char(ichar('A')-1+id2(3))
  rewind 10
  write(10) h,id2(1:npts)

999 end program fixwav

module wavhdr
  use iso_fortran_env, only: int32, int16
  implicit none

  type hdr
     character(len=4) :: ariff
     integer(int32)   :: lenfile
     character(len=4) :: awave
     character(len=4) :: afmt
     integer(int32)   :: lenfmt
     integer(int16)   :: nfmt2
     integer(int16)   :: nchan2
     integer(int32)   :: nsamrate
     integer(int32)   :: nbytesec
     integer(int16)   :: nbytesam2
     integer(int16)   :: nbitsam2
     character(len=4) :: adata
     integer(int32)   :: ndata
  end type hdr

contains

  function default_header(nsamrate,npts) result(hdr_out)
    implicit none
    integer, intent(in) :: nsamrate, npts
    type(hdr) :: hdr_out, h

    h%ariff    = 'RIFF'
    h%awave    = 'WAVE'
    h%afmt     = 'fmt '
    h%lenfmt   = 16
    h%nfmt2    = 1
    h%nchan2   = 1
    h%nsamrate = nsamrate
    h%nbitsam2 = 16
    h%nbytesam2 = h%nbitsam2 * h%nchan2 / 8
    h%adata    = 'data'
    h%nbytesec = h%nsamrate * h%nbitsam2 * h%nchan2 / 8
    h%ndata    = 2*npts
    h%lenfile  = h%ndata + 44 - 8

    hdr_out = h
  end function default_header

  subroutine set_wsjtx_wav_params(fMHz, mode, nsubmode, ntrperiod, id2)
    implicit none
    real,          intent(in)  :: fMHz
    character(len=8),   intent(in)  :: mode
    integer,       intent(in)  :: nsubmode, ntrperiod
    integer(int16),     intent(out) :: id2(4)

    integer, parameter :: NBANDS=23, NMODES=13
    character(len=8) :: modes(NMODES)
    integer(int16)   :: iband, imode, ip
    integer     :: i
    integer     :: iperiod(8)
    real        :: fband(NBANDS), dmin

    data fband/0.137,0.474,1.8,3.5,5.1,7.0,10.14,14.0,18.1,21.0,24.9,  &
         28.0,50.0,144.0,222.0,432.0,902.0,1296.0,2304.0,3400.0,       &
         5760.0,10368.0,24048.0/
    data modes/'Echo','FSK441','ISCAT','JT4','JT65','JT6M','JT9',      &
         'JT9+JT65','JTMS','JTMSK','WSPR','FT8','FT2'/
    data iperiod/5,10,15,30,60,120,900,0/

    dmin  = 1.e30
    iband = 0
    do i=1,NBANDS
       if (abs(fMHz-fband(i)) < dmin) then
          dmin  = abs(fMHz-fband(i))
          iband = i
       end if
    end do

    imode = 0
    do i=1,NMODES
       if (mode == modes(i)) imode = i
    end do

    ip = 0
    do i=1,8
       if (ntrperiod == iperiod(i)) ip = i
    end do

    id2(1) = iband
    id2(2) = imode
    id2(3) = nsubmode
    id2(4) = ip
  end subroutine set_wsjtx_wav_params

  subroutine get_wsjtx_wav_params(id2, band, mode, nsubmode, ntrperiod, ok)
    implicit none
    integer(int16),   intent(in)  :: id2(4)
    character(len=6), intent(out) :: band
    character(len=8), intent(out) :: mode
    integer,     intent(out) :: nsubmode, ntrperiod
    logical,     intent(out) :: ok

    integer, parameter :: NBANDS=23, NMODES=13
    character(len=8) :: modes(NMODES)
    character(len=6) :: bands(NBANDS)
    integer     :: iperiod(8)

    data modes/'Echo','FSK441','ISCAT','JT4','JT65','JT6M','JT9',    &
         'JT9+JT65','JTMS','JTMSK','WSPR','FT8','FT2'/
    data iperiod/5,10,15,30,60,120,900,0/
    data bands/'2190m','630m','160m','80m','60m','40m','30m','20m',  &
         '17m','15m','12m','10m','6m','2m','1.25m','70cm','33cm',    &
         '23cm','13cm','9cm','6cm','3cm','1.25cm'/

    ok = .true.
    if (id2(1) < 1 .or. id2(1) > NBANDS) ok = .false.
    if (id2(2) < 1 .or. id2(2) > NMODES) ok = .false.
    if (id2(3) < 1 .or. id2(3) > 8)      ok = .false.
    if (id2(4) < 1 .or. id2(4) > 8)      ok = .false.

    if (ok) then
       band      = bands(id2(1))
       mode      = modes(id2(2))
       nsubmode  = id2(3)
       ntrperiod = iperiod(id2(4))
    end if
  end subroutine get_wsjtx_wav_params

end module wavhdr

program prob

  implicit real*8 (a-h,o-z)
  integer*8 binomial
  integer x,s,XX,NN
  real*8 hypergeo
  character arg*8

  nargs=iargc()
  if(nargs.ne.4) then
     print*,'Usage:    prob  x  N  X  s'
     print*,'Example:  prob 35 63 40 40'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) x
  call getarg(2,arg)
  read(arg,*) NN
  call getarg(3,arg)
  read(arg,*) XX
  call getarg(4,arg)
  read(arg,*) s

!  print*,binomial(5, 3)             ! 10
!  print*,binomial(40, 19)           ! 131282408400

  write(*,1010) x,NN,XX,s
1010 format(//' x=',i2,'   N=',i2,'   X=',i2,'   s=',i2)
  write(*,1012) 
1012 format(/' x    P(x|N,X,s)  P(>=x|N,X,s) '/  &
             '-------------------------------')

  hsum=0.d0
  do ix=x,XX
     h=hypergeo(ix,NN,XX,s)
     hsum=hsum + h
     write(*,1020) ix,h,hsum
1020 format(i3,2d13.4)
  enddo

999 end program prob

subroutine ft8b(dd0,newdat,nQSOProgress,nfqso,nftx,ndepth,nzhsym,lapon,     &
     lapcqonly,napwid,lsubtract,nagain,ncontest,iaptype,mycall12,hiscall12, &
     f1,xdt,xbase,apsym,aph10,nharderrors,dmin,nbadcrc,ipass,               &
     msg37,xsnr,itone)

  use crc
  use timer_module, only: timer
  use packjt77
  include 'ft8_params.f90'
  parameter(NP2=2812)
  character*37 msg37
  character*12 mycall12,hiscall12
  character*77 c77
  real a(5)
  real s8(0:7,NN)
  real s2(0:511)
  real bmeta(174),bmetb(174),bmetc(174),bmetd(174)
  real llra(174),llrb(174),llrc(174),llrd(174),llrz(174)           !Soft symbols
  real dd0(15*12000)
  real ss(9)
  integer*1 message77(77),message91(91),apmask(174),cw(174)
  integer apsym(58),aph10(10)
  integer mcq(29),mcqru(29),mcqfd(29),mcqtest(29),mcqww(29)
  integer mrrr(19),m73(19),mrr73(19)
  integer itone(NN)
  integer icos7(0:6),ip(1)
  integer nappasses(0:5)  !Number of decoding passes to use for each QSO state
  integer naptypes(0:5,4) ! (nQSOProgress, decoding pass)  maximum of 4 passes for now
  integer ncontest,ncontest0
  logical one(0:511,0:8)
  integer graymap(0:7)
  integer iloc(1)
  complex cd0(0:3199)
  complex ctwk(32)
  complex csymb(32)
  complex cs(0:7,NN)
  logical first,newdat,lsubtract,lapon,lapcqonly,nagain,unpk77_success
  data icos7/3,1,4,0,6,5,2/  ! Flipped w.r.t. original FT8 sync array
  data     mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
  data   mcqru/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,0,0,1,1,0,0/
  data   mcqfd/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,1,0,0,0,1,0/
  data mcqtest/0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,0,1,0,1,1,1,1,1,1,0,0,1,0/
  data   mcqww/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,1,1,1,1,0/
  data    mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
  data     m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
  data   mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
  data first/.true./
  data graymap/0,1,3,2,5,6,4,7/
  save nappasses,naptypes,ncontest0,one

  if(first.or.(ncontest.ne.ncontest0)) then
     mcq=2*mcq-1
     mcqfd=2*mcqfd-1
     mcqru=2*mcqru-1
     mcqtest=2*mcqtest-1
     mcqww=2*mcqww-1
     mrrr=2*mrrr-1
     m73=2*m73-1
     mrr73=2*mrr73-1
     nappasses(0)=2
     nappasses(1)=2
     nappasses(2)=2
     nappasses(3)=4
     nappasses(4)=4
     nappasses(5)=3

! iaptype
!------------------------
!   1        CQ     ???    ???           (29+3=32 ap bits)
!   2        MyCall ???    ???           (29+3=32 ap bits)
!   3        MyCall DxCall ???           (58+3=61 ap bits)
!   4        MyCall DxCall RRR           (77 ap bits)
!   5        MyCall DxCall 73            (77 ap bits)
!   6        MyCall DxCall RR73          (77 ap bits)

     naptypes(0,1:4)=(/1,2,0,0/) ! Tx6 selected (CQ)
     naptypes(1,1:4)=(/2,3,0,0/) ! Tx1
     naptypes(2,1:4)=(/2,3,0,0/) ! Tx2
     naptypes(3,1:4)=(/3,4,5,6/) ! Tx3
     naptypes(4,1:4)=(/3,4,5,6/) ! Tx4
     naptypes(5,1:4)=(/3,1,2,0/) ! Tx5

     one=.false.
     do i=0,511
       do j=0,8
         if(iand(i,2**j).ne.0) one(i,j)=.true.
       enddo
     enddo
     first=.false.
     ncontest0=ncontest
  endif

  dxcall13=hiscall12  ! initialize for use in packjt77
  mycall13=mycall12

  max_iterations=30
  nharderrors=-1
  fs2=12000.0/NDOWN
  dt2=1.0/fs2
  twopi=8.0*atan(1.0)
  delfbest=0.
  ibest=0

  call timer('ft8_down',0)
  call ft8_downsample(dd0,newdat,f1,cd0)   !Mix f1 to baseband and downsample
  call timer('ft8_down',1)

  i0=nint((xdt+0.5)*fs2)                   !Initial guess for start of signal
  smax=0.0
  do idt=i0-10,i0+10                         !Search over +/- one quarter symbol
     call sync8d(cd0,idt,ctwk,0,sync)
     if(sync.gt.smax) then
        smax=sync
        ibest=idt
     endif
  enddo

! Now peak up in frequency
  smax=0.0
  do ifr=-5,5                              !Search over +/- 2.5 Hz
    delf=ifr*0.5
    dphi=twopi*delf*dt2
    phi=0.0
    do i=1,32
      ctwk(i)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
    enddo
    call sync8d(cd0,ibest,ctwk,1,sync)
    if( sync .gt. smax ) then
      smax=sync
      delfbest=delf
    endif
  enddo
  a=0.0
  a(1)=-delfbest
  call twkfreq1(cd0,NP2,fs2,a,cd0)
  f1=f1+delfbest                           !Improved estimate of DF

  call timer('ft8_down',0)
  call ft8_downsample(dd0,.false.,f1,cd0)   !Mix f1 to baseband and downsample
  call timer('ft8_down',1)

  smax=0.0
  do idt=-4,4                         !Search over +/- one quarter symbol
     call sync8d(cd0,ibest+idt,ctwk,0,sync)
     ss(idt+5)=sync
  enddo
  smax=maxval(ss)
  iloc=maxloc(ss)
  ibest=iloc(1)-5+ibest
  xdt=(ibest-1)*dt2
  sync=smax

  do k=1,NN
    i1=ibest+(k-1)*32
    csymb=cmplx(0.0,0.0)
    if( i1.ge.0 .and. i1+31 .le. NP2-1 ) csymb=cd0(i1:i1+31)
    call four2a(csymb,32,1,-1,1)
    cs(0:7,k)=csymb(1:8)/1e3
    s8(0:7,k)=abs(csymb(1:8))
  enddo  

! sync quality check
  is1=0
  is2=0
  is3=0
  do k=1,7
    ip=maxloc(s8(:,k))
    if(icos7(k-1).eq.(ip(1)-1)) is1=is1+1
    ip=maxloc(s8(:,k+36))
    if(icos7(k-1).eq.(ip(1)-1)) is2=is2+1
    ip=maxloc(s8(:,k+72))
    if(icos7(k-1).eq.(ip(1)-1)) is3=is3+1
  enddo
! hard sync sum - max is 21
  nsync=is1+is2+is3
  if(nsync .le. 6) then ! bail out
    nbadcrc=1
    return
  endif

  do nsym=1,3
    nt=2**(3*nsym)
    do ihalf=1,2
      do k=1,29,nsym
        if(ihalf.eq.1) ks=k+7
        if(ihalf.eq.2) ks=k+43
        amax=-1.0
        do i=0,nt-1
          i1=i/64
          i2=iand(i,63)/8
          i3=iand(i,7)
          if(nsym.eq.1) then
            s2(i)=abs(cs(graymap(i3),ks))
          elseif(nsym.eq.2) then
            s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i3),ks+1))
          elseif(nsym.eq.3) then
            s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks+1)+cs(graymap(i3),ks+2))
          else
            print*,"Error - nsym must be 1, 2, or 3."
          endif
        enddo
        i32=1+(k-1)*3+(ihalf-1)*87
        if(nsym.eq.1) ibmax=2 
        if(nsym.eq.2) ibmax=5 
        if(nsym.eq.3) ibmax=8 
        do ib=0,ibmax
          bm=maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)) - &
             maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib))
          if(i32+ib .gt.174) cycle
          if(nsym.eq.1) then
            bmeta(i32+ib)=bm
            den=max(maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)), &
                    maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib)))
            if(den.gt.0.0) then
              cm=bm/den
            else ! erase it
              cm=0.0
            endif
            bmetd(i32+ib)=cm
          elseif(nsym.eq.2) then
            bmetb(i32+ib)=bm
          elseif(nsym.eq.3) then
            bmetc(i32+ib)=bm
          endif
        enddo
      enddo
    enddo
  enddo
  call normalizebmet(bmeta,174)
  call normalizebmet(bmetb,174)
  call normalizebmet(bmetc,174)
  call normalizebmet(bmetd,174)

  scalefac=2.83
  llra=scalefac*bmeta
  llrb=scalefac*bmetb
  llrc=scalefac*bmetc
  llrd=scalefac*bmetd

  apmag=maxval(abs(llra))*1.01

! pass #
!------------------------------
!   1        regular decoding, nsym=1 
!   2        regular decoding, nsym=2 
!   3        regular decoding, nsym=3 
!   4        regular decoding, nsym=1, bit-by-bit normalized 
!   5        ap pass 1, nsym=1
!   6        ap pass 2
!   7        ap pass 3
!   8        ap pass 4

  if(lapon.or.ncontest.eq.7) then !Hounds always use AP
     if(.not.lapcqonly) then
        npasses=4+nappasses(nQSOProgress)
     else
        npasses=5 
     endif
  else
     npasses=4
  endif
  if(nzhsym.lt.50) npasses=4
  
  do ipass=1,npasses 
     llrz=llra
     if(ipass.eq.2) llrz=llrb
     if(ipass.eq.3) llrz=llrc
     if(ipass.eq.4) llrz=llrd
     if(ipass.le.4) then
        apmask=0
        iaptype=0
     endif
     if(ipass .gt. 4) then
        llrz=llra
        if(.not.lapcqonly) then
           iaptype=naptypes(nQSOProgress,ipass-4)
        else
           iaptype=1
        endif

! ncontest=0 : NONE
!          1 : NA_VHF
!          2 : EU_VHF
!          3 : FIELD DAY
!          4 : RTTY
!          5 : WW_DIGI 
!          6 : FOX
!          7 : HOUND
!          8 : ARRL_DIGI
!
! Conditions that cause us to bail out of AP decoding
        if(ncontest.le.5 .and. iaptype.ge.3 .and. (abs(f1-nfqso).gt.napwid .and. abs(f1-nftx).gt.napwid) ) cycle
        if(ncontest.eq.6) cycle                     ! No AP for Foxes
        if(ncontest.eq.7.and.f1.gt.950.0) cycle     ! Hounds use AP only for signals below 950 Hz
        if(iaptype.ge.2 .and. apsym(1).gt.1) cycle  ! No, or nonstandard, mycall 
        if(ncontest.eq.7 .and. iaptype.ge.2 .and. aph10(1).gt.1) cycle
        if(iaptype.ge.3 .and. apsym(30).gt.1) cycle ! No, or nonstandard, dxcall

        if(iaptype.eq.1) then ! CQ or CQ RU or CQ TEST or CQ FD
           apmask=0
           apmask(1:29)=1  
           if(ncontest.eq.0) llrz(1:29)=apmag*mcq(1:29)
           if(ncontest.eq.1) llrz(1:29)=apmag*mcqtest(1:29)
           if(ncontest.eq.2) llrz(1:29)=apmag*mcqtest(1:29)
           if(ncontest.eq.3) llrz(1:29)=apmag*mcqfd(1:29)
           if(ncontest.eq.4) llrz(1:29)=apmag*mcqru(1:29)
           if(ncontest.eq.5) llrz(1:29)=apmag*mcqww(1:29)
           if(ncontest.eq.7) llrz(1:29)=apmag*mcq(1:29)
           if(ncontest.eq.8) llrz(1:29)=apmag*mcqtest(1:29)
           apmask(75:77)=1 
           llrz(75:76)=apmag*(-1)
           llrz(77)=apmag*(+1)
        endif

        if(iaptype.eq.2) then ! MyCall,???,??? 
           apmask=0
           if(ncontest.eq.0.or.ncontest.eq.1.or.ncontest.eq.5.or.ncontest.eq.8) then
              apmask(1:29)=1  
              llrz(1:29)=apmag*apsym(1:29)
              apmask(75:77)=1 
              llrz(75:76)=apmag*(-1)
              llrz(77)=apmag*(+1)
           else if(ncontest.eq.2) then
              apmask(1:28)=1  
              llrz(1:28)=apmag*apsym(1:28)
              apmask(72:74)=1
              llrz(72)=apmag*(-1)
              llrz(73)=apmag*(+1)
              llrz(74)=apmag*(-1)
              apmask(75:77)=1 
              llrz(75:77)=apmag*(-1)
           else if(ncontest.eq.3) then
              apmask(1:28)=1  
              llrz(1:28)=apmag*apsym(1:28)
              apmask(75:77)=1 
              llrz(75:77)=apmag*(-1)
           else if(ncontest.eq.4) then
              apmask(2:29)=1  
              llrz(2:29)=apmag*apsym(1:28)
              apmask(75:77)=1 
              llrz(75)=apmag*(-1)
              llrz(76:77)=apmag*(+1)
           else if(ncontest.eq.7) then ! ??? RR73; MyCall <Fox Call hash10> ???
              apmask(29:56)=1  
              llrz(29:56)=apmag*apsym(1:28)
              apmask(57:66)=1
              llrz(57:66)=apmag*aph10(1:10)
              apmask(72:77)=1 
              llrz(72:73)=apmag*(-1)
              llrz(74)=apmag*(+1)
              llrz(75:77)=apmag*(-1)
           endif
        endif

        if(iaptype.eq.3) then ! MyCall,DxCall,??? 
           apmask=0
           if(ncontest.eq.0.or.ncontest.eq.1.or.ncontest.eq.2.or.ncontest.eq.5.or.ncontest.eq.7.or.ncontest.eq.8) then
              apmask(1:58)=1  
              llrz(1:58)=apmag*apsym
              apmask(75:77)=1 
              llrz(75:76)=apmag*(-1)
              llrz(77)=apmag*(+1)
           else if(ncontest.eq.3) then ! Field Day
              apmask(1:56)=1  
              llrz(1:28)=apmag*apsym(1:28)
              llrz(29:56)=apmag*apsym(30:57)
              apmask(72:74)=1 
              apmask(75:77)=1 
              llrz(75:77)=apmag*(-1)
           else if(ncontest.eq.4) then 
              apmask(2:57)=1  
              llrz(2:29)=apmag*apsym(1:28)
              llrz(30:57)=apmag*apsym(30:57)
              apmask(75:77)=1 
              llrz(75)=apmag*(-1)
              llrz(76:77)=apmag*(+1)
           endif
        endif

        if(iaptype.eq.5.and.ncontest.eq.7) cycle !Hound
        if(iaptype.eq.4 .or. iaptype.eq.5 .or. iaptype.eq.6) then  
           apmask=0
           if(ncontest.le.5 .or. (ncontest.eq.7.and.iaptype.eq.6) .or. ncontest.eq.8) then
              apmask(1:77)=1   ! mycall, hiscall, RRR|73|RR73
              llrz(1:58)=apmag*apsym
              if(iaptype.eq.4) llrz(59:77)=apmag*mrrr 
              if(iaptype.eq.5) llrz(59:77)=apmag*m73 
              if(iaptype.eq.6) llrz(59:77)=apmag*mrr73 
           else if(ncontest.eq.7.and.iaptype.eq.4) then ! Hound listens for MyCall RR73;...
              apmask(1:28)=1
              llrz(1:28)=apmag*apsym(1:28)
              apmask(57:66)=1
              llrz(57:66)=apmag*aph10(1:10)
              apmask(72:77)=1
              llrz(72:73)=apmag*(-1)
              llrz(74)=apmag*(1)
              llrz(75:77)=apmag*(-1)
           endif             
        endif
     endif

     cw=0
     dmin=0.0
     norder=2
     maxosd=2
     if(ndepth.eq.1) maxosd=-1  ! BP only
     if(ndepth.eq.2) maxosd=0   ! uncoupled BP+OSD
     if(ndepth.eq.3 .and.         &
        (abs(nfqso-f1).le.napwid .or. abs(nftx-f1).le.napwid .or. ncontest.eq.7)) then
        maxosd=2
     endif
     call timer('dec174_91 ',0)
     Keff=91
     call decode174_91(llrz,Keff,maxosd,norder,apmask,message91,cw,  &
                       ntype,nharderrors,dmin)
     if(nharderrors.ge.0) message77=message91(1:77)
     call timer('dec174_91 ',1)

     msg37='                                     '
     nbadcrc=1
     if(nharderrors.lt.0 .or. nharderrors.gt.36) cycle
     if(count(cw.eq.0).eq.174) cycle           !Reject the all-zero codeword
     write(c77,'(77i1)') message77
     read(c77(72:74),'(b3)') n3
     read(c77(75:77),'(b3)') i3
     if(i3.gt.5 .or. (i3.eq.0.and.n3.gt.6)) cycle
     if(i3.eq.0 .and. n3.eq.2) cycle
     call unpack77(c77,1,msg37,unpk77_success)
     if(.not.unpk77_success) cycle
     nbadcrc=0  ! If we get this far: valid codeword, valid (i3,n3), nonquirky message.
     call get_ft8_tones_from_77bits(message77,itone)
     if(lsubtract) then
        call timer('sub_ft8a',0)
        call subtractft8(dd0,itone,f1,xdt,.false.)
        call timer('sub_ft8a',1)
     endif
     xsig=0.0
     xnoi=0.0
     do i=1,79
        xsig=xsig+s8(itone(i),i)**2
        ios=mod(itone(i)+4,7)
        xnoi=xnoi+s8(ios,i)**2
     enddo
     xsnr=0.001
     xsnr2=0.001
     arg=xsig/xnoi-1.0 
     if(arg.gt.0.1) xsnr=arg
     arg=xsig/xbase/3.0e6-1.0
     if(arg.gt.0.1) xsnr2=arg
     xsnr=10.0*log10(xsnr)-27.0
     xsnr2=10.0*log10(xsnr2)-27.0
     if(.not.nagain) then
       xsnr=xsnr2
    endif
    if(nsync.le.10 .and. xsnr.lt.-24.0) then    !bail out, likely false decode
       nbadcrc=1
       return
    endif
    if(xsnr .lt. -24.0) xsnr=-24.0
    return
  enddo
  return
end subroutine ft8b

subroutine normalizebmet(bmet,n)
  real bmet(n)

  bmetav=sum(bmet)/real(n)
  bmet2av=sum(bmet*bmet)/real(n)
  var=bmet2av-bmetav*bmetav
  if( var .gt. 0.0 ) then
     bmetsig=sqrt(var)
  else
     bmetsig=sqrt(bmet2av)
  endif
  bmet=bmet/bmetsig
  return
end subroutine normalizebmet


function bessi0(x) 
! From Numerical Recipes
   real bessi0,x
   double precision p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9,y
   save p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9
   data p1,p2,p3,p4,p5,p6,p7/1.0d0,3.5156229d0,3.0899424d0,1.2067492d0, &
      0.2659732d0,0.360768d-1,0.45813d-2/
   data q1,q2,q3,q4,q5,q6,q7,q8,q9/0.39894228d0,0.1328592d-1,           &
      0.225319d-2,-0.157565d-2,0.916281d-2,-0.2057706d-1,               &
      0.2635537d-1,-0.1647633d-1,0.392377d-2/

   if (abs(x).lt.3.75) then 
      y=(x/3.75)**2
      bessi0=p1+y*(p2+y*(p3+y*(p4+y*(p5+y*(p6+y*p7))))) 
   else
      ax=abs(x)
      y=3.75/ax 
      bessi0=(exp(ax)/sqrt(ax))*(q1+y*(q2+y*(q3+y*(q4         &
           +y*(q5+y*(q6+y*(q7+y*(q8+y*q9))))))))
   endif
   return
end function bessi0

subroutine getcandidates2a(id,fa,fb,maxcand,savg,candidate,ncand)

! For now, hardwired to find the largest peak in the average spectrum

  include 'ft2_params.f90'
  real s(NH1,NHSYM)
  real savg(NH1),savsm(NH1)
  real x(NFFT1)
  complex cx(0:NH1)
  real candidate(3,100)
  integer*2 id(NMAX)
  integer*1 s8(8)
  integer indx(NH1)
  data s8/0,1,1,1,0,0,1,0/
  equivalence (x,cx)

! Compute symbol spectra, stepping by NSTEP steps.  
  savg=0.
  tstep=NSTEP/12000.0                         
  df=12000.0/NFFT1                            !3.125 Hz
  fac=1.0/300.0
  do j=1,NHSYM
     ia=(j-1)*NSTEP + 1
     ib=ia+NSPS-1
     x(1:NSPS)=fac*id(ia:ib)
     x(NSPS+1:)=0.
     call four2a(x,NFFT1,1,-1,0)              !r2c FFT
     do i=1,NH1
        s(i,j)=real(cx(i))**2 + aimag(cx(i))**2
     enddo
     savg=savg + s(1:NH1,j)                   !Average spectrum
  enddo
  savsm=0.
  do i=2,NH1-1
    savsm(i)=sum(savg(i-1:i+1))/3.
  enddo
  savsm(1)=savg(1)
  savsm(NH1)=savg(NH1)

  nfa=nint(fa/df)
  nfb=nint(fb/df)
  np=nfb-nfa+1
  indx=0
  call indexx(savsm(nfa:nfb),np,indx)
  xn=savsm(nfa+indx(nint(0.3*np)))
  if(xn.ne.0) savsm=savsm/xn
  imax=-1
  xmax=-99.
  do i=2,NH1-1
    if(savsm(i).gt.savsm(i-1).and.    &
       savsm(i).gt.savsm(i+1).and.    &
       savsm(i).gt.xmax) then
      xmax=savsm(i) 
      imax=i
    endif
  enddo
  f0=imax*df
  if(xmax.gt.1.2) then
     if(ncand.lt.maxcand) ncand=ncand+1
     candidate(1,ncand)=f0
  endif

  return
end subroutine getcandidates2a

      subroutine ssort (x,y,n,kflag)
c***purpose  sort an array and optionally make the same interchanges in
c            an auxiliary array.  the array may be sorted in increasing
c            or decreasing order.  a slightly modified quicksort
c            algorithm is used.
c
c   ssort sorts array x and optionally makes the same interchanges in
c   array y.  the array x may be sorted in increasing order or
c   decreasing order.  a slightly modified quicksort algorithm is used.
c
c   description of parameters
c      x - array of values to be sorted
c      y - array to be (optionally) carried along
c      n - number of values in array x to be sorted
c      kflag - control parameter
c            =  2  means sort x in increasing order and carry y along.
c            =  1  means sort x in increasing order (ignoring y)
c            = -1  means sort x in decreasing order (ignoring y)
c            = -2  means sort x in decreasing order and carry y along.

      integer kflag, n
!      real x(n), y(n)
!      real r, t, tt, tty, ty
      integer x(n), y(n)
      integer r, t, tt, tty, ty
      integer i, ij, j, k, kk, l, m, nn
      integer il(21), iu(21)

      nn = n
      if (nn .lt. 1) then
!         print*,'ssort: The number of sort elements is not positive.'
!         print*,'ssort: n = ',nn,'   kflag = ',kflag
         return
      endif
c
      kk = abs(kflag)
      if (kk.ne.1 .and. kk.ne.2) then
         print *,
     +      'the sort control parameter, k, is not 2, 1, -1, or -2.'
         return
      endif
c
c     alter array x to get decreasing order if needed
c
      if (kflag .le. -1) then
         do 10 i=1,nn
            x(i) = -x(i)
   10    continue
      endif
c
      if (kk .eq. 2) go to 100
c
c     sort x only
c
      m = 1
      i = 1
      j = nn
      r = 0.375e0
c
   20 if (i .eq. j) go to 60
      if (r .le. 0.5898437e0) then
         r = r+3.90625e-2
      else
         r = r-0.21875e0
      endif
c
   30 k = i
c
c     select a central element of the array and save it in location t
c
      ij = i + int((j-i)*r)
      t = x(ij)
c
c     if first element of array is greater than t, interchange with t
c
      if (x(i) .gt. t) then
         x(ij) = x(i)
         x(i) = t
         t = x(ij)
      endif
      l = j
c
c     if last element of array is less than than t, interchange with t
c
      if (x(j) .lt. t) then
         x(ij) = x(j)
         x(j) = t
         t = x(ij)
c
c        if first element of array is greater than t, interchange with t
c
         if (x(i) .gt. t) then
            x(ij) = x(i)
            x(i) = t
            t = x(ij)
         endif
      endif
c
c     find an element in the second half of the array which is smaller
c     than t
c
   40 l = l-1
      if (x(l) .gt. t) go to 40
c
c     find an element in the first half of the array which is greater
c     than t
c
   50 k = k+1
      if (x(k) .lt. t) go to 50
c
c     interchange these elements
c
      if (k .le. l) then
         tt = x(l)
         x(l) = x(k)
         x(k) = tt
         go to 40
      endif
c
c     save upper and lower subscripts of the array yet to be sorted
c
      if (l-i .gt. j-k) then
         il(m) = i
         iu(m) = l
         i = k
         m = m+1
      else
         il(m) = k
         iu(m) = j
         j = l
         m = m+1
      endif
      go to 70
c
c     begin again on another portion of the unsorted array
c
   60 m = m-1
      if (m .eq. 0) go to 190
      i = il(m)
      j = iu(m)
c
   70 if (j-i .ge. 1) go to 30
      if (i .eq. 1) go to 20
      i = i-1
c
   80 i = i+1
      if (i .eq. j) go to 60
      t = x(i+1)
      if (x(i) .le. t) go to 80
      k = i
c
   90 x(k+1) = x(k)
      k = k-1
      if (t .lt. x(k)) go to 90
      x(k+1) = t
      go to 80
c
c     sort x and carry y along
c
  100 m = 1
      i = 1
      j = nn
      r = 0.375e0
c
  110 if (i .eq. j) go to 150
      if (r .le. 0.5898437e0) then
         r = r+3.90625e-2
      else
         r = r-0.21875e0
      endif
c
  120 k = i
c
c     select a central element of the array and save it in location t
c
      ij = i + int((j-i)*r)
      t = x(ij)
      ty = y(ij)
c
c     if first element of array is greater than t, interchange with t
c
      if (x(i) .gt. t) then
         x(ij) = x(i)
         x(i) = t
         t = x(ij)
         y(ij) = y(i)
         y(i) = ty
         ty = y(ij)
      endif
      l = j
c
c     if last element of array is less than t, interchange with t
c
      if (x(j) .lt. t) then
         x(ij) = x(j)
         x(j) = t
         t = x(ij)
         y(ij) = y(j)
         y(j) = ty
         ty = y(ij)
c
c        if first element of array is greater than t, interchange with t
c
         if (x(i) .gt. t) then
            x(ij) = x(i)
            x(i) = t
            t = x(ij)
            y(ij) = y(i)
            y(i) = ty
            ty = y(ij)
         endif
      endif
c
c     find an element in the second half of the array which is smaller
c     than t
c
  130 l = l-1
      if (x(l) .gt. t) go to 130
c
c     find an element in the first half of the array which is greater
c     than t
c
  140 k = k+1
      if (x(k) .lt. t) go to 140
c
c     interchange these elements
c
      if (k .le. l) then
         tt = x(l)
         x(l) = x(k)
         x(k) = tt
         tty = y(l)
         y(l) = y(k)
         y(k) = tty
         go to 130
      endif
c
c     save upper and lower subscripts of the array yet to be sorted
c
      if (l-i .gt. j-k) then
         il(m) = i
         iu(m) = l
         i = k
         m = m+1
      else
         il(m) = k
         iu(m) = j
         j = l
         m = m+1
      endif
      go to 160
c
c     begin again on another portion of the unsorted array
c
  150 m = m-1
      if (m .eq. 0) go to 190
      i = il(m)
      j = iu(m)
c
  160 if (j-i .ge. 1) go to 120
      if (i .eq. 1) go to 110
      i = i-1
c
  170 i = i+1
      if (i .eq. j) go to 150
      t = x(i+1)
      ty = y(i+1)
      if (x(i) .le. t) go to 170
      k = i
c
  180 x(k+1) = x(k)
      y(k+1) = y(k)
      k = k-1
      if (t .lt. x(k)) go to 180
      x(k+1) = t
      y(k+1) = ty
      go to 170
c
c     clean up
c
  190 if (kflag .le. -1) then
         do 200 i=1,nn
            x(i) = -x(i)
  200    continue
      endif
      return
      end

program tastro

  implicit real*8 (a-h,o-z)

  character grid*6
  character*9 cauxra,cauxdec

  character*12 clock(3)
  integer nt(8)
  equivalence (nt(1),nyear)

  grid='FN20qi'
  nfreq=144
  cauxra='00:00:00'
  
10 call date_and_time(clock(1),clock(2),clock(3),nt)
  ih=ihour-ntz/60
  if(ih.le.0) then
     ih=ih+24
     nday=nday+1
  endif
  uth8=ih + imin/60.d0 + isec/3600.d0 + ims/3600000.d0 
  call astro0(nyear,month,nday,uth8,nfreq,grid,cauxra,cauxdec,       &
     AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
     dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,  &
     RaAux8,DecAux8,AzAux8,ElAux8,width1,width2,w501,w502,xlst8)
  
  write(*,1010) nyear,month,nday,ih,imin,isec,AzMoon8,ElMoon8,          &
       AzSun8,ElSun8,ndop,dgrd8,ntsky
1010 format(i4,i3,i3,i4.2,':',i2.2,':',i2.2,4f8.1,i6,f6.1,i6)

  call system('sleep 1')
  go to 10

end program tastro

subroutine genq65(msg0,ichk,msgsent,itone,i3,n3)

! Encodes a Q65 message to yield itone(1:85)

  use packjt77
  character*37 msg0               !Message to be generated
  character*37 msgsent            !Message as it will be received
  character*77 c77
  logical unpk77_success
  integer itone(85)               !QRA64 uses only 84
  integer dgen(13)
  integer sent(63)
  integer isync(22)
  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/
  save

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    itone(1)=nfreq
     write(msgsent,1000) nfreq
1000 format(i5,' Hz')
     goto 999
  endif
  i3=-1
  n3=-1
  call pack77(msg0,i3,n3,c77)
  read(c77(60:74),'(b15)') ng15
  if(ng15.eq.32373) c77(60:74)='111111010010011'    !Message is RR73
  call unpack77(c77,0,msgsent,unpk77_success)    !Unpack to get msgsent
  read(c77,1001) dgen
1001 format(12b6.6,b5.5)
  dgen(13)=2*dgen(13)           !Convert 77-bit to 78-bit payload
  if(ichk.eq.1) go to 999       !Return if checking only
  call q65_enc(dgen,sent)       !Encode message, dgen(1:13) ==> sent(1:63)

  j=1
  k=0
  do i=1,85
     if(i.eq.isync(j)) then
        j=j+1                   !Index for next sync symbol
        itone(i)=0              !Insert sync symbol at tone 0
     else
        k=k+1
        itone(i)=sent(k) + 1    !Q65 symbol=0 is transmitted at tone 1, etc.
     endif
  enddo

999 return
end subroutine genq65

module grid2k_mod
  implicit none
contains
  subroutine grid2k(grid,k)
    use grid2deg_mod
    character(len=6), intent(in) :: grid
    integer, intent(out) :: k
    real :: xlong, xlat
    integer :: nlong, nlat

    call grid2deg(grid,xlong,xlat)
    nlong=nint(xlong)
    nlat=nint(xlat)
    k=0
    if(nlat.ge.85) k=5*(nlong+179)/2 + nlat-84

  end subroutine grid2k
end module grid2k_mod

subroutine genft8refsig(itone,cref,f0)
  complex cref(79*1920)
  integer itone(79)
!  real*8 twopi,phi,dphi,dt,xnsps
  real twopi,phi,dphi,dt,xnsps
  data twopi/0.d0/
  save twopi
  if( twopi .lt. 0.1 ) twopi=8.d0*atan(1.d0)

  xnsps=1920.d0
  dt=1.d0/12000.d0
  phi=0.d0
  k=1
  do i=1,79
    dphi=twopi*(f0*dt+itone(i)/xnsps)
    do is=1,1920
      cref(k)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
      k=k+1
    enddo
  enddo
  return
end subroutine genft8refsig

module packjt77

! These variables are accessible from outside via "use packjt77":
  parameter (MAXHASH=1000,MAXRECENT=10)
  character (len=13), dimension(0:1023) ::  calls10=''
  character (len=13), dimension(0:4095) ::  calls12=''
  character (len=13), dimension(1:MAXHASH) :: calls22=''
  character (len=13), dimension(1:MAXRECENT) :: recent_calls=''
  character (len=13) :: mycall13=''
  character (len=13) :: dxcall13=''
  character (len=6)  :: dxbase=''
  integer, dimension(1:MAXHASH) :: ihash22=-1
  integer :: nzhash=0
  integer n28a,n28b

  contains

subroutine hash10(n10,c13)

  character*13 c13

  c13='<...>'
  if(n10.lt.0 .or. n10.gt.1023) return
  if(len(trim(calls10(n10))).gt.0) then
     c13=calls10(n10)
     c13='<'//trim(c13)//'>'
  endif
  return

end subroutine hash10

subroutine hash12(n12,c13)

  character*13 c13
  
  c13='<...>'
  if(n12.lt.0 .or. n12.gt.4095) return
  if(len(trim(calls12(n12))).gt.0) then
     c13=calls12(n12)
     c13='<'//trim(c13)//'>'
  endif
  return

end subroutine hash12


subroutine hash22(n22,c13)

  character*13 c13
  
  c13='<...>'
  do i=1,nzhash
     if(ihash22(i).eq.n22) then
        c13=calls22(i)
        c13='<'//trim(c13)//'>'
        go to 900
     endif
  enddo

900 return
end subroutine hash22


integer function ihashcall(c0,m)

  integer*8 n8
  character*13 c0
  character*38 c
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  n8=0
  do i=1,11
     j=index(c,c0(i:i)) - 1
     n8=38*n8 + j
  enddo
  ihashcall=ishft(47055833459_8*n8,m-64)

  return
end function ihashcall

subroutine save_hash_call(c13,n10,n12,n22)

  character*13 c13,cw

  cw=c13 
  if(cw(1:1).eq.' ' .or. cw(1:5).eq.'<...>') return
  if(cw(1:1).eq.'<') cw=cw(2:)
  i=index(cw,'>')
  if(i.gt.0) cw(i:)='         '

  if(len(trim(cw)) .lt. 3) return

  n10=ihashcall(cw,10)
  if(n10.ge.0 .and. n10 .le. 1023 .and. cw.ne.mycall13) calls10(n10)=cw

  n12=ihashcall(cw,12)
  if(n12.ge.0 .and. n12 .le. 4095 .and. cw.ne.mycall13) calls12(n12)=cw

  n22=ihashcall(cw,22)
  if(any(ihash22.eq.n22)) then   ! If entry exists, make sure callsign is the most recently received one 
    where(ihash22.eq.n22) calls22=cw
    go to 900
  endif

! New entry: move table down, making room for new one at the top
  ihash22(MAXHASH:2:-1)=ihash22(MAXHASH-1:1:-1)

! Add the new entry
  calls22(MAXHASH:2:-1)=calls22(MAXHASH-1:1:-1)
  ihash22(1)=n22
  calls22(1)=cw
  if(nzhash.lt.MAXHASH) nzhash=nzhash+1
900 continue
  return 
end subroutine save_hash_call

subroutine pack77(msg0,i3,n3,c77)

  use packjt
  character*37 msg,msg0
  character*18 c18
  character*13 w(19)
  character*77 c77
  integer nw(19)
  integer ntel(3)

  msg=msg0
  if(msg(1:3).eq.'$DX') then
     i1=index(msg,' ')
     msg=trim(dxbase)//' '//msg(i1+1:)
  endif

  i3_hint=i3
  n3_hint=n3
  i3=-1
  n3=-1
  if(i3_hint.eq.0 .and. n3_hint.eq.5) go to 5

! Convert msg to upper case; collapse multiple blanks; parse into words.
  call split77(msg,nwords,nw,w)
  if(msg(1:3).eq.'CQ ' .or. msg(1:3).eq.'DE ' .or. msg(1:4).eq.'QRZ ') go to 100

! Check 0.1 (DXpedition mode)
  call pack77_01(nwords,w,i3,n3,c77)
  if(i3.ge.0 .or. n3.ge.1) go to 900
! Check 0.2 (EU VHF contest exchange)
!  call pack77_02(nwords,w,i3,n3,c77)
!  if(i3.ge.0) go to 900

! Check 0.3 and 0.4 (ARRL Field Day exchange)
  call pack77_03(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900
  if(nwords.ge.2) go to 100

  ! Check 0.5 (telemetry)
5  i0=index(msg,' ')
  c18=msg(1:i0-1)
  c18=adjustr(c18)
  ntel=-99
  read(c18,1005,err=6) ntel
1005 format(3z6)
  if(ntel(1).ge.2**23) go to 800
6 if(ntel(1).ge.0 .and. ntel(2).ge.0 .and. ntel(3).ge.0) then
     i3=0
     n3=5
     write(c77,1006) ntel,n3,i3
1006 format(b23.23,2b24.24,2b3.3)
     go to 900
  endif

100 call pack77_06(nwords,w,i3,n3,c77,i3_hint,n3_hint)
  if(i3.ge.0) go to 900

! Check Type 1 (Standard 77-bit message) or Type 2, with optional "/P"
  call pack77_1(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900

! Check Type 3 (ARRL RTTY contest exchange)
  call pack77_3(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900

! Check Type 4 (One nonstandard call and one hashed call)
  call pack77_4(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900

! Check Type 5 (EU VHF Contest with 2 hashed calls, report, serial, and grid6)
  call pack77_5(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900

! It defaults to free text
800 i3=0
  n3=0
  msg(14:)='                        '
  call packtext77(msg(1:13),c77(1:71))
  write(c77(72:77),'(2b3.3)') n3,i3

900 return
end subroutine pack77

subroutine unpack77(c77,nrx,msg,unpk77_success)
!
! nrx=1 when unpacking a received message
! nrx=0 when unpacking a to-be-transmitted message
! the value of nrx is used to decide when mycall13 or dxcall13 should
! be used in place of a callsign from the hashtable
!
  parameter (NSEC=86)      !Number of ARRL Sections
  parameter (NUSCAN=171)   !Number of States and Provinces
  parameter (MAXGRID4=32400)
  integer*8 n58
  integer ntel(3)
  character*77 c77
  character*37 msg
  character*13 call_1,call_2,call_3,call_1a
  character*13 mycall13_0,dxcall13_0
  character*11 c11
  character*3 crpt,cntx,cpfx
  character*3 cmult(NUSCAN)
  character*6 cexch,grid6
  character*4 grid4,cserial
  character*3 csec(NSEC)
  character*38 c
  character*36 a2
  integer hashmy10,hashmy12,hashmy22,hashdx10,hashdx12,hashdx22
  logical unpk28_success,unpk77_success,unpkg4_success
  logical dxcall13_set,mycall13_set

  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/,nzzz/46656/
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/
  data csec/                                                         &
       "AB ","AK ","AL ","AR ","AZ ","BC ","CO ","CT ","DE ","EB ",  &       
       "EMA","ENY","EPA","EWA","GA ","GH ","IA ","ID ","IL ","IN ",  &
       "KS ","KY ","LA ","LAX","NS ","MB ","MDC","ME ","MI ","MN ",  &
       "MO ","MS ","MT ","NC ","ND ","NE ","NFL","NH ","NL ","NLI",  &       
       "NM ","NNJ","NNY","TER","NTX","NV ","OH ","OK ","ONE","ONN",  &
       "ONS","OR ","ORG","PAC","PR ","QC ","RI ","SB ","SC ","SCV",  &       
       "SD ","SDG","SF ","SFL","SJV","SK ","SNJ","STX","SV ","TN ",  &       
       "UT ","VA ","VI ","VT ","WCF","WI ","WMA","WNY","WPA","WTX",  &       
       "WV ","WWA","WY ","DX ","PE ","NB "/
  data cmult/                                                        &
       "AL ","AK ","AZ ","AR ","CA ","CO ","CT ","DE ","FL ","GA ",  &
       "HI ","ID ","IL ","IN ","IA ","KS ","KY ","LA ","ME ","MD ",  &
       "MA ","MI ","MN ","MS ","MO ","MT ","NE ","NV ","NH ","NJ ",  &
       "NM ","NY ","NC ","ND ","OH ","OK ","OR ","PA ","RI ","SC ",  &
       "SD ","TN ","TX ","UT ","VT ","VA ","WA ","WV ","WI ","WY ",  &
       "NB ","NS ","QC ","ON ","MB ","SK ","AB ","BC ","NWT","NF ",  &
       "LB ","NU ","YT ","PEI","DC ","DR ","FR ","GD ","GR ","OV ",  &
       "ZH ","ZL ","X01","X02","X03","X04","X05","X06","X07","X08",  &
       "X09","X10","X11","X12","X13","X14","X15","X16","X17","X18",  &
       "X19","X20","X21","X22","X23","X24","X25","X26","X27","X28",  &
       "X29","X30","X31","X32","X33","X34","X35","X36","X37","X38",  &
       "X39","X40","X41","X42","X43","X44","X45","X46","X47","X48",  &
       "X49","X50","X51","X52","X53","X54","X55","X56","X57","X58",  &
       "X59","X60","X61","X62","X63","X64","X65","X66","X67","X68",  &
       "X69","X70","X71","X72","X73","X74","X75","X76","X77","X78",  &
       "X79","X80","X81","X82","X83","X84","X85","X86","X87","X88",  &
       "X89","X90","X91","X92","X93","X94","X95","X96","X97","X98",  &
       "X99"/
  data dxcall13_set/.false./
  data mycall13_set/.false./
  data mycall13_0/''/
  data dxcall13_0/''/

  save hashmy10,hashmy12,hashmy22,hashdx10,hashdx12,hashdx22

  if(mycall13.ne.mycall13_0) then
    if(len(trim(mycall13)).gt.2) then
       mycall13_set=.true.
       mycall13_0=mycall13
       call save_hash_call(mycall13,hashmy10,hashmy12,hashmy22)
    else
       mycall13_set=.false.
    endif
  endif

  if(dxcall13.ne.dxcall13_0) then
    if(len(trim(dxcall13)).gt.2) then
      dxcall13_set=.true.
      dxcall13_0=dxcall13
      hashdx10=ihashcall(dxcall13,10)
      hashdx12=ihashcall(dxcall13,12)
      hashdx22=ihashcall(dxcall13,22)
    endif
  endif
  unpk77_success=.true.

! Check for bad data
  do i=1,77
     if(c77(i:i).ne.'0' .and. c77(i:i).ne.'1') then
        msg='failed unpack'
        unpk77_success=.false.
        return
     endif
  enddo

  read(c77(72:77),'(2b3)') n3,i3
  msg=repeat(' ',37)

  if(i3.eq.0 .and. n3.eq.0) then
! 0.0  Free text
     call unpacktext77(c77(1:71),msg(1:13))
     msg(14:)='                        '
     msg=adjustl(msg)
     if(msg(1:1).eq.' ') then
        unpk77_success=.false.
        return
     endif

  else if(i3.eq.0 .and. n3.eq.1) then
! 0.1  K1ABC RR73; W9XYZ <KH1/KH7Z> -11   28 28 10 5       71   DXpedition Mode
     read(c77,1010) n28a,n28b,n10,n5
1010 format(2b28,b10,b5)
     irpt=2*n5 - 30
     write(crpt,1012) irpt
1012 format(i3.2)
     if(irpt.ge.0) crpt(1:1)='+'
     call unpack28(n28a,call_1,unpk28_success) 
     if(.not.unpk28_success .or. n28a.le.2) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success)
     if(.not.unpk28_success .or. n28b.le.2) unpk77_success=.false.
     call hash10(n10,call_3)
     if(nrx.eq.1     .and. &
        dxcall13_set .and. &
        hashdx10.eq.n10) call_3='<'//trim(dxcall13)//'>'
     if(nrx.eq.0     .and. &
        mycall13_set .and. &
        n10.eq.hashmy10) call_3='<'//trim(mycall13)//'>'
     msg=trim(call_1)//' RR73; '//trim(call_2)//' '//trim(call_3)//' '//crpt

  else if(i3.eq.0 .and. n3.eq.2) then
     unpk77_success=.false.

  else if(i3.eq.0 .and. (n3.eq.3 .or. n3.eq.4)) then
! 0.3   WA9XYZ KA1ABC R 16A EMA            28 28 1 4 3 7    71   ARRL Field Day
! 0.4   WA9XYZ KA1ABC R 32A EMA            28 28 1 4 3 7    71   ARRL Field Day
     read(c77,1030) n28a,n28b,ir,intx,nclass,isec
1030 format(2b28,b1,b4,b3,b7)
     if(isec.gt.NSEC .or. isec.lt.1) then
         unpk77_success=.false.
         isec=1
     endif
     call unpack28(n28a,call_1,unpk28_success)
     if(.not.unpk28_success .or. n28a.le.2) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success)
     if(.not.unpk28_success .or. n28b.le.2) unpk77_success=.false.
     ntx=intx+1
     if(n3.eq.4) ntx=ntx+16
     write(cntx(1:2),1032) ntx
1032 format(i2)
     cntx(3:3)=char(ichar('A')+nclass)
     if(ir.eq.0 .and. ntx.lt.10) msg=trim(call_1)//' '//trim(call_2)//     &
          cntx//' '//csec(isec)
     if(ir.eq.1 .and. ntx.lt.10) msg=trim(call_1)//' '//trim(call_2)//     &
          ' R'//cntx//' '//csec(isec)
     if(ir.eq.0 .and. ntx.ge.10) msg=trim(call_1)//' '//trim(call_2)//     &
          ' '//cntx//' '//csec(isec)
     if(ir.eq.1 .and. ntx.ge.10) msg=trim(call_1)//' '//trim(call_2)//     &
          ' R '//cntx//' '//csec(isec)

  else if(i3.eq.0 .and. n3.eq.5) then
! 0.5   0123456789abcdef01                 71               71   Telemetry (18 hex)
     read(c77,1006) ntel
1006 format(b23,2b24)
     write(msg,1007) ntel
1007 format(3z6.6)
     do i=1,18
        if(msg(i:i).ne.'0') exit
        msg(i:i)=' '
     enddo
     msg=adjustl(msg)

  else if(i3.eq.0 .and. n3.eq.6) then
     read(c77(48:50),'(3b1)') j48,j49,j50
! bits 48:50
! itype=1: x00
! itype=2: xx1
! itype=3: 010
     if(j50.eq.1) then
        itype=2
     else if(j49.eq.0) then
        itype=1
     else if(j48.eq.0) then
        itype=3
     else
        itype=-1
        unpk77_success=.false.
     endif

     if(itype.eq.1) then
! WSPR Type 1
        read(c77,2010) n28,igrid4,idbm
2010    format(b28.28,b15.15,b5.5)
        idbm=nint(idbm*10.0/3.0)
        if(idbm.lt.0 .or. idbm.gt.60) unpk77_success=.false.
        call unpack28(n28,call_1,unpk28_success) 
        if(.not.unpk28_success) unpk77_success=.false.
        call to_grid4(igrid4,grid4,unpkg4_success)
        if(.not.unpkg4_success) unpk77_success=.false.
        write(crpt,'(i3)') idbm
        msg=trim(call_1)//' '//grid4//' '//trim(adjustl(crpt))
        if (unpk77_success) call save_hash_call(call_1,n10,n12,n22) !### Is this OK here? ###

     else if(itype.eq.2) then
! WSPR Type 2
        read(c77,2020) n28,npfx,idbm
2020    format(b28.28,b16.16,b5.5)
        idbm=nint(idbm*10.0/3.0)        
        if(idbm.lt.0 .or. idbm.gt.60) unpk77_success=.false.
        call unpack28(n28,call_1,unpk28_success) 
        if(.not.unpk28_success) unpk77_success=.false.
        write(crpt,'(i3)') idbm
        cpfx='   '
        if(npfx.lt.nzzz) then
! Prefix
           do i=3,1,-1
              j=mod(npfx,36)+1
              cpfx(i:i)=a2(j:j)
              npfx=npfx/36
              if(npfx.eq.0) exit
           enddo
           msg=trim(adjustl(cpfx))//'/'//trim(call_1)//' '//trim(adjustl(crpt))
           call_1a=trim(adjustl(cpfx))//'/'//trim(call_1)
           call save_hash_call(call_1a,n10,n12,n22)  !### Is this OK here? ###
        else
! Suffix
           npfx=npfx-nzzz
           if(npfx.le.35) then
              cpfx(1:1)=a2(npfx+1:npfx+1)
           else if(npfx.gt.35 .and. npfx.le.1295) then
              cpfx(1:1)=a2(npfx/36+1:npfx/36+1)
              cpfx(2:2)=a2(mod(npfx,36)+1:mod(npfx,36)+1)
           else if(npfx.gt.1295 .and. npfx.le.12959) then
              cpfx(1:1)=a2(npfx/360+1:npfx/360+1)
              cpfx(2:2)=a2(mod(npfx/10,36)+1:mod(npfx/10,36)+1)
              cpfx(3:3)=a2(mod(npfx,10)+1:mod(npfx,10)+1)
           else
              unpk77_success=.false.
              return
           endif
           msg=trim(call_1)//'/'//trim(adjustl(cpfx))//' '//trim(adjustl(crpt))
           call_1a=trim(call_1)//'/'//trim(adjustl(cpfx))
           call save_hash_call(call_1a,n10,n12,n22)  !### Is this OK here? ###
        endif
        
     else if(itype.eq.3) then
! WSPR Type 3
        read(c77,2030) n22,igrid6
2030    format(b22.22,b25.25)
        n28=n22+2063592
        call unpack28(n28,call_1,unpk28_success) 
        if(.not.unpk28_success) unpk77_success=.false.
        call to_grid(igrid6,grid6,unpkg4_success)
        if(.not.unpkg4_success) unpk77_success=.false.
        msg=trim(call_1)//' '//grid6
     endif
  
  else if(i3.eq.0 .and. n3.gt.6) then
     unpk77_success=.false.
   
  else if(i3.eq.1 .or. i3.eq.2) then
! Type 1 (standard message) or Type 2 ("/P" form for EU VHF contest)
     read(c77,1000) n28a,ipa,n28b,ipb,ir,igrid4,i3
1000 format(2(b28,b1),b1,b15,b3)
     call unpack28(n28a,call_1,unpk28_success)
     if(nrx.eq.1 .and. mycall13_set .and. hashmy22.eq.(n28a-2063592)) then
        call_1='<'//trim(mycall13)//'>'
        unpk28_success=.true.
     endif
     if(.not.unpk28_success) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success)
     if(.not.unpk28_success) unpk77_success=.false.
     if(call_1(1:3).eq.'CQ_') call_1(3:3)=' '
     if(index(call_1,'<').le.0) then
        i=index(call_1,' ')
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.1) call_1(i:i+1)='/R'
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.2) call_1(i:i+1)='/P'
        if(i.ge.4) call add_call_to_recent_calls(call_1) 
     endif
     if(index(call_2,'<').le.0) then
        i=index(call_2,' ')
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.1) call_2(i:i+1)='/R'
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.2) call_2(i:i+1)='/P'
        if(i.ge.4) then
           call add_call_to_recent_calls(call_2)
! only hash the "from" call
           call save_hash_call(call_2,ndum10,ndum12,ndum22)
        endif
     endif
     if(igrid4.le.MAXGRID4) then
        call to_grid4(igrid4,grid4,unpkg4_success)
        if(.not.unpkg4_success) unpk77_success=.false.
        if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//grid4
        if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R '//grid4
        if(msg(1:3).eq.'CQ ' .and. ir.eq.1) unpk77_success=.false.
     else
        irpt=igrid4-MAXGRID4
        if(irpt.eq.1) msg=trim(call_1)//' '//trim(call_2)
        if(irpt.eq.2) msg=trim(call_1)//' '//trim(call_2)//' RRR'
        if(irpt.eq.3) msg=trim(call_1)//' '//trim(call_2)//' RR73'
        if(irpt.eq.4) msg=trim(call_1)//' '//trim(call_2)//' 73'
        if(irpt.ge.5) then
           isnr=irpt-35
           if(isnr.gt.50) isnr=isnr-101
           write(crpt,'(i3.2)') isnr
           if(crpt(1:1).eq.' ') crpt(1:1)='+'
           if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//crpt
           if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R'//crpt
        endif
        if(msg(1:3).eq.'CQ ' .and. irpt.ge.2) unpk77_success=.false. 
     endif

  else if(i3.eq.3) then
! Type 3: ARRL RTTY Contest
     read(c77,1040) itu,n28a,n28b,ir,irpt,nexch,i3
1040 format(b1,2b28.28,b1,b3.3,b13.13,b3.3)
     write(crpt,1042) irpt+2
1042 format('5',i1,'9')
     nserial=nexch
     imult=-1
     if(nexch.gt.8000) then
        imult=nexch-8000
        nserial=-1
     endif
     call unpack28(n28a,call_1,unpk28_success)
     if(.not.unpk28_success) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success)
     if(.not.unpk28_success) unpk77_success=.false.
     imult=0
     nserial=0
     if(nexch.gt.8000) imult=nexch-8000
     if(nexch.lt.8000) nserial=nexch
     
     if(imult.ge.1 .and.imult.le.NUSCAN) then
        if(itu.eq.0 .and. ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//             &
             ' '//crpt//' '//cmult(imult)
        if(itu.eq.1 .and. ir.eq.0) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' '//crpt//' '//cmult(imult)
        if(itu.eq.0 .and. ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//             &
             ' R '//crpt//' '//cmult(imult)
        if(itu.eq.1 .and. ir.eq.1) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' R '//crpt//' '//cmult(imult)
     else if(nserial.ge.1 .and. nserial.le.7999) then
        write(cserial,'(i4.4)') nserial
        if(itu.eq.0 .and. ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//             &
             ' '//crpt//' '//cserial
        if(itu.eq.1 .and. ir.eq.0) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' '//crpt//' '//cserial
        if(itu.eq.0 .and. ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//             &
             ' R '//crpt//' '//cserial
        if(itu.eq.1 .and. ir.eq.1) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' R '//crpt//' '//cserial
     endif
  else if(i3.eq.4) then
! Type 4     
     read(c77,1050) n12,n58,iflip,nrpt,icq
1050 format(b12,b58,b1,b2,b1)
     do i=11,1,-1
        j=mod(n58,38)+1
        c11(i:i)=c(j:j)
        n58=n58/38
     enddo
     call hash12(n12,call_3)
     if(iflip.eq.0) then       ! 12 bit hash for TO call
        call_1=call_3          
        call_2=adjustl(c11)//'  '
        call add_call_to_recent_calls(call_2)
        call save_hash_call(call_2,ndum10,ndum12,ndum22)
        if(nrx.eq.1 .and.                        &  
           dxcall13_set .and. mycall13_set .and. & 
           call_2.eq.dxcall13 .and.              &
           n12.eq.hashmy12 ) call_1='<'//trim(mycall13)//'>'
        if(nrx.eq.1 .and.                        &
           mycall13_set .and.                    & 
           index(call_1,'<...>').gt.0 .and.      &
           n12.eq.hashmy12 ) call_1='<'//trim(mycall13)//'>'
     else                      ! 12 bit hash for DE call
        call_1=adjustl(c11)
        call_2=call_3          
        call add_call_to_recent_calls(call_1)
        if(nrx.eq.0 .and.                        & 
           mycall13_set .and. & 
           n12.eq.hashmy12) call_2='<'//trim(mycall13)//'>'
     endif
     if(icq.eq.0) then
        if(nrpt.eq.0) msg=trim(call_1)//' '//trim(call_2)
        if(nrpt.eq.1) msg=trim(call_1)//' '//trim(call_2)//' RRR'
        if(nrpt.eq.2) msg=trim(call_1)//' '//trim(call_2)//' RR73'
        if(nrpt.eq.3) msg=trim(call_1)//' '//trim(call_2)//' 73'
     else
        msg='CQ '//trim(call_2)
     endif

  else if(i3.eq.5) then
     
! Type 5  <PA3XYZ> <G4ABC/P> R 590003 IO91NP      h12 h22 r1 s3 S11 g25
! EU VHF contest
     read(c77,1060) n12,n22,ir,irpt,iserial,igrid6
1060 format(b12,b22,b1,b3,b11,b25)
     if(igrid6.lt.0 .or. igrid6.gt.18662399) then
        unpk77_success=.false.
        return
     endif
     call hash12(n12,call_1)
     if(n12.eq.hashmy12) call_1='<'//trim(mycall13)//'>'
     call hash22(n22,call_2)
     nrs=52+irpt
     write(cexch,1022) nrs,iserial
1022 format(i2,i4.4)
     call to_grid6(igrid6,grid6,unpk77_success)
     if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//cexch//' '//grid6
     if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R '//cexch//' '//grid6

  else if(i3.ge.6) then ! i3 values 6 and 7 are not yet defined
     unpk77_success=.false.
  endif
  if(msg(1:4).eq.'CQ <') unpk77_success=.false.

  return
end subroutine unpack77

subroutine pack28(c13,n28)

! Pack a special token, a 22-bit hash code, or a valid base call into a 28-bit
! integer.

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical is_digit,is_letter
  character*13 c13
  character*6 callsign
  character*1 c
  character*4 c4
  character*37 a1
  character*36 a2
  character*10 a3
  character*27 a4
  data a1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a3/'0123456789'/
  data a4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  
  is_digit(c)=c.ge.'0' .and. c.le.'9'
  is_letter(c)=c.ge.'A' .and. c.le.'Z'

  n28=-1
! Work-around for Swaziland prefix:
  if(c13(1:4).eq.'3DA0') callsign='3D0'//c13(5:7)
! Work-around for Guinea prefixes:
  if(c13(1:2).eq.'3X' .and. c13(3:3).ge.'A' .and.          &
       c13(3:3).le.'Z') callsign='Q'//c13(3:6)

! Check for special tokens first
  if(c13(1:3).eq.'DE ') then
     n28=0
     go to 900
  endif
  
  if(c13(1:4).eq.'QRZ ') then
     n28=1
     go to 900
  endif

  if(c13(1:3).eq.'CQ ') then
     n28=2
     go to 900
  endif

  if(c13(1:3).eq.'CQ_') then
     n=len(trim(c13))
     if(n.ge.4 .and. n.le.7) then
        nlet=0
        nnum=0
        do i=4,n
           c=c13(i:i)
           if(c.ge.'A' .and. c.le.'Z') nlet=nlet+1
           if(c.ge.'0' .and. c.le.'9') nnum=nnum+1
        enddo
        if(nnum.eq.3 .and. nlet.eq.0) then
           read(c13(4:3+nnum),*) nqsy
           n28=3+nqsy
           go to 900
        endif
        if(nlet.ge.1 .and. nlet.le.4 .and. nnum.eq.0) then
           c4=c13(4:n)
           c4=adjustr(c4)
           m=0
           do i=1,4
              j=0
              c=c4(i:i)
              if(c.ge.'A' .and. c.le.'Z') j=ichar(c)-ichar('A')+1
              m=27*m + j
           enddo
           n28=3+1000+m
           go to 900
        endif
     endif
  endif

! Check for <...> callsign
  if(c13(1:1).eq.'<')then
     call save_hash_call(c13,n10,n12,n22)   !Save callsign in hash table
     i2=index(c13,'>')
     c13=c13(2:i2-1)
     n22=ihashcall(c13,22)
     n28=NTOKENS + n22
     go to 900
  endif

! Check for standard callsign
  iarea=-1
  n=len(trim(c13))
  do i=n,2,-1
     if(is_digit(c13(i:i))) exit
  enddo
  iarea=i                                   !Call-area digit
  npdig=0                                   !Digits before call area
  nplet=0                                   !Letters before call area
  do i=1,iarea-1
     if(is_digit(c13(i:i))) npdig=npdig+1
     if(is_letter(c13(i:i))) nplet=nplet+1
  enddo
  nslet=0
  do i=iarea+1,n
     if(is_letter(c13(i:i))) nslet=nslet+1
  enddo
  if(iarea.lt.2 .or. iarea.gt.3 .or. nplet.eq.0 .or.       &
       npdig.ge.iarea-1 .or. nslet.gt.3) then
! Treat this as a nonstandard callsign: compute its 22-bit hash
     call save_hash_call(c13,n10,n12,n22)   !Save callsign in hash table
     n22=ihashcall(c13,22)
     n28=NTOKENS + n22
     go to 900
  endif
  
  n=len(trim(c13))
! This is a standard callsign
  call save_hash_call(c13,n10,n12,n22)   !Save callsign in hash table
  if(iarea.eq.2) callsign=' '//c13(1:5)
  if(iarea.eq.3) callsign=c13(1:6)
  i1=index(a1,callsign(1:1))-1
  i2=index(a2,callsign(2:2))-1
  i3=index(a3,callsign(3:3))-1
  i4=index(a4,callsign(4:4))-1
  i5=index(a4,callsign(5:5))-1
  i6=index(a4,callsign(6:6))-1
  n28=36*10*27*27*27*i1 + 10*27*27*27*i2 + 27*27*27*i3 + 27*27*i4 + &
       27*i5 + i6
  n28=n28 + NTOKENS + MAX22

900 n28=iand(n28,ishft(1,28)-1)
  return
end subroutine pack28


subroutine unpack28(n28_0,c13,success)

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical success
  character*13 c13
  character*37 c1
  character*36 c2
  character*10 c3
  character*27 c4
  data c1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c3/'0123456789'/
  data c4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

  success=.true.
  n28=n28_0
  if(n28.lt.NTOKENS) then
! Special tokens DE, QRZ, CQ, CQ_nnn, CQ_aaaa
     if(n28.eq.0) c13='DE           '
     if(n28.eq.1) c13='QRZ          '
     if(n28.eq.2) c13='CQ           '
     if(n28.le.2) go to 900
     if(n28.le.1002) then
        write(c13,1002) n28-3
1002    format('CQ_',i3.3)
        go to 900
     endif
     if(n28.le.532443) then
        n=n28-1003
        n0=n
        i1=n/(27*27*27)
        n=n-27*27*27*i1
        i2=n/(27*27)
        n=n-27*27*i2
        i3=n/27
        i4=n-27*i3
        c13=c4(i1+1:i1+1)//c4(i2+1:i2+1)//c4(i3+1:i3+1)//c4(i4+1:i4+1)
        c13=adjustl(c13)
        c13='CQ_'//c13(1:10)
        go to 900
     endif
  endif
  n28=n28-NTOKENS
  if(n28.lt.MAX22) then
! This is a 22-bit hash of a callsign
     n22=n28
     call hash22(n22,c13)     !Retrieve callsign from hash table
     go to 900
  endif
  
! Standard callsign
  n=n28 - MAX22
  i1=n/(36*10*27*27*27)
  n=n-36*10*27*27*27*i1
  i2=n/(10*27*27*27)
  n=n-10*27*27*27*i2
  i3=n/(27*27*27)
  n=n-27*27*27*i3
  i4=n/(27*27)
  n=n-27*27*i4
  i5=n/27
  i6=n-27*i5
  c13=c1(i1+1:i1+1)//c2(i2+1:i2+1)//c3(i3+1:i3+1)//c4(i4+1:i4+1)//     &
       c4(i5+1:i5+1)//c4(i6+1:i6+1)
  c13=adjustl(c13)

900 i0=index(c13,' ')
  if(i0.ne.0 .and. i0.lt.len(trim(c13))) then
     c13='QU1RK'
     success=.false.
  endif
  return
end subroutine unpack28

subroutine split77(msg,nwords,nw,w)

! Convert msg to upper case; collapse multiple blanks; parse into words.

  character*37 msg
  character*13 w(19)
  character*1 c,c0
  character*6 bcall_1
  logical ok1
  integer nw(19)
    
  iz=len(trim(msg))
  j=0
  k=0
  n=0
  c0=' '
  w='             '
  do i=1,iz
     if(ichar(msg(i:i)).eq.0) msg(i:i)=' '
     c=msg(i:i)                                 !Single character
     if(c.eq.' ' .and. c0.eq.' ') cycle         !Skip leading/repeated blanks
     if(c.ne.' ' .and. c0.eq.' ') then
        k=k+1                                   !New word
        n=0
     endif
     j=j+1                                      !Index in msg
     n=n+1                                      !Index in word
     if(c.ge.'a' .and. c.le.'z') c=char(ichar(c)-32)  !Force upper case
     msg(j:j)=c
     if(n.le.13) w(k)(n:n)=c                    !Copy character c into word
     c0=c
  enddo
  iz=j                                          !Message length
  nwords=k                                      !Number of words in msg
  if(nwords.le.0) go to 900
  do i=1,nwords
     nw(i)=len(trim(w(i)))
  enddo
  msg(iz+1:)='                                     '
  if(nwords.lt.3) go to 900
  call chkcall(w(3),bcall_1,ok1)
  if(ok1 .and. w(1)(1:3).eq.'CQ ') then
     w(1)='CQ_'//w(2)(1:10)             !Make "CQ " into "CQ_"
     w(2:12)=w(3:13)                    !Move all remaining words down by one
     nwords=nwords-1
  endif

900 return
end subroutine split77


subroutine pack77_01(nwords,w,i3,n3,c77)

! Pack a Type 0.1 message: DXpedition mode
! Example message:  "K1ABC RR73; W9XYZ <KH1/KH7Z> -11"   28 28 10 5

  character*13 w(19),c13
  character*77 c77
  character*6 bcall_1,bcall_2
  logical ok1,ok2

  if(nwords.ne.5) go to 900                !Must have 5 words
  if(trim(w(2)).ne.'RR73;') go to 900      !2nd word must be "RR73;"
  if(w(4)(1:1).ne.'<') go to 900           !4th word must have <...>
  if(index(w(4),'>').lt.1) go to 900
  n=-99
  read(w(5),*,err=1) n
1 if(n.eq.-99) go to 900                   !5th word must be a valid report
  n5=(n+30)/2
  if(n5.lt.0) n5=0
  if(n5.gt.31) n5=31
  call chkcall(w(1),bcall_1,ok1)
  if(.not.ok1) go to 900                   !1st word must be a valid basecall
  call chkcall(w(3),bcall_2,ok2)
  if(.not.ok2) go to 900                   !3rd word must be a valid basecall

! Type 0.1:  K1ABC RR73; W9XYZ <KH1/KH7Z> -11   28 28 10 5       71
  i3=0
  n3=1
  call pack28(w(1),n28a)
  call pack28(w(3),n28b)
  call save_hash_call(w(4),n10,n12,n22)
  i2=index(w(4),'>')
  c13=w(4)(2:i2-1)
  n10=ihashcall(c13,10)
  write(c77,1010) n28a,n28b,n10,n5,n3,i3
1010 format(2b28.28,b10.10,b5.5,2b3.3)
  
900 return
end subroutine pack77_01


subroutine pack77_03(nwords,w,i3,n3,c77)

! Check 0.3 and 0.4 (ARRL Field Day exchange)
! Example message:  WA9XYZ KA1ABC R 16A EMA       28 28 1 4 3 7    71  

  parameter (NSEC=86)      !Number of ARRL Sections
  character*13 w(19)
  character*77 c77
  character*6 bcall_1,bcall_2
  character*3 csec(NSEC)
  logical ok1,ok2
  data csec/                                                         &
       "AB ","AK ","AL ","AR ","AZ ","BC ","CO ","CT ","DE ","EB ",  &       
       "EMA","ENY","EPA","EWA","GA ","GH ","IA ","ID ","IL ","IN ",  &
       "KS ","KY ","LA ","LAX","NS ","MB ","MDC","ME ","MI ","MN ",  &
       "MO ","MS ","MT ","NC ","ND ","NE ","NFL","NH ","NL ","NLI",  &       
       "NM ","NNJ","NNY","TER","NTX","NV ","OH ","OK ","ONE","ONN",  &
       "ONS","OR ","ORG","PAC","PR ","QC ","RI ","SB ","SC ","SCV",  &       
       "SD ","SDG","SF ","SFL","SJV","SK ","SNJ","STX","SV ","TN ",  &       
       "UT ","VA ","VI ","VT ","WCF","WI ","WMA","WNY","WPA","WTX",  &       
       "WV ","WWA","WY ","DX ","PE ","NB "/

  if(nwords.lt.4 .or. nwords.gt.5) return  
  call chkcall(w(1),bcall_1,ok1)
  call chkcall(w(2),bcall_2,ok2)
  if(.not.ok1 .or. .not.ok2) return
  isec=-1
  do i=1,NSEC
     if(csec(i).eq.w(nwords)(1:3)) then
        isec=i
        exit
     endif
  enddo
  if(isec.eq.-1) return
  if(nwords.eq.5 .and. trim(w(3)).ne.'R') return
  
  ntx=-1
  j=len(trim(w(nwords-1)))-1
  read(w(nwords-1)(1:j),*,err=1,end=1) ntx          !Number of transmitters
1 if(ntx.lt.1 .or. ntx.gt.32) return
  nclass=ichar(w(nwords-1)(j+1:j+1))-ichar('A')
  
  m=len(trim(w(nwords)))                            !Length of section abbreviation
  if(m.lt.2 .or. m.gt.3) return

! 0.3   WA9XYZ KA1ABC R 16A EMA            28 28 1 4 3 7    71   ARRL Field Day
! 0.4   WA9XYZ KA1ABC R 32A EMA            28 28 1 4 3 7    71   ARRL Field Day
  
  i3=0
  n3=3                                 !Type 0.3 ARRL Field Day
  intx=ntx-1
  if(intx.ge.16) then
     n3=4                              !Type 0.4 ARRL Field Day
     intx=ntx-17
  endif
  call pack28(w(1),n28a)
  call pack28(w(2),n28b)
  ir=0
  if(w(3)(1:2).eq.'R ') ir=1
  write(c77,1010) n28a,n28b,ir,intx,nclass,isec,n3,i3
1010 format(2b28.28,b1,b4.4,b3.3,b7.7,2b3.3)

  return
end subroutine pack77_03


subroutine pack77_06(nwords,w,i3,n3,c77,i3_hint,n3_hint)

  character*13 w(19)
  character*77 c77
  character*6 bcall,grid6
  character*4 grid4
  character*1 c
  character*36 a2
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/,nzzz/46656/
  
  logical is_grid4,is_grid6,is_digit,ok
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  is_grid6(grid6)=(len(trim(grid6)).eq.6.or.len(trim(grid6)).eq.4).and. &
       grid6(1:1).ge.'A' .and. grid6(1:1).le.'R' .and.               &
       grid6(2:2).ge.'A' .and. grid6(2:2).le.'R' .and.               &
       grid6(3:3).ge.'0' .and. grid6(3:3).le.'9' .and.               &
       grid6(4:4).ge.'0' .and. grid6(4:4).le.'9' .and.               &
       (len(trim(grid6)).eq.4.or.                                    &
       (grid6(5:5).ge.'A' .and. grid6(5:5).le.'X' .and.              &
       grid6(6:6).ge.'A' .and. grid6(6:6).le.'X'))

  is_digit(c)=c.ge.'0' .and. c.le.'9'

  m1=len(trim(w(1)))
  m2=len(trim(w(2)))
  m3=len(trim(w(3)))
  if(nwords.eq.3 .and. m1.ge.3 .and. m1.le.6 .and. m2.eq.4 .and. m3.le.2) then
! WSPR Type 1
     if(.not.is_grid4(w(2)(1:4))) go to 900
     if(.not.is_digit(w(3)(1:1))) go to 900
     if(m3.eq.2) then
        if(.not.is_digit(w(3)(2:2))) go to 900
     endif
     i3=0
     n3=6
     call pack28(w(1),n28)
     grid4=w(2)(1:4)
     k1=(ichar(grid4(1:1))-ichar('A'))*18*10*10
     k2=(ichar(grid4(2:2))-ichar('A'))*10*10
     k3=(ichar(grid4(3:3))-ichar('0'))*10
     k4=(ichar(grid4(4:4))-ichar('0'))
     igrid4=k1+k2+k3+k4
     read(w(3),*) idbm
     if(idbm.lt.0) idbm=0
     if(idbm.gt.60) idbm=60
     idbm=nint(0.3*idbm)
     write(c77,1010) n28,igrid4,idbm,0,0,0,n3,i3
1010 format(b28.28,b15.15,b5.5,2i1,b21.21,2b3.3)
     go to 900
  endif
  if(nwords.eq.2 .and. m1.ge.5 .and. m1.le.10 .and. m2.le.2) then
! WSPR Type 2
     i1=index(w(1),'/')
     if(i1.lt.2 .or. i1.eq.m1) go to 900
     if(.not.is_digit(w(2)(1:1))) go to 900
     if(i1.eq.(m1-3) .and. .not.is_digit(w(1)(m1:m1))) go to 900
     if(m2.eq.2) then
        if(.not.is_digit(w(2)(2:2))) go to 900
     endif
     call chkcall(w(1),bcall,ok)
     if(.not.ok) go to 900
     if(i1.le.4) then
! We have a prefix
        npfx=index(a2,w(1)(1:1))-1
        if(i1.ge.3) npfx=36*npfx + index(a2,w(1)(2:2))-1
        if(i1.eq.4) npfx=36*npfx + index(a2,w(1)(3:3))-1
     else
! We have a suffix
        if((m1-i1).eq.1) npfx=index(a2,w(1)(i1+1:i1+1))-1
        if((m1-i1).eq.2) npfx=36*(index(a2,w(1)(i1+1:i1+1))-1) +             &
             index(a2,w(1)(i1+2:i1+2))-1
        if((m1-i1).eq.3) then
! Third character of a suffix must be a digit
           if(.not.is_digit(w(1)(i1+3:i1+3))) go to 900
           npfx=36*10*(index(a2,w(1)(i1+1:i1+1))-1) +                        &
             10*(index(a2,w(1)(i1+2:i1+2))-1) + index(a2,w(1)(i1+3:i1+3))-1
        endif
        npfx=npfx + nzzz
     endif
     i3=0
     n3=6
     call pack28(bcall//'       ',n28)
     read(w(2),*) idbm
     if(idbm.lt.0) idbm=0
     if(idbm.gt.60) idbm=60
     idbm=nint(0.3*idbm)
     write(c77,1020) n28,npfx,idbm,1,0,n3,i3
1020 format(b28.28,b16.16,b5.5,i1,b21.21,2b3.3)
     go to 900
  endif

  if(i3_hint.eq.0.and.n3_hint.eq.6.and.nwords.eq.2 .and. m1.ge.5  &
       .and. m1.le.12 .and. m2.le.6) then
! WSPR Type 3

     !n3_hint=6 and i3_hint=0 is a hint that the caller wanted a
     !50-bit encoding rather than the possible alternative n3=4 77-bit
     !encoding
     if(index(w(1),'<').lt.1 .or. index(w(1),'>').lt.1) go to 900
     grid6=w(2)(1:6)
     if(.not.is_grid6(grid6)) go to 900
     i3=0
     n3=6
     call pack28(w(1),n28)
     n22=n28-2063592
     k1=(ichar(grid6(1:1))-ichar('A'))*18*10*10*25*25
     k2=(ichar(grid6(2:2))-ichar('A'))*10*10*25*25
     k3=(ichar(grid6(3:3))-ichar('0'))*10*25*25
     k4=(ichar(grid6(4:4))-ichar('0'))*25*25
     if (grid6(5:6).eq.'  ') then
        igrid6=k1+k2+k3+k4+24*25+24
     else
        k5=(ichar(grid6(5:5))-ichar('A'))*25
        k6=(ichar(grid6(6:6))-ichar('A'))
        igrid6=k1+k2+k3+k4+k5+k6
     endif
     write(c77,1030) n22,igrid6,2,0,n3,i3
1030 format(b22.22,b25.25,b3.3,b21.21,2b3.3)
  endif

900 return  
end subroutine pack77_06


subroutine pack77_1(nwords,w,i3,n3,c77)
  
! Check Type 1 (Standard 77-bit message) and Type 2 (ditto, with a "/P" call)
! Example message:  WA9XYZ/R KA1ABC/R R FN42     28 1 28 1 1 15   74

  parameter (MAXGRID4=32400)
  character*13 w(19),c13
  character*77 c77
  character*6 bcall_1,bcall_2
  character*4 grid4
  character c1*1,c2*2
  logical is_grid4
  logical ok1,ok2
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  if(nwords.lt.2 .or. nwords.gt.4) return
  call chkcall(w(1),bcall_1,ok1)
  call chkcall(w(2),bcall_2,ok2)
  if(w(1)(1:3).eq.'DE ' .or. w(1)(1:3).eq.'CQ_' .or.  w(1)(1:3).eq.'CQ ' .or. &
       w(1)(1:4).eq.'QRZ ') ok1=.true.
  if(w(1)(1:1).eq.'<' .and. index(w(1),'>').ge.5) ok1=.true.
  if(w(2)(1:1).eq.'<' .and. index(w(2),'>').ge.5) ok2=.true.
  if(.not.ok1 .or. .not.ok2) return
  if(w(1)(1:1).eq.'<' .and. index(w(2),'/').gt.0) return
  if(w(2)(1:1).eq.'<' .and. index(w(1),'/').gt.0) return
  if(nwords.eq.2 .and. (.not.ok2 .or. index(w(2),'/').ge.2)) return
  if(nwords.eq.2) go to 10

  c1=w(nwords)(1:1)
  c2=w(nwords)(1:2)
  if(.not.is_grid4(w(nwords)(1:4)) .and. c1.ne.'+' .and. c1.ne.'-'              &
       .and. c2.ne.'R+' .and. c2.ne.'R-' .and. trim(w(nwords)).ne.'RRR' .and.   &
       trim(w(nwords)).ne.'RR73' .and. trim(w(nwords)).ne.'73') return
  if(c1.eq.'+' .or. c1.eq.'-') then
     ir=0
     read(w(nwords),*,err=900) irpt
     if(irpt.ge.-50 .and. irpt.le.-31) irpt=irpt+101
     irpt=irpt+35
  else if(c2.eq.'R+' .or. c2.eq.'R-') then
     ir=1
     read(w(nwords)(2:),*,err=900) irpt
     if(irpt.ge.-50 .and. irpt.le.-31) irpt=irpt+101
     irpt=irpt+35
  else if(trim(w(nwords)).eq.'RRR') then
     ir=0
     irpt=2
  else if(trim(w(nwords)).eq.'RR73') then
     ir=0
     irpt=3
  else if(trim(w(nwords)).eq.'73') then
     ir=0
     irpt=4
  endif

! 1     WA9XYZ/R KA1ABC/R R FN42           28 1 28 1 1 15   74   Standard msg
! 2     PA3XYZ/P GM4ABC/P R JO22           28 1 28 1 1 15   74   EU VHF contest  

10 i1psuffix=index(w(1)//' ' ,'/P ')
  i2psuffix=index(w(2)//' ','/P ')
  if(nwords.eq.2 .or. nwords.eq.3 .or. (nwords.eq.4 .and.               &
       w(3)(1:2).eq.'R ')) then
     n3=0
     i3=1                          !Type 1: Standard message, possibly with "/R"
     if (i1psuffix.ge.4.or.i2psuffix.ge.4) i3=2 !Type 2, with "/P"
  endif
  c13=bcall_1
  if(c13(1:3).eq.'CQ_' .or. w(1)(1:1).eq.'<') c13=w(1)
  call pack28(c13,n28a)
  c13=bcall_2
  if(w(2)(1:1).eq.'<') c13=w(2)
  call pack28(c13,n28b)
  ipa=0
  ipb=0
  if(i1psuffix.ge.4.or.index(w(1)//' ','/R ').ge.4) ipa=1
  if(i2psuffix.ge.4.or.index(w(2)//' ','/R ').ge.4) ipb=1
  
  grid4=w(nwords)(1:4)
  if(is_grid4(grid4)) then
     ir=0
     if(w(3).eq.'R ') ir=1
     j1=(ichar(grid4(1:1))-ichar('A'))*18*10*10
     j2=(ichar(grid4(2:2))-ichar('A'))*10*10
     j3=(ichar(grid4(3:3))-ichar('0'))*10
     j4=(ichar(grid4(4:4))-ichar('0'))
     igrid4=j1+j2+j3+j4
  else
     igrid4=MAXGRID4 + irpt
  endif
  if(nwords.eq.2) then
     ir=0
     irpt=1
     igrid4=MAXGRID4+irpt
  endif
  write(c77,1000) n28a,ipa,n28b,ipb,ir,igrid4,i3
1000 format(2(b28.28,b1),b1,b15.15,b3.3)
  return

900 return
end subroutine pack77_1


subroutine pack77_3(nwords,w,i3,n3,c77)
  
! Check Type 3 (ARRL RTTY contest exchange)
! ARRL RTTY   - US/Can: rpt state/prov      R 579 MA
!             - DX:     rpt serial          R 559 0013
! Example message:  TU; W9XYZ K1ABC R 579 MA           1 28 28 1 3 13   74
  
  parameter (NUSCAN=171)    !Number of US states and Canadian provinces/territories
  character*13 w(19)
  character*77 c77
  character*6 bcall_1,bcall_2
  character*3 cmult(NUSCAN),mult
  character crpt*3
  logical ok1,ok2
  data cmult/                                                        &
       "AL ","AK ","AZ ","AR ","CA ","CO ","CT ","DE ","FL ","GA ",  &
       "HI ","ID ","IL ","IN ","IA ","KS ","KY ","LA ","ME ","MD ",  &
       "MA ","MI ","MN ","MS ","MO ","MT ","NE ","NV ","NH ","NJ ",  &
       "NM ","NY ","NC ","ND ","OH ","OK ","OR ","PA ","RI ","SC ",  &
       "SD ","TN ","TX ","UT ","VT ","VA ","WA ","WV ","WI ","WY ",  &
       "NB ","NS ","QC ","ON ","MB ","SK ","AB ","BC ","NWT","NF ",  &
       "LB ","NU ","YT ","PEI","DC ","DR ","FR ","GD ","GR ","OV ",  &
       "ZH ","ZL ","X01","X02","X03","X04","X05","X06","X07","X08",  &
       "X09","X10","X11","X12","X13","X14","X15","X16","X17","X18",  &
       "X19","X20","X21","X22","X23","X24","X25","X26","X27","X28",  &
       "X29","X30","X31","X32","X33","X34","X35","X36","X37","X38",  &
       "X39","X40","X41","X42","X43","X44","X45","X46","X47","X48",  &
       "X49","X50","X51","X52","X53","X54","X55","X56","X57","X58",  &
       "X59","X60","X61","X62","X63","X64","X65","X66","X67","X68",  &
       "X69","X70","X71","X72","X73","X74","X75","X76","X77","X78",  &
       "X79","X80","X81","X82","X83","X84","X85","X86","X87","X88",  &
       "X89","X90","X91","X92","X93","X94","X95","X96","X97","X98",  &
       "X99"/

  if(w(1)(1:1).eq.'<' .and. w(2)(1:1).eq.'<') go to 900
  if(nwords.eq.4 .or. nwords.eq.5 .or. nwords.eq.6) then
     i1=1
     if(trim(w(1)).eq.'TU;') i1=2
     call chkcall(w(i1),bcall_1,ok1)
     call chkcall(w(i1+1),bcall_2,ok2)
     if(.not.ok1 .or. .not.ok2) go to 900
     crpt=w(nwords-1)(1:3)
     if(index(crpt,'-').ge.1 .or. index(crpt,'+').ge.1) go to 900
     if(crpt(1:1).eq.'5' .and. crpt(2:2).ge.'2' .and. crpt(2:2).le.'9' .and.    &
          crpt(3:3).eq.'9') then
        nserial=0
        read(w(nwords),*,err=1) nserial
     endif
1    mult='   '
     imult=-1
     do i=1,NUSCAN
        if(cmult(i).eq.w(nwords)) then
           imult=i
           mult=cmult(i)
           exit
        endif
     enddo
     nexch=0
     if(nserial.gt.0) nexch=nserial
     if(imult.gt.0) nexch=8000+imult
     if(mult.ne.'   ' .or. nserial.gt.0) then
        i3=3
        n3=0
        itu=0
        if(trim(w(1)).eq.'TU;') itu=1
        call pack28(w(1+itu),n28a)
        call pack28(w(2+itu),n28b)
        ir=0
        if(w(3+itu)(1:2).eq.'R ') ir=1
        read(w(3+itu+ir),*,err=900) irpt
        irpt=(irpt-509)/10 - 2
        if(irpt.lt.0) irpt=0
        if(irpt.gt.7) irpt=7
! 3     TU; W9XYZ K1ABC R 579 MA             1 28 28 1 3 13       74   ARRL RTTY contest
! 3     TU; W9XYZ G8ABC R 559 0013           1 28 28 1 3 13       74   ARRL RTTY (DX)
        write(c77,1010) itu,n28a,n28b,ir,irpt,nexch,i3
1010    format(b1,2b28.28,b1,b3.3,b13.13,b3.3)
     endif
  endif

900 return
end subroutine pack77_3


subroutine pack77_4(nwords,w,i3,n3,c77)
  
! Check Type 4 (One nonstandard call and one hashed call)
! Example message: <WA9XYZ> PJ4/KA1ABC RR73           12 58 1 2 1      74

  integer*8 n58
  logical ok1,ok2
  character*13 w(19)
  character*77 c77
  character*13 call_1,call_2
  character*11 c11
  character*6 bcall_1,bcall_2
  character*38 c
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  iflip=0
  i3=-1
  if(nwords.eq.2 .or. nwords.eq.3) then
     call_1=w(1)
     if(call_1(1:1).eq.'<') call_1=w(1)(2:len(trim(w(1)))-1)
     call_2=w(2)
     if(call_2(1:1).eq.'<') call_2=w(2)(2:len(trim(w(2)))-1)
     call chkcall(call_1,bcall_1,ok1)
     call chkcall(call_2,bcall_2,ok2)
     if(call_1.eq.bcall_1 .and. call_2.eq.bcall_2 .and. ok1 .and. ok2) go to 900
     icq=0
     if(trim(w(1)).eq.'CQ' .or. (ok1.and.ok2)) then
        if(trim(w(1)).eq.'CQ' .and. len(trim(w(2))).le.4) go to 900
        i3=4
        n3=0
        if(trim(w(1)).eq.'CQ') icq=1
     endif

     if(icq.eq.1) then
        iflip=0
        n12=0
        c11=adjustr(call_2(1:11))
        call save_hash_call(w(2),n10,n12,n22)
     else if(w(1)(1:1).eq.'<') then
        iflip=0
        i3=4
        call save_hash_call(w(1),n10,n12,n22)
        c11=adjustr(call_2(1:11))
     else if(w(2)(1:1).eq.'<') then
        iflip=1
        i3=4
        call save_hash_call(w(2),n10,n12,n22)
        c11=adjustr(call_1(1:11))
     endif
     n58=0
     do i=1,11
        n58=n58*38 + index(c,c11(i:i)) - 1
     enddo
     nrpt=0
     if(trim(w(3)).eq.'RRR') nrpt=1
     if(trim(w(3)).eq.'RR73') nrpt=2
     if(trim(w(3)).eq.'73') nrpt=3
     if(icq.eq.1) then
        iflip=0
        nrpt=0
     endif
     write(c77,1010) n12,n58,iflip,nrpt,icq,i3
1010 format(b12.12,b58.58,b1,b2.2,b1,b3.3)
     do i=1,77
        if(c77(i:i).eq.'*') c77(i:i)='0'     !### Clean up any illegal chars ###
     enddo
  endif

900 return
end subroutine pack77_4

subroutine pack77_5(nwords,w,i3,n3,c77)

! Pack a Type 0.2 message: EU VHF Contest mode
! Example message:  PA3XYZ/P R 590003 IO91NP           28 1 1 3 12 25
!                 <PA3XYZ> <G4ABC/P> R 590003 IO91NP   h10 h20 r1 s3 s12 g25

  character*13 w(19),c13
  character*77 c77
  character*6 grid6
  logical is_grid6

  is_grid6(grid6)=len(trim(grid6)).eq.6 .and.                        &
       grid6(1:1).ge.'A' .and. grid6(1:1).le.'R' .and.               &
       grid6(2:2).ge.'A' .and. grid6(2:2).le.'R' .and.               &
       grid6(3:3).ge.'0' .and. grid6(3:3).le.'9' .and.               &
       grid6(4:4).ge.'0' .and. grid6(4:4).le.'9' .and.               &
       grid6(5:5).ge.'A' .and. grid6(5:5).le.'X' .and.               &
       grid6(6:6).ge.'A' .and. grid6(6:6).le.'X'

  if(nwords.lt.4 .or. nwords.gt.5) return        !nwords must be 4 or 5
  if(w(1)(1:1).ne.'<' .or. w(2)(1:1).ne.'<') return !Both calls must be hashed
  nx=-1
  read(w(nwords-1),*,err=2) nx
2 if(nx.lt.520001 .or. nx.gt.594095) return   !Exchange between 520001 - 594095
  if(.not.is_grid6(w(nwords)(1:6))) return    !Last word must be a valid grid6

! Type 0.2: <PA3XYZ> <G4ABC/P> R 590003 IO91NP     h10 h20 r1 s3 s12 g25

  i3=5
  n3=0

  call save_hash_call(w(1),n10,n12,n22)
  i2=index(w(1),'>')
  c13=w(1)(2:i2-1)
  n12=ihashcall(c13,12)

  call save_hash_call(w(2),n10a,n12a,n22)
  i2=index(w(2),'>')
  c13=w(2)(2:i2-1)
  n22=ihashcall(c13,22)

  ir=0
  if(w(3)(1:2).eq.'R ') ir=1
  irpt=nx/10000 - 52
  iserial=mod(nx,10000)
  if(iserial.gt.2047) iserial=2047
  grid6=w(nwords)(1:6)
  j1=(ichar(grid6(1:1))-ichar('A'))*18*10*10*24*24
  j2=(ichar(grid6(2:2))-ichar('A'))*10*10*24*24
  j3=(ichar(grid6(3:3))-ichar('0'))*10*24*24
  j4=(ichar(grid6(4:4))-ichar('0'))*24*24
  j5=(ichar(grid6(5:5))-ichar('A'))*24
  j6=(ichar(grid6(6:6))-ichar('A'))
  igrid6=j1+j2+j3+j4+j5+j6

  write(c77,1010) n12,n22,ir,irpt,iserial,igrid6,i3
1010 format(b12.12,b22.22,b1,b3.3,b11.11,b25.25,b3.3)

  return
end subroutine pack77_5


subroutine packtext77(c13,c71)

  character*13 c13,w
  character*71 c71
  character*42 c
  character*1 qa(10),qb(10)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  call mp_short_init
  qa=char(0)
  w=adjustr(c13)
  do i=1,13
     j=index(c,w(i:i))-1
     if(j.lt.0) j=0
     call mp_short_mult(qb,qa(2:10),9,42)     !qb(1:9)=42*qa(2:9)
     call mp_short_add(qa,qb(2:10),9,j)      !qa(1:9)=qb(2:9)+j
  enddo

  write(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  return
end subroutine packtext77

subroutine unpacktext77(c71,c13)

  integer*1   ia(10)
  character*1 qa(10),qb(10)
  character*13 c13
  character*71 c71
  character*42 c
  equivalence (qa,ia),(qb,ib)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  qa(1)=char(0)
  read(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  do i=13,1,-1
     call mp_short_div(qb,qa(2:10),9,42,ir)
     c13(i:i)=c(ir+1:ir+1)
     qa(2:10)=qb(1:9)
  enddo

  return
end subroutine unpacktext77

subroutine mp_short_ops(w,u)
  character*1 w(*),u(*)
  integer i,ireg,j,n,ir,iv,ii1,ii2
  character*1 creg(4)
  save ii1,ii2
  equivalence (ireg,creg)

  entry mp_short_init
  ireg=256*ichar('2')+ichar('1')
  do j=1,4
     if (creg(j).eq.'1') ii1=j
     if (creg(j).eq.'2') ii2=j
  enddo
  return

  entry mp_short_add(w,u,n,iv)
  ireg=256*iv
  do j=n,1,-1
     ireg=ichar(u(j))+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_mult(w,u,n,iv)
  ireg=0
  do j=n,1,-1
     ireg=ichar(u(j))*iv+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_div(w,u,n,iv,ir)
  ir=0
  do j=1,n
     i=256*ir+ichar(u(j))
     w(j)=char(i/iv)
     ir=mod(i,iv)
  enddo
  return
  
  return
end subroutine mp_short_ops

subroutine add_call_to_recent_calls(callsign)

  character*13 callsign
  logical ladd

! only add if the callsign is not already on the list
  ladd=.true.
  do i=1,MAXRECENT-1 ! if callsign is at the end of the list add it again
     if(recent_calls(i).eq.callsign) ladd=.false.
  enddo

  if(ladd) then
     do i=MAXRECENT,2,-1
        recent_calls(i)=recent_calls(i-1)
     enddo
     recent_calls(1)=callsign
  endif

! Make sure that callsign is hashed
!  call save_hash_call(callsign,n10,n12,n22) ! commented out - do this in the calling routine:

  return
end subroutine add_call_to_recent_calls

subroutine to_grid4(n,grid4,ok)
  character*4 grid4
  logical ok

  ok=.false.
  j1=n/(18*10*10)
  if (j1.lt.0.or.j1.gt.17) goto 900
  n=n-j1*18*10*10
  j2=n/(10*10)
  if (j2.lt.0.or.j2.gt.17) goto 900
  n=n-j2*10*10
  j3=n/10
  if (j3.lt.0.or.j3.gt.9) goto 900
  j4=n-j3*10
  if (j4.lt.0.or.j4.gt.9) goto 900
  grid4(1:1)=char(j1+ichar('A'))
  grid4(2:2)=char(j2+ichar('A'))
  grid4(3:3)=char(j3+ichar('0'))
  grid4(4:4)=char(j4+ichar('0'))
  ok=.true.

900 return
end subroutine to_grid4

subroutine to_grid6(n,grid6,ok)
  character*6 grid6
  logical ok

  ok=.false.
  j1=n/(18*10*10*24*24)
  if (j1.lt.0.or.j1.gt.17) goto 900
  n=n-j1*18*10*10*24*24
  j2=n/(10*10*24*24)
  if (j2.lt.0.or.j2.gt.17) goto 900
  n=n-j2*10*10*24*24
  j3=n/(10*24*24)
  if (j3.lt.0.or.j3.gt.9) goto 900
  n=n-j3*10*24*24
  j4=n/(24*24)
  if (j4.lt.0.or.j4.gt.9) goto 900
  n=n-j4*24*24
  j5=n/24
  if (j5.lt.0.or.j5.gt.23) goto 900
  j6=n-j5*24
  if (j6.lt.0.or.j6.gt.23) goto 900
  grid6(1:1)=char(j1+ichar('A'))
  grid6(2:2)=char(j2+ichar('A'))
  grid6(3:3)=char(j3+ichar('0'))
  grid6(4:4)=char(j4+ichar('0'))
  grid6(5:5)=char(j5+ichar('A'))
  grid6(6:6)=char(j6+ichar('A'))  
  ok=.true.

900 return
end subroutine to_grid6

subroutine to_grid(n,grid6,ok)
  ! 4-, or 6-character grid
  character*6 grid6
  logical ok

  ok=.false.
  j1=n/(18*10*10*25*25)
  if (j1.lt.0.or.j1.gt.17) goto 900
  n=n-j1*18*10*10*25*25
  j2=n/(10*10*25*25)
  if (j2.lt.0.or.j2.gt.17) goto 900
  n=n-j2*10*10*25*25
  j3=n/(10*25*25)
  if (j3.lt.0.or.j3.gt.9) goto 900
  n=n-j3*10*25*25
  j4=n/(25*25)
  if (j4.lt.0.or.j4.gt.9) goto 900
  n=n-j4*25*25
  j5=n/25
  if (j5.lt.0.or.j5.gt.24) goto 900
  j6=n-j5*25
  if (j6.lt.0.or.j6.gt.24) goto 900
  grid6=''
  grid6(1:1)=char(j1+ichar('A'))
  grid6(2:2)=char(j2+ichar('A'))
  grid6(3:3)=char(j3+ichar('0'))
  grid6(4:4)=char(j4+ichar('0'))
  if (j5.ne.24.or.j6.ne.24) then
     grid6(5:5)=char(j5+ichar('A'))
     grid6(6:6)=char(j6+ichar('A'))
  endif
  ok=.true.

900 return
end subroutine to_grid

end module packjt77

subroutine encode174_91(message77,codeword)
!
! Add a 14-bit CRC to a 77-bit message and return a 174-bit codeword
!
   use, intrinsic :: iso_c_binding
   use iso_c_binding, only: c_loc,c_size_t
   use crc

   integer, parameter:: N=174, K=91, M=N-K
   character*91 tmpchar
   integer*1 codeword(N)
   integer*1 gen(M,K)
   integer*1 message77(77),message(K)
   integer*1 pchecks(M)
   integer*1, target :: i1MsgBytes(12)
   include "ldpc_174_91_c_generator.f90"
   logical first
   data first/.true./
   save first,gen

   if( first ) then ! fill the generator matrix
      gen=0
      do i=1,M
         do j=1,23
            read(g(i)(j:j),"(Z1)") istr
            ibmax=4
            if(j.eq.23) ibmax=3
            do jj=1, ibmax
               icol=(j-1)*4+jj
               if( btest(istr,4-jj) ) gen(i,icol)=1
            enddo
         enddo
      enddo
      first=.false.
   endif

! Add 14-bit CRC to form 91-bit message+CRC14
   write(tmpchar,'(77i1)') message77
   tmpchar(78:80)='000'
   i1MsgBytes=0
   read(tmpchar,'(10b8)') i1MsgBytes(1:10)
   ncrc14 = crc14 (c_loc (i1MsgBytes), 12)
   write(tmpchar(78:91),'(b14)') ncrc14
   read(tmpchar,'(91i1)') message

   do i=1,M
      nsum=0
      do j=1,K
         nsum=nsum+message(j)*gen(i,j)
      enddo
      pchecks(i)=mod(nsum,2)
   enddo

   codeword(1:K)=message
   codeword(K+1:N)=pchecks

   return
end subroutine encode174_91

subroutine sfrsd(mrsym,mrprob,mr2sym,mr2prob,ntrials,correct,indexes,   &
     param,ntry)

  integer mrsym(0:62),mrprob(0:62),mr2sym(0:62),mr2prob(0:62)
  integer correct(0:62),indexes(0:62),probs(0:62),thresh0(0:62)
  integer rxdat(0:62),rxdat2(0:62),rxprob(0:62),rxprob2(0:62)
  integer workdat(0:62),era_pos(0:50)
  integer perr(0:7,0:7)
  integer param(0:7)
  real ratio0(0:62)

  call init_rs_int()
  do i=0,62
     rxdat(i)=mrsym(62-i)
     rxdat2(i)=mr2sym(62-i)
     rxprob(i)=mrprob(62-i)
     rxprob2(i)=mr2prob(62-i)
  enddo

  do i=0,62
     indexes(i)=i
     probs(i)=rxprob(i)
  enddo

  do ip=1,62
     do k=0,63-ip
        if(probs(k).lt.probs(k+1)) then
           ntmp=probs(k)
           probs(k)=probs(k+1)
           probs(k+1)=ntmp
           ntmp=indexes(k)
           indexes(k)=indexes(k+1)
           indexes(k+1)=ntmp
        endif
     enddo
  enddo

  era_pos=0
  numera=0
  workdat=rxdat
  call decode_rs_int()
  if(nerr.ge.0) then
     correct=workdat
     param=0
     return
  endif

  call random_seed()

  ncandidates=0
  nsum=0
  do i=0,62
     nsum=nsum+rxprob(i)
     j=indexes(62-i)
     ratio0(i)=float(rxprob2(j))/(float(rxprob(j))+0.01)
     ii=int(7.999*ratio0(i))
     jj=(62-i)/8
     thresh0(i)=nint(1.3*perr(jj,ii))
  enddo
  if(nsum.eq.0) return

  do k=0,ntrials
     era_pos=0
     workdat=rxdat
     numera=0
     do i=0,62
        j=indexes(62-i)
        thresh=thresh0(i)
        ir=rand()
        if(...) then
           era_pos(numera)=j
           numera=numera+1
        endif
     enddo

     call decode_rs_int()
     if(nerr.ge.0) then
        ncandidates=ncandidates+1
        nhard=0
        nsoft=0
        nsofter=0
        do i=0,62
           if(workdat(i).ne.rxdat(i)) then
              nhard=nhard+1
              nsofter=nsofter+rxprob(i)
              if(workdat(i).ne.rxdat2(i)) nsoft=nsoft+rxprob(i)
           else
              nsofter=nsofter-rxprob(i)
           endif
        enddo
        nsoft=63*nsoft/nsum
        nsofter=63*nsofter/nsum
        ntotal=nsoft+nhard
        if(ntotal.lt.ntotal_min) then
           nsoft_min=nsoft
           nhard_min=nhard
           nsofter_min=nsofter
           ntotal_min=ntotal
           correct=workdat
           nera_best=numera
           ntry=k
        endif
        if(ntotal_min.lt.72 .and. nhard_min.lt.42) exit
     endif
     if(k.eq.ntrials-1) ntry=k+1
  enddo

  if(ntotal_min.ge.76 .or. nhard.ge.44) nhard_min=-1

  param(0)=ncandidates
  param(1)=nhard_min
  param(2)=nsoft_min
  param(3)=nera_best
  param(4)=nsofter_min
  if(param(0).eq.0) param(2)=-1

  return
end subroutine sfrsd


                 

program JT65code

! Provides examples of message packing, bit and symbol ordering,
! Reed Solomon encoding, and other necessary details of the JT65
! protocol.

  character*22 msg0,msg,decoded,cok*3
  integer dgen(12),sent(63),recd(12),era(51)

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: JT65code "message"'
     go to 999
  endif

  call getarg(1,msg0)                     !Get message from command line
  msg=msg0

  call chkmsg(msg,cok,nspecial,flip)      !See if it includes "OOO" report
  if(nspecial.gt.0) then                  !or is a shorthand message
     write(*,1010) 
1010 format('Shorthand message.')
     go to 999
  endif

  call packmsg(msg,dgen)                  !Pack message into 72 bits
  write(*,1020) msg0
1020 format('Message:   ',a22)            !Echo input message
  if(iand(dgen(10),8).ne.0) write(*,1030) !Is plain text bit set?
1030 format('Plain text.')         
  write(*,1040) dgen
1040 format('Packed message, 6-bit symbols: ',12i3) !Display packed symbols

  call rs_encode(dgen,sent)               !RS encode
  call interleave63(sent,1)               !Interleave channel symbols
  call graycode(sent,63,1)                !Apply Gray code
  write(*,1050) sent
1050 format('Channel symbols, including FEC:'/(i5,20i3))

  call graycode(sent,63,-1)
  call interleave63(sent,-1)
  call rs_decode(sent,era,0,recd,nerr)
  call unpackmsg(recd,decoded)            !Unpack the user message
  write(*,1060) decoded,cok
1060 format('Decoded message: ',a22,2x,a3)

999 end program JT65code

program ft4code

! Provides examples of message packing, LDPC(174,91) encoding, bit and
! symbol ordering, and other details of the FT8 protocol.

  use packjt77
  include 'ft4_params.f90'               !Set various constants
  include 'ft4_testmsg.f90'
  parameter (NWAVE=NN*NSPS)
 
  character*37 msg,msgsent
  character*77 c77
  character*9 comment
  character bad*1,msgtype*18
  integer itone(NN)
  integer*1 msgbits(77),rvec(77),codeword(174)
  data rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
            1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
            0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.1 .and. nargs.ne.3) then
     print*
     print*,'Program ft4code:  Provides examples of message packing, ',       &
          'LDPC(174,91) encoding,'
     print*,'bit and symbol ordering, and other details of the FT4 protocol.'
     print*
     print*,'Usage: ft4code [-c grid] "message"  # Results for specified message'
     print*,'       ft4code -t                   # Examples of all message types'
     go to 999
  endif

  call getarg(1,msg)                    !Message to be transmitted
  if(len(trim(msg)).eq.2 .and. msg(1:2).eq.'-t') then
     nmsg=NTEST
  else
     call fmtmsg(msg,iz)          !To upper case; collapse multiple blanks
     nmsg=1
  endif

  write(*,1010)
1010 format(4x,'Message',31x,'Decoded',29x,'Err i3.n3'/100('-')) 

  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)
     
! Generate msgsent, msgbits, and itone
     i3=-1
     n3=-1
     call pack77(msg,i3,n3,c77)
     call genft4(msg,0,msgsent,msgbits,itone)
     call encode174_91(msgbits,codeword)
     msgtype=""
     if(i3.eq.0) then
        if(n3.eq.0) msgtype="Free text"
        if(n3.eq.1) msgtype="DXpedition mode"
        if(n3.eq.2) msgtype="EU VHF Contest"
        if(n3.eq.3) msgtype="ARRL Field Day"
        if(n3.eq.4) msgtype="ARRL Field Day"
        if(n3.eq.5) msgtype="Telemetry"
        if(n3.ge.6) msgtype="Undefined type"
     endif 
     if(i3.eq.1) msgtype="Standard msg"
     if(i3.eq.2) msgtype="EU VHF Contest"
     if(i3.eq.3) msgtype="ARRL RTTY Roundup"
     if(i3.eq.4) msgtype="Nonstandard calls"
     if(i3.eq.5) msgtype="EU VHF Contest"
     if(i3.ge.6) msgtype="Undefined msg type"
     if(i3.ge.1) n3=-1
     bad=" "
     comment='         '
     if(msg.ne.msgsent) bad="*"
     if(n3.ge.0) then
        write(*,1020) imsg,msg,msgsent,bad,i3,n3,msgtype,comment
1020    format(i2,'.',1x,a37,1x,a37,1x,a1,2x,i1,'.',i1,1x,a18,1x,a9)
     else
        write(*,1022) imsg,msg,msgsent,bad,i3,msgtype,comment
1022    format(i2,'.',1x,a37,1x,a37,1x,a1,2x,i1,'.',1x,1x,a18,1x,a9)
     endif
  enddo

  if(nmsg.eq.1) then
     write(*,1030) ieor(msgbits,rvec)
1030 format(/'Source-encoded message before scrambling, 77 bits: ',/77i1)
     write(*,1032) rvec
1032 format(/'Scrambling vector, 77 bits: ',/77i1)
     write(*,1034) msgbits
1034 format(/'Source-encoded message after scrambling, 77 bits:'/77i1)
     write(*,1036) codeword(78:91)
1036 format(/'14-bit CRC: ',/14i1)
     write(*,1038) codeword(92:174)
1038 format(/'83 Parity bits: ',/83i1)     
     write(*,1040) 0,itone,0
1040 format(/'Channel symbols (105 tones):'/                            &
          'R Sync',13x,'Data',13x,                                      &
          ' Sync',13x,'Data',13x,                                       &
          ' Sync',13x,'Data',13x,' Sync R'/                             &
          i1,1x,4i1,1x,29i1,1x,4i1,1x,29i1,1x,4i1,1x,29i1,1x,4i1,i2)
  endif

999 end program ft4code

module decode65b_mod
  implicit none
contains

subroutine decode65b(s2,flip,mycall,hiscall,hisgrid,mode65,neme,ndepth,  &
     nqd,nkv,nhist,qual,decoded,s3,sy)
     
  use deep65_mod
  use extract_mod
  use pr_mod
  use setup65_mod

  real,          intent(in)    :: s2(66,126)
  real,          intent(out)   :: s3(64,63), sy(63)
  real,          intent(in)    :: flip
  real,          intent(inout) :: qual
  integer,       intent(in)    :: mode65, neme, ndepth, nqd
  integer,       intent(inout) :: nhist
  integer,       intent(out)   :: nkv
  character(len=12),  intent(in)    :: mycall, hiscall
  character(len=6),   intent(in)    :: hisgrid
  character(len=22),  intent(out) :: decoded

  integer :: nadd,ncount,i,j,k
  logical first,ltext
  character deepmsg*22
  integer :: mrs(63), mrs2(63)
  data deepmsg/'                      '/
  data first/.true./
  save

  if(first) call setup65
  first=.false.

  do j=1,63
     k=mdat(j)                       !Points to data symbol
     if(flip.lt.0.0) k=mdat2(j)
     do i=1,64
        s3(i,j)=s2(i+2,k)
     enddo
     k=mdat2(j)                       !Points to data symbol
     if(flip.lt.0.0) k=mdat(j)
     sy(j)=s2(1,k)
  enddo

  nadd=mode65
!  write(*,*) 'DECODE65B: flip=', flip, ' mode65=', mode65, ' ndepth=', ndepth, ' neme=', neme
!  write(*,*) 'DECODE65B: nhist in=', nhist
!  write(*,*) 'DECODE65B: first few s3(:,1) = ', s3(1:10,1)
!  write(*,*) 'DECODE65B: mdat(1:10) = ', mdat(1:10)
!  write(*,*) 'DECODE65B: mdat2(1:10) = ', mdat2(1:10)

  call extract(s3,nadd,ncount,nhist,decoded,ltext,mrs,mrs2)     !Extract the message
! Suppress "birdie messages" and other garbage decodes:
  if(decoded(1:7).eq.'000AAA ') ncount=-1
  if(decoded(1:7).eq.'0L6MWK ') ncount=-1
  if(flip.lt.0.0 .and. ltext) ncount=-1
  nkv=1
  if(ncount.lt.0) then 
     nkv=0
     decoded='                      '
  endif

  qual=0.
  if(ndepth.ge.1 .and. (nqd.eq.1 .or. flip.eq.1.0)) then
     call deep65(s3,mode65,neme,flip,mycall,hiscall,hisgrid,deepmsg,qual,mrs,mrs2)
     if(nqd.ne.1 .and. qual.lt.10.0) qual=0.0
     if(ndepth.lt.2 .and. qual.lt.6.0) qual=0.0
  endif
  if(nkv.eq.0 .and. qual.ge.1.0) decoded=deepmsg

  return
end subroutine decode65b

end module decode65b_mod 

subroutine geocentric(alat,elev,hlt,erad)

  implicit real*8 (a-h,o-z)

! IAU 1976 flattening f, equatorial radius a
  f = 1.d0/298.257d0
  a = 6378140.d0
  c = 1.d0/sqrt(1.d0 + (-2.d0 + f)*f*sin(alat)*sin(alat))
  arcf = (a*c + elev)*cos(alat)
  arsf = (a*(1.d0 - f)*(1.d0 - f)*c + elev)*sin(alat)
  hlt = datan2(arsf,arcf)
  erad = sqrt(arcf*arcf + arsf*arsf)
  erad = 0.001d0*erad

  return
end subroutine geocentric

program jt9code

! Generate simulated data for testing of WSJT-X

  character*22 msg,msgchk,msg0,msg1,decoded,cok*3,bad*1,msgtype*10,expected
  integer*4 i4tone(85)                     !Channel symbols (values 0-8)
  include 'testmsg.f90'
  include 'jt9sync.f90'

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: jt9code "message"'
     print*,'       jt9code -t'
     go to 999
  endif

  call getarg(1,msg)
  nmsg=1
  if(msg(1:2).eq."-t") then
     if (NTEST+5 > MAXTEST) then
        write(*,*) "NTEST exceed MAXTEST"
     endif
     testmsg(NTEST+1)="KA1ABC WB9XYZ EN34 OOO"
     testmsg(NTEST+2)="KA1ABC WB9XYZ OOO"
     testmsg(NTEST+3)="RO"
     testmsg(NTEST+4)="RRR"
     testmsg(NTEST+5)="73"
     testmsgchk(NTEST+1)="KA1ABC WB9XYZ EN34 OOO"
     testmsgchk(NTEST+2)="KA1ABC WB9XYZ OOO"
     testmsgchk(NTEST+3)="RO"
     testmsgchk(NTEST+4)="RRR"
     testmsgchk(NTEST+5)="73"
     nmsg=NTEST+5
  endif

  write(*,1010)
1010 format("    Message                Decoded              Err? Type          Expected"/   &
            76("-"))
  do imsg=1,nmsg
     if(nmsg.gt.1) then
        msg=testmsg(imsg)
        msgchk=testmsgchk(imsg)
     endif
     call fmtmsg(msg,iz)                !To upper case, collapse multiple blanks
     msg0=msg
     ichk=0
     call chkmsg(msg,cok,nspecial,flip)     !See if it includes "OOO" report
     msg1=msg                               !Message without "OOO"

     if(nspecial.gt.0) then                  !or is a shorthand message
        if(nspecial.eq.2) decoded="RO"
        if(nspecial.eq.3) decoded="RRR"
        if(nspecial.eq.4) decoded="73"
        itype=-1
        msgtype="Shorthand"
        go to 10
     endif

     call gen9(msg,ichk,decoded,i4tone,itype)   !Encode message into tone #s

     msgtype=""
     if(itype.eq.1) msgtype="Std Msg"
     if(itype.eq.2) msgtype="Type 1 pfx"
     if(itype.eq.3) msgtype="Type 1 sfx"
     if(itype.eq.4) msgtype="Type 2 pfx"
     if(itype.eq.5) msgtype="Type 2 sfx"
     if(itype.eq.6) msgtype="Free text"

     if(cok.eq."OOO") decoded(20:22)=cok
     call fmtmsg(decoded,iz)

10   bad=" "
     expected = 'EXACT'
     if(decoded.ne.msg0) then
        bad="*"
        if(decoded(1:13).eq.msg0(1:13) .and.                             &
             decoded(14:22).eq. '         ') expected = 'TRUNCATED'
     endif
     write(*,1020) imsg,msg0,decoded,bad,itype,msgtype,expected
1020 format(i2,'.',1x,a22,1x,a22,1x,a1,i3,":",a10,2x,a22)
  enddo

  if(nmsg.eq.1) write(*,1030) i4tone
1030 format(/'Channel symbols'/(30i2))

999 end program jt9code

program ft4sim_mult

! Generate simulated signals for experimental "FT4" mode 

  use wavhdr
  use packjt77
  include 'ft4_params.f90'               !FT4 protocol constants
  parameter (NWAVE=NN*NSPS)
  parameter (NZZ=72576)                  !Length of .wav file (21*3456)
  type(hdr) h                            !Header for .wav file
  character arg*12,fname*17,cjunk*4
  character msg37*37,msgsent37*37,c77*77
  complex cwave0((NN+2)*NSPS)
  real wave0((NN+2)*NSPS)
  real wave(NZZ)
  real tmp(NZZ)
  integer itone(NN)
  integer*1 msgbits(77)
  integer*2 iwave(NZZ)                  !Generated full-length waveform
  
! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage:    ft4sim_mult nsigs nfiles'
     print*,'Example:  ft4sim_mult  20     8 '
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nsigs               !Number of signals
  call getarg(2,arg)
  read(arg,*) nfiles              !Number of files

  twopi=8.0*atan(1.0)
  fs=12000.0                      !Sample rate (Hz)
  dt=1.0/fs                       !Sample interval (s)
  hmod=1.0                        !Modulation index (0.5 is MSK, 1.0 is FSK)
  tt=NSPS*dt                      !Duration of unsmoothed symbols (s)
  baud=1.0/tt                     !Keying rate (baud)
  txt=NZ*dt                       !Transmission length (s) without ramp up/down
  bandwidth_ratio=2500.0/(fs/2.0)
  txt=NN*NSPS/12000.0
  open(10,file='messages.txt',status='old',err=998)

  do ifile=1,nfiles
1    read(10,1001,end=999) cjunk,n
1001 format(a4,i2)
     if(cjunk.ne.'File' .or. n.ne.ifile) go to 1
     wave=0.
     write(fname,1002) ifile
1002 format('000000_',i6.6,'.wav')
     
     do isig=1,nsigs
        read(10,1003,end=100) cjunk,isnr,xdt0,ifreq,msg37
1003    format(a4,30x,i3,f5.1,i5,1x,a37)
        if(cjunk.eq.'File') go to 100
        if(isnr.lt.-17) isnr=-17
        f0=ifreq*960.0/576.0
        call random_number(r)
        xdt=r-0.5
! Source-encode, then get itone()
        i3=-1
        n3=-1
        call pack77(msg37,i3,n3,c77)
        call genft4(msg37,0,msgsent37,msgbits,itone)
        nwave0=(NN+2)*NSPS
        icmplx=0
        call gen_ft4wave(itone,NN,NSPS,12000.0,f0,cwave0,wave0,icmplx,nwave0)

        k0=nint((xdt+0.5)/dt)
        if(k0.lt.1) k0=1
        tmp(:k0-1)=0.0
        tmp(k0:k0+nwave0-1)=wave0
        tmp(k0+nwave0:)=0.0

 ! Insert this signal into wave() array
        sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*isnr)
        wave=wave + sig*tmp
        write(*,1100) fname(1:13),isig,isnr,xdt,nint(f0),msg37
1100    format(a13,i4,i5,f5.1,i6,2x,a37)
     enddo   ! isig
   
100  backspace 10

     do i=1,NZZ                   !Add gaussian noise at specified SNR
        xnoise=gran()
        wave(i)=wave(i) + xnoise
     enddo

     gain=30.0
     wave=gain*wave
     if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave=nint(wave)
     h=default_header(12000,NZZ)
     open(12,file=fname,status='unknown',access='stream')
     write(12) h,iwave                !Save to *.wav file
     close(12)
     print*,' '
  enddo      ! ifile
  go to 999

998 print*,'Cannot open file "messages.txt"'

999 end program ft4sim_mult

subroutine chkhist(mrsym,nmax,ipk)

  integer mrsym(63)
  integer hist(0:63)

  do i=0,63
     hist(i)=0
  enddo
  do j=1,63
     i=mrsym(j)
     hist(i)=hist(i)+1
  enddo

  nmax=0
  do i=0,63
     if(hist(i).gt.nmax) then
        nmax=hist(i)
        ipk=i+1
     endif
  enddo

  return
end subroutine chkhist

subroutine sun(y,m,DD,UT,lon,lat,RA,Dec,LST,Az,El,mjd,day)

  implicit none

  integer y                         !Year
  integer m                         !Month
  integer DD                        !Day
  integer mjd                       !Modified Julian Date
  real UT                           !UTC in hours
  real RA,Dec                       !RA and Dec of sun

! NB: Double caps here are single caps in the writeup.

! Orbital elements of the Sun (also N=0, i=0, a=1):
  real w                            !Argument of perihelion
  real e                            !Eccentricity
  real MM                           !Mean anomaly
  real Ls                           !Mean longitude

! Other standard variables:
  real v                            !True anomaly
  real EE                           !Eccentric anomaly
  real ecl                          !Obliquity of the ecliptic
  real d                            !Ephemeris time argument in days
  real r                            !Distance to sun, AU
  real xv,yv                        !x and y coords in ecliptic
  real lonsun                       !Ecliptic long and lat of sun
! Ecliptic coords of sun (geocentric)
  real xs,ys
! Equatorial coords of sun (geocentric)
  real xe,ye,ze
  real lon,lat
  real GMST0,LST,HA
  real xx,yy,zz
  real xhor,yhor,zhor
  real Az,El

  real day
  real rad
  data rad/57.2957795/

! Time in days, with Jan 0, 2000 equal to 0.0:
  d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + DD - 730530 + UT/24.0
  mjd=d + 51543
  ecl = 23.4393 - 3.563e-7 * d

! Compute updated orbital elements for Sun:
  w = 282.9404 + 4.70935e-5 * d
  e = 0.016709 - 1.151e-9 * d
  MM = mod(356.0470d0 + 0.9856002585d0 * d + 360000.d0,360.d0)
  Ls = mod(w+MM+720.0,360.0)

  EE = MM + e*rad*sin(MM/rad) * (1.0 + e*cos(M/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.0 - e*cos(EE/rad))

  xv = cos(EE/rad) - e
  yv = sqrt(1.0-e*e) * sin(EE/rad)
  v = rad*atan2(yv,xv)
  r = sqrt(xv*xv + yv*yv)
  lonsun = mod(v + w + 720.0,360.0)
! Ecliptic coordinates of sun (rectangular):
  xs = r * cos(lonsun/rad)
  ys = r * sin(lonsun/rad)

! Equatorial coordinates of sun (rectangular):
  xe = xs
  ye = ys * cos(ecl/rad)
  ze = ys * sin(ecl/rad)

! RA and Dec in degrees:
  RA = rad*atan2(ye,xe)
  Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))

  GMST0 = (Ls + 180.0)/15.0
  LST = mod(GMST0+UT+lon/15.0+48.0,24.0)    !LST in hours
  HA = 15.0*LST - RA                        !HA in degrees
  xx = cos(HA/rad)*cos(Dec/rad)
  yy = sin(HA/rad)*cos(Dec/rad)
  zz =             sin(Dec/rad)
  xhor = xx*sin(lat/rad) - zz*cos(lat/rad)
  yhor = yy
  zhor = xx*cos(lat/rad) + zz*sin(lat/rad)
  Az = mod(rad*atan2(yhor,xhor) + 180.0 + 360.0,360.0)
  El = rad*asin(zhor)
  day=d-1.5

  return
end subroutine sun

subroutine interleave63(d1,idir)

! Interleave (idir=1) or de-interleave (idir=-1) the array d1.

  integer d1(0:6,0:8)
  integer d2(0:8,0:6)

  if(idir.ge.0) then
     do i=0,6
        do j=0,8
           d2(j,i)=d1(i,j)
        enddo
     enddo
     call move(d2,d1,63)
  else
     call move(d1,d2,63)
     do i=0,6
        do j=0,8
           d1(i,j)=d2(j,i)
        enddo
     enddo
  endif
         
  return
end subroutine interleave63

subroutine filbig(dd,nmax,f0,newdat,nfsample,xpol,c4a,c4b,n4)

! Filter and downsample complex data stored in array dd(4,nmax).  
! Output is downsampled from 96000 Hz to 1375.125 Hz.

  use timer_module, only: timer
  parameter (MAXFFT1=5376000,MAXFFT2=77175)
  real*4  dd(4,nmax)                         !Input data
  complex ca(MAXFFT1),cb(MAXFFT1)            !FFTs of input
  complex c4a(MAXFFT2),c4b(MAXFFT2)          !Output data
  real*8 df
  real halfpulse(8)                 !Impulse response of filter (one sided)
  complex cfilt(MAXFFT2)                     !Filter (complex; imag = 0)
  real rfilt(MAXFFT2)                        !Filter (real)
  integer*8 plan1,plan2,plan3,plan4,plan5
  logical first,xpol
  include 'fftw3.f'
  common/cacb/ca,cb
  equivalence (rfilt,cfilt)
  data first/.true./,npatience/1/
  data halfpulse/114.97547150,36.57879257,-20.93789101,                &
       5.89886379,1.59355187,-2.49138308,0.60910773,-0.04248129/
  save

  if(nmax.lt.0) go to 900

  nfft1=MAXFFT1
  nfft2=MAXFFT2
  if(nfsample.eq.95238) then
     nfft1=5120000
     nfft2=74088
  endif

  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE
     
! Plan the FFTs just once
     call timer('FFTplans ',0)
     call sfftw_plan_dft_1d(plan1,nfft1,ca,ca,FFTW_BACKWARD,nflags)
     call sfftw_plan_dft_1d(plan2,nfft1,cb,cb,FFTW_BACKWARD,nflags)
     call sfftw_plan_dft_1d(plan3,nfft2,c4a,c4a,FFTW_FORWARD,nflags)
     call sfftw_plan_dft_1d(plan4,nfft2,c4b,c4b,FFTW_FORWARD,nflags)
     call sfftw_plan_dft_1d(plan5,nfft2,cfilt,cfilt,FFTW_BACKWARD,nflags)
     call timer('FFTplans ',1)

! Convert impulse response to filter function
     do i=1,nfft2
        cfilt(i)=0.
     enddo
     fac=0.00625/nfft1
     cfilt(1)=fac*halfpulse(1)
     do i=2,8
        cfilt(i)=fac*halfpulse(i)
        cfilt(nfft2+2-i)=fac*halfpulse(i)
     enddo
     call sfftw_execute(plan5)

     base=cfilt(nfft2/2+1)
     do i=1,nfft2
        rfilt(i)=real(cfilt(i))-base
     enddo

     df=96000.d0/nfft1
     if(nfsample.eq.95238) df=95238.1d0/nfft1
     first=.false.
  endif

! When new data comes along, we need to compute a new "big FFT"
! If we just have a new f0, continue with the existing ca and cb.

  if(newdat.ne.0 .or. sum(abs(ca)).eq.0.0) then  !### Test on ca should be unnecessary?
     nz=min(nmax,nfft1)
     do i=1,nz
        ca(i)=cmplx(dd(1,i),dd(2,i))
        if(xpol) cb(i)=cmplx(dd(3,i),dd(4,i))
     enddo

     if(nmax.lt.nfft1) then
        do i=nmax+1,nfft1
           ca(i)=0.
           if(xpol) cb(i)=0.
        enddo
     endif
     call timer('FFTbig  ',0)
     call sfftw_execute(plan1)
     if(xpol) call sfftw_execute(plan2)
     call timer('FFTbig  ',1)
     newdat=0
  endif

! NB: f0 is the frequency at which we want our filter centered.
!     i0 is the bin number in ca and cb closest to f0.

  i0=nint(f0/df) + 1
  nh=nfft2/2
  do i=1,nh                                !Copy data into c4a and c4b,
     j=i0+i-1                              !and apply the filter function
     if(j.ge.1 .and. j.le.nfft1) then
        c4a(i)=rfilt(i)*ca(j)
        if(xpol) c4b(i)=rfilt(i)*cb(j)
     else
        c4a(i)=0.
        if(xpol) c4b(i)=0.
     endif
  enddo
  do i=nh+1,nfft2
     j=i0+i-1-nfft2
     if(j.lt.1) j=j+nfft1                  !nfft1 was nfft2
     c4a(i)=rfilt(i)*ca(j)
     if(xpol) c4b(i)=rfilt(i)*cb(j)
  enddo

! Do the short reverse transform, to go back to time domain.
  call timer('FFTsmall',0)
  call sfftw_execute(plan3)
  if(xpol) call sfftw_execute(plan4)
  call timer('FFTsmall',1)
  n4=min(nmax/64,nfft2)
  go to 999

900 call sfftw_destroy_plan(plan1)
  call sfftw_destroy_plan(plan2)
  call sfftw_destroy_plan(plan3)
  call sfftw_destroy_plan(plan4)
  call sfftw_destroy_plan(plan5)

999 return
end subroutine filbig

program test_wspr

! This program provides examples of the source encoding, convolutional
! error-control coding, bit and symbol ordering, and synchronizing
! information contained in WSPR messages.

  character*22 msg,msg2
  character*23 msg3
  character*1 err2,err3
  integer*1 data0(11)
  logical lfile

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: test_wspr "message"'
     go to 999
  endif
  call getarg(1,msg)                             !Get message from command line
  call unpk(data0,1,msg3)                !Read the C hashtable
  lfile=msg(1:2).eq."-t"
  if(lfile) open(10,file="messages.txt",status="old")

  do imsg=1,999
     if(lfile) read(10,1001,end=900) msg
1001 format(a22)

     data0=0
     call wqencode(msg,ntype0,data0)             !Source encoding
!     write(*,1002) data0(1:7)
!1002 format('Source-encoded message (50 bits, hex):',7z3.2)
!     data0(8:11)=0

     call wqdecode(data0,msg2,ntype1)         

!  write(*,1020) ntype1
!1020 format('Message type: ',i7)
!  write(*,1030) msg2
!1030 format('Decoded message:  ',a22)

     call unpk(data0,0,msg3)
     do i=1,23
        if(ichar(msg3(i:i)).eq.0) then
           msg3(i:)="                      "
           exit
        endif
     enddo

     err2=' '
     err3=' '
     if(msg2.ne.msg) err2='*'
     if(msg3.ne.msg) err3='*'

     write(*,1040) msg,err2,msg2,err3,msg3
1040 format(a22,1x,a1,1x,a22,1x,a1,1x,a22)
     if(.not.lfile) exit
  enddo
900 call unpk(data0,2,msg3)


999 end program test_wspr

module jt65_decode

  integer, parameter :: NSZ=3413, NZMAX=60*12000

  type :: jt65_decoder
     procedure(jt65_decode_callback), pointer :: callback => null()
   contains
     procedure :: decode
  end type jt65_decoder

! Callback function to be called with each decode
  abstract interface
     subroutine jt65_decode_callback(this,sync,snr,dt,freq,drift,     &
          nflip,width,decoded,ft,qual,nsmo,nsum,minsync)

       import jt65_decoder
       implicit none
       class(jt65_decoder), intent(inout) :: this
       real, intent(in) :: sync
       integer, intent(in) :: snr
       real, intent(in) :: dt
       integer, intent(in) :: freq
       integer, intent(in) :: drift
       integer, intent(in) :: nflip
       real, intent(in) :: width
       character(len=22), intent(in) :: decoded
       integer, intent(in) :: ft
       integer, intent(in) :: qual
       integer, intent(in) :: nsmo
       integer, intent(in) :: nsum
       integer, intent(in) :: minsync

     end subroutine jt65_decode_callback
  end interface

contains

  subroutine decode(this,callback,dd0,npts,newdat,nutc,nf1,nf2,nfqso,     &
       ntol,nsubmode,minsync,nagain,n2pass,nrobust,ntrials,naggressive,   &
       ndepth,emedelay,clearave,mycall,hiscall,hisgrid,nexp_decode,       &
       nQSOProgress,ljt65apon)

!  Process dd0() data to find and decode JT65 signals.

    use jt65_mod
    use timer_module, only: timer

    include 'constants.f90'

    class(jt65_decoder), intent(inout) :: this
    procedure(jt65_decode_callback) :: callback
    real, intent(in) :: dd0(NZMAX),emedelay
    integer, intent(in) :: npts, nutc, nf1, nf2, nfqso, ntol     &
         , nsubmode, minsync, n2pass, ntrials, naggressive, ndepth      &
         , nexp_decode, nQSOProgress
    logical, intent(in) :: newdat, nagain, nrobust, clearave, ljt65apon
    character(len=12), intent(in) :: mycall, hiscall
    character(len=6), intent(in) :: hisgrid

    real dd(NZMAX)
    real ss(552,NSZ)
    real savg(NSZ)
    real a(5)
    character*22 decoded,decoded0,avemsg,deepave
    type candidate
       real freq
       real dt
       real sync
       real flip
    end type candidate
    type(candidate) ca(300)
    type accepted_decode
       real freq
       real dt
       real sync
       character*22 decoded
    end type accepted_decode
    type(accepted_decode) dec(50)
    logical :: first_time,prtavg,single_decode,bVHF,clear_avg65

    integer h0(0:11),d0(0:11)
    real r0(0:11)
    common/decstats/ntry65a,ntry65b,n65a,n65b,num9,numfano
    common/steve/thresh0
    common/sync/ss

!            0  1  2  3  4  5  6  7  8  9 10 11
    data h0/41,42,43,43,44,45,46,47,48,48,49,49/
    data d0/71,72,73,74,76,77,78,80,81,82,83,83/

!             0    1    2    3    4    5    6    7    8    9   10   11
    data r0/0.70,0.72,0.74,0.76,0.78,0.80,0.82,0.84,0.86,0.88,0.90,0.90/
    data nutc0/-999/,nfreq0/-999/,nsave/0/,clear_avg65/.true./
    save

    this%callback => callback
    first_time=nrobust .and. (emedelay.eq.-999.9)    !Silence compiler warning
    first_time=newdat
    dd=dd0
    ndecoded=0
    ndecoded0=0
    single_decode=iand(nexp_decode,32).ne.0 .or. nagain
    bVHF=iand(nexp_decode,64).ne.0

    if(bVHF) then
      nvec=ntrials
      npass=1
      if(n2pass.gt.1) npass=2
    else
      nvec=1000
      if(ndepth.eq.1) then
         npass=2
         nvec=100
      elseif(ndepth.eq.2) then
         npass=2
         nvec=1000
      else 
         npass=4
         nvec=1000
      endif
    endif
    do ipass=1,npass 
       first_time=.true.
       if(ipass.eq.1) then                        !First-pass parameters
          thresh0=2.5
          nsubtract=1
          nrob=0
       elseif( ipass.eq.2 ) then                  !Second-pass parameters
          thresh0=2.0
          nsubtract=1
          nrob=0
       elseif( ipass.eq.3 ) then 
          thresh0=2.0
          nsubtract=1
          nrob=0
       elseif( ipass.eq.4 ) then 
          thresh0=2.0
          nsubtract=0
          nrob=1
       endif
       if(npass.eq.1) then
         nsubtract=0
         thresh0=2.0
       endif

       call timer('symsp65 ',0)
       ss=0.
       call symspec65(dd,npts,nqsym,savg)    !Get normalized symbol spectra
       call timer('symsp65 ',1)
       nfa=nf1
       nfb=nf2

!### Q: should either of the next two uses of "single_decode" be "bVHF" instead?       
       if(single_decode .or. (bVHF .and. ntol.lt.1000)) then
          nfa=max(200,nfqso-ntol)
          nfb=min(4000,nfqso+ntol)
          thresh0=1.0
       endif
       df=12000.0/8192.0                     !df = 1.465 Hz
       if(bVHF) then
          ia=max(1,nint((nfa-100)/df))
          ib=min(NSZ,nint((nfb+100)/df))
          nz=ib-ia+1
          if(nz.lt.50) go to 900
          if(isnan(sum(savg(ia:ia+nz-1)))) go to 900
          call lorentzian(savg(ia),nz,a)
          baseline=a(1)
          amp=a(2)
          f0=(a(3)+ia-1)*df
          width=a(4)*df
       endif

       ncand=0
       call timer('sync65  ',0)
       call sync65(nfa,nfb,ntol,nqsym,ca,ncand,nrob,bVHF)
       ncand=min(ncand,50/ipass)
       call timer('sync65  ',1)

       mode65=2**nsubmode
       nflip=1
       nqd=0
       decoded='                      '
       decoded0=""
       freq0=0.
       prtavg=.false.
       if(.not.nagain) nsum=0
       if(clearave) then
          nsum=0
          nsave=0
          clear_avg65=.true.
       endif

       if(bVHF) then
! Be sure to search for shorthand message at nfqso +/- ntol
          if(ncand.lt.300) ncand=ncand+1
          ca(ncand)%sync=5.0
          ca(ncand)%dt=2.5
          ca(ncand)%freq=nfqso
          ca(ncand)%flip=0
       endif
       do icand=1,ncand
          sync1=ca(icand)%sync
          dtx=ca(icand)%dt
          freq=ca(icand)%freq
          if(bVHF) then
             flip=ca(icand)%flip
             nflip=int(flip)
          endif
          if(sync1.lt.float(minsync)) nflip=0
          if(ipass.eq.1) ntry65a=ntry65a + 1
          if(ipass.eq.2) ntry65b=ntry65b + 1
          call timer('decod65a',0)
          nft=0
          nspecial=0
          call decode65a(dd,npts,first_time,nqd,freq,nflip,mode65,nvec,     &
               naggressive,ndepth,ntol,mycall,hiscall,hisgrid,nQSOProgress, &
               ljt65apon,bVHF,sync2,a,dtx,nft,nspecial,qual,                &
               nhist,nsmo,decoded)
          call timer('decod65a',1)

          if(.not.bVHF) then   
             if(abs(a(1)).gt.10.0/ipass) cycle
             ibad=0
             if(abs(a(1)).gt.5.0) ibad=1
             if(abs(a(2)).gt.2.0) ibad=ibad+1
             if(abs(dtx-1.0).gt.2.5) ibad=ibad+1
             if(ibad.ge.2) cycle
          endif
          
          if(nspecial.eq.0 .and. sync1.eq.5.0 .and. dtx.eq.2.5) cycle
          if(nspecial.eq.2) decoded='RO'
          if(nspecial.eq.3) decoded='RRR'
          if(nspecial.eq.4) decoded='73'
          if(sync1.lt.float(minsync) .and.                                  &
               decoded.eq.'                      ') nflip=0
          if(nft.ne.0) nsum=1
          
          nhard_min=param(1)
          nrtt1000=param(4)
          ntotal_min=param(5)
          nsmo=param(9)
          
          nfreq=nint(freq+a(1))
          ndrift=nint(2.0*a(2))
          if(bVHF) then
            xtmp=10**((sync1+16.0)/10.0) ! sync comes to us in dB
            s2db=1.1*db(xtmp)+1.4*(dB(width)-4.3)-52.0 
!             s2db=sync1 - 30.0 + db(width/3.3)       !### VHF/UHF/microwave
             if(nspecial.gt.0) s2db=sync2
          else
             s2db=10.0*log10(sync2) - 35             !### Empirical (HF) 
          endif
          nsnr=nint(s2db)
          if(nsnr.lt.-30) nsnr=-30
          if(nsnr.gt.-1) nsnr=-1
          nftt=0
!********* DOES THIS STILL WORK WHEN NFT INCLUDES # OF AP SYMBOLS USED??
          if(nft.ne.1 .and. iand(ndepth,16).eq.16 .and.                    &
               sync1.ge.float(minsync) .and. (.not.prtavg)) then
! Single-sequence FT decode failed, so try for an average FT decode.
             if(nutc.ne.nutc0 .or. abs(nfreq-nfreq0).gt.ntol) then
! This is a new minute or a new frequency, so call avg65.
                nutc0=nutc
                nfreq0=nfreq
                nsave=nsave+1
                nsave=mod(nsave-1,64)+1
                call avg65(nutc,nsave,sync1,dtx,nflip,nfreq,mode65,ntol,     &
                     ndepth,nagain,ntrials,naggressive,clear_avg65,neme,     &
                     mycall,hiscall,hisgrid,nftt,avemsg,qave,deepave,nsum,   &
                     ndeepave,nQSOProgress,ljt65apon)
                nsmo=param(9)
                nqave=int(qave)

                if (associated(this%callback) .and.nftt.ge.1 .and. nsum.ge.2) then
! Display a decoded message obtained by averaging 2 or more transmissions
                   call this%callback(sync1,nsnr,dtx-1.0,nfreq,ndrift,  &
                        nflip,width,avemsg,nftt,nqave,nsmo,nsum,minsync)
                   prtavg=.true.
                end if

             endif
          endif

          if(nftt.eq.0) go to 5
!          if(nftt.eq.1) then
!!             nft=1
!             decoded=avemsg
!             go to 5
!          endif
          n=naggressive
          rtt=0.001*nrtt1000
          if(nft.lt.2 .and. minsync.ge.0 .and. nspecial.eq.0 .and. .not.bVHF) then
             if(nhard_min.gt.50) cycle
             if(nhard_min.gt.h0(n)) cycle
             if(ntotal_min.gt.d0(n)) cycle
             if(rtt.gt.r0(n)) cycle
          endif

5         continue
          if(decoded.eq.decoded0 .and. abs(freq-freq0).lt. 3.0 .and.    &
               minsync.ge.0) cycle                  !Don't display dupes
!          if(decoded.ne.'                      ' .or. minsync.lt.0) then
          if(decoded.ne.'                      ' .or. bVHF) then
             if(nsubtract.eq.1) then
                call timer('subtr65 ',0)
                call subtract65(dd,npts,freq,dtx)
                call timer('subtr65 ',1)
             endif

             ndupe=0 ! de-dedupe
             do i=1, ndecoded
                if(decoded==dec(i)%decoded) then
                   ndupe=1
                   exit
                endif
             enddo
             if(ndupe.ne.1 .and. ((sync1.ge.float(minsync)) .or. bVHF)) then
                if(ipass.eq.1) n65a=n65a + 1
                if(ipass.eq.2) n65b=n65b + 1
                if(ndecoded.lt.50) ndecoded=ndecoded+1
                dec(ndecoded)%freq=freq+a(1)
                dec(ndecoded)%dt=dtx
                dec(ndecoded)%sync=sync2
                dec(ndecoded)%decoded=decoded
                nqual=min(int(qual),9999)

                if(associated(this%callback)) then
                   call this%callback(sync1,nsnr,dtx-1.0,nfreq,ndrift,  &
                        nflip,width,decoded,nft,nqual,nsmo,1,minsync)
                end if
             endif
             decoded0=decoded
             freq0=freq
             if(decoded0.eq.'                      ') decoded0='*'
             if(single_decode .and. ndecoded.gt.0) go to 900
          endif
       enddo   ! icand
       if(ipass.gt.1 .and. ndecoded.eq.ndecoded0) exit
       ndecoded0=ndecoded
    enddo   ! ipass
900 return
  end subroutine decode

  subroutine avg65(nutc,nsave,snrsync,dtxx,nflip,nfreq,mode65,ntol,ndepth,    &
       nagain, ntrials,naggressive,clear_avg65,neme,mycall,hiscall,hisgrid,   &
       nftt,avemsg,qave,deepave,nsum,ndeepave,nQSOProgress,ljt65apon)

! Decodes averaged JT65 data

    use jt65_mod
    parameter (MAXAVE=64)
    character*22 avemsg,deepave,deepbest
    character mycall*12,hiscall*12,hisgrid*6
    character*1 csync,cused(64)
    logical nagain
    integer iused(64)
! Accumulated data for message averaging
    integer iutc(MAXAVE)
    integer nfsave(MAXAVE)
    integer nflipsave(MAXAVE)
    real s1b(-255:256,126)
    real s1save(-255:256,126,MAXAVE)
    real s2(66,126)
    real s3save(64,63,MAXAVE)
    real s3b(64,63)
    real s3c(64,63)
    real dtsave(MAXAVE)
    real syncsave(MAXAVE)
    logical first,clear_avg65,ljt65apon
    data first/.true./
    save

    if(first .or. clear_avg65) then
       iutc=-1
       nfsave=0
       dtdiff=0.2
       s3save=0.
       s1save=0.
       nsave=1           !### ???
! Silence compiler warnings
       if(nagain .and. ndeepave.eq.-99 .and. neme.eq.-99) stop
       first=.false.
       clear_avg65=.false.
    endif

    do i=1,64
       if(iutc(i).lt.0) exit
       if(nutc.eq.iutc(i) .and. abs(nfreq-nfsave(i)).le.ntol) go to 10
    enddo

! Save data for message averaging
    iutc(nsave)=nutc
    syncsave(nsave)=snrsync
    dtsave(nsave)=dtxx
    nfsave(nsave)=nfreq
    nflipsave(nsave)=nflip
    s1save(-255:256,1:126,nsave)=s1
    s3save(1:64,1:63,nsave)=s3a
    avemsg='                      '
    deepbest='                      '
    nfttbest=0
    
10  syncsum=0.
    dtsum=0.
    nfsum=0
    nsum=0
    s1b=0.
    s3b=0.
    s3c=0.

    do i=1,MAXAVE                               !Consider all saved spectra
       cused(i)='.'
       if(iutc(i).lt.0) exit
       if(mod(iutc(i),2).ne.mod(nutc,2)) cycle  !Use only same (odd/even) seq
       if(abs(dtxx-dtsave(i)).gt.dtdiff) cycle  !DT must match
       if(abs(nfreq-nfsave(i)).gt.ntol) cycle   !Freq must match
       if(nflipsave(i).eq.0) cycle              !No sync
       if(nflip.ne.nflipsave(i)) cycle          !Sync type (*/#) must match

       s3b=s3b + s3save(1:64,1:63,i)
       s1b=s1b + s1save(-255:256,1:126,i)
       syncsum=syncsum + syncsave(i)
       dtsum=dtsum + dtsave(i)
       nfsum=nfsum + nfsave(i)
       cused(i)='$'
       nsum=nsum+1
       iused(nsum)=i
    enddo
    if(nsum.lt.64) iused(nsum+1)=0

    syncave=0.
    dtave=0.
    fave=0.
    if(nsum.gt.0) then
       syncave=syncsum/nsum
       dtave=dtsum/nsum
       fave=float(nfsum)/nsum
    endif

    do i=1,nsave
       csync=' '
       if(nflipsave(i).lt.0.0) csync='#'
       if(nflipsave(i).gt.0.0) csync='*'
       write(14,1000) cused(i),iutc(i),syncsave(i),dtsave(i)-1.0,nfsave(i),csync
1000   format(a1,i5.4,f6.1,f6.2,i6,1x,a1)
    enddo
    if(nsum.lt.2) go to 900

    df=1378.125/512.0

! Do the smoothing loop
    qualbest=0.
    minsmo=0
    maxsmo=0
    if(mode65.ge.2) then
       minsmo=nint(width/df)
       maxsmo=2*minsmo
    endif
    nn=0
    do ismo=minsmo,maxsmo
       nftt=0
       if(ismo.gt.0) then
          do j=1,126
             call smo121(s1b(-255,j),512)
             if(j.eq.1) nn=nn+1
             if(nn.ge.4) then
                call smo121(s1b(-255,j),512)
                if(j.eq.1) nn=nn+1
             endif
          enddo
       endif

       do i=1,66
          jj=i
          if(mode65.eq.2) jj=2*i-1
          if(mode65.eq.4) then
             ff=4*(i-1)*df - 355.297852
             jj=nint(ff/df)+1
          endif
          s2(i,1:126)=s1b(jj,1:126)
       enddo

       do j=1,63
          k=mdat(j)                       !Points to data symbol
          if(nflip.lt.0) k=mdat2(j)
          do i=1,64
             s3c(i,j)=4.e-5*s2(i+2,k)
          enddo
       enddo

       nadd=nsum*ismo
       call extract(s3c,nadd,mode65,ntrials,naggressive,ndepth,nflip,mycall, &
            hiscall,hisgrid,nQSOProgress,ljt65apon,ncount,nhist, &
            avemsg,ltext,nftt,qual)
       if(nftt.eq.1) then
          nsmo=ismo
          param(9)=nsmo
          go to 900
       else if(nftt.ge.2) then
          if(qual.gt.qualbest) then
             deepbest=avemsg
             qualbest=qual
             nnbest=nn
             nsmobest=ismo
             nfttbest=nftt
          endif
       endif
    enddo
    if(nfttbest.eq.2) then
       avemsg=deepbest       !### ???
       deepave=deepbest
       qave=qualbest
       nsmo=nsmobest
       param(9)=nsmo
       nftt=nfttbest
    endif
900 continue
    
    return
  end subroutine avg65

end module jt65_decode

subroutine extract_callvar(msg37,call2)

  character, intent(in) :: msg37*37
  character, intent(out) :: call2*12
  character part2*12,part3*12

  call2=''; part2=''; part3=''
  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc3=index(msg37((ispc2+1):),' ')+ispc2
  part2=msg37(ispc1+1:ispc2-1); part3=msg37(ispc2+1:ispc3-1); npart2len=len_trim(part2)

  if(msg37(1:3).eq.'CQ ' .or. msg37(1:3).eq.'DE ' .or. msg37(1:4).eq.'QRZ ') then
    if(npart2len.gt.4) then; call2=part2
    elseif(npart2len.eq.4) then
      if(part2(2:2).ge.'0' .and. part2(2:2).lt.':' .or. part2(3:3).ge.'0' .and. part2(3:3).lt.':') then; call2=part2
      else; call2=part3
      endif
    elseif(npart2len.eq.3) then
      if(part2(1:1).ge.'A' .and. part2(1:1).lt.'[' .and. part2(2:2).ge.'0' .and. part2(2:2).lt.':') then; call2=part2
      else; call2=part3
      endif
    elseif(npart2len.eq.2) then; call2=part3
    endif
  elseif(ispc1.gt.3 .and. ispc1.lt.13) then; call2=part2
  endif

  return
end subroutine extract_callvar

subroutine extract(s3,nadd,ncount,nhist,decoded,ltext)

  use packjt
  use timer_module, only: timer
  real s3(64,63)
  character decoded*22
  integer dat4(12)
  integer mrsym(63),mr2sym(63),mrprob(63),mr2prob(63)
  logical first,ltext
  integer correct(63),itmp(63)
  integer param(0:8)
  integer h0(0:11),d0(0:11)
  real r0(0:11)
  common/test001/s3a(64,63),mrs(63),mrs2(63)        !### TEST ONLY ###

!          0  1  2  3  4  5  6  7  8  9 10 11
  data h0/41,42,43,43,44,45,46,47,48,48,49,49/
  data d0/71,72,73,74,76,77,78,80,81,82,83,83/
!            0    1    2    3    4    5    6    7    8    9   10   11
  data r0/0.70,0.72,0.74,0.76,0.78,0.80,0.82,0.84,0.86,0.88,0.90,0.90/

  data first/.true./,nsec1/0/
  save

  nfail=0
  call pctile(s3,4032,50,base)     ! ### or, use ave from demod64a
  s3=s3/base
  s3a=s3
1 call demod64a(s3,nadd,mrsym,mrprob,mr2sym,mr2prob,ntest,nlow)
!  if(ntest.lt.50 .or. nlow.gt.20) then
!     ncount=-999                         !Flag bad data
!     go to 900
!  endif
  call chkhist(mrsym,nhist,ipk)

  if(nhist.ge.20) then
     nfail=nfail+1
     call pctile(s3,4032,50,base)     ! ### or, use ave from demod64a
     s3(ipk,1:63)=base
     if(nfail.gt.30) then
        decoded='                      '
        ncount=-1
        go to 900
     endif
     go to 1
  endif

  mrs=mrsym
  mrs2=mr2sym

  call graycode(mrsym,63,-1)
  call interleave63(mrsym,-1)
  call interleave63(mrprob,-1)

  call graycode(mr2sym,63,-1)
  call interleave63(mr2sym,-1)
  call interleave63(mr2prob,-1)

  ntrials=10000
  naggressive=10

  ntry=0
  param=0

  call timer('ftrsd   ',0)
  call ftrsd2(mrsym,mrprob,mr2sym,mr2prob,ntrials,correct,param,ntry)
  call timer('ftrsd   ',1)
  ncandidates=param(0)
  nhard=param(1)
  nsoft=param(2)
  nerased=param(3)
  rtt=0.001*param(4)
  ntotal=param(5)
  qual=0.001*param(7)
  nd0=81
  r00=0.87
  if(naggressive.eq.10) then
     nd0=83
     r00=0.90
  endif
  if(ntotal.le.nd0 .and. rtt.le.r00) nft=1
  n=naggressive
  if(nhard.gt.50) nft=0
  if(nhard.gt.h0(n)) nft=0
  if(ntotal.gt.d0(n)) nft=0
  if(rtt.gt.r0(n)) nft=0

  ncount=-1
  decoded='                      '
  ltext=.false.
  if(nft.gt.0) then
! Turn the corrected symbol array into channel symbols for subtraction;
! pass it back to jt65a via common block "chansyms65".
     do i=1,12
        dat4(i)=correct(13-i)
     enddo
     do i=1,63
       itmp(i)=correct(64-i)
     enddo
     correct(1:63)=itmp(1:63)
     call interleave63(correct,1)
     call graycode65(correct,63,1)
     call unpackmsg(dat4,decoded)     !Unpack the user message
     ncount=0
     if(iand(dat4(10),8).ne.0) ltext=.true.
  endif
900 continue
  if(nft.eq.1 .and. nhard.lt.0) decoded='                      '
!  write(81,3001) naggressive,ncandidates,nhard,ntotal,rtt,qual,decoded
!3001 format(i2,i6,i3,i4,2f8.2,2x,a22)

  return
end subroutine extract

subroutine getpp(workdat,p)

  integer workdat(63)
  integer a(63)
  common/test001/s3a(64,63),mrs(63),mrs2(63)

  a(1:63)=workdat(63:1:-1)
  call interleave63(a,1)
  call graycode(a,63,1)

  psum=0.
  do j=1,63
     i=a(j)+1
     x=s3a(i,j)
     s3a(i,j)=0.
     psum=psum + x
     s3a(i,j)=x
  enddo
  p=psum/63.0

  return
end subroutine getpp

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
!-------------------------------------------------------------------------------

program wsprsim

  use wavhdr
  include 'wspr_params.f90'
  type(hdr) hwav
  character arg*12,fname14*14,fname15*15
  character*22 msg,msgsent
  complex   c0(0:NMAX/NDOWN-1)
  complex   c(0:NMAX/NDOWN-1)
  integer   itone(NN)
  integer*2 iwave(NMAX)
  real*8    fMHz

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.8) then
     print*,'Usage:   wsprsim "message"       f0  DT fsp del  nwav nfiles snr'
     print*,'Example: wsprsim "K1ABC FN42 30" 50 0.0 0.1 1.0  1      10   -33'
     go to 999
  endif
  call getarg(1,msg)                     !Message to be transmitted
  call getarg(2,arg)
  read(arg,*) f0                         !Freq relative to WSPR-band center (Hz)
  call getarg(3,arg)
  read(arg,*) xdt                        !Time offset from nominal (s)
  call getarg(4,arg)
  read(arg,*) fspread                    !Watterson frequency spread (Hz)
  call getarg(5,arg)
  read(arg,*) delay                      !Watterson delay (ms)
  call getarg(6,arg)
  read(arg,*) nwav                       !1 for *.wav file, 0 for *.c2 file
  call getarg(7,arg)
  read(arg,*) nfiles                     !Number of files
  call getarg(8,arg)
  read(arg,*) snrdb                      !SNR_2500

  twopi=8.0*atan(1.0)
  fs=12000.0/NDOWN
  dt=1.0/fs
  tt=NSPS*dt
  baud=12000.0/8192.0

  txt=NZ*dt                              !Transmission length (s)
  bandwidth_ratio=2500.0/(fs/2.0)
  sig=sqrt(bandwidth_ratio) * 10.0**(0.05*snrdb)
  if(snrdb.gt.90.0) sig=1.0
  txt=NN*NSPS0/12000.0

  call genwspr(msg,msgsent,itone)       !Encode the message, get itone

  write(*,1000) f0,xdt,txt,snrdb,fspread,delay,nfiles,msgsent
1000 format('f0:',f9.3,'   DT:',f6.2,'   txt:',f6.1,'   SNR:',f6.1,    &
          '   fspread:',f6.1,'   delay:',f6.1,'  nfiles:',i3,2x,a22)
!  write(*,*) "Channel symbols: "
!  write(*,'(162i2)') itone

  h=1.0
  phi=0.0
  c0=0.
  k=-1 + nint(xdt/dt)
  do j=1,NN
     dphi=-twopi*(f0+h*(itone(j)-1.5)*baud)*dt
     do i=1,NSPS
        k=k+1
        phi=mod(phi+dphi,twopi)
        if(k.ge.0 .and. k.lt.NMAX/NDOWN) c0(k)=cmplx(cos(phi),sin(phi))
     enddo
  enddo
  call sgran()
  do ifile=1,nfiles
     c=c0
     if(nwav.eq.0) then
        if( fspread .ne. 0.0 .or. delay .ne. 0.0 ) then
           call watterson(c,NMAX/NDOWN,NN*NSPS,fs,delay,fspread)
        endif
        c=c*sig
        if(snrdb.lt.90) then
           do i=0,NMAX/NDOWN-1                   !Add gaussian noise at specified SNR
              xnoise=gran()
              ynoise=gran()
              c(i)=c(i) + cmplx(xnoise,ynoise)
           enddo
        endif
        write(fname14,1100) ifile
1100    format('000000_',i4.4,'.c2')
        open(10,file=fname14,status='unknown',access='stream')
        fMHz=10.1387d0
        nmin=2
        write(10) fname14,nmin,fMHz,c      !Save to *.c2 file
        close(10)
        write(*,1108) ifile,xdt,f0,snrdb,fname14
1108    format(i4,f7.2,f8.2,f7.1,2x,a14)
     else
        freq=1500.0+f0
        call wspr_wav(baud,xdt,h,freq,itone,snrdb,iwave)
        hwav=default_header(12000,NMAX)
        write(fname15,1102) ifile
1102    format('000000_',i4.4,'.wav')
        open(10,file=fname15,status='unknown',access='stream')
        write(10) hwav,iwave                !Save to *.wav file
        close(10)
        write(*,1110) ifile,xdt,f0,snrdb,fname15
1110    format(i4,f7.2,f8.2,f7.1,2x,a15)
     endif
  enddo

999 end program wsprsim

subroutine indexx(arr,n,indx)

  parameter (M=7,NSTACK=50)
  integer n,indx(n)
  real arr(n)
  integer i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
  real a

  do j=1,n
     indx(j)=j
  enddo

  jstack=0
  l=1
  ir=n
1 if(ir-l.lt.M) then
     do j=l+1,ir
        indxt=indx(j)
        a=arr(indxt)
        do i=j-1,1,-1
           if(arr(indx(i)).le.a) goto 2
           indx(i+1)=indx(i)
        enddo
        i=0
2       indx(i+1)=indxt
     enddo
     if(jstack.eq.0) return

     ir=istack(jstack)
     l=istack(jstack-1)
     jstack=jstack-2

  else
     k=(l+ir)/2
     itemp=indx(k)
     indx(k)=indx(l+1)
     indx(l+1)=itemp

     if(arr(indx(l+1)).gt.arr(indx(ir))) then
        itemp=indx(l+1)
        indx(l+1)=indx(ir)
        indx(ir)=itemp
     endif

     if(arr(indx(l)).gt.arr(indx(ir))) then
        itemp=indx(l)
        indx(l)=indx(ir)
        indx(ir)=itemp
     endif

     if(arr(indx(l+1)).gt.arr(indx(l))) then
        itemp=indx(l+1)
        indx(l+1)=indx(l)
        indx(l)=itemp
     endif

     i=l+1
     j=ir
     indxt=indx(l)
     a=arr(indxt)
3    continue
     i=i+1
     if(arr(indx(i)).lt.a) goto 3

4    continue
     j=j-1
     if(arr(indx(j)).gt.a) goto 4
     if(j.lt.i) goto 5
     itemp=indx(i)
     indx(i)=indx(j)
     indx(j)=itemp
     goto 3

5    indx(l)=indx(j)
     indx(j)=indxt
     jstack=jstack+2
     if(jstack.gt.NSTACK) stop 'NSTACK too small in indexx'
     if(ir-i+1.ge.j-l)then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
     else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
     endif
  endif
  goto 1

end subroutine indexx

subroutine deep65(s3,mode65,neme,flip,mycall,hiscall,hisgrid,decoded,qual)

  use timer_module, only: timer
  parameter (MAXCALLS=10000,MAXRPT=63)
  real s3(64,63)
  character callsign*12,grid*4,message*22,hisgrid*6,c*1,ceme*3
  character*12 mycall,hiscall
  character*22 decoded,bestmsg
  character*22 testmsg(2*MAXCALLS + 2 + MAXRPT)
  character*15 callgrid(MAXCALLS)
  character*180 line
  character*4 rpt(MAXRPT)
  integer ncode(63,2*MAXCALLS + 2 + MAXRPT)
  real pp(2*MAXCALLS + 2 + MAXRPT)
  common/mrscom/ mrs(63),mrs2(63)
  common/c3com/ mcall3a
  data rpt/'-01','-02','-03','-04','-05',          &
           '-06','-07','-08','-09','-10',          &
           '-11','-12','-13','-14','-15',          &
           '-16','-17','-18','-19','-20',          &
           '-21','-22','-23','-24','-25',          &
           '-26','-27','-28','-29','-30',          &
           'R-01','R-02','R-03','R-04','R-05',     &
           'R-06','R-07','R-08','R-09','R-10',     &
           'R-11','R-12','R-13','R-14','R-15',     &
           'R-16','R-17','R-18','R-19','R-20',     &
           'R-21','R-22','R-23','R-24','R-25',     &
           'R-26','R-27','R-28','R-29','R-30',     &
           'RO','RRR','73'/
  save

  if(mcall3a.eq.0) go to 30

  call timer('deep65a ',0)
  mcall3a=0
  rewind 23
  k=0
  icall=0
  do n=1,MAXCALLS
     if(n.eq.1) then
        callsign=hiscall
        do i=4,12
           if(ichar(callsign(i:i)).eq.0) callsign(i:i)=' '
        enddo
        grid=hisgrid(1:4)
        if(ichar(grid(3:3)).eq.0) grid(3:3)=' '
        if(ichar(grid(4:4)).eq.0) grid(4:4)=' '
     else
        read(23,1002,end=20) line
1002    format (A80)
        if(line(1:4).eq.'ZZZZ') go to 20
        if(line(1:2).eq.'//') go to 10
        i1=index(line,',')
        if(i1.lt.4) go to 10
        i2=index(line(i1+1:),',')
        if(i2.lt.5) go to 10
        i2=i2+i1
        i3=index(line(i2+1:),',')
        if(i3.lt.1) i3=index(line(i2+1:),' ')
        i3=i2+i3
        callsign=line(1:i1-1)
        grid=line(i1+1:i2-1)
        ceme=line(i2+1:i3-1)
        if(neme.eq.1 .and. ceme.ne.'EME') go to 10
     endif

     icall=icall+1
     j1=index(mycall,' ') - 1
     if(j1.le.-1) j1=12
     if(j1.lt.3) j1=6
     j2=index(callsign,' ') - 1
     if(j2.le.-1) j2=12
     if(j2.lt.3) j2=6
     j3=index(mycall,'/')                 ! j3>0 means compound mycall
     j4=index(callsign,'/')               ! j4>0 means compound hiscall
     callgrid(icall)=callsign(1:j2)

     mz=1
! Allow MyCall + HisCall + rpt (?)
     if(n.eq.1 .and. j3.lt.1 .and. j4.lt.1 .and. callsign(1:6).ne.'      ')  &
          mz=MAXRPT+1
     do m=1,mz
        if(m.gt.1) grid=rpt(m-1)
        if(j3.lt.1 .and.j4.lt.1) callgrid(icall)=callsign(1:j2)//' '//grid
        message=mycall(1:j1)//' '//callgrid(icall)
        k=k+1
        testmsg(k)=message
        call encode65(message,ncode(1,k))
        
! Insert CQ message
        if(j4.lt.1) callgrid(icall)=callsign(1:j2)//' '//grid
        message='CQ '//callgrid(icall)
        k=k+1
        testmsg(k)=message
        call encode65(message,ncode(1,k))
     enddo
10   continue
  enddo

20 continue
  ntot=k
  call timer('deep65a ',1)

30 continue
  call timer('deep65b ',0)
  ref0=0.
  do j=1,63
     ref0=ref0 + s3(mrs(j),j)
  enddo

  p1=-1.e30
  do k=1,ntot
     pp(k)=0.
     if(k.ge.2 .and. k.le.64 .and. flip.lt.0.0) cycle
! Test all messages if flip=+1; skip the CQ messages if flip=-1.
     if(flip.gt.0.0 .or. testmsg(k)(1:3).ne.'CQ ') then
        sum=0.
        ref=ref0
        do j=1,63
           i=ncode(j,k)+1
           sum=sum + s3(i,j)
           if(i.eq.mrs(j)) ref=ref - s3(i,j) + s3(mrs2(j),j)
        enddo
        p=sum/ref
        pp(k)=p
        if(p.gt.p1) then
           p1=p
           ip1=k
           bestmsg=testmsg(k)
        endif
     endif
  enddo

  p2=-1.e30
  do i=1,ntot
     if(pp(i).gt.p2 .and. testmsg(i).ne.bestmsg) p2=pp(i)
  enddo

  if(mode65.eq.1) bias=max(1.12*p2,0.335)
  if(mode65.eq.2) bias=max(1.08*p2,0.405)
  if(mode65.ge.4) bias=max(1.04*p2,0.505)

  if(p2.eq.p1 .and. p1.ne.-1.e30) then
     open(77,file='error.log',status='unknown',access='append')
     write(77,*) p1,p2,ip1,bestmsg
     close(77)
  endif

  qual=100.0*(p1-bias)

  decoded='                      '
  c=' '

  if(qual.gt.1.0) then
     if(qual.lt.6.0) c='?'
     decoded=testmsg(ip1)
  else
     qual=0.
  endif
  decoded(22:22)=c

! Make sure everything is upper case.
  do i=1,22
     if(decoded(i:i).ge.'a' .and. decoded(i:i).le.'z')                &
          decoded(i:i)=char(ichar(decoded(i:i))-32)
  enddo
  call timer('deep65b ',1)

  return
end subroutine deep65

subroutine sfox_wave(fname)

! Called by WSJT-X when it's time for SuperFox to transmit.  Reads array
! itone(1:151) from disk file 'sfox_2.dat' in the writable data directory.

  parameter (NWAVE=(160+2)*134400*4) !Max WSJT-X waveform (FST4-1800 at 48kHz)
  parameter (NN=151,NSPS=1024)
  character*(*) fname
  integer itone(151)
  real*8 dt,twopi,f0,baud,phi,dphi

  common/foxcom/wave(NWAVE)

  wave=0.
  open(25,file=trim(fname),status='unknown',err=999)
  read(25,'(20i4)',err=999,end=999) itone
  close(25)
  if(itone(1).lt.0 .or. itone(1).gt.128) go to 999

! Generate the SuperFox waveform.

  dt=1.d0/48000.d0
  twopi=8.d0*atan(1.d0)
  f0=750.0d0
  phi=0.d0
  baud=12000.d0/NSPS
  k=0
  do j=1,NN
     f=f0 + baud*mod(itone(j),128)
     dphi=twopi*f*dt
     do ii=1,4*NSPS
        k=k+1
        phi=phi+dphi
        xphi=phi
        wave(k)=sin(xphi)
     enddo
  enddo

999 return
end subroutine sfox_wave

subroutine save_echo_params(nDopTotal,nDopAudio,nfrit,f1,fspread,id2,idir)

  integer*2 id2(10)
  integer*2 id2a(10)
  equivalence (nDopTotal0,id2a(1))
  equivalence (nDopAudio0,id2a(3))
  equivalence (nfrit0,id2a(5))
  equivalence (f10,id2a(7))
  equivalence (fspread0,id2a(9))

  if(idir.gt.0) then
     nDopTotal0=nDopTotal
     nDopAudio0=nDopAudio
     nfrit0=nfrit
     f10=f1
     fspread0=fspread
     id2=id2a
  else
     id2a=id2
     id2(1:10)=0
     nDopTotal=nDopTotal0
     nDopAudio=nDopAudio0
     nfrit=nfrit0
     f1=f10
     fspread=fspread0
  endif

  return
end subroutine save_echo_params

subroutine astro(nyear,month,nday,uth,freq8,Mygrid,                    &
          NStation,MoonDX,AzSun,ElSun,AzMoon0,ElMoon0,                 &
          ntsky,doppler00,doppler,dbMoon,RAMoon,DecMoon,HA,Dgrd,sd,    &
          poloffset,xnr,day,lon,lat,LST,techo)

! Computes astronomical quantities for display and tracking.
! NB: may want to smooth the Tsky map to 10 degrees or so.

  character*6 MyGrid,HisGrid
  real*8 freq8
  real LST
  real lat,lon
  integer*2 nt144(180)

!      common/echo/xdop(2),techo,AzMoon,ElMoon,mjd
  real xdop(2)

  data rad/57.2957795/
  data nt144/                                             &
       234, 246, 257, 267, 275, 280, 283, 286, 291, 298,  &
       305, 313, 322, 331, 341, 351, 361, 369, 376, 381,  &
       383, 382, 379, 374, 370, 366, 363, 361, 363, 368,  &
       376, 388, 401, 415, 428, 440, 453, 467, 487, 512,  &
       544, 579, 607, 618, 609, 588, 563, 539, 512, 482,  &
       450, 422, 398, 379, 363, 349, 334, 319, 302, 282,  &
       262, 242, 226, 213, 205, 200, 198, 197, 196, 197,  &
       200, 202, 204, 205, 204, 203, 202, 201, 203, 206,  &
       212, 218, 223, 227, 231, 236, 240, 243, 247, 257,  &
       276, 301, 324, 339, 346, 344, 339, 331, 323, 316,  &
       312, 310, 312, 317, 327, 341, 358, 375, 392, 407,  &
       422, 437, 451, 466, 480, 494, 511, 530, 552, 579,  &
       612, 653, 702, 768, 863,1008,1232,1557,1966,2385,  &
      2719,2924,3018,3038,2986,2836,2570,2213,1823,1461,  &
      1163, 939, 783, 677, 602, 543, 494, 452, 419, 392,  &
       373, 360, 353, 350, 350, 350, 350, 350, 350, 348,  &
       344, 337, 329, 319, 307, 295, 284, 276, 272, 272,  &
       273, 274, 274, 271, 266, 260, 252, 245, 238, 231/
  save

  call grid2deg(MyGrid,elon,lat)
  lon=-elon
  call sun(nyear,month,nday,uth,lon,lat,RASun,DecSun,LST,      &
       AzSun,ElSun,mjd,day)

  call MoonDopJPL(nyear,month,nday,uth,lon,lat,RAMoon,DecMoon,    &
       LST,HA,AzMoon,ElMoon,vr,techo)
  RAMoon=rad*RAMoon
  DecMoon=rad*DecMoon
  dist=2.99792458d5*techo/2.d0

! Compute spatial polarization offset
  xx=sin(lat/rad)*cos(ElMoon/rad) - cos(lat/rad)*              &
       cos(AzMoon/rad)*sin(ElMoon/rad)
  yy=cos(lat/rad)*sin(AzMoon/rad)
  if(NStation.eq.1) poloffset1=rad*atan2(yy,xx)
  if(NStation.eq.2) poloffset2=rad*atan2(yy,xx)

  doppler=-freq8*vr/2.99792458e5                 !One-way Doppler

  call coord(0.,0.,-1.570796,1.161639,RAMoon/rad,DecMoon/rad,el,eb)
  longecl_half=nint(rad*el/2.0)
  if(longecl_half.lt.1 .or. longecl_half.gt.180) longecl_half=180
  t144=nt144(longecl_half)
  tsky=(t144-2.7)*(144.0d6/freq8)**2.6 + 2.7      !Tsky for obs freq

  xdop(NStation)=doppler
  if(NStation.eq.2) then
     HisGrid=MyGrid
     go to 900
  endif

  doppler00=2.0*xdop(1)
  doppler=xdop(1)+xdop(2)
!      if(mode.eq.3) doppler=2.0*xdop(1)
  dBMoon=-40.0*log10(dist/356903.)
  sd=16.23*370152.0/dist

!      if(NStation.eq.1 .and. MoonDX.ne.0 .and. 
!     +    (mode.eq.2 .or. mode.eq.5)) then
  if(NStation.eq.1 .and. MoonDX.ne.0) then
     poloffset=mod(poloffset2-poloffset1+720.0,180.0)
     if(poloffset.gt.90.0) poloffset=poloffset-180.0
     x1=abs(cos(2*poloffset/rad))
     if(x1.lt.0.056234) x1=0.056234
     xnr=-20.0*log10(x1)
     if(HisGrid(1:1).lt.'A' .or. HisGrid(1:1).gt.'R') xnr=0
  endif

  tr=80.0                              !Good preamp
  tskymin=13.0*(408.0d6/freq8)**2.6      !Cold sky temperature
  tsysmin=tskymin+tr
  tsys=tsky+tr
  dgrd=-10.0*log10(tsys/tsysmin) + dbMoon
900 AzMoon0=Azmoon
  ElMoon0=Elmoon
  ntsky=nint(tsky)

!      auxHA = 15.0*(LST-auxra)                       !HA in degrees
!      pi=3.14159265
!      pio2=0.5*pi
!      call coord(pi,pio2-lat/rad,0.0,lat/rad,auxha*pi/180.0,
!     +  auxdec/rad,azaux,elaux)
!      AzAux=azaux*rad
!      ElAux=ElAux*rad

  return
end subroutine astro

program ft8_a8_test

! Aid for testing "a8" decodes -- those based on known MyCall, DXcall, and DXgrid.

  use wavhdr
  use ft8_a7
  include 'ft8_params.f90'           !Set various constants
  type(hdr) h                        !Header for .wav file
  character arg*12,fname*120
  character mycall*12,dxcall*12,dxgrid*6
  character*37 msgbest
  character*4 apflag
  integer*2 iwave(NMAX)              !Raw data from a *.wav file, fsample = 12000 Hz
  real dd(NMAX)                      !Floating point copy of iwave

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.lt.6) then
     print*,'Usage:   ft8_a8_test MyCall DXcall DXgrid  f1 ndepth    fname [...]'
     print*,'Example: ft8_a8_test  W3SZ  DL3WDG  JN68  1500  3  250804_120500.wav'
     go to 999
  endif
  call getarg(1,mycall)                  !Message to be transmitted
  call getarg(2,dxcall)
  call getarg(3,dxgrid)
  call getarg(4,arg)
  read(arg,*) f1                         !Expected Rx Freq
  call getarg(5,arg)
  read(arg,*) ndepth                     !Decoding depth

  do ifile=1,nargs-5
     call getarg(ifile+5,fname)                   !File name for *.wav data
     open(10,file=trim(fname),status='old',access='stream')
     read(10) h,iwave
     fac=1.0/32767.0
     dd=fac*iwave

     call ft8_a8d(dd,mycall,dxcall,dxgrid,f1,xdt,fbest,xsnr,plog,msgbest)

     apflag='  a8'
     if(plog.lt.-155) apflag(1:1)='?'
     if(len(trim(msgbest)).eq.0) apflag='    '
     write(*,1100) ifile,xdt,fbest,xsnr,plog,msgbest,apflag
1100 format(i4,f6.2,3f7.1,1x,a37,a4)
  enddo

999 end program ft8_a8_test

subroutine decode0(dd,ss,savg)

  use timer_module, only: timer
  parameter (NSMAX=60*96000,NFFT=32768)

  real*4 dd(2,NSMAX),ss(400,NFFT),savg(NFFT)
  real*8 fcenter
  integer offset
  integer hist(0:32768)
  logical*1 bAlso30
  character mycall*12,hiscall*12,mygrid*6,hisgrid*6,datetime*20
  character mycall0*12,hiscall0*12,hisgrid0*6
  character*64 result
  common/decodes/ndecodes,ncand2,nQDecoderDone,nWDecoderBusy,              &
       nWTransmitting,kHzRequested,result(50)
  common/npar/fcenter,nutc,fselected,mousedf,mousefqso,nagain,            &
       ndepth,ndiskdat,ntx60,newdat,nfa,nfb,nfcal,nfshift,                &
       ntx30a,ntx30b,ntol,n60,nCFOM,nfsample,ndop58,nmode,                 &
       ndop00,nsave,max_drift,offset,nhsym,mycall,mygrid,                 &
       hiscall,hisgrid,datetime,junk1,junk2,bAlso30
  save

  nQDecoderDone=0
  if(newdat.ne.0) then
     nz=96000*nhsym*0.15
     hist=0
     do i=1,nz
        j1=min(abs(dd(1,i)),32768.0)
        hist(j1)=hist(j1)+1
        j2=min(abs(dd(2,i)),32768.0)
        hist(j2)=hist(j2)+1
     enddo
     m=0
     do i=0,32768
        m=m+hist(i)
        if(m.ge.2*nz) go to 10
     enddo
10   rmsdd=1.5*i
  endif
      
  mycall0=mycall
  hiscall0=hiscall
  hisgrid0=hisgrid

  call timer('qmapa   ',0)
  call qmapa(dd,ss,savg,newdat,nutc,fcenter,ntol,nfa,nfb,                  &
       mousedf,mousefqso,nagain,ntx30a,ntx30b,nfshift,max_drift,offset,    &
       nfcal,mycall,hiscall,hisgrid,nfsample,nmode,ndepth,                 &
       datetime,ndop00,fselected,bAlso30,nhsym,NCFOM)
  call timer('qmapa   ',1)

  return
end subroutine decode0

subroutine unpackpfx(ng,call1)

  character*12 call1
  character*3 pfx

  if(ng.lt.60000) then
! Add-on prefix of 1 to 3 characters
     n=ng
     do i=3,1,-1
        nc=mod(n,37)
        if(nc.ge.0 .and. nc.le.9) then
           pfx(i:i)=char(nc+48)
        else if(nc.ge.10 .and. nc.le.35) then
           pfx(i:i)=char(nc+55)
        else
           pfx(i:i)=' '
        endif
        n=n/37
     enddo
     call1=pfx//'/'//call1
     if(call1(1:1).eq.' ') call1=call1(2:)
     if(call1(1:1).eq.' ') call1=call1(2:)
  else
! Add-on suffix, one character
     i1=index(call1,' ')
     nc=ng-60000
     if(nc.ge.0 .and. nc.le.9) then
        call1=call1(:i1-1)//'/'//char(nc+48)
     else if(nc.ge.10 .and. nc.le.35) then
        call1=call1(:i1-1)//'/'//char(nc+55)
     endif
  endif

  return
end subroutine unpackpfx

subroutine wqencode(msg,ntype,data0)

!  Parse and encode a WSPR message.

  use packjt
  parameter (MASK15=32767)
  character*22 msg
  character*12 call1,call2
  character grid4*4
  logical lbad1,lbad2
  integer*1 data0(11)
  integer nu(0:9)
  data nu/0,-1,1,0,-1,2,1,0,-1,1/

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  i1=index(msg,' ')
  i2=index(msg,'/')
  i3=index(msg,'<')
  call1=msg(:i1-1)
  if(i1.lt.3 .or. i1.gt.7 .or. i2.gt.0 .or. i3.gt.0) go to 10
  grid4=msg(i1+1:i1+4)
  call packcall(call1,n1,lbad1)
  call packgrid(grid4,ng,lbad2)
  if(lbad1 .or. lbad2) go to 10
  ndbm=0
  read(msg(i1+5:),*) ndbm
  if(ndbm.lt.0) ndbm=0
  if(ndbm.gt.60) ndbm=60
  ndbm=ndbm+nu(mod(ndbm,10))
  n2=128*ng + (ndbm+64)
  call pack50(n1,n2,data0)
  ntype=ndbm
  go to 900

10 if(i2.ge.2 .and. i3.lt.1) then
     call packpfx(call1,n1,ng,nadd)
     ndbm=0
     read(msg(i1+1:),*) ndbm
     if(ndbm.lt.0) ndbm=0
     if(ndbm.gt.60) ndbm=60
     ndbm=ndbm+nu(mod(ndbm,10))
     ntype=ndbm + 1 + nadd
     n2=128*ng + ntype + 64
     call pack50(n1,n2,data0)
  else if(i3.eq.1) then
     i4=index(msg,'>')
     call1=msg(2:i4-1)
     call hash(call1,i4-2,ih)
     i5=index(trim(msg(i1+1:)),' ')
! Convert grid to valid callsign format - first character moved to end
     call2=msg(i1+2:i1+i5-1)//msg(i1+1:i1+1)//'        '
     call packcall(call2,n1,lbad1)
     ndbm=0
     read(msg(i1+i5+1:),*) ndbm
     if(ndbm.lt.0) ndbm=0
     if(ndbm.gt.60) ndbm=60
     ndbm=ndbm+nu(mod(ndbm,10))
     ntype=-(ndbm+1)
     n2=128*ih + ntype + 64
     call pack50(n1,n2,data0)
  endif
900 continue
  
  return
end subroutine wqencode

subroutine bpdecode240_101(llr,apmask,maxiterations,message101,cw,nharderror,iter,ncheck)
!
! A log-domain belief propagation decoder for the (240,101) code.
!
   integer, parameter:: N=240, K=101, M=N-K
   integer*1 cw(N),apmask(N)
   integer*1 decoded(K)
   integer*1 message101(101)
   integer nrw(M),ncw
   integer Nm(6,M)
   integer Mn(3,N)  ! 3 checks per bit
   integer synd(M)
   real tov(3,N)
   real toc(6,M)
   real tanhtoc(6,M)
   real zn(N)
   real llr(N)
   real Tmn

   include "ldpc_240_101_parity.f90"

   decoded=0
   toc=0
   tov=0
   tanhtoc=0
! initialize messages to checks
   do j=1,M
      do i=1,nrw(j)
         toc(i,j)=llr((Nm(i,j)))
      enddo
   enddo

   ncnt=0
   nclast=0
   do iter=0,maxiterations
! Update bit log likelihood ratios (tov=0 in iteration 0).
      do i=1,N
         if( apmask(i) .ne. 1 ) then
            zn(i)=llr(i)+sum(tov(1:ncw,i))
         else
            zn(i)=llr(i)
         endif
      enddo

! Check to see if we have a codeword (check before we do any iteration).
      cw=0
      where( zn .gt. 0. ) cw=1
      ncheck=0
      do i=1,M
         synd(i)=sum(cw(Nm(1:nrw(i),i)))
         if( mod(synd(i),2) .ne. 0 ) ncheck=ncheck+1
! if( mod(synd(i),2) .ne. 0 ) write(*,*) 'check ',i,' unsatisfied'
      enddo
      if( ncheck .eq. 0 ) then ! we have a codeword - if crc is good, return it
         decoded=cw(1:101)
         call get_crc24(decoded,101,nbadcrc)
         nharderror=count( (2*cw-1)*llr .lt. 0.0 )
         if(nbadcrc.eq.0) then
            message101=decoded(1:101)
            return
         endif
      endif

      if( iter.gt.0 ) then  ! this code block implements an early stopping criterion
!  if( iter.gt.10000 ) then  ! this code block implements an early stopping criterion
         nd=ncheck-nclast
         if( nd .lt. 0 ) then ! # of unsatisfied parity checks decreased
            ncnt=0  ! reset counter
         else
            ncnt=ncnt+1
         endif
!    write(*,*) iter,ncheck,nd,ncnt
         if( ncnt .ge. 5 .and. iter .ge. 10 .and. ncheck .gt. 15) then
            nharderror=-1
            return
         endif
      endif
      nclast=ncheck

! Send messages from bits to check nodes
      do j=1,M
         do i=1,nrw(j)
            ibj=Nm(i,j)
            toc(i,j)=zn(ibj)
            do kk=1,ncw ! subtract off what the bit had received from the check
               if( Mn(kk,ibj) .eq. j ) then
                  toc(i,j)=toc(i,j)-tov(kk,ibj)
               endif
            enddo
         enddo
      enddo

! send messages from check nodes to variable nodes
      do i=1,M
         tanhtoc(1:6,i)=tanh(-toc(1:6,i)/2)
      enddo

      do j=1,N
         do i=1,ncw
            ichk=Mn(i,j)  ! Mn(:,j) are the checks that include bit j
            Tmn=product(tanhtoc(1:nrw(ichk),ichk),mask=Nm(1:nrw(ichk),ichk).ne.j)
            call platanh(-Tmn,y)
!      y=atanh(-Tmn)
            tov(i,j)=2*y
         enddo
      enddo

   enddo
   nharderror=-1
   return
end subroutine bpdecode240_101

subroutine subtract65(dd,npts,f0,dt)

! Subtract a jt65 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  use packjt
  use timer_module, only: timer

  integer correct(63)
  parameter (NMAX=60*12000) !Samples per 60 s
  parameter (NFILT=1600)
  real*4  dd(NMAX), window(-NFILT/2:NFILT/2)
  complex cref,camp,cfilt,cw
  integer nprc(126)
  real*8 dphi,phi
  logical first
  data nprc/                                   &
    1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0, &
    0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1, &
    0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1, &
    0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1, &
    1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1, &
    0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1, &
    1,1,1,1,1,1/
  data first/.true./
  common/chansyms65/correct
  common/heap1/cref(NMAX),camp(NMAX),cfilt(NMAX),cw(NMAX)
  save first

  pi=4.0*atan(1.0)

! Symbol duration is 4096/11025 s.
! Sample rate is 12000/s, so 12000*(4096/11025)=4458.23 samples/symbol.
! For now, call it 4458 samples/symbol. Over the message duration, we'll be off
! by about (4458.23-4458)*126=28.98 samples; 29 samples, or 0.7% of 1 symbol.
! Could eliminate accumulated error by injecting one extra sample every
! 5 or so symbols... Maybe try this later.

  nstart=dt*12000+1;
  nsym=126
  ns=4458 
  nref=nsym*ns
  nend=nstart+nref-1
  phi=0.0
  iref=1
  ind=1
  isym=1
  call timer('subtr_1 ',0)
  do k=1,nsym
    if( nprc(k) .eq. 1 ) then
        omega=2*pi*f0
    else
        omega=2*pi*(f0+2.6917*(correct(isym)+2))
        isym=isym+1
    endif
    dphi=omega/12000.0
    do i=1,ns
        cref(ind)=cexp(cmplx(0.0,phi))
        phi=modulo(phi+dphi,2*pi)
        id=nstart-1+ind
        if(id.ge.1) camp(ind)=dd(id)*conjg(cref(ind))
        ind=ind+1
     enddo
  enddo
  call timer('subtr_1 ',1)

  call timer('subtr_2 ',0)
! Smoothing filter: do the convolution by means of FFTs. Ignore end-around 
! cyclic effects for now.

  nfft=564480

  if(first) then
! Create and normalize the filter
     sum=0.0
     do j=-NFILT/2,NFILT/2
        window(j)=cos(pi*j/NFILT)**2
        sum=sum+window(j)
     enddo
     cw=0.
     do i=-NFILT/2,NFILT/2
        j=i+1
        if(j.lt.1) j=j+nfft
        cw(j)=window(i)/sum
     enddo
     call four2a(cw,nfft,1,-1,1)
     first=.false.
  endif

  nz=561708
  cfilt(1:nz)=camp(1:nz)
  cfilt(nz+1:nfft)=0.
  call four2a(cfilt,nfft,1,-1,1)
  fac=1.0/float(nfft)
  cfilt(1:nfft)=fac*cfilt(1:nfft)*cw(1:nfft)
  call four2a(cfilt,nfft,1,1,1)
  call timer('subtr_2 ',1)

! Subtract the reconstructed signal
  call timer('subtr_3 ',0)
  do i=1,nref
     j=nstart+i-1
     if(j.ge.1 .and. j.le.npts) dd(j)=dd(j)-2*REAL(cfilt(i)*cref(i))
  enddo
  call timer('subtr_3 ',1)

  return
end subroutine subtract65 

module geocentric_mod
  use iso_fortran_env, only: real64
  implicit none
contains
  subroutine geocentric(alat,elev,hlt,erad)
    implicit none
    real(real64), intent(in)  :: alat, elev
    real(real64), intent(out) :: hlt, erad  
    real(real64) :: f, a_radius, c, arcf, arsf
  
  ! IAU 1976 flattening f, equatorial radius a
    f = 1.d0/298.257d0
    a_radius = 6378140.d0
    c = 1.d0/sqrt(1.d0 + (-2.d0 + f)*f*sin(alat)*sin(alat))
    arcf = (a_radius*c + elev)*cos(alat)
    arsf = (a_radius*(1.d0 - f)*(1.d0 - f)*c + elev)*sin(alat)
    hlt = atan2(arsf,arcf)
    erad = sqrt(arcf*arcf + arsf*arsf)
    erad = 0.001d0*erad
  
  end subroutine geocentric
end module geocentric_mod

subroutine ft8mf1var(s8,itone,msgd,msg37,lft8sd)

  use ft8_mod1, only : itone76,idtone76,msgsd76
  real, intent(in) :: s8(0:7,79)
  real s8d(0:7,58)
  character msgd*37,msg37*37,msggrid*37,c1*12,c2*12,grid*4
  integer itone(79),mrs(58),mrs2(58)
  logical(1) lft8sd,lr73,lgrid,lreport,lrreport,lrrr

  lr73=.false.; lgrid=.false.; lreport=.false.; lrreport=.false.; lrrr=.false.
  c1='            '; c2='            '
  ispc1=index(msgd,' '); ispc2=index(msgd((ispc1+1):),' ')+ispc1; ispc3=index(msgd((ispc2+1):),' ')+ispc2
  if(len(msgd(1:ispc1-1)).le.12 .and. len(msgd(ispc1+1:ispc2-1)).le.12) then
    c1=msgd(1:ispc1-1); c2=msgd(ispc1+1:ispc2-1)
  else
    return
  endif
  if(len_trim(c1).lt.3 .or. len_trim(c2).lt.3) return
  if(msgd(ispc2+1:ispc3-1).eq.'RR73' .or. msgd(ispc2+1:ispc3-1).eq.'73') lr73=.true.
  if(.not.lr73 .and. (ispc3-ispc2).eq.5 .and. msgd(ispc2+1:ispc2+2).ne.'R+' .and. msgd(ispc2+1:ispc2+2).ne.'R-') &
    lgrid=.true.
  if(msgd(ispc2+1:ispc2+1).eq.'+' .or. msgd(ispc2+1:ispc2+1).eq.'-') lreport=.true.
  if(msgd(ispc2+1:ispc2+2).eq.'R+' .or. msgd(ispc2+1:ispc2+2).eq.'R-') lrreport=.true.
  if(msgd(ispc2+1:ispc3-1).eq.'RRR') lrrr=.true.

  thresh=0.0; i1=0; i2=0
  do i=1,58; if(i.le.29) then; s8d(0:7,i)=s8(0:7,i+7); else; s8d(0:7,i)=s8(0:7,i+14); endif; enddo
  do j=1,58
    s1=-1.0E6; s2=-1.0E6
    do i=0,7; if(s8d(i,j).gt.s1) then; s1=s8d(i,j); i1=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. s8d(i,j).gt.s2) then; s2=s8d(i,j); i2=i; endif; enddo
    mrs(j)=i1; mrs2(j)=i2
  enddo
  ref0=0.0
  do i=1,58; ref0=ref0 + s8d(mrs(i),i); enddo

  ipk=0; u1=0.0; u2=0.0
  do k=1,76
    psum=0.; ref=ref0
    do j=1,58; i3=idtone76(k,j); psum=psum + s8d(i3,j); if(i3.eq.mrs(j)) ref=ref - s8d(i3,j) + s8d(mrs2(j),j); enddo
    p=psum/ref
    if(p.gt.u1) then; u2=u1; u1=p; ipk=k
    else; if(p.gt.u2) u2=p
    endif
  enddo
!/'+09 ','+08 ','+07 ','+06 ','+05 ','+04 ','+03 ','+02 ','+01 ','+00 ', &
! '-01 ','-02 ','-03 ','-04 ','-05 ','-06 ','-07 ','-08 ','-09 ','-10 ', &
! '-11 ','-12 ','-13 ','-14 ','-15 ','-16 ','-17 ','-18 ','-19 ','-20 ', &
! '-21 ','-22 ','-23 ','-24 ','-25 ','-26 ','R+09','R+08','R+07','R+06', &
! 'R+05','R+04','R+03','R+02','R+01','R+00','R-01','R-02','R-03','R-04', &
! 'R-05','R-06','R-07','R-08','R-09','R-10','R-11','R-12','R-13','R-14', &
! 'R-15','R-16','R-17','R-18','R-19','R-20','R-21','R-22','R-23','R-24', &
! 'R-25','R-26','RRR ','RR73','73  ','AA00'/
  if(ipk.ne.0) then
    if(lgrid) then
      if(ipk.eq.76) then
        msggrid=msgsd76(76)
        ispc1=index(msggrid,' '); ispc2=index(msggrid((ispc1+1):),' ')+ispc1; ispc3=index(msggrid((ispc2+1):),' ')+ispc2
        grid=msggrid(ispc2+1:ispc3-1)
        if(grid.eq.'AA00') return
      endif
      if(ipk.lt.37 .or. (ipk.gt.72 .and. ipk.lt.76)) return
    endif
    if(lreport) then; if((ipk.gt.36 .and. ipk.lt.73) .or. ipk.eq.76) return; endif
    if(lrreport) then; if(ipk.lt.37 .or. ipk.eq.73 .or. ipk.eq.76) return; endif
    if(lrrr) then; if(ipk.lt.73 .or. ipk.eq.76) return; endif
    if(lr73) then; if(ipk.lt.74 .or. ipk.eq.76) return; endif

    qual=100.0*(u1-u2)
    thresh=(qual+10.0)*(u1-0.6)
    if(thresh.gt.4.0 .and. qual.gt.2.6 .and. u1.gt.0.77) then
!print *,'matched',thresh
!print *,msgsd76(ipk)
!      if(trim(msgsd76(ipk)).eq.'CQ DE AA00') return ! triggered by memory corruption?
      lft8sd=.true.; msg37=msgsd76(ipk); itone(1:79)=itone76(ipk,1:79); return
    endif
  endif

  return
end subroutine ft8mf1var

module jt65_mod9 
! stores callsign DB in memory for false decodes checking
  
  parameter (MAXC=200000)
! supporting 7-char Australian callsigns
  character*7 call0c(11500),calld(11100),callef(9000),callgh(7500),calli(7600),callj(10000),callk(24000),calllm(6500), &
              calln(9400),callo(6700),callpq(5800),callr(6500),callst(7500),calluv(10400),callw(13700),callxz(5800)
  character callsign*12
  character*180 line
  integer ncall0c,ncalld,ncallef,ncallgh,ncalli,ncallj,ncallk,ncalllm,ncalln,ncallo,ncallpq,ncallr,ncallst,ncalluv, &
          ncallw,ncallxz
  logical ldbvalid
  data ldbvalid/.true./
  data ncall0c,ncalld,ncallef,ncallgh,ncalli,ncallj,ncallk,ncalllm,ncalln,ncallo,ncallpq,ncallr,ncallst,ncalluv,ncallw, &
       ncallxz/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/

end module jt65_mod9

!callj dim was 9000; increased 20250709 to accommodate size of new ALLCALL7.TXT file dated 20250619

subroutine encode174(message,codeword)
! Encode an 87-bit message and return a 174-bit codeword. 
! The generator matrix has dimensions (87,87). 
! The code is a (174,87) regular ldpc code with column weight 3.
! The code was generated using the PEG algorithm.
! After creating the codeword, the columns are re-ordered according to 
! "colorder" to make the codeword compatible with the parity-check matrix 
!

include "ldpc_174_87_params.f90"

integer*1 codeword(N)
integer*1 gen(M,K)
integer*1 itmp(N)
integer*1 message(K)
integer*1 pchecks(M)
logical first
data first/.true./

save first,gen

if( first ) then ! fill the generator matrix
  gen=0
  do i=1,M
    do j=1,11
      read(g(i)( (j-1)*2+1:(j-1)*2+2 ),"(Z2)") istr
        do jj=1, 8
          icol=(j-1)*8+jj
          if( icol .le. 87 ) then
            if( btest(istr,8-jj) ) gen(i,icol)=1
          endif
        enddo
    enddo
  enddo
first=.false.
endif

do i=1,M
  nsum=0
  do j=1,K 
    nsum=nsum+message(j)*gen(i,j)
  enddo
  pchecks(i)=mod(nsum,2)
enddo
itmp(1:M)=pchecks
itmp(M+1:N)=message(1:K)
codeword(colorder+1)=itmp(1:N)

return
end subroutine encode174

subroutine ft8q3(cd,xdt,f0,call_1,call_2,grid4,msgbest,snr)

! Get q3-style decodes for FT8.

  use packjt77
  parameter(NN=79,NSPS=32)
  parameter(NWAVE=NN*NSPS)               !2528
  parameter(NZ=3200,NLAGS=NZ-NWAVE)
  character*12 call_1,call_2
  character*4 grid4
  character*37 msg,msgbest,msgsent
  character c77*77
  complex cwave(0:NWAVE-1)
  complex cd(0:NZ-1)
  complex z
  real xjunk(NWAVE)
  real ccf(0:NLAGS-1)
  real ccfmsg(206)
  integer itone(NN)
  integer*1 msgbits(77)
  logical std_1,std_2

  if(xdt.eq.-99.0) return                !Silence compiler warning
  call stdcall(call_1,std_1)
  call stdcall(call_2,std_2)

  fs=200.0                               !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  bt=2.0
  ccfbest=0.
  lagbest=-1

  do imsg=1,206
     msg=trim(call_1)//' '//trim(call_2)
     i=imsg
     if(.not.std_1) then
        if(i.eq.1 .or. i.ge.6)  msg='<'//trim(call_1)//'> '//trim(call_2)
        if(i.ge.2 .and. i.le.4) msg=trim(call_1)//' <'//trim(call_2)//'>'
     else if(.not.std_2) then
        if(i.le.4 .or. i.eq.6) msg='<'//trim(call_1)//'> '//trim(call_2)
        if(i.ge.7) msg=trim(call_1)//' <'//trim(call_2)//'>'
     endif
     j0=len(trim(msg))+2
     if(i.eq.2) msg(j0:j0+2)='RRR'
     if(i.eq.3) msg(j0:j0+3)='RR73'
     if(i.eq.4) msg(j0:j0+1)='73'
     if(i.eq.5) then
        if(std_2) msg='CQ '//trim(call_2)//' '//grid4
        if(.not.std_2) msg='CQ '//trim(call_2)
     endif
     if(i.eq.6 .and. std_2) msg(j0:j0+3)=grid4
     if(i.ge.7 .and. i.le.206) then
        isnr = -50 + (i-7)/2
        if(iand(i,1).eq.1) then
           write(msg(j0:j0+2),'(i3.2)') isnr
           if(msg(j0:j0).eq.' ') msg(j0:j0)='+'
        else
           write(msg(j0:j0+3),'("R",i3.2)') isnr
           if(msg(j0+1:j0+1).eq.' ') msg(j0+1:j0+1)='+'
        endif
     endif

! Source-encode, then get itone()
     i3=-1
     n3=-1
     call pack77(msg,i3,n3,c77)
     call genft8(msg,i3,n3,msgsent,msgbits,itone)
! Generate complex cwave
     call gen_ft8wave(itone,NN,NSPS,bt,fs,f0,cwave,xjunk,1,NWAVE)

     lagmax=-1
     ccfmax=0.
     nsum=32*2
     do lag=0,nlags-1
        z=0.
        s=0.
        do i=0,NWAVE-1
           z=z + cd(i+lag)*conjg(cwave(i))
           if(mod(i,nsum).eq.nsum-1 .or. i.eq.NWAVE-1) then
              s=s + abs(z)
              z=0.
           endif
        enddo
        ccf(lag)=s
        if(ccf(lag).gt.ccfmax) then
           ccfmax=ccf(lag)
           lagmax=lag
        endif
     enddo ! lag
     ccfmsg(imsg)=ccfmax
     if(ccfmax.gt.ccfbest) then
        ccfbest=ccfmax
        lagbest=lagmax
        msgbest=msg
     endif
  enddo  ! imsg

  call pctile(ccfmsg,207,50,base)
  call pctile(ccfmsg,207,67,sigma)
  sigma=sigma-base
  ccfmsg=(ccfmsg-base)/sigma
!  do imsg=1,207
!     write(44,3044) imsg,ccfmsg(imsg)
!3044 format(i5,f10.3)
!  enddo
  snr=maxval(ccfmsg)

  return
end subroutine ft8q3

subroutine extract4(sym0,ncount,decoded)

  use packjt
  real sym0(207)
  real sym(207)
  character decoded*22
  character*72 c72
  integer*1 symbol(207)
  integer*1 data1(13)                   !Decoded data (8-bit bytes)
  integer   data4a(9)                   !Decoded data (8-bit bytes)
  integer   data4(12)                   !Decoded data (6-bit bytes)
  integer mettab(-128:127,0:1)          !Metric table
  logical first
  data first/.true./
  save first,mettab,ndelta

  if(first) then
     call getmet4(mettab,ndelta)
     first=.false.
  endif

!### Optimize these params: ...
  amp=30.0
  limit=10000

  ave0=sum(sym0)/207.0
  sym=sym0-ave0
  sq=dot_product(sym,sym)
  rms0=sqrt(sq/206.0)
  sym=sym/rms0

  do j=1,207
     n=nint(amp*sym(j))
     if(n.lt.-127) n=-127
     if(n.gt.127) n=127
     symbol(j)=n
  enddo

  nbits=72
  ncycles=0
  ncount=-1
  decoded='                      '
  call interleave4(symbol(2),-1)          !Remove the interleaving
  call fano232(symbol(2),nbits+31,mettab,ndelta,limit,data1,     &
       ncycles,metric,ncount)
  nlim=ncycles/(nbits+31)

!### Make usage here like that in jt9fano...
  if(ncount.ge.0) then
     do i=1,9
        i4=data1(i)
        if(i4.lt.0) i4=i4+256
        data4a(i)=i4
     enddo
     write(c72,1100) (data4a(i),i=1,9)
1100 format(9b8.8)
     read(c72,1102) data4
1102 format(12b6)

     call unpackmsg(data4,decoded)
     if(decoded(1:6).eq.'000AAA') then
!        decoded='***WRONG MODE?***'
        decoded='                      '
        ncount=-1
     endif
  endif

  return
end subroutine extract4

subroutine timf2(k,nxpol,nfft,nwindow,nb,peaklimit,iqadjust,iqapply,faclim, &
  cx0,cy0,gainx,gainy,phasex,phasey,cx1,cy1,slimit,lstrong,px,py,nzap)

! Sequential processing of time-domain I/Q data, using Linrad-like
! "first FFT" and "first backward FFT".  

!  cx0,cy0      - complex input data
!  nfft      - length of FFTs
!  nwindow   - 0 for no window, 2 for sin^2 window
!  iqapply   - 0/1 determines if I/Q phase and amplitude corrections applied
!  gainx,y   - gain error in Q channel, relative to I
!  phasex,y  - phase error
!  cx1,cy1   - output data

! Non-windowed processing means no overlap, so kstep=nfft.  
! Sin^2 window has 50% overlap, kstep=nfft/2.

! Frequencies with strong signals are identified and separated.  The back
! transforms are done separately for weak and strong signals, so that
! noise blanking can be applied to the weak-signal portion.  Strong and
! weak are finally re-combined in the time domain.

  parameter (MAXFFT=1024,MAXNH=MAXFFT/2)
  parameter (MAXSIGS=100)
  complex cx0(0:nfft-1),cx1(0:nfft-1)
  complex cy0(0:nfft-1),cy1(0:nfft-1)
  complex cx(0:MAXFFT-1),cxt(0:MAXFFT-1)
  complex cy(0:MAXFFT-1),cyt(0:MAXFFT-1)
  complex cxs(0:MAXFFT-1),covxs(0:MAXNH-1)     !Strong X signals
  complex cys(0:MAXFFT-1),covys(0:MAXNH-1)     !Strong Y signals
  complex cxw(0:MAXFFT-1),covxw(0:MAXNH-1)     !Weak X signals
  complex cyw(0:MAXFFT-1),covyw(0:MAXNH-1)     !Weak Y signals
  real*4 w(0:MAXFFT-1)
  real*4 s(0:MAXFFT-1)
  logical*1 lstrong(0:MAXFFT-1),lprev
  integer ia(MAXSIGS),ib(MAXSIGS)
  complex h,u,v
  logical first
  data first/.true./
  data k0/99999999/
  save

  if(faclim+iqadjust.eq.-9999.0) iqadjust=0   !Silence compiler warning.
  if(first) then
     pi=4.0*atan(1.0)
     do i=0,nfft-1
        w(i)=(sin(i*pi/nfft))**2
     enddo
     s=0.
     nh=nfft/2
     kstep=nfft
     if(nwindow.eq.2) kstep=nh
     fac=1.0/nfft
     slimit=1.e30
     first=.false.
  endif

  if(k.lt.k0) then
     covxs=0.
     covxw=0.
     covys=0.
     covyw=0.
  endif
  k0=k

  cx(0:nfft-1)=cx0
  if(nwindow.eq.2) cx(0:nfft-1)=w(0:nfft-1)*cx(0:nfft-1)
  call four2a(cx,nfft,1,1,1)                       !First forward FFT (X)

  if(nxpol.ne.0) then
     cy(0:nfft-1)=cy0
     if(nwindow.eq.2) cy(0:nfft-1)=w(0:nfft-1)*cy(0:nfft-1)
     call four2a(cy,nfft,1,1,1)                    !First forward FFT (Y)
  endif

  if(iqapply.ne.0) then                            !Apply I/Q corrections (X)
     h=gainx*cmplx(cos(phasex),sin(phasex))
     v=0.
     do i=0,nfft-1
        u=cx(i)
        if(i.gt.0) v=cx(nfft-i)
        x=real(u)  + real(v)  - (aimag(u) + aimag(v))*aimag(h) +         &
             (real(u) - real(v))*real(h)
        y=aimag(u) - aimag(v) + (aimag(u) + aimag(v))*real(h)  +         &
             (real(u) - real(v))*aimag(h)
        cxt(i)=0.5*cmplx(x,y)
     enddo
  else
     cxt(0:nfft-1)=cx(0:nfft-1)
  endif

  if(nxpol.ne.0) then
     if(iqapply.ne.0) then                         !Apply I/Q corrections (Y)
        h=gainy*cmplx(cos(phasey),sin(phasey))
        v=0.
        do i=0,nfft-1
           u=cy(i)
           if(i.gt.0) v=cy(nfft-i)
           x=real(u)  + real(v)  - (aimag(u) + aimag(v))*aimag(h) +         &
                (real(u) - real(v))*real(h)
           y=aimag(u) - aimag(v) + (aimag(u) + aimag(v))*real(h)  +         &
                (real(u) - real(v))*aimag(h)
           cyt(i)=0.5*cmplx(x,y)
        enddo
     else
        cyt(0:nfft-1)=cy(0:nfft-1)
     endif
  endif

! Identify frequencies with strong signals, copy frequency-domain
! data into array cs (strong) or cw (weak).

  do i=0,nfft-1
     p=real(cxt(i))**2 + aimag(cxt(i))**2
     if(nxpol.ne.0) p=p + real(cyt(i))**2 + aimag(cyt(i))**2
     s(i)=p
  enddo
  ave=sum(s(0:nfft-1))/nfft
  lstrong(0:nfft-1)=s(0:nfft-1).gt.10.0*ave

  nsigs=0
  lprev=.false.
  iwid=1
  ib=-99
  do i=0,nfft-1
     if(lstrong(i) .and. (.not.lprev)) then
        if(nsigs.lt.MAXSIGS) nsigs=nsigs+1
        ia(nsigs)=i-iwid
        if(ia(nsigs).lt.0) ia(nsigs)=0
     endif
     if(.not.lstrong(i) .and. lprev) then
        ib(nsigs)=i-1+iwid
        if(ib(nsigs).gt.nfft-1) ib(nsigs)=nfft-1
     endif
     lprev=lstrong(i)
  enddo

  if(nsigs.gt.0) then
     do i=1,nsigs
        ja=ia(i)
        jb=ib(i)
        if(ja.lt.0 .or. ja.gt.nfft-1 .or. jb.lt.0 .or. jb.gt.nfft-1) then
           cycle
        endif
        if(jb.eq.-99) jb=ja + min(2*iwid,nfft-1)
        lstrong(ja:jb)=.true.
     enddo
  endif

  do i=0,nfft-1
     if(lstrong(i)) then
        cxs(i)=fac*cxt(i)
        cxw(i)=0.
        if(nxpol.ne.0) then
           cys(i)=fac*cyt(i)
           cyw(i)=0.
        endif
     else
        cxw(i)=fac*cxt(i)
        cxs(i)=0.
        if(nxpol.ne.0) then
           cyw(i)=fac*cyt(i)
           cys(i)=0.
        endif
     endif
  enddo

  call four2a(cxw,nfft,1,-1,1)                 !Transform weak and strong X
  call four2a(cxs,nfft,1,-1,1)                 !back to time domain, separately

  if(nxpol.ne.0) then
     call four2a(cyw,nfft,1,-1,1)              !Transform weak and strong Y
     call four2a(cys,nfft,1,-1,1)              !back to time domain, separately
  endif

  if(nwindow.eq.2) then
     cxw(0:nh-1)=cxw(0:nh-1)+covxw(0:nh-1)     !Add previous segment's 2nd half
     covxw(0:nh-1)=cxw(nh:nfft-1)              !Save 2nd half
     cxs(0:nh-1)=cxs(0:nh-1)+covxs(0:nh-1)     !Ditto for strong signals
     covxs(0:nh-1)=cxs(nh:nfft-1)

     if(nxpol.ne.0) then
        cyw(0:nh-1)=cyw(0:nh-1)+covyw(0:nh-1)  !Add previous segment's 2nd half
        covyw(0:nh-1)=cyw(nh:nfft-1)           !Save 2nd half
        cys(0:nh-1)=cys(0:nh-1)+covys(0:nh-1)  !Ditto for strong signals
        covys(0:nh-1)=cys(nh:nfft-1)
     endif
  endif

! Apply noise blanking to weak data
  if(nb.ne.0) then
     do i=0,kstep-1
        peak=abs(cxw(i))
        if(nxpol.ne.0) peak=max(peak,abs(cyw(i)))
        if(peak.gt.peaklimit) then
           cxw(i)=0.
           if(nxpol.ne.0) cyw(i)=0.
           nzap=nzap+1
        endif
     enddo
  endif

! Compute power levels from weak data only
  do i=0,kstep-1
     px=px + real(cxw(i))**2 + aimag(cxw(i))**2
     if(nxpol.ne.0) py=py + real(cyw(i))**2 + aimag(cyw(i))**2
  enddo

  cx1(0:kstep-1)=cxw(0:kstep-1) + cxs(0:kstep-1)       !Weak + strong (X)
  if(nxpol.ne.0) then
     cy1(0:kstep-1)=cyw(0:kstep-1) + cys(0:kstep-1)    !Weak + strong (Y)
  endif

  return
end subroutine timf2

subroutine ft8svar(s8,srr,itone,msg37,lft8s,nft8rxfsens,stophint)

  use ft8_mod1, only : itone56,idtone56,msg,nlasttx,lastrxmsg,mycall,hiscall
  real, intent(in) :: s8(0:7,79),srr
  real s8_1(0:7,79),s8d(0:7,58),xsync(21),xmsync(21),xdata(58),xmdata(58),xnoise(79),xmnoise(79)
  character, intent(out) :: msg37*37
  character*37 lastrcvdmsg,msgsent37
  integer, intent(out) :: itone(79)
  integer, intent(in) :: nft8rxfsens
  integer itonedem(58),idtone(58),mrs(58),mrs2(58),mrs3(58),mrs4(58),ip1(1)
  logical(1), intent(in) :: stophint
  logical(1), intent(out) :: lft8s
  logical(1) lmatched(58),lmycall,lhiscall,lrrr,lr73,lcallingrprt,lastrrprt,lastreport,lgrid

! taken from ft8_mod1
!    integer itone56(56,79),idtone56(56,58)
!    character*37 msg(56)

!nlasttx  last TX message
!  0       Tx was halted
!  1      AA1AA BB1BB PL35
!  2      AA1AA BB1BB -15
!  3      AA1AA BB1BB R-15
!  4      AA1AA BB1BB RRR/RR73
!  5      AA1AA BB1BB 73
!  6      CQ BB1BB PL35

  lft8s=.false.
  if(stophint) return; if(len_trim(hiscall).lt.3) return; if(nlasttx.eq.6 .or. nlasttx.eq.0) return ! CQ or TX halted
  lgrid=.false.; nft8rxfslow=nft8rxfsens; lmycall=.false.; lastrcvdmsg=''
  lmatched=.false.; s8_1=s8; lhiscall=.false.; lrrr=.false.; lr73=.false.; lcallingrprt=.false.; lastrrprt=.false.
  lastreport=.false.; itonedem=11; ntresh1=26; ntresh2=38; if(srr.gt.7.0) then; ntresh1=29; ntresh2=41; endif

  if(lastrxmsg(1)%lstate) then; lastrcvdmsg=lastrxmsg(1)%lastmsg; else; lastrcvdmsg=''; endif

  if(lastrcvdmsg.ne.'                                     ') then
    if(index(lastrcvdmsg,trim(hiscall)).gt.0) lhiscall=.true.
    if(index(lastrcvdmsg,trim(mycall)).eq.1) lmycall=.true.
    if(lmycall .and. lhiscall) then
      if(index(lastrcvdmsg,' RRR').gt.0) lrrr=.true.
      if(index(lastrcvdmsg,' RR73').gt.0 .or. index(lastrcvdmsg,' 73').gt.0) lr73=.true.
    endif
  else
    if(nlasttx.eq.2) lcallingrprt=.true. ! calling with REPORT scenario
  endif
  if(lmycall .and. lhiscall) then
    if(index(lastrcvdmsg,' +').gt.0 .or. index(lastrcvdmsg,' -').gt.0) lastreport=.true.
    if(index(lastrcvdmsg,' R+').gt.0 .or. index(lastrcvdmsg,' R-').gt.0) lastrrprt=.true.
  endif
  if(lastrxmsg(1)%lstate .and. lmycall .and. lhiscall .and. .not.lastreport .and. .not. lastrrprt .and. .not.lrrr .and. &
    .not.lr73) lgrid=.true.
  if(lastrxmsg(1)%lstate .and. .not.lmycall .and. lhiscall .and. nlasttx.eq.2) lcallingrprt=.true. ! calling with REPORT

  if(lgrid .and. index(msg(53),trim(mycall)//' '//trim(hiscall)//' AA00').eq.1) then ! standard callsigns
    i3=-1; n3=-1
    msg(53)=lastrxmsg(1)%lastmsg
    call genft8sdvar(msg(53),i3,n3,msgsent37,msgbits,itone)
    idtone56(53,1:29)=itone(8:36)
    idtone56(53,30:58)=itone(44:72)
    itone56(53,1:79)=itone(1:79)
  endif

  do i=1,58
    if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
    else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
  enddo

  nmycall1=0; nbase1=0
  do k=1,19
    if(idtone56(1,k).eq.itonedem(k)) then; if(k.lt.10) nmycall1=nmycall1+1; nbase1=nbase1+1; endif
  enddo

! /'-01 ','-02 ','-03 ','-04 ','-05 ','-06 ','-07 ','-08 ','-09 ','-10 ',
!  '-11 ','-12 ','-13 ','-14 ','-15 ','-16 ','-17 ','-18 ','-19 ','-20 ',
!  '-21 ','-22 ','-23 ','-24 ','-25 ','-26 ','R-01','R-02','R-03','R-04',
!  'R-05','R-06','R-07','R-08','R-09','R-10','R-11','R-12','R-13','R-14',
!  'R-15','R-16','R-17','R-18','R-19','R-20','R-21','R-22','R-23','R-24',
!  'R-25','R-26','AA00','RRR ','RR73','73  '/

  ilow=1; ihigh=56
  if(nlasttx.eq.1) then; ilow=1; ihigh=26 ! GRID R+REPORT RRR RR73 73 are not valid msgs
  elseif(lgrid) then; ilow=27; ihigh=53 ! REPORT RRR RR73 73 are not valid msgs
  elseif(lcallingrprt) then; ilow=27; ihigh=52 ! GRID REPORT RRR RR73 73 are not valid msgs
  elseif(lastrrprt) then; ilow=27; ihigh=56 ! REPORT is not a valid msg, GRID shall be excluded later 
  elseif(lr73 .or. lrrr) then; ilow=54; ihigh=56 ! GRID, REPORT or R+REPORT is not a valid msg, 
! MF GRID shall be excluded later
  endif

  nmatchditer1=0; ncrcpatyiter1=0; imax=0
  do i=ilow,ihigh
    if(lastreport .and. i.gt.26 .and. i.lt.54) cycle ! RREPORT is not a valid msg, direction change is not allowed
    nmatch1=0; ncrcpaty1=0
    do k=1,58
      if(idtone56(i,k).eq.itonedem(k)) then; nmatch1=nmatch1+1; if(k.gt.25) ncrcpaty1=ncrcpaty1+1; endif
    enddo
    if(nmatch1.gt.nmatchditer1) then
      imax=i; nmatchditer1=nmatch1; ncrcpatyiter1=ncrcpaty1
    endif
  enddo
!write (*,"(i2,1x,i2,1x,i2,1x,i2)") nmatchlast1,nmatchditer1,ncrcpatylast1,ncrcpatyiter1
  if(imax.eq.0) return
  if(srr.gt.3.0 .and. (nmycall1.lt.5 .or. nbase1.lt.10)) return ! prevent false decodes from the strong signals
  if((nlasttx.eq.1 .or. lcallingrprt) .and. nmycall1.eq.0) return ! answer to other operator
  if(lr73 .and. (imax.eq.53 .or. imax.eq.54)) return ! RRR,GRID is not a valid msg

  nmatch1=nmatchditer1; ncrcpaty1=ncrcpatyiter1
  idtone(1:58)=idtone56(imax,1:58)
  do k=1,58
    if(idtone(k).eq.itonedem(k)) lmatched(k)=.true. 
  enddo

  if(ncrcpaty1.lt.8) return
  
  thresh=0.0; i1=0; i2=0; i33=0; i4=0
  do i=1,58; if(i.le.29) then; s8d(0:7,i)=s8(0:7,i+7); else; s8d(0:7,i)=s8(0:7,i+14); endif; enddo
  do j=1,58
    s1=-1.0E6; s2=-1.0E6; s3=-1.0E6; s4=-1.0E6
    do i=0,7; if(s8d(i,j).gt.s1) then; s1=s8d(i,j); i1=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. s8d(i,j).gt.s2) then; s2=s8d(i,j); i2=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. i.ne.i2 .and. s8d(i,j).gt.s3) then; s3=s8d(i,j); i33=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. i.ne.i2 .and. i.ne.i33 .and. s8d(i,j).gt.s4) then; s4=s8d(i,j); i4=i; endif; enddo
    mrs(j)=i1; mrs2(j)=i2; mrs3(j)=i33; mrs4(j)=i4
  enddo
  ref0=0.; ref0paty=0.; ref0mycl=0.; ref0oth=0.
  do i=1,58
    ref0=ref0 + s8d(mrs(i),i)
    if(i.gt.26) then; ref0paty=ref0paty + s8d(mrs(i),i)
    else if(i.lt.10) then; ref0mycl=ref0mycl + s8d(mrs(i),i)
    endif
  enddo
  ref0oth=ref0mycl+ref0paty
  ipk=0; u1=0.; u2=0.; u1paty=0.; u2paty=0.; u1oth=0.; u2oth=0.
  do k=ilow,ihigh
    if(lastreport .and. k.gt.26 .and. k.lt.54) cycle ! GRID, RREPORT is not a valid msg, direction change is not allowed
    psum=0.0; ref=ref0; psumpaty=0.; refpaty=ref0paty; psumoth=0.; refoth=ref0oth
    do j=1,58; i=idtone56(k,j); psum=psum + s8d(i,j)
      if(j.gt.26) then; psumpaty=psumpaty + s8d(i,j); psumoth=psumoth + s8d(i,j)
      else if(j.lt.10) then; psumoth=psumoth + s8d(i,j)
      endif
      if(i.eq.mrs(j)) then
        stmp=s8d(mrs2(j),j)-s8d(i,j); ref=ref + stmp
        if(j.gt.26) then; refpaty=refpaty + stmp; refoth=refoth + stmp
        else if(j.lt.10) then; refoth=refoth + stmp
        endif
      endif
      if(i.eq.mrs2(j)) then
        stmp=s8d(mrs3(j),j) - s8d(mrs2(j),j); ref=ref + stmp
        if(j.gt.26) then; refpaty=refpaty + stmp; refoth=refoth + stmp
        else if(j.lt.10) then; refoth=refoth + stmp
        endif
      endif
      if(i.eq.mrs3(j)) then
        stmp=s8d(mrs4(j),j) - s8d(mrs3(j),j); ref=ref + stmp
        if(j.gt.26) then; refpaty=refpaty + stmp; refoth=refoth + stmp
        else if(j.lt.10) then; refoth=refoth + stmp
        endif
      endif
!!      if(i.eq.mrs2(j)) then; ref=ref - s8d(mrs(j),j) + s8d(mrs3(j),j); endif
!!      if(i.eq.mrs3(j)) then; ref=ref - s8d(mrs(j),j) + s8d(mrs4(j),j); endif
    enddo
    p=psum/ref; ppaty=psumpaty/refpaty; poth=psumoth/refoth
    if(p.gt.u1) then; u2=u1; u1=p; u2paty=u1paty; u1paty=ppaty; u2oth=u1oth; u1oth=poth; ipk=k
    else if(p.gt.u2) then; u2=p; u2paty=ppaty; u2oth=poth
    endif
  enddo
  if(lastrrprt .and. ipk.eq.53) return ! GRID is not valid
  if(lr73 .and. ipk.lt.55) return

  if(lcallingrprt .or. nlasttx.eq.1) nft8rxfslow=1

  if(ipk.ne.0) then
    qual=100.0*(u1-u2); qualp=100.0*(u1paty-u2paty); qualo=100.0*(u1oth-u2oth)
    thresh=(qual+10.0)*(u1-0.6); if(thresh.lt.1.5) return
    threshp=(qualp+10.0)*(u1paty-0.6); thresho=(qualo+10.0)*(u1oth-0.6)
    if((lcallingrprt .or. nlasttx.eq.1) .and. thresho.lt.3.43) return
    if(thresho.lt.2.63 .or. threshp.lt.2.45) return
    if(((nft8rxfslow.eq.1 .and. thresh.gt.4.0) .or. (nft8rxfslow.eq.2 .and. thresh.gt.3.55) &
      .or. (nft8rxfslow.eq.3 .and. thresh.gt.3.0)) .and. qual.gt.2.6 .and. u1.gt.0.77) then
!if(ipk.ne.7) print *,'match1',thresh
      lft8s=.true.; msg37=msg(ipk); itone(1:79)=itone56(ipk,1:79); go to 2
    endif
  endif

  if(imax.eq.ipk .and. (nft8rxfslow.gt.1 .or. (nft8rxfslow.eq.1 .and. thresh.gt.2.7)) .and. srr.lt.7.0 &
    .and. (ncrcpaty1.gt.14 .or. (nmatch1.gt.22 .and. ncrcpaty1.gt.13))) then
!if(imax.ne.7) print *,'11',thresh
    lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
  endif

  if(imax.eq.ipk .and. nmatch1.gt.ntresh1 .and. ncrcpaty1.gt.10) then
!if(imax.ne.7) print *,'12',thresh
    lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
  endif

  if(nmatchditer1.ge.16) then

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch2=nmatch1; ncrcpaty2=ncrcpaty1
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch2=nmatch2+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty2=ncrcpaty2+1; endif
    enddo
    if(nmatch2.gt.ntresh2 .and. ncrcpaty2.gt.19) then
!if(imax.ne.7) print *,'2',thresh
       lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    if(srr.gt.7.0) return ! do not process strong signals anymore

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch3=nmatch2; ncrcpaty3=ncrcpaty2
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch3=nmatch3+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty3=ncrcpaty3+1; endif
    enddo
    if(nmatch3.gt.44 .and. ncrcpaty3.gt.21) then
!if(imax.ne.7) print *,'3',thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch4=nmatch3; ncrcpaty4=ncrcpaty3
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch4=nmatch4+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty4=ncrcpaty4+1; endif
    enddo
    if((nft8rxfslow.eq.3 .or. (nft8rxfslow.eq.2 .and. thresh.gt.2.2)) .and. nmatch4.gt.47 .and. ncrcpaty4.gt.23) then
!if(imax.ne.7) print *,'4',thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch5=nmatch4; ncrcpaty5=ncrcpaty4
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch5=nmatch5+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty5=ncrcpaty5+1; endif
    enddo
    if((nft8rxfslow.eq.3 .or. (nft8rxfslow.eq.1 .and. thresh.gt.3.4) .or. (nft8rxfslow.eq.2 .and. thresh.gt.3.25)) &
      .and. nmatch5.gt.50 .and. (nmatch1.gt.21 .or. nmatch2.gt.31 .or. nmatch3.gt.38 .or. nmatch4.gt.46) &
      .and. ncrcpaty5.gt.25) then
!if(imax.ne.7) print *,'5',thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch6=nmatch5; ncrcpaty6=ncrcpaty5
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch6=nmatch6+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty6=ncrcpaty6+1; endif
    enddo
    if(((nft8rxfslow.eq.2 .and. thresh.gt.2.6) .or. (nft8rxfslow.eq.3 .and. thresh.gt.2.22)) &
      .and. imax.eq.ipk .and. ncrcpaty6.gt.26) then
!if(imax.ne.7) print *,'61',thresh
!print *,'61',thresh
!write (*,"(i2,1x,i2,1x,f5.2)") 6,ncrcpaty6,thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    if(nft8rxfslow.eq.1) then
      if(nmatch6.gt.54 .and. (nmatch1.gt.22 .or. nmatch2.gt.27 .or. nmatch3.gt.35 .or. &
        (nmatch2-nmatch1).gt.9 .or. (nmatch3-nmatch2).gt.10) .and. ncrcpaty6.gt.29 .and. thresh.gt.3.15) then
!if(imax.ne.7) print *,'62',thresh
!print *,'62',thresh
        lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
      endif
    endif

    if(ncrcpaty6.gt.29) then
      if((nft8rxfslow.eq.3 .or. (nft8rxfslow.eq.3 .and. thresh.gt.1.94)) .and. imax.eq.ipk .and. ncrcpaty2-ncrcpaty1.gt.3 &
        .and. ncrcpaty3-ncrcpaty2.gt.3 .and. ncrcpaty4-ncrcpaty3.gt.3 .and. ncrcpaty6-ncrcpaty5.lt.6) then
!if(imax.ne.7) print *,'63',thresh
!print *,'63',thresh
!if(imax.ne.7) write (*,"(i2,1x,f5.2,1x,f5.2,1x,f5.2)") 62,u1,qual,thresh
        lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
      endif
    endif
  endif

2 if(lft8s) then
    snr=0.0; snrbase=0.0; snrpaty=0.0; snrdata=0.0; snrsync=0.0; snrmycall=0.0; snrother=0.0
    do i=1,79
      xsig=s8(itone(i),i); xnoi=(sum(s8(0:7,i)) - xsig)/7.0; snr1=xsig/(xnoi+1E-6); snr=snr+snr1
      if(i.gt.7 .and. i.lt.34) then; snrbase=snrbase + snr1; if(i.lt.17) snrmycall=snrmycall + snr1; endif
      if((i.gt.43 .and. i.lt.73) .or. (i.gt.33 .and. i.lt.37)) then; snrpaty=snrpaty+snr1; endif
    enddo
    snrdata=snrbase+snrpaty; snrsync=snr-snrdata; snrother=snrmycall+snrpaty
    snrsync=snrsync/21.0; snrother=snrother/48.0; snrpaty=snrpaty/32.0
    if(lcallingrprt .or. nlasttx.eq.1) then
      soratio=snrsync/snrother
      if(soratio.gt.1.29) then;lft8s=.false.; msg37=''; return; endif
    endif
    spratio=snrsync/snrpaty
    if(spratio.lt.0.6 .or. spratio.gt.1.25) then;lft8s=.false.; msg37=''; return; endif

    do i=1,7; xsync(i)=s8(itone(i),i); enddo; do i=8,14; k=i+29; xsync(i)=s8(itone(k),k); enddo
    do i=15,21; k=i+58; xsync(i)=s8(itone(k),k); enddo
    do i=1,29; k=i+7; xdata(i)=s8(itone(k),k); enddo; do i=30,58; k=i+14; xdata(i)=s8(itone(k),k); enddo
    do i=1,79; k=modulo(itone(i)+4,8); xnoise(i)=s8(k,i); enddo

    do i=1,19
      if((xsync(i).gt.xsync(i+1) .and. xsync(i).lt.xsync(i+2)) &
        .or. (xsync(i).lt.xsync(i+1) .and. xsync(i).gt.xsync(i+2))) then; xmsync(i)=xsync(i)
      else if((xsync(i+1).gt.xsync(i) .and. xsync(i+1).lt.xsync(i+2)) &
        .or. (xsync(i+1).lt.xsync(i) .and. xsync(i+1).gt.xsync(i+2))) then; xmsync(i)=xsync(i+1)
      else if((xsync(i+2).gt.xsync(i) .and. xsync(i+2).lt.xsync(i+1)) &
        .or. (xsync(i+2).lt.xsync(i) .and. xsync(i+2).gt.xsync(i+1))) then; xmsync(i)=xsync(i+2)
      else; xmsync(i)=xsync(i)
      endif
    enddo
    xmsync(20)=xmsync(18); xmsync(21)=xmsync(19)

    do i=1,56
      if((xdata(i).gt.xdata(i+1) .and. xdata(i).lt.xdata(i+2)) &
        .or. (xdata(i).lt.xdata(i+1) .and. xdata(i).gt.xdata(i+2))) then; xmdata(i)=xdata(i)
      else if((xdata(i+1).gt.xdata(i) .and. xdata(i+1).lt.xdata(i+2)) &
        .or. (xdata(i+1).lt.xdata(i) .and. xdata(i+1).gt.xdata(i+2))) then; xmdata(i)=xdata(i+1)
      else if((xdata(i+2).gt.xdata(i) .and. xdata(i+2).lt.xdata(i+1)) &
        .or. (xdata(i+2).lt.xdata(i) .and. xdata(i+2).gt.xdata(i+1))) then; xmdata(i)=xdata(i+2)
      else; xmdata(i)=xdata(i)
      endif
    enddo
    xmdata(57)=xmdata(55); xmdata(58)=xmdata(56)

    do i=1,77
      if((xnoise(i).gt.xnoise(i+1) .and. xnoise(i).lt.xnoise(i+2)) &
        .or. (xnoise(i).lt.xnoise(i+1) .and. xnoise(i).gt.xnoise(i+2))) then; xmnoise(i)=xnoise(i)
      else if((xnoise(i+1).gt.xnoise(i) .and. xnoise(i+1).lt.xnoise(i+2)) &
        .or. (xnoise(i+1).lt.xnoise(i) .and. xnoise(i+1).gt.xnoise(i+2))) then; xmnoise(i)=xnoise(i+1)
      else if((xnoise(i+2).gt.xnoise(i) .and. xnoise(i+2).lt.xnoise(i+1)) &
        .or. (xnoise(i+2).lt.xnoise(i) .and. xnoise(i+2).gt.xnoise(i+1))) then; xmnoise(i)=xnoise(i+2)
      else; xmnoise(i)=xnoise(i)
      endif
    enddo
    xmnoise(78)=xmnoise(76); xmnoise(79)=xmnoise(77)

    ssync=sum(xmsync)/21.0; spaty=sum(xmdata(27:58))/32.0; spnoise=(sum(xmnoise(34:36)) + sum(xmnoise(44:72)))/32.0
    spother=(sum(xmdata(1:9)) + sum(xmdata(27:58)))/41.0
    spratiom=ssync/(spaty+1E-6); spnratiom=spaty/(spnoise+1E-6); sporatiom=ssync/(spother+1E-6)
    if(spnratiom.gt.2.3) then
      if(lcallingrprt .or. nlasttx.eq.1) then; if(sporatiom.gt.1.35) then; lft8s=.false.; msg37=''; return; endif
      else; if(spratiom.gt.1.35) then; lft8s=.false.; msg37=''; return; endif
      endif
    endif
  endif

  return
end subroutine ft8svar

subroutine symspec(k,ndiskdat,nb,nbslider,nfsample,    &
     pxdb,ssz5a,nkhz,ihsym,nzap,slimit,lstrong)

!  k        pointer to the most recent new data
!  ndiskdat 0/1 to indicate if data from disk
!  nb       0/1 status of noise blanker
!  nfsample sample rate (Hz)
!  pxdb     power in x channel (0-60 dB)
!  ssz5a    polarized spectrum, for waterfall display
!  nkhz     integer kHz portion of center frequency, e.g., 125 for 144.125
!  ihsym    index number of this half-symbol (1-400)
!  nzap     number of samples zero'ed by noise blanker

  include 'njunk.f90'
  parameter (NSMAX=60*96000)          !Total sample intervals per minute
  parameter (NFFT=32768)              !Length of FFTs
  real*8 ts,hsym
  real*8 fcenter
  common/datcom/dd(2,5760000),ss(400,NFFT),savg(NFFT),fcenter,nutc,  &
       junk(NJUNK)
  real*4 ssz5a(NFFT),w(NFFT)
  complex cx(NFFT)
  complex cx00(NFFT)
  complex cx0(0:1023),cx1(0:1023)
  logical*1 lstrong(0:1023)
  data rms/999.0/,k0/99999999/,nadjx/0/,nadjy/0/
  save

  hsym=0.15d0*96000.d0                 !Samples per Q65-30x half-symbol
  npts=2*hsym                          !Full Q65-30x symbol
  if(k.gt.5751000) go to 999
  if(k.lt.npts) then
     ihsym=0
     go to 999             !Wait for enough samples to start
  endif
  if(k0.eq.99999999) then
!     pi=4.0*atan(1.0)
!     do i=1,NFFT
!        w(i)=(sin(i*pi/NFFT))**2                          !Window
!     enddo
     w=0.7                             !Flat window
  endif

  if(k.lt.k0) then
     ts=1.d0 - hsym
     ss=0.
     savg=0.
     ihsym=0
     k1=0
     if(ndiskdat.eq.0) dd(1:2,k+1:5760000)=0.  !### Should not be needed ??? ###
  endif
  k0=k

  nzap=0
  sigmas=1.5*(10.0**(0.01*nbslider)) + 0.7
  peaklimit=sigmas*max(10.0,rms)
  faclim=3.0
  px=0.

  nwindow=2
  nfft2=1024
  kstep=nfft2
  if(nwindow.ne.0) kstep=nfft2/2
  nblks=(k-k1)/kstep
  do nblk=1,nblks
     j=k1+1
     do i=0,nfft2-1
        cx0(i)=cmplx(dd(1,j+i),dd(2,j+i))
     enddo
     call timf2(k,nfft2,nwindow,nb,peaklimit,       &
          faclim,cx0,cx1,slimit,lstrong,   &
          px,nzap)

     do i=0,kstep-1
        dd(1,j+i)=real(cx1(i))
        dd(2,j+i)=aimag(cx1(i))
     enddo
     k1=k1+kstep
  enddo

  ts=ts+hsym
  ja=ts                               !Index of first sample
  jb=ja+npts-1                        !Last sample
  i=0
  fac=0.0002
  do j=ja,jb                          !Copy data into cx
     x1=dd(1,j)
     x2=dd(2,j)
     i=i+1
     cx(i)=fac*cmplx(x1,x2)
  enddo
  cx(npts+1:)=0.

  if(nzap/178.lt.50 .and. (ndiskdat.eq.0 .or. ihsym.lt.280)) then
     nsum=nblks*kstep - nzap
     if(nsum.le.0) nsum=1
     rmsx=sqrt(px/nsum)
     rms=rmsx
  endif
  pxdb=0.
  if(rmsx.gt.1.0) pxdb=20.0*log10(rmsx)
  if(pxdb.gt.60.0) pxdb=60.0

  cx00=cx

  ihsym=ihsym+1
  cx=w*cx00                           !Apply window for 2nd forward FFT
  call four2a(cx,NFFT,1,1,1)          !Second forward FFT (X)
  n=min(400,ihsym)
  do i=1,NFFT
     sx=real(cx(i))**2 + aimag(cx(i))**2
     ss(n,i)=sx                    ! Pol = 0
     savg(i)=savg(i) + sx
     ssz5a(i)=sx
  enddo

  nkhz=nint(1000.d0*(fcenter-int(fcenter)))
  if(fcenter.eq.0.d0) nkhz=125
!  write(*,3001) hsym,ts,ja,jb,ihsym
!3001 format(2f12.3,3i10)

999 return
end subroutine symspec

module interleave63_mod
  implicit none
contains
  subroutine interleave63(d1,idir)
    use set_mod
    implicit none
    integer, intent(inout) :: d1(0:6,0:8)
    integer, intent(in) :: idir
    integer :: d2(0:8,0:6)
    integer :: i, j

    if(idir.ge.0) then
       do i=0,6
          do j=0,8
             d2(j,i)=d1(i,j)
          enddo
       enddo
       call move(d2,d1,63)
    else
       call move(d1,d2,63)
       do i=0,6
          do j=0,8
             d1(i,j)=d2(j,i)
          enddo
       enddo
    endif
           
  end subroutine interleave63
end module interleave63_mod

module filbig_mod
  use iso_fortran_env, only: real32, real64
  use iso_c_binding, only:c_intptr_t
  use timer_module,   only: timer
  use debug_log
  use cacb_mod
  use fftw3_constants
  use fftw3_f77_interfaces
  implicit none
contains

  subroutine filbig(dd, nmax, f0, newdat, nfsample, xpol, c4a, c4b, n4)

  ! Filter and downsample complex data stored in array dd(4,nmax).
  ! Output is downsampled from 96000 Hz to 1375.125 Hz.
    
    integer, parameter :: MAXFFT1 = 5376000, MAXFFT2 = 77175
    integer,   intent(in)    :: nmax
    real(real32),    intent(in)    :: dd(4, nmax)
    real(real64),    intent(in)    :: f0
    integer,   intent(inout) :: newdat
    integer,   intent(in)    :: nfsample
    logical,   intent(in)    :: xpol
    complex,   intent(out)   :: c4a(MAXFFT2), c4b(MAXFFT2)
    integer,   intent(out)   :: n4

    real(real64) :: df
    real halfpulse(8)                       !Impulse response (one sided)
    real base, fac, filtval
    integer i, i0, j, nfft1, nfft2, nflags, nh, npatience, nz
    complex cfilt(MAXFFT2)                     !Filter in frequency domain
    integer(c_intptr_t) plan1, plan2, plan3, plan4, plan5
    logical first
    data first/.true./, npatience/1/
    data halfpulse/114.97547150, 36.57879257, -20.93789101, &
       5.89886379, 1.59355187, -2.49138308, 0.60910773, -0.04248129/

    save

    call init_cacb(5376000)

    if (nmax .lt. 0) go to 900

    nfft1 = MAXFFT1
    nfft2 = MAXFFT2
    if (nfsample .eq. 95238) then
       nfft1 = 5120000
       nfft2 = 74088
    endif

    if (first) then
       nflags = FFTW_ESTIMATE
       if (npatience .eq. 1) nflags = FFTW_ESTIMATE_PATIENT
       if (npatience .eq. 2) nflags = FFTW_MEASURE
       if (npatience .eq. 3) nflags = FFTW_PATIENT
       if (npatience .eq. 4) nflags = FFTW_EXHAUSTIVE

  ! Plan the FFTs just once
       call timer('FFTplans ', 0)
       call sfftw_plan_dft_1d(plan1, nfft1, ca, ca, FFTW_BACKWARD, nflags)
       call sfftw_plan_dft_1d(plan2, nfft1, cb, cb, FFTW_BACKWARD, nflags)
       call sfftw_plan_dft_1d(plan3, nfft2, c4a, c4a, FFTW_FORWARD, nflags)
       call sfftw_plan_dft_1d(plan4, nfft2, c4b, c4b, FFTW_FORWARD, nflags)
       call sfftw_plan_dft_1d(plan5, nfft2, cfilt, cfilt, FFTW_BACKWARD, nflags)
       call timer('FFTplans ', 1)

  ! Convert impulse response to filter function
       do i = 1, nfft2
          cfilt(i) = 0.0
       enddo
       fac = 0.00625/nfft1
       cfilt(1) = fac*halfpulse(1)
       do i = 2, 8
          cfilt(i) = fac*halfpulse(i)
          cfilt(nfft2 + 2 - i) = fac*halfpulse(i)
       enddo
       call sfftw_execute(plan5)

       base = real(cfilt(nfft2/2 + 1))

       df = 96000.d0/nfft1
       if (nfsample .eq. 95238) df = 95238.1d0/nfft1
       first = .false.
    endif

  ! When new data comes along, we need to compute a new "big FFT"
  ! If we just have a new f0, continue with the existing ca and cb.

    if (newdat .ne. 0 .or. sum(abs(ca)) .eq. 0.0) then  !### Test on ca should be unnecessary?
       nz = min(nmax, nfft1)
       do i = 1, nz
          ca(i) = cmplx(dd(1, i), dd(2, i))
          if (xpol) cb(i) = cmplx(dd(3, i), dd(4, i))
       enddo

       if (nmax .lt. nfft1) then
          do i = nmax + 1, nfft1
             ca(i) = 0.0
             if (xpol) cb(i) = 0.0
          enddo
       endif
       call timer('FFTbig  ', 0)
       call sfftw_execute(plan1)
       if (xpol) call sfftw_execute(plan2)
       call timer('FFTbig  ', 1)
       newdat = 0
    endif

  ! NB: f0 is the frequency at which we want our filter centered.
  !     i0 is the bin number in ca and cb closest to f0.

    i0 = nint(f0/df) + 1
    nh = nfft2/2

    ! Lower half of filter
    do i = 1, nh
       j = i0 + i - 1
       if (j .ge. 1 .and. j .le. nfft1) then
          filtval = real(cfilt(i)) - base
          c4a(i) = filtval*ca(j)
          if (xpol) c4b(i) = filtval*cb(j)
       else
          c4a(i) = 0.0
          if (xpol) c4b(i) = 0.0
       endif
    enddo

    ! Upper half of filter, with wrap-around and bounds check
    do i = nh + 1, nfft2
       j = i0 + i - 1 - nfft2
       if (j .lt. 1) j = j + nfft1

       if (j < 1 .or. j > size(ca)) then
          write (dbg_unit, *) 'FILBIG OOB: i=', i, ' j=', j, ' nh=', nh, &
             ' nfft1=', nfft1, ' nfft2=', nfft2, ' i0=', i0
          flush(dbg_unit)
          stop 'FILBIG index OOB'
       end if

       filtval = real(cfilt(i)) - base
       c4a(i) = filtval*ca(j)
       if (xpol) c4b(i) = filtval*cb(j)
    enddo

  ! Do the short reverse transform, to go back to time domain.
    call timer('FFTsmall', 0)
    call sfftw_execute(plan3)
    if (xpol) call sfftw_execute(plan4)
    call timer('FFTsmall', 1)
    n4 = min(nmax/64, nfft2)
    go to 999

  900   call sfftw_destroy_plan(plan1)
    call sfftw_destroy_plan(plan2)
    call sfftw_destroy_plan(plan3)
    call sfftw_destroy_plan(plan4)
    call sfftw_destroy_plan(plan5)

  999   return
  end subroutine filbig

end module filbig_mod

subroutine demod64a(s3,nadd,mrsym,mrprob,mr2sym,mr2prob,ntest,nlow)

!  Demodulate the 64-bin spectra for each of 63 symbols in a frame.

!  Parameters
!     nadd     number of spectra already summed
!     mrsym    most reliable symbol value
!     mr2sym   second most likely symbol value
!     mrprob   probability that mrsym was the transmitted value
!     mr2prob  probability that mr2sym was the transmitted value

  implicit real*8 (a-h,o-z)
  real*4 s3(64,63)
  real*8 fs(64)
  integer mrsym(63),mrprob(63),mr2sym(63),mr2prob(63)
  common/mrscom/ mrs(63),mrs2(63)

  afac=1.1 * float(nadd)**0.64
  scale=255.999

!  Compute average spectral value
  sum=0.
  do j=1,63
     do i=1,64
        sum=sum+s3(i,j)
     enddo
  enddo
  ave=sum/(64.*63.)
  i1=1                                      !Silence warning
  i2=1

!  Compute probabilities for most reliable symbol values
  do j=1,63
     s1=-1.e30
     fsum=0.
     psum=0.
     do i=1,64
        x=min(afac*s3(i,j)/ave,50.d0)
        fs(i)=exp(x)
        fsum=fsum+fs(i)
        psum=psum + s3(i,j)
        if(s3(i,j).gt.s1) then
           s1=s3(i,j)
           i1=i                              !Most reliable
        endif
     enddo

     s2=-1.e30
     do i=1,64
        if(i.ne.i1 .and. s3(i,j).gt.s2) then
           s2=s3(i,j)
           i2=i                              !Second most reliable
        endif
     enddo
!     p1=fs(i1)/fsum                          !Normalized probabilities
!     p2=fs(i2)/fsum
     p1=s1/psum
     p2=s2/psum
     mrsym(j)=i1-1
     mr2sym(j)=i2-1
     mrprob(j)=scale*p1
     mr2prob(j)=scale*p2
     mrs(j)=i1
     mrs2(j)=i2
  enddo
  
  sum=0.
  nlow=0
  do j=1,63
     sum=sum+mrprob(j)
     if(mrprob(j).le.5) nlow=nlow+1
  enddo
!  ntest=sum/63
  ntest=sum

  return
end subroutine demod64a

!subroutine symspec65(dd,npts,ss,nqsym,savg)
subroutine symspec65(dd,npts,nqsym,savg)

! Compute JT65 symbol spectra at quarter-symbol steps

  parameter (NFFT=8192)
  parameter (NSZ=3413)                         !NFFT*5000/12000
  parameter (MAXHSYM=322)
  parameter (MAXQSYM=552)
  real*8 hstep
  real*4 dd(npts)
!  real*4 ss(MAXHSYM,NSZ)
  real*4 ss(MAXQSYM,NSZ)
  real*4 savg(NSZ)
  real*4 x(NFFT)
  real*4 w(NFFT)
  complex c(0:NFFT/2)
  logical first
  common/refspec/dfref,ref(NSZ)
  equivalence (x,c)
  data first/.true./
  save /refspec/,first,w
  common/sync/ss

  hstep=2048.d0*12000.d0/11025.d0              !half-symbol = 2229.116 samples
  qstep=hstep/2.0              !quarter-symbol = 1114.558 samples
  nsps=nint(2*hstep)
  df=12000.0/NFFT
  nhsym=(npts-NFFT)/hstep
  nqsym=(npts-NFFT)/qstep
  savg=0.
  fac1=1.e-3

  if(first) then
! Compute the FFT window
!     width=0.25*nsps
     do i=1,NFFT
!        z=(i-NFFT/2)/width
        w(i)=1
        if(i.gt.4458) w(i)=0
!        w(i)=exp(-z*z)
      enddo
     first=.false.
  endif

  do j=1,nqsym
     i0=(j-1)*qstep
     x=fac1*w*dd(i0+1:i0+NFFT)
     call four2a(c,NFFT,1,-1,0)                !r2c forward FFT
     do i=1,NSZ
        s=real(c(i))**2 + aimag(c(i))**2
        ss(j,i)=s
        savg(i)=savg(i)+s
     enddo
  enddo
  savg=savg/nhsym

!  call flat65(ss,nhsym,MAXQSYM,NSZ,ref)  !Flatten the 2d spectrum, saving
  call flat65(ss,nqsym,MAXQSYM,NSZ,ref)  !Flatten the 2d spectrum, saving
  dfref=df                               ! the reference spectrum ref()
  savg=savg/ref
!  do j=1,nhsym
  do j=1,nqsym
     ss(j,1:NSZ)=ss(j,1:NSZ)/ref
  enddo

  return
end subroutine symspec65

subroutine genfst4(msg0,ichk,msgsent,msgbits,i4tone,iwspr)

! Input:
!   - msg0     requested message to be transmitted
!   - ichk     if ichk=1, return only msgsent
!   - msgsent  message as it will be decoded
!   - i4tone   array of audio tone values, {0,1,2,3}
!   - iwspr    in: 0: FST4 1: FST4W
!              out 0: (240,101)/crc24, 1: (240,74)/crc24
!
! Frame structure:
! s8 d30 s8 d30 s8 d30 s8 d30 s8

   use packjt77
   include 'fst4_params.f90'
   character*37 msg0
   character*37 message                    !Message to be generated
   character*37 msgsent                    !Message as it will be received
   character*77 c77
   character*24 c24
   integer*4 i4tone(NN),itmp(ND)
   integer*1 codeword(2*ND)
   integer*1 msgbits(101),rvec(77)
   integer isyncword1(8),isyncword2(8)
   integer ncrc24
   logical unpk77_success
   data isyncword1/0,1,3,2,1,0,2,3/
   data isyncword2/2,3,1,0,3,2,0,1/
   data rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
      1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
      0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/
   message=msg0

   do i=1, 37
      if(ichar(message(i:i)).eq.0) then
         message(i:37)=' '
         exit
      endif
   enddo
   do i=1,37                               !Strip leading blanks
      if(message(1:1).ne.' ') exit
      message=message(i+1:)
   enddo

   i3=-1
   n3=-1
   if(iwspr.eq.1) then
      i3=0
      n3=6
   endif
   call pack77(message,i3,n3,c77)
   call unpack77(c77,0,msgsent,unpk77_success) !Unpack to get msgsent
   msgbits=0
   iwspr=0
   if(i3.eq.0.and.n3.eq.6) then
      iwspr=1
      read(c77,'(50i1)') msgbits(1:50)
      call get_crc24(msgbits,74,ncrc24)
      write(c24,'(b24.24)') ncrc24
      read(c24,'(24i1)') msgbits(51:74)
   else
      read(c77,'(77i1)') msgbits(1:77)
      msgbits(1:77)=mod(msgbits(1:77)+rvec,2)
      call get_crc24(msgbits,101,ncrc24)
      write(c24,'(b24.24)') ncrc24
      read(c24,'(24i1)') msgbits(78:101)
   endif

   if(ichk.eq.1) go to 999
   if(unpk77_success) go to 2
   msgbits=0
   itone=0
   msgsent='*** bad message ***                  '
   go to 999

 entry get_fst4_tones_from_bits(msgbits,i4tone,iwspr)

2  continue
   if(iwspr.eq.0) then 
      call encode240_101(msgbits,codeword)
   else
      call encode240_74(msgbits(1:74),codeword)
   endif

! Grayscale mapping:
! bits   tone
! 00     0
! 01     1
! 11     2
! 10     3

   do i=1,ND
      is=codeword(2*i)+2*codeword(2*i-1)
      if(is.le.1) itmp(i)=is
      if(is.eq.2) itmp(i)=3
      if(is.eq.3) itmp(i)=2
   enddo

   i4tone(  1:  8)=isyncword1
   i4tone(  9: 38)=itmp(  1: 30)
   i4tone( 39: 46)=isyncword2
   i4tone( 47: 76)=itmp( 31: 60)
   i4tone( 77: 84)=isyncword1
   i4tone( 85:114)=itmp( 61: 90)
   i4tone(115:122)=isyncword2
   i4tone(123:152)=itmp( 91:120)
   i4tone(153:160)=isyncword1

999 return

end subroutine genfst4

subroutine slope(y,npts,xpk)

! Remove best-fit slope from data in y(i).  When fitting the straight line,
! ignore the peak around xpk +/- 4 bins

  real y(npts)

  sumw=0.
  sumx=0.
  sumy=0.
  sumx2=0.
  sumxy=0.
  sumy2=0.
  do i=1,npts
     if(abs(i-xpk).gt.4.0) then
        sumw=sumw + 1.0
        x=i
        sumx=sumx + x
        sumy=sumy + y(i)
        sumx2=sumx2 + x*x
        sumxy=sumxy + x*y(i)
        sumy2=sumy2 + y(i)**2
     endif
  enddo

  delta=sumw*sumx2 - sumx**2
  a=(sumx2*sumy - sumx*sumxy) / delta
  b=(sumw*sumxy - sumx*sumy) / delta

  sq=0.
  do i=1,npts
     y(i)=y(i)-(a + b*i)
     if(abs(i-xpk).gt.4.0) sq=sq + y(i)**2
  enddo
  rms=sqrt(sq/(sumw-4.0))
  y=y/rms

  return
end subroutine slope

subroutine chkflscallvar(call_a,call_b,falsedec)

  character*12 call_a,call_b
  logical(1) falsedec,lfound

  if(call_a(1:2).eq.'<.') return
  falsedec=.true.; lfound=.false.
!print *,"11","'"//call_a//"'","'"//call_b//"'"
  if(call_a.eq.'MYCALL      ' .or. call_a.eq.'CQ          ') then
    call searchcallsvar(call_b,"            ",lfound); if(lfound) falsedec=.false.
  else if(call_b(1:1).eq.'<') then
    call searchcallsvar(call_a,"            ",lfound); if(lfound) falsedec=.false.
  else
    call searchcallsvar(call_a,call_b,lfound); if(lfound) falsedec=.false.
  endif

  return
end subroutine chkflscallvar

subroutine iqcal(nn,c,nfft,gain,phase,zsum,ipk,reject)

  complex c(0:nfft-1)
  complex z,zsum,zave

  if(nn.eq.0) then
     zsum=0.
  endif
  nn=nn+1
  smax=0.
  ipk=1
  do i=1,nfft-1                       !Find strongest signal
     s=real(c(i))**2 + aimag(c(i))**2
     if(s.gt.smax) then
        smax=s
        ipk=i
     endif
  enddo
  pimage=real(c(nfft-ipk))**2 + aimag(c(nfft-ipk))**2
  p=smax + pimage
  z=c(ipk)*c(nfft-ipk)/p              !Synchronous detection of image
  zsum=zsum+z
  zave=zsum/nn
  tmp=sqrt(1.0 - (2.0*real(zave))**2)
  phase=asin(2.0*aimag(zave)/tmp)    !Estimate phase
  gain=tmp/(1.0-2.0*real(zave))      !Estimate gain
  reject=10.0*log10(pimage/smax)

  return
end subroutine iqcal

subroutine save_echo_params(nDopTotal,nDopAudio,nfrit,f1,fspread,ntonespacing, &
     itone,id2,idir)

  integer*2 id2(15),id2a(15)
  integer*4 itone(6)
  integer*1 itone0(6)
  equivalence (nDopTotal0,id2a(1))
  equivalence (nDopAudio0,id2a(3))
  equivalence (nfrit0,id2a(5))
  equivalence (f10,id2a(7))
  equivalence (fspread0,id2a(9))
  equivalence (ntonespacing0,id2a(11))
  equivalence (itone0,id2a(13))
  
  if(idir.gt.0) then
     nDopTotal0=nDopTotal
     nDopAudio0=nDopAudio
     nfrit0=nfrit
     f10=f1
     fspread0=fspread
     ntonespacing0=ntonespacing
     itone0=itone
     id2=id2a
  else
     id2a=id2
     nDopTotal=nDopTotal0
     nDopAudio=nDopAudio0
     nfrit=nfrit0
     f1=f10
     fspread=fspread0
     ntonespacing=ntonespacing0
     if(any(itone0.lt.0) .or. any(itone0.gt.36)) itone0=0
     itone=itone0
  endif

  return
end subroutine save_echo_params

module indexx_mod
  implicit none
contains
  subroutine indexx(arr, n, indx)
  implicit none
  integer, intent(in) :: n
  real,    intent(in) :: arr(n)
  integer, intent(out) :: indx(n)

  integer, parameter :: M = 7, NSTACK = 50
  integer :: i, j, k, l, ir, jstack
  integer :: istack(NSTACK)
  integer :: indxt, itemp
  real    :: a

  ! Initialize index array
  do j = 1, n
     indx(j) = j
  end do

  jstack = 0
  l = 1
  ir = n

  do   ! main loop replacing label 1

     ! Use insertion sort for small subarrays
     if (ir - l < M) then
        do j = l+1, ir
           indxt = indx(j)
           a = arr(indxt)

           do i = j-1, l, -1
              if (arr(indx(i)) <= a) exit
              indx(i+1) = indx(i)
           end do

           indx(i+1) = indxt
        end do

        if (jstack == 0) return

        ir = istack(jstack)
        l  = istack(jstack-1)
        jstack = jstack - 2

     else
        ! Quicksort partitioning
        k = (l + ir) / 2
        itemp = indx(k); indx(k) = indx(l+1); indx(l+1) = itemp

        if (arr(indx(l+1)) > arr(indx(ir))) then
           itemp = indx(l+1); indx(l+1) = indx(ir); indx(ir) = itemp
        end if

        if (arr(indx(l)) > arr(indx(ir))) then
           itemp = indx(l); indx(l) = indx(ir); indx(ir) = itemp
        end if

        if (arr(indx(l+1)) > arr(indx(l))) then
           itemp = indx(l+1); indx(l+1) = indx(l); indx(l) = itemp
        end if

        i = l + 1
        j = ir
        indxt = indx(l)
        a = arr(indxt)

        ! Partition loop replacing labels 3 and 4
        do
           do
              i = i + 1
              if (arr(indx(i)) >= a) exit
           end do

           do
              j = j - 1
              if (arr(indx(j)) <= a) exit
           end do

           if (j < i) exit

           itemp = indx(i); indx(i) = indx(j); indx(j) = itemp
        end do

        indx(l) = indx(j)
        indx(j) = indxt

        ! Push larger segment, process smaller first
        jstack = jstack + 2
        if (jstack > NSTACK) stop 'NSTACK too small in indexx'

        if (ir - i + 1 >= j - l) then
           istack(jstack)   = ir
           istack(jstack-1) = i
           ir = j - 1
        else
           istack(jstack)   = j - 1
           istack(jstack-1) = l
           l = i
        end if
     end if

  end do

  end subroutine indexx
end module indexx_mod

! NOTE: This routine must remain a top-level Fortran subroutine.
! It has CHARACTER arguments, which require hidden length parameters
! that are passed automatically by the Fortran ABI.
! Keeping it outside any module preserves the legacy Fortran/C++ ABI
! and ensures the caller can continue to use the symbol name gen_q65_wave_.

subroutine gen_q65_wave(msg,ntxfreq,mode65,msgsent,iwave,nwave)

  use packjt
  use q65_encoding
  implicit none 

  integer, parameter :: NMAX = 2*60*11025

  !--------------------------------------------------------------------
  ! Arguments (must NOT use bind(C) because of CHARACTER arguments)
  !--------------------------------------------------------------------
  character*22, intent(in)  :: msg
  integer,      intent(in)  :: ntxfreq
  integer,      intent(in)  :: mode65
  character*22, intent(out) :: msgsent
  integer*2,    intent(out) :: iwave(NMAX)
  integer,      intent(out) :: nwave

  !--------------------------------------------------------------------
  ! Local character
  !--------------------------------------------------------------------
  character*37 :: msg37

  !--------------------------------------------------------------------
  ! Explicit REAL*8 variables (as in original)
  !--------------------------------------------------------------------
  real*8 :: t, dt, phi, f, f0, dfgen, dphi, twopi, tsym

  !--------------------------------------------------------------------
  ! Formerly implicit variables
  !--------------------------------------------------------------------
  integer :: i, j, j0, nsym, ndf, iz
  real    :: xphi

  integer :: codeword(65), itone(85)
  integer :: icos7(0:6)

  data icos7 /2,5,6,0,4,1,3/
  data twopi /6.283185307179586476d0/
  save

  !--------------------------------------------------------------------
  ! Logic (unchanged)
  !--------------------------------------------------------------------
   msgsent = msg
   msg37   = ''
   msg37(1:22) = msg

   ! Strip JT65-style OOO suffix if present
   if (len_trim(msg37) >= 4) then
      if (msg37(len_trim(msg37)-3:len_trim(msg37)) == ' OOO') then
         msg37(len_trim(msg37)-3:) = ' '
      end if
   end if

   call get_q65_tones(msg37, codeword, itone)

  nsym = 85
  tsym = 7200.d0/12000.d0
  dt   = 1.d0/11025.d0
  f0   = ntxfreq
  ndf  = 2**(mode65-1)
  dfgen = ndf*12000.d0/7200.d0
  phi  = 0.d0
  dphi = twopi*dt*f0
  i    = 0
  iz   = 85*7200*11025.d0/12000.d0
  t    = 0.d0
  j0   = 0

  do i = 1, iz
     t = t + dt
     j = t/tsym + 1.0
     if (j /= j0) then
        f    = f0 + itone(j)*dfgen
        dphi = twopi*dt*f
        j0   = j
     endif
     phi = phi + dphi
     if (phi > twopi) phi = phi - twopi
     xphi = real(phi)
     iwave(2*i-1) = 32767.0*cos(xphi)
     iwave(2*i)   = 32767.0*sin(xphi)
  enddo

  nwave = 2*iz

end subroutine gen_q65_wave

! does not require end module

module ft4_a7

  parameter(MAXDEC=200)

! For the following three arrays
!    First index   i=decode number in this sequence
!    Second index  j=0 or 1 for even or odd sequence
!    Third index   k=0 or 1 for previous or current tally for this j
  real dt0_ft4(MAXDEC,0:1,0:1)            !dt0_ft4(i,j,k)
  real f0_ft4(MAXDEC,0:1,0:1)             !f0_ft4(i,j,k)
  character*37 msg0_ft4(MAXDEC,0:1,0:1)   !msg0_ft4(i,j,k)

  integer jseq_ft4                         !even=0, odd=1
  integer ndec_ft4(0:1,0:1)               !ndec_ft4(j,k)
  data ndec_ft4/4*0/,jseq_ft4/0/

contains

subroutine ft4_a7_save(jseq,dt,f,msg)

  use packjt77
  character*37 msg,msg1
  character*13 w(19)
  character*4 g4
  integer nw(19)
  logical isgrid4

! Statement function:
  isgrid4(g4)=(len_trim(g4).eq.4 .and.                                        &
       ichar(g4(1:1)).ge.ichar('A') .and. ichar(g4(1:1)).le.ichar('R') .and.  &
       ichar(g4(2:2)).ge.ichar('A') .and. ichar(g4(2:2)).le.ichar('R') .and.  &
       ichar(g4(3:3)).ge.ichar('0') .and. ichar(g4(3:3)).le.ichar('9') .and.  &
       ichar(g4(4:4)).ge.ichar('0') .and. ichar(g4(4:4)).le.ichar('9'))

  if(index(msg,'/').ge.1 .or. index(msg,'<').ge.1) go to 999
  call split77(msg,nwords,nw,w)          !Parse msg into words
  if(nwords.lt.1) go to 999
  if(w(1)(1:3).eq.'CQ_') go to 999
  j=jseq

! Add this decode to current table for this sequence
  ndec_ft4(j,1)=ndec_ft4(j,1)+1         !Number of decodes in this sequence
  i=ndec_ft4(j,1)                        !i is index of a new table entry
  if(i.gt.MAXDEC) return                 !Prevent table overflow

  dt0_ft4(i,j,1)=dt                      !Save dt in table
  f0_ft4(i,j,1)=f                        !Save f in table
  msg0_ft4(i,j,1)=trim(w(1))//' '//trim(w(2)) !Save "call_1 call_2"
  if(w(1)(1:3).eq.'CQ ' .and. nw(2).le.2) then
     msg0_ft4(i,j,1)='CQ '//trim(w(2))//' '//trim(w(3)) !Save "CQ DX Call_2"
  endif
  msg1=msg0_ft4(i,j,1)                   !Message without grid
  nn=len(trim(msg1))                      !Message length without grid
! Include grid as part of message
  if(isgrid4(w(nwords))) msg0_ft4(i,j,1)=trim(msg0_ft4(i,j,1))//' '//trim(w(nwords))

! If a transmission at this frequency with message fragment "call_1 call_2"
! was decoded in the previous sequence, flag it as "DO NOT USE" because
! we have already decoded and subtracted that station's next transmission.

  call split77(msg0_ft4(i,j,1),nwords,nw,w)
  do i=1,ndec_ft4(j,0)
     if(f0_ft4(i,j,0).le.-98.0) cycle
     i2=index(msg0_ft4(i,j,0),' '//trim(w(2)))
     if(abs(f-f0_ft4(i,j,0)).le.3.0 .and. i2.ge.3) then
        f0_ft4(i,j,0)=-98.0     !Flag as "do not use" for a potential a7 decode
     endif
  enddo

999 return
end subroutine ft4_a7_save

subroutine ft4_a7d(dd0,newdat,call_1,call_2,grid4,xdt,f1,xbase,  &
     nharderrors,dmin,msg37,xsnr)

! Examine the raw data in dd0() for possible "a7" decodes.
! Adapted from ft8_a7d for FT4's 4-FSK/103-symbol frame.

  use timer_module, only: timer
  use packjt77
  include 'ft4_params.f90'
  parameter(NSS=NSPS/NDOWN)              !32 samples per symbol
  parameter(NP2=NMAX/NDOWN)              !4032 downsampled samples
  character*37 msg37,msg,msgsent,msgbest
  character*12 call_1,call_2
  character*4 grid4
  real a(5)
  real s4(0:3,NN)                      !FT4: 4 tones (FT8: s8(0:7,NN))
  real s2(0:255)                       !FT4: 2^8=256 (FT8: s2(0:511))
  real dmm(206)
  real bmeta(174),bmetb(174),bmetc(174),bmetd(174)
  real llra(174),llrb(174),llrc(174),llrd(174)
  real dd0(NMAX)
  real ss(9)
  integer*1 cw(174)
  integer*1 msgbits(77)
  integer*1 nxor(174),hdec(174)
  integer i4tone(NN)                    !FT4: 103 symbols (FT8: itone(79))
  integer ip(1)
  logical one(0:255,0:7)               !FT4: 4-FSK, 8 bits max (FT8: 0:511,0:8)
  integer graymap(0:3)                 !FT4: 4-FSK (FT8: graymap(0:7))
  integer iloc(1)
  complex cd0(0:NP2-1)                 !FT4: NP2=4032 (FT8: 0:3199)
  complex ctwk(2*NSS)                  !FT4: 64 (FT8: ctwk(32))
  complex csymb(NSS)
  complex cs(0:3,NN)                   !FT4: 4 tones, 103 sym (FT8: 0:7,79)
  logical std_1,std_2
  logical first,newdat
  data first/.true./
  data graymap/0,1,3,2/                !FT4: 4-FSK Gray code (FT8: /0,1,3,2,5,6,4,7/)
  save one

  if(first) then
     one=.false.
     do i=0,255                        !FT4: 0:255 (FT8: 0:511)
       do j=0,7                        !FT4: 0:7 (FT8: 0:8)
         if(iand(i,2**j).ne.0) one(i,j)=.true.
       enddo
     enddo
     first=.false.
  endif

  call stdcall(call_1,std_1)
  if(call_1(1:3).eq.'CQ ') std_1=.true.
  call stdcall(call_2,std_2)

  fs2=12000.0/NDOWN                      !666.67 Hz
  dt2=1.0/fs2
  twopi=8.0*atan(1.0)
  delfbest=0.
  ibest=0

  call timer('ft4_dwn ',0)
  call ft4_downsample(dd0,newdat,f1,cd0)  !FT4 downsample (FT8: ft8_downsample)
  call timer('ft4_dwn ',1)

  i0=nint((xdt+0.5)*fs2)                  !Initial guess for start of signal
  smax=0.0
  do idt=i0-10,i0+10                      !Search over +/- ~15 ms
     call sync4d(cd0,idt,ctwk,0,sync)     !FT4 sync (FT8: sync8d)
     if(sync.gt.smax) then
        smax=sync
        ibest=idt
     endif
  enddo

! Peak up in frequency
  smax=0.0
  do ifr=-5,5                              !Search over +/- 2.5 Hz
    delf=ifr*0.5
    dphi=twopi*delf*dt2
    phi=0.0
    do i=1,2*NSS                        !FT4: 64 (FT8: 32)
      ctwk(i)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
    enddo
    call sync4d(cd0,ibest,ctwk,1,sync)   !FT4 sync (FT8: sync8d)
    if( sync .gt. smax ) then
      smax=sync
      delfbest=delf
    endif
  enddo
  a=0.0
  a(1)=-delfbest
  call twkfreq1(cd0,NP2,fs2,a,cd0)
  f1=f1+delfbest                           !Improved estimate of DF

  call timer('ft4_dwn ',0)
  call ft4_downsample(dd0,.false.,f1,cd0)  !FT4 downsample (FT8: ft8_downsample)
  call timer('ft4_dwn ',1)

! Fine sync search
  smax=0.0
  do idt=-4,4
     call sync4d(cd0,ibest+idt,ctwk,0,sync) !FT4 sync (FT8: sync8d)
     ss(idt+5)=sync
  enddo
  smax=maxval(ss)
  iloc=maxloc(ss)
  ibest=iloc(1)-5+ibest
  xdt=(ibest-1)*dt2 - 0.5
  sync=smax

! Extract complex symbols and tone powers
! FT4: 103 symbols, 4 tones per symbol (FT8: 79 symbols, 8 tones)
  do k=1,NN
    i1=ibest+(k-1)*NSS
    csymb=cmplx(0.0,0.0)
    if( i1.ge.0 .and. i1+NSS-1 .le. NP2-1 ) csymb=cd0(i1:i1+NSS-1)
    call four2a(csymb,NSS,1,-1,1)
    cs(0:3,k)=csymb(1:4)/1e3          !FT4: bins 1:4 (FT8: 1:8)
    s4(0:3,k)=abs(csymb(1:4))         !FT4: 4 tones (FT8: s8, 8 tones)
  enddo

! Compute bit metrics for 3 data blocks, 3 symbol-sequence lengths
! FT4: 4-FSK, 2 bits/symbol, graymap = /0,1,3,2/
! Data symbols at positions: 5-33 (block 1), 38-66 (block 2), 71-99 (block 3)
  bmeta=0.
  bmetb=0.
  bmetc=0.
  bmetd=0.
  do nseq=1,3
    if(nseq.eq.1) nsym=1
    if(nseq.eq.2) nsym=2
    if(nseq.eq.3) nsym=4
    nt=2**(2*nsym)
    do iblock=1,3
      if(iblock.eq.1) ksoff=4
      if(iblock.eq.2) ksoff=37
      if(iblock.eq.3) ksoff=70
      do k=1,29,nsym
        ks=k+ksoff
        do itone=0,nt-1
          i1=itone/64
          i2=iand(itone,63)/16
          i3=iand(itone,15)/4
          i4=iand(itone,3)
          if(nsym.eq.1) then
            s2(itone)=abs(cs(graymap(i4),ks))
          elseif(nsym.eq.2) then
            s2(itone)=abs(cs(graymap(i3),ks)+cs(graymap(i4),ks+1))
          elseif(nsym.eq.4) then
            s2(itone)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks+1)+ &
                         cs(graymap(i3),ks+2)+cs(graymap(i4),ks+3))
          endif
        enddo
        i32=1+(k-1)*2+(iblock-1)*58
        if(nsym.eq.1) ibmax=1
        if(nsym.eq.2) ibmax=3
        if(nsym.eq.4) ibmax=7
        do ib=0,ibmax
          bm=maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)) - &
             maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib))
          if(i32+ib .gt.174) cycle
          if(nseq.eq.1) then
            bmeta(i32+ib)=bm
            den=max(maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)), &
                    maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib)))
            if(den.gt.0.0) then
              bmetd(i32+ib)=bm/den
            else
              bmetd(i32+ib)=0.0
            endif
          elseif(nseq.eq.2) then
            bmetb(i32+ib)=bm
          elseif(nseq.eq.3) then
            bmetc(i32+ib)=bm
          endif
        enddo
      enddo
    enddo
  enddo
  call normalizebmet(bmeta,174)
  call normalizebmet(bmetb,174)
  call normalizebmet(bmetc,174)
  call normalizebmet(bmetd,174)

  scalefac=2.83
  llra=scalefac*bmeta
  llrb=scalefac*bmetb
  llrc=scalefac*bmetc
  llrd=scalefac*bmetd

  MAXMSG=206
  pbest=0.
  dmin=1.e30
  nharderrors=-1
  i4tone=0

  do imsg=1,MAXMSG
     msg=trim(call_1)//' '//trim(call_2)
     i=imsg
     if(call_1(1:3).eq.'CQ ' .and. i.ne.5) msg='QU1RK '//trim(call_2)
     if(.not.std_1) then
        if(i.eq.1 .or. i.ge.6)  msg='<'//trim(call_1)//'> '//trim(call_2)
        if(i.ge.2 .and. i.le.4) msg=trim(call_1)//' <'//trim(call_2)//'>'
     else if(.not.std_2) then
        if(i.le.4 .or. i.eq.6) msg='<'//trim(call_1)//'> '//trim(call_2)
        if(i.ge.7) msg=trim(call_1)//' <'//trim(call_2)//'>'
     endif
     j0=len(trim(msg))+2
     if(i.eq.2) msg(j0:j0+2)='RRR'
     if(i.eq.3) msg(j0:j0+3)='RR73'
     if(i.eq.4) msg(j0:j0+1)='73'
     if(i.eq.5) then
        if(std_2) then
           msg='CQ '//trim(call_2)
           if(call_1(3:3).eq.'_') msg=trim(call_1)//' '//trim(call_2)
           if(grid4.ne.'RR73') msg=trim(msg)//' '//grid4
        endif
        if(.not.std_2) msg='CQ '//trim(call_2)
     endif
     if(i.eq.6 .and. std_2) msg(j0:j0+3)=grid4
     if(i.ge.7) then
        isnr = -50 + (i-7)/2
        if(iand(i,1).eq.1) then
           write(msg(j0:j0+2),'(i3.2)') isnr
           if(msg(j0:j0).eq.' ') msg(j0:j0)='+'
        else
           write(msg(j0:j0+3),'("R",i3.2)') isnr
           if(msg(j0+1:j0+1).eq.' ') msg(j0+1:j0+1)='+'
        endif
     endif

     call genft4(msg,0,msgsent,msgbits,i4tone)  !Source-encode this message
     if(msgsent(1:3).eq.'***') cycle             !Skip bad message hypotheses
     call encode174_91(msgbits,cw)                !Get codeword for this message
     pow=0.0
     do i=1,NN
        pow=pow+s4(i4tone(i),i)**2
     enddo

     hdec=0
     where(llra.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     da=sum(nxor*abs(llra))

     hdec=0
     where(llrb.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     dbb=sum(nxor*abs(llrb))

     hdec=0
     where(llrc.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     dc=sum(nxor*abs(llrc))

     hdec=0
     where(llrd.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     dd=sum(nxor*abs(llrd))

     dm=min(da,dbb,dc,dd)
     dmm(imsg)=dm
     if(dm.lt.dmin) then
        dmin=dm
        msgbest=msgsent
        pbest=pow
        if(dm.eq.da) then
           nharderrors=count((2*cw-1)*llra.lt.0.0)
        else if(dm.eq.dbb) then
           nharderrors=count((2*cw-1)*llrb.lt.0.0)
        else if(dm.eq.dc) then
           nharderrors=count((2*cw-1)*llrc.lt.0.0)
        else if(dm.eq.dd) then
           nharderrors=count((2*cw-1)*llrd.lt.0.0)
        endif
     endif

  enddo  ! imsg

  iloc=minloc(dmm)
  dmm(iloc(1))=1.e30
  iloc=minloc(dmm)
  dmin2=dmm(iloc(1))
  xsnr=-21.
  arg=pbest/xbase/3.0e6-1.0
  if(arg.gt.0.0) xsnr=max(-22.0,db(arg)-22.0)
  if(dmin.gt.100.0 .or. dmin2/dmin.lt.1.3) nharderrors=-1
  msg37=msgbest
  if(msg37(1:3).eq.'CQ ' .and. std_2 .and. grid4.eq.'    ') nharderrors=-1
  if(msg37(1:6).eq.'QU1RK ') nharderrors=-1

  return
end subroutine ft4_a7d

end module ft4_a7

subroutine bpdecode174_91(llr,apmask,maxiterations,message77,cw,nharderror,iter,ncheck)
!
! A log-domain belief propagation decoder for the (174,91) code.
!
use iso_c_binding, only: c_loc,c_size_t
use crc
integer, parameter:: N=174, K=91, M=N-K
integer*1 cw(N),apmask(N)
integer*1 decoded(K)
integer*1 message77(77)
integer nrw(M),ncw
integer Nm(7,M)   
integer Mn(3,N)  ! 3 checks per bit
integer synd(M)
real tov(3,N)
real toc(7,M)
real tanhtoc(7,M)
real zn(N)
real llr(N)
real Tmn

include "ldpc_174_91_c_parity.f90"

decoded=0
toc=0
tov=0
tanhtoc=0
! initialize messages to checks
do j=1,M
  do i=1,nrw(j)
    toc(i,j)=llr((Nm(i,j)))
  enddo
enddo

ncnt=0
nclast=0

do iter=0,maxiterations

! Update bit log likelihood ratios (tov=0 in iteration 0).
  do i=1,N
    if( apmask(i) .ne. 1 ) then
      zn(i)=llr(i)+sum(tov(1:ncw,i))
    else
      zn(i)=llr(i)
    endif
  enddo

! Check to see if we have a codeword (check before we do any iteration).
  cw=0
  where( zn .gt. 0. ) cw=1
  ncheck=0
  do i=1,M
    synd(i)=sum(cw(Nm(1:nrw(i),i)))
    if( mod(synd(i),2) .ne. 0 ) ncheck=ncheck+1
!   if( mod(synd(i),2) .ne. 0 ) write(*,*) 'check ',i,' unsatisfied'
  enddo
! write(*,*) 'number of unsatisfied parity checks ',ncheck
  if( ncheck .eq. 0 ) then ! we have a codeword - if crc is good, return it
    decoded=cw(1:K)
    call chkcrc14a(decoded,nbadcrc)
    nharderror=count( (2*cw-1)*llr .lt. 0.0 )
    if(nbadcrc.eq.0) then
      message77=decoded(1:77)
      return
    endif
  endif

  if( iter.gt.0 ) then  ! this code block implements an early stopping criterion
!  if( iter.gt.10000 ) then  ! this code block implements an early stopping criterion
    nd=ncheck-nclast
    if( nd .lt. 0 ) then ! # of unsatisfied parity checks decreased
      ncnt=0  ! reset counter
    else
      ncnt=ncnt+1
    endif
!    write(*,*) iter,ncheck,nd,ncnt
    if( ncnt .ge. 5 .and. iter .ge. 10 .and. ncheck .gt. 15) then
      nharderror=-1

      return
    endif
  endif
  nclast=ncheck

! Send messages from bits to check nodes 
  do j=1,M
    do i=1,nrw(j)
      ibj=Nm(i,j)
      toc(i,j)=zn(ibj)  
      do kk=1,ncw ! subtract off what the bit had received from the check
        if( Mn(kk,ibj) .eq. j ) then  
          toc(i,j)=toc(i,j)-tov(kk,ibj)
        endif
      enddo
    enddo
  enddo

! send messages from check nodes to variable nodes
  do i=1,M
    tanhtoc(1:7,i)=tanh(-toc(1:7,i)/2)
  enddo

  do j=1,N
    do i=1,ncw
      ichk=Mn(i,j)  ! Mn(:,j) are the checks that include bit j
      Tmn=product(tanhtoc(1:nrw(ichk),ichk),mask=Nm(1:nrw(ichk),ichk).ne.j)
      call platanh(-Tmn,y)
!      y=atanh(-Tmn)
      tov(i,j)=2*y
    enddo
  enddo

enddo
nharderror=-1
return
end subroutine bpdecode174_91

module fftw3_constants
  implicit none

  integer, parameter :: FFTW_R2HC              = 0
  integer, parameter :: FFTW_HC2R              = 1
  integer, parameter :: FFTW_DHT               = 2
  integer, parameter :: FFTW_REDFT00           = 3
  integer, parameter :: FFTW_REDFT01           = 4
  integer, parameter :: FFTW_REDFT10           = 5
  integer, parameter :: FFTW_REDFT11           = 6
  integer, parameter :: FFTW_RODFT00           = 7
  integer, parameter :: FFTW_RODFT01           = 8
  integer, parameter :: FFTW_RODFT10           = 9
  integer, parameter :: FFTW_RODFT11           = 10

  integer, parameter :: FFTW_FORWARD           = -1
  integer, parameter :: FFTW_BACKWARD          = +1

  integer, parameter :: FFTW_MEASURE           = 0
  integer, parameter :: FFTW_DESTROY_INPUT     = 1
  integer, parameter :: FFTW_UNALIGNED         = 2
  integer, parameter :: FFTW_CONSERVE_MEMORY   = 4
  integer, parameter :: FFTW_EXHAUSTIVE        = 8
  integer, parameter :: FFTW_PRESERVE_INPUT    = 16
  integer, parameter :: FFTW_PATIENT           = 32
  integer, parameter :: FFTW_ESTIMATE          = 64
  integer, parameter :: FFTW_ESTIMATE_PATIENT  = 128
  integer, parameter :: FFTW_BELIEVE_PCOST     = 256
  integer, parameter :: FFTW_DFT_R2HC_ICKY     = 512
  integer, parameter :: FFTW_NONTHREADED_ICKY  = 1024
  integer, parameter :: FFTW_NO_BUFFERING      = 2048
  integer, parameter :: FFTW_NO_INDIRECT_OP    = 4096
  integer, parameter :: FFTW_ALLOW_LARGE_GENERIC = 8192
  integer, parameter :: FFTW_NO_RANK_SPLITS    = 16384
  integer, parameter :: FFTW_NO_VRANK_SPLITS   = 32768
  integer, parameter :: FFTW_NO_VRECURSE       = 65536
  integer, parameter :: FFTW_NO_SIMD           = 131072

end module fftw3_constants

subroutine subtractft8(dd0,itone,f0,dt,lrefinedt)

! Subtract an ft8 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  parameter (NMAX=15*12000,NFRAME=1920*79)
  parameter (NFFT=NMAX,NFILT=3850)
  real dd(NMAX),dd0(NMAX)
  real window(-NFILT/2:NFILT/2)
  real x(NFFT+2)
  real endcorrection(NFILT/2+1)
  complex cx(0:NFFT/2)
  complex cref,camp,cfilt,cw,z
  integer itone(79)
  logical first,lrefinedt,ldt
  data first/.true./
  common/heap8/cref(NFRAME),camp(NMAX),cfilt(NMAX),cw(NMAX)
  equivalence (x,cx)
  save first,/heap8/,endcorrection

  if(first) then                         ! Create and normalize the filter
     pi=4.0*atan(1.0)
     fac=1.0/float(nfft)
     sumw=0.0
     do j=-NFILT/2,NFILT/2
        window(j)=cos(pi*j/NFILT)**2
        sumw=sumw+window(j)
     enddo
     cw=0.
     cw(1:NFILT+1)=window/sumw
     cw=cshift(cw,NFILT/2+1)
     call four2a(cw,nfft,1,-1,1)
     cw=cw*fac
     first=.false.
     do j=1,NFILT/2+1
       endcorrection(j)=1.0/(1.0-sum(window(j-1:NFILT/2))/sumw)
     enddo
  endif

! Generate complex reference waveform cref
  call gen_ft8wave(itone,79,1920,2.0,12000.0,f0,cref,xjunk,1,NFRAME)

  ldt=lrefinedt
  if(ldt) then                         !Are we refining DT ?
     sqa=sqf(-90)
     sqb=sqf(+90)
     sq0=sqf(0)
     call peakup(sqa,sq0,sqb,dx)
     if(abs(dx).gt.1.0) return         !No acceptable minimum: do not subtract
     i2=nint(90.0*dx)                  !Best estimate of idt
     ldt=.false.
     sq0=sqf(i2)                       !Do the subtraction with idt=i2
  else
     sq0=sqf(0)                        !Do the subtraction with idt=0
  endif
  dd0=dd                               !Return dd0 with this signal subtracted
!  write(44,3044) nint(f0),dt-0.5,1.e-8*sum(dd*dd)
!3044 format(i4,f7.2,f10.6)
  return

contains

  real function sqf(idt)         !Internal function: all variables accessible
    nstart=dt*12000+1 + idt
    camp=0.
    dd=dd0
    do i=1,nframe
       j=nstart-1+i 
       if(j.ge.1.and.j.le.NMAX) camp(i)=dd(j)*conjg(cref(i))
    enddo

    cfilt(1:nframe)=camp(1:nframe)
    cfilt(nframe+1:)=0.0
    call four2a(cfilt,nfft,1,-1,1)
    cfilt(1:nfft)=cfilt(1:nfft)*cw(1:nfft)
    call four2a(cfilt,nfft,1,1,1)
    cfilt(1:NFILT/2+1)=cfilt(1:NFILT/2+1)*endcorrection
    cfilt(nframe:nframe-NFILT/2:-1)=cfilt(nframe:nframe-NFILT/2:-1)*endcorrection
    x=0.
    do i=1,nframe
       j=nstart+i-1
       if(j.ge.1 .and. j.le.NMAX) then
          z=cfilt(i)*cref(i)
          dd(j)=dd(j)-2.0*real(z)      !Subtract the reconstructed signal
          x(i)=dd(j)
       endif
    enddo
    sqq=0.
    if(ldt) then
       call four2a(cx,NFFT,1,-1,0)                    !Forward FFT, r2c
       df=12000.0/NFFT
       ia=(f0-1.5*6.25)/df
       ib=(f0+8.5*6.25)/df
       do i=ia,ib
          sqq=sqq + real(cx(i))*real(cx(i)) + aimag(cx(i))*aimag(cx(i))
       enddo
    endif
    sqf=sqq
    return
  end function sqf

end subroutine subtractft8

program allsim

! Generate simulated data for WSJT-X modes: JT4, JT9, JT65, FT8, FT4, QRA64,
! and WSPR.  Also unmodulated carrier and 20 WPM CW.

  use wavhdr
  use packjt
  parameter (NMAX=60*12000)
  type(hdr) h                            !Header for the .wav file
  integer*2 iwave(NMAX)                  !Generated waveform (no noise)
  integer itone(206)                     !Channel symbols (values 0-8)
  integer icw(250)                       !Encoded CW message bits
  integer*1 msgbits(101)                 !Encoded message bits for FST4 FT8 FT4
  real dat(NMAX)                         !Audio waveform
  complex cwave(NMAX)
  real wave(NMAX)
  character message*22,msgsent*22,arg*8
  character*37 msg37,msgsent37

  nargs=iargc()
  if(nargs.ne.1 .and. nargs.ne.2) then
     print*,'Usage:    allsim snr [isig]'
     print*,'Examples: allsim -10           #Include all signal types'
     print*,'          allsim -10 6         #Include FT8 only'
     print*,'isig order:    1     2   3    4   5   6   7   8   9   10'
     print*,'            Carrier CW WSPR FST4 JT9 JT4 FT8 FT4 Q65 JT65'
     go to 999
  endif

  call getarg(1,arg)
  read(arg,*) snrdb                  !S/N in dB (2500 hz reference BW)
  isig=0
  if(nargs.eq.2) then
     call getarg(2,arg)
     read(arg,*) isig
  endif

  message='CQ KA2ABC FN20'
  msg37=message//'               '
  rmsdb=25.
  rms=10.0**(0.05*rmsdb)
  sig=10.0**(0.05*snrdb)

  call init_random_seed()       !Seed Fortran RANDOM_NUMBER generator
  call sgran()                  !Seed C rand generator (used in gran)

  h=default_header(12000,NMAX)
  open(10,file='000000_0000.wav',access='stream',status='unknown')
  do i=1,NMAX                   !Generate gaussian noise
     dat(i)=gran()
  enddo

  itone=0
  if(isig.eq.0 .or. isig.eq.1) then
     call addit(itone,12000,85,6912,400,sig,dat)    !1 Unmodulated carrier
  endif

  if(isig.eq.0 .or. isig.eq.2) then
     call morse('CQ CQ DE KA2ABC KA2ABC',icw,ncw)
     call addcw(icw,ncw,600,sig,dat)                !2 CW at 20 WPM
  endif

  if(isig.eq.0 .or. isig.eq.3) then
     call genwspr(message,msgsent,itone)
     call addit(itone,12000,86,8192,800,sig,dat)    !3 WSPR (only 59 s of data)
  endif

  if(isig.eq.0 .or. isig.eq.4) then                    !4 FST4-60
     iwspr=0
     call genfst4(msg37,0,msgsent37,msgbits,itone,iwspr)
     nwave=162*3888
     call gen_fst4wave(itone,160,3888,nwave,12000.0,1,1000.0,0,cwave,wave)
     dat(6001:6000+nwave)=dat(6001:6000+nwave) + sig*wave(1:nwave)
  endif

  if(isig.eq.0 .or. isig.eq.5) then
     call gen9(message,0,msgsent,itone,itype)
     call addit(itone,12000,85,6912,1200,sig,dat)      !4 JT9
  endif

  if(isig.eq.0 .or. isig.eq.6) then
     call gen4(message,0,msgsent,itone,itype)
     call addit(itone,11025,206,2520,1400,sig,dat)     !6 JT4
  endif

  if(isig.eq.0 .or. isig.eq.7) then
     call genft8(msg37,i3,n3,msgsent37,msgbits,itone)  !7 FT8
     nwave=79*1920
     call gen_ft8wave(itone,79,1920,2.0,12000.0,1600.0,cwave,wave,0,nwave)
     dat(6001:6000+nwave)=dat(6001:6000+nwave) + sig*wave(1:nwave)
     k=30*12000
     dat(6001+k:6000+nwave+k)=dat(6001+k:6000+nwave+k) + sig*wave(1:nwave)
  endif

  if(isig.eq.0 .or. isig.eq.8) then
     call genft4(msg37,0,msgsent37,msgbits,itone)      !8 FT4
     nwave=105*576
     call gen_ft4wave(itone,103,576,12000.0,1800.0,cwave,wave,0,nwave)
     dat(6001:6000+nwave)=dat(6001:6000+nwave) + sig*wave(1:nwave)
     k=15*12000
     dat(6001+k:6000+nwave+k)=dat(6001+k:6000+nwave+k) + sig*wave(1:nwave)
     k=30*12000
     dat(6001+k:6000+nwave+k)=dat(6001+k:6000+nwave+k) + sig*wave(1:nwave)
     k=45*12000
     dat(6001+k:6000+nwave+k)=dat(6001+k:6000+nwave+k) + sig*wave(1:nwave)
  endif

  if(isig.eq.0 .or. isig.eq.9) then
     call genq65(msg37,0,msgsent37,itone,i3,n3)
     call addit(itone,12000,85,7200,2000,sig,dat)      !9 Q65
  endif

  if(isig.eq.0 .or. isig.eq.10) then
     call gen65(message,0,msgsent,itone,itype)
     call addit(itone,11025,126,4096,2200,sig,dat)     !10 JT65A
  endif

  iwave=nint(rms*dat)
  write(10) h,iwave
  close(10)

999 end program allsim

module cacb_mod
   implicit none
   complex, allocatable :: ca(:), cb(:)  ! FFTs of input

contains
   subroutine init_cacb(n)
      use iso_fortran_env
      integer, intent(in) :: n
      if (.not. allocated(ca)) allocate (ca(n))
      if (.not. allocated(cb)) allocate (cb(n))
   end subroutine init_cacb

end module cacb_mod

subroutine q65_sync(ss,i0,nts_q65,ntrperiod,iseq,sync_ok,snr,xdt)

! Test for presence of Q65 sync tone

  parameter (NFFT=32768)
  parameter (LAGMAX=33)
  real ss(400,NFFT)                !Symbol spectra
  real ccf(0:LAGMAX)               !The WSJT "blue curve", peak at DT
  logical sync_ok
  integer isync0(22),isync(22),ipk(1)

! Q65 sync symbols
  data isync0/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/

  sync_ok=.false.
!  if(ntrperiod.ne.60) return
  
  tstep=0.15                      !0.5*tsym_Q65-30x, 0.25*tsys_Q65-60x
  nfac=4
  if(ntrperiod.eq.30) nfac=2
  do i=1,22                                !Expand sync stride for Q65-60x
     isync(i)=nfac*(isync0(i)-1) + 1
  enddo

  m=nts_q65/2
  if(ntrperiod.eq.30) m=nts_q65/4
  i1=max(1,i0-m)
  i2=min(NFFT,i0+m)
  ccf=0.
  do lag=0,LAGMAX                     !Search over range of DT
     do j=1,22                        !Test for Q65 sync
        k=isync(j) + lag + iseq*200
        if(k.ge.400) cycle
        if(ntrperiod.eq.60) then
           ccf(lag)=ccf(lag) + sum(ss(k,i1:i2)) + sum(ss(k+1,i1:i2)) &
                + sum(ss(k+2,i1:i2)) + sum(ss(k+3,i1:i2))
        else
           ccf(lag)=ccf(lag) + sum(ss(k,i1:i2)) + sum(ss(k+1,i1:i2))
        endif
! Q: Should we use weighted sums, perhaps a Lorentzian peak?
     enddo
  enddo
  ccfmax=maxval(ccf)
  ipk=maxloc(ccf)
  lagbest=ipk(1)-1
  xdt=lagbest*tstep - 1.0
  if(ntrperiod.eq.30) xd=xdt+0.6      !Why ???

  xsum=0.
  sq=0.
  nsum=0
  fpk=0.001*i0*96000.0/32768.0 + 32.0
  do i=0,lagmax                       !Compute ave and rms of "blue curve"
     if(abs(i-lagbest).gt.2) then
        xsum=xsum+ccf(i)
        sq=sq+ccf(i)**2
        nsum=nsum+1
     endif
!     write(40,3040) i,i*tstep-1.0,ccf(i),fpk
!3040 format(i5,3f8.2)
  enddo
  ave=xsum/nsum
  rms=sqrt(sq/nsum - ave*ave)
  snr=(ccfmax-ave)/rms
  sync_ok=snr.ge.5.0                  !Require snr > 5.0 for sync detection

  return
end subroutine q65_sync

subroutine fast9(id2,narg,line)

! Decoder for "fast9" modes, JT9E to JT9H.

  parameter (NMAX=30*12000,NSAVE=500)
  integer*2 id2(0:NMAX)
  integer narg(0:14)
  integer*1 i1SoftSymbols(207)
  integer*1 i1save(207,NSAVE)
  integer indx(NSAVE)
  integer*8 count0,count1,clkfreq
  real s1(720000)                      !To reserve space.  Logically s1(nq,jz)
  real s2(240,340)                     !Symbol spectra at quarter-symbol steps
  real ss2(0:8,85)                     !Folded symbol spectra
  real ss3(0:7,69)                     !Folded spectra without sync symbols
  real s(1500)
  real ccfsave(NSAVE)
  real t0save(NSAVE)
  real t1save(NSAVE)
  real freqSave(NSAVE)
  real t(6)
  character*22 msg                     !Decoded message
  character*80 line(100)
  data nsubmode0/-1/,ntot/0/
  save s1,nsubmode0,ntot

! Parameters from GUI are in narg():
  nutc=narg(0)                         !UTC
  npts=min(narg(1),NMAX)               !Number of samples in id2 (12000 Hz)
  nsubmode=narg(2)                     !0=A 1=B 2=C 3=D 4=E 5=F 6=G 7=H
  if(nsubmode.lt.4) go to 900
  newdat=narg(3)                       !1==> new data, compute symbol spectra
  minsync=narg(4)                      !Lower sync limit
  npick=narg(5)
  t0=0.001*narg(6)
  t1=0.001*narg(7)
  maxlines=narg(8)                     !Max # of decodes to return to caller
  nmode=narg(9)
  nrxfreq=narg(10)                     !Targer Rx audio frequency (Hz)
  ntol=narg(11)                        !Search range, +/- ntol (Hz)

  tmid=npts*0.5/12000.0
  line(1:100)(1:1)=char(0)
  s=0
  s2=0
  nsps=60 * 2**(7-nsubmode)            !Samples per sysbol
  nfft=2*nsps                          !FFT size
  nh=nfft/2
  nq=nfft/4
  istep=nsps/4                         !Symbol spectra at quarter-symbol steps
  jz=npts/istep
  df=12000.0/nfft                      !FFT bin width
  db1=db(2500.0/df)
  nfa=max(200,nrxfreq-ntol)            !Lower frequency limit
  nfb=min(nrxfreq+ntol,2500)           !Upper frequency limit
  nline=0
  t=0.

  if(newdat.eq.1 .or. nsubmode.ne.nsubmode0) then
     call system_clock(count0,clkfreq)
     call spec9f(id2,npts,nsps,s1,jz,nq)          !Compute symbol spectra, s1 
     call system_clock(count1,clkfreq)
     t(1)=t(1)+float(count1-count0)/float(clkfreq)
  endif

  nsubmode0=nsubmode
  tmsg=nsps*85.0/12000.0
  limit=2000
  nlen0=0
  i1=0
  i2=0
  ccfsave=0.
  do ilength=1,14
     nlen=1.4142136**(ilength-1)
     if(nlen.gt.jz/340) nlen=jz/340
     if(nlen.eq.nlen0) cycle
     nlen0=nlen

     db0=db(float(nlen))
     jlen=nlen*340
     jstep=jlen/4                      !### Is this about right? ###
     if(nsubmode.ge.6) jstep=jlen/2

     do ja=1,jz-jlen,jstep
        jb=ja+jlen-1
        call system_clock(count0,clkfreq)
        call foldspec9f(s1,nq,jz,ja,jb,s2)        !Fold symbol spectra into s2
        call system_clock(count1,clkfreq)
        t(2)=t(2)+float(count1-count0)/float(clkfreq)

! Find sync; put sync'ed symbol spectra into ss2 and ss3
! Might want to do a peakup in DT and DF, then re-compute symbol spectra.

        call system_clock(count0,clkfreq)
        call sync9f(s2,nq,nfa,nfb,ss2,ss3,lagpk,ipk,ccfbest)
        call system_clock(count1,clkfreq)
        t(3)=t(3)+float(count1-count0)/float(clkfreq)

        i1=i1+1
        if(ccfbest.lt.30.0) cycle
        call system_clock(count0,clkfreq)
        call softsym9f(ss2,ss3,i1SoftSymbols)     !Compute soft symbols
        call system_clock(count1,clkfreq)
        t(4)=t(4)+float(count1-count0)/float(clkfreq)

        i2=i2+1
        ccfsave(i2)=ccfbest
        i1save(1:207,i2)=i1SoftSymbols
        t0=(ja-1)*istep/12000.0
        t1=(jb-1)*istep/12000.0
        t0save(i2)=t0
        t1save(i2)=t1
        freq=ipk*df
        freqSave(i2)=freq
     enddo
  enddo
  nsaved=i2

  ccfsave(1:nsaved)=-ccfsave(1:nsaved)
  call system_clock(count0,clkfreq)
  indx=0
  call indexx(ccfsave,nsaved,indx)
  call system_clock(count1,clkfreq)
  t(5)=t(5)+float(count1-count0)/float(clkfreq)

  ccfsave(1:nsaved)=-ccfsave(1:nsaved)

  do iter=1,2
!     do isave=1,nsaved
     do isave=1,50
        i2=indx(isave)
        if(i2.lt.1 .or. i2.gt.nsaved) cycle      !### Why needed? ###
        t0=t0save(i2)
        t1=t1save(i2)
        if(iter.eq.1 .and. t1.lt.tmid) cycle
        if(iter.eq.2 .and. t1.ge.tmid) cycle
        ccfbest=ccfsave(i2)
        i1SoftSymbols=i1save(1:207,i2)
        freq=freqSave(i2)
        call system_clock(count0,clkfreq)
        call jt9fano(i1SoftSymbols,limit,nlim,msg)      !Invoke Fano decoder
        call system_clock(count1,clkfreq)
        t(6)=t(6)+float(count1-count0)/float(clkfreq)

        i=t0*12000.0
        kz=(t1-t0)/0.02
        smax=0.
        do k=1,kz
           sq=0.
           do n=1,240
              i=i+1
              x=id2(i)
              sq=sq+x*x
           enddo
           s(k)=sq/240.
           smax=max(s(k),smax)
        enddo
        call pctile(s,kz,35,base)
        snr=smax/(1.1*base) - 1.0
        nsnr=-20
        if(snr.gt.0.0) nsnr=nint(db(snr))

!        write(72,3002) nutc,iter,isave,nlen,tmid,t0,t1,ccfbest,   &
!             nint(freq),nlim,msg
!3002    format(i6.6,i1,i4,i3,4f6.1,i5,i7,1x,a22)

        if(msg.ne.'                      ') then

! Display multiple decodes only if they differ:
           do n=1,nline
              if(index(line(n),msg).gt.1) go to 100
           enddo
!### Might want to use decoded message to get a complete estimate of S/N.
           nline=nline+1
           write(line(nline),1000) nutc,nsnr,t0,nint(freq),msg,char(0)
1000       format(i6.6,i4,f5.1,i5,1x,'@ ',1x,a22,a1)
           ntot=ntot+1
!           write(70,5001) nsaved,isave,nline,maxlines,ntot,nutc,msg
!5001       format(5i5,i7.6,1x,a22)
           if(nline.ge.maxlines) go to 900
        endif
100     continue
     enddo
  enddo

900 continue
!  write(*,6001) t,t(6)/sum(t)
!6001 format(7f10.3)

  return
end subroutine fast9

subroutine pltanh(x,y)
  isign=+1
  z=x
  if( x.lt.0 ) then
    isign=-1
    z=abs(x)
  endif
  if( z.le. 0.8 ) then
    y=0.83*x
    return
  elseif( z.le. 1.6 ) then
    y=isign*(0.322*z+0.4064)
    return  
  elseif( z.le. 3.0 ) then
    y=isign*(0.0524*z+0.8378)
    return
  elseif( z.lt. 7.0 ) then
    y=isign*(0.0012*z+0.9914)
    return
  else
    y=isign*0.9998
    return
  endif
end subroutine pltanh

subroutine map65_mmdec(nutc,id2,nqd,ntrperiod, nsubmode,nfa,nfb,nfqso,   &
     ntol,newdat,nagain,max_drift,ndepth,mycall,hiscall,hisgrid)

  use prog_args
  use timer_module, only: timer
  use q65_decode

  include 'jt9com.f90'
  include 'timer_common.inc'

  type, extends(q65_decoder) :: counting_q65_decoder
     integer :: decoded
  end type counting_q65_decoder

  logical single_decode,bVHF,lnewdat,lagain,lclearave,lapcqonly
  integer*2 id2(300*12000)
  integer nqf(20)
!  type(params_block) :: params
  character(len=12) :: mycall, hiscall
  character(len=6) :: hisgrid
  data ntr0/-1/
  save
  type(counting_q65_decoder) :: my_q65

! Cast C character arrays to Fortran character strings
!  datetime=transfer(params%datetime, datetime)
!  mycall=transfer(params%mycall,mycall)
!  hiscall=transfer(params%hiscall,hiscall)
!  mygrid=transfer(params%mygrid,mygrid)
!  hisgrid=transfer(params%hisgrid,hisgrid)

  my_q65%decoded = 0
  ncontest=0
  nQSOprogress=0
  lclearave=.false.
  single_decode=.false.
  lapcqonly=.false.
  lnewdat=(newdat.ne.0)
  lagain=(nagain.ne.0)
  bVHF=.true.
  emedelay=2.5
!  ntrperiod=60

  call timer('dec_q65 ',0)
  call my_q65%decode(q65_decoded,id2,nqd,nutc,ntrperiod,nsubmode,nfqso,       &
       ntol,ndepth,nfa,nfb,lclearave,single_decode,lagain,max_drift,lnewdat,  &
       emedelay,mycall,hiscall,hisgrid,nQSOProgress,ncontest,lapcqonly,navg0,nqf)
  call timer('dec_q65 ',1)

  return

contains

  subroutine q65_decoded (this,nutc,snr1,nsnr,dt,freq,decoded,idec,   &
       nused,ntrperiod)

    use q65_decode
    implicit none

    class(q65_decoder), intent(inout) :: this
    integer, intent(in) :: nutc
    real, intent(in) :: snr1
    integer, intent(in) :: nsnr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=37), intent(in) :: decoded
    integer, intent(in) :: idec
    integer, intent(in) :: nused
    integer, intent(in) :: ntrperiod

    if(nutc+snr1+nsnr+dt+freq+idec+nused+ntrperiod.eq.-999) stop
    if(decoded.eq.'-999') stop

    cq0='q  '
    write(cq0(2:2),'(i1)') idec
    if(nused.ge.2) write(cq0(3:3),'(i1)') nused
    nsnr0=nsnr
    xdt0=dt
    nfreq0=nint(freq)
    msg0=decoded

    select type(this)
    type is (counting_q65_decoder)
       if(idec.ge.0) this%decoded = this%decoded + 1
    end select

   return
 end subroutine q65_decoded
  
end subroutine map65_mmdec

module sleep_msec_mod
  implicit none

  interface
     subroutine usleep(usec)
       ! Fortran-only interface to the C function usleep_
       integer(kind=8), intent(in) :: usec
     end subroutine usleep
  end interface

contains

  subroutine sleep_msec(n)
    integer, intent(in) :: n
    integer(kind=8) :: usec

    usec = int(n, kind=8) * 1000_8
    call usleep(usec)
  end subroutine sleep_msec

end module sleep_msec_mod

program mskber

! Generate an MSK waveform, pass it through an AWGN channel, apply coherent 
! MSK receiver, and count number of errors at each Eb/No.

  parameter (MAXSYM=1000*1000)
  parameter (NSPS=5)                        !Samples per symbol
  real ct(-NSPS:NSPS*MAXSYM-1)              !cos(pi*t/2T)
  real st(-NSPS:NSPS*MAXSYM-1)              !sin(pi*t/2T)
  real r(0:MAXSYM-1)                        !Random numbers to set test bits
  real xsym(0:MAXSYM-1)                     !Soft Rx symbols

  complex xt(-NSPS:NSPS*MAXSYM-1)           !Complex baseband Tx waveform
  complex nt(-NSPS:NSPS*MAXSYM-1)           !Generated AWGN channel noise
  complex yt(-NSPS:NSPS*MAXSYM-1)           !Received signal, yt = xt + fac*nt
  complex cwave(-NSPS:NSPS*MAXSYM-1)        !Audio waveform, Tx real part
  complex z

  integer sym0(0:MAXSYM-1)                  !Generated test bits
  integer sym(0:MAXSYM-1)                   !Hard-copy received bits
  integer sym1(0:7)

  character*12 arg
  data sym1/1,1,0,0,0,1,1,1/

  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage:  mskber nsym EbNo'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nsym
  call getarg(2,arg)
  read(arg,*) EbNo

  pi=4.0*atan(1.0)

  do i=-NSPS,NSPS*nsym-1                  !Define ct, st arrays
     t=i*pi/(2.0*NSPS)
     ct(i)=cos(t)
     st(i)=sin(t)
  enddo
  fac=1.0/sqrt(float(NSPS))

  do iEbNo=0,10                                  !Loop over a range of Eb/No
     sym0=0
     call random_number(r)
     where(r(0:nsym-1).gt.0.5) sym0(0:nsym-1)=1  !Generate random data bits
     if(nsym.eq.8) sym0(0:nsym-1)=sym1
     call mskmod(sym0,nsym,NSPS,ct,st,xt,cwave)  !Generate Tx waveform

     do i=-NSPS,NSPS*nsym-1                      !Generate Gaussian noise
        xx=0.707*gran()
        yy=0.707*gran()
        nt(i)=cmplx(xx,yy)
     enddo
     fac_noise=10.0**(-iEbNo/20.0)
     if(EbNo.ne.0.0) fac_noise=10.0**(-EbNo/20.0)
     yt=xt + fac_noise*nt                        !Rx signal, with noise

     call mskdemod(yt,nsym,NSPS,ct,st,xsym)      !MSK demodulator

     sym=0
     where(xsym.gt.0.0) sym=1

     if(nsym.le.160 .and. EbNo.ne.0.0) then
        write(*,1012) sym0(0:nsym-1)
        if(nsym.gt.50) write(*,1012) 
        write(*,1012) sym(0:nsym-1)
1012    format(50i1)
        do i=-nsps,nsps*nsym-1
           phi=i*2.0*pi*1500/12000.0
           z=cwave(i)*cmplx(cos(phi),sin(phi))    !Mix back to baseband
           write(51,1014) float(i)/nsps,xt(i),abs(xt(i)),cwave(i),z
1014       format(8f8.4)
        enddo
     endif

! Count the hard errors
     nerr=count(sym(0:nsym-1).ne.sym0(0:nsym-1))
     thber=0.5*erfc(10.0**(iEbNo/20.0))
     xEbNo=iEbNo
     if(EbNo.ne.0.0) xEbNo=EbNo
     write(*,1000) xEbNo,thber,float(nerr)/nsym
1000 format(f6.1,2f10.6)
     if(EbNo.ne.0.0) exit
  enddo

999 end program mskber

subroutine mskmod(sym,nsym,nsps,ct,st,xt,cwave)

! Generate MSK Tx waveform at baseband.

  integer sym(0:nsym-1)                   !Hard-copy received bits
  complex xt(-nsps:nsps*nsym-1)           !Complex baseband Tx waveform
  complex cwave(-nsps:nsps*nsym-1)        !Audio waveform, fc=1500 Hz.
  real ct(-nsps:nsps*nsym-1)              !cos(pi*t/2T)
  real st(-nsps:nsps*nsym-1)              !sin(pi*t/2T)
  real ai(-nsps:nsps*nsym-1)              !Rectangular pulses for even symbols
  real aq(-nsps:nsps*nsym-1)              !Rectangular pulses for odd symbols

  ai=0.
  aq=0.
  fac=1.0/sqrt(float(nsps))
  do j=0,nsym-1,2
     ia=(j-1)*nsps
     ib=ia+2*nsps-1
     ai(ia:ib)=2*sym(j)-1                !Even bits as rectangular pulses
     aq(ia+nsps:ib+nsps)=2*sym(j+1)-1    !Odd bits as rectangular pulses
  enddo
  xt=fac*cmplx(ai*ct,aq*st)                  !Baseband Tx waveform

  twopi=8.0*atan(1.0)
  do i=-nsps,nsps*nsym-1
     phi=i*twopi*1500/12000.0
     cwave(i)=xt(i)*cmplx(cos(phi),-sin(phi))
  enddo

  return
end subroutine mskmod

subroutine mskdemod(yt,nsym,nsps,ct,st,xsym) 

! MSK demodulator
! Rx phase must be known and stable; symbol sync must be established.

  complex yt(-nsps:nsps*nsym-1)           !Received signal
  real ct(-nsps:nsps*nsym-1)              !cos(pi*t/2T)
  real st(-nsps:nsps*nsym-1)              !sin(pi*t/2T)
  real xe(-nsps:nsps*nsym-1)              !Temp array for received even symbols
  real xo(-nsps:nsps*nsym-1)              !Temp array for received odd symbols
  real xsym(0:nsym-1)                     !Soft Rx symbols

  iz=nsps*(nsym+1)
  xe(-nsps:nsps*nsym-1)=real(yt)*ct       !Apply matched filters
  xo(-nsps:nsps*nsym-1)=aimag(yt)*st
  do j=0,nsym-1,2
     ia=(j-1)*nsps
     ib=ia+2*nsps-1
     xsym(j)=sum(xe(ia:ib))               !Integrate over 2 symbol lengths
     xsym(j+1)=sum(xo(ia+nsps:ib+nsps))
  enddo

  return
end subroutine mskdemod

subroutine dxped_fifo(cx,gx,isnrx)

  parameter (NCALLS=268)  
  character*6 xcall(NCALLS)
  character*4 xgrid(NCALLS)
  integer isnr(NCALLS)

  character cx*6,gx*4
  common/dxpfifo/nc,isnr,xcall,xgrid

  if(nc.lt.NCALLS) then
     nc=nc+1
     cx=xcall(nc)
     gx=xgrid(nc)
     isnrx=isnr(nc)
  else
     cx='      '
     gx='    '
     isnrx=0
  endif
  
  return
end subroutine dxped_fifo

subroutine libration(jd,RA,Dec,xl,b)

! Compute optical libration of moon at jd: that is, the sub-observer 
! point (xl,b) in selenographic coordinates.  RA and Dec are 
! topocentric values.

  implicit real*8 (a-h,o-z)
  parameter (RADS=0.0174532925199433d0)
  parameter (TWOPI=6.28318530717959d0)
  real*8 jd,j2000,mjd,lambda

  j2000=2451545.0d0
  RA2000=RA
  Dec2000=Dec
  year=2000.0d0 + (jd-j2000)/365.25d0
  mjd=jd-2400000.d0
  call sla_PRECES('FK5',year,2000.d0,RA2000,Dec2000)
  call sla_EQECL(RA2000,Dec2000,mjd,lambda,beta)
  day=jd - j2000
  t = day / 36525.d0
  xi = 1.54242 * RADS
  ft = 93.2720993 + 483202.0175273 * t - .0034029 * t * t
  b= ft / 360
  a = 360 * (b - floor(b))
  if (a.lt.0.d0) a = 360 + a;
  f=a/57.2957795131d0
  omega=sla_dranrm(2.182439196d0 - t*33.7570446085d0 + t*t*3.6236526d-5)
  w = lambda - omega
  y = sin(w) * cos(beta) * cos(xi) - sin(beta) * sin(xi)
  x = cos(w) * cos(beta)
  a = sla_dranrm(atan2(y, x))
  xl = a - f
  if(xl.lt.-0.25*TWOPI) xl=xl+TWOPI             !Fix 'round the back' angles
  if(xl.gt.0.25*TWOPI)  xl=xl-TWOPI
  b = asin(-sin(w) * cos(beta) * sin(xi) - sin(beta) * cos(xi))

  return
end subroutine libration

module stdout_channel_mod
    use iso_c_binding
    implicit none

    !===============================
    ! Types matching the C++ layout
    !===============================
    type, bind(C) :: StdoutSharedHeader
        integer(c_int32_t) :: version
        integer(c_int32_t) :: writeIndex
        integer(c_int32_t) :: dataSize
        integer(c_int32_t) :: seq
    end type StdoutSharedHeader

    !===============================
    ! Internal state
    !===============================
    type(c_ptr)                 :: g_buf_ptr        = c_null_ptr
    type(c_ptr)                 :: g_hdr_ptr        = c_null_ptr
    integer(c_int32_t)          :: g_buf_size       = 0
    integer(c_intptr_t)         :: g_event_handle   = 0

    type(StdoutSharedHeader), pointer :: hdr => null()
    character(kind=c_char), dimension(:), pointer :: buf => null()

    logical :: initialized = .false.

    !===============================
    ! Win32 SetEvent
    !===============================
    interface
        function win_set_event(hEvent) bind(C, name="win_set_event")
            use iso_c_binding
            implicit none
            type(c_ptr), value :: hEvent
            integer(c_int)     :: win_set_event
        end function win_set_event
    end interface

contains

    !=========================================================
    ! Called from C++ before run_m65_ starts
    !=========================================================
subroutine set_stdout_channel(buf_ptr, hdr_ptr, buf_size, event_handle) &
        bind(C, name="set_stdout_channel")

    use iso_c_binding
    implicit none

    !==== Dummy arguments =====================================================
    type(c_ptr),        value, intent(in) :: buf_ptr
    type(c_ptr),        value, intent(in) :: hdr_ptr
    integer(c_int32_t), value, intent(in) :: buf_size
    integer(c_intptr_t),value, intent(in) :: event_handle

    !==== Body ================================================================
    if (c_associated(buf_ptr) .and. c_associated(hdr_ptr) .and. buf_size > 0) then
        g_buf_ptr      = buf_ptr
        g_hdr_ptr      = hdr_ptr
        g_buf_size     = buf_size
        g_event_handle = event_handle

        call c_f_pointer(hdr_ptr, hdr)
        call c_f_pointer(buf_ptr, buf, [buf_size])

        initialized = .true.
    else
        initialized = .false.
    end if
end subroutine set_stdout_channel

    !=========================================================
    ! Safe write into shared memory + event signal
    !=========================================================
subroutine write_stdout(msg)
    use iso_c_binding
    implicit none

    !==== Dummy argument =====================================================
    character(len=*), intent(in) :: msg

    !==== Local variables ====================================================
    integer(c_int32_t) :: n, i, rc
    integer(c_int32_t) :: w, idx
    character(kind=c_char) :: ch

    if (.not. initialized) return
    if (.not. associated(hdr)) return
    if (.not. associated(buf)) return

    ! Length of the message (assumed to include newline)
    n = len_trim(msg)
    if (n <= 0) return

    ! Avoid filling the entire buffer
    if (n >= g_buf_size) n = g_buf_size - 1

    ! Snapshot current write index (0..g_buf_size-1)
    w = hdr%writeIndex
    if (w < 0 .or. w >= g_buf_size) w = 0

    ! Write bytes with wraparound, using 0-based idx and 1-based buf
    do i = 0, n - 1
        idx = w + i
        if (idx >= g_buf_size) idx = idx - g_buf_size
        ch = msg(i+1:i+1)
        buf(idx+1) = ch    ! buf is 1-based; idx is 0-based
    end do

    ! Advance writeIndex to first free slot after the data
    w = w + n
    if (w >= g_buf_size) w = w - g_buf_size
    hdr%writeIndex = w

    ! Optional: bump seq
    hdr%seq = hdr%seq + 1

    rc = win_set_event(transfer(g_event_handle, c_null_ptr))
end subroutine write_stdout

end module stdout_channel_mod

program sumsim

! Sum a number of *.wav files so that multiple signals are present

  use wavhdr
  parameter (NMAX=60*12000)
  type(hdr) h                            !Header for the .wav file
  integer*2 iwave(NMAX)                  !i*2 data
  real wave(NMAX)                        !r*4 data
  character*80 fname

  nargs=iargc()
  if(nargs.lt.1) then
     print*,'Usage:    sumsim file1 [file2, ...]'
     go to 999
  endif
  wave=0.

  do ifile=1,nargs
     call getarg(ifile,fname)
     open(10,file=trim(fname),status='old',access='stream')
     read(10) h
     npts=h%ndata/2
     nfsample=h%nsamrate
     read(10) iwave(1:npts)
     n=len(trim(fname))
     wave(1:npts)=wave(1:npts) + iwave(1:npts)
     rms=sqrt(dot_product(wave(1:npts),wave(1:npts))/npts)
     write(*,1000) ifile,npts,float(npts)/nfsample,rms,fname(n-14:n)
1000 format(i3,i8,f6.1,f10.3,2x,a15)
     close(10)
  enddo

!  fac=1.0/sqrt(float(nargs))
  fac=1.0/nargs
  iwave(1:npts)=nint(fac*wave(1:npts))
  
  open(12,file='000001_0000.wav',access='stream',status='unknown')
  write(12) h,iwave(1:npts)
  close(12)

999 end program sumsim

subroutine get_fst4_bitmetrics(cd,nss,bitmetrics,s4,nsync_qual,badsync)

   use timer_module, only: timer
   include 'fst4_params.f90'
   complex cd(0:NN*nss-1)
   complex cs(0:3,NN)
   complex csymb(nss)
   complex, allocatable, save :: ci(:,:)   ! ideal waveforms, 20 samples per symbol, 4 tones
   complex c1(4,8),c2(16,4),c4(256,2)
   integer isyncword1(0:7),isyncword2(0:7)
   integer graymap(0:3)
   integer ip(1)
   integer hbits(2*NN)
   logical one(0:65535,0:15)    ! 65536 8-symbol sequences, 16 bits
   logical first
   logical badsync
   real bitmetrics(2*NN,4)
   real s2(0:65535)
   real s4(0:3,NN)
   data isyncword1/0,1,3,2,1,0,2,3/
   data isyncword2/2,3,1,0,3,2,0,1/
   data graymap/0,1,3,2/
   data first/.true./,nss0/-1/
   save first,one,nss0

   if(nss.ne.nss0 .and. allocated(ci)) deallocate(ci)

   if(first .or. nss.ne.nss0) then
      allocate(ci(nss,0:3))
      one=.false.
      do i=0,65535
         do j=0,15
            if(iand(i,2**j).ne.0) one(i,j)=.true.
         enddo
      enddo
      twopi=8.0*atan(1.0)
      dphi=twopi/nss
      do itone=0,3
         dp=(itone-1.5)*dphi
         phi=0.0
         do j=1,nss
            ci(j,itone)=cmplx(cos(phi),sin(phi))
            phi=mod(phi+dp,twopi)
         enddo
      enddo
      first=.false.
   endif

   do k=1,NN
      i1=(k-1)*NSS
      csymb=cd(i1:i1+NSS-1)
      do itone=0,3
         cs(itone,k)=sum(csymb*conjg(ci(:,itone)))
      enddo
      s4(0:3,k)=abs(cs(0:3,k))**2
   enddo

! Sync quality check
   is1=0
   is2=0
   is3=0
   is4=0
   is5=0
   badsync=.false.
   ibmax=0

   do k=1,8
      ip=maxloc(s4(:,k))
      if(isyncword1(k-1).eq.(ip(1)-1)) is1=is1+1
      ip=maxloc(s4(:,k+38))
      if(isyncword2(k-1).eq.(ip(1)-1)) is2=is2+1
      ip=maxloc(s4(:,k+76))
      if(isyncword1(k-1).eq.(ip(1)-1)) is3=is3+1
      ip=maxloc(s4(:,k+114))
      if(isyncword2(k-1).eq.(ip(1)-1)) is4=is4+1
      ip=maxloc(s4(:,k+152))
      if(isyncword1(k-1).eq.(ip(1)-1)) is5=is5+1
   enddo
   nsync=is1+is2+is3+is4+is5   !Number of correct hard sync symbols, 0-40
   badsync=.false.
   if(nsync .lt. 16) then
      badsync=.true.
      return
   endif

   call timer('seqcorrs',0)
   bitmetrics=0.0

! Process the frame in 8-symbol chunks. Use 1-symbol correlations to calculate
! 2-symbol correlations. Then use 2-symbol correlations to calculate 4-symbol
! correlations. Finally, use 4-symbol correlations to calculate 8-symbol corrs.
! This eliminates redundant calculations.

   do k=1,NN,8

      do m=1,8  ! do 4 1-symbol correlations for each of 8 symbs
         s2=0
         do n=1,4
            c1(n,m)=cs(graymap(n-1),k+m-1) 
            s2(n-1)=abs(c1(n,m))
         enddo
         ipt=(k-1)*2+2*(m-1)+1
         do ib=0,1
            bm=maxval(s2(0:3),one(0:3,1-ib)) - &
               maxval(s2(0:3),.not.one(0:3,1-ib))
            if(ipt+ib.gt.2*NN) cycle
            bitmetrics(ipt+ib,1)=bm
         enddo
      enddo

      do m=1,4  ! do 16 2-symbol correlations for each of 4 2-symbol groups
         s2=0
         do i=1,4
            do j=1,4
               is=(i-1)*4+j
               c2(is,m)=c1(i,2*m-1)-c1(j,2*m)
               s2(is-1)=abs(c2(is,m))
            enddo
         enddo
         ipt=(k-1)*2+4*(m-1)+1
         do ib=0,3
            bm=maxval(s2(0:15),one(0:15,3-ib)) - &
               maxval(s2(0:15),.not.one(0:15,3-ib))
            if(ipt+ib.gt.2*NN) cycle
            bitmetrics(ipt+ib,2)=bm
         enddo
      enddo
  
      do m=1,2 ! do 256 4-symbol corrs for each of 2 4-symbol groups
         s2=0
         do i=1,16
            do j=1,16
               is=(i-1)*16+j
               c4(is,m)=c2(i,2*m-1)+c2(j,2*m)
               s2(is-1)=abs(c4(is,m))
            enddo
         enddo 
         ipt=(k-1)*2+8*(m-1)+1
         do ib=0,7
            bm=maxval(s2(0:255),one(0:255,7-ib)) - &
               maxval(s2(0:255),.not.one(0:255,7-ib))
            if(ipt+ib.gt.2*NN) cycle
            bitmetrics(ipt+ib,3)=bm
         enddo
      enddo

      s2=0 ! do 65536 8-symbol correlations for the entire group
      do i=1,256
         do j=1,256
            is=(i-1)*256+j
            s2(is-1)=abs(c4(i,1)+c4(j,2))
         enddo
      enddo
      ipt=(k-1)*2+1
      do ib=0,15
         bm=maxval(s2(0:65535),one(0:65535,15-ib)) - &
            maxval(s2(0:65535),.not.one(0:65535,15-ib))
         if(ipt+ib.gt.2*NN) cycle
         bitmetrics(ipt+ib,4)=bm
      enddo

   enddo

   call timer('seqcorrs',1)

   hbits=0
   where(bitmetrics(:,1).ge.0) hbits=1
   ns1=count(hbits(  1: 16).eq.(/0,0,0,1,1,0,1,1,0,1,0,0,1,1,1,0/))
   ns2=count(hbits( 77: 92).eq.(/1,1,1,0,0,1,0,0,1,0,1,1,0,0,0,1/))
   ns3=count(hbits(153:168).eq.(/0,0,0,1,1,0,1,1,0,1,0,0,1,1,1,0/))
   ns4=count(hbits(229:244).eq.(/1,1,1,0,0,1,0,0,1,0,1,1,0,0,0,1/))
   ns5=count(hbits(305:320).eq.(/0,0,0,1,1,0,1,1,0,1,0,0,1,1,1,0/))
   nsync_qual=ns1+ns2+ns3+ns4+ns5

   if(nsync_qual.lt. 46) then
      badsync=.true.
      return
   endif

   call normalizebmet(bitmetrics(:,1),2*NN)
   call normalizebmet(bitmetrics(:,2),2*NN)
   call normalizebmet(bitmetrics(:,3),2*NN)
   call normalizebmet(bitmetrics(:,4),2*NN)

   scalefac=2.83
   bitmetrics=scalefac*bitmetrics

   return

end subroutine get_fst4_bitmetrics

program nonstd_to_c58
  integer*8 n58
  character*11 call_nonstd
  character*38 c
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/
  call_nonstd='PJ4/K1ABC'   !Redifine as needed
  n58=0
  do i=1,11
     n58=n58*38 + index(c,call_nonstd(i:i)) - 1
  enddo
  write(*,1000) call_nonstd,n58
1000 format('Callsign: ',a11,2x,'c58 as decimal integer:',i20)    
end program nonstd_to_c58

subroutine ccf65(ss,nhsym,ssmax,sync1,dt1,flipk,syncshort,snr2,dt2)

  parameter (NFFT=512,NH=NFFT/2)
  real ss(322)                     !Input: half-symbol normalized powers
  real s(NFFT)                     !CCF = ss*pr
  complex cs(0:NH)                 !Complex FT of s
  real s2(NFFT)                    !CCF = ss*pr2
  complex cs2(0:NH)                !Complex FT of s2
  real pr(NFFT)                    !JT65 pseudo-random sync pattern
  complex cpr(0:NH)                !Complex FT of pr
  real pr2(NFFT)                   !JT65 shorthand pattern
  complex cpr2(0:NH)               !Complex FT of pr2
  real tmp1(322)
  real ccf(-11:54)
  logical first
  integer npr(126)
  data first/.true./
  equivalence (s,cs),(pr,cpr),(s2,cs2),(pr2,cpr2)
  save

! The JT65 pseudo-random sync pattern:
  data npr/                                        &
      1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,     &
      0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,     &
      0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,     &
      0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,     &
      1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,     &
      0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,     &
      1,1,1,1,1,1/

  if(first) then
! Initialize pr, pr2; compute cpr, cpr2.
     fac=1.0/NFFT
     do i=1,NFFT
        pr(i)=0.
        pr2(i)=0.
        k=2*mod((i-1)/8,2)-1
        if(i.le.NH) pr2(i)=fac*k
     enddo
     do i=1,126
        j=2*i
        pr(j)=fac*(2*npr(i)-1)
! Not sure why, but it works significantly better without the following line:
!        pr(j-1)=pr(j)
     enddo
     call four2a(cpr,NFFT,1,-1,0)
     call four2a(cpr2,NFFT,1,-1,0)
     first=.false.
  endif

! Look for JT65 sync pattern and shorthand square-wave pattern.
  ccfbest=0.
  ccfbest2=0.
  do i=1,nhsym-1
     s(i)=min(ssmax,ss(i)+ss(i+1))
!     s(i)=ss(i)+ss(i+1)
  enddo

  call pctile(s,nhsym-1,50,base)
  s(1:nhsym-1)=s(1:nhsym-1)-base
  s(nhsym:NFFT)=0.
  call four2a(cs,NFFT,1,-1,0)               !Real-to-complex FFT
  do i=0,NH
!     cs2(i)=cs(i)*conjg(cpr2(i))            !Mult by complex FFT of pr2
     cs(i)=cs(i)*conjg(cpr(i))              !Mult by complex FFT of pr
  enddo
  call four2a(cs,NFFT,1,1,-1)               !Complex-to-real inv-FFT
!  call four2a(cs2,NFFT,1,1,-1)              !Complex-to-real inv-FFT

  do lag=-11,54                             !Check for best JT65 sync
     j=lag
     if(j.lt.1) j=j+NFFT
     ccf(lag)=s(j)
!     if(abs(ccf(lag)).gt.ccfbest) then
     if(ccf(lag).gt.ccfbest) then           !No inverted sync for use at HF
!        ccfbest=abs(ccf(lag))
        ccfbest=ccf(lag)
        lagpk=lag
        flipk=1.0
!        if(ccf(lag).lt.0.0) flipk=-1.0
     endif
  enddo

!  do lag=-11,54                             !Check for best shorthand
!     ccf2=s2(lag+28)
!     if(ccf2.gt.ccfbest2) then
!        ccfbest2=ccf2
!        lagpk2=lag
!     endif
!  enddo

! Find rms level on baseline of "ccfblue", for normalization.
  sum=0.
  do lag=-11,54
     if(abs(lag-lagpk).gt.1) sum=sum + ccf(lag)
  enddo
  base=sum/50.0
  sq=0.
  do lag=-11,54
     if(abs(lag-lagpk).gt.1) sq=sq + (ccf(lag)-base)**2
  enddo
  rms=sqrt(sq/49.0)
  sync1=ccfbest/rms - 4.0
  dt1=lagpk*(2048.0/11025.0) - 2.5

! Find base level for normalizing snr2.
  do i=1,nhsym
     tmp1(i)=ss(i)
  enddo
  call pctile(tmp1,nhsym,40,base)
  snr2=0.398107*ccfbest2/base                !### empirical
  syncshort=0.5*ccfbest2/rms - 4.0           !### better normalizer than rms?
!  dt2=(2.5 + lagpk2*(2048.0/11025.0))
  dt2=0.

  return
end subroutine ccf65

module decodes_mod

    implicit none

    integer, parameter :: NLD = 32768
    ! from decodes
    integer :: ndecodes = 0
    
    !from early 
    integer :: nhsym1 = 0, nhsym2 = 0

    logical, allocatable :: ldecoded(:)
    
    !from c3com
    integer :: mcall3a = 0

    contains

      subroutine decodes_init()
        if (.not. allocated(ldecoded)) allocate(ldecoded(NLD))
      end subroutine decodes_init

end module decodes_mod

module q65

  parameter (NSTEP=8)          !Number of time bins per symbol in s1, s1a, s1b
  parameter (PLOG_MIN=-242.0)        !List decoding threshold
  integer iz0,jz0
!  integer listutc(10)
  integer apsym0(58),aph10(10)
  integer apmask1(78),apsymbols1(78)
  integer apmask(13),apsymbols(13)
  integer,dimension(22) ::  isync = (/1,9,12,13,15,22,23,26,27,33,35,   &
                                     38,46,50,55,60,62,66,69,74,76,85/)
  integer codewords(63,206)
  integer ibwa,ibwb,ncw,nsps,mode_q65,nfa,nfb,nqd
  integer idfbest,idtbest,ibw,ndistbest,maxiters,max_drift
  integer istep,nsmo,lag1,lag2,npasses,iseq,ncand,nrc
  integer i0,j0
  integer navg(0:1)
  logical lnewdat
  real candidates(20,3)                  !snr, xdt, and f0 of top candidates
  real, allocatable :: s1(:,:)           !Symbol spectra w/suppressed peaks
  real, allocatable :: s1w(:,:)       !Symbol spectra w/suppressed peaks (W3SZ)
  real, allocatable,save :: s1a(:,:,:)   !Cumulative symbol spectra
  real, allocatable,save :: ccf2(:)      !Max CCF(freq) at any lag (orange curve)
  real, allocatable,save :: ccf2_avg(:)  !Like ccf2, but for avg (red curve)
  real sync(85)                          !sync vector
  real df,dtstep,dtdec,f0dec,ftol,plog,drift

contains

subroutine q65_dec0(iavg,iwave,ntrperiod,nfqso,ntol,lclearave,  &
     emedelay,xdt,f0,snr1,width,dat4,snr2,idec,stageno)

! Top-level routine in q65 module
!   - Compute symbol spectra
!   - Attempt sync and q3 decode using all 85 symbols
!   - If that fails, try sync with 22 symbols and standard q[0124] decode
  
! Input:  iavg                   0 for single-period decode, 1 for average
!         iwave(0:nmax-1)        Raw data
!         ntrperiod              T/R sequence length (s)
!         nfqso                  Target frequency (Hz)
!         ntol                   Search range around nfqso (Hz)
!         lclearave              Flag to clear the accumulating array
!         emedelay               Extra delay for EME signals
! Output: xdt                    Time offset from nominal (s)
!         f0                     Frequency of sync tone
!         snr1                   Relative SNR of sync signal
!         width                  Estimated Doppler spread
!         dat4(13)               Decoded message as 13 six-bit integers
!         snr2                   Estimated SNR of decoded signal
!         idec                   Flag for decoding results
!            -1  No decode
!             0  No AP
!             1  "CQ        ?    ?"
!             2  "Mycall    ?    ?"
!             3  "MyCall HisCall ?"

  use packjt77
  use timer_module, only: timer

  parameter (LN=2176*63)           !LN=LL*NN; LL=64*(mode_q65+2), NN=63
  integer*2 iwave(0:12000*ntrperiod-1)   !Raw data
  integer dat4(13)
  character*37 decoded
  logical first,lclearave
  real, allocatable :: s3(:,:)           !Data-symbol energies s3(LL,63)
  real, allocatable :: ccf1(:)           !CCF(freq) at fixed lag (red)
  data first/.true./
  save first,LL0

  integer w3t
  integer w3f
  integer mm
  integer stageno

  NN=63

! Set some parameters and allocate storage for large arrays
  irc=-2
  nrc=-2
  idec=-1
  snr1=0.
  dat4=0
  LL=64*(2+mode_q65)
  nfft=nsps
  df=12000.0/nfft                        !Freq resolution = baud
  istep=nsps/NSTEP
  iz=5000.0/df                           !Uppermost frequency bin, at 5000 Hz
  txt=85.0*nsps/12000.0
  jz=(txt+1.0)*12000.0/istep             !Number of symbol/NSTEP bins
  if(nsps.ge.6912) jz=(txt+2.0)*12000.0/istep   !For TR 60 s and higher
  ftol=ntol
  ia=ntol/df
  ia2=max(ia,10*mode_q65,nint(100.0/df))
!  nsmo=int(0.7*mode_q65*mode_q65)
  nsmo=int(0.5*mode_q65*mode_q65)
  if(nsmo.lt.1) nsmo=1
  if(first) then                         !Generate the sync vector
     sync=-22.0/63.0                     !Sync tone OFF  
     do k=1,22
        sync(isync(k))=1.0               !Sync tone ON
     enddo
  endif

  allocate(s3(-64:LL-65,63))
  allocate(ccf1(-ia2:ia2))
  if(LL.ne.LL0 .or. iz.ne.iz0 .or. jz.ne.jz0 .or. lclearave) then
     if(allocated(s1)) deallocate(s1)
     allocate(s1(iz,jz))
     if(allocated(s1a)) deallocate(s1a)
     allocate(s1a(iz,jz,0:1))
     if(allocated(ccf2)) deallocate(ccf2)
     allocate(ccf2(iz))
     if(allocated(ccf2_avg)) deallocate(ccf2_avg)
     allocate(ccf2_avg(iz))
     s1=0.
     s1a=0.
     navg=0
     LL0=LL
     iz0=iz
     jz0=jz
     lclearave=.false.
  endif
  ccf1=0.
  if(iavg.eq.0) ccf2=0.
  dtstep=nsps/(NSTEP*12000.0)                 !Step size in seconds
  lag1=-1.0/dtstep
  lag2=1.0/dtstep + 0.9999
  if(nsps.ge.3600 .and. emedelay.gt.0) lag2=5.5/dtstep + 0.9999  !Include EME
  j0=0.5/dtstep
  if(nsps.ge.7200) j0=1.0/dtstep              !Nominal start-signal index

  s3=0.
!  if(iavg.eq.0 .and. lnewdat) then
  if(iavg.eq.0) then
     call timer('q65_syms',0)
! Compute symbol spectra with NSTEP time bins per symbol
     call q65_symspec(iwave,ntrperiod*12000,iz,jz,s1)
     call timer('q65_syms',1)
!     lnewdat=.false.
  else
     s1=s1a(:,:,iseq)
  endif

  i0=nint(nfqso/df)                             !Target QSO frequency
  dat4=0
  if(ncw.gt.0 .and. iavg.le.1) then
! Try list decoding via "Deep Likelihood".
     call timer('ccf_85  ',0)
! Try to synchronize using all 85 symbols
     call q65_ccf_85(s1,iz,jz,nfqso,ia,ia2,ipk,jpk,f0,xdt,imsg_best,   &
          better,ccf1)
     call timer('ccf_85  ',1)

     if(better.ge.1.10 .or. mode_q65.ge.8) then
        call timer('list_dec',0)
        call q65_dec_q3(s1,iz,jz,s3,LL,ipk,jpk,snr2,dat4,idec,decoded)
        call timer('list_dec',1)
     endif
! If idec=3 we have a q3 decode.  Continue to compute sync curve for plotting.
  endif

! Get 2d CCF and ccf2 using sync symbols only
  if(iavg.eq.0) then
     call timer('ccf_22a ',0)
     call q65_ccf_22(s1,iz,jz,nfqso,ntol,iavg,ipk,jpk,  &
          f0a,xdta,ccf2)
     call timer('ccf_22a ',1)
  endif

! Get 2d CCF and ccf2_avg using sync symbols only
  if(iavg.ge.1) then
     call timer('ccf_22b ',0)
     call q65_ccf_22(s1,iz,jz,nfqso,ntol,iavg,ipk,jpk,  &
          f0a,xdta,ccf2_avg)
     call timer('ccf_22b ',1)
  endif
  if(idec.lt.0) then
     f0=f0a
     xdt=xdta
  endif

! Estimate rms on ccf2 baseline
  call q65_sync_curve(ccf2,1,iz,rms2)
  smax=maxval(ccf2)
  snr1=0.
  if(rms2.gt.0) snr1=smax/rms2

  if(idec.le.0) then
! The q3 decode attempt failed. Copy synchronized symbol energies from s1
! into s3 and prepare to try a more general decode.
     call q65_s1_to_s3(s1,iz,jz,ipk,jpk,LL,mode_q65,sync,s3)
  endif

  smax=maxval(ccf1)

! Estimate frequency spread
  i1=-9999
  i2=-9999
  do i=-ia,ia
     if(i1.eq.-9999 .and. ccf1(i).ge.0.5*smax) i1=i
     if(i2.eq.-9999 .and. ccf1(-i).ge.0.5*smax) i2=-i
  enddo
  width=df*(i2-i1)
  if(ncw.eq.0) ccf1=0.
  call q65_write_red(iz,xdt,ccf2_avg,ccf2)   !### Need this call for WSJT-X

  if(idec.lt.0 .and. (iavg.eq.0 .or. iavg.eq.2)) then
     call q65_dec_q012(s3,LL,snr2,dat4,idec,decoded)
  endif

  if(idec.lt.0 .and. max_drift.eq.50 .and. stageno.eq.5) then

     if(allocated(s1w)) deallocate(s1w) ! w3sz
     allocate(s1w(iz,jz))               ! w3sz	 
	 
     s1w=s1
     do w3t=1,jz
        do w3f=1,iz
           mm=w3f + nint(drift*w3t/(jz*df))
           if(mm.ge.1 .and. mm.le.iz) then
              s1w(w3f,w3t)=s1(mm,w3t)
           endif
        end do
     end do

     if(ncw.gt.0 .and. iavg.le.1) then
        ! Try list decoding via "Deep Likelihood".
        call timer('ccf_85  ',0)
        ! Try to synchronize using all 85 symbols
        call q65_ccf_85(s1w,iz,jz,nfqso,ia,ia2,ipk,jpk,f0,xdt,imsg_best,   &
             better,ccf1)
        call timer('ccf_85  ',1)

! nsubmode  is Tone-spacing indicator, 0-4 for A-E: a 0; b 1; c 2; d 3; e 4.
! and mode_q65=2**nsubmode
        if(better.ge.1.10) then
           !     if(better.ge.1.04 .or. mode_q65.ge.8) then
           !     if(better.ge.1.10 .or. mode_q65.ge.8) then  ORIGINAL
           call timer('list_dec',0)
           call q65_dec_q3(s1w,iz,jz,s3,LL,ipk,jpk,snr2,dat4,idec,decoded)
           call timer('list_dec',1)
        endif ! if(better.ge.1.10)
     endif    ! if(ncw.gt.0 .and. iavg.le.1)
     ! If idec=3 we have a q3 decode.  Continue to compute sync curve for plotting.

     if(idec.eq.3) then
        idec=5
     endif

  endif        ! if(idec.lt.0 .and. max_drift.eq.50 .and. stageno.eq.5)

  return
end subroutine q65_dec0

subroutine q65_clravg

! Clear the averaging array to start a new average.

  if(allocated(s1a)) s1a(:,:,iseq)=0.
  navg(iseq)=0
  
  return
end subroutine q65_clravg

subroutine q65_symspec(iwave,nmax,iz,jz,s1)

! Compute symbol spectra with NSTEP time-steps per symbol.
  
  integer*2 iwave(0:nmax-1)              !Raw data
  real s1(iz,jz)
  complex, allocatable :: c0(:)          !Complex spectrum of symbol

  allocate(c0(0:nsps-1))
  nfft=nsps
  fac=1/32767.0
  do j=1,jz,2                     !Compute symbol spectra at 2*step size
     i1=(j-1)*istep
     i2=i1+nsps-1
     k=-1
     do i=i1,i2,2          !Load iwave data into complex array c0, for r2c FFT
        xx=iwave(i)
        yy=iwave(i+1)
        k=k+1
        c0(k)=fac*cmplx(xx,yy)
     enddo
     c0(k+1:)=0.
     call four2a(c0,nfft,1,-1,0)              !r2c FFT
     do i=1,iz
        s1(i,j)=real(c0(i))**2 + aimag(c0(i))**2
     enddo
! For large Doppler spreads, should we smooth the spectra here?
     if(nsmo.le.1) nsmo=0
     do i=1,nsmo
        call smo121(s1(1:iz,j),iz)
     enddo
! Interpolate to fill in the skipped-over spectra.
     if(j.ge.3) s1(1:iz,j-1)=0.5*(s1(1:iz,j-2)+s1(1:iz,j))
  enddo
  if(lnewdat) then
     navg(iseq)=navg(iseq) + 1
     ntc=min(navg(iseq),4)               !Averaging time constant in sequences
     u=1.0/ntc
     s1a(:,:,iseq)=u*s1 + (1.0-u)*s1a(:,:,iseq)
   endif

  return
end subroutine q65_symspec

subroutine q65_dec_q3(s1,iz,jz,s3,LL,ipk,jpk,snr2,dat4,idec,decoded)

! Copy synchronized symbol energies from s1 into s3, then attempt a q3 decode.

  character*37 decoded
  integer dat4(13)
  real s1(iz,jz)
  real s3(-64:LL-65,63)

  call q65_s1_to_s3(s1,iz,jz,ipk,jpk,LL,mode_q65,sync,s3)

  nsubmode=0
  if(mode_q65.eq.2) nsubmode=1
  if(mode_q65.eq.4) nsubmode=2
  if(mode_q65.eq.8) nsubmode=3
  if(mode_q65.eq.16) nsubmode=4
  if(mode_q65.eq.32) nsubmode=5
  baud=12000.0/nsps

  do ibw=ibwa,ibwb
     b90=1.72**ibw
     b90ts=b90/baud
     call q65_dec1(s3,nsubmode,b90ts,esnodb,irc,dat4,decoded)
     nrc=irc
     if(irc.ge.0) then
        snr2=esnodb - db(2500.0/baud) + 3.0     !Empirical adjustment
        idec=3
        exit
     endif
  enddo

  return
end subroutine q65_dec_q3

subroutine q65_dec_q012(s3,LL,snr2,dat4,idec,decoded)

! Do separate passes attempting q0, q1, q2 decodes.
  
  character*37 decoded
  character*78 c78
  integer dat4(13)
  real s3(-64:LL-65,63)
  logical lapcqonly

  nsubmode=0
  if(mode_q65.eq.2) nsubmode=1
  if(mode_q65.eq.4) nsubmode=2
  if(mode_q65.eq.8) nsubmode=3
  if(mode_q65.eq.16) nsubmode=4
  
  baud=12000.0/nsps
  iaptype=0
  nQSOprogress=0    !### TEMPORARY  ? ###
  ncontest=0
  lapcqonly=.false.
  
  do ipass=0,npasses                  !Loop over AP passes
     apmask=0                         !Try first with no AP information
     apsymbols=0
     if(ipass.ge.1) then
        ! Subsequent passes use AP information appropiate for nQSOprogress
        call q65_ap(nQSOprogress,ipass,ncontest,lapcqonly,iaptype,   &
             apsym0,apmask1,apsymbols1)
        write(c78,1050) apmask1
1050    format(78i1)
        read(c78,1060) apmask
1060    format(13b6.6)
        write(c78,1050) apsymbols1
        read(c78,1060) apsymbols
     endif

     do ibw=ibwa,ibwb
        b90=1.72**ibw
        b90ts=b90/baud
        call q65_dec2(s3,nsubmode,b90ts,esnodb,irc,dat4,decoded)
        nrc=irc
        if(irc.ge.0) then
           snr2=esnodb - db(2500.0/baud) + 3.0     !Empirical adjustment
           idec=iaptype
           go to 100
        endif
     enddo
  enddo

100 return
end subroutine q65_dec_q012

subroutine q65_ccf_85(s1,iz,jz,nfqso,ia,ia2,ipk,jpk,f0,xdt,imsg_best,   &
     better,ccf1)

! Attempt synchronization using all 85 symbols, in advance of an
! attempt at q3 decoding.  Return ccf1 for the "red sync curve".
  
  real s1(iz,jz)
  real, allocatable :: ccf(:,:)          !CCF(freq,lag)
  real, allocatable :: best(:)           !best(imsg) -- for checking 2nd best
  real ccf1(-ia2:ia2)
  integer ijpk(2)
  integer itone(85)

  allocate(ccf(-ia2:ia2,-53:214))
  allocate(best(ncw))
  ipk=0
  jpk=0
  ccf_best=0.
  imsg_best=-1
  do imsg=1,ncw
     i=1
     k=0
     do j=1,85
        if(j.eq.isync(i)) then
           i=i+1
           itone(j)=0
        else
           k=k+1
           itone(j)=codewords(k,imsg) + 1
        endif
     enddo

! Compute 2D ccf using all 85 symbols in the list message
     ccf=0.
     iia=200.0/df

     do lag=lag1,lag2
        do k=1,85
           j=j0 + NSTEP*(k-1) + 1 + lag
           if(j.ge.1 .and. j.le.jz) then
              do i=-ia2,ia2
                 ii=i0+mode_q65*itone(k)+i
                 if(ii.ge.iia .and. ii.le.iz) ccf(i,lag)=ccf(i,lag) + s1(ii,j)
              enddo
           endif
        enddo
     enddo

     ccfmax=maxval(ccf(-ia:ia,:))
     if(ccfmax.gt.ccf_best) then
        ccf_best=ccfmax
        ijpk=maxloc(ccf(-ia:ia,:))
        ipk=ijpk(1)-ia-1
        jpk=ijpk(2)-53-1
        f0=nfqso + ipk*df
        xdt=jpk*dtstep
        imsg_best=imsg
        ccf1=ccf(:,jpk)
     endif
     best(imsg)=ccfmax
  enddo  ! imsg

  deallocate(ccf)
  better=0.
  if(imsg_best.gt.0) then
     best(imsg_best)=0.
     better=ccf_best/maxval(best)
  endif

  return
end subroutine q65_ccf_85

subroutine q65_ccf_22(s1,iz,jz,nfqso,ntol,iavg,ipk,jpk,  &
     f0,xdt,ccf2)

! Attempt synchronization using only the 22 sync symbols.  Return ccf2
! for the "orange sync curve".

  real s1(iz,jz)
  real ccf2(iz)                               !Orange sync curve
  real tmp(20,3)
  real, allocatable :: xdt2(:)
  real, allocatable :: s1avg(:)
  integer, allocatable :: indx(:)

  allocate(xdt2(iz))
  allocate(s1avg(iz))
  allocate(indx(iz))

  ia=max(nfa,100)/df
  ib=min(nfb,4900)/df
!  if(nqd.ne.1 .or. iavg.ne.0) max_drift=0    !### Disabled March 22, 2023
  if(max_drift.ne.0) then
     ia=max(nint(100/df),nint((nfqso-ntol)/df))
     ib=min(nint(4900/df),nint((nfqso+ntol)/df))
  endif
  if(ia.ge.ib) ia=ib-ntol/df                  !Protect against wacky settings

  do i=ia,ib
     s1avg(i)=sum(s1(i,1:jz))
  enddo

  ccfbest=0.
  ibest=0
  lagpk=0
  lagbest=0
  idrift_max=0
  idrift_best=0

  do i=ia,ib
     ccfmax=0.
     do lag=lag1,lag2
        do idrift=-max_drift,max_drift
           ccft=0.
           do kk=1,22
              k=isync(kk)
              ii=i + nint(idrift*(k-43)/85.0)
              if(ii.lt.1 .or. ii.gt.iz) cycle
              n=NSTEP*(k-1) + 1
              j=n+lag+j0
              if(j.ge.1 .and. j.le.jz) ccft=ccft + s1(ii,j)
           enddo  ! kk
           ccft=ccft - (22.0/jz)*s1avg(i)
           if(ccft.gt.ccfmax) then
              ccfmax=ccft
              lagpk=lag
              idrift_max=idrift
           endif
        enddo  ! idrift
     enddo  ! lag

     ccf2(i)=ccfmax
     xdt2(i)=lagpk*dtstep

     if(ccfmax.gt.ccfbest .and. abs(i*df-nfqso).le.ftol) then
        ccfbest=ccfmax
        snrbest=snr
        ibest=i
        lagbest=lagpk
        idrift_best=idrift_max
     endif
  enddo  ! i

! Parameters for the top candidate:
  ipk=ibest - i0
  jpk=lagbest
  f0=nfqso + ipk*df
  xdt=jpk*dtstep
  drift=df*idrift_best
  ccf2(:ia)=0.
  ccf2(ib:)=0.

! Save parameters for best candidates
  jzz=ib-ia+1
  call indexx(ccf2(ia:ib),jzz,indx)

  call pctile(ccf2(ia:ib),jzz,50,ave)
  call pctile(ccf2(ia:ib),jzz,84,base)
  rms=base-ave
  ncand=0
  maxcand=20
  do j=1,20
     k=jzz-j+1
     if(k.lt.1 .or. k.gt.iz) cycle
     i=indx(k)+ia-1
     f=i*df
     i3=max(1, i-mode_q65)
     i4=min(iz,i+mode_q65)
     biggest=maxval(ccf2(i3:i4))
     if(ccf2(i).ne.biggest) cycle
     snr=(ccf2(i)-ave)/rms
     if(snr.lt.6.0) exit
     ncand=ncand+1
     candidates(ncand,1)=snr
     candidates(ncand,2)=xdt2(i)
     candidates(ncand,3)=f
     if(ncand.ge.maxcand) exit
  enddo

! Resort the candidates back into frequency order
  tmp(1:ncand,1:3)=candidates(1:ncand,1:3)
  candidates=0.
  call indexx(tmp(1:ncand,3),ncand,indx)
  do i=1,ncand
     candidates(i,1:3)=tmp(indx(i),1:3)
  enddo

  return
end subroutine q65_ccf_22

subroutine q65_dec1(s3,nsubmode,b90ts,esnodb,irc,dat4,decoded)

! Attmpt a full-AP list decode.

  use packjt77
  real s3(1,1)       !Silence compiler warning that wants to see a 2D array
  real s3prob(0:63,63)                   !Symbol-value probabilities
  integer dat4(13)
  character c77*77,decoded*37
  logical unpk77_success

  nFadingModel=1
  decoded='                                     '
  call q65_intrinsics_ff(s3,nsubmode,b90ts,nFadingModel,s3prob)
  call q65_dec_fullaplist(s3,s3prob,codewords,ncw,esnodb,dat4,plog,irc)
  if(sum(dat4).le.0) irc=-2
  if(irc.ge.0 .and. plog.gt.PLOG_MIN) then
     write(c77,1000) dat4(1:12),dat4(13)/2
1000 format(12b6.6,b5.5)
     call unpack77(c77,0,decoded,unpk77_success) !Unpack to get msgsent
  else
     irc=-1
  endif
  nrc=irc

  return
end subroutine q65_dec1

subroutine q65_dec2(s3,nsubmode,b90ts,esnodb,irc,dat4,decoded)

! Attempt a q0, q1, or q2 decode using spcified AP information.

  use packjt77
  real s3(iz0,jz0)       !Silence compiler warning that wants to see a 2D array
  real s3prob(0:63,63)                   !Symbol-value probabilities
  integer dat4(13)
  character c77*77,decoded*37
  logical unpk77_success

  nFadingModel=1
  decoded='                                     '
  call q65_intrinsics_ff(s3,nsubmode,b90ts,nFadingModel,s3prob)
  call q65_dec(s3,s3prob,APmask,APsymbols,maxiters,esnodb,dat4,irc)
  if(sum(dat4).le.0) irc=-2
  nrc=irc
  if(irc.ge.0) then
     write(c77,1000) dat4(1:12),dat4(13)/2
1000 format(12b6.6,b5.5)
     call unpack77(c77,0,decoded,unpk77_success) !Unpack to get msgsent
  endif

  return
end subroutine q65_dec2

subroutine q65_s1_to_s3(s1,iz,jz,ipk,jpk,LL,mode_q65,sync,s3)

! Copy synchronized symbol energies from s1 (or s1a) into s3.

  real s1(iz,jz)
  real s3(-64:LL-65,63)
  real sync(85)                          !sync vector
  
  i1=i0+ipk-64 + mode_q65
  i2=i1+LL-1
  if(i1.ge.1 .and. i2.le.iz) then
     j=j0+jpk-7
     n=0
     do k=1,85
        j=j+8
        if(sync(k).gt.0.0) then
           cycle
        endif
        n=n+1
        if(j.ge.1 .and. j.le.jz) s3(-64:LL-65,n)=s1(i1:i2,j)
     enddo
  endif
  call q65_bzap(s3,LL)                   !Zap birdies
  
  return
end subroutine q65_s1_to_s3

subroutine q65_write_red(iz,xdt,ccf2_avg,ccf2)

! Write data for the red and orange sync curves to LU 17.

  real ccf2_avg(iz)
  real ccf2(iz)

  call q65_sync_curve(ccf2_avg,1,iz,rms1)
  call q65_sync_curve(ccf2,1,iz,rms2)

  i1=max(1,nint(nfa/df))
  i2=min(iz,int(nfb/df))
  y0=minval(ccf2(i1:i2))
  y0_avg=minval(ccf2_avg(i1:i2))
  g=0.4
  g_avg=0.
  if(navg(iseq).ge.2) g_avg=g
  rewind 17
  write(17,1000) xdt,g_avg*minval(ccf2_avg),g_avg*maxval(ccf2_avg)
  do i=i1,i2
     freq=i*df
     y1=g_avg*(ccf2_avg(i)-y0_avg)
     y2=g*(ccf2(i)-y0)
     write(17,1000) freq,y1,y2
1000 format(f10.3,2f15.6)
  enddo
  flush(17)

  return
end subroutine q65_write_red

subroutine q65_sync_curve(ccf1,ia,ib,rms1)

! Condition the red or orange sync curve for plotting.

  real ccf1(ia:ib)

  ic=(ib-ia)/8;
  nsum=2*(ic+1)

  base1=(sum(ccf1(ia:ia+ic)) + sum(ccf1(ib-ic:ib)))/nsum
  ccf1=ccf1-base1
  sq=dot_product(ccf1(ia:ia+ic),ccf1(ia:ia+ic)) +         &
       dot_product(ccf1(ib-ic:ib),ccf1(ib-ic:ib))
  rms1=0.
  if(nsum.gt.0) rms1=sqrt(sq/nsum)
  if(rms1.gt.0.0) ccf1=ccf1/rms1
!  smax1=maxval(ccf1)
!  if(smax1.gt.10.0) ccf1=10.0*ccf1/smax1

  return
end subroutine q65_sync_curve

subroutine q65_bzap(s3,LL)

  parameter (NBZAP=15)
  real s3(-64:LL-65,63)
  integer ipk1(1)
  integer, allocatable :: hist(:)

  allocate(hist(-64:LL-65))
  hist=0
  do j=1,63
     ipk1=maxloc(s3(:,j))
     i=ipk1(1) - 65
     hist(i)=hist(i)+1
  enddo
  if(maxval(hist).gt.NBZAP) then
     do i=-64,LL-65
        if(hist(i).gt.NBZAP) s3(i,1:63)=1.0
     enddo
  endif

  return
end subroutine q65_bzap

subroutine q65_snr(dat4,dtdec,f0dec,mode_q65,snr2)

! Estimate SNR of a decoded transmission by aligning the spectra of
! all 85 symbols.
  
  integer dat4(13)
  integer codeword(63)
  integer itone(85)
  real, allocatable :: spec(:)

  allocate(spec(iz0))
  call q65_enc(dat4,codeword)
  i=1
  k=0
  do j=1,85
     if(j.eq.isync(i)) then
        i=i+1
        itone(j)=0
     else
        k=k+1
        itone(j)=codeword(k) + 1
     endif
  enddo

  spec=0.
  lagpk=nint(dtdec/dtstep)
  do k=1,85
     j=j0 + NSTEP*(k-1) + 1 + lagpk
     if(j.ge.1 .and. j.le.jz0) then
        do i=1,iz0
           ii=i+mode_q65*itone(k)
           if(ii.ge.1 .and. ii.le.iz0) spec(i)=spec(i) + s1(ii,j)
        enddo
     endif
  enddo

  i0=nint(f0dec/df)
  nsum=max(10*mode_q65,nint(50.0/df))
  ia=max(1,i0-2*nsum)
  ib=min(iz0,i0+2*nsum)
  sum1=sum(spec(ia:ia+nsum-1))
  sum2=sum(spec(ib-nsum+1:ib))
  avg=(sum1+sum2)/(2.0*nsum)
  spec=spec/avg                          !Baseline level is now 1.0
  smax=maxval(spec(ia:ib))
  sig_area=sum(spec(ia+nsum:ib-nsum)-1.0)
  w_equiv=sig_area/(smax-1.0)
  snr2=db(max(1.0,sig_area)) - db(2500.0/df)

  return
end subroutine q65_snr

subroutine q65_hist(if0,msg0,dxcall,dxgrid)

! Save the MAXHIST most receent decodes, and their f0 values; or, if
! dxcall is present, look up the most recent dxcall and dxgrid at the
! specified f0.

  parameter (MAXHIST=100)
  integer,intent(in) :: if0                         !Audio freq of decode
  character(len=37),intent(in),optional :: msg0     !Decoded message
  character(len=12),intent(out),optional :: dxcall  !Second callsign in message
  character(len=6),intent(out),optional :: dxgrid   !Third word in msg, if grid

  character*6 g1
  character*37 msg(MAXHIST)                      !Saved messages
  integer nf0(MAXHIST)                           !Saved frequencies
  logical isgrid                                 !Statement function
  data nhist/0/
  save nhist,nf0,msg

  isgrid(g1)=g1(1:1).ge.'A' .and. g1(1:1).le.'R' .and. g1(2:2).ge.'A' .and. &
       g1(2:2).le.'R' .and. g1(3:3).ge.'0' .and. g1(3:3).le.'9' .and.       &
       g1(4:4).ge.'0' .and. g1(4:4).le.'9' .and. g1(1:4).ne.'RR73'

  if(present(dxcall)) go to 100                  !This is a lookup request

  if(nhist.eq.MAXHIST) then
     nf0(1:MAXHIST-1)=nf0(2:MAXHIST)             !List is full, must make room
     msg(1:MAXHIST-1)=msg(2:MAXHIST)
     nhist=MAXHIST-1
  endif
  nhist=nhist+1                                  !Insert msg0 at end of list
  nf0(nhist)=if0
  msg(nhist)=msg0
  go to 900

100 if(dxcall(1:3).ne.'   ') go to 900
  dxcall='            '                        !This is a lookup request
  dxgrid='      '
! Look for a decode close to if0, starting with most recent ones
  do i=nhist,1,-1                     
     if(abs(nf0(i)-if0).gt.10) cycle
     i1=index(msg(i),' ')
     if(i1.ge.4 .and. i1.le.13) then
        i2=index(msg(i)(i1+1:),' ') + i1
        dxcall=msg(i)(i1+1:i2-1)                 !Extract dxcall
        g1=msg(i)(i2+1:i2+4)
        if(isgrid(g1)) dxgrid=g1(1:4)            !Extract dxgrid
        exit
     endif
  enddo

900 return
end subroutine q65_hist

subroutine q65_hist2(nfreq,msg0,callers,nhist2)

  use types
  use prog_args
  parameter (MAX_CALLERS=40)  !For multiple q3 decodes in NA VHf Contest mode
  character*37 msg0,msg
  type(q3list) callers(MAX_CALLERS)
  character*6 c6
  character*4 g4
  logical newcall,isgrid

  isgrid(g4)=g4(1:1).ge.'A' .and. g4(1:1).le.'R' .and. g4(2:2).ge.'A' .and. &
       g4(2:2).le.'R' .and. g4(3:3).ge.'0' .and. g4(3:3).le.'9' .and.       &
       g4(4:4).ge.'0' .and. g4(4:4).le.'9' .and. g4(1:4).ne.'RR73'

  msg=msg0
  if(index(msg,'/').gt.0) goto 900         !Ignore messages with compound calls
  i0=index(msg,' R ')
  if(i0.ge.7) msg=msg(1:i0)//msg(i0+3:)
  i1=index(msg,' ')
  c6='      '
  g4='    '
  if(i1.ge.4 .and. i1.le.13) then
     i2=index(msg(i1+1:),' ') + i1
     c6=msg(i1+1:i2-1)                     !Extract DX call
     g4=msg(i2+1:i2+4)                     !Extract DX grid
  endif

  newcall=.true.
  do i=1,nhist2
     if(callers(i)%call .eq. c6) then
        newcall=.false.
        callers(i)%nsec=time()
        callers(i)%nfreq=nfreq
        exit
     endif
  enddo

  if(newcall .and. isgrid(g4)) then
     if(nhist2.eq.MAX_CALLERS) then
! Purge the oldest caller
        callers(1:MAX_CALLERS-1)=callers(2:MAX_CALLERS)
        nhist2=nhist2-1
     endif
     nhist2=nhist2+1
     callers(nhist2)%call=c6
     callers(nhist2)%grid=g4
     callers(nhist2)%nsec=time()
     callers(nhist2)%nfreq=nfreq
  endif

  if(nhist2.ge.1 .and. nhist2.le.40) then
     open(24,file=trim(data_dir)//'/tsil.3q',status='unknown',     &
          form='unformatted')
     write(24) nhist2
     write(24) callers(1:nhist2)
     close(24)
  endif

900 return
end subroutine q65_hist2

end module q65

module four2a_mod
  use fftw3
  use iso_c_binding
  use fftw3_f77_interfaces

  implicit none
  
contains

  function loc_cplx(x) result(addr)
    use iso_c_binding, only: c_float_complex, c_intptr_t, c_loc
    implicit none
    complex(c_float_complex), intent(in), target :: x(*)
    integer(c_intptr_t) :: addr
    addr = transfer(c_loc(x), addr)
  end function loc_cplx

  recursive subroutine four2a(a, nfft, ndim, isign, iform) bind(C, name='four2a_')

    implicit none

    !==== Arguments ============================================================
    complex(c_float_complex), dimension(*), intent(inout) :: a
    integer(c_int), intent(in) :: nfft, ndim, isign, iform

    !==== Parameters ===========================================================
    integer, parameter :: NPMAX = 2100
    integer, parameter :: NSMALL = 16384

    !==== Local variables ======================================================
    complex(c_float_complex) :: aa(NSMALL)
    integer :: nn(NPMAX), ns(NPMAX), nf(NPMAX)
    integer(c_intptr_t) :: nl(NPMAX), nloc
    integer(c_intptr_t) :: plan(NPMAX)
    logical :: found_plan
    integer :: i, jz = 0, nflags
    integer :: nplan

    !==== Saved state ==========================================================
    save plan, nplan, nn, ns, nf, nl
    data nplan / 0 /

    ! Mark unused dummy to silence warnings
    if (.false.) print *, ndim

    !==== Early exit: destroy all plans =======================================
    if (nfft < 0) then
       !$omp critical(four2a)
       do i = 1, nplan
          !$omp critical(fftw)
          call sfftw_destroy_plan(plan(i))
          !$omp end critical(fftw)
       enddo
       nplan = 0
       !$omp end critical(four2a)
       return
    endif

    !==== Locate or create plan ===============================================
    nloc = loc_cplx(a)
    found_plan = .false.

    !$omp critical(four2a_setup)
    do i = 1, nplan
       if (nfft == nn(i) .and. isign == ns(i) .and. iform == nf(i) .and. nloc == nl(i)) then
          found_plan = .true.
          exit
       endif
    enddo

    if (.not. found_plan) then
       nplan = nplan + 1
       i = nplan

       nn(i) = nfft
       ns(i) = isign
       nf(i) = iform
       nl(i) = nloc

       nflags = FFTW_ESTIMATE

       if (nfft <= NSMALL) then
          jz = merge(nfft/2, nfft, iform == 0)
          aa(1:jz) = a(1:jz)
       endif

       !$omp critical(fftw)
       select case (iform)
       case (1)
          if (isign == -1) then
             call sfftw_plan_dft_1d(plan(i), nfft, a, a, FFTW_FORWARD, nflags)
          else
             call sfftw_plan_dft_1d(plan(i), nfft, a, a, FFTW_BACKWARD, nflags)
          endif
       case (0)
          call sfftw_plan_dft_r2c_1d(plan(i), nfft, a, a, nflags)
       case (-1)
          call sfftw_plan_dft_c2r_1d(plan(i), nfft, a, a, nflags)
       case default
          stop 'Unsupported request in four2a'
       end select
       !$omp end critical(fftw)

       if (nfft <= NSMALL) then
          a(1:jz) = aa(1:jz)
       endif
    endif
    !$omp end critical(four2a_setup)

    call sfftw_execute(plan(i))

  end subroutine four2a

end module four2a_mod

subroutine plotsave(swide,nw,nh,irow)

  real, dimension(:,:), allocatable :: sw
  real swide(0:nw-1)
  data nw0/-1/,nh0/-1/
  save nw0,nh0,sw

  if(irow.eq.-99) then
     if(allocated(sw)) deallocate(sw)
     go to 900
  endif

  if(nw.ne.nw0 .or. nh.ne.nh0 .or. (.not.allocated(sw))) then
     if(allocated(sw)) deallocate(sw)
!     if(nw0.ne.-1) deallocate(sw)
     allocate(sw(0:nw-1,0:nh-1))
     sw=0.
     nw0=nw
     nh0=nh
  endif
  df=12000.0/16384
  if(irow.lt.0) then
! Push a new row of data into sw
     do j=nh-1,1,-1
        sw(0:nw-1,j)=sw(0:nw-1,j-1)
     enddo
     sw(0:nw-1,0)=swide
  else
! Return the saved "irow" as swide(), for a waterfall replot.
     swide=sw(0:nw-1,irow)
  endif

900 return
end subroutine plotsave

subroutine ccf2(ss,nz,nflip,ccfbest,xlagpk)

!  parameter (LAGMIN=-86,LAGMAX=258)
  parameter (LAGMIN=-112,LAGMAX=258)  ! Look for DT from -3.6s to +5.0s
  real ss(nz)
  real ccf(-LAGMAX:LAGMAX)
  integer npr(126)

! The JT65 pseudo-random sync pattern:
  data npr/                                    &
      1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0, &
      0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1, &
      0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1, &
      0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1, &
      1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1, &
      0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1, &
      1,1,1,1,1,1/
  save

  ccfbest=0.
  lag1=LAGMIN
  lag2=LAGMAX
  do lag=lag1,lag2
     s0=0.
     s1=0.
     do i=1,126
        j=16*(i-1)+1 + lag
        if(j.ge.1 .and. j.le.nz-8) then
           x=ss(j)
           if(npr(i).eq.0) then
              s0=s0 + x
           else
              s1=s1 + x
           endif
        endif
     enddo
     ccf(lag)=nflip*(s1-s0)
     if(ccf(lag).gt.ccfbest) then
        ccfbest=ccf(lag)
        lagpk=lag
        xlagpk=lagpk
     endif
  enddo
  if( lagpk.gt.-LAGMAX .and. lagpk.lt.LAGMAX) then
     call peakup(ccf(lagpk-1),ccf(lagpk),ccf(lagpk+1),dx)
     xlagpk=lagpk+dx
  endif
  return
end subroutine ccf2

!
! readwav - open and read the header of a WAV format file
!
! On successful exit the file is left positioned at the start of the
! data.
!
! Example of usage:
!
!  use readwav
!  integer*2 sample
!  type(wav_header) wav
!  call wav%read ('file.wav')
!  write (*,*) 'Sample rate is: ', wav%audio_format%sample_rate
!  do i=0,wav%data_size
!    read (unit=wav%lun) sample
!    ! process sample
!  end do
!
module readwav
  implicit none

  type format_chunk
     integer*2 audio_format
     integer*2 num_channels
     integer sample_rate
     integer byte_rate
     integer*2 block_align
     integer*2 bits_per_sample
  end type format_chunk
  
  type, public :: wav_header
     integer :: lun
     type(format_chunk) :: audio_format
     integer :: data_size
   contains
     procedure :: read
  end type wav_header

  private
contains
  subroutine read (this, filename)
    implicit none

    type riff_descriptor
       character(len=4) :: id
       integer :: size
    end type riff_descriptor

    class(wav_header), intent(inout) :: this
    character(len=*), intent(in) :: filename

    integer :: filepos
    type(riff_descriptor) :: desc
    character(len=4) :: riff_type

    this%lun=26
    open (unit=this%lun, file=filename, access='stream',status='old')
    read (unit=this%lun) desc,riff_type
    inquire (unit=this%lun, pos=filepos)
    do
       read (unit=this%lun, pos=filepos) desc
       inquire (unit=this%lun, pos=filepos)
       if (desc%id .eq. 'fmt ') then
          read (unit=this%lun) this%audio_format
       else if (desc%id .eq. 'data') then
          this%data_size = desc%size
          exit
       end if
       filepos = filepos + (desc%size + 1) / 2 * 2 ! pad to even alignment
    end do
    return
  end subroutine read
end module readwav

subroutine pfxdump(fname)
  character*(*) fname
  include 'pfx.f90'

  open(11,file=fname,status='unknown')
  write(11,1001) sfx
1001 format('Supported Suffixes:'/(11('/',a1,2x)))
  write(11,1002) pfx
1002 format(/'Supported Add-On DXCC Prefixes:'/(15(a5,1x)))
  close(11)

  return
end subroutine pfxdump

subroutine symspec(k,ndiskdat,nb,nbslider,nfsample,    &
     pxdb,ssz5a,nkhz,ihsym,nzap,slimit,lstrong)

!  k        pointer to the most recent new data
!  ndiskdat 0/1 to indicate if data from disk
!  nb       0/1 status of noise blanker
!  nfsample sample rate (Hz)
!  pxdb     power in x channel (0-60 dB)
!  ssz5a    polarized spectrum, for waterfall display
!  nkhz     integer kHz portion of center frequency, e.g., 125 for 144.125
!  ihsym    index number of this half-symbol (1-400)
!  nzap     number of samples zero'ed by noise blanker

  use qmap_params, only: MAX_NSMAX, MAX_NFFT, nrate_active, nsmax_active, nfft_active
  include 'njunk.f90'
  real*8 ts,hsym
  real*8 fcenter
! COMMON sized at MAX (256 kHz wide-mode upper bound); see recvpkt.f90.
  common/datcom/dd(2,MAX_NSMAX),ss(400,MAX_NFFT),savg(MAX_NFFT),fcenter,nutc,  &
       junk(NJUNK)
! ssz5a is a dummy arg — caller (mainwindow.cpp dataSink) sizes the
! buffer at qmap_runtime::MAX_NFFT and bounds reads by activeNfft();
! assumed-size lets us write up to nfft_active entries here.
  real*4 ssz5a(*)
! Working buffers are sized at the runtime active NFFT on first call.
! Allocatable+save preserves the allocation across calls; we don't
! reallocate (active NFFT is set once at startup before any libqmap
! call; live rate-switching mid-session would need an explicit
! reallocate path, deferred).
  real*4, allocatable, save :: w(:)
  complex, allocatable, save :: cx(:)
  complex, allocatable, save :: cx00(:)
  complex cx0(0:1023),cx1(0:1023)
  logical*1 lstrong(0:1023)
  data rms/999.0/,k0/99999999/,nadjx/0/,nadjy/0/
  save

  hsym=0.15d0*real(nrate_active,8)     !Samples per Q65-30x half-symbol (= 0.15 s * active rate)
  npts=2*hsym                          !Full Q65-30x symbol
  if(k.gt.nsmax_active-9000) go to 999 !was: k.gt.5751000 = NSMAX-9000 at 96 kHz
  if(k.lt.npts) then
     ihsym=0
     go to 999             !Wait for enough samples to start
  endif
  if(k0.eq.99999999) then
     if(.not.allocated(cx))   allocate(cx(nfft_active))
     if(.not.allocated(cx00)) allocate(cx00(nfft_active))
     if(.not.allocated(w))    allocate(w(nfft_active))
!     pi=4.0*atan(1.0)
!     do i=1,nfft_active
!        w(i)=(sin(i*pi/nfft_active))**2                   !Window
!     enddo
     w=0.7                             !Flat window
  endif

  if(k.lt.k0) then
     ts=1.d0 - hsym
     ss=0.
     savg=0.
     ihsym=0
     k1=0
     if(ndiskdat.eq.0) dd(1:2,k+1:nsmax_active)=0.  !### Should not be needed ??? ### was: 5760000 = NSMAX at 96 kHz
  endif
  k0=k

  nzap=0
  sigmas=1.5*(10.0**(0.01*nbslider)) + 0.7
  peaklimit=sigmas*max(10.0,rms)
  faclim=3.0
  px=0.

  nwindow=2
  nfft2=1024
  kstep=nfft2
  if(nwindow.ne.0) kstep=nfft2/2
  nblks=(k-k1)/kstep
  do nblk=1,nblks
     j=k1+1
     do i=0,nfft2-1
        cx0(i)=cmplx(dd(1,j+i),dd(2,j+i))
     enddo
     call timf2(k,nfft2,nwindow,nb,peaklimit,       &
          faclim,cx0,cx1,slimit,lstrong,   &
          px,nzap)

     do i=0,kstep-1
        dd(1,j+i)=real(cx1(i))
        dd(2,j+i)=aimag(cx1(i))
     enddo
     k1=k1+kstep
  enddo

  ts=ts+hsym
  ja=ts                               !Index of first sample
  jb=ja+npts-1                        !Last sample
  i=0
  fac=0.0002
  do j=ja,jb                          !Copy data into cx
     x1=dd(1,j)
     x2=dd(2,j)
     i=i+1
     cx(i)=fac*cmplx(x1,x2)
  enddo
  cx(npts+1:)=0.

  if(nzap/178.lt.50 .and. (ndiskdat.eq.0 .or. ihsym.lt.280)) then
     nsum=nblks*kstep - nzap
     if(nsum.le.0) nsum=1
     rmsx=sqrt(px/nsum)
     rms=rmsx
  endif
  pxdb=0.
  if(rmsx.gt.1.0) pxdb=20.0*log10(rmsx)
  if(pxdb.gt.60.0) pxdb=60.0

  cx00=cx

  ihsym=ihsym+1
  cx=w*cx00                           !Apply window for 2nd forward FFT
  call four2a(cx,nfft_active,1,1,1)   !Second forward FFT (X) — was NFFT=32768
  n=min(400,ihsym)
  do i=1,nfft_active
     sx=real(cx(i))**2 + aimag(cx(i))**2
     ss(n,i)=sx                    ! Pol = 0
     savg(i)=savg(i) + sx
     ssz5a(i)=sx
  enddo

  nkhz=nint(1000.d0*(fcenter-int(fcenter)))
  if(fcenter.eq.0.d0) nkhz=125
!  write(*,3001) hsym,ts,ja,jb,ihsym
!3001 format(2f12.3,3i10)

999 return
end subroutine symspec

subroutine osdwspr(ss,apmask,ndeep,cw,nhardmin,dmin)
! 
use iso_c_binding
parameter (N=162, K=50, L=32)

!integer*1 p1(L),p2(L),p3(L),p4(L)
integer*1 gg(64)

real ss(N)
integer*1 apmask(N),apmaskr(N)
integer*1 gen(K,N)
integer*1 genmrb(K,N),g2(N,K)
integer*1 temp(K),m0(K),me(K),mi(K),misub(K),e2sub(N-K),e2(N-K),ui(N-K)
integer*1 r2pat(N-K)
integer indices(N),nxor(N)
integer*1 cw(N),ce(N),c0(N),hdec(N)
integer indx(N),ndeep,nhardmin
real rx(N),absrx(N),dmin
logical first,reset
data first/.true./
data gg/1,1,0,1,0,1,0,0,1,0,0,0,1,1,0,0,1,0,1,0,0,1,0,1,1,1,0,1,1,0,0,0, &
        0,1,0,0,0,0,0,0,1,0,0,1,1,1,1,0,0,0,1,0,0,1,0,0,1,0,1,1,1,1,1,1/

save first,gen

if( first ) then ! fill the generator matrix
  gen=0
  gen(1,1:2*L)=gg(1:2*L)
  do i=2,K
    gen(i,:)=cshift(gen(i-1,:),-2)
  enddo
  first=.false.
endif

rx=ss/127.0
apmaskr=apmask

! Hard decisions on the received word.
hdec=0            
where(rx .ge. 0) hdec=1

! Use magnitude of received symbols as a measure of reliability.
absrx=abs(rx) 
call indexx(absrx,N,indx)  

! Re-order the columns of the generator matrix in order of decreasing reliability.
do i=1,N
  genmrb(1:K,i)=gen(1:K,indx(N+1-i))
  indices(i)=indx(N+1-i)
enddo

! Do gaussian elimination to create a generator matrix with the most reliable
! received bits in positions 1:K in order of decreasing reliability (more or less). 
do id=1,K ! diagonal element indices 
  do icol=id,K+20  ! The 20 is ad hoc - beware
    iflag=0
    if( genmrb(id,icol) .eq. 1 ) then
      iflag=1
      if( icol .ne. id ) then ! reorder column
        temp(1:K)=genmrb(1:K,id)
        genmrb(1:K,id)=genmrb(1:K,icol)
        genmrb(1:K,icol)=temp(1:K) 
        itmp=indices(id)
        indices(id)=indices(icol)
        indices(icol)=itmp
      endif
      do ii=1,K
        if( ii .ne. id .and. genmrb(ii,id) .eq. 1 ) then
          genmrb(ii,1:N)=ieor(genmrb(ii,1:N),genmrb(id,1:N))
        endif
      enddo
      exit
    endif
  enddo
enddo

g2=transpose(genmrb)

! The hard decisions for the K MRB bits define the order 0 message, m0. 
! Encode m0 using the modified generator matrix to find the "order 0" codeword. 
! Flip various combinations of bits in m0 and re-encode to generate a list of
! codewords. Return the member of the list that has the smallest Euclidean
! distance to the received word. 

hdec=hdec(indices)   ! hard decisions from received symbols
m0=hdec(1:K)         ! zero'th order message
absrx=absrx(indices) 
rx=rx(indices)       
apmaskr=apmaskr(indices)

call mrbencode(m0,c0,g2,N,K)

nxor=ieor(c0,hdec)
nhardmin=sum(nxor)
dmin=sum(nxor*absrx)
cw=c0
ntotal=0
nrejected=0

if(ndeep.le.0) goto 998  ! norder=0
if(ndeep.gt.5) ndeep=5
if( ndeep.eq. 1) then
   nord=1
   npre1=0
   npre2=0
   nt=66
   ntheta=16
elseif(ndeep.eq.2) then
   nord=1
   npre1=1
   npre2=0
   nt=66
   ntheta=22
   ntau = 16
elseif(ndeep.eq.3) then
   nord=1
   npre1=1
   npre2=1
   nt=66
   ntheta=22
   ntau=16
elseif(ndeep.eq.4) then
   nord=2
   npre1=1
   npre2=1
   nt=66
   ntheta=22
   ntau=16
elseif(ndeep.eq.5) then
   nord=3
   npre1=1
   npre2=1
   nt=66
   ntheta=22
   ntau=16
endif

do iorder=1,nord
   misub(1:K-iorder)=0
   misub(K-iorder+1:K)=1
   iflag=K-iorder+1
   do while(iflag .ge.0)
      if(iorder.eq.nord .and. npre1.eq.0) then
         iend=iflag
      else
         iend=1
      endif
      d1=0.
      do n1=iflag,iend,-1
         mi=misub
         mi(n1)=1
         if(any(iand(apmaskr(1:K),mi).eq.1)) cycle
         ntotal=ntotal+1
         me=ieor(m0,mi)
         if(n1.eq.iflag) then
            call mrbencode(me,ce,g2,N,K)
            e2sub=ieor(ce(K+1:N),hdec(K+1:N))
            e2=e2sub
            nd1Kpt=sum(e2sub(1:nt))+1
            d1=sum(ieor(me(1:K),hdec(1:K))*absrx(1:K))
         else
            e2=ieor(e2sub,g2(K+1:N,n1))
            nd1Kpt=sum(e2(1:nt))+2
         endif
         if(nd1Kpt .le. ntheta) then
            call mrbencode(me,ce,g2,N,K)
            nxor=ieor(ce,hdec)
            if(n1.eq.iflag) then
               dd=d1+sum(e2sub*absrx(K+1:N))
            else
               dd=d1+ieor(ce(n1),hdec(n1))*absrx(n1)+sum(e2*absrx(K+1:N))
            endif
            if( dd .lt. dmin ) then
               dmin=dd
               cw=ce
               nhardmin=sum(nxor)
               nd1Kptbest=nd1Kpt
            endif
         else 
            nrejected=nrejected+1
         endif
      enddo
! Get the next test error pattern, iflag will go negative
! when the last pattern with weight iorder has been generated.
      call nextpat(misub,k,iorder,iflag)
   enddo
enddo

if(npre2.eq.1) then
   reset=.true.
   ntotal=0
   do i1=K,1,-1
      do i2=i1-1,1,-1
         ntotal=ntotal+1
         mi(1:ntau)=ieor(g2(K+1:K+ntau,i1),g2(K+1:K+ntau,i2))
         call boxit(reset,mi(1:ntau),ntau,ntotal,i1,i2)
      enddo
   enddo

   ncount2=0
   ntotal2=0
   reset=.true.
! Now run through again and do the second pre-processing rule
   misub(1:K-nord)=0
   misub(K-nord+1:K)=1
   iflag=K-nord+1
   do while(iflag .ge.0)
      me=ieor(m0,misub)
      call mrbencode(me,ce,g2,N,K)
      e2sub=ieor(ce(K+1:N),hdec(K+1:N))
      do i2=0,ntau
         ntotal2=ntotal2+1
         ui=0 
         if(i2.gt.0) ui(i2)=1 
         r2pat=ieor(e2sub,ui)
778      continue 
            call fetchit(reset,r2pat(1:ntau),ntau,in1,in2)
            if(in1.gt.0.and.in2.gt.0) then
               ncount2=ncount2+1
               mi=misub               
               mi(in1)=1
               mi(in2)=1
               if(sum(mi).lt.nord+npre1+npre2.or.any(iand(apmaskr(1:K),mi).eq.1)) cycle
               me=ieor(m0,mi)
               call mrbencode(me,ce,g2,N,K)
               nxor=ieor(ce,hdec)
               dd=sum(nxor*absrx)
               if( dd .lt. dmin ) then
                  dmin=dd
                  cw=ce
                  nhardmin=sum(nxor)
               endif
               goto 778
             endif
      enddo
      call nextpat(misub,K,nord,iflag)
   enddo
endif

998 continue
! Re-order the codeword to as-received order.
cw(indices)=cw
hdec(indices)=hdec
return
end subroutine osdwspr

subroutine mrbencode(me,codeword,g2,N,K)
integer*1 me(K),codeword(N),g2(N,K)
! fast encoding for low-weight test patterns
  codeword=0
  do i=1,K
    if( me(i) .eq. 1 ) then
      codeword=ieor(codeword,g2(1:N,i))
    endif
  enddo
return
end subroutine mrbencode

subroutine nextpat(mi,k,iorder,iflag)
  integer*1 mi(k),ms(k)
! generate the next test error pattern
  ind=-1
  do i=1,k-1
     if( mi(i).eq.0 .and. mi(i+1).eq.1) ind=i 
  enddo
  if( ind .lt. 0 ) then ! no more patterns of this order
    iflag=ind
    return
  endif
  ms=0
  ms(1:ind-1)=mi(1:ind-1)
  ms(ind)=1
  ms(ind+1)=0
  if( ind+1 .lt. k ) then
     nz=iorder-sum(ms)
     ms(k-nz+1:k)=1
  endif
  mi=ms
  do i=1,k  ! iflag will point to the lowest-index 1 in mi
    if(mi(i).eq.1) then
      iflag=i 
      exit
    endif
  enddo
  return
end subroutine nextpat

subroutine boxit(reset,e2,ntau,npindex,i1,i2)
  integer*1 e2(1:ntau)
  integer   indexes(4000,2),fp(0:525000),np(4000)
  logical reset
  common/boxes/indexes,fp,np

  if(reset) then
    patterns=-1
    fp=-1
    np=-1
    sc=-1
    indexes=-1
    reset=.false.
  endif
 
  indexes(npindex,1)=i1
  indexes(npindex,2)=i2
  ipat=0
  do i=1,ntau
    if(e2(i).eq.1) then
      ipat=ipat+ishft(1,ntau-i)
    endif
  enddo

  ip=fp(ipat)   ! see what's currently stored in fp(ipat)
  if(ip.eq.-1) then
    fp(ipat)=npindex
  else
     do while (np(ip).ne.-1)
      ip=np(ip) 
     enddo  
     np(ip)=npindex
  endif
  return
end subroutine boxit

subroutine fetchit(reset,e2,ntau,i1,i2)
  integer   indexes(4000,2),fp(0:525000),np(4000)
  integer   lastpat
  integer*1 e2(ntau)
  logical reset
  common/boxes/indexes,fp,np
  save lastpat,inext

  if(reset) then
    lastpat=-1
    reset=.false.
  endif

  ipat=0
  do i=1,ntau
    if(e2(i).eq.1) then
      ipat=ipat+ishft(1,ntau-i)
    endif
  enddo
  index=fp(ipat)

  if(lastpat.ne.ipat .and. index.gt.0) then ! return first set of indices
     i1=indexes(index,1)
     i2=indexes(index,2)
     inext=np(index)
  elseif(lastpat.eq.ipat .and. inext.gt.0) then
     i1=indexes(inext,1)
     i2=indexes(inext,2)
     inext=np(inext)
  else
     i1=-1
     i2=-1
     inext=-1
  endif
  lastpat=ipat
  return
end subroutine fetchit
 

program q65sim

! Generate simulated Q65 data for testing the decoder.

  use wavhdr
  use packjt
  parameter (NMAX=300*12000)             !Total samples in .wav file
  type(hdr) h                            !Header for .wav file
  integer*2 iwave(NMAX)                  !Generated waveform
  integer itone(85)                      !Channel symbols (values 0-65)
  integer ntone(85,10)                   !Channel symbols for up to 10 messages
  integer y(63)                          !Codeword
  integer istart                         !averaging compatible start seconds
  integer imins                          !minutes for 15s period timestamp
  integer isecs                          !seconds for 15s period timestamp
  real*4 xnoise(NMAX)                    !Generated random noise
  real*4 dat(NMAX)                       !Generated real data
  complex cdat(NMAX)                     !Generated complex waveform
  complex cspread(0:NMAX-1)              !Complex amplitude for Rayleigh fading 
  complex z
  real*8 f00,f0,dt,twopi,phi,dphi,baud,fsample,freq
  character fname*17,csubmode*1,arg*12,c2*2
  character*37 msg,msgsent,imsg(10)
  
  nargs=iargc()
  if(nargs.ne.11) then
     print*,'Usage:   q65sim         "msg"     A-E freq fDop DT  f1 Stp TRp Nsig Nfile SNR'
     print*,'Example: q65sim "K1ABC W9XYZ EN37" A  1500 0.0 0.0 0.0  1   60   1    1   -26'
     print*,'Example: q65sim "ST" A  1500 0.0 0.0 0.0  1   60   1   -26'
     print*,'         fDop = Doppler spread'
     print*,'         f1   = Drift or Doppler rate (Hz/min)'
     print*,'         Stp  = Step size (Hz)'
     print*,'         Stp  = 0 implies no Doppler tracking'
     print*,'         Nsig = number of generated signals, 1 - 10'
     print*,'         Creates filenames which increment to permit averaging in first period'
     print*,'         If msg = ST program produces a single tone at freq'
     go to 999
  endif
  call getarg(1,msg)
  call getarg(2,csubmode)
  mode65=2**(ichar(csubmode)-ichar('A'))
  call getarg(3,arg)
  read(arg,*) f00
  call getarg(4,arg)
  read(arg,*) fspread
  call getarg(5,arg)
  read(arg,*) xdt
  call getarg(6,arg)
  read(arg,*) f1
  call getarg(7,arg)
  read(arg,*) nstp
  call getarg(8,arg)
  read(arg,*) ntrperiod
  call getarg(9,arg)
  read(arg,*) nsig
  call getarg(10,arg)
  read(arg,*) nfiles
  call getarg(11,arg)
  read(arg,*) snrdb

  if(ntrperiod.eq.15) then
     nsps=1800
  else if(ntrperiod.eq.30) then
     nsps=3600
  else if(ntrperiod.eq.60) then
     nsps=7200
  else if(ntrperiod.eq.120) then
     nsps=16000
  else if(ntrperiod.eq.300) then
     nsps=41472
  else
     print*,'Invalid TR period'
     go to 999
  endif

  rms=100.
  fsample=12000.d0                   !Sample rate (Hz)
  npts=fsample*ntrperiod             !Total samples in .wav file
  nfft=npts
  nh=nfft/2
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  nsym=85                            !Number of channel symbols
  mode65=2**(ichar(csubmode) - ichar('A'))

  
  imsg(1)=msg
  if(nsig.ge.2) then
     i0=index(msg,' ')
     i0=i0 + index(msg(i0+1:),' ')-2
     do i=1,nsig
        c2=char(ichar('A')+i-1)//char(ichar('A')+i-1)
        imsg(i)=msg(1:i0-1)//c2//msg(i0+2:)
     enddo
  endif

  ichk=0
  do i=1,nsig
     msg=imsg(i)
     call genq65(msg,ichk,msgsent,itone,i3,n3)
     ntone(:,i)=itone
  enddo

  if(nsig.eq.1) then
     j=0
     do i=1,85
        if(itone(i).gt.0) then
           j=j+1
           y(j)=itone(i)-1
        endif
     enddo
     write(*,1001) y(1:13),y(1:13)
1001 format('Generated message'/'6-bit:  ',13i3/'binary: ',13b6.6)
     write(*,1002) y
1002 format(/'Codeword:'/(20i3))
     write(*,1003) itone
1003 format(/'Channel symbols:'/(20i3))
  endif

  baud=12000.d0/nsps                 !Keying rate (6.67 baud fot 15-s sequences)
  h=default_header(12000,npts)

  write(*,1004) 
1004 format('File    TR   Freq Mode  S/N   Dop     DT   f1  Stp  Message'/70('-'))

  do ifile=1,nfiles  !Loop over requested number of files
     istart = (ifile*ntrperiod*2) - (ntrperiod*2)
     if(ntrperiod.lt.30) then !wdg was 60
        imins=istart/60
        isecs=istart-(60*imins)
        write(fname,1005) imins,isecs        !Construction of output  filename for 15s periods with averaging
1005    format('000000_',i4.4, i2.2,'.wav')
     else
        write(fname,1106) istart/60     !Output filename to be compatible with averaging 30-300s periods
1106    format('000000_',i4.4,'.wav')
     endif

     open(10,file=trim(fname),access='stream',status='unknown')
     xnoise=0.
     if(snrdb.lt.90) then
        do i=1,npts
           xnoise(i)=gran()          !Generate gaussian noise
        enddo
     endif
     cdat=0.

     bandwidth_ratio=2500.0/6000.0
     sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*snrdb)
     if(snrdb.gt.90.0) sig=1.0
     write(*,1020) ifile,ntrperiod,f00,csubmode,snrdb,fspread,xdt,f1,nstp,trim(msgsent)
1020 format(i4,i6,f7.1,2x,a1,2x,f5.1,1x,f6.2,2f6.1,i4,2x,a)

     n=65.0*baud*mode65/100.0 + 0.9999
     nfstep=100*n
     nf1=1500 - nfstep*(nsig-1)/2
     do n=1,nsig
        f0=f00
        if(nsig.ge.2) then
           f0=nf1 + (n-1)*nfstep
           itone=ntone(:,n)
        endif
        phi=0.d0
        dphi=0.d0
        k=(xdt+0.5)*12000                   !Start audio at t=xdt+0.5 s (TR=15 and 30 s)
        if(ntrperiod.ge.60) k=(xdt+1.0)*12000   !TR 60+ at t = xdt + 1.0 s
        isym0=-99
        do i=1,npts                         !Add this signal into cdat()
           isym=i/nsps + 1
           if(isym.gt.nsym) exit
           if(isym.ne.isym0) then
              freq_drift=f1*i*dt/60.0
              if(nstp.ne.0) freq_drift=freq_drift - nstp*nint(freq_drift/nstp)
              if (msg(1:2).eq.'ST') then
                 freq = f0 + freq_drift
              else
                 freq = f0 + freq_drift + itone(isym)*baud*mode65
              endif
              dphi=twopi*freq*dt
              isym0=isym
           endif
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=cmplx(cos(xphi),sin(xphi))
           k=k+1
           if(k.ge.1) cdat(k)=cdat(k) + sig*z
        enddo
     enddo
     
     if(fspread.ne.0) then                  !Apply specified Doppler spread
        df=12000.0/nfft
        cspread(0)=1.0
        cspread(nh)=0.
        b=6.0                       !Use truncated Lorenzian shape for fspread
        do i=1,nh
           f=i*df
           x=b*f/fspread
           z=0.
           a=0.
           if(x.lt.3.0) then                          !Cutoff beyond x=3
              a=sqrt(1.111/(1.0+x*x)-0.1)             !Lorentzian amplitude
              phi1=twopi*rran()                       !Random phase
              z=a*cmplx(cos(phi1),sin(phi1))
           endif
           cspread(i)=z
           z=0.
           if(x.lt.3.0) then                !Same thing for negative freqs
              phi2=twopi*rran()
              z=a*cmplx(cos(phi2),sin(phi2))
           endif
           cspread(nfft-i)=z
        enddo

        call four2a(cspread,nfft,1,1,1)             !Transform to time domain

        sum=0.
        do i=0,nfft-1
           p=real(cspread(i))**2 + aimag(cspread(i))**2
           sum=sum+p
        enddo
        avep=sum/nfft
        fac=sqrt(1.0/avep)
        cspread=fac*cspread                   !Normalize to constant avg power
        cdat=cspread*cdat                     !Apply Rayleigh fading
     endif

!     psig=0.
!     pnoise=0.
!     do i=1,npts
!        if(i.gt.12000 .and. i.lt.624000) then
!           psig=psig + aimag(cdat(i))**2
!           pnoise=pnoise + xnoise(i)*xnoise(i)
!        endif
!     enddo
!     pnoise=pnoise*bandwidth_ratio
!     snr_2500=db(psig/pnoise)                 !Calibration confirmation!
!     print*,'SNR_2500:',snr_2500

     dat=aimag(cdat) + xnoise                 !Add generated AWGN noise
     fac=32767.0
     if(snrdb.ge.90.0) iwave(1:npts)=nint(fac*dat(1:npts))
     if(snrdb.lt.90.0) iwave(1:npts)=nint(rms*dat(1:npts))
     write(10) h,iwave(1:npts)                !Save the .wav file
     close(10)
  enddo

999 end program q65sim

subroutine encode240_74(message,codeword)
   use, intrinsic :: iso_c_binding
   use iso_c_binding, only: c_loc,c_size_t
   use crc

   integer, parameter:: N=240, K=74, M=N-K
   integer*1 codeword(N)
   integer*1 gen(M,K)
   integer*1 message(K)
   integer*1 pchecks(M)
   include "ldpc_240_74_generator.f90"
   logical first
   data first/.true./
   save first,gen

   if( first ) then ! fill the generator matrix
      gen=0
      do i=1,M
         do j=1,19
            read(g(i)(j:j),"(Z1)") istr
            ibmax=4
            if(j.eq.19) ibmax=2
            do jj=1, ibmax
               icol=(j-1)*4+jj
               if( btest(istr,4-jj) ) gen(i,icol)=1
            enddo
         enddo
      enddo
      first=.false.
   endif

   do i=1,M
      nsum=0
      do j=1,K
         nsum=nsum+message(j)*gen(i,j)
      enddo
      pchecks(i)=mod(nsum,2)
   enddo

   codeword(1:K)=message
   codeword(K+1:N)=pchecks

   return
end subroutine encode240_74

subroutine symspec(k,nxpol,ndiskdat,nb,nbslider,idphi,nfsample,    &
     fgreen,iqadjust,iqapply,gainx,gainy,phasex,phasey,rejectx,rejecty,  &
     pxdb,pydb,ssz5a,nkhz,ihsym,nzap,slimit,lstrong)

!  k        pointer to the most recent new data
!  nxpol    0/1 to indicate single- or dual-polarization
!  ndiskdat 0/1 to indicate if data from disk
!  nb       0/1 status of noise blanker
!  idphi    Phase correction for Y channel, degrees
!  nfsample sample rate (Hz)
!  fgreen   Frequency of green marker in I/Q calibrate mode (-48.0 to +48.0 kHz)
!  iqadjust 0/1 to indicate whether IQ adjustment is active
!  iqapply  0/1 to indicate whether to apply I/Q calibration
!  pxdb     power in x channel (0-60 dB)
!  pydb     power in y channel (0-60 dB)
!  ssz5a    polarized spectrum, for waterfall display
!  nkhz     integer kHz portion of center frequency, e.g., 125 for 144.125
!  ihsym    index number of this half-symbol (1-322)
!  nzap     number of samples zero'ed by noise blanker

  include 'njunk.f90'
  parameter (NSMAX=60*96000)          !Total sample intervals per minute
  parameter (NFFT=32768)              !Length of FFTs
  real*8 ts,hsym
  real*8 fcenter
  common/datcom/dd(4,5760000),ss(4,322,NFFT),savg(4,NFFT),fcenter,nutc,  &
       junk(NJUNK)
  real*4 ssz5a(NFFT),w(NFFT),w2a(NFFT),w2b(NFFT)
  complex z,zfac
  complex zsumx,zsumy
  complex cx(NFFT),cy(NFFT)
  complex cx00(NFFT),cy00(NFFT)
  complex cx0(0:1023),cx1(0:1023)
  complex cy0(0:1023),cy1(0:1023)
  logical*1 lstrong(0:1023)
  data rms/999.0/,k0/99999999/,nadjx/0/,nadjy/0/
  save

  nfast=1
  if(k.gt.5751000) go to 999
  if(k.lt.NFFT) then
     ihsym=0
     go to 999             !Wait for enough samples to start
  endif
  if(k0.eq.99999999) then
     pi=4.0*atan(1.0)
     w2a=0.
     w2b=0.
     do i=1,NFFT
        w(i)=(sin(i*pi/NFFT))**2                          !Window for nfast=1
        if(i.lt.17833) w2a(i)=(sin(i*pi/17832.925))**2    !Window a for nfast=2
        j=i-8916
        if(j.gt.0 .and. j.lt.17833) w2b(i)=(sin(j*pi/17832.925))**2    ! b
     enddo
     w2a=sqrt(2.0)*w2a
     w2b=sqrt(2.0)*w2b
  endif

  hsym=2048.d0*96000.d0/11025.d0      !Samples per JT65 half-symbol
  if(nfsample.eq.95238)   hsym=2048.d0*95238.1d0/11025.d0

  if(k.lt.k0) then
     ts=1.d0 - hsym
     savg=0.
     ihsym=0
     k1=0
     if(ndiskdat.eq.0) dd(1:4,k+1:5760000)=0.  !### Should not be needed ??? ###
  endif
  k0=k

  nzap=0
  sigmas=1.5*(10.0**(0.01*nbslider)) + 0.7
  peaklimit=sigmas*max(10.0,rms)
  faclim=3.0
  px=0.
  py=0.

  iqapply0=0
  iqadjust0=0
  if(iqadjust.ne.0) iqapply0=0
  nwindow=2
!  nwindow=0                                    !### No windowing ###
  nfft2=1024
  kstep=nfft2
  if(nwindow.ne.0) kstep=nfft2/2
  nblks=(k-k1)/kstep
  do nblk=1,nblks
     j=k1+1
     do i=0,nfft2-1
        cx0(i)=cmplx(dd(1,j+i),dd(2,j+i))
        if(nxpol.ne.0) cy0(i)=cmplx(dd(3,j+i),dd(4,j+i))
     enddo
     call timf2(k,nxpol,nfft2,nwindow,nb,peaklimit,iqadjust0,iqapply0,       &
          faclim,cx0,cy0,gainx,gainy,phasex,phasey,cx1,cy1,slimit,lstrong,   &
          px,py,nzap)

     do i=0,kstep-1
        dd(1,j+i)=real(cx1(i))
        dd(2,j+i)=aimag(cx1(i))
        if(nxpol.ne.0) then
           dd(3,j+i)=real(cy1(i))
           dd(4,j+i)=aimag(cy1(i))
        endif
     enddo
     k1=k1+kstep
  enddo

  npts=NFFT                           !Samples used in each half-symbol FFT

  ts=ts+hsym
  ja=ts                               !Index of first sample
  jb=ja+npts-1                        !Last sample

  i=0
  fac=0.0002
  dphi=idphi/57.2957795
  zfac=fac*cmplx(cos(dphi),sin(dphi))
  do j=ja,jb                          !Copy data into cx, cy
     x1=dd(1,j)
     x2=dd(2,j)
     if(nxpol.ne.0) then
        x3=dd(3,j)
        x4=dd(4,j)
     else
        x3=0.
        x4=0.
     endif
     i=i+1
     cx(i)=fac*cmplx(x1,x2)
     cy(i)=zfac*cmplx(x3,x4)          !NB: cy includes dphi correction
  enddo

  if(nzap/178.lt.50 .and. (ndiskdat.eq.0 .or. ihsym.lt.280)) then
     nsum=nblks*kstep - nzap
     if(nsum.le.0) nsum=1
     rmsx=sqrt(0.5*px/nsum)
     rmsy=sqrt(0.5*py/nsum)
     rms=rmsx
     if(nxpol.ne.0) rms=sqrt((px+py)/(4.0*nsum))
  endif
  pxdb=0.
  pydb=0.
  if(rmsx.gt.1.0) pxdb=20.0*log10(rmsx)
  if(rmsy.gt.1.0) pydb=20.0*log10(rmsy)
  if(pxdb.gt.60.0) pxdb=60.0
  if(pydb.gt.60.0) pydb=60.0

  cx00=cx
  if(nxpol.ne.0) cy00=cy

  do mm=1,nfast
     ihsym=ihsym+1
     if(nfast.eq.1) then
        cx=w*cx00                           !Apply window for 2nd forward FFT
        if(nxpol.ne.0) cy=w*cy00
     else
        if(mm.eq.1) then
           cx=w2a*cx00
           if(nxpol.ne.0) cy=w2a*cy00
        else
           cx=w2b*cx00
           if(nxpol.ne.0) cy=w2b*cy00
        endif
     endif

     call four2a(cx,NFFT,1,1,1)          !Second forward FFT (X)
     if(iqadjust.eq.0) nadjx=0
     if(iqadjust.ne.0 .and. nadjx.lt.50) call iqcal(nadjx,cx,NFFT,    &
          gainx,phasex,zsumx,ipkx,rejectx0)
     if(iqapply.ne.0) call iqfix(cx,NFFT,gainx,phasex)

     if(nxpol.ne.0) then
        call four2a(cy,NFFT,1,1,1)       !Second forward FFT (Y)
        if(iqadjust.eq.0) nadjy=0
        if(iqadjust.ne.0 .and. nadjy.lt.50) call iqcal(nadjy,cy,NFFT, &
             gainy,phasey,zsumy,ipky,rejecty)
        if(iqapply.ne.0) call iqfix(cy,NFFT,gainy,phasey)
     endif

     n=min(322,ihsym)
     do i=1,NFFT
        sx=real(cx(i))**2 + aimag(cx(i))**2  
        ss(1,n,i)=sx                    ! Pol = 0
        savg(1,i)=savg(1,i) + sx

        if(nxpol.ne.0) then
           z=cx(i) + cy(i)
           s45=0.5*(real(z)**2 + aimag(z)**2)
           ss(2,n,i)=s45                   ! Pol = 45
           savg(2,i)=savg(2,i) + s45

           sy=real(cy(i))**2 + aimag(cy(i))**2
           ss(3,n,i)=sy                    ! Pol = 90
           savg(3,i)=savg(3,i) + sy
        
           z=cx(i) - cy(i)
           s135=0.5*(real(z)**2 + aimag(z)**2)
           ss(4,n,i)=s135                  ! Pol = 135
           savg(4,i)=savg(4,i) + s135

           z=cx(i)*conjg(cy(i))
           q=sx - sy
           u=2.0*real(z)
           ssz5a(i)=0.707*sqrt(q*q + u*u)    !Spectrum of linear polarization
! Leif's formula:
!     ssz5a(i)=0.5*(sx+sy) + (real(z)**2 + aimag(z)**2 - sx*sy)/(sx+sy)
        else
           ssz5a(i)=sx
        endif
     enddo
  enddo

  if(ihsym.eq.278) then
     if(iqadjust.ne.0 .and. ipkx.ne.0 .and. ipky.ne.0) then
        rejectx=10.0*log10(savg(1,1+nfft-ipkx)/savg(1,1+ipkx))
        rejecty=10.0*log10(savg(3,1+nfft-ipky)/savg(3,1+ipky))
     endif
  endif

  nkhz=nint(1000.d0*(fcenter-int(fcenter)))
  if(fcenter.eq.0.d0) nkhz=125

999 return
end subroutine symspec

subroutine sync4d(cd0,i0,ctwk,itwk,sync)

! Compute sync power for a complex, downsampled FT4 signal.

  include 'ft4_params.f90'
  parameter(NP=NMAX/NDOWN,NSS=NSPS/NDOWN)
  complex cd0(0:NP-1)
  complex csynca(2*NSS),csyncb(2*NSS),csyncc(2*NSS),csyncd(2*NSS)
  complex csync2(2*NSS)
  complex ctwk(2*NSS)
  complex z1,z2,z3,z4
  logical first
  integer icos4a(0:3),icos4b(0:3),icos4c(0:3),icos4d(0:3)
  data icos4a/0,1,3,2/
  data icos4b/1,0,2,3/
  data icos4c/2,3,1,0/
  data icos4d/3,2,0,1/
  data first/.true./
  save first,twopi,csynca,csyncb,csyncc,csyncd,fac

  p(z1)=(real(z1*fac)**2 + aimag(z1*fac)**2)**0.5          !Statement function for power

  if( first ) then
    twopi=8.0*atan(1.0)
    k=1
    phia=0.0
    phib=0.0
    phic=0.0
    phid=0.0
    do i=0,3
      dphia=2*twopi*icos4a(i)/real(NSS) 
      dphib=2*twopi*icos4b(i)/real(NSS) 
      dphic=2*twopi*icos4c(i)/real(NSS) 
      dphid=2*twopi*icos4d(i)/real(NSS) 
      do j=1,NSS/2
        csynca(k)=cmplx(cos(phia),sin(phia)) 
        csyncb(k)=cmplx(cos(phib),sin(phib)) 
        csyncc(k)=cmplx(cos(phic),sin(phic)) 
        csyncd(k)=cmplx(cos(phid),sin(phid)) 
        phia=mod(phia+dphia,twopi)
        phib=mod(phib+dphib,twopi)
        phic=mod(phic+dphic,twopi)
        phid=mod(phid+dphid,twopi)
        k=k+1
      enddo
    enddo
    first=.false.
    fac=1.0/(2.0*NSS)
  endif

  i1=i0                            !four Costas arrays
  i2=i0+33*NSS
  i3=i0+66*NSS
  i4=i0+99*NSS

  z1=0.
  z2=0.
  z3=0.
  z4=0.

  if(itwk.eq.1) csync2=ctwk*csynca      !Tweak the frequency
  z1=0.
  if(i1.ge.0 .and. i1+4*NSS-1.le.NP-1) then
    z1=sum(cd0(i1:i1+4*NSS-1:2)*conjg(csync2))
  elseif( i1.lt.0 ) then
    npts=(i1+4*NSS-1)/2
    if(npts.le.16) then
      z1=0.
    else
      z1=sum(cd0(0:i1+4*NSS-1:2)*conjg(csync2(2*NSS-npts:)))
    endif
  endif

  if(itwk.eq.1) csync2=ctwk*csyncb      !Tweak the frequency
  if(i2.ge.0 .and. i2+4*NSS-1.le.NP-1) z2=sum(cd0(i2:i2+4*NSS-1:2)*conjg(csync2))

  if(itwk.eq.1) csync2=ctwk*csyncc      !Tweak the frequency
  if(i3.ge.0 .and. i3+4*NSS-1.le.NP-1) z3=sum(cd0(i3:i3+4*NSS-1:2)*conjg(csync2))

  if(itwk.eq.1) csync2=ctwk*csyncd      !Tweak the frequency
  z4=0.
  if(i4.ge.0 .and. i4+4*NSS-1.le.NP-1) then
    z4=sum(cd0(i4:i4+4*NSS-1:2)*conjg(csync2))
  elseif( i4+4*NSS-1.gt.NP-1 ) then
    npts=(NP-1-i4+1)/2
    if(npts.le.16) then
      z4=0.
    else
      z4=sum(cd0(i4:i4+2*npts-1:2)*conjg(csync2(1:npts)))
    endif
  endif

  sync = p(z1) + p(z2) + p(z3) + p(z4)

  return
end subroutine sync4d

subroutine sync9w(ss,nzhsym,lag1,lag2,ia,ib,ccfred,ccfblue,ipkbest,lagpk,nadd)

  include 'constants.f90'
  real ss(184,NSMAX)
  real ss1(184),ss1save(184)
  real ccfred(NSMAX)
  real ccfblue(-9:18)
  real sa(NSMAX),sb(NSMAX)
  include 'jt9sync.f90'

! Smooth the symbol spectra (by an amount consistent with measured width??)
  do j=1,nzhsym
     sa=ss(j,1:NSMAX)
     call smo(sa,NSMAX,sb,nadd)
     call smo(sb,NSMAX,sa,nadd)
     ss(j,1:NSMAX)=sa
  enddo

  ipk=0
  ipkbest=0
  sbest=0.
  ccfred=0.
  df=12000.0/16384.0

  do i=ia,ib                                 !Loop over specified freq range
     ss1=ss(1:184,i)                         !Symbol amplitudes at this freq
     call pctile(ss1,nzhsym,50,xmed)         !Median level at this freq
     ss1=ss1/xmed - 1.0

     smax=0.                                 !Find DT in specified range
     do lag=lag1,lag2
        sum1=0.
        nsum=nzhsym
        do j=1,16                            !Sum over 16 sync symbols
           k=ii2(j) + lag
           if(k.ge.1 .and. k.le.nzhsym) then
              sum1=sum1 + ss1(k)
              nsum=nsum-1
           endif
        enddo
        if(sum1.gt.smax) then
           smax=sum1
           ipk=i 
        endif
     enddo

     ccfred(i)=smax                        !Best at this freq, over all lags
     if(smax.gt.sbest) then
        sbest=smax
        ipkbest=ipk
        ss1save=ss1
     endif
  enddo

  call pctile(ccfred(ia),ib-ia+1,50,xmed)
  if(xmed.le.0.0) xmed=1.0
  ccfred=ccfred/xmed

  ss1=ss1save
  smax=0.                                 !Find DT in specified range
  do lag=lag1,lag2
     sum1=0.
     nsum=nzhsym
     do j=1,16                            !Sum over 16 sync symbols
        k=ii2(j) + lag
        if(k.ge.1 .and. k.le.nzhsym) then
           sum1=sum1 + ss1(k)
           nsum=nsum-1
        endif
     enddo
     ccfblue(lag)=sum1
     if(sum1.gt.smax) then
        smax=sum1
        lagpk=lag
     endif
  enddo
  if(lagpk.eq.-9) lagpk=-8                !Protect the ends of ccfblue()
  if(lagpk.eq.18) lagpk=17

  return
end subroutine sync9w

subroutine iqfix(c,nfft,gain,phase)

  complex c(0:nfft-1)
  complex z,h,u,v

  nh=nfft/2
  h=gain*cmplx(cos(phase),sin(phase))

  do i=1,nh-1
     u=c(i)
     v=c(nfft-i)
     x=real(u)  + real(v)  - (aimag(u) + aimag(v))*aimag(h) +         &
          (real(u) - real(v))*real(h)
     y=aimag(u) - aimag(v) + (aimag(u) + aimag(v))*real(h)  +         &
          (real(u) - real(v))*aimag(h)
     c(i)=0.5*cmplx(x,y)
     z=u
     u=v
     v=z
     x=real(u)  + real(v)  - (aimag(u) + aimag(v))*aimag(h) +         &
          (real(u) - real(v))*real(h)
     y=aimag(u) - aimag(v) + (aimag(u) + aimag(v))*real(h)  +         &
          (real(u) - real(v))*aimag(h)
     c(nfft-i)=0.5*cmplx(x,y)
  enddo

  return
end subroutine iqfix

subroutine ephem(mjd0,dut,east_long,geodetic_lat,height,nspecial,     &
     RA,Dec,Az,El,techo,dop,fspread_1GHz,vr)

  implicit real*8 (a-h,o-z)
  real*8 jd                      !Time of observationa as a Julian Date
  real*8 mjd,mjd0                !Modified Julian Date
  real*8 prec(3,3)               !Precession matrix, J2000 to Date
  real*8 rmatn(3,3)              !Nutation matrix
  real*8 rme2000(6)              !Vector from Earth center to Moon, JD2000
  real*8 rmeDate(6)              !Vector from Earth center to Moon at Date
  real*8 rmeTrue(6)              !Include nutation
  real*8 raeTrue(6)              !Vector from Earth center to Obs at Date
  real*8 rmaTrue(6)              !Vector from Obs to Moon at Date
  logical km,bary                !Set km=.true. to get km, km/s from ephemeris
  common/stcomx/km,bary,pvsun(6) !Common used in JPL subroutines
  common/librcom/xl(2),b(2)

  twopi=8.d0*atan(1.d0)          !Define some constants
  rad=360.d0/twopi
  clight=2.99792458d5
  au2km=0.1495978706910000d9
  pi=0.5d0*twopi
  pio2=0.5d0*pi
  km=.true.
  freq=1000.0d6

  do jj=1,2
     mjd=mjd0
     if(jj.eq.1) mjd=mjd - 1.d0/1440.d0
     djutc=mjd
     jd=2400000.5d0 + mjd
     djtt=mjd + sla_DTT(jd)/86400.d0
     ttjd=jd + sla_DTT(jd)/86400.d0

     if(nspecial.ne.8) then
        call pleph(ttjd,10,3,rme2000)            !RME (J2000) from JPL ephemeris

        year=2000.d0 + (jd-2451545.d0)/365.25d0
        call sla_PREC (2000.0d0, year, prec)     !Get precession matrix
        rmeDate(1:3)=matmul(prec,rme2000(1:3))   !Moon geocentric xyz at Date
        rmeDate(4:6)=matmul(prec,rme2000(4:6))   !Moon geocentric vel at Date
     else
        call sla_DMOON(djtt,rmeDate)             !No JPL ephemeris, use DMOON
        rmeDate=rmeDate*au2km
     endif

     if(nspecial.eq.7) then
        rmeTrue=rmeDate
     else
!Nutation to true equinox of Date
        call sla_NUT(djtt,rmatn)
        call sla_DMXV(rmatn,rmeDate,rmeTrue)
        call sla_DMXV(rmatn,rmeDate(4),rmeTrue(4))
     endif

! Local Apparent Sidereal Time:
     djut1=djutc + dut/86400.d0
     if(nspecial.eq.6) djut1=djutc
     xlast=sla_DRANRM(sla_GMST(djut1) + sla_EQEQX(djtt) + east_long)
     call sla_PVOBS(geodetic_lat,height,xlast,raeTrue)
     rmaTrue=rmeTrue - raeTrue*au2km

     if(nspecial.ne.2) then
! Allow for planetary aberration
        tl=499.004782D0*SQRT(rmaTrue(1)**2 + rmaTrue(2)**2 + rmaTrue(3)**2)
        rmaTrue(1:3)=rmaTrue(1:3)-tl*rmaTrue(4:6)/au2km
     endif

!Topocentric RA, Dec, dist, velocity
     call sla_DC62S(rmaTrue,RA,Dec,dist,RAdot,DECdot,vr)
     dop=-2.d0 * freq * vr/clight                    !EME doppler shift
     techo=2.d0*dist/clight                          !Echo delay time (s)
     call libration(jd,RA,Dec,xl(jj),b(jj))
  enddo

  fspread_1GHz=0.0d0
  dldt=57.2957795131*(xl(2)-xl(1))
  dbdt=57.2957795131*(b(2)-b(1))
  rate=sqrt((2*dldt)**2 + (2*dbdt)**2)
  fspread_1GHz=0.5*6741*rate

  call sla_DE2H(xlast-RA,Dec,geodetic_lat,Az,El)

  return
end subroutine ephem

module iqcal_mod
  implicit none
contains
  subroutine iqcal(nn,c,nfft,gain,phase,zsum,ipk,reject) &
    bind(C, name="iqcal_")
    implicit none
    integer, intent(in) :: nn
    integer, intent(in) :: nfft
    complex, intent(in) :: c(0:nfft-1)
    real, intent(out) :: gain, phase, reject
    complex, intent(inout) :: zsum
    integer, intent(out) :: ipk
    
    complex :: z,zave
    real :: s,smax,pimage,p,tmp
    integer :: i, n_avg
    
    if(nn.eq.0) then
       zsum=0.
    endif
    n_avg = nn + 1
    
    smax=0.
    ipk=1
    do i=1,nfft-1
       s=real(c(i))**2 + aimag(c(i))**2
       if(s.gt.smax) then
          smax=s
          ipk=i
       endif
    enddo
    pimage=real(c(nfft-ipk))**2 + aimag(c(nfft-ipk))**2
    p=smax + pimage
    z=c(ipk)*c(nfft-ipk)/p
    zsum=zsum+z
    
    zave=zsum/real(n_avg) 
    
    tmp=sqrt(1.0 - (2.0*real(zave))**2)
    phase=asin(2.0*aimag(zave)/tmp)
    gain=tmp/(1.0-2.0*real(zave))
    if(smax > 0.0) then
       reject=10.0*log10(pimage/smax)
    else
       reject=0.0
    endif
    
  end subroutine iqcal
end module iqcal_mod

real function dpol(mygrid,hisgrid)

! Compute spatial polartzation offset in degrees for the present 
! time, between two specified grid locators.

  character*6 MyGrid,HisGrid
  real lat,lon,LST
  character cdate*8,ctime2*10,czone*5
  integer  it(8)
  data rad/57.2957795/

  call date_and_time(cdate,ctime2,czone,it)
  nyear=it(1)
  month=it(2)
  nday=it(3)
  nh=it(5)-it(4)/60
  nm=it(6)
  ns=it(7)
  uth=nh + nm/60.0 + ns/3600.0

  call grid2deg(MyGrid,lon,lat)
  call MoonDop(nyear,month,nday,uth,-lon,lat,RAMoon,DecMoon,         &
       LST,HA,AzMoon,ElMoon,vr,dist)
  xx=sin(lat/rad)*cos(ElMoon/rad) - cos(lat/rad)*                    &
       cos(AzMoon/rad)*sin(ElMoon/rad)
  yy=cos(lat/rad)*sin(AzMoon/rad)
  poloffset1=rad*atan2(yy,xx)

  call grid2deg(hisGrid,lon,lat)
  call MoonDop(nyear,month,nday,uth,-lon,lat,RAMoon,DecMoon,         &
       LST,HA,AzMoon,ElMoon,vr,dist)
  xx=sin(lat/rad)*cos(ElMoon/rad) - cos(lat/rad)*                    &
       cos(AzMoon/rad)*sin(ElMoon/rad)
  yy=cos(lat/rad)*sin(AzMoon/rad)
  poloffset2=rad*atan2(yy,xx)

  dpol=mod(poloffset2-poloffset1+720.0,180.0)
  if(dpol.gt.90.0) dpol=dpol-180.0

  return
end function dpol

module q65_decode

  integer nsnr0,nfreq0
  real xdt0
  character msg0*37,cq0*3

  type :: q65_decoder
     procedure(q65_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type q65_decoder

  abstract interface
     subroutine q65_decode_callback (this,nutc,snr1,nsnr,dt,freq,    &
          decoded,idec,nused,ntrperiod)
       import q65_decoder
       implicit none
       class(q65_decoder), intent(inout) :: this
       integer, intent(in) :: nutc
       real, intent(in) :: snr1
       integer, intent(in) :: nsnr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=37), intent(in) :: decoded
       integer, intent(in) :: idec
       integer, intent(in) :: nused
       integer, intent(in) :: ntrperiod
     end subroutine q65_decode_callback
  end interface

contains

  subroutine decode(this,callback,iwave,nqd0,nutc,ntrperiod,nsubmode,nfqso,  &
       ntol,ndepth,nfa0,nfb0,lclearave,single_decode,lagain,max_drift0,      &
       lnewdat0,emedelay,mycall,hiscall,hisgrid,nQSOprogress,ncontest,       &
       lapcqonly,navg0,nqf)

! Top-level routine that organizes the decoding of Q65 signals
! Input:  iwave            Raw data, i*2
!         nutc             UTC for time-tagging the decode
!         ntrperiod        T/R sequence length (s)
!         nsubmode         Tone-spacing indicator, 0-4 for A-E
!         nfqso            Target signal frequency (Hz)
!         ntol             Search range around nfqso (Hz)
!         ndepth           Optional decoding level
!         lclearave        Flag to clear the message-averaging arrays
!         emedelay         Sync search extended to cover EME delays
!         nQSOprogress     Auto-sequencing state for the present QSO
!         ncontest         Supported contest type
!         lapcqonly        Flag to use AP only for CQ calls
! Output: sent to the callback routine for display to user

    use timer_module, only: timer
    use packjt77
    use, intrinsic :: iso_c_binding
    use q65                               !Shared variables
    use prog_args
    use types
 
    parameter (NMAX=300*12000)  !Max TRperiod is 300 s
    parameter (MAX_CALLERS=40)  !For multiple q3 decodes in NA VHf Contest mode

    class(q65_decoder), intent(inout) :: this

    procedure(q65_decode_callback) :: callback
    character(len=12) :: mycall, hiscall  !Used for AP decoding
    character(len=6) :: hisgrid
    character*37 decoded                  !Decoded message
    character*37 decodes(100)
    character*77 c77
    character*78 c78
    character*6 cutc
    character c6*6,c4*4,cmode*4
    character*80 fmt
    integer*2 iwave(NMAX)                 !Raw data
    real, allocatable :: dd(:)            !Raw data
    real xdtdecodes(100)
    real f0decodes(100)
    integer dat4(13)                      !Decoded message as 12 6-bit integers
    integer dgen(13)
    integer nqf(20)
    integer stageno                       !Added by W3SZ
    integer time
    logical lclearave,lnewdat0,lapcqonly,unpk77_success
    logical single_decode,lagain
    complex, allocatable :: c00(:)        !Analytic signal, 6000 Sa/s
    complex, allocatable :: c0(:)         !Analytic signal, 6000 Sa/s
    type(q3list) callers(MAX_CALLERS)

! Start by setting some parameters and allocating storage for large arrays
    call sec0(0,tdecode)
    stageno=0
    ndecodes=0
    decodes=' '
    f0decodes=0.
    xdtdecodes=0.
    nfa=nfa0
    nfb=nfb0
    nqd=nqd0
    lnewdat=lnewdat0
    max_drift=max_drift0
    idec=-1
    idf=0
    idt=0
    nrc=-2
    mode_q65=2**nsubmode
    npts=ntrperiod*12000
    nfft1=ntrperiod*12000
    nfft2=ntrperiod*6000
    npasses=1
    nhist2=0
    if(lagain) ndepth=ior(ndepth,3)       !Use 'Deep' for manual Q65 decodes
    dxcall13=hiscall  ! initialize for use in packjt77
    mycall13=mycall
    if(ncontest.eq.1) then
! NA VHF, WW-Digi, or ARRL Digi Contest
       open(24,file=trim(data_dir)//'/tsil.3q',status='unknown',     &
            form='unformatted')
       read(24,end=2) nhist2
       if(nhist2.ge.1 .and. nhist2.le.40) then
          read(24,end=2) callers(1:nhist2)
          now=time()
          do i=1,nhist2
             hours=(now - callers(i)%nsec)/3600.0
             if(hours.gt.24.0) then
                callers(i:nhist2-1)=callers(i+1:nhist2)
                nhist2=nhist2-1
             endif
          enddo
       else
          nhist2=0
       endif
2      close(24)
    endif

! Determine the T/R sequence: iseq=0 (even), or iseq=1 (odd)
    n=nutc
    if(ntrperiod.ge.60 .and. nutc.le.2359) n=100*n
    write(cutc,'(i6.6)') n
    read(cutc,'(3i2)') ih,im,is
    nsec=3600*ih + 60*im + is
    iseq=mod(nsec/ntrperiod,2)

    if(lclearave) call q65_clravg
    allocate(dd(npts))
    allocate (c00(0:nfft1-1))
    allocate (c0(0:nfft1-1))

    if(lagain) then
       call q65_hist(nfqso,dxcall=hiscall,dxgrid=hisgrid)
    endif

    nsps=1800
    if(ntrperiod.eq.30) then
       nsps=3600
    else if(ntrperiod.eq.60) then
       nsps=7200
    else if(ntrperiod.eq.120) then
       nsps=16000
    else if(ntrperiod.eq.300) then
       nsps=41472
    endif

    baud=12000.0/nsps
    this%callback => callback
    nFadingModel=1

!    ibwa=max(1,int(1.8*log(baud*mode_q65)) + 5)
!### This needs work!
    ibwa=1                          !Q65-60A
    if(mode_q65.eq.2) ibwa=3        !Q65-60B
    if(mode_q65.eq.4) ibwa=8        !Q65-60C
    if(mode_q65.eq.8) ibwa=8        !Q65-60D
    if(mode_q65.eq.16) ibwa=8       !Q65-60E
!###

!    ibwb=min(15,ibwa+4)
    ibwb=min(15,ibwa+6)
    maxiters=40
    if(iand(ndepth,3).eq.2) maxiters=60
    if(iand(ndepth,3).eq.3) then
       ibwa=max(1,ibwa-2)
       ibwb=min(15,ibwb+2)
       maxiters=100
    endif

! Generate codewords for full-AP list decoding
    if(ichar(hiscall(1:1)).eq.0) hiscall=' '
    if(ichar(hisgrid(1:1)).eq.0) hisgrid=' '
    ncw=0
    if(nqd.eq.1 .or. lagain .or. ncontest.eq.1) then
       if(ncontest.eq.1) then
          call q65_set_list2(mycall,hiscall,hisgrid,callers,nhist2,   &
               codewords,ncw)
       else
          call q65_set_list(mycall,hiscall,hisgrid,codewords,ncw)
       endif
    endif
    dgen=0
    call q65_enc(dgen,codewords)         !Initialize the Q65 codec
    nused=1
    iavg=0

! W3SZ patch: Initialize AP params here, rather than afer the call to ana64().
    call ft8apset(mycall,hiscall,ncontest,apsym0,aph10) ! Generate ap symbols
    where(apsym0.eq.-1) apsym0=0
    npasses=2
    if(nQSOprogress.eq.5) npasses=3

    call timer('q65_dec0',0)
! Call top-level routine in q65 module: establish sync and try for a
! q3 or q0 decode.
    call q65_dec0(iavg,iwave,ntrperiod,nfqso,ntol,lclearave,  &
         emedelay,xdt,f0,snr1,width,dat4,snr2,idec,stageno)
    call timer('q65_dec0',1)

    if(idec.ge.0) then
       dtdec=xdt                    !We have a q3 or q0 decode at nfqso
       f0dec=f0
       go to 100
    endif

    if(ncontest.eq.1 .and. lagain .and. iand(ndepth,16).eq.16) go to 50
    if(ncontest.eq.1 .and. lagain .and. iand(ndepth,16).eq.0) go to 100

! Prepare for a single-period decode with iaptype = 0, 1, 2, or 4
    jpk0=(xdt+1.0)*6000                      !Index of nominal start of signal
    if(ntrperiod.le.30) jpk0=(xdt+0.5)*6000  !For shortest sequences
    if(jpk0.lt.0) jpk0=0
    call ana64(iwave,npts,c00)          !Convert to complex c00() at 6000 Sa/s
    if(lapcqonly) npasses=1
    iaptype=0
    do ipass=0,npasses                  !Loop over AP passes
       apmask=0                         !Try first with no AP information
       apsymbols=0
       if(ipass.ge.1) then
          ! Subsequent passes use AP information appropiate for nQSOprogress
          call q65_ap(nQSOprogress,ipass,ncontest,lapcqonly,iaptype,   &
               apsym0,apmask1,apsymbols1)
          write(c78,1050) apmask1
1050      format(78i1)
          read(c78,1060) apmask
1060      format(13b6.6)
          write(c78,1050) apsymbols1
          read(c78,1060) apsymbols
       endif

       call timer('q65loop1',0)
       call q65_loops(c00,npts/2,nsps/2,nsubmode,ndepth,jpk0,   &
            xdt,f0,iaptype,xdt1,f1,snr2,dat4,idec)
       call timer('q65loop1',1)
       if(idec.ge.0) then
          dtdec=xdt1
          f0dec=f1
          go to 100       !Successful decode, we're done
       endif
    enddo  ! ipass

    if(iand(ndepth,16).eq.0 .or. navg(iseq).lt.2) go to 100

! There was no single-transmission decode. Try for an average 'q3n' decode.
50  iavg=1
    call timer('list_avg',0)
! Call top-level routine in q65 module: establish sync and try for a q3
! decode, this time using the cumulative 's1a' symbol spectra.
    call q65_dec0(iavg,iwave,ntrperiod,nfqso,ntol,lclearave,  &
         emedelay,xdt,f0,snr1,width,dat4,snr2,idec,stageno)
    call timer('list_avg',1)

    if(idec.ge.0) then
       dtdec=xdt               !We have a list-decode result from averaged data
       f0dec=f0
       nused=navg(iseq)
       go to 100
    endif

! There was no 'q3n' decode.  Try for a 'q[0124]n' decode.
! Call top-level routine in q65 module: establish sync and try for a q[012]n
! decode, this time using the cumulative 's1a' symbol spectra.

    call timer('q65_avg ',0)
    iavg=2
    call q65_dec0(iavg,iwave,ntrperiod,nfqso,ntol,lclearave,  &
         emedelay,xdt,f0,snr1,width,dat4,snr2,idec,stageno)
    call timer('q65_avg ',1)
    if(idec.ge.0) then
       dtdec=xdt                          !We have a q[012]n result
       f0dec=f0
       nused=navg(iseq)
    endif

100 if(idec.lt.0 .and. max_drift.eq.50) then
       stageno = 5
       call timer('q65_dec0',0)
       ! Call top-level routine in q65 module: establish sync and try for a
       ! q3 or q0 decode.
       call q65_dec0(iavg,iwave,ntrperiod,nfqso,ntol,lclearave,  &
            emedelay,xdt,f0,snr1,width,dat4,snr2,idec,stageno)
       call timer('q65_dec0',1)
       if(idec.ge.0) then
          dtdec=xdt             !We have a q[012]n result
          f0dec=f0
       endif
    endif                       ! if(idec.lt.0)

    decoded='                                     '
    if(idec.ge.0) then
! idec Meaning
! ------------------------------------------------------
! -1:  No decode
!  0:  Decode without AP information
!  1:  Decode with AP for "CQ        ?   ?"
!  2:  Decode with AP for "MyCall    ?   ?"
!  3:  Decode with AP for "MyCall DxCall ?"

! Unpack decoded message for display to user
       write(c77,1000) dat4(1:12),dat4(13)/2
1000   format(12b6.6,b5.5)
       call unpack77(c77,1,decoded,unpk77_success) !Unpack to get decoded
       idupe=0
       do i=1,ndecodes
          if(decodes(i).eq.decoded) idupe=1
       enddo
       if(idupe.eq.0) then
          ndecodes=min(ndecodes+1,100)
          decodes(ndecodes)=decoded
          f0decodes(ndecodes)=f0dec
          xdtdecodes(ndecodes)=dtdec
          call q65_snr(dat4,dtdec,f0dec,mode_q65,snr2)
          nsnr=nint(snr2)
          call this%callback(nutc,snr1,nsnr,dtdec,f0dec,decoded,    &
               idec,nused,ntrperiod)
          if(ncontest.eq.1) then
             call q65_hist2(nint(f0dec),decoded,callers,nhist2)
          else
             call q65_hist(nint(f0dec),msg0=decoded)
          endif
          if(iand(ndepth,128).ne.0 .and. .not.lagain .and.      &
               int(abs(f0dec-nfqso)).le.ntol ) call q65_clravg    !AutoClrAvg
          call sec0(1,tdecode)
          open(22,file=trim(data_dir)//'/q65_decodes.txt',status='unknown',  &
               position='append',iostat=ios)
          if(ios.eq.0) then
! Save decoding parameters to q65_decoded.dat, for later analysis.
             write(cmode,'(i3)') ntrperiod
             cmode(4:4)=char(ichar('A')+nsubmode)
             c6=hiscall(1:6)
             if(c6.eq.'      ') c6='<b>   '
             c4=hisgrid(1:4)
             if(c4.eq.'    ') c4='<b> '
             fmt='(i6.4,1x,a4,i5,4i2,8i3,i4,f6.2,f7.1,f6.1,f7.1,f6.2,'//   &
                  '1x,a6,1x,a6,1x,a4,1x,a)'
             if(ntrperiod.le.30) fmt(5:5)='6'
             if(idec.eq.3) nrc=0
             write(22,fmt) nutc,cmode,nfqso,nQSOprogress,idec,idfbest,idtbest, &
                  ibwa,ibwb,ibw,ndistbest,nused,icand,ncand,nrc,ndepth,xdt,    &
                  f0,snr2,plog,tdecode,mycall(1:6),c6,c4,trim(decoded)
             close(22)
          endif
       endif
    endif
    navg0=1000*navg(0) + navg(1)
    if(single_decode .or. lagain) go to 900

    do icand=1,ncand
! Prepare for single-period candidate decodes with iaptype = 0, 1, 2, or 4
       snr1=candidates(icand,1)
       xdt= candidates(icand,2)
       f0 = candidates(icand,3)
       do i=1,ndecodes
          fdiff=f0-f0decodes(i)
          if(fdiff.gt.-baud*mode_q65 .and. fdiff.lt.65*baud*mode_q65) go to 800
       enddo

!###  TEST REGION
       if(ncontest.eq.-1) then
          call timer('q65_dec0',0)
! Call top-level routine in q65 module: establish sync and try for a
! q3 or q0 decode.
          call q65_dec0(iavg,iwave,ntrperiod,nint(f0),ntol,lclearave,  &
               emedelay,xdt,f0,snr1,width,dat4,snr2,idec,stageno)
          call timer('q65_dec0',1)
          if(idec.ge.0) then
             dtdec=xdt                    !We have a q3 or q0 decode at f0
             f0dec=f0
             go to 200
          endif
       endif
!###
       jpk0=(xdt+1.0)*6000                   !Index of nominal start of signal
       if(ntrperiod.le.30) jpk0=(xdt+0.5)*6000  !For shortest sequences
       if(jpk0.lt.0) jpk0=0
       call ana64(iwave,npts,c00)       !Convert to complex c00() at 6000 Sa/s
       call ft8apset(mycall,hiscall,ncontest,apsym0,aph10) ! Generate ap symbols
       where(apsym0.eq.-1) apsym0=0

       npasses=2
       if(nQSOprogress.eq.5) npasses=3
       if(lapcqonly) npasses=1
       iaptype=0
       do ipass=0,npasses                  !Loop over AP passes
!          write(*,3001) nutc,icand,ipass,f0,xdt,snr1
!3001      format('a',i5.4,2i3,3f7.1)
          apmask=0                         !Try first with no AP information
          apsymbols=0
          if(ipass.ge.1) then
          ! Subsequent passes use AP information appropiate for nQSOprogress
             call q65_ap(nQSOprogress,ipass,ncontest,lapcqonly,iaptype,   &
                  apsym0,apmask1,apsymbols1)
             write(c78,1050) apmask1
             read(c78,1060) apmask
             write(c78,1050) apsymbols1
             read(c78,1060) apsymbols
          endif

          call timer('q65loop2',0)
          call q65_loops(c00,npts/2,nsps/2,nsubmode,ndepth,jpk0,   &
               xdt,f0,iaptype,xdt1,f1,snr2,dat4,idec)
          call timer('q65loop2',1)
!          write(*,3001) '=e',nfqso,ntol,ndepth,xdt,f0,idec
          if(idec.ge.0) then
             dtdec=xdt1
             f0dec=f1
             go to 200       !Successful decode, we're done
          endif
       enddo  ! ipass

200    decoded='                                     '
       if(idec.ge.0) then
! Unpack decoded message for display to user
          write(c77,1000) dat4(1:12),dat4(13)/2
          call unpack77(c77,1,decoded,unpk77_success) !Unpack to get decoded
          idupe=0
          do i=1,ndecodes
             if(decodes(i).eq.decoded) idupe=1
          enddo
          if(idupe.eq.0) then
             ndecodes=min(ndecodes+1,100)
             decodes(ndecodes)=decoded
             f0decodes(ndecodes)=f0dec
             call q65_snr(dat4,dtdec,f0dec,mode_q65,snr2)
             nsnr=nint(snr2)
             call this%callback(nutc,snr1,nsnr,dtdec,f0dec,decoded,    &
                  idec,nused,ntrperiod)
             if(ncontest.eq.1) then
                call q65_hist2(nint(f0dec),decoded,callers,nhist2)
             else
                call q65_hist(nint(f0dec),msg0=decoded)
             endif
             if(iand(ndepth,128).ne.0 .and. .not.lagain .and.      &
                  int(abs(f0dec-nfqso)).le.ntol ) call q65_clravg    !AutoClrAvg
             call sec0(1,tdecode)
             ios=1
             open(22,file=trim(data_dir)//'/q65_decodes.txt',status='unknown',&
                  position='append',iostat=ios)
             if(ios.eq.0) then
! Save decoding parameters to q65_decoded.dat, for later analysis.
                write(cmode,'(i3)') ntrperiod
                cmode(4:4)=char(ichar('A')+nsubmode)
                c6=hiscall(1:6)
                if(c6.eq.'      ') c6='<b>   '
                c4=hisgrid(1:4)
                if(c4.eq.'    ') c4='<b> '
                fmt='(i6.4,1x,a4,i5,4i2,8i3,i4,f6.2,f7.1,f6.1,f7.1,f6.2,'//   &
                     '1x,a6,1x,a6,1x,a4,1x,a)'
                if(ntrperiod.le.30) fmt(5:5)='6'
                if(idec.eq.3) nrc=0
                write(22,fmt) nutc,cmode,nfqso,nQSOprogress,idec,idfbest,    &
                     idtbest,ibwa,ibwb,ibw,ndistbest,nused,icand,ncand,nrc,  &
                     ndepth,xdt,f0,snr2,plog,tdecode,mycall(1:6),c6,c4,      &
                     trim(decoded)
                close(22)
             endif
          endif
       endif
800    continue
    enddo  ! icand
    if(iavg.eq.0 .and.navg(iseq).ge.2 .and. iand(ndepth,16).ne.0) go to 50

900 if(ncontest.ne.1 .or. lagain) go to 999
    if(ntrperiod.ne.60 .or. nsubmode.ne.0) go to 999

! This is first time here, and we're running Q65-60A in NA VHF Contest mode.
! Return a list of potential sync frequencies at which to try q3 decoding.

    k=0
    nqf=0
    bw=baud*mode_q65*65
    do i=1,ncand
!       snr1=candidates(i,1)
!       xdt= candidates(i,2)
       f0 = candidates(i,3)
       do j=1,ndecodes          ! Already decoded one at or near this frequency?
          fj=f0decodes(j)
          if(f0.gt.fj-5.0 .and. f0.lt.fj+bw+5.0) go to 990
       enddo
       k=k+1
       nqf(k)=nint(f0)
990    continue
    enddo

999 return
  end subroutine decode

end module q65_decode

program test_astro_pipeline
  use iso_fortran_env, only: real64
  use astrosub_mod
  implicit none

  integer        :: nyear, month, nday, nfreq, ndop00
  real(real64)   :: uth
  character(len=6) :: mygrid

  ! Simple test case
  nyear  = 2025
  month  = 1
  nday   = 15
  uth    = 12.0_real64      ! 12:00 UTC
  nfreq  = 1440000000/1000000  ! e.g. 1440 MHz → 1440
  mygrid = 'FN20rx'         ! or whatever grid you like
  ndop00 = 0

  call astrosub00(nyear,month,nday,uth,nfreq,mygrid,ndop00,len(mygrid))

  print *, 'Test astro pipeline:'
  print *, '  nyear  =', nyear
  print *, '  month  =', month
  print *, '  nday   =', nday
  print *, '  uth    =', uth
  print *, '  nfreq  =', nfreq
  print *, '  mygrid =', mygrid
  print *, '  ndop00 =', ndop00

end program test_astro_pipeline

!does not require end module

function stdmsg(msg0)

  ! Returns .true. if msg0 a standard "JT-style" message
  
  ! i3.n3
  !  0.0   Free text
  !  0.1   DXpeditiion mode
  !  0.2   EU VHF Contest
  !  0.3   ARRL Field Day <=16 transmitters
  !  0.4   ARRL Field Day >16 transmitters
  !  0.5   telemetry
  !  0.6
  !  0.7
  !  1     Standard 77-bit structured message (optional /R)
  !  2     EU VHF Contest (optional /P)
  !  3     ARRL RTTY Contest
  !  4     Nonstandard calls

  use iso_c_binding, only: c_bool
  use packjt
  use packjt77

  character*37 msg0,msg1
  character*77 c77
  logical(c_bool) :: stdmsg

  msg1=msg0
  i3=-1
  n3=-1
  call pack77(msg1,i3,n3,c77)
  stdmsg=(i3.gt.0 .or. n3.gt.0)

!###
!  rewind 82
!  do i=1,nzhash
!     write(82,3082) i,nzhash,callsign(i),ihash10(i),ihash12(i),ihash22(i)
!3082 format(2i5,2x,a13,3i10)
!  enddo
!  flush(82)
!###
  
  return
end function stdmsg

subroutine badmsg(irc,dat,nc1,nc2,ng2)

! Get rid of a few QRA64 false decodes that cannot be correct messages.  

  integer dat(12)                           !Decoded message (as 12 integers)

  ic1=ishft(dat(1),22) + ishft(dat(2),16) + ishft(dat(3),10)+         &
       ishft(dat(4),4) + iand(ishft(dat(5),-2),15)

! Test for "......" or "CQ 000"
  if(ic1.eq.262177560 .or. ic1.eq.262177563) then
     irc=-1
     return
  endif

  ic2=ishft(iand(dat(5),3),26) + ishft(dat(6),20) +                   &
       ishft(dat(7),14) + ishft(dat(8),8) + ishft(dat(9),2) +         &
       iand(ishft(dat(10),-4),3)

  ig=ishft(iand(dat(10),15),12) + ishft(dat(11),6) + dat(12)
  
! Test for blank, -01 to -30, R-01 to R-30, RO, RRR, 73
  if(ig.ge.32401 .and. ig.le.32464) return

  if(ig.ge.14220 .and. ig.le.14229) return  !-41 to -50
  if(ig.ge.14040 .and. ig.le.14049) return  !-31 to -40

  if(ig.ge.13320 .and. ig.le.13329) return  !+00 to +09
  if(ig.ge.13140 .and. ig.le.13149) return  !+10 to +19
  if(ig.ge.12960 .and. ig.le.12969) return  !+20 to +29
  if(ig.ge.12780 .and. ig.le.12789) return  !+30 to +39
  if(ig.ge.12600 .and. ig.le.12609) return  !+40 to +49

  if(ig.ge.12420 .and. ig.le.12429) return  !R-41 to R-50
  if(ig.ge.12240 .and. ig.le.12249) return  !R-31 to R-40

  if(ig.ge.11520 .and. ig.le.11529) return  !R+00 to R+09
  if(ig.ge.11340 .and. ig.le.11349) return  !R+10 to R+19
  if(ig.ge.11160 .and. ig.le.11169) return  !R+20 to R+29
  if(ig.ge.10980 .and. ig.le.10989) return  !R+30 to R+39
  if(ig.ge.10800 .and. ig.le.10809) return  !R+40 to R+49

  if(ic1.eq.nc1 .and. ic2.eq.nc2 .and. ng2.ne.32401 .and. ig.ne.ng2) irc=-1

  return
end subroutine badmsg

subroutine trimlist(sig,km,ftol,indx,nsiz,nz)

  parameter (MAXMSG=1000)             !Size of decoded message list
  real sig(MAXMSG,30)
  integer indx(MAXMSG),nsiz(MAXMSG)

!    1      2     3    4    5    6     7     8
!  nfile  nutc  freq  snr  dt  ipol  flip  sync

  call indexx(sig(1,3),km,indx)            !Sort list by frequency

  n=1
  i0=1
  do i=2,km         
     j0=indx(i-1)
     j=indx(i)
     if(sig(j,3)-sig(j0,3).gt.ftol) then
        nsiz(n)=i-i0
        i0=i
        n=n+1
     endif
  enddo
  nz=n
  nsiz(nz)=km+1-i0
  nsiz(nz+1)=-1

  return
end subroutine trimlist

program rsdtest

  real s3(64,63)
  character msg*22,arg*12
  integer param(0:7)

  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage: rsdtest ntrials nfiles'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) ntrials
  call getarg(2,arg)
  read(arg,*) nfiles

  open(10,file='s3_1000.bin',access='stream', status='old')
  open(22,file='kvasd.dat',access='direct',recl=1024,status='unknown')

  nadd=1
  ifile0=0
  if(nfiles.lt.0) then
     ifile0=-nfiles
     nfiles=99999
  endif

  do ifile=1,nfiles
     read(10,end=999) s3
     if(ifile.lt.ifile0) cycle
     call extract2(s3,nadd,ntrials,param,msg)
     if(ifile.eq.ifile0) exit
  enddo

999 end program rsdtest

subroutine spec64(c0,npts,nsps,mode_q65,jpk,s3,LL,NN)

  parameter (MAXFFT=20736)
  complex c0(0:npts-1)                      !Complex spectrum of dd()
  complex cs(0:MAXFFT-1)                     !Complex symbol spectrum
  real s3(LL,NN)                             !Synchronized symbol spectra
  real xbase0(LL),xbase(LL)
!  integer ipk1(1)
  integer isync(22)                          !Indices of sync symbols
  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/

  nfft=nsps
  j=0
  n=1
  do k=1,84
     if(k.eq.isync(n)) then
        n=n+1
        cycle
     endif
     j=j+1
     ja=(k-1)*nsps + jpk
     jb=ja+nsps-1
     if(ja.lt.0) ja=0
     if(jb.gt.npts-1) jb=npts-1
     nz=jb-ja
     cs(0:nz)=c0(ja:jb)
     if(nz.lt.nfft-1) cs(nz+1:)=0.
     call four2a(cs,nsps,1,-1,1)             !c2c FFT to frequency
     do ii=1,LL
        i=ii-65+mode_q65      !mode_q65 = 1 2 4 8 16 for Q65 A B C D E
        if(i.lt.0) i=i+nsps
        s3(ii,j)=real(cs(i))**2 + aimag(cs(i))**2
     enddo
  enddo

  df=6000.0/nfft
  do i=1,LL
     call pctile(s3(i,1:NN),NN,45,xbase0(i)) !Get baseline for passband shape
  enddo
  
  nh=25
  xbase(1:nh-1)=sum(xbase0(1:nh-1))/(nh-1.0)
  xbase(LL-nh+1:LL)=sum(xbase0(LL-nh+1:LL))/(nh-1.0)
  do i=nh,LL-nh
     xbase(i)=sum(xbase0(i-nh+1:i+nh))/(2*nh+1)  !Smoothed passband shape
  enddo
  
  do i=1,LL
     s3(i,1:NN)=s3(i,1:NN)/(xbase(i)+0.001) !Apply frequency equalization
  enddo

  return
end subroutine spec64

subroutine jtmsg(msg,iflag)

! Attempts to identify false decodes in JT-style messages.

! Returns iflag with sum of bits as follows:
! ------------------------------------------
!    1 Grid/Report invalid
!    2 Second callsign invalid
!    4 First callsign invalid
!    8 Very unlikely free text
!   16 Questionable free text
!    0 Message is probably OK
! ------------------------------------------

  character*22 msg,t
  character*13 w1,w2,w3,w
  character*6 bc1,bc2,bc3
  character*1 c
  logical c1ok,c2ok,c3ok,isdigit,isletter,isgrid4

! Statement functions  
  isdigit(c)=(ichar(c).ge.ichar('0')) .and. (ichar(c).le.ichar('9'))
  isletter(c)=(ichar(c).ge.ichar('A')) .and. (ichar(c).le.ichar('Z'))
  isgrid4(w)=(len_trim(w).eq.4 .and.                                        &
       ichar(w(1:1)).ge.ichar('A') .and. ichar(w(1:1)).le.ichar('R') .and.  &
       ichar(w(2:2)).ge.ichar('A') .and. ichar(w(2:2)).le.ichar('R') .and.  &
       ichar(w(3:3)).ge.ichar('0') .and. ichar(w(3:3)).le.ichar('9') .and.  &
       ichar(w(4:4)).ge.ichar('0') .and. ichar(w(4:4)).le.ichar('9'))

  t=trim(msg)                         !Temporary copy of msg
  nt=len_trim(t)

! Check for standard messages
! Insert underscore in "CQ AA " to "CQ ZZ ", "CQ nnn " to make them one word.
  if(t(1:3).eq.'CQ ' .and. isletter(t(4:4)) .and.                             &
       isletter(t(5:5)) .and. t(6:6).eq.' ') t(3:3)='_'
  if(t(1:3).eq.'CQ ' .and. isdigit(t(4:4)) .and.                              &
       isdigit(t(5:5)) .and. isdigit(t(6:6)) .and. t(7:7).eq.' ') t(3:3)='_'

! Parse first three words
  w1='             '
  w2='             '
  w3='             '
  i1=index(t,' ')
  if(i1.gt.0) w1(1:i1-1)=t(1:i1-1)
  t=t(i1+1:)
  i2=index(t,' ')
  if(i2.gt.0) w2(1:i2-1)=t(1:i2-1)
  t=t(i2+1:)
  i3=index(t,' ')
  if(i3.gt.0) w3(1:i3-1)=t(1:i3-1)

  if(w1(1:3).eq.'CQ ' .or. w1(1:3).eq.'CQ_' .or. w1(1:3).eq.'DE ' .or.   &
       w1(1:4).eq.'QRZ ') then
! CQ/DE/QRZ: Should have one good callsign in w2 and maybe a grid/rpt in w3
     call chkcall(w2,bc2,c2ok)
     iflag=0
     if(.not.c2ok) iflag=iflag+2
     if(len_trim(w3).ne.0 .and. (.not.isgrid4(w3))) iflag=iflag+1
     if(w1(1:3).eq.'DE ' .and. c2ok) iflag=0
     if(iflag.eq.0) return
  endif

! Check for two calls and maybe a grid, rpt, R+rpr, RRR, or 73
  iflag=0
  call chkcall(w1,bc1,c1ok)
  call chkcall(w2,bc2,c2ok)
  if(.not.c1ok) iflag=iflag+4
  if(.not.c2ok) iflag=iflag+2
  if(len_trim(w3).ne.0 .and. (.not.isgrid4(w3)) .and.                  &
          w3(1:1).ne.'+' .and. w3(1:1).ne.'-' .and.                      &
          w3(1:2).ne.'R+' .and. w3(1:2).ne.'R-' .and.                    &
          w3(1:3).ne.'73 ' .and. w3(1:4).ne.'RRR ') iflag=iflag+1
  call chkcall(w3,bc3,c3ok)
! Allow(?) non-standard messages of the form CQ AS OC K1JT
  if(w1(1:3).eq.'CQ_'.and.isletter(w2(1:1)).and.isletter(w2(2:2)).and.   &
     w2(3:3).eq.' '.and.c3ok) iflag=0
  if(iflag.eq.0 .or. nt.gt.13) return

! Check for plausible free text

  nc=0
  np=0
  do i=1,13
     c=msg(i:i)
     if(c.ne.' ') nc=nc+1             !Number of non-blank characters
     if(c.eq.'+') np=np+1             !Number of punctuation characters
     if(c.eq.'-') np=np+1
     if(c.eq.'.') np=np+1
     if(c.eq.'/') np=np+1
     if(c.eq.'?') np=np+1
  enddo
  nb=13-nc                            !Number of blanks
  iflag=16                             !Mark as potentially questionable
  if(nc.ge.12 .or. (nc.ge.11 .and. np.gt.0)) then
     iflag=8                           !Unlikely free text, flag it
  endif

! Save messages containing some common words
  if(msg(1:3).eq.'CQ ') iflag=0
  if(index(msg,'DE ').gt.0) iflag=0
  if(index(msg,'TU ').gt.0) iflag=0
  if(index(msg,' TU').gt.0) iflag=0
  if(index(msg,'73 ').gt.0) iflag=0
  if(index(msg,' 73').gt.0) iflag=0
  if(index(msg,'TNX').gt.0) iflag=0
  if(index(msg,'THX').gt.0) iflag=0
  if(index(msg,'EQSL').gt.0) iflag=0
  if(index(msg,'LOTW').gt.0) iflag=0
  if(index(msg,'DECOD').gt.0) iflag=0
  if(index(msg,'CHK').gt.0) iflag=0
  if(index(msg,'CLK').gt.0) iflag=0
  if(index(msg,'CLOCK').gt.0) iflag=0
  if(index(msg,'LOG').gt.0) iflag=0
  if(index(msg,'QRM').gt.0) iflag=0
  if(index(msg,'QSY').gt.0) iflag=0
  if(index(msg,'TEST').gt.0) iflag=0
  if(index(msg,'CQDX').gt.0) iflag=0
  if(index(msg,'CALL').gt.0) iflag=0
  if(index(msg,'QRZ').gt.0) iflag=0
  if(index(msg,'AUTO').gt.0) iflag=0
  if(index(msg,'PHOTO').gt.0) iflag=0
  if(index(msg,'HYBRID').gt.0) iflag=0

  if(c1ok .and. w1(1:6).eq.bc1) iflag=0
  if(c2ok .and. w2(1:6).eq.bc2) iflag=0

  if(nb.ge.4) iflag=0

  return
end subroutine jtmsg

subroutine packtext2(msg,n1,ng)

  character*8 msg
  real*8 dn
  character*41 c
  data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +./?'/

  dn=0.
  do i=1,8
     do j=1,41
        if(msg(i:i).eq.c(j:j)) go to 10
     enddo
     j=37
10   j=j-1                                !Codes should start at zero
     dn=41.d0*dn + j
  enddo

  ng=mod(dn,32768.d0)
  n1=(dn-ng)/32768.d0

  return
end subroutine packtext2

subroutine gen_cw_wave(message,ifreq,wave)

! Generate audio waveform for a short CW message.

  parameter (NMAX=98304)                 !2.048*48000
  character*(*) message
  integer icw(200)                       !Encoded CW message bits
  real*4 z(NMAX)
  real*8 dt,twopi,phi,dphi,fsample,tdit,t
  real*4 wave(NMAX)                      !Generated waveform
  real x(NMAX)
  real y(NMAX)

  call morse(message,icw,ncw)

  i1=0
  i2=0
  do i=1,ncw
     if(i1.eq.0 .and. icw(i).eq.1) i1=i
     if(icw(i).eq.1) i2=i+1
  enddo
  if(i1.lt.1 .or. i2.gt.200) go to 999
  ncw=i2-i1+1
  icw(1:ncw)=icw(i1:i2)

  fsample=48000.d0
  nspd=2.048d0*fsample/ncw
  wpm=1.2d0*fsample/nspd
  dt=1.d0/fsample                    !Sample interval (s)
  tdit=nspd*dt
  twopi=8.d0*atan(1.d0)
  dphi=twopi*ifreq*dt
  phi=0.
  k=0                                !Start audio at t=0
  t=0.
  x=0.
  do i=1,NMAX
     t=t+dt
     j=t/tdit + 1
     phi=phi + dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     k=k+1
     x(k)=icw(j)
     z(k)=sin(xphi)
  enddo

  nadd=0.002/dt
  call smo(x,NMAX,y,nadd)
  call smo(y,NMAX,x,nadd)
  call smo(x,NMAX,y,nadd)
  y(NMAX-3*NADD:NMAX)=0.
  fac=0.99999/maxval(abs(y))
  wave=fac*y*z
  
999 return
end subroutine gen_cw_wave

subroutine watterson(c,npts,nsig,fs,delay,fspread)
!
! npts is the total length of the simulated data vector
! nsig is the number of points that are occupied by signal
!
  complex c(0:npts-1)
  complex c2(0:npts-1)
  complex cs1(0:npts-1)
  complex cs2(0:npts-1)

  nonzero=0
  df=fs/npts
  if(fspread.gt.0.0) then
     do i=0,npts-1
        xx=gran()
        yy=gran()
        cs1(i)=0.707*cmplx(xx,yy)
        xx=gran()
        yy=gran()
        cs2(i)=0.707*cmplx(xx,yy)
     enddo
     call four2a(cs1,npts,1,-1,1)     !To freq domain
     call four2a(cs2,npts,1,-1,1)
     do i=0,npts-1
        f=i*df
        if(i.gt.npts/2) f=(i-npts)*df
        x=(f/fspread)**2
        a=0.
        if(x.le.50.0) then
           a=exp(-x)
        endif
        cs1(i)=a*cs1(i)
        cs2(i)=a*cs2(i)
        if(abs(f).lt.10.0) then
           p1=real(cs1(i))**2 + aimag(cs1(i))**2
           p2=real(cs2(i))**2 + aimag(cs2(i))**2
           if(p1.gt.0.0) nonzero=nonzero+1
!           write(62,3101) f,p1,p2,db(p1+1.e-12)-60,db(p2+1.e-12)-60
!3101       format(f10.3,2f12.3,2f10.3)
        endif
     enddo
     call four2a(cs1,npts,1,1,1)     !Back to time domain
     call four2a(cs2,npts,1,1,1)
     cs1(0:npts-1)=cs1(0:npts-1)/npts
     cs2(0:npts-1)=cs2(0:npts-1)/npts
  endif

  nshift=nint(0.001*delay*fs)
  if(delay.gt.0.0) then
     c2(0:npts-1)=cshift(c(0:npts-1),-nshift) !negative shifts are right shifts
  else
     c2(0:npts-1)=0.0
  endif
  sq=0.
  do i=0,npts-1
     if(nonzero.gt.1) then
        c(i)=0.5*(cs1(i)*c(i) + cs2(i)*c2(i))
     else
        c(i)=0.5*(c(i) + c2(i))
     endif
     sq=sq + real(c(i))**2 + aimag(c(i))**2
!     write(61,3001) i/12000.0,c(i)
!3001 format(3f12.6)
  enddo
  rms=sqrt(sq/nsig) 
  c=c/rms

  return
end subroutine watterson

program free_text
  character*13 c13,w
  character*71 f71
  character*42 c
  character*1 qa(10),qb(10)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/
  c13='TNX BOB 73 GL'             !Redefine as needed
  call mp_short_init
  qa=char(0)
  w=adjustr(c13)
  do i=1,13
     j=index(c,w(i:i))-1
     if(j.lt.0) j=0
     call mp_short_mult(qb,qa(2:10),9,42)    !qb(1:9)=42*qa(2:9)
     call mp_short_add(qa,qb(2:10),9,j)      !qa(1:9)=qb(2:9)+j
  enddo
  write(f71,1000) qa(2:10)
1000 format(b7.7,8b8.8)
  write(*,1010) c13,f71
1010 format('Free text: ',a13/'f71: ',a71)
end program free_text

subroutine mp_short_ops(w,u)
! Multi-precision arithmetic with storage in character arrays.  
  character*1 w(*),u(*)
  integer i,ireg,j,n,ir,iv,ii1,ii2
  character*1 creg(4)
  save ii1,ii2
  equivalence (ireg,creg)

  entry mp_short_init
  ireg=256*ichar('2')+ichar('1')
  do j=1,4
     if (creg(j).eq.'1') ii1=j
     if (creg(j).eq.'2') ii2=j
  enddo
  return

  entry mp_short_add(w,u,n,iv)
  ireg=256*iv
  do j=n,1,-1
     ireg=ichar(u(j))+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_mult(w,u,n,iv)
  ireg=0
  do j=n,1,-1
     ireg=ichar(u(j))*iv+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  return
end subroutine mp_short_ops

subroutine fitcal(x,y,r,iz,a,b,sigmaa,sigmab,rms)
  implicit real*8 (a-h,o-z)
  real*8 x(iz),y(iz),r(iz)

  sx=0.d0
  sy=0.d0
  sxy=0.d0
  sx2=0.d0
  do i=1,iz
     sx=sx + x(i)
     sy=sy + y(i)
     sxy=sxy + x(i)*y(i)
     sx2=sx2 + x(i)*x(i)
  enddo
  delta=iz*sx2 - sx*sx
  a=(sx2*sy - sx*sxy)/delta
  b=(iz*sxy - sx*sy)/delta

  sq=0.d0
  do i=1,iz
     r(i)=y(i) - (a + b*x(i))
     sq=sq + r(i)**2
  enddo
  rms=0.
  sigmaa=0.
  sigmab=0.
  if(iz.ge.3) then
     rms=sqrt(sq/(iz-2))
     sigmaa=sqrt(rms*rms*sx2/delta)
     sigmab=sqrt(iz*rms*rms/delta)
  endif

  return
end subroutine fitcal

subroutine filbig(dd,npts,f0,newdat,c4a,n4,sq0)

! Filter and downsample the real data in array dd(npts), sampled at 12000 Hz.
! Output is complex, sampled at 1378.125 Hz.

  use, intrinsic :: iso_c_binding
  use FFTW3
  use timer_module, only: timer

  parameter (NSZ=3413)
  parameter (NFFT1=672000,NFFT2=77175,NH2=38587)
  parameter (NZ2=1000)
  real*4  dd(npts)                           !Input data
  real*4 rca(NFFT1)
  complex ca(NFFT1/2+1)                      !FFT of input
  complex c4a(NFFT2)                         !Output data
  real*4 s(NZ2)
  real*8 df
  real halfpulse(8)                 !Impulse response of filter (one sided)
  complex cfilt(NFFT2)                       !Filter (complex; imag = 0)
  real rfilt(NFFT2)                          !Filter (real)
  type(C_PTR) :: plan1,plan2,plan3           !Pointers to FFTW plans
  logical first
  equivalence (rfilt,cfilt),(rca,ca)
  data first/.true./
  data halfpulse/114.97547150,36.57879257,-20.93789101,              &
       5.89886379,1.59355187,-2.49138308,0.60910773,-0.04248129/
  common/refspec/dfref,ref(NSZ)
  common/patience/npatience,nthreads
  save first,plan1,plan2,plan3,rfilt,cfilt,df,ca

  if(npts.lt.0) go to 900                    !Clean up at end of program

  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

! Plan the FFTs just once
     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     call fftwf_plan_with_nthreads(nthreads)
     plan1=fftwf_plan_dft_r2c_1d(nfft1,rca,ca,nflags)
     call fftwf_plan_with_nthreads(1)
     plan2=fftwf_plan_dft_1d(nfft2,c4a,c4a,-1,nflags)
     plan3=fftwf_plan_dft_1d(nfft2,cfilt,cfilt,+1,nflags)
     !$omp end critical(fftw)

! Convert impulse response to filter function
     do i=1,nfft2
        cfilt(i)=0.
     enddo
     fac=0.00625/nfft1
     cfilt(1)=fac*halfpulse(1)
     do i=2,8
        cfilt(i)=fac*halfpulse(i)
        cfilt(nfft2+2-i)=fac*halfpulse(i)
     enddo
     call fftwf_execute_dft(plan3,cfilt,cfilt)

     base=real(cfilt(NH2+1))
     do i=1,nfft2
        rfilt(i)=real(cfilt(i))-base
     enddo

     df=12000.d0/nfft1
     first=.false.
  endif

! When new data comes along, we need to compute a new "big FFT"
! If we just have a new f0, continue with the existing data in ca.

  if(newdat.ne.0) then
     call timer('FFTbig  ',0)
     nz=min(npts,nfft1)
     rca(1:nz)=dd(1:nz)
     rca(nz+1:)=0.
     call fftwf_execute_dft_r2c(plan1,rca,ca)
     call timer('FFTbig  ',1)

     ib=0
     do j=1,NSZ
        ia=ib+1
        ib=nint(j*dfref/df)
        fac=sqrt(min(30.0,1.0/ref(j)))
        ca(ia:ib)=fac*conjg(ca(ia:ib))
     enddo
     newdat=0
  endif

! NB: f0 is the frequency at which we want our filter centered.
!     i0 is the bin number in ca closest to f0.
  call timer('loops   ',0)
  i0=nint(f0/df) + 1
  do i=1,NH2                               !Copy data into c4a and apply
     j=i0+i-1                              !the filter function
     if(j.ge.1 .and. j.le.nfft1/2+1) then
        c4a(i)=rfilt(i)*ca(j)
     else
        c4a(i)=0.
     endif
  enddo
  do i=NH2+1,nfft2
     j=i0+i-1-nfft2
!     if(j.lt.1) j=j+nfft1                  !nfft1 was nfft2
     if(j.ge.1) then
        c4a(i)=rfilt(i)*ca(j)
     else
        c4a(i)=rfilt(i)*conjg(ca(2-j))
     endif
  enddo

  nadd=77                                   !nfft2/NZ2=77
  i=0
  do j=1,NZ2
     s(j)=0.
     do n=1,nadd
        i=i+1
        s(j)=s(j) + real(c4a(i))**2 + aimag(c4a(i))**2
     enddo
  enddo
  call pctile(s,NZ2,30,sq0)
  call timer('loops   ',1)

! Do the short reverse transform, to go back to time domain.
  call timer('FFTsmall',0)
  call fftwf_execute_dft(plan2,c4a,c4a)
  call timer('FFTsmall',1)
  n4=min(npts/8,nfft2)
  return

900 continue

  !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
  call fftwf_destroy_plan(plan1)
  call fftwf_destroy_plan(plan2)
  call fftwf_destroy_plan(plan3)
  !$omp end critical(fftw)
  
  return
end subroutine filbig

module map65_mmdec_mod
  implicit none
contains

  subroutine map65_mmdec(nutc,id2,nqd,ntrperiod, nsubmode,nfa,nfb,nfqso,   &
       ntol,newdat,nagain,max_drift,ndepth,mycall,hiscall,hisgrid)

    use prog_args
    use timer_module, only: timer
    use q65_decode
    use iso_fortran_env, only: int16

    include 'jt9com.f90'
    include 'timer_common.inc'

    type, extends(q65_decoder) :: counting_q65_decoder
       integer :: decoded
    end type counting_q65_decoder

    logical single_decode,bVHF,lnewdat,lagain,lclearave,lapcqonly
    integer(int16) id2(300*12000)
    integer nqf(20)
    integer nutc,nqd,ntrperiod,nsubmode,nfa,nfb,nfqso,ntol
    integer newdat,nagain,max_drift,ndepth,navg0,ncontest
    integer nqsoprogress,ntr0
    real emedelay
  !  type(params_block) :: params
    character(len=12) :: mycall, hiscall
    character(len=6) :: hisgrid
    data ntr0/-1/
    save
    type(counting_q65_decoder) :: my_q65

  ! Cast C character arrays to Fortran character strings
  !  datetime=transfer(params%datetime, datetime)
  !  mycall=transfer(params%mycall,mycall)
  !  hiscall=transfer(params%hiscall,hiscall)
  !  mygrid=transfer(params%mygrid,mygrid)
  !  hisgrid=transfer(params%hisgrid,hisgrid)

    my_q65%decoded = 0
    ncontest=0
    nQSOprogress=0
    lclearave=.false.
    single_decode=.false.
    lapcqonly=.false.
    lnewdat=(newdat.ne.0)
    lagain=(nagain.ne.0)
    bVHF=.true.
    emedelay=2.5
  !  ntrperiod=60

    call timer('dec_q65 ',0)
    call my_q65%decode(q65_decoded,id2,nqd,nutc,ntrperiod,nsubmode,nfqso,       &
         ntol,ndepth,nfa,nfb,lclearave,single_decode,lagain,max_drift,lnewdat,  &
         emedelay,mycall,hiscall,hisgrid,nQSOProgress,ncontest,lapcqonly,navg0,nqf)
    call timer('dec_q65 ',1)

    return

  contains

    subroutine q65_decoded (this,nutc,snr1,nsnr,dt,freq,decoded,idec,   &
         nused,ntrperiod)

      use q65_decode
      implicit none

      class(q65_decoder), intent(inout) :: this
      integer, intent(in) :: nutc
      real, intent(in) :: snr1
      integer, intent(in) :: nsnr
      real, intent(in) :: dt
      real, intent(in) :: freq
      character(len=37), intent(in) :: decoded
      integer, intent(in) :: idec
      integer, intent(in) :: nused
      integer, intent(in) :: ntrperiod

      if(nutc+snr1+nsnr+dt+freq+idec+nused+ntrperiod.eq.-999) stop
      if(decoded.eq.'-999') stop

      cq0='q  '
      write(cq0(2:2),'(i1)') idec
      if(nused.ge.2) write(cq0(3:3),'(i1)') nused
      nsnr0=nsnr
      xdt0=dt
      nfreq0=nint(freq)
      msg0=decoded

      select type(this)
      type is (counting_q65_decoder)
         if(idec.ge.0) this%decoded = this%decoded + 1
      end select

     return
   end subroutine q65_decoded
    
  end subroutine map65_mmdec
end module map65_mmdec_mod

! call may not start from 'Q', zero and two digits
  if(callsign(1:1).eq.'Q' .or. callsign(1:1).eq.'0' .or. callsign(1:1).eq.'/') then
        nbadcrc=1; msg37='                                     '; return; endif

   if(callsign(1:1).ge.'0' .and. callsign(1:1).le.'9') then
     if(callsign(2:2).ge.'0' .and. callsign(2:2).le.'9') then
       nbadcrc=1; msg37='                                     '; return; endif
     if(callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' .and. callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z' &
       .and. callsign(4:4).ge.'A' .and. callsign(4:4).le.'Z') then
       nbadcrc=1; msg37='                                     '; return; endif
   endif

   if(callsign(1:1).ge.'A' .and. callsign(1:1).le.'Z') then
     if(callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' &
       .and. callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z') then
       nbadcrc=1; msg37='                                     '; return; endif
   endif

   if(callsign(1:1).ge.'0' .and. callsign(1:1).le.'9') then
     if(callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' &
       .and. callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z') then
       if(callsign(1:3).ne.'3DA' .and. callsign(1:3).ne.'3XY') then
         nbadcrc=1; msg37='                                     '; return; endif
     endif
   endif

program fmtave

! Average groups of frequency-calibration measurements.
  
  implicit real*8 (a-h,o-z)
  character infile*80
  character*8 cutc,cutc1

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   fmtave <infile>'
     print*,'Example: fmtave fmt.all'
     go to 999
  endif
  call getarg(1,infile)

  open(10,file=infile,status='old')
  open(12,file='fmtave.out',status='unknown')

  write(*,1000)
1000 format('    Freq     DF    CAL   N     rms    UTC     Call'/       &
            '   (kHz)    (Hz)    ?         (Hz)'/                       &
            '----------------------------------------------------')
  nkhz0=0
  sum=0.d0
  sumsq=0.d0
  n=0
  do i=1,99999
     read(10,*,end=10) cutc,nkHz,ncal,noffset,faudio,df,dblevel,snr
     if((nkHz.ne.nkHz0) .and. i.ne.1) then
        ave=sum/n
        rms=0.d0
        if(n.gt.1) then
           rms=sqrt(abs(sumsq - sum*sum/n)/(n-1.d0))
        endif
        fMHz=0.001d0*nkHz0
        write(*,1010)  fMHz,ave,ncal0,n,rms,cutc1
        write(12,1010) fMHz,ave,ncal0,n,rms,cutc1
1010    format(f8.3,f9.3,i4,i5,f8.2,2x,a8,2x,a6)
        sum=0.d0
        sumsq=0.d0
        n=0
     endif
     dial_error=faudio-noffset
     sum=sum + dial_error
     sumsq=sumsq + dial_error**2
     n=n+1
     if(n.eq.1) then
        cutc1=cutc
        ncal0=ncal
     endif
     nkHz0=nkHz
  enddo

10 ave=sum/n
  rms=0.d0
  if(n.gt.0) then
     rms=sqrt((sumsq - sum*sum/n)/(n-1.d0))
  endif
  fMHz=0.001d0*nkHz
  write(*,1010)  fMHz,ave,ncal,n,rms,cutc1
  write(12,1010) fMHz,ave,ncal,n,rms,cutc1

999 end program fmtave

program fox_sim

! Simulates QSO exchanges using the proposed FT8 "DXpedition" mode.
  parameter (MAXSIG=5,NCALLS=268)  
  character*6 xcall(NCALLS)
  character*4 xgrid(NCALLS)
  integer isnr(NCALLS)

  character*32 fmsg(MAXSIG),fm
  character*22 hmsg(MAXSIG),hm
  character*16 log
  character*6 called(MAXSIG)
  character*4 gcalled(MAXSIG)
  character*6 MyCall
  character*4 MyGrid
  character*8 arg
  character*1 c1,c2,c3,c4
  integer ntot(MAXSIG),irate(MAXSIG),ntimes(MAXSIG)
  logical logit
  common/dxpfifo/nc,isnr,xcall,xgrid
  
  nargs=iargc()
  if(nargs.ne.2 .and. nargs.ne.4) then
     print*,'Usage: fox_sim  nseq maxtimes'
     print*,'       fox_sim  nseq maxtimes nsig fail'
     print*,' '
     print*,' nseq:     number of T/R sequences to execute'
     print*,' maxtimes: number of repeats of same Tx message'
     print*,' nsig:     number of simultaneous Tx sigals'
     print*,' fail:     receiving error rate'
     go to 999
  endif
  ii1=1
  ii2=5
  jj1=0
  jj2=5
  nseq=80
  if(nargs.ge.2) then
     call getarg(1,arg)
     read(arg,*) nseq
     call getarg(2,arg)
     read(arg,*) maxtimes
  endif
  if(nargs.eq.4) then
     call getarg(3,arg)
     read(arg,*) nsig
     call getarg(4,arg)
     read(arg,*) fail
     ii1=nsig
     ii2=nsig
     jj1=nint(10*fail)
     jj2=nint(10*fail)
  endif

! Read a file with calls and grids; insert random S/N values.
! This is used in place of an operator-selected FIFO
  open(10,file='xcall.txt',status='old')
  do i=1,NCALLS
     read(10,1000) xcall(i),xgrid(i)
1000 format(a6,7x,a4)
     if(i.ne.-99) cycle
     j=mod(i-1,26)
     c1=char(ichar('A')+j)
     k=mod((i-1)/26,26)
     c2=char(ichar('A')+k)     
     n=mod((i-1)/260,10)
     c3=char(ichar('0')+n)     
     xcall(i)='K'//c2//c3//c1//c1//c1

     j=mod(i-1,18)
     c1=char(ichar('A')+j)
     k=mod((i-1)/18,18)
     c2=char(ichar('A')+k)     
     n=mod((i-1)/10,10)
     c4=char(ichar('0')+n)     
     n=mod((i-1)/100,10)
     c3=char(ichar('0')+n)     
     xgrid(i)=c1//c2//c3//c4
     
     call random_number(x)
     isnr(i)=-20+int(40*x)
  enddo
!  close(10)

! Write headings for the summary file
  minutes=nseq/4
  write(13,1002) nseq,minutes,maxtimes
1002 format(/'Nseq:',i4,'   Minutes:',i3,'   Maxtimes:',i2//                   &
    18x,'Logged QSOs',22x,'Rate (QSOs/hour)'/                                  &
    'fail Nsig: 1     2     3     4     5          1     2     3     4     5'/ &
    71('-'))

  write(*,1003)
1003 format('Seq  s n Fox messages                      Hound messages    Logged info        i Rate'/87('-'))

  ntot=0
  irate=0
  MyCall='KH1DX'
  MyGrid='AJ10'

  do jj=jj1,jj2                        !Loop over Rx failure rates
     fail=0.1*jj    
     do ii=ii1,ii2                     !Loop over range of nsig
        nc=0                           !Set FIFO pointer to top
        ntimes=1
        nsig=ii
        nlogged=0
        fmsg="CQ KH1DX AJ10"
        hmsg=""
        called="      "
        do iseq=0,nseq                 !Loop over specified number of sequences
           if(iand(iseq,1).eq.0) then
              do j=1,nsig              !Loop over Fox's Tx slots
                 fm=fmsg(j)
                 hm=hmsg(j)

! Call fox_tx to determine the next Tx message for this slot
                 call fox_tx(maxtimes,fail,called(j),gcalled(j),hm,fm,    &
                      ntimes(j),log,logit)

                 fmsg(j)=fm
                 if(logit) then
! Log this QSO
                    nlogged=nlogged+1
                    nrate=0
                    if(iseq.gt.0) nrate=nint(nlogged*240.0/iseq)
                    write(*,1010) iseq,j,ntimes(j),fmsg(j),log,nlogged,nrate
1010                format(i4.4,2i2,1x,a32,20x,a16,2i4)
                    ! call log_routine()
                 else
                    write(*,1010) iseq,j,ntimes(j),fmsg(j)
                 endif
              enddo
              ! call transmit()
           endif
           
           if(iand(iseq,1).eq.1) then
              do j=1,nsig              !Listen for expected responses
                 fm=fmsg(j)
                 call fox_rx(fail,called(j),fm,hm)
                 if(j.ge.2) then
                    if(hm.eq.hmsg(j-1)) hm=""
                 endif
                 hmsg(j)=hm
                 write(*,1020) iseq,j,hmsg(j)
1020             format(i4.4,i2,37x,a22)
              enddo
           endif
           write(*,1021)
1021       format(87('-'))
        enddo
        ntot(ii)=nlogged
        irate(ii)=0
        if(iseq.gt.0) irate(ii)=nint(nlogged*3600.0/(15*iseq))
        write(*,1030) nsig,fail,nlogged,nc
1030    format(/'Nsig:',i3,'   Fail:',f4.1,'   Logged QSOs:',i4,      &
             '   Final nc:',i4)
     enddo
     
! Write the summary file
     write(13,1100) fail,ntot,irate
1100 format(f4.1,2x,5i6,5x,5i6)
  enddo

999 end program fox_sim

module moondop_mod
  implicit none
contains
 subroutine MoonDop(nyear,month,nday,uth4,lon4,lat4,RAMoon4,DecMoon4,   &
      LST4,HA4,AzMoon4,ElMoon4,vr4,dist4)
 
   use dot_mod
   use geocentric_mod
   use moon2_mod
   use toxyz_mod
   use gran_interface
   use iso_fortran_env, only: real32, real64
   implicit none

   integer, intent(in) :: nyear, month, nday
   real(real32), intent(in) :: uth4                    !UT in hours
   real(real32), intent(in) :: lon4                    !West longitude, degrees
   real(real32), intent(in) :: lat4                    !Latitude, degrees
   real(real32), intent(out) :: RAMoon4                 !Topocentric RA of moon, hours
   real(real32), intent(out) :: DecMoon4                !Topocentric Dec of Moon, degrees
   real(real32), intent(out) :: LST4                    !Locat sidereal time, hours
   real(real32), intent(out) :: HA4                     !Local Hour angle, degrees
   real(real32), intent(out) :: AzMoon4                 !Topocentric Azimuth of moon, degrees
   real(real32), intent(out) :: ElMoon4                 !Topocentric Elevation of moon, degrees
   real(real32), intent(out) :: vr4                     !Radial velocity of moon wrt obs, km/s
   real(real32), intent(out) :: dist4                   !Echo time, seconds
 
   real(real64) LST
   real(real64) RME(6)                  !Vector from Earth center to Moon
   real(real64) RAE(6)                  !Vector from Earth center to Obs
   real(real64) RMA(6)                  !Vector from Obs to Moon
   real(real64) rme0(6)
   logical km
   real(real64) :: dlat, dlong1, elev1, dlat1, erad1, dt, UT, RA, Dec, topRA
   real(real64) :: topDec, HA, Az0, El0, Az, El, dist
   real(real64) :: phi, radps, alpha1, delta1, dtopo0, vr
   integer :: i
   real(real64) :: rad, twopi
 
   data rad/57.2957795130823d0/,twopi/6.28318530717959d0/
 
   km=.true.
   dlat=lat4/rad
   dlong1=lon4/rad
   elev1=200.d0
   call geocentric(dlat,elev1,dlat1,erad1)
 
   dt=100.d0                       !For numerical derivative, in seconds
   UT=uth4
 
 ! NB: geodetic latitude used here, but geocentric latitude used when 
 ! determining Earth-rotation contribution to Doppler.
 
   call moon2(nyear,month,nDay,UT-dt/3600.d0,dlong1*rad,dlat*rad,     &
        RA,Dec,topRA,topDec,LST,HA,Az0,El0,dist)
   call toxyz(RA/rad,Dec/rad,dist,rme0)      !Convert to rectangular coords
 
   call moon2(nyear,month,nDay,UT,dlong1*rad,dlat*rad,                &
        RA,Dec,topRA,topDec,LST,HA,Az,El,dist)
   call toxyz(RA/rad,Dec/rad,dist,rme)       !Convert to rectangular coords
 
   phi=LST*twopi/24.d0
   call toxyz(phi,dlat1,erad1,rae)           !Gencentric numbers used here!
   radps=twopi/(86400.d0/1.002737909d0)
   rae(4)=-rae(2)*radps                      !Vel of Obs wrt Earth center
   rae(5)=rae(1)*radps
   rae(6)=0.d0
 
   do i=1,3
      rme(i+3)=(rme(i)-rme0(i))/dt
      rma(i)=rme(i)-rae(i)
      rma(i+3)=rme(i+3)-rae(i+3)
   enddo
 
   call fromxyz(rma,alpha1,delta1,dtopo0)     !Get topocentric coords
   vr=dot(rma(4),rma)/dtopo0
 
   RAMoon4=topRA
   DecMoon4=topDec
   LST4=LST
   HA4=HA
   AzMoon4=Az
   ElMoon4=El
   vr4=vr
   dist4=dist
 
   return
 end subroutine MoonDop
end module moondop_mod

subroutine packname(name,len,n1,n2)

  character*9 name
  real*8 dn

  dn=0
  do i=1,len
     n=ichar(name(i:i))
     if(n.ge.97 .and. n.le.122) n=n-32
     dn=27*dn + n-64
  enddo
  if(len.lt.9) then
     do i=len+1,9
        dn=27*dn
     enddo
  endif

  n2=mod(dn,32768.d0)
  dn=dn/32768.d0
  n1=dn

  return
end subroutine packname

subroutine recvpkt(nsam,nblock2,userx_no,k,buf4,buf8,buf16)

! Reformat timf2 data from Linrad and stuff data into r*4 array dd().

  include 'njunk.f90'
  parameter (NSMAX=60*96000)          !Total sample intervals per minute
  parameter (NFFT=32768)
  integer*1 userx_no
  real*4 d4,buf4(*)                   !(348)
  real*8 d8,buf8(*)                   !(174)
  complex*16 c16,buf16(*)             !(87)
  integer*2 jd(4),kd(2),nblock2
  real*4 xd(4),yd(2)
  real*8 fcenter
  common/datcom/dd(4,5760000),ss(4,322,NFFT),savg(4,NFFT),fcenter,nutc,  &
       junk(NJUNK)
  equivalence (kd,d4)
  equivalence (jd,d8,yd)
  equivalence (xd,c16)

  if(nblock2.eq.-9999) nblock2=-9998    !Silence a compiler warning
  if(nsam.eq.-1) then
! Move data from the UDP packet buffer into array dd().
     if(userx_no.eq.-1) then
        do i=1,174                    !One RF channel, r*4 data
           k=k+1
           d8=buf8(i)
           dd(1,k)=yd(1)
           dd(2,k)=yd(2)
        enddo
     else if(userx_no.eq.1) then
        do i=1,348                    !One RF channel, i*2 data
           k=k+1
           d4=buf4(i)
           dd(1,k)=kd(1)
           dd(2,k)=kd(2)
        enddo
     else if(userx_no.eq.-2) then
        do i=1,87                    !Two RF channels, r*4 data
           k=k+1
           c16=buf16(i)
           dd(1,k)=xd(1)
           dd(2,k)=xd(2)
           dd(3,k)=xd(3)
           dd(4,k)=xd(4)
        enddo
     else if(userx_no.eq.2) then
        do i=1,174                    !Two RF channels, i*2 data
           k=k+1
           d8=buf8(i)
           dd(1,k)=jd(1)
           dd(2,k)=jd(2)
           dd(3,k)=jd(3)
           dd(4,k)=jd(4)
        enddo
     endif
  else
     if(userx_no.eq.1) then
        do i=1,nsam                    !One RF channel, r*4 data
           k=k+1
           d4=buf4(i)
           dd(1,k)=kd(1)
           dd(2,k)=kd(2)

           k=k+1
           dd(1,k)=kd(1)
           dd(2,k)=kd(2)
        enddo
     endif
  endif

  return
end subroutine recvpkt

subroutine cgen65(message,mode65,samfac,nsendingsh,msgsent,cwave,nwave)

! Encodes a JT65 message into a wavefile.  
! Executes in 17 ms on opti-745.

  use packjt

  parameter (NMAX=60*96000)     !Max length of wave file
  character*22 message          !Message to be generated
  character*22 msgsent          !Message as it will be received
  character*3 cok               !'   ' or 'OOO'
  real*8 t,dt,phi,f,f0,dfgen,dphi,twopi,samfac,tsymbol
  complex cwave(NMAX)           !Generated complex wave file
  integer dgen(12)
  integer sent(63)
  logical first
  integer nprc(126)
  real pr(126)
  data nprc/1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,  &
            0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,  &
            0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,  &
            0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,  &
            1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,  &
            0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,  &
            1,1,1,1,1,1/
  data twopi/6.283185307179586476d0/,first/.true./
  save

  if(first) then
     do i=1,126
        pr(i)=2*nprc(i)-1
     enddo
     first=.false.
  endif

  call chkmsg(message,cok,nspecial,flip) !See if it's a shorthand
  if(nspecial.eq.0) then
     call packmsg(message,dgen,itype)    !Pack message into 72 bits
     nsendingsh=0
     if(iand(dgen(10),8).ne.0) nsendingsh=-1    !Plain text flag

     call rs_encode(dgen,sent)
     call interleave63(sent,1)           !Apply interleaving
     call graycode(sent,63,1)            !Apply Gray code
     nsym=126                            !Symbols per transmission
     tsymbol=4096.d0/11025.d0            !Time per symbol
  else
     nsendingsh=1                        !Flag for shorthand message
     nsym=32
     tsymbol=16384.d0/11025.d0
  endif

! Set up necessary constants
  dt=1.d0/(samfac*96000.d0)
  f0=118*11025.d0/1024
  dfgen=mode65*11025.d0/4096.d0
  t=0.d0
  phi=0.d0
  k=0
  j0=0
  ndata=nsym*96000.d0*samfac*tsymbol

  do i=1,ndata
     t=t+dt
     j=int(t/tsymbol) + 1                    !Symbol number, 1-126
     if(j.ne.j0) then
        f=f0
        if(nspecial.ne.0 .and. mod(j,2).eq.0) f=f0+10*nspecial*dfgen
        if(nspecial.eq.0 .and. flip*pr(j).lt.0.0) then
           k=k+1
           f=f0+(sent(k)+2)*dfgen
        endif
        dphi=twopi*dt*f
        j0=j
     endif
     phi=phi+dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     cwave(i)=cmplx(cos(xphi),-sin(xphi))
  enddo

  cwave(ndata+1:)=0
  nwave=ndata + 48000
  call unpackmsg(dgen,msgsent)
  if(flip.lt.0.0) then
     do i=22,1,-1
        if(msgsent(i:i).ne.' ') goto 10
     enddo
10   msgsent=msgsent(1:i)//' OOO'
  endif

  if(nsendingsh.eq.1) then
     if(nspecial.eq.2) msgsent='RO'
     if(nspecial.eq.3) msgsent='RRR'
     if(nspecial.eq.4) msgsent='73'
  endif

  return
end subroutine cgen65

program jt9

! Decoder for JT9.  Can run stand-alone, reading data from *.wav files;
! or as the back end of wsjt-x, with data placed in a shared memory region.

  use options
  use prog_args
  use, intrinsic :: iso_c_binding
  use FFTW3
  use timer_module, only: timer
  use timer_impl, only: init_timer, fini_timer
  use readwav

  include 'jt9com.f90'

  integer*2 id2a(180000)
  integer(C_INT) iret
  type(wav_header) wav
  real*4 s(NSMAX)
  real*8 TRperiod
  character c
  character(len=500) optarg, infile
  character wisfile*256
!### ndepth was defined as 60001.  Why???
  integer :: arglen,stat,offset,remain,mode=0,flow=200,fsplit=2700,          &
       fhigh=4000,nrxfreq=1500,ndepth=1,nexp_decode=0,nQSOProg=0
  logical :: read_files = .true., tx9 = .false., display_help = .false.,     &
       bLowSidelobes = .false., nexp_decode_set = .false.,                   &
       have_ntol = .false.
  type (option) :: long_options(33) = [                                      &
    option ('help', .false., 'h', 'Display this help message', ''),          &
    option ('shmem',.true.,'s','Use shared memory for sample data','KEY'),   &
    option ('tr-period', .true., 'p', 'Tx/Rx period, default SECONDS=60',    &
        'SECONDS'),                                                          &
    option ('executable-path', .true., 'e',                                  &
        'Location of subordinate executables (KVASD) default PATH="."',      &
        'PATH'),                                                             &
    option ('data-path', .true., 'a',                                        &
        'Location of writeable data files, default PATH="."', 'PATH'),       &
    option ('temp-path', .true., 't',                                        &
        'Temporary files path, default PATH="."', 'PATH'),                   &
    option ('lowest', .true., 'L',                                           &
        'Lowest frequency decoded (JT65), default HERTZ=200', 'HERTZ'),      &
    option ('highest', .true., 'H',                                          &
        'Highest frequency decoded, default HERTZ=4007', 'HERTZ'),           &
    option ('split', .true., 'S',                                            &
        'Lowest JT9 frequency decoded, default HERTZ=2700', 'HERTZ'),        &
    option ('rx-frequency', .true., 'f',                                     &
        'Receive frequency offset, default HERTZ=1500', 'HERTZ'),            &
    option ('freq-tolerance', .true., 'F',                                   &
        'Receive frequency tolerance, default HERTZ=20', 'HERTZ'),           &
    option ('patience', .true., 'w',                                         &
        'FFTW3 planing patience (0-4), default PATIENCE=1', 'PATIENCE'),     &
    option ('fft-threads', .true., 'm',                                      &
        'Number of threads to process large FFTs, default THREADS=1',        &
        'THREADS'),                                                          &
    option ('q65', .false., '3', 'Q65 mode', ''),                            &
    option ('jt4', .false., '4', 'JT4 mode', ''),                            &
    option ('ft4', .false., '5', 'FT4 mode', ''),                            &
    option ('jt65', .false.,'6', 'JT65 mode', ''),                           &
    option ('fst4', .false., '7', 'FST4 mode', ''),                          &
    option ('fst4w', .false., 'W', 'FST4W mode', ''),                        &
    option ('fst4w', .false., 'Y', 'FST4W mode, print hash22 values', ''),   &
    option ('ft8', .false., '8', 'FT8 mode', ''),                            &
    option ('jt9', .false., '9', 'JT9 mode', ''),                            &
    option ('qra64', .false., 'q', 'QRA64 mode', ''),                        &
    option ('msk144', .false., 'k', 'MSK144 mode', ''),                      &    
    option ('QSOprog', .true., 'Q', 'QSO progress (0-5), default PROGRESS=1',&
        'QSOprogress'),                                                      &
    option ('sub-mode', .true., 'b', 'Sub mode, default SUBMODE=A', 'A'),    &
    option ('depth', .true., 'd',                                            &
        'Decoding depth (1-3), default DEPTH=1', 'DEPTH'),                   &
    option ('tx-jt9', .false., 'T', 'Tx mode is JT9', ''),                   &
    option ('my-call', .true., 'c', 'my callsign', 'CALL'),                  &
    option ('my-grid', .true., 'G', 'my grid locator', 'GRID'),              &
    option ('his-call', .true., 'x', 'his callsign', 'CALL'),                &
    option ('his-grid', .true., 'g', 'his grid locator', 'GRID'),            &
    option ('experience-decode', .true., 'X',                                &
        'experience based decoding flags (1..n), default FLAGS=0',           &
        'FLAGS') ]

  type(dec_data), allocatable :: shared_data
  character(len=20) :: datetime=''
  character(len=12) :: mycall='K1ABC', hiscall='W9XYZ'
  character(len=6) :: mygrid='', hisgrid='EN37'
  common/patience/npatience,nthreads
  common/decstats/ntry65a,ntry65b,n65a,n65b,num9,numfano
  data npatience/1/,nthreads/1/,wisfile/' '/

  nsubmode = 0
  ntol = 20
  TRperiod=60.d0

  do
     call getopt('hs:e:a:b:r:m:p:d:f:F:w:t:9876543WYqkTL:S:H:c:G:x:g:X:Q:',     &
          long_options,c,optarg,arglen,stat,offset,remain,.true.)
     if (stat .ne. 0) then
        exit
     end if
     select case (c)
        case ('h')
           display_help = .true.
        case ('s')
           read_files = .false.
           shm_key = optarg(:arglen)
        case ('e')
           exe_dir = optarg(:arglen)
        case ('a')
           data_dir = optarg(:arglen)
        case ('b')
           nsubmode = ichar (optarg(:1)) - ichar ('A')
        case ('t')
           temp_dir = optarg(:arglen)
        case ('m')
           read (optarg(:arglen), *) nthreads
        case ('p')
           read (optarg(:arglen), *) TRperiod
        case ('d')
           read (optarg(:arglen), *) ndepth
        case ('f')
           read (optarg(:arglen), *) nrxfreq
        case ('F')
           read (optarg(:arglen), *) ntol
           have_ntol = .true.
        case ('L')
           read (optarg(:arglen), *) flow
        case ('S')
           read (optarg(:arglen), *) fsplit
        case ('H')
           read (optarg(:arglen), *) fhigh
        case ('q')
           mode = 164
         case ('k')
           mode = 144
         case ('Q')
           read (optarg(:arglen), *) nQSOProg
        case ('3')
           mode = 66
        case ('4')
           mode = 4
        case ('5')
           mode = 5
        case ('6')
           if (mode.lt.65) mode = mode + 65
        case ('7')
           mode = 240
        case ('8')
           mode = 8
        case ('9')
           if (mode.lt.9.or.mode.eq.65) mode = mode + 9
        case ('T')
           tx9 = .true.
        case ('w')
           read (optarg(:arglen), *) npatience
        case ('W')
           mode = 241
        case ('Y')
           mode = 242
        case ('c')
           read (optarg(:arglen), *) mycall
        case ('G')
           read (optarg(:arglen), *) mygrid
        case ('x')
           read (optarg(:arglen), *) hiscall
        case ('g')
           read (optarg(:arglen), *) hisgrid
        case ('X')
           read (optarg(:arglen), *) nexp_decode
           nexp_decode_set = .true.
     end select
  end do
  
  if (display_help .or. stat .lt. 0                      &
       .or. (.not. read_files .and. remain .gt. 0)       &
       .or. (read_files .and. remain .lt. 1)) then

     print *, 'Usage: jt9 [OPTIONS] file1 [file2 ...]'
     print *, '       Reads data from *.wav files.'
     print *, ''
     print *, '       jt9 -s <key> [-w patience] [-m threads] [-e path] [-a path] [-t path]'
     print *, '       Gets data from shared memory region with key==<key>'
     print *, ''
     print *, 'OPTIONS:'
     print *, ''
     do i = 1, size (long_options)
       call long_options(i) % print (6)
     end do
     go to 999
  endif

  iret=fftwf_init_threads()            !Initialize FFTW threading 

! Default to 1 thread, but use nthreads for the big ones
  call fftwf_plan_with_nthreads(1)

! Import FFTW wisdom, if available
  wisfile=trim(data_dir)//'/jt9_wisdom.dat'// C_NULL_CHAR
  iret=fftwf_import_wisdom_from_filename(wisfile)

  ntry65a=0
  ntry65b=0
  n65a=0
  n65b=0
  num9=0
  numfano=0

  if (.not. read_files) then
     call jt9a()          !We're running under control of WSJT-X
     go to 999
  endif

  if(mycall.eq.'b') mycall='            '
  if(hiscall.eq.'b') then
     hiscall='            '
     hisgrid='      '
  endif

  if (mode .eq. 241 .or. mode .eq. 242) then
     ntol = min (ntol, 100)
  else if (mode .eq. 65 + 9 .and. .not. have_ntol) then
     ntol = 20
  else if (mode .eq. 66 .and. .not. have_ntol) then
     ntol = 10
  else
     ntol = min (ntol, 1000)
  end if
  if (.not. nexp_decode_set) then
     if (mode .eq. 240 .or. mode .eq. 241 .or. mode .eq. 242) then
        nexp_decode = 3 * 256   ! single decode off and nb=0
     end if
  end if
  allocate(shared_data)
  nflatten=0
  do iarg = offset + 1, offset + remain
     call get_command_argument (iarg, optarg, arglen)
     infile = optarg(:arglen)
     call wav%read (infile)
     nfsample=wav%audio_format%sample_rate
     i1=index(infile,'.wav')
     if(i1.lt.1) i1=index(infile,'.WAV')
     if(infile(i1-5:i1-5).eq.'_') then
        read(infile(i1-4:i1-1),*,err=1) nutc
     else
        read(infile(i1-6:i1-1),*,err=1) nutc
     endif
     go to 2
1    nutc=0
2    nsps=6912
     npts=TRperiod*12000.d0
     kstep=nsps/2
     k=0
     nhsym=0
     nhsym0=-999
     if(iarg .eq. offset + 1) then
        call init_timer (trim(data_dir)//'/timer.out')
        call timer('jt9     ',0)
     endif
     shared_data%id2=0          !??? Why is this necessary ???
     if(mode.eq.5) npts=21*3456
     if(mode.eq.66) npts=TRperiod*12000
     do iblk=1,npts/kstep
        k=iblk*kstep
        if(mode.eq.8 .and. k.gt.179712) exit
        call timer('read_wav',0)
        read(unit=wav%lun,end=3) shared_data%id2(k-kstep+1:k)
        go to 4
3       call timer('read_wav',1)
        print*,'EOF on input file ',trim(infile)
        exit
4       call timer('read_wav',1)
        nhsym=(k-2048)/kstep
        if(nhsym.ge.1 .and. nhsym.ne.nhsym0) then
           if(mode.eq.9 .or. mode.eq.74) then
! Compute rough symbol spectra for the JT9 decoder
              ingain=0
              call timer('symspec ',0)
              nminw=1
              call symspec(shared_data,k,Tperiod,nsps,ingain,      &
                   bLowSidelobes,nminw,pxdb,s,df3,ihsym,npts8,pxdbmax)
              call timer('symspec ',1)
           endif
           nhsym0=nhsym
           if(nhsym.ge.181 .and. mode.ne.240 .and. mode.ne.241 .and. &
              mode.ne.242 .and. mode.ne.66) exit
        endif
     enddo
     close(unit=wav%lun)
     shared_data%params%nutc=nutc
     shared_data%params%ndiskdat=.true.
     shared_data%params%ntr=TRperiod
     shared_data%params%nfqso=nrxfreq
     shared_data%params%newdat=.true.
     shared_data%params%npts8=74736
     shared_data%params%nfa=flow
     shared_data%params%nfsplit=fsplit
     shared_data%params%nfb=fhigh
     shared_data%params%ntol=ntol
     shared_data%params%kin=64800
     if(mode.eq.240) shared_data%params%kin=720000   !### 60 s periods ###
     shared_data%params%nzhsym=nhsym
     shared_data%params%ndepth=ndepth
     shared_data%params%lft8apon=.true.
     shared_data%params%ljt65apon=.true.
     shared_data%params%napwid=75
     shared_data%params%dttol=3.
     if(mode.eq.164 .and. nsubmode.lt.100) nsubmode=nsubmode+100
     shared_data%params%nagain=.false.
     shared_data%params%nclearave=.false.
     shared_data%params%lapcqonly=.false.
     shared_data%params%naggressive=0
     shared_data%params%n2pass=2
     shared_data%params%nQSOprogress=nQSOProg
     shared_data%params%nranera=6                      !### ntrials=3000
     shared_data%params%nrobust=.false.
     shared_data%params%nexp_decode=nexp_decode
     shared_data%params%mycall=transfer(mycall,shared_data%params%mycall)
     shared_data%params%mygrid=transfer(mygrid,shared_data%params%mygrid)
     shared_data%params%hiscall=transfer(hiscall,shared_data%params%hiscall)
     shared_data%params%hisgrid=transfer(hisgrid,shared_data%params%hisgrid)
     if (tx9) then
        shared_data%params%ntxmode=9
     else
        shared_data%params%ntxmode=65
     end if
     if (mode.eq.0) then
        shared_data%params%nmode=65+9
     else
        shared_data%params%nmode=mode
     end if
     shared_data%params%nsubmode=nsubmode

!### temporary, for MAP65:
     if(mode.eq.66 .and. TRperiod.eq.60) shared_data%params%emedelay=2.5

     datetime="2013-Apr-16 15:13" !### Temp
     shared_data%params%datetime=transfer(datetime,shared_data%params%datetime)
     if(mode.eq.9 .and. fsplit.ne.2700) shared_data%params%nfa=fsplit
     if(mode.eq.8) then
! "Early" decoding pass, FT8 only, when jt9 reads data from disk
        nearly=41
        shared_data%params%nzhsym=nearly
        id2a(1:nearly*3456)=shared_data%id2(1:nearly*3456)
        id2a(nearly*3456+1:)=0
        call multimode_decoder(shared_data%ss,id2a,      &
             shared_data%params,nfsample)
        nearly=47
        shared_data%params%nzhsym=nearly
        id2a(1:nearly*3456)=shared_data%id2(1:nearly*3456)
        id2a(nearly*3456+1:)=0
        call multimode_decoder(shared_data%ss,id2a,      &
             shared_data%params,nfsample)
        id2a(nearly*3456+1:50*3456)=shared_data%id2(nearly*3456+1:50*3456)
        id2a(50*3456+1:)=0
        shared_data%params%nzhsym=50
        call multimode_decoder(shared_data%ss,id2a,      &
             shared_data%params,nfsample)
        cycle

     ! MSK144        
     else if (mode .eq. 144) then
      call decode_msk144(shared_data%id2, shared_data%params, data_dir)
     endif

! Normal decoding pass
     call multimode_decoder(shared_data%ss,shared_data%id2, &
          shared_data%params,nfsample)
  enddo

  call timer('jt9     ',1)
  call timer('jt9     ',101)

999 continue
! Output decoder statistics
  call fini_timer ()
! Save FFTW wisdom and free memory
  if(len(trim(wisfile)).gt.0) iret=fftwf_export_wisdom_to_filename(wisfile)
  call four2a(a,-1,1,1,1)
  call filbig(a,-1,1,0.0,0,0,0,0,0)        !used for FFT plans
  call fftwf_cleanup_threads()
  call fftwf_cleanup()
end program jt9

subroutine genmsk_128_90(msg0,ichk,msgsent,i4tone,itype)
! s8 + 48bits + s8 + 80 bits = 144 bits (72ms message duration)
!
! Encode an MSK144 message
! Input:
!   - msg0     requested message to be transmitted
!   - ichk     if ichk=1, return only msgsent
!              if ichk.ge.10000, set imsg=ichk-10000 for short msg
!   - msgsent  message as it will be decoded
!   - i4tone   array of audio tone values, 0 or 1
!   - itype    message type 
!                 1 = standard message  "Call_1 Call_2 Grid/Rpt"
!                 2 = type 1 prefix
!                 3 = type 1 suffix
!                 4 = type 2 prefix
!                 5 = type 2 suffix
!                 6 = free text (up to 13 characters)
!                 7 = short message     "<Call_1 Call2> Rpt"

  use iso_c_binding, only: c_loc,c_size_t
  use packjt77
  character*37 msg0
  character*37 message                    !Message to be generated
  character*37 msgsent                    !Message as it will be received
  character*77 c77
  integer*4 i4tone(144)
  integer*1 codeword(128)
  integer*1 msgbits(77) 
  integer*1 bitseq(144)                   !Tone #s, data and sync (values 0-1)
  integer*1 s8(8)
  real*8 pp(12)
  real*8 xi(864),xq(864),pi,twopi
  data s8/0,1,1,1,0,0,1,0/
  equivalence (ihash,i1hash)
  logical first,unpk77_success
  data first/.true./
  save

  if(first) then
    first=.false.
    nsym=128
    pi=4.0*atan(1.0)
    twopi=8.*atan(1.0)
    do i=1,12
      pp(i)=sin((i-1)*pi/12)
    enddo
  endif

  message(1:37)=' ' 
  itype=1
  if(msg0(1:1).eq.'@') then                    !Generate a fixed tone
     read(msg0(2:5),*,end=1,err=1) nfreq       !at specified frequency
     go to 2
1    nfreq=1000
2    i4tone(1)=nfreq
  else
     message=msg0

     do i=1, 37
        if(ichar(message(i:i)).eq.0) then
           message(i:37)=' '
           exit
        endif
     enddo
     do i=1,37                               !Strip leading blanks
        if(message(1:1).ne.' ') exit
        message=message(i+1:)
     enddo

     if(message(1:1).eq.'<') then
        i2=index(message,'>')
        i1=0
        if(i2.gt.0) i1=index(message(1:i2),' ')
        if(i1.gt.0) then
           call genmsk40(message,msgsent,ichk,i4tone,itype)
           if(itype.lt.0) go to 999
           i4tone(41)=-40
           go to 999
        endif
     endif

     i3=-1
     n3=-1
     call pack77(message,i3,n3,c77)
     call unpack77(c77,0,msgsent,unpk77_success) !Unpack to get msgsent
     if(ichk.eq.1) go to 999
     read(c77,"(77i1)") msgbits
     call encode_128_90(msgbits,codeword)

!Create 144-bit channel vector:
!8-bit sync word + 48 bits + 8-bit sync word + 80 bits
     bitseq=0 
     bitseq(1:8)=s8
     bitseq(9:56)=codeword(1:48)
     bitseq(57:64)=s8
     bitseq(65:144)=codeword(49:128)
     bitseq=2*bitseq-1

     xq(1:6)=bitseq(1)*pp(7:12)   !first bit is mapped to 1st half-symbol on q
     do i=1,71
       is=(i-1)*12+7
       xq(is:is+11)=bitseq(2*i+1)*pp
     enddo 
     xq(864-5:864)=bitseq(1)*pp(1:6)   !last half symbol
     do i=1,72                                    
       is=(i-1)*12+1
       xi(is:is+11)=bitseq(2*i)*pp
     enddo
! Map I and Q  to tones. 
    i4tone=0 
    do i=1,72
      i4tone(2*i-1)=(bitseq(2*i)*bitseq(2*i-1)+1)/2;
      i4tone(2*i)=-(bitseq(2*i)*bitseq(mod(2*i,144)+1)-1)/2;
    enddo
  endif

! Flip polarity
  i4tone=-i4tone+1
999 return
end subroutine genmsk_128_90

program fcal

! Compute Intercept (A) and Slope (B) for a series of FreqCal measurements. 
  parameter(NZ=1000)
  implicit real*8 (a-h,o-z)
  real*8 fd(NZ),deltaf(NZ),r(NZ)
  character infile*50
  character line*80
  character cutc*8

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   fcal <infile>'
     print*,'Example: fcal fmtave.out'
     go to 999
  endif
  call getarg(1,infile)

  open(10,file=infile,status='old',err=997)
  open(12,file='fcal.out',status='unknown')
  open(13,file='fcal.plt',status='unknown')

  i=0
  do j=1,9999
     read(10,1000,end=10) line
1000 format(a80)
     i0=index(line,' 0 ')
     i1=index(line,' 1 ')
     if(i0.le.0 .and. i1.le.0) then
        read(line,*,err=5) f,df
        ncal=1
        i=i+1
        fd(i)=f
        deltaf(i)=df
     else if(i1.gt.0) then
        i=i+1
        read(line,*,err=5) f,df,ncal,nn,rr,cutc
        fd(i)=f
        deltaf(i)=df
        r(i)=0.d0
     endif
5    continue
  enddo

10 iz=i
  if(iz.lt.2) go to 998
  call fit(fd,deltaf,r,iz,a,b,sigmaa,sigmab,rms)

  write(*,1002) 
1002 format('    Freq      DF     Meas Freq     Resid'/        &
            '   (MHz)     (Hz)      (MHz)        (Hz)'/        &
            '-----------------------------------------')       
  do i=1,iz
     fm=fd(i) + 1.d-6*deltaf(i)
     calfac=1.d0 + 1.d-6*deltaf(i)/fd(i)
     write(*,1010) fd(i),deltaf(i),fm,r(i)
     write(13,1010) fd(i),deltaf(i),fm,r(i)
1010 format(f8.3,f9.3,f14.9,f9.3,2x,a6)
  enddo
  calfac=1.d0 + 1.d-6*b
  err=1.d-6*sigmab

  if(iz.ge.3) then
     write(*,1100) a,b,rms
1100 format(/'A:',f8.2,' Hz    B:',f9.4,' ppm    StdDev:',f7.3,' Hz')
  if(iz.gt.2) write(*,1110) sigmaa,sigmab
1110 format('err:',f6.2,9x,f9.4,23x,f13.9)
  else
     write(*,1120) a,b
1120 format(/'A:',f8.2,' Hz    B:',f9.4)
  endif

  write(12,1130) a,b
1130 format(f10.4)

  go to 999

997 print*,'Cannot open input file: ',infile
  go to 999
998 print*,'Input file must contain at least 2 valid measurement pairs'

999 end program fcal

subroutine fit(x,y,r,iz,a,b,sigmaa,sigmab,rms)
  implicit real*8 (a-h,o-z)
  real*8 x(iz),y(iz),r(iz)

  sx=0.d0
  sy=0.d0
  sxy=0.d0
  sx2=0.d0
  do i=1,iz
     sx=sx + x(i)
     sy=sy + y(i)
     sxy=sxy + x(i)*y(i)
     sx2=sx2 + x(i)*x(i)
  enddo
  delta=iz*sx2 - sx*sx
  a=(sx2*sy - sx*sxy)/delta
  b=(iz*sxy - sx*sy)/delta

  sq=0.d0
  do i=1,iz
     r(i)=y(i) - (a + b*x(i))
     sq=sq + r(i)**2
  enddo
  rms=0.
  sigmaa=0.
  sigmab=0.
  if(iz.ge.3) then
     rms=sqrt(sq/(iz-2))
     sigmaa=sqrt(rms*rms*sx2/delta)
     sigmab=sqrt(iz*rms*rms/delta)
  endif

  return
end subroutine fit

subroutine inter_wspr(id,ndir)

! Interleave (ndir=1) or de-interleave (ndir=-1) the array id.

  integer*1 id(0:161),itmp(0:161)
  integer j0(0:161)
  logical first
  data first/.true./
  save

  if(first) then
! Compute the interleave table using bit reversal.
     k=-1
     do i=0,255
        n=0
        ii=i
        do j=0,7
           n=n+n
           if(iand(ii,1).ne.0) n=n+1
           ii=ii/2
        enddo
        if(n.le.161) then
           k=k+1
           j0(k)=n
        endif
     enddo
     first=.false.
  endif

  if(ndir.eq.1) then
     do i=0,161
        itmp(j0(i))=id(i)
     enddo
  else
     do i=0,161
        itmp(i)=id(j0(i))
     enddo
  endif

  do i=0,161
     id(i)=itmp(i)
  enddo

  return
end subroutine inter_wspr

module pfxdump_mod
  implicit none
contains
  subroutine pfxdump(fname)
    use pfx_data_mod
    implicit none
    character*(*), intent(in) :: fname
  
    open(11,file=fname,status='unknown')
    write(11,1001) sfx
  1001 format('Supported Suffixes:'/(11('/',a1,2x)))
    write(11,1002) pfx
  1002 format(/'Supported Add-On DXCC Prefixes:'/(15(a5,1x)))
    close(11)
  
  end subroutine pfxdump
end module pfxdump_mod

program jt65

  ! Test the JT65 decoder for WSJT-X

  use options
  use timer_module, only: timer
  use timer_impl, only: init_timer
  use jt65_test
  use readwav

  character c,mode
  logical :: display_help=.false.,nrobust=.false.,single_decode=.false., ljt65apon=.false.
  type(wav_header) :: wav
  integer*2 id2(NZMAX)
  real*4 dd(NZMAX)
  character*80 infile
  character(len=500) optarg
  character*12 mycall,hiscall
  character*6 hisgrid

  type (option) :: long_options(12) = [ &
       option ('aggressive',.true.,'a','aggressiveness [0-10], default AGGR=0','AGGR'), &
       option ('depth',.true.,'d','depth=5 hinted decoding, default DEPTH=0','DEPTH'),  &
       option ('freq',.true.,'f','signal frequency, default FREQ=1270','FREQ'),         &
       option ('help',.false.,'h','Display this help message',''),                      &
       option ('mode',.true.,'m','Mode A, B, C. Default is A.','MODE'),                 &
       option ('ntrials',.true.,'n','number of trials, default TRIALS=10000','TRIALS'), &
       option ('robust-sync',.false.,'r','robust sync',''),                             &
       option ('my-call',.true.,'c','my callsign',''),                                  &
       option ('his-call',.true.,'x','his callsign',''),                                &
       option ('his-grid',.true.,'g','his grid locator',''),                            &
       option ('experience-decoding',.true.,'X'                                         &
               ,'experience decoding options (1..n), default FLAGS=0','FLAGS'),         &
       option ('single-signal-mode',.false.,'s','decode at signal frequency only','') ]

  naggressive=10
  nfqso=1500
  ntrials=100000
  nexp_decode=0
  ntol=20
  nsubmode=0
  nlow=200
  nhigh=4000
  n2pass=1
  ndepth=1
  nQSOProgress=6

  do
     call getopt('a:d:f:hm:n:rc:x:g:X:s',long_options,c,optarg,narglen,nstat,noffset,nremain,.true.)
     if( nstat .ne. 0 ) then
        exit
     end if
     select case (c)
     case ('a')
        read (optarg(:narglen), *) naggressive
     case ('d')
        read (optarg(:narglen), *) ndepth
     case ('f')
        read (optarg(:narglen), *) nfqso
     case ('h')
        display_help = .true.
     case ('m')
        read (optarg(:narglen), *) mode
        if( mode .eq. 'b' .or. mode .eq. 'B' ) then
          nsubmode=1
        endif
        if( mode .eq. 'c' .or. mode .eq. 'C' ) then
          nsubmode=2
        endif
     case ('n')
        read (optarg(:narglen), *) ntrials
     case ('r')
        nrobust=.true.
     case ('c')
        read (optarg(:narglen), *) mycall
     case ('x')
        read (optarg(:narglen), *) hiscall
     case ('g')
        read (optarg(:narglen), *) hisgrid
     case ('X')
        read (optarg(:narglen), *) nexp_decode
     case ('s')
        single_decode=.true.
        ntol=100
        nlow=nfqso-ntol
        nhigh=nfqso+ntol
        n2pass=1
     end select
  end do

  if(single_decode) nexp_decode=ior(nexp_decode,32)
  if(display_help .or. nstat.lt.0 .or. nremain.lt.1) then
     print *, ''
     print *, 'Usage: jt65 [OPTIONS] file1 [file2 ...]'
     print *, ''
     print *, '       JT65 decode pre-recorded .WAV file(s)'
     print *, ''
     print *, 'OPTIONS:'
     print *, ''
     do i = 1, size (long_options)
        call long_options(i) % print (6)
     end do
     go to 999
  endif

  call init_timer ('timer.out')
  call timer('jt65    ',0)

  ndecoded=0
  do ifile=noffset+1,noffset+nremain
     nfa=nlow
     nfb=nhigh
     minsync=0
     call get_command_argument(ifile,optarg,narglen)
     infile=optarg(:narglen)
     call timer('read    ',0)
     call wav%read (infile)
     i1=index(infile,'.wav')
     if( i1 .eq. 0 ) i1=index(infile,'.WAV')
     read(infile(i1-4:i1-1),*,err=998) nutc
     npts=52*12000
     read(unit=wav%lun) id2(1:npts)
     close(unit=wav%lun)
     call timer('read    ',1)
     dd(1:npts)=id2(1:npts)
     dd(npts+1:)=0.
     call test(dd,nutc,nfa,nfb,nfqso,ntol,nsubmode, &
          n2pass,nrobust,ntrials,naggressive,ndepth, &
          mycall,hiscall,hisgrid,nexp_decode,nQSOProgress,ljt65apon)
!     if(nft.gt.0) exit
  enddo

  call timer('jt65    ',1)
  call timer('jt65    ',101)
  !  call four2a(a,-1,1,1,1)                  !Free the memory used for plans
  !  call filbig(a,-1,1,0.0,0,0,0,0,0)        ! (ditto)
  go to 999

998 print*,'Cannot read from file:'
  print*,infile

999 continue
end program jt65

module symspec_mod
  implicit none
contains

subroutine symspec(k,nxpol,ndiskdat,nb,nbslider,idphi,nfsample,    &
     iqadjust,iqapply,gainx,gainy,phasex,phasey,rejectx,rejecty,  &
     pxdb,pydb,ssz5a,nkhz,ihsym,nzap,slimit,lstrong) bind(C, name='symspec_')

  use iso_c_binding
  use datcom_ptrs_mod
  use npar_ptrs_mod,  only: fcenter
  use four2a_mod
  use timf2_mod
  use iqcal_mod
  use iqfix_mod
  implicit none

  integer,          intent(in)    :: k
  integer,          intent(in)    :: nxpol, ndiskdat
  integer,          intent(in)    :: nb, nbslider
  integer,          intent(in)    :: idphi, nfsample
  integer,          intent(in)    :: iqadjust, iqapply
  real(c_float),    intent(inout)    :: gainx, gainy
  real(c_float),    intent(inout)    :: phasex, phasey
  real(c_float),    intent(out)   :: rejectx, rejecty
  real(c_float),    intent(out)   :: pxdb, pydb
  real(c_float),    intent(out)   :: ssz5a(*)      ! spectrum output
  integer(c_int),   intent(out)   :: nkhz
  integer(c_int),   intent(inout) :: ihsym
  integer(c_int),   intent(inout) :: nzap
  real(c_float),    intent(inout) :: slimit
  integer(c_signed_char), intent(out) :: lstrong(*)

  ! Local parameters
  integer, parameter :: NSMAX = 60*96000

  ! Locals
  real*8 :: ts, hsym
  integer :: i, ipkx, ipky, iqadjust0, iqapply0, j, ja, jb, k0, k1, kstep, &
             mm, nadjx, nadjy, nblk, nblks, nfft2, npts, nsum, nwindow, n, nfast
  real*4 :: fac, faclim, peaklimit, px, py, q, rejectx0, rms, rmsx, rmsy, &
             s135, s45, sigmas, sx, sy, u, x1, x2, x3, x4, dphi, pi
  real*4 :: w(NFFT), w2a(NFFT), w2b(NFFT)
  complex :: z, zfac, zsumx, zsumy, cx(NFFT), cy(NFFT), cx00(NFFT), cy00(NFFT)
  complex :: cx0(0:1023), cx1(0:1023), cy0(0:1023), cy1(0:1023)

  data rms /999.0/, k0 /99999999/, nadjx /0/, nadjy /0/
  save

  !-------------------- Defensive initialization --------------------
  px      = 0.0
  py      = 0.0
  rmsx    = 0.0
  rmsy    = 0.0
  rejectx = 0.0
  rejecty = 0.0
  ipkx    = 0
  ipky    = 0
  zsumx   = (0.0, 0.0)
  zsumy   = (0.0, 0.0)
  rejectx0 = 0.0

  nfast = 1
  if (k > 5751000) return
  if (k < NFFT) then
     ihsym = 0
     return             ! Wait for enough samples to start
  endif

  if (k0 == 99999999) then
     pi  = 4.0*atan(1.0)
     w2a = 0.0
     w2b = 0.0
     do i = 1, NFFT
        w(i) = (sin(i*pi/NFFT))**2                    ! Window for nfast=1
        if (i < 17833) w2a(i) = (sin(i*pi/17832.925))**2    ! Window a for nfast=2
        j = i - 8916
        if (j > 0 .and. j < 17833) w2b(i) = (sin(j*pi/17832.925))**2    ! b
     enddo
     w2a = sqrt(2.0)*w2a
     w2b = sqrt(2.0)*w2b
  endif

  hsym = 2048.d0*96000.d0/11025.d0      ! Samples per JT65 half-symbol
  if (nfsample == 95238) hsym = 2048.d0*95238.1d0/11025.d0

  if (k < k0) then
     ts   = 1.d0 - hsym
     savg = 0.0
     ihsym = 0
     k1   = 0
     if (ndiskdat == 0) dd(1:4, k+1:5760000) = 0.0
  endif
  k0 = k

  nzap    = 0
  sigmas  = 1.5*(10.0**(0.01*nbslider)) + 0.7
  peaklimit = sigmas*max(10.0, rms)
  faclim  = 3.0

  iqapply0  = 0
  iqadjust0 = 0
  if (iqadjust /= 0) iqapply0 = 0
  nwindow = 2
  nfft2   = 1024
  kstep   = nfft2
  if (nwindow /= 0) kstep = nfft2/2
  nblks = (k - k1)/kstep

  do nblk = 1, nblks
     j = k1 + 1
     do i = 0, nfft2-1
        cx0(i) = cmplx(dd(1,j+i), dd(2,j+i))
        if (nxpol /= 0) cy0(i) = cmplx(dd(3,j+i), dd(4,j+i))
     enddo

     call timf2(k, nxpol, nfft2, nwindow, nb, peaklimit, iqadjust0, iqapply0, &
                faclim, cx0, cy0, gainx, gainy, phasex, phasey,               &
                cx1, cy1, slimit, lstrong, px, py, nzap)

     do i = 0, kstep-1
        dd(1,j+i) = real(cx1(i))
        dd(2,j+i) = aimag(cx1(i))
        if (nxpol /= 0) then
           dd(3,j+i) = real(cy1(i))
           dd(4,j+i) = aimag(cy1(i))
        endif
     enddo
     k1 = k1 + kstep
  enddo

  npts = NFFT

  ts = ts + hsym
  ja = ts
  jb = ja + npts - 1

  i   = 0
  fac = 0.0002
  dphi = idphi/57.2957795
  zfac = fac*cmplx(cos(dphi), sin(dphi))

  do j = ja, jb
     x1 = dd(1,j)
     x2 = dd(2,j)
     if (nxpol /= 0) then
        x3 = dd(3,j)
        x4 = dd(4,j)
     else
        x3 = 0.0
        x4 = 0.0
     endif
     i = i + 1
     cx(i) = fac*cmplx(x1, x2)
     cy(i) = zfac*cmplx(x3, x4)
  enddo

  if (nzap/178 < 50 .and. (ndiskdat == 0 .or. ihsym < 280)) then
     nsum = nblks*kstep - nzap
     if (nsum <= 0) nsum = 1
     rmsx = sqrt(0.5*px/nsum)
     rmsy = sqrt(0.5*py/nsum)
     rms  = rmsx
     if (nxpol /= 0) rms = sqrt((px + py)/(4.0*nsum))
  endif

  pxdb = 0.0
  pydb = 0.0
  if (rmsx > 1.0) pxdb = 20.0*log10(rmsx)
  if (rmsy > 1.0) pydb = 20.0*log10(rmsy)
  if (pxdb > 60.0) pxdb = 60.0
  if (pydb > 60.0) pydb = 60.0

  cx00 = cx
  if (nxpol /= 0) cy00 = cy

  do mm = 1, nfast
     ihsym = ihsym + 1
     if (nfast == 1) then
        cx = w*cx00
        if (nxpol /= 0) cy = w*cy00
     else
        if (mm == 1) then
           cx = w2a*cx00
           if (nxpol /= 0) cy = w2a*cy00
        else
           cx = w2b*cx00
           if (nxpol /= 0) cy = w2b*cy00
        endif
     endif

     call four2a(cx, NFFT, 1, 1, 1)
     if (iqadjust == 0) nadjx = 0
     if (iqadjust /= 0 .and. nadjx < 50) call iqcal(nadjx, cx, NFFT, &
          gainx, phasex, zsumx, ipkx, rejectx0)
     if (iqapply /= 0) call iqfix(cx, NFFT, gainx, phasex)

     if (nxpol /= 0) then
        call four2a(cy, NFFT, 1, 1, 1)
        if (iqadjust == 0) nadjy = 0
        if (iqadjust /= 0 .and. nadjy < 50) call iqcal(nadjy, cy, NFFT, &
             gainy, phasey, zsumy, ipky, rejecty)
        if (iqapply /= 0) call iqfix(cy, NFFT, gainy, phasey)
     endif

     n = min(322, ihsym)
     do i = 1, NFFT
        sx = real(cx(i))**2 + aimag(cx(i))**2
        ss(1,n,i) = sx
        savg(1,i) = savg(1,i) + sx

        if (nxpol /= 0) then
           z   = cx(i) + cy(i)
           s45 = 0.5*(real(z)**2 + aimag(z)**2)
           ss(2,n,i) = s45
           savg(2,i) = savg(2,i) + s45

           sy = real(cy(i))**2 + aimag(cy(i))**2
           ss(3,n,i) = sy
           savg(3,i) = savg(3,i) + sy

           z    = cx(i) - cy(i)
           s135 = 0.5*(real(z)**2 + aimag(z)**2)
           ss(4,n,i) = s135
           savg(4,i) = savg(4,i) + s135

           z = cx(i)*conjg(cy(i))
           q = sx - sy
           u = 2.0*real(z)
           ssz5a(i) = 0.707*sqrt(q*q + u*u)
        else
           ssz5a(i) = sx
        endif
     enddo
  enddo

  if (ihsym == 278) then
     if (iqadjust /= 0 .and. ipkx /= 0 .and. ipky /= 0) then
        rejectx = 10.0*log10(savg(1,1+NFFT-ipkx)/savg(1,1+ipkx))
        rejecty = 10.0*log10(savg(3,1+NFFT-ipky)/savg(3,1+ipky))
     endif
  endif

  nkhz = nint(1000.d0*(fcenter - int(fcenter)))
  if (fcenter == 0.d0) nkhz = 125

end subroutine symspec

end module symspec_mod

subroutine osd128_90(llr,apmask,ndeep,message77,cw,nhardmin,dmin)

! Ordered-statistics decoder for the (128,90) code.

  integer, parameter:: N=128, K=90, M=N-K
  integer*1 apmask(N),apmaskr(N)
  integer*1 gen(K,N)
  integer*1 genmrb(K,N),g2(N,K)
  integer*1 temp(K),m0(K),me(K),mi(K),misub(K),e2sub(N-K),e2(N-K),ui(N-K)
  integer*1 r2pat(N-K)
  integer indices(N),nxor(N)
  integer*1 cw(N),ce(N),c0(N),hdec(N)
  integer*1 decoded(K)
  integer*1 message77(77)
  integer indx(N)
  real llr(N),rx(N),absrx(N)

  include "ldpc_128_90_generator.f90"

  logical first,reset
  data first/.true./
  save first,gen

  if( first ) then ! fill the generator matrix
     gen=0
     do i=1,M
        do j=1,23
           read(g(i)(j:j),"(Z1)") istr
           ibmax=4
           if(j.eq.23) ibmax=2
           do jj=1, ibmax 
              irow=(j-1)*4+jj
              if( btest(istr,4-jj) ) gen(irow,K+i)=1 
           enddo
        enddo
     enddo
     do irow=1,K
        gen(irow,irow)=1
     enddo
     first=.false.
  endif

  rx=llr
  apmaskr=apmask
  d1=0.
  ntheta=0
  npre1=0
  npre2=0
  nt=0

! Hard decisions on the received word.
  hdec=0            
  where(rx .ge. 0) hdec=1

! Use magnitude of received symbols as a measure of reliability.
  absrx=abs(rx) 
  call indexx(absrx,N,indx)  

! Re-order columns of generator matrix in order of decreasing reliability.
  do i=1,N
     genmrb(1:K,i)=gen(1:K,indx(N+1-i))
     indices(i)=indx(N+1-i)
  enddo

! Do gaussian elimination to create a generator matrix with the most reliable
! received bits in positions 1:K in order of decreasing reliability (more or less). 
  do id=1,K ! diagonal element indices 
     do icol=id,K+20  ! The 20 is ad hoc - beware
        iflag=0
        if( genmrb(id,icol) .eq. 1 ) then
           iflag=1
           if( icol .ne. id ) then ! reorder column
              temp(1:K)=genmrb(1:K,id)
              genmrb(1:K,id)=genmrb(1:K,icol)
              genmrb(1:K,icol)=temp(1:K) 
              itmp=indices(id)
              indices(id)=indices(icol)
              indices(icol)=itmp
           endif
           do ii=1,K
              if( ii .ne. id .and. genmrb(ii,id) .eq. 1 ) then
                 genmrb(ii,1:N)=ieor(genmrb(ii,1:N),genmrb(id,1:N))
              endif
           enddo
           exit
        endif
     enddo
  enddo

  g2=transpose(genmrb)

! The hard decisions for the K MRB bits define the order 0 message, m0. 
! Encode m0 using the modified generator matrix to find the "order 0" codeword. 
! Flip various combinations of bits in m0 and re-encode to generate a list of
! codewords. Return the member of the list that has the smallest Euclidean
! distance to the received word. 

  hdec=hdec(indices)   ! hard decisions from received symbols
  m0=hdec(1:K)         ! zero'th order message
  absrx=absrx(indices) 
  rx=rx(indices)       
  apmaskr=apmaskr(indices)

  call mrbencode90(m0,c0,g2,N,K)
  nxor=ieor(c0,hdec)
  nhardmin=sum(nxor)
  dmin=sum(nxor*absrx)

  cw=c0
  ntotal=0
  nrejected=0

  if(ndeep.eq.0) goto 998  ! norder=0
  if(ndeep.gt.5) ndeep=5
  if( ndeep.eq. 1) then
     nord=1
     npre1=0
     npre2=0
     nt=12
     ntheta=3
  elseif(ndeep.eq.2) then
     nord=1
     npre1=1
     npre2=0
     nt=18
     ntheta=4
  elseif(ndeep.eq.3) then
     nord=1
     npre1=1
     npre2=0
     nt=12
     ntheta=4
  elseif(ndeep.eq.4) then
     nord=1
     npre1=1
     npre2=1
     nt=12
     ntheta=4
     ntau=15
  elseif(ndeep.eq.5) then
     nord=1
     npre1=1
     npre2=1
     nt=12
     ntheta=4
     ntau=5
  endif

  do iorder=1,nord
     misub(1:K-iorder)=0
     misub(K-iorder+1:K)=1
     iflag=K-iorder+1
     do while(iflag .ge.0)
        if(iorder.eq.nord .and. npre1.eq.0) then
           iend=iflag
        else
           iend=1
        endif
        do n1=iflag,iend,-1
           mi=misub
           mi(n1)=1
           if(any(iand(apmaskr(1:K),mi).eq.1)) cycle
           ntotal=ntotal+1
           me=ieor(m0,mi)
           if(n1.eq.iflag) then
              call mrbencode90(me,ce,g2,N,K)
              e2sub=ieor(ce(K+1:N),hdec(K+1:N))
              e2=e2sub
              nd1Kpt=sum(e2sub(1:nt))+1
              d1=sum(ieor(me(1:K),hdec(1:K))*absrx(1:K))
           else
              e2=ieor(e2sub,g2(K+1:N,n1))
              nd1Kpt=sum(e2(1:nt))+2
           endif
           if(nd1Kpt .le. ntheta) then
              call mrbencode90(me,ce,g2,N,K)
              nxor=ieor(ce,hdec)
              if(n1.eq.iflag) then
                 dd=d1+sum(e2sub*absrx(K+1:N))
              else
                 dd=d1+ieor(ce(n1),hdec(n1))*absrx(n1)+sum(e2*absrx(K+1:N))
              endif
              if( dd .lt. dmin ) then
                 dmin=dd
                 cw=ce
                 nhardmin=sum(nxor)
                 nd1Kptbest=nd1Kpt
              endif
           else 
              nrejected=nrejected+1
           endif
        enddo
! Get the next test error pattern, iflag will go negative
! when the last pattern with weight iorder has been generated.
        call nextpat90(misub,k,iorder,iflag)
     enddo
  enddo

  if(npre2.eq.1) then
     reset=.true.
     ntotal=0
     do i1=K,1,-1
        do i2=i1-1,1,-1
           ntotal=ntotal+1
           mi(1:ntau)=ieor(g2(K+1:K+ntau,i1),g2(K+1:K+ntau,i2))
           call boxit90(reset,mi(1:ntau),ntau,ntotal,i1,i2)
        enddo
     enddo

     ncount2=0
     ntotal2=0
     reset=.true.
! Now run through again and do the second pre-processing rule
     misub(1:K-nord)=0
     misub(K-nord+1:K)=1
     iflag=K-nord+1
     do while(iflag .ge.0)
        me=ieor(m0,misub)
        call mrbencode90(me,ce,g2,N,K)
        e2sub=ieor(ce(K+1:N),hdec(K+1:N))
        do i2=0,ntau
           ntotal2=ntotal2+1
           ui=0 
           if(i2.gt.0) ui(i2)=1 
           r2pat=ieor(e2sub,ui)
778        continue 
           call fetchit90(reset,r2pat(1:ntau),ntau,in1,in2)
           if(in1.gt.0.and.in2.gt.0) then
              ncount2=ncount2+1
              mi=misub               
              mi(in1)=1
              mi(in2)=1
              if(sum(mi).lt.nord+npre1+npre2.or.any(iand(apmaskr(1:K),mi).eq.1)) cycle
              me=ieor(m0,mi)
              call mrbencode90(me,ce,g2,N,K)
              nxor=ieor(ce,hdec)
              dd=sum(nxor*absrx)
              if( dd .lt. dmin ) then
                 dmin=dd
                 cw=ce
                 nhardmin=sum(nxor)
              endif
              goto 778
           endif
        enddo
        call nextpat90(misub,K,nord,iflag)
     enddo
  endif

998 continue
! Re-order the codeword to [message bits][parity bits] format. 
  cw(indices)=cw
  hdec(indices)=hdec
  decoded=cw(1:K) 
  call chkcrc13a(decoded,nbadcrc)
  message77=decoded(1:77)
  if(nbadcrc.eq.1) nhardmin=-nhardmin

  return
end subroutine osd128_90

subroutine mrbencode90(me,codeword,g2,N,K)
  integer*1 me(K),codeword(N),g2(N,K)
! fast encoding for low-weight test patterns
  codeword=0
  do i=1,K
     if( me(i) .eq. 1 ) then
        codeword=ieor(codeword,g2(1:N,i))
     endif
  enddo
  return
end subroutine mrbencode90

subroutine nextpat90(mi,k,iorder,iflag)
  integer*1 mi(k),ms(k)
! generate the next test error pattern
  ind=-1
  do i=1,k-1
     if( mi(i).eq.0 .and. mi(i+1).eq.1) ind=i 
  enddo
  if( ind .lt. 0 ) then ! no more patterns of this order
     iflag=ind
     return
  endif
  ms=0
  ms(1:ind-1)=mi(1:ind-1)
  ms(ind)=1
  ms(ind+1)=0
  if( ind+1 .lt. k ) then
     nz=iorder-sum(ms)
     ms(k-nz+1:k)=1
  endif
  mi=ms
  do i=1,k  ! iflag will point to the lowest-index 1 in mi
     if(mi(i).eq.1) then
        iflag=i 
        exit
     endif
  enddo
  return
end subroutine nextpat90

subroutine boxit90(reset,e2,ntau,npindex,i1,i2)
  integer*1 e2(1:ntau)
  integer indexes(5000,2),fp(0:525000),np(5000)
  logical reset
  common/boxes/indexes,fp,np

  if(reset) then
     patterns=-1
     fp=-1
     np=-1
     sc=-1
     indexes=-1
     reset=.false.
  endif
 
  indexes(npindex,1)=i1
  indexes(npindex,2)=i2
  ipat=0
  do i=1,ntau
     if(e2(i).eq.1) then
        ipat=ipat+ishft(1,ntau-i)
     endif
  enddo

  ip=fp(ipat)   ! see what's currently stored in fp(ipat)
  if(ip.eq.-1) then
     fp(ipat)=npindex
  else
     do while (np(ip).ne.-1)
        ip=np(ip) 
     enddo
     np(ip)=npindex
  endif
  return
end subroutine boxit90

subroutine fetchit90(reset,e2,ntau,i1,i2)
  integer   indexes(5000,2),fp(0:525000),np(5000)
  integer   lastpat
  integer*1 e2(ntau)
  logical reset
  common/boxes/indexes,fp,np
  save lastpat,inext

  if(reset) then
     lastpat=-1
     reset=.false.
  endif

  ipat=0
  do i=1,ntau
     if(e2(i).eq.1) then
        ipat=ipat+ishft(1,ntau-i)
     endif
  enddo
  index=fp(ipat)

  if(lastpat.ne.ipat .and. index.gt.0) then ! return first set of indices
     i1=indexes(index,1)
     i2=indexes(index,2)
     inext=np(index)
  elseif(lastpat.eq.ipat .and. inext.gt.0) then
     i1=indexes(inext,1)
     i2=indexes(inext,2)
     inext=np(inext)
  else
     i1=-1
     i2=-1
     inext=-1
  endif
  lastpat=ipat
  return
end subroutine fetchit90

program encode77

  use packjt77
  
  character*80 msg0
  character msg*37,cerr*1
  character*77 c77
  character*80 infile
  character*13 w(19)
  integer nw(19)
  logical unpk77_success

  nargs=iargc()
  if(nargs.ne.1 .and.nargs.ne.2) then
     print*,'Usage: encode77 "message"'
     print*,'       encode77 -f <infile>'
     go to 999
  endif
  call getarg(1,msg0)
  call fmtmsg(msg0,iz)
  if(nargs.eq.2) then
     call getarg(2,infile)
     open(10,file=infile,status='old')
     write(*,1000)
1000 format('i3.n3 Err Message to be encoded                 Decoded message' &
            /80('-'))
  endif
  
  do iline=1,999
     if(nargs.eq.2) read(10,1002,end=999) msg0
1002 format(a80)
     if(msg0(1:1).eq.'$') exit
     if(msg0.eq.'                                     ') cycle
     if(msg0(2:2).eq.'.' .or. msg0(3:3).eq.'.') cycle
     if(msg0(1:3).eq.'---') cycle
     msg0=adjustl(msg0)
     i3=-1
     n3=-1
     call pack77(msg0(1:37),i3,n3,c77)
     call unpack77(c77,1,msg,unpk77_success)
     cerr=' '
     if(msg.ne.msg0(1:37)) cerr='*'
     if(i3.eq.0 .and.n3.ne.6) write(*,1004) i3,n3,cerr,msg0(1:37),msg
1004 format(i2,'.',i1,4x,a1,1x,a37,1x,a37)
     if(i3.eq.0 .and.n3.eq.6) then
        call split77(msg,nwords,nw,w)
        j2=0
        if(nwords.eq.2 .and. len(trim(w(2))).le.2) j2=1
        if(nwords.eq.2 .and. len(trim(w(2))).eq.6) j2=2
        write(*,1005) i3,n3,j2,cerr,msg0(1:37),msg
1005    format(i2,'.',i1,'.',i1,2x,a1,1x,a37,1x,a37)
     endif
     if(i3.ge.1) write(*,1006) i3,cerr,msg0(1:37),msg
1006 format(i2,'.',5x,a1,1x,a37,1x,a37)
     if(nargs.eq.1) exit
  enddo

999 end program encode77

include '../chkcall.f90'

program hash22calc 
! Given a valid callsign, calculate and print its 22-bit hash.

  use packjt77
  
  character*13 callsign
  character*1  c
  character*6  basecall
  logical      cok

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Given a valid callsign, print its 22-bit hash.'
     print*,'Usage: hash22calc <callsign>'
     print*,'  e.g. hash22calc W9ABC'
     go to 999
  endif
  call getarg(1,callsign)

! convert to upper case
  ilen=len(trim(callsign)) 
  do i=1, ilen
     c=callsign(i:i)
     if(c.ge.'a' .and. c.le.'z') c=char(ichar(c)-32)  !Force upper case
     callsign(i:i)=c
  enddo 

! check for a valid callsign
  call chkcall(callsign,basecall,cok)
  if(.not.cok) then
     print*,'Invalid callsign'
     print*,'Usage: hash22calc <callsign>'
     goto 999
  endif

! calculate the hash
  n22 = ihashcall(callsign,22)
  write(*,'(a,i7.7)') callsign,n22

999 end program hash22calc

include '../chkcall.f90'

program cwsim

! Generate simulated audio for a CW message sent repeatedly for 60 seconds

  use wavhdr
  parameter (NMAX=60*12000)
  type(hdr) h                            !Header for the .wav file
  integer*2 iwave(NMAX)                  !Generated waveform (no noise)
  integer icw(500)                       !Encoded CW message bits
  complex cspread(0:NMAX-1)              !Complex amplitude for Rayleigh fading
  complex cdat(0:NMAX-1)                 !Complex waveform
  real dat(NMAX)                         !Audio waveform
  real*4 xnoise(NMAX)                    !Generated random noise
  character*60 message
  character*12 arg

  nargs=iargc()
  if(nargs.ne.6) then
     print*,'Usage:   cwsim         "message"           freq  bw wpm fspread snr'
     print*,'Example: cwsim "CQ CQ CQ DE K1JT K1JT K1JT" 700 100  20   100   -10'
     go to 999
  endif

  call getarg(1,message)
  call getarg(2,arg)
  read(arg,*) ifreq                  !Audio frequency (Hz)
  call getarg(3,arg)
  read(arg,*) bw                     !Bandwidth (Hz)
  call getarg(4,arg)
  read(arg,*) wpm                    !CW speed, words per minute
  call getarg(5,arg)
  read(arg,*) fspread                !Doppler spread in Hz
  call getarg(6,arg)
  read(arg,*) snrdb                  !S/N in dB (2500 hz reference BW)

  rms=500.0
  bandwidth_ratio=2500.0/6000.0
  sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*snrdb)
  twopi=8.0*atan(1.0)

  h=default_header(12000,NMAX)
  open(10,file='000000_0000.wav',access='stream',status='unknown')
  do i=1,NMAX                   !Generate gaussian noise
     xnoise(i)=gran()
  enddo

  itone=0
  call morse(message,icw,ncw)
  call cwsig(icw,ncw,ifreq,wpm,sig,cdat)
  nfft=NMAX

  if(fspread.ne.0) then                  !Apply specified Doppler spread
     nh=nfft/2
     df=12000.0/nfft
     cspread(0)=1.0
     cspread(nh)=0.
     b=6.0                       !Use truncated Lorenzian shape for fspread
     do i=1,nh
        f=i*df
        x=b*f/fspread
        z=0.
        a=0.
        if(x.lt.3.0) then                          !Cutoff beyond x=3
           a=sqrt(1.111/(1.0+x*x)-0.1)             !Lorentzian amplitude
           phi1=twopi*rran()                       !Random phase
           z=a*cmplx(cos(phi1),sin(phi1))
        endif
        cspread(i)=z
        z=0.
        if(x.lt.3.0) then                !Same thing for negative freqs
           phi2=twopi*rran()
           z=a*cmplx(cos(phi2),sin(phi2))
        endif
        cspread(nfft-i)=z
     enddo

     call four2a(cspread,nfft,1,1,1)             !Transform to time domain
     sum=0.
     do i=0,nfft-1
        p=real(cspread(i))**2 + aimag(cspread(i))**2
        sum=sum+p
     enddo
     avep=sum/nfft
     fac=sqrt(1.0/avep)
     cspread=fac*cspread                   !Normalize to constant avg power
     cdat=cspread*cdat                     !Apply Rayleigh fading
  endif

  dat=aimag(cdat) + xnoise
  
  cdat=dat
  call four2a(cdat,nfft,1,-1,1)                 !c2c to frequency domain
  ia=max(250/df,(ifreq-0.5*bw)/df)
  ib=ia+bw/df
  cdat(0:ia)=0.
  cdat(ib:)=0.
  call four2a(cdat,nfft,1,+1,1)                 !c2c to time domain
  fac=sqrt(5000/bw)/nfft
  dat=fac*real(cdat)
  
  iwave=nint(rms*dat)
  write(10) h,iwave
  close(10)

999 end program cwsim

subroutine cwsig(icw,ncw,ifreq,wpm,sig,cdat)

  parameter(NMAX=60*12000)
  integer icw(ncw)
  complex cdat(NMAX)
  complex z(NMAX)
  real x(NMAX)
  real y(NMAX)
  real*8 dt,twopi,phi,dphi,fsample,tdit,t

  nspd=nint(1.2*12000.0/wpm)
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  tdit=nspd*dt
  twopi=8.d0*atan(1.d0)
  dphi=twopi*ifreq*dt
  phi=0.
  k=12000                            !Start audio at t = 1.0 s
  t=0.
  npts=59*12000
  x=0.
  do i=1,npts
     t=t+dt
     j=nint(t/tdit) + 1
     j=mod(j-1,ncw) + 1
     phi=phi + dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     k=k+1
     x(k)=icw(j)
     z(k)=cmplx(cos(xphi),sin(xphi))
     if(t.ge.59.5) exit
  enddo

  nadd=0.004/dt
  call smo(x,npts,y,nadd)
  y=y/nadd
  cdat=sig*y*z

  return
end subroutine cwsig

subroutine morse(msg,idat,n)

! Convert ascii message to a Morse code bit string.
!    Dash = 3 dots
!    Space between dots, dashes = 1 dot
!    Space between letters = 3 dots
!    Space between words = 7 dots

  character*(*) msg
  integer idat(500)
  integer*1 ic(21,38)
  data ic/                                        &
     1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,20,  &
     1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,0,0,18,  &
     1,0,1,0,1,1,1,0,1,1,1,0,1,1,1,0,0,0,0,0,16,  &
     1,0,1,0,1,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,14,  &
     1,0,1,0,1,0,1,0,1,1,1,0,0,0,0,0,0,0,0,0,12,  &
     1,0,1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,1,1,0,1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,12,  &
     1,1,1,0,1,1,1,0,1,0,1,0,1,0,0,0,0,0,0,0,14,  &
     1,1,1,0,1,1,1,0,1,1,1,0,1,0,1,0,0,0,0,0,16,  &
     1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,0,0,0,18,  &
     1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 6,  &
     1,1,1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,1,1,0,1,0,1,1,1,0,1,0,0,0,0,0,0,0,0,0,12,  &
     1,1,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 8,  &
     1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 2,  &
     1,0,1,0,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,1,1,0,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 8,  &
     1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 4,  &
     1,0,1,1,1,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,14,  &
     1,1,1,0,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,0,1,1,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 8,  &
     1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 6,  &
     1,1,1,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,12,  &
     1,0,1,1,1,0,1,1,1,0,1,0,0,0,0,0,0,0,0,0,12,  &
     1,1,1,0,1,1,1,0,1,0,1,1,1,0,0,0,0,0,0,0,14,  &
     1,0,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 8,  &
     1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 6,  &
     1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 4,  &
     1,0,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 8,  &
     1,0,1,0,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,10,  &
     1,1,1,0,1,0,1,0,1,1,1,0,0,0,0,0,0,0,0,0,12,  &
     1,1,1,0,1,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,14,  &
     1,1,1,0,1,1,1,0,1,0,1,0,0,0,0,0,0,0,0,0,12,  &
     1,1,1,0,1,0,1,0,1,1,1,0,1,0,0,0,0,0,0,0,14,  &
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 2/     !Incremental word space
  save

  msglen=len(trim(msg))
  idat=0
  n=6
  do k=1,msglen
     jj=ichar(msg(k:k))
     if(jj.ge.97 .and. jj.le.122) jj=jj-32  !Convert lower to upper case
     if(jj.ge.48 .and. jj.le.57) j=jj-48    !Numbers
     if(jj.ge.65 .and. jj.le.90) j=jj-55    !Letters
     if(jj.eq.47) j=36                      !Slash (/)
     if(jj.eq.32) j=37                      !Word space
     j=j+1

! Insert this character
     nmax=ic(21,j)
     if (n + nmax + 4 .gt. size (idat)) exit
     do i=1,nmax
        n=n+1
        idat(n)=ic(i,j)
     enddo

! Insert character space of 2 dit lengths:
     n=n+1
     idat(n)=0
     n=n+1
     idat(n)=0
  enddo

! Insert word space at end of message
  do j=1,4
     n=n+1
     idat(n)=0
  enddo

  return
end subroutine morse

subroutine msk40_freq_search(cdat,fc,if1,if2,delf,nframes,navmask,cb,    &
     cdat2,xmax,bestf,cs,xccs)

  parameter (NSPM=240,NZ=7*NSPM)
  complex cdat(NZ)
  complex cdat2(NZ)
  complex c(NSPM)                    !Coherently averaged complex data
  complex ct2(2*NSPM)
  complex cs(NSPM)
  complex cb(42)                     !Complex waveform for sync word 
  complex cc(0:NSPM-1)
  real xcc(0:NSPM-1)
  real xccs(0:NSPM-1)
  integer navmask(nframes)           !Tells which frames to average

  navg=sum(navmask) 
  n=nframes*NSPM
!  fac=1.0/(48.0*sqrt(float(navg)))
  fac=1.0/(24.0*sqrt(float(navg)))

  do ifr=if1,if2                     !Find freq that maximizes sync
     ferr=ifr*delf
     call tweak1(cdat,n,-(fc+ferr),cdat2)
     c=0
     do i=1,nframes
        ib=(i-1)*NSPM+1
        ie=ib+NSPM-1
        if( navmask(i) .eq. 1 ) c=c+cdat2(ib:ie)
     enddo

     cc=0
     ct2(1:NSPM)=c
     ct2(NSPM+1:2*NSPM)=c

     do ish=0,NSPM-1
        cc(ish)=dot_product(ct2(1+ish:42+ish),cb(1:42))
     enddo

     xcc=abs(cc)
     xb=maxval(xcc)*fac
     if(xb.gt.xmax) then
        xmax=xb
        bestf=ferr
        cs=c
        xccs=xcc
     endif
  enddo

!  write(71,3001) fc,delf,if1,if2,nframes,bestf,xmax
!3001 format(2f8.3,3i5,2f8.3)

  return
end subroutine msk40_freq_search

subroutine hint65(s3,mrs,mrs2,nadd,nflip,mycall,hiscall,hisgrid,qual,decoded)

  use packjt
  use prog_args
  parameter (MAXCALLS=10000,MAXRPT=63)
  parameter (MAXMSG=2*MAXCALLS + 2 + MAXRPT)
  real s3(64,63)
  integer*1 sym1(0:62,MAXMSG)
  integer*1 sym2(0:62,MAXMSG)
  integer mrs(63),mrs2(63)
  integer dgen(12),sym(0:62),sym_rev(0:62)
  character*6 mycall,hiscall,hisgrid,call2(MAXCALLS)
  character*4 grid2(MAXCALLS),rpt(MAXRPT)
  character callsign*12,grid*4
  character*180 line
  character ceme*3,msg*22,msg00*22
  character*22 msg0(MAXMSG),decoded
  logical*1 eme(MAXCALLS)
  logical first
  data first/.true./
  data rpt/'-01','-02','-03','-04','-05',          &
           '-06','-07','-08','-09','-10',          &
           '-11','-12','-13','-14','-15',          &
           '-16','-17','-18','-19','-20',          &
           '-21','-22','-23','-24','-25',          &
           '-26','-27','-28','-29','-30',          &
           'R-01','R-02','R-03','R-04','R-05',     &
           'R-06','R-07','R-08','R-09','R-10',     &
           'R-11','R-12','R-13','R-14','R-15',     &
           'R-16','R-17','R-18','R-19','R-20',     &
           'R-21','R-22','R-23','R-24','R-25',     &
           'R-26','R-27','R-28','R-29','R-30',     &
           'RO','RRR','73'/
  save first,sym1,nused,msg0,sym2

  first=.true.   !### For now, at least: always recompute hypothetical messages
  if(first) then
     neme=0
     open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')
     icall=0
     j=0
     do i=1,MAXCALLS
        read(23,1002,end=10) line
1002    format(a80)
        if(line(1:4).eq.'ZZZZ') cycle
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4) cycle
        i2=index(line(i1+1:),',')
        if(i2.lt.5) cycle
        i2=i2+i1
        i3=index(line(i2+1:),',')
        if(i3.lt.1) i3=index(line(i2+1:),' ')
        i3=i2+i3
        callsign=line(1:i1-1)
        grid=line(i1+1:i1+4)
        ceme=line(i2+1:i3-1)
        eme(i)=ceme.eq.'EME'
        if(neme.eq.1 .and. (.not.eme(i))) cycle
        j=j+1
        call2(j)=callsign(1:6)               !### Fix for compound callsigns!
        grid2(j)=grid
     enddo
10   ncalls=j
     close(23)

! NB: generation of test messages is not yet complete!
     j=0
     do i=-1,ncalls
        if(i.eq.0 .and. hiscall.eq.'      ' .and. hisgrid(1:4).eq.'    ') cycle
        mz=2
        if(i.eq.-1) mz=1
        if(i.eq.0) mz=65
        do m=1,mz
           j=j+1
           if(i.eq.-1) then
              msg='0123456789ABC'
           else if(i.eq.0) then
              if(m.eq.1) msg=mycall//' '//hiscall//' '//hisgrid(1:4)
              if(m.eq.2) msg='CQ '//hiscall//' '//hisgrid(1:4)
              if(m.ge.3) msg=mycall//' '//hiscall//' '//rpt(m-2)
           else
              if(m.eq.1)  msg=mycall//' '//call2(i)//' '//grid2(i)
              if(m.eq.2)  msg='CQ '//call2(i)//' '//grid2(i)
           endif
           call fmtmsg(msg,iz)
           call packmsg(msg,dgen,itype) !Pack message into 72 bits
           call rs_encode(dgen,sym_rev)            !RS encode
           sym(0:62)=sym_rev(62:0:-1)
           sym1(0:62,j)=sym

           call interleave63(sym_rev,1)            !Interleave channel symbols
           call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
           sym2(0:62,j)=sym_rev(0:62)
           msg0(j)=msg
        enddo
     enddo
     nused=j
     first=.false.
  endif

  ref0=0.
  do j=1,63
     ref0=ref0 + s3(mrs(j)+1,j)
  enddo

  u1=0.
  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  ipk2=0
  msg00='                      '
  do k=1,nused
     if(k.ge.2 .and. k.le.64 .and. nflip.lt.0) cycle
! Test all messages if nflip=+1; skip the CQ messages if nflip=-1.
     if(nflip.gt.0 .or. msg0(k)(1:3).ne.'CQ ') then
        psum=0.
        ref=ref0
        do j=1,63
           i=sym2(j-1,k)+1
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
        enddo
        p=psum/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) then
              ipk2=ipk
              u2=u1
           endif
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) then
           u2=p
           ipk2=k
        endif
     endif
  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  if(nadd.ge.4) bias=max(1.08*u2,0.45)
  if(nadd.ge.8) bias=max(1.04*u2,0.60)
  qual=100.0*(u1-bias)
  qmin=1.0
  if(qual.ge.qmin) decoded=msg0(ipk)

  return
end subroutine hint65

module iqfix_mod
  implicit none
contains
 subroutine iqfix(c,nfft,gain,phase) &
   bind(C, name="iqfix_")
   implicit none
   integer, intent(in) :: nfft
   complex, intent(inout) :: c(0:nfft-1)
   real, intent(in) :: gain, phase
   
   complex :: z,h,u,v
   integer :: i, nh
   real :: x,y
   
   nh=nfft/2
   h=gain*cmplx(cos(phase),sin(phase))
   
   do i=1,nh-1
      u=c(i)
      v=c(nfft-i)
      x=real(u)  + real(v)  - (aimag(u) + aimag(v))*aimag(h) +         &
           (real(u) - real(v))*real(h)
      y=aimag(u) - aimag(v) + (aimag(u) + aimag(v))*real(h)  +         &
           (real(u) - real(v))*aimag(h)
      c(i)=0.5*cmplx(x,y)
      z=u
      u=v
      v=z
      x=real(u)  + real(v)  - (aimag(u) + aimag(v))*aimag(h) +         &
           (real(u) - real(v))*real(h)
      y=aimag(u) - aimag(v) + (aimag(u) + aimag(v))*real(h)  +         &
           (real(u) - real(v))*aimag(h)
      c(nfft-i)=0.5*cmplx(x,y)
   enddo
   
 end subroutine iqfix
end module iqfix_mod

subroutine afc65b(cx,cy,npts,fsample,nflip,ipol,xpol,ndphi,a,ccfbest,dtbest)

  logical xpol
  complex cx(npts)
  complex cy(npts)
  real a(5),deltaa(5)

  a(1)=0.
  a(2)=0.
  a(3)=0.
  a(4)=45.0*(ipol-1.0)
  deltaa(1)=2.0
  deltaa(2)=2.0
  deltaa(3)=2.0
  deltaa(4)=22.5
  deltaa(5)=0.05
  nterms=3
  if(xpol) nterms=4

! Don't fit polarization when solving for dphi
  if(ndphi.ne.0) nterms=3

!  Start the iteration
  chisqr=0.
  chisqr0=1.e6
  do iter=1,3                               !One iteration is enough?
     do j=1,nterms
        chisq1=fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
        fn=0.
        delta=deltaa(j)
10      a(j)=a(j)+delta
        chisq2=fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      fn=fn+1.0
        a(j)=a(j)+delta
        chisq3=fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
        deltaa(j)=deltaa(j)*fn/3.
     enddo
     chisqr=fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
     if(chisqr/chisqr0.gt.0.9999) go to 30
     chisqr0=chisqr
  enddo

30 ccfbest=ccfmax * (1378.125/fsample)**2
  dtbest=dtmax

  if(a(4).lt.0.0) a(4)=a(4)+180.0
  if(a(4).ge.180.0) a(4)=a(4)-180.0
  if(nint(a(4)).eq.180) a(4)=0.
  ipol=nint(a(4)/45.0) + 1
  if(ipol.gt.4) ipol=ipol-4

  return
end subroutine afc65b

logical function baddatavar()

  use jt65_mod6

  ninterval=1200
  j=0
  smin=1.e30
  smax=-smin
  iz=49*12000/ninterval
  nadd=ninterval/60

 ! 3457-4800 range: cover broken data being observed under Windows XP
  if(abs(dd(4200)).lt.0.1) dd(4200)=1.0

  do i=1,iz
     sq=0.
     do n=1,ninterval,60
        j=j+60
        x=dd(j)
        sq=sq + x*x
     enddo
     rms=sqrt(sq/nadd)
     smin=min(smin,rms)
     smax=max(smax,rms)
  enddo

  sratio=smax/(smin+1.e-30)
  baddatavar=.false.
  if(sratio.gt.1.e30) baddatavar=.true.

  return
end function baddatavar

subroutine decode65b(s2,nflip,nadd,mode65,ntrials,naggressive,ndepth,      &
     mycall,hiscall,hisgrid,nQSOProgress,ljt65apon,nqd,nft,qual,           &
     nhist,decoded)

  use jt65_mod
  real s2(66,126)
  real s3(64,63)
  logical ltext,ljt65apon
  character decoded*22
  character mycall*12,hiscall*12,hisgrid*6
  save

  if(nqd.eq.-99) stop                !Silence compiler warning
  do j=1,63
     k=mdat(j)                       !Points to data symbol
     if(nflip.lt.0) k=mdat2(j)
     do i=1,64
        s3(i,j)=s2(i+2,k)
     enddo
  enddo

  call extract(s3,nadd,mode65,ntrials,naggressive,ndepth,nflip,mycall,   &
      hiscall,hisgrid,nQSOProgress,ljt65apon,ncount,                     &
      nhist,decoded,ltext,nft,qual)

! Suppress "birdie messages" and other garbage decodes:
  if(decoded(1:7).eq.'000AAA ') ncount=-1
  if(decoded(1:7).eq.'0L6MWK ') ncount=-1
  if(nflip.lt.0 .and. ltext) ncount=-1
  if(ncount.lt.0) then 
     nft=0
     decoded='                      '
  endif

  return
end subroutine decode65b

subroutine ft8apset(mycall12,hiscall12,ncontest,apsym,aph10)
  use packjt77
  character*77 c77
  character*37 msg,msgchk
  character*12 mycall12,hiscall12,hiscall
  character*13 hc13
  character*10 c10
  integer apsym(58),aph10(10)
  logical nohiscall,unpk77_success,std

  apsym=0
  apsym(1)=99
  apsym(30)=99
  aph10=0
  aph10(1)=99
  if(len(trim(mycall12)).lt.3) return 

  nohiscall=.false. 
  hiscall=hiscall12 
  if(len(trim(hiscall)).lt.3) then
     hiscall='KA1ABC'                   !Use a dummy hiscall
     nohiscall=.true.
  else
     hc13=hiscall
     n10=0
     n12=0
     n22=0
     call save_hash_call(hc13,n10,n12,n22)
     write(c10,'(b10.10)') iand(n10,Z'3FF') 
     read(c10,'(10i1.1)',err=1) aph10
     aph10=2*aph10-1
  endif

! Encode a dummy standard message: i3=1, 28 1 28 1 1 15
!
  msg=trim(mycall12)//' '//trim(hiscall)//' RRR'
  call stdcall(mycall12,std)
  if(.not.std) msg='<'//trim(mycall12)//'> '//trim(hiscall)//' RRR'
  i3=0
  n3=0
  call pack77(msg,i3,n3,c77)
  call unpack77(c77,1,msgchk,unpk77_success)
  if(ncontest.eq.7.and. (i3.ne.1 .or. .not.unpk77_success)) return
  if(ncontest.le.5.and. (i3.ne.1 .or. msg.ne.msgchk .or. .not.unpk77_success)) return 

  read(c77,'(58i1)',err=2) apsym(1:58)
  apsym=2*apsym-1
  if(nohiscall) then
    apsym(30)=99
    aph10(1)=99 
  endif
  return

1 aph10=0
  aph10(1)=99
  return
2 apsym=0
  apsym(1)=99
  apsym(30)=99
  return

end subroutine ft8apset

module ftrsd2_mod
  use iso_c_binding
  implicit none
  interface
    subroutine ftrsd2_(mrsym, mrprob, mr2sym, mr2prob, ntrials0, correct, param, ntry) bind(C, name="ftrsd2_")
      use iso_c_binding
      integer(c_int), intent(in) :: mrsym(*), mrprob(*), mr2sym(*), mr2prob(*)
      integer(c_int), intent(in) :: ntrials0
      integer(c_int), intent(in) :: correct(*), param(*), ntry(*)
    end subroutine ftrsd2_
  end interface
end module ftrsd2_mod

subroutine flat4(s,npts0,nflatten)

! Flatten a spectrum for optimum display
! Input:  s(npts)    Linear scale in power
!         nflatten   If nflatten=0, convert to dB but do not flatten
! Output: s(npts)    Flattened, with dB scale


  implicit real*8 (a-h,o-z)
  real*4 s(6827)
  real*4 base
  real*8 x(1000),y(1000),a(5)
  data nseg/10/,npct/10/

  npts=min(6827,npts0)
  if(s(1).gt.1.e29) go to 900         !Boundary between Rx intervals: do nothing
  do i=1,npts
     s(i)=10.0*log10(s(i))            !Convert to dB scale
  enddo

  if(nflatten.gt.0) then
     nterms=5
     if(nflatten.eq.2) nterms=1
     nlen=npts/nseg                   !Length of test segment
     i0=npts/2                        !Midpoint
     k=0
     do n=1,nseg                      !Skip first segment, likely rolloff here
        ib=n*nlen
        ia=ib-nlen+1
        if(n.eq.nseg) ib=npts
        call pctile(s(ia),ib-ia+1,npct,base) !Find lowest npct of points
        do i=ia,ib
           if(s(i).le.base) then
              if (k.lt.1000) k=k+1    !Save these "lower envelope" points
              x(k)=i-i0
              y(k)=s(i)
           endif
        enddo
     enddo
     kz=k
     a=0.
  
     call polyfit(x,y,y,kz,nterms,0,a,chisqr)  !Fit a low-order polynomial

     do i=1,npts
        t=i-i0
        yfit=a(1)+t*(a(2)+t*(a(3)+t*(a(4)+t*(a(5)))))
        s(i)=s(i)-yfit                !Subtract the fitted baseline
     enddo
  endif

900 return
end subroutine flat4

MODULE prog_args
  CHARACTER(len=80) :: shm_key
  CHARACTER(len=500) :: exe_dir = '.', data_dir = '.', temp_dir = '.',    &
       share_dir = '.' !ft8md added share_dir
  LOGICAL :: lquiet = .false.
END MODULE prog_args

subroutine zplot(amp,nz,jj,ave,rms)

  real amp(nz)
  character*1 line(100),mark(0:6)
  data mark/' ',' ','.','-','+','X','$'/

  sum=0.
  smax=0.
  do i=1,nz
     sum=sum+amp(i)
     if(amp(i).gt.smax) then
        smax=amp(i)
        ipk=i
     endif
  enddo
  ave=(sum-smax)/(nz-1)
  sq=0.
  do i=1,nz
     if(i.ne.ipk) sq=sq+(amp(i)-ave)**2
  enddo
  rms=sqrt(sq/(nz-2))

  do i=1,nz
     n=(amp(i)-ave)/rms
!     n=(amp(i)-ave)/0.33
     if(n.lt.0) n=0
     if(n.gt.6) n=6
     line(i)=mark(n)
  enddo
  write(89,1010) jj,0.01*ave,0.01*rms,(line(i),i=1,nz)
1010 format(i3,2f6.1,1x,100a1)
  
  return
end subroutine zplot

subroutine lorentzian_fading(c,npts,fs,fspread)
!
! npts is the total length of the simulated data vector
!
  complex c(0:npts-1)
  complex cspread(0:npts-1)
  complex z

  twopi=8.0*atan(1.0)
  df=fs/npts
  nh=npts/2
  cspread(0)=1.0
  cspread(nh)=0.
  b=6.0
  do i=1,nh
     f=i*df
     x=b*f/fspread
     z=0.
     a=0.
     if(x.lt.3.0) then
        a=sqrt(1.111/(1.0+x*x)-0.1)
        phi1=twopi*rran()
        z=a*cmplx(cos(phi1),sin(phi1))
     endif
     cspread(i)=z
     z=0.
     if(x.lt.3.0) then
        phi2=twopi*rran()
        z=a*cmplx(cos(phi2),sin(phi2))
     endif
     cspread(npts-i)=z
  enddo

  call four2a(cspread,npts,1,1,1)

  s=sum(abs(cspread)**2)
  avep=s/npts
  fac=sqrt(1.0/avep)
  cspread=fac*cspread
  c=cspread*c
   
  return
end subroutine lorentzian_fading

subroutine rms_augapvar(nutc,lowrms)

  use jt65_mod6, only : dd

  logical lowrms,baddatavar

  rms1=sqrt(dot_product(dd(100000:100099),dd(100000:100099))/100.0)
  rms2=sqrt(dot_product(dd(200000:200099),dd(200000:200099))/100.0)
  rms3=sqrt(dot_product(dd(300000:300099),dd(300000:300099))/100.0)
  rms4=sqrt(dot_product(dd(400000:400099),dd(400000:400099))/100.0)
  rms5=sqrt(dot_product(dd(500000:500099),dd(500000:500099))/100.0)
  rms=(rms1+rms2+rms3+rms4+rms5)/5.0
  if(rms.lt.2.0) then
     write(*,1016) nutc,'input signal low rms','d'
1016 format(i4.4,2x,a20,19x,a1)
     call flush(6)
     lowrms=.true.
     return
  endif

  if(baddatavar()) then
     write(*,1017) nutc,'audio gap detected','d'
1017 format(i4.4,2x,a18,21x,a1)
     call flush(6)
	 
     j=0
     do i=1,490
        sq=0.
        do n=1,1200,60
           j=j+60
           x=dd(j)
           sq=sq + abs(x)
        enddo
        if(sq.lt.1.0) then
           dd(j)=1.0; dd(j-600)=1.0
        endif
     enddo
  endif

  return
end subroutine rms_augapvar

! LDPC (174,91) code
parameter (KK=91)                     !Information bits (77 + CRC14)
parameter (ND=58)                     !Data symbols
parameter (NS=21)                     !Sync symbols (3 @ Costas 7x7)
parameter (NN=NS+ND)                  !Total channel symbols (79)
parameter (NSPS=1920)                 !Samples per symbol at 12000 S/s
parameter (NZ=NSPS*NN)                !Samples in full 15 s waveform (151,680)
parameter (NMAX=15*12000)             !Samples in iwave (180,000)
parameter (NFFT1=2*NSPS, NH1=NFFT1/2) !Length of FFTs for symbol spectra
parameter (NSTEP=NSPS/4)              !Rough time-sync step size
parameter (NHSYM=NMAX/NSTEP-3)        !Number of symbol spectra (1/4-sym steps)
parameter (NDOWN=60)                  !Downsample factor

module sec0_mod
  use sec_midn_mod
  implicit none
contains

  subroutine sec0(mode, t)
    integer, intent(in) :: mode
    real, intent(out) :: t
    real, save :: t0 = 0.0

    if (mode == 1) then
       t0 = sec_midn()
       t = t0
    else
       t = sec_midn() - t0
    end if
  end subroutine sec0

end module sec0_mod

module graycode65_mod
  implicit none

  ! Fortran-only interface to igray
  interface
    integer function igray(n, idir)
      integer, intent(in) :: n, idir
    end function igray
  end interface

contains

  subroutine graycode65(dat, n, idir)
    integer, intent(in)    :: n, idir
    integer, intent(inout) :: dat(n)
    integer :: i

    do i = 1, n
       dat(i) = igray(dat(i), idir)
    enddo
  end subroutine graycode65

end module graycode65_mod

subroutine deg2grid(dlong0,dlat,grid)

  real dlong                        !West longitude (deg)
  real dlat                         !Latitude (deg)
  character grid*6

  dlong=dlong0
  if(dlong.lt.-180.0) dlong=dlong+360.0
  if(dlong.gt.180.0) dlong=dlong-360.0

! Convert to units of 5 min of longitude, working east from 180 deg.
  nlong=int(60.0*(180.0-dlong)/5.0)
  n1=nlong/240                      !20-degree field
  n2=(nlong-240*n1)/24              !2 degree square
  n3=nlong-240*n1-24*n2             !5 minute subsquare
  grid(1:1)=char(ichar('A')+n1)
  grid(3:3)=char(ichar('0')+n2)
  grid(5:5)=char(ichar('a')+n3)

! Convert to units of 2.5 min of latitude, working north from -90 deg.
  nlat=int(60.0*(dlat+90)/2.5)
  n1=nlat/240                       !10-degree field
  n2=(nlat-240*n1)/24               !1 degree square
  n3=nlat-240*n1-24*n2              !2.5 minuts subsquare
  grid(2:2)=char(ichar('A')+n1)
  grid(4:4)=char(ichar('0')+n2)
  grid(6:6)=char(ichar('a')+n3)

  return
end subroutine deg2grid

subroutine foldspec9f(s1,nq,jz,ja,jb,s2)

! Fold symbol spectra (quarter-symbol steps) from s1 into s2

  real s1(nq,jz)
  real s2(240,340)                       !340 = 4*85
  integer nsum(340)

  s2=0.
  nsum=0

  do j=ja,jb
     k=mod(j-1,340)+1
     nsum(k)=nsum(k)+1
     do i=1,NQ
        s2(i,k)=s2(i,k) + s1(i,j)
     enddo
  enddo

  do k=1,340
     fac=1.0
     if(nsum(k).gt.0) fac=1.0/nsum(k)
     s2(1:nq,k)=fac*s2(1:nq,k)
  enddo

  ave=sum(s2)/(340.0*nq)
  if(ave.gt.0.0) s2=s2/ave

  return
end subroutine foldspec9f

subroutine decode1a(dd,newdat,f0,nflip,mode65,nfsample,xpol,            &
     mycall,hiscall,hisgrid,neme,ndepth,nqd,dphi,ndphi,                 &
     nutc,nkhz,ndf,ipol,ntol,sync2,a,dt,pol,nkv,nhist,nsum,nsave,       &
     qual,decoded)

! Apply AFC corrections to a candidate JT65 signal, then decode it.

  use timer_module, only: timer
  parameter (NMAX=60*96000)          !Samples per 60 s
  real*4  dd(4,NMAX)                 !92 MB: raw data from Linrad timf2
  complex cx(NMAX/64), cy(NMAX/64)   !Data at 1378.125 samples/s
  complex c5x(NMAX/256),c5y(NMAX/256) !Data at 344.53125 Hz
  complex c5a(512)
  complex z
  real s2(66,126)
  real s3(64,63),sy(63)
  real a(5)
  logical first,xpol
  character decoded*22
  character mycall*12,hiscall*12,hisgrid*6
  data first/.true./,jjjmin/1000/,jjjmax/-1000/
  data nutc0/-999/,nhz0/-9999999/
  save

! Mix sync tone to baseband, low-pass filter, downsample to 1378.125 Hz
  dt00=dt
  call timer('filbig  ',0)
  call filbig(dd,NMAX,f0,newdat,nfsample,xpol,cx,cy,n5)
! NB: cx, cy have sample rate 96000*77125/5376000 = 1378.125 Hz
  call timer('filbig  ',1)
  if(mode65.eq.0) goto 900
  sqa=0.
  sqb=0.
  do i=1,n5
     sqa=sqa + real(cx(i))**2 + aimag(cx(i))**2
     if(xpol) sqb=sqb + real(cy(i))**2 + aimag(cy(i))**2
  enddo
  sqa=sqa/n5
  sqb=sqb/n5

! Find best DF, f1, f2, DT, and pol.  Start by downsampling to 344.53125 Hz
  if(xpol) then
     z=cmplx(cos(dphi),sin(dphi))
     cy(:n5)=z*cy(:n5)                !Adjust for cable length difference
  endif
! Add some zeros at start of c5 arrays -- empirical fix for negative DT's
  nadd=1089
  c5x(:nadd)=0.
  call fil6521(cx,n5,c5x(nadd+1),n6)
  if(xpol) then
     c5y(:nadd)=0.
     call fil6521(cy,n5,c5y(nadd+1),n6)
  endif
  n6=n6+nadd

  fsample=1378.125/4.
  a(5)=dt00
  i0=nint((a(5)+0.5)*fsample) - 2 + nadd
  if(i0.lt.1) then
     write(13,*) 'i0 too small in decode1a:',i0,f0
     flush(13)
     i0=1
  endif
  nz=n6+1-i0

! We're looking only at sync tone here... so why not downsample by another
! factor of 1/8, say?  Should be a significant execution speed-up.
! Best fit for DF, f1, f2, pol
  call afc65b(c5x(i0),c5y(i0),nz,fsample,nflip,ipol,xpol,ndphi,a,ccfbest,dtbest)

  pol=a(4)/57.2957795
  aa=cos(pol)
  bb=sin(pol)
  sq0=aa*aa*sqa + bb*bb*sqb
  sync2=3.7*ccfbest/sq0

! Apply AFC corrections to the time-domain signal
! Now we are back to using the 1378.125 Hz sample rate, enough to 
! accommodate the full JT65C bandwidth.

  call twkfreq_xy(cx,cy,n5,a)

! Compute spectrum at best polarization for each half symbol.
! Adding or subtracting a small number (e.g., 5) to j may make it decode.\
! NB: might want to try computing full-symbol spectra (nfft=512, even for
! submodes B and C).

  nsym=126
  nfft=512
  j=(dt00+dtbest+2.685)*1378.125
  if(j.lt.0) j=0


! Perhaps should try full-symbol-length FFTs even in B, C sub-modes?
! (Tried this, found no significant difference in decodes.)

  do k=1,nsym
!         do n=1,mode65
     do n=1,1
        do i=1,nfft
           j=min(j+1,NMAX/64)
           c5a(i)=aa*cx(j) + bb*cy(j)
        enddo
        call four2a(c5a,nfft,1,1,1)
        if(n.eq.1) then
           do i=1,66
!                  s2(i,k)=real(c5a(i))**2 + aimag(c5a(i))**2
              jj=i
              if(mode65.eq.2) jj=2*i-1
              if(mode65.eq.4) jj=4*i-3
              s2(i,k)=real(c5a(jj))**2 + aimag(c5a(jj))**2
           enddo
        else
           do i=1,66
              s2(i,k)=s2(i,k) + real(c5a(i))**2 + aimag(c5a(i))**2
           enddo
        endif
     enddo
  enddo

  flip=nflip
  call timer('dec65b  ',0)
  call decode65b(s2,flip,mycall,hiscall,hisgrid,mode65,neme,ndepth,    &
       nqd,nkv,nhist,qual,decoded,s3,sy)
  dt=dt00 + dtbest + 1.7
  call timer('dec65b  ',1)

  if(nqd.eq.1 .and. decoded.eq.'                      ') then
     nhz=1000*nkhz + ndf
     ihzdiff=min(500,ntol)
     if(nutc.ne.nutc0 .or. abs(nhz-nhz0).ge.ihzdiff) syncbest=0.
     if(sync2.gt.0.99999*syncbest) then
        nsave=nsave+1
        nsave=mod(nsave-1,64)+1
        npol=nint(57.296*pol)

        call s3avg(nsave,mode65,nutc,nhz,xdt,npol,ntol,s3,nsum,nkv,decoded)
        syncbest=sync2
        nhz0=nhz
     endif
     nutc0=nutc
  endif

900 return
end subroutine decode1a

subroutine clockit(dname,k)

! Times procedure number n between a call with k=0 (tstart) and with
! k=1 (tstop). Accumulates sums of these times in array ut (user time).
! Also traces all calls (for debugging purposes) if limtrace.gt.0

  character*8 dname,name(50),space,ename
  character*16 sname
  character*512 data_dir,fname
  logical first,on(50)
  real ut(50),ut0(50),dut(50),tt(2)
  integer ncall(50),nlevel(50),nparent(50)
  integer onlevel(0:10)
  data first/.true./,eps/0.000001/,ntrace/0/
  data level/0/,nmax/0/,space/'        '/
  data limtrace/0/,lu/29/,ntimer/1/
!  data limtrace/1000000/,lu/29/,ntimer/1/
  save

  if(ntimer.eq.0) return
  if(lu.lt.1) lu=6
  if(k.gt.1) go to 40                        !Check for "all done" (k>1)
  onlevel(0)=0

  do n=1,nmax                                !Check for existing name
     if(name(n).eq.dname) go to 20
  enddo

  nmax=nmax+1                                !This is a new one
  n=nmax
  ncall(n)=0
  on(n)=.false.
  ut(n)=eps
  name(n)=dname

20 if(k.eq.0) then                                !Get start times (k=0)
     if(on(n)) print*,'Error in timer: ',dname,' already on.'
     level=level+1                                !Increment the level
     on(n)=.true.
     ut0(n)=etime(tt)
     ncall(n)=ncall(n)+1
     if(ncall(n).gt.1.and.nlevel(n).ne.level) then
        nlevel(n)=-1
     else
        nlevel(n)=level
     endif
     nparent(n)=onlevel(level-1)
     onlevel(level)=n

  else if(k.eq.1) then        !Get stop times and accumulate sums. (k=1)
     if(on(n)) then
        on(n)=.false.
        ut1=etime(tt)
        ut(n)=ut(n)+ut1-ut0(n)
     endif
     level=level-1
  endif

  ntrace=ntrace+1
  if(ntrace.lt.limtrace) write(28,1020) ntrace,dname,k,level,nparent(n)
1020 format(i8,': ',a8,3i5)
  return

! Write out the timer statistics

40 open(lu,file=trim(fname),status='unknown')
  write(lu,1040)
1040 format(/'     name                 time  frac     dtime',       &
             ' dfrac  calls level parent'/73('-'))

  if(k.gt.100) then
     ndiv=k-100
     do i=1,nmax
        ncall(i)=ncall(i)/ndiv
        ut(i)=ut(i)/ndiv
     enddo
  endif

  total=ut(1)
  sum=0.
  sumf=0.
  do i=1,nmax
     dut(i)=ut(i)
     do j=i,nmax
        if(nparent(j).eq.i) dut(i)=dut(i)-ut(j)
     enddo
     utf=ut(i)/total
     dutf=dut(i)/total
     sum=sum+dut(i)
     sumf=sumf+dutf
     kk=nlevel(i)
     sname=space(1:kk)//name(i)//space(1:8-kk)
     ename=space
     if(i.ge.2) ename=name(nparent(i))
     write(lu,1060) float(i),sname,ut(i),utf,dut(i),dutf,           &
          ncall(i),nlevel(i),ename
1060 format(f4.0,a16,2(f10.2,f6.2),i7,i5,2x,a8)
  enddo

  write(lu,1070) sum,sumf
1070 format(/36x,f10.2,f6.2)
  close(lu)
  return

  entry clockit2(data_dir)
  l1=index(data_dir,char(0))-1
  if(l1.ge.1) data_dir(l1+1:l1+1)='/'
  fname=data_dir(1:l1+1)//'clockit.out'
  return
  
end subroutine clockit

subroutine gen_ft4wave(itone,nsym,nsps,fsample,f0,cwave,wave,icmplx,nwave)

  real wave(nwave)
  complex cwave(nwave)
  real pulse(6912)              !576*4*3
  real dphi(0:250000-1)
  integer itone(nsym)
  logical first
  data first/.true./
  save pulse,first,twopi,dt,hmod

  if(first) then
     twopi=8.0*atan(1.0)
     dt=1.0/fsample
     hmod=1.0
! Compute the smoothed frequency-deviation pulse
     do i=1,3*nsps
        tt=(i-1.5*nsps)/real(nsps)
        pulse(i)=gfsk_pulse(1.0,tt)
     enddo
     first=.false.
  endif

! Compute the smoothed frequency waveform.
! Length = (nsym+2)*nsps samples, zero-padded
  dphi_peak=twopi*hmod/real(nsps)
  dphi=0.0 
  do j=1,nsym         
     ib=(j-1)*nsps
     ie=ib+3*nsps-1
     dphi(ib:ie) = dphi(ib:ie) + dphi_peak*pulse(1:3*nsps)*itone(j)
  enddo

! Calculate and insert the audio waveform
  phi=0.0
  dphi = dphi + twopi*f0*dt                          !Shift frequency up by f0
  wave=0.
  if(icmplx.eq.1) cwave=0.
  k=0
  do j=0,(nsym+2)*nsps-1
     k=k+1
     if(icmplx.eq.0) then
        wave(k)=sin(phi)
     else
        cwave(k)=cmplx(cos(phi),sin(phi))
     endif
     phi=mod(phi+dphi(j),twopi)
  enddo

! Compute the ramp-up and ramp-down symbols
  if(icmplx.eq.0) then
     wave(1:nsps)=wave(1:nsps) *                                          &
          (1.0-cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
     k1=(nsym+1)*nsps+1
     wave(k1:k1+nsps-1)=wave(k1:k1+nsps-1) *                              &
          (1.0+cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
  else
     cwave(1:nsps)=cwave(1:nsps) *                                          &
          (1.0-cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
     k1=(nsym+1)*nsps+1
     cwave(k1:k1+nsps-1)=cwave(k1:k1+nsps-1) *                              &
          (1.0+cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
  endif

  return
end subroutine gen_ft4wave

module trimlist_mod
  implicit none
contains
  subroutine trimlist(sig,km,ftol,indx,nsiz,nz)
    use indexx_mod
    implicit none
  
    integer, parameter :: MAXMSG=1000             !Size of decoded message list
    real, intent(in) :: sig(MAXMSG,30)
    integer, intent(in) :: km
    real, intent(in) :: ftol
    integer, intent(out) :: indx(MAXMSG)
    integer, intent(out) :: nsiz(MAXMSG)
    integer, intent(out) :: nz
    
    integer :: n, i0, i, j0, j
  
  !    1      2     3    4    5    6     7     8
  !  nfile  nutc  freq  snr  dt  ipol  flip  sync
  
    call indexx(sig(1,3),km,indx)            !Sort list by frequency
  
    n=1
    i0=1
    do i=2,km         
       j0=indx(i-1)
       j=indx(i)
       if(sig(j,3)-sig(j0,3).gt.ftol) then
          nsiz(n)=i-i0
          i0=i
          n=n+1
       endif
    enddo
    nz=n
    nsiz(nz)=km+1-i0
    nsiz(nz+1)=-1
  
  end subroutine trimlist
end module trimlist_mod

real*8 function determ(array,norder)
  implicit real*8 (a-h,o-z)
  real*8 array(10,10)

  determ=1.
  do k=1,norder
     if (array(k,k).ne.0) go to 41
     do j=k,norder
        if(array(k,j).ne.0) go to 31
     enddo
     determ=0.
     go to 60

31   do i=k,norder
        s8=array(i,j)
        array(i,j)=array(i,k)
        array(i,k)=s8
     enddo
     determ=-1.*determ
41   determ=determ*array(k,k)
     if(k.lt.norder) then
        k1=k+1
        do i=k1,norder
           do j=k1,norder
              array(i,j)=array(i,j)-array(i,k)*array(k,j)/array(k,k)
           enddo
        enddo
     end if
  enddo

60 return
end function determ

subroutine avecho(id2,ndop,nfrit,nauto,navg,nqual,f1,xlevel,snrdb,   &
     db_err,dfreq,width,bDiskData)

  integer TXLENGTH
  parameter (TXLENGTH=27648)           !27*1024
  parameter (NFFT=32768,NH=NFFT/2)
  parameter (NZ=4096)
  integer*2 id2(34560)                 !Buffer for Rx data
  real sa(NZ)      !Avg spectrum relative to initial Doppler echo freq
  real sb(NZ)      !Avg spectrum with Dither and changing Doppler removed
  real, dimension (:,:), allocatable :: sax
  real, dimension (:,:), allocatable :: sbx
  integer nsum       !Number of integrations
  real dop0          !Doppler shift for initial integration (Hz)
  real dop           !Doppler shift for current integration (Hz)
  real s(8192)
  real x(NFFT)
  integer ipkv(1)
  logical ex
  logical*1 bDiskData
  complex c(0:NH)
  equivalence (x,c),(ipk,ipkv)
  common/echocom/nclearave,nsum,blue(NZ),red(NZ)
  common/echocom2/fspread_self,fspread_dx
  data navg0/-1/
  save dop0,navg0,sax,sbx

  if(navg.ne.navg0) then
     if(allocated(sax)) deallocate(sax)
     if(allocated(sbx)) deallocate(sbx)
     allocate(sax(1:navg,1:NZ))
     allocate(sbx(1:navg,1:NZ))
     nsum=0
     navg0=navg
  endif
  
  fspread=fspread_dx                !### Use the predicted Doppler spread ###
  if(bDiskData) fspread=width
  if(nauto.eq.1) fspread=fspread_self
  inquire(file='fspread.txt',exist=ex)
  if(ex) then
     open(39,file='fspread.txt',status='old')
     read(39,*) fspread
     close(39)
  endif
  fspread=min(max(0.04,fspread),700.0)
  width=fspread
  dop=ndop
  sq=0.
  do i=1,TXLENGTH
     x(i)=id2(i)
     sq=sq + x(i)*x(i)
  enddo
  xlevel=10.0*log10(sq/TXLENGTH)

  if(nclearave.ne.0) nsum=0
  if(nsum.eq.0) then
     dop0=dop                             !Remember the initial Doppler
     sax=0.                               !Clear the average arrays
     sbx=0.
  endif

  x(TXLENGTH+1:)=0.
  x=x/TXLENGTH
  call four2a(x,NFFT,1,-1,0)
  df=12000.0/NFFT
  do i=1,8192                             !Get spectrum 0 - 3 kHz
     s(i)=real(c(i))**2 + aimag(c(i))**2
  enddo

  fnominal=1500.0           !Nominal audio frequency w/o doppler or dither
  ia=nint((fnominal+dop0-nfrit)/df)
  ib=nint((f1+dop-nfrit)/df)
  if(ia.lt.2048 .or. ib.lt.2048 .or. ia.gt.6144 .or. ib.gt.6144) then
     snrdb=0.
     db_err=0.
     dfreq=0.
     go to 900
  endif

  nsum=nsum+1
  j=mod(nsum-1,navg)+1
  do i=1,NZ
     sax(j,i)=s(ia+i-2048)    !Center at initial doppler freq
     sbx(j,i)=s(ib+i-2048)    !Center at expected echo freq
     sa(i)=sum(sax(1:navg,i))
     sb(i)=sum(sbx(1:navg,i))
  enddo
  
  call echo_snr(sa,sb,fspread,blue,red,snrdb,db_err,dfreq,snr_detect)
  nqual=snr_detect-2
  if(nqual.lt.0) nqual=0
  if(nqual.gt.10) nqual=10

! Scale for plotting
  redmax=maxval(red)
  fac=10.0/max(redmax,10.0)
  blue=fac*blue
  red=fac*red
  nsmo=max(0.0,0.25*width/df)
  do i=1,nsmo
     call smo121(red,NZ)
     call smo121(blue,NZ)
  enddo

  ia=50.0/df
  ib=250.0/df
  call pctile(red(ia:ib),ib-ia+1,50,bred1)
  call pctile(blue(ia:ib),ib-ia+1,50,bblue1)
  ia=1250.0/df
  ib=1450.0/df
  call pctile(red(ia:ib),ib-ia+1,50,bred2)
  call pctile(blue(ia:ib),ib-ia+1,50,bblue2)

  red=red-0.5*(bred1+bred2)
  blue=blue-0.5*(bblue1+bblue2)

900 call sleep_msec(10)   !Avoid the "blue Decode button" syndrome
  return
end subroutine avecho

module wideband_sync

  type candidate
     real :: snr          !Relative S/N of sync detection
     real :: f            !Freq of sync tone, 0 to 96000 Hz
     real :: xdt          !DT of matching sync pattern, -1.0 to +4.0 s
     real :: pol          !Polarization angle, degrees
     integer :: ipol      !Polarization angle, 1 to 4 ==> 0, 45, 90, 135 deg
     integer :: iflip     !Sync type: JT65 = +/- 1, Q65 = 0
     integer :: indx
  end type candidate
  type sync_dat
     real :: ccfmax
     real :: xdt
     real :: pol
     integer :: ipol
     integer :: iflip
     logical :: birdie
  end type sync_dat

  parameter (NFFT=32768)
  parameter (MAX_CANDIDATES=50)
  parameter (SNR1_THRESHOLD=4.5)
  type(sync_dat) :: sync(NFFT)
  integer nkhz_center

  contains

subroutine get_candidates(ss,savg,xpol,jz,nfa,nfb,nts_jt65,nts_q65,cand,ncand)

! Search symbol spectra ss() over frequency range nfa to nfb (in kHz) for
! JT65 and Q65 sync patterns. The nts_* variables are the submode tone
! spacings: 1 2 4 8 16 for A B C D E.  Birdies are detected and
! excised.  Candidates are returned in the structure array cand().

  parameter (MAX_PEAKS=100)
  real ss(4,322,NFFT),savg(4,NFFT)
  real pavg(-20:20)
  integer indx(NFFT)
  logical xpol,skip,ldecoded
  type(candidate) :: cand(MAX_CANDIDATES)
  common/early/nhsym1,nhsym2,ldecoded(32768)

  call wb_sync(ss,savg,xpol,jz,nfa,nfb)          !Output to sync() array

  tstep=2048.0/11025.0        !0.185760 s: 0.5*tsym_jt65, 0.3096*tsym_q65
  df3=96000.0/NFFT
  ia=nint(1000*nfa/df3) + 1
  ib=nint(1000*nfb/df3) + 1
  if(ia.lt.1) ia=1
  if(ib.gt.NFFT-1) ib=NFFT-1
  iz=ib-ia+1
  
  call indexx(sync(ia:ib)%ccfmax,iz,indx)   !Sort by relative snr

  k=0
  do i=1,MAX_PEAKS
     n=indx(iz+1-i) + ia - 1
     f0=0.001*(n-1)*df3
     snr1=sync(n)%ccfmax
     if(snr1.lt.SNR1_THRESHOLD) exit
     flip=sync(n)%iflip
     if(flip.ne.0.0 .and. nts_jt65.eq.0) cycle
     if(flip.eq.0.0 .and. nts_q65.eq.0) cycle
     if(sync(n)%birdie) cycle

! Test for signal outside of TxT range and set bw for this signal type   
     j1=(sync(n)%xdt + 1.0)/tstep - 1.0
     j2=(sync(n)%xdt + 52.0)/tstep + 1.0
     if(flip.ne.0) j2=(sync(n)%xdt + 47.811)/tstep + 1.0
     ipol=sync(n)%ipol
     pavg=0.
     do j=1,j1
        pavg=pavg + ss(ipol,j,n-20:n+20)
     enddo
     do j=j2,jz
        pavg=pavg + ss(ipol,j,n-20:n+20)
     enddo
     jsum=j1 + (jz-j2+1)
     pmax=maxval(pavg(-2:2))              !### Why not just pavg(0) ?
     base=(sum(pavg)-pmax)/jsum
     pmax=pmax/base
     if(pmax.gt.5.0) cycle
     skip=.false.
     do m=1,k                              !Skip false syncs within signal bw
        diffhz=1000.0*(f0-cand(m)%f)
        bw=nts_q65*110.0
        if(cand(m)%iflip.ne.0) bw=nts_jt65*178.0
        if(diffhz.gt.-0.03*bw .and. diffhz.lt.1.03*bw) skip=.true.
     enddo
     if(skip) cycle
     k=k+1
     cand(k)%snr=snr1
     cand(k)%f=f0
     cand(k)%xdt=sync(n)%xdt
     cand(k)%pol=sync(n)%pol
     cand(k)%ipol=sync(n)%ipol
     cand(k)%iflip=nint(flip)
     cand(k)%indx=n
!     write(50,3050) i,k,m,f0+32.0,diffhz,bw,snr1,db(snr1)
!3050 format(3i5,f8.3,2f8.0,2f8.2)
     if(k.ge.MAX_CANDIDATES) exit
  enddo
  ncand=k

  return
end subroutine get_candidates

subroutine wb_sync(ss,savg,xpol,jz,nfa,nfb)

! Compute "orange sync curve" using the Q65 sync pattern

  use timer_module, only: timer
  parameter (NFFT=32768)
  parameter (LAGMAX=30)
  real ss(4,322,NFFT)
  real savg(4,NFFT)
  real savg_med(4)
  real ccf4(4),ccf4best(4),a(3)
  logical first,xpol
  integer isync(22)
  integer jsync0(63),jsync1(63)
  integer ip(1)

! Q65 sync symbols
  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/
  data jsync0/                                                         &
       1,  4,  5,  9, 10, 11, 12, 13, 14, 16, 18, 22, 24, 25, 28, 32,  &
       33, 34, 37, 38, 39, 40, 42, 43, 45, 46, 47, 48, 52, 53, 55, 57, &
       59, 60, 63, 64, 66, 68, 70, 73, 80, 81, 89, 90, 92, 95, 97, 98, &
       100,102,104,107,108,111,114,119,120,121,122,123,124,125,126/
  data jsync1/                                                         &
       2,  3,  6,  7,  8, 15, 17, 19, 20, 21, 23, 26, 27, 29, 30, 31,  &
       35, 36, 41, 44, 49, 50, 51, 54, 56, 58, 61, 62, 65, 67, 69, 71, &
       72, 74, 75, 76, 77, 78, 79, 82, 83, 84, 85, 86, 87, 88, 91, 93, &
       94, 96, 99,101,103,105,106,109,110,112,113,115,116,117,118/
  data first/.true./
  save first,isync,jsync0,jsync1

  tstep=2048.0/11025.0        !0.185760 s: 0.5*tsym_jt65, 0.3096*tsym_q65
  if(first) then
     fac=0.6/tstep
     do i=1,22                                !Expand the Q65 sync stride
        isync(i)=nint((isync(i)-1)*fac) + 1
     enddo
     do i=1,63
        jsync0(i)=2*(jsync0(i)-1) + 1
        jsync1(i)=2*(jsync1(i)-1) + 1
     enddo
     first=.false.
  endif

  df3=96000.0/NFFT
  ia=nint(1000*nfa/df3) + 1          !Flat frequency range for WSE converters
  ib=nint(1000*nfb/df3) + 1
  if(ia.lt.1) ia=1
  if(ib.gt.NFFT-1) ib=NFFT-1
  npol=1
  if(xpol) npol=4

  do i=1,npol
     call pctile(savg(i,ia:ib),ib-ia+1,50,savg_med(i))
  enddo
!  do i=ia,ib
!     write(14,3014) 0.001*(i-1)*df3,savg(1:npol,i)
!3014 format(5f10.3)
!  enddo

  lagbest=0
  ipolbest=1
  flip=0.

  do i=ia,ib
     ccfmax=0.
     do lag=0,LAGMAX

        ccf=0.
        ccf4=0.
        do j=1,22                        !Test for Q65 sync
           k=isync(j) + lag
           ccf4(1:npol)=ccf4(1:npol) + ss(1:npol,k,i+1) +       &
                ss(1:npol,k+1,i+1) + ss(1:npol,k+2,i+1) 
        enddo
        ccf4(1:npol)=ccf4(1:npol) - savg(1:npol,i+1)*3*22/float(jz)
        ccf=maxval(ccf4)
        ip=maxloc(ccf4)
        ipol=ip(1)
        if(ccf.gt.ccfmax) then
           ipolbest=ipol
           lagbest=lag
           ccfmax=ccf
           ccf4best=ccf4
           flip=0.
        endif

        ccf=0.
        ccf4=0.
        do j=1,63                       !Test for JT65 sync, std msg
           k=jsync0(j) + lag
           ccf4(1:npol)=ccf4(1:npol) + ss(1:npol,k,i+1) + ss(1:npol,k+1,i+1)
        enddo
        ccf4(1:npol)=ccf4(1:npol) - savg(1:npol,i+1)*2*63/float(jz)
        ccf=maxval(ccf4)
        ip=maxloc(ccf4)
        ipol=ip(1)
        if(ccf.gt.ccfmax) then
           ipolbest=ipol
           lagbest=lag
           ccfmax=ccf
           ccf4best=ccf4
           flip=1.0
        endif

        ccf=0.
        ccf4=0.
        do j=1,63                       !Test for JT65 sync, OOO msg
           k=jsync1(j) + lag
           ccf4(1:npol)=ccf4(1:npol) + ss(1:npol,k,i+1) + ss(1:npol,k+1,i+1)
        enddo
        ccf4(1:npol)=ccf4(1:npol) - savg(1:npol,i+1)*2*63/float(jz)
        ccf=maxval(ccf4)
        ip=maxloc(ccf4)
        ipol=ip(1)
        if(ccf.gt.ccfmax) then
           ipolbest=ipol
           lagbest=lag
           ccfmax=ccf
           ccf4best=ccf4
           flip=-1.0
        endif

     enddo  ! lag

     poldeg=0.
     if(xpol .and. ccfmax.ge.SNR1_THRESHOLD) then
        call polfit(ccf4best,4,a)
        poldeg=a(3)
     endif
     sync(i)%ccfmax=ccfmax
     sync(i)%xdt=lagbest*tstep-1.0
     sync(i)%pol=poldeg
     sync(i)%ipol=ipolbest
     sync(i)%iflip=flip
     sync(i)%birdie=.false.
     if(ccfmax/(savg(ipolbest,i)/savg_med(ipolbest)).lt.3.0) sync(i)%birdie=.true.
!     if(sync(i)%iflip.eq.0 .and. sync(i)%ccfmax .gt. 20.0) then
!        write(50,3050) i,lagbest,sync(i)%ccfmax,sync(i)%xdt,sync(i)%ipol,  &
!             sync(i)%birdie,ccf4best
!3050    format(2i5,f10.3,f8.2,i5,1x,L3,4f7.1)
!     endif

  enddo  ! i (frequency bin)

  call pctile(sync(ia:ib)%ccfmax,ib-ia+1,50,base)
  sync(ia:ib)%ccfmax=sync(ia:ib)%ccfmax/base

  bw=65*4*1.66666667                        !Q65-60C bandwidth
  nbw=bw/df3 + 1                            !Number of bins to blank
  syncmin=2.0
  nguard=10
  do i=ia,ib
     if(sync(i)%ccfmax.lt.syncmin) cycle
     spk=maxval(sync(i:i+nbw)%ccfmax)
     ip =maxloc(sync(i:i+nbw)%ccfmax)
     i0=ip(1)+i-1
     ja=min(i,i0-nguard)
     jb=i0+nbw+nguard
     sync(ja:jb)%ccfmax=0.
     sync(i0)%ccfmax=spk
  enddo

!  do i=ia,ib
!     write(15,3015) 0.001*(i-1)*df3+32.0,sync(i)%ccfmax,sync(i)%xdt,  &
!          sync(i)%ipol,sync(i)%iflip,sync(i)%birdie
!3015 format(3f10.3,2i6,L5)
!  enddo

  return
end subroutine wb_sync

end module wideband_sync

subroutine lorentzian(y,npts,a)

! Input:  y(npts); assume x(i)=i, i=1,npts
! Output: a(1:5)
!         a(1) = baseline
!         a(2) = amplitude
!         a(3) = x0
!         a(4) = width
!         a(5) = chisqr

  real y(npts)
  real a(5)
  real deltaa(4)

  a=0.
  df=12000.0/8192.0                               !df = 1.465 Hz
  width=0.
  ipk=0
  ymax=-1.e30
  do i=1,npts
     if(y(i).gt.ymax) then
        ymax=y(i)
        ipk=i
     endif
!     write(50,3001) i,i*df,y(i)
!3001 format(i6,2f12.3)
  enddo
!  base=(sum(y(ipk-149:ipk-50)) + sum(y(ipk+51:ipk+150)))/200.0
  base=(sum(y(1:20)) + sum(y(npts-19:npts)))/40.0
  stest=ymax - 0.5*(ymax-base)
  ssum=y(ipk)
  do i=1,50
     if(ipk+i.gt.npts) exit
     if(y(ipk+i).lt.stest) exit
     ssum=ssum + y(ipk+i)
  enddo
  do i=1,50
     if(ipk-i.lt.1) exit
     if(y(ipk-i).lt.stest) exit
     ssum=ssum + y(ipk-i)
  enddo
  ww=ssum/y(ipk)
  width=2
  t=ww*ww - 5.67
  if(t.gt.0.0) width=sqrt(t)
  a(1)=base
  a(2)=ymax-base
  a(3)=ipk
  a(4)=width

! Now find Lorentzian parameters

  deltaa(1)=0.1
  deltaa(2)=0.1
  deltaa(3)=1.0
  deltaa(4)=1.0
  nterms=4

!  Start the iteration
  chisqr=0.
  chisqr0=1.e6
  do iter=1,5
     do j=1,nterms
        chisq1=fchisq0(y,npts,a)
        fn=0.
        delta=deltaa(j)
10      a(j)=a(j)+delta
        chisq2=fchisq0(y,npts,a)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      fn=fn+1.0
        a(j)=a(j)+delta
        chisq3=fchisq0(y,npts,a)
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
        deltaa(j)=deltaa(j)*fn/3.
!          write(*,4000) iter,j,a,chisq2
!4000      format(i1,i2,4f10.4,f11.3)
     enddo
     chisqr=fchisq0(y,npts,a)
!       write(*,4000) 0,0,a,chisqr
     if(chisqr/chisqr0.gt.0.99) exit
     chisqr0=chisqr
  enddo
  a(5)=chisqr

  return
end subroutine lorentzian

subroutine ps4(dat,nfft,s)

  parameter (NMAX=2520+2)
  parameter (NHMAX=NMAX/2-1)
  real dat(nfft)
  real dat2(NMAX)
  real s(NHMAX)
  complex c(0:NMAX)
  equivalence(dat2,c)

  nh=nfft/2
  do i=1,nh
     dat2(i)=dat(i)/128.0       !### Why 128 ??
  enddo
  do i=nh+1,nfft
     dat2(i)=0.
  enddo

  call four2a(c,nfft,1,-1,0)

  fac=1.0/nfft
  do i=1,nh
     s(i)=fac*(real(c(i))**2 + aimag(c(i))**2)
  enddo

  return
end subroutine ps4

program ldpcsim240_74

! End-to-end test of the (240,74)/crc24 encoder and decoders.

   use packjt77

   parameter(N=240, NN=120)
   character*8 arg
   character*37 msg0,msgsent,msg
   character*77 c77
   character*24 c24
   integer*1 msgbits(101)
   integer*1 apmask(240)
   integer*1 cw(240)
   integer*1 codeword(N),message74(74)
   integer ncrc24
   integer modtype, graymap(0:3)
   integer*4 itone(120)
   integer channeltype
   integer lmax(1)
   real rxdata(N)
   real llr(240)
   real bitmetrics(2*NN,4)
   complex c1(4,8),c2(16,4),c4(256,2),cs(0:3,NN)
   real s2(0:65535)
   logical one(0:65535,0:15)    ! 65536 8-symbol sequences, 16 bits
   logical first
   data first/.true./
   data graymap/0,1,3,2/

   nargs=iargc()
   if(nargs.ne.7 .and. nargs.ne.8) then
      print*,'Usage: ldpcsim       maxosd norder #trials    s  Keff  modtype  channel '
      print*,'e.g.   ldpcsim240_74   2      4     1000    0.85  50      1        0'
      print*,'s    : if negative, then value is ignored and sigma is calculated from SNR.'
      print*,'maxosd<0: do bp only'
      print*,'maxosd=0: do bp and then call osd once with channel llrs.'
      print*,'maxosd>0: do bp and then call osc maxosd times with saved bp outputs.'
      print*,'norder  : osd decoding depth'
      print*,'Keff    : # of message bits, Keff must be in the range 50:74'
      print*,'modtype : 0 coherent BPSK, 1 4FSK'
      print*,'channel : 0 AWGN, 1 Rayleigh (4FSK only)'
      print*,'WSPR-format message is optional'
      return
   endif
   call getarg(1,arg)
   read(arg,*) maxosd
   call getarg(2,arg)
   read(arg,*) norder
   call getarg(3,arg)
   read(arg,*) ntrials
   call getarg(4,arg)
   read(arg,*) s
   call getarg(5,arg)
   read(arg,*) Keff
   call getarg(6,arg)
   read(arg,*) modtype
   call getarg(7,arg)
   read(arg,*) channeltype
   call getarg(8,arg)

   msg0='K9AN EN50 20                       '
   call pack77(msg0,i3,n3,c77)

   rate=real(Keff)/real(N)

   write(*,*) "code rate: ",rate
   write(*,*) "maxosd   : ",maxosd
   write(*,*) "norder   : ",norder
   write(*,*) "s        : ",s
   write(*,*) "K        : ",Keff
   if(modtype.eq.0) write(*,*) "modtype  : coherent BPSK"
   if(modtype.eq.1) write(*,*) "modtype  : noncoherent 4FSK"
   if(channeltype.eq.0) write(*,*) "channel  : AWGN"
   if(channeltype.eq.1) write(*,*) "channel  : Rayleigh"

   msgbits=0
   read(c77,'(50i1)') msgbits(1:50)
   write(*,*) 'message'
   write(*,'(50i1)') msgbits(1:50)

   call get_crc24(msgbits,74,ncrc24)
   write(c24,'(b24.24)') ncrc24
   read(c24,'(24i1)') msgbits(51:74)
   write(*,'(24i1)') msgbits(51:74)
   write(*,*) 'message with crc24'
   write(*,'(74i1)') msgbits(1:74)

   call encode240_74(msgbits(1:74),codeword)
   do i=1,120
     is=codeword(2*i)+2*codeword(2*i-1)
     itone(i)=graymap(is) 
   enddo

   write(*,*) 'codeword'
   write(*,'(77i1,1x,24i1,1x,73i1)') codeword

!   call init_random_seed()
!   call sgran()

   one=.false.
   do i=0,65535
      do j=0,15
         if(iand(i,2**j).ne.0) one(i,j)=.true.
      enddo
   enddo

   write(*,*) "Eb/N0    Es/N0   ngood  nundetected   symbol error rate"
   do idb = 24,-8,-1
      db=idb/2.0-1.0
      sigma=1/sqrt( 2*rate*iq*(10**(db/10.0)) )  ! to make db represent Eb/No
!  sigma=1/sqrt( 2*(10**(db/10.0)) )        ! db represents Es/No
      ngood=0
      nue=0
      nberr=0
      nsymerr=0

      do itrial=1, ntrials
! Create a realization of a noisy received word
         if(modtype.eq.0) then
            iq = 1 ! bits per symbol
            sigma=1/sqrt( 2*rate*iq*(10**(db/10.0)) )  ! to make db represent Eb/No
            do i=1,N
               rxdata(i) = 2.0*codeword(i)-1.0 + sigma*gran()
            enddo
            nerr=0
            do i=1,N
               if( rxdata(i)*(2*codeword(i)-1.0) .lt. 0 ) nerr=nerr+1
            enddo
            nberr=nberr+nerr

            rxav=sum(rxdata)/N
            rx2av=sum(rxdata*rxdata)/N
            rxsig=sqrt(rx2av-rxav*rxav)
            rxdata=rxdata/rxsig
            if( s .lt. 0 ) then
               ss=sigma
            else
               ss=s
            endif

            llr=2.0*rxdata/(ss*ss)
         else
! noncoherent MFSK
            iq = 2 ! bits per symbol
            sigma=1/sqrt( 2*rate*iq*(10**(db/10.0)) )  ! to make db represent Eb/No
            A=1
            do i=1,120
               do j=0,3
                  if(j.eq.itone(i)) then
                     if(channeltype.eq.0) then
                        A=1.0
                     elseif(channeltype.eq.1) then
                        xI=gran()**2+gran()**2
                        A=sqrt(xI/2)
                     endif
                     cs(j,i)= A + sigma*gran() + cmplx(0,1)*sigma*gran()
                  elseif(j.ne.itone(i)) then
                     cs(j,i)=     sigma*gran() + cmplx(0,1)*sigma*gran()
                  endif
               enddo
               lmax=maxloc(abs(cs(:,i)))
               if(lmax(1)-1.ne.itone(i) ) nsymerr=nsymerr+1
            enddo

            do k=1,NN,8

               do m=1,8  ! do 4 1-symbol correlations for each of 8 symbs
                  s2=0
                  do is=1,4
                     c1(is,m)=cs(graymap(is-1),k+m-1)
                     s2(is-1)=abs(c1(is,m))
                  enddo
                  ipt=(k-1)*2+2*(m-1)+1
                  do ib=0,1
                     bm=maxval(s2(0:3),one(0:3,1-ib)) - &
                        maxval(s2(0:3),.not.one(0:3,1-ib))
                     if(ipt+ib.gt.2*NN) cycle
                     bitmetrics(ipt+ib,1)=bm
                  enddo
               enddo

               do m=1,4  ! do 16 2-symbol correlations for each of 4 2-symbol groups
                  s2=0
                  do i=1,4
                     do j=1,4
                        is=(i-1)*4+j
                        c2(is,m)=c1(i,2*m-1)+c1(j,2*m)
                        s2(is-1)=abs(c2(is,m))**2
                     enddo
                  enddo
                  ipt=(k-1)*2+4*(m-1)+1
                  do ib=0,3
                     bm=maxval(s2(0:15),one(0:15,3-ib)) - &
                        maxval(s2(0:15),.not.one(0:15,3-ib))
                     if(ipt+ib.gt.2*NN) cycle
                     bitmetrics(ipt+ib,2)=bm
                  enddo
               enddo

               do m=1,2 ! do 256 4-symbol corrs for each of 2 4-symbol groups
                  s2=0
                  do i=1,16
                     do j=1,16
                        is=(i-1)*16+j
                        c4(is,m)=c2(i,2*m-1)+c2(j,2*m)
                        s2(is-1)=abs(c4(is,m))
                     enddo
                  enddo
                  ipt=(k-1)*2+8*(m-1)+1
                  do ib=0,7
                     bm=maxval(s2(0:255),one(0:255,7-ib)) - &
                        maxval(s2(0:255),.not.one(0:255,7-ib))
                     if(ipt+ib.gt.2*NN) cycle
                     bitmetrics(ipt+ib,3)=bm
                  enddo
               enddo

               s2=0 ! do 65536 8-symbol correlations for the entire group
               do i=1,256
                  do j=1,256
                     is=(i-1)*256+j
                     s2(is-1)=abs(c4(i,1)+c4(j,2))
                  enddo
               enddo
               ipt=(k-1)*2+1
               do ib=0,15
                  bm=maxval(s2(0:65535),one(0:65535,15-ib)) - &
                     maxval(s2(0:65535),.not.one(0:65535,15-ib))
                  if(ipt+ib.gt.2*NN) cycle
                  bitmetrics(ipt+ib,4)=bm
               enddo

            enddo

            call normalizebmet(bitmetrics(:,1),2*NN)
            call normalizebmet(bitmetrics(:,2),2*NN)
            call normalizebmet(bitmetrics(:,3),2*NN)
            call normalizebmet(bitmetrics(:,4),2*NN)

            scalefac=2.83
            bitmetrics=scalefac*bitmetrics

            llr=bitmetrics(:,1)
         endif

         apmask=0
         dmin=0.0
         call decode240_74(llr, Keff, maxosd, norder, apmask, message74, cw, ntype, nharderror, dmin)
         if(nharderror.ge.0) then
            n2err=0
            do i=1,N
               if( cw(i).ne.codeword(i) ) n2err=n2err+1
            enddo
            if(n2err.eq.0) then
               ngood=ngood+1
            else
               nue=nue+1
            endif
         endif
      enddo
!      snr2500=db+10*log10(200.0/116.0/2500.0)
      esn0=db+10*log10(rate*iq)
      pberr=real(nberr)/real(ntrials*N)
      pserr=real(nsymerr)/real(ntrials*120)
      write(*,"(f4.1,4x,f5.1,1x,i8,1x,i8,8x,e10.3)") db,esn0,ngood,nue,pserr

   enddo

end program ldpcsim240_74

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    fmeasure.f90
! Description:
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------
program fmeasure

  parameter(NZ=1000)
  implicit real*8 (a-h,o-z)
  character infile*50
  character line*80

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   fmeasure <infile>'
     print*,'Example: fmeasure fmtave.out'
     go to 999
  endif
  call getarg(1,infile)

  open(10,file=infile,status='old',err=997)
  open(11,file='fcal.out',status='old',err=998)
  open(12,file='fmeasure.out',status='unknown')

  read(11,*) a,b

  write(*,1000) 
  write(12,1000) 
1000 format('    Freq     DF     A+B*f     Corrected  Offset'/        &
            '   (MHz)    (Hz)    (Hz)        (MHz)      (Hz)'/        &
            '-----------------------------------------------')       
  i=0
  do j=1,9999
     read(10,1010,end=999) line
1010 format(a80)
     i0=index(line,' 0 ')
     if(i0.gt.0) then
        read(line,*,err=5) f,df
        dial_error=a + b*f
        fcor=f + 1.d-6*df - 1.d-6*dial_error
        offset_hz=1.d6*(fcor-f)
        write(*,1020)  f,df,dial_error,fcor,offset_hz
        write(12,1020) f,df,dial_error,fcor,offset_hz
1020    format(3f8.3,f15.9,f8.2)
     endif
5    continue
  enddo

  go to 999

997 print*,'Cannot open input file: ',infile
  go to 999
998 print*,'Cannot open fcal.out'

999 end program fmeasure

module iso_c_utilities

  use, intrinsic :: iso_c_binding, only: c_ptr, c_char, c_f_pointer, c_associated
  implicit none

  public :: c_to_f_string, c_f_dyn_string

  private

  character(c_char), dimension(1), save, target :: dummy_string = "?"

  interface        ! strlen is a standard C function from <string.h>
     ! int strlen(char *string)
     function strlen (string) result (len) bind (c, name="strlen")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_size_t
       implicit none
       type(c_ptr), value :: string
       integer(kind=c_size_t) :: len
     end function strlen

     ! void free(void * p)
     subroutine c_free (p) bind (c, name="free")
       use, intrinsic :: iso_c_binding, only: c_ptr
       implicit none
       type(c_ptr), value :: p
     end subroutine c_free
  end interface

contains

  !
  ! Cast C string pointer to Fortran string pointer
  !
  ! Warning! - C data must outlive result scope
  !
  function c_to_f_string (c_str) result (f_str)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_f_pointer, c_char
    implicit none
    type(c_ptr), intent(in) :: c_str
    character(kind=c_char, len=:), pointer :: f_str
    character(kind=c_char), pointer :: arr(:)
    interface        ! strlen is a standard C function from <string.h>
       ! int strlen(char *string)
       function strlen (string) result (len) bind (c, name="strlen")
         use, intrinsic :: iso_c_binding, only: c_ptr, c_size_t
         implicit none
         type(c_ptr), value :: string
         integer(kind=c_size_t) :: len
       end function strlen
    end interface
    call c_f_pointer (c_str, arr, [strlen (c_str)])
    call get_scalar_pointer (size (arr), arr, f_str)
  end function c_to_f_string

  subroutine get_scalar_pointer (scalar_len, scalar, fptr)
    ! Convert a null-terminated C string into a Fortran character pointer
    use, intrinsic :: iso_c_binding, only: c_char
    integer, intent(in) :: scalar_len
    character(kind=c_char, len=scalar_len), intent(in), target :: scalar(1)
    character(kind=c_char, len=:), pointer :: fptr
    fptr => scalar(1)
  end subroutine get_scalar_pointer

  function c_f_dyn_string (cptr) result (fstr)
    ! Convert a null-terminated malloc'ed C string into a Fortran character array
    type(c_ptr), intent(in) :: cptr ! The C address
    character(kind=c_char), allocatable :: fstr(:)
    character(kind=c_char), pointer :: fptr(:)
    interface        ! strlen is a standard C function from <string.h>
       ! void free(void * p)
       subroutine c_free (p) bind (c, name="free")
         use, intrinsic :: iso_c_binding, only: c_ptr
         implicit none
         type(c_ptr), value :: p
       end subroutine c_free
    end interface
    if (c_associated (cptr)) then
       call c_f_pointer (fptr=fptr, cptr=cptr, shape=[strlen(cptr)])
    else
       ! To avoid segfaults, associate FPTR with a dummy target:
       fptr => dummy_string
    end if
    fstr = fptr
    call c_free (cptr)
  end function c_f_dyn_string

end module

subroutine fast_decode(id2,narg,trperiod,line,mycall_12,   &
     hiscall_12)

  parameter (NMAX=30*12000)
  integer*2 id2(NMAX)
  integer*2 id2a(NMAX)
  integer*2 id2b(NMAX)
  integer narg(0:14)
  double precision trperiod
  real dat(30*12000)
  complex cdat(262145),cdat2(262145)
  logical pick,first
  character*6 cfile6
  character*80 line(100)
  character*12 mycall_12,hiscall_12
  character*6 mycall,hiscall
  data first/.true./,nutca/0/,nutcb/0/
  save npts,cdat,cdat2,id2a,id2b,nutca,nutcb

  if(first) then
     id2a=0
     id2b=0
     first=.false.
  endif

  mycall=mycall_12(1:6)
  hiscall=hiscall_12(1:6)
  nutc=narg(0)
  ndat0=narg(1)
  nsubmode=narg(2)
  newdat=narg(3)
  minsync=narg(4)
  npick=narg(5)
  t0=0.001*narg(6)
  t1=0.001*narg(7)
  tmid=0.5*(t0+t1)
  maxlines=narg(8)
  nmode=narg(9)
  nrxfreq=narg(10)
  ntol=narg(11)
  nhashcalls=narg(12)

  line(1:100)(1:1)=char(0)
  if(t0.gt.trperiod) go to 900
  if(t0.gt.t1) go to 900

  if(nmode.eq.102) then
     call fast9(id2,narg,line)
     go to 900
  endif

  if(newdat.eq.1) then
     cdat2=cdat
     ndat=ndat0
     call wav11(id2,ndat,dat)
     nzz=11025*int(trperiod)    !beware if fractional T/R period ever used here
     if(ndat.lt.nzz) dat(ndat+1:nzz)=0.0
     ndat=min(ndat,30*11025)
     call ana932(dat,ndat,cdat,npts)          !Make downsampled analytic signal
  endif

! Now cdat() is the downsampled analytic signal.  
! New sample rate = fsample = BW = 11025 * (9/32) = 3100.78125 Hz
! NB: npts, nsps, etc., are all reduced by 9/32

  write(cfile6,'(i6.6)') nutc
  nfreeze=1
  mousedf=0
  mousebutton=0
  mode4=1
  if(nsubmode.eq.1) mode4=2
  nafc=0
  ndebug=0
  t2=0.
  ia=1
  ib=npts
  pick=.false.

  if(npick.gt.0) then
     pick=.true.
     dt=1.0/11025.0 * (32.0/9.0)
     ia=t0/dt + 1.
     ib=t1/dt + 1.
     t2=t0
  endif
  jz=ib-ia+1
  line(1:100)(1:1)=char(0)

900 return
end subroutine fast_decode

program rtty_spec

! Generate simulated data for standard RTTY and WSJT-X modes FT8, FT4

  use wavhdr
  use packjt
  parameter (NMAX=15*12000)
  type(hdr) h
  complex cwave(NMAX)
  real wave(NMAX)
  real*4 dat(NMAX)             !Generated waveform
  integer*2 iwave(NMAX)        !Generated waveform
  integer itone(680)           !Channel symbols (values 0-1, 0-3, 0-7)
  integer*1 msgbits(77)
  character*37 msg37,msgsent37
  character*8 arg

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage:   rtty_spec <snr>'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) snrdb                  !S/N in dB (2500 hz reference BW)

  rmsdb=25.
  rms=10.0**(0.05*rmsdb)
  sig=10.0**(0.05*snrdb)
  npts=NMAX

  do i=1,NMAX                   !Generate gaussian noise
     dat(i)=gran()
  enddo

! Add the RTTY signal
  fsample=12000.0                   !Sample rate (Hz)
  dt=1.0/fsample                    !Sample interval (s)
  twopi=8.0*atan(1.0)
  phi=0.
  dphi=0.
  j0=-1
  do i=6001,NMAX-6000
     j=nint(i*dt/0.022)
     if(j.ne.j0) then
        f0=1415.0
        call random_number(rr)
        if(rr.gt.0.5) f0=1585.0
        dphi=twopi*f0*dt
        j0=j
     endif
     phi=phi+dphi
     if(phi.gt.twopi) phi=phi-twopi
     dat(i)=dat(i) + sig*sin(phi)
  enddo

! FT8 signal (FSK)
  i3=0
  n3=0
  msg37='WB9XYZ KA2ABC FN42'
  call genft8(msg37,i3,n3,msgsent37,msgbits,itone)
  nsym=79
  nsps=1920
  bt=99.0
  f0=3500.0
  icmplx=0
  nwave=nsym*nsps
  call gen_ft8wave(itone,nsym,nsps,bt,fsample,f0,cwave,wave,icmplx,nwave)
  dat(6001:6000+nwave)=dat(6001:6000+nwave) + sig*wave(1:nwave)

! FT8 signal (GFSK)
  i3=0
  n3=0
  msg37='WB9XYZ KA2ABC FN42'
  call genft8(msg37,i3,n3,msgsent37,msgbits,itone)
  nsym=79
  nsps=1920
  bt=2.0
  f0=4000.0
  icmplx=0
  nwave=nsym*nsps
  call gen_ft8wave(itone,nsym,nsps,bt,fsample,f0,cwave,wave,icmplx,nwave)
  dat(6001:6000+nwave)=dat(6001:6000+nwave) + sig*wave(1:nwave)

! Add the FT4 signal
  ichk=0
  call genft4(msg37,ichk,msgsent37,msgbits,itone)
  nsym=103
  nsps=576
  f0=4500.0
  icmplx=0
  nwave=(nsym+2)*nsps
  call gen_ft4wave(itone,nsym,nsps,fsample,f0,cwave,wave,icmplx,nwave)
  dat(6001:6000+nwave)=dat(6001:6000+nwave) + sig*wave(1:nwave)

  h=default_header(12000,NMAX)
  datmax=maxval(abs(dat))
  iwave=nint(32767.0*dat/datmax)
  open(10,file='000000_000001.wav',access='stream',status='unknown')
  write(10) h,iwave
  close(10)

999 end program rtty_spec

subroutine sync4(dat,jz,ntol,nfqso,mode,mode4,minwidth,dtx,dfx,snrx,    &
     snrsync,flip,width)

! Synchronizes JT4 data, finding the best-fit DT and DF.  

  parameter (NFFTMAX=2520)         !Max length of FFTs
  parameter (NHMAX=NFFTMAX/2)      !Max length of power spectra
  parameter (NSMAX=525)            !Max number of half-symbol steps
  integer ntol                     !Range of DF search
  real dat(jz)
  real s2(NHMAX,NSMAX)             !2d spectrum, stepped by half-symbols
  real ccfblue(-5:540)             !CCF with pseudorandom sequence
  real ccfred(NHMAX)               !Peak of ccfblue, as function of freq
  real red(NHMAX)                  !Peak of ccfblue, as function of freq
  integer ipk1(1)
  integer nch(7)
  logical savered
  equivalence (ipk1,ipk1a)
  data nch/1,2,4,9,18,36,72/
  save

! Do FFTs of twice symbol length, stepped by half symbols.  Note that 
! we have already downsampled the data by factor of 2.
  nsym=207
  nfft=2520
  nh=nfft/2
  nq=nfft/4
  nsteps=jz/nq - 1
  df=0.5*11025.0/nfft
  ftop=nfqso + 7*mode4*df
  if(ftop.gt.11025.0/4.0) then
     print*,'*** Rx Freq is set too high for this submode ***'
     go to 900
  endif

  if(mode.eq.-999) width=0.                        !Silence compiler warning

  do j=1,nsteps                     !Compute spectrum for each step, get average
     k=(j-1)*nq + 1
     call ps4(dat(k),nfft,s2(1,j))
  enddo

! Set freq and lag ranges
  ia=(nfqso-ntol)/df              !Index of lowest tone, bottom of search range
  ib=(nfqso+ntol)/df              !Index of lowest tone, top of search range
  iamin=nint(100.0/df)
  if(ia.lt.iamin) ia=iamin
  ibmax=nint(2700.0/df) - 6*mode4
  if(ib.gt.ibmax) ib=ibmax

  lag1=-5
  lag2=59
  syncbest=-1.e30
  snrx=-26.0
  ccfred=0.
  red=0.
  i0=nint(nfqso/df)

  do ich=minwidth,7                       !Find best width
     kz=nch(ich)/2
     savered=.false.
     iaa=ia+kz
     ibb=ib-kz
     do i=iaa,ibb                       !Find best frequency channel for CCF
        call xcor4(s2,i,nsteps,nsym,lag1,lag2,ich,mode4,ccfblue,ccf0,   &
             lagpk0,flip)
        ccfred(i)=ccf0
        
! Find rms of the CCF, without main peak
        call slope(ccfblue(lag1),lag2-lag1+1,lagpk0-lag1+1.0)
        sync=abs(ccfblue(lagpk0))
!        write(*,3000) ich,i,i*df,ccf0,sync,syncbest
!3000    format(2i5,4f12.3)

! Find best sync value
        if(sync.gt.syncbest*1.03) then
           ipk=i
           lagpk=lagpk0
           ichpk=ich
           syncbest=sync
           savered=.true.
        endif
     enddo
     if(savered) red=ccfred
  enddo
  if(syncbest.lt.-1.e29) go to 900
  ccfred=red
  call pctile(ccfred(ia:ib),ib-ia+1,45,base)
  ccfred=ccfred-base
  
  dfx=ipk*df

! Peak up in time, at best whole-channel frequency
  call xcor4(s2,ipk,nsteps,nsym,lag1,lag2,ichpk,mode4,ccfblue,ccfmax,   &
       lagpk,flip)
  xlag=lagpk
  if(lagpk.gt.lag1 .and. lagpk.lt.lag2) then
     call peakup(ccfblue(lagpk-1),ccfmax,ccfblue(lagpk+1),dx2)
     xlag=lagpk+dx2
  endif

! Find rms of the CCF, without the main peak
  call slope(ccfblue(lag1),lag2-lag1+1,xlag-lag1+1.0)
  sq=0.
  nsq=0
  do lag=lag1,lag2
     if(abs(lag-xlag).gt.2.0) then
        sq=sq+ccfblue(lag)**2
        nsq=nsq+1
     endif
  enddo
  rms=sqrt(sq/nsq)
  snrsync=max(0.0,db(abs(ccfblue(lagpk)/rms - 1.0)) - 4.5)
  dt=2.0/11025.0
  istart=xlag*nq
  dtx=istart*dt

  ipk1=maxloc(ccfred)
  ccf10=0.5*maxval(ccfred)
  do i=ipk1a,ia,-1
     if(ccfred(i).le.ccf10) exit
  enddo
  i1=i
  do i=ipk1a,ib
     if(ccfred(i).le.ccf10) exit
  enddo
  nw=i-i1
  width=nw*df

  sq=0.
  ns=0
  iaa=max(ipk1a-10*nw,ia)
  ibb=min(ipk1a+10*nw,ib)
  jmax=2*mode4/3
  do i=iaa,ibb
     j=abs(i-ipk1a)
     if(j.gt.nw .and. j.lt.jmax) then
        sq=sq + ccfred(j)*ccfred(j)
        ns=ns+1
     endif
  enddo
  rms=sqrt(sq/ns)
  snrx=10.0*log10(ccfred(ipk1a)/rms) - 41.2

900  return
end subroutine sync4

subroutine flat1(savg,iz,nsmo,syellow)

  real savg(iz)
  real syellow(iz)
  real x(8192)

  ia=nsmo/2 + 1
  ib=iz - nsmo/2 - 1
  nstep=20
  nh=nstep/2
  do i=ia,ib,nstep
     call pctile(savg(i-nsmo/2),nsmo,50,x(i))
     x(i-nh:i+nh-1)=x(i)
  enddo
  x(1:ia-1)=x(ia)
  x(ib+1:iz)=x(ib)

  x0=0.001*maxval(x(iz/10:(9*iz)/10))
  syellow(1:iz)=savg(1:iz)/(x(1:iz)+x0)

  return
end subroutine flat1

module noisegen_mod
  implicit none
contains
  subroutine noisegen(d4,nmax)
    use iso_c_binding, only: c_ptr, c_loc, c_float
    use gran_interface
    use iso_fortran_env, only: real32
    implicit none
  
    integer, intent(in) :: nmax
    real(real32), intent(out) :: d4(4,nmax)
    integer :: i
  
    do i=1,nmax
       d4(1,i)=gran()
       d4(2,i)=gran()
       d4(3,i)=gran()
       d4(4,i)=gran()
    enddo
  
  end subroutine noisegen
end module noisegen_mod

subroutine ft2_iwave(msg37,f0,snrdb,iwave)

! Generate waveform for experimental "FT2" mode 

  use packjt77
  include 'ft2_params.f90'               !Set various constants
  parameter (NWAVE=NN*NSPS)
  character msg37*37,msgsent37*37
  real wave(NWAVE),xnoise(NWAVE)
  integer itone(NN)
  integer*2 iwave(NWAVE)                 !Generated full-length waveform
  
  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  hmod=0.8                               !Modulation index (MSK=0.5, FSK=1.0)
  tt=NSPS*dt                             !Duration of symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  bw=1.5*baud                            !Occupied bandwidth (Hz)
  txt=NZ*dt                              !Transmission length (s)
  bandwidth_ratio=2500.0/(fs/2.0)
!  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
!  if(snrdb.gt.90.0) sig=1.0
  txt=NN*NSPS/12000.0

! Source-encode, then get itone():
  itype=1
  call genft2(msg37,0,msgsent37,itone,itype)

  k=0
  phi=0.0 
  sqsig=0.
  do j=1,NN                             !Generate real waveform
     dphi=twopi*(f0*dt+(hmod/2.0)*(2*itone(j)-1)/real(NSPS))
     do i=1,NSPS
        k=k+1
        wave(k)=sqrt(2.0)*sin(phi)      !Signal has rms = 1.0
        sqsig=sqsig + wave(k)**2
        phi=mod(phi+dphi,twopi)
     enddo
  enddo

  if(snrdb.gt.90.0) then
     iwave=nint((32767.0/sqrt(2.0))*wave)
     return
  endif
  
  sqnoise=1.e-30
  if(snrdb.lt.90) then
     do i=1,NWAVE                   !Add gaussian noise at specified SNR
        xnoise(i)=gran()            !Noise has rms = 1.0
     enddo
  endif
  xnoise=xnoise*sqrt(0.5*fs/2500.0)
  fac=30.0
  snr_amplitude=10.0**(0.05*snrdb)
  wave=fac*(snr_amplitude*wave + xnoise)
  datpk=maxval(abs(wave))
  print*,'A',snr_amplitude,datpk

  iwave=nint((30000.0/datpk)*wave)
  
  return
end subroutine ft2_iwave

subroutine chkfalse8var(msg37,i3,n3,nbadcrc,iaptype,lcall1hash)

  use ft8_mod1, only : mycall,hiscall,hisgrid4
  character msg37*37,decoded*22,callsign*12,calltmp*12,call_a*12,call_b*12,  &
       grid*12,callmask6*6
  character*6 mask6(3)
  integer, intent(in) :: i3,n3
  logical(1) falsedec,lchkcall,lgvalid,lwrongcall
  logical(1), intent(in) :: lcall1hash
  data mask6/'001000','101000','011000'/

  call_a=''
  call_b=''
! iaptype=0 non-AP decoder
! iaptype=1 CQ message AP decoder

! i3 n3                                      Bits               Total  Message type
! ---------------------------------------------------------------------------------------
! 0   0 FREE TEXT MSG                        71                   71
! 0   1 K1ABC RR73; W9XYZ <KH1/KH7Z> -12     28 28 10 5           71   DXpedition Mode
! 0   2 PA3XYZ/P R 590003 IO91NP             28 1 1 3 12 25       70   EU VHF contest (2)
! 0   2 PA3XYZ 520093 IO91NP                 28 1 1 3 12 25       70   EU VHF contest (2)
! 0   3 WA9XYZ KA1ABC R 16A EMA              28 28 1 4 3 7        71   ARRL Field Day
! 0   3 WA9XYZ KA1ABC 7D EMA                 28 28 1 4 3 7        71   ARRL Field Day
! 0   3 WA9XYZ G8ABC 1D DX                   28 28 1 4 3 7        71   ARRL Field Day
! 0   4 WA9XYZ KA1ABC R 32A EMA              28 28 1 4 3 7        71   ARRL Field Day
! 0   5 123456789ABCDEF012                   71                   71   Telemetry (18 hex)
! 0   5 7123456789ABCDEF01                   71                   71   Telemetry (18 hex)
! 0   5 71234567                             71                   71   Telemetry (18 hex)
! 0   5 81234567                             71                   71   Telemetry (18 hex)
! 0   5 8123456789ABCDEF01                   71                   71   Telemetry (18 hex)
! 1     WA9XYZ/R KA1ABC/R R FN42             28 1 28 1 1 15       74   Standard msg, with std or non std callsign
! 1     WA9XYZ KA1ABC R-11                   28 1 28 1 1 15       74   Standard msg, with std or non std callsign
! 1     CQ 039 P30KJE/R DR46
! 2     PA1XYZ/P GM4ABC/P R FN42             28 1 28 1 1 15       74   EU VHF Contest
! 2     CQ 039 P30KJE/P DR46
! 3     TU; W9XYZ K1ABC R 579 MA             1 28 28 1 3 13       74   ARRL RTTY contest
! 3     TU; W9XYZ G8ABC R 559 0013           1 28 28 1 3 13       74   ARRL RTTY (DX)
! 4     <WA9XYZ> PJ4/KA1ABC RR73             13 58 1 2            74   Nonstandard call
! 4     <WA9XYZ> PJ4/KA1ABC                  13 58 1 2            74   Nonstandard call
! 4     PJ4/KA1ABC <WA9XYZ> RRR              13 58 1 2            74   Nonstandard call
! 4     CQ ZW5STAYHOME                       13 58 1 2            74   Nonstandard call

! 'CQ 5NGX46MFKUE' 'CQ 53HDFKJEASD' 'CQ HDF53KJEASD'  i3=4 n3=1 
! -23  0.3 1482 ~ CQ EQ3YCI/KVNA  i3=4 n3=1 
! -23 -1.3 CQ P28Z58W/77M  i3=4 n3=1
  if(msg37(1:3).eq.'CQ ') then
     callsign=''
     ispc1=index(msg37,' ')
     ispc2=index(msg37((ispc1+1):),' ')+ispc1
     if(i3.eq.4) then
        islash=index(msg37,'/')
        if(islash.le.0) then
           callsign=trim(msg37(ispc1+1:))
           nlencall=len_trim(callsign)
           if(nlencall.lt.1) return
           ispccall=index(callsign,' ')
! CQ 9D6T0GA4 Z space inside callsign of any length: protocol violation, or last char is digit
           if(ispccall.lt.nlencall .or. callsign(nlencall:nlencall).lt.':') then
              go to 900
           endif
        else
           if(islash.gt.ispc1 .and. islash.lt.ispc2) then
              if(islash-ispc1.le.ispc2-islash) then
                 callsign=msg37(islash+1:ispc2-1)
              else
                 callsign=msg37(ispc1+1:islash-1)
              endif
           endif
        endif
        
        include 'callsign_q.f90'
        
        if(islash.gt.0) then
           falsedec=.false.
           call chkflscallvar('CQ          ',callsign,falsedec)
           if(falsedec) go to 900
        else
           nlen=len_trim(callsign)
           if(nlen.ge.10) then
              falsedec=.false.
              call chklong8(callsign,falsedec)
              if(falsedec) go to 900
           else if(nlen.eq.6 .and. index(callsign,'/').lt.1) then
! 'CQ VK6ZRW'  protocol violation, i3 for stdcall shall be equal to 1
              do i=1,6
                 if(callsign(i:i).gt.'/' .and. callsign(i:i).lt.':') then
                    callmask6(i:i)='1'
                 else
                    callmask6(i:i)='0'
                 endif
              enddo
 
              falsedec=.false.
              do i=1,3
                 if(callmask6.eq.mask6(i)) then
                    falsedec=.true.
                    exit
                 endif ! standard callsign, false decode
              enddo
              if(falsedec) go to 900
           endif
        endif

! i=1 AP mask iaptype 1 false decodes
! -23  0.9 2630 ~ CQ P5RXL MK92 *
! -24  0.3  550 ~ CQ DZ0BIL/R AD94 *
!  -7  0.2  400 ~ CQ LI9NAI/R CF97 * in some noisy setups such decodes possible with a high SNR

     else if(iaptype.eq.1) then
        ispc3=index(msg37((ispc2+1):),' ')+ispc2
        if(msg37(ispc2-2:ispc2-1).eq.'/R' .or.                               &
             msg37(ispc2-2:ispc2-1).eq.'/P') then
           callsign=msg37(ispc1+1:ispc2-3)
        else
           callsign=msg37(ispc1+1:ispc2-1)
        endif
        
        include 'callsign_q.f90'

        grid=''
        if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and.        &
             msg37(ispc2+1:ispc2+1).lt.'S' .and.                             &
             msg37(ispc2+2:ispc2+2).gt.'@' .and.                             &
             msg37(ispc2+2:ispc2+2).lt.'S' .and.                             &
             msg37(ispc2+3:ispc2+3).lt.':' .and.                             &
             msg37(ispc2+4:ispc2+4).lt.':') grid=msg37(ispc2+1:ispc3-1)
        if(len_trim(grid).eq.4) then
           call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
           if(lwrongcall .or. .not.lgvalid) go to 900
        endif
     endif

     if(i3.eq.4) then
! CQ Y09Q7/SS60M  i3=4 n3=1
        callsign=''
        callsign=trim(msg37(4:))
        islash=index(callsign,'/')
        islash2=index(callsign(islash+1:),'/')
        nlencall=len_trim(callsign)
        if(nlencall.eq.11 .and. islash.gt.0 .and. islash2.lt.1) then

           if(islash.lt.7) then
              if((callsign(islash+1:islash+1).lt.':' .and.                   &
                   callsign(islash+2:islash+2).lt.':') .or.                  &
                   callsign(islash+1:islash+1).eq.'Q' .or.                   &
                   callsign(nlencall:nlencall).lt.':') go to 900
           endif
           
           if(islash.gt.5) then
              if(callsign(islash-1:islash-1).lt.':' .or.                     &
                   (callsign(1:1).lt.':' .and. callsign(2:2).lt.':') .or.    &
                   callsign(1:1).eq.'Q') go to 900
           endif

           if(islash.gt.4 .and. islash.lt.8) then
              call_a=''
              call_b=''
              call_a=callsign(1:islash-1)
              call_b=callsign(islash+1:)
              falsedec=.false.
              call chkflscallvar(call_a,call_b,falsedec)
              if(falsedec) go to 900
           endif
        endif
     endif

! CQ 039 P30KJE/R DR46 i3=1 n3=5
! CQ 039 P30KJE/P DR46 i3=2 n3=5
     if(msg37(4:4).lt.':' .and. msg37(4:4).gt.'/' .and. msg37(7:7).eq.' '     &
          .and. (i3.eq.1 .or. i3.eq.2)) then
        islash=index(msg37,'/')
        if(islash.gt.10 .and. islash.lt.15) then
           callsign=''
           grid=''
           callsign=msg37(8:islash-1)
           grid=msg37(islash+3:islash+6)
           nlengrid=len_trim(grid)
           if(nlengrid.eq.4 .and. grid(1:1).gt.'@' .and. grid(4:4).lt.':') then
              call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
              if(lwrongcall .or. .not.lgvalid) go to 900
           endif
           falsedec=.false.
           call chkflscallvar('MYCALL      ',callsign,falsedec)
           if(falsedec) go to 900
        endif
     endif

! CQ CJ3OPE/R FP61 i3=1
! CQ KU3XIK NN41
     if(i3.eq.1 .and. iaptype.eq.0) then
        callsign=''
        grid=''
        islash=index(msg37,'/R ')
        if(islash.gt.6) then
           callsign=msg37(4:islash-1)
           grid=msg37(islash+3:islash+6)
        else if(islash.lt.1) then
           ispc1=index(msg37,' ')
           ispc2=index(msg37((ispc1+1):),' ')+ispc1
           ispc3=index(msg37((ispc2+1):),' ')+ispc2
           if(len_trim(msg37).eq.ispc3-1) then
              callsign=msg37(ispc1+1:ispc2-1)
              grid=msg37(ispc2+1:ispc3-1)
           else
              return ! 4-word message, will be processed in ft8bvar.f90
           endif
        endif
        nlengrid=len_trim(grid)
        if(nlengrid.eq.4 .and. grid(1:1).gt.'@' .and. grid(4:4).lt.':') then
           call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
           if(lwrongcall .or. .not.lgvalid) go to 900
        endif
        
        if(islash.gt.6) then
           falsedec=.false.
           call chkflscallvar('MYCALL      ',callsign,falsedec)
           if(falsedec) go to 900
        endif
     endif

     return ! prevent further checking if message starts from 'CQ '
! TO DO via patterns: '175715 -18 -0.1 2519 ~ CQ P2PSR6UWBHS'
  endif

  if(iaptype.eq.2) then ! message starts with user's callsign, 2nd callsign is random
! ES1JA JA1QZQ/R R GD47
! UA3ALE A70DDN/R OF23
! ES6DO NH4CXV MA87
! EA1AHY PW1BSL R GR47 i3=1
! ES6DO ST0VQA R174 invalid message, can not be transmitted
     
     ispc1=index(msg37,' ')
     ispc2=index(msg37((ispc1+1):),' ')+ispc1
     callsign=''
     grid=''
     callsign=msg37(ispc1+1:ispc2-1)
     islash=index(callsign,'/R')
     if(islash.gt.3) then
        calltmp='            '
        calltmp=callsign(1:islash-1)
        callsign=calltmp
     endif

     include 'callsign_q.f90'

     ispc3=index(msg37((ispc2+1):),' ')+ispc2
     indxr=index(msg37,' R ')
     if(indxr.gt.7) then
        ispc4=index(msg37((ispc3+1):),' ')+ispc3
        if(ispc4-ispc3.eq.5) then
           if(msg37(ispc3+1:ispc3+1).gt.'@' .and.                            &
                msg37(ispc3+1:ispc3+1).lt.'S' .and.                          &
                msg37(ispc3+2:ispc3+2).gt.'@' .and.                          &
                msg37(ispc3+2:ispc3+2).lt.'S' .and.                          &
                msg37(ispc3+3:ispc3+3).lt.':' .and.                          &
                msg37(ispc3+4:ispc3+4).lt.':') then
              grid=msg37(ispc3+1:ispc4-1)
           else ! invalid message
              go to 900
           endif
        endif
     else if(indxr.lt.1) then
        if(ispc3-ispc2.eq.5) then
           if(msg37(ispc2+1:ispc2+1).gt.'@' .and.                            &
                msg37(ispc2+1:ispc2+1).lt.'S' .and.                          &
                msg37(ispc2+2:ispc2+2).gt.'@' .and.                          &
                msg37(ispc2+2:ispc2+2).lt.'S' .and.                          &
                msg37(ispc2+3:ispc2+3).lt.':' .and.                          &
                msg37(ispc2+4:ispc2+4).lt.':') then
              grid=msg37(ispc2+1:ispc3-1)
           else ! invalid message
              go to 900
           endif
        endif
     endif
     if(len_trim(grid).eq.4) then
        call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
        if(lwrongcall .or. .not.lgvalid) go to 900
     endif

    return ! no need in other checks
  endif

  if(iaptype.eq.40) then ! AP mask '<mycall> ??? ???'
! JH4PUL/3 BG4NSA RQ43 * reported false decodes
! JH4PUL/3 M06FLK R AE10 * at least it is possible to transmit the message
     ispc1=index(msg37,' ')
     ispc2=index(msg37((ispc1+1):),' ')+ispc1
     callsign=''
     grid=''
     callsign=msg37(ispc1+1:ispc2-1)

     include 'callsign_q.f90'

     ispc3=index(msg37((ispc2+1):),' ')+ispc2
     indxr=index(msg37,' R ')
     if(indxr.gt.7) then
        ispc4=index(msg37((ispc3+1):),' ')+ispc3
        if(ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc3+1).gt.'@' .and.        &
             msg37(ispc3+1:ispc3+1).lt.'S' .and.                             &
             msg37(ispc3+2:ispc3+2).gt.'@' .and.                             &
             msg37(ispc3+2:ispc3+2).lt.'S' .and.                             &
             msg37(ispc3+3:ispc3+3).lt.':' .and.                             &
             msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
     else if(indxr.lt.1) then
        if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and.        &
             msg37(ispc2+1:ispc2+1).lt.'S' .and.                             &
             msg37(ispc2+2:ispc2+2).gt.'@' .and.                             &
             msg37(ispc2+2:ispc2+2).lt.'S' .and.                             &
             msg37(ispc2+3:ispc2+3).lt.':' .and.                                 &
             msg37(ispc2+4:ispc2+4).lt.':') grid=msg37(ispc2+1:ispc3-1)
     endif

     if(len_trim(grid).eq.4) then
        call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
        if(lwrongcall .or. .not.lgvalid) go to 900
     endif
     return ! no need in other checks for iaptype 40
  endif

! RV6ARZ CX7CO R NI25 ! mycall hiscall ??? AP mask false decode, both callsigns are correct, checking for valid grid
! ES6DO TK60CNES R MJ79 ! non standard DXCall, iaptype 11
! UA0ZZZ AA1AAA/1 R GC45 ! non standard DXCall, iaptype 11
! JH4PUL/3 HB9CEX R PN76 * ! non standard mycall, iaptype 41
! JH4PUL/3 JT1DN HB30 * ! non standard mycall, iaptype 41

  if(iaptype.eq.3 .or. iaptype.eq.11 .or. iaptype.eq.21 .or. iaptype.eq.41) then
     indxr=index(msg37,' R ')
     if(iaptype.eq.21 .and. indxr.gt.0) go to 900 ! invalid message in Hound mode
     islash1=index(msg37,'/')
     ispc1=index(msg37,' ')
     ispc2=index(msg37((ispc1+1):),' ')+ispc1
     if(ispc1.gt.3 .and. ispc2.gt.7) then
        if(islash1.lt.ispc1 .or. (islash1.eq.ispc2-2 .and.                   &
             msg37(ispc2-1:ispc2-1).lt.':' )) then ! AA1AAA/1 can be first or 2nd callsign
           if(msg37(1:ispc1-1).eq.mycall .and.                               &
                msg37(ispc1+1:ispc2-1).eq.hiscall) then
              ispc3=index(msg37((ispc2+1):),' ')+ispc2
              grid=''
              if(indxr.gt.7) then
                 ispc4=index(msg37((ispc3+1):),' ')+ispc3
                 if(ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc3+1).gt.'@'     &
                      .and. msg37(ispc3+1:ispc3+1).lt.'S' .and.              &
                      msg37(ispc3+2:ispc3+2).gt.'@' .and.                    &
                      msg37(ispc3+2:ispc3+2).lt.'S' .and.                    &
                      msg37(ispc3+3:ispc3+3).lt.':' .and.                    &
                      msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
              else if(indxr.lt.1) then
                 if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@'     &
                      .and. msg37(ispc2+1:ispc2+1).lt.'S' .and.              &
                      msg37(ispc2+2:ispc2+2).gt.'@' .and.                    &
                      msg37(ispc2+2:ispc2+2).lt.'S' .and.                    &
                      msg37(ispc2+3:ispc2+3).lt.':' .and.                    &
                      msg37(ispc2+4:ispc2+4).lt.':') grid=msg37(ispc2+1:ispc3-1)
              endif

              if(len_trim(grid).eq.4 .and. grid.ne.hisgrid4) then
                 ! correctly decoded contest message
                 if(iaptype.eq.21) then
                    if(grid.eq.'RR73') then
                       ! AP mask 'mybcall hisbcall ???' can trigger RR73 message
                       return 
                    else
                       go to 900
                    endif
                 endif
                 call chkgridvar(hiscall,grid,lchkcall,lgvalid,lwrongcall)
                 if(grid.eq.'RR73') then
                    lgvalid = .true.
                 else 
                    if(.not.lgvalid) go to 900
                 endif
              endif
           endif
        endif
     endif
     return ! no need in other checks
  endif

  if((i3.ge.1 .and. i3.le.3) .and. (index(msg37,' R ').gt.0 .or.             &
       index(msg37,'/R ').gt.0 .or. index(msg37,'/P ').gt.0)) then

! i3=1: 'VF5RMP/P OW3ATG/P R MF' '378YYA/R 9H5PQU R OL53'
! i3=2: 'YT4MEY/P WL8QEW R IR03'
! i3=1: 'ER2XXD 8L7UWC R 529 26'			   
! i3=3 n3=1: '1M8JSH TI0CZQ R 539 42'
! i3=2 n3=5: 'DQ2VF/P J2OON KG37'
! 'N40RTH AD2WPI/R MG62'

     islash1=index(msg37,'/')
     call_a=''
     call_b=''
     ispc1=index(msg37,' ')
     ispc2=index(msg37((ispc1+1):),' ')+ispc1
     if(islash1.lt.1 .and. ispc1.gt.3 .and. ispc2.gt.7) then
        call_a=msg37(1:ispc1-1)
        call_b=msg37(ispc1+1:ispc2-1)
        if(call_b.ne.hiscall) then
           include 'call_q.f90'
           falsedec=.false.
           call chkflscallvar(call_a,call_b,falsedec)
           if(falsedec) go to 900
        endif
     endif

     if(islash1.gt.0 .and. ispc1.gt.3 .and. ispc2.gt.7) then
        islash2=index(msg37((islash1+1):),'/')+islash1
        if(islash1.gt.ispc1) then
           call_a=msg37(1:ispc1-1)
           call_b=msg37(ispc1+1:islash1-1)
        else
           call_a=msg37(1:islash1-1)
           if(islash2.gt.islash1) then
              call_b=msg37(ispc1+1:islash2-1)
           else
              call_b=msg37(ispc1+1:ispc2-1)
           endif
        endif
        include 'call_q.f90'
        if(call_a.ne.mycall .and. call_b.ne.hiscall) then
           falsedec=.false.
           call chkflscallvar(call_a,call_b,falsedec)
           if(falsedec) go to 900
        endif
     endif
  endif

! i3=1 n3=4
! 000189 -23  0.4  300 ~ <...> QG6GFE CQ14
! 110015 -21 -0.0 2050 ~ <...> NF7OEX CP03
! check if grid is correct for call_2

  if(lcall1hash .and. i3.eq.1) then
     ! hash can be associated with a valid callsign in the table
     ispc1=index(msg37,' ')
     if(msg37(1:ispc1-1).ne.mycall) then
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        callsign=''
        grid=''
        callsign=msg37(ispc1+1:ispc2-1)
        islash=index(callsign,'/')
        if(islash.lt.1) then
           include 'callsign_q.f90'
           if(callsign.ne.hiscall) then
              ispc3=index(msg37((ispc2+1):),' ')+ispc2
              if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and.  &
                   msg37(ispc2+1:ispc2+1).lt.'S' .and.                       &
                   msg37(ispc2+2:ispc2+2).gt.'@' .and.                       &
                   msg37(ispc2+2:ispc2+2).lt.'S' .and.                       &
                   msg37(ispc2+3:ispc2+3).lt.':' .and.                       &
                   msg37(ispc2+4:ispc2+4).lt.':') then
                 grid=msg37(ispc2+1:ispc3-1)
                 call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
                 if(lwrongcall .or. .not.lgvalid) go to 900
              endif
           endif
        endif
     endif
  endif

! i3=1 n3=1 '4P6NPC 5M5UJG BK49'
! i3=3 n3=1 '8Z7TLB JQ0OTZ 589 02'
! i3=0 n3=3 'CE3NTP 4C2DWN 5E ONE'

  if(iaptype.ne.2) then
     if(((i3.eq.1 .or. i3.eq.3) .and. index(msg37,' R ').le.0 .and.          &
          index(msg37,'/').le.0) .or. (i3.eq.0 .and. n3.eq.3)) then
        if(msg37(1:2).eq.'<.') go to 2
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        if(ispc1.gt.3 .and. ispc2.gt.7) then
           call_a=msg37(1:ispc1-1)
           if(call_a.eq.mycall) go to 2 ! exception to incoming calls
           call_b=msg37(ispc1+1:ispc2-1)
           include 'call_q.f90'
           falsedec=.false.
           call chkflscallvar(call_a,call_b,falsedec)
           if(falsedec) go to 900
        endif
     endif
  endif

2 continue

  if(i3.eq.4) then
     ibrace1=index(msg37,'<.')
     if(index(msg37,'<.').gt.4) then
        callsign=''
        callsign=msg37(1:ibrace1-2)
        islash=index(callsign,'/')
        nlencall=len_trim(callsign)
        if(nlencall.lt.1) go to 4
        
! i3=4 n3=2 '6397X6JN637 <...> RRR' 
! 'R 5QCDOIY9 <...> RR73'
        if(index(trim(callsign),' ').gt.0 .or. (islash.lt.1 .and.            &
             callsign(nlencall:nlencall).lt.':')) go to 900
        include 'callsign_q.f90'
        falsedec=.false.
        call chklong8(callsign,falsedec)
        if(falsedec) go to 900
     endif
     if(msg37(1:2).eq.'<.' .or. index(msg37,'.>').gt.4) then
!'<...> 104J71MFOT9 RR73'
! i3=4 n3=0 '<...> /7ZZZZ/ /8'
! i3=4 n3=2 '<...> 6HGLDZ 5IN2 RRR'
        callsign=''
        nlenmsg=len_trim(msg37)
        if(msg37(1:2).eq.'<.') then
           if(msg37(nlenmsg-4:nlenmsg).eq.' RR73') then
              callsign=msg37(7:nlenmsg-5)
           else if(msg37(nlenmsg-2:nlenmsg).eq.' 73') then
              callsign=msg37(7:nlenmsg-3)
           else if(msg37(nlenmsg-3:nlenmsg).eq.' RRR') then
              callsign=msg37(7:nlenmsg-4)
           else
              callsign=msg37(7:nlenmsg)
           endif
        else
           ibracket=index(msg37,'<.')
           callsign=msg37(1:ibracket-2)
        endif
        nlencall=len_trim(callsign)
        if(nlencall.gt.0) then
           ispace=index(callsign(1:nlencall),' ')
           islash=index(callsign,'/')
           if(ispace.gt.0 .or. (islash.lt.1 .and.                         &
                callsign(nlencall:nlencall).lt.':') .or.                  &
                islash.eq.nlencall) go to 900

! KY2HTW/0O5M <...>  i3=4 n3=0
           if(islash.gt.4) then
              islash2=index(callsign(islash+1:),'/')
              if(nlencall.eq.11 .and. islash2.lt.1) then
                 if(islash.lt.7) then
                    if((callsign(islash+1:islash+1).lt.':' .and.          &
                         callsign(islash+2:islash+2).lt.':') .or.         &
                         callsign(islash+1:islash+1).eq.'Q' .or.          &
                         callsign(nlencall:nlencall).lt.':') go to 900
                 endif

                 if(islash.gt.5) then
                    if(callsign(islash-1:islash-1).lt.':' .or.            &
                         (callsign(1:1).lt.':' .and.callsign(2:2).lt.':') &
                         .or. callsign(1:1).eq.'Q') go to 900
                 endif
   
                 if(islash.gt.4 .and. islash.lt.8) then
                    call_a=''
                    call_b=''
                    call_a=callsign(1:islash-1)
                    call_b=callsign(islash+1:)
                    falsedec=.false.
                    call chkflscallvar(call_a,call_b,falsedec)
                    if(falsedec) go to 900
                 endif
              endif
           endif
           include 'callsign_q.f90'
           falsedec=.false.
           call chklong8(callsign,falsedec)
           if(falsedec) go to 900
        endif
     endif
! '<...> T99LMF GC41' need to understand how to check such message
  endif

4    continue

  if(i3.eq.3 .and. msg37(1:3).eq.'TU;') then 
!i3=3 n3=3 'TU; QV4UPP 632TGU 529'
     ispc1=index(msg37,' ')
     ispc2=index(msg37((ispc1+1):),' ')+ispc1 
     ispc3=index(msg37((ispc2+1):),' ')+ispc2
     if(ispc2.gt.7 .and. ispc3.gt.11) then
        call_a=msg37(ispc1+1:ispc2-1)
        call_b=msg37(ispc2+1:ispc3-1)
        include 'call_q.f90'
        falsedec=.false.
        call chkflscallvar(call_a,call_b,falsedec)
        if(falsedec) go to 900
     endif
  endif

  if(i3.eq.0 .and. n3.eq.0) then
! 'J/.ZM1R-D1Q89'
     if(index(msg37,'/.').gt.0) go to 900
     decoded=msg37(1:22)
     falsedec=.false.
     call filtersfreevar(decoded,falsedec)
     if(falsedec) go to 900
  endif

! CQ_RLXA 551626 ^J65XI 
  if(i3.eq.0 .and. (msg37(1:3).eq.'CQ_' .or. index(msg37,'^').gt.0)) go to 900
  go to 999
  
900 nbadcrc=1
  msg37=''

999 return
end subroutine chkfalse8var

module packjt
  implicit none 
  contains

subroutine packbits(dbits,nsymd,m0,sym)

 ! Pack 0s and 1s from dbits() into sym() with m0 bits per word.
 ! NB: nsymd is the number of packed output words.
   use iso_fortran_env, only: int8
   implicit none
   integer,   intent(in)  :: nsymd, m0
   integer(int8), intent(in)  :: dbits(:)
   integer,   intent(out) :: sym(:)

   integer :: i, j, k, m, n

   k = 0
   do i = 1, nsymd
      n = 0
      do j = 1, m0
         k = k + 1
         m = dbits(k)
         n = ior(ishft(n,1), m)
      end do
      sym(i) = n
   end do
end subroutine packbits


 subroutine unpackbits(sym,nsymd,m0,dbits)

 ! Unpack bits from sym() into dbits(), one bit per byte.
 ! NB: nsymd is the number of input words, and m0 their length.
 ! there will be m0*nsymd output bytes, each 0 or 1.
   use iso_fortran_env, only: int8
   implicit none
   integer,   intent(in)  :: sym(:)
   integer,   intent(in)  :: nsymd, m0
   integer(int8), intent(out) :: dbits(:)

   integer :: i, j, k, mask

   k = 0
   do i = 1, nsymd
      mask = ishft(1, m0 - 1)
      do j = 1, m0
         k = k + 1
         dbits(k) = 0
         if (iand(mask, sym(i)) .ne. 0) dbits(k) = 1
         mask = ishft(mask, -1)
      end do
   end do
end subroutine unpackbits

subroutine packcall(callsign, ncall, text)
   use nchar_mod 
   implicit none
   integer, parameter :: NBASE = 37*36*10*27*27*27

   character(len=6), intent(inout) :: callsign
   integer,     intent(out)   :: ncall
   logical,     intent(out)   :: text

   character(len=6) :: tmp
   character(len=1) :: c
   integer     :: i, nfreq
   integer     :: n1, n2, n3, n4, n5, n6

   text = .false.

   if (callsign(1:4) .eq. '3DA0') callsign = '3D0'//callsign(5:6)

   if (callsign(1:3) .eq. 'CQ ') then
      ncall = NBASE + 1
      if (callsign(4:4) .ge. '0' .and. callsign(4:4) .le. '9' .and. &
          callsign(5:5) .ge. '0' .and. callsign(5:5) .le. '9' .and. &
          callsign(6:6) .ge. '0' .and. callsign(6:6) .le. '9') then
         read(callsign(4:6),*) nfreq
         ncall = NBASE + 3 + nfreq
      end if
      return
   else if (callsign(1:4) .eq. 'QRZ ') then
      ncall = NBASE + 2
      return
   else if (callsign(1:3) .eq. 'DE ') then
      ncall = 267796945
      return
   end if

   tmp = '      '
   if (callsign(3:3) .ge. '0' .and. callsign(3:3) .le. '9') then
      tmp = callsign
   else if (callsign(2:2) .ge. '0' .and. callsign(2:2) .le. '9') then
      if (callsign(6:6) .ne. ' ') then
         text = .true.
         return
      end if
      tmp = ' '//callsign(:5)
   else
      text = .true.
      return
   end if

   do i = 1, 6
      c = tmp(i:i)
      if (c .ge. 'a' .and. c .le. 'z') &
         tmp(i:i) = char(ichar(c) - ichar('a') + ichar('A'))
   end do

   n1 = 0
   if ((tmp(1:1) .ge. 'A' .and. tmp(1:1) .le. 'Z') .or. tmp(1:1) .eq. ' ') n1 = 1
   if (tmp(1:1) .ge. '0' .and. tmp(1:1) .le. '9') n1 = 1
   n2 = 0
   if (tmp(2:2) .ge. 'A' .and. tmp(2:2) .le. 'Z') n2 = 1
   if (tmp(2:2) .ge. '0' .and. tmp(2:2) .le. '9') n2 = 1
   n3 = 0
   if (tmp(3:3) .ge. '0' .and. tmp(3:3) .le. '9') n3 = 1
   n4 = 0
   if ((tmp(4:4) .ge. 'A' .and. tmp(4:4) .le. 'Z') .or. tmp(4:4) .eq. ' ') n4 = 1
   n5 = 0
   if ((tmp(5:5) .ge. 'A' .and. tmp(5:5) .le. 'Z') .or. tmp(5:5) .eq. ' ') n5 = 1
   n6 = 0
   if ((tmp(6:6) .ge. 'A' .and. tmp(6:6) .le. 'Z') .or. tmp(6:6) .eq. ' ') n6 = 1

   if (n1 + n2 + n3 + n4 + n5 + n6 .ne. 6) then
      text = .true.
      return
   end if

   ncall = nchar(tmp(1:1))
   ncall = 36*ncall + nchar(tmp(2:2))
   ncall = 10*ncall + nchar(tmp(3:3))
   ncall = 27*ncall + nchar(tmp(4:4)) - 10
   ncall = 27*ncall + nchar(tmp(5:5)) - 10
   ncall = 27*ncall + nchar(tmp(6:6)) - 10
end subroutine packcall


subroutine unpackcall(ncall, word, iv2, psfx)
   implicit none
   integer,     intent(in)  :: ncall
   character(len=12), intent(out):: word
   integer,     intent(out) :: iv2
   character(len=4), intent(out) :: psfx

   integer :: n, i
   character(len=37) :: c

   integer, parameter :: NBASE = 37*36*10*27*27*27
   data c /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ '/

   word = '......'
   psfx = '    '

   if ((ncall < 0 .or. ncall >= 262177560) .and. ncall .ne. 262177561) then
      write(*,*) 'unpackcall: ncall out of range = ', ncall
   end if

   n    = ncall
   iv2 = 0

   if (n .ge. 262177560) go to 20

   word = '......'
   i = mod(n,27) + 11
   word(6:6) = c(i:i)
   n = n/27
   i = mod(n,27) + 11
   word(5:5) = c(i:i)
   n = n/27
   i = mod(n,27) + 11
   word(4:4) = c(i:i)
   n = n/27
   i = mod(n,10) + 1
   word(3:3) = c(i:i)
   n = n/10
   i = mod(n,36) + 1
   word(2:2) = c(i:i)
   n = n/36
   i = n + 1
   word(1:1) = c(i:i)
   do i = 1, 4
      if (word(i:i) .ne. ' ') go to 10
   end do
   go to 999
10 word = word(i:)
   go to 999

20 if (n .ge. 267796946) go to 999

   if ((n .ge. 262178563) .and. (n .le. 264002071)) then
      iv2 = 1
      n = n - 262178563
      i = mod(n,37) + 1
      psfx(4:4) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(3:3) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(2:2) = c(i:i)
      n = n/37
      i = n + 1
      psfx(1:1) = c(i:i)

   else if ((n .ge. 264002072) .and. (n .le. 265825580)) then
      iv2 = 2
      n = n - 264002072
      i = mod(n,37) + 1
      psfx(4:4) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(3:3) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(2:2) = c(i:i)
      n = n/37
      i = n + 1
      psfx(1:1) = c(i:i)

   else if ((n .ge. 265825581) .and. (n .le. 267649089)) then
      iv2 = 3
      n = n - 265825581
      i = mod(n,37) + 1
      psfx(4:4) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(3:3) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(2:2) = c(i:i)
      n = n/37
      i = n + 1
      psfx(1:1) = c(i:i)

   else if ((n .ge. 267649090) .and. (n .le. 267698374)) then
      iv2 = 4
      n = n - 267649090
      i = mod(n,37) + 1
      psfx(3:3) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(2:2) = c(i:i)
      n = n/37
      i = n + 1
      psfx(1:1) = c(i:i)

   else if ((n .ge. 267698375) .and. (n .le. 267747659)) then
      iv2 = 5
      n = n - 267698375
      i = mod(n,37) + 1
      psfx(3:3) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(2:2) = c(i:i)
      n = n/37
      i = n + 1
      psfx(1:1) = c(i:i)

   else if ((n .ge. 267747660) .and. (n .le. 267796944)) then
      iv2 = 6
      n = n - 267747660
      i = mod(n,37) + 1
      psfx(3:3) = c(i:i)
      n = n/37
      i = mod(n,37) + 1
      psfx(2:2) = c(i:i)
      n = n/37
      i = n + 1
      psfx(1:1) = c(i:i)

   else if (n .eq. 267796945) then
      iv2 = 7
      psfx = '    '
   end if

999 if (word(1:3) .eq. '3D0') word = '3DA0'//word(4:)
end subroutine unpackcall

 subroutine packgrid(grid,ng,text)
   use grid2deg_mod, only: grid2deg
   implicit none
   
   integer, parameter :: NGBASE=180*180
   character(len=4), intent(inout) :: grid   ! modified when mapping extended reports
   integer,     intent(out)   :: ng
   logical,     intent(out)   :: text

   integer      :: n, long, lat
   real         :: dlong, dlat
   character(len=1)  :: c1

   text=.false.
   if(grid.eq.'    ') go to 90               !Blank grid is OK

 ! First, handle signal reports in the original range, -01 to -30 dB
   if(grid(1:1).eq.'-') then
      read(grid(2:3),*,err=800,end=800) n
      if(n.ge.1 .and. n.le.30) then
         ng=NGBASE+1+n
         go to 900
      endif
      go to 10
   else if(grid(1:2).eq.'R-') then
      read(grid(3:4),*,err=800,end=800) n
      if(n.ge.1 .and. n.le.30) then
         ng=NGBASE+31+n
         go to 900
      endif
      go to 10
 ! Now check for RO, RRR, or 73 in the message field normally used for grid
   else if(grid(1:4).eq.'RO  ') then
      ng=NGBASE+62
      go to 900
   else if(grid(1:4).eq.'RRR ') then
      ng=NGBASE+63
      go to 900
   else if(grid(1:4).eq.'73  ') then
      ng=NGBASE+64
      go to 900
   endif

 ! Now check for extended-range signal reports: -50 to -31, and 0 to +49.
 10 n=99
   c1=grid(1:1)
   read(grid,*,err=20,end=20) n
   go to 30
 20 read(grid(2:4),*,err=30,end=30) n
 30 if(n.ge.-50 .and. n.le.49) then
      if(c1.eq.'R') then
         write(grid,1002) n+50
 1002    format('LA',i2.2)
      else
         write(grid,1003) n+50
 1003    format('KA',i2.2)
      endif
      go to 40
   endif

 ! Maybe it's free text ?
   if(grid(1:1).lt.'A' .or. grid(1:1).gt.'R') text=.true.
   if(grid(2:2).lt.'A' .or. grid(2:2).gt.'R') text=.true.
   if(grid(3:3).lt.'0' .or. grid(3:3).gt.'9') text=.true.
   if(grid(4:4).lt.'0' .or. grid(4:4).gt.'9') text=.true.
   if(text) go to 900

 ! OK, we have a properly formatted grid locator
 40 call grid2deg(grid//'mm',dlong,dlat)
   long=int(dlong)
   lat=int(dlat+ 90.0)
   ng=((long+180)/2)*180 + lat
   go to 900

 90 ng=NGBASE + 1
   go to 900

 800 text=.true.
 900 continue

   return
 end subroutine packgrid

 subroutine unpackgrid(ng, grid)

   use deg2grid_mod
   implicit none

   integer, parameter :: NGBASE = 180*180
   integer,     intent(in)  :: ng
   character(len=4), intent(out) :: grid

   integer      :: n
   real         :: dlong, dlat
   character(len=6)  :: grid6

   grid='    '
   if(ng.ge.32400) go to 10
   dlat=mod(ng,180)-90
   dlong=(ng/180)*2 - 180 + 2
   call deg2grid(dlong,dlat,grid6)
   grid=grid6(:4)
   if(grid(1:2).eq.'KA') then
      read(grid(3:4),*) n
      n=n-50
      write(grid,1001) n
 1001 format(i3.2)
      if(grid(1:1).eq.' ') grid(1:1)='+'
   else if(grid(1:2).eq.'LA') then
      read(grid(3:4),*) n
      n=n-50
      write(grid,1002) n
 1002 format('R',i3.2)
      if(grid(2:2).eq.' ') grid(2:2)='+'
   endif
   go to 900

 10 n=ng-NGBASE-1
   if(n.ge.1 .and.n.le.30) then
      write(grid,1012) -n
 1012 format(i3.2)
   else if(n.ge.31 .and.n.le.60) then
      n=n-30
      write(grid,1022) -n
 1022 format('R',i3.2)
   else if(n.eq.61) then
      grid='RO'
   else if(n.eq.62) then
      grid='RRR'
   else if(n.eq.63) then
      grid='73'
   endif

 900 return
 end subroutine unpackgrid

 subroutine packmsg(msg0,dat,itype)

  use getpfx1_mod
  use fil6521_mod
  use k2grid_mod
  use fmtmsg_mod
  
  implicit none

 ! Packs a JT4/JT9/JT65 message into twelve 6-bit symbols

 ! itype Message Type
 !--------------------
 !   1   Standard message
 !   2   Type 1 prefix
 !   3   Type 1 suffix
 !   4   Type 2 prefix
 !   5   Type 2 suffix
 !   6   Free text
 !  -1   Does not decode correctly
 
   character(len=22), intent(in)  :: msg0
   integer,      intent(out) :: dat(:)
   integer,      intent(out) :: itype

   integer, parameter :: NBASE  = 37*36*10*27*27*27
   integer, parameter :: NBASE2 = 262178562

   character(len=22) :: msg
   character(len=12) :: c1, c2
   character(len=4)  :: c3
   character(len=6)  :: grid6
   logical      :: text1, text2, text3
   integer      :: i, ia, ib, ic, iz
   integer      :: k1, k2, nv2a, nv2b
   integer      :: nc1, nc2, ng, k

   msg=msg0
   itype=1
   call fmtmsg(msg,iz)

   if(msg(1:6).eq.'CQ DX ') msg(3:3)='9'
   if(msg(1:3).eq."CQ " .and.                                         &
        msg(4:4).ge.'A' .and. msg(4:4).le.'Z' .and.                   &
        msg(5:5).ge.'A' .and. msg(5:5).le.'Z' .and.                   &
        msg(6:6).eq.' ') msg='E9'//msg(4:)
   
 ! See if it's a CQ message
   if(msg(1:3).eq.'CQ ') then
      i=3
 ! ... and if so, does it have a reply frequency?
      if(msg(4:4).ge.'0' .and. msg(4:4).le.'9' .and.                  &
           msg(5:5).ge.'0' .and. msg(5:5).le.'9' .and.                &
           msg(6:6).ge.'0' .and. msg(6:6).le.'9') i=7
      go to 1
   endif

   do i=1,22
      if(msg(i:i).eq.' ') go to 1       !Get 1st blank
   enddo
   go to 10                             !Consider msg as plain text

 1 ia=i
   c1=msg(1:ia-1)
   do i=ia+1,22
      if(msg(i:i).eq.' ') go to 2       !Get 2nd blank
   enddo
   go to 10                             !Consider msg as plain text

 2 ib=i
   c2=msg(ia+1:ib-1)

   do i=ib+1,22
      if(msg(i:i).eq.' ') go to 3       !Get 3rd blank
   enddo
   go to 10                             !Consider msg as plain text

 3 ic=i
   c3='    '
   if(ic.ge.ib+1) c3=msg(ib+1:ic)
   if(c3.eq.'OOO ') c3='    '           !Strip out the OOO flag
   call getpfx1(c1,k1,nv2a)
   if(nv2a.ge.4) go to 10
   call packcall(c1,nc1,text1)
   if(text1) go to 10
   call getpfx1(c2,k2,nv2b)
   call packcall(c2,nc2,text2)
   if(text2) go to 10
   if(nv2a.eq.2 .or. nv2a.eq.3 .or. nv2b.eq.2 .or. nv2b.eq.3) then
      if(k1.lt.0 .or. k2.lt.0 .or. k1*k2.ne.0) go to 10
      if(k2.gt.0) k2=k2+450
      k=max(k1,k2)
      if(k.gt.0) then
         call k2grid(k,grid6)
         c3=grid6(:4)
      endif
   endif
   call packgrid(c3,ng,text3)

   if(nv2a.lt.4 .and. nv2b.lt.4 .and. (.not.text1) .and. (.not.text2) .and.  &
        (.not.text3)) go to 20

   nc1=0
   if(nv2b.eq.4) then
      if(c1(1:3).eq.'CQ ')  nc1=262178563 + k2
      if(c1(1:4).eq.'QRZ ') nc1=264002072 + k2 
      if(c1(1:3).eq.'DE ')  nc1=265825581 + k2
   else if(nv2b.eq.5) then
      if(c1(1:3).eq.'CQ ')  nc1=267649090 + k2
      if(c1(1:4).eq.'QRZ ') nc1=267698375 + k2
      if(c1(1:3).eq.'DE ')  nc1=267747660 + k2
   endif
   if(nc1.ne.0) go to 20

 ! The message will be treated as plain text.
 10 itype=6
   call packtext(msg,nc1,nc2,ng)
   ng=ng+32768

 ! Encode data into 6-bit words
 20 continue
   if(itype.ne.6) itype=max(nv2a,nv2b)
   dat(1)=iand(ishft(nc1,-22),63)                !6 bits
   dat(2)=iand(ishft(nc1,-16),63)                !6 bits
   dat(3)=iand(ishft(nc1,-10),63)                !6 bits
   dat(4)=iand(ishft(nc1, -4),63)                !6 bits
   dat(5)=4*iand(nc1,15)+iand(ishft(nc2,-26),3)  !4+2 bits
   dat(6)=iand(ishft(nc2,-20),63)                !6 bits
   dat(7)=iand(ishft(nc2,-14),63)                !6 bits
   dat(8)=iand(ishft(nc2, -8),63)                !6 bits
   dat(9)=iand(ishft(nc2, -2),63)                !6 bits
   dat(10)=16*iand(nc2,3)+iand(ishft(ng,-12),15) !2+4 bits
   dat(11)=iand(ishft(ng,-6),63)
   dat(12)=iand(ng,63)

   return
 end subroutine packmsg

subroutine unpackmsg(dat, msg)
   use getpfx2_mod
   implicit none

   !==== Dummy arguments =====================================================
   integer,      intent(in)  :: dat(:)
   character(len=22), intent(out) :: msg

   !==== Local variables =====================================================
   integer :: nc1, nc2, ng
   integer :: iv2, nfreq
   integer :: i, j, k, n1, n2
   integer :: junk1
   character(len=12) :: c1, c2
   character(len=4)  :: grid, psfx, junk2
   character(len=6)  :: grid6
   logical :: cqnnn

   integer, parameter :: NBASE  = 37*36*10*27*27*27
   integer, parameter :: NGBASE = 180*180

   cqnnn=.false.
   nc1=ishft(dat(1),22) + ishft(dat(2),16) + ishft(dat(3),10)+         &
        ishft(dat(4),4) + iand(ishft(dat(5),-2),15)

   nc2=ishft(iand(dat(5),3),26) + ishft(dat(6),20) +                   &
        ishft(dat(7),14) + ishft(dat(8),8) + ishft(dat(9),2) +         &
        iand(ishft(dat(10),-4),3)

   ng=ishft(iand(dat(10),15),12) + ishft(dat(11),6) + dat(12)
   
!print *, 'UNPACKMSG PACKED: nc1=',nc1,' nc2=',nc2,' ng=',ng, ' dat=', &
!     dat(1),dat(2),dat(3),dat(4),dat(5),dat(6),dat(7),dat(8),dat(9), &
!     dat(10),dat(11),dat(12)


   if(ng.ge.32768) then
      call unpacktext(nc1,nc2,ng,msg)
      go to 100
   endif
   
!print *, 'UNPACKMSG BEFORE unpackcall nc1: nc1=',nc1,' iv2(before)=',iv2
call unpackcall(nc1,c1,iv2,psfx)
!print *, 'UNPACKMSG AFTER unpackcall nc1:  iv2=',iv2,' c1="',trim(c1),'" psfx="',psfx,'"'

   if(iv2.eq.0) then
 ! This is an "original JT65" message
      if(nc1.eq.NBASE+1) c1='CQ    '
      if(nc1.eq.NBASE+2) c1='QRZ   '
      nfreq=nc1-NBASE-3
      if(nfreq.ge.0 .and. nfreq.le.999) then
         write(c1,1002) nfreq
 1002    format('CQ ',i3.3)
         cqnnn=.true.
      endif
   endif

!   print *, 'UNPACKMSG BEFORE unpackcall nc2: nc2=',nc2
call unpackcall(nc2,c2,junk1,junk2)
!print *, 'UNPACKMSG AFTER unpackcall nc2:  c2="',trim(c2),'" junk2="',junk2,'"'

   call unpackgrid(ng,grid)

   if(iv2.gt.0) then
 ! This is a JT65v2 message
      do i=1,4
         if(ichar(psfx(i:i)).eq.0) psfx(i:i)=' '
      enddo

      n1=len_trim(psfx)
      n2=len_trim(c2)
      if(iv2.eq.1) msg='CQ '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.2) msg='QRZ '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.3) msg='DE '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.4) msg='CQ '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.5) msg='QRZ '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.6) msg='DE '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.7) msg='DE '//c2(:n2)//' '//grid
      if(iv2.eq.8) msg=' '
      go to 100
   else

   endif

   grid6=grid//'ma'
   call grid2k(grid6,k)
   if(k.ge.1 .and. k.le.450)   call getpfx2(k,c1)
   if(k.ge.451 .and. k.le.900) call getpfx2(k,c2)

   i=index(c1,char(0))
   if(i.ge.3) c1=c1(1:i-1)//'            '
   i=index(c2,char(0))
   if(i.ge.3) c2=c2(1:i-1)//'            '

   msg='                      '
   j=0
   if(cqnnn) then
      msg=c1//'          '
      j=7                                  !### ??? ###
      go to 10
   endif

   do i=1,12
      j=j+1
      msg(j:j)=c1(i:i)
      if(c1(i:i).eq.' ') go to 10
   enddo
   j=j+1
   msg(j:j)=' '

 10 do i=1,12
      if(j.le.21) j=j+1
      msg(j:j)=c2(i:i)
      if(c2(i:i).eq.' ') go to 20
   enddo
   if(j.le.21) j=j+1
   msg(j:j)=' '

 20 if(k.eq.0) then
      do i=1,4
         if(j.le.21) j=j+1
         msg(j:j)=grid(i:i)
      enddo
      if(j.le.21) j=j+1
      msg(j:j)=' '
   endif

 100 continue
   if(msg(1:6).eq.'CQ9DX ') msg(3:3)=' '
   if(msg(1:2).eq.'E9' .and.                                          &
        msg(3:3).ge.'A' .and. msg(3:3).le.'Z' .and.                   &
        msg(4:4).ge.'A' .and. msg(4:4).le.'Z' .and.                   &
        msg(5:5).eq.' ') msg='CQ '//msg(3:)

   return
 end subroutine unpackmsg

subroutine packtext(msg, nc1, nc2, nc3)

   implicit none

   integer, parameter :: MASK28 = 2**28 - 1
   character(len=13), intent(in)  :: msg
   integer,      intent(out) :: nc1, nc2, nc3

   integer :: i, j
   character(len=42) :: c
   data c /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/

   nc1=0
   nc2=0
   nc3=0

   do i=1,5                                !First 5 characters in nc1
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 10
      enddo
      j=37
 10   j=j-1                                !Codes should start at zero
      nc1=42*nc1 + j
   enddo

   do i=6,10                               !Characters 6-10 in nc2
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 20
      enddo
      j=37
 20   j=j-1                                !Codes should start at zero
      nc2=42*nc2 + j
   enddo

   do i=11,13                              !Characters 11-13 in nc3
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 30
      enddo
      j=37
 30   j=j-1                                !Codes should start at zero
      nc3=42*nc3 + j
   enddo

 ! We now have used 17 bits in nc3.  Must move one each to nc1 and nc2.
   nc1=nc1+nc1
   if(iand(nc3,32768).ne.0) nc1=nc1+1
   nc2=nc2+nc2
   if(iand(nc3,65536).ne.0) nc2=nc2+1
   nc3=iand(nc3,32767)

   return
 end subroutine packtext

 subroutine unpacktext(nc1, nc2, nc3, msg)
   implicit none
   integer,      intent(inout) :: nc1, nc2, nc3
   character(len=22), intent(out)   :: msg

   integer :: i, j
   character(len=44) :: c
   data c /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/

   nc3=iand(nc3,32767)                      !Remove the "plain text" bit
   if(iand(nc1,1).ne.0) nc3=nc3+32768
   nc1=nc1/2
   if(iand(nc2,1).ne.0) nc3=nc3+65536
   nc2=nc2/2

   do i=5,1,-1
      j=mod(nc1,42)+1
      msg(i:i)=c(j:j)
      nc1=nc1/42
   enddo

   do i=10,6,-1
      j=mod(nc2,42)+1
      msg(i:i)=c(j:j)
      nc2=nc2/42
   enddo

   do i=13,11,-1
      j=mod(nc3,42)+1
      msg(i:i)=c(j:j)
      nc3=nc3/42
   enddo
   msg(14:22) = '         '

   return
 end subroutine unpacktext

subroutine grid2k(grid, k)
   use grid2deg_mod, only: grid2deg
   implicit none
   character(len=6), intent(in)  :: grid
   integer,     intent(out) :: k

   real :: xlong, xlat
   integer :: nlong, nlat

   call grid2deg(grid, xlong, xlat)
   nlong = nint(xlong)
   nlat  = nint(xlat)
   k = 0
   if (nlat .ge. 85) k = 5*(nlong + 179)/2 + nlat - 84
end subroutine grid2k



subroutine grid2n(grid, n)
   implicit none
   character(len=4), intent(in)  :: grid
   integer,     intent(out) :: n

   integer :: i1, i2, i

   i1=ichar(grid(1:1))-ichar('A')
   i2=ichar(grid(3:3))-ichar('0')
   i=10*i1 + i2
   n=-i - 31

   return
 end subroutine grid2n

subroutine n2grid(n, grid)
   implicit none
   integer,     intent(in)  :: n
   character(len=4), intent(out) :: grid

   integer :: i, i1, i2

   if(n.gt.-31 .or. n.lt.-70) stop 'Error in n2grid'
   i=-(n+31)                           !NB: 0 <= i <= 39
   i1=i/10
   i2=mod(i,10)
   grid(1:1)=char(ichar('A')+i1)
   grid(2:2)='A'
   grid(3:3)=char(ichar('0')+i2)
   grid(4:4)='0'

   return
 end subroutine n2grid



 subroutine pack50(n1, n2, dat)
   use iso_fortran_env, only: int8
   implicit none
   integer,  intent(in)  :: n1, n2
   integer(int8), intent(out):: dat(:)

   integer(int8) :: i1

   i1=iand(ishft(n1,-20),255)                !8 bits
   dat(1)=i1
   i1=iand(ishft(n1,-12),255)                 !8 bits
   dat(2)=i1
   i1=iand(ishft(n1, -4),255)                 !8 bits
   dat(3)=i1
   i1=16*iand(n1,15)+iand(ishft(n2,-18),15)   !4+4 bits
   dat(4)=i1
   i1=iand(ishft(n2,-10),255)                 !8 bits
   dat(5)=i1
   i1=iand(ishft(n2, -2),255)                 !8 bits
   dat(6)=i1
   i1=64*iand(n2,3)                           !2 bits
   dat(7)=i1
   dat(8)=0
   dat(9)=0
   dat(10)=0
   dat(11)=0

   return
 end subroutine pack50

subroutine packpfx(call1, n1, ng, nadd)
   implicit none
   character(len=12), intent(in)  :: call1
   integer,      intent(out) :: n1, ng, nadd

   character(len=12) :: call0
   character(len=3)  :: pfx
   logical      :: text
   integer      :: i1, i, nc, n

  i1=index(call1,'/')
  if(call1(i1+2:i1+2).eq.' ') then
! Single-character add-on suffix (maybe also fourth suffix letter?)
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     nc=ichar(call1(i1+1:i1+1))
     if(nc.ge.48 .and. nc.le.57) then
        n=nc-48
     else if(nc.ge.65 .and. nc.le.90) then
        n=nc-65+10
     else
        n=38
     endif
     nadd=1
     ng=60000-32768+n
  else if(call1(i1+3:i1+3).eq.' ') then
! Two-character numerical suffix, /10 to /99
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     n=10*(ichar(call1(i1+1:i1+1))-48) + ichar(call1(i1+2:i1+2)) - 48
     nadd=1
     ng=60000 + 26 + n
  else
! Prefix of 1 to 3 characters
     pfx=call1(:i1-1)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     call0=call1(i1+1:)
     call packcall(call0,n1,text)

     ng=0
     do i=1,3
        nc=ichar(pfx(i:i))
        if(nc.ge.48 .and. nc.le.57) then
           n=nc-48
        else if(nc.ge.65 .and. nc.le.90) then
           n=nc-65+10
        else
           n=36
        endif
        ng=37*ng + n
     enddo
     nadd=0
     if(ng.ge.32768) then
        ng=ng-32768
        nadd=1
     endif
  endif

  return
end subroutine packpfx

end module packjt

subroutine searchcallsvar(callsign1,callsign2,lfound)
  
  use jt65_mod9, only : ncall0c,ncalld,ncallef,ncallgh,ncalli,ncallj,ncallk,ncalllm,ncalln,ncallo,ncallpq,ncallr, &
                        ncallst,ncalluv,ncallw,ncallxz,call0c,calld,callef,callgh,calli,callj,callk,calllm,calln,callo,  &
                        callpq,callr,callst,calluv,callw,callxz,ldbvalid ! callsign DB in memory
  character*12 callsign0,callsign1,callsign2
  logical(1) lfound

  if(.not.ldbvalid) then; lfound=.true.; return; endif ! bail out
 
  nlencall1=len_trim(callsign1);  nlencall2=len_trim(callsign2)
  if(nlencall1.gt.7 .and. callsign2.eq."            ") then; lfound=.true.; return; endif
  if(nlencall2.gt.7) callsign2="            " ! we can not put in ALLCALL all special callsign0s in advance
  ncycles=2; if(callsign2.eq."            ") ncycles=1
  do j=1,ncycles
    if(j.eq.1) then; callsign0=callsign1; else; callsign0=callsign2; endif
    if(callsign0.eq."TU;") cycle
    if(callsign0(1:1).lt."N") then
      if(callsign0(1:1).lt."I") then
        if(callsign0(1:1).lt."E") then
          if(callsign0(1:1).lt."D") then
            do i=1,ncall0c; if(call0c(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncalld; if(calld(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."G") then
            do i=1,ncallef; if(callef(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallgh; if(callgh(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
         endif
        endif
      else
        if(callsign0(1:1).lt."K") then
          if(callsign0(1:1).lt."J") then
            do i=1,ncalli; if(calli(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallj; if(callj(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."L") then
            do i=1,ncallk; if(callk(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncalllm; if(calllm(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        endif
      endif
    else
      if(callsign0(1:1).lt."S") then
        if(callsign0(1:1).lt."P") then
          if(callsign0(1:1).lt."O") then
            do i=1,ncalln; if(calln(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallo; if(callo(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."R") then
            do i=1,ncallpq; if(callpq(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallr; if(callr(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
         endif
        endif
      else
        if(callsign0(1:1).lt."W") then
          if(callsign0(1:1).lt."U") then
            do i=1,ncallst; if(callst(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncalluv; if(calluv(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."X") then
            do i=1,ncallw; if(callw(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallxz; if(callxz(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        endif
      endif
    endif
  enddo
! print *,"blocked ",callsign1,callsign2
  return
end subroutine searchcallsvar

program testEchoCall

  parameter (NSPS=4096,NH=NSPS/2,NZ=3*12000)
  integer*2 iwave(NZ)                    !Raw data, 12000 Hz sample rate
  integer ihdr(11)
  integer*1 itone(6)
  character*120 fname
  character*6 rxcall,hhmmss
  common/echocom/nclearave,nsum,blue(4096),red(4096)
  common/echocom2/fspread_self,fspread_dx

  narg=iargc()
  if(narg.lt.1) then
     print*,'Usage: testEchoCall fname1 [fname2, ...]'
     go to 999
  endif

  write(*,1000) 
1000 format('  UTC     Hour   Level  Doppler  Width     N     Q     DF' &
            '    SNR   dBerr   Message'/82('-'))

  nclearave=1
  navg=10
  nauto=1
  nqual=0
  do ifile=1,narg
     call getarg(ifile,fname)
     open(10,file=trim(fname),access='stream',status='unknown')
     read(10) ihdr,iwave
     close(10)

! Retrieve params known at time of transmissiion and saved in iwave
     call save_echo_params(nDop,nDopAudio,nfrit,f1,fspread,ndf,itone,iwave,-1)
     fspread_self=fspread

     call avecho(iwave,0,nfrit,ndf,nauto,navg,nqual,f1,xlevel,snrdb,db_err,dfreq, &
          width,bDiskData,bEchoCall,txcall,rxcall)
     i1=index(fname,'.wav')
     hhmmss=fname(i1-6:i1-1)
     read(hhmmss,'(3i2)') ih,im,is
     hour=ih + im/60.0 + is/3600.0
     write(*,1110) hhmmss,hour,xlevel,ndop,fspread,nsum,nqual,nint(dfreq),  &
          snrdb,db_err,rxcall
1110 format(a6,2x,f7.4,2x,f5.2,1x,i7,1x,f7.1,1x,i5,1x,i5,1x,i6,1x,f6.1,1x,f7.1,3x,a6)
     nclearave=0
  enddo

999 end program testEchoCall

module recvpkt_mod
  use datcom_ptrs_mod          ! for dd
   use iso_fortran_env, only: real64, real32, int16 
  implicit none
contains

subroutine recvpkt(nsam, nblock2, userx_no, k, buf4, buf8, buf16) &
     bind(C, name="recvpkt_")

  use iso_c_binding
  use datcom_ptrs_mod
  integer(c_int),      intent(in)    :: nsam
  integer(c_int16_t),  intent(inout) :: nblock2
  integer(c_int8_t),   intent(in)    :: userx_no
  integer(c_int),      intent(inout) :: k

  real(c_float),       intent(in)    :: buf4(*)
  real(c_double),      intent(in)    :: buf8(*)
  complex(c_double_complex), intent(in) :: buf16(*)

    ! ===== Locals =====
    integer :: i
    integer, parameter :: NSMAX = 60*96000

    ! Silence unused warning
    if (nblock2 .eq. -9999) nblock2 = -9998

    if (nsam .eq. -1) then
       ! Move data from UDP/PortAudio buffer into dd()

       select case (userx_no)

       case (-1)
          do i = 1, 174
             k = k + 1
             call unpack_r8_to_r4(buf8(i), dd(1,k), dd(2,k))
          end do

       case (1)
          do i = 1, 348
             k = k + 1
             call unpack_r4_to_i2_as_r4(buf4(i), dd(1,k), dd(2,k))
          end do

       case (-2)
          do i = 1, 87
             k = k + 1
             call unpack_c16_to_r4(buf16(i), dd(1,k), dd(2,k), dd(3,k), dd(4,k))
          end do

       case (2)
          do i = 1, 174
             k = k + 1
             call unpack_r8_to_i2_as_r4(buf8(i), dd(1,k), dd(2,k), dd(3,k), dd(4,k))
          end do

       end select

    else
       ! nsam >= 0: special case for one RF channel, r*4 data
       if (userx_no .eq. 1) then
          do i = 1, nsam
             k = k + 1
             call unpack_r4_to_i2_as_r4(buf4(i), dd(1,k), dd(2,k))

             k = k + 1
             dd(1,k) = dd(1,k-1)
             dd(2,k) = dd(2,k-1)
          end do
       end if
    end if

  end subroutine recvpkt

  ! ===== Helper routines (unchanged ABI, now module-scoped) =====

  subroutine unpack_r8_to_r4(x, a, b)
    real(real64),  intent(in)  :: x
    real(real32),  intent(out) :: a, b
    real(real32)               :: tmp(2)
    tmp = transfer(x, tmp)
    a = tmp(1)
    b = tmp(2)
  end subroutine unpack_r8_to_r4

  subroutine unpack_r4_to_i2_as_r4(x, a, b)
    real(real32),    intent(in)  :: x
    real(real32),    intent(out) :: a, b
    integer(int16)              :: tmp(2)
    tmp = transfer(x, tmp)
    a = real(tmp(1))
    b = real(tmp(2))
  end subroutine unpack_r4_to_i2_as_r4

  subroutine unpack_c16_to_r4(x, a1, a2, a3, a4)
    complex(real64), intent(in) :: x
    real(real32),    intent(out) :: a1, a2, a3, a4
    real(real32) :: tmp(4)
    tmp = transfer(x, tmp, size(tmp))
    a1 = tmp(1)
    a2 = tmp(2)
    a3 = tmp(3)
    a4 = tmp(4)
  end subroutine unpack_c16_to_r4

  subroutine unpack_r8_to_i2_as_r4(x, a1, a2, a3, a4)
    real(real64),    intent(in)  :: x
    real(real32),    intent(out) :: a1, a2, a3, a4
    integer(int16)              :: tmp(4)
    tmp = transfer(x, tmp)
    a1 = real(tmp(1))
    a2 = real(tmp(2))
    a3 = real(tmp(3))
    a4 = real(tmp(4))
  end subroutine unpack_r8_to_i2_as_r4

end module recvpkt_mod

program emedop

  real*8 txfreq8
  real*8 rxfreq8
  real*4 LST
  real*4 lat_a
  real*4 lat_b
  character*80 infile
  character*256 jpleph_file_name
  common/jplcom/jpleph_file_name
  data jpleph_file_name/'JPLEPH'/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: emedop <infile>'
     go to 999
  endif

  call getarg(1,infile)
  open(10,file=infile,status='old',err=900)
  read(10,1001) lat_a
1001 format(10x,f12.0)
  read(10,1001) wlon_a
  read(10,1001) lat_b
  read(10,1001) wlon_b
  read(10,1001) txfreq8
  read(10,1002) nyear,month,nday,ih,im,is
1002 format(10x,i4,2i2,1x,i2,1x,i2,1x,i2)
  sec_start=3600.0*ih + 60.0*im + is
  read(10,1002) nyear,month,nday,ih,im,is
  sec_stop=3600.0*ih + 60.0*im + is
  read(10,1001) sec_step

  write(*,1005)
1005 format('  Date       UTC      Tx Freq      Rx Freq    Doppler'/    &
            '------------------------------------------------------')
  
  sec=sec_start
  ncalc=(sec_stop - sec_start)/sec_step

  do icalc=1,ncalc
     uth=sec/3600.0
     call MoonDopJPL(nyear,month,nday,uth,-wlon_a,lat_a,RAMoon,DecMoon,    &
          LST,HA,AzMoon,ElMoon,vr_a,techo)

     call MoonDopJPL(nyear,month,nday,uth,-wlon_b,lat_b,RAMoon,DecMoon,    &
          LST,HA,AzMoon,ElMoon,vr_b,techo)
  
     dop_a=-txfreq8*vr_a/2.99792458e5                 !One-way Doppler from a
     dop_b=-txfreq8*vr_b/2.99792458e5                 !One-way Doppler to b
     doppler=1.e6*(dop_a + dop_b)
     rxfreq8=txfreq8 + dop_a + dop_b

     ih=sec/3600.0
     im=(sec-ih*3600.0)/60.0
     is=nint(mod(sec,60.0))
     write(*,1010) nyear,month,nday,ih,im,is,txFreq8,rxFreq8,doppler
1010 format(i4,2i2.2,2x,i2.2,':',i2.2,':',i2.2,2f13.7,f8.1)

     sec=sec + sec_step
  enddo
  go to 999
900 print*,'Cannot open file ',trim(infile)
999 end program emedop

  

subroutine getdphi(qphi)

  real qphi(12)

  s=0.
  c=0.
  do i=1,12
     th=i*30/57.2957795
     s=s+qphi(i)*sin(th)
     c=c+qphi(i)*cos(th)
  enddo

  dphi=57.2957795*atan2(s,c)
  write(*,1010) nint(dphi)
1010 format('!Best-fit Dphi =',i4,' deg')

  return
  end

module getdphi_mod
  implicit none
contains

subroutine getdphi(qphi)
  implicit none

  ! Arguments
  real, intent(in) :: qphi(12)

  ! Locals
  real :: c, dphi, s, th
  integer :: i

  s = 0.0
  c = 0.0

  do i = 1, 12
     th = i * 30.0 / 57.2957795   ! convert degrees to radians
     s  = s + qphi(i) * sin(th)
     c  = c + qphi(i) * cos(th)
  end do

  dphi = 57.2957795 * atan2(s, c)
  write(*,1010) nint(dphi)
1010 format('!Best-fit Dphi =', i4, ' deg')

end subroutine getdphi

end module getdphi_mod

subroutine genqra64(msg0,ichk,msgsent,itone,itype)

! Encodes a QRA64 message to yield itone(1:84) or a QRA65 msg, itone(1:85)

  use packjt
  character*22 msg0
  character*22 message            !Message to be generated
  character*22 msgsent            !Message as it will be received
  integer itone(85)               !QRA64 uses only 84
  character*3 cok                 !'   ' or 'OOO'
  integer dgen(13)
  integer sent(63)
  integer isync(22)
  integer icos7(0:6)
  data icos7/2,5,6,0,4,1,3/       !Defines a 7x7 Costas array
  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/
  save

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    itone(1)=nfreq
     write(msgsent,1000) nfreq
1000 format(i5,' Hz')
  else
     message=msg0
     do i=1,22
        if(ichar(message(i:i)).eq.0) then
           message(i:)='                      '
           exit
        endif
     enddo

     do i=1,22                               !Strip leading blanks
        if(message(1:1).ne.' ') exit
        message=message(i+1:)
     enddo

     call chkmsg(message,cok,nspecial,flip)
     call packmsg(message,dgen,itype)    !Pack message into 72 bits
     call unpackmsg(dgen,msgsent)        !Unpack to get message sent
     if(ichk.eq.1) go to 999             !Return if checking only
     call qra64_enc(dgen,sent)           !Encode using QRA64

     if(ichk.eq.65) then
! Experimental QRA65 mode
        j=1
        k=0
        do i=1,85
           if(i.eq.isync(j)) then
              j=j+1                      !Index for next sync symbol
              itone(i)=0                 !Insert a sync symbol
           else
              k=k+1
              itone(i)=sent(k) + 1
           endif
        enddo
     else
! Original QRA64 mode
        itone(1:7)=10*icos7              !Insert 7x7 Costas array in 3 places
        itone(8:39)=sent(1:32)
        itone(40:46)=10*icos7
        itone(47:77)=sent(33:63)
        itone(78:84)=10*icos7
     endif
  endif

999 return
end subroutine genqra64

subroutine q65_set_list2(mycall,hiscall,hisgrid,callers,nhist2,codewords,ncw)

  use types
  parameter (MAX_NCW=206)
  parameter (MAX_CALLERS=40)  !For multiple q3 decodes in NA VHf Contest mode
  character*12 mycall,hiscall
  character*6 hisgrid,c6
  character*4 g4
  character*37 msg,msgsent
  logical std,isgrid
  integer codewords(63,MAX_NCW)
  integer itone(85)
  integer isync(22)
  type(q3list) callers(MAX_CALLERS)

  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/

  isgrid(g4)=g4(1:1).ge.'A' .and. g4(1:1).le.'R' .and. g4(2:2).ge.'A' .and. &
       g4(2:2).le.'R' .and. g4(3:3).ge.'0' .and. g4(3:3).le.'9' .and.       &
       g4(4:4).ge.'0' .and. g4(4:4).le.'9' .and. g4(1:4).ne.'RR73'

  call stdcall(hiscall,std)
  jmax=nhist2
  if(std .and. isgrid(hisgrid(1:4))) then
     jmax=min(MAX_CALLERS,nhist2+1)
     do j=1,nhist2
        if(callers(j)%call .eq. hiscall(1:6)) then
           jmax=nhist2
           exit
        endif
     enddo
  endif

  codewords(:,1)=0
  i=1
  do j=1,jmax
     c6=callers(j)%call
     g4=callers(j)%grid
     if(j.eq.nhist2+1) then
        c6=hiscall(1:6)
        g4=hisgrid(1:4)
     endif
     do k=1,5
        i=i+1
        msg=trim(mycall)//' '//trim(c6)
        j0=len(trim(msg))+1
        if(k.eq.1) msg=msg(1:j0)//g4
        if(k.eq.2) msg=msg(1:j0)//'R '//g4
        if(k.eq.3) msg(j0:j0+3)=' RRR'
        if(k.eq.4) msg(j0:j0+4)=' RR73'
        if(k.eq.5) msg(j0:j0+2)=' 73'
        call genq65(msg,0,msgsent,itone,i3,n3)
        i0=1
        jj=0
        do kk=1,85
           if(kk.eq.isync(i0)) then
              i0=i0+1
              cycle
           endif
           jj=jj+1
           codewords(jj,i)=itone(kk) - 1
        enddo
!        write(71,3001) i,j,k,codewords(1:13,i),trim(msg)
!3001    format(3i3,2x,13i3,2x,a)
     enddo
  enddo
  ncw=i

  return
end subroutine q65_set_list2

subroutine afc65b(cx,npts,fsample,nflip,mode65,a,ccfbest,dtbest)

! Find delta f, f1, f2 ==> a(1:3)

  complex cx(npts)
  real a(5),deltaa(5)

  a=0.
  a1=0.
  a2=0.
  i2=8*mode65
  i1=-i2
  j2=8*mode65
  j1=-j2
  ccfmax=0.
  istep=2*mode65
  do iter=1,2
     do i=i1,i2,istep
        a(1)=i
        do j=j1,j2,istep
           a(2)=j
           chisq=fchisq65(cx,npts,fsample,nflip,a,ccf,dtmax)
           if(ccf.gt.ccfmax) then
              a1=a(1)
              a2=a(2)
              ccfmax=ccf
           endif
!           write(81,3081) istep,i1,i2,j1,j2,i,j,ccf,ccfmax,dtmax,a1,a2
!3081       format(7i4,5f8.2)
        enddo
     enddo
     i1=int(a1)-istep
     i2=int(a1)+istep
     j1=int(a2)-istep
     j2=int(a2)+istep
     istep=1
  enddo
  
!  a(1)=0.
!  a(2)=0.
  a(1)=a1
  a(2)=a2
  a(3)=0.
  a(4)=0.
  deltaa(1)=2.0*mode65
  deltaa(2)=2.0*mode65
  deltaa(3)=1.0
  nterms=2                                  !Maybe 2 is enough?

!  Start the iteration
  chisqr=0.
  chisqr0=1.e6
  do iter=1,100                              !How many iters is enough?
     do j=1,nterms
        chisq1=fchisq65(cx,npts,fsample,nflip,a,ccfmax,dtmax)
        fn=0.
        delta=deltaa(j)
10      a(j)=a(j)+delta
        chisq2=fchisq65(cx,npts,fsample,nflip,a,ccfmax,dtmax)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      fn=fn+1.0
        a(j)=a(j)+delta
        chisq3=fchisq65(cx,npts,fsample,nflip,a,ccfmax,dtmax)
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
        deltaa(j)=deltaa(j)*fn/3.
!        write(*,4000) iter,j,a(1:2),-chisq2
!4000    format(2i2,4f9.4)
     enddo
     chisqr=fchisq65(cx,npts,fsample,nflip,a,ccfmax,dtmax)
     fdiff=chisqr/chisqr0-1.0
!     write(*,4000) 0,0,a(1:2),-chisqr,fdiff
     if(abs(fdiff).lt.0.0001) exit
     chisqr0=chisqr
  enddo
  ccfbest=ccfmax * (1378.125/fsample)**2
  dtbest=dtmax

  return
end subroutine afc65b

subroutine chkspecial8var(msg37,msg37_2,nbadcrc)

  use ft8_mod1, only : mycall,hiscall
  character msg37*37,msg37_2*37,call_a*12,call_b*12,call_c*12
  logical(1) falsedec

  call_a='            '; call_b='            '; call_c='            '

! V03VTJ RR73; 2D3VDY <...> +08     call_a call_b call_c     
!V03VTJ <...> RR73         
!2D3VDY <...> +08          
! Y84NN RR73; HO5RFG <...> -16           
!Y84NN <...> RR73          
!HO5RFG <...> -16          
! P7IJQ RR73; MP4LEL <...> +02           
!P7IJQ <...> RR73          
!MP4LEL <...> +02 
 
  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc12=index(msg37_2,' ')
  if(ispc1.gt.3 .and. ispc2.gt.7) then
    call_a=msg37(1:ispc1-1); call_b=msg37_2(1:ispc12-1); call_c=msg37(ispc1+1:ispc2-1)
    if(call_a.ne.mycall .and. call_b.ne.mycall .and. call_c.ne.hiscall) then
! call may not start from 'Q', zero and two digits
      if(call_a(1:1).eq.'Q' .or. call_b(1:1).eq.'Q') then
        nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
      if(call_a(1:1).eq.'0' .or. call_b(1:1).eq.'0') then
        nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
      if(call_a(1:1).ge.'0' .and. call_a(1:1).le.'9' .and. call_a(2:2).ge.'0' .and. call_a(2:2).le.'9') then
        nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
      if(call_b(1:1).ge.'0' .and. call_b(1:1).le.'9' .and. call_b(2:2).ge.'0' .and. call_b(2:2).le.'9') then
        nbadcrc=1;  msg37='                                     '; msg37_2=msg37; return; endif

      falsedec=.false.
      call chkflscallvar(call_a,call_b,falsedec)
      if(falsedec) then; nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
    endif
  endif

  return
end subroutine chkspecial8var

      subroutine write_char(c, iunit)
      character c
      integer iunit
      write(iunit,1000) c
 1000 format(a,$)
      end      

      subroutine export_wisdom_to_file(iunit)
      integer iunit
      external write_char
c      call dfftw_export_wisdom(write_char, iunit)
      call sfftw_export_wisdom(write_char, iunit)
      end

      subroutine read_char(ic, iunit)
      integer ic
      integer iunit
      character*256 buf
      save buf
      integer ibuf
      data ibuf/257/
      save ibuf
      if (ibuf .lt. 257) then
         ic = ichar(buf(ibuf:ibuf))
         ibuf = ibuf + 1
         return
      endif
      read(iunit,1000,end=10) buf
 1000 format(a256)
      ic = ichar(buf(1:1))
      ibuf = 2
      return
 10   ic = -1
      ibuf = 257
      rewind iunit
      return
      end
      
      subroutine import_wisdom_from_file(isuccess, iunit)
      integer isuccess
      integer iunit
      external read_char
c      call dfftw_import_wisdom(isuccess, read_char, iunit)
      call sfftw_import_wisdom(isuccess, read_char, iunit)
      end

subroutine timf2(x0,k,nfft,nwindow,nb,peaklimit,x1,     &
     slimit,lstrong,px,nzap)

! Sequential processing of time-domain I/Q data, using Linrad-like
! "first FFT" and "first backward FFT", treating frequencies with
! strong signals differently.  Noise blanking is applied to weak
! signals only.

!  x0       - real input data
!  nfft     - length of FFTs
!  nwindow  - 0 for no window, 2 for sin^2 window
!  x1       - real output data

! Non-windowed processing means no overlap, so kstep=nfft.  
! Sin^2 window has 50% overlap, kstep=nfft/2.

! Frequencies with strong signals are identified and separated.  Back
! transforms are done separately for weak and strong signals, so that
! noise blanking can be applied to the weak-signal portion.  Strong and
! weak are finally re-combined, in the time domain.

  parameter (MAXFFT=1024,MAXNH=MAXFFT/2)
  parameter (MAXSIGS=100)
  real x0(0:nfft-1),x1(0:nfft-1)
  real x(0:MAXFFT-1),xw(0:MAXFFT-1),xs(0:MAXFFT-1)
  real xwov(0:MAXNH-1),xsov(0:MAXNH-1)
  complex cx(0:MAXFFT-1),cxt(0:MAXFFT-1)
  complex cxs(0:MAXFFT-1)                     !Strong signals
  complex cxw(0:MAXFFT-1)                     !Weak signals
  real*4 w(0:MAXFFT-1)
  real*4 s(0:MAXNH)
  logical*1 lstrong(0:MAXNH),lprev
  integer ia(MAXSIGS),ib(MAXSIGS)
  logical first
  equivalence (x,cx),(xw,cxw),(xs,cxs)
  data first/.true./
  data k0/99999999/
  save

  if(first) then
     pi=4.0*atan(1.0)
     do i=0,nfft-1
        w(i)=(sin(i*pi/nfft))**2
     enddo
     s=0.
     nh=nfft/2
     kstep=nfft
     if(nwindow.eq.2) kstep=nh
     fac=1.0/nfft
     slimit=1.e30
     first=.false.
  endif

  if(k.lt.k0) then
     xsov=0.
     xwov=0.
  endif
  k0=k

  x(0:nfft-1)=x0
  if(nwindow.eq.2) x(0:nfft-1)=w(0:nfft-1)*x(0:nfft-1)
  call four2a(cx,nfft,1,-1,0)                       !First forward FFT, r2c
  cxt(0:nh)=cx(0:nh)

! Identify frequencies with strong signals.
  do i=0,nh
     p=real(cxt(i))**2 + aimag(cxt(i))**2
     s(i)=p
  enddo
  ave=sum(s(0:nh))/nh
  lstrong(0:nh)=s(0:nh).gt.10.0*ave

  nsigs=0
  lprev=.false.
  iwid=1
  ib=-99
  do i=0,nh
     if(lstrong(i) .and. (.not.lprev)) then
        if(nsigs.lt.MAXSIGS) nsigs=nsigs+1
        ia(nsigs)=i-iwid
        if(ia(nsigs).lt.0) ia(nsigs)=0
     endif
     if(.not.lstrong(i) .and. lprev) then
        ib(nsigs)=i-1+iwid
        if(ib(nsigs).gt.nh) ib(nsigs)=nh
     endif
     lprev=lstrong(i)
  enddo

  if(nsigs.gt.0) then
     do i=1,nsigs
        ja=ia(i)
        jb=ib(i)
        if(ja.lt.0 .or. ja.gt.nh .or. jb.lt.0 .or. jb.gt.nh) then
           cycle
        endif
        if(jb.eq.-99) jb=ja + min(2*iwid,nh)
        lstrong(ja:jb)=.true.
     enddo
  endif

! Copy frequency-domain data into array cs (strong) or cw (weak).
  do i=0,nh
     if(lstrong(i)) then
        cxs(i)=fac*cxt(i)
        cxw(i)=0.
     else
        cxw(i)=fac*cxt(i)
        cxs(i)=0.
     endif
  enddo

  call four2a(cxw,nfft,1,1,-1)           !Transform weak and strong back
  call four2a(cxs,nfft,1,1,-1)           !to time domain, separately (c2r)

  if(nwindow.eq.2) then
     xw(0:nh-1)=xw(0:nh-1)+xwov(0:nh-1)     !Add previous segment's 2nd half
     xwov(0:nh-1)=xw(nh:nfft-1)             !Save 2nd half
     xs(0:nh-1)=xs(0:nh-1)+xsov(0:nh-1)     !Ditto for strong signals
     xsov(0:nh-1)=xs(nh:nfft-1)
  endif

! Apply noise blanking to weak data
  if(nb.ne.0) then
     do i=0,kstep-1
        peak=abs(xw(i))
        if(peak.gt.peaklimit) then
           xw(i)=0.
           nzap=nzap+1
        endif
     enddo
  endif

! Compute power levels from weak data only
  do i=0,kstep-1
     px=px + xw(i)**2
  enddo

  x1(0:kstep-1)=xw(0:kstep-1) + xs(0:kstep-1)     !Recombine weak + strong

  return
end subroutine timf2

subroutine encode4(message,ncode)

  use packjt
  parameter (MAXCALLS=7000,MAXRPT=63)
  integer ncode(206)
  character*22 message          !Message to be generated
  character*3 cok               !'   ' or 'OOO'
  integer dgen(13)
  integer*1 data0(13),symbol(216)

  call chkmsg(message,cok,nspecial,flip)
  call packmsg(message,dgen,itype) !Pack 72-bit message into 12 six-bit symbols
  call entail(dgen,data0)
  call encode232(data0,206,symbol)       !Convolutional encoding
  call interleave4(symbol,1)             !Apply JT4 interleaving
  do i=1,206
     ncode(i)=symbol(i)
  enddo

end subroutine encode4

module options
  !
  ! Source code copied from:
  ! http://fortranwiki.org/fortran/show/Command-line+arguments
  !
  implicit none

  type option
     !> Long name.
     character(len=100) :: name
     !> Does the option require an argument?
     logical :: has_arg
     !> Corresponding short name.
     character :: chr
     !> Description.
     character(len=500) :: descr
     !> Argument name, if required.
     character(len=20) :: argname
   contains
     procedure :: print => print_opt
  end type option

contains

  !> Parse command line options. Options and their arguments must come before
  !> all non-option arguments. Short options have the form "-X", long options
  !> have the form "--XXXX..." where "X" is any character. Parsing can be
  !> stopped with the option '--'.
  !> The following code snippet illustrates the intended use:
  !> \code
  !> do
  !>   call getopt (..., optchar=c, ...)
  !>   if (stat /= 0) then
  !>     ! optional error handling
  !>     exit
  !>   end if
  !>   select case (c)
  !>     ! process options
  !>   end select
  !> end do
  !> \endcode
  subroutine getopt (options, longopts, optchar, optarg, arglen, stat, &
       offset, remain, err)
    use iso_fortran_env, only: error_unit

    !> String containing the characters that are valid short options. If
    !> present, command line arguments are scanned for those options.
    !> If a character is followed by a colon (:) its corresponding option
    !> requires an argument. E.g. "vn:" defines two options -v and -n with -n
    !> requiring an argument.
    character(len=*), intent(in), optional :: options

    !> Array of long options. If present, options of the form '--XXXX...' are
    !> recognised. Each option has an associated option character. This can be
    !> any character of default kind, it is just an identifier. It can, but
    !> doesn't have to, match any character in the options argument. In fact it
    !> is possible to only pass long options and no short options at all.
    !> Only name, has_arg and chr need to be set.
    type(option), intent(in), optional :: longopts(:)

    !> If stat is not 1, optchar contains the option character that was parsed.
    !> Otherwise its value is undefined.
    character, intent(out), optional :: optchar

    !> If stat is 0 and the parsed option requires an argument, optarg contains
    !> the first len(optarg) (but at most 500) characters of that argument.
    !> Otherwise its value is undefined. If the arguments length exceeds 500
    !> characters and err is .true., a warning is issued.
    character(len=*), intent(out), optional :: optarg

    !> If stat is 0 and the parsed option requires an argument, arglen contains
    !> the actual length of that argument. Otherwise its value is undefined.
    !> This can be used to make sure the argument was not truncated by the
    !> limited length of optarg.
    integer, intent(out), optional :: arglen

    !> Status indicator. Can have the following values:
    !>   -  0: An option was successfully parsed.
    !>   -  1: Parsing stopped successfully because a non-option or '--' was
    !>         encountered.
    !>   - -1: An unrecognised option was encountered.
    !>   - -2: A required argument was missing.
    !>   .
    !> Its value is never undefined.
    integer, intent(out), optional :: stat

    !> If stat is 1, offset contains the number of the argument before the
    !> first non-option argument, i.e. offset+n is the nth non-option argument.
    !> If stat is not 1, offset contains the number of the argument that would
    !> be parsed in the next call to getopt. This number can be greater than
    !> the actual number of arguments.
    integer, intent(out), optional :: offset

    !> If stat is 1, remain contains the number of remaining non-option
    !> arguments, i.e. the non-option arguments are in the range 
    !> (offset+1:offset+remain). If stat is not 1, remain is undefined.
    integer, intent(out), optional :: remain

    !> If err is present and .true., getopt prints messages to the standard
    !> error unit if an error is encountered (i.e. whenever stat would be set
    !> to a negative value).
    logical, intent(in), optional :: err

    integer, save :: pos = 1, cnt = 0
    character(len=500), save :: arg

    integer :: chrpos, length, st, id = 0
    character :: chr
    logical :: long

    if (cnt == 0) cnt = command_argument_count()
    long = .false.

    ! no more arguments left
    if (pos > cnt) then
       pos = pos - 1
       st = 1
       goto 10
    end if

    call get_command_argument (pos, arg, length)

    ! is argument an option?
    if (arg(1:1) == '-') then

       chr = arg(2:2)

       ! too long ('-xxxx...') for one dash?
       if (chr /= '-' .and. len_trim(arg) > 2) then
          st = -1
          goto 10
       end if

       ! forced stop ('--')
       if (chr == '-' .and. arg(3:3) == ' ') then
          st = 1
          goto 10
       end if

       ! long option ('--xxx...')
       if (chr == '-') then

          long = .true.

          ! check if valid
          id = lookup(arg(3:))

          ! option is invalid, stop
          if (id == 0) then
             st = -1
             goto 10
          end if

          chr = longopts(id)%chr

          ! check if option requires an argument
          if (.not. longopts(id)%has_arg) then
             st = 0
             goto 10
          end if

          ! check if there are still arguments left
          if (pos == cnt) then
             st = -2
             goto 10
          end if

          ! go to next position
          pos = pos + 1

          ! get argument
          call get_command_argument (pos, arg, length)

          ! make sure it is not an option
          if (arg(1:1) == '-') then
             st = -2
             pos = pos - 1
             goto 10
          end if

       end if

       ! short option
       ! check if valid
       if (present(options)) then
          chrpos = scan(options, chr)
       else
          chrpos = 0
       end if

       ! option is invalid, stop
       if (chrpos == 0) then
          st = -1
          goto 10
       end if

       ! look for argument requirement
       if (chrpos < len_trim(options)) then
          if (options(chrpos+1:chrpos+1) == ':') then

             ! check if there are still arguments left
             if (pos == cnt) then
                st = -2
                goto 10
             end if

             ! go to next position
             pos = pos + 1

             ! get argument
             call get_command_argument (pos, arg, length)

             ! make sure it is not an option
             if (arg(1:1) == '-') then
                st = -2
                pos = pos - 1
                goto 10
             end if

          end if
       end if

       ! if we get to this point, no error happened
       ! return option and the argument (if there is one)
       st = 0
       goto 10
    end if

    ! not an option, parsing stops
    st = 1
    ! we are already at the first non-option argument
    ! go one step back to the last option or option argument
    pos = pos - 1


    ! error handling and setting of return values
10  continue

    if (present(err)) then
       if (err) then

          select case (st)
          case (-1)
             write (error_unit, *) "error: unrecognised option: " // trim(arg) 
          case (-2)
             if (.not. long) then
                write (error_unit, *) "error: option -" // chr &
                     // " requires an argument"
             else
                write (error_unit, *) "error: option --" &
                     // trim(longopts(id)%name) // " requires an argument"
             end if
          end select

       end if
    end if

    if (present(optchar)) optchar = chr
    if (present(optarg))  optarg  = arg
    if (present(arglen))  arglen  = length
    if (present(stat))    stat    = st
    if (present(offset))  offset  = pos
    if (present(remain))  remain  = cnt-pos

    ! setup pos for next call to getopt
    pos = pos + 1

  contains

    integer function lookup (name)
      character(len=*), intent(in) :: name
      integer :: i

      ! if there are no long options, skip the loop
      if (.not. present(longopts)) goto 10

      do i = 1, size(longopts)
         if (name == longopts(i)%name) then
            lookup = i
            return
         end if
      end do
      ! if we get to this point, the option was not found

10    lookup = 0
    end function lookup

  end subroutine getopt

  !============================================================================

  !> Print an option in the style of a man page. I.e.
  !> \code
  !> -o arg
  !> --option arg
  !>    description.................................................................
  !>    ............................................................................
  !> \endcode
  subroutine print_opt (opt, unit)
    !> the option
    class(option), intent(in) :: opt
    !> logical unit number
    integer, intent(in) :: unit

    integer :: l, c1, c2

    if (opt%has_arg) then
       write (unit, '(1x,"-",a,1x,a)') opt%chr, trim(opt%argname)
       write (unit, '(1x,"--",a,1x,a)') trim(opt%name), trim(opt%argname)
    else
       write (unit, '(1x,"-",a)') opt%chr
       write (unit, '(1x,"--",a)') trim(opt%name)
    end if
    l = len_trim(opt%descr)

    ! c1 is the first character of the line
    ! c2 is one past the last character of the line
    c1 = 1
    do
       if (c1 > l) exit
       ! print at maximum 4+76 = 80 characters
       c2 = min(c1 + 76, 500)
       ! if not at the end of the whole string
       if (c2 /= 500) then
          ! find the end of a word
          do
             if (opt%descr(c2:c2) == ' ') exit
             c2 = c2-1
          end do
       end if
       write (unit, '(4x,a)') opt%descr(c1:c2-1)
       c1 = c2+1
    end do

  end subroutine print_opt

end module options

program ft8sim_gfsk

! Generate simulated "type 2" ft8 files
! Output is saved to a *.wav file.

  use wavhdr
  use packjt77
  include 'ft8_params.f90'               !Set various constants
  parameter (NWAVE=NN*NSPS)
  type(hdr) h                            !Header for .wav file
  character arg*12,fname*17
  character msg37*37,msgsent37*37
  character c77*77
  complex c0(0:NMAX-1)
  complex c(0:NMAX-1)
  complex cwave(0:NWAVE-1)
  real wave(NMAX)
  real xjunk(NWAVE)
  integer itone(NN)
  integer*1 msgbits(77)
  integer*2 iwave(NMAX)                  !Generated full-length waveform

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.7) then
     print*,'Usage:    ft8sim "message"                 f0     DT fdop del nfiles snr'
     print*,'Examples: ft8sim "K1ABC W9XYZ EN37"       1500.0 0.0  0.1 1.0   10   -18'
     print*,'          ft8sim "WA9XYZ/R KA1ABC/R FN42" 1500.0 0.0  0.1 1.0   10   -18'
     print*,'          ft8sim "K1ABC RR73; W9XYZ <KH1/KH7Z> -11" 300 0 0 0 25 1 -10'
     print*,'          ft8sim "<G4ABC/P> <PA9XYZ> R 570007 JO22DB" 1500 0 0 0 1 -10'
     go to 999
  endif
  call getarg(1,msg37)                   !Message to be transmitted
  call getarg(2,arg)
  read(arg,*) f0                         !Frequency (only used for single-signal)
  call getarg(3,arg)
  read(arg,*) xdt                        !Time offset from nominal (s)
  call getarg(4,arg)
  read(arg,*) fspread                    !Watterson frequency spread (Hz)
  call getarg(5,arg)
  read(arg,*) delay                      !Watterson delay (ms)
  call getarg(6,arg)
  read(arg,*) nfiles                     !Number of files
  call getarg(7,arg)
  read(arg,*) snrdb                      !SNR_2500

  nsig=1
  if(f0.lt.100.0) then
     nsig=f0
     f0=1500
  endif

  nfiles=abs(nfiles)
  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  tt=NSPS*dt                             !Duration of symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  bw=8*baud                              !Occupied bandwidth (Hz)
  txt=NZ*dt                              !Transmission length (s)
  bt=2.0                         
  bandwidth_ratio=2500.0/(fs/2.0)
  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
  if(snrdb.gt.90.0) sig=1.0
  txt=NN*NSPS/12000.0

  ! Source-encode, then get itone()
  i3=-1
  n3=-1
  call pack77(msg37,i3,n3,c77)
  call genft8(msg37,i3,n3,msgsent37,msgbits,itone)
  call gen_ft8wave(itone,NN,NSPS,bt,fs,f0,cwave,xjunk,1,NWAVE)  !Generate complex cwave

  write(*,*)  
  write(*,'(a23,a37,3x,a7,i1,a1,i1)') 'Decoded message: ',msgsent37,'i3.n3: ',i3,'.',n3
  write(*,1000) f0,xdt,txt,snrdb,bw
1000 format('f0:',f9.3,'   DT:',f6.2,'   TxT:',f6.1,'   SNR:',f6.1,    &
       '  BW:',f4.1)
  write(*,*)  
  if(i3.eq.1) then
    write(*,*) '         mycall                         hiscall                    hisgrid'
    write(*,'(28i1,1x,i1,1x,28i1,1x,i1,1x,i1,1x,15i1,1x,3i1)') msgbits(1:77) 
  else
    write(*,'(a14)') 'Message bits: '
    write(*,'(77i1)') msgbits
  endif
  write(*,*) 
  write(*,'(a17)') 'Channel symbols: '
  write(*,'(79i1)') itone
  write(*,*)  

  call sgran()

  do ifile=1,nfiles
     c0=0.
     c0(0:NWAVE-1)=cwave
     c0=cshift(c0,-nint((xdt+0.5)/dt))
     if(fspread.ne.0.0 .or. delay.ne.0.0) call watterson(c0,NMAX,NWAVE,fs,delay,fspread)
     c=sig*c0
  
     wave=imag(c)
     peak=maxval(abs(wave))
     nslots=1

     psig=0.
     pnoise=0.
     if(snrdb.lt.90) then
        do i=1,NMAX                   !Add gaussian noise at specified SNR
           xnoise=gran()
           if(i.ge.6001 .and. i.le.157692) then
              psig=psig + wave(i)*wave(i)     !Signal power
              pnoise=pnoise + xnoise*xnoise   !Noise power in signal interval
           endif
           wave(i)=wave(i) + xnoise
        enddo
     endif

! Noise power in signal interval and 2500 Hz bandwidth:
     pnoise=bandwidth_ratio*pnoise
     snr_2500=db(psig/pnoise)                 !SNR in 2500 Hz bandwidth

     gain=100.0
     if(snrdb.lt.90.0) then
       wave=gain*wave
     else
       datpk=maxval(abs(wave))
       fac=32766.9/datpk
       wave=fac*wave
     endif
     if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave=nint(wave)
     h=default_header(12000,NMAX)
     write(fname,1102) ifile
1102 format('000000_',i6.6,'.wav')
     open(10,file=fname,status='unknown',access='stream')
     write(10) h,iwave                !Save to *.wav file
     close(10)
     write(*,1110) ifile,xdt,f0,snrdb,fname,snr_2500
1110 format(i4,f7.2,f8.2,f7.1,2x,a17,f8.2)
  enddo    
999 end program ft8sim_gfsk

subroutine tone8myc()

  use ft8_mod1, only : idtonemyc,mycall
  character msg37*37,msgsent37*37
  integer itone(79)
  integer*1 msgbits(77)

  msg37=''; msg37=trim(mycall)//' AA1AAA FN25'
  i3=-1; n3=-1
  call genft8var(msg37,i3,n3,0,msgsent37,msgbits,itone)
  idtonemyc(1:29)=itone(8:36); idtonemyc(30:58)=itone(44:72)
 
  return
end subroutine tone8myc

program call_to_c28
  parameter (NTOKENS=2063592,MAX22=4194304)
  character*6 call_std
  character a1*37,a2*36,a3*10,a4*27
  data a1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a3/'0123456789'/
  data a4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
 ! call_std must be right adjusted, length 6
  call_std=' K1ABC'              !Redefine as needed
  i1=index(a1,call_std(1:1))-1
  i2=index(a2,call_std(2:2))-1
  i3=index(a3,call_std(3:3))-1
  i4=index(a4,call_std(4:4))-1
  i5=index(a4,call_std(5:5))-1
  i6=index(a4,call_std(6:6))-1
  n28=NTOKENS + MAX22 + 36*10*27*27*27*i1 + 10*27*27*27*i2 + &
       27*27*27*i3 + 27*27*i4 + 27*i5 + i6
  write(*,1000) call_std,n28
1000 format('Callsign: ',a6,2x,'c28 as decimal integer:',i10)
end program call_to_c28

subroutine encode_128_90(message77,codeword)
!
! Add a 13-bit CRC to a 77-bit message and return a 128-bit codeword
!
use, intrinsic :: iso_c_binding
use iso_c_binding, only: c_loc,c_size_t
use crc

integer, parameter:: N=128, K=90, M=N-K
character*90 tmpchar
integer*1 codeword(N)
integer*1 gen(M,K)
integer*1 message77(77),message(K)
integer*1 pchecks(M)
integer*1, target :: i1MsgBytes(12)
include "ldpc_128_90_generator.f90"
logical first
data first/.true./
save first,gen

if( first ) then ! fill the generator matrix
  gen=0
  do i=1,M
    do j=1,23
      read(g(i)(j:j),"(Z1)") istr
        ibmax=4
        if(j.eq.23) ibmax=2 
        do jj=1, ibmax 
          icol=(j-1)*4+jj
          if( btest(istr,4-jj) ) gen(i,icol)=1
        enddo
    enddo
  enddo
first=.false.
endif

! Add 13 bit CRC to form 90-bit message+CRC13
write(tmpchar,'(77i1)') message77
tmpchar(78:80)='000'
i1MsgBytes=0
read(tmpchar,'(10b8)') i1MsgBytes(1:10)
ncrc13 = crc13 (c_loc (i1MsgBytes), 12)
write(tmpchar(78:90),'(b13)') ncrc13
read(tmpchar,'(90i1)') message

do i=1,M
  nsum=0
  do j=1,K 
    nsum=nsum+message(j)*gen(i,j)
  enddo
  pchecks(i)=mod(nsum,2)
enddo

codeword(1:K)=message
codeword(K+1:N)=pchecks

return
end subroutine encode_128_90

program echosim

! Generate simulated echo-mode files -- self-echo or "measure" 

  use wavhdr
  parameter (NWAVE=27648,NMAX=32768,NZ=36000)
  type(hdr) h                            !Header for .wav file
  character arg*12,fname*17
  complex c0(0:NMAX-1)
  complex c(0:NMAX-1)
  real*4 level_1,level_2
  real*8 f0,dt,twopi,phi,dphi
  real wave(NZ)
  integer*2 iwave(NZ)                  !Generated full-length waveform
  equivalence (nDop0,iwave(1))
  equivalence (nDopAudio0,iwave(3))
  equivalence (nfrit0,iwave(5))
  equivalence (f10,iwave(7))
  equivalence (fspread0,iwave(9))

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.3 .and. nargs.ne.5) then
     print*,'Usage 1:  echosim   f0   fdop fspread nfiles snr'
     print*,'Example:  echosim  1500   0.0   4.0     10   -22'
     print*,'Usage 2:  echosim level_1 level_2 nfiles'
     print*,'Example:  echosim   30.0    40.0   100'
     go to 999
  endif

  call getarg(1,arg)
  read(arg,*) f0                         !Tone frequency
  call getarg(2,arg)
  read(arg,*) fdop                       !Doppler shift (Hz)
  call getarg(3,arg)
  read(arg,*) fspread             !Frequency spread (Hz) (JHT Lorentzian model)

  if(nargs.eq.3) then
     level_1=f0
     level_2=fdop
     nfiles=fspread
     snrdb=0.
     go to 10
  endif
  
  call getarg(4,arg)
  read(arg,*) nfiles                     !Number of files
  call getarg(5,arg)
  read(arg,*) snrdb                      !SNR_2500

10 twopi=8.d0*atan(1.d0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.d0/fs                              !Sample interval (s)
  bandwidth_ratio=2500.0/(fs/2.0)
  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
  if(snrdb.gt.90.0) sig=1.0
  dphi=twopi*(f0+fdop)*dt

  write(*,1000)
1000 format('   N   f0     fDop fSpread   SNR  File name'/51('-'))

  do ifile=1,nfiles
     wave=0.

     if(nargs.eq.5) then
        phi=0.d0
        do i=0,NWAVE-1
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           c0(i)=cmplx(cos(xphi),sin(xphi))
        enddo
        c0(NWAVE:)=0.
        if(fspread.gt.0.0) call fspread_lorentz(c0,fspread)
        c=sig*c0
        wave(1:NWAVE)=imag(c(1:NWAVE))
        peak=maxval(abs(wave))
     endif

     if(snrdb.lt.90) then
        do i=1,NWAVE                   !Add gaussian noise at specified SNR
           xnoise=gran()
           wave(i)=wave(i) + xnoise
        enddo
        do i=NWAVE+1,NZ
           xnoise=gran()
           wave(i)=xnoise
        enddo
     endif

     gain=100.0
     if(nargs.eq.3) then
        gain=10.0**(0.05*level_1)
        if(mod((ifile-1)/10,2).eq.1) gain=10.0**(0.05*level_2)
     endif
     if(snrdb.lt.90.0) then
       wave=gain*wave
     else
       datpk=maxval(abs(wave))
       fac=32766.9/datpk
       wave=fac*wave
     endif
     if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave=nint(wave)

     nDop0=nint(fdop)
     nDopAudio0=0
     nfrit0=0
     f10=f0 + fdop
     fspread0=fspread
     
     h=default_header(12000,NMAX)
     n=3*(ifile-1)
     ihr=n/3600
     imin=(n-3600*ihr)/60
     isec=mod(n,60)
     write(fname,1102) ihr,imin,isec
1102 format('000000_',3i2.2,'.wav')
     open(10,file=fname,status='unknown',access='stream')
     write(10) h,iwave                !Save to *.wav file
     close(10)
     write(*,1110) ifile,f0,fdop,fspread,snrdb,fname
1110 format(i4,4f7.1,2x,a17)
  enddo

999 end program echosim

subroutine read_qm(fname,iret)

  include 'njunk.f90'
  parameter(NMAX=60*96000,NFFT=32768)
  character*(*) fname
  character prog_id*24,mycall*12,mygrid*6
  real*8 fcenter
  integer nxtra(15)                        !For possible future additions
  integer*1 id1(2,NMAX)
  common/datcom/dd(2,5760000),ss(400,NFFT),savg(NFFT),                  &
       fcenter,nutc,fselected,mousedf,mousefqso,nagain,                 &
       ndepth,ndiskdat,ntx60,newdat,nn1,nn2,nfcal,nfshift,              &
       ntx30a,ntx30b   !...

  open(28,file=trim(fname),status='old',access='stream',err=900)
  read(28,end=910) prog_id,mycall,mygrid,fcenter,nutc,ntx30a,           &
       ntx30b,ndop00,ndop58,ia,ib,fac0,nxtra
  iret=3
  if(ib.eq.NMAX/2) iret=1
  if(ia.eq.NMAX/2+1) iret=2
  fac=1.0
  if(fac0.gt.0.0) fac=1.0/fac0
  id1=0
  read(28,end=910) id1(1:2,ia:ib)
  dd=0.
  dd(1:2,ia:ib)=fac*id1(1:2,ia:ib)   !Boost back to previous level
  go to 999

900 iret=-1; go to 999
910 iret=-2

999 close(28)

!  sq1=0.
!  sq2=0.
!  NH=NMAX/2
!  do i=1,NMAX
!     if(i.le.NH) sq1=sq1 + dd(1,i)*dd(1,i) + dd(2,i)*dd(2,i)
!     if(i.gt.NH) sq2=sq2 + dd(1,i)*dd(1,i) + dd(2,i)*dd(2,i)
!  enddo
!  print*,'B',sqrt(sq1/NMAX),sqrt(sq2/NMAX)

  return
end subroutine read_qm

subroutine freqcal(id2,k,nkhz,noffset,ntol,line)

  parameter (NZ=30*12000,NFFT=55296,NH=NFFT/2)
  integer*2 id2(0:NZ-1)
  complex sp,sn
  real x(0:NFFT-1)
  real xi(0:NFFT-1)
  real w(0:NFFT-1)                      !Window function
  real s(0:NH)
  character line*80,cflag*1
  logical first
  complex cx(0:NH)
  equivalence (x,cx)
  data n/0/,k0/9999999/,first/.true./
  save n,k0,w,first,pi,fs,xi

  if(first) then
     pi=4.0*atan(1.0)
     fs=12000.0
     do i=0,NFFT-1
        ww=sin(i*pi/NFFT)
        w(i)=ww*ww/NFFT
        xi(i)=2.0*pi*i
     enddo
     first=.false.
  endif
  
  if(k.lt.NFFT) go to 900
  if(k.lt.k0) n=0
  k0=k
     
  x=w*id2(k-NFFT:k-1)              !Apply window
  call four2a(x,NFFT,1,-1,0)       !Compute spectrum, r2c
  df=fs/NFFT
  if (ntol.gt.noffset) then
     ia=0
     ib=nint((noffset*2)/df)
  else
     ia=nint((noffset-ntol)/df)
     ib=nint((noffset+ntol)/df)
  endif
  smax=0.
  s=0.
  ipk=-99
  do i=ia,ib
     s(i)=real(cx(i))**2 + aimag(cx(i))**2
     if(s(i).gt.smax) then
        smax=s(i)
        ipk=i
     endif
  enddo

  if(ipk.ge.1) then
    call peakup(s(ipk-1),s(ipk),s(ipk+1),dx)
    fpeak=df * (ipk+dx)
    ap=(fpeak/fs+1.0/(2.0*NFFT))
    an=(fpeak/fs-1.0/(2.0*NFFT))
    sp=sum(id2((k-NFFT):k-1)*cmplx(cos(xi*ap),-sin(xi*ap)))
    sn=sum(id2((k-NFFT):k-1)*cmplx(cos(xi*an),-sin(xi*an)))
    fpeak=fpeak+fs*(abs(sp)-abs(sn))/(abs(sp)+abs(sn))/(2*NFFT)
    xsum=0.
    nsum=0
    do i=ia,ib
       if(abs(i-ipk).gt.10) then
          xsum=xsum+s(i)
          nsum=nsum+1
       endif
    enddo
    ave=xsum/nsum
    snr=db(smax/ave)
    pave=db(ave) + 8.0
  else
    snr=-99.9
    pave=-99.9
    fpeak=-99.9
    ferr=-99.9
  endif
  cflag=' '
  if(snr.lt.20.0) cflag='*'
  n=n+1
  nsec=mod(time(),86400)
  nhr=nsec/3600
  nmin=mod(nsec/60,60)
  nsec=mod(nsec,60)
  ncal=1
  ferr=fpeak-noffset
  write(line,1100)  nhr,nmin,nsec,nkhz,ncal,noffset,fpeak,ferr,pave,   &
            snr,cflag,char(0)
1100 format(i2.2,':',i2.2,':',i2.2,i7,i3,i6,2f10.3,2f7.1,2x,a1,a1)

900 return
end subroutine freqcal

subroutine genmsk40(msg,msgsent,ichk,itone,itype)

  use hashing
  character*37 msg,msgsent,hashmsg
  character*4 crpt,rpt(0:15)
  logical first
  integer*4 itone(144)
  integer*1 message(16),codeword(32),bitseq(40)
  integer*1 s8r(8)
  data s8r/1,0,1,1,0,0,0,1/   ! Sync word is reversed wrt msk144 sync word.
  data first/.true./
  data rpt/"-03 ","+00 ","+03 ","+06 ","+10 ","+13 ","+16 ", &
           "R-03","R+00","R+03","R+06","R+10","R+13","R+16", &
           "RRR ","73  "/
  save first,rpt

  itype=-1
  msgsent='*** bad message ***'
  itone=0
  i1=index(msg,'>')
  if(i1.lt.9) go to 900
  call fmtmsg(msg,iz)
  crpt=msg(i1+2:i1+5)
  do i=0,15
     if(crpt.eq.rpt(i)) go to 10
  enddo
  go to 900

10 irpt=i                                   !Report index, 0-15
  if(ichk.lt.10000) then
     hashmsg=msg(2:i1-1)
     call hash(hashmsg,37,ihash)          
     ihash=iand(ihash,4095)                 !12-bit hash 
     ig=16*ihash + irpt                     !4-bit report 
  else
     ig=ichk-10000
  endif

  do i=1,16
    message(i)=iand(1,ishft(ig,1-i))
  enddo

  call encode_msk40(message,codeword)
!  write(*,'(a6,i6,2x,a6,i6,2x,a6,i6)') ' msg: ',ig,'rprt: ',irpt,'hash: ',ihash
!  write(*,'(a6,32i1)') '  cw: ',codeword

  bitseq(1:8)=s8r
  bitseq(9:40)=codeword
  bitseq=2*bitseq-1

! Map I and Q  to tones.
  itone=0
  do i=1, 20
    itone(2*i-1)=(bitseq(2*i)*bitseq(2*i-1)+1)/2;
    itone(2*i)=-(bitseq(2*i)*bitseq(mod(2*i,40)+1)-1)/2;
  enddo

! Flip polarity
  itone=-itone+1 

  msgsent=msg
  itype=7

900 return
end subroutine genmsk40

program cablog

  character*100 line,infile,outfile
  character cband*4,cmode*2,cdate*10,cutc*4,callsign*10,mycall*10
  character csent*4,crcvd*4,dsent*4,drcvd*4,g1*4
  character*3 cmo(12)
  integer icomma(20)
  logical map65
  logical isgrid,gridx
  data cmo/'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep',   &
           'Oct','Nov','Dec'/

  isgrid(g1)=g1(1:1).ge.'A' .and. g1(1:1).le.'R' .and. g1(2:2).ge.'A' .and. &
       g1(2:2).le.'R' .and. g1(3:3).ge.'0' .and. g1(3:3).le.'9' .and.       &
       g1(4:4).ge.'0' .and. g1(4:4).le.'9' .and. g1(1:4).ne.'RR73'

  nargs=iargc()
  if(nargs.ne.4) then
     print*,"Program cablog converts file 'wsjtx.log' written by WSJT-X"
     print*,"(or wsjt.log written by MAP65) to a bare-bones Cabrillo"
     print*,"log for the ARRL International EME Contest. You will"
     print*,"certainly need to edit the header information, and you may"
     print*,"edit the log elsewhere as required."
     print*,' '
     print*,'Usage:    cablog <MyCall> <sent> <rcvd> <infile>'
     print*,'Examples: cablog   W2ZQ    -15    -16  wsjtx.log'
     print*,'          cablog   W2ZQ     O      O   wsjt.log'
     go to 999
  endif
  call getarg(1,mycall)
  outfile=trim(mycall)//'.log'
  call getarg(2,dsent)
  gridx=isgrid(dsent)
  call getarg(3,drcvd)
  call getarg(4,infile)
  open(10,file=trim(infile),status='old')
  open(12,file=trim(outfile),status='unknown')

  write(12,1000)
1000 format('START-OF-LOG: 3.0'/           &
          'CONTEST: ARRL-EME'/             &
          'CALLSIGN: '/                    &
          'CATEGORY-OPERATOR: '/           &
          'CATEGORY-BAND: '/               &
          'CATEGORY-MODE: '/               &
          'EMAIL: '/                       &
          'OPERATORS: '/                   &
          'CATEGORY-POWER: HIGH'/          &
          'CATEGORY-TRANSMITTER: ONE'/     &
          'CATEGORY-STATION: FIXED'/       &
          'CATEGORY-TIME: 24-HOURS'/       &
          'CATEGORY-ASSISTED: ASSISTED'/   &
          'LOCATION: SNJ'/                 &
          'CLAIMED-SCORE: '/               &
          'CLUB: '/                        &
          'NAME: '/                        &
          'ADDRESS: '/                     &
          'ADDRESS: '/                     &
          'ADDRESS: '/                     &
          'CREATED-BY: cablog (C) K1JT')        

  n=0
  map65=.false.
  
  do nn=1,9999
     read(10,'(a100)',end=900) line
     if(len(trim(line)).eq.0) cycle
     if(line(6:6).ge.'A' .and. line(6:6).le.'Z') map65=.true.
     n=n+1
     k=0
     do j=1,100
        if(line(j:j).eq.',') then
           k=k+1
           icomma(k)=j
        endif
     enddo
     cmode='DG'
     if(index(line,',CW,').gt.10) cmode='CW'

     if(map65) then
        do i=1,12
           if(cmo(i).eq.line(6:8)) write(cdate(6:7),'(i2.2)') i
        enddo
        cdate(1:5)=line(1:5)
        cdate(8:10)=line(9:11)
        cutc=line(13:14)//line(16:17)
        i0=index(line(19:),',')
        callsign=line(19:17+i0)
        cband='144 '
        csent=dsent
        crcvd=drcvd
     else
        cdate=line(1:10)
        cutc=line(32:33)//line(35:36)
        i0=index(line(41:),',')
        callsign=line(41:39+i0)
        read(line(icomma(6)+1:icomma(7)-1),*,err=10,end=10) freq
        go to 20
10      print*,'***Error at line ',n
        print*,trim(line)     
20      if(freq.ge.50.0 .and. freq.le.54.0) cband='50  '
        if(freq.ge.144.0 .and. freq.le.148.0) cband='144 '
        if(freq.ge.28.0 .and. freq.le.29.0) cband='144 '
        if(freq.ge.222.0 .and. freq.le.225.0) cband='222 '
        if(freq.ge.420.0 .and. freq.le.450.0) cband='432 '
        if(freq.ge.902.0 .and. freq.le.928.0) cband='902 '
        if(freq.ge.1240.0 .and. freq.le.1300.0) cband='1.2G'
        if(freq.ge.2300.0 .and. freq.le.2450.0) cband='2.3G'
        if(freq.ge.3300.0 .and. freq.le.3500.0) cband='3.4G'
        if(freq.ge.5650.0 .and. freq.le.5925.0) cband='5.7G'
        if(freq.ge.10000.0 .and. freq.le.10500.0) cband='10G '
        if(freq.ge.24000.0 .and. freq.le.24250.0) cband='24G '
        if(icomma(8).eq.icomma(9)-1) then
           csent=dsent
        else
           csent=line(icomma(8)+1:icomma(9)-1)
        endif
        if(icomma(9).eq.icomma(10)-1) then
           crcvd=drcvd
        else
           crcvd=line(icomma(9)+1:icomma(10)-1)
        endif
     endif
     if(gridx) then
        csent=dsent
        crcvd=line(icomma(5)+1:icomma(6)-1)
     endif
     
     write(12,1030) cband,cmode,cdate,cutc,mycall,csent,callsign,crcvd
1030 format('QSO: ',a4,1x,a2,1x,a10,1x,a4,1x,a6,1x,a4,4x,a10,1x,a4)
  enddo

900 write(12,1900)
1900 format('END-OF-LOG:')
  write(*,1910) n,trim(outfile)
1910 format('Processed',i5,' QSOs.'/'Output file: ',a)

999 end program cablog
     
!2023-10-28,00:17:00,2023-10-28,00:21:00,G7TZZ,IO92,1296.083100,Q65,-17,-17,,,,
!2023-Nov-30,20:31,W8WN,EM77,0,Q65A
  

module afc65b_mod
  implicit none
contains  

subroutine afc65b(cx,cy,npts,fsample,nflip,ipol,xpol,ndphi,a,ccfbest,dtbest)
  use debug_log
  use fchisq_mod
  
  implicit none
 
  logical            :: xpol
  integer            :: npts, nflip, ipol, ndphi
  complex            :: cx(npts), cy(npts)
  real               :: a(5), deltaa(5)
  integer            :: iter, j, nterms
  real               :: ccfbest, dtbest
  real               :: chisq1, chisq2, chisq3, chisqr, chisqr0
  real               :: delta, dtmax, fn, tmp
  real               :: fsample, ccfmax

  ! Initial parameter guesses
  a(1) = 0.0
  a(2) = 0.0
  a(3) = 0.0
  if (ipol < 1 .or. ipol > 4) ipol = 1
  a(4) = 45.0*(ipol - 1.0)

  deltaa(1) = 2.0
  deltaa(2) = 2.0
  deltaa(3) = 2.0
  deltaa(4) = 22.5
  deltaa(5) = 0.05

  nterms = 3
  if (xpol) nterms = 4

  ! Don't fit polarization when solving for dphi
  if (ndphi /= 0) nterms = 3

  ! Start the iteration
  chisqr  = 0.0
  chisqr0 = 1.0e6
  
  do iter = 1, 3                      ! One iteration is enough?
     do j = 1, nterms
        chisq1 = fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
        fn     = 0.0
        delta  = deltaa(j)

        ! Find first step where chisq changes
        do
           a(j)   = a(j) + delta
           chisq2 = fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
           if (chisq2 /= chisq1) exit
        end do

        ! If we stepped uphill, reverse direction and swap labels
        if (chisq2 > chisq1) then
           delta  = -delta
           a(j)   = a(j) + delta
           tmp    = chisq1
           chisq1 = chisq2
           chisq2 = tmp
        endif

        ! Walk while chisq keeps improving
        do
           fn    = fn + 1.0
           a(j)  = a(j) + delta
           chisq3 = fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
           if (chisq3 < chisq2) then
              chisq1 = chisq2
              chisq2 = chisq3
           else
              exit
           endif
        end do

        ! Guard against division by zero in flat regions
        if (chisq3 == chisq2) cycle

        ! Find minimum of parabola defined by last three points
        delta     = delta*(1.0/(1.0 + (chisq1 - chisq2)/(chisq3 - chisq2)) + 0.5)
        a(j)      = a(j) - delta
        deltaa(j) = deltaa(j)*fn/3.0
     enddo

     chisqr = fchisq(cx,cy,npts,fsample,nflip,a,ccfmax,dtmax)
     if (chisqr/chisqr0 > 0.9999) exit
     chisqr0 = chisqr
  enddo

  ccfbest = ccfmax * (1378.125/fsample)**2
  dtbest  = dtmax

  ! Wrap polarization angle into [0,180)
  if (a(4) < 0.0)   a(4) = a(4) + 180.0
  if (a(4) >= 180.) a(4) = a(4) - 180.0
  if (nint(a(4)) == 180) a(4) = 0.0

  if (a(4) < 0.0 .or. a(4) >= 180.0) then
     print *, 'afc65b: bad a(4) after wrap, set to 0. was ', a(4)
     a(4) = 0.0
  endif

  ipol = nint(a(4)/45.0) + 1
  if (ipol > 4) ipol = ipol - 4
  
end subroutine afc65b

end module afc65b_mod

subroutine encode_msk40(message,codeword)
! Encode a 16-bit message and return a 32-bit codeword. 
! The code is a (32,16) regular ldpc code with column weight 3.
! The code was generated using the PEG algorithm.
! After creating the codeword, the columns are re-ordered according to 
! "colorder" to make the codeword compatible with the parity-check
! matrix stored in Radford Neal's "pchk" format.
!
integer*1 codeword(32)
integer*1 colorder(32)
integer g(16)
integer*1 gen40(16,16)
integer*1 itmp(32)
integer*1 message(16)
integer*1 pchecks(16)
logical first
data first/.true./
data g/Z'4428',Z'5a6b',Z'1b04',Z'2c12',Z'60c4',Z'1071',Z'be6a',Z'36dd', &
       Z'c580',Z'ad9a',Z'eca2',Z'7843',Z'332e',Z'a685',Z'5906',Z'1efe'/
data colorder/4,1,2,3,0,8,6,10,13,28,20,23,17,15,27,25, &
             16,12,18,19,7,21,22,11,24,5,26,14,9,29,30,31/
save first,gen40

if( first ) then ! fill the generator matrix
  gen40=0
  do i=1,16
    do j=1,16
      if( btest(g(i),16-j) ) gen40(i,j)=1
    enddo
  enddo
  first=.false.
endif

do i=1,16
  nsum=0
  do j=1,16
    nsum=nsum+message(j)*gen40(i,j)
  enddo
  pchecks(i)=mod(nsum,2)
enddo
itmp(1:16)=pchecks
itmp(17:32)=message(1:16)
codeword(colorder+1)=itmp(1:32)

return
end subroutine encode_msk40

subroutine genwave(itone,nsym,nsps,nwave,fsample,hmod,f0,icmplx,cwave,wave)

  real wave(nwave)
  complex cwave(nwave)
  integer hmod
  integer itone(nsym)
  logical ex
  real*8 dt,phi,dphi,twopi,freq,baud

  dt=1.d0/fsample
  twopi=8.d0*atan(1.d0)
  baud=fsample/nsps

! Calculate the audio waveform
  phi=0.d0
  if(icmplx.le.0) wave=0.
  if(icmplx.eq.1) cwave=0.
  k=0
  do j=1,nsym
     freq=f0 + itone(j)*hmod*baud
     dphi=twopi*freq*dt
     do i=1,nsps
        k=k+1
        if(icmplx.eq.1) then
           cwave(k)=cmplx(cos(phi),sin(phi))
        else
           wave(k)=sin(phi)
        endif
        phi=phi+dphi
        if(phi.gt.twopi) phi=phi-twopi
     enddo
  enddo

!### TEMPORARY code to allow transmitting both A and B submodes
  inquire(file='Q65_Tx2',exist=ex)
  if(ex) then
     k=0
     do j=1,nsym
        freq=f0 + itone(j)*2.d0*hmod*baud + 500.d0
        dphi=twopi*freq*dt
        do i=1,nsps
           k=k+1
           wave(k)=0.5*(wave(k)+sin(phi))
           phi=phi+dphi
           if(phi.gt.twopi) phi=phi-twopi
        enddo
     enddo
  endif
!###

  return
end subroutine genwave

  use, intrinsic :: iso_c_binding, only: c_int, c_short, c_float, c_char, c_bool

  include 'constants.f90'

  !
  ! these structures must be kept in sync with ../commons.h
  !
  type, bind(C) :: params_block
     integer(c_int) :: nutc
     logical(c_bool) :: ndiskdat
     integer(c_int) :: ntr
     integer(c_int) :: nQSOProgress ! See MainWindow::m_QSOProgress for values
     integer(c_int) :: nfqso
     integer(c_int) :: nftx
     logical(c_bool) :: newdat
     integer(c_int) :: npts8
     integer(c_int) :: nfa
     integer(c_int) :: nfsplit
     integer(c_int) :: nfb
     integer(c_int) :: ntol
     integer(c_int) :: kin
     integer(c_int) :: nzhsym
     integer(c_int) :: nsubmode
     logical(c_bool) :: nagain
     integer(c_int) :: ndepth
     logical(c_bool) :: lft8apon 
     logical(c_bool) :: lapcqonly
     logical(c_bool) :: ljt65apon 
     integer(c_int) :: napwid
     integer(c_int) :: ntxmode
     integer(c_int) :: nmode
     integer(c_int) :: minw
     logical(c_bool) :: nclearave
     integer(c_int) :: minsync
     real(c_float) :: emedelay
     real(c_float) :: dttol
     integer(c_int) :: nlist
     integer(c_int) :: listutc(10)
     integer(c_int) :: n2pass
     integer(c_int) :: nranera
     integer(c_int) :: naggressive
     logical(c_bool) :: nrobust
     integer(c_int) :: nexp_decode
     integer(c_int) :: max_drift
     character(kind=c_char) :: datetime(20)
     character(kind=c_char) :: mycall(12)
     character(kind=c_char) :: mygrid(6)
     character(kind=c_char) :: hiscall(12)
     character(kind=c_char) :: hisgrid(6)
     logical(c_bool) :: b_even_seq
     logical(c_bool) :: b_superfox
     integer(c_int) :: yymmdd
  end type params_block

  type, bind(C) :: dec_data
     integer(c_int) :: ipc(3)
     real(c_float) :: ss(184,NSMAX)
     real(c_float) :: savg(NSMAX)
     real(c_float) :: sred(5760)
     integer(c_short) :: id2(NMAX)
     type(params_block) :: params
  end type dec_data

program fersum

  character mode*5
  character infile*40
  real dop(0:9)
  real thresh(0:9,12),threshsync(0:9,12)
  data dop/0.25,0.5,1.0,2.0,4.0,8.0,16.0,32.0,64.0,128.0/

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: fersum <infile>'
     go to 999
  endif
  call getarg(1,infile)
  open(10,file=infile,status='old')
  thresh=0.
  threshsync=0.

  do iblk=1,999
1    read(10,1002,end=100) mode,iters,ntot,naggr,d,navg,nds
1002 format(a5,8x,i5,4x,i6,7x,i3,6x,f6.2,17x,i3,5x,i2)
     write(33,*) iblk,mode
     if(mode.eq.'     ') go to 1
     read(10,1002)
     read(10,1002)
     read(10,1002)

     nsync0=0
     ngood0=0
     xsum0=0.
     do n=1,99
        read(10,1010,end=100) snr,nsync,ngood,nbad,xsync,esync,dsnr,esnr,   &
             xdt,edt,dfreq,efreq,xsum,esum,xwidth,ewidth
1010    format(f5.1,2i6i4,2f6.1,f6.1,f5.1,f6.2,f5.2,6f5.1)
        if(snr.eq.0.0) exit
        if(mode(5:5).eq.'A') nmode=1
        if(mode(5:5).eq.'B') nmode=2
        if(mode(5:5).eq.'C') nmode=3
        j=nint(log(d)/log(2.0) + 2.0)
        if(navg.eq.1 .and. nds.eq.0) k=nmode
        if(navg.eq.1 .and. nds.eq.1) k=nmode+3
        if(navg.gt.1 .and. nds.eq.0) k=nmode+6
        if(navg.gt.1 .and. nds.eq.1) k=nmode+9
        if(nsync0.le.iters/2 .and. nsync.ge.iters/2) then
           threshsync(j,k)=snr-float(nsync-iters/2)/(nsync-nsync0)
        endif
        if(ngood0.le.iters/2 .and. ngood.ge.iters/2) then
           threshold=snr-float(ngood-iters/2)/(ngood-ngood0)
           xsumavg=max(1.0,0.5*(xsum0+xsum))
!           write(*,1020) mode,iters,ntot,naggr,d,navg,nds,threshold,xsumavg
!1020       format(a5,i7,i7,i3,f7.2,i3,i3,f7.1,f6.1)
           thresh(j,k)=threshold
        endif
        nsync0=nsync
        ngood0=ngood
        xsum0=xsum
     enddo
  enddo

100 write(12,1100)
1100 format(' ')
  do i=0,9
     write(12,1110) dop(i),thresh(i,1:12)
1110 format(f6.2,13f6.1)
  enddo

  write(12,1110)
  do i=0,9
     write(12,1110) dop(i),threshsync(i,1:12)
  enddo

999 end program fersum

module ft4_decode

   type :: ft4_decoder
      procedure(ft4_decode_callback), pointer :: callback
   contains
      procedure :: decode
   end type ft4_decoder

   abstract interface
      subroutine ft4_decode_callback (this,sync,snr,dt,freq,decoded,nap,qual)
         import ft4_decoder
         implicit none
         class(ft4_decoder), intent(inout) :: this
         real, intent(in) :: sync
         integer, intent(in) :: snr
         real, intent(in) :: dt
         real, intent(in) :: freq
         character(len=37), intent(in) :: decoded
         integer, intent(in) :: nap
         real, intent(in) :: qual
      end subroutine ft4_decode_callback
   end interface

contains

   subroutine decode(this,callback,iwave,nQSOProgress,nfqso,    &
      nfa,nfb,ndepth,lapcqonly,ncontest,mycall,hiscall)
      use timer_module, only: timer
      use packjt77
      include 'ft4/ft4_params.f90'
      parameter (MAXCAND=200)
      class(ft4_decoder), intent(inout) :: this
      procedure(ft4_decode_callback) :: callback
      parameter (NSS=NSPS/NDOWN,NDMAX=NMAX/NDOWN)
      character message*37,msgsent*37
      character c77*77
      character*37 decodes(100)
      character*17 cdatetime0
      character*12 mycall,hiscall
      character*12 mycall0,hiscall0
      character*6 hhmmss

      complex cd2(0:NDMAX-1)                  !Complex waveform
      complex cb(0:NDMAX-1)
      complex cd(0:NN*NSS-1)                       !Complex waveform
      complex ctwk(2*NSS),ctwk2(2*NSS,-16:16)

      real a(5)
      real bitmetrics(2*NN,3)
      real dd(NMAX)
      real llr(2*ND),llra(2*ND),llrb(2*ND),llrc(2*ND),llrd(2*ND)
      real candidate(2,MAXCAND)
      real savg(NH1),sbase(NH1)

      integer apbits(2*ND)
      integer apmy_ru(28),aphis_fd(28)
      integer*2 iwave(NMAX)                 !Raw received data
      integer*1 message77(77),rvec(77),apmask(2*ND),cw(2*ND)
      integer*1 message91(91)
      integer*1 hbits(2*NN)
      integer i4tone(103)
      integer nappasses(0:5)    ! # of decoding passes for QSO States 0-5
      integer naptypes(0:5,4)   ! nQSOProgress, decoding pass
      integer mcq(29),mcqru(29),mcqfd(29),mcqtest(29),mcqww(29)
      integer mrrr(19),m73(19),mrr73(19)

      logical nohiscall,unpk77_success
      logical first, dobigfft
      logical dosubtract,doosd
      logical badsync
      logical, intent(in) :: lapcqonly

      data first/.true./
      data     mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
      data   mcqru/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,0,0,1,1,0,0/
      data   mcqfd/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,1,0,0,0,1,0/
      data mcqtest/0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,0,1,0,1,1,1,1,1,1,0,0,1,0/
      data   mcqww/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,1,1,1,1,0/      
      data    mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
      data     m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
      data   mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
      data rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
         1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
         0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/
      save fs,dt,tt,txt,twopi,h,first,apbits,nappasses,naptypes, &
         mycall0,hiscall0,ctwk2

      this%callback => callback
      hhmmss=cdatetime0(8:13)
      dxcall13=hiscall        ! initialize for use in packjt77
      mycall13=mycall

      smax1=0.
      nd1=0

      if(first) then
         fs=12000.0/NDOWN                !Sample rate after downsampling
         dt=1/fs                         !Sample interval after downsample (s)
         tt=NSPS*dt                      !Duration of "itone" symbols (s)
         txt=NZ*dt                       !Transmission length (s) without ramp up/down
         twopi=8.0*atan(1.0)
         h=1.0

         do idf=-16,16
            a=0.
            a(1)=real(idf)
            ctwk=1.
            call twkfreq1(ctwk,2*NSS,fs/2.0,a,ctwk2(:,idf))
         enddo

         mcq=2*mod(mcq+rvec(1:29),2)-1
         mcqru=2*mod(mcqru+rvec(1:29),2)-1
         mcqfd=2*mod(mcqfd+rvec(1:29),2)-1
         mcqtest=2*mod(mcqtest+rvec(1:29),2)-1
         mcqww=2*mod(mcqww+rvec(1:29),2)-1
         mrrr=2*mod(mrrr+rvec(59:77),2)-1
         m73=2*mod(m73+rvec(59:77),2)-1
         mrr73=2*mod(mrr73+rvec(59:77),2)-1
         nappasses(0)=2
         nappasses(1)=2
         nappasses(2)=2
         nappasses(3)=2
         nappasses(4)=2
         nappasses(5)=3

! iaptype
!------------------------
!   1        CQ     ???    ???           (29 ap bits)
!   2        MyCall ???    ???           (29 ap bits)
!   3        MyCall DxCall ???           (58 ap bits)
!   4        MyCall DxCall RRR           (77 ap bits)
!   5        MyCall DxCall 73            (77 ap bits)
!   6        MyCall DxCall RR73          (77 ap bits)
!********
         naptypes(0,1:4)=(/1,2,0,0/) ! Tx6 selected (CQ)
         naptypes(1,1:4)=(/2,3,0,0/) ! Tx1
         naptypes(2,1:4)=(/2,3,0,0/) ! Tx2
         naptypes(3,1:4)=(/3,6,0,0/) ! Tx3
         naptypes(4,1:4)=(/3,6,0,0/) ! Tx4
         naptypes(5,1:4)=(/3,1,2,0/) ! Tx5

         mycall0=''
         hiscall0=''
         first=.false.
      endif

      l1=index(mycall,char(0))
      if(l1.ne.0) mycall(l1:)=" "
      l1=index(hiscall,char(0))
      if(l1.ne.0) hiscall(l1:)=" "
      if(mycall.ne.mycall0 .or. hiscall.ne.hiscall0) then
         apbits=0
         apbits(1)=99
         apbits(30)=99
         apmy_ru=0
         aphis_fd=0

         if(len(trim(mycall)) .lt. 3) go to 10

         nohiscall=.false.
         hiscall0=hiscall
         if(len(trim(hiscall0)).lt.3) then
            hiscall0=mycall  ! use mycall for dummy hiscall - mycall won't be hashed.
            nohiscall=.true.
         endif
         message=trim(mycall)//' '//trim(hiscall0)//' RR73'
         i3=-1
         n3=-1
         call pack77(message,i3,n3,c77)
         call unpack77(c77,1,msgsent,unpk77_success)
         if(i3.ne.1 .or. (message.ne.msgsent) .or. .not.unpk77_success) go to 10
         read(c77,'(77i1)') message77
         apmy_ru=2*mod(message77(1:28)+rvec(2:29),2)-1
         aphis_fd=2*mod(message77(30:57)+rvec(29:56),2)-1
         message77=mod(message77+rvec,2)
         call encode174_91(message77,cw)
         apbits=2*cw-1
         if(nohiscall) apbits(30)=99

10       continue
         mycall0=mycall
         hiscall0=hiscall
      endif
      ndecodes=0
      decodes=' '
      fa=nfa
      fb=nfb
      dd=iwave

! ndepth=3: 3 passes, bp+osd
! ndepth=2: 3 passes, bp only
! ndepth=1: 1 pass, no subtraction

      max_iterations=40
      syncmin=1.18
      dosubtract=.true.
      doosd=.true.
      nsp=3
      if(ndepth.eq.2) then
         doosd=.false.
      endif
      if(ndepth.eq.1) then
         nsp=1
         dosubtract=.false.
         doosd=.false.
      endif

      do isp = 1,nsp
         if(isp.eq.2) then
            if(ndecodes.eq.0) exit
            nd1=ndecodes
         elseif(isp.eq.3) then
            nd2=ndecodes-nd1
            if(nd2.eq.0) exit
         endif

         candidate=0.0
         ncand=0
         call timer('getcand4',0)
         call getcandidates4(dd,fa,fb,syncmin,nfqso,MAXCAND,savg,candidate,   &
            ncand,sbase)
         call timer('getcand4',1)
         dobigfft=.true.
         do icand=1,ncand
            f0=candidate(1,icand)
            snr=candidate(2,icand)-1.0
            call timer('ft4_down',0)
            call ft4_downsample(dd,dobigfft,f0,cd2)  !Downsample to 32 Sam/Sym
            call timer('ft4_down',1)
            if(dobigfft) dobigfft=.false.
            sum2=sum(cd2*conjg(cd2))/(real(NMAX)/real(NDOWN))
            if(sum2.gt.0.0) cd2=cd2/sqrt(sum2)
! Sample rate is now 12000/18 = 666.67 samples/second
            do iseg=1,3                ! DT search is done over 3 segments
               do isync=1,2          
                  if(isync.eq.1) then
                     idfmin=-12
                     idfmax=12
                     idfstp=3
                     ibmin=-344
                     ibmax=1012
                     if(iseg.eq.1) then
                        ibmin=108
                        ibmax=560
                     elseif(iseg.eq.2) then
                        smax1=smax
                        ibmin=560
                        ibmax=1012
                     elseif(iseg.eq.3) then
                        ibmin=-344
                        ibmax=108
                     endif
                     ibstp=4
                  else
                     idfmin=idfbest-4
                     idfmax=idfbest+4
                     idfstp=1
                     ibmin=ibest-5
                     ibmax=ibest+5
                     ibstp=1
                  endif
                  ibest=-1
                  idfbest=0
                  smax=-99.
                  call timer('sync4d  ',0)
                  do idf=idfmin,idfmax,idfstp
                     do istart=ibmin,ibmax,ibstp
                        call sync4d(cd2,istart,ctwk2(:,idf),1,sync)  !Find sync power
                        if(sync.gt.smax) then
                           smax=sync
                           ibest=istart
                           idfbest=idf
                        endif
                     enddo
                  enddo
                  call timer('sync4d  ',1)
               enddo
               if(iseg.eq.1) smax1=smax
               if(smax.lt.1.2) cycle
               if(iseg.gt.1 .and. smax.lt.smax1) cycle 
               f1=f0+real(idfbest)
               if( f1.le.10.0 .or. f1.ge.4990.0 ) cycle
               call timer('ft4down ',0)
               call ft4_downsample(dd,dobigfft,f1,cb) !Final downsample, corrected f0
               call timer('ft4down ',1)
               sum2=sum(abs(cb)**2)/(real(NSS)*NN)
               if(sum2.gt.0.0) cb=cb/sqrt(sum2)
               cd=0.
               if(ibest.ge.0) then
                  it=min(NDMAX-1,ibest+NN*NSS-1)
                  np=it-ibest+1
                  cd(0:np-1)=cb(ibest:it)
               else
                  cd(-ibest:ibest+NN*NSS-1)=cb(0:NN*NSS+2*ibest-1)
               endif
               call timer('bitmet  ',0)
               call get_ft4_bitmetrics(cd,bitmetrics,badsync)
               call timer('bitmet  ',1)
               if(badsync) cycle
               hbits=0
               where(bitmetrics(:,1).ge.0) hbits=1
               ns1=count(hbits(  1:  8).eq.(/0,0,0,1,1,0,1,1/))
               ns2=count(hbits( 67: 74).eq.(/0,1,0,0,1,1,1,0/))
               ns3=count(hbits(133:140).eq.(/1,1,1,0,0,1,0,0/))
               ns4=count(hbits(199:206).eq.(/1,0,1,1,0,0,0,1/))
               nsync_qual=ns1+ns2+ns3+ns4
               if(nsync_qual.lt. 20) cycle

               scalefac=2.83
               llra(  1: 58)=bitmetrics(  9: 66, 1)
               llra( 59:116)=bitmetrics( 75:132, 1)
               llra(117:174)=bitmetrics(141:198, 1)
               llra=scalefac*llra
               llrb(  1: 58)=bitmetrics(  9: 66, 2)
               llrb( 59:116)=bitmetrics( 75:132, 2)
               llrb(117:174)=bitmetrics(141:198, 2)
               llrb=scalefac*llrb
               llrc(  1: 58)=bitmetrics(  9: 66, 3)
               llrc( 59:116)=bitmetrics( 75:132, 3)
               llrc(117:174)=bitmetrics(141:198, 3)
               llrc=scalefac*llrc

               apmag=maxval(abs(llra))*1.1
               npasses=3+nappasses(nQSOProgress)
               if(lapcqonly) npasses=4
               if(ndepth.eq.1) npasses=3
               if(ncontest.ge.6) npasses=3  ! Don't support Fox and Hound
               do ipass=1,npasses
                  if(ipass.eq.1) llr=llra
                  if(ipass.eq.2) llr=llrb
                  if(ipass.eq.3) llr=llrc
                  if(ipass.le.3) then
                     apmask=0
                     iaptype=0
                  endif

                  if(ipass .gt. 3) then
                     llrd=llrc
                     iaptype=naptypes(nQSOProgress,ipass-3)
                     if(lapcqonly) iaptype=1

! ncontest=0 : NONE
!          1 : NA_VHF
!          2 : EU_VHF
!          3 : FIELD DAY
!          4 : RTTY
!          5 : WW_DIGI 
!          6 : FOX
!          7 : HOUND
!
! Conditions that cause us to bail out of AP decoding
                     napwid=50
                     if(ncontest.le.5 .and. iaptype.ge.3 .and. (abs(f1-nfqso).gt.napwid) ) cycle
                     if(iaptype.ge.2 .and. apbits(1).gt.1) cycle  ! No, or nonstandard, mycall
                     if(iaptype.ge.3 .and. apbits(30).gt.1) cycle ! No, or nonstandard, dxcall

                     if(iaptype.eq.1) then  ! CQ or CQ TEST or CQ FD or CQ RU or CQ WW 
                        apmask=0
                        apmask(1:29)=1
                        if( ncontest.eq.0 ) llrd(1:29)=apmag*mcq(1:29)
                        if( ncontest.eq.1 ) llrd(1:29)=apmag*mcqtest(1:29)
                        if( ncontest.eq.2 ) llrd(1:29)=apmag*mcqtest(1:29)
                        if( ncontest.eq.3 ) llrd(1:29)=apmag*mcqfd(1:29)
                        if( ncontest.eq.4 ) llrd(1:29)=apmag*mcqru(1:29) 
                        if( ncontest.eq.5 ) llrd(1:29)=apmag*mcqww(1:29) 
                     endif

                     if(iaptype.eq.2) then ! MyCall,???,???
                        apmask=0
                        if(ncontest.eq.0.or.ncontest.eq.1.or.ncontest.eq.5) then
                           apmask(1:29)=1
                           llrd(1:29)=apmag*apbits(1:29)
                        else if(ncontest.eq.2) then
                           apmask(1:28)=1
                           llrd(1:28)=apmag*apbits(1:28)
                        else if(ncontest.eq.3) then
                           apmask(1:28)=1
                           llrd(1:28)=apmag*apbits(1:28)
                        else if(ncontest.eq.4) then
                           apmask(2:29)=1
                           llrd(2:29)=apmag*apmy_ru(1:28)
                        endif
                     endif

                     if(iaptype.eq.3) then ! MyCall,DxCall,???
                        apmask=0
                        if(ncontest.eq.0.or.ncontest.eq.1.or.ncontest.eq.2.or.ncontest.eq.5) then
                           apmask(1:58)=1
                           llrd(1:58)=apmag*apbits(1:58)
                        else if(ncontest.eq.3) then ! Field Day
                           apmask(1:56)=1
                           llrd(1:28)=apmag*apbits(1:28)
                           llrd(29:56)=apmag*aphis_fd(1:28)
                        else if(ncontest.eq.4) then 
                           apmask(2:57)=1
                           llrd(2:29)=apmag*apmy_ru(1:28)
                           llrd(30:57)=apmag*apbits(30:57)
                        endif
                     endif

                     if(iaptype.eq.4 .or. iaptype.eq.5 .or. iaptype.eq.6) then
                        apmask=0
                        if(ncontest.le.5) then
                           apmask(1:77)=1   ! mycall, hiscall, RRR|73|RR73
                           if(iaptype.eq.6) llrd(1:77)=apmag*apbits(1:77)
                        endif
                     endif

                     llr=llrd
                  endif
                  message77=0
                  dmin=0.0

                  ndeep=2
                  maxosd=2  
                  if(abs(nfqso-f1).le.napwid) then
                     ndeep=2
                     maxosd=3
                  endif
                  if(.not.doosd) maxosd = -1
                  call timer('dec174_91 ',0)
                  Keff=91
                  call decode174_91(llr,Keff,maxosd,ndeep,apmask,message91,cw, &
                                    ntype,nharderror,dmin)
                  message77=message91(1:77)
                  call timer('dec174_91 ',1)

                  if(sum(message77).eq.0) cycle
                  if( nharderror.ge.0 ) then
                     message77=mod(message77+rvec,2) ! remove rvec scrambling
                     write(c77,'(77i1)') message77(1:77)
                     call unpack77(c77,1,message,unpk77_success)
                     if(.not.unpk77_success) exit
                     if(dosubtract) then
                        call get_ft4_tones_from_77bits(message77,i4tone)
                        dt=real(ibest)/666.67
                        call timer('subtract',0)
                        call subtractft4(dd,i4tone,f1,dt)
                        call timer('subtract',1)
                     endif
                     idupe=0
                     do i=1,ndecodes
                        if(decodes(i).eq.message) idupe=1
                     enddo
                     if(idupe.eq.1) exit
                     ndecodes=ndecodes+1
                     decodes(ndecodes)=message
                     if(snr.gt.0.0) then
                        xsnr=10*log10(snr)-14.8
                     else
                        xsnr=-21.0
                     endif
                     nsnr=nint(max(-21.0,xsnr))
                     xdt=ibest/666.67 - 0.5
                     qual=1.0-(nharderror+dmin)/60.0 
                     call this%callback(smax,nsnr,xdt,f1,message,iaptype,qual)
                     exit
                  endif
               enddo                      !Sequence estimation
               if(nharderror.ge.0) exit
            enddo                         !3 DT segments
         enddo                            !Candidate list
      enddo                               !Subtraction loop
      return
   end subroutine decode

end module ft4_decode

program psk_parse

  character line*256,callsign*12,callsign0*12,progname*30
  integer nc(6),ntot(6),nsingle(6)
  logical zap
  data callsign0/'            '/

  open(10,file='jt65-2',status='old')
  nc=0
  ntot=0
  ncalls=0
  nsingle=0
  zap=.false.

  do iline=1,9999999
     read(10,'(a256)',end=900) line
     n=len(trim(line))
     i1=0
     i2=0
     i3=0
     do i=1,n
        if(ichar(line(i:i)).eq.9) then
           if(i1.eq.0) then
              i1=i
              cycle
           endif
           if(i2.eq.0) then
              i2=i
              cycle
           endif
           if(i3.eq.0) then
              i3=i
              exit
           endif
        endif
     enddo
     callsign=line(1:i1-1)

     if(zap) then
        if(callsign(1:1).ge.'0' .and. callsign(1:1).le.'9' .and.               &
           callsign(2:2).ge.'0' .and. callsign(2:2).le.'9' .and.               &
           callsign(3:3).ge.'0' .and. callsign(3:3).le.'9') cycle

        if(callsign(1:1).ge.'A' .and. callsign(1:1).le.'Z' .and.               &
           callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' .and.               &
           callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z' .and.               &
           callsign(4:4).ge.'A' .and. callsign(4:4).le.'Z') cycle

        if(callsign(1:1).eq.'N' .and.                                        &
           callsign(2:2).ge.'0' .and. callsign(2:2).le.'9' .and.               &
           callsign(3:3).ge.'0' .and. callsign(3:3).le.'9') cycle

     endif

     progname=line(i1+1:i2-1)
     do i=1,len(trim(progname))
        if(progname(i:i).eq.' ') progname(i:i)='_'
     enddo
     read(line(i2+1:i3-1),*) ndecodes
     read(line(i3+1:),*) nreporters

     j=6
     if(index(progname,'WSJT-X').gt.0) j=1
     if(index(progname,'HB9HQX').gt.0) j=2
     if(index(progname,'JTDX').gt.0) j=3
     if(index(progname,'Comfort').gt.0) j=4
     if(index(progname,'COMFORT').gt.0) j=4
     if(index(progname,'JT65-HF').gt.0 .and. j.eq.6) j=5

     nctot=sum(nc)
     if(callsign.ne.callsign0 .and. nctot.gt.0) then
        write(13,1000) callsign0,nc,nctot
1000    format(a12,6i8,i10)
        if(nctot.eq.1) nsingle(j)=nsingle(j)+1
        nc=0
        callsign0=callsign
        ncalls=ncalls+1
     endif
     nc(j)=nc(j) + ndecodes
     ntot(j)=ntot(j) + ndecodes
     write(12,1010) iline,callsign,ndecodes,nreporters,progname
1010 format(i8,2x,a12,2x,2i8,2x,a30)
  enddo

900 nctot=sum(nc)
  if(nctot.gt.0) write(13,1000) callsign0,nc,nctot

  write(*,1018) 
1018 format('   Total    WSJT-X  HB9HQX   JTDX  Comfort JT65-HF   Other'/  &
            '----------------------------------------------------------')
  write(*,1019)
1019 format('Spots reported; fraction of total:')
  write(*,1020) sum(ntot),ntot
1020 format(i8,2x,6i8)
  fac=1.0/sum(ntot)
  write(*,1030) 1.0000,fac*ntot
1030 format(f8.4,2x,6f8.4,f10.4)

  write(*,1038)
1038 format(/'Singletons; as fraction of spots by same program')
  write(*,1040) sum(nsingle),nsingle
1040 format(i8,2x,6i8)
  write(*,1030) float(sum(nsingle))/sum(ntot),float(nsingle)/ntot

  write(*,1050) ncalls
1050 format(/'Distinct calls spotted:',i6)

end program psk_parse

subroutine q65_set_list(mycall,hiscall,hisgrid,codewords,ncw)

  parameter (MAX_NCW=206)
  character*12 mycall,hiscall
  character*6 hisgrid
  character*37 msg,msgsent
  logical my_std,his_std
  integer codewords(63,MAX_NCW)
  integer itone(85)
  integer isync(22)
  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/

  ncw=0
  if(hiscall(1:1).eq. ' ') return
  call stdcall(mycall,my_std)
  call stdcall(hiscall,his_std)
  
  ncw=MAX_NCW
  do i=1,ncw
     msg=trim(mycall)//' '//trim(hiscall)
     if(.not.my_std) then
        if(i.eq.1 .or. i.ge.6)  msg='<'//trim(mycall)//'> '//trim(hiscall)
        if(i.ge.2 .and. i.le.4) msg=trim(mycall)//' <'//trim(hiscall)//'>'
     else if(.not.his_std) then
        if(i.le.4 .or. i.eq.6) msg='<'//trim(mycall)//'> '//trim(hiscall)
        if(i.ge.7) msg=trim(mycall)//' <'//trim(hiscall)//'>'
     endif
     j0=len(trim(msg))+2
     if(i.eq.2) msg(j0:j0+2)='RRR'
     if(i.eq.3) msg(j0:j0+3)='RR73'
     if(i.eq.4) msg(j0:j0+1)='73'
     if(i.eq.5) then
        if(his_std) msg='CQ '//trim(hiscall)//' '//hisgrid(1:4)
        if(.not.his_std) msg='CQ '//trim(hiscall)
     endif
     if(i.eq.6 .and. his_std) msg(j0:j0+3)=hisgrid(1:4)
     if(i.ge.7 .and. i.le.206) then
        isnr = -50 + (i-7)/2
        if(iand(i,1).eq.1) then
           write(msg(j0:j0+2),'(i3.2)') isnr
           if(msg(j0:j0).eq.' ') msg(j0:j0)='+'
        else
           write(msg(j0:j0+3),'("R",i3.2)') isnr
           if(msg(j0+1:j0+1).eq.' ') msg(j0+1:j0+1)='+'
        endif
     endif

     call genq65(msg,0,msgsent,itone,i3,n3)
     i0=1
     j=0
     do k=1,85
        if(k.eq.isync(i0)) then
           i0=i0+1
           cycle
        endif
        j=j+1
        codewords(j,i)=itone(k) - 1
     enddo
!     write(71,3001) i,isnr,codewords(1:13,i),trim(msg)
!3001 format(i3,2x,i3.2,2x,13i3,2x,a)
  enddo

  return
end subroutine q65_set_list

subroutine stdcall(callsign,std)

  character*12 callsign
  character*1 c
  logical is_digit,is_letter,std
!Statement functions:
  is_digit(c)=c.ge.'0' .and. c.le.'9'
  is_letter(c)=c.ge.'A' .and. c.le.'Z'

! Check for standard callsign
  iarea=-1
  n=len(trim(callsign))
  do i=n,2,-1
     if(is_digit(callsign(i:i))) exit
  enddo
  iarea=i                                   !Right-most digit (call area)
  npdig=0                                   !Digits before call area
  nplet=0                                   !Letters before call area
  do i=1,iarea-1
     if(is_digit(callsign(i:i))) npdig=npdig+1
     if(is_letter(callsign(i:i))) nplet=nplet+1
  enddo
  nslet=0                                   !Letters in suffix
  do i=iarea+1,n
     if(is_letter(callsign(i:i))) nslet=nslet+1
  enddo
  std=.true.
  if(iarea.lt.2 .or. iarea.gt.3 .or. nplet.eq.0 .or.       &
       npdig.ge.iarea-1 .or. nslet.gt.3) std=.false.

  return
end subroutine stdcall

module zplot_mod
  implicit none
contains
  subroutine zplot(amp,nz,jj,ave,rms)
    implicit none
    integer, intent(in) :: nz, jj
    real, intent(in) :: amp(nz)
    real, intent(out) :: ave, rms
    
    character*1 :: line(100)
    character*1 :: mark(0:6)
    data mark/' ',' ','.','-','+','X','$'/
    integer :: i, ipk, n
    real :: sum, smax, sq
  
    sum=0.
    smax=0.
    do i=1,nz
       sum=sum+amp(i)
       if(amp(i).gt.smax) then
          smax=amp(i)
          ipk=i
       endif
    enddo
    ave=(sum-smax)/(nz-1)
    sq=0.
    do i=1,nz
       if(i.ne.ipk) sq=sq+(amp(i)-ave)**2
    enddo
    rms=sqrt(sq/(nz-2))
  
    do i=1,nz
       n=(amp(i)-ave)/rms
  !     n=(amp(i)-ave)/0.33
       if(n.lt.0) n=0
       if(n.gt.6) n=6
       line(i)=mark(n)
    enddo
    write(89,1010) jj,0.01*ave,0.01*rms,(line(i),i=1,nz)
  1010 format(i3,2f6.1,1x,100a1)
    
  end subroutine zplot
end module zplot_mod

subroutine encode65(message,sent)

  use packjt
  character message*22
  integer dgen(12)
  integer sent(63)

  call packmsg(message,dgen,itype)
  call rs_encode(dgen,sent)
  call interleave63(sent,1)
  call graycode(sent,63,1)

  return
end subroutine encode65

module ft8_a7

  parameter(MAXDEC=200)

! For the following three arrays
!    First index   i=decode number in this sequence
!    Second index  j=0 or 1 for even or odd sequence
!    Third index   k=0 or 1 for previous or current tally for this j
  real dt0(MAXDEC,0:1,0:1)                 !dt0(i,j,k)
  real f0(MAXDEC,0:1,0:1)                  !f0(i,j,k)
  character*37 msg0(MAXDEC,0:1,0:1)        !msg0(i,j,k)

  integer itone_a7(79)
  integer jseq                             !even=0, odd=1
  integer ndec(0:1,0:1)                    !ndec(j,k)
  data ndec/4*0/,jseq/0/

contains

subroutine ft8_a7_save(nutc,dt,f,msg)

  use packjt77
  character*37 msg,msg1
  character*13 w(19)
  character*4 g4
  integer nw(19)
  logical isgrid4

! Statement function:
  isgrid4(g4)=(len_trim(g4).eq.4 .and.                                        &
       ichar(g4(1:1)).ge.ichar('A') .and. ichar(g4(1:1)).le.ichar('R') .and.  &
       ichar(g4(2:2)).ge.ichar('A') .and. ichar(g4(2:2)).le.ichar('R') .and.  &
       ichar(g4(3:3)).ge.ichar('0') .and. ichar(g4(3:3)).le.ichar('9') .and.  &
       ichar(g4(4:4)).ge.ichar('0') .and. ichar(g4(4:4)).le.ichar('9'))

  if(index(msg,'/').ge.1 .or. index(msg,'<').ge.1) go to 999
  call split77(msg,nwords,nw,w)          !Parse msg into words
  if(nwords.lt.1) go to 999
  if(w(1)(1:3).eq.'CQ_') go to 999
  j=mod(nutc/5,2)                        !j is 0 or 1 for odd/even sequence
  jseq=j

! Add this decode to current table for this sequence
  ndec(j,1)=ndec(j,1)+1                  !Number of decodes in this sequence
  i=ndec(j,1)                            !i is index of a new table entry
  if(i.ge.MAXDEC-1) return               !Prevent table overflow

  dt0(i,j,1)=dt                          !Save dt in table
  f0(i,j,1)=f                            !Save f in table
  msg0(i,j,1)=trim(w(1))//' '//trim(w(2)) !Save "call_1 call_2"
  if(w(1)(1:3).eq.'CQ ' .and. nw(2).le.2) then
     msg0(i,j,1)='CQ '//trim(w(2))//' '//trim(w(3)) !Save "CQ DX Call_2"
  endif
  msg1=msg0(i,j,1)                       !Message without grid
  nn=len(trim(msg1))                     !Message length without grid
! Include grid as part of message
  if(isgrid4(w(nwords))) msg0(i,j,1)=trim(msg0(i,j,1))//' '//trim(w(nwords))

! If a transmission at this frequency with message fragment "call_1 call_2" 
! was decoded in the previous sequence, flag it as "DO NOT USE" because
! we have already decoded and subtracted that station's next transmission.

  call split77(msg0(i,j,1),nwords,nw,w)          !Parse msg into words
  do i=1,ndec(j,0)
     if(f0(i,j,0).le.-98.0) cycle
     i2=index(msg0(i,j,0),' '//trim(w(2)))
     if(abs(f-f0(i,j,0)).le.3.0 .and. i2.ge.3) then
        f0(i,j,0)=-98.0           !Flag as "do not use" for a potential a7 decode
     endif
  enddo
  
999 return
end subroutine ft8_a7_save

subroutine ft8_a7d(dd0,newdat,call_1,call_2,grid4,xdt,f1,xbase,nharderrors,dmin,  &
     msg37,xsnr)

! Examine the raw data in dd0() for possible "a7" decodes.
  
  use crc
  use timer_module, only: timer
  use packjt77
  include 'ft8_params.f90'
  parameter(NP2=2812)
  character*37 msg37,msg,msgsent,msgbest
  character*12 call_1,call_2
  character*4 grid4
  real a(5)
  real s8(0:7,NN)
  real s2(0:511)
  real dmm(206)
  real bmeta(174),bmetb(174),bmetc(174),bmetd(174)
  real llra(174),llrb(174),llrc(174),llrd(174)           !Soft symbols
  real dd0(15*12000)
  real ss(9)
  real rcw(174)
  integer*1 cw(174)
  integer*1 msgbits(77)
  integer*1 nxor(174),hdec(174)
  integer itone(NN)
  integer icos7(0:6),ip(1)
  logical one(0:511,0:8)
  integer graymap(0:7)
  integer iloc(1)
  complex cd0(0:3199)
  complex ctwk(32)
  complex csymb(32)
  complex cs(0:7,NN)
  logical std_1,std_2
  logical first,newdat
  data icos7/3,1,4,0,6,5,2/                !Sync array
  data first/.true./
  data graymap/0,1,3,2,5,6,4,7/
  save one

  if(first) then
     one=.false.
     do i=0,511
       do j=0,8
         if(iand(i,2**j).ne.0) one(i,j)=.true.
       enddo
     enddo
     first=.false.
  endif

  call stdcall(call_1,std_1)
  if(call_1(1:3).eq.'CQ ') std_1=.true.
  call stdcall(call_2,std_2)

  fs2=12000.0/NDOWN
  dt2=1.0/fs2
  twopi=8.0*atan(1.0)
  delfbest=0.
  ibest=0

  call timer('ft8_down',0)
  call ft8_downsample(dd0,newdat,f1,cd0)   !Mix f1 to baseband and downsample
  call timer('ft8_down',1)

  i0=nint((xdt+0.5)*fs2)                   !Initial guess for start of signal
  smax=0.0
  do idt=i0-10,i0+10                       !Search over +/- one quarter symbol
     call sync8d(cd0,idt,ctwk,0,sync)      !NB: ctwk not used here
     if(sync.gt.smax) then
        smax=sync
        ibest=idt
     endif
  enddo

! Peak up in frequency
  smax=0.0
  do ifr=-5,5                              !Search over +/- 2.5 Hz
    delf=ifr*0.5
    dphi=twopi*delf*dt2
    phi=0.0
    do i=1,32
      ctwk(i)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
    enddo
    call sync8d(cd0,ibest,ctwk,1,sync)
    if( sync .gt. smax ) then
      smax=sync
      delfbest=delf
    endif
  enddo
  a=0.0
  a(1)=-delfbest
  call twkfreq1(cd0,NP2,fs2,a,cd0)
  f1=f1+delfbest                           !Improved estimate of DF

  call timer('ft8_down',0)
  call ft8_downsample(dd0,.false.,f1,cd0)   !Mix f1 to baseband and downsample
  call timer('ft8_down',1)

  smax=0.0
  do idt=-4,4                         !Search over +/- one quarter symbol
     call sync8d(cd0,ibest+idt,ctwk,0,sync)
     ss(idt+5)=sync
  enddo
  smax=maxval(ss)
  iloc=maxloc(ss)
  ibest=iloc(1)-5+ibest
  xdt=(ibest-1)*dt2 - 0.5
  sync=smax

  do k=1,NN
    i1=ibest+(k-1)*32
    csymb=cmplx(0.0,0.0)
    if( i1.ge.0 .and. i1+31 .le. NP2-1 ) csymb=cd0(i1:i1+31)
    call four2a(csymb,32,1,-1,1)
    cs(0:7,k)=csymb(1:8)/1e3
    s8(0:7,k)=abs(csymb(1:8))
  enddo  

! sync quality check
  is1=0
  is2=0
  is3=0
  do k=1,7
    ip=maxloc(s8(:,k))
    if(icos7(k-1).eq.(ip(1)-1)) is1=is1+1
    ip=maxloc(s8(:,k+36))
    if(icos7(k-1).eq.(ip(1)-1)) is2=is2+1
    ip=maxloc(s8(:,k+72))
    if(icos7(k-1).eq.(ip(1)-1)) is3=is3+1
  enddo
! hard sync sum - max is 21
  nsync=is1+is2+is3
!  if(nsync .le. 6) return ! bail out

  do nsym=1,3
    nt=2**(3*nsym)
    do ihalf=1,2
      do k=1,29,nsym
        if(ihalf.eq.1) ks=k+7
        if(ihalf.eq.2) ks=k+43
        amax=-1.0
        do i=0,nt-1
          i1=i/64
          i2=iand(i,63)/8
          i3=iand(i,7)
          if(nsym.eq.1) then
            s2(i)=abs(cs(graymap(i3),ks))
          elseif(nsym.eq.2) then
            s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i3),ks+1))
          elseif(nsym.eq.3) then
            s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks+1)+cs(graymap(i3),ks+2))
          else
            print*,"Error - nsym must be 1, 2, or 3."
          endif
        enddo
        i32=1+(k-1)*3+(ihalf-1)*87
        if(nsym.eq.1) ibmax=2 
        if(nsym.eq.2) ibmax=5 
        if(nsym.eq.3) ibmax=8 
        do ib=0,ibmax
          bm=maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)) - &
             maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib))
          if(i32+ib .gt.174) cycle
          if(nsym.eq.1) then
            bmeta(i32+ib)=bm
            den=max(maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)), &
                    maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib)))
            if(den.gt.0.0) then
              cm=bm/den
            else ! erase it
              cm=0.0
            endif
            bmetd(i32+ib)=cm
          elseif(nsym.eq.2) then
            bmetb(i32+ib)=bm
          elseif(nsym.eq.3) then
            bmetc(i32+ib)=bm
          endif
        enddo
      enddo
    enddo
  enddo
  call normalizebmet(bmeta,174)
  call normalizebmet(bmetb,174)
  call normalizebmet(bmetc,174)
  call normalizebmet(bmetd,174)

  scalefac=2.83
  llra=scalefac*bmeta
  llrb=scalefac*bmetb
  llrc=scalefac*bmetc
  llrd=scalefac*bmetd

!  apmag=maxval(abs(llra))*1.01

  MAXMSG=206
  pbest=0.
  dmin=1.e30
  nharderrors=-1
  
  do imsg=1,MAXMSG
     msg=trim(call_1)//' '//trim(call_2)
     i=imsg
     if(call_1(1:3).eq.'CQ ' .and. i.ne.5) msg='QU1RK '//trim(call_2)
     if(.not.std_1) then
        if(i.eq.1 .or. i.ge.6)  msg='<'//trim(call_1)//'> '//trim(call_2)
        if(i.ge.2 .and. i.le.4) msg=trim(call_1)//' <'//trim(call_2)//'>'
     else if(.not.std_2) then
        if(i.le.4 .or. i.eq.6) msg='<'//trim(call_1)//'> '//trim(call_2)
        if(i.ge.7) msg=trim(call_1)//' <'//trim(call_2)//'>'
     endif
     j0=len(trim(msg))+2
     if(i.eq.2) msg(j0:j0+2)='RRR'
     if(i.eq.3) msg(j0:j0+3)='RR73'
     if(i.eq.4) msg(j0:j0+1)='73'
     if(i.eq.5) then
        if(std_2) then
           msg='CQ '//trim(call_2)
           if(call_1(3:3).eq.'_') msg=trim(call_1)//' '//trim(call_2)
           if(grid4.ne.'RR73') msg=trim(msg)//' '//grid4
        endif
        if(.not.std_2) msg='CQ '//trim(call_2)
     endif
     if(i.eq.6 .and. std_2) msg(j0:j0+3)=grid4
     if(i.ge.7) then
        isnr = -50 + (i-7)/2
        if(iand(i,1).eq.1) then
           write(msg(j0:j0+2),'(i3.2)') isnr
           if(msg(j0:j0).eq.' ') msg(j0:j0)='+'
        else
           write(msg(j0:j0+3),'("R",i3.2)') isnr
           if(msg(j0+1:j0+1).eq.' ') msg(j0+1:j0+1)='+'
        endif
     endif

     i3=-1
     n3=-1
     call genft8(msg,i3,n3,msgsent,msgbits,itone) !Source-encode this message
     call encode174_91(msgbits,cw)                !Get codeword for this message
     rcw=2*cw-1
     pow=0.0
     do i=1,79
        pow=pow+s8(itone(i),i)**2
     enddo

     hdec=0
     where(llra.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     da=sum(nxor*abs(llra))

     hdec=0
     where(llrb.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     dbb=sum(nxor*abs(llrb))

     hdec=0
     where(llrc.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     dc=sum(nxor*abs(llrc))

     hdec=0
     where(llrd.ge.0.0) hdec=1
     nxor=ieor(hdec,cw)
     dd=sum(nxor*abs(llrd))

     dm=min(da,dbb,dc,dd)
     dmm(imsg)=dm
     if(dm.lt.dmin) then
        dmin=dm
        msgbest=msgsent
        pbest=pow
        if(dm.eq.da) then
           nharderrors=count((2*cw-1)*llra.lt.0.0)
        else if(dm.eq.dbb) then
           nharderrors=count((2*cw-1)*llrb.lt.0.0)
        else if(dm.eq.dc) then
           nharderrors=count((2*cw-1)*llrc.lt.0.0)
        else if(dm.eq.dd) then
           nharderrors=count((2*cw-1)*llrd.lt.0.0)
        endif
     endif
     
  enddo  ! imsg

  iloc=minloc(dmm)
  dmm(iloc(1))=1.e30
  iloc=minloc(dmm)
  dmin2=dmm(iloc(1))
  xsnr=-27.
  arg=pbest/xbase/3.0e6-1.0
  if(arg.gt.0.0) xsnr=max(-26.0,db(arg)-26.0)
!  write(41,3041) nharderrors,dmin,dmin2,dmin2/dmin,xsnr,trim(msgbest)
!3041 format(i3,2f7.1,f7.2,f7.1,1x,a)
  if(dmin.gt.100.0 .or. dmin2/dmin.lt.1.3) nharderrors=-1
  msg37=msgbest
  if(msg37(1:3).eq.'CQ ' .and. std_2 .and. grid4.eq.'    ') nharderrors=-1
  if(msg37(1:6).eq.'QU1RK ') nharderrors=-1

  return
end subroutine ft8_a7d

end module ft8_a7

subroutine wqenc(msg,ntype,data0)

!  Parse and encode a WSPR message.

  use packjt
  parameter (MASK15=32767)
  character*22 msg
  character*12 call1,call2
  character*4 grid
  character*9 name
  character ccur*4,cxp*2
  logical lbad1,lbad2
  integer*1 data0(11)
  integer nu(0:9)
  data nu/0,-1,1,0,-1,2,1,0,-1,1/

  read(msg,1001,end=1,err=1) ng,n1
1001 format(z4,z7)
  ntype=62
  n2=128*ng + (ntype+64)
  call pack50(n1,n2,data0)             !Pack 8 bits per byte, add tail
  go to 900

1  if(msg(1:6).eq.'73 DE ') go to 80
  if(index(msg,' W ').gt.0 .and. index(msg,' DBD ').gt.0) go to 90
  if(msg(1:4).eq.'QRZ ') go to 100
  if(msg(1:8).eq.'PSE QSY ') go to 110
  if(msg(1:3).eq.'WX ') go to 120

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  i1=index(msg,' ')
  if(i1.lt.4 .or. i1.gt.7) go to 10
  call1=msg(:i1-1)
  grid=msg(i1+1:i1+4)
  call packcall(call1,n1,lbad1)
  call packgrid(grid,ng,lbad2)
  if(lbad1 .or. lbad2) go to 10
  ndbm=0
  read(msg(i1+5:),*,err=10,end=800) ndbm
  if(ndbm.lt.0 .or. ndbm.gt.60) go to 800
  ndbm=ndbm+nu(mod(ndbm,10))
  n2=128*ng + (ndbm+64)
  call pack50(n1,n2,data0)
  ntype=ndbm
  go to 900

! "BestDX" automated WSPR reply (type 1)
10 if(i1.ne.5 .or. msg(5:8).ne.' DE ') go to 20
  grid=msg(1:4)
  call packgrid(grid,ng,lbad2)
  if(lbad2) go to 800
  call1=msg(9:)
  call packcall(call1,n1,lbad1)
  if(lbad1) go to 800
  ntype=1
  n2=128*ng + (ntype+64)
  call pack50(n1,n2,data0)             !Pack 8 bits per byte, add tail
  go to 900

! CQ (msg #1; types 2, 4, 5)
20  if(msg(1:3).ne.'CQ ') go to 30
  if(index(msg,'/').le.0) then
     i2=index(msg(4:),' ')
     call1=msg(4:i2+3)
     grid=msg(i2+4:)
     call packcall(call1,n1,lbad1)
     if(lbad1) go to 30
     call packgrid(grid,ng,lbad2)
     if(lbad2) go to 30
     ntype=2
     n2=128*ng + (ntype+64)
     call pack50(n1,n2,data0)
  else
     ntype=4                                     ! or 5
     call1=msg(4:)
     call packpfx(call1,n1,ng,nadd)
     ntype=ntype+nadd
     n2=128*ng + ntype + 64
     call pack50(n1,n2,data0)
  endif
  go to 900

! Reply to CQ (msg #2; types 6,8,9,11)
30 if(msg(1:1).ne.'<' .and. msg(1:3).ne.'DE ') go to 40
  if(index(msg,' RRR ').gt.0) go to 50
  if(msg(1:1).eq.'<') then
     ntype=6
     i1=index(msg,'>')
     call1=msg(2:i1-1)
     read(msg(i1+1:),*,err=31,end=31) k,muf,ccur,cxp
     go to 130
31   call2=msg(i1+2:)
     call hash(call1,i1-2,ih)
     call packcall(call2,n1,lbad1)
     n2=128*ih + (ntype+64)
     call pack50(n1,n2,data0)
  else
     i1=index(msg(4:),' ')
     call1=msg(4:i1+2)
     if(index(msg,'/').le.0) then
        ntype=8
        ih=0
        call packcall(call1,n1,lbad1)
        grid=msg(i1+4:i1+7)
        call packgrid(grid,ng,lbad2)
        n2=128*ng + (ntype+64)
        call pack50(n1,n2,data0)
     else
        ntype=9                                   ! or 11
        call1=msg(4:)
        call packpfx(call1,n1,ng,nadd)
        ntype=ntype + 2*nadd
        n2=128*ng + ntype + 64
        call pack50(n1,n2,data0)
     endif
  endif
  go to 900

! Call(s) + report (msg #3; types -1 to -27)
! Call(s) + R + report (msg #4; types -28 to -54)
40 if(index(msg,' RRR').gt.0) go to 50
  i1=index(msg,'<')
  if(i1.gt.0 .and. (i1.lt.5 .or. i1.gt.8)) go to 50
  i2=index(msg,'/')
  if(i2.gt.0 .and.i2.le.4) then
     ntype=-10                                   ! -10 to -27
     i0=index(msg,' ')
     call1=msg(:i0-1)
     call packpfx(call1,n1,ng,nadd)
     ntype=ntype - 9*nadd
     i2=index(msg,' ')
     i3=index(msg,' R ')
     if(i3.gt.0) i2=i2+2                            !-28 to -36
     read(msg(i2+2:i2+2),*,end=800,err=800) nrpt
     ntype=ntype - (nrpt-1)
     if(i3.gt.0) ntype=ntype-27
     n2=128*ng + ntype + 64
     call pack50(n1,n2,data0)
     go to 900
  else if(i1.eq.0) then
     go to 50
  endif
  call1=msg(:i1-2)                               !-1 to -9
  i2=index(msg,'>')
  call2=msg(i1+1:i2-1)
  call hash(call2,i2-i1-1,ih)
  i3=index(msg,' R ')
  if(i3.gt.0) i2=i2+2                            !-28 to -36
  read(msg(i2+3:i2+3),*,end=42,err=42) nrpt
  go to 43
42 nrpt=1
43 ntype=-nrpt
  if(i3.gt.0) ntype=-(nrpt+27)
  call packcall(call1,n1,lbad1)
  n2=128*ih + (ntype+64)
  call pack50(n1,n2,data0)
  go to 900

50 i0=index(msg,'<')
  if(i0.le.0 .and. msg(1:3).ne.'DE ') go to 60
  i3=index(msg,' RRR')
  if(i3.le.0) go to 60
! Call or calls and RRR (msg#5; type2 12,14,15,16)
  i0=index(msg,'<')
  if(i0.eq.1) then
     if(index(msg,'/').le.0) then
        ntype=14
        i1=index(msg,'>')
        call1=msg(2:i1-1)
        call2=msg(i1+2:)
        i2=index(call2,' ')
        call2=call2(:i2-1)
        call packcall(call2,n1,lbad1)
        call hash(call1,i1-2,ih)
        n2=128*ih + (ntype+64)
        call pack50(n1,n2,data0)
     else
        stop '0002'
     endif
  else if(i0.ge.5 .and. i0.le.8) then
     if(index(msg,'/').le.0) then
        ntype=12
        i1=index(msg,'>')
        call1=msg(:i0-2)
        call2=msg(i0+1:i1-1)
        call packcall(call1,n1,lbad1)
        call hash(call2,i1-i0-1,ih)
        n2=128*ih + (ntype+64)
        call pack50(n1,n2,data0)
     else
        stop '0002'
     endif
  else
     i1=index(msg(4:),' ')
     call1=msg(4:i1+2)
     if(index(msg,'/').le.0) then
        ntype=9
        grid=msg(i1+4:i1+7)
     else
        ntype=15                                   ! or 16
        call1=msg(4:)
        i0=index(call1,' ')
        call1=call1(:i0-1)
        call packpfx(call1,n1,ng,nadd)
        ntype=ntype+nadd
        n2=128*ng + ntype + 64
        call pack50(n1,n2,data0)
     endif
  endif
  go to 900

! TNX <name> 73 GL (msg #6; type 18 ...)
60 if(msg(1:4).ne.'TNX ') go to 70
  ntype=18
  n1=0
  i2=index(msg(5:),' ')
  name=msg(5:i2+4)
  call packname(name,i2-1,n1,ng)
  n2=128*ng + (ntype+64)
  call pack50(n1,n2,data0)
  go to 900

! TNX name 73 GL (msg #6; type -56 ...)
70 if(msg(1:3).ne.'OP ') go to 80
  ntype=-56
  n1=0
  i2=index(msg(4:),' ')
  name=msg(4:i2+3)
  call packname(name,i2-1,n1,ng)
  n2=128*ng + (ntype+64)
  call pack50(n1,n2,data0)
  go to 900

! 73 DE call grid (msg #6; type 19)
80 if(msg(1:6).ne.'73 DE ') go to 90
  ntype=19
  i1=index(msg(7:),' ')
  call1=msg(7:)
  if(index(call1,'/').le.0) then
     i1=index(call1,' ')
     grid=call1(i1+1:)
     call1=call1(:i1-1)
     call packcall(call1,n1,lbad1)
     call packgrid(grid,ng,lbad2)
     if(lbad1 .or. lbad2) go to 800
     n2=128*ng + (ntype+64)
     call pack50(n1,n2,data0)
     go to 900
  else
     ntype=21                                   ! or 22
     call packpfx(call1,n1,ng,nadd)
     ntype=ntype + nadd
     n2=128*ng + ntype + 64
     call pack50(n1,n2,data0)
     go to 900
  endif

! [pwr] W [gain] DBD [73 GL] (msg #6; types 24, 25)
90  if(index(msg,' W ').le.0) go to 140
  ntype=25
  if(index(msg,' DBD 73 GL').gt.0) ntype=24
  i1=index(msg,' ')
  read(msg(:i1-1),*,end=800,err=800) watts
  if(watts.ge.1.0) nwatts=watts
  if(watts.lt.1.0) nwatts=3000 + nint(1000.*watts)
  if(index(msg,'DIPOLE').gt.0) then
     ndbd=30000
  else if(index(msg,'VERTICAL').gt.0) then
     ndbd=30001
  else
     i2=index(msg(i1+3:),' ')
     read(msg(i1+3:i1+i2+1),*,end=800,err=800) ndbd
  endif
  n1=nwatts
  ng=ndbd + 32
  n2=128*ng + (ntype+64)
  call pack50(n1,n2,data0)
  go to 900

! QRZ call (msg #3; type 26)
100 call1=msg(5:)
  call packcall(call1,n1,lbad1)
  if(lbad1) go to 800
  ntype=26
  n2=ntype+64
  call pack50(n1,n2,data0)
  go to 900

! PSE QSY [nnn] KHZ (msg #6; type 28)
110 ntype=28
  read(msg(9:),*,end=800,err=800) n1
  n2=ntype+64
  call pack50(n1,n2,data0)
  go to 900

! WX wx temp C|F wind (msg #6; type 29)
120 ntype=29
  if(index(msg,' CLEAR ').gt.0) then
     i1=10
     n1=10000
  else if(index(msg,' CLOUDY ').gt.0) then
     i1=11
     n1=20000
  else if(index(msg,' RAIN ').gt.0) then
     i1=9
     n1=30000
  else if(index(msg,' SNOW ').gt.0) then
     i1=9
     n1=40000
  endif
  read(msg(i1:),*,err=800,end=800) ntemp
  ntemp=ntemp+100
  i1=index(msg,' C ')
  if(i1.gt.0) ntemp=ntemp+1000
  n1=n1+ntemp
  if(index(msg,' CALM').gt.0) ng=1
  if(index(msg,' BREEZES').gt.0) ng=2
  if(index(msg,' WINDY').gt.0) ng=3
  if(index(msg,' DRY').gt.0) ng=4
  if(index(msg,' HUMID').gt.0) ng=5

  n2=128*ng + (ntype+64)
  call pack50(n1,n2,data0)

  go to 900

! Solar/geomagnetic/ionospheric data
130 ntype=63
  call packprop(k,muf,ccur,cxp,n1)
  call hash(call1,i1-2,ih)
  n2=128*ih + ntype + 64 
  call pack50(n1,n2,data0)
  go to 900

140 continue

! Plain text
800 ntype=-57
  call packtext2(msg(:8),n1,ng)
  n2=128*ng + ntype + 64
  call pack50(n1,n2,data0)
  go to 900

900 continue
  return
end subroutine wqenc

subroutine twkfreq65(c4aa,n5,a)

  complex c4aa(n5)
  real a(5)
  complex w,wstep
  data twopi/6.283185307/

! Apply AFC corrections to the c4aa data
  w=1.0
  wstep=1.0
  x0=0.5*(n5+1)
  s=2.0/n5
  do i=1,n5
     x=s*(i-x0)
     if(mod(i,100).eq.1) then
        p2=1.5*x*x - 0.5
        dphi=(a(1) + x*a(2) + p2*a(3)) * (twopi/1378.125)
        wstep=cmplx(cos(dphi),sin(dphi))
     endif
     w=w*wstep
     c4aa(i)=w*c4aa(i)
  enddo

  return
end subroutine twkfreq65

module fftw_inplace_interface
  use iso_c_binding
  implicit none

  interface
     function fftwf_plan_dft_1d_inplace(n, a, sign, flags) bind(C, name="fftwf_plan_dft_1d")
        import :: c_int, c_ptr, c_float_complex
        integer(c_int), value :: n
        complex(c_float_complex) :: a(*)
        integer(c_int), value :: sign
        integer(c_int), value :: flags
        type(c_ptr) :: fftwf_plan_dft_1d_inplace
     end function
  end interface

end module fftw_inplace_interface

subroutine gen65(msg00,ichk,msgsent0,itone,itype) BIND(c)

! Encodes a JT65 message to yieild itone(1:126)
! Temporarily, does not implement EME shorthands

  use packjt
  character*1 msg00(23),msgsent0(23)
  character*22 msg0
  character*22 message          !Message to be generated
  character*22 msgsent          !Message as it will be received
  integer itone(126)
  character*3 cok               !'   ' or 'OOO'
  integer dgen(13)
  integer sent(63)
  integer nprc(126)
  data nprc/1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,  &
            0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,  &
            0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,  &
            0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,  &
            1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,  &
            0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,  &
            1,1,1,1,1,1/
  save

  do i=1,22
     msg0(i:i)=msg00(i)
  enddo

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    itone(1)=nfreq
  else
     message=msg0
     do i=1,22
        if(ichar(message(i:i)).eq.0) then
           message(i:)='                      '
           exit
        endif
     enddo

     do i=1,22                               !Strip leading blanks
        if(message(1:1).ne.' ') exit
        message=message(i+1:)
     enddo

     call chkmsg(message,cok,nspecial,flip)
     ntest=0
     if(flip.lt.0.0) ntest=1
     if(nspecial.eq.0) then
        call packmsg(message,dgen,itype)    !Pack message into 72 bits
        call unpackmsg(dgen,msgsent)        !Unpack to get message sent
        msgsent(20:22)=cok
        call fmtmsg(msgsent,iz)
        if(ichk.ne.0) go to 900             !Return if checking only

        call rs_encode(dgen,sent)           !Apply Reed-Solomon code
        call interleave63(sent,1)           !Apply interleaving
        call graycode65(sent,63,1)          !Apply Gray code
        nsym=126                            !Symbols per transmission
        k=0
        do j=1,nsym
           if(nprc(j).eq.ntest) then
              k=k+1
              itone(j)=sent(k)+2
           else
              itone(j)=0
           endif
        enddo
     else
        nsym=32
        k=0
        do j=1,nsym
           do n=1,4
              k=k+1
              if(iand(j,1).eq.1) itone(k)=0
              if(iand(j,1).eq.0) itone(k)=10*nspecial
              if(k.eq.126) go to 10
           enddo
        enddo
10      msgsent=message
        itype=7
     endif
  endif

900 do i=1,22
     msgsent0(i)=msgsent(i:i)
  enddo
  msgsent0(23)=char(0)

  return
end subroutine gen65

  INTEGER FFTW_R2HC
  PARAMETER (FFTW_R2HC=0)
  INTEGER FFTW_HC2R
  PARAMETER (FFTW_HC2R=1)
  INTEGER FFTW_DHT
  PARAMETER (FFTW_DHT=2)
  INTEGER FFTW_REDFT00
  PARAMETER (FFTW_REDFT00=3)
  INTEGER FFTW_REDFT01
  PARAMETER (FFTW_REDFT01=4)
  INTEGER FFTW_REDFT10
  PARAMETER (FFTW_REDFT10=5)
  INTEGER FFTW_REDFT11
  PARAMETER (FFTW_REDFT11=6)
  INTEGER FFTW_RODFT00
  PARAMETER (FFTW_RODFT00=7)
  INTEGER FFTW_RODFT01
  PARAMETER (FFTW_RODFT01=8)
  INTEGER FFTW_RODFT10
  PARAMETER (FFTW_RODFT10=9)
  INTEGER FFTW_RODFT11
  PARAMETER (FFTW_RODFT11=10)
  INTEGER FFTW_FORWARD
  PARAMETER (FFTW_FORWARD=-1)
  INTEGER FFTW_BACKWARD
  PARAMETER (FFTW_BACKWARD=+1)
  INTEGER FFTW_MEASURE
  PARAMETER (FFTW_MEASURE=0)
  INTEGER FFTW_DESTROY_INPUT
  PARAMETER (FFTW_DESTROY_INPUT=1)
  INTEGER FFTW_UNALIGNED
  PARAMETER (FFTW_UNALIGNED=2)
  INTEGER FFTW_CONSERVE_MEMORY
  PARAMETER (FFTW_CONSERVE_MEMORY=4)
  INTEGER FFTW_EXHAUSTIVE
  PARAMETER (FFTW_EXHAUSTIVE=8)
  INTEGER FFTW_PRESERVE_INPUT
  PARAMETER (FFTW_PRESERVE_INPUT=16)
  INTEGER FFTW_PATIENT
  PARAMETER (FFTW_PATIENT=32)
  INTEGER FFTW_ESTIMATE
  PARAMETER (FFTW_ESTIMATE=64)
  INTEGER FFTW_ESTIMATE_PATIENT
  PARAMETER (FFTW_ESTIMATE_PATIENT=128)
  INTEGER FFTW_BELIEVE_PCOST
  PARAMETER (FFTW_BELIEVE_PCOST=256)
  INTEGER FFTW_DFT_R2HC_ICKY
  PARAMETER (FFTW_DFT_R2HC_ICKY=512)
  INTEGER FFTW_NONTHREADED_ICKY
  PARAMETER (FFTW_NONTHREADED_ICKY=1024)
  INTEGER FFTW_NO_BUFFERING
  PARAMETER (FFTW_NO_BUFFERING=2048)
  INTEGER FFTW_NO_INDIRECT_OP
  PARAMETER (FFTW_NO_INDIRECT_OP=4096)
  INTEGER FFTW_ALLOW_LARGE_GENERIC
  PARAMETER (FFTW_ALLOW_LARGE_GENERIC=8192)
  INTEGER FFTW_NO_RANK_SPLITS
  PARAMETER (FFTW_NO_RANK_SPLITS=16384)
  INTEGER FFTW_NO_VRANK_SPLITS
  PARAMETER (FFTW_NO_VRANK_SPLITS=32768)
  INTEGER FFTW_NO_VRECURSE
  PARAMETER (FFTW_NO_VRECURSE=65536)
  INTEGER FFTW_NO_SIMD
  PARAMETER (FFTW_NO_SIMD=131072)

program m65

! Decoder for map65.  Can run stand-alone, reading data from *.tf2 files;
! or as the back end of map65, with data placed in a shared memory region.

! Fortran logical units
!
!   10  binary input data, *.tf2 files
!   11  prefixes.txt
!   12  wb_w65.txt
!   13  map65.log
!   14  
!   15
!   16  tquick log
!   17  saved *.tf2 files
!   18  test file to be transmitted (wsjtgen.f90)
!   19  livecq.txt
!   20
!   21  map65_rx.log
!   22
!   23  CALL3.TXT
!   24
!   25
!   26  tmp26.txt

  use timer_module, only: timer
  use timer_impl, only: init_timer, fini_timer

  include 'njunk.f90'
  parameter (NFFT=32768)
  parameter (NSMAX=60*96000)
  parameter (NREAD=2048)
  integer*2 i2(NREAD)
  real*8 hsym
  real*4 ssz5a(NFFT)
  logical*1 lstrong(0:1023),ldecoded,eof
  real*8 fc0,fcenter
  character*80 arg,infile
  character mycall*12,hiscall*12,mygrid*6,hisgrid*6,datetime*20
  common/datcom/dd(4,5760000),ss(4,322,NFFT),savg(4,NFFT),fc0,nutc0,junk(NJUNK)
  common/npar/fcenter,nutc,idphi,mousedf,mousefqso,nagain,                &
       ndepth,ndiskdat,neme,newdat,nfa,nfb,nfcal,nfshift,                 &
       mcall3,nkeep,ntol,nxant,nrxlog,nfsample,nxpol,nmode,               &
       ndop00,nsave,max_drift,nhsym,mycall,mygrid,hiscall,hisgrid,datetime
  common/early/nhsym1,nhsym2,ldecoded(32768)

  nargs=iargc()
  if(nargs.ne.1 .and. nargs.lt.5) then
     print*,'Usage:    m65 Jsub Qsub Xpol <95238|96000> file1 [file2 ...]'
     print*,'Examples: m65   B   A    X       96000     *.tf2'
     print*,'          m65   C   C    N       96000     *.iq'
     print*,''
     print*,'          m65 -s'
     print*,'  (Gets data from MAP65, via shared memory region.)'
     go to 999
  endif
  nstandalone=1
  nhsym1=280
  nhsym2=302
  call getarg(1,arg)
  if(arg(1:2).eq.'-s') then
     call m65a
     go to 999
  endif
  n=1
  if(arg(1:1).eq.'0') n=0
  if(arg(1:1).eq.'A') n=1
  if(arg(1:1).eq.'B') n=2
  if(arg(1:1).eq.'C') n=3

  call getarg(2,arg)
  m=1
  if(arg(1:1).eq.'0') m=0
  if(arg(1:1).eq.'A') m=1
  if(arg(1:1).eq.'B') m=2
  if(arg(1:1).eq.'C') m=3
  if(arg(1:1).eq.'D') m=4
  if(arg(1:1).eq.'E') m=5
  nmode=10*m + n

  call getarg(3,arg)
  nxpol=0
  if(arg(1:1).eq.'X')   nxpol=1

  call getarg(4,arg)
  nfsample=96000
  if(arg.eq.'95238') nfsample=95238

  ifile1=5

! Some default parameters for command-line execution, in early testing.
  mycall='K1JT'
  mygrid='FN20QI'
  hiscall='K9AN'
  hisgrid='EN50'
  nfa=100          !144.100
  nfb=162          !144.162
  ntol=100
  nkeep=10         !???
  mousefqso=140    !For IK4WLV in 210220_1814.tf2
  mousedf=0
  nfcal=0
  nkhz_center=125

  if(nxpol.eq.0) then
     nfa=55        !For KA1GT files
     nfb=143
     mousefqso=69  !W2HRO signal
     nkhz_center=100
  endif

  call ftninit('.')
  call init_timer('timer.out')
  call timer('m65     ',0)
        
  do ifile=ifile1,nargs
     call getarg(ifile,infile)
     open(10,file=infile,access='stream',status='old',err=998)
     i1=index(infile,'.tf2')
     if(i1.lt.1) i1=index(infile,'.iq')
     read(infile(i1-4:i1-1),*,err=1) nutc0
     go to 2
1    nutc0=0
2    hsym=2048.d0*96000.d0/11025.d0          !Samples per half symbol
     read(10) fcenter
     newdat=1
     nhsym0=-999
     k=0

     nch=2
     if(nxpol.eq.1) nch=4
     eof=.false.
     do irec=1,9999999
        if(.not.eof) read(10,end=4) i2
        go to 6
4       eof=.true.
6       if(eof) i2=0
        do i=1,NREAD,nch
           k=k+1
           if(k.gt.60*96000) exit
           dd(1,k)=i2(i)
           dd(2,k)=i2(i+1)
           if(nxpol.eq.1) then
              dd(3,k)=i2(i+2)
              dd(4,k)=i2(i+3)
           endif
        enddo
        nhsym=(k-2048)/hsym
        if(nhsym.ge.1 .and. nhsym.ne.nhsym0) then
           ndiskdat=1
           nb=0
! Emit signal readyForFFT
           fgreen=-13.0
           iqadjust=0
           iqapply=0
           nbslider=100
           gainx=0.9962
           gainy=1.0265
           phasex=0.01426
           phasey=-0.01195
           call timer('symspec ',0)
           call symspec(k,nxpol,ndiskdat,nb,nbslider,idphi,nfsample,   &
                fgreen,iqadjust,iqapply,gainx,gainy,phasex,phasey,rejectx,   &
                rejecty,pxdb,pydb,ssz5a,nkhz,ihsym,nzap,slimit,lstrong)
           call timer('symspec ',1)
           nhsym0=nhsym

           nutc=nutc0
           if(nhsym.eq.nhsym1) call decode0(dd,ss,savg,nstandalone)
           if(nhsym.eq.nhsym2) then
              call decode0(dd,ss,savg,nstandalone)
              exit
           endif
        endif
     enddo  ! irec

     if(iqadjust.ne.0) write(*,3002) rejectx,rejecty
3002 format('Image rejection:',2f7.1,' dB')
  enddo  ! ifile

  call timer('m65     ',1)
  call timer('m65     ',101)
  go to 999

998 print*,'Cannot open file:'
  print*,infile

999 call fini_timer()
  if(arg(1:2).eq.'-s') then
     write(21,1999) datetime(:17)
1999 format('Subprocess m65 terminated normally at UTC ',a17)
     close(21)
  endif

end program m65

program testfast9

  parameter (NMAX=30*12000)
  integer*2 id2(NMAX)
  integer narg(0:11)
  character*80 line(100)
  character submode*1,infile*80
  
  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage:   testfast9 submode infile'
     print*,'Example: testfast9 E 150806_123300.wav'
     go to 999
  endif
  call getarg(1,submode)
  call getarg(2,infile)

  open(10,file=infile,access='stream',status='old')
  read(10) id2(1:22)                     !Skip 44 header bytes
  npts=NMAX
  read(10,end=1) id2(1:npts)                   !Read the raw data

1 i1=index(infile,'.wav')
  read(infile(i1-6:i1-1),*) narg(0)
  narg(1)=NMAX
  n=ichar(submode)
  narg(2)=n-ichar('A')
  if(n.ge.97 .and. n.le.104) narg(2)=n-ichar('a')
  narg(3)=1
  narg(4)=0
  narg(5)=0
  narg(6)=0
  narg(7)=29951
  narg(8)=1
  narg(9)=102
  narg(10)=700
  narg(11)=500

  call fast9(id2,narg,line)
  print*,line(1)

999 end program testfast9

subroutine filbigvar(f0,newfft,c4a,n4,sq0,c6a,n2)

! Filter and downsample the real data in array dd(npts), sampled at 12000 Hz.
! Output is complex, sampled at 1378.125 Hz.

  use, intrinsic :: iso_c_binding
  use FFTW3
  use timer_module, only: timer
  use jt65_mod5 !ref(3413)
  use jt65_mod6 !NPTS=624000 dd(NPTS)

  parameter (NFFT1=672000,NFFT2=77175,NFFT3=9646,NSZ=3413)
  parameter (NZ2=1000)
  
  real*4 rca(NFFT1)
  complex ca(NFFT1/2+1)                      !FFT of input
  complex c4a(NFFT2),c6a(NFFT3)              !Output data
  real*4 s(NZ2)
  integer i,j
  real halfpulse(15),halfpulse2(15)  !Impulse response of filter (one sided)
  complex cfilt(NFFT2),cfilt2(NFFT2)    !Filter (complex; imag = 0)
  real rfilt(NFFT2),rfilt2(NFFT2)     !Filter (real)
  type(C_PTR) :: plan1,plan2,plan3,plan4,plan5    !Pointers to FFTW plans
  logical first
  logical(1) newfft
  equivalence (rfilt,cfilt),(rfilt2,cfilt2),(rca,ca)
  data first/.true./

! Kaiser-Bessel FIR LPF  http://www.arc.id.au/FilterDesign.html
! fsample    (Hz)  12000      Input sample rate
! Ntaps            29          Number of filter taps
! fc         (Hz)  4353       Cutoff frequency
! dF/2       (Hz)  328        Half transition band
! Stop Atten (dB)  30        Stopband attenuation
! fout       (Hz)  1378.125   Output sample rate
  data halfpulse/0.725500000, 0.240786311, -0.154852552, 0.053941884, 0.022651887, -0.053126870, &
  0.041168005, -0.009120071, -0.017722128, 0.025226891, -0.015037961, -0.001056840, 0.011283798, &
 -0.011212205, 0.004348607/

! Kaiser-Bessel FIR LPF  http://www.arc.id.au/FilterDesign.html
! fsample    (Hz)  1378.125   Input sample rate
! Ntaps            29          Number of filter taps
! fc         (Hz)  86         Cutoff frequency
! dF/2       (Hz)  38        Half transition band
! Stop Atten (dB)  30        Stopband attenuation
! fout       (Hz)  172.265625   Output sample rate
   data halfpulse2/0.124952381, 0.121297716, 0.110774440, 0.094635363, 0.074749989, 0.053318415, &
  0.032545585, 0.014332629, 0.000036722, -0.009663997, -0.014785038, -0.015937306, -0.014143718, &
 -0.010611825, -0.006507996/
  common/patience/npatience,nthreads
  save first,plan1,plan2,plan3,plan4,plan5,rfilt,cfilt,rfilt2,cfilt2,ca

  if(f0.lt.0.) go to 900                    !Clean up at end of program

  nthreadsmin=nthreads !single JT65 mode
  if(nnmode.eq.74) then
    nthreadsmin=max(nthreads-1,1)
    if(nthreads.ge.8 .and. nthreads.lt.12) nthreadsmin=nthreads-2
    if(nthreads.ge.12) nthreadsmin=nthreads-3
  endif
  
  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

! Plan the FFTs just once
     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     call fftwf_plan_with_nthreads(nthreadsmin)
     plan1=fftwf_plan_dft_r2c_1d(nfft1,rca,ca,nflags)
     plan2=fftwf_plan_dft_1d(nfft2,c4a,c4a,-1,nflags)
     plan3=fftwf_plan_dft_1d(nfft2,cfilt,cfilt,+1,nflags)
     call fftwf_plan_with_nthreads(1)
     plan4=fftwf_plan_dft_1d(nfft3,cfilt2,cfilt2,+1,nflags)
     plan5=fftwf_plan_dft_1d(nfft3,c6a,c6a,-1,nflags)
     !$omp end critical(fftw)

! Convert impulse response to filter function
     cfilt=0.
     cfilt2=0.
     fac=0.00625/nfft1
     fac2=0.03

     cfilt(1)=fac*halfpulse(1)
     cfilt2(1)=fac2*halfpulse2(1)
     do i=2,15
        cfilt(i)=fac*halfpulse(i)
        cfilt(nfft2+2-i)=fac*halfpulse(i)
     enddo
     do i=2,15
        cfilt2(i)=fac2*halfpulse2(i)
        cfilt2(nfft3+2-i)=fac2*halfpulse2(i)
     enddo

     call fftwf_execute_dft(plan3,cfilt,cfilt)
     call fftwf_execute_dft(plan4,cfilt2,cfilt2)

     base=real(cfilt(38588)) ! nfft2/2+1
     base2=real(cfilt2(nfft3/2+1))
     do i=1,nfft2
        rfilt(i)=real(cfilt(i))-base
     enddo
     do i=1,nfft3
        rfilt2(i)=real(cfilt2(i))-base2
     enddo
     first=.false.
  endif

! When new data comes along, we need to compute a new "big FFT"
! If we just have a new f0, continue with the existing data in ca.

  if(newfft) then
!     call timer('FFTbig  ',0)
     rca(1:npts)=dd(1:npts)
     rca(npts+1:)=0.

     call fftwf_execute_dft_r2c(plan1,rca,ca)
!     call timer('FFTbig  ',1)

     ib=0
     do j=1,NSZ
        ia=ib+1
        ib=nint(float(j)*(672000./8192)) ! NFFT1/NFFT
        if(ref(j).le.0.0) ref(j)=0.0001
        fac=sqrt(1.0/ref(j))
        ca(ia:ib)=fac*conjg(ca(ia:ib))
     enddo
  endif

! NB: f0 is the frequency at which we want our filter centered.
!     i0 is the bin number in ca closest to f0.
!  call timer('loops   ',0)
  i0=nint(f0*56.) + 1 ! f0/df where delta f = 12000/672000 = 1/56
  nh=38587 ! nfft2/2

  do i=1,nh                                !Copy data into c4a and apply
     j=i0+i-1                              !the filter function
     if(j.ge.1 .and. j.le.nfft1/2+1) then
        c4a(i)=rfilt(i)*ca(j)
     else
        c4a(i)=0.
     endif
  enddo
  do i=nh+1,nfft2
     j=i0+i-1-nfft2
     if(j.ge.1) then
        c4a(i)=rfilt(i)*ca(j)
     else
        c4a(i)=rfilt(i)*conjg(ca(2-j))
     endif
  enddo
  
  nh=nfft3/2
  do i=1,nh
     c6a(i)=rfilt2(i)*c4a(i)
  enddo
  do i=nh+1,nfft3
     c6a(i)=rfilt2(i)*c4a(nfft2-nfft3+i)
  enddo

  nadd=nfft2/(3.0*NZ2) ! 180Hz BW

  i=0
  do j=1,NZ2
     s(j)=0.
     do n=1,nadd
        i=i+1
        s(j)=s(j) + real(c4a(i))**2 + aimag(c4a(i))**2
     enddo
  enddo
  call pctile(s,NZ2,10,sq0)
  sq0=sq0*1.732 ! SQRT(3.0)
!  call timer('loops   ',1)

! Do the short reverse transform, to go back to time domain.
!  call timer('FFTsmall',0)
  call fftwf_execute_dft(plan2,c4a,c4a)
  call fftwf_execute_dft(plan5,c6a,c6a)
!  call timer('FFTsmall',1)
  n4=min(npts/8,nfft2)
  n2=nfft3

  return

900 continue

  !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
  call fftwf_destroy_plan(plan1)
  call fftwf_destroy_plan(plan2)
  call fftwf_destroy_plan(plan3)
  call fftwf_destroy_plan(plan4)
  call fftwf_destroy_plan(plan5)
  !$omp end critical(fftw)
  
  return
end subroutine filbigvar

subroutine avecho(id2_0,ndop,nfrit,nauto,ndf,navg,nqual,f1,xlevel,  &
     snrdb,db_err,dfreq,width,bDiskData,bEchoCall,txcall,rxcall)

  parameter (NTX=6*4096)
  parameter (NFFT=32768,NH=NFFT/2)
  parameter (NZ=4096)
  integer*2 id2_0(NTX+4096)                 !Raw Rx data
  integer*2 id2(NTX+4096)                   !Local copy of Rx data
  integer*2 id2a(15)                        !Just the parameter portion
  integer*4 itone4(6)
  integer*1 itone1(6)
  real sa(NZ)      !Avg spectrum relative to initial Doppler echo freq
  real sb(NZ)      !Avg spectrum with Dither and changing Doppler removed
  real, dimension (:,:), allocatable :: sax  !2D sa spectrum with navg slots
  real, dimension (:,:), allocatable :: sbx  !2D sb spectrum with navg slots
  integer nsum       !Number of integrations
  real dop0          !Doppler shift for initial integration (Hz)
  real dop           !Doppler shift for current integration (Hz)
  real s(8192)
  real x(NFFT)
  integer ipkv(1)
  logical*1 bDiskData,bEchoCall
  complex c(0:NH)
  character*6 txcall,rxcall
  equivalence (itone1,id2a(13))
  equivalence (x,c),(ipk,ipkv)
  common/echocom/nclearave,nsum,blue(NZ),red(NZ)
  common/echocom2/fspread_self,fspread_dx
  data navg0/-1/
  save dop0,navg0,sax,sbx

  if(ndf.eq.-999) stop                !Silence compiler warning
  if(bEchoCall .and. .not.bDiskData) then
! Calculate the transmitted tones for real-time Echo Call testing
     call gen_echocall(txcall,itone4)
     itone1=itone4
     id2_0(13:15)=id2a(13:15)           !Copy the tone values into id2_0
  endif

  fspread=fspread_dx                    !Use the predicted spread
  if(bDiskData) fspread=width
  if(nauto.eq.1) fspread=fspread_self
  fspread=min(max(0.04,fspread),700.0)
  width=fspread

  if(navg.ne.navg0) then
! If navg changes, start fresh by reallocating sax and sbx
     if(allocated(sax)) deallocate(sax)
     if(allocated(sbx)) deallocate(sbx)
     allocate(sax(1:navg,1:NZ))
     allocate(sbx(1:navg,1:NZ))
     nsum=0
     navg0=navg
  endif
  
  sq=sum(float(id2_0(16:NTX))**2)
  xlevel=10.0*log10(sq/(NTX-15))

  if(navg.eq.1) nclearave=1
  if(nclearave.ne.0) nsum=0
  dop=ndop
  if(nsum.eq.0) then
     dop0=dop                             !Remember the initial Doppler
     sax=0.                               !Clear the average arrays
     sbx=0.
  endif

  df=12000.0/NFFT
  fnominal=1500.0           !Nominal audio frequency w/o doppler or dither
  ia=nint((fnominal+dop0-nfrit)/df)
  ib=nint((f1+dop-nfrit)/df)
  snrdb=0.
  db_err=0.
  dfreq=0.

! If some parameter is way off, abort this procedure
  if(ia.lt.2048 .or. ib.lt.2048 .or. ia.gt.6144 .or. ib.gt.6144) go to 900
       
! Copy data from id2_0 to id2
  id2=id2_0

! Shift all tone frequencies to 1500 Hz, returning modified data in id2
! and decoded message in rxcall.
  rxcall='      '
  call decode_echo(id2,.false.,rxcall)

  x(1:15)=0.
  x(16:NTX)=id2(16:NTX)
  x(NTX+1:)=0.
  x=x/NTX
  call four2a(x,NFFT,1,-1,0)              !Compute the tone-aligned spectrum
  do i=1,8192                             !Array s(1:8192) is spectrum 0-3 kHz
     s(i)=real(c(i))**2 + aimag(c(i))**2
  enddo

  nsum=nsum+1
  j=mod(nsum-1,navg)+1
  do i=1,NZ
     sax(j,i)=s(ia+i-2048)    !Center at initial doppler freq
     sbx(j,i)=s(ib+i-2048)    !Center at expected echo freq
     sa(i)=sum(sax(1:navg,i))
     sb(i)=sum(sbx(1:navg,i))
  enddo

  call echo_snr(sa,sb,fspread,blue,red,snrdb,db_err,dfreq,snr_detect)

  db_err=db_err/sqrt(float(nsum))
  nqual=snr_detect-2
  if(nqual.lt.0) nqual=0
  if(nqual.gt.10) nqual=10
  xdt=0.
 
! Scale for plotting
  redmax=maxval(red)
  fac=10.0/max(redmax,10.0)
  blue=fac*blue
  red=fac*red
  nsmo=max(0.0,0.25*width/df)
  do i=1,nsmo
     call smo121(red,NZ)
     call smo121(blue,NZ)
  enddo

  ia=50.0/df
  ib=250.0/df
  call pctile(red(ia:ib),ib-ia+1,50,bred1)
  call pctile(blue(ia:ib),ib-ia+1,50,bblue1)
  ia=1250.0/df
  ib=1450.0/df
  call pctile(red(ia:ib),ib-ia+1,50,bred2)
  call pctile(blue(ia:ib),ib-ia+1,50,bblue2)

  red=red-0.5*(bred1+bred2)
  blue=blue-0.5*(bblue1+bblue2)

900 call sleep_msec(10)   !Avoid the "blue Decode button" syndrome
  if(abs(dfreq).ge.1000.0) dfreq=0.

  return
end subroutine avecho

program contest72

  use packjt
  integer dat(12)
  logical text,bcontest,ok
  character*22 msg,msg0,msg1
  character*72 ct1,ct2
  character*12 callsign1,callsign2
  character*1 c0
  character*42 c
  character*6 mygrid
  data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/
  data bcontest/.true./
  data mygrid/"EM48  "/

! itype Message Type
!--------------------
!   1   Standardd message
!   2   Type 1 prefix
!   3   Type 1 suffix
!   4   Type 2 prefix
!   5   Type 2 suffix
!   6   Free text
!  -1   Does not decode correctly
  
  nargs=iargc()
  if(nargs.eq.0) open(10,file='contest_msgs.txt',status='old')

  nn=0
  do imsg=1,9999
     if(nargs.eq.1) then
        if(imsg.gt.1) exit
        call getarg(1,msg0)
     else
        read(10,1001,end=999) msg0
1001    format(a22)
     endif
     msg=msg0
     call packmsg(msg,dat,itype,bcontest)
     call unpackmsg(dat,msg1,bcontest,mygrid)
     ok=msg1.eq.msg0
     if(msg0.eq.'                      ') then
        write(*,1002)
     else
        if(jt_c2(1:1).eq.'W') msg0='  '//msg0(1:20)
        nn=nn+1
        write(*,1002) nn,msg0,ok,jt_itype,jt_nc1,jt_nc2,jt_ng,jt_k1,jt_k2
1002    format(i1,'. ',a22,L2,i2,2i10,i6,2i8)
        if(index(msg1,' 73 ').gt.4) nn=0
     endif
     if(.not.ok) print*,msg0,msg1
     if(itype.lt.0 .or. itype.eq.6) cycle
     
     if(msg(1:3).eq.'CQ ') then
        m=2
        write(ct1,1010) dat
1010    format(12b6.6)
!        write(*,1014) ct1
!1014    format(a72)
        cycle
     endif

     i1=index(msg,'<')
     if(i1.eq.1) then
        m=0
        cycle
     endif
     
     if(i.ge.5) then
        m=3
        cycle
     endif

     if(msg(1:6).eq.'73 CQ ') then
        m=4
        cycle
     endif
     
     call packmsg(msg,dat,itype,.false.)
     write(ct1,1010) dat
     call packtext(msg,nc1,nc2,ng,.false.,'')
!     write(ct2,1012) nc1,nc2,ng+32768
!1012 format(2b28.28,b16.16)
!     write(*,1014) ct1
!     write(*,1014) ct2
!     write(*,1014)
  enddo

999 end program contest72

module wideband_sync

   use iso_fortran_env, only: real32

   type candidate
      real :: snr          !Relative S/N of sync detection
      real :: f            !Freq of sync tone, 0 to 96000 Hz
      real :: xdt          !DT of matching sync pattern, -1.0 to +4.0 s
      real :: pol          !Polarization angle, degrees
      integer :: ipol      !Polarization angle, 1 to 4 ==> 0, 45, 90, 135 deg
      integer :: iflip     !Sync type: JT65 = +/- 1, Q65 = 0
      integer :: indx
   end type candidate
   type sync_dat
      real :: ccfmax
      real :: xdt
      real :: pol
      integer :: ipol
      integer :: iflip
      logical :: birdie
   end type sync_dat

   integer, parameter :: NFFT = 32768
   integer, parameter :: MAX_CANDIDATES = 50
   real(real32), parameter :: SNR1_THRESHOLD = 4.5
   type(sync_dat), allocatable :: sync(:)  !NFFT
   integer nkhz_center

contains

   subroutine get_candidates(ss, savg, xpol, jz, nfa, nfb, nts_jt65, nts_q65, cand, ncand)
      use iso_c_binding
      use debug_log
      use indexx_mod, only: indexx
      use iso_fortran_env, only: real64
      
      implicit none

      !==== Dummy arguments =====================================================
      real,    intent(in)    :: ss(4,322,NFFT)
      real,    intent(in)    :: savg(4,NFFT)
      logical, intent(in)    :: xpol
      integer, intent(in)    :: jz, nfa, nfb
      integer, intent(in)    :: nts_jt65, nts_q65
      type(candidate), intent(out) :: cand(MAX_CANDIDATES)
      integer, intent(out)   :: ncand


! Search symbol spectra ss() over frequency range nfa to nfb (in kHz) for
! JT65 and Q65 sync patterns. The nts_* variables are the submode tone
! spacings: 1 2 4 8 16 for A B C D E.  Birdies are detected and
! excised.  Candidates are returned in the structure array cand().

      integer, parameter :: MAX_PEAKS = 100
      real pavg(-20:20)
      real base, bw, diffhz, df3, flip, flip_top, pmax, snr1, snr_top, tstep
      real(real64) f0
      integer i, ia, ib, ipol, iz, j
      integer j1, j2, k, n, n_top, jsum, m
      integer, allocatable :: indx(:)
      logical skip

      call wb_sync(ss, savg, xpol, jz, nfa, nfb)          !Output to sync() array

      tstep = 2048.0/11025.0        !0.185760 s: 0.5*tsym_jt65, 0.3096*tsym_q65
      df3 = 96000.0/NFFT
      ia = nint(1000*nfa/df3) + 1
      ib = nint(1000*nfb/df3) + 1
      if (ia .lt. 1) ia = 1
      if (ib .gt. NFFT - 1) ib = NFFT - 1
      iz = ib - ia + 1
      allocate (indx(iz))

      ! w3sz this if block should not be necessary but it is
      if (iz <= 0) then
!         print *, 'GET_CAND: iz <= 0, ia=', ia, ' ib=', ib
         flush (6)
         return
      endif

      call indexx(sync(ia:ib)%ccfmax, iz, indx)   !Sort by relative snr

      n_top = indx(iz) + ia - 1
      snr_top = sync(n_top)%ccfmax
      flip_top = sync(n_top)%iflip

      k = 0
      do i = 1, MAX_PEAKS
         if ((iz + 1 - i) .lt. 1) cycle !w3sz debug
         n = indx(iz + 1 - i) + ia - 1
         f0 = 0.001*(n - 1)*df3
         snr1 = sync(n)%ccfmax
         if (snr1 .lt. SNR1_THRESHOLD) exit
         flip = sync(n)%iflip
         if (flip .ne. 0.0 .and. nts_jt65 .eq. 0) cycle
         if (flip .eq. 0.0 .and. nts_q65 .eq. 0) cycle
         if (sync(n)%birdie) cycle

! Test for signal outside of TxT range and set bw for this signal type
         j1 = int((sync(n)%xdt + 1.0)/tstep - 1.0)
         j2 = int((sync(n)%xdt + 52.0)/tstep + 1.0)
         if (flip .ne. 0) j2 = int((sync(n)%xdt + 47.811)/tstep + 1.0)
         ipol = sync(n)%ipol
         pavg = 0.
         do j = 1, j1
            pavg = pavg + ss(ipol, j, n - 20:n + 20)
         enddo
         do j = j2, jz
            pavg = pavg + ss(ipol, j, n - 20:n + 20)
         enddo
         jsum = j1 + (jz - j2 + 1)
         pmax = maxval(pavg(-2:2))              !### Why not just pavg(0) ?
         base = (sum(pavg) - pmax)/jsum
         pmax = pmax/base
         if (pmax .gt. 5.0) cycle
         skip = .false.
         do m = 1, k                              !Skip false syncs within signal bw
            diffhz = 1000.0*(f0 - cand(m)%f)
            bw = nts_q65*110.0
            if (cand(m)%iflip .ne. 0) bw = nts_jt65*178.0
            if (diffhz .gt. -0.03*bw .and. diffhz .lt. 1.03*bw) skip = .true.
         enddo
         if (skip) cycle
         k = k + 1
         cand(k)%snr = snr1
         cand(k)%f = f0
         cand(k)%xdt = sync(n)%xdt
         cand(k)%pol = sync(n)%pol
         cand(k)%ipol = sync(n)%ipol
         cand(k)%iflip = nint(flip)
         cand(k)%indx = n
!     write(50,3050) i,k,m,f0+32.0,diffhz,bw,snr1,db(snr1)
!3050 format(3i5,f8.3,2f8.0,2f8.2)
         if (k .ge. MAX_CANDIDATES) exit
      enddo
      ncand = k      
      return
   end subroutine get_candidates

   subroutine wb_sync(ss, savg, xpol, jz, nfa, nfb)
      use iso_c_binding
      use debug_log
      use indexx_mod
      use txpol_mod
      use trimlist_mod
      use pctile_mod
      use polfit_mod
      implicit none

      !==== Dummy arguments =====================================================
      real,    intent(in)    :: ss(4,322,NFFT)
      real,    intent(in)    :: savg(4,NFFT)
      logical, intent(in)    :: xpol
      integer, intent(in)    :: jz, nfa, nfb

      integer, parameter :: LAGMAX = 30
      real(c_float) :: savg_med(4)
      real ccf4(4), ccf4best(4), a(3)
      real base, bw, ccf, ccfmax, df3, fac, flip, poldeg, spk, syncmin, tstep
      integer i, i0, ia, ib, ipolbest, j, ja, jb, k, lag, lagbest
      integer nbw, nguard, npol, ipol
      logical first
      integer isync(22)
      integer jsync0(63), jsync1(63)
      integer ip(1)
      
        ! --- JT65 wideband debugging probe ---
        ! real :: freq_hz

! Q65 sync symbols
      data isync/1, 9, 12, 13, 15, 22, 23, 26, 27, 33, 35, 38, 46, 50, 55, 60, 62, 66, 69, 74, 76, 85/
      data jsync0/ &
         1, 4, 5, 9, 10, 11, 12, 13, 14, 16, 18, 22, 24, 25, 28, 32, &
         33, 34, 37, 38, 39, 40, 42, 43, 45, 46, 47, 48, 52, 53, 55, 57, &
         59, 60, 63, 64, 66, 68, 70, 73, 80, 81, 89, 90, 92, 95, 97, 98, &
         100, 102, 104, 107, 108, 111, 114, 119, 120, 121, 122, 123, 124, 125, 126/
      data jsync1/ &
         2, 3, 6, 7, 8, 15, 17, 19, 20, 21, 23, 26, 27, 29, 30, 31, &
         35, 36, 41, 44, 49, 50, 51, 54, 56, 58, 61, 62, 65, 67, 69, 71, &
         72, 74, 75, 76, 77, 78, 79, 82, 83, 84, 85, 86, 87, 88, 91, 93, &
         94, 96, 99, 101, 103, 105, 106, 109, 110, 112, 113, 115, 116, 117, 118/
      data first/.true./
      save first, isync, jsync0, jsync1

      tstep = 2048.0/11025.0        !0.185760 s: 0.5*tsym_jt65, 0.3096*tsym_q65
      if (first) then
         fac = 0.6/tstep
         do i = 1, 22                                !Expand the Q65 sync stride
            isync(i) = nint((isync(i) - 1)*fac) + 1
         enddo
         do i = 1, 63
            jsync0(i) = 2*(jsync0(i) - 1) + 1
            jsync1(i) = 2*(jsync1(i) - 1) + 1
         enddo
         first = .false.
      endif

      df3 = 96000.0/NFFT
      ia = nint(1000*nfa/df3) + 1          !Flat frequency range for WSE converters
      ib = nint(1000*nfb/df3) + 1
      if (ia .lt. 1) ia = 1
      if (ib .gt. NFFT - 1) ib = NFFT - 1
      npol = 1
      if (xpol) npol = 4

      do i = 1, npol
         call pctile(savg(i, ia:ib), ib - ia + 1, 50, savg_med(i))
      enddo
!  do i=ia,ib
!     write(14,3014) 0.001*(i-1)*df3,savg(1:npol,i)
!3014 format(5f10.3)
!  enddo

      lagbest = 0
      ipolbest = 1
      flip = 0.

      do i = ia, ib
         ccfmax = 0.
         do lag = 0, LAGMAX

            ccf = 0.
            ccf4 = 0.
            do j = 1, 22                        !Test for Q65 sync
               k = isync(j) + lag
               ccf4(1:npol) = ccf4(1:npol) + ss(1:npol, k, i + 1) + &
                              ss(1:npol, k + 1, i + 1) + ss(1:npol, k + 2, i + 1)
            enddo
            ccf4(1:npol) = ccf4(1:npol) - savg(1:npol, i + 1)*3*22/float(jz)
            ccf = maxval(ccf4)
            ip = maxloc(ccf4)
            ipol = ip(1)
            if (ccf .gt. ccfmax) then
               ipolbest = ipol
               lagbest = lag
               ccfmax = ccf
               ccf4best = ccf4
               flip = 0.
            endif

            ccf = 0.
            ccf4 = 0.
            do j = 1, 63                       !Test for JT65 sync, std msg
               k = jsync0(j) + lag
               ccf4(1:npol) = ccf4(1:npol) + ss(1:npol, k, i + 1) + ss(1:npol, k + 1, i + 1)
            enddo
            ccf4(1:npol) = ccf4(1:npol) - savg(1:npol, i + 1)*2*63/float(jz)
            ccf = maxval(ccf4)
            ip = maxloc(ccf4)
            ipol = ip(1)
            if (ccf .gt. ccfmax) then
               ipolbest = ipol
               lagbest = lag
               ccfmax = ccf
               ccf4best = ccf4
               flip = 1.0
            endif

            ccf = 0.
            ccf4 = 0.
            do j = 1, 63                       !Test for JT65 sync, OOO msg
               k = jsync1(j) + lag
               ccf4(1:npol) = ccf4(1:npol) + ss(1:npol, k, i + 1) + ss(1:npol, k + 1, i + 1)
            enddo
            ccf4(1:npol) = ccf4(1:npol) - savg(1:npol, i + 1)*2*63/float(jz)
            ccf = maxval(ccf4)
            ip = maxloc(ccf4)
            ipol = ip(1)
            if (ccf .gt. ccfmax) then
               ipolbest = ipol
               lagbest = lag
               ccfmax = ccf
               ccf4best = ccf4
               flip = -1.0
            endif

         enddo  ! lag

         poldeg = 0.
         if (xpol .and. ccfmax .ge. SNR1_THRESHOLD) then
            call polfit(ccf4best, 4, a)
            poldeg = a(3)
         endif
        sync(i)%ccfmax = ccfmax
        sync(i)%xdt    = lagbest*tstep - 1.0
        sync(i)%pol    = poldeg
        sync(i)%ipol   = ipolbest
        sync(i)%iflip  = int(flip)
        sync(i)%birdie = .false.
        if (ccfmax/(savg(ipolbest, i)/savg_med(ipolbest)) .lt. 3.0) sync(i)%birdie = .true.

        ! --- JT65 wideband probe (new) ---
!        freq_hz = 0.001 * (i - 1) * df3     ! convert FFT bin index to kHz

!        if (abs(freq_hz - 11.305d0) .lt. 0.02d0) then
!           write(*,*) 'WBSYNC BIN: freq=', freq_hz, &
!                      ' ccfmax=', sync(i)%ccfmax, &
!                      ' birdie=', sync(i)%birdie, &
!                      ' iflip=', sync(i)%iflip
!        endif

        enddo   ! i (frequency bin)

      call pctile(sync(ia:ib)%ccfmax, ib - ia + 1, 50, base)
      sync(ia:ib)%ccfmax = sync(ia:ib)%ccfmax/base

      bw = 65*4*1.66666667                        !Q65-60C bandwidth
      nbw = int(bw/df3 + 1)                            !Number of bins to blank
      syncmin = 2.0
      nguard = 10
      do i = ia, ib
         if (sync(i)%ccfmax .lt. syncmin) cycle
         if ((i .lt. 1) .or. (i .gt. (NFFT - nbw))) cycle !w3sz debug
         spk = maxval(sync(i:i + nbw)%ccfmax)
         ip = maxloc(sync(i:i + nbw)%ccfmax)
         i0 = ip(1) + i - 1
         ja = min(i, i0 - nguard)
         jb = i0 + nbw + nguard
         if (ja .lt. 1) cycle !ja = 1  !w3sz debug
         if (jb .lt. 1) cycle !jb = 1  !w3sz debug
         if (ja .gt. NFFT) cycle !ja = NFFT  !w3sz debug
         if (jb .gt. NFFT) cycle !jb = NFFT  !w3sz debug
         sync(ja:jb)%ccfmax = 0.
         sync(i0)%ccfmax = spk
      enddo

!  do i=ia,ib
!     write(15,3015) 0.001*(i-1)*df3+32.0,sync(i)%ccfmax,sync(i)%xdt,  &
!          sync(i)%ipol,sync(i)%iflip,sync(i)%birdie
!3015 format(3f10.3,2i6,L5)
!  enddo

      return
   end subroutine wb_sync

   subroutine init_wideband_sync(n)
      implicit none
      integer, intent(in) :: n
      if (.not. allocated(sync)) allocate (sync(n))
   end subroutine init_wideband_sync

end module wideband_sync

subroutine hash(string,len,ihash)
  use iso_c_binding, only: c_loc,c_size_t
  use hashing
  parameter (MASK15=32767)
!  character*(*), target :: string
  character*1, target :: string
     i=nhash(c_loc(string),int(len,c_size_t),146)
     ihash=iand(i,MASK15)
  return
end subroutine hash

subroutine getpfx1(callsign,k,nv2)

  character*12 callsign0,callsign,lof,rof
  character*8 c
  character addpfx*8,tpfx*4,tsfx*3
  logical ispfx,issfx,invalid
  common/pfxcom/addpfx
  include 'pfx.f90'

  callsign0=callsign
  nv2=0
  iz=index(callsign,' ') - 1
  if(iz.lt.0) iz=12
  islash=index(callsign(1:iz),'/')
  k=0
  c='   '
  if(islash.gt.0 .and. islash.le.(iz-4)) then
!  Add-on prefix
     c=callsign(1:islash-1)
     callsign=callsign(islash+1:iz)
     do i=1,NZ
        if(pfx(i)(1:4).eq.c) then
           k=i
           go to 10
        endif
     enddo
     if(addpfx.eq.c) then
        k=449
        go to 10
     endif

  else if(islash.eq.(iz-1)) then
!  Add-on suffix
     c=callsign(islash+1:iz)
     callsign=callsign(1:islash-1)
     do i=1,NZ2
        if(sfx(i).eq.c(1:1)) then
           k=400+i
           go to 10
        endif
     enddo
  endif

10 if(islash.ne.0 .and.k.eq.0) then
!  Original JT65 would force this compound callsign to be treated as
!  plain text.  In JT65v2, we will encode the prefix or suffix into nc1.
!  The task here is to compute the proper value of k.
     lof=callsign0(:islash-1)
     rof=callsign0(islash+1:)
     llof=len_trim(lof)
     lrof=len_trim(rof)
     ispfx=(llof.gt.0 .and. llof.le.4)
     issfx=(lrof.gt.0 .and. lrof.le.3)
     invalid=.not.(ispfx.or.issfx)
     if(ispfx.and.issfx) then
        if(llof.lt.3) issfx=.false.
        if(lrof.lt.3) ispfx=.false.
        if(ispfx.and.issfx) then
           i=ichar(callsign0(islash-1:islash-1))
           if(i.ge.ichar('0') .and. i.le.ichar('9')) then
              issfx=.false.
           else
              ispfx=.false.
           endif
        endif
     endif

     if(invalid) then
        k=-1
     else
        if(ispfx) then
           tpfx=lof(1:4)
           k=nchar(tpfx(1:1))
           k=37*k + nchar(tpfx(2:2))
           k=37*k + nchar(tpfx(3:3))
           k=37*k + nchar(tpfx(4:4))
           nv2=1
           i=index(callsign0,'/')
           callsign=callsign0(:i-1)
           callsign=callsign0(i+1:)
        endif
        if(issfx) then
           tsfx=rof(1:3)
           k=nchar(tsfx(1:1))
           k=37*k + nchar(tsfx(2:2))
           k=37*k + nchar(tsfx(3:3))
           nv2=2
           i=index(callsign0,'/')
           callsign=callsign0(:i-1)
        endif
     endif
  endif

  return
end subroutine getpfx1

subroutine ft8_a8d(dd,mycall,dxcall,dxgrid,f1a,xdt,fbest,xsnr,plog,msgbest)

! List decoding for FT8, activated only at nfqso (Rx Freq) +/- 10 Hz and when
! DxCall and DxGrid are populated. Returns xdt, fbest, and msgbest.

  use packjt77
  use ft8_a7
  use timer_module, only: timer
  include 'ft8_params.f90'           !Set various constants
  parameter (NWAVE=NN*NSPS/NDOWN)    !Length of generated cwave = 2528
  parameter (NZZ=3200)               !Length of downsampled arrays
  parameter (NFFT=NZZ,NH=NFFT/2)     !FFT length
  parameter (NMSGS=206)              !Number of messages to be tried
  parameter (PLOG_MIN=-160.0)        !Minimum log probability
  character mycall*12,dxcall*12,dxgrid*6
  character*37 msg,msgsent,msgbest
  character*77 c77
  integer*1 msgbits(77)
  real xjunk(NZZ)
  real s(-NH:NH)                     !Power spectrum of cd0
!  real s00(-NH:NH)                   !Raw spectrum of downsampled data
  real s0(-NH:NH)                    !Best-fit re-centered spectrum for this msg
  real s1(-NH:NH)                    !Overall best-fit re-centered spectrum
  real s8(0:7)                       !Spectrum of a single symbol
  real dd(NMAX)                      !Floating point copy of iwave
  real a(5)
  complex cwave(0:NZZ-1)             !Complex waveform corresponding to msg
  complex cd(0:NZZ-1)                !Data from dd, now complex and sampled at 200 Hz
  complex cd0(0:NZZ-1)               !All tones in cd nominally shifted to 0 Hz
  complex csymb(0:31)
  integer itone(NN)
  integer itone_best(NN)
  integer ipk(1)
  logical newdat

  f1=f1a
  newdat=.true.
! Mix from f1 to baseband and downsample from dd into cd (complex, 200 Hz sampling)
  call ft8_downsample(dd,newdat,f1,cd)
  fac=1.e-6

  fsd=200.0                              !Downsampled rate (Hz)
  bt=2.0                                 !Gaussian smoothing parameter
  dt=1.0/fsd
  df=200.0/NFFT
  s=0.
  ss=0.
  sq=0.

! Find the message that fits the received waveform best
  sbest=0.
  tbest=0.
  fbest=0.
  msgbest=''
  itone_best=0
  do imsg=1,NMSGS
     call getmsg(imsg,mycall,dxcall,dxgrid,msg)

! Source-encode the message, get itone(), and generate complex FT8 waveform.
     i3=-1
     n3=-1
     call pack77(msg,i3,n3,c77)
     call genft8(msg,i3,n3,msgsent,msgbits,itone)
     call gen_ft8wave(itone,NN,32,bt,fsd,0.0,cwave,xjunk,1,NWAVE)
     cwave(NWAVE:)=0.

! For this message, find the best lag
     spk=0.
     fpk=0.
     tpk=0.
     lagpk=0
     lag1=-200
     lag2=200
     lagstep=4
     do iter=1,2
        if(iter.eq.2) then
           lag1=lagpk-8
           lag2=lagpk+8
           lagstep=1
        endif
        do lag=lag1,lag2,lagstep
           do i=0,NWAVE-1
              j=i+lag + 100
              cd0(i)=0.
              if(j.ge.0 .and. j.le.NWAVE-1) cd0(i)=cd(j)*conjg(cwave(i))
           enddo

           cd0(NWAVE:)=0.
           call four2a(cd0,NFFT,1,-1,1)               !Forward c2c FFT

           do i=0,NFFT-1
              j=i
              if(i.gt.NH) j=i-NFFT
              s(j)=fac*(real(cd0(i))**2 + aimag(cd0(i))**2)
           enddo

           call smo121(s,NFFT+1)

           smax=0.
           do j=-NH,NH
              smax=max(s(j),smax)
              if(s(j).gt.spk) then
                 spk=s(j)
                 fpk=j*df + f1
                 lagpk=lag
                 tpk=lag*dt
                 s0=s                       !Save best-fit spectrum for this msg
              endif
           enddo  ! j
        enddo  ! lag
     enddo  ! iter

     if(spk.gt.sbest) then
        sbest=spk
        fbest=fpk
        tbest=tpk
        msgbest=msg
        itone_best=itone
        s1=s0                                !Save overall best-fit spectrum
     endif
  enddo  ! imsg

  a=0
  a(1)=f1-fbest
!  if(abs(a(1)+5.0).gt.10.0) then             !Effective Ftol = 10 Hz
  if(abs(a(1)).gt.5.0) then                   !Effective Ftol = 5 Hz
     msgbest=''
     return
  endif
  call twkfreq1(cd,NZZ,200.0,a,cd)           !Re-center the spectrum
  
  xdt=tbest
  ave=(sum(s1(-200:-100)) + sum(s1(100:200)))/202.0
  s1=s1/ave - 1.0
  s1pk=maxval(s1(-32:32))
  sig=0.
  nsig=0
  do i=-32,32
     if(s1(i).lt.0.5*s1pk) cycle
     sig=sig+s1(i)
     nsig=nsig+1
  enddo
  sig=sig/nsig
  xsnr=db(sig)-35.0
  if(xsnr.lt.-30) xsnr=-30                   !Set min SNR for 'a8' decodes

  if(msgbest.ne.'') then
! Compute probability of successful decode.
     plog=0.0
     nhard=0
     nsum=0
     sum_sync=0.
     sum_sig=0.
     sum_big=0.
     do k=1,NN
        i0=32*(k-1) + nint((tbest+0.5)/0.005)
        csymb=0.
        do i=0,31
           if(i0+i.ge.0 .and. i0+i.le.NZZ-1) csymb(i)=cd(i0+i)
        enddo
        call four2a(csymb,32,1,-1,1)           !c2c
        do i=0,7
           s8(i)=real(csymb(i))**2 + aimag(csymb(i))**2
        enddo
        s8sum=sum(s8)
        if(s8sum.gt.0.0) then
           p=s8(itone_best(k))/s8sum
           plog=plog + log(p)
           nsum=nsum+1
        endif
        ipk=maxloc(s8)-1
        if(ipk(1).ne.itone_best(k)) nhard=nhard+1
        if(k.le.7 .or. (k.ge.37 .and. k.le.43) .or. k.ge.73) then
           sum_sync=sum_sync + s8(itone_best(k))
        else
           sum_sig=sum_sig + s8(itone_best(k))
        endif
        sum_big=sum_big + s8(ipk(1))
     enddo
     if(nsum.lt.NN) plog=plog + (NN-nsum)*log(0.125)
     sigobig=(sum_sync+sum_sig)/sum_big
!     write(60,3060) nsum,xdt,fbest,xsnr,plog,nhard,sigosync,sigobig,trim(msgbest)
!3060 format(i2,f8.3,3f8.1,i5,2f7.2,1x,a)
     if(nhard.gt.54 .or. plog.lt.-159.0 .or. sigobig.lt.0.71) msgbest=''
  endif
  
  return
end subroutine ft8_a8d

subroutine qmapa(dd,ss,savg,newdat,nutc,fcenter,ntol,nfa,nfb,         &
     mousedf,mousefqso,nagain,ntx30a,ntx30b,nfshift,max_drift,offset, &
     nfcal,mycall,hiscall,hisgrid,nfsample,nBaseSubmode,ndepth,       &
     datetime,ndop00,fselected,bAlso30,nhsym,nCFOM)

!  Processes timf2 data received from Linrad to find and decode Q65 signals.

  use timer_module, only: timer

  type candidate
     real :: snr          !Relative S/N of sync detection
     real :: f            !Freq of sync tone, 0 to 96000 Hz
     real :: xdt          !DT of matching sync pattern, -1.0 to +4.0 s
     integer :: ntrperiod !60 for Q65-60x, 30 for Q65-30x
     integer :: iseq      !0 for first half-minute, 1 for second half
  end type candidate

  type good_decode
     real :: f            !Freq of sync tone, 0 to 96000 Hz
     integer :: ntrperiod !60 for Q65-60x, 30 for Q65-30x
     integer :: iseq      !0 for first half-minute, 1 for second half
  end type good_decode

  parameter (NFFT=32768)             !Size of FFTs done in symspec()
  parameter (MAX_CANDIDATES=50)
  parameter (MAXMSG=1000)            !Size of decoded message list
  parameter (NSMAX=60*96000)
  real dd(2,NSMAX)                   !I/Q data from Linrad
  real ss(400,NFFT)                  !Symbol spectra
  real savg(NFFT)                    !Average spectrum
  real*8 fcenter                     !Center RF frequency, MHz
  logical*1 bAlso30,bClickDecode
  character mycall*12,hiscall*12,hisgrid*6
  type(candidate) :: cand(MAX_CANDIDATES)
  type(good_decode) found(MAX_CANDIDATES)
  character*64 result
  character*20 datetime
  common/decodes/ndecodes,ncand2,nQDecoderDone,nWDecoderBusy,              &
       nWTransmitting,kHzRequested,result(50)
  save

  tsec0=sec_midn()
  if(nagain.ge.1) ndepth=3            !Use full depth for click-to-decode
  nkhz_center=nint(1000.0*(fcenter-int(fcenter)))
  mfa=nfa-nkhz_center+48
  mfb=nfb-nkhz_center+48
  mode_q65=nBaseSubmode
  nts_q65=2**(mode_q65-1)             !Q65 tone separation factor
  f0_selected=fselected - nkhz_center + 48.0

  if(nagain.le.1) then
     call timer('get_cand',0)
     ! Get a list of decoding candidates
     call getcand2(ss,savg,nts_q65,nagain,nhsym,ntx30a,ntx30b,ntol,     &
          f0_selected,bAlso30,cand,ncand2)
     call timer('get_cand',1)
  endif

  nwrite_q65=0
  df=96000.0/NFFT                     !df = 96000/NFFT = 2.930 Hz
  ftol=0.010                          !Frequency tolerance (kHz)
  foffset=0.001*(1270 + nfcal)        !Offset from sync tone, plus CAL
  fqso=mousefqso + foffset - 0.5*(nfa+nfb) + nfshift !fqso at baseband (khz)
  nqd=0
  bClickDecode=(nagain.ge.1)

  call timer('fftbig  ',0)
  call fftbig(dd,NSMAX) !Do the full-length FFT
  call timer('fftbig  ',1)

  if(nagain.ge.2) then
     ncand2=1
     fqso=fselected
  endif

  do icand=1,ncand2                        !Attempt to decode each candidate
     tsec=sec_midn() - tsec0
     if(ndiskdat.eq.0) then
        ! No more realtime decode attempts if it's nearly too late, already
        if(nhsym.eq.130 .and. tsec.gt.6.0) exit
        if(nhsym.eq.200 .and. tsec.gt.10.0) exit
        if(nhsym.eq.330 .and. tsec.gt.6.0) exit
        if(nhsym.eq.390 .and. tsec.gt.16.0) exit
     endif
     f0=cand(icand)%f
     ntrperiod=cand(icand)%ntrperiod
     iseq=cand(icand)%iseq

     if(nagain.eq.0) then
        ! Skip this candidate if we already decoded it.
        do j=1,ndecodes
           if(abs(f0-found(j)%f).lt.0.005 .and.                             &
           ntrperiod.eq.found(j)%ntrperiod .and.                            &
           iseq.eq.found(j)%iseq) go to 10
        enddo
     endif

     mode_q65_tmp=mode_q65
     if(ntrperiod.eq.30) mode_q65_tmp=max(1,mode_q65-1)
     freq=f0+nkhz_center-48.0-1.27046
     ikhz=nint(freq)
     idec=-1
     call timer('q65b    ',0)
     call q65b(nutc,nqd,fcenter,nfcal,nfsample,ikhz,mousedf,ntol,           &
          ntrperiod,iseq,mycall,hiscall,hisgrid,mode_q65_tmp,f0,fqso,       &
          nkhz_center,newdat,nagain,bClickDecode,max_drift,offset,         &
          ndepth,datetime,nCFOM,ndop00,nhsym,idec)
     call timer('q65b    ',1)
     if(bClickDecode .and. idec.ge.0) exit
     if(idec.ge.0) then
        ! Save some details on good decodes, to avoid duplicated effort
        found(ndecodes)%f=f0
        found(ndecodes)%ntrperiod=ntrperiod
        found(ndecodes)%iseq=iseq
     end if
10   continue
  enddo  ! icand

  return
end subroutine qmapa

module tm2_mod
  implicit none

  interface
     subroutine tmoonsub(day, glat, glong, el, rv, xl, b, pax)
       real(8), intent(in)  :: day, glat, glong
       real(8), intent(out) :: el, rv, xl, b, pax
     end subroutine tmoonsub
  end interface

contains

subroutine tm2(day, xlat4, xlon4, xl4, b4)
  implicit none

  ! Arguments
  real(8), intent(in)  :: day
  real(4), intent(in)  :: xlat4, xlon4
  real(4), intent(out) :: xl4, b4

  ! Locals
  real(8), parameter :: RADS = 0.0174532925199433d0
  real(8) :: glat, glong
  real(8) :: el, rv, xl, b, pax

  ! Convert to radians
  glat  = xlat4 * RADS
  glong = xlon4 * RADS

  ! Call the external routine
  call tmoonsub(day, glat, glong, el, rv, xl, b, pax)

  ! Convert back to real*4
  xl4 = real(xl, 4)
  b4  = real(b, 4)

end subroutine tm2

end module tm2_mod

subroutine addit(itone,nfsample,nsym,nsps,ifreq,sig,dat)

  integer itone(nsym)
  real dat(60*12000)
  real*8 f,dt,twopi,phi,dphi,baud,fsample,freq,tsym,t

  tsym=nsps*1.d0/nfsample            !Symbol duration
  baud=1.d0/tsym
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  dphi=0.

  f=ifreq
  phi=0.
  ntot=nsym*tsym/dt
  k=12000                             !Start audio at t = 1.0 s
  t=0.
  isym0=-1
  do i=1,ntot
     t=t+dt
     isym=nint(t/tsym) + 1
     if(isym.gt.nsym) exit
     if(isym.ne.isym0) then
        freq=f + itone(isym)*baud
        dphi=twopi*freq*dt
        isym0=isym
     endif
     phi=phi + dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     k=k+1
     dat(k)=dat(k) + sig*sin(xphi)
  enddo

  return
end subroutine addit

subroutine addcw(icw,ncw,ifreq,sig,dat)

  integer icw(ncw)
  real dat(60*12000)
  real s(60*12000)
  real x(60*12000)
  real y(60*12000)
  real*8 dt,twopi,phi,dphi,fsample,tdit,t

  wpm=25.0
  nspd=nint(1.2*12000.0/wpm)
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  tdit=nspd*dt
  twopi=8.d0*atan(1.d0)
  dphi=twopi*ifreq*dt
  phi=0.
  k=12000                             !Start audio at t = 1.0 s
  t=0.
  npts=59*12000
  x=0.
  do i=1,npts
     t=t+dt
     j=nint(t/tdit) + 1
     j=mod(j-1,ncw) + 1
     phi=phi + dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     k=k+1
     x(k)=icw(j)
     s(k)=sin(xphi)
     if(t.ge.59.5) exit
  enddo

  nadd=0.004/dt
  call smo(x,npts,y,nadd)
  y=y/nadd
  dat=dat + sig*y*s

  return
end subroutine addcw

!-------------------------------------------------------------------------------
!
! This file is part of the WSPR application, Weak Signal Propagation Reporter
!
! File Name:    wspr_old_subs.f90
! Description:  Utility subroutines from WSPR 2.0
!
! Copyright (C) 2001-2014 Joseph Taylor, K1JT
! License: GPL-3
!
! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 3 of the License, or (at your option) any later
! version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
! details.
!
! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
! Street, Fifth Floor, Boston, MA 02110-1301, USA.
!
!-------------------------------------------------------------------------------

subroutine deg2grid(dlong0,dlat,grid)

  real dlong                        !West longitude (deg)
  real dlat                         !Latitude (deg)
  character grid*6

  dlong=dlong0
  if(dlong.lt.-180.0) dlong=dlong+360.0
  if(dlong.gt.180.0) dlong=dlong-360.0

! Convert to units of 5 min of longitude, working east from 180 deg.
  nlong=60.0*(180.0-dlong)/5.0
  n1=nlong/240                      !20-degree field
  n2=(nlong-240*n1)/24              !2 degree square
  n3=nlong-240*n1-24*n2             !5 minute subsquare
  grid(1:1)=char(ichar('A')+n1)
  grid(3:3)=char(ichar('0')+n2)
  grid(5:5)=char(ichar('a')+n3)

! Convert to units of 2.5 min of latitude, working north from -90 deg.
  nlat=60.0*(dlat+90)/2.5
  n1=nlat/240                       !10-degree field
  n2=(nlat-240*n1)/24               !1 degree square
  n3=nlat-240*n1-24*n2              !2.5 minuts subsquare
  grid(2:2)=char(ichar('A')+n1)
  grid(4:4)=char(ichar('0')+n2)
  grid(6:6)=char(ichar('a')+n3)

  return
end subroutine deg2grid

subroutine encode232(dat,nbytes,symbol,maxsym)

! Convolutional encoder for a K=32, r=1/2 code.

  integer*1 dat(nbytes)             !User data, packed 8 bits per byte
  integer*1 symbol(maxsym)          !Channel symbols, one bit per byte
  integer*1 i1

! Layland-Lushbaugh polynomials for a K=32, r=1/2 convolutional code,
! and 8-bit parity lookup table.

  data npoly1/-221228207/,npoly2/-463389625/
  integer*1 partab(0:255)
  data partab/                 &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0/

  nstate=0
  k=0
  do j=1,nbytes
     do i=7,0,-1
        i1=dat(j)
        i4=i1
        if (i4.lt.0) i4=i4+256
        nstate=ior(ishft(nstate,1),iand(ishft(i4,-i),1))
        n=iand(nstate,npoly1)
        n=ieor(n,ishft(n,-16))
        k=k+1
        symbol(k)=partab(iand(ieor(n,ishft(n,-8)),255))
        n=iand(nstate,npoly2)
        n=ieor(n,ishft(n,-16))
        k=k+1
        symbol(k)=partab(iand(ieor(n,ishft(n,-8)),255))
     enddo
  enddo

  return
end subroutine encode232

subroutine fano232(symbol,nbits,mettab,ndelta,maxcycles,dat,ncycles,metric,ierr)

! Sequential decoder for K=32, r=1/2 convolutional code using 
! the Fano algorithm.  Translated from C routine for same purpose
! written by Phil Karn, KA9Q.

  parameter (MAXBITS=103)
  parameter (MAXDAT=13)               !(MAXBITS+7)/8
  integer*1 symbol(0:2*MAXBITS-1)
  integer*1 dat(MAXDAT)               !Decoded user data, 8 bits per byte
  integer mettab(0:255,0:1)           !Metric table

! These were the "node" structure in Karn's C code:
  integer nstate(0:MAXBITS-1)      !Encoder state of next node
  integer gamma(0:MAXBITS-1)       !Cumulative metric to this node
  integer metrics(0:3,0:MAXBITS-1) !Metrics indexed by all possible Tx syms
  integer tm(0:1,0:MAXBITS-1)      !Sorted metrics for current hypotheses
  integer ii(0:MAXBITS-1)          !Current branch being tested

  logical noback

! Layland-Lushbaugh polynomials for a K=32, r=1/2 convolutional code,
! and 8-bit parity lookup table.

  data npoly1/-221228207/,npoly2/-463389625/
  integer*1 partab(0:255)
  data partab/                 &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       0, 1, 1, 0, 1, 0, 0, 1, &
       1, 0, 0, 1, 0, 1, 1, 0/

  ntail=nbits-31

! Compute all possible branch metrics for each symbol pair.
! This is the only place we actually look at the raw input symbols
  i4a=0
  i4b=0
  do np=0,nbits-1
     j=2*np
     i4a=symbol(j)
     i4b=symbol(j+1)
     if (i4a.lt.0) i4a=i4a+256
     if (i4b.lt.0) i4b=i4b+256
     metrics(0,np) = mettab(i4a,0) + mettab(i4b,0)
     metrics(1,np) = mettab(i4a,0) + mettab(i4b,1)
     metrics(2,np) = mettab(i4a,1) + mettab(i4b,0)
     metrics(3,np) = mettab(i4a,1) + mettab(i4b,1)
  enddo

  np=0
  nstate(np)=0

! Compute and sort branch metrics from the root node
  n=iand(nstate(np),npoly1)
  n=ieor(n,ishft(n,-16))
  lsym=partab(iand(ieor(n,ishft(n,-8)),255))
  n=iand(nstate(np),npoly2)
  n=ieor(n,ishft(n,-16))
  lsym=lsym+lsym+partab(iand(ieor(n,ishft(n,-8)),255))
  m0=metrics(lsym,np)
  m1=metrics(ieor(3,lsym),np)
  if(m0.gt.m1) then
     tm(0,np)=m0                      !0-branch has better metric
     tm(1,np)=m1
  else
     tm(0,np)=m1                      !1-branch is better
     tm(1,np)=m0
     nstate(np)=nstate(np) + 1        !Set low bit
  endif

! Start with best branch
  ii(np)=0
  gamma(np)=0
  nt=0

! Start the Fano decoder
  do i=1,nbits*maxcycles
! Look forward
     ngamma=gamma(np) + tm(ii(np),np)
     if(ngamma.ge.nt) then

! Node is acceptable.  If first time visiting this node, tighten threshold:
        if(gamma(np).lt.(nt+ndelta)) nt=nt +                     &
             ndelta * ((ngamma-nt)/ndelta)

! Move forward
        gamma(np+1)=ngamma
        nstate(np+1)=ishft(nstate(np),1)
        np=np+1
        if(np.eq.nbits-1) go to 100     !We're done!

        n=iand(nstate(np),npoly1)
        n=ieor(n,ishft(n,-16))
        lsym=partab(iand(ieor(n,ishft(n,-8)),255))
        n=iand(nstate(np),npoly2)
        n=ieor(n,ishft(n,-16))
        lsym=lsym+lsym+partab(iand(ieor(n,ishft(n,-8)),255))
            
        if(np.ge.ntail) then
           tm(0,np)=metrics(lsym,np)      !We're in the tail, all zeros
        else
           m0=metrics(lsym,np)
           m1=metrics(ieor(3,lsym),np)
           if(m0.gt.m1) then
              tm(0,np)=m0                 !0-branch has better metric
              tm(1,np)=m1
           else
              tm(0,np)=m1                 !1-branch is better
              tm(1,np)=m0
              nstate(np)=nstate(np) + 1   !Set low bit
           endif
        endif

        ii(np)=0                          !Start with best branch
        go to 99
     endif

! Threshold violated, can't go forward
10   noback=.false.
     if(np.eq.0) noback=.true.
     if(np.gt.0) then
        if(gamma(np-1).lt.nt) noback=.true.
     endif

     if(noback) then
! Can't back up, either.  Relax threshold and look forward again 
! to a better branch.
        nt=nt-ndelta
        if(ii(np).ne.0) then
           ii(np)=0
           nstate(np)=ieor(nstate(np),1)
        endif
        go to 99
     endif

! Back up
     np=np-1
     if(np.lt.ntail .and. ii(np).ne.1) then
! Search the next best branch
        ii(np)=ii(np)+1
        nstate(np)=ieor(nstate(np),1)
        go to 99
     endif
     go to 10
99   continue
  enddo
  i=nbits*maxcycles

100 metric=gamma(np)                       !Final path metric

! Copy decoded data to user's buffer
  nbytes=(nbits+7)/8
  np=7
  do j=1,nbytes-1
     i4a=nstate(np)
     dat(j)=i4a
     np=np+8
  enddo
  dat(nbytes)=0

  ncycles=i+1
  ierr=0
  if(i.ge.maxcycles*nbits) ierr=-1

  return
end subroutine fano232

subroutine grid2deg(grid0,dlong,dlat)

! Converts Maidenhead grid locator to degrees of West longitude
! and North latitude.

  character*6 grid0,grid
  character*1 g1,g2,g3,g4,g5,g6

  grid=grid0
  i=ichar(grid(5:5))
  if(grid(5:5).eq.' ' .or. i.le.64 .or. i.ge.128) grid(5:6)='mm'

  if(grid(1:1).ge.'a' .and. grid(1:1).le.'z') grid(1:1)=            &
       char(ichar(grid(1:1))+ichar('A')-ichar('a'))
  if(grid(2:2).ge.'a' .and. grid(2:2).le.'z') grid(2:2)=            &
       char(ichar(grid(2:2))+ichar('A')-ichar('a'))
  if(grid(5:5).ge.'A' .and. grid(5:5).le.'Z') grid(5:5)=            &
       char(ichar(grid(5:5))-ichar('A')+ichar('a'))
  if(grid(6:6).ge.'A' .and. grid(6:6).le.'Z') grid(6:6)=            &
       char(ichar(grid(6:6))-ichar('A')+ichar('a'))

  g1=grid(1:1)
  g2=grid(2:2)
  g3=grid(3:3)
  g4=grid(4:4)
  g5=grid(5:5)
  g6=grid(6:6)

  nlong = 180 - 20*(ichar(g1)-ichar('A'))
  n20d = 2*(ichar(g3)-ichar('0'))
  xminlong = 5*(ichar(g5)-ichar('a')+0.5)
  dlong = nlong - n20d - xminlong/60.0
  nlat = -90+10*(ichar(g2)-ichar('A')) + ichar(g4)-ichar('0')
  xminlat = 2.5*(ichar(g6)-ichar('a')+0.5)
  dlat = nlat + xminlat/60.0

  return
end subroutine grid2deg

subroutine hash(string,len,ihash)

  parameter (MASK15=32767)
  character*(*) string
  integer*1 ic(12)

     do i=1,len
        ic(i)=ichar(string(i:i))
     enddo
     i=nhash(ic,len,146)
     ihash=iand(i,MASK15)

!     print*,'C',ihash,len,string
  return
end subroutine hash

subroutine inter_mept(id,ndir)

! Interleave (ndir=1) or de-interleave (ndir=-1) the array id.

  integer*1 id(0:161),itmp(0:161)
  integer j0(0:161)
  logical first
  data first/.true./
  save

  if(first) then
! Compute the interleave table using bit reversal.
     k=-1
     do i=0,255
        n=0
        ii=i
        do j=0,7
           n=n+n
           if(iand(ii,1).ne.0) n=n+1
           ii=ii/2
        enddo
        if(n.le.161) then
           k=k+1
           j0(k)=n
        endif
     enddo
     first=.false.
  endif

  if(ndir.eq.1) then
     do i=0,161
        itmp(j0(i))=id(i)
     enddo
  else
     do i=0,161
        itmp(i)=id(j0(i))
     enddo
  endif

  do i=0,161
     id(i)=itmp(i)
  enddo

  return
end subroutine inter_mept

function nchar(c)

! Convert ASCII number, letter, or space to 0-36 for callsign packing.

  character c*1
  data n/0/                            !Silence compiler warning

  if(c.ge.'0' .and. c.le.'9') then
     n=ichar(c)-ichar('0')
  else if(c.ge.'A' .and. c.le.'Z') then
     n=ichar(c)-ichar('A') + 10
  else if(c.ge.'a' .and. c.le.'z') then
     n=ichar(c)-ichar('a') + 10
  else if(c.ge.' ') then
     n=36
  else
     Print*,'Invalid character in callsign ',c,' ',ichar(c)
     stop
  endif
  nchar=n

  return
end function nchar

subroutine pack50(n1,n2,dat)

  integer*1 dat(11),i1

  i1=iand(ishft(n1,-20),255)                !8 bits
  dat(1)=i1
  i1=iand(ishft(n1,-12),255)                 !8 bits
  dat(2)=i1
  i1=iand(ishft(n1, -4),255)                 !8 bits
  dat(3)=i1
  i1=16*iand(n1,15)+iand(ishft(n2,-18),15)   !4+4 bits
  dat(4)=i1
  i1=iand(ishft(n2,-10),255)                 !8 bits
  dat(5)=i1
  i1=iand(ishft(n2, -2),255)                 !8 bits
  dat(6)=i1
  i1=64*iand(n2,3)                           !2 bits
  dat(7)=i1
  dat(8)=0
  dat(9)=0
  dat(10)=0
  dat(11)=0

  return
end subroutine pack50

subroutine packcall(callsign,ncall,text)

! Pack a valid callsign into a 28-bit integer.

  parameter (NBASE=37*36*10*27*27*27)
  character callsign*6,c*1,tmp*6,digit*10
  logical text
  data digit/'0123456789'/

  text=.false.

! Work-around for Swaziland prefix:
  if(callsign(1:4).eq.'3DA0') callsign='3D0'//callsign(5:6)

  if(callsign(1:3).eq.'CQ ') then
     ncall=NBASE + 1
     if(callsign(4:4).ge.'0' .and. callsign(4:4).le.'9' .and.       &
          callsign(5:5).ge.'0' .and. callsign(5:5).le.'9' .and.     &
          callsign(6:6).ge.'0' .and. callsign(6:6).le.'9') then
        nfreq=100*(ichar(callsign(4:4))-48) +                       &
             10*(ichar(callsign(5:5))-48) +                         &
             ichar(callsign(6:6))-48
        ncall=NBASE + 3 + nfreq
     endif
     return
  else if(callsign(1:4).eq.'QRZ ') then
     ncall=NBASE + 2
     return
  endif

  tmp='      '
  if(callsign(3:3).ge.'0' .and. callsign(3:3).le.'9') then
     tmp=callsign
  else if(callsign(2:2).ge.'0' .and. callsign(2:2).le.'9') then
     if(callsign(6:6).ne.' ') then
        text=.true.
        return
     endif
     tmp=' '//callsign(1:5)
  else
     text=.true.
     return
  endif

  do i=1,6
     c=tmp(i:i)
     if(c.ge.'a' .and. c.le.'z')                             &
          tmp(i:i)=char(ichar(c)-ichar('a')+ichar('A'))
  enddo

  n1=0
  if((tmp(1:1).ge.'A'.and.tmp(1:1).le.'Z').or.tmp(1:1).eq.' ') n1=1
  if(tmp(1:1).ge.'0' .and. tmp(1:1).le.'9') n1=1
  n2=0
  if(tmp(2:2).ge.'A' .and. tmp(2:2).le.'Z') n2=1
  if(tmp(2:2).ge.'0' .and. tmp(2:2).le.'9') n2=1
  n3=0
  if(tmp(3:3).ge.'0' .and. tmp(3:3).le.'9') n3=1
  n4=0
  if((tmp(4:4).ge.'A'.and.tmp(4:4).le.'Z').or.tmp(4:4).eq.' ') n4=1
  n5=0
  if((tmp(5:5).ge.'A'.and.tmp(5:5).le.'Z').or.tmp(5:5).eq.' ') n5=1
  n6=0
  if((tmp(6:6).ge.'A'.and.tmp(6:6).le.'Z').or.tmp(6:6).eq.' ') n6=1

  if(n1+n2+n3+n4+n5+n6 .ne. 6) then
     text=.true.
     return 
  endif

  ncall=nchar(tmp(1:1))
  ncall=36*ncall+nchar(tmp(2:2))
  ncall=10*ncall+nchar(tmp(3:3))
  ncall=27*ncall+nchar(tmp(4:4))-10
  ncall=27*ncall+nchar(tmp(5:5))-10
  ncall=27*ncall+nchar(tmp(6:6))-10

  return
end subroutine packcall

subroutine packgrid(grid,ng,text)

  parameter (NGBASE=180*180)
  character*4 grid
  logical text

  text=.false.
  if(grid.eq.'    ') go to 90                 !Blank grid is OK

! Test for numerical signal report, etc.
  if(grid(1:1).eq.'-') then
     n=10*(ichar(grid(2:2))-48) + ichar(grid(3:3)) - 48
     ng=NGBASE+1+n
     go to 100
  else if(grid(1:2).eq.'R-') then
     n=10*(ichar(grid(3:3))-48) + ichar(grid(4:4)) - 48
     if(n.eq.0) go to 90
     ng=NGBASE+31+n
     go to 100
  else if(grid(1:2).eq.'RO') then
     ng=NGBASE+62
     go to 100
  else if(grid(1:3).eq.'RRR') then
     ng=NGBASE+63
     go to 100
  else if(grid(1:2).eq.'73') then
     ng=NGBASE+64
     go to 100
  endif

  if(grid(1:1).lt.'A' .or. grid(1:1).gt.'R') text=.true.
  if(grid(2:2).lt.'A' .or. grid(2:2).gt.'R') text=.true.
  if(grid(3:3).lt.'0' .or. grid(3:3).gt.'9') text=.true.
  if(grid(4:4).lt.'0' .or. grid(4:4).gt.'9') text=.true.
  if(text) go to 100

  call grid2deg(grid//'mm',dlong,dlat)
  long=dlong
  lat=dlat+ 90.0
  ng=((long+180)/2)*180 + lat
  go to 100

90 ng=NGBASE + 1

100 return
end subroutine packgrid

subroutine packpfx(call1,n1,ng,nadd)

  character*12 call1,call0
  character*3 pfx
  logical text

  i1=index(call1,'/')
  if(call1(i1+2:i1+2).eq.' ') then
! Single-character add-on suffix (maybe also fourth suffix letter?)
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     nc=ichar(call1(i1+1:i1+1))
     if(nc.ge.48 .and. nc.le.57) then
        n=nc-48
     else if(nc.ge.65 .and. nc.le.90) then
        n=nc-65+10
     else
        n=38
     endif
     nadd=1
     ng=60000-32768+n
  else if(call1(i1+3:i1+3).eq.' ') then
! Two-character numerical suffix, /10 to /99
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     n=10*(ichar(call1(i1+1:i1+1))-48) + ichar(call1(i1+2:i1+2)) - 48
     nadd=1
     ng=60000 + 26 + n
  else
! Prefix of 1 to 3 characters
     pfx=call1(:i1-1)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     call0=call1(i1+1:)
     call packcall(call0,n1,text)

     ng=0
     do i=1,3
        nc=ichar(pfx(i:i))
        if(nc.ge.48 .and. nc.le.57) then
           n=nc-48
        else if(nc.ge.65 .and. nc.le.90) then
           n=nc-65+10
        else
           n=36
        endif
        ng=37*ng + n
     enddo
     nadd=0
     if(ng.ge.32768) then
        ng=ng-32768
        nadd=1
     endif
  endif

  return
end subroutine packpfx

subroutine unpack50(dat,n1,n2)

  integer*1 dat(11)

  i=dat(1)
  i4=iand(i,255)
  n1=ishft(i4,20)
  i=dat(2)
  i4=iand(i,255)
  n1=n1 + ishft(i4,12)
  i=dat(3)
  i4=iand(i,255)
  n1=n1 + ishft(i4,4)
  i=dat(4)
  i4=iand(i,255)
  n1=n1 + iand(ishft(i4,-4),15)
  n2=ishft(iand(i4,15),18)
  i=dat(5)
  i4=iand(i,255)
  n2=n2 + ishft(i4,10)
  i=dat(6)
  i4=iand(i,255)
  n2=n2 + ishft(i4,2)
  i=dat(7)
  i4=iand(i,255)
  n2=n2 + iand(ishft(i4,-6),3)

  return
end subroutine unpack50

subroutine unpackcall(ncall,word)

  character word*12,c*37

  data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ '/

  n=ncall
  word='......'
  if(n.ge.262177560) go to 999            !Plain text message ...
  i=mod(n,27)+11
  word(6:6)=c(i:i)
  n=n/27
  i=mod(n,27)+11
  word(5:5)=c(i:i)
  n=n/27
  i=mod(n,27)+11
  word(4:4)=c(i:i)
  n=n/27
  i=mod(n,10)+1
  word(3:3)=c(i:i)
  n=n/10
  i=mod(n,36)+1
  word(2:2)=c(i:i)
  n=n/36
  i=n+1
  word(1:1)=c(i:i)
  do i=1,4
     if(word(i:i).ne.' ') go to 10
  enddo
  go to 999
10 word=word(i:)

999 if(word(1:3).eq.'3D0') word='3DA0'//word(4:)
  return
end subroutine unpackcall

subroutine unpackgrid(ng,grid)

  parameter (NGBASE=180*180)
  character grid*4,grid6*6,digit*10
  data digit/'0123456789'/

  grid='    '
  if(ng.ge.32400) go to 10
  dlat=mod(ng,180)-90
  dlong=(ng/180)*2 - 180 + 2
  call deg2grid(dlong,dlat,grid6)
  grid=grid6(1:4) !XXX explicitly truncate this -db
  go to 100

10 n=ng-NGBASE-1
  if(n.ge.1 .and.n.le.30) then
     grid(1:1)='-'
     grid(2:2)=char(48+n/10)
     grid(3:3)=char(48+mod(n,10))
  else if(n.ge.31 .and.n.le.60) then
     n=n-30
     grid(1:2)='R-'
     grid(3:3)=char(48+n/10)
     grid(4:4)=char(48+mod(n,10))
  else if(n.eq.61) then
     grid='RO'
  else if(n.eq.62) then
     grid='RRR'
  else if(n.eq.63) then
     grid='73'
  endif

100 return
end subroutine unpackgrid

subroutine unpackpfx(ng,call1)

  character*12 call1
  character*3 pfx

  if(ng.lt.60000) then
! Add-on prefix of 1 to 3 characters
     n=ng
     do i=3,1,-1
        nc=mod(n,37)
        if(nc.ge.0 .and. nc.le.9) then
           pfx(i:i)=char(nc+48)
        else if(nc.ge.10 .and. nc.le.35) then
           pfx(i:i)=char(nc+55)
        else
           pfx(i:i)=' '
        endif
        n=n/37
     enddo
     call1=pfx//'/'//call1(1:8)
     if(call1(1:1).eq.' ') call1=call1(2:)
     if(call1(1:1).eq.' ') call1=call1(2:)
  else
! Add-on suffix, one or teo characters
     i1=index(call1,' ')
     nc=ng-60000
     if(nc.ge.0 .and. nc.le.9) then
        call1=call1(:i1-1)//'/'//char(nc+48)
     else if(nc.ge.10 .and. nc.le.35) then
        call1=call1(:i1-1)//'/'//char(nc+55)
     else if(nc.ge.36 .and. nc.le.125) then
        nc1=(nc-26)/10
        nc2=mod(nc-26,10)
        call1=call1(:i1-1)//'/'//char(nc1+48)//char(nc2+48)
     endif
  endif

  return
end subroutine unpackpfx

subroutine wqdecode(data0,message,ntype)

  parameter (N15=32768)
  integer*1 data0(11)
  character*22 message
  character*12 callsign
  character*3 cdbm
  character grid4*4,grid6*6
  logical first
  character*12 dcall(0:N15-1)
  data first/.true./
  save first,dcall

! May want to have a timeout (say, one hour?) on calls fetched 
! from the hash table.

  if(first) then
     dcall='            '
     first=.false.
  endif

  message='                      '
  call unpack50(data0,n1,n2)
  call unpackcall(n1,callsign)
  i1=index(callsign,' ')
  call unpackgrid(n2/128,grid4)
  ntype=iand(n2,127) -64

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  if(ntype.ge.0 .and. ntype.le.62) then
     nu=mod(ntype,10)
     if(nu.eq.0 .or. nu.eq.3 .or. nu.eq.7) then
        write(cdbm,'(i3)') ntype
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        message=callsign(1:i1)//grid4//' '//cdbm
        call hash(callsign,i1-1,ih)
        dcall(ih)=callsign(:i1)
     else
        nadd=nu
        if(nu.gt.3) nadd=nu-3
        if(nu.gt.7) nadd=nu-7
        ng=n2/128 + 32768*(nadd-1)
        call unpackpfx(ng,callsign)
        ndbm=ntype-nadd
        write(cdbm,'(i3)') ndbm
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
        i2=index(callsign,' ')
        message=callsign(:i2)//cdbm
        call hash(callsign,i2-1,ih)
        dcall(ih)=callsign(:i2)
     endif
  else if(ntype.lt.0) then
     ndbm=-(ntype+1)
     grid6=callsign(6:6)//callsign(1:5)
     ih=(n2-ntype-64)/128
     callsign=dcall(ih)
     write(cdbm,'(i3)') ndbm
     if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
     if(cdbm(1:1).eq.' ') cdbm=cdbm(2:)
     i2=index(callsign,' ')
     if(dcall(ih)(1:1).ne.' ') then
        message='<'//callsign(:i2-1)//'> '//grid6//' '//cdbm
     else
        message='<...> '//grid6//' '//cdbm
     endif
  endif

  return
end subroutine wqdecode

subroutine wqencode(msg,ntype,data0)

!  Parse and encode a WSPR message.

  parameter (MASK15=32767)
  character*22 msg
  character*12 call1,call2
  character grid4*4,grid6*6
  logical lbad1,lbad2
  integer*1 data0(11)
  integer nu(0:9)
  data nu/0,-1,1,0,-1,2,1,0,-1,1/

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  i1=index(msg,' ')
  i2=index(msg,'/')
  i3=index(msg,'<')
  call1=msg(:i1-1)
  if(i1.lt.3 .or. i1.gt.7 .or. i2.gt.0 .or. i3.gt.0) go to 10
  grid4=msg(i1+1:i1+4)
  call packcall(call1,n1,lbad1)
  call packgrid(grid4,ng,lbad2)
  if(lbad1 .or. lbad2) go to 10
  ndbm=0
  read(msg(i1+5:),*) ndbm
  if(ndbm.lt.0) ndbm=0
  if(ndbm.gt.60) ndbm=60
  ndbm=ndbm+nu(mod(ndbm,10))
  n2=128*ng + (ndbm+64)
  call pack50(n1,n2,data0)
  ntype=ndbm
  go to 900

10 if(i2.ge.2 .and. i3.lt.1) then
     call packpfx(call1,n1,ng,nadd)
     ndbm=0
     read(msg(i1+1:),*) ndbm
     if(ndbm.lt.0) ndbm=0
     if(ndbm.gt.60) ndbm=60
     ndbm=ndbm+nu(mod(ndbm,10))
     ntype=ndbm + 1 + nadd
     n2=128*ng + ntype + 64
     call pack50(n1,n2,data0)
  else if(i3.eq.1) then
     i4=index(msg,'>')
     call1=msg(2:i4-1)
     call hash(call1,i4-2,ih)
     grid6=msg(i1+1:i1+6)
     call2=grid6(2:6)//grid6(1:1)//'      '
     call packcall(call2,n1,lbad1)
     ndbm=0
     read(msg(i1+8:),*) ndbm
     if(ndbm.lt.0) ndbm=0
     if(ndbm.gt.60) ndbm=60
     ndbm=ndbm+nu(mod(ndbm,10))
     ntype=-(ndbm+1)
     n2=128*ih + ntype + 64
     call pack50(n1,n2,data0)
  endif
  go to 900

900 continue
  return
end subroutine wqencode

module sec_midn_mod
  implicit none
contains

  real function sec_midn()
    implicit none
    integer :: values(8)

    call date_and_time(values=values)

    ! values(5) = hour
    ! values(6) = minute
    ! values(7) = second
    ! values(8) = milliseconds

    sec_midn = values(5)*3600.0 + values(6)*60.0 + values(7) + values(8)/1000.0
  end function sec_midn

end module sec_midn_mod

subroutine foxgen_wrap(msg40,msgbits,itone)

  parameter (NN=79,ND=58,KK=77,NSPS=4*1920)
  parameter (NWAVE=(160+2)*134400*4) !the biggest waveform we generate (FST4-1800)
  logical*1 bMoreCQs
  character*40 msg40,cmsg
  character*12 mycall12
  integer*1 msgbits(KK),msgbits2
  integer itone(NN)
  common/foxcom/wave(NWAVE),nslots,nfreq,i3bit(5),cmsg(5),mycall12,bMoreCQs
  common/foxcom2/itone2(NN),msgbits2(KK)

  nslots=1
  nfreq=300
  i1=index(msg40,'<')
  i2=index(msg40,'>')
  mycall12=msg40(i1+1:i2-1)//'    '
  cmsg(1)=msg40
  i3bit(1)=1
  call foxgen()
  msgbits=msgbits2
  itone=itone2

  return
end subroutine foxgen_wrap

program mapsim

! Generate simulated data for testing of MAP65

  parameter (NMAX=60*96000)
  real*4 d4(4,NMAX)                   !Floating-point data
  integer*2 id4(4,NMAX)               !i*2 data, dual polarization
  integer*2 id2(2,NMAX)               !i*2 data, single polarization
  complex cwave(NMAX)                 !Generated complex waveform (no noise)
  complex z,zx,zy
  real*8 fcenter,fsample,samfac,f,dt,twopi,phi,dphi
  logical bq65
  character msg0*22,message*22,msgsent*22,arg*8,fname*11,mode*2
  character*16 msg_list(60)
  data msg_list/                                          &
       'W1AAA K2BBB EM00','W2CCC K3DDD EM01','W3EEE K4FFF EM02',   &
       'W5GGG K6HHH EM03','W7III K8JJJ EM04','W9KKK K0LLL EM05',   &
       'G0MMM F1NNN JN06','G2OOO F3PPP JN07','G4QQQ F5RRR JN08',   &
       'G6SSS F7TTT JN09','W1XAA K2XBB EM10','W2XCC K3XDD EM11',   &
       'W3XEE K4XFF EM12','W5XGG K6XHH EM13','W7XII K8XJJ EM14',   &
       'W9XKK K0XLL EM15','G0XMM F1XNN JN16','G2XOO F3XPP JN17',   &
       'G4XQQ F5XRR JN18','G6XSS F7XTT JN19','W1YAA K2YBB EM20',   &
       'W2YCC K3YDD EM21','W3YEE K4YFF EM22','W5YGG K6YHH EM23',   &
       'W7YII K8YJJ EM24','W9YKK K0YLL EM25','G0YMM F1YNN JN26',   &
       'G2YOO F3YPP JN27','G4YQQ F5YRR JN28','G6YSS F7YTT JN29',   &
       'W1ZAA K2ZBB EM30','W2ZCC K3ZDD EM31','W3ZEE K4ZFF EM32',   &
       'W5ZGG K6ZHH EM33','W7ZII K8ZJJ EM34','W9ZKK K0ZLL EM35',   &
       'G0ZMM F1ZNN JN36','G2ZOO F3ZPP JN37','G4ZQQ F5ZRR JN38',   &
       'G6ZSS F7ZTT JN39','W1AXA K2BXB EM40','W2CXC K3DXD EM41',   &
       'W3EXE K4FXF EM42','W5GXG K6HXH EM43','W7IXI K8JXJ EM44',   &
       'W9KXK K0LXL EM45','G0MXM F1NXN JN46','G2OXO F3PXP JN47',   &
       'G4QXQ F5RXR JN48','G6SXS F7TXT JN49','W1AYA K2BYB EM50',   &
       'W2CYC K3DYD EM51','W3EYE K4FYF EM52','W5GYG K6HYH EM53',   &
       'W7IYI K8JYJ EM54','W9KYK K0LYL EM55','G0MYM F1NYN JN56',   &
       'G2OYO F3PYP JN57','G4QYQ F5RYR JN58','G6SYS F7TYT JN59'/
  
  nargs=iargc()
  if(nargs.ne.10) then
     print*,'Usage:   mapsim "message"     mode DT  fa fb nsigs pol fDop SNR nfiles'
     print*,'Example: mapsim "CQ K1ABC FN42" B 2.5 -20 20  21    45  0.0 -20   1'
     print*,' '
     print*,'         mode = A B C for JT65; QA-QE for Q65-60A' 
     print*,'         fa = lowest freq in kHz, relative to center'
     print*,'         fb = highest freq in kHz, relative to center'
     print*,'         message = "list" to use callsigns from list'
     print*,'         pol = -1 to generate a range of polarization angles.'
     print*,'         SNR = 0 to generate a range of SNRs.'
     go to 999
  endif

  call getarg(1,msg0)
  call getarg(2,mode)                !JT65 sub-mode (A B C QA-QE)
  call getarg(3,arg)
  read(arg,*) dt0                    !Time delay
  call getarg(4,arg)
  read(arg,*) fa                     !Lowest freq (kHz, relative to fcenter)
  call getarg(5,arg)
  read(arg,*) fb                     !Highest freq
  call getarg(6,arg)
  read(arg,*) nsigs                  !Number of signals in each file
  call getarg(7,arg)
  read(arg,*) npol                   !Polarization in degrees
  pol=npol
  call getarg(8,arg)
  read(arg,*) fdop                   !Doppler spread
  call getarg(9,arg)
  read(arg,*) snrdb                  !S/N
  call getarg(10,arg)
  read(arg,*) nfiles                 !Number of files

  message=msg0                       !Transmitted message
  rmsdb=25.
  rms=10.0**(0.05*rmsdb)
  fcenter=144.125d0                  !Center frequency (MHz)
  fsample=96000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  rad=360.0/twopi
  samfac=1.d0
  bq65=(mode(1:1).eq.'Q')
  ntone_spacing=1
  ntxfreq=1270
  fac=1.0/32767.0
  if(mode(1:1).eq.'B' .or. mode(2:2).eq.'B') ntone_spacing=2
  if(mode(1:1).eq.'C' .or. mode(2:2).eq.'C') ntone_spacing=4
  if(mode(2:2).eq.'D') ntone_spacing=8
  if(mode(2:2).eq.'E') ntone_spacing=16
  npts=NMAX

  write(*,1000)
1000 format('File N Mode  DT    freq   pol   fDop   SNR   Message'/68('-'))

  do ifile=1,nfiles
     ilist=0
     nmin=ifile-1
     if(mode(2:2).eq.' ') nmin=2*nmin
     write(fname,1002) nmin                      !Create the output filenames
1002 format('000000_',i4.4)
     open(10,file=fname//'.iq',access='stream',status='unknown')
     open(11,file=fname//'.tf2',access='stream',status='unknown')

     call noisegen(d4,npts)                      !Generate Gaussuian noise

     if(msg0(1:4).ne.'list') then
        if(bq65) then
           call gen_q65_cwave(message,ntxfreq,ntone_spacing,msgsent,        &
                cwave,nwave)
        else
           call cgen65(message,ntone_spacing,samfac,nsendingsh,msgsent,     &
                cwave,nwave)
        endif
     endif

     if(fdop.gt.0.0) call dopspread(cwave,fdop)

     do isig=1,nsigs

        if(msg0(1:4).eq.'list') then
           ilist=ilist+1
           message=msg_list(ilist)
           if(bq65) then
              call gen_q65_cwave(message,ntxfreq,ntone_spacing,msgsent,     &
                   cwave,nwave)
           else
              call cgen65(message,ntone_spacing,samfac,nsendingsh,msgsent,  &
                   cwave,nwave)
           endif
        endif

        if(npol.lt.0) pol=(isig-1)*180.0/nsigs
        a=cos(pol/rad)
        b=sin(pol/rad)
        f=1000.0*(fa+fb)/2.0
        if(nsigs.gt.1) f=1000.0*(fa + (isig-1)*(fb-fa)/(nsigs-1.0))
        dphi=twopi*f*dt + 0.5*twopi

        snrdbx=snrdb
        if(snrdb.eq.0.0) snrdbx=-15.0 - 15.0*(isig-1.0)/nsigs
        sig=sqrt(2.2*2500.0/96000.0) * 10.0**(0.05*snrdbx)
        write(*,1020) ifile,isig,mode,dt0,0.001*f,nint(pol),fDop,snrdbx,msgsent
1020    format(i3,i3,2x,a2,f6.2,f8.3,i5,2f7.1,2x,a22)

        phi=0.
!        i0=fsample*(3.5d0+0.05d0*(isig-1))
        i0=fsample*(1.d0 + dt0)
        do i=1,nwave
           phi=phi + dphi
           if(phi.lt.-twopi) phi=phi+twopi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=sig*cwave(i)*cmplx(cos(xphi),-sin(xphi))
           zx=a*z
           zy=b*z
           j=i+i0
           d4(1,j)=d4(1,j) + real(zx)
           d4(2,j)=d4(2,j) + aimag(zx)
           d4(3,j)=d4(3,j) + real(zy)
           d4(4,j)=d4(4,j) + aimag(zy)
        enddo
     enddo

     do i=1,npts
        id4(1,i)=nint(rms*d4(1,i))
        id4(2,i)=nint(rms*d4(2,i))
        id4(3,i)=nint(rms*d4(3,i))
        id4(4,i)=nint(rms*d4(4,i))
        id2(1,i)=id4(1,i)
        id2(2,i)=id4(2,i)
     enddo

     write(10) fcenter,id2(1:2,1:npts)
     write(11) fcenter,id4(1:4,1:npts)
     close(10)
     close(11)
  enddo

999 end program mapsim

subroutine dopspread(cwave,fspread)

  parameter (NMAX=60*96000)
  parameter (NFFT=NMAX,NH=NFFT/2)
  complex cwave(NMAX)
  complex cspread(0:NMAX-1)

  twopi=8.0*atan(1.0)
  df=96000.0/nfft
  cspread(0)=1.0
  cspread(NH)=0.
  b=6.0                       !Use truncated Lorenzian shape for fspread
  do i=1,NH
     f=i*df
     x=b*f/fspread
     z=0.
     a=0.
     if(x.lt.3.0) then                          !Cutoff beyond x=3
        a=sqrt(1.111/(1.0+x*x)-0.1)             !Lorentzian amplitude
        phi1=twopi*rran()                       !Random phase
        z=a*cmplx(cos(phi1),sin(phi1))
     endif
     cspread(i)=z
     z=0.
     if(x.lt.3.0) then                !Same thing for negative freqs
        phi2=twopi*rran()
        z=a*cmplx(cos(phi2),sin(phi2))
     endif
     cspread(nfft-i)=z
  enddo

  call four2a(cspread,nfft,1,1,1)             !Transform to time domain

  sum=0.
  do i=0,nfft-1
     p=real(cspread(i))**2 + aimag(cspread(i))**2
     sum=sum+p
  enddo
  avep=sum/nfft
  fac=sqrt(1.0/avep)
  cspread=fac*cspread                   !Normalize to constant avg power
  cwave=cspread*cwave                   !Apply Rayleigh fading
  
!  do i=0,nfft-1
!     p=real(cspread(i))**2 + aimag(cspread(i))**2
!     write(14,3010) i,p,cspread(i)
!3010 format(i8,3f12.6)
!  enddo

  return
end subroutine dopspread

program jt4sim

! Generate simulated jt4 data for testing the decoder using new fading models
! Based on qra64sim with appropriate changes for JT4
! Includes option to generate 1000Hz single tone with "ST" as the message

  use wavhdr
  use packjt
  use jt4
  parameter (NMAX=60*12000)              ! = 648,000
  parameter (NFFT=10*65536,NH=NFFT/2)
  type(hdr) h                            !Header for .wav file
  integer*2 iwave(NMAX)                  !Generated waveform
  integer*4 itone(206)                     !Channel symbols (values 0-8)
  real*4 xnoise(NMAX)                    !Generated random noise
  real*4 dat(NMAX)                       !Generated real data
  complex cdat(NMAX)                     !Generated complex waveform
  complex cspread(0:NFFT-1)              !Complex amplitude for Rayleigh fading
  complex z
  real*8 f0,dt,twopi,phi,dphi,baud,fsample,freq
  character message*22,fname*11,csubmode*1,arg*12
  character msgsent*22
  
  nargs=iargc()
  if(nargs.ne. 7) then
     print *, 'Usage:   jt4sim        "msg"     A-E Nsigs fDop DT Nfiles SNR'
     print *, 'Example  jt4sim "K1ABC W9XYZ EN37" A   10   0.2 0.0   1     0'
     print *, 'Example  jt4sim "ST"               A   10   0.2 0.0   1     0'
     go to 999
  endif
  call getarg(1,message)
  call fmtmsg(message, iz)
  call getarg(2,csubmode)
  mode4=ichar(csubmode) - ichar('A') + 1
  call getarg(3,arg)
  read(arg,*) nsigs
  call getarg(4,arg)
  read(arg,*) fspread
  call getarg(5,arg)
  read(arg,*) xdt
  call getarg(6,arg)
  read(arg,*) nfiles
  call getarg(7,arg)
  read(arg,*) snrdb
  
  if(mode4.ge.8) nsigs=1 ! temporary - will need sorting out
  rms=100.
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  npts=60*12000                      !Total samples in .wav file
  nsps=12000.d0/4.375d0
  baud=12000.d0/nsps                 !Keying rate = 1.7361111111
  nsym=206                           !Number of channel symbols
  h=default_header(12000,npts)
  dfsig=2000.0/nsigs                 !Freq spacing between sigs in file (Hz)
  ichk=0

  write(*,1000) 
1000 format('File  Sig    Freq  A-E   S/N   DT   Dop    Message'/60('-'))

  do ifile=1,nfiles                  !Loop over requested number of files
     write(fname,1002) ifile         !Output filename
1002 format('000000_',i4.4)
     open(10,file=fname//'.wav',access='stream',status='unknown')
     xnoise=0.
     cdat=0.
     if(snrdb.lt.90) then
        do i=1,npts
           xnoise(i)=gran()          !Generate gaussian noise
        enddo
     endif

     do isig=1,nsigs                 !Generate requested number of sigs
        if(mod(nsigs,2).eq.0) f0=1500.0 + dfsig*(isig-0.5-nsigs/2)
        if(mod(nsigs,2).eq.1) f0=1500.0 + dfsig*(isig-(nsigs+1)/2)
        if(nsigs.eq.1) f0=1000.0
        xsnr=snrdb
        if(snrdb.eq.0.0) xsnr=-20 - isig

        call gen4(message,ichk,msgsent,itone,itype)

        bandwidth_ratio=2500.0/6000.0
        sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*xsnr)
        if(xsnr.gt.90.0) sig=1.0
        write(*,1020) ifile,isig,f0,csubmode,xsnr,xdt,fspread,message
1020    format(i4,i4,f10.3,2x,a1,2x,f5.1,f6.2,f6.1,1x,a22)

        phi=0.d0
        dphi=0.d0
        k=(xdt+1.0)*12000                   !Start audio at t = xdt + 1.0 s
        isym0=-99
        
        do i=1,npts                         !Add this signal into cdat()
           isym=i/nsps + 1
           if(isym.gt.nsym) exit
           if(isym.ne.isym0) then
           if(message(1:2).eq.'ST') then    !Finds ST in message string for single tone
              freq=1000                     !1000Hz for single tone
           else 
              freq=f0 + itone(isym)*baud*nch(mode4) 
           endif
              dphi=twopi*freq*dt
              isym0=isym
          
           endif
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=cmplx(cos(xphi),sin(xphi))
           k=k+1
           if(k.ge.1) cdat(k)=cdat(k) + sig*z
        enddo
     enddo

     if(fspread.ne.0) then                  !Apply specified Doppler spread
        df=12000.0/nfft
        twopi=8*atan(1.0)
        cspread(0)=1.0
        cspread(NH)=0.
        b=6.0                                     !Lorenzian 3/28 onward
        do i=1,NH
           f=i*df
           x=b*f/fspread
           z=0.
           a=0.
           if(x.lt.3.0) then                          !Cutoff beyond x=3
              a=sqrt(1.111/(1.0+x*x)-0.1)             !Lorentzian
              call random_number(r1)
              phi1=twopi*r1
              z=a*cmplx(cos(phi1),sin(phi1))
           endif
           cspread(i)=z
           z=0.
           if(x.lt.50.0) then
              call random_number(r2)
              phi2=twopi*r2
              z=a*cmplx(cos(phi2),sin(phi2))
           endif
           cspread(NFFT-i)=z
        enddo

        do i=0,NFFT-1
           f=i*df
           if(i.gt.NH) f=(i-nfft)*df
           s=real(cspread(i))**2 + aimag(cspread(i))**2
!          write(13,3000) i,f,s,cspread(i)
!3000      format(i5,f10.3,3f12.6)
        enddo
!        s=real(cspread(0))**2 + aimag(cspread(0))**2
!        write(13,3000) 1024,0.0,s,cspread(0)

        call four2a(cspread,NFFT,1,1,1)             !Transform to time domain

        sum=0.
        do i=0,NFFT-1
           p=real(cspread(i))**2 + aimag(cspread(i))**2
           sum=sum+p
        enddo
        avep=sum/NFFT
        fac=sqrt(1.0/avep)
        cspread=fac*cspread                   !Normalize to constant avg power
        cdat(1:NFFT)=cspread*cdat(1:NFFT)     !Apply Rayleigh fading

!        do i=0,NFFT-1
!           p=real(cspread(i))**2 + aimag(cspread(i))**2
!           write(14,3010) i,p,cspread(i)
!3010       format(i8,3f12.6)
!        enddo

     endif

     dat=aimag(cdat) + xnoise                 !Add the generated noise
     fac=32767.0/nsigs
     if(snrdb.ge.90.0) iwave(1:npts)=nint(fac*dat(1:npts))
     if(snrdb.lt.90.0) iwave(1:npts)=nint(rms*dat(1:npts))
     write(10) h,iwave(1:npts)                !Save the .wav file
     close(10)
  enddo

999 end program jt4sim

subroutine msk144sync(cdat,nframes,ntol,delf,navmask,npeaks,fc,fest,   &
     npklocs,nsuccess,xmax,c)

!$ use omp_lib

  parameter (NSPM=864)
  complex cdat(NSPM*nframes)
  complex cdat2(NSPM*nframes,8)
  complex c(NSPM)                    !Coherently averaged complex data
  complex cs(NSPM,8)
  complex cb(42)                     !Complex waveform for sync word 

  integer s8(8)
  integer iloc(1)
  integer npklocs(npeaks)
  integer navmask(nframes)                 ! defines which frames to average

  real cbi(42),cbq(42)
  real pkamps(npeaks)
  real xcc(0:NSPM-1)
  real xccs(0:NSPM-1,8)
  real xm(8)
  real bf(8)
  real pp(12)                        !Half-sine pulse shape
  logical first
  data first/.true./
  data s8/0,1,1,1,0,0,1,0/
  save first,cb,fs,pi,twopi,dt,s8,pp

  if(first) then
     pi=4.0*atan(1.0)
     twopi=8.0*atan(1.0)
     fs=12000.0
     dt=1.0/fs

     do i=1,12                       !Define half-sine pulse
       angle=(i-1)*pi/12.0
       pp(i)=sin(angle)
     enddo

! Define the sync word waveforms
     s8=2*s8-1  
     cbq(1:6)=pp(7:12)*s8(1)
     cbq(7:18)=pp*s8(3)
     cbq(19:30)=pp*s8(5)
     cbq(31:42)=pp*s8(7)
     cbi(1:12)=pp*s8(2)
     cbi(13:24)=pp*s8(4)
     cbi(25:36)=pp*s8(6)
     cbi(37:42)=pp(1:6)*s8(8)
     cb=cmplx(cbi,cbq)

     first=.false.
  endif

  nfreqs=2*nint(ntol/delf) + 1
  xm=0.0
  bf=0.0
  nthreads=1
!$ nthreads=min(4,int(OMP_GET_MAX_THREADS(),4))
  nstep=nfreqs/nthreads

!$OMP PARALLEL NUM_THREADS(nthreads) PRIVATE(id,if1,if2)
  id=1
!$ id=OMP_GET_THREAD_NUM() + 1            !Thread id = 1,2,...
  if1=-nint(ntol/delf) + (id-1)*nstep
  if2=if1+nstep-1
  if(id.eq.nthreads) if2=nint(ntol/delf)
  call msk144_freq_search(cdat,fc,if1,if2,delf,nframes,navmask,cb,    &
       cdat2(1,id),xm(id),bf(id),cs(1,id),xccs(1,id))
!$OMP END PARALLEL

  xmax=xm(1)
  fest=fc+bf(1)
  c=cs(1:NSPM,1)
  xcc=xccs(0:NSPM-1,1)
  if(nthreads.gt.1) then
     do i=2,nthreads
        if(xm(i).gt.xmax) then
           xmax=xm(i)
           fest=fc+bf(i)
           c=cs(1:NSPM,i)
           xcc=xccs(0:NSPM-1,i)
        endif
     enddo
  endif

! Find npeaks largest peaks
  do ipk=1,npeaks
     iloc=maxloc(xcc)
     ic2=iloc(1)
     npklocs(ipk)=ic2
     pkamps(ipk)=xcc(ic2-1)
     xcc(max(0,ic2-7):min(NSPM-1,ic2+7))=0.0
  enddo

  nsuccess=0
  if(xmax.ge.1.3) nsuccess=1

  return
end subroutine msk144sync

program ft4sim

! Generate simulated signals for experimental "FT4" mode 

  use wavhdr
  use packjt77
  include 'ft4_params.f90'               !Set various constants
  type(hdr) h                            !Header for .wav file
  character arg*12,fname*17
  character msg37*37,msgsent37*37
  character c77*77
  complex c0(0:NMAX-1)
  complex c(0:NMAX-1)
  real wave(NMAX)
  integer itone(NN)
  integer*1 msgbits(77)
  integer*2 iwave(NMAX)                  !Generated full-length waveform
  integer icos4(4)
  data icos4/0,1,3,2/
  
! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.7) then
     print*,'Usage:    ft4sim "message"               f0   DT fdop del nfiles snr'
     print*,'Examples: ft4sim "CQ W9XYZ EN37"        1500 0.0  0.1 1.0   10   -15'
     print*,'          ft4sim "K1ABC W9XYZ R 539 WI" 1500 0.0  0.1 1.0   10   -15'
     go to 999
  endif
  call getarg(1,msg37)                   !Message to be transmitted
  call getarg(2,arg)
  read(arg,*) f0                         !Frequency (only used for single-signal)
  call getarg(3,arg)
  read(arg,*) xdt                        !Time offset from nominal (s)
  call getarg(4,arg)
  read(arg,*) fspread                    !Watterson frequency spread (Hz)
  call getarg(5,arg)
  read(arg,*) delay                      !Watterson delay (ms)
  call getarg(6,arg)
  read(arg,*) nfiles                     !Number of files
  call getarg(7,arg)
  read(arg,*) snrdb                      !SNR_2500

  nfiles=abs(nfiles)
  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  hmod=1.0                               !Modulation index (0.5 is MSK, 1.0 is FSK)
  tt=NSPS*dt                             !Duration of symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  txt=NZ2*dt                             !Transmission length (s)

  bandwidth_ratio=2500.0/(fs/2.0)
  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
  if(snrdb.gt.90.0) sig=1.0

  ! Source-encode, then get itone()
  i3=-1
  n3=-1
  call pack77(msg37,i3,n3,c77)
  read(c77,'(77i1)') msgbits
  call genft4(msg37,0,msgsent37,msgbits,itone)
  write(*,*)  
  write(*,'(a9,a37,3x,a7,i1,a1,i1)') 'Message: ',msgsent37,'i3.n3: ',i3,'.',n3
  write(*,1000) f0,xdt,txt,snrdb
1000 format('f0:',f9.3,'   DT:',f6.2,'   TxT:',f6.1,'   SNR:',f6.1)
  write(*,*)  
  if(i3.eq.1) then
    write(*,*) '         mycall                         hiscall                    hisgrid'
    write(*,'(28i1,1x,i1,1x,28i1,1x,i1,1x,i1,1x,15i1,1x,3i1)') msgbits(1:77) 
  else
    write(*,'(a14)') 'Message bits: '
    write(*,'(77i1)') msgbits
  endif
  write(*,*) 
  write(*,'(a17)') 'Channel symbols: '
  write(*,'(76i1)') itone
  write(*,*)  

  call sgran()

  fsample=12000.0
  icmplx=1
  call gen_ft4wave(itone,NN,NSPS,fsample,f0,c0,wave,icmplx,NMAX)

  k=nint((xdt+0.5)/dt)-NSPS
  c0=cshift(c0,-k)
  if(k.gt.0) c0(0:k-1)=0.0
  if(k.lt.0) c0(NMAX+k:NMAX-1)=0.0

  do ifile=1,nfiles
     c=c0
     if(fspread.ne.0.0 .or. delay.ne.0.0) call watterson(c,NMAX,NZ,fs,delay,fspread)
     c=sig*c
     wave=real(c)
     peak=maxval(abs(wave))
     nslots=1
   
     if(snrdb.lt.90) then
        do i=1,NMAX                   !Add gaussian noise at specified SNR
           xnoise=gran()
           wave(i)=wave(i) + xnoise
        enddo
     endif

     gain=100.0
     if(snrdb.lt.90.0) then
       wave=gain*wave
     else
       datpk=maxval(abs(wave))
       fac=32766.9/datpk
       wave=fac*wave
     endif
     if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave=nint(wave)
     h=default_header(12000,NMAX)
     write(fname,1102) ifile
1102 format('000000_',i6.6,'.wav')
     open(10,file=fname,status='unknown',access='stream')
     write(10) h,iwave                !Save to *.wav file
     close(10)
     write(*,1110) ifile,xdt,f0,snrdb,fname
1110 format(i4,f7.2,f8.2,f7.1,2x,a17)
  enddo
  
999 end program ft4sim

subroutine getcandidates4(dd,fa,fb,syncmin,nfqso,maxcand,savg,candidate,   &
     ncand,sbase)

  include 'ft4_params.f90'
  real s(NH1,NHSYM)
  real savg(NH1),savsm(NH1)
  real sbase(NH1)
  real x(NFFT1)
  real window(NFFT1)
  complex cx(0:NH1)
  real candidate(2,maxcand),candidatet(2,maxcand)
  real dd(NMAX)
  equivalence (x,cx)
  logical first
  data first/.true./
  save first,window

  if(first) then
    first=.false.
    pi=4.0*atan(1.)
    window=0.
    call nuttal_window(window,NFFT1)
  endif

! Compute symbol spectra, stepping by NSTEP steps.  
  savg=0.
  df=12000.0/NFFT1                            
  fac=1.0/300.0
  do j=1,NHSYM
     ia=(j-1)*NSTEP + 1
     ib=ia+NFFT1-1
     if(ib.gt.NMAX) exit
     x=fac*dd(ia:ib)*window
     call four2a(x,NFFT1,1,-1,0)              !r2c FFT
     s(1:NH1,j)=abs(cx(1:NH1))**2
     savg=savg + s(1:NH1,j)                   !Average spectrum
  enddo
  savg=savg/NHSYM
  savsm=0.
  do i=8,NH1-7
    savsm(i)=sum(savg(i-7:i+7))/15.
  enddo

  nfa=fa/df
  if(nfa.lt.nint(200.0/df)) nfa=nint(200.0/df)
  nfb=fb/df
  if(nfb.gt.nint(4910.0/df)) nfb=nint(4910.0/df)
  call ft4_baseline(savg,nfa,nfb,sbase)
  if(any(sbase(nfa:nfb).le.0)) return 
  savsm(nfa:nfb)=savsm(nfa:nfb)/sbase(nfa:nfb)
  f_offset = -1.5*12000.0/NSPS
  ncand=0
  candidatet=0
  do i=nfa+1,nfb-1
     if(savsm(i).ge.savsm(i-1) .and. savsm(i).ge.savsm(i+1) .and.      &
          savsm(i).ge.syncmin) then
        den=savsm(i-1)-2*savsm(i)+savsm(i+1)
        del=0.
        if(den.ne.0.0)  del=0.5*(savsm(i-1)-savsm(i+1))/den
        fpeak=(i+del)*df+f_offset
        if(fpeak.lt.200.0 .or. fpeak.gt.4910.0) cycle
        speak=savsm(i) - 0.25*(savsm(i-1)-savsm(i+1))*del
        ncand=ncand+1
        candidatet(1,ncand)=fpeak
        candidatet(2,ncand)=speak
        if(ncand.eq.maxcand) exit
     endif
  enddo
  candidate=0
  nq=count(abs(candidatet(1,1:ncand)-nfqso).le.20.0)
  n1=1
  n2=nq+1
  do i=1,ncand
     if(abs(candidatet(1,i)-nfqso).le.20.0) then
        candidate(1:2,n1)=candidatet(1:2,i)
        n1=n1+1
     else
        candidate(1:2,n2)=candidatet(1:2,i)
        n2=n2+1
     endif
  enddo
return
end subroutine getcandidates4

subroutine bpdecode128_90(llr,apmask,maxiterations,message77,cw,nharderror,iter)
!
! A log-domain belief propagation decoder for the (128,90) code.
!
  use iso_c_binding, only: c_loc,c_size_t
  use crc
  integer, parameter:: N=128, K=90, M=N-K
  integer*1 cw(N),apmask(N)
  integer*1 decoded(K)
  integer*1 message77(77)
  integer Nm(11,M)   
  integer Mn(3,N) 
  integer nrw(M)
  integer synd(M)
  real tov(4,N)
  real toc(11,M)
  real tanhtoc(11,M)
  real zn(N)
  real llr(N)
  real Tmn

  include "ldpc_128_90_reordered_parity.f90"

  decoded=0
  toc=0
  tov=0
  tanhtoc=0
! initialize messages to checks
  do j=1,M
    do i=1,nrw(j)
      toc(i,j)=llr((Nm(i,j)))
    enddo
  enddo

  ncnt=0
  nclast=0

  do iter=0,maxiterations

! Update bit log likelihood ratios (tov=0 in iteration 0).
    do i=1,N
      if( apmask(i) .ne. 1 ) then
        zn(i)=llr(i)+sum(tov(1:ncw,i))
      else
        zn(i)=llr(i)
      endif
    enddo

! Check to see if we have a codeword (check before we do any iteration).
    cw=0
    where( zn .gt. 0. ) cw=1
    ncheck=0
    do i=1,M
      synd(i)=sum(cw(Nm(1:nrw(i),i)))
      if( mod(synd(i),2) .ne. 0 ) ncheck=ncheck+1
!     if( mod(synd(i),2) .ne. 0 ) write(*,*) 'check ',i,' unsatisfied'
    enddo
!   write(*,*) 'number of unsatisfied parity checks ',ncheck
    if( ncheck .eq. 0 ) then ! we have a codeword - reorder the columns and return it
      decoded=cw(1:K)
      call chkcrc13a(decoded,nbadcrc)
      if(nbadcrc.eq.0) then
        message77=decoded(1:77)
        nharderror=count( (2*cw-1)*llr .lt. 0.0 )
        return
      endif
    endif

    if( iter.gt.0 ) then  ! this code block implements an early stopping criterion
!    if( iter.gt.10000 ) then  ! this code block implements an early stopping criterion
      nd=ncheck-nclast
      if( nd .lt. 0 ) then ! # of unsatisfied parity checks decreased
        ncnt=0  ! reset counter
      else
        ncnt=ncnt+1
      endif
!      write(*,*) iter,ncheck,nd,ncnt
      if( ncnt .ge. 3 .and. iter .ge. 5 .and. ncheck .gt. 10) then
        nharderror=-1
        return
      endif
    endif
    nclast=ncheck

! Send messages from bits to check nodes 
    do j=1,M
      do i=1,nrw(j)
        ibj=Nm(i,j)
        toc(i,j)=zn(ibj)  
        do kk=1,ncw ! subtract off what the bit had received from the check
          if( Mn(kk,ibj) .eq. j ) then  
            toc(i,j)=toc(i,j)-tov(kk,ibj)
          endif
        enddo
      enddo
    enddo

! send messages from check nodes to variable nodes
    do i=1,M
      tanhtoc(1:11,i)=tanh(-toc(1:11,i)/2)
    enddo

    do j=1,N
      do i=1,ncw
        ichk=Mn(i,j)  ! Mn(:,j) are the checks that include bit j
        Tmn=product(tanhtoc(1:nrw(ichk),ichk),mask=Nm(1:nrw(ichk),ichk).ne.j)
        call platanh(-Tmn,y)
!        y=atanh(-Tmn)
        tov(i,j)=2*y
      enddo
    enddo

  enddo
  nharderror=-1
  return

end subroutine bpdecode128_90

! call may not start from 'Q', zero and two digits
  if(call_a(1:1).eq.'Q' .or. call_b(1:1).eq.'Q') then
    nbadcrc=1; msg37='                                     '; return; endif
  if(call_a(1:1).eq.'0' .or. call_b(1:1).eq.'0') then
    nbadcrc=1; msg37='                                     '; return; endif
  if(call_a(1:1).ge.'0' .and. call_a(1:1).le.'9' .and. call_a(2:2).ge.'0' .and. call_a(2:2).le.'9') then
    nbadcrc=1; msg37='                                     '; return; endif
  if(call_b(1:1).ge.'0' .and. call_b(1:1).le.'9' .and. call_b(2:2).ge.'0' .and. call_b(2:2).le.'9') then
    nbadcrc=1; msg37='                                     '; return; endif

module env_module
  implicit none
  integer, parameter :: max_path_length = 4096

contains
  logical function is_windows()
    implicit none
    character(len=256) :: appData
    integer :: length, status
    integer :: i

    ! Initialize the function result to false
    is_windows = .false.

    ! Retrieve the APPDATA environment variable
    call get_environment_variable('APPDATA', appData, length, status)

    ! Check if the environment variable was successfully retrieved
    if (status == 0) then
      ! Look for a backslash in the APPDATA variable
      do i = 1, length
        if (appData(i:i) == '\') then
          is_windows = .true.
          exit
        end if
      end do
    end if
  end function is_windows

  subroutine get_executable_directory(executable_directory)
    implicit none
    character(len=max_path_length), intent(out) :: executable_directory
    character(len=max_path_length) :: full_path, temp_directory
    integer :: length, status, last_sep
    integer :: i, j
    logical :: win

    ! Retrieve the command argument 0, which is the path to the executable
    call get_command_argument(0, full_path, length, status)
    if (status /= 0) then
      executable_directory = 'Unknown'
    else
      full_path = full_path(1:length)

      ! Find the last directory separator
      last_sep = 0
      do i = length, 1, -1
        if (full_path(i:i) == '/' .or. full_path(i:i) == '\') then
          last_sep = i
          exit
        end if
      end do

      ! Extract the directory part
      if (last_sep > 0) then
        executable_directory = full_path(1:last_sep-1)
      else
        executable_directory = '.'
      end if

      ! Check if the OS is not Windows and escape spaces if needed
      win = is_windows()
      if (.not. win) then
        temp_directory = ''
        j = 1
        do i = 1, len_trim(executable_directory)
          if (executable_directory(i:i) == ' ') then
            temp_directory(j:j+1) = '\ '
            j = j + 2
          else
            temp_directory(j:j) = executable_directory(i:i)
            j = j + 1
          end if
        end do
        executable_directory = temp_directory
      end if
    end if
  end subroutine get_executable_directory
end module env_module

subroutine four2a(a,nfft,ndim,isign,iform)

! IFORM = 1, 0 or -1, as data is
! complex, real, or the first half of a complex array.  Transform
! values are returned in array DATA.  They are complex, real, or
! the first half of a complex array, as IFORM = 1, -1 or 0.

! The transform of a real array (IFORM = 0) dimensioned N(1) by N(2)
! by ... will be returned in the same array, now considered to
! be complex of dimensions N(1)/2+1 by N(2) by ....  Note that if
! IFORM = 0 or -1, N(1) must be even, and enough room must be
! reserved.  The missing values may be obtained by complex conjugation.  

! The reverse transformation of a half complex array dimensioned
! N(1)/2+1 by N(2) by ..., is accomplished by setting IFORM
! to -1.  In the N array, N(1) must be the true N(1), not N(1)/2+1.
! The transform will be real and returned to the input array.

! This version of four2a makes calls to the FFTW library to do the 
! actual computations.

  use fftw3
  parameter (NPMAX=2100)                 !Max number of stored plans
  parameter (NSMALL=16385)               !Max half complex size of "small" FFTs
  complex a(nfft)                        !Array to be transformed
  complex aa(NSMALL)                     !Local copy of "small" a()
  integer nn(NPMAX),ns(NPMAX),nf(NPMAX)  !Params of stored plans 
  integer*8 nl(NPMAX),nloc               !More params of plans
  integer*8 plan(NPMAX)                  !Pointers to stored plans
  logical found_plan
  data nplan/0/                          !Number of stored plans
  common/patience/npatience,nthreads     !Patience and threads for FFTW plans
  save plan,nplan,nn,ns,nf,nl

  if(nfft.lt.0) go to 999

  nloc=loc(a)

  found_plan = .false.
  !$omp critical(four2a_setup)
  do i=1,nplan
     if(nfft.eq.nn(i) .and. isign.eq.ns(i) .and.                     &
          iform.eq.nf(i) .and. nloc.eq.nl(i)) then
        found_plan = .true.
        exit
     end if
  enddo

  if(i.ge.NPMAX) stop 'Too many FFTW plans requested.'

  if (.not. found_plan) then
     nplan=nplan+1
     i=nplan

     nn(i)=nfft
     ns(i)=isign
     nf(i)=iform
     nl(i)=nloc

! Planning: FFTW_ESTIMATE, FFTW_ESTIMATE_PATIENT, FFTW_MEASURE, 
!            FFTW_PATIENT,  FFTW_EXHAUSTIVE
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

     if(nfft.le.NSMALL) then
        jz=nfft
        if(iform.le.0) jz=nfft/2+1
        aa(1:jz)=a(1:jz)
     endif

     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     if(isign.eq.-1 .and. iform.eq.1) then
        call sfftw_plan_dft_1d(plan(i),nfft,a,a,FFTW_FORWARD,nflags)
     else if(isign.eq.1 .and. iform.eq.1) then
        call sfftw_plan_dft_1d(plan(i),nfft,a,a,FFTW_BACKWARD,nflags)
     else if(isign.eq.-1 .and. iform.eq.0) then
        call sfftw_plan_dft_r2c_1d(plan(i),nfft,a,a,nflags)
     else if(isign.eq.1 .and. iform.eq.-1) then
        call sfftw_plan_dft_c2r_1d(plan(i),nfft,a,a,nflags)
     else
        stop 'Unsupported request in four2a'
     endif
     !$omp end critical(fftw)

     if(nfft.le.NSMALL) then
        jz=nfft
        if(iform.le.0) jz=nfft/2+1
        a(1:jz)=aa(1:jz)
     endif
  end if
  !$omp end critical(four2a_setup)

  call sfftw_execute(plan(i))
  return

999 continue

  !$omp critical(four2a)
  do i=1,nplan
! The test is only to silence a compiler warning:
     if(ndim.ne.-999) then
        !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
        call sfftw_destroy_plan(plan(i))
        !$omp end critical(fftw)
     end if
  enddo
  nplan=0
  !$omp end critical(four2a)

  return
end subroutine four2a

subroutine gen_EchoCall(callsign,itone)

  character*6 callsign
  integer itone(6)
  
  itone=0                                             !Default character is blank
  do i=1,len(trim(callsign))
     m=ichar(callsign(i:i))
     if(m.ge.48 .and. m.le.57) itone(i)=m-47       !0-9
     if(m.ge.65 .and. m.le.90) itone(i)=m-54       !A-Z
     if(m.ge.97 .and. m.le.122) itone(i)=m-86      !a-z
  enddo

  return
end subroutine gen_EchoCall

subroutine chkcrc13a(decoded,nbadcrc)

  use crc
  integer*1 decoded(90)
  integer*1, target:: i1Dec8BitBytes(12)
  character*90 cbits

! Write decoded bits into cbits: 77-bit message plus 13-bit CRC
  write(cbits,1000) decoded
1000 format(90i1)
  read(cbits,1001) i1Dec8BitBytes
1001 format(12b8)
  read(cbits,1002) ncrc13                         !Received CRC13
1002 format(77x,b13)

  i1Dec8BitBytes(10)=iand(i1Dec8BitBytes(10),transfer(128+64+32+16+8,0_1))
  i1Dec8BitBytes(11:12)=0
  icrc13=crc13(c_loc(i1Dec8BitBytes),12)          !CRC13 computed from 77 msg bits

  nbadcrc=1
  if(ncrc13.eq.icrc13) nbadcrc=0
  
  return
end subroutine chkcrc13a

subroutine wav11(d2,npts,dd)

! Convert i*2 data sampled at 12000 Hz to r*4 sampled at 11025 Hz.

  parameter (NZ11=60*11025,NZ12=60*12000)
  parameter (NFFT1=64*12000,NFFT2=64*11025)
  integer*2 d2(NZ12)
  real*4 dd(NZ11)
  real x(NFFT1)
  complex cx(0:NFFT1/2)
  equivalence (x,cx)
  save x,cx

  jz=min(NZ12,npts)
  x(1:jz)=d2(1:jz)
  x(jz+1:)=0.0
  call four2a(cx,nfft1,1,-1,0)                    !Forward FFT, r2c
  df=12000.0/NFFT1
  ia=5000.0/df
  cx(ia:)=0.0
  call four2a(cx,nfft2,1,1,-1)                   !Inverse FFT, c2r
  npts=jz*11025.0/12000.0
  fac=1.e-6
  dd(1:npts)=fac*x(1:npts)

  return
end subroutine wav11

subroutine toxyz(alpha,delta,r,vec)

  implicit real*8 (a-h,o-z)
  real*8 vec(3)

  vec(1)=r*cos(delta)*cos(alpha)
  vec(2)=r*cos(delta)*sin(alpha)
  vec(3)=r*sin(delta)

  return
end subroutine toxyz

subroutine fromxyz(vec,alpha,delta,r)
  
  implicit real*8 (a-h,o-z)
  real*8 vec(3)
  data twopi/6.283185307d0/

  r=sqrt(vec(1)**2 + vec(2)**2 + vec(3)**2)
  alpha=atan2(vec(2),vec(1))
  if(alpha.lt.0.d0) alpha=alpha+twopi
  delta=asin(vec(3)/r)

  return
end subroutine fromxyz

subroutine downsam9(id2,npts8,nsps8,newdat,nspsd,fpk,c2)

!Downsample from id2() into c2() so as to yield nspsd samples per symbol, 
!mixing from fpk down to zero frequency.  The downsample factor is 432.

  use, intrinsic :: iso_c_binding
  use FFTW3
  use timer_module, only: timer

  include 'constants.f90'
  integer(C_SIZE_T) NMAX1
  parameter (NMAX1=653184)
  parameter (NFFT1=653184,NFFT2=1512)
  type(C_PTR) :: plan                        !Pointers plan for big FFT
  integer*2 id2(0:8*npts8-1)
  logical, intent(inout) :: newdat
  real*4, pointer :: x1(:)
  complex c1(0:NFFT1/2)
  complex c2(0:NFFT2-1)
  real s(5000)
  logical first
  common/patience/npatience,nthreads
  data first/.true./
  save plan,first,c1,s,x1

  df1=12000.0/NFFT1
  npts=8*npts8
  if(npts.gt.NFFT1) npts=NFFT1  !### Fix! ###

  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE
! Plan the FFTs just once

     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     plan=fftwf_alloc_real(NMAX1)
     call c_f_pointer(plan,x1,[NMAX1])
     x1(0:NMAX1-1) => x1        !remap bounds
     call fftwf_plan_with_nthreads(nthreads)
     plan=fftwf_plan_dft_r2c_1d(NFFT1,x1,c1,nflags)
     call fftwf_plan_with_nthreads(1)
     !$omp end critical(fftw)

     first=.false.
  endif

  if(newdat) then
     x1(0:npts-1)=id2(0:npts-1)
     x1(npts:NFFT1-1)=0.                      !Zero the rest of x1
     call timer('FFTbig9 ',0)
     call fftwf_execute_dft_r2c(plan,x1,c1)
     call timer('FFTbig9 ',1)

     nadd=int(1.0/df1)
     s=0.
     do i=1,5000
        j=int((i-1)/df1)
        do n=1,nadd
           j=j+1
           s(i)=s(i)+real(c1(j))**2 + aimag(c1(j))**2
        enddo
     enddo
     newdat=.false.
  endif

  ndown=8*nsps8/nspsd                      !Downsample factor = 432
  nh2=NFFT2/2
  nf=nint(fpk)
  i0=int(fpk/df1)

  nw=100
  ia=max(1,nf-nw)
  ib=min(5000,nf+nw)
  call pctile(s(ia),ib-ia+1,40,avenoise)

  fac=sqrt(1.0/avenoise)
  do i=0,NFFT2-1
     j=i0+i
     if(i.gt.nh2) j=j-NFFT2
     c2(i)=fac*c1(j)
  enddo
  call four2a(c2,NFFT2,1,1,1)              !FFT back to time domain

  return
end subroutine downsam9

subroutine to_contest_msg(msg0,msg)

! If the message has "R grid4" istead of "grid4", remove the "R "
! and substitute the diametrically opposite grid.
  
  character*6 g1,g2
  character*22 msg0,msg
  logical isgrid
  isgrid(g1)=g1(1:1).ge.'A' .and. g1(1:1).le.'R' .and. g1(2:2).ge.'A' .and. &
       g1(2:2).le.'R' .and. g1(3:3).ge.'0' .and. g1(3:3).le.'9' .and.       &
       g1(4:4).ge.'0' .and. g1(4:4).le.'9' .and. g1(1:4).ne.'RR73'

  i0=index(msg0,' R ') + 3                  !Check for ' R ' in message
  g1=msg0(i0:i0+3)//'  '
  if(isgrid(g1)) then                       !Check for ' R grid'
     call grid2deg(g1,dlong,dlat)
     dlong=dlong+180.0
     if(dlong.gt.180.0) dlong=dlong-360.0
     dlat=-dlat
     call deg2grid(dlong,dlat,g2)           !g2=antipodes grid
     msg=msg0(1:i0-3)//g2(1:4)              !Send message with g2
  else
     msg=msg0
  endif

  return
end subroutine to_contest_msg

function nchar(c)

! Convert ascii number, letter, or space to 0-36 for callsign packing.

  character c*1

  n=0                                    !Silence compiler warning
  if(c.ge.'0' .and. c.le.'9') then
     n=ichar(c)-ichar('0')
  else if(c.ge.'A' .and. c.le.'Z') then
     n=ichar(c)-ichar('A') + 10
  else if(c.ge.'a' .and. c.le.'z') then
     n=ichar(c)-ichar('a') + 10
  else if(c.ge.' ') then
     n=36
  else
     Print*,'Invalid character in callsign ',c,' ',ichar(c)
     call exit(1)
  endif
  nchar=n

  return
end function nchar

! Variable              Purpose
!---------------------------------------------------------------------------
integer NRING          !Length of Rx ring buffer
integer NTZ            !Length of Tx waveform in samples
parameter(NRING=230400) !Ring buffer at 12000 samples/sec
parameter(NTZ=23040)   !144*160
parameter(NMAX=30000)  !2.5*12000
real snrdb
integer ndevin         !Device# for audio input
integer ndevout        !Device# for audio output
integer iwrite         !Pointer to Rx ring buffer
integer itx            !Pointer to Tx buffer
integer ngo            !Set to 0 to terminate audio streams
integer nTransmitting  !Actually transmitting?
integer nTxOK          !OK to transmit?
integer nport          !COM port for PTT
logical tx_once        !Transmit one message, then exit
logical ltx            !True if msg i has been transmitted
logical lrx            !True if msg i has been received
logical autoseq
logical QSO_in_progress
integer*2 y1           !Ring buffer for audio channel 0
integer*2 y2           !Ring buffer for audio channel 1
integer*2 iwave        !Data for Tx audio
character*6 mycall
character*6 hiscall
character*6 hiscall_next
character*4 mygrid
character*3 exch
character*37 txmsg

common/gcom1/snrdb,ndevin,ndevout,iwrite,itx,ngo,nTransmitting,nTxOK,nport,   &
     ntxed,tx_once,y1(NRING),y2(NRING),iwave(NTZ+3*1152),ltx(5),lrx(5),      &
     autoseq,QSO_in_progress,mycall,hiscall,hiscall_next,mygrid,exch,txmsg

program cfom_iq

  parameter(NMAX=60*96000)
  integer*2 id2(2,NMAX)
  complex*16 c,w,wstep
  real*8 fcenter,uth8,twopi,dphi
  character*6 mygrid

  twopi=8.d0*atan(1.d0)
  open(10,file='231028_0131.iq',status='old',access='stream')
  open(12,file='231028_0131.cfom',status='unknown',access='stream')

  mygrid='FN20OG'
  nyear=2023
  month=10
  nday=28
  uth8=01 + 31.d0/60
  nfreq=1296
  call astrosub00(nyear,month,nday,uth8,nfreq,mygrid,ndop0)
  call astrosub00(nyear,month,nday,uth8+1.d0/60.d0,nfreq,mygrid,ndop1)

  print*,ndop0,ndop1
  
  read(10) fcenter,id2(1:2,1:56*96000)
  id2(1:2,56*96000+1:NMAX)=0

  dop0=0.5*ndop0
  dop1=0.5*ndop1
  j=0
  w=1.0
  do isec=1,60
     dop=dop0 + (isec-0.5)*(dop1-dop0)/60.
     dphi=dop*twopi/96000.0
     wstep=cmplx(cos(dphi),sin(dphi))
     do n=1,96000
        j=j+1
        x=id2(1,j)
        y=id2(2,j)
        w=w*wstep
        c=100.d0*w*cmplx(x,y)
        id2(1,j)=0.01d0*real(c)
        id2(2,j)=0.01d0*aimag(c)
     enddo
  enddo

  write(12) fcenter,id2
        
end program cfom_iq

subroutine genwave(itone,nsym,nsps,nwave,fsample,tonespacing,f0,icmplx, &
     cwave,wave)

  real*8 tonespacing
  real wave(nwave)
  complex cwave(nwave)
  integer itone(nsym)
  real*8 dt,phi,dphi,twopi,freq

  dt=1.d0/fsample
  twopi=8.d0*atan(1.d0)

! Calculate the audio waveform
  phi=0.d0
  if(icmplx.le.0) wave=0.
  if(icmplx.eq.1) cwave=0.
  k=0
  do j=1,nsym
     freq=f0 + itone(j)*tonespacing
     dphi=twopi*freq*dt
     do i=1,nsps
        k=k+1
        if(icmplx.eq.1) then
           cwave(k)=cmplx(cos(phi),sin(phi))
        else
           wave(k)=sin(phi)
        endif
        phi=phi+dphi
        if(phi.gt.twopi) phi=phi-twopi
     enddo
  enddo

  return
end subroutine genwave

subroutine ft8bvar(newdat1,nQSOProgress,nfqso,nftx,napwid,lsubtract,npos,freqsub, &
     tmpcqdec,tmpmyc,nagainfil,iaptype,f1,xdt,nbadcrc,lft8sdec,msg37,msg37_2,     &
     xsnr,stophint,nthr,lFreeText,ipass,lft8subpass,lspecial,lcqcand,ncqsignal,   &
     nmycsignal,npass,i3bit,lft8s,lmycallstd,lhiscallstd,levenint,loddint,lft8sd, &
     i3,n3,nft8rxfsens,ncount,msgsrcvd,lrepliedother,lhashmsg,lqsothread,         &
     lft8lowth,lhighsens,lsubtracted,tmpcqsig,tmpmycsig,tmpqsosig,lnohiscall,     &
     lnomycall,lnohisgrid,qual,iaptype2)

  use packjt77, only : unpack77var
  use ft8_mod1, only : allmessages,ndecodes,apsym,mcq,m73,mrr73,mrrr,icos7,       &
       naptypes,nhaptypes,one,graymap,oddcopy,evencopy,lastrxmsg,lasthcall,       &
       nlasttx,calldteven,calldtodd,lqsomsgdcd,mycalllen1,msgroot,msgrootlen,     &
       allfreq,idtone25,lapmyc,idtonemyc,mycall,hiscall,lhound,apsymsp,           &
       ndxnsaptypes,apsymdxns1,apsymdxnsrrr,lenabledxcsearch,lwidedxcsearch,      &
       apcqsym,apsymdxnsrr73,apsymdxns73,mybcall,hisbcall,lskiptx1,nft8cycles,    &
       ctwkw,ctwkn,nincallthr,msgincall,xdtincall,maskincallthr,ctwk256,numcqsig, &
       numdeccq,evencq,oddcq,nummycsig,numdecmyc,evenmyc,oddmyc,idtone56,         &
       idtonecqdxcns,evenqso,oddqso,nmycnsaptypes,apsymmyns1,apsymmyns2,          &
       apsymmynsrr73,apsymmyns73,apsymdxstd,apsymdxnsr73,apsymdxns732,ltxing,     &
       apsymmynsrrr,idtonedxcns73,idtonefox73,idtonespec  !ft8md added

  include 'ft8_params.f90'
  character c77*77,msg37*37,msg37_2*37,msgd*37,msgbase37*37,call_a*12,call_b*12
  character callsign*12,grid*12
  character*37 msgsrcvd(130)
  complex cd0(-800:4000),cd1(-800:4000),cd2(-800:4000),cd3(-800:4000),ctwk(32),   &
       csymb(32),cs(0:7,79),csymbr(32),csr(0:7,79),csig(32),csig0(151680),z1,     &
       csymb256(256),cstmp2(0:7,79),csold(0:7,79),cscs(0:7,79)
  real a(5),s8(0:7,79),s82(0:7,79),s2(0:511),sp(0:7),s81(0:7),snrsync(21),        &
       syncw(7),sumkw(7),scoreratiow(7),freqsub(200),s256(0:8),s2563(0:26),       &
       syncavpart(3)
  real bmeta(174),bmetb(174),bmetc(174),bmetd(174)
  real llra(174),llrb(174),llrc(174),llrd(174),llrz(174)
  real qual !ft8md  
  integer*1 message77(77),apmask(174),cw(174),nsmax(8)
  integer itone(79),ip(1),ka(1),nqsoend(3)
  integer, intent(in) :: nQSOProgress,nfqso,nftx,napwid,nthr,ipass,nft8rxfsens
  logical newdat1,lsubtract,lFreeText,nagainfil,lspecial,unpk77_successvar
  logical(1), intent(in) :: stophint,lft8subpass,lmycallstd,lhiscallstd,          &
       lqsothread,lft8lowth,lhighsens,lcqcand,levenint,loddint,lnohiscall,        &
       lnomycall,lnohisgrid
  logical(1) falsedec,lastsync,ldupemsg,lft8s,lft8sdec,lft8sd,lsdone,ldupeft8sd,  &
       lrepliedother,lhashmsg,lvirtual2,lvirtual3,lsd,lcq,ldeepsync,lcallsstd,    &
       lfound,lsubptxfreq,lreverse,lchkcall,lgvalid,lwrongcall,lsubtracted,       &
       lcqsignal,loutapwid,lfoundcq,lmycsignal,lfoundmyc,lqsosig,ldxcsig,         &
       lcqdxcsig,lcqdxcnssig,lqsocandave,lcall1hash,lqsosigtype3,lqso73,lqsorr73, &
       lqsorrr,lfoxspecrpt,lfoxstdr73,lapcqonly,lcall2hash,lskipnotap
  integer iaptype2

  type tmpcqdec_struct
     real freq
     real xdt
  end type tmpcqdec_struct
  type(tmpcqdec_struct) tmpcqdec(numdeccq)

  type tmpcqsig_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type tmpcqsig_struct
  type(tmpcqsig_struct) tmpcqsig(numcqsig) ! 20 sigs 24 threads

  type tmpmyc_struct
     real freq
     real xdt
  end type tmpmyc_struct
  type(tmpmyc_struct) tmpmyc(numdecmyc)

  type tmpmycsig_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type tmpmycsig_struct
  type(tmpmycsig_struct) tmpmycsig(nummycsig) ! 5 sigs

  type tmpqsosig_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type tmpqsosig_struct
  type(tmpqsosig_struct) tmpqsosig(1)

  iaptype2 = 99  !ft8md
  
  max_iterations=30
  nharderrors=-1
  nbadcrc=1
  delfbest=0.
  ibest=0
  dfqso=500.
  rrxdt=0.5
  fs2=200.
  dt2=0.005 ! fs2=12000.0/NDOWN; dt2=1.0/fs2
  lcall1hash=.false.
  lcall2hash=.false.
  lskipnotap=.false.
  ldeepsync=.false.
  if(lft8lowth .or. lft8subpass) ldeepsync=.true.
  lcallsstd=.true.
  if(.not.lmycallstd .or. .not.lhiscallstd) lcallsstd=.false.

  xdt0=xdt
  f10=f1
! apply last freq f1 and last DT criteria here  
  nqso=1
  if(lqsothread .and. .not. lft8sdec .and. .not.lqsomsgdcd .and. .not.stophint &
       .and. nlasttx.ge.1 .and. nlasttx.le.4 .and. abs(f10-nfqso).lt.2.51) then
     if(lastrxmsg(1)%lstate .and. abs(lastrxmsg(1)%xdt-xdt).lt.0.18) then
        nqso=2
     elseif(.not.lastrxmsg(1)%lstate) then
        nqso=2
     endif
  endif

  lvirtual2=.false.
  lvirtual3=.false.
  maxlasttx=4
  if(lqsothread .and. .not. lft8sdec .and. .not.lqsomsgdcd) then
     if(len_trim(hiscall).gt.2) then
        if(xdt.gt.4.9 .or. xdt.lt.-4.9) then
           if(lastrxmsg(1)%lstate .and. trim(lastrxmsg(1)%lastmsg).eq.trim(msgroot)//&
                ' RRR') maxlasttx=5
        endif
        if(xdt.gt.4.9) then
           if(.not.stophint .and. nlasttx.ge.1 .and. nlasttx.le.maxlasttx .and.      &
                abs(f10-nfqso).lt.0.1) then
              if(lastrxmsg(1)%lstate) then
                 xdt0=lastrxmsg(1)%xdt
                 nqso=2
                 lvirtual2=.true.
              endif
              if(.not.lastrxmsg(1)%lstate) then
                 if(levenint) then
                    do i=1,150
                       if(trim(calldteven(i)%call2).eq.trim(hiscall)) then
                          xdt0=calldteven(i)%dt
                          nqso=3
                          lvirtual2=.true.
                          exit
                       endif
                    enddo
                 else if(loddint) then 
                    do i=1,150
                       if(trim(calldtodd(i)%call2).eq.trim(hiscall)) then
                          xdt0=calldtodd(i)%dt
                          nqso=3
                          lvirtual2=.true.
                          exit
                       endif
                    enddo
                 endif
              endif
           endif
        elseif (xdt.lt.-4.9) then
           if(.not.stophint .and. nlasttx.ge.1 .and. nlasttx.le.maxlasttx .and. &
                abs(f10-nfqso).lt.0.1) then
              if(lastrxmsg(1)%lstate) then
                 xdt0=lastrxmsg(1)%xdt
                 nqso=3
                 lvirtual3=.true.
              endif
              if(.not.lastrxmsg(1)%lstate) then
                 if(levenint) then
                    do i=1,150
                       if(trim(calldteven(i)%call2).eq.trim(hiscall)) then
                          xdt0=calldteven(i)%dt
                          nqso=3
                          lvirtual3=.true.
                          exit
                       endif
                    enddo
                 else if(loddint) then
                    do i=1,150
                       if(trim(calldtodd(i)%call2).eq.trim(hiscall)) then
                          xdt0=calldtodd(i)%dt
                          nqso=3
                          lvirtual3=.true.
                          exit
                       endif
                    enddo
                 endif
              endif
           endif
        endif
     endif
  endif

  call ft8_downsamplevar(newdat1,f1,nqso,cd0,cd2,cd3,lhighsens,lsubtracted,npos, &
       freqsub)   !Mix f1 to baseband and downsample

  lsd=.false.
  isd=1
  lcq=.false.
  if(levenint) then
     do i=1,130
        if(.not.evencopy(i)%lstate) cycle
        if(abs(evencopy(i)%freq-f1).lt.3.0 .and. abs(evencopy(i)%dt-xdt).lt.0.19) then
           msgd=evencopy(i)%msg
           lsd=.true.
           isd=i
           if(msgd(1:3).eq.'CQ ' .or. msgd(1:3).eq.'DE ' .or.                &
                msgd(1:4).eq.'QRZ ') lcq=.true.
        endif
     enddo
  elseif(loddint) then
     do i=1,130
        if(.not.oddcopy(i)%lstate) cycle
        if(abs(oddcopy(i)%freq-f1).lt.3.0 .and. abs(oddcopy(i)%dt-xdt).lt.0.19) then
           msgd=oddcopy(i)%msg
           lsd=.true.
           isd=i
           if(msgd(1:3).eq.'CQ ' .or. msgd(1:3).eq.'DE ' .or.                &
                msgd(1:4).eq.'QRZ ') lcq=.true.
        endif
     enddo
  endif

  if(lsd .and. nqso.eq.1) nqso=4

!nlasttx  last TX message
!  0       Tx was halted
!  1      AA1AA BB1BB PL35
!  2      AA1AA BB1BB -15
!  3      AA1AA BB1BB R-15
!  4      AA1AA BB1BB RRR/RR73
!  5      AA1AA BB1BB 73
!  6      CQ BB1BB PL35

  if(nqso.eq.4) cd1=cd0
  do iqso=1,nqso
     lapcqonly=.false.
     if(iqso.gt.1 .and. iqso.lt.4 .and. nqso.eq.4) cycle
     if(xdt0.lt.-4.9 .or. xdt0.gt.4.9) cycle
     if(lvirtual2 .and. iqso.ne.2) cycle
     if(lvirtual3 .and. iqso.lt.2) cycle
     if((lvirtual2 .or. lvirtual3) .and. nft8rxfsens.lt.3 .and. iqso.eq.3) cycle
     lastsync=.false.
     lsdone=.false.
     if(.not.lvirtual2 .and. .not.lvirtual3 .and. iqso.eq.2) then
        cd0=cd2
     elseif(lvirtual2 .and. iqso.eq.2) then
        cd0=cd2
     elseif(lvirtual3 .and. iqso.eq.2) then
        cd0=cd3
     endif
     if(iqso.eq.4) then
        call tonesdvar(msgd,lcq)
        if(.not.ldeepsync) go to 32
        cd0=cd1
     endif
     if(iqso.eq.3) go to 16
     i0=nint((xdt0+0.5)*fs2)                   !Initial guess for start of signal
     smax=0.0
     ctwk=cmplx(1.0,0.0)
     do idt=i0-8,i0+8                         !Search over +/- one quarter symbol
        call sync8dvar(cd0,idt,ctwk,0,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)
        if(sync.gt.smax) then
           smax=sync
           ibest=idt
        endif
     enddo
     xdt2=ibest*dt2                           !Improved estimate for DT

     ! Now peak up in frequency
     i0=nint(xdt2*fs2)
     smax=0.0
     kstep=1
     do ifr=-5,5
        if(iqso.eq.1 .or. iqso.eq.4) then
           ctwk=ctwkw(kstep,:)
           delf=ifr*0.5 ! Search over +/- 2.5 Hz
        else
           ctwk=ctwkn(kstep,:)
           delf=ifr*0.25 ! Search over +/- 1.25 Hz
        endif
        call sync8dvar(cd0,i0,ctwk,1,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)
        if(sync.gt.smax) then
           smax=sync
           delfbest=delf
        endif
        kstep=kstep+1
     enddo
     a=0.0
     a(1)=-delfbest
     call twkfreq1var(cd0,-800,3199,4000,fs2,a,cd0)
     xdt=xdt2
     f1=f10+delfbest                           !Improved estimate of DF
     dfqso=abs(nfqso-f1)
     lastsync=.true.
     call sync8dvar(cd0,i0,ctwk,2,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)

16   if(iqso.eq.3) ibest=ibest+1

     syncav=3.
     syncavpart=3.
     snrsync=0.
     do k=1,79
        i1=ibest+(k-1)*32
        csymb=cd0(i1:i1+31)
        if((k.ge.1 .and. k.le.7) .or. (k.ge.37 .and. k.le.43) .or.             &
             (k.ge.73 .and. k.le.79)) then
           call four2avar(csymb,32,1,-1,1)
           s81(0:7)=abs(csymb(1:8))
           if(k.ge.1 .and. k.le.7) then
              synclev=s81(icos7(k-1))
              snoiselev=(sum(s81)-synclev)/7.0
              if(snoiselev.gt.1.E-16) snrsync(k)=synclev/snoiselev
           else if(k.ge.37 .and. k.le.43) then
              synclev=s81(icos7(k-37))
              snoiselev=(sum(s81)-synclev)/7.0
              if(snoiselev.gt.1.E-16) snrsync(k-29)=synclev/snoiselev
           else if(k.ge.73 .and. k.le.79) then
              synclev=s81(icos7(k-73))
              snoiselev=(sum(s81)-synclev)/7.0
              if(snoiselev.gt.1.E-16) snrsync(k-58)=synclev/snoiselev
           endif
        else
           cycle
        endif
     enddo

     syncav=sum(snrsync)/21.
     syncavpart(1)=sum(snrsync(1:7))/7.
     syncavpart(2)=sum(snrsync(8:14))/7.
     syncavpart(3)=sum(snrsync(15:21))/7.
     syncavemax=maxval(syncavpart,1)

!    plev=0.0
!    do k=1000,1009; abscd=abs(cd0(k)); if(abscd.gt.plev) plev=abscd; enddo
!    plev=plev/61.0
!    do k=0,3199; xx=plev*gran(); yy=plev*gran(); cd0(k)=cd0(k) + complex(xx,yy); enddo

     lreverse=.false.
     if(nft8cycles.lt.2) then 
        if(ipass.eq.2) lreverse=.true.
     else
        if(ipass.eq.5 .or. ipass.eq.7) lreverse=.true.
     endif

     do k=1,79
        i1=ibest+(k-1)*32
        csymb=cd0(i1:i1+31)
        if(syncav.lt.2.5) then
           csymb(1)=csymb(1)*1.9
           csymb(32)=csymb(32)*1.9
           scr=SQRT(abs(csymb(1)))/SQRT(abs(csymb(32)))
           if(scr.gt.1.0) then
              csymb(32)=csymb(32)*scr
           else
              if(scr.gt.1.E-16) csymb(1)=csymb(1)/scr
           endif
        endif
        do i=1,32
           csymbr(i)=cmplx(real(csymb(33-i)),-aimag(csymb(33-i)))
        enddo
        if(lreverse) then
           call four2avar(csymb,32,1,-1,1)
           cscs(0:7,k)=csymb(1:8)/1e3
           csymb=csymbr
        endif
        call four2avar(csymb,32,1,-1,1)
        cs(0:7,k)=csymb(1:8)/1e3
        if(lreverse) then
           csr=cs
        else
           call four2avar(csymbr,32,1,-1,1)
           csr(0:7,k)=csymbr(1:8)/1e3
        endif
        s8(0:7,k)=abs(csymb(1:8))
     enddo

     sp=0.
     do k=0,7
        sp(k)=sum(s8(k,1:7))+sum(s8(k,18:79))
     enddo
     ka=minloc(sp)-1
     k=ka(1)
     if(k.lt.0) go to 128
     do kb=0,7
        if(kb.eq.k) cycle
        spr=sp(kb)/sp(k)
        if(spr.gt.1.5) then
           s8(kb,:)=s8(kb,:)/spr
           sprsqr=SQRT(spr)
           cs(kb,:)=cs(kb,:)/sprsqr
           csr(kb,:)=csr(kb,:)/sprsqr
           cscs(kb,:)=cscs(kb,:)/sprsqr
        endif
     enddo
128  continue

     if(iqso.gt.1 .and. iqso.lt.4) then
        s82=SQRT(s8)
        go to 8
     endif
     if(iqso.eq.4) go to 32

     nsyncscorew=0
     scoreratiowa=0.
     rrxdt=xdt-0.5
     if(rrxdt.ge.-0.5 .and. rrxdt.le.2.13) then
        do k=1,7
           syncw(icos7(k-1)+1)=s8(icos7(k-1),k)+s8(icos7(k-1),k+36) +        &
                s8(icos7(k-1),k+72)
        enddo
        do k=1,7
           sumkw(k)=(sum(s8(k-1,:))-syncw(k))/25.333
        enddo ! (79-3)/3
     else if(rrxdt.lt.-0.5) then
        do k=1,7
           syncw(icos7(k-1)+1)=s8(icos7(k-1),k+36)+s8(icos7(k-1),k+72)
        enddo
        do k=1,7
           sumkw(k)=(sum(s8(k-1,26:79))-syncw(k))/26.
        enddo ! (54-2)/2
     else if(rrxdt.gt.2.13) then
        do k=1,7
           syncw(icos7(k-1)+1)=s8(icos7(k-1),k)+s8(icos7(k-1),k+36)
        enddo
        do k=1,7
           sumkw(k)=(sum(s8(k-1,1:54))-syncw(k))/26.
        enddo ! (54-2)/2
     endif
     do k=1,7
        if(syncw(k).gt.sumkw(k)) nsyncscorew=nsyncscorew+1
        scoreratiow(k)=syncw(k)/sumkw(k)
     enddo
     scoreratiowa=sum(scoreratiow)/7.

! sync quality check
     is1=0
     is2=0
     is3=0
     nsyncscore=0
     nsyncscore1=0
     nsyncscore2=0
     nsyncscore3=0
     scoreratio=0.
     scoreratio1=0.
     scoreratio2=0.
     scoreratio3=0.
     nsync2=0
     do k=1,7
        s81(:)=s8(:,k)
        ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) then
           is1=is1+1
        else
           s81(ip(1)-1)=0.
           ip=maxloc(s81)
           if(icos7(k-1).eq.(ip(1)-1)) nsync2=nsync2+1
        endif
        s81=s8(:,k+36)
        ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) then
           is2=is2+1
        else
           s81(ip(1)-1)=0.
           ip=maxloc(s81)
           if(icos7(k-1).eq.(ip(1)-1)) nsync2=nsync2+1
        endif
        s81=s8(:,k+72)
        ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) then
           is3=is3+1
        else
           s81(ip(1)-1)=0.
           ip=maxloc(s81)
           if(icos7(k-1).eq.(ip(1)-1)) nsync2=nsync2+1
        endif
        if(rrxdt.ge.-0.5) then
           synck=s8(icos7(k-1),k)
           sumk=(sum(s8(:,k))-synck)/7.0
           if(synck.gt.sumk) then
              nsyncscore1=nsyncscore1+1
              scoreratio1=scoreratio1+synck/sumk
           endif
        endif
        synck=s8(icos7(k-1),k+36)
        sumk=(sum(s8(:,k+36))-synck)/7.0
        if(synck.gt.sumk) then
           nsyncscore2=nsyncscore2+1
           scoreratio2=scoreratio2+synck/sumk
        endif
        if(rrxdt.le.2.13) then
           synck=s8(icos7(k-1),k+72)
           sumk=(sum(s8(:,k+72))-synck)/7.0
           if(synck.gt.sumk) then
              nsyncscore3=nsyncscore3+1
              scoreratio3=scoreratio3+synck/sumk
           endif
        endif
     enddo
     nsyncscore=nsyncscore1+nsyncscore2+nsyncscore3
     scoreratio=scoreratio1+scoreratio2+scoreratio3
! hard sync sum - max is 21
     nsync=is1+is2+is3
! bail out
     rscq=0.
     if(lcqcand) then
        do k11=8,16
           ip=maxloc(s8(:,k11))
           if(k11.lt.16) then
              if(ip(1).eq.1) rscq=rscq+1.
           else
              if(ip(1).eq.2) rscq=rscq+1.
           endif
        enddo
        ip=maxloc(s8(:,17))
        if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
        ip=maxloc(s8(:,27))
        if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
        ip=maxloc(s8(:,33))
        if(ip(1).eq.3 .or. ip(1).eq.4) rscq=rscq+0.5
     endif
     if(lcqcand .and. nsync.eq.4) then
        if(nsync+nsync2.lt.12) then
           if(rscq.lt.6.6) then
              nbadcrc=1
              return
           endif
        endif
        lapcqonly=.true.
     else if(lcqcand .and. nsync.eq.5) then
        if(nsync+nsync2.lt.12) then
           if(rscq.lt.6.1) then
              nbadcrc=1
              return
           endif
        endif
        lapcqonly=.true.
     else if(lcqcand .and. nsync.eq.6) then
        if(nsync+nsync2.lt.11) then
           if(rscq.lt.5.6) then
              nbadcrc=1
              return
           endif
        endif
        lapcqonly=.true.
     else
        if(nsync.lt.7) then
           nbadcrc=1
           return
        endif
     endif

     lskipnotap=.false.
     if(.not.lapcqonly .and. nsync.lt.11) then
        nsmax=0
        do k=1,7
           s81=s8(:,k)
           include 'syncdist.f90'
           s81=s8(:,k+36)
           include 'syncdist.f90'
           s81=s8(:,k+72)
           include 'syncdist.f90'
        enddo
        if(sum(nsmax(7:8)).gt.sum(nsmax(2:3)) .or.                          &
             sum(nsmax(5:6)).gt.sum(nsmax(2:3))) lskipnotap=.true.
     endif

!    if(lcqcand .and. nsync.lt.7 .and. nsync.gt.1) then
!      if(nsync+nsync2.lt.9) then
!        rscq=0.
!        do k11=8,16
!          ip=maxloc(s8(:,k11))
!          if(k11.lt.16) then; if(ip(1).eq.1) rscq=rscq+1.; else; if(ip(1).eq.2) rscq=rscq+1.; endif
!        enddo
!        ip=maxloc(s8(:,17)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
!        ip=maxloc(s8(:,27)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
!        ip=maxloc(s8(:,33)); if(ip(1).eq.3 .or. ip(1).eq.4) rscq=rscq+0.5
!        if(rscq.lt.4.9) then; nbadcrc=1; return; endif
!      endif
!    else
!      if(nsync.lt.7) then; nbadcrc=1; return; endif
!    endif

     if(nsyncscore.gt.0) then
        scoreratio=scoreratio/nsyncscore
     else
        scoreratio=0.
     endif
     if(nsyncscore1.gt.0) then
        scoreratio1=scoreratio1/nsyncscore1
     else
        scoreratio1=0.
     endif
     if(nsyncscore3.gt.0) then
        scoreratio3=scoreratio3/nsyncscore3
     else
        scoreratio3=0.
     endif
    
     if(dfqso.ge.2.0 .or. (dfqso.lt.2.0 .and. stophint)) then
        if(rrxdt.ge.-0.5 .and. rrxdt.le.2.13) then
           if(nsyncscore.lt.8 .or. (nsyncscore.lt.10 .and. scoreratio.lt.5.5) .or. &
                (nsyncscore.lt.11 .and. scoreratio.lt.3.63)) then
              nbadcrc=1
              return ! 377 out of 20709
           else if(nsyncscore.eq.11 .and. scoreratio.lt.5.37) then
              if(nsyncscore1.lt.5 .and. nsyncscore3.lt.5 .and. scoreratio1.lt.4.2  &
                   .and. scoreratio3.lt.4.2) then
                 nbadcrc=1
                 return ! 261
              endif
           else if(nsyncscore.eq.12 .and. scoreratio.lt.4.6) then
              if(nsyncscore1.lt.5 .and. nsyncscore3.lt.5 .and. scoreratio1.lt.4.0  &
                   .and. scoreratio3.lt.4.0) then
                 nbadcrc=1
                 return ! 222
              endif
           else if(nsyncscore.eq.13 .and. scoreratio.lt.4.4) then
              if(nsyncscore1.lt.5 .and. nsyncscore2.lt.6 .and. nsyncscore3.lt.5    &
                   .and. scoreratio1.lt.4.4 .and. scoreratio3.lt.4.4) then
                 nbadcrc=1
                 return ! 98
              endif
           else if(nsyncscorew.lt.3) then
              if((nsyncscore1.gt.5 .and. scoreratio1.gt.13.8) .or.                &
                   (nsyncscore2.gt.5 .and. scoreratio2.gt.13.8) .or.              &
                   (nsyncscore3.gt.5 .and. scoreratio3.gt.13.8)) go to 32
              nbadcrc=1
              return ! 75
           else if(nsyncscorew.eq.3) then
              if(scoreratio1.gt.15. .or. scoreratio2.gt.15. .or. scoreratio3.gt.15.) &
                   go to 32
              nbadcrc=1
              return ! 125
           else if(nsyncscorew.eq.4) then
              if(nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. nsyncscore3.eq.7 .or. &
                   scoreratio1.gt.10. .or. scoreratio2.gt.10. .or.                 &
                   scoreratio3.gt.10.) go to 32
              nbadcrc=1
              return ! 94
           else if(nsyncscorew.eq.5) then
              if(nsyncscore.gt.17 .or. nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. &
                   nsyncscore3.eq.7 .or. scoreratio1.gt.10. .or.                   &
                   scoreratio2.gt.10. .or. scoreratio3.gt.10.) go to 32
              nbadcrc=1
              return ! 131
           endif
        else if(rrxdt.lt.-0.5) then
           if(nsyncscore.lt.6 .or. (nsyncscore.gt.5 .and. nsyncscore.lt.8 .and.    &
                nsyncscorew.lt.6 .and. scoreratio2.lt.5.5 .and.                    &
                scoreratio3.lt.5.5)) then
              nbadcrc=1
              return ! 46
           else if(nsyncscore.eq.8) then
              if(nsyncscore2.lt.6 .and. nsyncscore3.lt.6 .and. scoreratio2.lt.6.6  &
                   .and. scoreratio3.lt.6.6) then
                 nbadcrc=1
                 return ! 20 
              endif
           else if(nsyncscore.eq.9 .and. scoreratio.lt.6.0) then
              if(nsyncscore2.lt.6 .and. nsyncscore3.lt.6 .and. scoreratio2.lt.6.6  &
                   .and. scoreratio3.lt.6.5) then
                 nbadcrc=1
                 return ! 5 
              endif
           else if(nsyncscorew.lt.3) then
              if((nsyncscore2.gt.5 .and. scoreratio2.gt.13.8) .or.                 &
                   (nsyncscore3.gt.5 .and. scoreratio3.gt.13.8)) go to 32
              nbadcrc=1
              return ! 22
           else if(nsyncscorew.eq.3) then
              if(scoreratio2.gt.15. .or. nsyncscore3.gt.15) go to 32
              nbadcrc=1
              return ! 31
           else if(nsyncscorew.eq.4) then
              if(nsyncscore2.eq.7 .or. nsyncscore3.eq.7 .or. scoreratio2.gt.10.   &
                   .or. nsyncscore3.gt.10) go to 32
              nbadcrc=1
              return ! 34
           else if(nsyncscorew.eq.5) then
              if(nsyncscore.gt.11 .or. nsyncscore2.eq.7 .or. nsyncscore3.eq.7     &
                   .or. scoreratio2.gt.10. .or. scoreratio3.gt.10.) go to 32
              nbadcrc=1
              return ! 35
           endif
        else if(rrxdt.gt.2.13) then
           if(nsyncscore.lt.6 .or. (nsyncscore.gt.5 .and. nsyncscore.lt.8 .and.   &
                nsyncscorew.lt.6 .and. scoreratio1.lt.5.5 .and.                   &
                scoreratio2.lt.5.5)) then
              nbadcrc=1
              return ! 4
           else if(nsyncscore.eq.8) then
              if(nsyncscore1.lt.6 .and. nsyncscore2.lt.6 .and. scoreratio1.lt.6.6 &
                   .and. scoreratio2.lt.6.6) then
                 nbadcrc=1
                 return ! 8
              endif
           else if(nsyncscore.eq.9 .and. scoreratio.lt.6.0) then
              if(nsyncscore1.lt.6 .and. nsyncscore2.lt.6 .and. scoreratio2.lt.6.6 &
                   .and. scoreratio1.lt.6.5) then
                 nbadcrc=1
                 return ! 2
              endif
           else if(nsyncscorew.lt.3) then
              if((nsyncscore1.gt.5 .and. scoreratio1.gt.13.8) .or.                &
                   (nsyncscore2.gt.5 .and. scoreratio2.gt.13.8)) go to 32
              nbadcrc=1
              return ! 12
           else if(nsyncscorew.eq.3) then
              if(scoreratio1.gt.15. .or. scoreratio2.gt.15.) go to 32
              nbadcrc=1
              return ! 32
           else if(nsyncscorew.eq.4) then
              if(nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. scoreratio1.gt.10.   &
                   .or. nsyncscore2.gt.10) go to 32
              nbadcrc=1
              return ! 103
           else if(nsyncscorew.eq.5) then
              if(nsyncscore.gt.11 .or. nsyncscore1.eq.7 .or. nsyncscore2.eq.7     &
                   .or. scoreratio1.gt.10. .or. scoreratio2.gt.10.) go to 32
              nbadcrc=1
              return ! 0
           endif
        endif
     endif

32   if(lsd) then
        if(iqso.eq.4 .and. .not.ldeepsync) go to 64
        call ft8sd1var(s8,itone,msgd,msg37,lft8sd,lcq)
        if(lft8sd) then
           if(levenint) then
              evencopy(isd)%lstate=.false.
           elseif(loddint) then
              oddcopy(isd)%lstate=.false.
           endif
           i3=1
           n3=1
           iaptype2=iaptype
           iaptype=0
           nbadcrc=0
           lsd=.false.
           go to 2
        endif

64      if(iqso.eq.4) then
           if(.not.lcq) then
              call ft8mf1var(s8,itone,msgd,msg37,lft8sd)
              if(lft8sd) then
                 if(levenint) then
                    evencopy(isd)%lstate=.false.
                 elseif(loddint) then
                    oddcopy(isd)%lstate=.false.
                 endif
                 i3=1
                 n3=1
                 iaptype2=iaptype
                 iaptype=0
                 nbadcrc=0
                 lsd=.false.
                 go to 2
              endif
           else
              call ft8mfcqvar(s8,itone,msgd,msg37,lft8sd)
              if(lft8sd) then
                 if(levenint) then
                    evencopy(isd)%lstate=.false.
                 elseif(loddint) then
                    oddcopy(isd)%lstate=.false.
                 endif
                 i3=1
                 n3=1
                 iaptype2=iaptype
                 iaptype=0
                 nbadcrc=0
                 lsd=.false.
                 go to 2
              endif
           endif
        endif
     endif

     if(iqso.eq.4) then
        nbadcrc=1
        go to 2
     endif
     
     synclev=0.0
     snoiselev=1.0
     do k=1,7
        synclev=synclev+s8(icos7(k-1),k+36)
     enddo
     snoiselev=(sum(s8(0:7,37:43))- synclev)/7.0
     if(snoiselev.lt.0.1) snoiselev=1.0 ! safe division
     srr=synclev/snoiselev

!  SNR   srr range  average srr
! -18 1.8...4.0  2.9
! -19 1.7...3.6  2.65
! -20 1.6...3.3  2.43
! -21 1.6...3.0  2.22
! -22 1.55...2.8 2.19
! -23 1.4...2.6  2.03
! -24            1.94

8    if(iqso.gt.1 .and. iqso.lt.4) then
        if(.not.lqsomsgdcd .and. .not.(.not.lmycallstd .and. .not.lhiscallstd)) then
           if(.not.lft8sdec .and. dfqso.lt.2.0) then
              if(lvirtual2 .or. lvirtual3) srr=0.0
              call ft8svar(s82,srr,itone,msg37,lft8s,nft8rxfsens,stophint)
              if(lft8s) then
                 if(index(msg37,'<').gt.0) then
                    lhashmsg=.true.
                 endif
                 nbadcrc=0
                 lft8sdec=.true.
                 lsdone=.true.
                 go to 2 ! i3=16 n3=16, any affect?
              endif
           endif
        endif
        lsdone=.true.
        nbadcrc=1
        cycle
     endif

     i1=ibest+224 ! 7*32
     csymb256=cd0(i1:i1+255)*ctwk256
     call four2avar(csymb256,256,1,-1,1)
     s256(0:8)=abs(csymb256(1:9))
     rscq=0.
     nmic=0
     do k11=8,16
        ip=maxloc(s8(:,k11))
        if(ip(1).eq.idtonemyc(k11-7)+1) nmic=nmic+1
        if(k11.lt.16) then
           if(ip(1).eq.1) rscq=rscq+1.
        else
           if(ip(1).eq.2) rscq=rscq+1.
        endif
     enddo
     ip=maxloc(s8(:,17))
     if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
     ip=maxloc(s8(:,27))
     if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
     ip=maxloc(s8(:,33))
     if(ip(1).eq.3 .or. ip(1).eq.4) rscq=rscq+0.5

     lqsosig=.false.
     lqsosigtype3=.false.
     lqso73=.false.
     lqsorr73=.false.
     lqsorrr=.false. ! 73/rr73/rrr for std/nonstd callsigns
     if(.not.lqsomsgdcd .and. (dfqso.lt.napwid .or. abs(nftx-f1).lt.napwid) .and. &
          lapmyc .and. len_trim(hiscall).gt.2) then
        nqsot=0
        do i=1,19
           ip=maxloc(s8(:,i+7))
           if(ip(1).eq.idtone56(1,i)+1) nqsot=nqsot+1
        enddo
        if(nqsot.gt.6) lqsosig=.true. ! decoding depth only
        do i=20,22
           ip=maxloc(s8(:,i+7))
           if(ip(1).eq.idtone56(1,i)+1) nqsot=nqsot+1
        enddo
        if(nqsot.gt.3) lqsosigtype3=.true.
        nqsoend=0 ! array 73,rr73,rrr
        if(dfqso.lt.napwid .and. (nQSOProgress.eq.3 .or. nQSOProgress.eq.4)) then
           ! QSO RX freq only
           do i=24,58
              if(i.lt.30) then
                 ip=maxloc(s8(:,i+7))
              else
                 ip=maxloc(s8(:,i+14))
              endif
              if(ip(1).eq.idtone56(56,i)+1) nqsoend(1)=nqsoend(1)+1
              if(ip(1).eq.idtone56(55,i)+1) nqsoend(2)=nqsoend(2)+1
              if(ip(1).eq.idtone56(54,i)+1) nqsoend(3)=nqsoend(3)+1
           enddo
           ip=maxloc(nqsoend)
           if(nqsoend(ip(1)).gt.6) then
              if(ip(1).eq.1) then
                 lqso73=.true.
              else if(ip(1).eq.2) then
                 lqsorr73=.true.
              else if(ip(1).eq.3) then
                 lqsorrr=.true.
              endif
           endif
        endif
     endif

     lcqsignal=.false.
     ip(1)=maxloc(s256,1)
     if(ip(1).eq.5 .or. rscq.gt.3.1) lcqsignal=.true.
     if(.not.lcqsignal .and. ip(1).eq.4 .or. ip(1).eq.6) then
        s2563(0:8)=s256(0:8)
        s2563(9:26)=abs(csymb256(9:26))
        ip(1)=maxloc(s2563,1)
        if(ip(1).eq.4 .or. ip(1).eq.6) lcqsignal=.true.
     endif
     lmycsignal=.false.
     if(lapmyc .and. nmic.gt.2) lmycsignal=.true.

     ldxcsig=.false.
     lcqdxcsig=.false.
     lcqdxcnssig=.false.
     ndxt=0
     if(lhiscallstd) then
        do k11=17,26
           ip=maxloc(s8(:,k11))
           if(ip(1).eq.idtone56(1,k11-7)+1) ndxt=ndxt+1
        enddo
        if(ndxt.gt.3) ldxcsig=.true.
        if(lcqsignal .and. ldxcsig) lcqdxcsig=.true.
     endif
! nonstd DXCall search in idle mode
     if(.not.lhiscallstd .and. len_trim(hiscall).gt.2) then ! nonstandard DXCall
        ncqdxcnst=0
        do i=1,4
           ip=maxloc(s8(:,i+7))
           if(ip(1).eq.idtonecqdxcns(i)+1) ncqdxcnst=ncqdxcnst+1
        enddo
        ndxt=0
        do i=5,23
           ip=maxloc(s8(:,i+7))
           if(ip(1).eq.idtonedxcns73(i)+1) ndxt=ndxt+1
           if(ip(1).eq.idtonecqdxcns(i)+1) ncqdxcnst=ncqdxcnst+1
        enddo
        ldxcsig=.false.
        if(dfqso.lt.napwid) then
           if(ndxt.gt.4) ldxcsig=.true. ! relaxed threshold for RXF napwid
           if(ncqdxcnst.gt.5) lcqdxcnssig=.true.
        else
           if(ndxt.gt.5) ldxcsig=.true.
           if(ncqdxcnst.gt.6) lcqdxcnssig=.true.
        endif
     endif

     lfoxstdr73=.false.
     lfoxspecrpt=.false.
     nfoxspecrpt=0 ! checking fo special message with report to mybcall
     if(lhound) then
        nfoxstdbase=0 ! checking for report signal and base of RR73 signal
        nfoxspecr73=0 ! checking fo special message with RR73 to mybcall
        nfoxr73=0 ! checking for RR73 signal with standard message
        fdelta=abs(f1-nfqso)
        fdeltam=modulo(fdelta,60.)
        if(fdelta.lt.245.0 .and. fdeltam.lt.3.0 .and. (nQSOProgress.eq.1 .or.     &
             nQSOProgress.eq.3)) then ! calculate on possible Fox frequencies only
           do i=1,18
              ip=maxloc(s8(:,i+7))
              if(ip(1).eq.idtonefox73(i)+1) nfoxstdbase=nfoxstdbase+1
              if(i.gt.10 .and. ip(1).eq.idtonespec(i)+1) nfoxspecrpt=nfoxspecrpt+1
           enddo
           do i=20,22 ! hash10
              ip=maxloc(s8(:,i+7))
              if(ip(1).eq.idtonespec(i)+1) then
                 nfoxspecrpt=nfoxspecrpt+1
                 nfoxspecr73=nfoxspecr73+1
              endif
           enddo
           ip=maxloc(s8(:,25+7)) ! i3,n3
           if(ip(1).eq.idtonespec(25)+1) then
              nfoxspecrpt=nfoxspecrpt+1
              nfoxspecr73=nfoxspecr73+1
           endif
           if(nfoxstdbase.eq.0) then
              rspecstdrpt=(nfoxspecrpt*18.)/(1.2)
           else
              rspecstdrpt=(nfoxspecrpt*18.)/(12.*nfoxstdbase)
           endif
           if(rspecstdrpt.gt.1.) lfoxspecrpt=.true.
           if(nQSOProgress.eq.3) then
              do i=24,58
                 if(i.lt.30) then
                    ip=maxloc(s8(:,i+7))
                 else
                    ip=maxloc(s8(:,i+14))
                 endif
                 if(ip(1).eq.idtonefox73(i)+1) nfoxr73=nfoxr73+1
              enddo
              if(nfoxspecr73.eq.0) then
                 rstdr73=(nfoxr73*4.)/(3.5)
              else
                 rstdr73=(nfoxr73*4.)/(35.*nfoxspecr73)
              endif
              if(rstdr73.gt.1.) lfoxstdr73=.true.
           endif
        endif
     endif

     lsubptxfreq=.false.
     if(lapmyc .and. abs(f1-nftx).lt.2.0 .and. .not.lhound .and. .not.lft8sdec     &
          .and. .not.lqsomsgdcd .and. ((.not.lskiptx1 .and. nlasttx.eq.1) .or.     &
          (lskiptx1 .and. nlasttx.eq.2))) lsubptxfreq=.true.

     nweak=1
     if(lft8subpass .or. dfqso.lt.2.0 .or. lsubptxfreq) nweak=2
     nsubpasses=nweak
     if(lcqsignal) then
        nsubpasses=3
        if(levenint) then
           do ik=1,numcqsig
              if(evencq(ik,nthr)%freq.gt.5001.) exit
              if(abs(evencq(ik,nthr)%freq-f1).lt.2.0 .and.                        &
                   abs(evencq(ik,nthr)%xdt-xdt).lt.0.05) then
                 nsubpasses=5
                 csold=evencq(ik,nthr)%cs
              endif
           enddo
        else if (loddint) then
           do ik=1,numcqsig
              if(oddcq(ik,nthr)%freq.gt.5001.) exit
              if(abs(oddcq(ik,nthr)%freq-f1).lt.2.0 .and.                         &
                   abs(oddcq(ik,nthr)%xdt-xdt).lt.0.05) then
                 nsubpasses=5
                 csold=oddcq(ik,nthr)%cs
              endif
           enddo
        endif
     endif
     if(lmycsignal .and. lmycallstd) then
        nsubpasses=6
        if(levenint) then
           do ik=1,nummycsig
              if(evenmyc(ik,nthr)%freq.gt.5001.) exit
              if(abs(evenmyc(ik,nthr)%freq-f1).lt.2.0 .and.                       &
                   abs(evenmyc(ik,nthr)%xdt-xdt).lt.0.05) then
                 nsubpasses=8
                 csold=evenmyc(ik,nthr)%cs
              endif
           enddo
        else if (loddint) then
           do ik=1,nummycsig
              if(oddmyc(ik,nthr)%freq.gt.5001.) exit
              if(abs(oddmyc(ik,nthr)%freq-f1).lt.2.0 .and.                        &
                   abs(oddmyc(ik,nthr)%xdt-xdt).lt.0.05) then
                 nsubpasses=8
                 csold=oddmyc(ik,nthr)%cs
              endif
           enddo
        endif
     endif
     lqsocandave=.false.
     if(lapmyc .and. ndxt.gt.2 .and. nmic.gt.2 .and. .not.lqsomsgdcd .and.        &
          lmycallstd .and. lhiscallstd .and. dfqso.lt.napwid/2.0) then
        lqsocandave=.true.
        nsubpasses=9
        if(levenint) then
           if(abs(evenqso(1,nthr)%freq-f1).lt.2.0 .and.                          &
                abs(evenqso(1,nthr)%xdt-xdt).lt.0.05) then
              nsubpasses=11
              csold=evenqso(1,nthr)%cs
           endif
        else if (loddint) then
           if(abs(oddqso(1,nthr)%freq-f1).lt.2.0 .and.                           &
                abs(oddqso(1,nthr)%xdt-xdt).lt.0.05) then
              nsubpasses=11
              csold=oddqso(1,nthr)%cs
           endif
        endif
     endif

     do isubp1=1,nsubpasses
        if(nweak.eq.1 .and. isubp1.eq.2) cycle
   
       ! skip if it is lmycsignal, can be both lcq and lmy
        if(isubp1.gt.2 .and. isubp1.lt.6 .and. lmycsignal) cycle

        syncavemax=3.
        if(isubp1.eq.2) cs=csr
        if(ipass.eq.npass-1 .and. (lcqsignal .or. lmycsignal) .and.               &
             ((nweak.eq.1 .and. isubp1.eq.1) .or. (nweak.eq.2 .and.               &
             isubp1.eq.2))) cstmp2=cs
        if(ipass.eq.npass .and. lapmyc .and. ndxt.gt.2 .and. nmic.gt.2 .and.      &
             ((nweak.eq.1 .and. isubp1.eq.1) .or.                                 &
             (nweak.eq.2 .and. isubp1.eq.2))) cstmp2=cs
        do nsym=1,3
           nt=2**(3*nsym)-1
           do ihalf=1,2
              do k=1,29,nsym
                 if(ihalf.eq.1) then
                    ks=k+7
                 else
                    ks=k+43
                 endif
                 ks1=ks+1
                 ks2=ks+2
                 do i=0,nt
                    i1=i/64
                    i2=iand(i,63)/8
                    i33=iand(i,7)
                    if(isubp1.lt.3) then
                       if(nsym.eq.1) then
                          s2(i)=abs(cs(graymap(i33),ks))
                       elseif(nsym.eq.2) then
                          s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i33),ks1))
                       else
                          s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks1) +      &
                               cs(graymap(i33),ks2))
                       endif
                    else if(isubp1.eq.3 .or. isubp1.eq.6 .or. isubp1.eq.9) then
                       if(nsym.eq.1) then
                          s2(i)=abs(cscs(graymap(i33),ks))**2 +                   &
                               abs(csr(graymap(i33),ks))**2
                       elseif(nsym.eq.2) then
                          s2(i)=abs(cscs(graymap(i2),ks) +                        &
                               cscs(graymap(i33),ks1))**2 +                       &
                               abs(csr(graymap(i2),ks)+csr(graymap(i33),ks1))**2
                       else
                          s2(i)=abs(cscs(graymap(i1),ks) +                        &
                               cscs(graymap(i2),ks1)+cscs(graymap(i33),ks2))**2 + &
                               abs(csr(graymap(i1),ks)+csr(graymap(i2),ks1) +     &
                               csr(graymap(i33),ks2))**2
                       endif
                    else if(isubp1.eq.4 .or. isubp1.eq.7 .or. isubp1.eq.10) then
                       if(nsym.eq.1) then
                          s2(i)=abs(cs(graymap(i33),ks))**2 +                     &
                               abs(csold(graymap(i33),ks))**2
                       elseif(nsym.eq.2) then
                          s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i33),ks1))**2 + &
                               abs(csold(graymap(i2),ks)+csold(graymap(i33),ks1))**2
                       else
                          s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks1) +      &
                               cs(graymap(i33),ks2))**2 +                         &
                               abs(csold(graymap(i1),ks)+csold(graymap(i2),ks1) + &
                               csold(graymap(i33),ks2))**2
                       endif
                    else if(isubp1.eq.5 .or. isubp1.eq.8 .or. isubp1.eq.11) then
                       if(nsym.eq.1) then
                          s2(i)=abs(cs(graymap(i33),ks))+abs(csold(graymap(i33),ks))
                       elseif(nsym.eq.2) then
                          s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i33),ks1)) +    &
                               abs(csold(graymap(i2),ks)+csold(graymap(i33),ks1))
                       else
                          s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks1) +      &
                               cs(graymap(i33),ks2)) +                            &
                               abs(csold(graymap(i1),ks)+csold(graymap(i2),ks1) + &
                               csold(graymap(i33),ks2))
                       endif
                    endif
                    if(isubp1.eq.1 .and. srr.lt.2.5) then
                       !  srr.lt.2.5 -19dB SNR threshold
                       if(srr.gt.2.3) then 
                          s2(i)=s2(i)**2
                       else
                          ss1=s2(i)
                          if(ss1.lt.5.77) then
                             s2(i)=1+8.*ss1**2-0.12*ss1**4
                          else
                             s2(i)=(ss1+5.82)**2
                          endif
                       endif
                    endif
                    if(isubp1.gt.1 .and. srr.lt.2.5) then
                       s2(i)=(0.5*s2(i))**3 ! -19dB SNR threshold
                    endif
                 enddo
                 i32=1+(k-1)*3+(ihalf-1)*87
                 if(nsym.eq.1) ibmax=2
                 if(nsym.eq.2) ibmax=5
                 if(nsym.eq.3) ibmax=8
                 do ib=0,ibmax
                    bm=maxval(s2(0:nt),one(0:nt,ibmax-ib)) -                     &
                         maxval(s2(0:nt),.not.one(0:nt,ibmax-ib))
                    if(i32+ib .gt.174) cycle
                    if(nsym.eq.1) then
                       bmeta(i32+ib)=bm
                       den=max(maxval(s2(0:nt),one(0:nt,ibmax-ib)),              &
                            maxval(s2(0:nt),.not.one(0:nt,ibmax-ib)))
                       if(den.gt.0.0) then
                          cm=bm/den
                       else
                          cm=0.0
                       endif
                       bmetd(i32+ib)=cm
                    elseif(nsym.eq.2) then
                       bmetb(i32+ib)=bm
                    elseif(nsym.eq.3) then
                       bmetc(i32+ib)=bm
                    endif
                 enddo
              enddo ! k
           enddo ! ihalf
        enddo ! nsym

!tests
!call indexx(bmetc(1:174),174,indx)
!src=abs(bmetc(indx(1))/bmetc(indx(174)))
!print *,src
          
        call normalizebmetvar(bmeta,174)
        call normalizebmetvar(bmetb,174)
        call normalizebmetvar(bmetc,174)
        call normalizebmetvar(bmetd,174)
        scalefac=2.83 
        llra=scalefac*bmeta 
        llrb=scalefac*bmetb 
        llrc=scalefac*bmetc 
        llrd=scalefac*bmetd
        apmag=maxval(abs(llra))*1.01

! isubp2 #
!------------------------------
!   1        regular decoding, nsym=1 
!   2        regular decoding, nsym=2 
!   3        regular decoding, nsym=3 
!   4        regular decoding, llrd
!   5..18    ap passes

! iaptype Hound OFF, MyCall is standard, DXCall is standard or empty
!------------------------
!   0        cycle
!   1        CQ     ???    ???           (29+3=32 ap bits)
!   2        MyCall ???    ???           (29+3=32 ap bits)
!   3        MyCall DxCall ???           (58+3=61 ap bits)
!   4        MyCall DxCall RRR           (77 ap bits)
!   5        MyCall DxCall 73            (77 ap bits)
!   6        MyCall DxCall RR73          (77 ap bits)

! naptypes(nQSOProgress, extra decoding pass)
!                                  1 1 1 1 1 1 1 1 1 1 2 2 2 2  2  2  2  2  2  2  3  3
!                        5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3  4  5  6  7  8  9  0  1
!  data naptypes(0,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx6 CQ
!  data naptypes(1,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx1 Grid
!  data naptypes(2,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx2 Report
!  data naptypes(3,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
!  data naptypes(4,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,2,2,2,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
!  data naptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx5 73

! iaptype standard DxCall tracking, also valid in Hound mode
!------------------------
!   31        CQ  DxCall Grid(???)     (77 ap bits)
!   35        ??? DxCall 73            (29+19 ap bits)
!   36        ??? DxCall RR73          (29+19 ap bits)

! iaptype Hound off, MyCall is nonstandard, DXCall is standard or empty
!------------------------
!   0         cycle
!   1         CQ     ???    ???        (29+3=32 ap bits)
!   40       <MyCall> ???  ???         (29+3=32 ap bits) incoming call
!   41       <MyCall> DxCall ???       (58 ap bits) REPORT/RREPORT
!   42        MyCall <DxCall> RRR      (77 ap bits)
!   43        MyCall <DxCall> 73       (77 ap bits)
!   44        MyCall <DxCall> RR73     (77 ap bits)
!   31        CQ  DxCall Grid(???)     (77 ap bits) standard DxCall tracking
!   35        ??? DxCall 73            (29+19 ap bits) standard DxCall tracking
!   36        ??? DxCall RR73          (29+19 ap bits) standard DxCall tracking

! nmycnsaptypes(nQSOProgress, extra decoding pass)
!  data nmycnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx6 CQ
!  data nmycnsaptypes(1,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx1 DXcall MyCall
!  data nmycnsaptypes(2,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx2 Report
!  data nmycnsaptypes(3,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/    ! Tx3 RRreport
!  data nmycnsaptypes(4,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,40,40,40,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
!  data nmycnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx5 73

! iaptype Hound off, MyCall is standard, DXCall is not empty and is nonstandard
!------------------------
!   0         cycle
!   1         CQ     ???    ???            (29+3=32 ap bits)
!   2         MyCall ???    ???            (29+3=32 ap bits)
!   11        MyCall <DxCall> ???          (58 ap bits) REPORT/RREPORT
!   12       <MyCall> DxCall RRR           (77 ap bits)
!   13       <MyCall> DxCall 73            (77 ap bits)
!   14       <MyCall> DxCall RR73          (77 ap bits)
!   31        CQ  DxCall                   (77 ap bits) ! full compound or just nonstandard callsign
!   35        ??? DxCall 73                (64 ap bits) ! full compound or just nonstandard callsign
!   36        ??? DxCall RR73              (64 ap bits) ! full compound or just nonstandard callsign

! ndxnsaptypes(nQSOProgress, extra decoding pass)
!  data ndxnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx6 CQ
!  data ndxnsaptypes(1,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/          ! Tx1 Grid
!  data ndxnsaptypes(2,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/          ! Tx2 Report
!  data ndxnsaptypes(3,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
!  data ndxnsaptypes(4,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,2,2,2,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
!  data ndxnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx5 73

! iaptype Hound mode
!------------------------
!    0        cycle
!    1        CQ     ???    ???            (29+3=32 ap bits) standard callsign
!   21        MyBaseCall DxBaseCall ???    (58+3=61 ap bits) Report
!   22        ??? RR73; MyCall <???> ???   (28+6=34 ap bits)
!   23        MyBaseCall DxBaseCall RR73   (77 ap bits)
!   24        MyCall RR73; ??? <???> ???   (28+6=34 ap bits)
!   31        CQ  DxCall (DXGrid)          (77 ap bits) ! standard/full compound or just nonstandard callsign
!   36        ??? DxCall RR73              (29+19/64 ap bits) ! standard/ full compound or just nonstandard callsign
!  111        CQ     ???                   (3 last i3 bits) type 4 message with nonstandard callsign

! nhaptypes(nQSOProgress, extra decoding pass)
!  data nhaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,111,111,111/       ! Tx6 CQ, possible in idle mode if DXCall is empty
!  data nhaptypes(1,1:27)/21,21,21,22,22,22,0,0,0,0,0,0,0,0,0,31,31,31,0,0,0,36,36,36,0,0,0/ ! Tx1 Grid idle mode or transmitting
!  data nhaptypes(2,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx2 none
!  data nhaptypes(3,1:27)/21,21,21,22,22,22,23,23,23,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/ ! Tx3 RRreport QSO in progress or QSO is finished
!  data nhaptypes(4,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx4 none
!  data nhaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx5 none

        loutapwid=.false.
        loutapwid=abs(f1-nfqso).gt.napwid .and. abs(f1-nftx).gt.napwid
        scqnr=2.
        smycnr=2.
      
    !  print*,'stophint is ',stophint,' lft8sdec is ',lft8sdec
    !  print*,'lnohiscall is ',lnohiscall,' loutapwid is ',loutapwid
    !  print*,'lenabledxcsearch ',lenabledxcsearch, ' lwidedxcsearch is ',lwidedxcsearch
    !  print*,'lcqdxcsig is', lcqdxcsig
    !  print*,'lcqsignal is',lcqsignal
    !  print*,'ldxcsig',ldxcsig
    !  print*,'lhiscallstd',lhiscallstd
    !  print*,'mycall ',mycall,mybcall
    !  print*,'hiscall ',hiscall,hisbcall
    !  print*,'hisgrid is ',hisgrid

        do isubp2=1,31
           if(isubp2.lt.5) then
              if(lapcqonly .or. lskipnotap) cycle
              if(ltxing) then
                 ! enabled Tx and transmitted message including CQ at last interval
                 if(abs(f1-nfqso).lt.3.0) then ! +- 3Hz sync8var QSOfreq candidate list
                    if(syncavemax.lt.1.8) cycle
                 else
                    if(syncavemax.lt.1.9) cycle
                 endif
              else
                 if(syncavemax.lt.1.8) cycle
              endif
           endif
           if(isubp2.eq.4) cycle
           if(isubp1.gt.2 .and. isubp2.lt.5) cycle ! skip regular decoding for extra subpasses
           if(lqsocandave) then
              if(isubp1.gt.2 .and. isubp1.lt.9) cycle ! skip other extra subpasses if QSO signal, highest priority
              if(lqsomsgdcd) cycle
           else if(lmycsignal .and. lmycallstd) then
              if(isubp1.gt.2 .and. isubp1.lt.6) cycle ! skip CQ signal extra subpasses if MyCall signal
           endif           

           if(isubp2.lt.5) then
              apmask=0
              iaptype2=iaptype
              iaptype=0
              if(isubp2.eq.1) then
                 if(ipass.eq.1) then
                    llrz=llrd
                 else
                    llrz=llra
                 endif
                 if(isubp1.gt.1 .and. ipass.gt.1) llrz=llrd
              else if(isubp2.eq.2) then
                 llrz=llrb
                 if(isubp1.gt.1) llrz=llra
              else if(isubp2.eq.3) then
                 llrz=llrc
              else if(isubp2.eq.4) then
                 llrz=llrd
              endif
           else
              if(.not.lhound) then
                 if(lmycallstd .and. (lhiscallstd .or. lnohiscall)) then
                    iaptype=naptypes(nQSOProgress,isubp2-4)
                    iaptype2=iaptype
            !  print*,'line 1357 iaptype,isubp1,isubp2 = ',iaptype,isubp1,isubp2
                    if(iaptype.eq.0) cycle
                    if(lqsomsgdcd .and. iaptype.gt.2 .and. iaptype.lt.31) cycle ! QSO message already decoded
                    if(iaptype.eq.2) then
                       if(.not.lapmyc .or. lapcqonly) cycle ! skip AP for 'mycall ???? ????' in 2..3 minutes after last TX
                       if(nQSOProgress.ne.0 .and. nmic.lt.2) cycle ! reduce CPU load at QSO
                    endif
                  !  if(.not.stophint .and. iaptype.gt.30) cycle ! no DXCall searching at QSO, reduce Lag
                  !  if(stophint .and. iaptype.gt.2 .and. iaptype.lt.31) cycle
                    if(lft8sdec .and. iaptype.gt.2) cycle ! QSO message already decoded
                    if(iaptype.gt.2 .and. lnohiscall) cycle ! no DXCall
                    if(iaptype.gt.2 .and. iaptype.lt.31 .and. loutapwid) cycle
                  !  if(iaptype.eq.3 .and. .not.lqsosigtype3) cycle ! not QSO signal
                  !  if(iaptype.eq.4 .and. .not.lqsorrr) cycle ! not RRR signal
                  !  if(iaptype.eq.5 .and. .not.lqso73) cycle ! not 73 signal
                  !  if(iaptype.eq.6 .and. .not.lqsorr73) cycle ! not RR73 signal
                    if(iaptype.gt.30 .and. .not.lenabledxcsearch) cycle ! in QSO or TXing CQ or last logged is DX Call: searching disabled
                    if(iaptype.gt.30 .and. .not.lwidedxcsearch .and. loutapwid) cycle ! only RX freq DX Call searching
                    if(iaptype.eq.31 .and. .not.lcqdxcsig) cycle ! not CQ signal from std DXCall
                    if(iaptype.eq.31 .and. .not.lhiscallstd .and. lapcqonly) cycle ! skip weak CQ signals with std call
                    if(iaptype.gt.31 .and. lapcqonly) cycle ! skip weak CQ signals              
                    if(iaptype.eq.35 .and. .not.lqso73) cycle ! DXCall searching, not 73 signal
                    if(iaptype.eq.36 .and. .not.lqsorr73) cycle ! DXCall searching, not RR73 signal
                    if(lqsocandave .and. isubp1.gt.8 .and. (iaptype.lt.3 .or. iaptype.gt.6)) cycle ! QSO signal
                  !  if(.not.lqsocandave .and. lmycsignal .and. isubp1.gt.5 .and. isubp1.lt.9 .and. iaptype.ne.2) cycle ! skip other AP if lmycsignal extra subpasses)
                    
                    if(iaptype.eq.1) then
                       if(isubp2.eq.20) then
                          scqlev=0.
                          do i4=1,9
                             scqlev=scqlev+s8(idtone25(2,i4),i4+7)
                          enddo
                          snoiselev=(sum(s8(0:7,8:16))-scqlev)/7.0
                          scqnr=scqlev/snoiselev
                          if(scqnr.lt.1.0 .and. .not.lcqsignal) cycle
                       endif
                       if(isubp2.eq.21) then
                          if(lft8lowth .or. lft8subpass) then
                             if(scqnr.lt.1.2 .and. .not.lcqsignal) cycle
                          endif
                          if(.not. lft8subpass .and. .not.lft8lowth) then
                             if(scqnr.lt.1.3 .and. .not.lcqsignal) cycle
                          endif
                       endif
                    endif

                    if(iaptype.eq.2) then
                       if(isubp2.eq.17) then
                          smyclev=0.
                          do i4=1,9
                             smyclev=smyclev+s8(idtonemyc(i4),i4+7)
                          enddo
                          snoiselev=(sum(s8(0:7,8:16))-smyclev)/7.0
                          smycnr=smyclev/snoiselev
                          if(smycnr.lt.1.0 .and. .not.lmycsignal) cycle
                       endif
                       if(isubp2.eq.18) then
                          if(lft8lowth .or. lft8subpass) then
                             if(smycnr.lt.1.2 .and. .not.lmycsignal) cycle
                          endif
                       endif
                    endif

                    if(iaptype.eq.3) then
                       if(isubp2.eq.5) then
                          smyclev=0.
                          do i4=1,9
                             smyclev=smyclev+s8(idtonemyc(i4),i4+7)
                          enddo
                          snoiselev=(sum(s8(0:7,8:16))-smyclev)/7.0
                          smycnr=smyclev/snoiselev
                          if(smycnr.lt.1.0) cycle
                       else if(isubp2.eq.6) then
                          if(smycnr.lt.1.2) cycle
                       endif
                    endif

                    apmask=0
                    if(iaptype.eq.1) then ! CQ
                       if(isubp2.eq.20) then
                          llrz=llrc
                       else if(isubp2.eq.21) then
                          llrz=llrb
                       else if(isubp2.eq.22) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*mcq(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.2) then ! MyCall ??? ???
                       if(isubp2.eq.17) then
                          llrz=llrc
                       else if(isubp2.eq.18) then
                          llrz=llrb
                       else if(isubp2.eq.19) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*apsym(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.3) then ! MyCall DxCall ???
                       if(isubp2.eq.5) then
                          llrz=llrc
                       else if(isubp2.eq.6) then
                          llrz=llrb
                       else if(isubp2.eq.7) then
                          llrz=llra
                       endif
                       apmask(1:58)=1
                       llrz(1:58)=apmag*apsym
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.gt.3 .and. iaptype.lt.7) then
                       if(isubp2.eq.8 .or. isubp2.eq.11 .or. isubp2.eq.14) then
                          llrz=llrc
                       else if(isubp2.eq.9 .or. isubp2.eq.12 .or. isubp2.eq.15) then
                          llrz=llrb
                       else if(isubp2.eq.10 .or. isubp2.eq.13 .or. isubp2.eq.16) then
                          llrz=llrb
                       endif
                       apmask(1:77)=1
                       llrz(1:58)=apmag*apsym ! mycall hiscall 73|RR73
                       if(iaptype.eq.5) then
                          llrz(59:77)=apmag*m73
                       else if(iaptype.eq.6) then
                          llrz(59:77)=apmag*mrr73
                       else if(iaptype.eq.4) then
                          llrz(59:77)=apmag*mrrr
                       endif
                    else if(iaptype.eq.31) then ! CQ DxCall Grid(???)
                       if(isubp2.eq.23) then
                          llrz=llrc
                       else if(isubp2.eq.24) then
                          llrz=llrb
                       else if(isubp2.eq.25) then
                          llrz=llra
                       endif
                       if(lnohisgrid) then
                          apmask(1:58)=1
                          llrz(1:58)=apmag*apcqsym(1:58)
                          apmask(75:77)=1
                          llrz(75:76)=apmag*(-1)
                          llrz(77)=apmag*(+1)
                       else
                          apmask(1:77)=1
                          llrz(1:77)=apmag*apcqsym
                       endif
                    else if(iaptype.eq.35) then ! ??? DxCall 73, type 1 std DXCall
                       if(isubp2.eq.29) then
                          llrz=llrc
                       else if(isubp2.eq.30) then
                          llrz=llrb
                       else if(isubp2.eq.31) then
                          llrz=llra
                       endif
                       apmask(30:77)=1
                       llrz(30:58)=apmag*apsym(30:58)
                       llrz(59:77)=apmag*m73
                    else if(iaptype.eq.36) then ! ??? DxCall RR73 type 1 std DXCall
                       if(isubp2.eq.26) then
                          llrz=llrc
                       else if(isubp2.eq.27) then
                          llrz=llrb
                       else if(isubp2.eq.28) then
                          llrz=llra
                       endif
                       apmask(30:77)=1
                       llrz(30:58)=apmag*apsym(30:58)
                       llrz(59:77)=apmag*mrr73
                    endif
              
            !!  print*,'line 1533 iaptype,isubp1,isubp2 = ',iaptype,isubp1,isubp2
                    
                 else if(lmycallstd .and. .not.lhiscallstd .and.                  &
                      len_trim(hiscall).gt.2) then
                    iaptype=ndxnsaptypes(nQSOProgress,isubp2-4)
                    iaptype2=iaptype
                    if(iaptype.eq.0) cycle
                    if(iaptype.eq.2 .and. lapcqonly) cycle ! skip weak CQ signals
                    if(.not.stophint .and. iaptype.gt.30) cycle ! no DXCall searching at QSO, reduce Lag
                    if((lqsomsgdcd .or. .not.lapmyc) .and. iaptype.gt.1 .and. iaptype.lt.15) cycle ! skip AP for mycall in 2..3 minutes after last TX
                    if(iaptype.eq.12 .and. .not.lqsorrr) cycle ! not RRR signal
                    if(iaptype.eq.13 .and. .not.lqso73) cycle ! not 73 signal
                    if(iaptype.eq.14 .and. .not.lqsorr73) cycle ! not RR73 signal
                    if(iaptype.gt.30 .and. .not.lenabledxcsearch) cycle ! in QSO or TXing CQ or last logged is DX Call: searching disabled
                    if(iaptype.gt.30 .and. .not.lwidedxcsearch .and. loutapwid) cycle ! only RX freq DX Call searching
                    if(iaptype.gt.30 .and. lapcqonly) cycle ! skip weak CQ signals
                    if(iaptype.eq.31 .and. .not.lcqdxcnssig) cycle ! it is not CQ signal of non-standard DXCall
                    if(iaptype.eq.35 .and. .not.lqso73) cycle ! DXCall searching, not 73 signal
                    if(iaptype.eq.36 .and. .not.lqsorr73) cycle ! DXCall searching, not RR73 signal
                    if(lqsocandave .and. isubp1.gt.8 .and. (iaptype.lt.11 .or. iaptype.gt.14)) cycle ! QSO signal
                    if(iaptype.gt.2 .and. iaptype.lt.15 .and. loutapwid) cycle
                    
                    if(iaptype.eq.1) then
                       if(isubp2.eq.20) then
                          scqlev=0.
                          do i4=1,9
                             scqlev=scqlev+s8(idtone25(2,i4),i4+7)
                          enddo
                          snoiselev=(sum(s8(0:7,8:16))-scqlev)/7.0
                          scqnr=scqlev/snoiselev
                          if(scqnr.lt.1.0 .and. .not.lcqsignal) cycle
                       endif
                       if(isubp2.eq.21) then
                          if(lft8lowth .or. lft8subpass) then
                             if(scqnr.lt.1.2 .and. .not.lcqsignal) cycle
                          endif
                          if(.not. lft8subpass .and. .not.lft8lowth) then
                             if(scqnr.lt.1.3 .and. .not.lcqsignal) cycle
                          endif
                       endif
                    endif

                    if(iaptype.eq.2) then
                       if(isubp2.eq.17) then
                          smyclev=0.
                          do i4=1,9
                             smyclev=smyclev+s8(idtonemyc(i4),i4+7)
                          enddo
                          snoiselev=(sum(s8(0:7,8:16))-smyclev)/7.0
                          smycnr=smyclev/snoiselev
                          if(smycnr.lt.1.0 .and. .not.lmycsignal) cycle
                       endif
                       if(isubp2.eq.18) then
                          if(lft8lowth .or. lft8subpass) then
                             if(smycnr.lt.1.2 .and. .not.lmycsignal) cycle
                          endif
                       endif
                    endif

                    apmask=0
                    if(iaptype.eq.1) then ! CQ ??? ???
                       if(isubp2.eq.20) then
                          llrz=llrc
                       else if(isubp2.eq.21) then
                          llrz=llrb
                       else if(isubp2.eq.22) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*mcq(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.2) then ! MyCall ??? ???
                       if(isubp2.eq.17) then
                          llrz=llrc
                       else if(isubp2.eq.18) then
                          llrz=llrb
                       else if(isubp2.eq.19) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*apsym(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.11) then ! MyCall <DxCall> ???  ! report rreport type 1 msg
                       if(isubp2.eq.5) then
                          llrz=llrc
                       else if(isubp2.eq.6) then
                          llrz=llrb
                       else if(isubp2.eq.7) then
                          llrz=llra
                       endif
                       apmask(1:58)=1
                       llrz(1:58)=apmag*apsymdxns1
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.12) then  ! type 4 <MyCall> DxCall RRR
                       if(isubp2.eq.14) then
                          llrz=llrc
                       else if(isubp2.eq.15) then
                          llrz=llrb
                       else if(isubp2.eq.16) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apsymdxnsrrr
                    else if(iaptype.eq.13) then  ! type 4 <MyCall> DxCall 73
                       if(isubp2.eq.11) then
                          llrz=llrc
                       else if(isubp2.eq.12) then
                          llrz=llrb
                       else if(isubp2.eq.13) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apsymdxns732
                    else if(iaptype.eq.14) then  ! type 4 <MyCall> DxCall RR73
                       if(isubp2.eq.8) then
                          llrz=llrc
                       else if(isubp2.eq.9) then
                          llrz=llrb
                       else if(isubp2.eq.10) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apsymdxnsr73
                    else if(iaptype.eq.31) then ! CQ  DxCall ! full compound or nonstandard
                       if(isubp2.eq.23) then
                          llrz=llrc
                       else if(isubp2.eq.24) then
                          llrz=llrb
                       else if(isubp2.eq.25) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apcqsym
                    else if(iaptype.eq.35) then ! ??? DxCall 73 ! full compound or nonstandard
                       if(isubp2.eq.29) then
                          llrz=llrc
                       else if(isubp2.eq.30) then
                          llrz=llrb
                       else if(isubp2.eq.31) then
                          llrz=llra
                       endif
                       apmask(14:77)=1
                       llrz(14:77)=apmag*apsymdxns73(14:77)
                    else if(iaptype.eq.36) then ! ??? DxCall RR73 ! full compound or nonstandard
                       if(isubp2.eq.26) then
                          llrz=llrc
                       else if(isubp2.eq.27) then
                          llrz=llrb
                       else if(isubp2.eq.28) then
                          llrz=llra
                       endif
                       apmask(14:77)=1
                       llrz(14:77)=apmag*apsymdxnsrr73(14:77)
                    endif

                 else if(.not.lmycallstd .and. .not.lhiscallstd .and.             &
                      len_trim(hiscall).gt.2) then ! empty mycall or compound/nonstandard both calls
                    iaptype=ndxnsaptypes(nQSOProgress,isubp2-4)
                    iaptype2=iaptype
                    if(iaptype.eq.0) cycle
                    if(iaptype.gt.1 .and. iaptype.lt.31) cycle
                    if(.not.stophint .and. iaptype.gt.1) cycle ! on air, QSO is not possible
                    if(iaptype.gt.30 .and. lapcqonly) cycle ! skip weak CQ signals with std call
                    if(iaptype.eq.31 .and. .not.lcqdxcnssig) cycle ! it is not CQ signal of non-standard DXCall
                    if(iaptype.gt.34 .and. .not.ldxcsig) cycle ! not DXCall signal

                    if(iaptype.eq.1) then
                       if(isubp2.eq.20) then
                          scqlev=0.
                          do i4=1,9
                             scqlev=scqlev+s8(idtone25(2,i4),i4+7)
                          enddo
                          snoiselev=(sum(s8(0:7,8:16))-scqlev)/7.0
                          scqnr=scqlev/snoiselev
                          if(scqnr.lt.1.0 .and. .not.lcqsignal) cycle
                       endif
                       if(isubp2.eq.21) then
                          if(lft8lowth .or. lft8subpass)then
                             if(scqnr.lt.1.2 .and. .not.lcqsignal) cycle
                          endif
                          if(.not. lft8subpass .and. .not.lft8lowth) then
                             if(scqnr.lt.1.3 .and. .not.lcqsignal) cycle
                          endif
                       endif
                    endif
                    
                    apmask=0
                    if(iaptype.eq.1) then ! CQ ??? ???
                       if(isubp2.eq.20) then
                          llrz=llrc
                       else if(isubp2.eq.21) then
                          llrz=llrb
                       else if(isubp2.eq.22) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*mcq(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)

! Nonstandard DXCall search masks below are for monitoring purpose in idle mode,
! QSO is not possible
! wideband searching being used by default

                    else if(iaptype.eq.31) then ! CQ  DxCall ! full compound or nonstandard
                       if(isubp2.eq.23) then
                          llrz=llrc
                       else if(isubp2.eq.24) then
                          llrz=llrb
                       else if(isubp2.eq.25) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apcqsym
                    else if(iaptype.eq.35) then ! ??? DxCall 73 ! full compound or nonstandard
                       if(isubp2.eq.29) then
                          llrz=llrc
                       else if(isubp2.eq.30) then
                          llrz=llrb
                       else if(isubp2.eq.31) then
                          llrz=llra
                       endif
                       apmask(14:77)=1
                       llrz(14:77)=apmag*apsymdxns73(14:77)
                    else if(iaptype.eq.36) then ! ??? DxCall RR73 ! full compound or nonstandard
                       if(isubp2.eq.26) then
                          llrz=llrc
                       else if(isubp2.eq.27) then
                          llrz=llrb
                       else if(isubp2.eq.28) then
                          llrz=llra
                       endif
                       apmask(14:77)=1
                       llrz(14:77)=apmag*apsymdxnsrr73(14:77)
                    endif

                 else if(.not.lmycallstd .and. (lhiscallstd .or. lnohiscall)) then
                    iaptype=nmycnsaptypes(nQSOProgress,isubp2-4)
                    iaptype2=iaptype
                    if(iaptype.eq.0) cycle
                    if(isubp1.eq.2 .and. nweak.eq.1) cycle
                    if(isubp1.gt.5) cycle ! so far CQ averaging only
                    if(iaptype.eq.40 .and. lapcqonly) cycle ! skip weak CQ signals
                    if(iaptype.gt.40 .and. iaptype.lt.45 .and. lqsomsgdcd) cycle ! already decoded
                    if(iaptype.eq.42 .and. .not.lqsorrr) cycle ! not RRR signal
                    if(iaptype.eq.43 .and. .not.lqso73) cycle ! not 73 signal
                    if(iaptype.eq.44 .and. .not.lqsorr73) cycle ! not RR73 signal
                    if(iaptype.gt.39 .and. .not.lapmyc) cycle
                    if(lnomycall .and. iaptype.gt.39 .and. iaptype.lt.45) cycle ! skip QSO signals if mycall is empty
                    if(lnohiscall .and. iaptype.ne.1 .and. iaptype.ne.40) cycle ! skip DXCall masks if empty
                    if(iaptype.gt.30 .and. iaptype.lt.40 .and. .not.stophint) cycle ! in QSO, reduce number of CPU cycles
                    if(iaptype.eq.31 .and. .not.lcqdxcsig) cycle ! not CQ signal from std DXCall
                    if(iaptype.gt.34 .and. iaptype.lt.37 .and. (.not.ldxcsig .or. lapcqonly)) cycle ! not DXCall signal, skip weak CQ signals
                    if(iaptype.gt.30 .and. iaptype.lt.40 .and. .not.lwidedxcsearch .and. loutapwid) cycle ! if wideband DX search disabled

                    apmask=0
                    if(lcqsignal .and. iaptype.eq.1) then ! CQ ??? ???
                       if(isubp2.eq.20) then
                          llrz=llrc
                       else if(isubp2.eq.21) then
                          llrz=llrb
                       else if(isubp2.eq.22) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*mcq(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.31) then ! CQ DxCall Grid(???) //std DX call type1 with or without grid
                       if(isubp2.eq.23) then
                          llrz=llrc
                       else if(isubp2.eq.24) then
                          llrz=llrb
                       else if(isubp2.eq.25) then
                          llrz=llra
                       endif
                       if(lnohisgrid) then
                          apmask(1:58)=1
                          llrz(1:58)=apmag*apcqsym(1:58)
                          apmask(75:77)=1
                          llrz(75:76)=apmag*(-1)
                          llrz(77)=apmag*(+1)
                       else
                          apmask(1:77)=1
                          llrz(1:77)=apmag*apcqsym
                       endif
                    else if(iaptype.eq.35) then ! ??? DxCall 73 //std DX call
                       if(isubp2.eq.29) then
                          llrz=llrc
                       else if(isubp2.eq.30) then
                          llrz=llrb
                       else if(isubp2.eq.31) then
                          llrz=llra
                       endif
                       apmask(30:77)=1
                       llrz(30:58)=apmag*apsymdxstd(30:58)
                       llrz(59:77)=apmag*m73
                    else if(iaptype.eq.36) then ! ??? DxCall RR73 //std DX call
                       if(isubp2.eq.26) then
                          llrz=llrc
                       else if(isubp2.eq.27) then
                          llrz=llrb
                       else if(isubp2.eq.28) then
                          llrz=llra
                       endif
                       apmask(30:77)=1
                       llrz(30:58)=apmag*apsymdxstd(30:58)
                       llrz(59:77)=apmag*mrr73
                    else if(iaptype.eq.40) then ! <MyCall>,???,??? type 1
                       if(isubp2.eq.17) then
                          llrz=llrc
                       else if(isubp2.eq.18) then
                          llrz=llrb
                       else if(isubp2.eq.19) then
                          llrz=llra
                       endif
                       apmask(1:29)=1
                       llrz(1:29)=apmag*apsymmyns1(1:29)
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.41) then ! <MyCall>,DXCall,??? type 1
                       if(isubp2.eq.5) then
                          llrz=llrc
                       else if(isubp2.eq.6) then
                          llrz=llrb
                       else if(isubp2.eq.7) then
                          llrz=llra
                       endif
                       apmask(1:58)=1
                       llrz(1:58)=apmag*apsymmyns2
                       apmask(75:77)=1
                       llrz(75:76)=apmag*(-1)
                       llrz(77)=apmag*(+1)
                    else if(iaptype.eq.42) then ! MyCall,<DXCall>,RRR type 4
                       if(isubp2.eq.14) then
                          llrz=llrc
                       else if(isubp2.eq.15) then
                          llrz=llrb
                       else if(isubp2.eq.16) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apsymmynsrrr
                    else if(iaptype.eq.43) then ! MyCall,<DXCall>,73 type 4
                       if(isubp2.eq.11) then
                          llrz=llrc
                       else if(isubp2.eq.12) then
                          llrz=llrb
                       else if(isubp2.eq.13) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apsymmyns73
                    else if(iaptype.eq.44) then ! MyCall,<DXCall>,RR73 type 4
                       if(isubp2.eq.8) then
                          llrz=llrc
                       else if(isubp2.eq.9) then
                          llrz=llrb
                       else if(isubp2.eq.10) then
                          llrz=llra
                       endif
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apsymmynsrr73
                    endif
                 else
                    cycle ! fallback
                 endif

              else if(lhound) then
                 iaptype=nhaptypes(nQSOProgress,isubp2-4)
                 iaptype2=iaptype
                 if(iaptype.eq.0) cycle
                 if(lnomycall .and. iaptype.gt.1 .and. iaptype.lt.31) cycle ! skip AP if mycall is missed in config
                 if(lhiscallstd .and. iaptype.eq.31 .and. .not.lcqsignal) cycle ! not CQ signal, skip CQ DXCall DXgrid mask
                 if(lqsomsgdcd .and. iaptype.gt.0 .and. iaptype.lt.25) cycle ! QSO message already decoded
                 if(.not.stophint .and. (iaptype.eq.31 .or. iaptype.eq.36)) cycle ! CQ and RR73 decoding not needed if TX is on
                 if(nQSOProgress.eq.1) then
                    if(lfoxspecrpt) then
                       if(iaptype.eq.21) cycle ! it is not standard message report signal
                       if((iaptype.eq.31 .or. iaptype.eq.36) .and. nfoxspecrpt.gt.3) cycle ! probably special message signal
                    else
                       if(iaptype.eq.22) cycle ! it is not special message report signal
                       if((iaptype.eq.31 .or. iaptype.eq.36) .and. nmic.gt.3) cycle ! probably standard message signal with mybcall
                    endif
                 endif
                 if(nQSOProgress.eq.3) then
                    if(lfoxspecrpt) then
                       if(iaptype.eq.21) cycle ! it is not standard message report signal
                    else
                       if(iaptype.eq.22) cycle ! it is not special message report signal
                    endif
                    if(lfoxstdr73) then
                       if(iaptype.eq.24) cycle ! it is not special message RR73 signal
                    else
                       if(iaptype.eq.23) cycle ! it is not standard message RR73 signal
                    endif
                 endif
! can be staying in queue, need to process possible incoming report iaptype 21/22 even if TX is switched off
                 if(.not.lapmyc .and. (iaptype.eq.23 .or. iaptype.eq.24)) cycle ! skip AP for mycall RR73 in 2..3 minutes after last TX
                 fdelta=abs(f1-nfqso)
                 fdeltam=modulo(fdelta,60.) ! dupe string to prevent compiler warning
                 if(nQSOProgress.gt.0 .and. iaptype.lt.31 .and. (fdelta.gt.245.0 .or.  &
                      fdeltam.gt.3.0)) cycle ! AP shall be applied to Fox frequencies only
                 if((iaptype.eq.31 .or. iaptype.eq.36) .and. .not.lwidedxcsearch .and. &
                      (fdelta.gt.245.0 .or. fdeltam.gt.3.0)) cycle ! only Fox frequencies DX Call searching
                 if(iaptype.eq.31 .and. .not.lhiscallstd .and. lapcqonly) cycle ! skip weak CQ signals with std call
                 if(iaptype.eq.36 .and. lwidedxcsearch .and. lapcqonly) cycle ! skip weak CQ signals
                 if(iaptype.eq.111 .and. lapcqonly) cycle ! skip weak CQ signals with std call

                 apmask=0
                 if(iaptype.eq.1) then ! CQ ??? ??? type 1 msg
                    if(isubp2.eq.20) then
                       llrz=llrc
                    else if(isubp2.eq.21) then
                       llrz=llrb
                    else if(isubp2.eq.22) then
                       llrz=llra
                    endif
                    apmask(1:29)=1
                    llrz(1:29)=apmag*mcq(1:29)
                    apmask(75:77)=1
                    llrz(75:76)=apmag*(-1)
                    llrz(77)=apmag*(+1)
                 else if(iaptype.eq.21) then ! MyBaseCall DxBaseCall ???  ! report
                    if(isubp2.eq.5) then
                       llrz=llrc
                    else if(isubp2.eq.6) then
                       llrz=llrb
                    else if(isubp2.eq.7) then
                       llrz=llra
                    endif
                    apmask(1:58)=1
                    llrz(1:58)=apmag*apsym
                    apmask(75:77)=1
                    llrz(75:76)=apmag*(-1)
                    llrz(77)=apmag*(+1)
                 else if(iaptype.eq.22) then ! ??? RR73; MyCall <???> ??? ! report
                    if(isubp2.eq.8) then
                       llrz=llrc
                    else if(isubp2.eq.9) then
                       llrz=llrb
                    else if(isubp2.eq.10) then
                       llrz=llra
                    endif
                    apmask(29:66)=1
                    llrz(29:66)=apmag*apsymsp(29:66)
                    apmask(72:77)=1
                    llrz(72:73)=apmag*(-1)
                    llrz(74)=apmag*(+1)
                    llrz(75:77)=apmag*(-1)
                 else if(iaptype.eq.23) then ! MyBaseCall DxBaseCall RR73
                    if(isubp2.eq.11) then
                       llrz=llrc
                    else if(isubp2.eq.12) then
                       llrz=llrb
                    else if(isubp2.eq.13) then
                       llrz=llra
                    endif
                    apmask(1:77)=1
                    llrz(1:58)=apmag*apsym
                    llrz(59:77)=apmag*mrr73
                 else if(iaptype.eq.24) then ! MyCall RR73; ??? <???> ???
                    if(isubp2.eq.14) then
                       llrz=llrc
                    else if(isubp2.eq.15) then
                       llrz=llrb
                    else if(isubp2.eq.16) then
                       llrz=llra
                    endif
                    apmask(1:28)=1
                    apmask(57:66)=1
                    llrz(1:28)=apmag*apsymsp(1:28)
                    llrz(57:66)=apmag*apsymsp(57:66)
                    apmask(72:77)=1
                    llrz(72:73)=apmag*(-1)
                    llrz(74)=apmag*(+1)
                    llrz(75:77)=apmag*(-1)
                 else if(iaptype.eq.31) then ! CQ  DxCall Grid(???)
                    if(isubp2.eq.23) then
                       llrz=llrc
                    else if(isubp2.eq.24) then
                       llrz=llrb
                    else if(isubp2.eq.25) then
                       llrz=llra
                    endif
                    if(lhiscallstd) then
                       if(lnohisgrid) then
                          apmask(1:58)=1
                          llrz(1:58)=apmag*apcqsym(1:58)
                          apmask(75:77)=1
                          llrz(75:76)=apmag*(-1)
                          llrz(77)=apmag*(+1)
                       else
                          apmask(1:77)=1
                          llrz(1:77)=apmag*apcqsym
                       endif
                    else
                       apmask(1:77)=1
                       llrz(1:77)=apmag*apcqsym
                    endif
                 else if(iaptype.eq.36) then
                    if(isubp2.eq.26) then
                       llrz=llrc
                    else if(isubp2.eq.27) then
                       llrz=llrb
                    else if(isubp2.eq.28) then
                       llrz=llra
                    endif
                    if(lhiscallstd .or. (.not.lhiscallstd .and.                   &
                         len_trim(hiscall).gt.2 &
                         .and. index(hiscall,"/").gt.0)) then
                       apmask(30:77)=1
                       llrz(30:58)=apmag*apsym(30:58)
                       llrz(59:77)=apmag*mrr73 ! ??? DxBaseCall RR73
                    else
                       cycle ! (noncompound .and. nonstandard) Fox callsign being not supported by Fox WSJT-X
                    endif
                 else if(iaptype.eq.111) then ! CQ ??? type 4 msg (iflip,nrpt,icq,i3 001100)
                    if(isubp2.eq.29) then
                       llrz=llrc
                    else if(isubp2.eq.30) then
                       llrz=llrb
                    else if(isubp2.eq.31) then
                       llrz=llra
                    endif
                    apmask(72:77)=1
                    llrz(72:73)=apmag*(-1)
                    llrz(74:75)=apmag*(1)
                    llrz(76:77)=apmag*(-1)
                 endif
              else
                 cycle ! fallback
              endif
           endif
           cw=0
           call bpdecode174_91var(llrz,apmask,max_iterations,message77,cw,        &
                nharderrors,niterations)
           dmin=0.0
           if(nharderrors.lt.0) then
              ndeep=3
              if(lqsosig .or. lmycsignal) then
                 if((dfqso.lt.napwid .or. (abs(nftx-f1).lt.napwid .and. lapmyc))  &
                      .and. .not.nagainfil) ndeep=4
                 if(lapmyc .and. lqsomsgdcd .or. iaptype.eq.0) ndeep=3 ! deep is not needed, reduce number of CPU cycles
                 if(.not.stophint .and. len_trim(hiscall).gt.2) ndeep=3 ! unload CPU, let ft8svar pick up QSO message
              endif
              if(ldxcsig .and. stophint .and. dfqso.lt.napwid) ndeep=4 ! DXCall search inside RX napwid
              if(lhound) ndeep=3 ! we have no enough CPU resources to decode all Fox slots with ndeep=4
!          if(nagainfil .or. swl) ndeep=5 ! 30 against 26 -23dB, more than 15sec to decode and many false decodes
!          if(swl) ndeep=4 ! 29 decodes -23dB, 7..12sec to decode
              if(nagainfil) ndeep=5
!print *,omp_get_nested(),OMP_get_num_threads()

              call osd174_91var(llrz,apmask,ndeep,message77,cw,nharderrors,dmin,nthr)
           endif
           
           nbadcrc=1
           msg37=''
           if(count(cw.eq.0).eq.174) cycle           !Reject the all-zero codeword
           if(nharderrors.lt.0 .or. nharderrors+dmin.ge.60.0 .or. (isubp2.gt.2    &
                .and. nharderrors.gt.39)) then ! chk isubp2 value
              if(nweak.eq.2 .and. isubp1.eq.2) then
                 if(ipass.eq.npass-1) then
                    if(lcqsignal) then
                       if(isubp2.eq.22) then ! last pass, std and nonstd mycall
                          lfoundcq=.false.
                          do ik=1,numdeccq
                             if(tmpcqdec(ik)%freq.gt.5001.0) exit
                             if(abs(tmpcqdec(ik)%freq-f1).lt.5.0 .and. abs(tmpcqdec(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                                lfoundcq=.true.
                                exit
                             endif
                          enddo
                          if(.not.lfoundcq .and. ncqsignal.lt.numcqsig) then
                             ncqsignal=ncqsignal+1
                             tmpcqsig(ncqsignal)%freq=f1
                             tmpcqsig(ncqsignal)%xdt=xdt
                             tmpcqsig(ncqsignal)%cs=cstmp2
                          endif
                       endif
                    endif
                    if(lmycsignal .and. isubp2.eq.19) then ! last pass
                       lfoundmyc=.false.
                       do ik=1,numdecmyc
                          if(tmpmyc(ik)%freq.gt.5001.0) exit
                          if(abs(tmpmyc(ik)%freq-f1).lt.5.0 .and.                &
                               abs(tmpmyc(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                             lfoundmyc=.true.
                             exit
                          endif
                       enddo
                       if(.not.lfoundmyc .and. nmycsignal.lt.nummycsig) then
                          nmycsignal=nmycsignal+1
                          tmpmycsig(nmycsignal)%freq=f1
                          tmpmycsig(nmycsignal)%xdt=xdt
                          tmpmycsig(nmycsignal)%cs=cstmp2
                       endif
                    endif
                 endif
                 if(ipass.eq.npass) then
                    if(lqsocandave .and. (iaptype.eq.3 .or. iaptype.eq.6)) then
                       tmpqsosig(1)%freq=f1
                       tmpqsosig(1)%xdt=xdt
                       tmpqsosig(1)%cs=cstmp2
                    endif
                 endif
              endif
              !print*,'line 2149 iaptype,isubp1,isubp2,ndeep = ',iaptype,isubp1,isubp2,ndeep

              if(isubp1.gt.1) cycle
              ! print*,'line 2150 did not cycle'
              if(lqsothread .and. (.not.lhound .and. iaptype.ge.3 .or. lhound     &
                   .and. (iaptype.eq.21 .or. iaptype.eq.23)) .and. .not.lsdone) then
                 if(.not.lqsomsgdcd .and. .not.(.not.lmycallstd .and.             &
                      .not.lhiscallstd)) then
                    if(.not.lft8sdec .and. .not.stophint .and. dfqso.lt.2.0) then
                       call ft8svar(s8,srr,itone,msg37,lft8s,nft8rxfsens,stophint)
                       if(lft8s) then
                          if(index(msg37,'<').gt.0) then
                             lhashmsg=.true.
                          endif
                          nbadcrc=0
                          lft8sdec=.true.
                       endif
                    endif
                 endif
                 lsdone=.true.
              endif
              if(nbadcrc.eq.0) then
                 i3=1
                 n3=1
                 exit
              endif

              if(lsd .and. isubp2.eq.3 .and. nbadcrc.eq.1 .and. srr.lt.7.0) then ! low DR setups shall not try FT8SDvar for strong signals
                 call ft8sdvar(s8,srr,itone,msgd,msg37,lft8sd,lcq)
                 if(lft8sd) then
                    if(levenint) then
                       evencopy(isd)%lstate=.false.
                    elseif(loddint) then
                       oddcopy(isd)%lstate=.false.
                    endif
                    i3=1
                    n3=1
                    iaptype2=iaptype
                    iaptype=0
                    nbadcrc=0
                    lsd=.false.
                    exit
                 endif
              endif

              if(nweak.eq.1 .and. isubp1.eq.1) then
                 if(ipass.eq.npass-1) then
                    if(lcqsignal) then
                       if(isubp2.eq.22) then ! last pass, std and nonstd mycall
                          lfoundcq=.false.
                          do ik=1,numdeccq
                             if(tmpcqdec(ik)%freq.gt.5001.0) exit
                             if(abs(tmpcqdec(ik)%freq-f1).lt.5.0 .and.           &
                                  abs(tmpcqdec(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                                lfoundcq=.true.
                                exit
                             endif
                          enddo
                          if(.not.lfoundcq .and. ncqsignal.lt.numcqsig) then
                             ncqsignal=ncqsignal+1
                             tmpcqsig(ncqsignal)%freq=f1
                             tmpcqsig(ncqsignal)%xdt=xdt
                             tmpcqsig(ncqsignal)%cs=cstmp2
                          endif
                       endif
                    endif
                    if(lmycsignal .and. isubp2.eq.19) then ! last pass
                       lfoundmyc=.false.
                       do ik=1,numdecmyc
                          if(tmpmyc(ik)%freq.gt.5001.0) exit
                          if(abs(tmpmyc(ik)%freq-f1).lt.5.0 .and.                &
                               abs(tmpmyc(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                             lfoundmyc=.true.
                             exit
                          endif
                       enddo
                       if(.not.lfoundmyc .and. nmycsignal.lt.nummycsig) then
                          nmycsignal=nmycsignal+1
                          tmpmycsig(nmycsignal)%freq=f1
                          tmpmycsig(nmycsignal)%xdt=xdt
                          tmpmycsig(nmycsignal)%cs=cstmp2
                       endif
                    endif
                 endif
                 if(ipass.eq.npass) then
                    if(lqsocandave .and. (iaptype.eq.3 .or. iaptype.eq.6)) then
                       tmpqsosig(1)%freq=f1
                       tmpqsosig(1)%xdt=xdt
                       tmpqsosig(1)%cs=cstmp2
                    endif
                 endif
              endif
            !  print*,'line 2242 nbadcrc=',nbadcrc

              if(nbadcrc.eq.1) cycle
           endif

           write(c77,'(77i1)') message77
           read(c77(72:74),'(b3)') n3
           read(c77(75:77),'(b3)') i3
           !print*,'line 2247 iaptype=',iaptype,' i3=',i3,' n3=',n3
           if((i3.gt.4 .or. (i3.eq.0 .and. n3.gt.5)) .and. (.not.(i3.eq.5 .and.   &
                (n3.eq.1 .or. n3.eq.7 .or.n3.eq.6 .or.n3.eq.4 .or.n3.eq.3 .or.n3.eq.0 &
                .or.n3.eq.5 .or. n3.eq.2 .or. n3.eq.8 .or. n3.eq.9)))) cycle  
                ! ft8md added n3.eq.6 and n3.eq.4 and n3.eq.3 and n3.eq.0 
                ! and n3.eq.5 for USA calls with EU VHF 
                ! added .or. n3.eq.2 .or. n3.eq.8 .or. n3.eq.9 as test for EU VHF
           !print*,'did not cycle at line 2248'
           call unpack77var(c77,1,msg37,unpk77_successvar,nthr)
           if(.not.unpk77_successvar) then
              if(lqsothread .and. (.not.lhound .and. iaptype.ge.3 .or. lhound .and. &
                   (iaptype.eq.21 .or. iaptype.eq.23)) .and. .not.lsdone) then
                 if(.not.lqsomsgdcd .and. .not.(.not.lmycallstd .and.             &
                      .not.lhiscallstd)) then
                    if(.not.lft8sdec .and. .not.stophint .and. dfqso.lt.2.0) then
                       call ft8svar(s8,srr,itone,msg37,lft8s,nft8rxfsens,stophint)
                       if(lft8s) then
                          if(index(msg37,'<').gt.0) then
                             lhashmsg=.true.
                          endif
                          nbadcrc=0
                          lft8sdec=.true.
                       endif
                    endif
                 endif
                 lsdone=.true.
                 if(nbadcrc.eq.0) then
                    i3=1
                    n3=1
                    exit
                 endif
              endif
              cycle
           endif

           if(iaptype.eq.1 .and. msg37(1:10).eq.'CQ DE AA00') then
              nbadcrc=1
              cycle
           endif
           lcall1hash=.false.
           if(msg37(1:1).eq.'<') lcall1hash=.true.
           nbadcrc=0  ! If we get this far: valid codeword, valid (i3,n3), nonquirky message.
           call get_tones_from_77bits(message77,itone)
! 0.1  K1ABC RR73; W9XYZ <KH1/KH7Z> -11   28 28 10 5       71   DXpedition Mode
           i3bit=0
           if(i3.eq.0 .and. n3.eq.1) i3bit=1
!        iFreeText=message77(57)
! 0.0  Free text
           if(i3.eq.0 .and. n3.eq.0) then
              lFreeText=.true.
           else
              lFreeText=.false.
           endif
! delete braces
           lcall2hash=.false.
           if(.not.lFreeText .and. i3bit.ne.1 .and. index(msg37,'<').gt.0) then
              if(index(msg37,'<').gt.4) lcall2hash=.true.
              if(index(msg37,'<').gt.0) then
                 lhashmsg=.true.
              endif
           endif
           if(nbadcrc.eq.0) exit
        enddo ! ap passes
        if(nbadcrc.eq.0) exit
     enddo ! weak sigs
     if(nbadcrc.eq.0) exit
  enddo !nqso sync
  
2 if(nbadcrc.eq.0) then
! check for the false FT8Svar decode
     if(lft8s .and. lrepliedother) then
        msg37=''
        nbadcrc=1
        return
     endif
     msg37_2=''
     if(i3bit.eq.1 .and. .not.lft8s .and. .not.lft8sd) then
        call msgparservar(msg37,msg37_2)
        lspecial=.true.  !only in ft8var

!protection against a false FT8Svar decode in Hound mode 
        if(lhound .and. dfqso.lt.2.0) lqsomsgdcd=.true. !$OMP FLUSH (lqsomsgdcd)
     endif
     qual=1.0-(nharderrors+dmin)/60.0
     xsnr=0.001
     xnoi=1.E-8
     xsnrtmp=0.001
     do i=1,79
        xsig=s8(itone(i),i)**2
        xnoi=(sum(s8(0:7,i)**2) - xsig)/7.0
        if(xnoi.lt.0.01) xnoi=0.01 ! safe division and better accuracy
        if(xnoi.lt.xsig) then
           xsnr=xsig/xnoi
        else
           xsnr=1.01
        endif
        xsnrtmp=xsnrtmp+xsnr
     enddo

     xsnr=xsnrtmp/79.0-1.0
     xsnr=10.0*log10(xsnr)-26.5
     if(xsnr.gt.7.0) xsnr=xsnr+(xsnr-7.0)/2.0
     if(xsnr.gt.30.0) then
        xsnr=xsnr-1.0
        if(xsnr.gt.40.0) xsnr=xsnr-1.0
        if(xsnr.gt.49.0) xsnr=49.0
     endif
     xsnrs=xsnr
     if(xsnr .lt. -17.0) then
        if(xsnr.lt.-22.5 .and. xsnr.gt.-23.5) xsnr=-22.5 ! safe division and better accuracy
        xsnr=xsnr-(1.0+1.4/(23.0+xsnr))**2+1.2
     endif
     if(iaptype.eq.0) then
        if(xsnr.lt.-23.0) xsnr=-23.0
     else
        if(xsnr.lt.-24.0) xsnr=-24.0
     endif
     if(lft8s .or. lft8sd) then
        if(xsnr.lt.-22.0) xsnr=xsnrs-1.0 ! correction offset
        if(xsnr.lt.-26.0) xsnr=-26.0

! -26  0.1 1477 ~ AC1MX AC1MX R-17          ^
        if(len_trim(mycall).gt.3 .and. index(msg37,' '//trim(mycall)//' ').gt.1) then
           msg37=''
           return
        endif
        go to 4 ! bypass checking to false decode
     endif
     !if(len_trim(msg37)>0) print*,'line 2371 ',msg37

     rxdt=xdt-0.5
     if(iaptype.gt.34 .and. iaptype.lt.40) then ! DX Call searching false iaptype 35,36: 'CS7CYU/R FO5QB 73', 'T57KWP/R FO5QB RR73'
        ispc1=index(msg37,' ')
        if(ispc1.gt.5) then
           if(msg37((ispc1-2):(ispc1-1)).eq.'/R') then ! have to cascade it to prevent getting out of index range
              call_a=''
              call_a=msg37(1:(ispc1-3))
              lfound=.false.
              call searchcallsvar(call_a,"            ",lfound)
              if(.not.lfound) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif
        endif
     else if(qual.lt.0.39 .or. xsnr.lt.-20.5 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.9  &
          .or. (iaptype.gt.0 .and. iaptype.lt.4) .or. iaptype.eq.11 .or.         &
          iaptype.eq.21 .or. iaptype.eq.40 .or. iaptype.eq.41) then
        if(iaptype.gt.3 .and. iaptype.lt.7) go to 4 ! skip, nothing to check
        if(iaptype.ne.2 .and. iaptype.ne.3 .and. iaptype.ne.11 .and. iaptype.ne.21 &
             .and. iaptype.ne.40 .and. iaptype.ne.41) then
           if((mybcall.ne."            " .and. index(msg37,mybcall).gt.0) .or. &
              (hisbcall.ne."            " .and. index(msg37,hisbcall).gt.0)) go to 256
        endif

        if(i3bit.eq.1) then
        !  print*,'nbadcrc line 2400',nbadcrc
           call chkspecial8var(msg37,msg37_2,nbadcrc)
        !  print*,'nbadcrc line 2402',nbadcrc
        else
        !  print*,'nbadcrc line 2404 nbadcrc,i3,n3',nbadcrc,i3,n3
           call chkfalse8var(msg37,i3,n3,nbadcrc,iaptype,lcall1hash)
        !  print*,'nbadcrc line 2406',nbadcrc
        endif
        if(nbadcrc.eq.1) then
           msg37=''
           return
        endif
     endif
     if(iaptype.eq.2 .or. iaptype.eq.3 .or. iaptype.eq.11 .or. iaptype.eq.21 .or. &
          iaptype.eq.40 .or. iaptype.eq.41) go to 4 ! already checked

! decoded without AP masks:
! CQ PLIB U40OKH FE61
! CQ 000 RO8JSV GJ38
256  if(iaptype.eq.0 .and. i3.eq.1 .and. msg37(1:3).eq.'CQ ') then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        if((ispc2-ispc1).eq.4 .or. (ispc2-ispc1).eq.5) then
           ispc3=index(msg37((ispc2+1):),' ')+ispc2
           ispc4=index(msg37((ispc3+1):),' ')+ispc3
           if((ispc3-ispc2).gt.3 .and. (ispc4-ispc3).eq.5) then
              grid=''
              if(msg37(ispc3+1:ispc3+1).gt.'@' .and. msg37(ispc3+1:ispc3+1).lt.'S' &
                   .and. msg37(ispc3+2:ispc3+2).gt.'@' .and.                       &
                   msg37(ispc3+2:ispc3+2).lt.'S' .and.                             &
                   msg37(ispc3+3:ispc3+3).lt.':' .and.                             &
                   msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
              if(grid.ne.'') then
                 callsign=''
                 callsign=msg37(ispc2+1:ispc3-1)
                 call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
                 if(lwrongcall .or. .not.lgvalid) then
                    nbadcrc=1
                    msg37=''
                    return
                 endif
              endif
           endif
        endif
     endif

! i3=1,2 false decodes with ' R '
! 3B4NDC/R C40AUZ/R R IR83  i3=1
! MS8QQS UX3QBS/P R NG63  i3=2
! <...> P32WRF R LR56
! P32WRF <...> R LR56

     if((i3.eq.1 .or. i3.eq.2) .and. index(msg37,' R ').gt.0) then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        ispc3=index(msg37((ispc2+1):),' ')+ispc2
        if(ispc3-ispc2.eq.2) then
           if(msg37(ispc2:ispc3).eq.' R ') then
              call_b=''
              if((i3.eq.1 .and. msg37(ispc2-2:ispc2-1).eq.'/R') .or.             &
                   (i3.eq.2 .and. msg37(ispc2-2:ispc2-1).eq.'/P')) then
                 call_b=msg37(ispc1+1:ispc2-3)
              else
                 call_b=msg37(ispc1+1:ispc2-1)
              endif
              if(lcall2hash) then ! valid call_b can be found in hash table, check call_a then
                 call_a=''
                 if((i3.eq.1 .and. msg37(ispc1-2:ispc1-1).eq.'/R') .or.          &
                      (i3.eq.2 .and. msg37(ispc1-2:ispc1-1).eq.'/R')) then
                    call_a=msg37(1:ispc1-3)
                 else
                    call_a=msg37(1:ispc1-1)
                 endif
                 falsedec=.false.
                 call chkflscallvar('CQ          ',call_a,falsedec)
                 if(falsedec) then
                    nbadcrc=1
                    msg37=''
                    return
                 endif
              else if(len_trim(call_b).gt.2) then
                 ispc4=index(msg37((ispc3+1):),' ')+ispc3
                 grid=''
                 if(ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc3+1).gt.'@' .and.   &
                      msg37(ispc3+1:ispc3+1).lt.'S' .and.                        &
                      msg37(ispc3+2:ispc3+2).gt.'@' .and.                        &
                      msg37(ispc3+2:ispc3+2).lt.'S' .and.                        &
                      msg37(ispc3+3:ispc3+3).lt.':' .and.                        &
                      msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
                 if(grid.ne.'') then
                    call chkgridvar(call_b,grid,lchkcall,lgvalid,lwrongcall)
                    if(lwrongcall .or. .not.lgvalid) then
                       nbadcrc=1
                       msg37=''
                       return
                    endif
                 endif
              endif
           endif
        endif
     endif

! 0.3   WA9XYZ KA1ABC R 16A EMA            28 28 1 4 3 7    71   ARRL Field Day
! 0.4   WA9XYZ KA1ABC R 32A EMA            28 28 1 4 3 7    71   ARRL Field Day
! -23  3.1  197 ~ Z67BGE H67HJI 22G EMA i3=0 n3=4
!  -3  2.2 FY4IML UV7BEA R 24F NNJ   i3=0 n3=4
     
     if(i3.eq.0 .and. n3.gt.2 .and. n3.lt.5) then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        if(ispc1.gt.3 .and. ispc2.gt.7) then
           call_a=''
           call_b=''
           if(msg37(1:ispc1-1).eq.'/R' .or. msg37(1:ispc1-1).eq.'/P') then
              call_a=msg37(1:ispc1-3)
           else
              call_a=msg37(1:ispc1-1)
           endif
           if(msg37(ispc1+1:ispc2-1).eq.'/R' .or. msg37(ispc1+1:ispc2-1).eq.'/P') then
              call_b=msg37(ispc1+1:ispc2-3)
           else
              call_b=msg37(ispc1+1:ispc2-1)
           endif

! operators outside USA and Canada shall transmit ' DX '
           if(call_b(1:1).ne.'A' .and. call_b(1:1).ne.'K' .and. call_b(1:1).ne.'N' &
                .and. call_b(1:1).ne.'W' .and. call_b(1:1).ne.'V' .and.           &
                call_b(1:1).ne.'C' .and. call_b(1:1).ne.'X') then
              if(index(msg37,' DX ').lt.1) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif

! USA AA..AL
           if(call_b(1:1).eq.'A' .and. (call_b(2:2).lt.'A' .or. call_b(2:2).gt.'L')) then
              if(index(msg37,' DX ').lt.1) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif

! Canada CF..CK,CY,CZ,VA..VG,VO,VX,VY,XJ..XO
           if(call_b(1:1).eq.'C' .and. (call_b(2:2).lt.'F' .or. call_b(2:2).gt.'K')) then
              if(call_b(2:2).ne.'Y' .and. call_b(2:2).ne.'Z') then
                 if(index(msg37,' DX ').lt.1) then
                    nbadcrc=1
                    msg37=''
                    return
                 endif
              endif
           endif

           if(call_b(1:1).eq.'V' .and. (call_b(2:2).lt.'A' .or. call_b(2:2).gt.'G')) then
              if(call_b(2:2).ne.'O' .and. call_b(2:2).ne.'X' .and. call_b(2:2).ne.'Y') then
                 if(index(msg37,' DX ').lt.1) then
                    nbadcrc=1
                    msg37=''
                    return
                 endif
              endif
           endif
           if(call_b(1:1).eq.'X' .and. (call_b(2:2).lt.'J' .or. call_b(2:2).gt.'O')) then
              if(index(msg37,' DX ').lt.1) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif
           if(xsnr.lt.-19.0 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.0) then
              falsedec=.false.
              call chkflscallvar(call_a,call_b,falsedec)
              if(falsedec) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif
        endif
     endif

! EU VHF contest exchange i3=5
! <PA3XYZ> <G4ABC/P> R 590003 IO91NP      h12 h22 r1 s3 S11 g25
! packing is not implemented in WSJT-X 2.5.4?
! old implementation with i3=0 n3=2
! JL6GSC/P R 571553 CJ76MV i3=5
! G59XTB R 521562 RA82SJ

     if(i3.eq.5 .and. n3.eq.1 .and. (xsnr.lt.-19.0 .or. rxdt.lt.-0.5 .or.        &
          rxdt.gt.1.0)) then ! was if i3-0 and n3=2
        ispc1=index(msg37,' ')
        if(ispc1.gt.3) then
           call_b=''
           if(msg37(ispc1-2:ispc1-1).eq.'/P') then
              call_b=msg37(1:ispc1-3)
           else
              call_b=msg37(1:ispc1-1)
           endif
           falsedec=.false.
           call chkflscallvar('CQ          ',call_b,falsedec)
           if(falsedec) then
              nbadcrc=1
              msg37=''
              return
           endif
        endif
     endif

! FT8OPG/R Z27HRN/R OH12 check all standard messages with contest callsigns
! /P has i3.eq.2 .and. n3.eq.0
     if(iaptype.eq.0 .and. i3.eq.1 .and. n3.eq.0 .and. index(msg37,'/R ').gt.3) then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        if(ispc1.gt.3 .and. ispc2.gt.6) then
           call_a=''
           call_b=''
           if(msg37(ispc1-2:ispc1-1).eq.'/R') then
              call_a=msg37(1:ispc1-3)
           else
              call_a=msg37(1:ispc1-1)
           endif
           if(msg37(ispc2-2:ispc2-1).eq.'/R') then
              call_b=msg37(ispc1+1:ispc2-3)
           else
              call_b=msg37(ispc1+1:ispc2-1)
           endif
           falsedec=.false.
           call chkflscallvar(call_a,call_b,falsedec)
           if(falsedec) then
              nbadcrc=1
              msg37=''
              return
           endif
        endif
     endif

! -23 -0.5 2533 ~ <...> W LKNQZG2K4 RR73  invalid message, iaptype=0 this type of message is not allowed for transmission with RR73   
! -23 -1.2 1335 ~ <...> Z7VENB8R G9 RRR   non AP decode, iaptype=0 invalid message, this type of message is not allowed 
! for transmission with RRR   

     if(msg37(1:2).eq.'<.') then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        ispc3=index(msg37((ispc2+1):),' ')+ispc2
        ispc4=index(msg37((ispc3+1):),' ')+ispc3
        if((ispc4-ispc3.eq.4 .and. msg37(ispc3+1:ispc4-1).eq.'RRR') .or.          &
             (ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc4-1).eq.'RR73') .or.       &
             (ispc4-ispc3.eq.3 .and. msg37(ispc3+1:ispc4-1).eq.'73')) then
           nbadcrc=1
           msg37=''
           return
        endif

! -19 0.0 2256 ~ <...> 9T4DQZ RP53  non AP decode, iaptype=0 i3=1 n3=1  SAME AS CQ MSG
! <...> 9T4DQZ -15(R-15) message has i3=1 n3=4
        if(i3.eq.1 .and. n3.eq.1 .and. (xsnr.lt.-18.0 .or. rxdt.lt.-0.5 .or.     &
             rxdt.gt.1.0)) then
           callsign='            '
           callsign=msg37(ispc1+1:ispc2-1)
           grid=msg37(ispc2+1:ispc3-1)
           include 'callsign_q.f90'
           call chkgridvar(callsign,grid,lchkcall,lgvalid,lwrongcall)
           if(lwrongcall) then
              nbadcrc=1
              msg37=''
              return
           endif
           if(lchkcall .or. .not.lgvalid) then
              falsedec=.false.
              call chkflscallvar('CQ          ',callsign,falsedec)
              if(falsedec) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif
        endif
     endif

! -22  0.3 1000 ~ 9Y4DWY <...> BF70  iaptype=0 i3=1 n3=2  invalid message in FT8
! protocol, can be transmitted manually

     if(i3.eq.1) then
        ispc1=index(msg37,' ')
        if(msg37(ispc1+1:ispc1+2).eq.'<.') then
           ispc2=index(msg37((ispc1+1):),' ')+ispc1
           ispc3=index(msg37((ispc2+1):),' ')+ispc2
           if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and.        &
                msg37(ispc2+1:ispc2+1).lt.'S' .and.                             &
                msg37(ispc2+2:ispc2+2).gt.'@' .and.                             &
                msg37(ispc2+2:ispc2+2).lt.'S' .and.                             &
                msg37(ispc2+3:ispc2+3).lt.':' .and.                             &
                msg37(ispc2+4:ispc2+4).lt.':') then ! there is a valid grid in message
              call_b=''
              call_b=msg37(1:ispc1-1)
              falsedec=.false.
              call chkflscallvar('CQ          ',call_b,falsedec)
              if(falsedec) then
                 nbadcrc=1
                 msg37=''
                 return
              endif
           endif
        endif
     endif

! i3=3 parse ARRL RTTY contest message
! i3 n3                                      Bits               Total  Message type
! 3     TU; W9XYZ K1ABC R 579 MA             1 28 28 1 3 13       74   ARRL RTTY contest
! 3     TU; W9XYZ G8ABC R 559 0013           1 28 28 1 3 13       74   ARRL RTTY (DX)
! TU; D47IAQ <...> 559 032' does protocol support the message?

     if(i3.eq.3 .and. msg37(1:3).eq.'TU;') then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1 
        ispc3=index(msg37((ispc2+1):),' ')+ispc2
        call_a=''
        call_b=''
        call_a=msg37(ispc1+1:ispc2-1)
        call_b=msg37(ispc2+1:ispc3-1)
! check for false, too tough, need to rework if contest is supported
        falsedec=.false.
        call chkflscallvar(call_a,call_b,falsedec)
        if(falsedec) then
           nbadcrc=1
           msg37=''
           return
        endif
! parse
        lspecial=.true.
        msg37_2=msg37(5:37)//'    '
        msg37=''
        msg37='DE '//trim(call_b)//' TU'
     endif

! DX Call searching false decodes, search for 1st callsign in ALLCALL7
! 6W6VIV EY8MM 73
! 6Y9KOZ EY8MM RR73
     if(iaptype.gt.34 .and. iaptype.lt.40 .and. (xsnr.lt.-21.0 .or. rxdt.lt.-0.5 &
          .or. rxdt.gt.1.0)) then
        ispc1=index(msg37,' ')
        if(ispc1.gt.1) then
           call_b=''
           call_b=msg37(1:ispc1-1)
           falsedec=.false.
           call chkflscallvar('CQ          ',call_b,falsedec)
           if(falsedec) then
              nbadcrc=1
              msg37=''
              return
           endif
        endif
     endif

4    continue
!### Possibly call ft8_a8d() here ??? ###

     ldupemsg=.false.
     if(ndecodes.gt.0) then
        do i=1,ndecodes
           if(allmessages(i).eq.msg37 .and. abs(allfreq(i)-f1).lt.45.0) then
              ldupemsg=.true.
           endif
        enddo
     endif

     if(.not.ldupemsg .and. dfqso.lt.2.0 .and. ((i3.eq.1 .and. .not.lft8s) .or. &
          lft8s)) then
        if(msg37(1:msgrootlen+1).eq.trim(msgroot)//' ') then
           lasthcall=hiscall
           lastrxmsg(1)%lastmsg=msg37
           lastrxmsg(1)%xdt=xdt-0.5
           lastrxmsg(1)%lstate=.true.
           lqsomsgdcd=.true.
!$OMP FLUSH (lqsomsgdcd)
        else if(.not.lft8s .and. mycalllen1.gt.2) then
           if(msg37(1:mycalllen1).ne.trim(mycall)//' ' .and.                    &
                index(msg37,' '//trim(hiscall)//' ').gt.0) then
              lrepliedother=.true.
           endif
        endif
     endif

     if(len_trim(hiscall).gt.3 .and. .not.lqsomsgdcd) then
        if(msg37(1:msgrootlen+1).eq.trim(msgroot)//' ') then
           lqsomsgdcd=.true.
!$OMP FLUSH (lqsomsgdcd)
        endif
     endif
     
     if(.not.stophint .and. .not.ldupemsg .and. dfqso.lt.2.0 .and. nlasttx.gt.0 &
          .and. nlasttx.lt.6 .and. msg37(1:3).eq.'CQ ') then
        nlength=len_trim(hiscall)
        if(nlength.gt.2) then
           if(msg37(4:4+nlength).eq.trim(hiscall)//' ' .or.                     &
                msg37(7:7+nlength).eq.trim(hiscall)//' ') lrepliedother=.true.
        endif
     endif

     if(mycalllen1.gt.2) then
        if(.not.ldupemsg .and. msg37(1:mycalllen1).eq.trim(mycall)//' ') then
           nincallthr(nthr)=nincallthr(nthr)+1
           nindex=maskincallthr(nthr)+nincallthr(nthr)
           if(nindex.lt.maskincallthr(nthr+1)) then
              msgincall(nindex)=msg37
              xdtincall(nindex)=xdt-0.5
           else
              nincallthr(nthr)=nincallthr(nthr)-1
           endif
        endif
     endif

     ldupeft8sd=.false.
     if(ncount.gt.0 .and. lft8sd) then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        msgbase37=''
        msgbase37=msg37(1:ispc2-1)
        do i=1,ncount
           if(trim(msgbase37).eq.trim(msgsrcvd(i))) then
              ldupeft8sd=.true.
              exit
           endif
        enddo
     endif

     if(ldupeft8sd) then
        msg37=''
        nbadcrc=1
        return
     endif

     if(.not.ldupemsg .and. i3.eq.1 .and. .not.lft8sd .and. .not.lft8s .and.    &
          msg37(1:3).ne.'CQ ') then
        ispc1=index(msg37,' ')
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        ncount=ncount+1
        msgsrcvd(ncount)=msg37(1:ispc2-1)
     endif

! -23  0.0 1606 ~ <...> 3U1TBM/R CC65 i3=4 n3=0
! -18  0.3 1609 ~ CQ 6U6MBL/R IJ90 i3=1  in some noisy setups false decode with any SNR value is possible

     if((i3.eq.4 .and. n3.eq.0) .or. (i3.eq.1 .and. msg37(1:3).eq."CQ ")) then
        if(index(msg37,'/R ').gt.9) then
           ispc1=index(msg37,' ')
           ispc2=index(msg37((ispc1+1):),' ')+ispc1
           if(ispc2.gt.11) then
              ispc3=index(msg37((ispc2+1):),' ')+ispc2
              if(msg37((ispc2-2):(ispc2-1)).eq.'/R') then
                 if((ispc3-ispc2).eq.5) then
                    grid=msg37(ispc2+1:ispc3-1)
! grid can not be txed, invalid message:
                    if(i3.eq.4 .and. len_trim(grid).eq.4) then
                       nbadcrc=1
                       msg37=''
                       return
                    endif
                    call_b=''
                    call_b=msg37((ispc1+1):(ispc2-3))
                    call chkgridvar(call_b,grid,lchkcall,lgvalid,lwrongcall)
                    if(lwrongcall .or. .not.lgvalid) then
                       nbadcrc=1
                       msg37=''
                       return
                    endif
                 endif
              endif
           endif
        endif
     endif

! protocol violations
! 713STG 869TK NO05  i3=2 n3=5, false decode, as per protocol type2 shall be /P message
     if(i3.eq.2 .and. index(msg37,'/P ').lt.1) then
        msg37=''
        nbadcrc=1
        return
     endif

! -18  0.5  584 ~ UA3ALE <...> PR07         *  AP decode with grid
     if(iaptype.eq.2) then
        nhash=index(msg37,"<...>")
        if(nhash.gt.4 .and. nhash.lt.13 .and. msg37(nhash+6:nhash+6).gt.'@' .and. &
             msg37(nhash+7:nhash+7).gt.'@') then
           msg37=''
           nbadcrc=1
           return
        endif
     endif

     if(lsubtract) then
        noff=10
        sync0=0.
        syncp=0.
        syncm=0.
        k=1
        call gen_ft8wavevar(itone,79,1920,2.0,12000.0,0.0,csig0,xjunk,1,151680)
        do i=0,78
           do j=1,32
              csig(j)=csig0(k)
              k=k+60
           enddo
           i21=i0+i*32
           z1=0.
           z1=sum(cd0(i21:i21+31)*conjg(csig))
           sync0 = sync0 + real(z1)**2 + aimag(z1)**2
           i21=i0+i*32+noff
           z1=0.
           z1=sum(cd0(i21:i21+31)*conjg(csig))
           syncp = syncp + real(z1)**2 + aimag(z1)**2
           i21=i21-noff*2
           z1=0.
           z1=sum(cd0(i21:i21+31)*conjg(csig))
           syncm = syncm + real(z1)**2 + aimag(z1)**2
        enddo
        call peakup(syncm,sync0,syncp,dx)
        if(abs(dx).gt.1.0) then
           scorr=0.
        else
           scorr=real(noff)*(dx) ! was * dx ft8md
        endif
        xdt3=xdt+scorr*dt2
        call subtractft8var(itone,f1,xdt3)
        lsubtracted=.true. ! inside current thread
        if(npos.lt.200) then
           npos=npos+1
           freqsub(npos)=f1
        endif
     endif
  endif

  return
end subroutine ft8bvar

subroutine normalizebmetvar(bmet,n)
  real bmet(n)

!  bmetav=sum(bmet)/real(n)
  bmet2av=sum(bmet*bmet)/real(n)
!  var=bmet2av-bmetav*bmetav
!  if( var .gt. 0.0 ) then
!     bmetsig=sqrt(var)
!  else
  bmetsig=sqrt(bmet2av)
!  endif
  bmet=bmet/bmetsig

  return
end subroutine normalizebmetvar

subroutine calibrate(data_dir,iz,a,b,rms,sigmaa,sigmab,irc)

! Average groups of frequency-calibration measurements, then fit a
! straight line for slope and intercept.

  parameter (NZ=1000)
  implicit real*8 (a-h,o-z)
  character*(*) data_dir
  character*256 infile,outfile
  character*8 cutc,cutc1
  character*1 c1
  real*8 fd(NZ),deltaf(NZ),r(NZ),rmsd(NZ)
  integer nn(NZ)

  infile=trim(data_dir)//'/'//'fmt.all'
  outfile=trim(data_dir)//'/'//'fcal2.out'

  open(10,file=trim(infile),status='old',err=996)
  open(12,file=trim(outfile),status='unknown',err=997)

  nkhz0=0
  sum=0.d0
  sumsq=0.d0
  n=0
  j=0
  do i=1,99999
     read(10,*,end=10,err=995) cutc,nkHz,ncal,noffset,faudio,df,dblevel,snr
     if((nkHz.ne.nkHz0) .and. i.ne.1) then
        ave=sum/n
        rms=0.d0
        if(n.gt.1) then
           rms=sqrt(abs(sumsq - sum*sum/n)/(n-1.d0))
        endif
        fMHz=0.001d0*nkHz0
        j=j+1
        fd(j)=fMHz
        deltaf(j)=ave
        r(j)=0.d0
        rmsd(j)=rms
        nn(j)=n
        sum=0.d0
        sumsq=0.d0
        n=0
     endif
     dial_error=faudio-noffset
     sum=sum + dial_error
     sumsq=sumsq + dial_error**2
     n=n+1
     if(n.eq.1) then
        cutc1=cutc
        ncal0=ncal
     endif
     nkHz0=nkHz
  enddo

10 ave=sum/n
  rms=0.d0
  if(n.gt.0) then
     rms=sqrt((sumsq - sum*sum/n)/(n-1.d0))
  endif
  fMHz=0.001d0*nkHz
  j=j+1
  fd(j)=fMHz
  deltaf(j)=ave
  r(j)=0.d0
  rmsd(j)=rms
  nn(j)=n
  iz=j
  if(iz.lt.2) go to 998

  call fitcal(fd,deltaf,r,iz,a,b,sigmaa,sigmab,rms)

  write(12,1002) 
1002 format('    Freq      DF     Meas Freq    N    rms    Resid'/        &
            '   (MHz)     (Hz)      (MHz)          (Hz)     (Hz)'/        &
            '----------------------------------------------------')       
  irc=0
  do i=1,iz
     fm=fd(i) + 1.d-6*deltaf(i)
     c1=' '
     if(rmsd(i).gt.1.0d0) c1='*'
     write(12,1012)  fd(i),deltaf(i),fm,nn(i),rmsd(i),r(i),c1
1012 format(f8.3,f9.3,f14.9,i4,f7.2,f9.3,1x,a1)
  enddo
  go to 999

995 irc=-4; iz=i; go to 999
996 irc=-1; go to 999
997 irc=-2; go to 999
998 irc=-3
999 continue
  close(10)
  close(12)

  return
end subroutine calibrate

subroutine ana64(iwave,npts,c0)

  use timer_module, only: timer

  integer*2 iwave(npts)                      !Raw data at 12000 Hz
  complex c0(0:npts-1)                       !Complex data at 6000 Hz
  save

  nfft1=npts
  nfft2=nfft1/2
  df1=12000.0/nfft1
  fac=2.0/(32767.0*nfft1)
  c0(0:npts-1)=fac*iwave(1:npts)
  call four2a(c0,nfft1,1,-1,1)             !Forward c2c FFT
  c0(nfft2/2+1:nfft2-1)=0.
  c0(0)=0.5*c0(0)
  call four2a(c0,nfft2,1,1,1)              !Inverse c2c FFT; c0 is analytic sig

  return
end subroutine ana64

subroutine rectify_msk(c,msg0,imsg,freq2)

  parameter (NSPM=1404)
  complex c(0:NSPM-1)                         !Received data
  complex cmsg(0:NSPM-1)                      !Message waveform
  complex c1(0:NSPM-1)                        !Rectified signal
  complex c2(0:NSPM-1)                        !Integral of rectified signal
  complex c3(0:2*NSPM-1)                      !FFT of rectified signal
  complex cfac
  character*22 msg0,msg,msgsent
  integer i4tone(234)

  ichk=0
  msg=msg0
  nsym=234
  if(imsg.ge.0) then
     ichk=10000+imsg
     msg="<C1ALL C2ALL> 73"
     nsym=35
  endif
  call genmsk(msg,ichk,msgsent,i4tone,itype)  !Get tone sequence for msg

  twopi=8.0*atan(1.0)
  dt=1.0/12000.0
  f0=1000.0
  f1=2000.0
  phi=0.
  dphi=0.
  k=-1
  c2=0.
  do j=1,nsym                                  !Generate Tx waveform for msg
     if(i4tone(j).eq.0) dphi=twopi*f0*dt
     if(i4tone(j).eq.1) dphi=twopi*f1*dt
     do i=1,6
        k=k+1
        phi=phi+dphi
        cmsg(k)=cmplx(cos(phi),sin(phi))
        c1(k)=conjg(cmsg(k))*c(k)
        if(k.ge.1) c2(k)=c2(k-1) + c1(k)
     enddo
  enddo
  c2(0)=c2(1)
  pha=atan2(aimag(c2(NSPM-1)),real(c2(NSPM-1)))
  cfac=cmplx(cos(pha),-sin(pha))
  c1=cfac*c1
  c2=cfac*c2
  nfft=2*NSPM
  c3(0:NSPM-1)=c2
  c3(NSPM:nfft-1)=0.
  df=12000.0/nfft
  call four2a(c3,nfft,1,-1,1)
  smax=0.
  do i=0,nfft-1
     f=i*df
     if(i.gt.nfft/2) f=f-12000.0
     s=1.e-10*(real(c3(i))**2 + aimag(c3(i))**2)
     if(s.gt.smax) then
        smax=s
        freq2=1500.0 + f
     endif
  enddo

  return
end subroutine rectify_msk

subroutine astrosub(nyear,month,nday,uth8,nfreq,mygrid,hisgrid,          &
     AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
     RAMoon8,DecMoon8,Dgrd8,poloffset8,xnr8)

  implicit real*8 (a-h,o-z)
  character*6 mygrid,hisgrid

  call astro0(nyear,month,nday,uth8,nfreq,mygrid,hisgrid,                &
     AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
     dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,  &
     width1,width2,w501,w502,xlst8)

  return  
end subroutine astrosub

subroutine astrosub00(nyear,month,nday,uth8,nfreq,mygrid,ndop00)

  implicit real*8 (a-h,o-z)
  character*6 mygrid

  call astrosub(nyear,month,nday,uth8,nfreq,mygrid,mygrid,               &
     AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
     RAMoon8,DecMoon8,Dgrd8,poloffset8,xnr8)

  return
end subroutine astrosub00

module packjt

! These variables are accessible from outside via "use packjt":
  integer jt_itype,jt_nc1,jt_nc2,jt_ng,jt_k1,jt_k2
  character*6 jt_c1,jt_c2,jt_c3
  
  contains

subroutine packbits(dbits,nsymd,m0,sym)

 ! Pack 0s and 1s from dbits() into sym() with m0 bits per word.
 ! NB: nsymd is the number of packed output words.

   integer sym(:)
   integer*1 dbits(:)

   k=0
   do i=1,nsymd
      n=0
      do j=1,m0
         k=k+1
         m=dbits(k)
         n=ior(ishft(n,1),m)
      enddo
      sym(i)=n
   enddo

   return
 end subroutine packbits

 subroutine unpackbits(sym,nsymd,m0,dbits)

 ! Unpack bits from sym() into dbits(), one bit per byte.
 ! NB: nsymd is the number of input words, and m0 their length.
 ! there will be m0*nsymd output bytes, each 0 or 1.

   integer sym(:)
   integer*1 dbits(:)

   k=0
   do i=1,nsymd
      mask=ishft(1,m0-1)
      do j=1,m0
         k=k+1
         dbits(k)=0
         if(iand(mask,sym(i)).ne.0) dbits(k)=1
         mask=ishft(mask,-1)
      enddo
   enddo

   return
 end subroutine unpackbits

 subroutine packcall(callsign,ncall,text)

 ! Pack a valid callsign into a 28-bit integer.

   parameter (NBASE=37*36*10*27*27*27)
   character callsign*6,c*1,tmp*6
   logical text

   text=.false.

 ! Work-around for Swaziland prefix:
   if(callsign(1:4).eq.'3DA0') callsign='3D0'//callsign(5:6)

 ! Work-around for Guinea prefixes:
   if(callsign(1:2).eq.'3X' .and. callsign(3:3).ge.'A' .and.          &
        callsign(3:3).le.'Z') callsign='Q'//callsign(3:6)
   
   if(callsign(1:3).eq.'CQ ') then
      ncall=NBASE + 1
      if(callsign(4:4).ge.'0' .and. callsign(4:4).le.'9' .and.        &
           callsign(5:5).ge.'0' .and. callsign(5:5).le.'9' .and.      &
           callsign(6:6).ge.'0' .and. callsign(6:6).le.'9') then
         read(callsign(4:6),*) nfreq
         ncall=NBASE + 3 + nfreq
      endif
      return
   else if(callsign(1:4).eq.'QRZ ') then
      ncall=NBASE + 2
      return
   else if(callsign(1:3).eq.'DE ') then
      ncall=267796945
      return
   endif

   tmp='      '
   if(callsign(3:3).ge.'0' .and. callsign(3:3).le.'9') then
      tmp=callsign
   else if(callsign(2:2).ge.'0' .and. callsign(2:2).le.'9') then
      if(callsign(6:6).ne.' ') then
         text=.true.
         return
      endif
      tmp=' '//callsign(:5)
   else
      text=.true.
      return
   endif

   do i=1,6
      c=tmp(i:i)
      if(c.ge.'a' .and. c.le.'z')                                &
           tmp(i:i)=char(ichar(c)-ichar('a')+ichar('A'))
   enddo

   n1=0
   if((tmp(1:1).ge.'A'.and.tmp(1:1).le.'Z').or.tmp(1:1).eq.' ') n1=1
   if(tmp(1:1).ge.'0' .and. tmp(1:1).le.'9') n1=1
   n2=0
   if(tmp(2:2).ge.'A' .and. tmp(2:2).le.'Z') n2=1
   if(tmp(2:2).ge.'0' .and. tmp(2:2).le.'9') n2=1
   n3=0
   if(tmp(3:3).ge.'0' .and. tmp(3:3).le.'9') n3=1
   n4=0
   if((tmp(4:4).ge.'A'.and.tmp(4:4).le.'Z').or.tmp(4:4).eq.' ') n4=1
   n5=0
   if((tmp(5:5).ge.'A'.and.tmp(5:5).le.'Z').or.tmp(5:5).eq.' ') n5=1
   n6=0
   if((tmp(6:6).ge.'A'.and.tmp(6:6).le.'Z').or.tmp(6:6).eq.' ') n6=1

   if(n1+n2+n3+n4+n5+n6 .ne. 6) then
      text=.true.
      return 
   endif

   ncall=nchar(tmp(1:1))
   ncall=36*ncall+nchar(tmp(2:2))
   ncall=10*ncall+nchar(tmp(3:3))
   ncall=27*ncall+nchar(tmp(4:4))-10
   ncall=27*ncall+nchar(tmp(5:5))-10
   ncall=27*ncall+nchar(tmp(6:6))-10

   return
 end subroutine packcall

 subroutine unpackcall(ncall,word,iv2,psfx)

   parameter (NBASE=37*36*10*27*27*27)
   character word*12,c*37,psfx*4

   data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ '/

   word='......' 
   psfx='    '
   n=ncall
   iv2=0
   if(n.ge.262177560) go to 20
   word='......'
 !  if(n.ge.262177560) go to 999            !Plain text message ...
   i=mod(n,27)+11
   word(6:6)=c(i:i)
   n=n/27
   i=mod(n,27)+11
   word(5:5)=c(i:i)
   n=n/27
   i=mod(n,27)+11
   word(4:4)=c(i:i)
   n=n/27
   i=mod(n,10)+1
   word(3:3)=c(i:i)
   n=n/10
   i=mod(n,36)+1
   word(2:2)=c(i:i)
   n=n/36
   i=n+1
   word(1:1)=c(i:i)
   do i=1,4
      if(word(i:i).ne.' ') go to 10
   enddo
   go to 999
 10 word=word(i:)
   go to 999

 20 if(n.ge.267796946) go to 999

 ! We have a JT65v2 message
   if((n.ge.262178563) .and. (n.le.264002071)) then
 ! CQ with prefix
      iv2=1
      n=n-262178563
      i=mod(n,37)+1
      psfx(4:4)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.264002072) .and. (n.le.265825580)) then
 ! QRZ with prefix
      iv2=2
      n=n-264002072
      i=mod(n,37)+1
      psfx(4:4)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.265825581) .and. (n.le.267649089)) then
 ! DE with prefix
      iv2=3
      n=n-265825581
      i=mod(n,37)+1
      psfx(4:4)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.267649090) .and. (n.le.267698374)) then
 ! CQ with suffix
      iv2=4
      n=n-267649090
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.267698375) .and. (n.le.267747659)) then
 ! QRZ with suffix
      iv2=5
      n=n-267698375
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.267747660) .and. (n.le.267796944)) then
 ! DE with suffix
      iv2=6
      n=n-267747660
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if(n.eq.267796945) then
 ! DE with no prefix or suffix
      iv2=7
      psfx = '    '
   endif

999 if(word(1:3).eq.'3D0') word='3DA0'//word(4:)
   if(word(1:1).eq.'Q' .and. word(2:2).ge.'A' .and.                 &
        word(2:2).le.'Z') word='3X'//word(2:)

   return
 end subroutine unpackcall

 subroutine packgrid(grid,ng,text)

   parameter (NGBASE=180*180)
   character*4 grid
   character*1 c1
   logical text

   text=.false.
   if(grid.eq.'    ') go to 90               !Blank grid is OK

 ! First, handle signal reports in the original range, -01 to -30 dB
   if(grid(1:1).eq.'-') then
      read(grid(2:3),*,err=800,end=800) n
      if(n.ge.1 .and. n.le.30) then
         ng=NGBASE+1+n
         go to 900
      endif
      go to 10
   else if(grid(1:2).eq.'R-') then
      read(grid(3:4),*,err=800,end=800) n
      if(n.ge.1 .and. n.le.30) then
         ng=NGBASE+31+n
         go to 900
      endif
      go to 10
 ! Now check for RO, RRR, or 73 in the message field normally used for grid
   else if(grid(1:4).eq.'RO  ') then
      ng=NGBASE+62
      go to 900
   else if(grid(1:4).eq.'RRR ') then
      ng=NGBASE+63
      go to 900
   else if(grid(1:4).eq.'73  ') then
      ng=NGBASE+64
      go to 900
   endif

 ! Now check for extended-range signal reports: -50 to -31, and 0 to +49.
 10 n=99
   c1=grid(1:1)
   read(grid,*,err=20,end=20) n
   go to 30
 20 read(grid(2:4),*,err=30,end=30) n
 30 if(n.ge.-50 .and. n.le.49) then
      if(c1.eq.'R') then
         write(grid,1002) n+50
 1002    format('LA',i2.2)
      else
         write(grid,1003) n+50
 1003    format('KA',i2.2)
      endif
      go to 40
   endif

 ! Maybe it's free text ?
   if(grid(1:1).lt.'A' .or. grid(1:1).gt.'R') text=.true.
   if(grid(2:2).lt.'A' .or. grid(2:2).gt.'R') text=.true.
   if(grid(3:3).lt.'0' .or. grid(3:3).gt.'9') text=.true.
   if(grid(4:4).lt.'0' .or. grid(4:4).gt.'9') text=.true.
   if(text) go to 900

 ! OK, we have a properly formatted grid locator
 40 call grid2deg(grid//'mm',dlong,dlat)
   long=int(dlong)
   lat=int(dlat+ 90.0)
   ng=((long+180)/2)*180 + lat
   go to 900

 90 ng=NGBASE + 1
   go to 900

 800 text=.true.
 900 continue

   return
 end subroutine packgrid

 subroutine unpackgrid(ng,grid)

   parameter (NGBASE=180*180)
   character grid*4,grid6*6

   grid='    '
   if(ng.ge.32400) go to 10
   dlat=mod(ng,180)-90
   dlong=(ng/180)*2 - 180 + 2
   call deg2grid(dlong,dlat,grid6)
   grid=grid6(:4)
   if(grid(1:2).eq.'KA') then
      read(grid(3:4),*) n
      n=n-50
      write(grid,1001) n
 1001 format(i3.2)
      if(grid(1:1).eq.' ') grid(1:1)='+'
   else if(grid(1:2).eq.'LA') then
      read(grid(3:4),*) n
      n=n-50
      write(grid,1002) n
 1002 format('R',i3.2)
      if(grid(2:2).eq.' ') grid(2:2)='+'
   endif
   go to 900

 10 n=ng-NGBASE-1
   if(n.ge.1 .and.n.le.30) then
      write(grid,1012) -n
 1012 format(i3.2)
   else if(n.ge.31 .and.n.le.60) then
      n=n-30
      write(grid,1022) -n
 1022 format('R',i3.2)
   else if(n.eq.61) then
      grid='RO'
   else if(n.eq.62) then
      grid='RRR'
   else if(n.eq.63) then
      grid='73'
   endif

 900 return
 end subroutine unpackgrid

 subroutine packmsg(msg0,dat,itype)

 ! Packs a JT4/JT9/JT65 message into twelve 6-bit symbols

 ! itype Message Type
 !--------------------
 !   1   Standardd message
 !   2   Type 1 prefix
 !   3   Type 1 suffix
 !   4   Type 2 prefix
 !   5   Type 2 suffix
 !   6   Free text
 !  -1   Does not decode correctly

   parameter (NBASE=37*36*10*27*27*27)
   parameter (NBASE2=262178562)
   character*22 msg0,msg
   integer dat(:)
   character*12 c1,c2
   character*4 c3
   character*6 grid6
   logical text1,text2,text3

   itype=1
   msg=msg0

   call fmtmsg(msg,iz)
   if(msg(1:3).eq.'CQ ' .and. msg(4:4).ge.'0' .and. msg(4:4).le.'9'   &
        .and. msg(5:5).eq.' ') msg='CQ 00'//msg(4:)

   if(msg(1:6).eq.'CQ DX ') msg(3:3)='9'
   if(msg(1:3).eq.'CQ ' .and.                                         &
        msg(4:4).ge.'A' .and. msg(4:4).le.'Z' .and.                   &
        msg(5:5).ge.'A' .and. msg(5:5).le.'Z' .and.                   &
        msg(6:6).eq.' ') msg='E9'//msg(4:)
   
 ! See if it's a CQ message
   if(msg(1:3).eq.'CQ ') then
      i=3
 ! ... and if so, does it have a reply frequency?
      if(msg(4:4).ge.'0' .and. msg(4:4).le.'9' .and.                  &
           msg(5:5).ge.'0' .and. msg(5:5).le.'9' .and.                &
           msg(6:6).ge.'0' .and. msg(6:6).le.'9') i=7
      go to 1
   endif

   do i=1,22
      if(msg(i:i).eq.' ') go to 1       !Get 1st blank
   enddo
   go to 10                             !Consider msg as plain text

 1 ia=i
   c1=msg(1:ia-1)
   do i=ia+1,22
      if(msg(i:i).eq.' ') go to 2       !Get 2nd blank
   enddo
   go to 10                             !Consider msg as plain text

 2 ib=i
   c2=msg(ia+1:ib-1)

   do i=ib+1,22
      if(msg(i:i).eq.' ') go to 3       !Get 3rd blank
   enddo
   go to 10                             !Consider msg as plain text

 3 ic=i
   c3='    '
   if(ic.ge.ib+1) c3=msg(ib+1:ic)
   if(c3.eq.'OOO ') c3='    '           !Strip out the OOO flag
   call getpfx1(c1,k1,nv2a)
   if(nv2a.ge.4) go to 10
   call packcall(c1,nc1,text1)
   if(text1) go to 10
   call getpfx1(c2,k2,nv2b)
   call packcall(c2,nc2,text2)
   if(text2) go to 10
   if(nv2a.eq.2 .or. nv2a.eq.3 .or. nv2b.eq.2 .or. nv2b.eq.3) then
      if(k1.lt.0 .or. k2.lt.0 .or. k1*k2.ne.0) go to 10
      if(k2.gt.0) k2=k2+450
      k=max(k1,k2)
      if(k.gt.0) then
         call k2grid(k,grid6)
         c3=grid6(:4)
      endif
   endif
   call packgrid(c3,ng,text3)

   if(nv2a.lt.4 .and. nv2b.lt.4 .and. (.not.text1) .and. (.not.text2) .and.  &
        (.not.text3)) go to 20

   nc1=0
   if(nv2b.eq.4) then
      if(c1(1:3).eq.'CQ ' .and. (.not.text3))  nc1=262178563 + k2
      if(c1(1:4).eq.'QRZ ' .and. (.not.text3)) nc1=264002072 + k2
      if(c1(1:3).eq.'DE ' .and. (.not.text3))  nc1=265825581 + k2
   else if(nv2b.eq.5) then
      if(c1(1:3).eq.'CQ ' .and. (.not.text3))  nc1=267649090 + k2
      if(c1(1:4).eq.'QRZ ' .and. (.not.text3)) nc1=267698375 + k2
      if(c1(1:3).eq.'DE ' .and. (.not.text3))  nc1=267747660 + k2
   endif
   if(nc1.ne.0) go to 20

 ! The message will be treated as plain text.
 10 itype=6
   call packtext(msg,nc1,nc2,ng)
   ng=ng+32768

 ! Encode data into 6-bit words
20 continue
   if(itype.ne.6) itype=max(nv2a,nv2b)
   jt_itype=itype
   jt_c1=c1(1:6)
   jt_c2=c2(1:6)
   jt_c3=c3
   jt_k1=k1
   jt_k2=k2
   jt_nc1=nc1
   jt_nc2=nc2
   jt_ng=ng
   dat(1)=iand(ishft(nc1,-22),63)                !6 bits
   dat(2)=iand(ishft(nc1,-16),63)                !6 bits
   dat(3)=iand(ishft(nc1,-10),63)                !6 bits
   dat(4)=iand(ishft(nc1, -4),63)                !6 bits
   dat(5)=4*iand(nc1,15)+iand(ishft(nc2,-26),3)  !4+2 bits
   dat(6)=iand(ishft(nc2,-20),63)                !6 bits
   dat(7)=iand(ishft(nc2,-14),63)                !6 bits
   dat(8)=iand(ishft(nc2, -8),63)                !6 bits
   dat(9)=iand(ishft(nc2, -2),63)                !6 bits
   dat(10)=16*iand(nc2,3)+iand(ishft(ng,-12),15) !2+4 bits
   dat(11)=iand(ishft(ng,-6),63)
   dat(12)=iand(ng,63)

   return
 end subroutine packmsg

 subroutine unpackmsg(dat,msg)

   parameter (NBASE=37*36*10*27*27*27)
   parameter (NGBASE=180*180)
   integer dat(:)
   character c1*12,c2*12,grid*4,msg*22,grid6*6,psfx*4,junk2*4
   logical cqnnn

   cqnnn=.false.
   nc1=ishft(dat(1),22) + ishft(dat(2),16) + ishft(dat(3),10)+         &
        ishft(dat(4),4) + iand(ishft(dat(5),-2),15)

   nc2=ishft(iand(dat(5),3),26) + ishft(dat(6),20) +                   &
        ishft(dat(7),14) + ishft(dat(8),8) + ishft(dat(9),2) +         &
        iand(ishft(dat(10),-4),3)

   ng=ishft(iand(dat(10),15),12) + ishft(dat(11),6) + dat(12)

   if(ng.ge.32768) then
      call unpacktext(nc1,nc2,ng,msg)
      go to 100
   endif

   call unpackcall(nc1,c1,iv2,psfx)
   if(iv2.eq.0) then
 ! This is an "original JT65" message
      if(nc1.eq.NBASE+1) c1='CQ    '
      if(nc1.eq.NBASE+2) c1='QRZ   '
      nfreq=nc1-NBASE-3
      if(nfreq.ge.0 .and. nfreq.le.999) then
         write(c1,1002) nfreq
 1002    format('CQ ',i3.3)
         cqnnn=.true.
      endif
   endif

   call unpackcall(nc2,c2,junk1,junk2)
   call unpackgrid(ng,grid)

   if(iv2.gt.0) then
 ! This is a JT65v2 message
      do i=1,4
         if(ichar(psfx(i:i)).eq.0) psfx(i:i)=' '
      enddo

      n1=len_trim(psfx)
      n2=len_trim(c2)
      if(iv2.eq.1) msg='CQ '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.2) msg='QRZ '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.3) msg='DE '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.4) msg='CQ '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.5) msg='QRZ '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.6) msg='DE '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.7) then
         grid6=grid//'ma'
         call grid2k(grid6,k)
         if(k.ge.451 .and. k.le.900) then
            call getpfx2(k,c2)
            n2=len_trim(c2)
            msg='DE '//c2(:n2)
         else
            msg='DE '//c2(:n2)//' '//grid
         endif
      endif
      if(iv2.eq.8) msg=' '
      go to 100
   else

   endif

   grid6=grid//'ma'
   call grid2k(grid6,k)
   if(k.ge.1 .and. k.le.450)   call getpfx2(k,c1)
   if(k.ge.451 .and. k.le.900) call getpfx2(k,c2)

   i=index(c1,char(0))
   if(i.ge.3) c1=c1(1:i-1)//'            '
   i=index(c2,char(0))
   if(i.ge.3) c2=c2(1:i-1)//'            '

   msg='                      '
   j=0
   if(cqnnn) then
      msg=c1//'          '
      j=7                                  !### ??? ###
      go to 10
   endif

   do i=1,12
      j=j+1
      msg(j:j)=c1(i:i)
      if(c1(i:i).eq.' ') go to 10
   enddo
   j=j+1
   msg(j:j)=' '

 10 do i=1,12
      if(j.le.21) j=j+1
      msg(j:j)=c2(i:i)
      if(c2(i:i).eq.' ') go to 20
   enddo
   if(j.le.21) j=j+1
   msg(j:j)=' '

 20 if(k.eq.0) then
      do i=1,4
         if(j.le.21) j=j+1
         msg(j:j)=grid(i:i)
      enddo
      if(j.le.21) j=j+1
      msg(j:j)=' '
   endif

 100 continue
   if(msg(1:6).eq.'CQ9DX ') msg(3:3)=' '
   if(msg(1:2).eq.'E9' .and.                                          &
        msg(3:3).ge.'A' .and. msg(3:3).le.'Z' .and.                   &
        msg(4:4).ge.'A' .and. msg(4:4).le.'Z' .and.                   &
        msg(5:5).eq.' ') msg='CQ '//msg(3:)

   if(msg(1:5).eq.'CQ 00' .and. msg(6:6).ge.'0' .and.                 &
        msg(6:6).le.'9') msg='CQ '//msg(6:)

   return
 end subroutine unpackmsg

 subroutine packtext(msg,nc1,nc2,nc3)

   parameter (MASK28=2**28 - 1)
   character*22 msg
   character*42 c
   data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/

   nc1=0
   nc2=0
   nc3=0

   do i=1,5                                !First 5 characters in nc1
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 10
      enddo
      j=37
 10   j=j-1                                !Codes should start at zero
      nc1=42*nc1 + j
   enddo

   do i=6,10                               !Characters 6-10 in nc2
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 20
      enddo
      j=37
 20   j=j-1                                !Codes should start at zero
      nc2=42*nc2 + j
   enddo

   do i=11,13                              !Characters 11-13 in nc3
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 30
      enddo
      j=37
 30   j=j-1                                !Codes should start at zero
      nc3=42*nc3 + j
   enddo

 ! We now have used 17 bits in nc3.  Must move one each to nc1 and nc2.
   nc1=nc1+nc1
   if(iand(nc3,32768).ne.0) nc1=nc1+1
   nc2=nc2+nc2
   if(iand(nc3,65536).ne.0) nc2=nc2+1
   nc3=iand(nc3,32767)

   return
 end subroutine packtext

 subroutine unpacktext(nc1a,nc2a,nc3a,msg)

   character*22 msg
   character*44 c
   data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/

   nc1=nc1a
   nc2=nc2a
   nc3=iand(nc3a,32767)                      !Remove the "plain text" bit
   if(iand(nc1,1).ne.0) nc3=nc3+32768
   nc1=nc1/2
   if(iand(nc2,1).ne.0) nc3=nc3+65536
   nc2=nc2/2

   do i=5,1,-1
      j=mod(nc1,42)+1
      msg(i:i)=c(j:j)
      nc1=nc1/42
   enddo

   do i=10,6,-1
      j=mod(nc2,42)+1
      msg(i:i)=c(j:j)
      nc2=nc2/42
   enddo

   do i=13,11,-1
      j=mod(nc3,42)+1
      msg(i:i)=c(j:j)
      nc3=nc3/42
   enddo
   msg(14:22) = '         '

   return
 end subroutine unpacktext

 subroutine getpfx1(callsign,k,nv2)

   character*12 callsign0,callsign,lof,rof
   character*8 c
   character addpfx*8,tpfx*4,tsfx*3
   logical ispfx,issfx,invalid
   common/pfxcom/addpfx
   include 'pfx.f90'

   callsign0=callsign
   nv2=1
   iz=index(callsign,' ') - 1
   if(iz.lt.0) iz=12
   islash=index(callsign(1:iz),'/')
   k=0
 !  if(k.eq.0) go to 10     !Tnx to DL9RDZ for reminder:this was for tests only!
   c='   '
   if(islash.gt.0 .and. islash.le.(iz-4)) then
 ! Add-on prefix
      c=callsign(1:islash-1)
      callsign=callsign(islash+1:iz)
      do i=1,NZ
         if(pfx(i)(1:4).eq.c) then
            k=i
            nv2=2
            go to 10
         endif
      enddo
      if(addpfx.eq.c) then
         k=449
         nv2=2
         go to 10
      endif

   else if(islash.eq.(iz-1)) then
 ! Add-on suffix
      c=callsign(islash+1:iz)
      callsign=callsign(1:islash-1)
      do i=1,NZ2
         if(sfx(i).eq.c(1:1)) then
            k=400+i
            nv2=3
            go to 10
         endif
      enddo
   endif

 10 if(islash.ne.0 .and.k.eq.0) then
 ! Original JT65 would force this compound callsign to be treated as
 ! plain text.  In JT65v2, we will encode the prefix or suffix into nc1.
 ! The task here is to compute the proper value of k.
      lof=callsign0(:islash-1)
      rof=callsign0(islash+1:)
      llof=len_trim(lof)
      lrof=len_trim(rof)
      ispfx=(llof.gt.0 .and. llof.le.4)
      issfx=(lrof.gt.0 .and. lrof.le.3)
      invalid=.not.(ispfx.or.issfx)
      if(ispfx.and.issfx) then
         if(llof.lt.3) issfx=.false.
         if(lrof.lt.3) ispfx=.false.
         if(ispfx.and.issfx) then
            i=ichar(callsign0(islash-1:islash-1))
            if(i.ge.ichar('0') .and. i.le.ichar('9')) then
               issfx=.false.
            else
               ispfx=.false.
            endif
         endif
      endif

      if(invalid) then
         k=-1
      else
         if(ispfx) then
            tpfx=lof(1:4)
            k=nchar(tpfx(1:1))
            k=37*k + nchar(tpfx(2:2))
            k=37*k + nchar(tpfx(3:3))
            k=37*k + nchar(tpfx(4:4))
            nv2=4
            i=index(callsign0,'/')
            callsign=callsign0(:i-1)
            callsign=callsign0(i+1:)
         endif
         if(issfx) then
            tsfx=rof(1:3)
            k=nchar(tsfx(1:1))
            k=37*k + nchar(tsfx(2:2))
            k=37*k + nchar(tsfx(3:3))
            nv2=5
            i=index(callsign0,'/')
            callsign=callsign0(:i-1)
         endif
      endif
   endif

   return
 end subroutine getpfx1

 subroutine getpfx2(k0,callsign)

   character callsign*12
   include 'pfx.f90'
   character addpfx*8
   common/pfxcom/addpfx

   k=k0
   if(k.gt.450) k=k-450
   if(k.ge.1 .and. k.le.NZ) then
      iz=index(pfx(k),' ') - 1
      callsign=pfx(k)(1:iz)//'/'//callsign
   else if(k.ge.401 .and. k.le.400+NZ2) then
      iz=index(callsign,' ') - 1
      callsign=callsign(1:iz)//'/'//sfx(k-400)
   else if(k.eq.449) then
      iz=index(addpfx,' ') - 1
      if(iz.lt.1) iz=8
      callsign=addpfx(1:iz)//'/'//callsign
   endif

   return
 end subroutine getpfx2

 subroutine grid2k(grid,k)

   character*6 grid

   call grid2deg(grid,xlong,xlat)
   nlong=nint(xlong)
   nlat=nint(xlat)
   k=0
   if(nlat.ge.85) k=5*(nlong+179)/2 + nlat-84

   return
 end subroutine grid2k

 subroutine k2grid(k,grid)
   character grid*6

   nlong=2*mod((k-1)/5,90)-179
   if(k.gt.450) nlong=nlong+180
   nlat=mod(k-1,5)+ 85
   dlat=nlat
   dlong=nlong
   call deg2grid(dlong,dlat,grid)

   return
 end subroutine k2grid

 subroutine grid2n(grid,n)
   character*4 grid

   i1=ichar(grid(1:1))-ichar('A')
   i2=ichar(grid(3:3))-ichar('0')
   i=10*i1 + i2
   n=-i - 31

   return
 end subroutine grid2n

 subroutine n2grid(n,grid)
   character*4 grid

   if(n.gt.-31 .or. n.lt.-70) stop 'Error in n2grid'
   i=-(n+31)                           !NB: 0 <= i <= 39
   i1=i/10
   i2=mod(i,10)
   grid(1:1)=char(ichar('A')+i1)
   grid(2:2)='A'
   grid(3:3)=char(ichar('0')+i2)
   grid(4:4)='0'

   return
 end subroutine n2grid

 function nchar(c)

 ! Convert ascii number, letter, or space to 0-36 for callsign packing.

   character c*1

   n=0                                    !Silence compiler warning
   if(c.ge.'0' .and. c.le.'9') then
      n=ichar(c)-ichar('0')
   else if(c.ge.'A' .and. c.le.'Z') then
      n=ichar(c)-ichar('A') + 10
   else if(c.ge.'a' .and. c.le.'z') then
      n=ichar(c)-ichar('a') + 10
   else if(c.ge.' ') then
      n=36
   else
      Print*,'Invalid character in callsign ',c,' ',ichar(c)
      stop
   endif
   nchar=n

   return
 end function nchar

 subroutine pack50(n1,n2,dat)

   integer*1 dat(:),i1

   i1=iand(ishft(n1,-20),255)                !8 bits
   dat(1)=i1
   i1=iand(ishft(n1,-12),255)                 !8 bits
   dat(2)=i1
   i1=iand(ishft(n1, -4),255)                 !8 bits
   dat(3)=i1
   i1=16*iand(n1,15)+iand(ishft(n2,-18),15)   !4+4 bits
   dat(4)=i1
   i1=iand(ishft(n2,-10),255)                 !8 bits
   dat(5)=i1
   i1=iand(ishft(n2, -2),255)                 !8 bits
   dat(6)=i1
   i1=64*iand(n2,3)                           !2 bits
   dat(7)=i1
   dat(8)=0
   dat(9)=0
   dat(10)=0
   dat(11)=0

   return
 end subroutine pack50

subroutine packpfx(call1,n1,ng,nadd)

  character*12 call1,call0
  character*3 pfx
  logical text

  i1=index(call1,'/')
  if(call1(i1+2:i1+2).eq.' ') then
! Single-character add-on suffix (maybe also fourth suffix letter?)
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     nc=ichar(call1(i1+1:i1+1))
     if(nc.ge.48 .and. nc.le.57) then
        n=nc-48
     else if(nc.ge.65 .and. nc.le.90) then
        n=nc-65+10
     else
        n=38
     endif
     nadd=1
     ng=60000-32768+n
  else if(call1(i1+3:i1+3).eq.' ') then
! Two-character numerical suffix, /10 to /99
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     n=10*(ichar(call1(i1+1:i1+1))-48) + ichar(call1(i1+2:i1+2)) - 48
     nadd=1
     ng=60000 + 26 + n
  else
! Prefix of 1 to 3 characters
     pfx=call1(:i1-1)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     call0=call1(i1+1:)
     call packcall(call0,n1,text)

     ng=0
     do i=1,3
        nc=ichar(pfx(i:i))
        if(nc.ge.48 .and. nc.le.57) then
           n=nc-48
        else if(nc.ge.65 .and. nc.le.90) then
           n=nc-65+10
        else
           n=36
        endif
        ng=37*ng + n
     enddo
     nadd=0
     if(ng.ge.32768) then
        ng=ng-32768
        nadd=1
     endif
  endif

  return
end subroutine packpfx

end module packjt

subroutine smo(x,npts,y,nadd)

  real x(npts)
  real y(npts)

  nh=nadd/2
  do i=1+nh,npts-nh
     sum=0.
     do j=-nh,nh
        sum=sum + x(i+j)
     enddo
     y(i)=sum
  enddo
  x=y
  x(:nh)=0.
  x(npts-nh+1:)=0.

  return
end subroutine smo

! LDPC (128,90) code
parameter (KK=90)                     !Information bits (77 + CRC13)
parameter (ND=128)                    !Data symbols
parameter (NS=16)                     !Sync symbols (2x8)
parameter (NN=NS+ND)                  !Total channel symbols (144)
parameter (NSPS=160)                  !Samples per symbol at 12000 S/s
parameter (NZ=NSPS*NN)                !Samples in full 1.92 s waveform (23040)
parameter (NMAX=30000)                !Samples in iwave (2.5*12000)
parameter (NFFT1=400, NH1=NFFT1/2)    !Length of FFTs for symbol spectra
parameter (NSTEP=NSPS/4)              !Rough time-sync step size
parameter (NHSYM=NMAX/NSTEP-3)        !Number of symbol spectra (1/4-sym steps)
parameter (NDOWN=16)                  !Downsample factor

program jt9w

  parameter (NSMAX=6827,NZMAX=60*12000)
  real ss(184,NSMAX)
  real ref(NSMAX)
  integer*2 id2(NZMAX)
  character*12 arg
  character*22 decoded

  call getarg(1,arg)
  read(arg,*) iutc

  open(20,file='refspec.dat',status='old')
  do i=1,NSMAX
     read(20,*) j,freq,ref(i)
  enddo

  do ifile=1,999
     read(60,end=999) nutc,nfqso,ntol,ndepth,nmode,nsubmode,ss,id2
     if(nutc.ne.iutc) cycle
     ntol=100
     call decode9w(nutc,nfqso,ntol,nsubmode,ss,id2,sync,nsnr,xdt,freq,decoded)
     write(*,1100) nutc,nsnr,xdt1-1.0,nint(freq),decoded
1100 format(i4.4,i4,f5.1,i5,1x,'@',1x,a22)
     exit
  enddo

999 end program jt9w

subroutine sync8dvar(cd0,i0,ctwk,itwk,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)

! Compute sync power for a complex, downsampled FT8 signal.
  use ft8_mod1, only : csync,csynce,csyncsd,csyncsdcq,csynccq

  complex, intent(in) :: cd0(-800:4000),ctwk(32)
  complex csync1(0:18,32),csync2(32),z1,z2,z3,z4,zt1(0:6),zt2(0:6),zt3(0:6),zt4(0:7),zt5(0:18), &
          z11(224),z22(224),z33(224)
  real sync1(0:20)!,sync2(0:20)
  integer, intent(in) :: i0,ipass,iqso
  logical(1), intent(in) :: lcq,lcallsstd,lcqcand
  logical(1) lastsync

  sync=0.; sync1=0.; zt1=0.; zt2=0.; zt3=0.; z11=0.; z22=0.; z33=0.!; sync2=0.
  k=1
  do i=0,6 ! Sum over 7 Costas frequencies and three Costas arrays
    i1=i0+i*32; i2=i1+1152; i3=i1+2304 ! +36*32, +72*32
    csync2=csync(i,1:32)
    if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
    z11(k:k+31)=cd0(i1:i1+31)*conjg(csync2);  z22(k:k+31)=cd0(i2:i2+31)*conjg(csync2)
    z33(k:k+31)=cd0(i3:i3+31)*conjg(csync2)
    zt1(i)=sum(z11(k:k+31)); zt2(i)=sum(z22(k:k+31)); zt3(i)=sum(z33(k:k+31))
    k=k+32
  enddo
  if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then
    if(.not.lastsync) then
      do i=0,6
        sync1(i) = SQRT(real(zt1(i))**2 + aimag(zt1(i))**2)
        sync1(i+7) = SQRT(real(zt2(i))**2 + aimag(zt2(i))**2)
        sync1(i+14) = SQRT(real(zt3(i))**2 + aimag(zt3(i))**2)
      enddo
      sync=sum(sync1)
    else
      do i=0,6
        sync = sync + real(zt1(i))**2 + aimag(zt1(i))**2 + real(zt2(i))**2 + aimag(zt2(i))**2 + real(zt3(i))**2 + &
          aimag(zt3(i))**2
      enddo
    endif
  else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then
    if(.not.lastsync) then
      do i=0,6
        sync1(i) = real(zt1(i))**2 + aimag(zt1(i))**2
        sync1(i+7) = real(zt2(i))**2 + aimag(zt2(i))**2
        sync1(i+14) = real(zt3(i))**2 + aimag(zt3(i))**2
      enddo
      sync=sum(sync1)
    else
      do i=0,6
        sync = sync + real(zt1(i))**2 + aimag(zt1(i))**2 + real(zt2(i))**2 + aimag(zt2(i))**2 + real(zt3(i))**2 + &
          aimag(zt3(i))**2
      enddo
    endif
  else ! if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8)  then
    do i=0,6
      if(i.lt.6) then
        z1=(zt1(i)+zt1(i+1))/2; z2=(zt2(i)+zt2(i+1))/2; z3=(zt3(i)+zt3(i+1))/2 ! use i=5 z values for i=6
      endif
      if(.not.lastsync) then
        sync = sync + abs(real(z1)) + abs(aimag(z1)) + abs(real(z2)) + abs(aimag(z2)) + abs(real(z3)) + abs(aimag(z3))
      else
        sync = sync + real(z1)**2 + aimag(z1)**2 + real(z2)**2 + aimag(z2)**2 + real(z3)**2 + aimag(z3)**2
      endif
    enddo
  endif

  if(itwk.eq.1 .and. lcqcand .and. iqso.eq.1) then
    zt4=0.
    do i=0,7
      csync2=csynccq(i,1:32); csync2=ctwk*csync2      !Tweak the frequency
      i4=i0+(i+7)*32; zt4(i)=sum(cd0(i4:i4+31)*conjg(csync2))
    enddo
    do i=0,7
      if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8)  then
        if(i.lt.7) z4=(zt4(i)+zt4(i+1))/2 ! use i=6 z4 value for i=7
      else
       z4=zt4(i)
      endif
      if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then; sync = sync + SQRT(real(z4)**2 + aimag(z4)**2)
      else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then; sync = sync + real(z4)**2 + aimag(z4)**2
      else if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8) then; sync = sync + abs(real(z4)) + abs(aimag(z4))
      endif
    enddo
  endif

  if(.not.lastsync) then
    if(iqso.gt.1 .and. iqso.lt.4 .and. lcallsstd) csync1=csynce; if(iqso.eq.4 .and. .not.lcq) csync1=csyncsd

    if((iqso.eq.4 .and. .not.lcq) .or. ((iqso.eq.2 .or. iqso.eq.3) .and. lcallsstd)) then
      zt5=0.
      do i=0,18
        csync2=csync1(i,1:32)
        if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
        i4=i0+(i+7)*32; zt5(i)=sum(cd0(i4:i4+31)*conjg(csync2))
      enddo
      do i=0,18
        if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7)  then
          if(i.lt.18) z4=(zt5(i)+zt5(i+1))/2 ! use i=17 z4 value for i=18
        else
         z4=zt5(i)
        endif
        if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then; sync = sync + SQRT(real(z4)**2 + aimag(z4)**2)
        else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then; sync = sync + real(z4)**2 + aimag(z4)**2
        else if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8) then; sync = sync + abs(real(z4)) + abs(aimag(z4))
        endif
      enddo
    endif

    if(iqso.eq.4 .and. lcq) then
      do i=0,57
        csync2=csyncsdcq(i,1:32)
        if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
        z4=0.; if(i.lt.29) then; k=i+7; else; k=i+14; endif
        i4=i0+k*32; z4=sum(cd0(i4:i4+31)*conjg(csync2))
        if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then; sync = sync + SQRT(real(z4)**2 + aimag(z4)**2)
          else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then; sync = sync + real(z4)**2 + aimag(z4)**2
          else if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8) then; sync = sync + abs(real(z4)) + abs(aimag(z4))
        endif
      enddo
    endif
  endif

  return
end subroutine sync8dvar

subroutine ccf65(ss,nhsym,ssmax,sync1,ipol1,jpz,dt1,flipk,      &
     syncshort,snr2,ipol2,dt2)

  parameter (NFFT=512,NH=NFFT/2)
  real ss(4,322)                   !Input: half-symbol powers, 4 pol'ns
  real s(NFFT)                     !CCF = ss*pr
  complex cs(0:NH)                 !Complex FT of s
  real s2(NFFT)                    !CCF = ss*pr2
  complex cs2(0:NH)                !Complex FT of s2
  real pr(NFFT)                    !JT65 pseudo-random sync pattern
  complex cpr(0:NH)                !Complex FT of pr
  real pr2(NFFT)                   !JT65 shorthand pattern
  complex cpr2(0:NH)               !Complex FT of pr2
  real tmp1(322)
  real ccf(-11:54,4)
  logical first
  integer npr(126)
  data first/.true./
  equivalence (s,cs),(pr,cpr),(s2,cs2),(pr2,cpr2)
  save

! The JT65 pseudo-random sync pattern:
  data npr/                                        &
      1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,     &
      0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,     &
      0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,     &
      0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,     &
      1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,     &
      0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,     &
      1,1,1,1,1,1/

  if(first) then
! Initialize pr, pr2; compute cpr, cpr2.
     fac=1.0/NFFT
     do i=1,NFFT
        pr(i)=0.
        pr2(i)=0.
        k=2*mod((i-1)/8,2)-1
        if(i.le.NH) pr2(i)=fac*k
     enddo
     do i=1,126
        j=2*i
        pr(j)=fac*(2*npr(i)-1)
! Not sure why, but it works significantly better without the following line:
!        pr(j-1)=pr(j)
     enddo
     call four2a(cpr,NFFT,1,-1,0)
     call four2a(cpr2,NFFT,1,-1,0)
     first=.false.
  endif
  syncshort=0.
  snr2=0.

! Look for JT65 sync pattern and shorthand square-wave pattern.
  ccfbest=0.
  ccfbest2=0.
  ipol1=1
  ipol2=1
  do ip=1,jpz                                  !Do jpz polarizations
     do i=1,nhsym-1
!        s(i)=ss(ip,i)+ss(ip,i+1)
        s(i)=min(ssmax,ss(ip,i)+ss(ip,i+1))
     enddo
     call pctile(s,nhsym-1,50,base)
     s(1:nhsym-1)=s(1:nhsym-1)-base
     s(nhsym:NFFT)=0.
     call four2a(cs,NFFT,1,-1,0)                !Real-to-complex FFT
     do i=0,NH
        cs2(i)=cs(i)*conjg(cpr2(i))            !Mult by complex FFT of pr2
        cs(i)=cs(i)*conjg(cpr(i))              !Mult by complex FFT of pr
     enddo
     call four2a(cs,NFFT,1,1,-1)               !Complex-to-real inv-FFT
     call four2a(cs2,NFFT,1,1,-1)              !Complex-to-real inv-FFT

     do lag=-11,54                             !Check for best JT65 sync
        j=lag
        if(j.lt.1) j=j+NFFT
        ccf(lag,ip)=s(j)
        if(abs(ccf(lag,ip)).gt.ccfbest) then
           ccfbest=abs(ccf(lag,ip))
           lagpk=lag
           ipol1=ip
           flipk=1.0
           if(ccf(lag,ip).lt.0.0) flipk=-1.0
        endif
     enddo
     
!###  Not sure why this is ever true???  
     if(sum(ccf).eq.0.0) return
!###
     do lag=-11,54                             !Check for best shorthand
        ccf2=s2(lag+28)
        if(ccf2.gt.ccfbest2) then
           ccfbest2=ccf2
           lagpk2=lag
           ipol2=ip
        endif
     enddo
     
  enddo

! Find rms level on baseline of "ccfblue", for normalization.
  sumccf=0.
  do lag=-11,54
     if(abs(lag-lagpk).gt.1) sumccf=sumccf + ccf(lag,ipol1)
  enddo
  base=sumccf/50.0
  sq=0.
  do lag=-11,54
     if(abs(lag-lagpk).gt.1) sq=sq + (ccf(lag,ipol1)-base)**2
  enddo
  rms=sqrt(sq/49.0)
  sync1=-4.0
  if(rms.gt.0.0) sync1=ccfbest/rms - 4.0
  dt1=lagpk*(2048.0/11025.0) - 2.5

! Find base level for normalizing snr2.
  do i=1,nhsym
     tmp1(i)=ss(ipol2,i)
  enddo
  call pctile(tmp1,nhsym,40,base)
  snr2=0.01
  if(base.gt.0.0) snr2=0.398107*ccfbest2/base  !### empirical
  syncshort=0.5*ccfbest2/rms - 4.0             !### better normalizer than rms?
  dt2=2.5 + lagpk2*(2048.0/11025.0)

  return
end subroutine ccf65

subroutine tweak1(ca,jz,f0,cb)

! Shift frequency of analytic signal ca, with output to cb

  complex ca(jz),cb(jz)
  real*8 twopi
  complex*16 w,wstep
  complex w4
  data twopi/0.d0/
  save twopi

  if(twopi.eq.0.d0) twopi=8.d0*atan(1.d0)
  w=1.d0
  dphi=twopi*f0/12000.d0
  wstep=cmplx(cos(dphi),sin(dphi))
  do i=1,jz
     w=w*wstep
     w4=w
     cb(i)=w4*ca(i)
  enddo

  return
end subroutine tweak1

subroutine grayline(nyear,month,nday,uth,mygrid,nduration,isun)

  character*6 mygrid
  real LST
  real lat,lon

  call grid2deg(MyGrid,elon,lat)
  lon=-elon

  uth0=uth-0.5*nduration/60.0
  uth1=uth+0.5*nduration/60.0

  call sun(nyear,month,nday,uth0,lon,lat,RASun,DecSun,LST,        &
       AzSun,ElSun0,mjd,day)
  call sun(nyear,month,nday,uth1,lon,lat,RASun,DecSun,LST,        &
       AzSun,ElSun1,mjd,day)

  elchk=-0.8333
  isun=-1
  if(elsun0.lt.elchk .and. elsun1.ge.elchk) then
     isun=0
  else if(elsun0.gt.elchk .and. elsun1.le.elchk) then
     isun=2
  else if(elsun1.gt.elchk) then
     isun=1
  else
     isun=3
  endif

  return
end subroutine grayline

subroutine afc9(c3a,npts,fsample,a,syncpk)

  parameter (NZ2=1512)
  complex c3a(0:NZ2-1)
  complex c3(0:NZ2-1)
  real a(3),deltaa(3)

  a(1)=0.                                   !f0
  a(2)=0.                                   !f1
  a(3)=0.                                   !f2
  deltaa(1)=1.736
  deltaa(2)=1.736
  deltaa(3)=1.0
  nterms=3

! Start the iteration
  chisqr=0.
  chisqr0=1.e6
  c3=c3a
  a3=a(3)
  do iter=1,4
     do j=1,nterms
        if(a(3).ne.a3) call shft(c3a,a(3),a3,c3)
        chisq1=fchisq(c3,npts,fsample,a)
        fn=0.
        delta=deltaa(j)
10      a(j)=a(j)+delta
        if(a(3).ne.a3) call shft(c3a,a(3),a3,c3)
        chisq2=fchisq(c3,npts,fsample,a)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      fn=fn+1.0
        a(j)=a(j)+delta
        if(a(3).ne.a3) call shft(c3a,a(3),a3,c3)
        chisq3=fchisq(c3,npts,fsample,a)
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
        if(j.lt.3) deltaa(j)=deltaa(j)*fn/3.
!        write(*,4000) iter,j,a,-chisq2
!4000    format(i1,i2,3f10.4,f11.3)
     enddo
     if(a(3).ne.a3) call shft(c3a,a(3),a3,c3)
     chisqr=fchisq(c3,npts,fsample,a)
!     write(*,4000) 0,0,a,-chisqr
     if(chisqr/chisqr0.gt.0.99) exit
     chisqr0=chisqr
  enddo

  syncpk=-chisqr
  c3a=c3
!  write(*,4001) a,syncpk
!4001 format(3x,3f10.4,f11.3)

  return
end subroutine afc9

subroutine shft(c3a,a3a,a3,c3)
  complex c3a(0:1359)
  complex  c3(0:1359)

  a3=a3a
  n=nint(a3)
  c3=cshift(c3a,n)
  if(n.gt.0) c3(1360-n:)=0.0
  if(n.lt.0) c3(:n-1)=0.0

  return
end subroutine shft

subroutine flat65(ss,nhsym,maxhsym,nsz,ref)

  real stmp(nsz)
  real ss(maxhsym,nsz)
  real ref(nsz)

  npct=28                                       !Somewhat arbitrary
  do i=1,nsz
     call pctile(ss(1,i),nhsym,npct,stmp(i))
  enddo

  nsmo=33
  ia=nsmo/2 + 1
  ib=nsz - nsmo/2 - 1
  do i=ia,ib
     call pctile(stmp(i-nsmo/2),nsmo,npct,ref(i))
  enddo
  ref(:ia-1)=ref(ia)
  ref(ib+1:)=ref(ib)
  ref=4.0*ref

  return
end subroutine flat65

      

subroutine q65b(nutc,nqd,nxant,fcenter,nfcal,nfsample,ikhz,mousedf,ntol,xpol, &
     mycall0,mygrid,hiscall0,hisgrid,mode_q65,f0,fqso,newdat,nagain,          &
     max_drift,nhsym,ndop00,idec)

! This routine provides an interface between MAP65 and the Q65 decoder
! in WSJT-X.  All arguments are input data obtained from the MAP65 GUI.
! Raw Rx data are available as the 96 kHz complex spectrum ca(MAXFFT1)
! in common/cacb.  If xpol is true, we also have cb(MAXFFT1) for the
! orthogonal polarization.  Decoded messages are sent back to the GUI
! on stdout.

!  use wavhdr
  use q65_decode
  use wideband_sync
  use timer_module, only: timer

  parameter (MAXFFT1=5376000)              !56*96000
  parameter (MAXFFT2=336000)               !56*6000 (downsampled by 1/16)
  parameter (NMAX=60*12000)
  parameter (RAD=57.2957795)
!  type(hdr) h                            !Header for the .wav file
  integer*2 iwave(60*12000)
  complex ca(MAXFFT1),cb(MAXFFT1)          !FFTs of raw x,y data
  complex cx(0:MAXFFT2-1),cy(0:MAXFFT2-1),cz(0:MAXFFT2)
  logical xpol,ldecoded
  integer ipk1(1)
  real*8 fcenter,freq0,freq1
  character*12 mycall0,hiscall0
  character*12 mycall,hiscall
  character*6 mygrid,hisgrid
  character*4 grid4
  character*28 msg00
  character*80 line
  character*80 wsjtx_dir
  character*1 cp,cmode*2
  common/cacb/ca,cb
  common/early/nhsym1,nhsym2,ldecoded(32768)
  common/decodes/ndecodes
  data nutc00/-1/,msg00/'                            '/
  save

  if(newdat.eq.1) nutc00=-1
  open(9,file='wsjtx_dir.txt',status='old')
  read(9,'(a)') wsjtx_dir                      !Establish the working directory
  close(9)

  if(mycall0(1:1).ne.' ') mycall=mycall0
  if(hiscall0(1:1).ne.' ') hiscall=hiscall0
  if(hisgrid(1:4).ne.'    ') grid4=hisgrid(1:4)

! Find best frequency and ipol from sync_dat, the "orange sync curve".
  df3=96000.0/32768.0
  ifreq=nint((1000.0*f0)/df3)
  ia=nint(ifreq-ntol/df3)
  ib=nint(ifreq+ntol/df3)
  ipk1=maxloc(sync(ia:ib)%ccfmax)
  ipk=ia+ipk1(1)-1
  if(ldecoded(ipk)) go to 900
  snr1=sync(ipk)%ccfmax
  ipol=1
  if(xpol) ipol=sync(ipk)%ipol

  nfft1=MAXFFT1
  nfft2=MAXFFT2
  df=96000.0/NFFT1
  if(nfsample.eq.95238) then
     nfft1=5120000
     nfft2=322560
     df=96000.0/nfft1
  endif
  nh=nfft2/2
  f_mouse=1000.0*(fqso+48.0) + mousedf
  f_ipk=ipk*df3
  k0=nint((ipk*df3-1000.0)/df)
  if(nagain.eq.1) k0=nint((f_mouse-1000.0)/df)

  if(k0.lt.nh .or. k0.gt.MAXFFT1-nfft2+1) go to 900
  if(snr1.lt.1.5) go to 900                      !### Threshold needs work? ###

  fac=1.0/nfft2
  cx(0:nfft2-1)=ca(k0:k0+nfft2-1)
  cx=fac*cx
  if(xpol) then
     cy(0:nfft2-1)=cb(k0:k0+nfft2-1)
     cy=fac*cy
  endif

! Here cx and cy (if xpol) are frequency-domain data around the selected
! QSO frequency, taken from the full-length FFT computed in filbig().
! Values for fsample, nfft1, nfft2, df, and the downsampled data rate
! are as follows:

!  fSample  nfft1       df        nfft2  fDownSampled
!    (Hz)              (Hz)                 (Hz)
!----------------------------------------------------
!   96000  5376000  0.017857143  336000   6000.000
!   95238  5120000  0.018601172  322560   5999.994

  poldeg=0.
  if(xpol) then
     poldeg=sync(ipk)%pol
     cz(0:MAXFFT2-1)=cos(poldeg/RAD)*cx + sin(poldeg/RAD)*cy
  else
     cz(0:MAXFFT2-1)=cx
  endif

  cz(MAXFFT2)=0.
! Roll off below 500 Hz and above 2500 Hz.
  ja=nint(500.0/df)
  jb=nint(2500.0/df)
  do i=0,ja
     r=0.5*(1.0+cos(i*3.14159/ja))
     cz(ja-i)=r*cz(ja-i)
     cz(jb+i)=r*cz(jb+i)
  enddo
 cz(ja+jb+1:)=0.

!Transform to time domain (real), fsample=12000 Hz
  call four2a(cz,2*nfft2,1,1,-1)
  do i=0,nfft2-1
     j=nfft2-1-i
     iwave(2*i+2)=nint(real(cz(j)))       !Note the reversed order!
     iwave(2*i+1)=nint(aimag(cz(j)))
  enddo
  iwave(2*nfft2+1:)=0

!  open(30,file='000000_0001.wav',status='unknown',access='stream')
!  h=default_header(12000,NMAX)
!  write(30) h,iwave
!  close(30)

  nsubmode=mode_q65-1
  nfa=990                   !Tight limits around ipk for the wideband decode
  nfb=1010
  if(nagain.eq.1) then      !For nagain=1, use limits of +/- ntol
     nfa=max(100,1000-ntol)
     nfb=min(2500,1000+ntol)
  endif
  nsnr0=-99             !Default snr for no decode
  ndpth=3

! NB: Frequency of ipk is now shifted to 1000 Hz.
  call map65_mmdec(nutc,iwave,nqd,60,nsubmode,nfa,nfb,1000,ntol,     &
       newdat,nagain,max_drift,ndepth,mycall,hiscall0,hisgrid)

  MHz=fcenter
  freq0=MHz + 0.001d0*ikhz

  if(nsnr0.gt.-99) then
     ldecoded(ipk)=.true.
     nq65df=nint(1000*(0.001*k0*df+nkhz_center-48.0+1.000-1.27046-ikhz))-nfcal
     nq65df=nq65df + nfreq0 - 1000
     npol=nint(poldeg)
     if(nxant.ne.0) then
        npol=npol-45
        if(npol.lt.0) npol=npol+180
     endif
     call txpol(xpol,msg0(1:22),mygrid,npol,nxant,ntxpol,cp)
     ikhz1=ikhz
     ndf=nq65df
     if(ndf.gt.500) ikhz1=ikhz + (nq65df+500)/1000
     if(ndf.lt.-500) ikhz1=ikhz + (nq65df-500)/1000
     ndf=nq65df - 1000*(ikhz1-ikhz)
     if(nqd.eq.1 .and. abs(nq65df-mousedf).lt.ntol) then
        write(line,1020) ikhz1,ndf,npol,nutc,xdt0,nsnr0,msg0(1:27),cq0,  &
             ntxpol,cp
1020    format('!',i3.3,i5,i4,i6.4,f5.1,i5,' : ',a27,a3,i4,1x,a1)
        write(*,1100) trim(line)
1100    format(a)
     endif

! Write to lu 26, for Messages and Band Map windows
     cmode=': '
     cmode(2:2)=char(ichar('A') + mode_q65-1)
     freq1=freq0 + 0.001d0*(ikhz1-ikhz)
     write(26,1014) freq1,ndf,0,0,0,xdt0,npol,0,nsnr0,nutc,msg0(1:22),   &
          ':',cp,cmode
1014 format(f8.3,i5,3i3,f5.1,i4,i3,i4,i5.4,4x,a22,1x,2a1,2x,a2)

! Suppress writing duplicates (same time, decoded message, and frequency)
! to map65_rx.log
     if(nutc.ne.nutc00 .or. msg0(1:28).ne.msg00 .or. freq1.ne.freq1_00) then
! Write to file map65_rx.log:
        ndecodes=ndecodes+1
        write(21,1110)  freq1,ndf,xdt0,npol,nsnr0,nutc,msg0(1:28),   &
             cmode(2:2),cq0
1110    format(f8.3,i5,f5.1,2i4,i5.4,2x,a28,': ',a1,2x,a3)
        nutc00=nutc
        msg00=msg0(1:28)
        freq1_00=freq1
        frx=0.001*k0*df+nkhz_center-48.0+1.0 - 0.001*nfcal
        fsked=frx - 0.001*ndop00/2.0 - 1.5
        write(12,1120) nutc,fsked,xdt0,nsnr0,trim(msg0)
1120    format(i4.4,f9.3,f7.2,i5,2x,a,i6)
     endif
  endif

900 close(13)
  close(17)
  call flush(6)
  idec=-1
  read(cq0(2:2),*) idec

  return
end subroutine q65b

subroutine genft8(msg,i3,n3,msgsent,msgbits,itone)

! Encode an FT8 message, producing array itone().
  
  use packjt77
  include 'ft8_params.f90'
  character msg*37,msgsent*37
  character*77 c77
  integer*1 msgbits(77),codeword(174)
  integer itone(79)
  integer icos7(0:6)
  integer graymap(0:7)
  logical unpk77_success
  data icos7/3,1,4,0,6,5,2/                   !Costas 7x7 tone pattern
  data graymap/0,1,3,2,5,6,4,7/

  i3=-1
  n3=-1
  call pack77(msg,i3,n3,c77)
  call unpack77(c77,0,msgsent,unpk77_success)
  read(c77,'(77i1)',err=1) msgbits
  if(unpk77_success) go to 2
1 msgbits=0
  itone=0
  msgsent='*** bad message ***                  '
  go to 900

entry get_ft8_tones_from_77bits(msgbits,itone) 

2  call encode174_91(msgbits,codeword)      !Encode the test message

! Message structure: S7 D29 S7 D29 S7
  itone(1:7)=icos7
  itone(36+1:36+7)=icos7
  itone(NN-6:NN)=icos7
  k=7
  do j=1,ND
     i=3*j -2
     k=k+1
     if(j.eq.30) k=k+7
     indx=codeword(i)*4 + codeword(i+1)*2 + codeword(i+2)
     itone(k)=graymap(indx)
  enddo

900 return
end subroutine genft8

subroutine interleave4(id,ndir)
  integer*1 id(0:205),itmp(0:205)
  integer j0(0:205)
  logical first
  data first/.true./
  save first,j0

  if(first) then
     k=-1
     do i=0,255
        m=i
        n=iand(m,1)
        n=2*n + iand(m/2,1)
        n=2*n + iand(m/4,1)
        n=2*n + iand(m/8,1)
        n=2*n + iand(m/16,1)
        n=2*n + iand(m/32,1)
        n=2*n + iand(m/64,1)
        n=2*n + iand(m/128,1)
        if(n.le.205) then
           k=k+1
           j0(k)=n
        endif
     enddo
     first=.false.
  endif

  if(ndir.eq.1) then
     do i=0,205
        itmp(j0(i))=id(i)
     enddo
  else
     do i=0,205
        itmp(i)=id(j0(i))
     enddo
  endif

  do i=0,205
     id(i)=itmp(i)
  enddo

  return
end subroutine interleave4

program jt65sim

! Generate simulated JT65 data for testing WSJT-X

  use wavhdr
  use packjt
  use options
  parameter (NMAX=54*12000)              ! = 648,000 @12kHz
  parameter (NFFT=10*65536,NH=NFFT/2)
  type(hdr) h                            !Header for .wav file
  integer*2 iwave(NMAX)                  !Generated waveform
  integer*4 itone(126)                   !Channel symbols (values 0-65)
  integer dgen(12)                       !Twelve 6-bit data symbols
  integer sent(63)                       !RS(63,12) codeword
  real*4 xnoise(NMAX)                    !Generated random noise
  real*4 dat(NMAX)                       !Generated real data
  complex cdat(NMAX)                     !Generated complex waveform
  complex cspread(0:NFFT-1)              !Complex amplitude for Rayleigh fading
  complex z
  real*8 f0,dt,twopi,phi,dphi,baud,fsample,freq,sps
  character msg*22,fname*11,csubmode*1,c,optarg*500,numbuf*32
!  character call1*5,call2*5
  logical :: display_help=.false.,seed_prngs=.true.
  type (option) :: long_options(13) = [ &
    option ('help',.false.,'h','Display this help message',''),                                &
    option ('sub-mode',.true.,'m','sub mode, default MODE=A','MODE'),                          &
    option ('num-sigs',.true.,'n','number of signals per file, default SIGNALS=10','SIGNALS'), &
    option ('f0',.true.,'F','base frequency offset, default F0=1500.0','F0'), &
    option ('doppler-spread',.true.,'d','Doppler spread, default SPREAD=0.0','SPREAD'),        &
    option ('drift per min',.true.,'D','Frequency drift (Hz/min), default DRIFT=0.0','DRIFT'),        &
    option ('time-offset',.true.,'t','Time delta, default SECONDS=0.0','SECONDS'),             &
    option ('num-files',.true.,'f','Number of files to generate, default FILES=1','FILES'),    &
    option ('no-prng-seed',.false.,'p','Do not seed PRNGs (use for reproducible tests)',''),   &
    option ('strength',.true.,'s','S/N in dB (2500Hz reference b/w), default SNR=0','SNR'),    &
    option ('11025',.false.,'S','Generate at 11025Hz sample rate, default 12000Hz',''),        &
    option ('gain-offset',.true.,'G','Gain offset in dB, default GAIN=0dB','GAIN'),            &
    option ('message',.true.,'M','Message text','Message') ]

  integer nprc(126)                                      !Sync pattern
  data nprc/1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,  &
            0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,  &
            0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,  &
            0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,  &
            1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,  &
            0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,  &
            1,1,1,1,1,1/

! Default parameters:
  csubmode='A'
  mode65=1
  nsigs=10
  bf0=1500.
  fspread=0.
  drift=0.
  xdt=0.
  snrdb=0.
  nfiles=1
  nsample_rate=12000
  gain_offset=0.
  msg="K1ABC W9XYZ EN37"

  do
     call getopt('hm:n:F:d:D:t:f:ps:SG:M:',long_options,c,optarg,narglen,nstat,noffset,nremain,.true.)
     if( nstat .ne. 0 ) then
        exit
     end if
     select case (c)
     case ('h')
        display_help = .true.
     case ('m')
        read (optarg(:narglen), *) csubmode
        if(csubmode.eq.'A') mode65=1
        if(csubmode.eq.'B') mode65=2
        if(csubmode.eq.'C') mode65=4
     case ('n')
        read (optarg(:narglen), *,err=10) nsigs
     case ('F')
        read (optarg(:narglen), *,err=10) bf0
     case ('d')
        read (optarg(:narglen), *,err=10) fspread
     case ('D')
        read (optarg(:narglen), *,err=10) drift 
     case ('t')
        read (optarg(:narglen), *) numbuf
        if (numbuf(1:1) == '\') then !'\'
           read (numbuf(2:), *,err=10) xdt
        else
           read (numbuf, *,err=10) xdt
        end if
     case ('f')
        read (optarg(:narglen), *,err=10) nfiles
     case ('p')
        seed_prngs=.false.
     case ('s')
        read (optarg(:narglen), *) numbuf
        if (numbuf(1:1) == '\') then !'\'
           read (numbuf(2:), *,err=10) snrdb
        else
           read (numbuf, *,err=10) snrdb
        end if
     case ('S')
        nsample_rate=11025
     case ('G')
        read (optarg(:narglen), *) numbuf
        if (numbuf(1:1) == '\') then !'\'
           read (numbuf(2:), *, err=10) gain_offset
        else
           read (numbuf, *, err=10) gain_offset
        end if
     case ('M')
        read (optarg(:narglen), '(A)',err=10) msg
     end select
     cycle
10   display_help=.true.
     print *, 'Optional argument format error for option -', c
  end do

  if(display_help .or. nstat.lt.0 .or. nremain.ge.1) then
     print *, ''
     print *, 'Usage: jt65sim [OPTIONS]'
     print *, ''
     print *, '       Generate one or more simulated JT65 signals in .WAV file(s)'
     print *, ''
     print *, 'Example: jt65sim -m B -n 10 -d 0.2 -s \\-24.5 -t 0.0 -f 4'
     print *, ''
     print *, 'OPTIONS: NB Use \ (\\ on *nix shells) to escape -ve arguments'
     print *, ''
     do i = 1, size (long_options)
       call long_options(i) % print (6)
     end do
     go to 999
  endif

  if (seed_prngs) then
     call init_random_seed()    ! seed Fortran RANDOM_NUMBER generator
     call sgran()               ! see C rand generator (used in gran)
  end if

  rms=100. * 10. ** (gain_offset / 20.)

  fsample=nsample_rate               !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  npts=54*nsample_rate               !Total samples in .wav file
  baud=11025.d0/4096.d0              !Keying rate
  sps=real(nsample_rate)/baud        !Samples per symbol, at fsample=NSAMPLE_RATE Hz
  nsym=126                           !Number of channel symbols
  h=default_header(nsample_rate,npts)
  dfsig=2000.0/nsigs                 !Freq spacing between sigs in file (Hz)

  do ifile=1,nfiles                  !Loop over requested number of files
     write(fname,1002) ifile         !Output filename
1002 format('000000_',i4.4)
     open(10,file=fname//'.wav',access='stream',status='unknown')

     xnoise=0.
     cdat=0.
     if(snrdb.lt.90) then
        do i=1,npts
           xnoise(i)=gran()          !Generate gaussian noise
        enddo
     endif

     do isig=1,nsigs                        !Generate requested number of sigs
        if(mod(nsigs,2).eq.0) f0=bf0 + dfsig*(isig-0.5-nsigs/2)
        if(mod(nsigs,2).eq.1) f0=bf0 + dfsig*(isig-(nsigs+1)/2)
        xsnr=snrdb
        if(snrdb.eq.0.0) xsnr=-19 - isig
        if(csubmode.eq.'B' .and. snrdb.eq.0.0) xsnr=-21 - isig
        if(csubmode.eq.'C' .and. snrdb.eq.0.0) xsnr=-21 - isig

        call packmsg(msg,dgen,itype)        !Pack message into 12 six-bit bytes
        call rs_encode(dgen,sent)           !Encode using RS(63,12)
        call interleave63(sent,1)           !Interleave channel symbols
        call graycode65(sent,63,1)          !Apply Gray code

        nprc_test=0
        i1=len(trim(msg))
        if(i1.gt.10) then
           if(msg(i1-3:i1).eq.' OOO') nprc_test=1
        endif
        k=0
        do j=1,nsym                         !Insert sync and data into itone()
           if(nprc(j).eq.nprc_test) then
              k=k+1
              itone(j)=sent(k)+2
           else
              itone(j)=0
           endif
        enddo

        if(len(trim(msg)).eq.2.or.len(trim(msg)).eq.3) then
          nshorthand=0
          if(msg(1:2).eq.'RO') nshorthand=2
          if(msg(1:3).eq.'RRR') nshorthand=3
          if(msg(1:2).eq.'73') nshorthand=4
          if(nshorthand.gt.0) then
            ntoggle=0
            do i=1,nsym,4
              itone(i)=ntoggle*10*nshorthand
              if(i+1.le.126) itone(i+1)=ntoggle*10*nshorthand
              if(i+2.le.126) itone(i+2)=ntoggle*10*nshorthand
              if(i+3.le.126) itone(i+3)=ntoggle*10*nshorthand
              ntoggle=mod(ntoggle+1,2)
            enddo
          endif
        endif

        bandwidth_ratio=2500.0/(fsample/2.0)
        sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*xsnr)
        if(xsnr.gt.90.0) sig=1.0
        write(*,1020) ifile,isig,f0,csubmode,xsnr,xdt,fspread,msg
1020    format(i4,i4,f10.3,2x,a1,2x,f5.1,f6.2,f5.1,1x,a22)

        phi=0.d0
        dphi=0.d0
        k=nsample_rate + xdt*nsample_rate     !Start audio at t = xdt + 1.0 s
        isym0=-99
        do i=1,npts                         !Add this signal into cdat()
           isym=floor(i/sps)+1
           if(isym.gt.nsym) exit
           freq=f0 + (drift/60.0)*(i-npts/2)*dt + itone(isym)*baud*mode65
           dphi=twopi*freq*dt
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=cmplx(cos(xphi),sin(xphi))
           k=k+1
           if(k.ge.1) cdat(k)=cdat(k) + sig*z
        enddo
     enddo

     if(fspread.ne.0) then                  !Apply specified Doppler spread
        df=real(nsample_rate)/nfft
        twopi=8*atan(1.0)
        cspread(0)=1.0
        cspread(NH)=0.

! The following options were added 3/15/2016 to make the half-power tone 
! widths equal to the requested Doppler spread.  (Previously we effectively 
! used b=1.0 and Gaussian shape, which made the tones 1.665 times wider.)
!        b=2.0*sqrt(log(2.0))                     !Gaussian (before 3/15/2016)
!        b=2.0                                    !Lorenzian 3/15 - 3/27
        b=6.0                                     !Lorenzian 3/28 onward

        do i=1,NH
           f=i*df
           x=b*f/fspread
           z=0.
           a=0.
           if(x.lt.3.0) then                          !Cutoff beyond x=3
!              a=sqrt(exp(-x*x))                      !Gaussian
              a=sqrt(1.111/(1.0+x*x)-0.1)             !Lorentzian
              call random_number(r1)
              phi1=twopi*r1
              z=a*cmplx(cos(phi1),sin(phi1))
           endif
           cspread(i)=z
           z=0.
           if(x.lt.50.0) then
              call random_number(r2)
              phi2=twopi*r2
              z=a*cmplx(cos(phi2),sin(phi2))
           endif
           cspread(NFFT-i)=z
        enddo

        do i=0,NFFT-1
           f=i*df
           if(i.gt.NH) f=(i-nfft)*df
           s=real(cspread(i))**2 + aimag(cspread(i))**2
!          write(13,3000) i,f,s,cspread(i)
!3000      format(i5,f10.3,3f12.6)
        enddo
!        s=real(cspread(0))**2 + aimag(cspread(0))**2
!        write(13,3000) 1024,0.0,s,cspread(0)

        call four2a(cspread,NFFT,1,1,1)             !Transform to time domain

        sum=0.
        do i=0,NFFT-1
           p=real(cspread(i))**2 + aimag(cspread(i))**2
           sum=sum+p
        enddo
        avep=sum/NFFT
        fac=sqrt(1.0/avep)
        cspread=fac*cspread                   !Normalize to constant avg power
        cdat(1:npts)=cspread(1:npts)*cdat(1:npts) !Apply Rayleigh fading

!        do i=0,NFFT-1
!           p=real(cspread(i))**2 + aimag(cspread(i))**2
!           write(14,3010) i,p,cspread(i)
!3010       format(i8,3f12.6)
!        enddo

     endif

     dat(1:npts)=aimag(cdat(1:npts)) + xnoise(1:npts)              !Add the generated noise
     if(snrdb.lt.90.0) then
       dat(1:npts)=rms*dat(1:npts)
     else
       datpk=maxval(abs(dat(1:npts)))
       fac=32766.9/datpk
       dat(1:npts)=fac*dat(1:npts)
     endif
     if(any(abs(dat(1:npts)).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave(1:npts)=nint(dat(1:npts))
     write(10) h,iwave(1:npts)                !Save the .wav file
     close(10)
  enddo

999 end program jt65sim

subroutine zplt(z,iplt,sync,dtx,nfreq,flip,sync2,nplot,emedelay,dttol,   &
  nfqso,ntol)

  real z(458,65)
  real zz(458,65)
  integer ij(2)
  character*4 lab

  call pctile(z,458*65,84,rms)
  fac=0.05/rms
  z=fac*z
  dtq=0.114286
  df=11025.0/(2.0*2520.0)

  ia=nint((nfqso-ntol)/df) - 273
  if(ia.lt.1) ia=1
  ib=nint((nfqso+ntol)/df) - 273
  if(ib.gt.458) ib=458
  ja=(emedelay+0.8-dttol)/dtq
  if(ja.lt.1) ja=1
  jb=(emedelay+0.8+dttol)/dtq
  if(jb.gt.65) jb=65

  zz=0.
  zz(ia:ib,ja:jb)=z(ia:ib,ja:jb)

  zmin=minval(zz)
  zmax=maxval(zz)
  flip=1.0
  if(abs(zmin).gt.abs(zmax)) flip=-1.0

  ij=maxloc(zz)
  if(flip.lt.0.0) ij=minloc(zz)
  i0=ij(1)
  j0=ij(2)
  nfreq=nint((i0+273)*df)
  dtx=j0*dtq-0.8
!  write(69,3101) ia,ib,ja,jb,ij,dtx,nfreq
!3101 format(6i5,f8.2,i6)

  ia=max(1,i0-72)
  ib=min(458,i0+72)
  sync=16.33*flip*(z(i0,j0) - 0.5*(z(ia,j0)+z(ib,j0)))
  sync2=20.0*flip*z(i0,j0)

  if(nplot.eq.0) go to 900

  zmax=max(abs(zmin),abs(zmax),1.0)
  zmin=-zmax

  do j=1,65
     write(61,1100) j*dtq-0.8,z(i0,j)
1100 format(2f10.3)
  enddo

  do i=1,458
     write(62,1100) (i+273)*df,flip*z(i,j0)
  enddo

  xx=1.5
  yy=7.5 - 3.0*iplt
  width=6.0
  height=2.0
  IP=458
  JP=65
  imax=IP
  jmax=JP

  if(iplt.eq.0) then
     call imopen("testjt4.ps")
     call imfont("Helvetica",16)
     call impalette("BlueRed.pal")
  endif

  call imr4mat_color(z,IP,JP,imax,jmax,zmin,zmax,xx,yy,   &
       width,height,1)
  call imstring("Frequency (Hz)",xx+0.5*width,yy-0.5,2,0)
  dy=0.1
  do i=1,9
     x=xx + 0.1*i*width
     call imyline(x,yy,dy)
     call imyline(x,yy+height,-dy)
  enddo
  do i=1,6
     nf=(i-1)*200 + 600
     write(lab,1020) nf
1020  format(i4)
     x=xx + (i-1)*0.2*width
     call imstring(lab,x,yy-0.25,2,0)
  enddo

  dx=0.1
  do i=0,6
     y=yy + height*(0.8+i)/(65.0*0.114286)
     call imxline(xx,y,dx)
     call imxline(xx+width,y,-dx)
  enddo

  do i=0,6,2
     y=yy + height*(0.8+i)/(65.0*0.114286)
     write(lab,1020) i
     call imstring(lab(4:4),xx-0.15,y-0.08,2,0)
  enddo

  y=yy + height*(3.8)/(65.0*0.114286)
  call imstring("DT", xx-0.5,y     ,2,0)
  call imstring("(s)",xx-0.5,y-0.25,2,0)

  if(iplt.eq.2) call imclose

900 return
end subroutine zplt

module timer_module
  implicit none

  abstract interface
     subroutine timer_callback (dname, k)
       character(len=8), intent(in) :: dname
       integer, intent(in) :: k
     end subroutine timer_callback
  end interface

  public :: null_timer
  procedure(timer_callback), pointer :: timer => null_timer

contains
  !
  ! default Fortran implementation which does nothing
  !
  subroutine null_timer (dname, k)
    implicit none
    character(len=8), intent(in) :: dname
    integer, intent(in) :: k
    if(dname.eq.'99999999' .and. k.eq.9999) stop  !Silence compiler warnings
  end subroutine null_timer
end module timer_module

module set_mod
  implicit none
contains
  
  subroutine move(x,y,n)
    implicit none
    integer, intent(in) :: n
    integer, intent(in) :: x(n)
    integer, intent(out) :: y(n)
    integer :: i
    do i=1,n
       y(i)=x(i)
    enddo
  end subroutine move
  
end module set_mod

! FT4 
! LDPC(174,91) code, four 4x4 Costas arrays for sync, ramp-up and ramp-down symbols

parameter (KK=91)                     !Information bits (77 + CRC14)
parameter (ND=87)                     !Data symbols
parameter (NS=16)                     !Sync symbols 
parameter (NN=NS+ND)                  !Sync and data symbols (103)
parameter (NN2=NS+ND+2)               !Total channel symbols (105)
parameter (NSPS=576)                  !Samples per symbol at 12000 S/s
parameter (NZ=NSPS*NN)                !Sync and Data samples (59328)
parameter (NZ2=NSPS*NN2)              !Total samples in shaped waveform (60480)
parameter (NMAX=21*3456)              !Samples in iwave (72576)
parameter (NFFT1=2304, NH1=NFFT1/2)   !Length of FFTs for symbol spectra
parameter (NSTEP=NSPS)                !Coarse time-sync step size
parameter (NHSYM=(NMAX-NFFT1)/NSTEP)  !Number of symbol spectra (1/4-sym steps)
parameter (NDOWN=18)                  !Downsample factor

real function fchisq0(y,npts,a)

  real y(npts),a(4)
  
!  rewind 51
  chisq = 0.
  do i=1,npts
     x=i
     z=(x-a(3))/(0.5*a(4))
     yfit=a(1)
     if(abs(z).lt.3.0) then
        d=1.0 + z*z
        yfit=a(1) + a(2) * (1.0/d - 0.1)
     endif
     chisq=chisq + (y(i) - yfit)**2
!     write(51,3001) i,y(i),yfit,y(i)-yfit
!3001 format(i5,3f10.4)
  enddo
  fchisq0=chisq

  return
end function fchisq0

module packjt77sdvar

! These variables are accessible from outside via "use packjt77sdvar":
!  integer n28avar,n28bvar

  contains

subroutine pack77sdvar(msg0,i3,n3,c77)

  use packjt
  character*37 msg,msg0
  character*13 w(19)
  character*77 c77
  integer nw(19)

  msg=msg0

! Convert msg to upper case; collapse multiple blanks; parse into words.
  call split77var(msg,nwords,nw,w)
  i3=-1
  n3=-1
  if(msg(1:3).eq.'CQ ' .or. msg(1:3).eq.'DE ' .or. msg(1:4).eq.'QRZ ') go to 100

! Check Type 1 (Standard 77-bit message) or Type 2, with optional "/P"
100 call pack77_1var(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900

! It defaults to free text
  i3=0
  n3=0
  msg(14:)='                        '
  call packtext77var(msg(1:13),c77(1:71))
  write(c77(72:77),'(2b3.3)') n3,i3

900 return
end subroutine pack77sdvar

subroutine unpack77sdvar(c77,msg,unpk77_successvar)

  parameter (MAXGRID4=32400)
  integer*8 n58
  character*77 c77*77,msg*37,c*38,call_1*13,call_2*13,c11*11,grid4*4,crpt*3
  logical unpk28_success,unpk77_successvar

  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  unpk77_successvar=.true.

! Check for bad data
  do i=1,77
     if(c77(i:i).ne.'0' .and. c77(i:i).ne.'1') then
        msg='failed unpack'
        unpk77_successvar=.false.
        return
     endif
  enddo

  read(c77(72:77),'(2b3)') n3,i3
  msg=repeat(' ',37)
  if(i3.eq.0 .and. n3.eq.0) then
! 0.0  Free text
     call unpacktext77var(c77(1:71),msg(1:13))
     msg(14:)='                        '
     msg=adjustl(msg)

  else if(i3.eq.1 .or. i3.eq.2) then
! Type 1 (standard message) or Type 2 ("/P" form for EU VHF contest)
     read(c77,1000) n28avar,ipa,n28bvar,ipb,ir,igrid4,i3
1000 format(2(b28,b1),b1,b15,b3)
     call unpack28var(n28avar,call_1,unpk28_success)
     if(.not.unpk28_success) unpk77_successvar=.false.
     call unpack28var(n28bvar,call_2,unpk28_success)
     if(.not.unpk28_success) unpk77_successvar=.false.
     if(call_1(1:3).eq.'CQ_') call_1(3:3)=' '
     if(index(call_1,'<').le.0) then
        i=index(call_1,' ')
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.1) call_1(i:i+1)='/R'
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.2) call_1(i:i+1)='/P'
     endif
     if(index(call_2,'<').le.0) then
        i=index(call_2,' ')
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.1) call_2(i:i+1)='/R'
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.2) call_2(i:i+1)='/P'
     endif
     if(igrid4.le.MAXGRID4) then
        n=igrid4
        j1=n/(18*10*10)
        n=n-j1*18*10*10
        j2=n/(10*10)
        n=n-j2*10*10
        j3=n/10
        j4=n-j3*10
        grid4(1:1)=char(j1+ichar('A'))
        grid4(2:2)=char(j2+ichar('A'))
        grid4(3:3)=char(j3+ichar('0'))
        grid4(4:4)=char(j4+ichar('0'))
        if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//grid4
        if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R '//grid4
        if(msg(1:3).eq.'CQ ' .and. ir.eq.1) unpk77_successvar=.false.
     else
        irpt=igrid4-MAXGRID4
        if(irpt.eq.1) msg=trim(call_1)//' '//trim(call_2)
        if(irpt.eq.2) msg=trim(call_1)//' '//trim(call_2)//' RRR'
        if(irpt.eq.3) msg=trim(call_1)//' '//trim(call_2)//' RR73'
        if(irpt.eq.4) msg=trim(call_1)//' '//trim(call_2)//' 73'
        if(irpt.ge.5) then
           write(crpt,'(i3.2)') irpt-35
           if(crpt(1:1).eq.' ') crpt(1:1)='+'
           if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//crpt
           if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R'//crpt
        endif
        if(msg(1:3).eq.'CQ ' .and. irpt.ge.2) unpk77_successvar=.false. 
     endif

  else if(i3.eq.4) then
     read(c77,1050) n12,n58,iflip,nrpt,icq
1050 format(b12,b58,b1,b2,b1)
     if(icq.eq.1) then
       do i=11,1,-1
         j=mod(n58,38)+1
         c11(i:i)=c(j:j)
         n58=n58/38
       enddo
       call_2=adjustl(c11)//'  '
       msg='CQ '//trim(call_2)
       if(msg(1:4).eq.'CQ <') unpk77_successvar=.false.
     else
       unpk77_successvar=.false.
     endif
  endif

  return
end subroutine unpack77sdvar

subroutine pack28var(c13,n28)

! Pack a special token, a 22-bit hash code, or a valid base call into a 28-bit
! integer.

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical is_digit,is_letter
  character*13 c13
  character*6 callsign
  character*1 c
  character*4 c4
  character*37 a1
  character*36 a2
  character*10 a3
  character*27 a4
  data a1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a3/'0123456789'/
  data a4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  
  is_digit(c)=c.ge.'0' .and. c.le.'9'
  is_letter(c)=c.ge.'A' .and. c.le.'Z'

  n28=-1
! Work-around for Swaziland prefix:
  if(c13(1:4).eq.'3DA0') callsign='3D0'//c13(5:7)
! Work-around for Guinea prefixes:
  if(c13(1:2).eq.'3X' .and. c13(3:3).ge.'A' .and.          &
       c13(3:3).le.'Z') callsign='Q'//c13(3:6)

! Check for special tokens first
  if(c13(1:3).eq.'DE ') then
     n28=0
     go to 900
  endif
  
  if(c13(1:4).eq.'QRZ ') then
     n28=1
     go to 900
  endif

  if(c13(1:3).eq.'CQ ') then
     n28=2
     go to 900
  endif

  if(c13(1:3).eq.'CQ_') then
     n=len(trim(c13))
     if(n.ge.4 .and. n.le.7) then
        nlet=0
        nnum=0
        do i=4,n
           c=c13(i:i)
           if(c.ge.'A' .and. c.le.'Z') nlet=nlet+1
           if(c.ge.'0' .and. c.le.'9') nnum=nnum+1
        enddo
        if(nnum.eq.3 .and. nlet.eq.0) then
           read(c13(4:3+nnum),*) nqsy
           n28=3+nqsy
           go to 900
        endif
        if(nlet.ge.1 .and. nlet.le.4 .and. nnum.eq.0) then
           c4=c13(4:n)
           c4=adjustr(c4)
           m=0
           do i=1,4
              j=0
              c=c4(i:i)
              if(c.ge.'A' .and. c.le.'Z') j=ichar(c)-ichar('A')+1
              m=27*m + j
           enddo
           n28=3+1000+m
           go to 900
        endif
     endif
  endif

! Check for standard callsign
  iarea=-1
  n=len(trim(c13))
  do i=n,2,-1
     if(is_digit(c13(i:i))) exit
  enddo
  iarea=i                                   !Call-area digit
  npdig=0                                   !Digits before call area
  nplet=0                                   !Letters before call area
  do i=1,iarea-1
     if(is_digit(c13(i:i))) npdig=npdig+1
     if(is_letter(c13(i:i))) nplet=nplet+1
  enddo
  nslet=0
  do i=iarea+1,n
     if(is_letter(c13(i:i))) nslet=nslet+1
  enddo
  
  n=len(trim(c13))
! This is a standard callsign
  if(iarea.eq.2) callsign=' '//c13(1:5)
  if(iarea.eq.3) callsign=c13(1:6)
  i1=index(a1,callsign(1:1))-1
  i2=index(a2,callsign(2:2))-1
  i3=index(a3,callsign(3:3))-1
  i4=index(a4,callsign(4:4))-1
  i5=index(a4,callsign(5:5))-1
  i6=index(a4,callsign(6:6))-1
  n28=36*10*27*27*27*i1 + 10*27*27*27*i2 + 27*27*27*i3 + 27*27*i4 + &
       27*i5 + i6
  n28=n28 + NTOKENS + MAX22

900 n28=iand(n28,ishft(1,28)-1)
  return
end subroutine pack28var


subroutine unpack28var(n28_0,c13,success)

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical success
  character*13 c13
  character*37 c1
  character*36 c2
  character*10 c3
  character*27 c4
  data c1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c3/'0123456789'/
  data c4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

  success=.true.
  n28=n28_0
  if(n28.lt.NTOKENS) then
! Special tokens DE, QRZ, CQ, CQ_nnn, CQ_aaaa
     if(n28.eq.0) c13='DE           '
     if(n28.eq.1) c13='QRZ          '
     if(n28.eq.2) c13='CQ           '
     if(n28.le.2) go to 900
     if(n28.le.1002) then
        write(c13,1002) n28-3
1002    format('CQ_',i3.3)
        go to 900
     endif
     if(n28.le.532443) then
        n=n28-1003
        n0=n
        i1=n/(27*27*27)
        n=n-27*27*27*i1
        i2=n/(27*27)
        n=n-27*27*i2
        i3=n/27
        i4=n-27*i3
        c13=c4(i1+1:i1+1)//c4(i2+1:i2+1)//c4(i3+1:i3+1)//c4(i4+1:i4+1)
        c13=adjustl(c13)
        c13='CQ_'//c13(1:10)
        go to 900
     endif
  endif
  n28=n28-NTOKENS
  
! Standard callsign
  n=n28 - MAX22
  i1=n/(36*10*27*27*27)
  n=n-36*10*27*27*27*i1
  i2=n/(10*27*27*27)
  n=n-10*27*27*27*i2
  i3=n/(27*27*27)
  n=n-27*27*27*i3
  i4=n/(27*27)
  n=n-27*27*i4
  i5=n/27
  i6=n-27*i5
  c13=c1(i1+1:i1+1)//c2(i2+1:i2+1)//c3(i3+1:i3+1)//c4(i4+1:i4+1)//     &
       c4(i5+1:i5+1)//c4(i6+1:i6+1)
  c13=adjustl(c13)

900 i0=index(c13,' ')
  if(i0.ne.0 .and. i0.lt.len(trim(c13))) then
     c13='QU1RK'
     success=.false.
  endif
  return
end subroutine unpack28var

subroutine split77var(msg,nwords,nw,w)

! Convert msg to upper case; collapse multiple blanks; parse into words.

  character*37 msg
  character*13 w(19)
  character*1 c,c0
  character*6 bcall_1
  logical ok1
  integer nw(19)
    
  iz=len(trim(msg))
  j=0
  k=0
  n=0
  c0=' '
  w='             '
  do i=1,iz
     if(ichar(msg(i:i)).eq.0) msg(i:i)=' '
     c=msg(i:i)                                 !Single character
     if(c.eq.' ' .and. c0.eq.' ') cycle         !Skip leading/repeated blanks
     if(c.ne.' ' .and. c0.eq.' ') then
        k=k+1                                   !New word
        n=0
     endif
     j=j+1                                      !Index in msg
     n=n+1                                      !Index in word
     if(c.ge.'a' .and. c.le.'z') c=char(ichar(c)-32)  !Force upper case
     msg(j:j)=c
     if(n.le.13) w(k)(n:n)=c                    !Copy character c into word
     c0=c
  enddo
  iz=j                                          !Message length
  nwords=k                                      !Number of words in msg
  if(nwords.le.0) go to 900
  nw(k)=len(trim(w(k)))
  msg(iz+1:)='                                     '
  if(nwords.lt.3) go to 900
  call chkcall(w(3),bcall_1,ok1)
  if(ok1 .and. w(1)(1:3).eq.'CQ ') then
     w(1)='CQ_'//w(2)(1:10)             !Make "CQ " into "CQ_"
     w(2:12)=w(3:13)                    !Move all remeining words down by one
     nwords=nwords-1
  endif
  
900 return
end subroutine split77var

subroutine pack77_1var(nwords,w,i3,n3,c77)
! Check Type 1 (Standard 77-bit message) and Type 2 (ditto, with a "/P" call)

  parameter (MAXGRID4=32400)
  character*13 w(19),c13
  character*77 c77
  character*6 bcall_1,bcall_2
  character*4 grid4
  character c1*1,c2*2
  logical is_grid4
  logical ok1,ok2
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  if(nwords.lt.2 .or. nwords.gt.4) return
  call chkcall(w(1),bcall_1,ok1)
  call chkcall(w(2),bcall_2,ok2)
  if(w(1)(1:3).eq.'DE ' .or. w(1)(1:3).eq.'CQ_' .or.  w(1)(1:3).eq.'CQ ' .or. &
       w(1)(1:4).eq.'QRZ ') ok1=.true.
  if(w(1)(1:1).eq.'<' .and. index(w(1),'>').ge.5) ok1=.true.
  if(w(2)(1:1).eq.'<' .and. index(w(2),'>').ge.5) ok2=.true.
  if(.not.ok1 .or. .not.ok2) return
  if(w(1)(1:1).eq.'<' .and. index(w(2),'/').gt.0) return
  if(w(2)(1:1).eq.'<' .and. index(w(1),'/').gt.0) return
  if(nwords.eq.2 .and. (.not.ok2 .or. index(w(2),'/').ge.2)) return
  if(nwords.eq.2) go to 10

  c1=w(nwords)(1:1)
  c2=w(nwords)(1:2)
  if(.not.is_grid4(w(nwords)(1:4)) .and. c1.ne.'+' .and. c1.ne.'-'              &
       .and. c2.ne.'R+' .and. c2.ne.'R-' .and. trim(w(nwords)).ne.'RRR' .and.   &
       trim(w(nwords)).ne.'RR73' .and. trim(w(nwords)).ne.'73') return
  if(c1.eq.'+' .or. c1.eq.'-') then
     ir=0
     read(w(nwords),*,err=900) irpt
     irpt=irpt+35
  else if(c2.eq.'R+' .or. c2.eq.'R-') then
     ir=1
     read(w(nwords)(2:),*) irpt
     irpt=irpt+35
  else if(trim(w(nwords)).eq.'RRR') then
     ir=0
     irpt=2
  else if(trim(w(nwords)).eq.'RR73') then
     ir=0
     irpt=3
  else if(trim(w(nwords)).eq.'73') then
     ir=0
     irpt=4
  endif

! 1     WA9XYZ/R KA1ABC/R R FN42           28 1 28 1 1 15   74   Standard msg
! 2     PA3XYZ/P GM4ABC/P R JO22           28 1 28 1 1 15   74   EU VHF contest  

10 i1psuffix=index(w(1)//' ' ,'/P ')
  i2psuffix=index(w(2)//' ','/P ')
  if(nwords.eq.2 .or. nwords.eq.3 .or. (nwords.eq.4 .and.               &
       w(3)(1:2).eq.'R ')) then
     n3=0
     i3=1                          !Type 1: Standard message, possibly with "/R"
     if (i1psuffix.ge.4.or.i2psuffix.ge.4) i3=2 !Type 2, with "/P"
  endif
  c13=bcall_1
  if(c13(1:3).eq.'CQ_' .or. w(1)(1:1).eq.'<') c13=w(1)
  call pack28var(c13,n28avar)
  c13=bcall_2
  if(w(2)(1:1).eq.'<') c13=w(2)
  call pack28var(c13,n28bvar)
  ipa=0
  ipb=0
  if(i1psuffix.ge.4.or.index(w(1)//' ','/R ').ge.4) ipa=1
  if(i2psuffix.ge.4.or.index(w(2)//' ','/R ').ge.4) ipb=1
  
  grid4=w(nwords)(1:4)
  if(is_grid4(grid4)) then
     ir=0
     if(w(3).eq.'R ') ir=1
     j1=(ichar(grid4(1:1))-ichar('A'))*18*10*10
     j2=(ichar(grid4(2:2))-ichar('A'))*10*10
     j3=(ichar(grid4(3:3))-ichar('0'))*10
     j4=(ichar(grid4(4:4))-ichar('0'))
     igrid4=j1+j2+j3+j4
  else
     igrid4=MAXGRID4 + irpt
  endif
  if(nwords.eq.2) then
     ir=0
     irpt=1
     igrid4=MAXGRID4+irpt
  endif
  write(c77,1000) n28avar,ipa,n28bvar,ipb,ir,igrid4,i3
1000 format(2(b28.28,b1),b1,b15.15,b3.3)
  return

900 return
end subroutine pack77_1var

subroutine packtext77var(c13,c71)

  character*13 c13,w
  character*71 c71
  character*42 c
  character*1 qa(10),qb(10)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  call mp_short_init
  qa=char(0)
  w=adjustr(c13)
  do i=1,13
     j=index(c,w(i:i))-1
     if(j.lt.0) j=0
     call mp_short_mult(qb,qa(2:10),9,42)     !qb(1:9)=42*qa(2:9)
     call mp_short_add(qa,qb(2:10),9,j)      !qa(1:9)=qb(2:9)+j
  enddo

  write(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  return
end subroutine packtext77var

subroutine unpacktext77var(c71,c13)

  integer*1   ia(10)
  character*1 qa(10),qb(10)
  character*13 c13
  character*71 c71
  character*42 c
  equivalence (qa,ia),(qb,ib)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  qa(1)=char(0)
  read(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  do i=13,1,-1
     call mp_short_div(qb,qa(2:10),9,42,ir)
     c13(i:i)=c(ir+1:ir+1)
     qa(2:10)=qb(1:9)
  enddo

  return
end subroutine unpacktext77var

subroutine mp_short_opsvar(w,u)
  character*1 w(*),u(*)
  integer i,ireg,j,n,ir,iv,ii1,ii2
  character*1 creg(4)
  save ii1,ii2
  equivalence (ireg,creg)

  entry mp_short_init
  ireg=256*ichar('2')+ichar('1')
  do j=1,4
     if (creg(j).eq.'1') ii1=j
     if (creg(j).eq.'2') ii2=j
  enddo
  return

  entry mp_short_add(w,u,n,iv)
  ireg=256*iv
  do j=n,1,-1
     ireg=ichar(u(j))+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_mult(w,u,n,iv)
  ireg=0
  do j=n,1,-1
     ireg=ichar(u(j))*iv+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_div(w,u,n,iv,ir)
  ir=0
  do j=1,n
     i=256*ir+ichar(u(j))
     w(j)=char(i/iv)
     ir=mod(i,iv)
  enddo
  return
  
  return
end subroutine mp_short_opsvar

end module packjt77sdvar

subroutine set(a,y,n)
  real y(n)
  do i=1,n
     y(i)=a
  enddo
  return
end subroutine set

subroutine move(x,y,n)
  real x(n),y(n)
  do i=1,n
     y(i)=x(i)
  enddo
  return
end subroutine move

subroutine zero(x,n)
  real x(n)
  do i=1,n
     x(i)=0.0
  enddo
  return
end subroutine zero

subroutine add(a,b,c,n)
  real a(n),b(n),c(n)
  do i=1,n
     c(i)=a(i)+b(i)
  enddo
  return
end subroutine add

subroutine sync9(ss,nzhsym,lag1,lag2,ia,ib,ccfred,red2,ipkbest)

  include 'constants.f90'
  real ss(184,NSMAX)
  real ss1(184)
  real ccfred(NSMAX)
  real savg(NSMAX)
  real savg2(NSMAX)
  real smo(-5:25)
  real sq(NSMAX)
  real red2(NSMAX)
  character*27 cr
  data cr/'(C) 2016, Joe Taylor - K1JT'/
  include 'jt9sync.f90'

  ipk=0
  ipkbest=0
  sbest=0.
  ccfred=0.

  do i=ia,ib                         !Loop over freq range
     ss1=ss(1:184,i)
     call pctile(ss1,nzhsym,40,xmed)

     ss1=ss1/xmed - 1.0
     do j=1,nzhsym
        if(ss1(j).gt.3.0) ss1(j)=3.0
     enddo

     call pctile(ss1,nzhsym,45,sbase)
     ss1=ss1-sbase
     sq0=dot_product(ss1(1:nzhsym),ss1(1:nzhsym))
     rms=sqrt(sq0/(nzhsym-1))

     smax=0.
     do lag=lag1,lag2                !DT = 2.5 to 5.0 s
        sum1=0.
        sq2=sq0
        nsum=nzhsym
        do j=1,16                    !Sum over 16 sync symbols
           k=ii2(j) + lag
           if(k.ge.1 .and. k.le.nzhsym) then
              sum1=sum1 + ss1(k)
              sq2=sq2 - ss1(k)*ss1(k)
              nsum=nsum-1
           endif
        enddo
        if(sum1.gt.smax) then
           smax=sum1
           ipk=i 
        endif
        rms=sqrt(sq2/(nsum-1))
     enddo
     ccfred(i)=smax                        !Best at this freq, over all lags
     if(smax.gt.sbest) then
        sbest=smax
        ipkbest=ipk
     endif
  enddo

  call pctile(ccfred(ia),ib-ia+1,50,xmed)
  if(xmed.le.0.0) xmed=1.0
  ccfred=2.0*ccfred/xmed 

  savg=0.
  do j=1,nzhsym
     savg(ia:ib)=savg(ia:ib) + ss(j,ia:ib)
  enddo
  savg(ia:ib)=savg(ia:ib)/nzhsym
  smo(0:20)=1.0/21.0
  smo(-5:-1)=-(1.0/21.0)*(21.0/10.0)
  smo(21:25)=smo(-5)

  do i=ia,ib
     sm=0.
     do j=-5,25
        if(i+j.ge.1 .and. i+j.lt.NSMAX) sm=sm + smo(j)*savg(i+j)
     enddo
     savg2(i)=sm
     sq(i)=sm*sm
  enddo

  call pctile(sq(ia:ib),ib-ia+1,20,sq0)
  rms=sqrt(sq0)
  savg2(ia:ib)=savg2(ia:ib)/(5.0*rms)

  red2=0.
  do i=ia+11,ib-10
     ref=max(savg2(i-10),savg2(i+10))
     red2(i)=savg2(i)-ref
     if(red2(i).lt.-99.0) red2(i)=-99.0
     if(red2(i).gt.99.0) red2(i)=99.0
  enddo

  return
end subroutine sync9

subroutine spec_qra65(c0,nsps,s3,LL,NN)

! Compute synchronized symbol spectra.  

  complex c0(0:85*nsps-1)                !Synchronized complex data at 6000 S/s
  complex, allocatable :: cs(:)          !Complex symbol spectrum
  real s3(LL,NN)                         !Synchronized symbol spectra
  real xbase0(LL),xbase(LL)              !Work arrays
  integer isync(22)                      !Indices of sync symbols
  data isync/1,9,12,13,15,22,23,26,27,33,35,38,46,50,55,60,62,66,69,74,76,85/

  allocate(cs(0:nsps-1))
  fac=1.0/nsps
  j=0
  n=1
  do k=1,84
     if(k.eq.isync(n)) then
        n=n+1
        cycle
     endif
     j=j+1
     ja=(k-1)*nsps
     jb=ja+nsps-1
     cs=fac*c0(ja:jb)
     call four2a(cs,nsps,1,-1,1)             !c2c FFT to frequency
     do ii=1,LL
        i=ii-65
        if(i.lt.0) i=i+nsps
        s3(ii,j)=real(cs(i))**2 + aimag(cs(i))**2
     enddo
  enddo

  df=6000.0/nsps
  do i=1,LL
     call pctile(s3(i,1:NN),NN,45,xbase0(i)) !Get baseline for passband shape
  enddo
  
  nh=9
  xbase(1:nh-1)=sum(xbase0(1:nh-1))/(nh-1.0)
  xbase(LL-nh+1:LL)=sum(xbase0(LL-nh+1:LL))/(nh-1.0)
  do i=nh,LL-nh
     xbase(i)=sum(xbase0(i-nh+1:i+nh))/(2*nh+1)  !Smoothed passband shape
  enddo
  
  do i=1,LL
     s3(i,1:NN)=s3(i,1:NN)/(xbase(i)+0.001) !Apply frequency equalization
  enddo

  return
end subroutine spec_qra65

subroutine osd240_101(llr,k,apmask,ndeep,message101,cw,nhardmin,dmin)
!
! An ordered-statistics decoder for the (240,101) code.
! Message payload is 77 bits. Any or all of a 24-bit CRC can be
! used for detecting incorrect codewords. The remaining CRC bits are
! cascaded with the LDPC code for the purpose of improving the
! distance spectrum of the code.
!
! If p1 (0.le.p1.le.24) is the number of CRC24 bits that are
! to be used for bad codeword detection, then the argument k should
! be set to 77+p1.
!
! Valid values for k are in the range [77,101].
!
   character*24 c24
   integer, parameter:: N=240
   integer*1 apmask(N),apmaskr(N)
   integer*1, allocatable, save :: gen(:,:)
   integer*1, allocatable :: genmrb(:,:),g2(:,:)
   integer*1, allocatable :: temp(:),m0(:),me(:),mi(:),misub(:),e2sub(:),e2(:),ui(:)
   integer*1, allocatable :: r2pat(:)
   integer indices(N),nxor(N)
   integer*1 cw(N),ce(N),c0(N),hdec(N)
   integer*1, allocatable :: decoded(:)
   integer*1 message101(101)
   integer indx(N)
   real llr(N),rx(N),absrx(N)

   logical first,reset
   data first/.true./
   save first

   allocate( genmrb(k,N), g2(N,k) )
   allocate( temp(k), m0(k), me(k), mi(k), misub(k), e2sub(N-k), e2(N-k), ui(N-k) )
   allocate( r2pat(N-k), decoded(k) )

   if( first ) then ! fill the generator matrix
!
! Create generator matrix for partial CRC cascaded with LDPC code.
! 
! Let p2=101-k and p1+p2=24. 
!
! The last p2 bits of the CRC24 are cascaded with the LDPC code.
! 
! The first p1=k-77 CRC24 bits will be used for error detection.
!
      allocate( gen(k,N) )
      gen=0
      do i=1,k
         message101=0
         message101(i)=1
         if(i.le.77) then
            call get_crc24(message101,101,ncrc24)
            write(c24,'(b24.24)') ncrc24
            read(c24,'(24i1)') message101(78:101)
            message101(78:k)=0
         endif
         call encode240_101(message101,cw)
         gen(i,:)=cw
      enddo

      first=.false.
   endif

   rx=llr
   apmaskr=apmask

! Hard decisions on the received word.
   hdec=0
   where(rx .ge. 0) hdec=1

! Use magnitude of received symbols as a measure of reliability.
   absrx=abs(rx)
   call indexx(absrx,N,indx)

! Re-order the columns of the generator matrix in order of decreasing reliability.
   do i=1,N
      genmrb(1:k,i)=gen(1:k,indx(N+1-i))
      indices(i)=indx(N+1-i)
   enddo

! Do gaussian elimination to create a generator matrix with the most reliable
! received bits in positions 1:k in order of decreasing reliability (more or less).
   do id=1,k ! diagonal element indices
      do icol=id,k+20  ! The 20 is ad hoc - beware
         iflag=0
         if( genmrb(id,icol) .eq. 1 ) then
            iflag=1
            if( icol .ne. id ) then ! reorder column
               temp(1:k)=genmrb(1:k,id)
               genmrb(1:k,id)=genmrb(1:k,icol)
               genmrb(1:k,icol)=temp(1:k)
               itmp=indices(id)
               indices(id)=indices(icol)
               indices(icol)=itmp
            endif
            do ii=1,k
               if( ii .ne. id .and. genmrb(ii,id) .eq. 1 ) then
                  genmrb(ii,1:N)=ieor(genmrb(ii,1:N),genmrb(id,1:N))
               endif
            enddo
            exit
         endif
      enddo
   enddo

   g2=transpose(genmrb)

! The hard decisions for the k MRB bits define the order 0 message, m0.
! Encode m0 using the modified generator matrix to find the "order 0" codeword.
! Flip various combinations of bits in m0 and re-encode to generate a list of
! codewords. Return the member of the list that has the smallest Euclidean
! distance to the received word.

   hdec=hdec(indices)   ! hard decisions from received symbols
   m0=hdec(1:k)         ! zero'th order message
   absrx=absrx(indices)
   rx=rx(indices)
   apmaskr=apmaskr(indices)

   call mrbencode101(m0,c0,g2,N,k)
   nxor=ieor(c0,hdec)
   nhardmin=sum(nxor)
   dmin=sum(nxor*absrx)

   cw=c0
   ntotal=0
   nrejected=0
   npre1=0
   npre2=0
   nt=0

   if(ndeep.eq.0) goto 998  ! norder=0
   if(ndeep.gt.6) ndeep=6
   if( ndeep.eq. 1) then
      nord=1
      npre1=0
      npre2=0
      nt=40
      ntheta=12
   elseif(ndeep.eq.2) then
      nord=1
      npre1=1
      npre2=0
      nt=40
      ntheta=12
   elseif(ndeep.eq.3) then
      nord=1
      npre1=1
      npre2=1
      nt=40
      ntheta=12
      ntau=14
   elseif(ndeep.eq.4) then
      nord=2
      npre1=1
      npre2=1
      nt=40
      ntheta=12
      ntau=17
   elseif(ndeep.eq.5) then
      nord=3
      npre1=1
      npre2=1
      nt=40
      ntheta=12
      ntau=15
   elseif(ndeep.eq.6) then
      nord=4
      npre1=1
      npre2=1
      nt=95
      ntheta=12
      ntau=15
   endif

   do iorder=1,nord
      misub(1:k-iorder)=0
      misub(k-iorder+1:k)=1
      iflag=k-iorder+1
      do while(iflag .ge.0)
         if(iorder.eq.nord .and. npre1.eq.0) then
            iend=iflag
         else
            iend=1
         endif
         d1=0.
         do n1=iflag,iend,-1
            mi=misub
            mi(n1)=1
            if(any(iand(apmaskr(1:k),mi).eq.1)) cycle
            ntotal=ntotal+1
            me=ieor(m0,mi)
            if(n1.eq.iflag) then
               call mrbencode101(me,ce,g2,N,k)
               e2sub=ieor(ce(k+1:N),hdec(k+1:N))
               e2=e2sub
               nd1kpt=sum(e2sub(1:nt))+1
               d1=sum(ieor(me(1:k),hdec(1:k))*absrx(1:k))
            else
               e2=ieor(e2sub,g2(k+1:N,n1))
               nd1kpt=sum(e2(1:nt))+2
            endif
            if(nd1kpt .le. ntheta) then
               call mrbencode101(me,ce,g2,N,k)
               nxor=ieor(ce,hdec)
               if(n1.eq.iflag) then
                  dd=d1+sum(e2sub*absrx(k+1:N))
               else
                  dd=d1+ieor(ce(n1),hdec(n1))*absrx(n1)+sum(e2*absrx(k+1:N))
               endif
               if( dd .lt. dmin ) then
                  dmin=dd
                  cw=ce
                  nhardmin=sum(nxor)
                  nd1kptbest=nd1kpt
               endif
            else
               nrejected=nrejected+1
            endif
         enddo
! Get the next test error pattern, iflag will go negative
! when the last pattern with weight iorder has been generated.
         call nextpat101(misub,k,iorder,iflag)
      enddo
   enddo

   if(npre2.eq.1) then
      reset=.true.
      ntotal=0
      do i1=k,1,-1
         do i2=i1-1,1,-1
            ntotal=ntotal+1
            mi(1:ntau)=ieor(g2(k+1:k+ntau,i1),g2(k+1:k+ntau,i2))
            call boxit101(reset,mi(1:ntau),ntau,ntotal,i1,i2)
         enddo
      enddo

      ncount2=0
      ntotal2=0
      reset=.true.
! Now run through again and do the second pre-processing rule
      misub(1:k-nord)=0
      misub(k-nord+1:k)=1
      iflag=k-nord+1
      do while(iflag .ge.0)
         me=ieor(m0,misub)
         call mrbencode101(me,ce,g2,N,k)
         e2sub=ieor(ce(k+1:N),hdec(k+1:N))
         do i2=0,ntau
            ntotal2=ntotal2+1
            ui=0
            if(i2.gt.0) ui(i2)=1
            r2pat=ieor(e2sub,ui)
778         continue
            call fetchit101(reset,r2pat(1:ntau),ntau,in1,in2)
            if(in1.gt.0.and.in2.gt.0) then
               ncount2=ncount2+1
               mi=misub
               mi(in1)=1
               mi(in2)=1
               if(sum(mi).lt.nord+npre1+npre2.or.any(iand(apmaskr(1:k),mi).eq.1)) cycle
               me=ieor(m0,mi)
               call mrbencode101(me,ce,g2,N,k)
               nxor=ieor(ce,hdec)
               dd=sum(nxor*absrx)
               if( dd .lt. dmin ) then
                  dmin=dd
                  cw=ce
                  nhardmin=sum(nxor)
               endif
               goto 778
            endif
         enddo
         call nextpat101(misub,k,nord,iflag)
      enddo
   endif

998 continue
! Re-order the codeword to [message bits][parity bits] format.
   cw(indices)=cw
   hdec(indices)=hdec
   message101=cw(1:101)
   call get_crc24(message101,101,nbadcrc)
   if(nbadcrc.ne.0) nhardmin=-nhardmin

   return
end subroutine osd240_101

subroutine mrbencode101(me,codeword,g2,N,K)
   integer*1 me(K),codeword(N),g2(N,K)
! fast encoding for low-weight test patterns
   codeword=0
   do i=1,K
      if( me(i) .eq. 1 ) then
         codeword=ieor(codeword,g2(1:N,i))
      endif
   enddo
   return
end subroutine mrbencode101

subroutine nextpat101(mi,k,iorder,iflag)
   integer*1 mi(k),ms(k)
! generate the next test error pattern
   ind=-1
   do i=1,k-1
      if( mi(i).eq.0 .and. mi(i+1).eq.1) ind=i
   enddo
   if( ind .lt. 0 ) then ! no more patterns of this order
      iflag=ind
      return
   endif
   ms=0
   ms(1:ind-1)=mi(1:ind-1)
   ms(ind)=1
   ms(ind+1)=0
   if( ind+1 .lt. k ) then
      nz=iorder-sum(ms)
      ms(k-nz+1:k)=1
   endif
   mi=ms
   do i=1,k  ! iflag will point to the lowest-index 1 in mi
      if(mi(i).eq.1) then
         iflag=i
         exit
      endif
   enddo
   return
end subroutine nextpat101

subroutine boxit101(reset,e2,ntau,npindex,i1,i2)
   integer*1 e2(1:ntau)
   integer   indexes(5000,2),fp(0:525000),np(5000)
   logical reset
   common/boxes/indexes,fp,np

   if(reset) then
      patterns=-1
      fp=-1
      np=-1
      sc=-1
      indexes=-1
      reset=.false.
   endif

   indexes(npindex,1)=i1
   indexes(npindex,2)=i2
   ipat=0
   do i=1,ntau
      if(e2(i).eq.1) then
         ipat=ipat+ishft(1,ntau-i)
      endif
   enddo

   ip=fp(ipat)   ! see what's currently stored in fp(ipat)
   if(ip.eq.-1) then
      fp(ipat)=npindex
   else
      do while (np(ip).ne.-1)
         ip=np(ip)
      enddo
      np(ip)=npindex
   endif
   return
end subroutine boxit101

subroutine fetchit101(reset,e2,ntau,i1,i2)
   integer   indexes(5000,2),fp(0:525000),np(5000)
   integer   lastpat
   integer*1 e2(ntau)
   logical reset
   common/boxes/indexes,fp,np
   save lastpat,inext

   if(reset) then
      lastpat=-1
      reset=.false.
   endif

   ipat=0
   do i=1,ntau
      if(e2(i).eq.1) then
         ipat=ipat+ishft(1,ntau-i)
      endif
   enddo
   index=fp(ipat)

   if(lastpat.ne.ipat .and. index.gt.0) then ! return first set of indices
      i1=indexes(index,1)
      i2=indexes(index,2)
      inext=np(index)
   elseif(lastpat.eq.ipat .and. inext.gt.0) then
      i1=indexes(inext,1)
      i2=indexes(inext,2)
      inext=np(inext)
   else
      i1=-1
      i2=-1
      inext=-1
   endif
   lastpat=ipat
   return
end subroutine fetchit101

subroutine blanker(iwave,nz,ndropmax,npct,c_bigfft)

  integer*2 iwave(nz)
  complex c_bigfft(0:nz/2)
  integer hist(0:32768)
  real fblank                     !Fraction of points to be blanked

  fblank=0.01*npct
  hist=0
  do i=1,nz
! ### NB: if iwave(i)=-32768, abs(iwave(i))=-32768 ###
     if(iwave(i).eq.-32768) iwave(i)=-32767
     n=abs(iwave(i))
     hist(n)=hist(n)+1
  enddo
  n=0
  do i=32768,0,-1
     n=n+hist(i)
     if(n.ge.nint(nz*fblank/ndropmax)) exit
  enddo
  nthresh=i
  ndrop=0
  ndropped=0

  xx=0.
  do i=1,nz
     i0=iwave(i)
     if(ndrop.gt.0) then
        i0=0
        ndropped=ndropped+1
        ndrop=ndrop-1
     endif

! Start to apply blanking
     if(abs(i0).gt.nthresh) then
        i0=0
        ndropped=ndropped+1
        ndrop=ndropmax
     endif
     
! Now copy the data into c_bigfft
     if(iand(i,1).eq.1) then
        xx=i0
     else
        yy=i0
        j=i/2 - 1
        c_bigfft(j)=cmplx(xx,yy)
     endif
  enddo

  return
end subroutine blanker

subroutine display(nkeep,ftol)

  parameter (MAXLINES=400,MX=400,MAXCALLS=500)
  integer indx(MAXLINES),indx2(MX)
  character*83 line(MAXLINES),line2(MX),line3(MAXLINES)
  character out*52,out0*52,cfreq0*3,livecq*58
  character*6 callsign,callsign0
  character*12 freqcall(MAXCALLS)
  real freqkHz(MAXLINES)
  integer utc(MAXLINES),utc2(MX),utcz
  real*8 f0
  save

  out0=' '
  rewind(26)

  do i=1,MAXLINES
     read(26,1010,end=10) line(i)
1010 format(a77)
     read(line(i),1020) f0,ndf,nh,nm
1020 format(f8.3,i5,25x,i3,i2)
     utc(i)=60*nh + nm
     freqkHz(i)=1000.d0*(f0-144.d0) + 0.001d0*ndf
  enddo

10 backspace(26)
  nz=i-1
  utcz=utc(nz)
  nz=nz-1
  if(nz.lt.1) go to 999
  nquad=max(nkeep/4,3)
  do i=1,nz
     nage=utcz-utc(i)
     if(nage.lt.0) nage=nage+1440
     iage=nage/nquad
     write(line(i)(73:74),1021) iage
1021 format(i2)
  enddo

  nage=utcz-utc(1)
  if(nage.lt.0) nage=nage+1440
  if(nage.gt.nkeep) then
     do i=1,nz
        nage=utcz-utc(i)
        if(nage.lt.0) nage=nage+1440
        if(nage.le.nkeep) go to 20
     enddo
20   i0=i
     nz=nz-i0+1
     rewind(26)
     if(nz.lt.1) go to 999
     do i=1,nz
        j=i+i0-1
        line(i)=line(j)
        utc(i)=utc(j)
        freqkHz(i)=freqkHz(j)
        write(26,1022) line(i)
1022    format(a77)
     enddo
  endif

  call flush(26)
  call indexx(freqkHz,nz,indx)

  nstart=1
  k3=0
  k=1
  m=indx(1)
  if(m.lt.1 .or. m.gt.MAXLINES) then
     print*,'Error in display.f90: ',nz,m
     m=1
  endif
  line2(1)=line(m)
  utc2(1)=utc(m)
  do i=2,nz
     j0=indx(i-1)
     j=indx(i)
     if(freqkHz(j)-freqkHz(j0).gt.2.0*ftol) then
        if(nstart.eq.0) then
           k=k+1
           line2(k)=""
           utc2(k)=-1
        endif
        kz=k
        if(nstart.eq.1) then
           call indexx(float(utc2(1:kz)),kz,indx2)
           k3=0
           do k=1,kz
              k3=min(k3+1,400)
              line3(k3)=line2(indx2(k))
           enddo
           nstart=0
        else
           call indexx(float(utc2(1:kz)),kz,indx2)
           do k=1,kz
              k3=min(k3+1,400)
              line3(k3)=line2(indx2(k))
           enddo
        endif
        k=0
     endif
     if(i.eq.nz) then
        k=k+1
        line2(k)=""
        utc2(k)=-1
     endif
     k=k+1
     line2(k)=line(j)
     utc2(k)=utc(j)
     j0=j
  enddo
  kz=k
  call indexx(float(utc2(1:kz)),kz,indx2)
  do k=1,kz
     k3=min(k3+1,400)
     line3(k3)=line2(indx2(k))
  enddo

  rewind 19
  rewind 20
  cfreq0='   '
  nc=0
  callsign0='      '
  do k=1,k3
     out=line3(k)(6:13)//line3(k)(28:31)//line3(k)(39:45)//       &
          line3(k)(35:38)//line3(k)(46:74)
     if(out(1:3).ne.'   ') then
        cfreq0=out(1:3)
        livecq=line3(k)(6:13)//line3(k)(28:31)//line3(k)(39:45)//       &
             line3(k)(23:27)//line3(k)(35:38)//line3(k)(46:70)//        &
             line3(k)(73:77)
        if(livecq(56:56).eq.':') livecq(56:58)=' '//livecq(56:57)
        if(index(livecq,' CQ ').gt.0 .or. index(livecq,' QRZ ').gt.0 .or.   &
           index(livecq,' QRT ').gt.0 .or. index(livecq,' CQV ').gt.0 .or.  &
           index(livecq,' CQH ').gt.0) write(19,1029) livecq
1029    format(a58)

! Suppress listing duplicate (same time, decoded message, and frequency)
        if(out(14:17).ne.out0(14:17) .or. out(26:50).ne.out0(26:50) .or.  &
             out(1:3).ne.out0(1:3)) then
           write(*,1030) out                  !Messages
1030       format('@',a52)
           out0=out
        endif

        i1=index(out(26:),' ')
        callsign=out(i1+26:)
        i2=index(callsign,' ')
        if(i2.gt.1) callsign(i2:)='      '
        if(callsign.ne.'      ' .and. callsign.ne.callsign0) then
           len=i2-1
           if(len.lt.0) len=6
           if(len.ge.4) then                        !Omit short "callsigns"
              if(nc.lt.MAXCALLS) nc=nc+1
              freqcall(nc)=cfreq0//' '//callsign//line3(k)(73:74)
              callsign0=callsign
           endif
        endif
        if(callsign.ne.'      ' .and. callsign.eq.callsign0) then
           freqcall(nc)=cfreq0//' '//callsign//line3(k)(73:74)
        endif
     endif
  enddo
  flush(19)
  if(nc.lt.MAXCALLS) nc=nc+1
  freqcall(nc)='            '
  if(nc.lt.MAXCALLS) nc=nc+1
  freqcall(nc)='            '
  freqcall(nc+1)='            '
  freqcall(nc+2)='            '

  do i=1,nc
  write(*,1042) freqcall(i)                         !Band Map
1042 format('&',a12)
  enddo

999  continue
  return
end subroutine display

subroutine fmtmsg(msg,iz)

  character*(*) msg

! Convert all letters to upper case
  iz=len(msg)
  do i=1,iz
     if(msg(i:i).ge.'a' .and. msg(i:i).le.'z')                       &
          msg(i:i)= char(ichar(msg(i:i))+ichar('A')-ichar('a'))
     if(msg(i:i).ne.' ') iz=i
  enddo

  do iter=1,37                           !Collapse multiple blanks into one
     ib2=index(msg(1:iz),'  ')
     if(ib2.lt.1) go to 100
     msg=msg(1:ib2)//msg(ib2+2:)
     iz=iz-1
  enddo

100 return
end subroutine fmtmsg

subroutine cfom(dd,k0,k,ndop0)
  
  parameter(NMAX=60*96000)
  real dd(2,NMAX)
  complex*16 w,wstep
  complex*8 c
  real*8 twopi,dphi
  logical first
  data first/.true./
  save twopi,w,first

  if(first) then
     twopi=8.d0*atan(1.d0)
     w=1.d0
     first=.false.
  endif

  dop0=0.5*ndop0
  dphi=dop0*twopi/96000.0
  wstep=cmplx(cos(dphi),sin(dphi))

  do j=k0+1,k
     c=w*cmplx(dd(1,j),dd(2,j))
     dd(1,j)=real(c)
     dd(2,j)=aimag(c)
     w=w*wstep
  enddo

  return
end subroutine cfom

subroutine zaptx(dd,k0,k)

  parameter(NMAX=60*96000)
  real dd(2,NMAX)

  dd(1:2,k0+1:k)=0.

  return
end subroutine zaptx

subroutine partint(ndelay,nutc)

  use jt65_mod6
  real rnd

  numsamp=ndelay*1200
  dd(numsamp+1:624000)=dd(1:(624000-numsamp))
     do i=1,numsamp
        call random_number(rnd)
        dd(i)=10.0*rnd-5.
     enddo
  write(*,2) nutc,'partial loss of data','d'
2 format(i4.4,2x,a20,21x,a1)
  call flush(6)

  return
end subroutine partint

subroutine foxfilt(nslots,nfreq,width,wave)

  parameter (NN=79,ND=58,KK=87,NSPS=4*1920)
  parameter (NWAVE=NN*NSPS,NFFT=614400,NH=NFFT/2)
  real wave(NWAVE)
  real x(NFFT)
  complex cx(0:NH)
  equivalence (x,cx)

  x(1:NWAVE)=wave
  x(NWAVE+1:)=0.
  call four2a(cx,NFFT,1,-1,0)              !r2c
  df=48000.0/NFFT
  fa=nfreq - 0.5*6.25
  fb=nfreq + 7.5*6.25 + (nslots-1)*60.0
  ia2=nint(fa/df)
  ib1=nint(fb/df)
  ia1=nint(ia2-width/df)
  ib2=nint(ib1+width/df)
  pi=4.0*atan(1.0)
  do i=ia1,ia2
     fil=(1.0 + cos(pi*df*(i-ia2)/width))/2.0
     cx(i)=fil*cx(i)
  enddo
  do i=ib1,ib2
     fil=(1.0 + cos(pi*df*(i-ib1)/width))/2.0
     cx(i)=fil*cx(i)
  enddo
  cx(0:ia1-1)=0.
  cx(ib2+1:)=0.

  call four2a(cx,nfft,1,1,-1)                  !c2r
  wave=x(1:NWAVE)/nfft

  return
end subroutine foxfilt

subroutine ftninit(appd)

  use timer_module, only: timer
  use, intrinsic :: iso_c_binding, only: C_NULL_CHAR
  use FFTW3
  character*(*) appd
  character addpfx*8
  character wisfile*256
  common/pfxcom/addpfx

  addpfx='    '
  call pfxdump(appd//'/prefixes.txt')
  open(12,file=appd//'/wb_q65.txt',status='unknown')
  open(13,file=appd//'/map65.log',status='unknown')
  open(19,file=appd//'/livecq.txt',status='unknown')
  open(21,file=appd//'/map65_rx.log',status='unknown',access='append',err=950)
  open(26,file=appd//'/tmp26.txt',status='unknown')

! Import FFTW wisdom, if available:
  iret=fftwf_init_threads()            !Initialize FFTW threading 
! Default to 1 thread, but use nthreads for the big ones
  call fftwf_plan_with_nthreads(1)
! Import FFTW wisdom, if available
  wisfile=trim(appd)//'/m65_wisdom.dat'// C_NULL_CHAR
  iret=fftwf_import_wisdom_from_filename(wisfile)
  return

950 write(0,*) '!Error opening ALL65.TXT'
  stop

end subroutine ftninit

subroutine sync8var(nfa,nfb,syncmin,nfqso,candidate,ncand,jzb,jzt,ipass,lqsothread,ncandthin,ndtcenter)

  use ft8_mod1, only : dd8,windowx,facx,icos7,lagcc,lagccbail,nfawide,nfbwide
  include 'ft8_params.f90'
  complex cx(0:NH1)
  real s(NH1,NHSYM),x(NFFT1),sync2d(NH1,jzb:jzt),red(NH1),candidate0(5,450),candidate(4,460),tall(30),freq,rcandthin,dtcenter
  integer jpeak(NH1),indx(NH1),ii(1)
  integer, intent(in) :: nfa,nfb,nfqso,jzb,jzt,ipass,ncandthin,ndtcenter
  logical(1) syncq(NH1,jzb:jzt),redcq(NH1),lcq,lcq2,lpass1,lpass2
  logical(1), intent(in) :: lqsothread
  equivalence (x,cx)

! Compute symbol spectra, stepping by NSTEP steps.  
  tstep=0.04 ! NSTEP/12000.0                         
  df=3.125 ! 12000.0/NFFT1 , Hz
  syncq=.false.; redcq=.false.; candidate(4,:)=0.
  rcandthin=ncandthin/100.;
  dtcenter=ndtcenter/100.

  if(ipass.eq.1 .or. ipass.eq.4 .or. ipass.eq.7) then
    do j=1,NHSYM
      ia=(j-1)*NSTEP + 1
      ib=ia+NSPS-1
      x(1:759)=0.
      if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
      x(961:2880)=facx*dd8(ia:ib); x(961)=x(961)*1.9; x(2880)=x(2880)*1.9
      if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
      x(3082:)=0.
      call four2avar(cx,NFFT1,1,-1,0)              !r2c FFT
      do i=1,NH1
        s(i,j)=SQRT(real(cx(i))**2 + aimag(cx(i))**2)
      enddo
    enddo
  endif
  if(ipass.eq.2 .or. ipass.eq.5 .or. ipass.eq.8) then
    do j=1,NHSYM
      ia=(j-1)*NSTEP + 1
      ib=ia+NSPS-1
      x(1:759)=0.
      if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
      x(961:2880)=facx*dd8(ia:ib); x(961)=x(961)*1.9; x(2880)=x(2880)*1.9
      if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
      x(3082:)=0.
      call four2avar(cx,NFFT1,1,-1,0)              !r2c FFT
      do i=1,NH1
        s(i,j)=real(cx(i))**2 + aimag(cx(i))**2
      enddo
    enddo
  endif
  if(ipass.eq.3 .or. ipass.eq.6 .or. ipass.eq.9) then
    do j=1,NHSYM
      ia=(j-1)*NSTEP + 1
      ib=ia+NSPS-1
      x(1:759)=0.
      if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
      x(961:2880)=facx*dd8(ia:ib); x(961)=x(961)*1.9; x(2880)=x(2880)*1.9
      if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
      x(3082:)=0.
      call four2avar(cx,NFFT1,1,-1,0)              !r2c FFT
      do i=1,NH1
        s(i,j)=abs(real(cx(i))) + abs(aimag(cx(i)))
      enddo
    enddo
  endif

  ia=max(1,nint(nfa/df)); ib=max(1,nint(nfb/df)); iaw=max(1,nint(nfawide/df)); ibw=max(1,nint(nfbwide/df))
  nssy=4 ! NSPS/NSTEP   ! # steps per symbol
  nssy36=144 ! nssy*36
  nssy72=288 ! nssy*72
  nfos=2 ! NFFT1/NSPS   ! # frequency bin oversampling factor
  jstrt=12.5 ! 0.5/tstep

  if(lagcc .and. .not.lagccbail) then
    nfos6=12 ! nfos*6
    do j=jzb,jzt
      do i=iaw,ibw
        ta=0.; tb=0.; tc=0.
        do n=0,6
          k=j+jstrt+nssy*n
          if(k.gt.0) then
            ta=s(i+nfos*icos7(n),k)
            if(ta.gt.1e-9) then; tall(n+1)=ta*6.0/(sum(s(i:i+nfos6:nfos,k))-ta); else; tall(n+1)=0.; endif
          endif
          k36=k+nssy36
          if(k36.gt.0 .and. k36.le.NHSYM) then
            tb=s(i+nfos*icos7(n),k36)
            if(tb.gt.1e-9) then; tall(n+17)=tb*6.0/(sum(s(i:i+nfos6:nfos,k36))-tb); else; tall(n+17)=0.; endif
          endif
          k72=k+nssy72
          if(k72.le.NHSYM) then
            tc=s(i+nfos*icos7(n),k72)
            if(tc.gt.1e-9) then; tall(n+24)=tc*6.0/(sum(s(i:i+nfos6:nfos,k72))-tc); else; tall(n+24)=0.; endif
          endif
        enddo
        lcq=.false.
        if(ipass.gt.1) then
          do n=7,15
            k=j+jstrt+nssy*n
            if(k.gt.0) then
              if(n.lt.15) then
                tall(n+1)=s(i,k)*6.0/(sum(s(i:i+nfos6:nfos,k))-s(i,k))
              else
                tall(n+1)=s(i+2,k)*6.0/(sum(s(i:i+nfos6:nfos,k))-s(i+2,k))
              endif
            endif
          enddo
          sya=sum(tall(1:7)); sycq=sum(tall(8:16)); sybc=sum(tall(17:30))
          sy1=(sya+sycq+sybc)/30.; sy2=(sya+sybc)/21.; sync_abc=max(sy1,sy2)
          sy1=(sycq+sybc)/23.; sy2=(sybc)/14.; sync_bc=max(sy1,sy2); if(sy1.gt.sy2) lcq=.true.
        else
          sybc=sum(tall(17:30)); sync_abc=sum(tall(1:7))+sybc; sync_bc=sybc/14.; sync_abc=sync_abc/21.
        endif
        sync2d(i,j)=max(sync_abc,sync_bc); if(lcq) syncq(i,j)=.true.
      enddo
    enddo
  else
!    nfos6=15 ! 16i spec bw -1
    nfos6=16
    do j=jzb,jzt
      do i=iaw,ibw
        ta=0.; tb=0.; tc=0.; tcq=0.; t0a=0.; t0b=0.; t0c=0.; t0cq=0.
        do n=0,6
          k=j+jstrt+nssy*n
          if(k.gt.0) then; ta=ta + s(i+nfos*icos7(n),k); t0a=t0a + sum(s(i:i+nfos6,k)) - s(i+nfos*icos7(n)+1,k); endif
          k36=k+nssy36
          if(k36.gt.0 .and. k36.le.NHSYM) then
            tb=tb + s(i+nfos*icos7(n),k36); t0b=t0b + sum(s(i:i+nfos6,k36)) - s(i+nfos*icos7(n)+1,k36)
          endif
          k72=k+nssy72
          if(k72.le.NHSYM) then
            tc=tc + s(i+nfos*icos7(n),k72)
            t0c=t0c + sum(s(i:i+nfos6,k72)) - s(i+nfos*icos7(n)+1,k72)
          endif
        enddo
        do n=7,15
          k=j+jstrt+nssy*n
          if(k.ge.1) then
            if(n.lt.15) then; tcq=tcq + s(i,k); t0cq=t0cq + sum(s(i:i+nfos6,k)) - s(i,k+1)
            else; tcq=tcq + s(i+2,k); t0cq=t0cq + sum(s(i:i+nfos6,k)) - s(i,k+3)
            endif
          endif
        enddo
        t1=ta+tb+tc; t01=t0a+t0b+t0c; t2=t1+tcq; t02=t01+t0cq
        t01=(t01-t1*2)/42.0; if(t01.lt.1e-8) t01=1.0; t02=(t02-t2*2)/60.0; if(t02.lt.1e-8) t02=1.0 ! safe division
        sync01=t1/(7.0*t01); sync02=(t1/7.0 + tcq/9.0)/t02; syncf=max(sync01,sync02)
        lcq=.false.; if(sync02.gt.sync01) lcq=.true.
        t1=tb+tc; t01=t0b+t0c; t2=t1+tcq; t02=t01+t0cq
        t01=(t01-t1*2)/28.0; if(t01.lt.1e-8) t01=1.0; t02=(t02-t2*2)/46.0; if(t02.lt.1e-8) t02=1.0 ! safe division
        sync01=t1/(7.0*t01); sync02=(t1/7.0 + tcq/9.0)/t02; syncs=max(sync01,sync02)
        lcq2=.false.; if(sync02.gt.sync01) lcq2=.true.
        sync2d(i,j)=max(syncf,syncs)
        if(syncf.gt.syncs) then; if(lcq) syncq(i,j)=.true.; else; if(lcq2) syncq(i,j)=.true.; endif
      enddo
    enddo
  endif

  red=0.
  do i=iaw,ibw
    ii=maxloc(sync2d(i,jzb:jzt)) - 1 + jzb
    j0=ii(1)
    jpeak(i)=j0
    red(i)=sync2d(i,j0); if(syncq(i,j0)) redcq(i)=.true.
!     write(52,3052) i*df,red(i),db(red(i))
!3052 format(3f12.3)
  enddo

  iz=ibw-iaw+1
  call indexx(red(iaw:ibw),iz,indx)
  ibase=indx(max(1,nint(0.40*iz))) - 1 + iaw ! max is workaround to prevent indx getting out of bounds
  base=red(ibase)
  if(base.lt.1e-8) base=1.0 ! safe division
  red=red/base

  candidate0=0.; k=0; iz=ib-ia+1; lpass1=.false.; lpass2=.false.
  if(rcandthin.lt.0.99) then
    if(ipass.eq.1 .or. ipass.eq.4 .or. ipass.eq.7) then; lpass1=.true.
    else if(ipass.eq.2 .or. ipass.eq.5 .or. ipass.eq.8) then; lpass2=.true.
    endif
  endif
  call indexx(red(ia:ib),iz,indx)
  do i=1,iz
    n=ia + indx(iz+1-i) - 1
    freq=n*df
    if(abs(freq-nfqso).gt.3.0) then
      if (red(n).lt.syncmin) cycle
    else
      if (red(n).lt.1.1) cycle
    endif
    if(jpeak(n).lt.-49 .or. jpeak(n).gt.76) cycle
    if(k.lt.450) then; k=k+1; else; exit; endif
! being sorted by sync
    candidate0(1,k)=freq
    candidate0(2,k)=(jpeak(n)-1)*tstep
    candidate0(3,k)=red(n)
    if(rcandthin.lt.0.99) then ! candidate thinning option
      if(lpass2) then
        candidate0(5,k)=candidate0(3,k)/(abs(candidate0(2,k)-dtcenter)+1.0)**2
      else
        candidate0(5,k)=candidate0(3,k)/(abs(candidate0(2,k)-dtcenter)+1.0)
      endif
    endif
    if(redcq(n)) candidate0(4,k)=2.
  enddo
  ncand=k

  fdif0=4.0;
  xdtdelta=0.0
! save sync only to the best of near-dupe freqs 
  do i=1,ncand
    if(i.ge.2) then
      do j=1,i-1
        fdiff=abs(candidate0(1,i)-candidate0(1,j))
        xdtdelta=abs(candidate0(2,i)-candidate0(2,j))
        if(fdiff.lt.fdif0 .and. abs(candidate0(1,i)-nfqso).gt.3.0) then
          if(xdtdelta.lt.0.1) then
            if(candidate0(3,i).ge.candidate0(3,j)) candidate0(3,j)=0.
            if(candidate0(3,i).lt.candidate0(3,j)) candidate0(3,i)=0.
          endif
        endif
      enddo
!        write(*,3001) i,candidate0(1,i-1),candidate0(1,i),candidate0(3,i-1),  &
!             candidate0(3,i)
!3001    format(i2,4f8.1)
    endif
  enddo

! Sort by sync
!  call indexx(candidate0(3,1:ncand),ncand,indx)
  if(rcandthin.gt.0.99) then; call indexx(candidate0(3,1:ncand),ncand,indx)
! sort by sync value with DT weight
  else; call indexx(candidate0(5,1:ncand),ncand,indx)
  endif
! Sort by frequency 
!  call indexx(candidate0(1,1:ncand),ncand,indx)

  k=1; ncandfqso=0
!Put nfqso at top of list and apply lowest sync threshold for nfqso
  fprev=5004.
  do i=ncand,1,-1
    j=indx(i)
    if(abs(candidate0(1,j)-nfqso).le.3.0 .and. candidate0(3,j).ge.1.1 .and. abs(candidate0(1,j)-fprev).gt.3.0) then
      candidate(1,k)=candidate0(1,j); candidate(2,k)=candidate0(2,j)
      candidate(3,k)=candidate0(3,j); candidate(4,k)=candidate0(4,j)
      fprev=candidate0(1,j)
      k=k+1; ncandfqso=ncandfqso+1
    endif
  enddo

!put virtual candidates for FT8Svar decoder
  if(lqsothread) then
    candidate(1,k)=float(nfqso)
    candidate(2,k)=5.0 ! xdt
    candidate(3,k)=0.0 ! sync
    k=k+1; ncandfqso=ncandfqso+1
    candidate(1,k)=float(nfqso)
    candidate(2,k)=-5.0
    candidate(3,k)=0.0
    k=k+1; ncandfqso=ncandfqso+1
  endif

  do i=ncand,1,-1
    j=indx(i)
    if(abs(candidate0(1,j)-nfqso).gt.3.0) then; syncmin1=syncmin; else; syncmin1=1.1; endif
    if(candidate0(3,j) .ge. syncmin1) then
      candidate(1,k)=candidate0(1,j); candidate(2,k)=candidate0(2,j)
      candidate(3,k)=candidate0(3,j); candidate(4,k)=candidate0(4,j)
      k=k+1
      if(k.gt.460) exit 
    endif
  enddo
  ncand=k-1
  if(ncand-ncandfqso.gt.1 .and. rcandthin.lt.0.99) then
! applying decoding pass weight factor, derived from number of candidates in each pass
    if(lpass1) then; rcandthin=min(rcandthin*1.27,1.0)
    else if(lpass2) then
      if(rcandthin.gt.0.79) then; rcandthin=rcandthin**2
      else; rcandthin=rcandthin*0.79
      endif
    else; rcandthin=min(rcandthin*5.0,1.0) ! ipass 3,6,9
    endif
    ncand=ncandfqso+nint((ncand-ncandfqso)*rcandthin)
  endif

  return
end subroutine sync8var

subroutine fox_tx(maxtimes,fail,called,gcalled,hm,fm,ntimes,log,logit)

! Determine fm, the next message for Fox to transmit in this slot

  character*32 fm
  character*22 hm
  character*4 g4,MyGrid,gcalled,gx,gy
  character*6 MyCall,called,cx,cy
  character*16 log
  logical isgrid,logit
  data MyCall/'KH1DX'/,MyGrid/'AJ10'/
  save

  isgrid(g4)=g4(1:1).ge.'A' .and. g4(1:1).le.'R' .and. g4(2:2).ge.'A' .and. &
       g4(2:2).le.'R' .and. g4(3:3).ge.'0' .and. g4(3:3).le.'9' .and.       &
       g4(4:4).ge.'0' .and. g4(4:4).le.'9' .and. g4(1:4).ne.'RR73'

  logit=.false.
  n=len(trim(hm))
  g4=""
  if(n.gt.8) g4=hm(n-3:n)
  call random_number(r)
  if(r.lt.fail .and. .not.isgrid(g4)) hm=""        !Fox failed to copy

  i2=len(trim(hm))
  if(i2.gt.10) then
     i1=index(hm,' ')
     i3=index(hm(i1+1:),' ') + i1
     cx=hm(i1+1:i3)
     gx=hm(i2-3:i2)
     i4=index(hm,MyCall)

! Check for a new caller
     if(i4.eq.1 .and. isgrid(gx)) then
        call random_number(r)
        isent=nint(-20+40*r)
        write(fm,1002) cx,MyCall,isent
1002    format(a6,1x,a6,i4.2)
        if(fm(15:15).eq.' ') fm(15:15)='+'
        called=cx
        gcalled=gx
     endif
     log=''

! Check for message with R+rpt
     if(i4.eq.1 .and. cx.eq.called .and.                         &
          (index(hm,'R+').ge.8 .or. index(hm,'R-').ge.8)) then
        write(log,1006) called,gcalled,isent        !Format a log entry
1006    format(a6,2x,a4,i4.2)
        if(log(14:14).eq.' ') log(14:14)='+'
        logit=.true.
        call dxped_fifo(cy,gy,isnry)
! If FIFO is empty we should call CQ in this slot
        ntimes=1
        write(fm,1008) cx,cy,isnry
1008    format(a6,' RR73; ',a6,1x,'<KH1DX>',i4.2)
        if(fm(29:29).eq.' ') fm(29:29)='+'
        called=cy
        gcalled=gy
     endif
  endif

  if(hm.eq.'') then
     if(fm(1:3).ne.'CQ ') then
!        if(ntimes.lt.maxtimes) then
           ntimes=ntimes+1
!        else
!           ntimes=1
! If FIFO is empty we should call CQ in this slot
!           call dxped_fifo(cy,gy,isnry)
!           call random_number(r)
!           isnr=nint(-20+40*r)
!           write(fm,1010) cy,gy,isnr
           write(fm,1010) called,MyCall,isent
1010       format(a6,1x,a6,i4.2)
           if(fm(15:15).eq.' ') fm(15:15)='+'
!        endif
     endif
  endif

! Collapse multiple blanks in message
  iz=len(trim(fm))
  do iter=1,5
     ib2=index(fm(1:iz),'  ')
     if(ib2.lt.1) exit
     fm=fm(1:ib2)//fm(ib2+2:)
     iz=iz-1
  enddo

! Generate waveform for fm
  return
end subroutine fox_tx

module pctile_mod
   implicit none
contains

subroutine pctile(x, npts, npct, xpct)
   use shell_mod
   implicit none

   !==== Dummy arguments =====================================================
   integer, intent(in)  :: npts, npct
   real,    intent(in)  :: x(npts)
   real,    intent(out) :: xpct

   !==== Local variables =====================================================
   real, allocatable :: tmp(:)
   integer :: j

   !==== Input validation ====================================================
   if (npts < 1 .or. npct < 0 .or. npct > 100) then
      xpct = 1.0
      return
   endif

   allocate(tmp(npts))
   tmp = x

   call shell(npts, tmp)

   j = nint(npts * 0.01 * npct)
   if (j < 1) j = 1
   if (j > npts) j = npts

   xpct = tmp(j)

   deallocate(tmp)
end subroutine pctile

end module pctile_mod

subroutine sfox_wave_gfsk(fname)

! Called by WSJT-X when it's time for SuperFox to transmit.  Reads array
! itone(1:151) from disk file 'sfox_2.dat' in the writable data directory.
! Generates a GFSK waveform with short ramp-up and ramp-down symbols of 
! duration NSPS/BT at the beginning and end of the waveform.

  parameter (NWAVE=(160+2)*134400*4) !Max WSJT-X waveform (FST4-1800 at 48kHz)
  parameter (NSYM=151,NSPS=1024*4)
  parameter (NPTS=(NSYM+2)*NSPS)
  parameter (BT=8)
  character*(*) fname
  integer itone(151)
  real*8 dt,twopi,f0,baud,phi,dphi_peak
  real*8 dphi(0:NPTS-1)
  real*8 pulse(3*NSPS)
  logical first/.true./

  common/foxcom/wave(NWAVE)
  save first,twopi,dt,hmod,dphi_peak,pulse

  if(first) then
    fsample=48000.0
    twopi=8.d0*atan(1.d0)
    dt=1.d0/fsample
    hmod=1.0
    dphi_peak=twopi*hmod/real(NSPS)
    do i=1,3*NSPS 
      tt=(i-1.5*NSPS)/real(NSPS)
      pulse(i)=gfsk_pulse(BT,tt)
    enddo
    first=.false.
  endif
  wave=0.
 
  open(25,file=trim(fname),status='unknown',err=999)
  read(25,'(20i4)',err=999,end=999) itone
  close(25)
  if(itone(1).lt.0 .or. itone(1).gt.128) go to 999

! Generate the SuperFox waveform.
  
  dphi=0.d0
  do j=1,NSYM
    ib=(j-1)*NSPS
    ie=ib+3*NSPS-1
    dphi(ib:ie)=dphi(ib:ie)+dphi_peak*pulse(1:3*NSPS)*itone(j)
  enddo
  dphi(0:2*NSPS-1)=dphi(0:2*NSPS-1)+dphi_peak*itone(1)*pulse(NSPS+1:3*NSPS)
  dphi(NSYM*NSPS:(NSYM+2)*NSPS-1)=dphi(NSYM*NSPS:(NSYM+2)*NSPS-1)+dphi_peak*itone(NSYM)*pulse(1:2*NSPS)

  phi=0.d0
  f0=750.0d0
  dphi=dphi+twopi*f0*dt
  k=0
  do j=1,NSPS*(NSYM+2)-1
    k=k+1
    wave(k)=sin(phi)
    phi=phi+dphi(j)
  enddo
  
! Add raised cosine ramps at the beginning and end of the waveform.
! Since the modulator expects an integral number of symbols, dummy
! symbols are added to the beginning and end of the waveform to 
! hold the ramps. All but nramp of the samples in each dummy
! symbol will be zero.
 
  nramp=NSPS/BT
  wave(1:NSPS-nramp)=0.0
  wave(NSPS-nramp+1:NSPS)=wave(NSPS-nramp+1:NSPS) *                   &
       (1.0-cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  k1=(NSYM+1)*NSPS+1
  wave(k1:k1+nramp-1)=wave(k1:k1+nramp-1) *                           &
       (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  wave(k1+nramp:NPTS)=0.0

999 return
end subroutine sfox_wave_gfsk

subroutine analytic(d,npts,nfft,c,pc,beq)

! Convert real data to analytic signal

  parameter (NFFTMAX=1024*1024)

  real d(npts)              ! passband signal
  real h(NFFTMAX/2)         ! real BPF magnitude
  real*8 pc(5),pclast(5)    ! static phase coeffs
  real*8 ac(5),aclast(5)    ! amp coeffs
  real*8 fp

  complex corr(NFFTMAX/2)  ! complex frequency-dependent correction 
  complex c(NFFTMAX)        ! analytic signal

  logical*1 beq            ! boolean static equalizer flag

  data nfft0/0/
  data aclast/0.0,0.0,0.0,0.0,0.0/
  data pclast/0.0,0.0,0.0,0.0,0.0/
!  data ac/1.0,0.05532,0.11438,0.12918,0.09274/ ! amp coeffs for TS2000
  data ac/1.0,0.0,0.0,0.0,0.0/ 

  save corr,nfft0,h,ac,aclast,pclast,pi,t,beta

  df=12000.0/nfft
  nh=nfft/2
  if( nfft.ne.nfft0 ) then
     pi=4.0*atan(1.0)
     t=1.0/2000.0
     beta=0.1
     do i=1,nh+1
        ff=(i-1)*df
        f=ff-1500.0
        h(i)=1.0
        if(abs(f).gt.(1-beta)/(2*t) .and. abs(f).le.(1+beta)/(2*t)) then
           h(i)=h(i)*0.5*(1+cos((pi*t/beta )*(abs(f)-(1-beta)/(2*t))))
        elseif( abs(f) .gt. (1+beta)/(2*t) ) then
           h(i)=0.0
        endif
     enddo
     nfft0=nfft
  endif

  if( any(aclast .ne. ac) .or. any(pclast .ne. pc) ) then
     aclast=ac
     pclast=pc
!     write(*,3001) pc
!3001 format('Phase coeffs:',5f12.6)
     do i=1,nh+1
        ff=(i-1)*df
        f=ff-1500.0
        fp=f/1000.0
        corr(i)=ac(1)+fp*(ac(2)+fp*(ac(3)+fp*(ac(4)+fp*ac(5))))
        pd=fp*fp*(pc(3)+fp*(pc(4)+fp*pc(5))) ! ignore 1st two terms
        corr(i)=corr(i)*cmplx(cos(pd),sin(pd))
     enddo
  endif

  fac=2.0/nfft
  c(1:npts)=fac*d(1:npts)
  c(npts+1:nfft)=0.
  call four2a(c,nfft,1,-1,1)               !Forward c2c FFT

  if( beq ) then
    c(1:nh+1)=h(1:nh+1)*corr(1:nh+1)*c(1:nh+1)
  else
    c(1:nh+1)=h(1:nh+1)*c(1:nh+1)
  endif

  c(1)=0.5*c(1)                            !Half of DC term
  c(nh+2:nfft)=0.                          !Zero the negative frequencies
  call four2a(c,nfft,1,1,1)                !Inverse c2c FFT
  return
end subroutine analytic

!
! Generate a seed for the RANDOM_NUMBER PRNG that is guaranteed to be
! unique even if many processes are started simultaneously
!
subroutine init_random_seed()
  use iso_fortran_env, only: int64
  implicit none
  integer, allocatable :: seed(:)
  integer :: i, n, un, istat, dt(8), pid
  integer(int64) :: t

  call random_seed(size = n)
  allocate(seed(n))
  ! First try if the OS provides a random number generator
  open(newunit=un, file="/dev/urandom", access="stream", &
       form="unformatted", action="read", status="old", iostat=istat)
  if (istat == 0) then
     read(un) seed
     close(un)
  else
     ! Fallback to XOR:ing the current time and pid. The PID is
     ! useful in case one launches multiple instances of the same
     ! program in parallel.
     call system_clock(t)
     if (t == 0) then
        call date_and_time(values=dt)
        t = (dt(1) - 1970) * 365_int64 * 24 * 60 * 60 * 1000 &
             + dt(2) * 31_int64 * 24 * 60 * 60 * 1000 &
             + dt(3) * 24_int64 * 60 * 60 * 1000 &
             + dt(5) * 60 * 60 * 1000 &
             + dt(6) * 60 * 1000 + dt(7) * 1000 &
             + dt(8)
     end if
     pid = getpid()
     t = ieor(t, int(pid, kind(t)))
     do i = 1, n
        seed(i) = lcg(t)
     end do
  end if
  call random_seed(put=seed)
contains
  ! This simple PRNG might not be good enough for real work, but is
  ! sufficient for seeding a better PRNG.
  function lcg(s)
    integer :: lcg
    integer(int64) :: s
    if (s == 0) then
       s = 104729
    else
       s = mod(s, 4294967296_int64)
    end if
    s = mod(s * 279470273_int64, 4294967291_int64)
    lcg = int(mod(s, int(huge(0), int64)), kind(0))
  end function lcg
end subroutine init_random_seed

subroutine save_qm(fname,revision,mycall,mygrid,dd,ntx30a,ntx30b,fcenter,  &
     nutc,ndop00,ndop58)

  parameter(NMAX=60*96000)
  character*120 fname
  character*22 revision
  character*12 mycall
  character*6 mygrid
  real*4 dd(2,NMAX)
  real*8 fcenter
  integer nxtra(15)                        !For possible future additions
  integer*1,allocatable :: id1(:,:)

  ia=1
  ib=NMAX
  if(ntx30a.gt.5) ia=NMAX/2+1
  if(ntx30b.gt.5) ib=NMAX/2
  
  sq=0.
  do i=ia,ib
     x=dd(1,i)
     y=dd(2,i)
     sq=sq + x*x + y*y
  enddo
  nsum=2*(ib-ia+1)
  rms=sqrt(sq/nsum)

  nbad=0
  dmax=0.
  fac0=10.0/rms
  allocate(id1(1:2,1:NMAX))
  
  do i=ia,ib
     x=fac0*dd(1,i)
     y=fac0*dd(2,i)
     ax=abs(x)
     ay=abs(y)
     dmax=max(dmax,ax,ay)
     if(ax.gt.127.0) then
        x=0.
        nbad=nbad+1
     endif
     if(ay.gt.127.0) then
        y=0.
        nbad=nbad+1
     endif
     id1(1,i)=nint(x)
     id1(2,i)=nint(y)
  enddo
  if(ia.gt.30*96000) id1(1:2,1:ia-1)=0
  if(ib.eq.30*96000) id1(1:2,ib+1:60*96000)=0

  open(29,file=trim(fname),status='unknown',access='stream')
  nxtra=0
  write(29) revision//'  ',mycall,mygrid,fcenter,nutc,ntx30a,ntx30b,  &
       ndop00,ndop58,ia,ib,fac0,nxtra  !Write header to disk
  write(29) id1(1:2,ia:ib)             !Write 8-bit data to disk
  close(29)
  deallocate(id1)

  return
end subroutine save_qm

subroutine agccft8(nfa,nfb,forcedt)

  use ft8_mod1, only : dd8,twopi,lagccbail
  integer, parameter :: NFFT=1024,NSZ=426,NHSYM=178,NHSTEP=960 !3413 = NFFT*5000/12000
 ! nhsym=(npts-NFFT)/nhstep !number of half-symbols 178.96(6) = (180000-8192)/(1920/2)
  real*4 x11(NFFT),w11(NFFT),ss33(NSZ),s3(NHSYM)
  real, DIMENSION(:), ALLOCATABLE :: sa33
  integer, DIMENSION(:), ALLOCATABLE :: indx
  integer, intent(in) :: nfa,nfb
  complex c11(0:NFFT/2)
  logical(1) first
  equivalence (x11,c11)
  data first/.true./
  save first,w11

  if(first) then ! FFT window
    do k=1,NFFT
      w11(k)=sin(twopi*(k+2)/2048) ! 16384 = 2*NFFT
    enddo
    first=.false.
  endif

  fac1=1.1e-3 ! 7548, 9.6e-4 7540, 9.7e-4 7546, 9.8e-4 7543, 1.0e-3 7539, 1.2e-3 7534..7538, 1.3e-3 7547, 2.4e-3 7543

  if(nfb.lt.5000) then; nfblim=nfb; else; nfblim=4999; endif ! ss33 top index protection
  nf1=NFFT*nfa/12000+1; nf2=NFFT*nfblim/12000
  nmed=(nf2-nf1)/2; nsb=nf2-nf1+1

  allocate(sa33(nsb), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(indx(nsb), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"

  do j=1,10
    i0=(j-1)*nhstep; x11=fac1*w11*dd8(i0+1:i0+NFFT)
    call four2avar(c11,NFFT,1,-1,0)                !r2c forward FFT
    do i=nf1,nf2
      s33=ABS(c11(i)); ss33(i)=SQRT(s33)
    enddo
    sa33(1:nsb)=ss33(nf1:nf2)
    call indexx(sa33(1:nsb),nsb,indx)
    smed=sa33(indx(nmed)); if(smed.gt.1.e-6) then; s3(j)=smed; else; s3(j)=1.0; endif
  enddo

  do j=169,178
    i0=(j-1)*nhstep; x11=fac1*w11*dd8(i0+1:i0+NFFT)
    call four2avar(c11,NFFT,1,-1,0)                !r2c forward FFT
    do i=nf1,nf2
      s33=ABS(c11(i)); ss33(i)=SQRT(s33)
    enddo
    sa33(1:nsb)=ss33(nf1:nf2)
    call indexx(sa33(1:nsb),nsb,indx)
    smed=sa33(indx(nmed)); if(smed.gt.1.e-6) then; s3(j)=smed; else; s3(j)=1.0; endif
  enddo

  deallocate (sa33, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
  deallocate (indx, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  s3min1=minval(s3(1:10)); s3min2=minval(s3(169:178)); s3min=min(s3min1,s3min2)
  s3max1=maxval(s3(1:10)); s3max2=maxval(s3(169:178)); s3max=max(s3max1,s3max2)
  if(s3min.lt.0.1) then; s3min=1.0; s3max=1.0; endif
  s3ratio=s3max/s3min

  lagccbail=.false.
! 2.0dB delta
  if(s3ratio.lt.1.26) then; lagccbail=.true.; return; endif

  k=1
  do j=1,10
    dd8(k:k+959)=dd8(k:k+959)/s3(j); k=k+960
  enddo
  k=1+168*960
  do j=169,178
    dd8(k:k+959)=dd8(k:k+959)/s3(j); k=k+960
  enddo
  dd8(170881:171650)=dd8(170881:171650)/s3(178); dd8(171651:180000)=0.

  return
end subroutine agccft8

module lorentzian_mod
  implicit none
contains
 subroutine lorentzian(y,npts,a)
 use fchisq0_mod
 implicit none

 ! Input:  y(npts); assume x(i)=i, i=1,npts
 ! Output: a(5)
 !         a(1) = baseline
 !         a(2) = amplitude
 !         a(3) = x0
 !         a(4) = width
 !         a(5) = chisqr

   integer, intent(in) :: npts
   real, intent(in) :: y(npts)
   real, intent(out) :: a(5)

   real :: deltaa(4)
   real :: df, width, ymax, base, stest, ssum, ww, t, fn
   real :: chisqr, chisqr0, chisq1, chisq2, chisq3, delta, tmp
   integer :: i, ipk, nterms, iter, j

   a=0.
   df=12000.0/8192.0                               !df = 1.465 Hz
   width=0.
   ipk=0
   ymax=-1.e30
   do i=1,npts
      if(y(i).gt.ymax) then
         ymax=y(i)
         ipk=i
      endif
   enddo

   base=(sum(y(1:20)) + sum(y(npts-19:npts)))/40.0
   stest=ymax - 0.5*(ymax-base)
   ssum=y(ipk)
   do i=1,50
      if(ipk+i.gt.npts) exit
      if(y(ipk+i).lt.stest) exit
      ssum=ssum + y(ipk+i)
   enddo
   do i=1,50
      if(ipk-i.lt.1) exit
      if(y(ipk-i).lt.stest) exit
      ssum=ssum + y(ipk-i)
   enddo
   ww=ssum/y(ipk)
   width=2
   t=ww*ww - 5.67
   if(t.gt.0.0) width=sqrt(t)
   a(1)=base
   a(2)=ymax-base
   a(3)=ipk
   a(4)=width

 ! Now find Lorentzian parameters

   deltaa(1)=0.1
   deltaa(2)=0.1
   deltaa(3)=1.0
   deltaa(4)=1.0
   nterms=4

 !  Start the iteration
   chisqr=0.
   chisqr0=1.e6
   do iter=1,5
      do j=1,nterms
         chisq1=fchisq0(y,npts,a)
         fn=0.
         delta=deltaa(j)
 10      a(j)=a(j)+delta
         chisq2=fchisq0(y,npts,a)
         if(chisq2.eq.chisq1) go to 10
         if(chisq2.gt.chisq1) then
            delta=-delta                      !Reverse direction
            a(j)=a(j)+delta
            tmp=chisq1
            chisq1=chisq2
            chisq2=tmp
         endif
 20      fn=fn+1.0
         a(j)=a(j)+delta
         chisq3=fchisq0(y,npts,a)
         if(chisq3.lt.chisq2) then
            chisq1=chisq2
            chisq2=chisq3
            go to 20
         endif

 ! Find minimum of parabola defined by last three points
         delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
         a(j)=a(j)-delta
         deltaa(j)=deltaa(j)*fn/3.
      enddo
      chisqr=fchisq0(y,npts,a)
      if(chisqr/chisqr0.gt.0.99) exit
      chisqr0=chisqr
   enddo
   a(5)=chisqr

   return
 end subroutine lorentzian
end module lorentzian_mod

module ft8_decode

  parameter (MAXFOX=1000)
  character*12 c2fox(MAXFOX)
  character*4  g2fox(MAXFOX)
  integer nsnrfox(MAXFOX)
  integer nfreqfox(MAXFOX)
  integer n30fox(MAXFOX)
  integer n30z
  integer nfox

  type :: ft8_decoder
     procedure(ft8_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type ft8_decoder

  abstract interface
     subroutine ft8_decode_callback (this,sync,snr,dt,freq,decoded,nap,qual)
       import ft8_decoder
       implicit none
       class(ft8_decoder), intent(inout) :: this
       real, intent(in) :: sync
       integer, intent(in) :: snr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=37), intent(in) :: decoded
       integer, intent(in) :: nap 
       real, intent(in) :: qual 
     end subroutine ft8_decode_callback
  end interface

contains

  subroutine decode(this,callback,iwave,nQSOProgress,nfqso,nftx,newdat,  &
       nutc,nfa,nfb,nzhsym,ndepth,emedelay,ncontest,nagain,lft8apon,     &
       lapcqonly,napwid,mycall12,hiscall12,ldiskdat)
    use iso_c_binding, only: c_bool, c_int
    use timer_module, only: timer
    use shmem, only: shmem_lock, shmem_unlock
    use ft8_a7

    include 'ft8/ft8_params.f90'

    class(ft8_decoder), intent(inout) :: this
    procedure(ft8_decode_callback) :: callback
    parameter (MAXCAND=1000,MAX_EARLY=200)
    real*8 tsec,tseq
    real s(NH1,NHSYM)
    real sbase(NH1)
    real candidate(3,MAXCAND)
    real dd(15*12000),dd1(15*12000)
    logical, intent(in) :: lft8apon,lapcqonly,nagain
    logical newdat,lsubtract,ldupe,lrefinedt
    logical*1 ldiskdat
    logical lsubtracted(MAX_EARLY)
    character*12 mycall12,hiscall12,call_1,call_2
    character*4 grid4
    integer*2 iwave(15*12000)
    integer apsym2(58),aph10(10)
    character datetime*13,msg37*37
    character*37 allmessages(200)
    character*12 ctime
    integer allsnrs(200)
    integer itone(NN)
    integer itone_save(NN,MAX_EARLY)
    real f1_save(MAX_EARLY)
    real xdt_save(MAX_EARLY)
    data nutc0/-1/

    save dd,dd1,nutc0,ndec_early,itone_save,f1_save,xdt_save,lsubtracted,  &
         allmessages
    
    this%callback => callback
    write(datetime,1001) nutc        !### TEMPORARY ###
1001 format("000000_",i6.6)

    if(nutc0.eq.-1) then
       msg0=' '
       dt0=0.
       f0=0.
    endif
!Added 41==nzhsym to force a reset if the same wav file is processed twice or more in a row,
!in which case nutc.eq.nutc0 and ndec(jseq,1) doesn't get reset
    if(nzhsym==41 .or. (nutc.ne.nutc0)) then
! New UTC.  Move previously saved 'a7' data from k=1 to k=0
       iz=ndec(jseq,1)
       dt0(1:iz,jseq,0)  = dt0(1:iz,jseq,1)
       f0(1:iz,jseq,0)   = f0(1:iz,jseq,1)
       msg0(1:iz,jseq,0) = msg0(1:iz,jseq,1)
       ndec(jseq,0)=iz
       ndec(jseq,1)=0
       nutc0=nutc
       dt0(:,jseq,1)=0.
       f0(:,jseq,1)=0.
    endif

    if(ndepth.eq.1 .and. nzhsym.lt.50) then
       ndec_early=0
       return
    endif
    if(ndepth.eq.1 .and. nzhsym.eq.50) then
       dd=iwave
    endif

    call ft8apset(mycall12,hiscall12,ncontest,apsym2,aph10)

    if(nzhsym.le.47) then
       dd=iwave
       dd1=dd
    endif

    if(nzhsym.eq.41) then
       ndecodes=0
       allmessages='                                     '
       allsnrs=0
    else
       ndecodes=ndec_early
    endif

    if(nzhsym.eq.47 .and. ndec_early.eq.0) then
       dd1=dd
       go to 800
    endif

    if(nzhsym.eq.47 .and. ndec_early.ge.1) then
       lsubtracted=.false.
       lrefinedt=.true.
       if(ndepth.le.2) lrefinedt=.false.
       call timer('sub_ft8b',0)
       do i=1,ndec_early
          if(xdt_save(i)-0.5.lt.0.396) then
             call subtractft8(dd,itone_save(1,i),f1_save(i),xdt_save(i),  &
                  lrefinedt)
             lsubtracted(i)=.true.
          endif
          call timestamp(tsec,tseq,ctime)
          if(.not.ldiskdat .and. tseq.ge.14.3d0) then !Bail out before done
             call timer('sub_ft8b',1)
             dd1=dd
             go to 800
          endif
       enddo
       call timer('sub_ft8b',1)
       dd1=dd
       go to 900
    endif

    if(nzhsym.eq.50 .and. ndec_early.ge.1 .and. .not.nagain) then
       n=47*3456
       dd(1:n)=dd1(1:n)
       dd(n+1:)=iwave(n+1:)
       call timer('sub_ft8c',0)
       do i=1,ndec_early
          if(lsubtracted(i)) cycle
          call subtractft8(dd,itone_save(1,i),f1_save(i),xdt_save(i),.true.)
       enddo
       call timer('sub_ft8c',1)
    endif

    ifa=nfa
    ifb=nfb
    if(nzhsym.eq.50 .and. nagain) then
       dd=iwave
       ifa=nfqso-20
       ifb=nfqso+20
    endif

! For now:
! ndepth=1: 1 pass, bp  
! ndepth=2: subtraction, 3 passes, bp+osd (no subtract refinement) 
! ndepth=3: subtraction, 3 passes, bp+osd
    npass=3
    if(ndepth.eq.1) npass=2
    do ipass=1,npass
      newdat=.true.
      syncmin=1.22
      if(ndepth.le.2) syncmin=1.6
      if(nzhsym.eq.41) syncmin=2.0
      if(ipass.eq.1) then
        lsubtract=.true.
        ndeep=ndepth
        if(ndepth.eq.3) ndeep=2
      elseif(ipass.eq.2) then
        n2=ndecodes
        if(ndecodes.eq.0) cycle
        lsubtract=.true.
        ndeep=ndepth
      elseif(ipass.eq.3) then
        if((ndecodes-n2).eq.0) cycle
        lsubtract=.true. 
        ndeep=ndepth
      endif 
      call timer('sync8   ',0)
      maxc=MAXCAND
      call sync8(dd,ifa,ifb,syncmin,nfqso,maxc,candidate,ncand,sbase)
      call timer('sync8   ',1)
      do icand=1,ncand
        sync=candidate(3,icand)
        f1=candidate(1,icand)
        xdt=candidate(2,icand)
        xbase=10.0**(0.1*(sbase(nint(f1/3.125))-40.0))
        msg37='                                     '
        call timer('ft8b    ',0)
        call ft8b(dd,newdat,nQSOProgress,nfqso,nftx,ndeep,nzhsym,lft8apon,  &
             lapcqonly,napwid,lsubtract,nagain,ncontest,iaptype,mycall12,   &
             hiscall12,f1,xdt,xbase,apsym2,aph10,nharderrors,dmin,          &
             nbadcrc,iappass,msg37,xsnr,itone)
        call timer('ft8b    ',1)
        nsnr=nint(xsnr)
        xdt=xdt-0.5
        hd=nharderrors+dmin
        if(nbadcrc.eq.0) then
           ldupe=.false.
           do id=1,ndecodes
              if(msg37.eq.allmessages(id)) ldupe=.true.
           enddo
           if(.not.ldupe) then
              ndecodes=ndecodes+1
              allmessages(ndecodes)=msg37
              allsnrs(ndecodes)=nsnr
              f1_save(ndecodes)=f1
              xdt_save(ndecodes)=xdt+0.5
              itone_save(1:NN,ndecodes)=itone
           endif
           if(.not.ldupe .and. associated(this%callback)) then
              qual=1.0-(nharderrors+dmin)/60.0 ! scale qual to [0.0,1.0]
              if(emedelay.ne.0) xdt=xdt+2.0
              call this%callback(sync,nsnr,xdt,f1,msg37,iaptype,qual)
              call ft8_a7_save(nutc,xdt,f1,msg37)  !Enter decode in table
           endif
        endif
        call timestamp(tsec,tseq,ctime)
        if(.not.ldiskdat .and. nzhsym.eq.41 .and.                        &
             tseq.ge.13.4d0) go to 800                 !Bail out before done
      enddo  ! icand
   enddo  ! ipass

800 ndec_early=0
   if(nzhsym.lt.50) ndec_early=ndecodes
   
900 continue
   if(lft8apon .and. ncontest.ne.6 .and. ncontest.ne.7 .and. nzhsym.eq.50 .and. ndec(jseq,0).ge.1) then
      newdat=.true.
      do i=1,ndec(jseq,0)
         if(f0(i,jseq,0).eq.-99.0) exit
         if(f0(i,jseq,0).eq.-98.0) cycle
         if(index(msg0(i,jseq,0),'<').ge.1) cycle      !### Temporary ###
         msg37=msg0(i,jseq,0)
         i1=index(msg37,' ')
         i2=index(msg37(i1+1:),' ') + i1
         call_1=msg37(1:i1-1)
         call_2=msg37(i1+1:i2-1)
         grid4=msg37(i2+1:i2+4)
         if(grid4.eq.'RR73' .or. index(grid4,'+').gt.0 .or.                      &
              index(grid4,'-').gt.0) grid4='    '         
         xdt=dt0(i,jseq,0)
         f1=f0(i,jseq,0)
         xbase=10.0**(0.1*(sbase(max(1,nint(f1/3.125)))-40.0))
         msg37='                                     '
         call timer('ft8_a7d ',0)
         call ft8_a7d(dd,newdat,call_1,call_2,grid4,xdt,f1,xbase,nharderrors,   &
              dmin,msg37,xsnr)
         call timer('ft8_a7d ',1)

         if(nharderrors.ge.0) then
            if(associated(this%callback)) then
               nsnr=xsnr
               iaptype=7
               qual=1.0
               call this%callback(sync,nsnr,xdt,f1,msg37,iaptype,qual)
               call ft8_a7_save(nutc,xdt,f1,msg37)  !Enter decode in table
            endif
         endif
      enddo
   endif

   return
end subroutine decode

subroutine timestamp(tsec,tseq,ctime)
  real*8 tsec,tseq
  character*12 ctime
  integer itime(8)
  call date_and_time(values=itime)
  tsec=3600.d0*(itime(5)-itime(4)/60.d0) + 60.d0*itime(6) +      &
       itime(7) + 0.001d0*itime(8)
  tsec=mod(tsec+2*86400.d0,86400.d0)
  tseq=mod(itime(7)+0.001d0*itime(8),15.d0)
  if(tseq.lt.10.d0) tseq=tseq+15.d0
  sec=itime(7)+0.001*itime(8)
  write(ctime,1000) itime(5)-itime(4)/60,itime(6),sec
1000 format(i2.2,':',i2.2,':',f6.3)
  if(ctime(7:7).eq.' ') ctime(7:7)='0'
  return
end subroutine timestamp

end module ft8_decode

program count4

  parameter(NMAX=1000)
  character*47 line
  real snr(NMAX)
  real dt(NMAX)
  real f(NMAX)

  open(10,file='/users/joe/appdata/local/wsjt-x/all.txt',status='old')

  read(10,1000,end=10) line
1000 format(a47)

  nsync1=0
  nsync2=0
  n1=0
  n2=0
  nerr=0

  do i=1,99999
     read(10,1000,end=10) line
     if(line(47:47).ne.' ') cycle                !Skip average decodes
     if(line(20:20).eq.'*') nsync1=nsync1+1
     if(line(20:20).eq.'#') nsync2=nsync2+1
     if(line(22:34).eq.'CQ K1ABC FN42') then
        n2=n2+1                                  !Correlation decode
        read(line,1002) snr(n2),dt(n2),f(n2)
1002    format(4x,f4.0,f5.2,f5.0)
        if(line(42:42).eq.'*') n1=n1+1           !Convolutional decode
     else
        if(line(22:34).ne.'             ') nerr=nerr+1
     endif
  enddo

10 call stats(snr,n2,snrave,snrdev)
  call stats(dt,n2,dtave,dtdev)
  call stats(f,n2,fave,fdev)

write(*,1010) nsync1,nsync2,n1,n2,nerr,snrave,dtave,fave,snrdev,dtdev,fdev
1010 format(5i5,f7.1,f7.2,f7.0/25x,f7.1,f7.2,f7.0)

end program count4

subroutine stats(x,nz,ave,rms)
  real x(nz)

  ave=0.
  rms=0.
  if(nz.gt.0) ave=sum(x)/nz
  x=x-ave
  if(nz.gt.1) rms=sqrt(dot_product(x,x)/(nz-1))

  return
end subroutine stats

program EMEchart

  ! Working together with 'gnuplot', this program produces annual
  ! Moon Ephemeris Charts useful for planning EME activity.
  ! Copyright by Joe Taylor, K1JT, and licensed for use by anyone
  ! under terms of the General Public License, GPLv3.

  ! In a bash shell, with gfortran and gnuplot accessible in your PATH:
  ! $ gfortran -o EMEchart -static EMEchart.f90
  ! $ 

  character arg*8,line*120,cmnd*20,path*256
  integer moday(12)
  logical leap,lsun,lsgr
  data moday/31,28,31,30,31,30,31,31,30,31,30,32/  !Include Jan of next year
  data rasgr/266.8/,decsgr/-29.0/                  !RA, Dec of Sgr A

  narg=iargc()
  if(narg.ne.1) then
     print*,'Usage: EMEchart <year>'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nyear
  leap=.false.
  if(mod(nyear,4).eq.0) then
     leap=.true.                               !This is a leap year
     moday(2)=29
  endif

  open(10,file='EMEchart.in',status='old')      !Bare bones gnuplot script
  open(11,file='EMEchart.plt',status='unknown') !Finished gnuplot script
  write(11,1000) nyear
1000 format('set output "EMEchart_',i4,'.pdf"')
  write(11,1002) nyear
1002 format('set title "Moon Ephemeris for ',i4,  &
          ', by K1JT" offset 0,2 font "Sans Bold,16"')

  id=0                                         !id is day of year
  imo1=1
  do i=1,999
     read(10,'(a120)',end=999) line
     if(leap .and. (line(1:17).eq.'set xrange [1:91]')) line='set xrange [1:92]'
     if(leap .and. (line(1:19).eq.'set xrange [91:182]')) line='set xrange [92:183]'
     if(leap .and. (line(1:20).eq.'set xrange [182:274]')) line='set xrange [183:275]'
     if(leap .and. (line(1:20).eq.'set xrange [274:366]')) line='set xrange [275:367]'
     write(11,'(a)') trim(line)
     if(line(1:9).eq.'# Weekend') then
        call labobj(imo1,imo1+2)
        imo1=imo1+3
     endif
  enddo
  
999 continue

contains

subroutine labobj(imo1,imo2)

  character line*256,ticpos*7

  nlab=10
  nobj=0
  line=''
  do imo=imo1,imo2
     do iday=1,moday(imo)
        id=id+1
        do iut=0,1
           uth=iut*12.0
           call sun0(nyear,1,id,uth,mjd,rasun,decsun)
           call moon0(nyear,1,id,uth,ramoon,decmoon,dist)
           extra_loss=10.0*log10((356000.0/dist)**4)
           x=rasun-ramoon
           if(x.gt.180.0) x=x-360.0
           if(x.lt.-180.0) x=x+360.0
           x=x/cos((decsun+decmoon)/(2.0*57.2957795))
           y=decsun-decmoon
           sunmoon=sqrt(x*x + y*y)
           x=rasgr-ramoon
           if(x.gt.180.0) x=x-360.0
           if(x.lt.-180.0) x=x+360.0
           x=x/cos((decsun+decmoon)/(2.0*57.2957795))
           y=decsgr-decmoon
           sgrmoon=sqrt(x*x + y*y)
           lsun=sunmoon.lt.10.0
           lsgr=sgrmoon.lt.10.0
           day=id + uth/24.0
           write(14,1010) day,nyear,imo,iday,decmoon,extra_loss,sunmoon,sgrmoon
1010       format(f6.2,i6,2i3.2,4f8.2)
           if(lsun)  write(15,1020) day,decmoon
1020       format(f6.2,f7.2)
           if(lsgr)  write(16,1020) day,decmoon
           if(iut.eq.0 .and. mod(mjd,7).eq.3) then
              nlab=nlab+1
              if(iday.lt.10) write(11,1030) nlab,iday,id
1030          format('set label',i3,' "',i1,'" at',i4,',32 center font "Sans,10"')
              if(iday.ge.10) write(11,1040) nlab,iday,id
1040          format('set label',i3,' "',i2,'" at',i4,',32 center font "Sans,10"')
              nobj=nobj+1
              write(11,1050) nobj,id+1
1050          format('set object',i3,' rectangle center',i4,  &
                   ',28.0 size 2,4 fc rgb "green" fs solid 0.5')
              write(ticpos,1060) id
1060          format('""',i4,',')
              line=trim(line)//ticpos
              write(ticpos,1060) id+2
              line=trim(line)//ticpos
           endif
        enddo
     enddo
  enddo
  n=len(trim(line))
  line(n:n)=')'
  line='set xtics ('//trim(line)
  write(11,'(a)') trim(line)

  return
end subroutine labobj

end program EMEchart

subroutine sun0(y,m,DD,UT,mjd,RA,Dec)

  implicit none

  integer y                         !Year
  integer m                         !Month
  integer DD                        !Day
  integer mjd                       !Modified Julian Date
  real UT                           !UTC in hours
  real RA,Dec                       !RA and Dec of sun

! NB: Double caps here are single caps in the writeup.

! Orbital elements of the Sun (also N=0, i=0, a=1):
  real w                            !Argument of perihelion
  real e                            !Eccentricity
  real MM                           !Mean anomaly
  real Ls                           !Mean longitude

! Other standard variables:
  real v                            !True anomaly
  real EE                           !Eccentric anomaly
  real ecl                          !Obliquity of the ecliptic
  real d                            !Ephemeris time argument in days
  real r                            !Distance to sun, AU
  real xv,yv                        !x and y coords in ecliptic
  real lonsun                       !Ecliptic long and lat of sun
! Ecliptic coords of sun (geocentric)
  real xs,ys
! Equatorial coords of sun (geocentric)
  real xe,ye,ze
  real rad
  data rad/57.2957795/

! Time in days, with Jan 0, 2000 equal to 0.0:
  d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + DD - 730530 + UT/24.0
  mjd=d + 51543
  ecl = 23.4393 - 3.563e-7 * d

! Compute updated orbital elements for Sun:
  w = 282.9404 + 4.70935e-5 * d
  e = 0.016709 - 1.151e-9 * d
  MM = mod(356.0470d0 + 0.9856002585d0 * d + 360000.d0,360.d0)
  Ls = mod(w+MM+720.0,360.0)

  EE = MM + e*rad*sin(MM/rad) * (1.0 + e*cos(M/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.0 - e*cos(EE/rad))

  xv = cos(EE/rad) - e
  yv = sqrt(1.0-e*e) * sin(EE/rad)
  v = rad*atan2(yv,xv)
  r = sqrt(xv*xv + yv*yv)
  lonsun = mod(v + w + 720.0,360.0)
! Ecliptic coordinates of sun (rectangular):
  xs = r * cos(lonsun/rad)
  ys = r * sin(lonsun/rad)

! Equatorial coordinates of sun (rectangular):
  xe = xs
  ye = ys * cos(ecl/rad)
  ze = ys * sin(ecl/rad)

! RA and Dec in degrees:
  RA = rad*atan2(ye,xe)
  Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))

  return
end subroutine sun0

subroutine moon0(y,m,Day,UT4,RA4,Dec4,dist4)

  implicit none

  integer y                           !Year
  integer m                           !Month
  integer Day                         !Day
  real*4 UT4,RA4,Dec4,dist4
  real*8 UT                           !UTC in hours
  real*8 RA,Dec                       !RA and Dec of moon

! NB: Double caps are single caps in the writeup.

  real*8 NN                           !Longitude of ascending node
  real*8 i                            !Inclination to the ecliptic
  real*8 w                            !Argument of perigee
  real*8 a                            !Semi-major axis
  real*8 e                            !Eccentricity
  real*8 MM                           !Mean anomaly

  real*8 v                            !True anomaly
  real*8 EE                           !Eccentric anomaly
  real*8 ecl                          !Obliquity of the ecliptic

  real*8 d                            !Ephemeris time argument in days
  real*8 r                            !Distance to sun, AU
  real*8 xv,yv                        !x and y coords in ecliptic
  real*8 lonecl,latecl                !Ecliptic long and lat of moon
  real*8 xg,yg,zg                     !Ecliptic rectangular coords
  real*8 Ms                           !Mean anomaly of sun
  real*8 ws                           !Argument of perihelion of sun
  real*8 Ls                           !Mean longitude of sun (Ns=0)
  real*8 Lm                           !Mean longitude of moon
  real*8 DD                           !Mean elongation of moon
  real*8 FF                           !Argument of latitude for moon
  real*8 xe,ye,ze                     !Equatorial geocentric coords of moon
  real*8 dist
  real*8 rad,twopi
  data rad/57.2957795131d0/,twopi/6.283185307d0/

  UT=UT4
  d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + Day - 730530 + UT/24.d0
  ecl = 23.4393d0 - 3.563d-7 * d

! Orbital elements for Moon:  
  NN = 125.1228d0 - 0.0529538083d0 * d
  i = 5.1454d0
  w = mod(318.0634d0 + 0.1643573223d0 * d + 360000.d0,360.d0)
  a = 60.2666d0
  e = 0.054900d0
  MM = mod(115.3654d0 + 13.0649929509d0 * d + 360000.d0,360.d0)

  EE = MM + e*rad*sin(MM/rad) * (1.d0 + e*cos(MM/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.d0 - e*cos(EE/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.d0 - e*cos(EE/rad))

  xv = a * (cos(EE/rad) - e)
  yv = a * (sqrt(1.d0-e*e) * sin(EE/rad))

  v = mod(rad*atan2(yv,xv)+720.d0,360.d0)
  r = sqrt(xv*xv + yv*yv)

! Get geocentric position in ecliptic rectangular coordinates:

  xg = r * (cos(NN/rad)*cos((v+w)/rad)-sin(NN/rad)*sin((v+w)/rad)*cos(i/rad))
  yg = r * (sin(NN/rad)*cos((v+w)/rad)+cos(NN/rad)*sin((v+w)/rad)*cos(i/rad))
  zg = r * (sin((v+w)/rad)*sin(i/rad))

! Ecliptic longitude and latitude of moon:
  lonecl = mod(rad*atan2(yg/rad,xg/rad)+720.d0,360.d0)
  latecl = rad*atan2(zg/rad,sqrt(xg*xg + yg*yg)/rad)

! Now include orbital perturbations:
  Ms = mod(356.0470d0 + 0.9856002585d0 * d + 3600000.d0,360.d0)
  ws = 282.9404d0 + 4.70935d-5*d
  Ls = mod(Ms + ws + 720.d0,360.d0)
  Lm = mod(MM + w + NN+720.d0,360.d0)
  DD = mod(Lm - Ls + 360.d0,360.d0)
  FF = mod(Lm - NN + 360.d0,360.d0)

  lonecl = lonecl                                &
       - 1.274d0 * sin((MM-2.d0*DD)/rad)         &
       + 0.658d0 * sin(2.d0*DD/rad)              &
       - 0.186d0 * sin(Ms/rad)                   &
       - 0.059d0 * sin((2.d0*MM-2.d0*DD)/rad)    &
       - 0.057d0 * sin((MM-2.d0*DD+Ms)/rad)      &
       + 0.053d0 * sin((MM+2.d0*DD)/rad)         &
       + 0.046d0 * sin((2.d0*DD-Ms)/rad)         &
       + 0.041d0 * sin((MM-Ms)/rad)              &
       - 0.035d0 * sin(DD/rad)                   &
       - 0.031d0 * sin((MM+Ms)/rad)              &
       - 0.015d0 * sin((2.d0*FF-2.d0*DD)/rad)    &
       + 0.011d0 * sin((MM-4.d0*DD)/rad)

  latecl = latecl                                &
       - 0.173d0 * sin((FF-2.d0*DD)/rad)         &
       - 0.055d0 * sin((MM-FF-2.d0*DD)/rad)      &
       - 0.046d0 * sin((MM+FF-2.d0*DD)/rad)      &
       + 0.033d0 * sin((FF+2.d0*DD)/rad)         &
       + 0.017d0 * sin((2.d0*MM+FF)/rad)

  r = 60.36298d0                                 &
       - 3.27746d0*cos(MM/rad)                   &
       - 0.57994d0*cos((MM-2.d0*DD)/rad)         &
       - 0.46357d0*cos(2.d0*DD/rad)              &
       - 0.08904d0*cos(2.d0*MM/rad)              &
       + 0.03865d0*cos((2.d0*MM-2.d0*DD)/rad)    &
       - 0.03237d0*cos((2.d0*DD-Ms)/rad)         &
       - 0.02688d0*cos((MM+2.d0*DD)/rad)         &
       - 0.02358d0*cos((MM-2.d0*DD+Ms)/rad)      &
       - 0.02030d0*cos((MM-Ms)/rad)              &
       + 0.01719d0*cos(DD/rad)                   &
       + 0.01671d0*cos((MM+Ms)/rad)
  
  dist=r*6378.140d0

! Geocentric coordinates:
! Rectangular ecliptic coordinates of the moon:

  xg = r * cos(lonecl/rad)*cos(latecl/rad)
  yg = r * sin(lonecl/rad)*cos(latecl/rad)
  zg = r *                 sin(latecl/rad)

! Rectangular equatorial coordinates of the moon:
  xe = xg
  ye = yg*cos(ecl/rad) - zg*sin(ecl/rad)
  ze = yg*sin(ecl/rad) + zg*cos(ecl/rad)
   
! Right Ascension, Declination:
  RA = mod(rad*atan2(ye,xe)+360.d0,360.d0)
  Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))

  RA4=RA
  Dec4=Dec
  dist4=dist

  return
end subroutine moon0

subroutine cwfilter(first)

  use ft8_mod1, only : cw,windowc1,windowx,pivalue,facx,mcq,m73,mrr73,mrrr,one,twopi,facc1,dt,csync,idtone25,csynccq, &
                       NFILT1,NFILT2,endcorr,ctwkw,ctwkn,ctwk256
  use jt65_mod9 ! callsign DB to memory
  use prog_args ! path to files

  parameter (NFFT=180000)
  complex csig0(151680)
  real*4 window1(-NFILT1/2:NFILT1/2),window2(-NFILT2/2:NFILT2/2)
  character*37 msgcq25(25),msgsent37
  integer itone(79)
  integer*1 msgbits(77)
  logical, intent(in) :: first

!pushing callsigns from ALLCALL to memory
!note that with new, larger ALLCALL7.TXT files, dimensions of various ncall arrays may need to be increased in jt65_mod9.f90
!on 20250709 callj dim was increased from 9000 to 10000 when updated ALLCALL7.TXT file was added
  if(first) then
    open(24,file='ALLCALL7.TXT',status='unknown') ! accepting Australian 7-char callsigns
    do i=1,MAXC
      read(24,1004,end=20) line
1004  format(a80)
      if(line(1:4).eq.'ZZZZ') exit
      if(line(1:2).eq.'//') cycle
      i1=index(line,',')
      if(i1.lt.4 .or. i1.gt.8) cycle
      callsign=line(1:i1-1)
      if(callsign(1:1).gt.'0' .and. callsign(1:1).lt.'D') then; ncall0c=ncall0c+1; call0c(ncall0c)=callsign(1:7)
      else if(callsign(1:1).gt.'C' .and. callsign(1:1).lt.'E') then; ncalld=ncalld+1; calld(ncalld)=callsign(1:7)
      else if(callsign(1:1).gt.'D' .and. callsign(1:1).lt.'G') then; ncallef=ncallef+1; callef(ncallef)=callsign(1:7)
      else if(callsign(1:1).gt.'F' .and. callsign(1:1).lt.'I') then; ncallgh=ncallgh+1; callgh(ncallgh)=callsign(1:7)
      else if(callsign(1:1).gt.'H' .and. callsign(1:1).lt.'J') then; ncalli=ncalli+1; calli(ncalli)=callsign(1:7)
      else if(callsign(1:1).gt.'I' .and. callsign(1:1).lt.'K') then; ncallj=ncallj+1; callj(ncallj)=callsign(1:7)
      else if(callsign(1:1).gt.'J' .and. callsign(1:1).lt.'L') then; ncallk=ncallk+1; callk(ncallk)=callsign(1:7)
      else if(callsign(1:1).gt.'K' .and. callsign(1:1).lt.'N') then; ncalllm=ncalllm+1; calllm(ncalllm)=callsign(1:7)
      else if(callsign(1:1).gt.'M' .and. callsign(1:1).lt.'O') then; ncalln=ncalln+1; calln(ncalln)=callsign(1:7)
      else if(callsign(1:1).gt.'N' .and. callsign(1:1).lt.'P') then; ncallo=ncallo+1; callo(ncallo)=callsign(1:7)
      else if(callsign(1:1).gt.'O' .and. callsign(1:1).lt.'R') then; ncallpq=ncallpq+1; callpq(ncallpq)=callsign(1:7)
      else if(callsign(1:1).gt.'Q' .and. callsign(1:1).lt.'S') then; ncallr=ncallr+1; callr(ncallr)=callsign(1:7)
      else if(callsign(1:1).gt.'R' .and. callsign(1:1).lt.'U') then; ncallst=ncallst+1; callst(ncallst)=callsign(1:7)
      else if(callsign(1:1).gt.'T' .and. callsign(1:1).lt.'W') then; ncalluv=ncalluv+1; calluv(ncalluv)=callsign(1:7)
      else if(callsign(1:1).gt.'V' .and. callsign(1:1).lt.'X') then; ncallw=ncallw+1; callw(ncallw)=callsign(1:7)
      else if(callsign(1:1).gt.'W' .and. callsign(1:1).le.'Z') then; ncallxz=ncallxz+1; callxz(ncallxz)=callsign(1:7)
      endif
    enddo
20  close(24)
!print *,ncall0c,"call0c"; print *,ncalld,"calld"; print *,ncallef,"callef"; print *,ncallgh,"callgh"
!print *,ncalli,"calli"; print *,ncallj,"callj"; print *,ncallk,"callk"; print *,ncalllm,"calllm"
!print *,ncalln,"calln"; print *,ncallo,"callo"; print *,ncallpq,"callpq"; print *,ncallr,"callr"
!print *,ncallst,"callst"; print *,ncalluv,"calluv"; print *,ncallw,"callw"; print *,ncallxz,"callxz"
    if(ncall0c.lt.1 .or. ncalld.lt.1 .or. ncallef.lt.1 .or. ncallgh.lt.1 .or. ncalli.lt.1 .or. ncallj.lt.1 .or. &
       ncallk.lt.1 .or. ncalllm.lt.1 .or. ncalln.lt.1 .or. ncallo.lt.1 .or. ncallpq.lt.1 .or. ncallr.lt.1 .or.  &
       ncallst.lt.1 .or. ncalluv.lt.1 .or. ncallw.lt.1 .or. ncallxz.lt.1) then
      ldbvalid=.false.
      write(*,4) 'ALLCALL7.TXT is too short or broken?','d' ! 50th position for "d"
4     format(a36,13x,a1)
      call flush(6)
    endif

    pivalue=4.d0*atan(1.d0)
    twopi=8.d0*atan(1.d0)
    dt=1.d0/12000.d0

    do i=0,54; windowc1(i)=(1.0+cos(i*pivalue/55))/2; enddo
    facx=1.0/300.0
    do i=0,200
      windowx(i)=(1.0+cos(i*pivalue/200))/2
    enddo
    windowx=facx*windowx
    facc1=0.01/sqrt(61440.) ! 1.0/sqrt(192000.*3200.) NFFT1*NFFT2

    mcq=2*mcq-1
    mrrr=2*mrrr-1
    m73=2*m73-1
    mrr73=2*mrr73-1

    one=.false.
    do i=0,511
      do j=0,8
        if(iand(i,2**j).ne.0) one(i,j)=.true.
      enddo
    enddo

    msgcq25=''
    msgcq25(2)='CQ 2E0DLA IO92'
    msgcq25(3)='CQ BH3NEB ON81'
    msgcq25(4)='CQ CG3CGT FN04'
    msgcq25(5)='CQ DX CT1JA IM59'
    msgcq25(6)='CQ CU20E'
    msgcq25(7)='CQ NA CX1OB GF14'
    msgcq25(8)='CQ DF2AJ JN49'
    msgcq25(9)='CQ DG4XPZ JN58'
    msgcq25(10)='CQ EA8XR IL19'
    msgcq25(11)='CQ F1YE IN94'
    msgcq25(12)='CQ DX G1KLN IO82'
    msgcq25(13)='CQ HL2KVF PM38'
    msgcq25(14)='CQ IU1ZSV JN45'
    msgcq25(15)='CQ JG1TWO PM96'
    msgcq25(16)='CQ K2ST EM96'
    msgcq25(17)='CQ N9TUX EL98'
    msgcq25(18)='CQ SA NO2FA FM18'
    msgcq25(19)='CQ OH6GKE KP13'
    msgcq25(20)='CQ PD0ORM JO24'
    msgcq25(21)='CQ DX PT7DS HI06'
    msgcq25(22)='CQ RA3XEP KO84'
    msgcq25(23)='CQ SM2GSH KP05'
    msgcq25(24)='CQ UA9OHX NO15'
    msgcq25(25)='CQ JA W0YH EN12'
    do i=2,25
      i3=-1; n3=-1
      call genft8sdvar(msgcq25(i),i3,n3,msgsent37,msgbits,itone)
      if(i.eq.2) then
        call gen_ft8wave(itone,79,1920,2.0,12000.0,0.0,csig0,xjunk,1,151680)
        m=1
        do j=0,14
          do k=1,32
            if(j.lt.7) then; csync(j,k)=csig0(m); else; csynccq(j-7,k)=csig0(m); endif
            m=m+60
          enddo
        enddo
      endif
      idtone25(i,1:29)=itone(8:36)
      idtone25(i,30:58)=itone(44:72)
    enddo
    dt2=0.005 ! fs2=200 Hz
    k=1
    do ifr=-5,5                              !Search over +/- 2.5 Hz
      delf=ifr*0.5
      dphi=twopi*delf*dt2
      phi=0.0
      do i=1,32
        ctwkw(k,i)=cmplx(cos(phi),sin(phi))
        phi=mod(phi+dphi,twopi)
      enddo
      k=k+1
    enddo
    k=1
    do ifr=-5,5                              !Search over +/- 1.25 Hz
      delf=ifr*0.25
      dphi=twopi*delf*dt2
      phi=0.0
      do i=1,32
        ctwkn(k,i)=cmplx(cos(phi),sin(phi))
        phi=mod(phi+dphi,twopi)
      enddo
      k=k+1
    enddo
! lcqsignal
    delf=3.125
    dphi=twopi*delf*dt2
    phi=0.0
    do i=1,256
      ctwk256(i)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
    enddo
  endif

! this filter is being used for signal subtraction
! Create and normalize the filter
  if(first) then
    fac=1.0/float(nfft)
    sumw=0.0
    do j=-NFILT1/2,NFILT1/2
       window1(j)=cos(pivalue*j/NFILT1)**2
       sumw=sumw+window1(j)
    enddo
    cw=0.
    cw(1:NFILT1+1)=window1/sumw
    cw=cshift(cw,NFILT1/2+1)
    do j=1,NFILT1/2+1
      endcorr(j)=1.0/(1.0-sum(window1(j-1:NFILT1/2))/sumw)
    enddo
    call four2avar(cw,NFFT,1,-1,1)
    cw=cw*fac
  endif

  return  
end subroutine cwfilter
  

subroutine mixlpf(x1,nbfo,c0)

  real*4 x1(512)
  real*8 twopi,phi,dphi
  complex c1(512),c2(105+512)
  complex c0(64)
  data phi/0.d0/
  save phi,c2

  twopi=8.d0*atan(1.d0)
  dphi=twopi*nbfo/12000.d0
  
  do i=1,512
     phi=phi+dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     c1(i)=x1(i)*cmplx(cos(xphi),sin(xphi))
  enddo
  c2(106:105+512)=c1
  
  call fil3c(c2,105+512,c0,n2)
  c2(1:105)=c1(512-104:512)                       !Save 105 trailing samples

  return
end subroutine mixlpf

subroutine genft8sdvar(msg,i3,n3,msgsent,msgbits,itone)

! Encode an FT8 message, producing array itone().
  
  use packjt77sdvar
  use ft8_mod1, only : icos7,graymap
  character msg*37,msgsent*37,c77*77
  integer*1 msgbits(77),codeword(174)
  integer itone(79)
  logical unpk77_successvar

  i3=-1
  n3=-1
  call pack77sdvar(msg,i3,n3,c77)
  call unpack77sdvar(c77,msgsent,unpk77_successvar)
  read(c77,'(77i1)',err=1) msgbits
  if(unpk77_successvar) go to 2
1 msgbits=0
  itone=0
  msgsent='*** bad message ***                  '
  go to 900

2  call encode174_91var(msgbits,codeword)      !Encode the test message

! Message structure: S7 D29 S7 D29 S7
  itone(1:7)=icos7; itone(37:43)=icos7; itone(73:79)=icos7
  k=7
  do j=1,58
     i=3*j -2
     k=k+1
     if(j.eq.30) k=k+7
     indx=codeword(i)*4 + codeword(i+1)*2 + codeword(i+2)
     itone(k)=graymap(indx)
  enddo

900 return
end subroutine genft8sdvar

module sort_mod
  implicit none
contains
  subroutine sort(n,arr)
    implicit none
    integer, intent(in) :: n
    real, intent(inout) :: arr(n)
    real :: tmp(n) ! tmp is likely used by ssort as workspace?
    ! Original call: call ssort(arr,tmp,n,1)
    ! ssort usually needs a workspace or index array.
    ! Assuming external ssort.
    
    call ssort(arr,tmp,n,1)
    
  end subroutine sort
end module sort_mod

subroutine softsym9f(ss2,ss3,i1SoftSymbols)

! Compute soft symbols and S/N

  real ss2(0:8,85)
  real ss3(0:7,69)
  integer*1 i1SoftSymbolsScrambled(207)
  integer*1 i1SoftSymbols(207)

  ss=0.
  sig=0.
  if(ss2(0,1).eq.-999.0) return       !Silence compiler warning
  do j=1,69
     smax=0.
     do i=0,7
        smax=max(smax,ss3(i,j))
        ss=ss+ss3(i,j)
     enddo
     sig=sig+smax
     ss=ss-smax
  enddo
  ave=ss/(69*7)                       !Baseline
!  call pctile(ss2,9*85,35,xmed)                       !### better? ###
  ss3=ss3/ave
  sig=sig/69.                         !Signal

  m0=3
  k=0
  scale=10.0
  do j=1,69
     do m=m0-1,0,-1                   !Get bit-wise soft symbols
        if(m.eq.2) then
           r1=max(ss3(4,j),ss3(5,j),ss3(6,j),ss3(7,j))
           r0=max(ss3(0,j),ss3(1,j),ss3(2,j),ss3(3,j))
        else if(m.eq.1) then
           r1=max(ss3(2,j),ss3(3,j),ss3(4,j),ss3(5,j))
           r0=max(ss3(0,j),ss3(1,j),ss3(6,j),ss3(7,j))
        else
           r1=max(ss3(1,j),ss3(2,j),ss3(4,j),ss3(7,j))
           r0=max(ss3(0,j),ss3(3,j),ss3(5,j),ss3(6,j))
        endif

        k=k+1
        i4=nint(scale*(r1-r0))
        if(i4.lt.-127) i4=-127
        if(i4.gt.127) i4=127
        i1SoftSymbolsScrambled(k)=i4
     enddo
  enddo


  call interleave9(i1SoftSymbolsScrambled,-1,i1SoftSymbols)

  return
end subroutine softsym9f

subroutine wspr_downsample(id2,k)

! Input:
!  id2       raw 16-bit integer data, 12000 Hz sample rate
!  k         pointer to the most recent new data

! Output (in common/c0com)
!  c0        complex data downsampled to 1500 Hz

  parameter (NMAX=120*12000)         !Total sample intervals per 30 minutes
  parameter (NDMAX=120*1500)         !Sample intervals at 1500 Hz rate
  parameter (NSMAX=1366)             !Max length of saved spectra
  parameter (NFFT1=1024)
  parameter (MAXFFT3=32768)
  real*4 w3(MAXFFT3)
  real*4 x0(NFFT1)
  real*4 x2(NFFT1+105)
  real*4 ssum(NSMAX)
  integer*2 id2(NMAX)
  complex c0
  common/c0com/c0(NDMAX)
  data rms/999.0/,k0/99999999/,nfft3z/0/,nsps/8192/,nbfo/1500/
  save

  nfft3=nsps/4
  jstep=nsps/16
  if(k.gt.NMAX) go to 999
  if(k.lt.nfft3) go to 999                   !Wait for enough samples to start
  if(nfft3.ne.nfft3z) then
     pi=4.0*atan(1.0)
     do i=1,nfft3
        w3(i)=2.0*(sin(i*pi/nfft3))**2             !Window for nfft3
     enddo
     nfft3z=nfft3
  endif

  if(k.lt.k0) then
     ja=0
     ssum=0.
     k1=0
     k8=0
     x2=0.
!     if(ndiskdat.eq.0) then
!        id2(k+1:)=0
!        c0=0.          !This is necessary to prevent "ghosts".  Not sure why.
!     endif
  endif
  k0=k
 
  nzap=0
  nbslider=0
  sigmas=1.0*(10.0**(0.01*nbslider)) + 0.7
  peaklimit=sigmas*max(10.0,rms)
  px=0.

  nwindow=2
  kstep1=NFFT1
  if(nwindow.ne.0) kstep1=NFFT1/2
  fac=2.0/NFFT1
  nblks=(k-k1)/kstep1
  gain=1.0
  nb=0
  do nblk=1,nblks
     do i=1,NFFT1
        x0(i)=gain*id2(k1+i)
     enddo
!     call timf2(x0,k,NFFT1,nwindow,nb,peaklimit,x1,   &
!          slimit,lstrong,px,nzap)
! Mix at nbfo Hz, lowpass at +/-750 Hz, and downsample to 1500 Hz complex.
     call mixlpf(x0,nbfo,c0(k8+1))
     k1=k1+kstep1
     k8=k8+kstep1/8
  enddo

999 return
end subroutine wspr_downsample

program ft2

  use packjt77
  include 'gcom1.f90'
  integer ft2audio,ptt
  logical allok
  character*20 pttport
  character*8 arg
  character*80 fname
  integer*2 id2(30000)

  open(12,file='all_ft2.txt',status='unknown',position='append')
  nargs=iargc()
  if(nargs.eq.1) then
     call getarg(1,fname)
     open(10,file=fname,status='old',access='stream')
     read(10) id2(1:22)  !Read (and ignore) the header
     read(10) id2        !Read the Rx data
     close(10)
     call ft2_decode(fname(1:17),nfqso,id2,ndecodes,mycall,hiscall,nrx)
     go to 999
  endif
  
  allok=.true.
! Get home-station details
  open(10,file='ft2.ini',status='old',err=1)
  go to 2
1 print*,'Cannot open ft2.ini'
  allok=.false.
2 read(10,*,err=3) mycall,mygrid,ndevin,ndevout,pttport,exch
  go to 4
3 print*,'Error reading ft2.ini'
  allok=.false.
4 if(index(pttport,'/').lt.1) read(pttport,*) nport
  hiscall='      '
  hiscall_next='      '
  idevin=ndevin
  idevout=ndevout
  call padevsub(idevin,idevout)
  if(idevin.ne.ndevin .or. idevout.ne.ndevout) allok=.false.
  i1=0
  i1=ptt(nport,1,1,iptt)
  i1=ptt(nport,1,0,iptt)
  if(i1.lt.0 .and. nport.ne.0) allok=.false.
  if(.not.allok) then
     write(*,"('Please fix setup error(s) and restart.')")
     go to 999
  endif

  nright=1
  iwrite=0
  iwave=0
  nwave=NTZ
  nfsample=12000
  ngo=1
  npabuf=1152
  ntxok=0
  ntransmitting=0
  tx_once=.false.
  snrdb=99.0
  txmsg='CQ K1JT FN20'
  ltx=.false.
  lrx=.false.
  autoseq=.false.
  QSO_in_progress=.false.
  ntxed=0

  if(nargs.eq.3) then
     call getarg(1,txmsg)
     call getarg(2,arg)
     read(arg,*) f0
     call getarg(3,arg)
     read(arg,*) snrdb
     tx_once=.true.
     ftx=1500.0
     call transmit(-1,ftx,iptt)
     snrdb=99.0
  endif
  
! Start the audio streams  
  ierr=ft2audio(idevin,idevout,npabuf,nright,y1,y2,NRING,iwrite,itx,     &
       iwave,nwave+3*1152,nfsample,nTxOK,nTransmitting,ngo)
  if(ierr.ne.0) then
     print*,'Error',ierr,' starting audio input and/or output.'
  endif

999 end program ft2

subroutine update(total_time,ic1,ic2)

  use wavhdr
  type(hdr) h
  real*8 total_time
  integer*8 count0,count1,clkfreq
  integer ptt
  integer*2 id(30000)
  logical transmitted,level,ok
  character*70 line
  character cdatetime*17,fname*17,mode*8,band*6
  include 'gcom1.f90'
  data nt0/-1/,transmitted/.false./,snr/-99.0/
  data level/.false./
  save nt0,transmitted,level,snr,iptt

  if(ic1.ne.0 .or. ic2.ne.0) then
     if(ic1.eq.27 .and. ic2.eq.0) ngo=0        !ESC
     if(nTxOK.eq.0 .and. ntransmitting.eq.0) then
        nfunc=0
        if(ic1.eq.0 .and. ic2.eq.59) nfunc=1   !F1
        if(ic1.eq.0 .and. ic2.eq.60) nfunc=2   !F2
        if(ic1.eq.0 .and. ic2.eq.61) nfunc=3   !F3
        if(ic1.eq.0 .and. ic2.eq.62) nfunc=4   !F4
        if(ic1.eq.0 .and. ic2.eq.63) nfunc=5   !F5
        if(nfunc.eq.1 .or. (nfunc.ge.2 .and. hiscall.ne.'      ')) then
           ftx=1500.0
           call transmit(nfunc,ftx,iptt)
        endif
     endif
     if(ic1.eq.13 .and. ic2.eq.0) hiscall=hiscall_next
     if((ic1.eq.97 .or. ic1.eq.65) .and. ic2.eq.0) autoseq=.not.autoseq
     if((ic1.eq.108 .or. ic1.eq.76) .and. ic2.eq.0) level=.not.level
  endif

  if(ntransmitting.eq.1) transmitted=.true.
  if(transmitted .and. ntransmitting.eq.0) then
     i1=0
     if(iptt.eq.1 .and. nport.gt.0) i1=ptt(nport,0,1,iptt)
     if(tx_once .and. transmitted) stop
     transmitted=.false.
  endif

  nt=2*total_time
  if(nt.gt.nt0 .or. ic1.ne.0 .or. ic2.ne.0) then
     if(level) then
! Measure and display the average level of signal plus noise in past 0.5 s
        k=iwrite-6000
        if(k.lt.1) k=k+NRING
        sq=0.
        do i=1,6000
           k=k+1
           if(k.gt.NRING) k=k-NRING
           x=y1(k)
           sq=sq + x*x
        enddo
        sigdb=0.
        if(sq.gt.0.0) sigdb=db(sq/6000.0)
        n=sigdb
        if(n.lt.1) n=1
        if(n.gt.70) n=70
        line=' '
        line(n:n)='*'
        write(*,1030) sigdb,ntxed,autoseq,QSO_in_progress,(line(i:i),i=1,n)
1030    format(f4.1,i3,2L2,1x,70a1)
!        write(*,1020) nt,total_time,iwrite,itx,ntxok,ntransmitting,ndecodes,  &
!             snr,sigdb,line
!1020    format(i6,f9.3,i10,i6,3i3,f6.0,f6.1,1x,a30)
     endif
     k=iwrite-30000
     if(k.lt.1) k=k+NRING
     do i=1,30000
        k=k+1
        if(k.gt.NRING) k=k-NRING
        id(i)=y1(k)
     enddo
     nutc=0
     nfqso=1500
     ndecodes=0
     if(maxval(abs(id)).gt.0) then
        call system_clock(count0,clkfreq)
        nrx=-1
        call ft2_decode(cdatetime(),nfqso,id,ndecodes,mycall,hiscall,nrx)
        call system_clock(count1,clkfreq)
!        tdecode=float(count1-count0)/float(clkfreq)

        if(ndecodes.ge.1) then
           fMHz=7.074
           mode='FT2'
           nsubmode=1
           ntrperiod=0
           h=default_header(12000,30000)
           k=0
           do i=1,250
              sq=0
              do n=1,120
                 k=k+1
                 x=id(k)
                 sq=sq + x*x
              enddo
              write(43,3043) i,0.01*i,1.e-4*sq
3043          format(i7,f12.6,f12.3)
           enddo
           call set_wsjtx_wav_params(fMHz,mode,nsubmode,ntrperiod,id)
           band=""
           mode=""
           nsubmode=-1
           ntrperiod=-1
           call get_wsjtx_wav_params(id,band,mode,nsubmode,ntrperiod,ok)
!           write(*,1010) band,ntrperiod,mode,char(ichar('A')-1+id(3))
!1010       format('Band: ',a6,'  T/R period:',i4,'   Mode: ',a8,1x,a1)

           fname=cdatetime()
           fname(14:17)='.wav'
           open(13,file=fname,status='unknown',access='stream')
           write(13) h,id
           close(13)
        endif
        if(autoseq .and.nrx.eq.2) QSO_in_progress=.true.
        if(autoseq .and. QSO_in_progress .and. nrx.ge.1 .and. nrx.le.4) then
           lrx(nrx)=.true.
           ftx=1500.0
           if(ntxed.eq.1) then
              if(nrx.eq.2) then
                 call transmit(3,ftx,iptt)
              else
                 call transmit(1,ftx,iptt)
              endif
           endif
           if(ntxed.eq.2) then
              if(nrx.eq.3) then
                 call transmit(4,ftx,iptt)
                 QSO_in_progress=.false.
                 write(*,1032)
1032             format('QSO complete: S+P side')
              else
                 call transmit(2,ftx,iptt)
              endif
           endif
           if(ntxed.eq.3) then
              if(nrx.eq.4) then
                 QSO_in_progress=.false.
                 write(*,1034)
1034             format('QSO complete: CQ side')
              else
                 call transmit(3,ftx,iptt)
              endif
           endif
        endif
     endif
     nt0=nt
  endif

  return
end subroutine update

character*17 function cdatetime()
  character cdate*8,ctime*10
  call date_and_time(cdate,ctime)
  cdatetime=cdate(3:8)//'_'//ctime
  return
end function cdatetime

subroutine transmit(nfunc,ftx,iptt)
  include 'gcom1.f90'
  character*17 cdatetime
  integer ptt

  if(nTxOK.eq.1) return
  
  if(nfunc.eq.1) txmsg='CQ '//trim(mycall)//' '//mygrid
  if(nfunc.eq.2) txmsg=trim(hiscall)//' '//trim(mycall)//     &
       ' 559 '//trim(exch)
  if(nfunc.eq.3) txmsg=trim(hiscall)//' '//trim(mycall)//     &
       ' R 559 '//trim(exch)
  if(nfunc.eq.4) txmsg=trim(hiscall)//' '//trim(mycall)//' RR73'
  if(nfunc.eq.5) txmsg='TNX 73 GL'
  call ft2_iwave(txmsg,ftx,snrdb,iwave)
  iwave(23041:)=0
  i1=ptt(nport,1,1,iptt)
  ntxok=1
  n=len(trim(txmsg))
  write(*,1010) cdatetime(),0,0.0,nint(ftx),(txmsg(i:i),i=1,n)
  write(12,1010) cdatetime(),0,0.0,nint(ftx),(txmsg(i:i),i=1,n)
1010 format(a17,i4,f6.2,i5,' Tx ',37a1)
  if(nfunc.ge.1 .and. nfunc.le.4) ntxed=nfunc
  if(nfunc.ge.1 .and. nfunc.le.5) ltx(nfunc)=.true.
  if(nfunc.eq.2 .or. nfunc.eq.3) QSO_in_progress=.true.

  return
end subroutine transmit

subroutine decode_msk144(audio_samples, params, data_dir)
  include 'jt9com.f90'

  ! constants
  integer, parameter :: SAMPLING_RATE = 12000
  integer, parameter :: BLOCK_SIZE = 7168
  integer, parameter :: STEP_SIZE = BLOCK_SIZE / 2
  integer, parameter :: CALL_LENGTH = 12
  
  ! aguments
  integer*2 audio_samples(NMAX)
  type(params_block) :: params
  character(len = 500) :: data_dir

  ! parameters of mskrtd
  integer*2 :: buffer(BLOCK_SIZE)
  real :: tsec   
  logical :: bshmsg = .false. ! enables shorthand messages  
  logical :: btrain = .false. ! turns on training in MSK144 mode
  real*8 :: pcoeffs(5) = (/ 0.0, 0.0, 0.0, 0.0, 0.0 /); ! phase equalization
  logical :: bswl = .false.
  character(len = 80) :: line
  character(len = CALL_LENGTH) :: mycall 
  character(len = CALL_LENGTH) :: hiscall

  ! local variables
  integer :: sample_count
  integer :: position
  integer :: message_count = 0


  ! decode in 0.3s blocks
  sample_count = params%ntr * SAMPLING_RATE
  mycall = transfer(params%mycall, mycall)    ! string to char[]
  hiscall = transfer(params%hiscall, hiscall)

  do position = 1, sample_count - BLOCK_SIZE + 1, STEP_SIZE
    buffer =  audio_samples(position : position + BLOCK_SIZE - 1)
    tsec = position / REAL(SAMPLING_RATE)

    call mskrtd(buffer, params%nutc, tsec, params%ntol, params%nfqso, params%ndepth, &
      mycall, hiscall, bshmsg, btrain, pcoeffs, bswl, data_dir, line)

    if (line(1:1) .ne. char(0)) then
      line = line(1:index(line, char(0))-1)
      write(*, 1001) line
      1001 format(a80)
      message_count = message_count + 1;
    end if
  end do

  if (.not. params%ndiskdat) then
    write(*, 1002) 0, message_count, 0
    1002 format('<DecodeFinished>', 2i4, i9)
  end if

end subroutine decode_msk144

subroutine flat1b(psavg,nsmo,s2,nh,nsteps,nhmax,nsmax)

  real psavg(nh)
  real s2(nhmax,nsmax)
  real x(8192)

  ia=nsmo/2 + 1
  ib=nh - nsmo/2 - 1
  do i=ia,ib
     call pctile(psavg(i-nsmo/2),nsmo,50,x(i))
  enddo
  do i=1,ia-1
     x(i)=x(ia)
  enddo
  do i=ib+1,nh
     x(i)=x(ib)
  enddo

  do i=1,nh
     psavg(i)=psavg(i)/x(i)
     do j=1,nsteps
        s2(i,j)=s2(i,j)/x(i)
     enddo
  enddo

  return
end subroutine flat1b

      

!program smolorentz
subroutine smolorentz(s1,nz,w,s2)

!  parameter (nz=512)
  real s1(nz),s2(nz)
  real y(-50:50)
!  character*8 arg

!  s1=0.
!  s1(256)=1.

!  call getarg(1,arg)
!  read(arg,*) w
  
  do i=-50,50
     x=i
     z=x/(0.5*w)
     y(i)=0.
     if(abs(z).lt.3.0) then
        d=1.0 + z*z
        y(i)=(1.0/d - 0.1)*10.0/9.0
     endif
  enddo

  jz=nint(1.5*w)
  if(jz.gt.50) jz=50
  do i=1,nz
     s=0.
     sy=0.
     do j=-jz,jz
        k=i+j
        if(k.ge.1 .and. k.le.nz) then
           s=s + s1(k)*y(j)
           sy=sy+y(j)
        endif
     enddo
     s2(i)=s/sy
!     write(52,3002) i-256,s1(i),s2(i)
!3002 format(i5,2f10.4)
  enddo

end subroutine smolorentz

subroutine filtersfreevar(decoded,falsedec)
  
  real datacorr
  character decoded*22,d1*1,d2*2,d3*3,d4*4,d5*5
  logical(1) falsedec

  ndot=0
  nsign=0
  nother=0

  if(decoded(11:12).eq.'73') go to 4
  if(decoded(12:13).eq.'73') go to 4
  if(decoded(1:1).eq.'/') go to 2

  do i=1,13
     d1=decoded(i:i); d2=decoded(i:(i+1)); d3=decoded(i:(i+2)); d4=decoded(i:(i+3)); d5=decoded(i:(i+4))
     if(d2.eq.'73' .or. d2.eq.'TU' .or. d2.eq.'GL') go to 4
!  HA8QJ -07   HA8QJ R-07  
     if(i.gt.4) then
        if((d2.eq.' -' .or. d2.eq.' +') .and. decoded(i+2:i+2).ge.'0' .and. decoded(i+2:i+2).lt.'3') go to 4
        if((d3.eq.' R-' .or. d3.eq.' R+') .and.  decoded(i+3:i+3).ge.'0' .and. decoded(i+3:i+3).lt.'3') go to 4
     endif
     if(d3.eq.'QSL' .or. d3.eq.'TNX' .or. d2.eq.'RR' .or.  &
        d3.eq.'QSO' .or. d3.eq.'CFM' .or. d4.eq.'LOTW' .or. &
        d3.eq.'BND' .or. d3.eq.'QSY' .or. d4.eq.'BAND') go to 4
     if(d3.eq.'MAS' .or. d3.eq.'HNY' .or. d3.eq.'HPY' .or. d3.eq.' DT' .or. &
        d3.eq.'XMS' .or. d5.eq.'EASTE' .or. d5.eq.'PIRAT' .or. d4.eq.'TEST') go to 4
     if(d5.eq.'/HYBR' .or. d5.eq.'/HTML' .or. d5.eq.'/PHOT' .or. d5.eq.'/IMAG' .or. d5.eq.'/JOIN' .or. d5.eq.'QRZ.C' & 
         .or. d4.eq.'/GIF' .or. d4.eq.'/JPG' .or. d4.eq.'/AVI' .or. d4.eq.'/MP4' .or. d4.eq.'/CMD') go to 4
     if(d1.eq.'.') ndot=ndot+1
     if(d1.eq.'-' .or. d1.eq.'+' .or. d1.eq.'?') nsign=nsign+1
     if(d1.eq.'/' .or. d1.eq.'?') nother=nother+1
  enddo

  if(ndot.ge.2 .or. nsign.ge.2 .or. nother.ge.2) go to 2
  if(decoded(1:2).eq.'-0')  go to 2
  if(decoded(1:1).ne.' ' .and. decoded(2:2).eq.' ') go to 2

  if(((decoded(13:13).ge.'A' .and. decoded(13:13).le.'Z') .or.  &
     (decoded(13:13).ge.'0' .and. decoded(13:13).le.'9')) .and. &
     decoded(12:12).eq.' ') go to 2

  if(decoded(1:1).eq.'.' .or. decoded(1:1).eq.'+' .or. decoded(1:1).eq.'?' &
     .or. decoded(1:1).eq.'/' .or. decoded(13:13).eq.'.' .or. decoded(13:13).eq.'+' &
     .or. decoded(13:13).eq.'-' .or. decoded(13:13).eq.'/') go to 2

  if(decoded(2:2).eq.'-' .or. decoded(2:2).eq.'+' .or. decoded(12:12).eq.'.' .or. &
     decoded(12:12).eq.'+' .or. decoded(12:12).eq.'-') go to 2

  if(decoded(12:12).ge.'0' .and. decoded(12:12).le.'9' .and. &
     decoded(13:13).ge.'0' .and. decoded(13:13).le.'9') then

     if(decoded(12:13).ne.'55' .and. decoded(12:13).ne.'73' .and. decoded(12:13).ne.'88') go to 2

  endif
 
  if(decoded(1:1).eq.'0' .and. decoded(2:2).ne.'.') go to 2

  do i=1,12
     if(i.lt.12 .and. decoded(i:i).eq."?" .and. decoded(i+1:i+1).ne." ") go to 2
     if(i.lt.12 .and. decoded(i:i).ne." " .and. decoded(i+1:i+1).eq."+" &
        .and. (decoded(i+2:i+2).le."0" .or. decoded(i+2:i+2).ge."9")) go to 2

     if(decoded(i:i).ge.'A' .and. decoded(i:i).le.'Z' .and. decoded(i+1:i+1).eq.'.' .and. &
        decoded(i+2:i+2).ge.'A' .and. decoded(i+2:i+2).le.'Z') go to 2

     if(decoded(i+1:i+2).eq.'/ ' .or. decoded(i+1:i+2).eq.' /') go to 2

     if(decoded(i:i).ge.'0' .and. decoded(i:i).le.'9' .and. decoded(i+1:i+1).eq.'/' .and. &
        decoded(i+2:i+2).ge.'0' .and. decoded(i+2:i+2).le.'9') go to 2

     if(decoded(i:i).eq.' ' .and. decoded(i+1:i+1).ge.'A' .and. decoded(i+1:i+1).le.'Z' .and.     &
        decoded(i+1:i+1).ne.'F' .and. decoded(i+1:i+1).ne.'G' .and. decoded(i+1:i+1).ne.'I' .and. &
        decoded(i+2:i+2).eq.'/') go to 2

     if(decoded(i:i).eq.' ' .and. decoded(i+1:i+1).ge.'A' .and. decoded(i+1:i+1).le.'Z' .and.     &
        (decoded(i+2:i+2).eq.'.' .or. decoded(i+2:i+2).eq.'+' .or. decoded(i+2:i+2).eq.'-')) go to 2

  enddo

  if(decoded(1:1).eq.'-' .and. decoded(2:2).le.'1' .and. decoded(2:2).ge.'9') go to 2
 
  if(decoded(1:1).ge.'1' .and. decoded(1:1).le.'9' .and.  &
     decoded(2:2).ge.'0' .and. decoded(2:2).le.'9' .and.  &
     decoded(3:3).ge.'0' .and. decoded(3:3).le.'9' .and.  &
     decoded(4:4).ne.'W') go to 2
 
  if(decoded(1:1).ge.'1' .and. decoded(1:1).le.'9' .and.  &
     decoded(2:2).ge.'0' .and. decoded(2:2).le.'9' .and.  &
     decoded(3:3).ne.'W') go to 2

  if(decoded(1:1).ge.'1' .and. decoded(1:1).le.'9' .and.  &
     decoded(2:3).ne.'EL') go to 2

  if(decoded(10:10).ne.'/' .and. decoded(11:11).ne.'/' .and. decoded(12:12).ge.'A' .and. &
     decoded(12:12).le.'Z' .and. decoded(13:13).ge.'0' .and. decoded(12:12).le.'9') go to 2

  call datacor(datapwr,datacorr)

! ban free message if datacorr is less than 1.55
  if(datacorr.lt.1.55) go to 2

  ncount=0
  nchar=0

  do i=1,13
     if(decoded(i:i).eq.' ') exit
     if(decoded(i:i).eq.'/' .or. decoded(i:i).eq.'-' .or. decoded(i:i).eq.'.') nchar=nchar+1
     ncount=ncount+1
  enddo

  if(ncount.eq.13 .and. nchar.ge.0) go to 2  

!print *,"passed"
!print *,decoded

  go to 4

2 falsedec=.true.
!print *,"stopped"
!print *,decoded
 return

4 return
end subroutine filtersfreevar

subroutine chkcall(w,bc,cok)

! Check "w" to see if it could be a valid standard callsign or a valid
! compound callsign.
! Return base call "bc" and a logical "cok" indicator.

  character w*13                            !A putative callsign
  character bc*6                            !Base call (tentative)
  character c*1
  logical cok,isdigit,isletter
  
  isdigit(c)=(ichar(c).ge.ichar('0')) .and. (ichar(c).le.ichar('9'))
  isletter(c)=(ichar(c).ge.ichar('A')) .and. (ichar(c).le.ichar('Z'))
  
  cok=.true.
  bc=w(1:6)
  n1=len_trim(w)
  if(n1.gt.11) go to 100
  if(index(w,'.').ge.1) go to 100
  if(index(w,'+').ge.1) go to 100
  if(index(w,'-').ge.1) go to 100
  if(index(w,'?').ge.1) go to 100
  if(n1.gt.6 .and. index(w,'/').le.0) go to 100

  i0=index(w,'/')
  if(max(i0-1,n1-i0).gt.6) go to 100      !Base call must be < 7 characters
  if(i0.ge.2 .and. i0.le.n1-1) then       !Extract base call from compound call
     if(i0-1.le.n1-i0) bc=w(i0+1:n1)//'   '
     if(i0-1.gt.n1-i0) bc=w(1:i0-1)//'   '
  endif

  nbc=len_trim(bc)
  if(nbc.gt.6) go to 100  !Base call should have no more than 6 characters

! One of first two characters (c1 or c2) must be a letter
  if((.not.isletter(bc(1:1))) .and. (.not.isletter(bc(2:2)))) go to 100
! Real calls don't start with Q, but we'll allow the placeholder
! callsign QU1RK to be considered a standard call:
  if(bc(1:1).eq.'Q' .and. bc(1:5).ne.'QU1RK') go to 100

! Must have a digit in 2nd or 3rd position
  i1=0
  if(isdigit(bc(2:2))) i1=2
  if(isdigit(bc(3:3))) i1=3
  if(i1.eq.0) go to 100

! Callsign must have a suffix of 1-3 letters
  if(i1.eq.nbc) go to 100
  n=0
  do i=i1+1,nbc
     j=ichar(bc(i:i))
     if(j.lt.ichar('A') .or. j.gt.ichar('Z')) go to 100
     n=n+1
  enddo
  if(n.ge.1 .and. n.le.3) go to 200

100 cok=.false.
     
200 return
end subroutine chkcall

program synctest

  ! Program to test an algorithm for detecting sync signals for both
  ! JT65 and Q65-60x signals and rejecting birdies in MAP65 data.
  ! The important work is done in module wideband_sync.

  use timer_module, only: timer
  use timer_impl, only: init_timer, fini_timer
  use wideband_sync

  real ss(4,322,NFFT),savg(4,NFFT)
!  real candidate(MAX_CANDIDATES,5)             !snr1,f0,xdt0,ipol,flip
  character*8 arg
  type(candidate) :: cand(MAX_CANDIDATES)
  
  nargs=iargc()
  if(nargs.ne.5) then
     print*,'Usage:   synctest iutc nfa nfb nts_jt65 nts_q65'
     print*,'Example: synctest 1814  23  83      2        1'
     go to 999
  endif
  call getarg(1,arg)
  read (arg,*) iutc
  call getarg(2,arg)
  read (arg,*) nfa
  call getarg(3,arg)
  read (arg,*) nfb
  call getarg(4,arg)
  read (arg,*) nts_jt65
  call getarg(5,arg)
  read (arg,*) nts_q65

  open(50,file='50.a',form='unformatted',status='old')
  do ifile=1,9999
     read(50,end=998) nutc,npol,ss(1:npol,:,:),savg(1:npol,:)
     if(nutc.eq.iutc) exit
  enddo
  close(50)

  call init_timer('timer.out')
  call timer('synctest',0)

  call timer('get_cand',0)
  call  get_candidates(ss,savg,302,.true.,nfa,nfb,nts_jt65,nts_q65,cand,ncand)
  call timer('get_cand',1)

  do k=1,ncand
     write(*,1010) k,cand(k)%snr,cand(k)%f,cand(k)%f+77,cand(k)%xdt,    &
          cand(k)%ipol,cand(k)%iflip
1010 format(i3,4f10.3,2i3)
  enddo

998 call timer('synctest',1)
  call timer('synctest',101)
  call fini_timer()

999 end program synctest

subroutine hspec(id2,k,nutc0,ntrpdepth,nrxfreq,ntol,bmsk144,             &
     btrain,pcoeffs,ingain,mycall,hiscall,bshmsg,bswl,datadir,green,s,   &
     jh,pxmax,dbNoGain,line1)

! Input:
!  k         pointer to the most recent new data
!  nutc0     UTC for display of decode(s)
!  ntrpdepth TR period and 1000*ndepth
!  nrxfreq   Rx audio center frequency
!  ntol      Decoding range is +/- ntol
!  ncontest  Contest type (0=NONE 1=NA_VHF 2=EU_VHF 3=FIELD_DAY 4=RTTY 5=WW_DIGI)
!  bmsk144   Boolean, true if in MSK144 mode
!  btrain    Boolean, turns on training in MSK144 mode
!  ingain    Relative gain for spectra

! Output:
!  green()   power
!  s()       spectrum for horizontal spectrogram
!  jh        index of most recent data in green(), s()

  parameter (JZ=703)
  character*(*) line1
  character*80  line0
  character*(*) datadir
  character*(*) mycall,hiscall
  integer*2 id2(0:120*12000-1)
  logical*1 bmsk144,bshmsg,btrain,bswl
  real green(0:JZ-1)
  real s(0:63,0:JZ-1)
  real x(512)
  real*8 pcoeffs(5)
  complex cx(0:256)
  data rms/999.0/,k0/99999999/
  equivalence (x,cx)
  save ja,rms0

  ndepth=ntrpdepth/1000
  ntrperiod=ntrpdepth - 1000*ndepth
  gain=10.0**(0.1*ingain)
  nfft=512
  nstep=nfft
  nblks=7
  if(ntrperiod.lt.30) then
     nstep=256
     nblks=14
  endif

  if(k.gt.30*12000) go to 900
  if(k.lt.nfft) then       
     jh=0
     go to 900                                 !Wait for enough samples to start
  endif

  if(k.lt.k0) then                             !Start a new data block
     ja=-nstep
     jh=-1
     rms0=0.0
  endif

  pxmax = 0;
  do iblk=1,nblks
     if(jh.lt.JZ-1) jh=jh+1
     ja=ja+nstep
     jb=ja+nfft-1
     x=id2(ja:jb)
     sq=dot_product(x,x)
     xmax = maxval(x);
     xmin = abs(minval(x));
     if (xmin > xmax) xmax = xmin;
     if (xmax.gt.0.0) pxmax=20.0*log10(xmax);
     rms=sqrt(gain*sq/nfft)
     rms2=sqrt(sq/nfft);
     green(jh)=0.
     if(rms.gt.0.0) then
        green(jh)=20.0*log10(rms)
        dbNoGain=20.0*log10(rms2);
     endif
     call four2a(x,nfft,1,-1,0)                   !Real-to-complex FFT
     df=12000.0/nfft
     fac=(1.0/nfft)**2
     do i=1,64
        j=2*i
        sx=real(cx(j))**2 + aimag(cx(j))**2 + real(cx(j-1))**2 +        &
             aimag(cx(j-1))**2
        s(i-1,jh)=fac*gain*sx
     enddo
     if(ja+2*nfft.gt.k) exit
  enddo
  k0=k

  if(bmsk144) then
     if(k.ge.7168) then
        tsec=(k-7168)/12000.0
        k0=k-7168
        tt1=sum(float(abs(id2(k0:k0+3583))))
        k0=k-3584
        tt2=sum(float(abs(id2(k0:k0+3583))))
        if(tt1.ne.0.0 .and. tt2.ne.0) then
           call mskrtd(id2(k-7168+1:k),nutc0,tsec,ntol,nrxfreq,ndepth,   &
                mycall,hiscall,bshmsg,btrain,pcoeffs,bswl,datadir,line0)
           if(line0(1:1).eq.char(0)) then 
              line1(1:1)=char(0)
           else
              line1(1:62)=line0(1:62) 
           endif 
        endif
     endif
  endif

900 return
end subroutine hspec

subroutine msk144decodeframe(c,softbits,msgreceived,nsuccess)
!  use timer_module, only: timer
  use packjt77
  parameter (NSPM=864)
  character*37 msgreceived
  character*77 c77
  complex cb(42)
  complex cfac,cca,ccb
  complex c(NSPM)
  integer*1 decoded77(77),apmask(128),cw(128)
  integer s8(8),hardbits(144)
  real*8 dt, fs, pi, twopi
  real cbi(42),cbq(42)
  real pp(12)
  real softbits(144)
  real llr(128)
  logical first,unpk77_success
  data first/.true./
  data s8/0,1,1,1,0,0,1,0/
  save first,cb,fs,pi,twopi,dt,s8,pp

  if(first) then
! define half-sine pulse and raised-cosine edge window
     pi=4d0*datan(1d0)
     twopi=8d0*datan(1d0)
     fs=12000.0
     dt=1.0/fs

     do i=1,12
       angle=(i-1)*pi/12.0
       pp(i)=sin(angle)
     enddo

! define the sync word waveforms
     s8=2*s8-1  
     cbq(1:6)=pp(7:12)*s8(1)
     cbq(7:18)=pp*s8(3)
     cbq(19:30)=pp*s8(5)
     cbq(31:42)=pp*s8(7)
     cbi(1:12)=pp*s8(2)
     cbi(13:24)=pp*s8(4)
     cbi(25:36)=pp*s8(6)
     cbi(37:42)=pp(1:6)*s8(8)
     cb=cmplx(cbi,cbq)
     first=.false.
  endif

  nsuccess=0
  msgreceived=' '

! Estimate carrier phase. 
  cca=sum(c(1:1+41)*conjg(cb))
  ccb=sum(c(1+56*6:1+56*6+41)*conjg(cb))
  cfac=ccb*conjg(cca)
  phase0=atan2(imag(cca+ccb),real(cca+ccb))

! Remove phase error - want constellation rotated so that sample points lie on I/Q axes
  cfac=cmplx(cos(phase0),sin(phase0))
  c=c*conjg(cfac)

! matched filter - 
  softbits(1)=sum(imag(c(1:6))*pp(7:12))+sum(imag(c(864-5:864))*pp(1:6))
  softbits(2)=sum(real(c(1:12))*pp)
  do i=2,72
    softbits(2*i-1)=sum(imag(c(1+(i-1)*12-6:1+(i-1)*12+5))*pp)
    softbits(2*i)=sum(real(c(7+(i-1)*12-6:7+(i-1)*12+5))*pp)
  enddo

! sync word hard error weight is used as a discriminator for 
! frames that have reasonable probability of decoding
  hardbits=0
  do i=1,144
    if( softbits(i) .ge. 0.0 ) then
      hardbits(i)=1
    endif
  enddo
  nbadsync1=(8-sum( (2*hardbits(1:8)-1)*s8 ) )/2
  nbadsync2=(8-sum( (2*hardbits(1+56:8+56)-1)*s8 ) )/2
  nbadsync=nbadsync1+nbadsync2
  if( nbadsync .gt. 4 ) then
    return
  endif

! normalize the softsymbols before submitting to decoder
  sav=sum(softbits)/144
  s2av=sum(softbits*softbits)/144
  ssig=sqrt(s2av-sav*sav)
  softbits=softbits/ssig

  sigma=0.60
  llr(1:48)=softbits(9:9+47)
  llr(49:128)=softbits(65:65+80-1)
  llr=2.0*llr/(sigma*sigma)
  
  max_iterations=10
  apmask=0
  dmin=0.0
  call bpdecode128_90(llr,apmask,max_iterations,decoded77,cw,nharderror,niterations)
  if( nharderror .ge. 0 .and. nharderror .lt. 18 ) then
    nsuccess=1
    write(c77,'(77i1)') decoded77
    read(c77(72:77),'(2b3)') n3,i3
    if( (i3.eq.0.and.(n3.eq.1 .or. n3.eq.3 .or. n3.eq.4 .or. n3.gt.5)) .or. i3.eq.3 .or. i3.gt.5 ) then
        nsuccess=0 
    else 
        call unpack77(c77,1,msgreceived,unpk77_success)
        if(.not.unpk77_success) nsuccess=0
    endif
  endif

  return
end subroutine msk144decodeframe

subroutine ana932(dat,npts0,cdat,npts)

  real dat(npts0)
  complex cdat(262145)

  n=log(float(npts0))/log(2.0)
  nfft1=2**(n+1)
  nfft2=9*nfft1/32
  df932=11025.0/nfft1
  fac=2.0/nfft1
  do i=1,npts0/2
     cdat(i)=fac*cmplx(dat(2*i-1),dat(2*i))
  enddo
  cdat(npts0/2+1:nfft1/2)=0.
  call four2a(cdat,nfft1,1,-1,0)               !Forward r2c FFT
  call four2a(cdat,nfft2,1,1,1)                !Inverse c2c FFT
  npts=npts0*9.0/32.0                          !Downsampled data length
  npts2=npts

  return
end subroutine ana932

subroutine mskrtd(id2,nutc0,tsec,ntol,nrxfreq,ndepth,mycall,hiscall,      &
     bshmsg,btrain,pcoeffs,bswl,datadir,line)

! Real-time decoder for MSK144.  
! Analysis block size = NZ = 7168 samples, t_block = 0.597333 s 
! Called from hspec() at half-block increments, about 0.3 s

  use packjt77

  parameter (NZ=7168)                !Block size
  parameter (NSPM=864)               !Number of samples per message frame
  parameter (NFFT1=8192)             !FFT size for making analytic signal
  parameter (NPATTERNS=4)            !Number of frame averaging patterns to try
  parameter (NSHMEM=50)              !Number of recent SWL messages to remember

  character*4 decsym                 !"&" for mskspd or "^" for long averages
  character*37 msgreceived           !Decoded message
  character*37 msglast,msglastswl    !Used for dupechecking
  character*(*) line                  !Formatted line with UTC dB T Freq Msg
  character*(*) mycall,hiscall
  character*37 recent_shmsgs(NSHMEM)
  character*(*) datadir

  complex cdat(NFFT1)                !Analytic signal
  complex c(NSPM)                    !Coherently averaged complex data
  complex ct(NSPM)

  integer*2 id2(NZ)                  !Raw 16-bit data
  integer iavmask(8)
  integer iavpatterns(8,NPATTERNS)
  integer npkloc(10)
  integer nhasharray(MAXRECENT,MAXRECENT)
  integer nsnrlast,nsnrlastswl

  real d(NFFT1)
  real pow(8)
  real softbits(144)
  real xmc(NPATTERNS)
  real*8 pcoeffs(5)

  logical*1 bshmsg,btrain,bswl
  logical*1 first
  logical*1 bshdecode
  logical*1 seenb4
  logical*1 bflag
  logical*1 bvar
 
  data first/.true./
  data iavpatterns/ &
       1,1,1,1,0,0,0,0, &
       0,0,1,1,1,1,0,0, &
       1,1,1,1,1,0,0,0, &
       1,1,1,1,1,1,1,0/
  data xmc/2.0,4.5,2.5,3.5/     !Used to set time at center of averaging mask
  save first,tsec0,nutc00,pnoise,cdat,msglast,msglastswl,     &
       nsnrlast,nsnrlastswl,nhasharray,recent_shmsgs
!       nsnrlast,nsnrlastswl,nhasharray,recent_shmsgs,mycall13

  if(first) then
     tsec0=tsec
     nutc00=nutc0
     pnoise=-1.0
     do i=1,MAXRECENT
       recent_calls(i)(1:13)=' '
     enddo
     do i=1,nshmem
       recent_shmsgs(i)(1:37)=' '
     enddo
     msglast='                                     '
     msglastswl='                                     '
     nsnrlast=-99
     nsnrlastswl=-99
!     mycall13=mycall//' '
!     dxcall13=hiscall//' '
     mycall13=' '
     dxcall13=' '
     mycall13(1:12)=mycall
     dxcall13(1:12)=hiscall
     first=.false.
  endif

  fc=nrxfreq

! Reset if mycall or dxcall changes
  if(mycall13(1:12).ne.mycall .or. dxcall13(1:12).ne.hiscall) first=.true.

! Dupe checking setup 
  if(nutc00.ne.nutc0 .or. tsec.lt.tsec0) then ! reset dupe checker
    msglast='                                     '
    msglastswl='                                     '
    nsnrlast=-99
    nsnrlastswl=-99
    nutc00=nutc0
  endif
  
  tframe=float(NSPM)/12000.0 
  line(1:1)=char(0)
  msgreceived='                                     '
  max_iterations=10
  niterations=0
  d(1:NZ)=id2
  rms=sqrt(sum(d(1:NZ)*d(1:NZ))/NZ)
  if(rms.lt.1.0) go to 999
  fac=1.0/rms
  d(1:NZ)=fac*d(1:NZ)
  d(NZ+1:NFFT1)=0.
  bvar=.true.
  if( btrain ) bvar=.false.   ! if training, turn off rx eq
  call analytic(d,NZ,NFFT1,cdat,pcoeffs,bvar)  

! Calculate average power for each frame and for the entire block.
! If decode is successful, largest power will be taken as signal+noise.
! If no decode, entire-block average will be used to update noise estimate.
  pmax=-99
  do i=1,8 
     ib=(i-1)*NSPM+1
     ie=ib+NSPM-1
     pow(i)=real(dot_product(cdat(ib:ie),cdat(ib:ie)))*rms**2
     pmax=max(pmax,pow(i))
  enddo
  pavg=sum(pow)/8.0

! Short ping decoder uses squared-signal spectrum to determine where to
! center a 3-frame analysis window and attempts to decode each of the 
! 3 frames along with 2- and 3-frame averages. 
  np=8*NSPM
  call msk144spd(cdat,np,ntol,ndecodesuccess,msgreceived,fc,fest,tdec,navg,ct, &
                 softbits)
  bshdecode=.false.
  if(ndecodesuccess.eq.0 .and. (bshmsg.or.bswl)) then
     call msk40spd(cdat,np,ntol,mycall,hiscall,bswl,nhasharray,      &
              ndecodesuccess,msgreceived,fc,fest,tdec,navg)
     if(ndecodesuccess .ge.1) bshdecode=.true.
  endif
  if( ndecodesuccess .ge. 1 ) then
    tdec=tsec+tdec
    ipk=0
    is=0
    goto 900
  endif 

! If short ping decoder doesn't find a decode, 
! Fast - short ping decoder only. 
! Normal - try 4-frame averages
! Deep - try 4-, 5- and 7-frame averages. 
  npat=NPATTERNS
  if( ndepth .eq. 1 ) npat=0
  if( ndepth .eq. 2 ) npat=2
  do iavg=1,npat
     iavmask=iavpatterns(1:8,iavg)
     navg=sum(iavmask)
     deltaf=10.0/real(navg)  ! search increment for frequency sync
     npeaks=2
     call msk144sync(cdat(1:8*NSPM),8,ntol,deltaf,iavmask,npeaks,fc,           &
          fest,npkloc,nsyncsuccess,xmax,c)
     if( nsyncsuccess .eq. 0 ) cycle

     do ipk=1,npeaks
        do is=1,3   
           ic0=npkloc(ipk)
           if(is.eq.2) ic0=max(1,ic0-1)
           if(is.eq.3) ic0=min(NSPM,ic0+1)
           ct=cshift(c,ic0-1)
           call msk144decodeframe(ct,softbits,msgreceived,ndecodesuccess)
           if(ndecodesuccess .gt. 0) then
              tdec=tsec+xmc(iavg)*tframe
              goto 900
           endif
        enddo                         !Slicer dither
     enddo                            !Peak loop 
  enddo


  msgreceived=' '

! no decode - update noise level used for calculating displayed snr.  
  if( pnoise .lt. 0 ) then         ! initialize noise level
     pnoise=pavg
  elseif( pavg .gt. pnoise ) then  ! noise level is slow to rise
     pnoise=0.9*pnoise+0.1*pavg
  elseif( pavg .lt. pnoise ) then  ! and quick to fall
     pnoise=pavg
  endif
  go to 999

900 continue
! Successful decode - estimate snr 
  if( pnoise .gt. 0.0 ) then
    snr0=10.0*log10(pmax/pnoise-1.0)
  else
    snr0=0.0
  endif
  nsnr=nint(snr0)

  if(.not. bshdecode) then
    call msk144signalquality(ct,snr0,fest,tdec,softbits,msgreceived,hiscall,   &
                          btrain,datadir,ncorrected,eyeopening,pcoeffs)
  endif

  decsym=' &  '
  if( btrain ) decsym=' ^  '
  if( bshdecode ) then
    ncorrected=0
    eyeopening=0.0
  endif

  if( nsnr .lt. -8 ) nsnr=-8
  if( nsnr .gt. 24 ) nsnr=24

! Dupe check. 
  bflag=ndecodesuccess.eq.1 .and.                                              &
        (msgreceived.ne.msglast .or. nsnr.gt.nsnrlast .or. tsec.lt.tsec0)
  if(bflag) then
     msglast=msgreceived
     nsnrlast=nsnr
     if(.not. bshdecode) then
        call update_msk40_hasharray(nhasharray)
     endif
     write(line,1021) nutc0,nsnr,tdec,nint(fest),decsym,msgreceived,char(0)
1021 format(i6.6,i4,f5.1,i5,a4,a37,a1)
  elseif(bswl .and. ndecodesuccess.ge.2) then 
    seenb4=.false.
    do i=1,nshmem
      if( msgreceived .eq. recent_shmsgs(i) ) then
        seenb4=.true.
      endif
    enddo
    call update_recent_shmsgs(msgreceived,recent_shmsgs,nshmem)
    bflag=seenb4 .and.                                                        &
      (msgreceived.ne.msglastswl .or. nsnr.gt.nsnrlastswl .or. tsec.lt.tsec0) & 
      .and. nsnr.gt.-6
    if(bflag) then
      msglastswl=msgreceived
      nsnrlastswl=nsnr
      write(line,1021) nutc0,nsnr,tdec,nint(fest),decsym,msgreceived,char(0)
    endif
  endif
999 tsec0=tsec

  return
end subroutine mskrtd

subroutine update_recent_shmsgs(message,msgs,nsize)
  character*37 msgs(nsize)
  character*37 message
  logical*1 seen

  seen=.false.
  do i=1,nsize
    if( msgs(i) .eq. message ) seen=.true. 
  enddo

  if( .not. seen ) then
    do i=nsize,2,-1
      msgs(i)=msgs(i-1)
    enddo
    msgs(1)=message
  endif

  return
end subroutine update_recent_shmsgs

module nchar_mod
  implicit none
contains
  integer function nchar(c)
    implicit none
    character, intent(in) :: c
    integer :: n

    n=0                                    !Silence compiler warning
    if(c.ge.'0' .and. c.le.'9') then
       n=ichar(c)-ichar('0')
    else if(c.ge.'A' .and. c.le.'Z') then
       n=ichar(c)-ichar('A') + 10
    else if(c.ge.'a' .and. c.le.'z') then
       n=ichar(c)-ichar('a') + 10
    else if(c.ge.' ') then
       n=36
    else
       Print*,'Invalid character in callsign ',c,' ',ichar(c)
       stop 1
    endif
    nchar=n
  end function nchar
end module nchar_mod

program test_snr

! Test an algorithm for measuring SNR of EME echoes.

  use wavhdr
  parameter (NMAX=27648)           !27*1024
  parameter (NFFT=32768,NH=NFFT/2)
  parameter (NZ=4096)

  type(hdr) h                            !Header for the .wav file
  integer*2 id2(NMAX)                 !Buffer for Rx data  
  complex c(0:NH)
  real x(NFFT)
  real s(8192)
  real sa(4096)
  real sb(4096)
  real red(4096)
  real blue(4096)
  character*80 infile
  equivalence (x,c)

  nargs=iargc()
  if(nargs.lt.1) then
     print*,'Usage:    test_snr <infile>'
     go to 999
  endif
  call getarg(1,infile)
  i0=index(infile,'_')
  read(infile(1:i0-1),*) fspread0                    !Generated Doppler spread
  read(infile(i0+1:i0+3),*) snrdb0                   !Generated SNR
  open(10,file=trim(infile),status='old',access='stream')
  read(10) h
  npts=h%ndata/2
  npings=npts/NMAX
  nfsample=h%nsamrate
  df=12000.0/NFFT
  s=0.
  fac=1.0/NMAX
  
  do iping=1,npings
     read(10) id2(1:NMAX)
     x(1:NMAX)=fac*id2(1:NMAX)
     x(NMAX+1:)=0.     
     call four2a(x,NFFT,1,-1,0)
     do i=1,8192                             !Accumulate spectrum 0 - 3 kHz
        s(i)=s(i) + real(c(i))**2 + aimag(c(i))**2
     enddo
  enddo

  sa=s(2049:6144)
  sb=s(2049:6144)

  call echo_snr(sa,sb,fspread0,blue,red,snrdb,db_err,fpeak,snr_detect)
  
  nqual=min(10,int(snr_detect-4.0))

  write(*,1010) fspread0,snrdb0,snrdb,snrdb-snrdb0,db_err,fpeak,   &
       snr_detect,nqual

1010 format(5f6.1,2f7.1,i4)

  do i=1,8192
     write(12,1100) i*df,s(i)
1100 format(f10.3,e15.6)
  enddo

999 end program test_snr

subroutine mskdt(d,npts,ty,yellow,nyel)

  parameter (NFFT=1024,NH=NFFT/2)
  real d(npts)
  real x(0:NFFT-1)
  real green(703)
  real yellow(703)                    !703 = 30*12000/512
  real ty(703)
  real y2(175)
  real ty2(175)
  integer indx(703)
  logical ok
  complex c(0:NH)
  equivalence (x,c)

  df=12000.0/NFFT
  i1=nint(300.0/df)
  i2=nint(800.0/df)
  i3=nint(2200.0/df)
  i4=nint(2700.0/df)
  nblks=npts/NH - 1

  do j=1,nblks
     ib=(j+1)*NH
     ia=ib-NFFT+1
     x=d(ia:ib)
     call four2a(x,NFFT,1,-1,0)             !r2c FFT
     sqlow=0.
     do i=i1,i2
        sqlow=sqlow + real(c(i))**2 + aimag(c(i))**2
     enddo
     sqmid=0.
     do i=i2,i3
        sqmid=sqmid + real(c(i))**2 + aimag(c(i))**2
     enddo
     sqhigh=0.
     do i=i3,i4
        sqhigh=sqhigh + real(c(i))**2 + aimag(c(i))**2
     enddo
     green(j)=db(sqlow+sqmid+sqhigh)
     yellow(j)=db(sqmid/(sqlow+sqhigh))
     ty(j)=j*512.0/12000.0
  enddo

  npct=20
  call pctile(green,nblks,npct,base)
  green(1:nblks)=green(1:nblks) - base - 0.3
  call pctile(yellow,nblks,npct,base)
  yellow(1:nblks)=yellow(1:nblks) - base - 0.6
  call indexx(yellow,nblks,indx)

  do j=1,nblks/4
     k=indx(nblks+1-j)
     ty(j)=ty(k)
     yellow(j)=yellow(k)
     if(yellow(j).lt.1.5) exit
  enddo
  nyel=j-1
  k=1
  y2(1)=yellow(1)
  ty2(1)=ty(1)
  do j=2,nyel
     ok=.true.
     do i=1,j-1
        if(abs(ty(i)-ty(j)).lt.0.117) ok=.false.
     enddo
     if(ok) then
        k=k+1
        y2(k)=yellow(j)
        ty2(k)=ty(j)
     endif
  enddo
  nyel=k
  yellow(1:nyel)=y2(1:nyel)
  ty(1:nyel)=ty2(1:nyel)

  return
end subroutine mskdt

module fftw3_f77_interfaces
  use iso_c_binding, only: c_int, c_intptr_t, c_float_complex, c_float
  implicit none

  interface
    subroutine sfftw_destroy_plan(plan)
      import :: c_intptr_t
      implicit none
      integer(c_intptr_t) :: plan
    end subroutine sfftw_destroy_plan

    subroutine sfftw_plan_dft_1d(plan, n, in, out, sign, flags)
      import :: c_int, c_intptr_t, c_float_complex
      implicit none
      integer(c_intptr_t) :: plan
      integer(c_int)      :: n, sign, flags
      complex(c_float_complex) :: in(*), out(*)
    end subroutine sfftw_plan_dft_1d

   subroutine sfftw_plan_dft_r2c_1d(plan, n, in, out, flags)
    import :: c_int, c_intptr_t, c_float_complex
    implicit none
    integer(c_intptr_t) :: plan
    integer(c_int)      :: n, flags
    complex(c_float_complex) :: in(*), out(*)
  end subroutine sfftw_plan_dft_r2c_1d

  subroutine sfftw_plan_dft_c2r_1d(plan, n, in, out, flags)
    import :: c_int, c_intptr_t, c_float_complex
    implicit none
    integer(c_intptr_t) :: plan
    integer(c_int)      :: n, flags
    complex(c_float_complex) :: in(*), out(*)
  end subroutine sfftw_plan_dft_c2r_1d

    subroutine sfftw_execute(plan)
      import :: c_intptr_t
      implicit none
      integer(c_intptr_t) :: plan
    end subroutine sfftw_execute
  end interface

end module fftw3_f77_interfaces

subroutine lpf1(dd,jz,dat,jz2)

  parameter (NFFT1=64*11025,NFFT2=32*11025)
  real dd(jz)
  real dat(jz)
  real x(NFFT1)
  complex cx(0:NFFT1/2)
  equivalence (x,cx)
  save x,cx

  fac=1.0/float(NFFT1)
  x(1:jz)=fac*dd(1:jz)
  x(jz+1:NFFT1)=0.0
  call four2a(cx,NFFT1,1,-1,0)                    !Forwarxd FFT, r2c
  cx(NFFT2/2:)=0.0

!  df=11025.0/NFFT1
!  do i=1,NFFT1/2
!     sx=real(cx(i))**2 + aimag(cx(i))**2
!     write(50,3000) i*df,sx
!3000 format(f15.6,e12.3)
!  enddo

  call four2a(cx,NFFT2,1,1,-1)                   !Inverse FFT, c2r
  jz2=jz/2
  dat(1:jz2)=x(1:jz2)

  return
end subroutine lpf1

program ldpcsim174_91
! End to end test of the (174,91)/crc14 encoder and decoder.
   use packjt77

   integer, parameter:: N=174, K=91, M=N-K, NN=58
   character*37 msg,msgsent
   character*77 c77
   character*8 arg
   integer*1, allocatable ::  codeword(:), decoded(:), message(:)
   integer*1 msgbits(77)
   integer*1 message91(91)
   integer*1 apmask(N), cw(N)
   integer lmax(1)
   integer modtype, itone(79), itonecw(58), graymap(0:7)
   integer nerrtot(0:N),nerrdec(0:N)
   integer channeltype
   logical unpk77_success
   logical one(0:511,0:8)
   real*8, allocatable ::  rxdata(:)
   real     llr(174),llra(174),llrb(174),llrc(174),llrd(174)
   real     bmeta(174),bmetb(174),bmetc(174),bmetd(174)
   complex cs(0:7,NN)
   real s2(0:511)
   data graymap/0,1,3,2,5,6,4,7/

   nerrtot=0
   nerrdec=0

!

   nargs=iargc()
   if(nargs.ne.7) then
      print*,'Usage: ldpcsim  maxosd  norder  #trials   s     Keff  modtype  channel'
      print*,'eg:    ldpcsim    10      2      1000    0.84    91     1         0'
      print*,'  maxosd<0: do bp only'
      print*,'  maxosd=0: do bp and then call osd once with channel llrs'
      print*,'  maxosd>1: do bp and then call osd maxosd times with saved bp outputs'
      print*,'  norder  : osd decoding depth'
      print*,'  s       : BPSK only, noise sigma, if s<0 value is ignored and sigma is calculated from SNR.'
      print*,'  Keff    : Keff must be in the range [77,91]; Keff-77 is the # of bits to use as CRC.'
      print*,'  modtype : 0, coherent BPSK; 1 noncoherent 8FSK'
      print*,'  channel : 0, AWGN; 1, block Rayleigh (Rayleigh only works with 8FSK!)'
      return
   endif
   call getarg(1,arg)
   read(arg,*) maxosd
   call getarg(2,arg)
   read(arg,*) norder 
   call getarg(3,arg)
   read(arg,*) ntrials
   call getarg(4,arg)
   read(arg,*) s
   call getarg(5,arg)
   read(arg,*) Keff
   call getarg(6,arg)
   read(arg,*) modtype
   call getarg(7,arg)
   read(arg,*) channeltype

!  scale Eb/No for a (174,91) code
   rate=real(K)/real(N)

   write(*,*) "rate: ",rate

   allocate ( codeword(N), decoded(K), message(K) )
   allocate ( rxdata(N) )

   one=.false.
   do i=0,511
      do j=0,8
         if(iand(i,2**j).ne.0) one(i,j)=.true.
      enddo
   enddo

   msg="K9ABC K1ABC FN20"
   i3=0
   n3=1
   call pack77(msg,i3,n3,c77) !Pack into 12 6-bit bytes
   call unpack77(c77,1,msgsent,unpk77_success) !Unpack to get msgsent
   write(*,*) "message sent ",msgsent

   read(c77,'(77i1)') msgbits(1:77)
   write(*,*) 'message'
   write(*,'(a71,1x,a3,1x,a3)') c77(1:71),c77(72:74),c77(75:77)

   call init_random_seed()

   iq=1
   if(modtype.gt.0) then ! MFSK - get tones
      i3=-1
      n3=-1
      call genft8(msg,i3,n3,msgsent,msgbits,itone)
      write(*,*) 'message tones'
      write(*,'(79(i1,1x))') itone
      itonecw(1:29)=itone(8:36)
      itonecw(30:58)=itone(44:72)
      iq=3 ! bits per symbol    
   endif
   call encode174_91(msgbits,codeword)
   write(*,*) 'crc14'
   write(*,'(14i1)') codeword(78:91)
   write(*,*) 'codeword'
   write(*,'(22(8i1,1x))') codeword
   write(*,*) 'Eb/N0   Es/N0   SNR2500   ngood  nundetected   sigma         psymerr            pbiterr'
   do idb = 20,-4,-1
      nsymerr=0
      nbiterr=0
      db=idb/2.0-1.0
      sigma=1/sqrt( 2*rate*iq*(10**(db/10.0)) )
      ngood=0
      nue=0
      nsumerr=0
      do itrial=1, ntrials
! Create a realization of a noisy received word
         if(modtype.eq.0) then
            do i=1,N
               rxdata(i) = 2.0*codeword(i)-1.0 + sigma*gran()
            enddo
            nerr=0
            do i=1,N
               if( rxdata(i)*(2*codeword(i)-1.0) .lt. 0 ) nerr=nerr+1
            enddo
            if(nerr.ge.1) nerrtot(nerr)=nerrtot(nerr)+1

            rxav=sum(rxdata)/N
            rx2av=sum(rxdata*rxdata)/N
            rxsig=sqrt(rx2av-rxav*rxav)
            rxdata=rxdata/rxsig
            if( s .lt. 0 ) then
               ss=sigma
            else
               ss=s
            endif
            llr=2.0*rxdata/(ss*ss)
         else
! noncoherent MFSK
            do i=1,58
               do j=0,7
                  if(j.eq.itonecw(i)) then
                     if(channeltype.eq.0) then
                        A=1.0
                     elseif(channeltype.eq.1) then
                        xI=gran()**2 + gran()**2
                        A=sqrt(xI/2)
                     endif
                     cs(j,i)= A + sigma*gran() + cmplx(0,1)*sigma*gran()
                  elseif(j.ne.itonecw(i)) then
                     cs(j,i)=      sigma*gran() + cmplx(0,1)*sigma*gran()
                  endif
               enddo
               lmax=maxloc(abs(cs(:,i)))
               if(lmax(1)-1.ne.itonecw(i) ) nsymerr=nsymerr+1
            enddo
            do nsym=1,3
               nt=2**(3*nsym)
                  do ks=1,58,nsym
                     amax=-1.0
                     do i=0,nt-1
                        i1=i/64
                        i2=iand(i,63)/8
                        i3=iand(i,7)
                        if(nsym.eq.1) then
                           s2(i)=abs(cs(graymap(i3),ks))
                        elseif(nsym.eq.2) then
                           s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i3),ks+1))
                        elseif(nsym.eq.3) then
                           if(ks.ne.58) then
                              s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks+1)+cs(graymap(i3),ks+2))
                           else
                              s2(i)=abs(cs(graymap(i1),ks))
                           endif
                        else
                           print*,"Error - nsym must be 1, 2, or 3."
                        endif
                     enddo

                     i32=1+(ks-1)*3
                     if(nsym.eq.1) ibmax=2
                     if(nsym.eq.2) ibmax=5
                     if(nsym.eq.3) ibmax=8
                     do ib=0,ibmax
                        bm=maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)) - &
                           maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib))
                        if(i32+ib .gt.174) cycle
                        if(nsym.eq.1) then
                           bmeta(i32+ib)=bm
                           den=max(maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)), &
                              maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib)))
                           if(den.gt.0.0) then
                              cm=bm/den
                           else ! erase it
                              cm=0.0
                           endif
                           bmetd(i32+ib)=cm
                        elseif(nsym.eq.2) then
                           bmetb(i32+ib)=bm
                        elseif(nsym.eq.3) then
                           bmetc(i32+ib)=bm
                        endif
                     enddo
                  enddo
            enddo
            call normalizebmet(bmeta,174)
            call normalizebmet(bmetb,174)
            call normalizebmet(bmetc,174)
            call normalizebmet(bmetd,174)

            scalefac=2.83  
            llra=scalefac*bmeta
            llrb=scalefac*bmetb
            llrc=scalefac*bmetc
            llrd=scalefac*bmetd

            llr=llrc 
         endif

         do i=1, 174 
           if(llr(i)*(codeword(i)-0.5).lt.0) nbiterr=nbiterr+1
         enddo

         nap=0 ! number of AP bits
         llr(1:nap)=5*(2.0*msgbits(1:nap)-1.0)
         apmask=0
         apmask(1:nap)=1
         call decode174_91(llr,Keff,maxosd,norder,apmask,message91,cw,ntype,nharderrors,dmin)
! If the decoder finds a valid codeword, nharderrors will be .ge. 0.
         if( nharderrors.ge.0 ) then
            nhw=count(cw.ne.codeword)
            if(nhw.eq.0) then ! this is a good decode
               ngood=ngood+1
               nerrdec(nerr)=nerrdec(nerr)+1
            else
               nue=nue+1
            endif
         endif
         nsumerr=nsumerr+nerr
      enddo

      esn0=db+10.0*log10(iq*rate) ! iq=3 bits per symbol for 8FSK
      snr2500=esn0-10.0*log10(2500/6.25)
!      pberr=real(nsumerr)/(real(ntrials*N))
      psymerr=real(nsymerr)/(ntrials*174.0/iq)
      pbiterr=real(nbiterr)/(ntrials*174.0)
      write(*,"(f4.1,4x,f5.1,4x,f5.1,1x,i8,1x,i8,8x,f5.2,8x,e10.3,8x,e10.3)") db,esn0,snr2500,ngood,nue,ss,psymerr,pbiterr

   enddo

   open(unit=23,file='nerrhisto.dat',status='unknown')
   do i=1,174
      write(23,'(i4,2x,i10,i10,f10.2)') i,nerrdec(i),nerrtot(i),real(nerrdec(i))/real(nerrtot(i)+1e-10)
   enddo
   close(23)

end program ldpcsim174_91

subroutine normalizebmet(bmet,n)
   real bmet(n)

   bmetav=sum(bmet)/real(n)
   bmet2av=sum(bmet*bmet)/real(n)
   var=bmet2av-bmetav*bmetav
   if( var .gt. 0.0 ) then
      bmetsig=sqrt(var)
   else
      bmetsig=sqrt(bmet2av)
   endif
   bmet=bmet/bmetsig
   return
end subroutine normalizebmet

subroutine k2grid(k,grid)
  character grid*6

  nlong=2*mod((k-1)/5,90)-179
  if(k.gt.450) nlong=nlong+180
  nlat=mod(k-1,5)+ 85
  dlat=nlat
  dlong=nlong
  call deg2grid(dlong,dlat,grid)

  return
end subroutine k2grid

subroutine foxgen(bSuperFox,fname)

  ! Called from MainWindow::foxTxSequencer() to generate the Tx waveform in
  ! FT8 Fox mode.  The Tx message can contain up to 5 "slots", each carrying
  ! its own FT8 signal.
  
  ! Encoded messages can be of the form "HoundCall FoxCall rpt" (a standard FT8
  ! message with i3bit=0) or "HoundCall_1 RR73; HoundCall_2 <FoxCall> rpt", 
  ! a new message type with i3bit=1.  The waveform is generated with
  ! fsample=48000 Hz; it is compressed to reduce the PEP-to-average power ratio,
  ! with (currently disabled) filtering afterware to reduce spectral growth.

  ! Input message information is provided in character array cmsg(5), in
  ! common/foxcom/.  The generated wave(NWAVE) is passed back in the same
  ! common block.
  
  parameter (NN=79,ND=58,NSPS=4*1920)
  parameter (NWAVE=(160+2)*134400*4) !the biggest waveform we generate (FST4-1800 at 48kHz)
  parameter (NFFT=614400,NH=NFFT/2)
  logical*1 bSuperFox,bMoreCQs,bSendMsg
  character*(*) fname
  character*40 cmsg
  character*26 textMsg
  character*37 msg,msgsent
  integer itone(79)
  integer*1 msgbits(77),msgbits2
  integer*1, target:: mycall
  real x(NFFT)
  real*8 dt,twopi,f0,fstep,dfreq,phi,dphi
  complex cx(0:NH)
  common/foxcom/wave(NWAVE),nslots,nfreq,i3bit(5),cmsg(5),mycall(12),  &
       textMsg,bMoreCQs,bSendMsg
  common/foxcom2/itone2(NN),msgbits2(77)
  equivalence (x,cx),(y,cy)

  if(bSuperFox) then
     n=nslots
     if(bMoreCQs) cmsg(1)(40:40)='1'               !Set flag to include a CQ
     if(bSendMsg) then
        n=min(nslots+1,3)
        cmsg(n)=textMsg
        cmsg(n)(39:39)='1'                         !Set flag for text message
        nslots=n
     endif
     open(25,file=fname,status='unknown')
     write(25,'(a40)') cmsg(1:n)
     close(25)
     go to 999
  endif

  fstep=60.d0
  dfreq=6.25d0
  dt=1.d0/48000.d0
  twopi=8.d0*atan(1.d0)
  irpt=0
  nplot=0
  wave=0.

  do n=1,nslots
     msg=cmsg(n)(1:37)
     call genft8(msg,i3,n3,msgsent,msgbits,itone)
! Make copies of itone() and msgbits() for ft8sim
     itone2=itone
     msgbits2=msgbits
     f0=nfreq + fstep*(n-1)
     phi=0.d0
     k=0
     do j=1,NN
        f=f0 + dfreq*itone(j)
        dphi=twopi*f*dt
        do ii=1,NSPS
           k=k+1
           phi=phi+dphi
           xphi=phi
           wave(k)=wave(k)+sin(xphi)
        enddo
     enddo
  enddo
  kz=k
  
  peak1=maxval(abs(wave))
  wave=wave/peak1
  width=50.0
  call foxfilt(nslots,nfreq,width,wave)
  peak3=maxval(abs(wave))
  wave=wave/peak3
  
999 return
end subroutine foxgen

! include 'plotspec.f90'

program ldpcsim

use, intrinsic :: iso_c_binding
use hashing
use packjt

character*22 msg,msgsent,msgreceived
character*8 arg
integer*1, allocatable ::  codeword(:), decoded(:), message(:)
real*8, allocatable ::  rxdata(:), rxavgd(:)
real, allocatable :: llr(:)
integer ihash
integer*1 hardbits(32)

nargs=iargc()
if(nargs.ne.4) then
   print*,'Usage: ldpcsim  niter navg   #trials  s '
   print*,'eg:    ldpcsim   10     1     1000    0.75'
   return
endif
call getarg(1,arg)
read(arg,*) max_iterations 
call getarg(2,arg)
read(arg,*) navg 
call getarg(3,arg)
read(arg,*) ntrials 
call getarg(4,arg)
read(arg,*) s

K=16
N=32
!rate=real(K)/real(N)
! don't count hash bits as data bits
rate=4.0/real(N)
write(*,*) "rate: ",rate
write(*,*) "niter= ",max_iterations,"navg= ",navg," s= ",s

allocate ( codeword(N), decoded(K), message(K) )
allocate ( rxdata(N), rxavgd(N), llr(N) )

msg="K1JT K9AN"
call fmtmsg(msg,iz)
call hash(msg,22,ihash)
irpt=14
ihash=iand(ihash,4095)                 !12-bit hash
ig=16*ihash + irpt                     !4-bit report
write(*,*) irpt,ihash,ig

do i=1,16
  message(i)=iand(1,ishft(ig,1-i))
enddo
write(*,'(16i1)') message
call encode_msk40(message,codeword)
write(*,'(32i1)') codeword
call init_random_seed()

write(*,*) "Eb/N0  SNR2500   ngood  nundetected nbadhash"
do idb = 0, 30
  db=idb/2.0
  sigma=1/sqrt( 2*rate*(10**(db/10.0)) )
  ngood=0
  nue=0
  nbadhash=0

  itsum=0
  do itrial=1, ntrials
    rxavgd=0d0
    do iav=1,navg
      call sgran()
! Create a realization of a noisy received word
      do i=1,N
        rxdata(i) = 2.0*codeword(i)-1.0 + sigma*gran()
      enddo
      rxavgd=rxavgd+rxdata
    enddo
    rxdata=rxavgd

! Correct signal normalization is important for this decoder.
    rxav=sum(rxdata)/N
    rx2av=sum(rxdata*rxdata)/N
    rxsig=sqrt(rx2av-rxav*rxav)
    rxdata=rxdata/rxsig
    if( s .le. 0 ) then
      ss=sigma
    else 
      ss=s
    endif

    llr=2.0*rxdata/(ss*ss)

    call bpdecode40(llr, max_iterations, decoded, niterations)
! If the decoder finds a valid codeword, niterations will be .ge. 0.
    if( niterations .ge. 0 ) then
      nueflag=0
      nhashflag=0
      imsg=0
      do i=1,16
        imsg=ishft(imsg,1)+iand(1,decoded(17-i))
      enddo
      nrxrpt=iand(imsg,15)
      nrxhash=(imsg-nrxrpt)/16
      if( nrxhash .ne. ihash ) then
        nbadhash=nbadhash+1
        nhashflag=1   
      endif

! Check the message plus hash against what was sent.
      do i=1,K
        if( message(i) .ne. decoded(i) ) then
          nueflag=1
        endif
      enddo

      if( nhashflag .eq. 0 .and. nueflag .eq. 0 ) then
        ngood=ngood+1
        itsum=itsum+niterations
      else if( nhashflag .eq. 0 .and. nueflag .eq. 1 ) then
        nue=nue+1;
      endif
    else
      hardbits=0
      where(llr .gt. 0) hardbits=1
!      write(*,'(32i1)') hardbits 
!      write(*,'(32i1)') codeword 
      isum=0
      do i=1,32
        if( hardbits(i) .ne. codeword(i) ) isum=isum+1
      enddo
!      write(*,*) 'number of errors ',isum
    endif
  enddo
  avits=real(itsum)/real(ngood+0.1)
  snr2500=db-10.0
  write(*,"(f4.1,4x,f5.1,1x,i8,1x,i8,1x,i8,1x,f8.2,1x,f8.1)") db,snr2500,ngood,nue,nbadhash,ss,avits

enddo

end program ldpcsim

module ccf65_mod
   implicit none

contains

   subroutine ccf65(ss, nhsym, ssmax, sync1, ipol1, jpz, dt1, flipk, &
                    syncshort, snr2, ipol2, dt2)

      use debug_log
      use pctile_mod
      use four2a_mod
      implicit none

      integer, parameter :: NFFT = 512, NH = NFFT/2

      ! Arguments
      real, intent(in)    :: ss(4, 322)                   ! Input: half-symbol powers, 4 pol'ns
      integer, intent(in) :: nhsym, jpz
      real, intent(in)    :: ssmax
      real, intent(out)   :: sync1, dt1, flipk, syncshort, snr2, dt2
      integer, intent(out):: ipol1, ipol2

      ! Working arrays (per call)
      real s(NFFT)                     ! CCF = ss*pr
      complex cs(NFFT)                    ! Complex FT of s
      real s2(NFFT)                    ! CCF = ss*pr2
      complex cs2(NFFT)                   ! Complex FT of s2
      real tmp1(322)
      real ccf(-11:54, 4)

      ! Sync templates (persist across calls)
      logical, save :: first = .true.
      integer       :: npr(126)
      real, save :: pr(NFFT)           ! JT65 pseudo-random sync pattern
      real, save :: pr2(NFFT)          ! JT65 shorthand pattern
      complex, save :: cpr(NFFT)          ! Complex FT of pr
      complex, save :: cpr2(NFFT)         ! Complex FT of pr2

      ! Locals
      integer ip, i, j, k, lag, lagpk, lagpk2
      real base, ccf2, ccfbest, ccfbest2
      real fac, rms, sq, sumccf

      ! The JT65 pseudo-random sync pattern:
      data npr/ &
         1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, &
         0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, &
         0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 1, &
         0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, &
         1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, &
         0, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 1, &
         1, 1, 1, 1, 1, 1/

      !---------------------------------------------------------------
      ! One-time initialization of sync templates
      !---------------------------------------------------------------
      if (first) then
         fac = 1.0/NFFT

         pr = 0.0
         pr2 = 0.0

         do i = 1, NFFT
            k = 2*mod((i - 1)/8, 2) - 1
            if (i <= NH) pr2(i) = fac*k
         enddo

         do i = 1, 126
            j = 2*i
            pr(j) = fac*(2*npr(i) - 1)
         enddo

         ! Load real templates into complex arrays and FFT them
         do i = 1, NFFT
            cpr(i) = cmplx(pr(i), 0.0)
            cpr2(i) = cmplx(pr2(i), 0.0)
         enddo

         call four2a(cpr, NFFT, 1, -1, 0)
         call four2a(cpr2, NFFT, 1, -1, 0)

         first = .false.
      endif

      syncshort = 0.0
      snr2 = 0.0

      ccfbest = 0.0
      ccfbest2 = 0.0
      ipol1 = 1
      ipol2 = 1
      lagpk = 0
      lagpk2 = 0

      !---------------------------------------------------------------
      ! Loop over polarizations
      !---------------------------------------------------------------
      do ip = 1, jpz

         ! Build s from ss, with clipping
         do i = 1, nhsym - 1
            s(i) = min(ssmax, ss(ip, i) + ss(ip, i + 1))
         enddo
         s(nhsym:NFFT) = 0.0

         ! Remove local baseline
         call pctile(s, nhsym - 1, 50, base)
         s(1:nhsym - 1) = s(1:nhsym - 1) - base

         ! Forward FFT of s
         do i = 1, NFFT
            cs(i) = cmplx(s(i), 0.0)
         enddo
         call four2a(cs, NFFT, 1, -1, 0)

         ! Multiply by sync templates in frequency domain
         do i = 1, NFFT
            cs2(i) = cs(i)*conjg(cpr2(i))
            cs(i) = cs(i)*conjg(cpr(i))
         enddo

         ! Inverse FFT back to time domain
         call four2a(cs, NFFT, 1, 1, -1)
         call four2a(cs2, NFFT, 1, 1, -1)

         ! Extract real parts into s, s2
         do i = 1, NFFT
            s(i) = real(cs(i))
            s2(i) = real(cs2(i))
         enddo

         ! Find best JT65 sync
         do lag = -11, 54
            j = lag
            if (j < 1) j = j + NFFT
            ccf(lag, ip) = s(j)
            if (abs(ccf(lag, ip)) > ccfbest) then
               ccfbest = abs(ccf(lag, ip))
               lagpk = lag
               ipol1 = ip
               flipk = 1.0
               if (ccf(lag, ip) < 0.0) flipk = -1.0
            endif
         enddo

         ! Best shorthand
         do lag = -11, 54
            ccf2 = s2(lag + 28)
            if (ccf2 > ccfbest2) then
               ccfbest2 = ccf2
               lagpk2 = lag
               ipol2 = ip
            endif
         enddo

      enddo  ! ip

      ! If no sync peak found, bail cleanly
      if (ccfbest == 0.0) then
         sync1 = -4.0
         dt1 = 0.0
         syncshort = 0.0
         snr2 = 0.0
         dt2 = 0.0
         return
      endif

      !---------------------------------------------------------------
      ! Baseline and RMS for normalization
      !---------------------------------------------------------------
      sumccf = 0.0
      do lag = -11, 54
         if (abs(lag - lagpk) > 1) sumccf = sumccf + ccf(lag, ipol1)
      enddo
      base = sumccf/50.0

      sq = 0.0
      do lag = -11, 54
         if (abs(lag - lagpk) > 1) sq = sq + (ccf(lag, ipol1) - base)**2
      enddo
      rms = sqrt(sq/49.0)

      sync1 = -4.0
      if (rms > 0.0) sync1 = ccfbest/rms - 4.0
      dt1 = lagpk*(2048.0/11025.0) - 2.5

      !---------------------------------------------------------------
      ! Shorthand SNR and timing
      !---------------------------------------------------------------
      do i = 1, nhsym
         tmp1(i) = ss(ipol2, i)
      enddo
      call pctile(tmp1, nhsym, 40, base)

      snr2 = 0.01
      if (base > 0.0) snr2 = 0.398107*ccfbest2/base
      if (rms > 0.0) then
         syncshort = 0.5*ccfbest2/rms - 4.0
      else
         syncshort = -4.0
      endif
      dt2 = 2.5 + lagpk2*(2048.0/11025.0)

   end subroutine ccf65

end module ccf65_mod

module jt65_test

  ! Test the JT65 decoder for WSJT-X

  implicit none

  public :: test
  integer, parameter, public :: NZMAX=60*12000
  integer, public :: nft

contains

  subroutine test (dd,nutc,nflow,nfhigh,nfqso,ntol,nsubmode,n2pass,nrobust     &
       ,ntrials,naggressive,ndepth,mycall,hiscall,hisgrid,nexp_decode,         &
        nQSOProgress,ljt65apon)
    use timer_module, only: timer
    use jt65_decode
    implicit none

    include 'constants.f90'
    real, intent(in) :: dd(NZMAX)
    integer, intent(in) :: nutc, nflow, nfhigh, nfqso, ntol, nsubmode, n2pass  &
         , ntrials, naggressive, ndepth, nexp_decode, nQSOProgress
    logical, intent(in) :: nrobust,ljt65apon
    character(len=12), intent(in) :: mycall, hiscall
    character(len=6), intent(in) :: hisgrid
    type(jt65_decoder) :: my_decoder
    logical nclearave                          !### Should be a dummy arg?
    nclearave=.false.

    call timer('jt65a   ',0)
    call my_decoder%decode(my_callback,dd,npts=52*12000,newdat=.true.,     &
         nutc=nutc,nf1=nflow,nf2=nfhigh,nfqso=nfqso,ntol=ntol,             &
         nsubmode=nsubmode, minsync=-1,nagain=.false.,n2pass=n2pass,       &
         nrobust=nrobust,ntrials=ntrials,naggressive=naggressive,          &
         ndepth=ndepth,emedelay=0.0,clearave=nclearave,mycall=mycall,      &
         hiscall=hiscall,hisgrid=hisgrid,nexp_decode=nexp_decode,          &
         nQSOProgress=nQSOProgress,ljt65apon=ljt65apon)
    call timer('jt65a   ',1)
  end subroutine test

  subroutine my_callback (this,sync,snr,dt,freq,drift,nflip,width,     &
       decoded,ft,qual,smo,sum,minsync)
    use jt65_decode
    implicit none

    class(jt65_decoder), intent(inout) :: this
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    integer, intent(in) :: freq
    integer, intent(in) :: drift
    integer, intent(in) :: nflip
    real, intent(in) :: width
    character(len=22), intent(in) :: decoded
    integer, intent(in) :: ft
    integer, intent(in) :: qual
    integer, intent(in) :: smo
    integer, intent(in) :: sum
    integer, intent(in) :: minsync

    integer nwidth
    real t

    if(minsync+nflip+qual.eq.-9999) stop            !Silence compiler warning
    t=max(0.0,width*width-7.2)
    nwidth=max(nint(sqrt(t)),2)
!### deal with nflip here! ###
!### also single_decode, csync, etc... ###
    write(*,1012) nint(sync),snr,dt,freq,drift,nwidth,         &
         decoded,ft,sum,smo
1012 format(i4,i5,f6.2,i5,i4,i3,1x,a22,' JT65',3i3)
    nft=ft
    call flush(6)

  end subroutine my_callback

end module jt65_test

module astrosub_mod
  use iso_fortran_env, only: real64
  use iso_c_binding, only: c_int, c_double, c_char
  use astro0_mod
  implicit none

contains

  ! Pure Fortran interface (internal)
  subroutine astrosub(nyear,month,nday,uth8,nfreq,mygrid,hisgrid,          &
       AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
       RAMoon8,DecMoon8,Dgrd8,poloffset8,xnr8)
    implicit none
    integer,        intent(in)  :: nyear, month, nday, nfreq
    real(real64),   intent(inout)  :: uth8
    character(len=6), intent(in):: mygrid, hisgrid
    real(real64),   intent(out) :: AzSun8, ElSun8, AzMoon8, ElMoon8
    real(real64),   intent(out) :: AzMoonB8, ElMoonB8
    integer,        intent(out) :: ntsky, ndop, ndop00
    real(real64),   intent(out) :: RAMoon8, DecMoon8, Dgrd8
    real(real64),   intent(out) :: poloffset8, xnr8

    ! Locals for astro0 extras we don’t export
    real(real64) :: dbMoon8, HA8, sd8, dfdt, dfdt0
    real(real64) :: width1, width2, w501, w502, xlst8

    call astro0(nyear,month,nday,uth8,nfreq,mygrid,hisgrid,                &
       AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
       dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,  &
       width1,width2,w501,w502,xlst8)
  end subroutine astrosub

  subroutine astrosub_legacy(nyear,month,nday,uth8,nfreq,                    &
                            mygrid,hisgrid,                                 &
                            azsun,elsun,azmoon,elmoon,                      &
                            azmoondx,elmoondx,                              &
                            ntsky,ndop,ndop00,                              &
                            ramoon,decmoon,dgrd,poloffset,xnr,              &
                            len1,len2)                                      &
      bind(C, name='astrosub_')

    use iso_c_binding
    implicit none

    ! ===== C ABI dummy arguments (must match C++ exactly) =====
    integer(c_int),    intent(inout) :: nyear, month, nday, nfreq
    real(c_double),    intent(inout) :: uth8
    character(c_char), intent(in)    :: mygrid(*), hisgrid(*)
    real(c_double),    intent(out)   :: azsun, elsun, azmoon, elmoon
    real(c_double),    intent(out)   :: azmoondx, elmoondx
    integer(c_int),    intent(out)   :: ntsky, ndop, ndop00
    real(c_double),    intent(out)   :: ramoon, decmoon, dgrd
    real(c_double),    intent(out)   :: poloffset, xnr
    integer(c_int),    value         :: len1, len2

    ! ===== Local CHARACTER*6 buffers =====
    character(len=6) :: g1, g2

    ! ===== Local Fortran outputs =====
    real(real64) :: AzSun8, ElSun8, AzMoon8, ElMoon8
    real(real64) :: AzMoonB8, ElMoonB8
    integer      :: ntsky_loc, ndop_loc, ndop00_loc
    real(real64) :: RAMoon8, DecMoon8, Dgrd8, poloffset8, xnr8
    
    ! ===== Convert C strings to CHARACTER*6 =====
    call copy_c_to_f6(g1, mygrid, len1)
    call copy_c_to_f6(g2, hisgrid, len2)

    ! ===== Call modern Fortran routine =====
    call astrosub(nyear,month,nday,uth8,nfreq,g1,g2,                         &
        AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,                    &
        ntsky_loc,ndop_loc,ndop00_loc,                                      &
        RAMoon8,DecMoon8,Dgrd8,poloffset8,xnr8)
    ! ===== Copy results back to C =====
    azsun    = AzSun8
    elsun    = ElSun8
    azmoon   = AzMoon8
    elmoon   = ElMoon8
    azmoondx = AzMoonB8
    elmoondx = ElMoonB8

    ntsky    = ntsky_loc
    ndop     = ndop_loc
    ndop00   = ndop00_loc

    ramoon   = RAMoon8
    decmoon  = DecMoon8
    dgrd     = Dgrd8
    poloffset= poloffset8
    xnr      = xnr8
  end subroutine astrosub_legacy

  ! C-callable wrapper: astrosub00_
  subroutine astrosub00(nyear,month,nday,uth8,nfreq,mygrid,ndop00, mygrid_len) &
       bind(C, name='astrosub00_')
    use iso_c_binding
    implicit none
    ! C ABI arguments
    integer(c_int),    intent(inout) :: nyear, month, nday, nfreq, ndop00
    real(c_double),    intent(inout) :: uth8
    character(c_char), intent(in)    :: mygrid(*)
    integer(c_int),    value         :: mygrid_len

    ! Locals
    character(len=6) :: mygrid6, hisgrid6
    integer          :: ntsky, ndop
    real(real64)     :: AzSun8, ElSun8, AzMoon8, ElMoon8
    real(real64)     :: AzMoonB8, ElMoonB8
    real(real64)     :: RAMoon8, DecMoon8, Dgrd8
    real(real64)     :: poloffset8, xnr8

    ! C string → Fortran CHARACTER*6
    call copy_c_to_f6(mygrid6, mygrid, mygrid_len)
    hisgrid6 = mygrid6   ! same grid for now

    call astrosub(nyear,month,nday,uth8,nfreq,mygrid6,hisgrid6,            &
       AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
       RAMoon8,DecMoon8,Dgrd8,poloffset8,xnr8)
       
  end subroutine astrosub00

  subroutine copy_c_to_f6(dest, src, n)
    use iso_c_binding, only: c_char, c_int, c_double, c_null_char

    character(len=6),   intent(out) :: dest
    character(c_char),  intent(in)  :: src(*)
    integer(c_int),     intent(in)  :: n
    integer :: i

    dest = '      '
    do i = 1, min(6, n)
      if (src(i) == c_null_char) exit
      dest(i:i) = src(i)
    end do
  end subroutine copy_c_to_f6

end module astrosub_mod

subroutine pctile(x,npts,npct,xpct)

  real x(npts)
  real,allocatable :: tmp(:)

  if(npts.lt.0 .or. npct.lt.0 .or. npct.gt.100) then
     xpct=1.0
     go to 900
  endif
  allocate(tmp(npts))

  tmp=x
  call shell(npts,tmp)
  j=nint(npts*0.01*npct)
  if(j.lt.1) j=1
  if(j.gt.npts) j=npts
  xpct=tmp(j)
  deallocate(tmp)

900 return
end subroutine pctile

subroutine gen9(msg0,ichk,msgsent,i4tone,itype)

! Encodes a JT9 message and returns msgsent, the message as it will
! be decoded, and an integer array i4tone(85) of 9-FSK tone values 
! in the range 0-8.  

  use packjt
  character*22 msg0
  character*22 message                    !Message to be generated
  character*22 msgsent                    !Message as it will be received
  integer*4 i4Msg6BitWords(13)            !72-bit message as 6-bit words
  integer*1 i1Msg8BitBytes(13)            !72 bits and zero tail as 8-bit bytes
  integer*1 i1EncodedBits(207)            !Encoded information-carrying bits
  integer*1 i1ScrambledBits(207)          !Encoded bits after interleaving
  integer*4 i4DataSymbols(69)             !Data symbols (values 0-7)
  integer*4 i4GrayCodedSymbols(69)        !Gray-coded symbols (values 0-7)
  integer*4 i4tone(85)                    !Tone #s, data and sync (values 0-8)
  include 'jt9sync.f90'
  save

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    i4tone(1)=nfreq
  else
     message=msg0
     do i=1,22
        if(ichar(message(i:i)).eq.0) then
           message(i:)='                      '
           exit
        endif
     enddo

     do i=1,22                               !Strip leading blanks
        if(message(1:1).ne.' ') exit
        message=message(i+1:)
     enddo

     call packmsg(message,i4Msg6BitWords,itype) !Pack into 12 6-bit bytes
     call unpackmsg(i4Msg6BitWords,msgsent) !Unpack to get msgsent
     if(ichk.ne.0) go to 999
     call entail(i4Msg6BitWords,i1Msg8BitBytes)  !Add tail, make 8-bit bytes
     nsym2=206
     call encode232(i1Msg8BitBytes,nsym2,i1EncodedBits)   !Encode K=32, r=1/2
     i1EncodedBits(207)=0
     call interleave9(i1EncodedBits,1,i1ScrambledBits)    !Interleave bits
     i1ScrambledBits(207)=0
     call packbits(i1ScrambledBits,69,3,i4DataSymbols)    !Pk 3-bits into words
     call graycode(i4DataSymbols,69,1,i4GrayCodedSymbols) !Apply Gray code

! Insert sync symbols at ntone=0 and add 1 to the data-tone numbers.
     j=0
     do i=1,85
        if(isync(i).eq.1) then
           i4tone(i)=0
        else
           j=j+1
           i4tone(i)=i4GrayCodedSymbols(j)+1
        endif
     enddo
  endif

999 return
end subroutine gen9

subroutine recvpkt(nsam,nblock2,userx_no,k,buf4,buf8,ndb)

! Reformat timf2 data from Linrad and stuff data into r*4 array dd().

  include 'njunk.f90'
  parameter (NSMAX=60*96000)          !Total sample intervals per minute
  parameter (NFFT=32768)
  integer*1 userx_no
  real*4 d4,buf4(*)                   !(348)
  real*8 d8,buf8(*)                   !(174)
  integer*2 jd(4),kd(2),nblock2
  real*4 yd(2)
  real*8 fcenter
  common/datcom/dd(2,5760000),ss(400,NFFT),savg(NFFT),fcenter,nutc,  &
       junk(NJUNK)
  equivalence (kd,d4)
  equivalence (jd,d8,yd)

  gain=10.0**(0.05*ndb)
  if(nblock2.eq.-9999) nblock2=-9998    !Silence a compiler warning
  if(nsam.eq.-1) then
! Move data from the UDP packet buffer into array dd().
     if(userx_no.eq.-1) then
        do i=1,174                    !One RF channel, r*4 data
           k=k+1
           d8=buf8(i)
           dd(1,k)=yd(1)*gain
           dd(2,k)=yd(2)*gain
        enddo
     else if(userx_no.eq.1) then
        do i=1,348                    !One RF channel, i*2 data
           k=k+1
           d4=buf4(i)
           dd(1,k)=kd(1)*gain
           dd(2,k)=kd(2)*gain
        enddo
     endif
  else
     if(userx_no.eq.1) then
        do i=1,nsam                    !One RF channel, r*4 data
           k=k+1
           d4=buf4(i)
           dd(1,k)=kd(1)*gain
           dd(2,k)=kd(2)*gain

           k=k+1
           dd(1,k)=kd(1)*gain
           dd(2,k)=kd(2)*gain
        enddo
     endif
  endif

  return
end subroutine recvpkt

module smo_mod
  implicit none
contains
  subroutine smo(x,npts,y,nadd)
    implicit none
    integer, intent(in) :: npts, nadd
    real, intent(inout) :: x(npts)
    real, intent(out) :: y(npts)
    integer :: nh, i, j
    real :: sum
  
    nh=nadd/2
    do i=1+nh,npts-nh
       sum=0.
       do j=-nh,nh
          sum=sum + x(i+j)
       enddo
       y(i)=sum
    enddo
    x=y
    x(:nh)=0.
    x(npts-nh+1:)=0.
  
  end subroutine smo
end module smo_mod

subroutine fix_contest_msg(mygrid,msg)

! If distance from mygrid to grid1 is more thsn 10000 km, change "grid1"
! to "R grid2" where grid2 is the antipodes of grid1.

  character*6 mygrid
  character*22 msg
  character*6 g1,g2
  logical isgrid

  isgrid(g1)=g1(1:1).ge.'A' .and. g1(1:1).le.'R' .and. g1(2:2).ge.'A' .and. &
       g1(2:2).le.'R' .and. g1(3:3).ge.'0' .and. g1(3:3).le.'9' .and.       &
       g1(4:4).ge.'0' .and. g1(4:4).le.'9' .and. g1(1:4).ne.'RR73'

  n=len(trim(msg))
  if(n.lt.4) return

  g1=msg(n-3:n)//'  '
  if(isgrid(g1)) then
     call azdist(mygrid,g1,0.d0,nAz,nEl,nDmiles,nDkm,nHotAz,nHotABetter)
     if(ndkm.gt.10000) then
        call grid2deg(g1,dlong,dlat)
        dlong=dlong+180.0
        if(dlong.gt.180.0) dlong=dlong-360.0
        dlat=-dlat
        call deg2grid(dlong,dlat,g2)
        msg=msg(1:n-4)//'R '//g2(1:4)
     endif
  endif

  return
end subroutine fix_contest_msg

program msk144sim

  use wavhdr
  parameter (NMAX=30*12000)
  real pings(0:NMAX-1)
  real waveform(0:NMAX-1)
  character arg*8,msg*37,msgsent*37,fname*40
  real wave(0:NMAX-1)              !Simulated received waveform
  real*8 twopi,freq,phi,dphi0,dphi1,dphi
  type(hdr) h                          !Header for .wav file
  integer*2 iwave(0:NMAX-1)
  integer itone(144)                   !Message bits

  nargs=iargc()
  if(nargs.ne.6) then
     print*,'Usage:   msk144sim       message      TRp freq width snr nfiles'
     print*,'Example: msk144sim "K1ABC W9XYZ EN37"  15 1500  0.12   2    1'
     print*,'         msk144sim "K1ABC W9XYZ EN37"  30 1500  2.5   15    1'
     go to 999
  endif
  call getarg(1,msg)
  call getarg(2,arg)
  read(arg,*) nTRperiod
  call getarg(3,arg)
  read(arg,*) freq
  call getarg(4,arg)
  read(arg,*) width
  call getarg(5,arg)
  read(arg,*) snrdb
  call getarg(6,arg)
  read(arg,*) nfiles

!sig is the peak amplitude of the ping. 
  sig=sqrt(2.0)*10.0**(0.05*snrdb)
  npts=nTRperiod*12000
  h=default_header(12000,npts)
  i1=len(trim(msg))-5
  ichk=0
  itype=1
  call fmtmsg(msg,iz)
  call genmsk_128_90(msg,ichk,msgsent,itone,itype) 
  write(*,*) 'Requested message: ',msg
  write(*,*) 'Message sent     : ',msgsent
  write(*,*) 'Tones: '
  if(itone(41).ge.0) then
     write(*,'(1x,72i1)') itone(1:72)
     write(*,'(1x,72i1)') itone(73:144)
  else
     write(*,'(1x,40i1)') itone(1:40)
  endif

  twopi=8.d0*atan(1.d0)
  nsym=144
  nsps=6
  if( itone(41) .lt. 0 ) nsym=40
  baud=2000.d0
  dphi0=twopi*(freq-0.25d0*baud)/12000.d0
  dphi1=twopi*(freq+0.25d0*baud)/12000.d0
  phi=0.0
  k=0
  nreps=npts/(nsym*nsps)

  do jrep=1,nreps
    do i=1,nsym
      if( itone(i) .eq. 0 ) then
        dphi=dphi0
      else
        dphi=dphi1
      endif
      do j=1,nsps
        waveform(k)=cos(phi)
        k=k+1
        phi=mod(phi+dphi,twopi)
      enddo 
    enddo
  enddo 

  if(itype.lt.1 .or. itype.gt.7) then
     print*,'Illegal message'
     go to 999
  endif

  call makepings(pings,nTRperiod,npts,width,sig)

!  call sgran()
  do ifile=1,nfiles                  !Loop over requested number of files
     write(fname,1002) ifile         !Output filename
1002 format('000000_',i6.6)
     open(10,file=fname(1:13)//'.wav',access='stream',status='unknown')

     wave=0.0
     iwave=0
     fac=sqrt(6000.0/2500.0)
     do i=0,npts-1
        xx=gran()
        wave(i)=pings(i)*waveform(i) + fac*xx
        iwave(i)=30.0*wave(i)
     enddo

     write(10) h,iwave(0:npts-1)               !Save the .wav file
     endfile(10)
     close(10)

  enddo

999 end program msk144sim

subroutine getpfx2(k0,callsign)

  character callsign*12
  include 'pfx.f90'
  character addpfx*8
  common/pfxcom/addpfx

  k=k0
  if(k.gt.450) k=k-450
  if(k.ge.1 .and. k.le.NZ) then
     iz=index(pfx(k),' ') - 1
     callsign=pfx(k)(1:iz)//'/'//callsign
  else if(k.ge.401 .and. k.le.400+NZ2) then
     iz=index(callsign,' ') - 1
     callsign=callsign(1:iz)//'/'//sfx(k-400)
  else if(k.eq.449) then
     iz=index(addpfx,' ') - 1
     if(iz.lt.1) iz=8
     callsign=addpfx(1:iz)//'/'//callsign
  endif

  return
end subroutine getpfx2

subroutine polfit(y,npts,a)

! Input:  y(npts)                !Expect npts=4
! Output: a(1) = baseline
!         a(2) = amplitude
!         a(3) = theta (deg)

  real y(npts)
  real a(3)
  real deltaa(3)
  integer ipk(1)
  save

! Set starting values:
  a(1)=minval(y)
  a(2)=maxval(y)-a(1)
  ipk=maxloc(y)
  a(3)=(ipk(1)-1)*45.0

  deltaa(1:2)=0.1*a(2)
  deltaa(3)=10.0
  nterms=3

!  Start the iteration
  chisqr=0.
  chisqr0=1.e6
  iters=10

  do iter=1,iters
     do j=1,nterms
        chisq1=fchisq_pol(y,npts,a)
        fn=0.
        delta=deltaa(j)
10      a(j)=a(j)+delta
        chisq2=fchisq_pol(y,npts,a)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      fn=fn+1.0
        a(j)=a(j)+delta
        chisq3=fchisq_pol(y,npts,a)
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
        deltaa(j)=deltaa(j)*fn/3.
!          write(*,4000) iter,j,a,deltaa,chisq2
!4000      format(2i2,2(2x,3f8.2),f12.5)
     enddo  ! j=1,nterms
     chisqr=fchisq_pol(y,npts,a)
!     write(*,4000) 0,0,a,chisqr
     if(chisqr.lt.1.0) exit
     if(deltaa(1).lt.0.01*(a(2)-a(1)) .and. deltaa(2).lt.0.01*(a(2)-a(1))   &
          .and. deltaa(3).lt.1.0) exit
     if(chisqr/chisqr0.gt.0.99) exit
     chisqr0=chisqr
  enddo  ! iter
  a(3)=mod(a(3)+360.0,180.0)

  return
end subroutine polfit

real function fchisq_pol(y,npts,a)

  real y(npts),a(3)
  data rad/57.2957795/
  
  chisq = 0.
  do i=1,npts
     theta=(i-1)*45.0
     yfit=a(1) + a(2)*cos((theta-a(3))/rad)**2
     chisq=chisq + (y(i) - yfit)**2
  enddo
  fchisq_pol=chisq

  return
end function fchisq_pol

program q65params

  integer ntrp(5)
  integer nsps(5)
  data ntrp/15,30,60,120,300/
  data nsps/1800,3600,7200,16000,41472/

  write(*,1000)
1000 format('T/R   tsym   baud    BW     TxT    SNR'/39('-'))
  do i=1,5
     baud=12000.0/nsps(i)
     bw=65.0*baud
     tsym=1.0/baud
     txt=85.0*tsym
     snr=-27.0 + 10.0*log10(7200.0/nsps(i))
     write(*,1010) ntrp(i),tsym,baud,bw,txt,snr
1010 format(i3,2f7.3,3f7.1)
  enddo

  do j=1,5
     write(*,1020) char(ichar('A')+j-1)
1020 format(/a1,'  T/R   baud    BW'/20('-'))
     do i=1,5
        baud=12000.0/nsps(i)
        spacing=baud*2**(j-1)
        bw=65.0*spacing
        write(*,1030) ntrp(i),spacing,nint(bw)
1030    format(i6,f7.2,i6)
     enddo
  enddo

end program q65params

subroutine packprop(k,muf,ccur,cxp,n1)

! Pack propagation indicators into a 21-bit number.

! k      k-index, 0-9; 10="N/A"
! muf    muf, 2-60 MHz; 0=N/A, 1="none", 61=">60 MHz"
! ccur   up to two current events, each indicated by single
!        or double letter.
! cxp    zero or one expected event, indicated by single or
!        double letter

  character ccur*4,cxp*2

  j=ichar(ccur(1:1))-64
  if(j.lt.0) j=0
  n1=j
  do i=2,4
     if(ccur(i:i).eq.' ') go to 10
     if(ccur(i:i).eq.ccur(i-1:i-1)) then
        n1=n1+26
     else
        j=ichar(ccur(i:i))-64
        if(j.lt.0) j=0
        n1=53*n1 + j
     endif
  enddo

10 j=ichar(cxp(1:1))-64
  if(j.lt.0) j=0
  if(cxp(2:2).eq.cxp(1:1)) j=j+26
  n1=53*n1 + j
  n1=11*n1 + k
  n1=62*n1 + muf

  return
end subroutine packprop

subroutine encode232(dat,nsym,symbol)

! Convolutional encoder for a K=32, r=1/2 code.

  integer*1 dat(13)                 !User data, packed 8 bits per byte
  integer*1 symbol(206)             !Channel symbols, one bit per byte
  integer*1 i1
  include 'conv232.f90'

  nstate=0
  k=0
  do j=1,nsym
     do i=7,0,-1
        i1=dat(j)
        i4=i1
        if (i4.lt.0) i4=i4+256
        nstate=ior(ishft(nstate,1),iand(ishft(i4,-i),1))
        n=iand(nstate,npoly1)
        n=ieor(n,ishft(n,-16))
        k=k+1
        symbol(k)=partab(iand(ieor(n,ishft(n,-8)),255))
        n=iand(nstate,npoly2)
        n=ieor(n,ishft(n,-16))
        k=k+1
        symbol(k)=partab(iand(ieor(n,ishft(n,-8)),255))
        if(k.ge.nsym) go to 100
     enddo
  enddo

100 continue

  return
end subroutine encode232

subroutine refspectrum(id2,bclear,brefspec,buseref,fname)

! Input:
!  id2       i*2        Raw 16-bit integer data, 12000 Hz sample rate
!  brefspec  logical    True when accumulating a reference spectrum

  parameter (NFFT=6912,NH=NFFT/2,NPOLYLOW=400,NPOLYHIGH=2600)
  integer*2 id2(NFFT)
  logical*1 bclear,brefspec,buseref,blastuse
  
  real xs(0:NH-1)                         !Saved upper half of input chunk convolved with h(t) 
  real x(0:NFFT-1)                        !Work array
  real*4 w(0:NFFT-1)                      !Window function
  real*4 s(0:NH)                          !Average spectrum
  real*4 fil(0:NH)
  real*8 xfit(1500),yfit(1500),sigmay(1500),a(5),chisqr !Polyfit arrays
  logical first
  complex cx(0:NH)                        !Complex frequency-domain work array
  complex cfil(0:NH)
  character*(*) fname
  common/spectra/syellow(6827),ref(0:NH),filter(0:NH)
  equivalence(x,cx)
  data first/.true./,blastuse/.false./
  save

  if(first) then
     pi=4.0*atan(1.0)
     do i=0,NFFT-1
        ww=sin(i*pi/NFFT)
        w(i)=ww*ww/NFFT
     enddo
     nsave=0
     s=0.0
     filter=1.0
     xs=0.
     first=.false.
  endif
  if(bclear) s=0.

  if(brefspec) then
     x(0:NH-1)=0.001*id2(1:NH)
     x(NH:NFFT-1)=0.0
     call four2a(cx,NFFT,1,-1,0)                 !r2c FFT

     do i=1,NH
        s(i)=s(i) + real(cx(i))**2 + aimag(cx(i))**2
     enddo
     nsave=nsave+1

     fac0=0.9
     if(mod(nsave,4).eq.0) then
        df=12000.0/NFFT
        ia=nint(1000.0/df)
        ib=nint(2000.0/df)
        avemid=sum(s(ia:ib))/(ib-ia+1)
        do i=0,NH
           fil(i)=0.
           if(s(i).gt.0.0) then
              fil(i)=sqrt(avemid/s(i))
           endif
        enddo

! Default range is 240 - 4000 Hz.  For narrower filters, use frequencies
! at which gain is -20 dB relative to 1500 Hz.
        ia=nint(240.0/df)
        ib=nint(4000.0/df)
        i0=nint(1500.0/df)
        do i=i0,ia,-1
           if(s(i)/s(i0).lt.0.01) exit
        enddo
        ia=i
        do i=i0,ib,1
           if(s(i)/s(i0).lt.0.01) exit
        enddo
        ib=i

        fac=fac0
        do i=ia,1,-1
           fac=fac*fac0
           fil(i)=fac*fil(i)
        enddo

        fac=fac0
        do i=ib,NH
           fac=fac*fac0
           fil(i)=fac*fil(i)
        enddo

        do iter=1,100                        !### ??? ###
           call smo121(fil,NH)
        enddo

        do i=0,NH 
           filter(i)=-60.0
           if(s(i).gt.0.0) filter(i)=20.0*log10(fil(i))
        enddo

        il=nint(NPOLYLOW/df)
        ih=nint(NPOLYHIGH/df)
        nfit=ih-il+1
        mode=0
        nterms=5
        do i=1,nfit
          xfit(i)=((i+il-1)*df-1500.0)/1000.0
          yfit(i)=fil(i+il-1)
          sigmay(i)=1.0
        enddo
        call polyfit(xfit,yfit,sigmay,nfit,nterms,mode,a,chisqr)

        open(16,file=fname,status='unknown')
        write(16,1003) NPOLYLOW,NPOLYHIGH,nterms,a
1003    format(3i5,5e25.16)
        do i=1,NH
           freq=i*df
           ref(i)=db(s(i)/avemid)
           write(16,1005) freq,s(i),ref(i),fil(i),filter(i)
1005       format(f10.3,e12.3,f12.6,e12.3,f12.6)
        enddo
        close(16)
     endif
     return
  endif

  if(buseref) then
     if(blastuse.neqv.buseref) then !just enabled so read filter
        fil=1.0
        open(16,file=fname,status='old',err=999)
        read(16,1003,err=20,end=999) ndummy,ndummy,nterms,a
        goto 30
20      rewind(16)              !allow for old style refspec.dat with no header
30      do i=1,NH
           read(16,1005,err=999,end=999) freq,s(i),ref(i),fil(i),filter(i)
        enddo
! Make the filter causal for overlap and add.
        cx(0)=0.0
        cx(1:NH)=fil(1:NH)/NFFT
        call four2a(cx,NFFT,1,1,-1)
        x=cshift(x,-400)
        x(800:NH)=0.0
        call four2a(cx,NFFT,1,-1,0)
        cfil=cx
        close(16)
     endif
! Use overlap and add method to apply causal reference filter.
     x(0:NH-1)=id2(1:NH)
     x(NH:NFFT-1)=0.0
     x=x/NFFT
     call four2a(cx,NFFT,1,-1,0)
     cx=cfil*cx
     call four2a(cx,NFFT,1,1,-1)
     x(0:NH-1)=x(0:NH-1)+xs    
     xs=x(NH:NFFT-1)
     id2(1:NH)=nint(x(0:NH-1))
  endif
  blastuse=buseref

999 return
end subroutine refspectrum

subroutine gen_ft8wave(itone,nsym,nsps,bt,fsample,f0,cwave,wave,icmplx,nwave)
!
! generate ft8 waveform using Gaussian-filtered frequency pulses.
!
  use timer_module, only: timer
  parameter(MAX_SECONDS=20,NTAB=65536)
  real wave(nwave)
  complex cwave(nwave),ctab(0:NTAB-1)
  real pulse(23040)
  real dphi(0:(nsym+2)*nsps-1)
  integer itone(nsym)
  data fchk0/0.0/
  save pulse,twopi,dt,hmod,fchk0,ctab

  ibt=nint(10*bt)
  fchk=nsym+nsps+bt+fsample
  if(fchk.ne.fchk0) then
     twopi=8.0*atan(1.0)
     dt=1.0/fsample
     hmod=1.0
! Compute the frequency-smoothing pulse
     do i=1,3*nsps
        tt=(i-1.5*nsps)/real(nsps)
        pulse(i)=gfsk_pulse(bt,tt)
     enddo
     do i=0,NTAB-1
        phi=i*twopi/NTAB
        ctab(i)=cmplx(cos(phi),sin(phi))
     enddo
     fchk0=fchk
  endif

! Compute the smoothed frequency waveform.
! Length = (nsym+2)*nsps samples, first and last symbols extended 
  dphi_peak=twopi*hmod/real(nsps)
  dphi=0.0 
  do j=1,nsym         
     ib=(j-1)*nsps
     ie=ib+3*nsps-1
     dphi(ib:ie) = dphi(ib:ie) + dphi_peak*pulse(1:3*nsps)*itone(j)
  enddo
! Add dummy symbols at beginning and end with tone values equal to 1st and last symbol, respectively
  dphi(0:2*nsps-1)=dphi(0:2*nsps-1)+dphi_peak*itone(1)*pulse(nsps+1:3*nsps)
  dphi(nsym*nsps:(nsym+2)*nsps-1)=dphi(nsym*nsps:(nsym+2)*nsps-1)+dphi_peak*itone(nsym)*pulse(1:2*nsps)

! Calculate and insert the audio waveform
  phi=0.0
  dphi = dphi + twopi*f0*dt                      !Shift frequency up by f0
  if(icmplx .eq. 0) wave=0.
  if(icmplx .ne. 0) cwave=0. !Avoid writing to memory we may not have access to

  call timer('gen_loop',0)
  k=0
  do j=nsps,nsps+nwave-1                         !Don't include dummy symbols
     k=k+1
     if(icmplx.eq.0) then
        wave(k)=sin(phi)
     else
        i=phi*float(NTAB)/twopi
        cwave(k)=ctab(i)
     endif
     phi=mod(phi+dphi(j),twopi)
  enddo
  call timer('gen_loop',1)

! Apply envelope shaping to the first and last symbols
  nramp=nint(nsps/8.0)
  if(icmplx.eq.0) then
     wave(1:nramp)=wave(1:nramp) *                                          &
          (1.0-cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
     k1=nsym*nsps-nramp+1
     wave(k1:k1+nramp-1)=wave(k1:k1+nramp-1) *                              &
          (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  else
     cwave(1:nramp)=cwave(1:nramp) *                                        &
          (1.0-cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
     k1=nsym*nsps-nramp+1
     cwave(k1:k1+nramp-1)=cwave(k1:k1+nramp-1) *                            &
          (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  endif

  return
end subroutine gen_ft8wave

subroutine m65a

  use timer_module, only: timer
  use timer_impl, only: init_timer !, limtrace
  use, intrinsic :: iso_c_binding, only: C_NULL_CHAR
  use FFTW3
  
  interface
     function address_m65()
     integer*1, pointer :: address_m65
     end function address_m65
  end interface
  
  integer*1 attach_m65
  integer size_m65
  integer*1, pointer :: p_m65
  character*80 cwd
  character wisfile*256
  logical fileExists

  call getcwd(cwd)
  call ftninit(trim(cwd))
  call init_timer (trim(cwd)//'/timer.out')

  limtrace=0
  lu=12
  i1=attach_m65()

10 inquire(file=trim(cwd)//'/.lock',exist=fileExists)
  if(fileExists) then
     call sleep_msec(100)
     go to 10
  endif

  inquire(file=trim(cwd)//'/.quit',exist=fileExists)
  if(fileExists) then
     call timer('decode0 ',101)
     i=detach_m65()
     ! Save FFTW wisdom and free memory
     wisfile=trim(cwd)//'/m65_wisdom.dat'// C_NULL_CHAR
     if(len(trim(wisfile)).gt.0) iret=fftwf_export_wisdom_to_filename(wisfile)
     call four2a(a,-1,1,1,1)
     call filbig(a,-1,1,0.0,0,0,0,0,0) !used for FFT plans
     call fftwf_cleanup_threads()
     call fftwf_cleanup()
     go to 999
  endif
  
  nbytes=size_m65()
  if(nbytes.le.0) then
     print*,'m65a: Shared memory mem_m65 does not exist.' 
     print*,'Program m65a should be started automatically from within map65.'
     go to 999
  endif
  p_m65=>address_m65()
  call m65b(p_m65,nbytes)
  call sleep_msec(500)          ! wait for .lock to be recreated
  go to 10

999 return
end subroutine m65a

subroutine m65b(m65com,nbytes)
  integer*1 m65com(0:nbytes-1)
  kss=4*4*60*96000
  ksavg=kss+4*4*322*32768
  kfcenter=ksavg+4*4*32768
 call m65c(m65com(0),m65com(kss),m65com(ksavg),m65com(kfcenter))
  return
end subroutine m65b

subroutine m65c(dd,ss,savg,nparams0)

  include 'njunk.f90'
  real*4 dd(4,5760000),ss(4,322,32768),savg(4,32768)
  real*8 fcenter
  integer nparams0(NJUNK+2),nparams(NJUNK+2)
  logical ldecoded
  character*12 mycall,hiscall
  character*6 mygrid,hisgrid
  character*20 datetime
  common/npar/fcenter,nutc,idphi,mousedf,mousefqso,nagain,              &
       ndepth,ndiskdat,neme,newdat,nfa,nfb,nfcal,nfshift,               &
       mcall3,nkeep,ntol,nxant,nrxlog,nfsample,nxpol,nmode,             &
       ndop00,nsave,max_drift,nhsym,mycall,mygrid,hiscall,hisgrid,       &
       datetime,junk1,junk2
  common/early/nhsym1,nhsym2,ldecoded(32768)
  equivalence (nparams,fcenter)
  
  nparams=nparams0                     !Copy parameters into common/npar/
  npatience=1
  if(nhsym.eq.nhsym1 .and. iand(nrxlog,1).ne.0) then
     write(21,1000) datetime(:17)
1000 format(/'UTC Date: 'a17/78('-'))
     flush(21)
  endif
  if(iand(nrxlog,2).ne.0) rewind(21)
  if(iand(nrxlog,4).ne.0) then
     if(nhsym.eq.nhsym1) rewind(26)
     if(nhsym.eq.nhsym2) backspace(26)
  endif

  nstandalone=0
  if(sum(nparams).ne.0) call decode0(dd,ss,savg,nstandalone)

  return
end subroutine m65c

  parameter (MAXTEST=75,NTEST=68)
  character*22 testmsg(MAXTEST)
  character*22 testmsgchk(MAXTEST)
  ! Test msgs should include the extremes for the different types
  ! See pfx.f90
  ! Type 1 P & A
  ! Type 1 1A & E5
  data testmsg(1:NTEST)/         &
       "CQ WB9XYZ EN34",         &
       "CQ DX WB9XYZ EN34",      &
       "QRZ WB9XYZ EN34",        &
       "KA1ABC WB9XYZ EN34",     &
       "KA1ABC WB9XYZ RO",       &
       "KA1ABC WB9XYZ -21",      &
       "KA1ABC WB9XYZ R-19",     &
       "KA1ABC WB9XYZ RRR",      &
       "KA1ABC WB9XYZ 73",       &
       "KA1ABC WB9XYZ",          &
       "CQ 010 WB9XYZ EN34",     &
       "CQ 999 WB9XYZ EN34",     &
       "CQ EU WB9XYZ EN34",      &
       "CQ WY WB9XYZ EN34",      &
       "1A/KA1ABC WB9XYZ",       &
       "E5/KA1ABC WB9XYZ",       &
       "KA1ABC 1A/WB9XYZ",       &
       "KA1ABC E5/WB9XYZ",       &
       "KA1ABC/P WB9XYZ",        &
       "KA1ABC/A WB9XYZ",        &
       "KA1ABC WB9XYZ/P",        &
       "KA1ABC WB9XYZ/A",        &
       "CQ KA1ABC/P",            &
       "CQ WB9XYZ/A",            &
       "QRZ KA1ABC/P",           &
       "QRZ WB9XYZ/A",           &
       "DE KA1ABC/P",            &
       "DE WB9XYZ/A",            &
       "CQ 1A/KA1ABC",           &
       "CQ E5/KA1ABC",           &
       "DE 1A/KA1ABC",           &
       "DE E5/KA1ABC",           &
       "QRZ 1A/KA1ABC",          &
       "QRZ E5/KA1ABC",          &
       "CQ WB9XYZ/1A",           &
       "CQ WB9XYZ/E5",           &
       "QRZ WB9XYZ/1A",          &
       "QRZ WB9XYZ/E5",          &
       "DE WB9XYZ/1A",           &
       "DE WB9XYZ/E5",           &
       "CQ A000/KA1ABC FM07",    &
       "CQ ZZZZ/KA1ABC FM07",    &
       "QRZ W4/KA1ABC FM07",     &
       "DE W4/KA1ABC FM07",      &
       "CQ W4/KA1ABC -22",       &
       "DE W4/KA1ABC -22",       &
       "QRZ W4/KA1ABC -22",      &
       "CQ W4/KA1ABC R-22",      &
       "DE W4/KA1ABC R-22",      &
       "QRZ W4/KA1ABC R-22",     &
       "DE W4/KA1ABC 73",        &
       "CQ KA1ABC FM07",         &
       "QRZ KA1ABC FM07",        &
       "DE KA1ABC/VE6 FM07",     &
       "CQ KA1ABC/VE6 -22",      &
       "DE KA1ABC/VE6 -22",      &
       "QRZ KA1ABC/VE6 -22",     &
       "CQ KA1ABC/VE6 R-22",     &
       "DE KA1ABC/VE6 R-22",     &
       "QRZ KA1ABC/VE6 R-22",    &
       "DE KA1ABC 73",           &
       "HELLO WORLD",            &
       "ZL4/KA1ABC 73",          &
       "KA1ABC XL/WB9XYZ",       &
       "KA1ABC WB9XYZ/W4",       &
       "DE KA1ABC/QRP 2W",       &
       "KA1ABC/1 WB9XYZ/1",      &
       "123456789ABCDEFGH"/
  data testmsgchk(1:NTEST)/      &
       "CQ WB9XYZ EN34",         &
       "CQ DX WB9XYZ EN34",      &
       "QRZ WB9XYZ EN34",        &
       "KA1ABC WB9XYZ EN34",     &
       "KA1ABC WB9XYZ RO",       &
       "KA1ABC WB9XYZ -21",      &
       "KA1ABC WB9XYZ R-19",     &
       "KA1ABC WB9XYZ RRR",      &
       "KA1ABC WB9XYZ 73",       &
       "KA1ABC WB9XYZ",          &
       "CQ 000 WB9XYZ EN34",     &
       "CQ 999 WB9XYZ EN34",     &
       "CQ EU WB9XYZ EN34",      &
       "CQ WY WB9XYZ EN34",      &
       "1A/KA1ABC WB9XYZ",       &
       "E5/KA1ABC WB9XYZ",       &
       "KA1ABC 1A/WB9XYZ",       &
       "KA1ABC E5/WB9XYZ",       &
       "KA1ABC/P WB9XYZ",        &
       "KA1ABC/A WB9XYZ",        &
       "KA1ABC WB9XYZ/P",        &
       "KA1ABC WB9XYZ/A",        &
       "CQ KA1ABC/P",            &
       "CQ WB9XYZ/A",            &
       "QRZ KA1ABC/P",           &
       "QRZ WB9XYZ/A",           &
       "DE KA1ABC/P",            &
       "DE WB9XYZ/A",            &
       "CQ 1A/KA1ABC",           &
       "CQ E5/KA1ABC",           &
       "DE 1A/KA1ABC",           &
       "DE E5/KA1ABC",           &
       "QRZ 1A/KA1ABC",          &
       "QRZ E5/KA1ABC",          &
       "CQ WB9XYZ/1A",           &
       "CQ WB9XYZ/E5",           &
       "QRZ WB9XYZ/1A",          &
       "QRZ WB9XYZ/E5",          &
       "DE WB9XYZ/1A",           &
       "DE WB9XYZ/E5",           &
       "CQ A000/KA1ABC FM07",    &
       "CQ ZZZZ/KA1ABC FM07",    &
       "QRZ W4/KA1ABC FM07",     &
       "DE W4/KA1ABC FM07",      &
       "CQ W4/KA1ABC -22",       &
       "DE W4/KA1ABC -22",       &
       "QRZ W4/KA1ABC -22",      &
       "CQ W4/KA1ABC R-22",      &
       "DE W4/KA1ABC R-22",      &
       "QRZ W4/KA1ABC R-22",     &
       "DE W4/KA1ABC 73",        &
       "CQ KA1ABC FM07",         &
       "QRZ KA1ABC FM07",        &
       "DE KA1ABC/VE6 FM07",     &
       "CQ KA1ABC/VE6 -22",      &
       "DE KA1ABC/VE6 -22",      &
       "QRZ KA1ABC/VE6 -22",     &
       "CQ KA1ABC/VE6 R-22",     &
       "DE KA1ABC/VE6 R-22",     &
       "QRZ KA1ABC/VE6 R-22",    &
       "DE KA1ABC 73",           &
       "HELLO WORLD",            &
       "ZL4/KA1ABC 73",          &
       "KA1ABC XL/WB9",          &
       "KA1ABC WB9XYZ",          &
       "DE KA1ABC/QRP",          &
       "KA1ABC/1 WB9X",          &
       "123456789ABCD"/

program EchoCallSim

! Generate simulated transmissions for echo_call mode.

  use wavhdr
  parameter (NSPS=4096,NZ=3*12000)
  parameter (NMAX=6*NSPS)                !Samples in .wav file, 2.2*12000
  type(hdr) h                            !Header for .wav file
  integer*2 iwave(NZ)                    !Generated waveform
  integer itone(6)                       !Channel symbols, values 0-37
  real*4 xnoise(NMAX)                    !Generated random noise
  real*4 dat(NMAX)                       !Generated real data
  complex cdat(NMAX)                     !Generated complex waveform
  complex z
  real*8 f0,dt,twopi,phi,dphi,fsample,freq
  character callsign*6,fname*17,arg*8

!  character*37 c
!  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  
  nargs=iargc()
  if(nargs.ne.7) then
     print*,'Usage:   EchoCallSim callsign f0 fdop fspread ndf nfiles snrdb'
     print*,'Example: EchoCallSim   K1JT  1500 0.0  10.0    10   10    -15'
     go to 999
  endif
  call getarg(1,callsign)
  call getarg(2,arg)
  read(arg,*) f0
  call getarg(3,arg)
  read(arg,*) fdop
  call getarg(4,arg)
  read(arg,*) fspread
  call getarg(5,arg)
  read(arg,*) ndf
  call getarg(6,arg)
  read(arg,*) nfiles
  call getarg(7,arg)
  read(arg,*) snrdb

  write(*,1000)
1000 format('   N   f0     fDop fSpread  ndf  SNR   File name'/63('-'))

  call gen_echocall(callsign,itone)

  twopi=8.d0*atan(1.d0)
  rms=100.
  fsample=12000.d0                   !Sample rate (Hz)
  npts=NMAX                          !Total samples in .wav file
  nfft=npts
  nh=nfft/2
  dt=1.d0/fsample                    !Sample interval (s)
  df=12000.0/NSPS
  
  do ifile=1,nfiles  !Loop over requested number of files
     xnoise=0.
     if(snrdb.lt.90) then
        do i=1,npts
           xnoise(i)=gran()          !Generate gaussian noise
        enddo
     endif

     bandwidth_ratio=2500.0/6000.0
     sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*snrdb)
     if(snrdb.gt.90.0) sig=1.0

     phi=0.d0
     dphi=0.d0
     k=0
     do j=1,6
        freq=f0 + fdop + itone(j)*ndf
        dphi=twopi*freq*dt
        do i=1,NSPS
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=cmplx(cos(xphi),sin(xphi))
           k=k+1
           cdat(k)=sig*z
        enddo
     enddo

     if(fspread.gt.0.0) call fspread_lorentz(cdat,fspread)

     dat=aimag(cdat) + xnoise                 !Add generated AWGN noise
     fac=32767.0
     if(snrdb.ge.90.0) iwave(1:npts)=nint(fac*dat(1:npts))
     if(snrdb.lt.90.0) iwave(1:npts)=nint(rms*dat(1:npts))
     iwave(npts+1:)=0

     nDop=nint(fdop)
     nDopAudio=0
     nfrit=0
     f1=f0 + fdop
     call save_echo_params(nDop,nDopAudio,nfrit,f1,fspread,ndf,itone,iwave,1)

     h=default_header(12000,NZ)
     n=6*(ifile-1)
     ihr=n/3600
     imin=(n-3600*ihr)/60
     isec=mod(n,60)
     write(fname,1102) ihr,imin,isec
1102 format('000000_',3i2.2,'.wav')
     open(10,file=trim(fname),access='stream',status='unknown')
     write(10) h,iwave                        !Save the .wav file
     close(10)

     write(*,1110) ifile,f0,fdop,fspread,ndf,snrdb,fname
1110 format(i4,3f7.1,i5,f7.1,2x,a17)

  enddo

999 end program EchoCallSim

! This routine provides an interface between MAP65 and the Q65 decoder
! in WSJT-X.  All arguments are input data obtained from the MAP65 GUI.
! Raw Rx data are available as the 96 kHz complex spectrum ca(MAXFFT1)
! in cacb_mod.  If xpol is true, we also have cb(MAXFFT1) for the
! orthogonal polarization.  Decoded messages are sent back to the GUI
! on stdout.

      module q65b_mod
      implicit none
      contains

      subroutine q65b(nutc, nqd, nxant, fcenter, nfcal, nfsample, ikhz, mousedf, ntol, xpol, &
                  mycall0, mygrid, hiscall0, hisgrid, mode_q65, f0, fqso, newdat, nagain, &
                  max_drift, ndop00, idec)

      use iso_c_binding
      use q65_decode
      use wideband_sync
      use timer_module, only: timer
      use debug_log
      use stdout_channel_mod, only: write_stdout
      use decodes_mod,  only: ldecoded, ndecodes
      use cacb_mod
      use four2a_mod
      use txpol_mod
      use iso_fortran_env, only: real64, int16
      use map65_mmdec_mod

      implicit none

      !==== Dummy arguments =====================================================
      integer,      intent(in)    :: nutc
      integer,      intent(in)    :: nqd
      integer,      intent(in)    :: nxant
      real(real64),       intent(in)    :: fcenter
      integer,      intent(in)    :: nfcal
      integer,      intent(in)    :: nfsample
      integer,      intent(in)    :: ikhz
      integer,      intent(in)    :: mousedf
      integer,      intent(in)    :: ntol
      logical,      intent(in)    :: xpol
      character(len=12), intent(in)    :: mycall0
      character(len=6),  intent(in)    :: mygrid
      character(len=12), intent(in)    :: hiscall0
      character(len=6),  intent(in)    :: hisgrid
      integer,      intent(in)    :: mode_q65
      real(real64),       intent(in)    :: f0
      real,         intent(in)    :: fqso
      integer,      intent(in)    :: newdat
      integer,      intent(in)    :: nagain
      integer,      intent(in)    :: max_drift
      integer,      intent(in)    :: ndop00
      integer,      intent(out)   :: idec

      !==== Local parameters ====================================================
      integer, parameter :: MAXFFT1 = 5376000
      integer, parameter :: MAXFFT2 = 336000
      integer, parameter :: NMAX    = 60*12000
      real(real64), parameter  :: RAD     = 57.2957795

      !==== Local variables =====================================================
      integer(int16) :: iwave(300*12000)
      complex   :: cx(0:MAXFFT2-1), cy(0:MAXFFT2-1), cz(0:MAXFFT2)
      integer   :: ipk1(1)
      integer   :: i, ia, ib, ifreq, ikhz1, ipk, ipol
      integer   :: j, ja, jb, k0, mhz, ndf, ndpth, nfft1, nfft2
      integer   :: npol, nq65df, nsubmode, ntxpol, nutc00, nh
      integer   :: nfa, nfb
      real      :: df, df3, f_ipk, f_mouse, fac
      real      :: freq1_00, frx, fsked, poldeg, r, snr1
      real(real64)    :: freq0, freq1
      character(len=12) :: mycall, hiscall
      character(len=4)  :: grid4
      character(len=28) :: msg00
      character(len=80) :: wsjtx_dir
      character(len=1)  :: cp
      character(len=2)  :: cmode
      character(len=256) :: linenew

      ! From q65_decode / wideband_sync / globals:
      !   real    :: xdt0
      !   integer :: nsnr0, nfreq0, nkhz_center
      !   character(len=3) :: cq0
      !   character(len=28) :: msg0
      !   type(sync_type) :: sync(:)
      ! These are assumed to be provided by the used modules.

      data nutc00 /-1/
      data msg00  /'                            '/
      save

      call init_cacb(5376000)
      
      call init_wideband_sync(NFFT)

#ifndef FORTRAN_APPLE
      open (9, file='wsjtx_dir.txt', status='old')
      read (9, '(a)') wsjtx_dir
      close (9)
#endif

      if (mycall0(1:1) .ne. ' ') mycall = mycall0
      if (hiscall0(1:1) .ne. ' ') hiscall = hiscall0
      if (hisgrid(1:4) .ne. '    ') grid4 = hisgrid(1:4)

! Find best frequency and ipol from sync_dat, the "orange sync curve".
      df3 = 96000.0/32768.0
      ifreq = nint((1000.0*f0)/df3)
      ia = nint(ifreq - ntol/df3)
      ib = nint(ifreq + ntol/df3)

      if (ia >= 1 .and. ia <= 32768 .and. ib >= 1 .and. ib <= 32768) then !if added qt6
         ipk1 = maxloc(sync(ia:ib)%ccfmax)
      else
         go to 901
      endif

      ipk = ia + ipk1(1) - 1
      if (ldecoded(ipk)) go to 900
      snr1 = sync(ipk)%ccfmax
      ! ipol was never declared and its value is never used
      ipol = 1
      if (xpol) ipol = sync(ipk)%ipol

      nfft1 = MAXFFT1
      nfft2 = MAXFFT2
      df = 96000.0/NFFT1
      if (nfsample .eq. 95238) then
         nfft1 = 5120000
         nfft2 = 322560
         df = 96000.0/nfft1
      endif
      nh = nfft2/2
      f_mouse = 1000.0*(fqso + 48.0) + mousedf
      f_ipk = ipk*df3
      k0 = nint((ipk*df3 - 1000.0)/df)
      if (nagain .eq. 1) k0 = nint((f_mouse - 1000.0)/df)

      if (k0 .lt. nh .or. k0 .gt. MAXFFT1 - nfft2 + 1) go to 900
      if (snr1 .lt. 1.5) go to 900                      !### Threshold needs work? ###

      fac = 1.0/nfft2
      cx(0:nfft2 - 1) = ca(k0:k0 + nfft2 - 1)
      cx = fac*cx
      if (xpol) then
         cy(0:nfft2 - 1) = cb(k0:k0 + nfft2 - 1)
         cy = fac*cy
      endif

! Here cx and cy (if xpol) are frequency-domain data around the selected
! QSO frequency, taken from the full-length FFT computed in filbig().
! Values for fsample, nfft1, nfft2, df, and the downsampled data rate
! are as follows:

!  fSample  nfft1       df        nfft2  fDownSampled
!    (Hz)              (Hz)                 (Hz)
!----------------------------------------------------
!   96000  5376000  0.017857143  336000   6000.000
!   95238  5120000  0.018601172  322560   5999.994

      poldeg = 0.
      if (xpol) then
         poldeg = sync(ipk)%pol
         cz(0:MAXFFT2 - 1) = cos(poldeg/RAD)*cx + sin(poldeg/RAD)*cy
      else
         cz(0:MAXFFT2 - 1) = cx
      endif

      cz(MAXFFT2) = 0.
! Roll off below 500 Hz and above 2500 Hz.
      ja = nint(500.0/df)
      jb = nint(2500.0/df)
      do i = 0, ja
         r = 0.5*(1.0 + cos(i*3.14159/ja))
         cz(ja - i) = r*cz(ja - i)
         cz(jb + i) = r*cz(jb + i)
      enddo
      cz(ja + jb + 1:) = 0.

!Transform to time domain (real), fsample=12000 Hz
      call four2a(cz, 2*nfft2, 1, 1, -1)
      do i = 0, nfft2 - 1
         j = nfft2 - 1 - i
         iwave(2*i + 2) = int(max(-32768, min(32767, nint(real(cz(j))))), kind=2)
         iwave(2*i + 1) = int(max(-32768, min(32767, nint(aimag(cz(j))))), kind=2)
      enddo
      iwave(2*nfft2 + 1:) = 0

!  open(30,file='000000_0001.wav',status='unknown',access='stream')
!  h=default_header(12000,NMAX)
!  write(30) h,iwave
!  close(30)

      nsubmode = mode_q65 - 1
      nfa = 990                   !Tight limits around ipk for the wideband decode
      nfb = 1010
      if (nagain .eq. 1) then      !For nagain=1, use limits of +/- ntol
         nfa = max(100, 1000 - ntol)
         nfb = min(2500, 1000 + ntol)
      endif
      nsnr0 = -99             !Default snr for no decode
      ndpth = 3

! NB: Frequency of ipk is now shifted to 1000 Hz.
      call map65_mmdec(nutc, iwave, nqd, 60, nsubmode, nfa, nfb, 1000, ntol, &
                       newdat, nagain, max_drift, ndpth, mycall, hiscall0, hisgrid)

      MHz = fcenter
      freq0 = MHz + 0.001d0*ikhz

      if (nsnr0 .gt. -99) then
         ldecoded(ipk) = .true.
         nq65df = nint(1000*(0.001*k0*df + nkhz_center - 48.0 + 1.000 - 1.27046 - ikhz)) - nfcal
         nq65df = nq65df + nfreq0 - 1000
         npol = nint(poldeg)
         if (nxant .ne. 0) then
            npol = npol - 45
            if (npol .lt. 0) npol = npol + 180
         endif
         call txpol(xpol, msg0(1:28), mygrid, npol, nxant, ntxpol, cp) ! was 1:22
         ikhz1 = ikhz
         ndf = nq65df
         if (ndf .gt. 500) ikhz1 = ikhz + (nq65df + 500)/1000
         if (ndf .lt. -500) ikhz1 = ikhz + (nq65df - 500)/1000
         ndf = nq65df - 1000*(ikhz1 - ikhz)
         if (nqd .eq. 1 .and. abs(nq65df - mousedf) .lt. ntol) then
            write (linenew, '("!",I3.3,I5,I4,I6.4,F5.1,I5," : ",A28,A3,I4,1X,A1)') &
               ikhz1, ndf, npol, nutc, xdt0, nsnr0, msg0(1:28), cq0, ntxpol, cp
            call write_stdout(trim(linenew)//new_line('a'))

         endif

! Write to lu 26, for Messages and Band Map windows
         cmode = ': '
         cmode(2:2) = char(ichar('A') + mode_q65 - 1)
         freq1 = freq0 + 0.001d0*(ikhz1 - ikhz)
         write (26, 1014) freq1, ndf, 0, 0, 0, xdt0, npol, 0, nsnr0, nutc, msg0(1:28), &
            ':', cp, cmode ! was 1:22
1014     format(f8.3, i5, 3i3, f5.1, i4, i3, i4, i5.4, 4x, a28, 1x, 2a1, 2x, a2) ! was a22

! Suppress writing duplicates (same time, decoded message, and frequency)
! to map65_rx.log
         if (nutc .ne. nutc00 .or. msg0(1:28) .ne. msg00 .or. freq1 .ne. freq1_00) then
! Write to file map65_rx.log:
            ndecodes = ndecodes + 1
            write (21, 1110) freq1, ndf, xdt0, npol, nsnr0, nutc, msg0(1:28), &
               cmode(2:2), cq0
1110        format(f8.3, i5, f5.1, 2i4, i5.4, 2x, a28, ': ', a1, 2x, a3)
            nutc00 = nutc
            msg00 = msg0(1:28)
            freq1_00 = freq1
            frx = 0.001*k0*df + nkhz_center - 48.0 + 1.0 - 0.001*nfcal
            fsked = frx - 0.001*ndop00/2.0 - 1.5
            write (12, 1120) nutc, fsked, xdt0, nsnr0, trim(msg0)
1120        format(i4.4, f9.3, f7.2, i5, 2x, a, i6)
         endif
      endif

900   close (13)
      close (17)
      idec = -1
      read (cq0(2:2), *) idec
      return
901   close (13)
      close (17)
      idec = -1
      return
   end subroutine q65b

end module q65b_mod

module shell_mod
  implicit none
contains
  subroutine shell(n,a)
    implicit none
    integer, intent(in) :: n
    real, intent(inout) :: a(n)
    integer :: i,j,inc
    real :: v
  
    inc=1
  1 inc=3*inc+1
    if(inc.le.n) go to 1
  2  inc=inc/3
  
    do i=inc+1,n
       v=a(i)
       j=i
  3    if(a(j-inc).gt.v) then
          a(j)=a(j-inc)
          j=j-inc
          if(j.le.inc) go to 4
          go to 3
       endif
  4    a(j)=v
    enddo
  
    if(inc.gt.1) go to 2
  
  end subroutine shell
end module shell_mod

subroutine chkstat(dd,nhsym,pdb)

! Assumed-size dd(:) — caller's COMMON-block dimension wins at runtime.
! Was real dd(2,5760000); freed up to match the wide-mode COMMON layout.
  real dd(2,*)
  real pdb(4)
  integer ia(4),ib(4)
  logical*1 btx0,btx1

  btx0=.false.
  btx1=.false.
  ia(1)=23*96000+1
  ib(1)=24*96000
  ia(2)=27*96000+1
  ib(2)=28*96000
  ia(3)=53*96000+1
  ib(3)=54*96000
  ia(4)=57*96000+1
  ib(4)=58*96000

  do j=1,4
     sq=0.
     do i=ia(j),ib(j)
        sq=sq + dd(1,i)*dd(1,i) + dd(2,i)*dd(2,i)
     enddo
     pdb(j)=db(1.0 + sq/(2.0*96000.0))
  enddo
  
  return
end subroutine chkstat

program tastro

  implicit none
  use astro0_mod

  character(6)  :: grid
  character(9)  :: cauxra, cauxdec
  character(12) :: clock(3)

  integer :: nt(8)
  integer :: nyear, month, nday, ntz
  integer :: ihour, imin, isec, ims
  integer :: ih, nfreq

  real(8) :: uth8
  real(8) :: AzSun8, ElSun8, AzMoon8, ElMoon8
  real(8) :: AzMoonB8, ElMoonB8, dbMoon8
  real(8) :: RAMoon8, DecMoon8, HA8, Dgrd8, sd8
  real(8) :: poloffset8, xnr8, dfdt, dfdt0
  real(8) :: RaAux8, DecAux8, AzAux8, ElAux8
  real(8) :: width1, width2, w501, w502, xlst8
  integer :: ntsky, ndop, ndop00

  grid   = 'FN20qi'
  nfreq  = 144
  cauxra = '00:00:00'

  ! Main loop: update astronomical display once per second
do
   call date_and_time(clock(1), clock(2), clock(3), nt)

   nyear = nt(1)
   month = nt(2)
   nday  = nt(3)
   ntz   = nt(4)
   ihour = nt(5)
   imin  = nt(6)
   isec  = nt(7)
   ims   = nt(8)

   ih = ihour - ntz/60
   if (ih <= 0) then
      ih = ih + 24
      nday = nday + 1
   endif

   uth8 = ih + imin/60.d0 + isec/3600.d0 + ims/3600000.d0

   call astro0(nyear,month,nday,uth8,nfreq,grid,cauxra,cauxdec,       &
      AzSun8,ElSun8,AzMoon8,ElMoon8,AzMoonB8,ElMoonB8,ntsky,ndop,ndop00,  &
      dbMoon8,RAMoon8,DecMoon8,HA8,Dgrd8,sd8,poloffset8,xnr8,dfdt,dfdt0,  &
      RaAux8,DecAux8,AzAux8,ElAux8,width1,width2,w501,w502,xlst8)

   write(*,1010) nyear,month,nday,ih,imin,isec,AzMoon8,ElMoon8,          &
        AzSun8,ElSun8,ndop,dgrd8,ntsky

   call system('sleep 1')
end do

end program tastro

!does not require end module

module ft8_mod1

  parameter (NPS=180000,NFR=151680,NFILT1=4000,NFILT2=3400,numcqsig=20,   &
       numdeccq=40,nummycsig=5,numdecmyc=25,nmaxthreads=24)
  real*4 dd8(nps)
  real endcorr(NFILT1/2+1)
  complex cw(nps),csync(0:6,32),csynce(0:18,32),csyncsd(0:18,32),         &
       csyncsdcq(0:57,32),csynccq(0:7,32),ctwkw(11,32),ctwkn(11,32),      &
       ctwk256(256)
  character*37 allmessages(200),msgsd76(76),msg(56),msgroot,msgincall(174)
  character lasthcall*12,mycall12_0*12,mycall12_00*12,hiscall12_0*12,     &
       hisgrid4*4,hisgrid*6 !ft8md w3sz added hisgrid
  character(len=12) :: mycall,hiscall,mybcall,hisbcall
  real allfreq(200),windowc1(0:54),windowx(0:200),pivalue,facx,twopi,     &
       facc1,dt,sumxdtt(24),avexdt,xdtincall(174)
  integer itone76(76,79),idtone76(76,58),itone56(56,79),idtone56(56,58),  &
       idtone25(25,58),allsnrs(200),apsym(58),idtonemyc(58),mcq(29),      &
       mrrr(19),m73(19),mrr73(19),naptypes(0:5,27),icos7(0:6),            &
       graymap(0:7),nappasses(0:5),nmsg,ndecodes,nlasttx,mycalllen1,      &
       msgrootlen,nfawide,nfbwide,nhaptypes(0:5,27),apsymsp(66),          &
       apsymdxns1(58),apsymdxnsrrr(77),ndxnsaptypes(0:5,27),apcqsym(77),  &
       apsymdxnsrr73(77),apsymdxns73(77),nft8cycles,ncandallthr(24),      &
       maskincallthr(25),nincallthr(24),idtonecqdxcns(58),apsymmyns1(29), &
       apsymmyns2(58),apsymmynsrr73(77),apsymmyns73(77),                  &
       nmycnsaptypes(0:5,27),apsymdxstd(58),apsymdxnsr73(77),             &
       apsymdxns732(77),apsymmynsrrr(77),idtonedxcns73(58),               &
       idtonefox73(58),idtonespec(58),nintcount
  integer*1 gen(91,174)
  logical one(0:511,0:8),lqsomsgdcd,first_osd
  logical(1) lapmyc,lagcc,lagccbail,lhound,lenabledxcsearch,              &
       lwidedxcsearch,lmultinst,lskiptx1,ltxing
  data maskincallthr/0,30,45,55,65,75,85,90,95,100,105,110,115,120,125,   &
       130,135,140,145,150,155,160,165,170,175/
  data     mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
  data    mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
  data     m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
  data   mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
  data   icos7/3,1,4,0,6,5,2/
  data graymap/0,1,3,2,5,6,4,7/
  data mycall12_0/'dummy'/
  data mycall12_00/'dummy'/
  data hiscall12_0/'dummy'/

! Hound OFF, MyCall is standard, DXCall is standard or empty
  data naptypes(0,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,  &
       36,36,35,35,35/ ! Tx6 CQ
  data naptypes(1,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,  &
       36,36,35,35,35/ ! Tx1 Grid
  data naptypes(2,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,  &
       36,36,35,35,35/ ! Tx2 Report
  data naptypes(3,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,0,0,0,0,0,0,31,31,31,36,  &
       36,36,35,35,35/ ! Tx3 RRreport
  data naptypes(4,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,2,2,2,0,0,0,31,31,31,36,  &
       36,36,35,35,35/ ! Tx4 RRR,RR73
  data naptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,  &
       36,36,35,35,35/ ! Tx5 73

! Hound OFF, MyCall is non-standard, DXCall is standard or empty
  data nmycnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,   &
       31,31,36,36,36,35,35,35/             ! Tx6 CQ
  data nmycnsaptypes(1,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,   &
       31,31,36,36,36,35,35,35/             ! Tx1 DXcall MyCall
  data nmycnsaptypes(2,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,   &
       31,31,36,36,36,35,35,35/             ! Tx2 Report
  data nmycnsaptypes(3,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,0,0,0,0, &
       0,0,31,31,31,36,36,36,35,35,35/    ! Tx3 RRreport
  data nmycnsaptypes(4,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,40,40,40,&
       0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
  data nmycnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,&
       31,36,36,36,35,35,35/             ! Tx5 73

! Hound mode
  data nhaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0, &
       111,111,111/       ! Tx6 CQ, possible in idle mode if DXCall is empty
  data nhaptypes(1,1:27)/21,21,21,22,22,22,0,0,0,0,0,0,0,0,0,31,31,31,0,0,&
       0,36,36,36,0,0,0/ ! Tx1 Grid idle mode or transmitting
  data nhaptypes(2,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
       0,0,0/             ! Tx2 none
  data nhaptypes(3,1:27)/21,21,21,22,22,22,23,23,23,24,24,24,0,0,0,0,0,0, &
       0,0,0,0,0,0,0,0,0/ ! Tx3 RRreport QSO in progress or QSO is finished
  data nhaptypes(4,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
       0,0,0/             ! Tx4 none
  data nhaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
       0,0,0/             ! Tx5 none

!Non-standard DXCall
  data ndxnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31, &
       36,36,36,35,35,35/             ! Tx6 CQ
  data ndxnsaptypes(1,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31, &
       31,36,36,36,35,35,35/          ! Tx1 Grid
  data ndxnsaptypes(2,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31, &
       31,36,36,36,35,35,35/          ! Tx2 Report
  data ndxnsaptypes(3,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,0,0,0,0,  &
       0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
  data ndxnsaptypes(4,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,2,2,2,0,  &
       0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
  data ndxnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31, &
       36,36,36,35,35,35/             ! Tx5 73
  data nintcount/0/
  data avexdt/0.0/
  data first_osd/.true./

  type odd_struct
     real freq
     real dt
     logical lstate
     character*37 msg
  end type odd_struct
  type(odd_struct) odd(130)

  type even_struct
     real freq
     real dt
     logical lstate
     character*37 msg
  end type even_struct
  type(even_struct) even(130)

  type oddcopy_struct
     real freq
     real dt
     logical lstate
     character*37 msg
  end type oddcopy_struct
  type(oddcopy_struct) oddcopy(130)

  type evencopy_struct
     real freq
     real dt
     logical lstate
     character*37 msg
  end type evencopy_struct
  type(evencopy_struct) evencopy(130)
  
  type lastrxmsg_struct
     real xdt
     logical lstate
     character*37 lastmsg
  end type lastrxmsg_struct
  type (lastrxmsg_struct) lastrxmsg(1)
  data lastrxmsg%lstate/.false./

  type callsigndtodd_struct
     real dt
     character*12 call2
  end type callsigndtodd_struct
  type (callsigndtodd_struct) calldtodd(150)

  type callsigndteven_struct
     real dt
     character*12 call2
  end type callsigndteven_struct
  type (callsigndteven_struct) calldteven(150)

  type incall_struct
     real xdt
     character*37 msg
  end type incall_struct
  type (incall_struct) incall(30)

  type evencq_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type evencq_struct
  type(evencq_struct) evencq(numcqsig,nmaxthreads) ! 24 threads

  type oddcq_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type oddcq_struct
  type(oddcq_struct) oddcq(numcqsig,nmaxthreads)

  type evenmyc_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type evenmyc_struct
  type(evenmyc_struct) evenmyc(nummycsig,nmaxthreads)

  type oddmyc_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type oddmyc_struct
  type(oddmyc_struct) oddmyc(nummycsig,nmaxthreads)

  type evenqso_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type evenqso_struct
  type(evenqso_struct) evenqso(1,nmaxthreads)

  type oddqso_struct
     real freq
     real xdt
     complex cs(0:7,79)
  end type oddqso_struct
  type(oddqso_struct) oddqso(1,nmaxthreads)

end module ft8_mod1

module display_mod
  implicit none
contains

subroutine display(nkeep, ftol)
  use stdout_channel_mod, only: write_stdout
  use iso_fortran_env, only: real64
  use indexx_mod, only: indexx
  implicit none

  ! Arguments
  integer, intent(in) :: nkeep
  real,    intent(in) :: ftol

  ! Parameters
  integer, parameter :: MAXLINES = 400
  integer, parameter :: MX       = 400
  integer, parameter :: MAXCALLS = 500

  ! Locals
  integer         :: indx(MAXLINES), indx2(MX)
  character(len=83)  :: line(MAXLINES), line2(MX), line3(MAXLINES)
  character(len=63)  :: out, out0
  character(len=3)   :: cfreq0
  character(len=6)   :: callsign, callsign0
  character(len=12)  :: freqcall(MAXCALLS)

  real            :: freqkHz(MAXLINES)
  integer         :: utc(MAXLINES), utc2(MX), utcz
  real(real64)    :: f0

  character(len=83)  :: livecq2, livecq3
  character(len=128) :: linenew
  character(len=64)  :: linenew2

  integer :: io_status
  integer :: ndf, nh, nm
  integer :: i, j, j0, k, k3, kz
  integer :: nz, nage, iage, nquad
  integer :: i0, i1, i2, len, nc, m, nstart

  ! Initialize some scalars/arrays defensively
  out0      = ' '
  cfreq0    = ' '
  callsign0 = ' '
  freqcall  = '            '

  !------------------ Read and filter valid lines ---------------------
  rewind(26)
  nz = 0

  do i = 1, MAXLINES
     read(26,1010,end=10) line(i)
1010 format(a83)
     read(line(i),1020,iostat=io_status) f0, ndf, nh, nm
1020 format(f8.3,i5,25x,i3,i2)

     if (io_status /= 0) cycle

     utc(i)     = 60*nh + nm
     freqkHz(i) = 1000.d0*(f0 - 144.d0) + 0.001d0*ndf
  enddo
  
10 backspace(26)
  nz = i -1
  utcz = utc(nz)
  nz=nz-1
  if (nz < 1) return
  nquad = max(nkeep/4, 3)
  do i = 1, nz
     nage = utcz - utc(i)
     if (nage < 0) nage = nage + 1440
     iage = nage / nquad
     write(line(i)(79:80),1021) iage
1021 format(i2)
  enddo

  nage = utcz - utc(1)
  if (nage < 0) nage = nage + 1440
  if (nage > nkeep) then
     do i = 1, nz
        nage = utcz - utc(i)
        if (nage < 0) nage = nage + 1440
        if (nage <= nkeep) go to 20
     enddo
20   i0 = i
     nz = nz - i0 + 1
     rewind(26)
     if (nz < 1) return
     do i = 1, nz
        j = i + i0 - 1
        line(i)    = line(j)
        utc(i)     = utc(j)
        freqkHz(i) = freqkHz(j)
        write(26,1022) line(i)
1022    format(a83)
     enddo
  endif

  flush(26)
  call indexx(freqkHz, nz, indx)

  nstart = 1
  k3     = 0
  k      = 1
  m      = indx(1)

  if (m < 1 .or. m > MAXLINES) then
     write(linenew,'(A,1X,I0,1X,I0)') 'Error in display.f90:', nz, m
     call write_stdout(trim(linenew)//new_line('a'))
     m = 1
  endif
  line2(1) = line(m)
  utc2(1)  = utc(m)
  do i = 2, nz
     j0 = indx(i-1)
     j  = indx(i)
     if (freqkHz(j) - freqkHz(j0) > 2.0*ftol) then
        if (nstart == 0) then
           k = k + 1
           line2(k) = ""
           utc2(k)  = -1
        endif
        kz = k
        if(nstart.eq.1) then
           call indexx(float(utc2(1:kz)), kz, indx2)
           k3=0
        do k = 1, kz
           k3 = min(k3+1, MAXLINES)
           line3(k3) = line2(indx2(k))
        enddo
        nstart = 0
        else
           call indexx(float(utc2(1:kz)),kz,indx2)
           do k=1,kz
              k3=min(k3+1,400)
              line3(k3)=line2(indx2(k))
           enddo
        endif
        k= 0
     endif
     if (i == nz) then
        k = k + 1
        line2(k) = ""
        utc2(k)  = -1
     endif
     k = k + 1
     line2(k) = line(j)
     utc2(k)  = utc(j)
     j0=j
  enddo
  kz = k
  call indexx(float(utc2(1:kz)), kz, indx2)
  do k = 1, kz
     k3 = min(k3+1, MAXLINES)
     line3(k3) = line2(indx2(k))
  enddo

  rewind 19
  rewind 20
  cfreq0='   '
  nc = 0
  callsign0='      '
  do k = 1, k3
     out = line3(k)(1:13)//line3(k)(28:31)//line3(k)(39:45)// &
           line3(k)(35:38)//line3(k)(46:80)
     livecq2 = line3(k)
     if (out(6:8) /= '   ') then
        cfreq0 = out(6:8)

! Suppress listing duplicate (same time, decoded message, and frequency)
        if (out(19:22) /= out0(19:22) .or. out(31:55) /= out0(31:55) .or. &
            out(6:8) /= out0(6:8)) then
           livecq3 = out(1:61)//' '//livecq2(23:27)//' '//livecq2(79:83)
           write(linenew,'("@",A)') trim(livecq3)
           call write_stdout(trim(linenew)//new_line('a'))
           out0 = out
        endif

        i1 = index(out(31:), ' ')
        callsign = out(i1+31:)
        i2 = index(callsign, ' ')
        if (i2 > 1) callsign(i2:) = '      '
        if (callsign /= '      ' .and. callsign /= callsign0) then
           len = i2 - 1
           if (len < 0) len = 6
           if (len >= 3) then
              if (nc < MAXCALLS) nc = nc + 1
              freqcall(nc) = cfreq0//' '//callsign//line3(k)(79:80)
              callsign0=callsign
           endif
        endif
        if (callsign /= '      ' .and. callsign == callsign0) then
           if (nc > 0 .and. nc <= MAXCALLS) then
              freqcall(nc) = cfreq0//' '//callsign//line3(k)(79:80)
           endif
        endif
     endif
  enddo

if(nc.lt.MAXCALLS) nc=nc+1
freqcall(nc)='            '

if(nc.lt.MAXCALLS) nc=nc+1
freqcall(nc)='            '

if (nc+1 <= MAXCALLS) freqcall(nc+1) = '            '
if (nc+2 <= MAXCALLS) freqcall(nc+2) = '            '


  do i = 1, nc
     write(linenew2,'("&",A)') trim(freqcall(i))
     call write_stdout(trim(linenew2)//new_line('a'))
  enddo

end subroutine display

end module display_mod

subroutine datacor(datapwr,datacorr)

  use jt65_mod2var, only : s3,correct

  real datapwr,datacorr

! calculate information tones power and datapower/syncpower ratio
  datapwr=0.0
  do i=1,63
     datapwr=datapwr+s3(correct(i)+1,i)
  enddo

! use short correlation function in time and frequency domains
  timeplus=0.; timeminus=0.; freqplus=0.; freqminus=0.
  do i=1,63
     k=i+1
     m=i-1
     if(i.eq.1) m=2
     if(i.eq.63) k=62
     timeplus=timeplus+s3(correct(i)+1,k)
     timeminus=timeminus+s3(correct(i)+1,m)
     if(correct(i).lt.63) then
        j=1
     else
        j=-1
     endif
     if(correct(i).gt.1) then
        n=-1
     else
        n=1
     endif
     freqplus=freqplus+s3(correct(i)+1+j,i)
     freqminus=freqminus+s3(correct(i)+1+n,i)
  enddo
  datacorr=datapwr*4.0/(timeplus+timeminus+freqplus+freqminus)

  return
end subroutine datacor

subroutine cfom(dd,k0,k,ndop0)
  ! Constant Frequency Offset Measurement: applies a complex-phasor
  ! frequency shift of (-ndop0/2) Hz to the IQ samples in dd between
  ! sample k0+1 and k inclusive. Used to remove self-EME Doppler
  ! before the long FFT in qmapa, so a self-echo lands at the dial
  ! instead of being shifted by the round-trip Doppler.
  !
  ! Sample-rate aware: the per-sample phase increment is scaled by
  ! the active runtime rate (was hardcoded 96000.0 — broke wide-mode
  ! 256 kHz, where the same dphi gave 2.67× the intended shift).
  use qmap_params, only: nrate_active

  ! Assumed-size dummy — caller dimensions match the active runtime
  ! NSMAX. Was real dd(2,NMAX) with NMAX=60*96000 hardcoded.
  real dd(2,*)
  complex*16 w,wstep,c
  real*8 twopi,dphi

  ! Reset phase accumulator on every call. Was `data first/save w` so
  ! subsequent calls picked up where the previous one left off — broke
  ! the relationship between sample index n and exp(j·dphi·n) for any
  ! call after the first, randomising the per-buffer phase reference.
  twopi=8.d0*atan(1.d0)
  w=1.d0

  dop0=0.5*ndop0
  dphi=dop0*twopi/real(nrate_active,8)
  ! cmplx() returns DEFAULT (single) precision unless kind= is given.
  ! Without kind=8 the wstep phase is truncated to ~1e-7, and the
  ! per-sample phase error accumulates linearly over 15M samples to
  ! ~1.5 rad = 86° cumulative drift across a 60 s buffer — looks like
  ! fake Doppler drift to Q65 LDPC and breaks the decode.
  wstep=cmplx(cos(dphi),sin(dphi),kind=8)

  do j=k0+1,k
     ! Force double-precision throughout the multiply chain (cmplx
     ! defaults to single → would truncate the per-sample product).
     c=w*cmplx(dd(1,j),dd(2,j),kind=8)
     dd(1,j)=real(c,kind=4)
     dd(2,j)=real(aimag(c),kind=4)
     w=w*wstep
  enddo

  return
end subroutine cfom

subroutine fillhashvar(numthreads,lfill)

  use packjt77 ! also setting mycall13var,dxcall13var
  use ft8_mod1, only : mycall,hiscall
  integer, intent(in) :: numthreads
  logical, intent(in) :: lfill
  character*13 cw

  if(lfill) then
    do i=1,numthreads
      do m=1,nlast_callsvar(i)
        nposition=nthrindexvar(i)+m
        cw=last_callsvar(nposition)
!print *,i,m,cw
        n10=ihashcallvar(cw,10)
        if(n10.ge.0 .and. n10 .le. 1023 .and. cw.ne.mycall13var) calls10var(n10)=cw

        n12=ihashcallvar(cw,12)
        if(n12.ge.0 .and. n12 .le. 4095 .and. cw.ne.mycall13var) calls12var(n12)=cw

        n22=ihashcallvar(cw,22)
        if(any(ihash22var.eq.n22)) then   ! If entry exists, make sure callsign is the most recently received one
          where(ihash22var.eq.n22) calls22var=cw
          go to 900
        endif

! New entry: move table down, making room for new one at the top
        ihash22var(nzhashvar:2:-1)=ihash22var(nzhashvar-1:1:-1)

! Add the new entry
        calls22var(nzhashvar:2:-1)=calls22var(nzhashvar-1:1:-1)
        ihash22var(1)=n22
        calls22var(1)=cw
        if(nzhashvar.lt.MAXHASHvar) nzhashvar=nzhashvar+1
900     continue
      enddo
    enddo
  else
    nlast_callsvar=0
    mycall13var=mycall//' '; dxcall13var=hiscall//' '
    if(mycall13var.ne.mycall13_0var) then
      if(len(trim(mycall13var)).gt.2) then
        mycall13_setvar=.true.
        mycall13_0var=mycall13var
        call save_hash_mycallvar(mycall13var,hashmy10var,hashmy12var,hashmy22var)
!print *,mycall13var,hashmy10var,hashmy12var,hashmy22var
      else
        mycall13_setvar=.false.
      endif
    endif

    if(dxcall13var.ne.dxcall13_0var) then
      if(len(trim(dxcall13var)).gt.2) then
        dxcall13_setvar=.true.
        dxcall13_0var=dxcall13var
        hashdx10var=ihashcallvar(dxcall13var,10)
! make sure new DX Call is stored in hash tables prior to decoding
! it is needed if manually callsign set in DX Call window was not decoded before
        call save_hash_callvar(dxcall13var,1)
!print *,dxcall13var,hashdx10var
      else
        dxcall13_setvar=.false.
      endif
    endif
  endif

  return
end subroutine fillhashvar

module ft8_decodevar

  logical ltry_a8
  type :: ft8_decodervar
     procedure(ft8_decodevar_callback), pointer :: callback
   contains
     procedure :: decodevar
  end type ft8_decodervar

  abstract interface
     subroutine ft8_decodevar_callback (this,snr,dt,freq,decodedvar,nap,qual)
       import ft8_decodervar
       implicit none
       class(ft8_decodervar), intent(inout) :: this
       integer, intent(in) :: snr
       integer, intent(in) :: nap 
       real, intent(in) :: dt,freq,qual
       character(len=37), intent(in) :: decodedvar !ft8md was 26
     end subroutine ft8_decodevar_callback
  end interface

contains

  subroutine decodevar(this,callback,nQSOProgress,nfqso,nft8rxfsens,nftx,nutc,  &
       nfa,nfb,ncandthin,ndtcenter,nsec,napwid,lmycallstd,lhiscallstd,          &
       stophint,nthr,numthreads,nagainfil,lft8lowth,lft8subpass,lhideft8dupes,  &
       lft8apon,ncontest)

    use timer_module, only: timer
    use omp_lib
    use ft8_a7

    use ft8_mod1, only : ndecodes,allmessages,allsnrs,allfreq,odd,even,nmsg,    &
         lastrxmsg,lasthcall,calldteven,calldtodd,incall,oddcopy,evencopy,      &
         avexdt,mycall,hiscall,dd8,nft8cycles,ncandallthr,nincallthr,evencq,    &
         oddcq,numcqsig,numdeccq,evenmyc,oddmyc,nummycsig,numdecmyc,lapmyc,     &
         evenqso,oddqso,lqsomsgdcd,hisgrid4

    include 'ft8_params.f90'

    class(ft8_decodervar), intent(inout) :: this
    procedure(ft8_decodevar_callback) :: callback
    real, DIMENSION(:), ALLOCATABLE :: dd8m
    real candidate(4,460),freqsub(200)
    real qual !ft8md
    integer, intent(in) :: nQSOProgress,nfqso,nft8rxfsens,nftx,nfa,nfb,         &
         ncandthin,ndtcenter,nsec,napwid,nthr,numthreads
    logical, intent(in) :: nagainfil
    logical(1), intent(in) :: stophint,lft8lowth,lft8subpass,lhideft8dupes,     &
         lmycallstd,lhiscallstd,lft8apon
    logical newdat1,lsubtract,ldupe,lFreeText,lspecial
    logical(1) lft8sdec,lft8s,lft8sd,lrepliedother,lhashmsg,lqsothread,         &
         lhidemsg,lhighsens,lcqcand,lsubtracted,levenint,loddint,lnohiscall,    &
         lnomycall,lnohisgrid
    character msg37*37,msg37_2*37,msg26*37,call2*12 !ft8md msg26 was *26
    character*37 msgsrcvd(130)
    logical la8
    integer nsnr
    character*6 dxgrid

    type oddtmp_struct
       real freq
       real dt
       logical lstate
       character*37 msg
    end type oddtmp_struct
    type(oddtmp_struct) oddtmp(130)

    type eventmp_struct
       real freq
       real dt
       logical lstate
       character*37 msg
    end type eventmp_struct
    type(eventmp_struct) eventmp(130)

    type tmpcqdec_struct
       real freq
       real xdt
    end type tmpcqdec_struct
    type(tmpcqdec_struct) tmpcqdec(numdeccq) ! 40 sigs

    type tmpcqsig_struct
       real freq
       real xdt
      complex cs(0:7,79)
    end type tmpcqsig_struct
    type(tmpcqsig_struct) tmpcqsig(numcqsig) ! 20 sigs

    type tmpmyc_struct
       real freq
       real xdt
    end type tmpmyc_struct
    type(tmpmyc_struct) tmpmyc(numdecmyc) ! 25 sigs

    type tmpmycsig_struct
       real freq
       real xdt
       complex cs(0:7,79)
    end type tmpmycsig_struct
    type(tmpmycsig_struct) tmpmycsig(nummycsig) ! 5 sigs

    type tmpqsosig_struct
       real freq
       real xdt
       complex cs(0:7,79)
    end type tmpqsosig_struct
    type(tmpqsosig_struct) tmpqsosig(1)

    this%callback => callback
    la8=.true.

    oddtmp%lstate=.false.
    eventmp%lstate=.false.
    nmsgloc=0
    ncandthr=0
    nmsgcq=0
    tmpcqdec(:)%freq=6000.0
    nmsgmyc=0
    tmpmyc(:)%freq=6000.0
    tmpcqsig(:)%freq=6000.0
    tmpmycsig(:)%freq=6000.0
    tmpqsosig(1)%freq=6000.0
    if(hiscall.eq.'') then
       lastrxmsg(1)%lstate=.false. 
    else if(lastrxmsg(1)%lstate .and. lasthcall.ne.hiscall .and.               &
         index(lastrxmsg(1)%lastmsg,trim(hiscall)).le.0) then
       lastrxmsg(1)%lstate=.false.
    endif

    levenint=.false.
    loddint=.false.
    if(nsec.eq.0 .or. nsec.eq.30) then
       levenint=.true.
    elseif(nsec.eq.15 .or. nsec.eq.45) then
       loddint=.true.
    endif

    lrepliedother=.false.
    lft8sdec=.false.
    lqsothread=.false.
    lsubtracted=.false.
    ncount=0
    mycalllen1=len_trim(mycall)+1
    nincallthr(nthr)=0
    nallocthr=0
    ncqsignal=0
    nmycsignal=0

    lnohiscall=.false.
    if(len_trim(hiscall).lt.3) lnohiscall=.true.
    lnomycall=.false.
    if(len_trim(mycall).lt.3) lnomycall=.true.
    lnohisgrid=.false.
    if(len_trim(hisgrid4).ne.4) lnohisgrid=.true.
    if(nfqso.ge.nfa .and. nfqso.le.nfb) lqsothread=.true.

    if(lqsothread .and. .not.lastrxmsg(1)%lstate .and. .not.stophint .and.     &
         hiscall.ne.'') then
! got incoming call
       do i=1,30
          if(incall(i)%msg(1:1).eq." ") exit
          if(index(incall(i)%msg,(trim(mycall)//' '//trim(hiscall))).eq.1) then
             lastrxmsg(1)%lastmsg=incall(i)%msg
             lastrxmsg(1)%xdt=incall(i)%xdt
             lastrxmsg(1)%lstate=.true.
             exit
          endif
       enddo

       if(.not.lastrxmsg(1)%lstate) then
! calling someone, lastrxmsg still not valid
          if(levenint) then
             do i=1,130
                if(.not.evencopy(i)%lstate) cycle
                if(index(evencopy(i)%msg,' '//trim(hiscall)//' ').gt.1) then
                   lastrxmsg(1)%lastmsg=evencopy(i)%msg
                   lastrxmsg(1)%xdt=evencopy(i)%dt
                   lastrxmsg(1)%lstate=.true.
                   exit
                endif
             enddo

          elseif(loddint) then
             do i=1,130
                if(.not.oddcopy(i)%lstate) cycle
                if(index(oddcopy(i)%msg,' '//trim(hiscall)//' ').gt.1) then
                   lastrxmsg(1)%lastmsg=oddcopy(i)%msg
                   lastrxmsg(1)%xdt=oddcopy(i)%dt
                   lastrxmsg(1)%lstate=.true.
                   exit
                endif
             enddo
          endif
       endif
    endif

! sliding search over +/- 2.5s relative to 0.5s TX start time
    jzb=-62 + avexdt*25.
    jzt=62 + avexdt*25.

    npass=3 ! fallback
    if(nft8cycles.eq.1) then
       npass=3
    else if(nft8cycles.eq.2) then
       npass=6
    else if(nft8cycles.eq.3) then
       npass=9
    else
       npass=3
    endif

    syncmin=1.3
    do ipass=1,npass
       newdat1=.true.
       lsubtract=.true.
       npos=0
       if(ipass.eq.1 .or. ipass.eq.4 .or. ipass.eq.7) then
          if(lft8lowth) syncmin=1.225
       elseif(ipass.eq.2 .or. ipass.eq.5 .or. ipass.eq.8) then
          if(lft8lowth) syncmin=1.3
       elseif(ipass.eq.3 .or. ipass.eq.6 .or. ipass.eq.9) then
          if(lft8lowth) syncmin=1.1
       endif
       if(ipass.gt.5 .or. (ipass.eq.3 .and. npass.eq.3)) lsubtract=.false.

       if(ipass.eq.4) then
!$omp barrier
!$omp single
          if(npass.eq.9) then ! 3 decoding cycles
             nallocthr=nthr
             allocate(dd8m(180000), STAT = nAllocateStatus1)
             if(nAllocateStatus1.ne.0) STOP "Not enough memory"
             dd8m=dd8
          endif
          do i=1,179999
             dd8(i)=(dd8(i)+dd8(i+1))/2
          enddo
!$omp end single
!$omp barrier
       else if(ipass.eq.7) then
!$omp barrier
          if(nthr.eq.nallocthr) then
             dd8(1)=dd8m(1)
             do i=2,180000
                dd8(i)=(dd8m(i-1)+dd8m(i))/2
             enddo
             deallocate (dd8m, STAT = nDeAllocateStatus1)
             if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
          endif
!$omp barrier
       endif
       
       call sync8var(nfa,nfb,syncmin,nfqso,candidate,ncand,jzb,jzt,ipass,       &
            lqsothread,ncandthin,ndtcenter)
       do icand=1,ncand
          sync=candidate(3,icand)
          f1=candidate(1,icand)
          xdt=candidate(2,icand)
          lcqcand=.false.
          if(candidate(4,icand).gt.1.0) lcqcand=.true.
          lhighsens=.false.
          if(sync.lt.1.9 .or. ((ipass.eq.2 .or. ipass.eq.4 .or. ipass.eq.6)     &
               .and. sync.lt.3.15)) lhighsens=.true.
          lspecial=.false.
          lFreeText=.false.
          i3bit=0
          lft8s=.false.
          lft8sd=.false.
          lhashmsg=.false.
          iaptype=0
          msg37=''
          i3=16
          n3=16

          call ft8bvar(newdat1,nQSOProgress,nfqso,nftx,napwid,lsubtract,npos,   &
               freqsub,tmpcqdec,tmpmyc,nagainfil,iaptype,f1,xdt,nbadcrc,        &
               lft8sdec,msg37,msg37_2,xsnr,stophint,nthr,lFreeText,ipass,       &
               lft8subpass,lspecial,lcqcand,ncqsignal,nmycsignal,npass,i3bit,   &
               lft8s,lmycallstd,lhiscallstd,levenint,loddint,lft8sd,i3,n3,      &
               nft8rxfsens,ncount,msgsrcvd,lrepliedother,lhashmsg,lqsothread,   &
               lft8lowth,lhighsens,lsubtracted,tmpcqsig,tmpmycsig,tmpqsosig,    &
               lnohiscall,lnomycall,lnohisgrid,qual,iaptype2)
          nsnr=nint(xsnr)
          xdt=xdt-0.5
          if(nbadcrc.eq.0) then
             lhidemsg=.false.
             if(lspecial) then
                nspecial=2
             else
                nspecial=1
             endif

!$omp critical(find_dupes)
             do k=1,nspecial
          !ft8md  if(k.eq.2) msg37=msg37_2  ! this splits DXpedition mode msg into 2 lines 
                ldupe=.false.
                if(msg37(1:6).eq."      ") ldupe=.true. 
                if(.not.ldupe .and. ndecodes.gt.0) then
                   do idec=1,ndecodes
                      if(lhideft8dupes) then
                         if(msg37.eq.allmessages(idec) .and.                    &
                              (nsnr.le.allsnrs(idec) .or.                       &
                              (nsnr.gt.allsnrs(idec) .and.                      &
                              abs(allfreq(idec)-f1).lt.45.0))) then
                            ldupe=.true.
                            exit
                         endif
                      else
                         if(msg37.eq.allmessages(idec) .and.                    &
                              ((nsnr.le.allsnrs(idec) .and.                     &
                              abs(allfreq(idec)-f1).lt.45.0) .or.               &
                              (nsnr.gt.allsnrs(idec) .and.                      &
                              abs(allfreq(idec)-f1).lt.45.0 .and.               &
                              numthreads.ne.1))) then
                            ldupe=.true.
                            exit
                         endif
                      endif
                   enddo
                endif
                
                if(.not.ldupe) then
                   if(.not.lFreeText .and. k.eq.1) call extract_callvar(msg37,call2)
!!!$omp critical(update_arrays)
                   ndecodes=ndecodes+1
                   allmessages(ndecodes)=msg37
                   allsnrs(ndecodes)=nsnr
                   allfreq(ndecodes)=f1

                   if(.not.lhidemsg) then
 ! simulated wav tests affected, structure contains data for at least previous and current even|odd intervals
                      if(levenint) then
                         calldteven(150:2:-1)=calldteven(150-1:1:-1)
                         calldteven(1)%call2=call2
                         calldteven(1)%dt=xdt
                      else if(loddint) then
                         calldtodd(150:2:-1)=calldtodd(150-1:1:-1)
                         calldtodd(1)%call2=call2
                         calldtodd(1)%dt=xdt
                      endif
                   endif
!!!$omp end critical(update_arrays)

                   if(.not.lhidemsg) then
                      msg26=msg37(1:37) !ft8md was 1:26
                      if(associated(this%callback)) then
                         call this%callback(nsnr,xdt,f1,msg26,iaptype2,qual)
                      endif
                   endif

                   if(msg37(1:3).eq.'CQ ' .and. nmsgcq.lt.numdeccq) then
                      nmsgcq=nmsgcq+1
                      xdtr=xdt+0.5
                      tmpcqdec(nmsgcq)%freq=f1
                      tmpcqdec(nmsgcq)%xdt=xdtr
                   endif
                   
                   if(lapmyc .and. lmycallstd) then
                      ispc1=index(msg37,' ')
                      if(msg37(1:ispc1-1).eq.trim(mycall) .and.                 &
                           nmsgmyc.lt.numdecmyc) then
                         nmsgmyc=nmsgmyc+1
                         xdtr=xdt+0.5
                         tmpmyc(nmsgmyc)%freq=f1
                         tmpmyc(nmsgmyc)%xdt=xdtr
                      endif
                   endif

                   if(i3.eq.4 .and. msg37(1:3).eq.'CQ ' .and.                   &
                        mod(nsec,15).eq.0 .and. nmsgloc.lt.130) then
                      nmsgloc=nmsgloc+1

                      if(levenint) then
                         eventmp(nmsgloc)%msg=msg37
                         eventmp(nmsgloc)%freq=f1
                         eventmp(nmsgloc)%dt=xdt
                         eventmp(nmsgloc)%lstate=.true.
                      endif

                      if(loddint) then
                         oddtmp(nmsgloc)%msg=msg37
                         oddtmp(nmsgloc)%freq=f1
                         oddtmp(nmsgloc)%dt=xdt
                         oddtmp(nmsgloc)%lstate=.true.
                      endif
                      go to 4 ! tmp filled in
                   endif

                   if(.not.lFreeText) then
! protection against any possible free txtmsg bit corruption
                      ispc1=index(msg37,' ')
                      if(.not.lhashmsg .and. mod(nsec,15).eq.0 .and.            &
                           ((i3.eq.1 .and. .not.lft8sd) .or. lft8sd) .and.      &
                           msg37(1:ispc1-1).ne.trim(mycall) .and.               &
                           nmsgloc.lt.130 .and. index(msg37,'<').le.0) then


                         ! compound callsigns not supported
                         if(index(msg37,'/').gt.0 .and. msg37(1:3).ne.'CQ ') go to 4
                         
                         nmsgloc=nmsgloc+1
                         if(levenint) then
                            eventmp(nmsgloc)%msg=msg37
                            eventmp(nmsgloc)%freq=f1
                            eventmp(nmsgloc)%dt=xdt
                            eventmp(nmsgloc)%lstate=.true.
                         endif
                         if(loddint) then
                            oddtmp(nmsgloc)%msg=msg37
                            oddtmp(nmsgloc)%freq=f1
                            oddtmp(nmsgloc)%dt=xdt
                            oddtmp(nmsgloc)%lstate=.true.
                         endif
                      endif
                   endif
                endif
4               continue
             enddo !do k
!$omp end critical(find_dupes)
          endif
       enddo !icand
       ncandthr=ncandthr+ncand
    enddo !ipass
            
!a8 test code was here            

    if(levenint) then
       evencq(1:ncqsignal,nthr)%freq=tmpcqsig(1:ncqsignal)%freq
       evencq(1:ncqsignal,nthr)%xdt=tmpcqsig(1:ncqsignal)%xdt
       do ik=1,ncqsignal
          evencq(ik,nthr)%cs=tmpcqsig(ik)%cs
       enddo
       if(lapmyc) then
          evenmyc(1:nmycsignal,nthr)%freq=tmpmycsig(1:nmycsignal)%freq
          evenmyc(1:nmycsignal,nthr)%xdt=tmpmycsig(1:nmycsignal)%xdt
          do ik=1,nmycsignal
             evenmyc(ik,nthr)%cs=tmpmycsig(ik)%cs
          enddo
          if(.not.lqsomsgdcd .and. tmpqsosig(1)%freq.lt.5001.) then
             evenqso(1,nthr)%freq=tmpqsosig(1)%freq
             evenqso(1,nthr)%xdt=tmpqsosig(1)%xdt
             evenqso(1,nthr)%cs=tmpqsosig(1)%cs
          endif
       endif
    else if(loddint) then
       oddcq(1:ncqsignal,nthr)%freq=tmpcqsig(1:ncqsignal)%freq
       oddcq(1:ncqsignal,nthr)%xdt=tmpcqsig(1:ncqsignal)%xdt
       do ik=1,ncqsignal
          oddcq(ik,nthr)%cs=tmpcqsig(ik)%cs
       enddo
       if(lapmyc) then
          oddmyc(1:nmycsignal,nthr)%freq=tmpmycsig(1:nmycsignal)%freq
          oddmyc(1:nmycsignal,nthr)%xdt=tmpmycsig(1:nmycsignal)%xdt
          do ik=1,nmycsignal
             oddmyc(ik,nthr)%cs=tmpmycsig(ik)%cs
          enddo
          if(.not.lqsomsgdcd .and. tmpqsosig(1)%freq.lt.5001.) then
             oddqso(1,nthr)%freq=tmpqsosig(1)%freq
             oddqso(1,nthr)%xdt=tmpqsosig(1)%xdt
             oddqso(1,nthr)%cs=tmpqsosig(1)%cs
          endif
       endif
    endif

    ncandthr=nint(float(ncandthr)/npass)
    ncandallthr(nthr)=ncandallthr(nthr)+ncandthr

    if(nmsgloc.gt.0) then
!$omp critical(update_structures)
       if(levenint) then
          even(nmsg+1:nmsg+nmsgloc)%msg=eventmp(1:nmsgloc)%msg
          even(nmsg+1:nmsg+nmsgloc)%freq=eventmp(1:nmsgloc)%freq
          even(nmsg+1:nmsg+nmsgloc)%dt=eventmp(1:nmsgloc)%dt
          even(nmsg+1:nmsg+nmsgloc)%lstate=eventmp(1:nmsgloc)%lstate
          nmsg=nmsg+nmsgloc
       else if(loddint) then
          odd(nmsg+1:nmsg+nmsgloc)%msg=oddtmp(1:nmsgloc)%msg
          odd(nmsg+1:nmsg+nmsgloc)%freq=oddtmp(1:nmsgloc)%freq
          odd(nmsg+1:nmsg+nmsgloc)%dt=oddtmp(1:nmsgloc)%dt
          odd(nmsg+1:nmsg+nmsgloc)%lstate=oddtmp(1:nmsgloc)%lstate
          nmsg=nmsg+nmsgloc
       endif
!$omp end critical(update_structures)
    endif

!$omp single            
! test code for a8 start
   if(lft8apon .and. ncontest.ne.6 .and. ncontest.ne.7 .and. la8 .and.          &
        len(trim(hiscall)).ge.3 .and.            &
        len(trim(hisgrid4)).ge.4 .and. ltry_a8) then
! Try for an a8 decode at nfqso
      f1=nfqso
      dxgrid=hisgrid4
      call timer('ft8_a8d ',0)
      call ft8_a8d(dd8,mycall,hiscall,dxgrid,f1,xdt,fbest,xsnr,plog,msg37) !w3sz was dd
      call timer('ft8_a8d ',1)
      if(msg37(1:1).ne.' ') then
         if(associated(this%callback)) then
            sync=10.0  !### ???   !URUR was 10, tried 15
            nsnr=nint(xsnr)
            iaptype=8
            qual=1.0
            if(plog.lt.-147.0) qual=0.16
            call this%callback(nsnr,xdt,fbest,msg37,iaptype,qual)
         endif
      endif
   endif
! test code for a8 stop    
!$omp end single nowait
    
    return
  end subroutine decodevar
end module ft8_decodevar

module toxyz_mod
  use iso_fortran_env, only: real64
  implicit none
contains
  subroutine toxyz(alpha,delta,r,vec)
    implicit none
    real(real64), intent(in) :: alpha, delta, r
    real(real64), intent(out) :: vec(3)
  
    vec(1)=r*cos(delta)*cos(alpha)
    vec(2)=r*cos(delta)*sin(alpha)
    vec(3)=r*sin(delta)
  
  end subroutine toxyz

  subroutine fromxyz(vec,alpha,delta,r)
    implicit none
    real(real64), intent(in) :: vec(3)
    real(real64), intent(out) :: alpha, delta, r
    real(real64) :: twopi
    data twopi/6.283185307d0/
  
    r=sqrt(vec(1)**2 + vec(2)**2 + vec(3)**2)
    alpha=atan2(vec(2),vec(1))
    if(alpha.lt.0.d0) alpha=alpha+twopi
    delta=asin(vec(3)/r)
  
  end subroutine fromxyz
end module toxyz_mod

module ftnquit_mod
  use filbig_mod
  use four2a_mod
      use iso_fortran_env, only: real64, real32
  implicit none
contains

subroutine ftnquit
  implicit none

  integer, parameter :: MAXFFT2 = 77175

  real(real32)        :: dd_dummy(1,1)
  integer       :: nmax_dummy = -1
  real(real64)  :: f0_dummy = 0.0d0
  integer       :: newdat_dummy = 0
  integer       :: nfsample_dummy = 0
  logical       :: xpol_dummy = .false.
  complex       :: c4a_dummy(MAXFFT2), c4b_dummy(MAXFFT2)
  integer       :: n4_dummy = 0

  complex :: a_dummy(1)

  call four2a(a_dummy, -1, 1, 1, 1)

  call filbig(dd_dummy, nmax_dummy, f0_dummy, newdat_dummy, &
              nfsample_dummy, xpol_dummy, c4a_dummy, c4b_dummy, n4_dummy)

end subroutine ftnquit

end module ftnquit_mod

program synctest

   ! Program to test an algorithm for detecting sync signals for both
   ! JT65 and Q65-60x signals and rejecting birdies in MAP65 data.
   ! The important work is done in module wideband_sync.

   use timer_module, only: timer
   use timer_impl, only: init_timer, fini_timer
   use wideband_sync
   implicit none

   integer, parameter :: NFFT_WBS = 32768 ! Assumed from context of wideband_sync
   ! Actually NFFT_WBS might be in wideband_sync module. Checked wideband_sync.f90?
   ! Assuming 32768 based on typical MAP65 usage.
   
   real ss(4, 322, NFFT_WBS), savg(4, NFFT_WBS)
!  real candidate(MAX_CANDIDATES,5)             !snr1,f0,xdt0,ipol,flip
   character*8 arg
   type(candidate) :: cand(MAX_CANDIDATES)
   
   integer :: nargs, iutc, nfa, nfb, nts_jt65, nts_q65, ifile, nutc, npol
   integer :: ncand, k

   nargs = iargc()
   if (nargs .ne. 5) then
      print *, 'Usage:   synctest iutc nfa nfb nts_jt65 nts_q65'
      print *, 'Example: synctest 1814  23  83      2        1'
      go to 999
   endif
   call getarg(1, arg)
   read (arg, *) iutc
   call getarg(2, arg)
   read (arg, *) nfa
   call getarg(3, arg)
   read (arg, *) nfb
   call getarg(4, arg)
   read (arg, *) nts_jt65
   call getarg(5, arg)
   read (arg, *) nts_q65

   call init_wideband_sync(NFFT)

   open (50, file='50.a', form='unformatted', status='old')
   do ifile = 1, 9999
      read (50, end=998) nutc, npol, ss(1:npol, :, :), savg(1:npol, :)
      if (nutc .eq. iutc) exit
   enddo
   close (50)

   call init_timer('timer.out')
   call timer('synctest', 0)

   call timer('get_cand', 0)
   call get_candidates(ss, savg, 302, .true., nfa, nfb, nts_jt65, nts_q65, cand, ncand)
   call timer('get_cand', 1)

   do k = 1, ncand
      write (*, 1010) k, cand(k)%snr, cand(k)%f, cand(k)%f + 77, cand(k)%xdt, &
         cand(k)%ipol, cand(k)%iflip
1010  format(i3, 4f10.3, 2i3)
   enddo

998 call timer('synctest', 1)
   call timer('synctest', 101)
   call fini_timer()

999 end program synctest

!does not require end module

module twkfreq_xy_mod
  implicit none
contains
  subroutine twkfreq_xy(c4aa,c4bb,n5,a)
    implicit none
    integer, intent(in) :: n5
    complex, intent(inout) :: c4aa(n5), c4bb(n5)
    real, intent(in) :: a(5)
    
    complex :: w,wstep
    real :: twopi
    data twopi/6.283185307/
    real :: x0, s, x, p2, dphi
    integer :: i
  
  ! Apply AFC corrections to the c4aa and c4bb data
    w=1.0
    wstep=1.0
    x0=0.5*(n5+1)
    s=2.0/n5
    do i=1,n5
       x=s*(i-x0)
       if(mod(i,1000).eq.1) then
          p2=1.5*x*x - 0.5
  !            p3=2.5*(x**3) - 1.5*x
  !            p4=4.375*(x**4) - 3.75*(x**2) + 0.375
          dphi=(a(1) + x*a(2) + p2*a(3)) * (twopi/1378.125)
          wstep=cmplx(cos(dphi),sin(dphi))
       endif
       w=w*wstep
       c4aa(i)=w*c4aa(i)
       c4bb(i)=w*c4bb(i)
    enddo
  
  end subroutine twkfreq_xy
end module twkfreq_xy_mod

module k2grid_mod
  implicit none
contains
  subroutine k2grid(k,grid)
    use deg2grid_mod, only: deg2grid
    character(len=6), intent(out) :: grid
    integer, intent(in) :: k
    
    integer :: nlong, nlat
    real :: dlong, dlat
  
    nlong=2*mod((k-1)/5,90)-179
    if(k.gt.450) nlong=nlong+180
    nlat=mod(k-1,5)+ 85
    dlat=nlat
    dlong=nlong
    call deg2grid(dlong,dlat,grid)
  
  end subroutine k2grid
end module k2grid_mod

subroutine decode_echo(id2,searching,rxcall)

! For EchoCall mode, recovers transmitted callsign from received echoes.
!     id2(NZ)  received echo data
!     rxcall     decoded message (callsign, usually)
! Time alignment of received data is assumed accurate, as EME delay is known.

  parameter (NSPS=4096,NZ=6*NSPS)
  integer*2 id2(NZ)      !Raw Rx data
  integer itone(6)         !Tone offsets corresponding to ransmitted callsign
  integer ipk(1)
  logical searching
  complex c0(0:NZ)         !Analytic data, 12000 Hz sample rate
  complex c1(0:NSPS-1)     !Data for a single echo character
  complex c2(0:NZ)         !Analytic data with shifted tone freqs
  character*6 rxcall       !The recovered callsign
  real s(0:NSPS-1)         !Spectrum for one received character
  real p(0:NSPS-1,6)       !Summed spectra for all six received characters
  real a(3)
  character*37 c
  common/echocom/nclearave,nsum,blue(4096),red(4096)
  equivalence (ipk1,ipk(1))
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

! Retrieve params known at time of transmission and saved in id2
  call save_echo_params(nDop,nDopAudio,nfrit,f1,fspread,ndf,itone,id2,-1)

  df=12000.0/NSPS
  if(ndf.lt.10 .or. ndf.gt.30) return
  if(f1.eq.0.0) f1=1500.0
  i1=nint((f1 - 5*ndf)/df)
  i2=nint((f1 + 42*ndf)/df)
  if(i1.le.0 .or. i1.gt.4096 .or. i2.le.0 .or. i2.gt.4096) return
  nn=i2-i1+1

  if(nclearave.ne.0) p=0.
  nfft=NZ
  df1=12000.0/nfft
  fac=2.0/(32767.0*nfft)
  c0(0:NZ-1)=fac*id2(1:NZ)
  c0(0:14)=0.
  call four2a(c0,nfft,1,-1,1)           !Forward c2c FFT
  c0(nfft/2+1:nfft-1)=0.
  c0(0)=0.5*c0(0)
  call four2a(c0,nfft,1,1,1)            !Inverse c2c FFT; c0 is analytic sig

  rxcall='      '
  nskip=2*fspread/df

  do j=1,6
     ia=(j-1)*NSPS
     ib=ia+NSPS-1
     c1=c0(ia:ib)
     call four2a(c1,NSPS,1,-1,1)           !Forward c2c
     do i=0,NSPS/2
        s(i)=real(c1(i))**2 + aimag(c1(i))**2
     enddo
     if(.not.searching) then
        p(:,j)=p(:,j) + s                     !Sum the spectra for each character
        ipk=maxloc(p(i1:i2,j))
        k=nint(((ipk1+i1-1)*df - f1)/ndf) + 1
        if(k.ge.1 .and. k.le.37) rxcall(j:j)=c(k:k)    !SNR test here ???
     endif
  enddo

  do j=1,6                               !Move all tone frequencies to f1
     ia=(j-1)*NSPS
     ib=ia+NSPS-1
     a=0.
     a(1)=-itone(j)*ndf
     call twkfreq(c0(ia:ib),c2(ia:ib),NSPS,12000.0,a)
  enddo

! Return real(c2) as id2 ...
  id2(16:NZ)=32767.0*real(c2(15:NZ-1))
  
  return
end subroutine decode_echo

subroutine recvpkt(nsam,nblock2,userx_no,k,buf4,buf8,ndb)

! Reformat timf2 data from Linrad and stuff data into r*4 array dd().

  use qmap_params, only: MAX_NSMAX, MAX_NFFT, iz_packet_active
  include 'njunk.f90'
  parameter (NSMAX=60*96000)          !Total sample intervals per minute (active 96 kHz baseline)
  parameter (NFFT=32768)              !FFT size (active 96 kHz baseline)
  integer*1 userx_no
  real*4 d4,buf4(*)                   !(348)
  real*8 d8,buf8(*)                   !(174)
  integer*2 jd(4),kd(2),nblock2
  real*4 yd(2)
  real*8 fcenter
! COMMON sized at MAX (256 kHz wide-mode upper bound). Active loops still
! use NSMAX/NFFT (= 96 kHz baseline) so behaviour is unchanged; the unused
! tail of each array is just slack until wide-mode runtime selection lands.
  common/datcom/dd(2,MAX_NSMAX),ss(400,MAX_NFFT),savg(MAX_NFFT),fcenter,nutc,  &
       junk(NJUNK)
  equivalence (kd,d4)
  equivalence (jd,d8,yd)

  gain=10.0**(0.05*ndb)
  if(nblock2.eq.-9999) nblock2=-9998    !Silence a compiler warning
  if(nsam.eq.-1) then
! Move data from the UDP packet buffer into array dd().
     if(userx_no.eq.-1) then
        do i=1,174                    !One RF channel, r*4 data
           k=k+1
           d8=buf8(i)
           dd(1,k)=yd(1)*gain
           dd(2,k)=yd(2)*gain
        enddo
     else if(userx_no.eq.1) then
        do i=1,iz_packet_active       !One RF channel, i*2 data; was hardcoded 348 (96 kHz baseline). soundin.cpp pushes the actual per-packet pair count via qmap_set_iz_packet_active() before calling here.
           k=k+1
           d4=buf4(i)
           dd(1,k)=kd(1)*gain
           dd(2,k)=kd(2)*gain
        enddo
     endif
  else
     if(userx_no.eq.1) then
        do i=1,nsam                    !One RF channel, r*4 data
           k=k+1
           d4=buf4(i)
           dd(1,k)=kd(1)*gain
           dd(2,k)=kd(2)*gain

           k=k+1
           dd(1,k)=kd(1)*gain
           dd(2,k)=kd(2)*gain
        enddo
     endif
  endif

  return
end subroutine recvpkt

module polfit_mod
  implicit none
contains
  subroutine polfit(y,npts,a)
    implicit none
  
  ! Input:  y(npts)                !Expect npts=4
  ! Output: a(1) = baseline
  !         a(2) = amplitude
  !         a(3) = theta (deg)
  
    integer, intent(in) :: npts
    real, intent(in) :: y(npts)
    real, intent(out) :: a(3)
    
    real :: deltaa(3)
    integer :: ipk(1)
    integer :: nterms, iters, iter, j
    real :: chisq1, fn, delta, chisq2, tmp, chisq3, chisqr, chisqr0
    save
  
  ! Set starting values:
    a(1)=minval(y)
    a(2)=maxval(y)-a(1)
    ipk=maxloc(y)
    a(3)=(ipk(1)-1)*45.0
  
    deltaa(1:2)=0.1*a(2)
    deltaa(3)=10.0
    nterms=3
  
  !  Start the iteration
    chisqr=0.
    chisqr0=1.e6
    iters=10
  
    do iter=1,iters
       do j=1,nterms
          chisq1=fchisq_pol(y,npts,a)
          fn=0.
          delta=deltaa(j)
   10      a(j)=a(j)+delta
          chisq2=fchisq_pol(y,npts,a)
          if(chisq2.eq.chisq1) go to 10
          if(chisq2.gt.chisq1) then
             delta=-delta                      !Reverse direction
             a(j)=a(j)+delta
             tmp=chisq1
             chisq1=chisq2
             chisq2=tmp
          endif
   20      fn=fn+1.0
          a(j)=a(j)+delta
          chisq3=fchisq_pol(y,npts,a)
          if(chisq3.lt.chisq2) then
             chisq1=chisq2
             chisq2=chisq3
             go to 20
          endif
  
  ! Find minimum of parabola defined by last three points
          delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
          a(j)=a(j)-delta
          deltaa(j)=deltaa(j)*fn/3.
  !          write(*,4000) iter,j,a,deltaa,chisq2
  !4000      format(2i2,2(2x,3f8.2),f12.5)
       enddo  ! j=1,nterms
       chisqr=fchisq_pol(y,npts,a)
  !     write(*,4000) 0,0,a,chisqr
       if(chisqr.lt.1.0) exit
       if(deltaa(1).lt.0.01*(a(2)-a(1)) .and. deltaa(2).lt.0.01*(a(2)-a(1))   &
            .and. deltaa(3).lt.1.0) exit
       if(chisqr/chisqr0.gt.0.99) exit
       chisqr0=chisqr
    enddo  ! iter
    a(3)=mod(a(3)+360.0,180.0)
  
  end subroutine polfit
  
  real function fchisq_pol(y,npts,a)
    implicit none  
    integer, intent(in) :: npts
    real, intent(in) :: y(npts),a(3)
    real :: rad
    data rad/57.2957795/
    integer :: i
    real :: chisq, theta, yfit
    
    chisq = 0.
    do i=1,npts
       theta=(i-1)*45.0
       yfit=a(1) + a(2)*cos((theta-a(3))/rad)**2
       chisq=chisq + (y(i) - yfit)**2
    enddo
    fchisq_pol=chisq
  
  end function fchisq_pol
end module polfit_mod

module m65a_mod
  implicit none
contains

subroutine m65a()

  use timer_module, only: timer
  use, intrinsic :: iso_c_binding, only: C_NULL_CHAR
  use npar_ptrs_mod
  use datcom_ptrs_mod, only: dd,ss,savg
  use m65_mod
  use FFTW3
  use ftninit_mod
  
  implicit none
  
  character(len=256) cwd
    
  ! Try Unix-style PWD first
  call get_environment_variable("PWD", cwd)

  ! If empty, try Windows-style CD
  if (len_trim(cwd) == 0) then
     call get_environment_variable("CD", cwd)
  end if

  ! If still empty, fall back to current directory
  if (len_trim(cwd) == 0) then
     cwd = "."
  end if
  
  call ftninit(trim(cwd))
  
  if (.not. associated(savg)) then
    print *, 'ERROR:M65A savg is not associated!'
  end if
  
  if (.not. associated(dd)) then
    print *, 'ERROR: M65A dd is not associated!'
  end if
  
  if (.not. associated(ss)) then
    print *, 'ERROR: M65A ss is not associated!'
  end if
      
  call m65c()
  return

end subroutine m65a

end module m65a_mod

#!/bin/sh

# to be invoked from uscan (debian/watch)

set -eux

: $0 "$@"
# $1 is expected to be "--upstream-version"
version="$2"
tarball="wsjtx-improved_$version.orig.tar.gz"

# unpack original tarball, move inner tarball in place
tar xf ../$tarball
mk-origtargz --copyright-file debian/copyright --force-repack --version $version+repack wsjtx-*/src/wsjtx.tgz
rm -rf wsjtx-*/

# import into git
echo "To import into git, do:"
echo gbp import-orig --pristine-tar --upstream-version=$version+repack ../wsjtx-improved_$version+repack.orig.tar.xz

#dch -v $version+repack-1 "New upstream version $version."

gcc -c ft2audio.c
gcc -c ptt.c
gfortran -c ../77bit/packjt77.f90
gfortran -c ../wavhdr.f90
gfortran -c ../crc.f90
gfortran -o ft2 -fbounds-check -fno-second-underscore -ffpe-trap=invalid,zero -Wall -Wno-conversion -Wno-character-truncation ft2.f90 ft2_iwave.f90 ft2_decode.f90 getcandidates2.f90 ft2audio.o ptt.o /JTSDK/wsjtx-output/qt55/2.1.0/Release/build/libwsjt_fort.a /JTSDK/wsjtx-output/qt55/2.1.0/Release/build/libwsjt_cxx.a libportaudio.a ../libfftw3f_win.a -lwinmm
rm *.o *.mod

#!/bin/sh

#
# Windows
#
inkscape -z -e /tmp/image-0.png wsjt_globe_128x128.svg
inkscape -z -e /tmp/image-1.png wsjtx_globe_1024x1024.svg
convert '/tmp/image-%d.png[0-1]' -background transparent	\
    \( -clone 0 -resize 16 -colors 256 -compress none \)	\
    \( -clone 0 -resize 20 -colors 256 -compress none \)	\
    \( -clone 0 -resize 24 -colors 256 -compress none \)	\
    \( -clone 0 -resize 32 -colors 256 -compress none \)	\
    \( -clone 0 -resize 40 -colors 256 -compress none \)	\
    \( -clone 1 -resize 48 -colors 256 -compress none \)	\
    \( -clone 1 -resize 96 -colors 256 -compress none \)	\
    \( -clone 1 -resize 128 -colors 256 -compress none \)	\
    \( -clone 0 -resize 16 -compress none \)	\
    \( -clone 0 -resize 20 -compress none \)	\
    \( -clone 0 -resize 24 -compress none \)	\
    \( -clone 0 -resize 32 -compress none \)	\
    \( -clone 0 -resize 40 -compress none \)	\
    \( -clone 1 -resize 48 -compress none \)	\
    \( -clone 1 -resize 64 -compress none \)	\
    \( -clone 1 -resize 96 -compress none \)	\
    \( -clone 1 -resize 128 -compress none \)	\
    \( -clone 1 -resize 256 -compress Zip \)	\
    -delete 1 -delete 0	\
    -alpha remove ../icons/windows-icons/wsjtx.ico
rm /tmp/image-0.png /tmp/image-1.png
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/windows-icons/wsjtx.ico
#
inkscape -z -e /dev/stdout -w 150 -h 57 -b white installer_logo.svg | tail -n +4 |	\
    convert png:- -resize 150x57 +matte BMP3:../icons/windows-icons/installer_logo.bmp
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/windows-icons/installer_logo.bmp

#
# Mac
#
mkdir -p ../icons/Darwin/wsjtx.iconset
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_16x16.png -w 16 -h 16 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_16x16@2x.png -w 32 -h 32 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_32x32.png -w 32 -h 32 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_32x32@2x.png -w 64 -h 64 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_128x128.png -w 128 -h 128 wsjtx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_128x128@2x.png -w 256 -h 256 wsjtx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_256x256.png -w 256 -h 256 wsjtx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_256x256@2x.png -w 512 -h 512 wsjtx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_512x512.png -w 512 -h 512 wsjtx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_512x512@2x.png -w 1024 -h 1024 wsjtx_globe_1024x1024.svg
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Darwin/wsjtx.iconset/*
# generic globe iconset for utilities
mkdir -p ../icons/Darwin/wsjt.iconset
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_16x16.png -w 16 -h 16 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_16x16@2x.png -w 32 -h 32 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_32x32.png -w 32 -h 32 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_32x32@2x.png -w 64 -h 64 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_128x128.png -w 128 -h 128 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_128x128@2x.png -w 256 -h 256 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_256x256.png -w 256 -h 256 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_256x256@2x.png -w 512 -h 512 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_512x512.png -w 512 -h 512 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_512x512@2x.png -w 1024 -h 1024 wsjt_globe_1024x1024.svg
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Darwin/wsjt.iconset/*
#
inkscape -z -e "../icons/Darwin/DragNDrop Background.png" -w 640 -h 480 -b white "DragNDrop Background.svg"
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' "../icons/Darwin/DragNDrop Background.png"

#
# KDE & Gnome
#
inkscape -z -e ../icons/Unix/wsjtx_icon.png -w 128 -h 128 wsjtx_globe_1024x1024.svg
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Unix/wsjtx_icon.png

fftwf-wisdom -o fftwf_wisdom.dat -t 1 cif256 rif512 rib512 cif1024 cib1024 cib32768 

fftwf-wisdom -w fftwf_wisdom.dat -o fftwf_wisdom.dat -t 1 cif77175 cib77175 cib5376000 cif74088 cib74088 cib5120000 

fftwf-wisdom -w fftwf_wisdom.dat -o fftwf_wisdom.dat -t 1 cif37632 cib37632 cib2621440 cif37044 cib37044 cib2560000

fftwf-wisdom -w fftwf_wisdom.dat -o fftwf_wisdom.dat -t 1 cif24192 cif3456 cif336000

#!/bin/sh
WSJTX_BUNDLE="`echo "$0" | sed -e 's/\/Contents\/MacOS\/.*//'`"
WSJTX_RESOURCES="$WSJTX_BUNDLE/Contents/Resources"
WSJTX_TEMP="/tmp/wsjtx/$UID"

echo "running $0"
echo "WSJTX_BUNDLE: $WSJTX_BUNDLE"

# Setup temporary runtime files
rm -rf "$WSJTX_TEMP"

export "DYLD_LIBRARY_PATH=$WSJTX_RESOURCES/lib"
export "PATH=$WSJTX_RESOURCES/bin:$PATH"

#export
exec "$WSJTX_RESOURCES/bin/wsjtx"

# Contributing

This file describes a path to contribute to this project. Check out our
[CODE OF CONDUCT](./CODE_OF_CONDUCT.md).

## Bug Reports and Feature Requests

If you have encountered a problem with QDarkStyle or have an idea for a new
feature, please submit it to the
[issue tracker](https://github.com/ColinDuquesnoy/QDarkStyleSheet/issues).

## Contributing to QDarkStyle

The recommended way for new contributors to submit code to QDarkStyle is to
fork the repository on GitHub and then submit a pull request after
committing the changes.  The pull request will then need to be approved by one
of the manteiners before it is merged into the main repository.

- Check for open issues or open a fresh issue to start a discussion around a
    feature idea or a bug.
- Fork [the repository](https://github.com/ColinDuquesnoy/QDarkStyleSheet)
    on GitHub to start making your changes to the master branch.
- Write a test which shows that the bug was fixed or that the feature works
    as expected if its a function, or create a screenshot if you are changing
    the stylesheet evidencing the changes.
- Send a pull request and bug the maintainer until it gets merged and
    published. Make sure to add yourself to
    [AUTHORS](./AUTHORS.md)
    and the change(s) to
    [CHANGES](./CHANGES.md).

## Getting Started

These are the basic steps needed to start developing on QDarkStyle.

- Create an account on GitHub.

- Fork the main
    [QDarkStyle repository](https://github.com/ColinDuquesnoy/QDarkStyleSheet)
    using the GitHub interface.

- Clone the forked repository to your machine.

    ```bash
       git clone https://github.com/USERNAME/qdarkstyle
       cd qdarkstyle
    ```

- Checkout the appropriate branch.

    ```bash
       git checkout master
    ```

- Setup a virtual environment (not essential, but highly recommended).

    ```bash
       virtualenv ~/.venv
       . ~/.venv/bin/activate
       pip install -e .
    ```

- Create a new working branch. Choose any name you like.

    ```bash
       git checkout -b feature-xyz
    ```

- Hands on.

    For tips on working with the code, see the Code Guide.

- Test, test, test.

    Testing is best done through ``tox``, which provides a number of targets and
    allows testing against multiple different Python environments:

- Please add a list point to [CHANGES](./CHANGES.md) if the fix or
    feature is not trivial (small doc updates, typo fixes).

- Please add you as an author to [AUTHORS](./AUTHORS.md).

- Add files to commit.

    Add files that are part of your changes, remember that each commit
    must represent a small but functional change. Remember to add CHANGES.md
    and AUTHORS.md too. To add all files changed do:
    ```bash
       git add .
    ```

- Commiting changes.

    GitHub recognizes certain phrases that can be used to automatically
    update the issue tracker, so you can commit like this:

    ```bash
       git commit -m "Add useful new feature that does this, close #42"
    ```
    ```bash
       git commit -m "Fix returning problem for get_style(), fix #78"
    ```

- Push changes in the branch to your forked repository on GitHub.

    ```bash
       git push origin feature-xyz
    ```

- Submit a pull request (PR).

    Do it from your branch to the respective branch using the
    [GitHub PR](https://github.com/ColinDuquesnoy/QDarkStyleSheet/pulls)
    interface.

- Wait for mainteiner to review your changes.

## Logging

Inside modules we provided a logging that should be used to inform the user.
Please, follow the levels bellow.

- debug: for debug information, high detailed one, directed to programers;
- info: something important for common user to know;
- warning: something that should not be a big problem or a desicision changed;
- error: some error, but not capable of stop program;
- critical: something that stops the running program.

## Guide to QDarkStyle

Now you can use our example to work on the stylesheet. It has all possible
widget provided by Qt - common ones. Feel free to add more to them.

To simplify the structure, there are separated files in
[example.ui](./example/ui/) folder.

- `dw_buttons.ui`: all types of buttons;
- `dw_containers_no_tabs.ui`: all types of containers except for tabs;
- `dw_containers_tabs.ui`: all containers tabs;
- `dw_displays.ui`: all types of displays;
- `dw_inputs_fields.ui`: all types of inputs with fields;
- `dw_inputs_no_fields.ui`: all types of inputs without fields;
- `dw_views.ui`: all types of views;
- `dw_widgets.ui`: all types of widgets;
- `mw_menus.ui`: main window with all menus and toolbars.

*Obs.: `dw` stands for dock widget and `mw` for main window.*

The entire example is built at runtime, in
[example.py](./example/example.py). To see more information about it,
see its documentation.

### Modifying UI Files

Feel free to modify [ui](./example/ui) files with Qt Designer and recompile UI using
[process_ui.py](./script/process_ui.py) script, inside script folder, using:

```bash
python process_ui.py
```

It will generate all `_ui.py` files for PyQt4, PyQt5, PySide, QtPy, PyQtGraph.

### Modifying QSS File

If you are changing the [stylesheet](./qdarkstyle/style.qss), you will need
to recompile the QRC files using [process_qrc.py](./script/process_qrc.py)
script, inside script folder.

```bash
python process_qrc.py
```

This generates all `_rc.py` files for PyQt4, PyQt5, PySide, QtPy, PyQtGraph.

### Making It Easy

To simplify this process for the developer, if you are changing many things,
use the script [run_ui_css_edition.py](./script/run_ui_css_edition.py):

```bash
python run_ui_css_edition.py
```

This creates a loop that restarts the application, process ui and css
files.

For more information about those scripts, see their documentation.

### Qt, Stylesheets and Palettes

- [Box model](http://doc.qt.io/qt-5/images/stylesheet-boxmodel.png)
- [Box model with height and width](https://www.tutorialrepublic.com/lib/images/css-box-model.jpg)
- [Customizing Widgets](http://doc.qt.io/qt-5/stylesheet-customizing.html)
- [Window structure](http://doc.qt.io/qt-5/images/mainwindowlayout.png)
- [QMainWindow](http://doc.qt.io/qt-5/qmainwindow.html)
- [References](http://doc.qt.io/qt-5/stylesheet.html)

Create good palettes with these tools. For example, on paletton, choose
  three colors from greyish light (foreground), greyish dark (background)
  and three more colorfull colors (selection). Greyish colors have a litle
  bit of the main color, so it is nice to change it if you change the main
  color.

- [Paletton.com](http://paletton.com/)
- [Coolors.co](https://coolors.co/)

## Unit Testing and Fix Preview

It is a good practice, if you are writing functions to QDarkStyle or fixing
something related to those functions (not style), that you provide a test
for it.

If you are fixing something about style, please, at least, provide an
screenshot before and after the fix to comparison. This could be inserted
in the issue tracker, as a message. Better than that, use modules provided
in test folder to create a GUI test, creating a new file for it.

Check [test](./test) files to more details. Tests will keep our application stable.

## If You Are a Mantainer, Go Ahead

We create a guide to create and upload this package to PyPI, follow the
instructions in [PRODUCTION](./PRODUCTION.md).

# Authors

## Mainteiner(s)

These people were/are mainteiners of this project.

- 2013-2018
    [Colin Duquesnoy](https://github.com/ColinDuquesnoy) -
    <colin.duquesnoy@gmail.com> -
    original author.
- 2018
    [Daniel Pizetta](https://github.com/dpizetta) -
    <daniel.pizetta@usp.br> -
    improvements and bug fixes.

## Contributor(s)

These people contribute to bug fixes, improvements and so on.
Please, insert your information after the last one.

- Year - Name - `<contact>` - contribution.
- 2018 - [mowoolli](https://github.com/mowoolli) - bug fixes.
- 2018 - Xingyun Wu - `xingyun.wu@foxmail.com` - bug fixes.
- 2018 - [KcHNST](https://github.com/KcHNST) - bug fixes.

Thank you all!

# Production

Of course, until you start these steps, make sure the package have passed all
tests and checkers before continue.

- Create a `.pypirc` file in your home folder with this
    ```bash
        [distutils]
        index-servers =
        pypi
        testpypi

        [pypi]
        repository:https://pypi.python.org/pypi
        username=your username

        [testpypi]
        repository: https://test.pypi.org/legacy/
        username=your username
    ```

    If you want to put also your password in that file, remember to set
    appropriated permission to it.

    *Note that you need to create an account for both sites.*

- Install TWine
    ```bash
        sudo apt install twine
    ```

- Register if necessary
    ```bash
        python setup.py register
    ```

- Create a distribution (code package and wheel)
    ```bash
        python setup.py sdist bdist_wheel
    ```

- Test uploading using Twine
    ```bash
        twine upload -r testpypi dist/*
    ```

- Check if things are OK on [PyPI test page](https://test.pypi.org/project/QDarkStyle).

- Test installing using pip from test PyPI
    ```bash
        pip install --index-url https://test.pypi.org/project/ qdarkstyle
    ```

- **If you make sure all things are OK**, upload officialy
    ```bash
        twine upload -r pypi dist/*
    ```

- Check if things are OK on [PyPI official page](https://pypi.python.org/pypi/QDarkStyle).

- Test installing using pip
    ```bash
        pip install qdarkstyle
    ```
